Package: DCL
Type: Package
Title: Claims Reserving under the Double Chain Ladder Model
Version: 0.1.2
Date: 2022-05-05
Depends: lattice, latticeExtra
Author: Maria Dolores Martinez-Miranda, Jens Perch Nielsen and Richard Verrall 
Maintainer: Maria Dolores Martinez-Miranda <mmiranda@ugr.es>
Description: Statistical modelling and forecasting in claims reserving in non-life insurance under the Double Chain Ladder framework by Martinez-Miranda, Nielsen and Verrall (2012).
License: GPL-2
NeedsCompilation: no
Packaged: 2022-05-05 16:05:57 UTC; Usuario
Repository: CRAN
Date/Publication: 2022-05-05 16:40:02 UTC
Built: R 4.6.0; ; 2026-04-27 08:37:33 UTC; unix

Package: DCL
Type: Package
Title: Claims Reserving under the Double Chain Ladder Model
Version: 0.1.2
Date: 2022-05-05
Depends: lattice, latticeExtra
Author: Maria Dolores Martinez-Miranda, Jens Perch Nielsen and Richard Verrall 
Maintainer: Maria Dolores Martinez-Miranda <mmiranda@ugr.es>
Description: Statistical modelling and forecasting in claims reserving in non-life insurance under the Double Chain Ladder framework by Martinez-Miranda, Nielsen and Verrall (2012).
License: GPL-2
NeedsCompilation: no
Packaged: 2022-05-05 16:05:57 UTC; Usuario
Repository: CRAN
Date/Publication: 2022-05-05 16:40:02 UTC
Built: R 4.3.3; ; 2025-01-24 15:26:23 UTC; unix

exportPattern("^[[:alpha:]]+")
import("lattice")
import("latticeExtra")
importFrom("grDevices", "terrain.colors")
importFrom("graphics", "axis", "boxplot", "grid", "hist", "legend",
     "lines", "matplot", "par", "points")
importFrom("stats", "quantile", "rbinom", "rgamma", "rmultinom",
     "rpois", "sd")

* This document written in UTF-8

0. 地球流体電脳ライブラリについて

地球流体関係者が長年にわたり蓄積してきた FORTRAN ライブラリです. 
ライセンスは　二条項BSDライセンス　です．正確なライセンスはLICENSEファイルを
参照してください．

地球流体電脳倶楽部については

	http://www.gfd-dennou.org/

電脳ライブラリについては

	http://www.gfd-dennou.org/arch/dcl/

を御覧下さい.


1. ファイル

このパッケージのトップディレクトリにあるファイルのうち, 重要なものにつ
いて簡単に説明します.

	CHECK		動作チェックのポイント
	HISTORY		作業記録
	INSTALL		インストール方法
	NOTE		注意点を書いたファイルのありか
	README		このファイル


2. インストール

詳しくは, INSTALL を見て下さい.

標準的なプラットフォームでは, ./configure; make; make install で dcl
本体がインストールされるはずです.


3. メーリングリスト

地球流体電脳倶楽部では，メーリングリスト dcusers を開設し, 計算・情報
環境についてのもろもろの問題点に関してさまざまな個人が情報交換を行なう
ための「サロン」としています.

メイリングリストへの登録方法, およびコマンドメールの使い方などの案内は,

	dcusers-ml-help@gfd-dennou.org

宛にメールを送ることによって自動的に返信されます. この際, Subjectや本
文には何も書かなくても構いません.

詳しくは,

	http://www.gfd-dennou.org/arch/dcusers/

を御覧下さい.



4. 地球流体電脳倶楽部 dcl-5.3 クレジット

以下に名前を上げたのは, おもに dcl-5.1 までの開発に関わった人達である.
dcl-5.1 以降について, これ以外にも多くの人からのコメント, 資源提供がお
こなわれている. HISTORY ファイルを参考にされたい.

* プログラム製作

	石岡圭一, 酒井敏, 佐藤薫, 塩谷雅人, 沼口敦
	乙部直人、神代ｘ、辻野ｘ、西本ｘ、堀之内武
	豊田ｘ、鍵本ｘ、西澤ｘ、大塚ｘ、保坂征宏、余田成男
	石渡正樹, 竹広真一, 中島健介, 西憲敬, 林祥介,
  Paul Swarztrauber (NCAR)

* デバッグ協力

	石田明生, 石渡正樹, 市川香, 沖大幹, 沖理子, 桜井隆博, 佐藤正樹,
	竹広真一, 中島健介, 沼口敦, 根田昌典, 野村真佐子, 藤尾伸三,
	保坂征宏

* 文章

  酒井敏, 塩谷雅人, 余田成男，鍵本 崇, 乙部 直人, 神代 剛, 辻野 智紀
  堀之内武、豊田ｘ、 林祥介，西憲敬，沼口敦,
  石渡正樹, 佐藤薫, 佐藤正樹, 竹広真一, 中島健介, 西憲敬, 沼口敦,
  林祥介, 保坂征宏

* 参考資源

	Layout [二木徹],
	XYGRAPH [佐藤亨],
	Numerical Recipes [Willam H. Press et al.],
	NCARG [NCAR],
	FFTPACK [Paul Swarztrauber]

        ref grph1/slpack  :     Layout [二木徹]
        ref grph1/szpack  :     XYGRAPH [佐藤亨]
        ref misc1/bitlib  :     NCARG [NCAR]
        ref env1/bitmap   :     XYGRAPH [佐藤亨]
        ref math2/fftlib  :     FFTPACK [Paul Swarztrauber(NCAR)]


* 版権

＜佐々木さんに確認＞

* 引用について

	「地球流体電脳ライブラリ」の著作者は「地球流体電脳倶楽部」, そ
	の英語名は 'GFD-DENNOU Library', 'GFD-DENNOU Club' である. 地
	球流体電脳ライブラリを用いて作成された著作物等には, 謝辞の形で
	たとえば，

	(英文)
	"The figures were produced by GFD-DENNOU Library."

	(和文)
	「図の作成には地球流体電脳ライブラリをもちいた.」

	あるいは，参考文献の形式で

	(和文)
	地球流体電脳ライブラリ開発グループ，2017:
	地球流体電脳ライブラリ, dcl-7.0,
	http://www.gfd-dennou.org/arch/dcl/,
	地球流体電脳倶楽部.

	(英文)
	GFD-DENNOU Library development group, 2017:
	GFD-DENNOU Library, dcl-7.0,
	http://www.gfd-dennou.org/arch/dcl/,
	GFD-DENNOU Club.

	のように引用していただければ幸いである.


* 謝辞

	dcl-5.1 の作成にあたっては, 科学技術振興事業団(JST)から平成 11
	年度計算科学技術活用型特定研究開発推進事業(短期集中型)のプロジェ
	クト「地球惑星流体現象を念頭においた多次元数値データの構造化」
	として支援を受けた. ここに謝意をあらわします.

dcl
===

##D-cleaner [ Disk && Directory Cleaner ]

given a path **dcl** will clean this directory, and eventually subdirs, from a list of files, and eventually unmount or eject the volume. 
 
####config files
you can customize the file list to be deleted by editing config files   
`[/etc/dclrc , ~/.dclrc]`  
or a custom file using the `-f` option. 
default built-in filter list is always read unless you use the `--override` option.  
the default built in list actually is  
`[".DS_Store","._.DS_Store",".Spotlight-V100"]`  

####dcl.rc example:
	
	%lang:glob     #use glob syntax instead of regex
	#declare a syntax is optional.
	*.o            #all object files (glob syntax)
	.DS_Dtore      #osx stuff !!
	Makefile.in
	#this is a comment

##install

```
sudo make install
```

or run it locally on yout directory.

###help

```
$ dcl -h
dcl v0.1
by Fernando Iazeolla, iazasoft, 2013 (c)
this software is distributed under GPLv2 licence.

USAGE: dcl [ OPTIONS ] dir-path

where dir-path is the directory path
and OPTIONS are:
--help		-h		#show this help
--help config	-h config	#show help about .dclrc config file(s)
--version	-v		#show program version
--eject		-e		#eject volume after cleaned
--umount	-u		#unmount volume after cleaned.
--override	-o		#exclude the default built-in file list
--filelist <file>  -f <file>	#specify a custom file list
--norec		-r		#not recursive across sub dirs
--verbose	-vv		#verbose output
--show		-s		#show matching files to be deleted
--pretend	-p		#do not perform deletion.
--ask		-i [-a]		#ask confirmation before deleting each
--filter 'filter'  -x 'filter'	#define filter to be deleted on command line. 
--lang [regex|glob] -l [regex|glob] #set parser language. (Default=glob)
--quiet		-q		#quiet output.

```
###examples

```
$ dcl -vv -p -r .       #show verbose without deleting(--pretend option) files that would be 
                        #deleted only in this dir  

$ dcl -s -u /mnt/Disk1      #clean /mnt/Disk1 recursively showing only deleted files 
                            #and unmount the volume.  

$ dcl /mnt/Disk2        #clean /mnt/Disk1 recursively. output almost nothing.(use -q for no output)


#these perform the same:
$ dcl -x '*.o *.c' /mnt/floppy	#clean all .c and all .o files from /mnt/floppy

$ dcl -x '*.o;*.c' /mnt/floppy  #clean all .c and all .o files from /mnt/floppy

$ dcl -x '*.o:*.c' /mnt/floppy  #clean all .c and all .o files from /mnt/floppy

$ dcl -x '*.o,*.c' /mnt/floppy  #clean all .c and all .o files from /mnt/floppy
```

#####web
[dcl project page](http://github.com/elboza/dcl)

####That's all falks!

```
 _____
< bye >
 -----
        \   ^__^
         \  (oo)\_______
            (__)\       )\/\
                ||----w |
                ||     ||
```

本ディレクトリは流線描画用ルーチン集です.
ファイルは以下のように構成されています.

./tmpack
|-- test.f   : テストプログラム
|-- tmstln.f : 流線描画用メインルーチン
|-- tmslcl.f : 流線計算用ソルバルーチン
`-- tmvset.f : 描画用パラメータ設定・取得ルーチン

[注意]
test.f は環境によってはスタックメモリ不足により Segmentation fault を起こす可能性があります. その場合は, 

$ ulimit -s unlimited

等のコマンドによりスタックの制限を外して下さい.
もしくは, test.f 内の NX, NY の値を小さくして下さい.

[使い方]
各ルーチンは Fortran コンパイラでコンパイルして下さい.
以下, gfortran でコンパイルする手引きです.

* サブルーチンファイルのコンパイル手順
$ for i in tm*.f
$ do
$ gfortran -c $i
$ done

* テストファイルのコンパイル手順
$ dclfrt test.f *.o -o test

* テストファイルの実行手順
$ ./test
 SKIP
 10    # ここは 1 以上の整数を代入

*-----------------------------------------------------------------------
C     SUBROUTINE CFFTF(N,C,WSAVE)
C
C     SUBROUTINE CFFTF COMPUTES THE FORWARD COMPLEX DISCRETE FOURIER
C     TRANSFORM (THE FOURIER ANALYSIS). EQUIVALENTLY , CFFTF COMPUTES
C     THE FOURIER COEFFICIENTS OF A COMPLEX PERIODIC SEQUENCE.
C     THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER C.
C
C     THE TRANSFORM IS NOT NORMALIZED. TO OBTAIN A NORMALIZED TRANSFORM
C     THE OUTPUT MUST BE DIVIDED BY N. OTHERWISE A CALL OF CFFTF
C     FOLLOWED BY A CALL OF CFFTB WILL MULTIPLY THE SEQUENCE BY N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE CFFTF MUST BE
C     INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C
C     N      THE LENGTH OF THE COMPLEX SEQUENCE C. THE METHOD IS
C            MORE EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES. N
C
C     C      A COMPLEX ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C
C     WSAVE   A REAL WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4N+15
C             IN THE PROGRAM THAT CALLS CFFTF. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY CFFTF AND CFFTB.
C
C     OUTPUT PARAMETERS
C
C     C      FOR J=1,...,N
C
C                C(J)=THE SUM FROM K=1,...,N OF
C
C                      C(K)*EXP(-I*(J-1)*(K-1)*2*PI/N)
C
C                            WHERE I=SQRT(-1)
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SUBROUTINE CFFTF OR CFFTB
C
      SUBROUTINE CFFTF (N,C,WSAVE)
      DIMENSION       C(*)       ,WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      IW1 = N+N+1
      IW2 = IW1+N+N
      CALL CFFTF1 (N,C,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE EZFFT1 (N,WA,IFAC)
      DIMENSION       WA(*)      ,IFAC(*)    ,NTRYH(4)
      EXTERNAL RFPI
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
      TPI = 2.0*RFPI()
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 111 K1=1,NFM1
         IP = IFAC(K1+2)
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         ARG1 = FLOAT(L1)*ARGH
         CH1 = 1.
         SH1 = 0.
         DCH1 = COS(ARG1)
         DSH1 = SIN(ARG1)
         DO 110 J=1,IPM
            CH1H = DCH1*CH1-DSH1*SH1
            SH1 = DCH1*SH1+DSH1*CH1
            CH1 = CH1H
            I = IS+2
            WA(I-1) = CH1
            WA(I) = SH1
            IF (IDO .LT. 5) GO TO 109
            DO 108 II=5,IDO,2
               I = I+2
               WA(I-1) = CH1*WA(I-3)-SH1*WA(I-2)
               WA(I) = CH1*WA(I-2)+SH1*WA(I-3)
  108       CONTINUE
  109       IS = IS+IDO
  110    CONTINUE
         L1 = L2
  111 CONTINUE
      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE CFFTF1 (N,C,CH,WA,IFAC)
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDOT = IDO+IDO
         IDL1 = IDOT*L1
         IF (IP .NE. 4) GO TO 103
         IX2 = IW+IDOT
         IX3 = IX2+IDOT
         IF (NA .NE. 0) GO TO 101
         CALL PASSF4 (IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 102
  101    CALL PASSF4 (IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102    NA = 1-NA
         GO TO 115
  103    IF (IP .NE. 2) GO TO 106
         IF (NA .NE. 0) GO TO 104
         CALL PASSF2 (IDOT,L1,C,CH,WA(IW))
         GO TO 105
  104    CALL PASSF2 (IDOT,L1,CH,C,WA(IW))
  105    NA = 1-NA
         GO TO 115
  106    IF (IP .NE. 3) GO TO 109
         IX2 = IW+IDOT
         IF (NA .NE. 0) GO TO 107
         CALL PASSF3 (IDOT,L1,C,CH,WA(IW),WA(IX2))
         GO TO 108
  107    CALL PASSF3 (IDOT,L1,CH,C,WA(IW),WA(IX2))
  108    NA = 1-NA
         GO TO 115
  109    IF (IP .NE. 5) GO TO 112
         IX2 = IW+IDOT
         IX3 = IX2+IDOT
         IX4 = IX3+IDOT
         IF (NA .NE. 0) GO TO 110
         CALL PASSF5 (IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 111
  110    CALL PASSF5 (IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111    NA = 1-NA
         GO TO 115
  112    IF (NA .NE. 0) GO TO 113
         CALL PASSF (NAC,IDOT,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         GO TO 114
  113    CALL PASSF (NAC,IDOT,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114    IF (NAC .NE. 0) NA = 1-NA
  115    L1 = L2
         IW = IW+(IP-1)*IDOT
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      N2 = N+N
      DO 117 I=1,N2
         C(I) = CH(I)
  117 CONTINUE
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLNZR(RX1,RY1,RX2,RY2,INDEX)


      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLNZR','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLNZR','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZLNOP(INDEX)
      CALL SZLNZR(RX1,RY1,RX2,RY2)
      CALL SZLNCL

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSMAP(SIMFAC, VXOFF, VYOFF, PLX, PLY, PLROT)


      CALL MSGDMP('M','SGSMAP',
     +     'THIS IS OLD INTERFACE - USE SGSSIM/SGSMPL !')

      CALL SGSSIM(SIMFAC, VXOFF, VYOFF)
      CALL SGSMPL(PLX, PLY, PLROT)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQMAP(SIMFAC, VXOFF, VYOFF, PLX, PLY, PLROT)

      CALL MSGDMP('M','SGQMAP',
     +     'THIS IS OLD INTERFACE - USE SGQSIM/SGQMPL !')

      CALL SGQSIM(SIMFAC, VXOFF, VYOFF)
      CALL SGQMPL(PLX, PLY, PLROT)

      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE UICRGB(VAL,CMASK,IRGB)
      PARAMETER (NMAX=256)

      DIMENSION RC(NMAX), RC0(NMAX), IR(NMAX), IG(NMAX), IB(NMAX)
      DIMENSION RS(NMAX), RS0(NMAX), SD(NMAX)

      DIMENSION ICOLOR(*), CLRLVL(*)
      DIMENSION SHADE(*),  SHDLVL(*)

      CHARACTER CDSNX*1024,CMSG*80
      CHARACTER CDSN*(*)
      LOGICAL   LCYCLE, LSHADE, LCSET, LSSET

      SAVE

      EXTERNAL  IUFOPN

      DATA NLEV,  NSHADE       / 7, 4 /
      DATA LCSET, LSSET        /.FALSE., .FALSE./

      DATA IR / Z'FF', Z'00', Z'00', Z'00', Z'FF', Z'FF', Z'FF', 249*0/
      DATA IG / Z'00', Z'00', Z'FF', Z'FF', Z'FF', Z'00', Z'00', 249*0/
      DATA IB / Z'FF', Z'FF', Z'FF', Z'00', Z'00', Z'00', Z'FF', 249*0/
      DATA RC0/ 0.000, .1667, .3333, .5000, .6667, .8333, 1.000, 249*0./
      DATA RCMIN, RCMAX, RSMIN, RSMAX / 999.0, 999.0, 999.0, 999.0/

      DATA SD /-0.2, -0.2,  0.2,  0.2, 252*0./
      DATA RS0/ 0.0,  0.5,  0.5,  1.0, 252*0./

      IF(LCYCLE) THEN
        RANGE = RC(NLEV)-RC(1)
        VC = MOD(MOD(VAL-RC(1),RANGE)+RANGE,RANGE)+RC(1)
      ELSE
        VC = VAL
      END IF

      IF(VC.LE.RC(1)) THEN
        JR = IR(1)
        JG = IG(1)
        JB = IB(1)
        GOTO 100
      END IF

      DO 10 I=2, NLEV
        IF(VC.LE.RC(I)) THEN
           X0 = RC(I) - RC(I-1)
           X1 = RC(I) - VC
           X2 = VC   - RC(I-1)
          JR = (X2*IR(I) + X1*IR(I-1))/X0
          JG = (X2*IG(I) + X1*IG(I-1))/X0
          JB = (X2*IB(I) + X1*IB(I-1))/X0
          GOTO 100
        END IF
  10  CONTINUE

      JR = IR(NLEV)
      JG = IG(NLEV)
      JB = IB(NLEV)

  100 CONTINUE

      IF(LSHADE) THEN
        RANGE = RS(NSHADE)-RS(1)
        VM = MOD(MOD(VAL-RS(1),RANGE)+RANGE,RANGE)+RS(1)
        DO 110 I=2, NSHADE
          IF(VM.LE.RS(I)) THEN
            X0 = RS(I) - RS(I-1)
            X1 = RS(I) - VM
            X2 = VM    - RS(I-1)
            CC = (X2*SD(I) + X1*SD(I-1))/X0
            GOTO 120
          END IF
 110    CONTINUE
 120    CONTINUE
      ELSE
        CC = CMASK
      END IF

      IF(CC.GT.0) THEN
        KR = JR + (255-JR)*CC
        KG = JG + (255-JG)*CC
        KB = JB + (255-JB)*CC
      ELSE
        KR = JR*ABS(1.+CC)
        KG = JG*ABS(1.+CC)
        KB = JB*ABS(1.+CC)
      END IF

      CALL UIFPAC(KR, KG, KB, IRGB)

      RETURN

*-----------------------------------------------------------------------
      ENTRY UICINI(ZMIN, ZMAX)

      CALL UILGET('LCYCLE', LCYCLE)
      CALL UILGET('LMASK', LSHADE )

      IF(.NOT.LCSET) THEN
        RCMIN = ZMIN
        RCMAX = ZMAX
      END IF

      IF(.NOT.LSSET) THEN
        RSMIN = RCMIN
        RSMAX = RCMIN+(RCMAX-RCMIN)/10.
      END IF

      DO 200 I=1, NLEV
        RC(I) = RC0(I)*(RCMAX-RCMIN) + RCMIN
  200 CONTINUE

      DO 210 I=1, NSHADE
        RS(I) = RS0(I)*(RSMAX-RSMIN) + RSMIN
  210 CONTINUE

      RETURN
*-----------------------------------------------------------------------
      ENTRY UISCRG(ZMIN, ZMAX)

        IF(ZMIN.GE.ZMAX) THEN
          CALL MSGDMP('E','UISCRG','ZMIN > ZMAX.')
        END IF

        RCMIN = ZMIN
        RCMAX = ZMAX
        LCSET = .TRUE.
      RETURN

*-----------------------------------------------------------------------
      ENTRY UISMRG(ZMIN, ZMAX)

        IF(ZMIN.GE.ZMAX) THEN
          CALL MSGDMP('E','UISMRG','ZMIN > ZMAX.')
        END IF

        RSMIN = ZMIN
        RSMAX = ZMAX
        LSSET = .TRUE.
      RETURN

*-----------------------------------------------------------------------
      ENTRY UIQCRG(ZMIN, ZMAX)

        ZMIN = RCMIN
        ZMAX = RCMAX

      RETURN

*-----------------------------------------------------------------------
      ENTRY UIQMRG(ZMIN, ZMAX)

        ZMIN = RSMIN 
        ZMAX = RSMAX 

      RETURN

*-----------------------------------------------------------------------
      ENTRY UISCSQ(CLRLVL,  ICOLOR, N)

      IF(N.GT.NMAX) THEN
        CALL MSGDMP('M','UISCSQ','TOO MANY LEVEL (N).')
      END IF

      NLEV = MIN(N, NMAX)
      DO 20 I=1, N
        RC0(I) = (CLRLVL(I)-CLRLVL(1))/(CLRLVL(N)-CLRLVL(1))
        CALL UIIPAC(ICOLOR(I), IR(I), IG(I), IB(I))
  20  CONTINUE

      RETURN

*-----------------------------------------------------------------------
      ENTRY UISCFL(CDSN)

*     / INQUIRE OUTLINE FILE /

      CALL UIQFNM(CDSN,CDSNX)
      IF (CDSNX.EQ.' ') THEN
        CMSG='COLOR MAP FILE = '//CDSN(1:LENC(CDSN))
        CALL MSGDMP('M','UISCFL',CMSG)
        CALL MSGDMP('E','UISCFL','COLOR MAP FILE DOES NOT EXIST.')
      END IF

*     / OPEN OUTLINE FILE /

      IU=IUFOPN()
      OPEN(IU,FILE=CDSNX,FORM='FORMATTED',STATUS='OLD')

      READ(IU, '(I3)') NN

      IF(NN.GT.NMAX) THEN
        CALL MSGDMP('M','UISCFL','TOO MANY LEVEL.')
      END IF

      NLEV = MIN(NN, NMAX)

      DO 30 I=1, NLEV
        READ(IU, '(G6.4, Z8)',IOSTAT=IOST) XLEVEL, ICLR
        IF(IOST.NE.0) CALL MSGDMP('E','UISCFL','ERROR IN FILE.')

        RC0(I) = XLEVEL
        CALL UIIPAC(ICLR, IR(I), IG(I), IB(I))
  30  CONTINUE

      RMIN = RC0(1)
      RMAX = RC0(NLEV)
      DO 40 I=1, NLEV
        RC0(I) = (RC0(I)-RMIN)/(RMAX-RMIN)
  40  CONTINUE

      CLOSE(IU)
      RETURN
*-----------------------------------------------------------------------
      ENTRY UISMSQ(SHDLVL,  SHADE, N)

      IF(N.GT.NMAX) THEN
        CALL MSGDMP('M','UISMSQ','TOO MANY LEVEL (N).')
      END IF

      NSHADE = MIN(N,NMAX)
      DO 50 I=1, N
        RS0(I) = (SHDLVL(I)-SHDLVL(1))/(SHDLVL(N)-SHDLVL(1))
        SD (I) = SHADE(I)
  50  CONTINUE

      RETURN

*-----------------------------------------------------------------------
      ENTRY UISMFL(CDSN)

*     / INQUIRE OUTLINE FILE /

      CALL UIQFNM(CDSN,CDSNX)
      IF (CDSNX.EQ.' ') THEN
        CMSG='COLOR MAP FILE = '//CDSN(1:LENC(CDSN))
        CALL MSGDMP('M','UISMFL',CMSG)
        CALL MSGDMP('E','UISMFL','MASK FILE DOES NOT EXIST.')
      END IF

*     / OPEN OUTLINE FILE /

      IU=IUFOPN()
      OPEN(IU,FILE=CDSNX,FORM='FORMATTED',STATUS='OLD')

      READ(IU, '(I3)') NN
      IF(NN.GT.NMAX) THEN
        CALL MSGDMP('M','UISMFL','TOO MANY LEVEL.')
      END IF

      NSHADE = MIN(NN, NMAX)

      DO 60 I=1, NSHADE
        READ(IU, '(F6.4,F8.3)',IOSTAT=IOST) RS0(I), SD(I)
        IF(IOST.NE.0) CALL MSGDMP('E','UISMFL','ERROR IN FILE.')
  60  CONTINUE

      RMIN = RS0(1)
      RMAX = RS0(NSHADE)
      DO 70 I=1, NSHADE
        RS0(I) = (RS0(I)-RMIN)/(RMAX-RMIN)
  70  CONTINUE

      CLOSE(IU)
      END

*-----------------------------------------------------------------------
*     HEXDCI
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE HEXDCI(CP,IP)

      CHARACTER CP*(*)

      LOGICAL   LFST,LCHREQ,LCHAR
      CHARACTER CHEX(0:15)*1

      SAVE

      EXTERNAL  LCHREQ

      DATA      CHEX/ '0', '1', '2', '3', '4', '5', '6', '7',
     +                '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'/
      DATA      LFST/.TRUE./


      IF (LFST) THEN
        CALL GLIGET('NBITSPW',NBITS)
        NHEX=NBITS/4
        LFST=.FALSE.
      END IF

      NH=LEN(CP)
      IP=0
      DO 10 I=1,MIN(NHEX,NH)
        ISKIP=NBITS-I*4
        IDX=NH-I+1
        LCHAR=.FALSE.
        DO 15 J=0,15
          IF (LCHREQ(CP(IDX:IDX),CHEX(J))) THEN
            IPX=J
            LCHAR=.TRUE.
            GO TO 20
          END IF
   15   CONTINUE
   20   CONTINUE
        IF (.NOT.LCHAR) THEN
          CALL MSGDMP('E','HEXDCI','INVALID HEXADECIMAL CHARACTER.')
        END IF
        CALL SBYTE(IP,IPX,ISKIP,4)
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     TONE PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTNU(N,UPX,UPY)

      REAL      UPX(*),UPY(*),VPX(*),VPY(*),RPX(*),RPY(*)

      SAVE

      DATA      ITPATZ/1/


      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNU','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPATZ.EQ.0) THEN
        CALL MSGDMP('M','SGTNU','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPATZ.LT.0) THEN
        CALL MSGDMP('E','SGTNU','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZTNOP(ITPATZ)
      CALL SZTNZU(N,UPX,UPY)
      CALL SZTNCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTNV(N,VPX,VPY)

      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNV','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPATZ.EQ.0) THEN
        CALL MSGDMP('M','SGTNV','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPATZ.LT.0) THEN
        CALL MSGDMP('E','SGTNV','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZTNOP(ITPATZ)
      CALL SZTNZV(N,VPX,VPY)
      CALL SZTNCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTNR(N,RPX,RPY)

      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNR','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPATZ.EQ.0) THEN
        CALL MSGDMP('M','SGTNR','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPATZ.LT.0) THEN
        CALL MSGDMP('E','SGTNR','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZTNOP(ITPATZ)
      CALL SZTNZR(N,RPX,RPY)
      CALL SZTNCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSTNP(ITPAT)

      ITPATZ=ITPAT

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQTNP(ITPAT)

      ITPAT=ITPATZ

      RETURN
      END

*-----------------------------------------------------------------------
*     UDLINE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDLINE(Z,MX,KX,KY,KK,CX,LOPEN,IBR)

      INTEGER   IBR(*)
      REAL      Z(MX,*)
      LOGICAL   LOPEN

      INTEGER   JX(0:3),JY(0:3),JK(0:3)
      REAL      TX(0:3),TY(0:3),RTX(0:3)
      LOGICAL   LTX(0:3),LUDCHK,LNP,LEND

      SAVE


*     / MAIN /

      IX=KX
      IY=KY
      K =KK
      K1=1-K
      IX0=IX
      IY0=IY
      K0 =K
      CALL UDUXUY(Z,MX,IX,IY,K,CX,UX,UY)
      CALL SZOPLU
      CALL SZMVLU(UX,UY)
      IF (LOPEN) THEN
        CALL UDBCLR(IX,IY,K,0,IBR)
      END IF
      IX1=IX+K
      IY1=IY+K1
      IF (LUDCHK(IX1,IY1,K,1,IBR)) THEN
        CALL UDGRDN(1,IX,IY,K,JX,JY,JK)
      ELSE
        CALL UDGRDN(2,IX,IY,K,JX,JY,JK)
      END IF

   30 CONTINUE
        NP=0
        IF (LUDCHK(JX(2),JY(2),JK(2),1,IBR)) THEN
          LTX(0)=.TRUE.
          DO 10 J=1,3
            IF (LUDCHK(JX(J),JY(J),JK(J),0,IBR)) THEN
              NP=NP+1
              LTX(J)=.TRUE.
              JN=J
            ELSE
              LTX(J)=.FALSE.
            END IF
   10     CONTINUE
          IF (NP.EQ.1) THEN
            JP=JN
            CALL UDUXUY(Z,MX,JX(JP),JY(JP),JK(JP),CX,SX,SY)
          ELSE IF (NP.EQ.2) THEN
            IF (LTX(0).EQV.LTX(1)) THEN
              JP=1
            ELSE
              JP=3
            END IF
            CALL UDUXUY(Z,MX,JX(JP),JY(JP),JK(JP),CX,SX,SY)
          ELSE IF (NP.EQ.3) THEN
            DO 15 J=0,3
              CALL UDUXUY(Z,MX,JX(J),JY(J),JK(J),CX,TX(J),TY(J))
   15       CONTINUE
            CALL GLRGET('REALMAX',RTMIN)
            DO 20 J=0,3
              J1=J
              J2=MOD(J+1,4)
              RTX(J)=SQRT((TX(J1)-TX(J2))**2+(TY(J1)-TY(J2))**2)
              IF (RTX(J).LT.RTMIN) THEN
                RTMIN=RTX(J)
                JRT=J
              END IF
   20       CONTINUE
            JM1=JRT
            JM2=MOD(JRT+1,4)
            LTX(JM1)=.FALSE.
            LTX(JM2)=.FALSE.
            IF (LTX(0).EQV.LTX(1)) THEN
              JP=1
              SX=TX(1)
              SY=TY(1)
            ELSE
              JP=3
              SX=TX(3)
              SY=TY(3)
            END IF
          END IF
        END IF
        LNP=NP.EQ.0
        IF (.NOT.LNP) THEN
          CALL SZPLLU(SX,SY)
          IXD=JX(JP)-IX
          IYD=JY(JP)-IY
          IX=JX(JP)
          IY=JY(JP)
          K =JK(JP)
          CALL UDBCLR(IX,IY,K,0,IBR)
          IF ((K.EQ.0 .AND. IYD.EQ.1) .OR.
     +        (K.EQ.1 .AND. IXD.EQ.1)) THEN
            CALL UDGRDN(1,IX,IY,K,JX,JY,JK)
          ELSE
            CALL UDGRDN(2,IX,IY,K,JX,JY,JK)
          END IF
        END IF
        LEND=IX.EQ.IX0 .AND. IY.EQ.IY0 .AND. K.EQ.K0
      IF (.NOT.(LNP.OR.LEND)) GO TO 30

      CALL SZCLLU

      END

*-----------------------------------------------------------------------
*     PARAMETER CONTROL (GENERIC)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 122)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(  1)/'RDX     '/, ITYPE(  1) / 3 /
      DATA      CPARAS(  2)/'RDY     '/, ITYPE(  2) / 3 /
      DATA      CPARAS(  3)/'LCLIP   '/, ITYPE(  3) / 2 /
      DATA      CPARAS(  4)/'LCHAR   '/, ITYPE(  4) / 2 /
      DATA      CPARAS(  5)/'LLNINT  '/, ITYPE(  5) / 2 /
      DATA      CPARAS(  6)/'LGCINT  '/, ITYPE(  6) / 2 /
      DATA      CPARAS(  7)/'LSOFTF  '/, ITYPE(  7) / 2 /
      DATA      CPARAS(  8)/'LCL2TN  '/, ITYPE(  8) / 2 /
      DATA      CPARAS(  9)/'IRMODE  '/, ITYPE(  9) / 1 /
      DATA      CPARAS( 10)/'BITLEN  '/, ITYPE( 10) / 3 /
      DATA      CPARAS( 11)/'MOVE    '/, ITYPE( 11) / 1 /
      DATA      CPARAS( 12)/'NBITS   '/, ITYPE( 12) / 1 /
      DATA      CPARAS( 13)/'LCNTL   '/, ITYPE( 13) / 2 /
      DATA      CPARAS( 14)/'SMALL   '/, ITYPE( 14) / 3 /
      DATA      CPARAS( 15)/'SHIFT   '/, ITYPE( 15) / 3 /
      DATA      CPARAS( 16)/'ISUP    '/, ITYPE( 16) / 1 /
      DATA      CPARAS( 17)/'ISUB    '/, ITYPE( 17) / 1 /
      DATA      CPARAS( 18)/'IRST    '/, ITYPE( 18) / 1 /
      DATA      CPARAS( 19)/'LFULL   '/, ITYPE( 19) / 2 /
      DATA      CPARAS( 20)/'PMFACT  '/, ITYPE( 20) / 3 /
      DATA      CPARAS( 21)/'NPMSKIP '/, ITYPE( 21) / 1 /
      DATA      CPARAS( 22)/'RFAROT  '/, ITYPE( 22) / 3 /
      DATA      CPARAS( 23)/'TNBLEN  '/, ITYPE( 23) / 3 /
      DATA      CPARAS( 24)/'IFONT   '/, ITYPE( 24) / 1 /
      DATA      CPARAS( 25)/'ICLRMAP '/, ITYPE( 25) / 1 /
      DATA      CPARAS( 26)/'LFPROP  '/, ITYPE( 26) / 2 /
      DATA      CPARAS( 27)/'LROT    '/, ITYPE( 27) / 2 /
      DATA      CPARAS( 28)/'IROT    '/, ITYPE( 28) / 1 /
      DATA      CPARAS( 29)/'FWC     '/, ITYPE( 29) / 3 /
      DATA      CPARAS( 30)/'CWL     '/, ITYPE( 30) / 3 /
      DATA      CPARAS( 31)/'FFCT    '/, ITYPE( 31) / 3 /
      DATA      CPARAS( 32)/'INDEXC  '/, ITYPE( 32) / 1 /
      DATA      CPARAS( 33)/'LBUFF   '/, ITYPE( 33) / 2 /
      DATA      CPARAS( 34)/'NBUFF   '/, ITYPE( 34) / 1 /
      DATA      CPARAS( 35)/'RBUFF   '/, ITYPE( 35) / 3 /
      DATA      CPARAS( 36)/'LCURV   '/, ITYPE( 36) / 2 /
      DATA      CPARAS( 37)/'RCURV   '/, ITYPE( 37) / 3 /
      DATA      CPARAS( 38)/'LPROP   '/, ITYPE( 38) / 2 /
      DATA      CPARAS( 39)/'LUARW   '/, ITYPE( 39) / 2 /
      DATA      CPARAS( 40)/'AFACT   '/, ITYPE( 40) / 3 /
      DATA      CPARAS( 41)/'CONST   '/, ITYPE( 41) / 3 /
      DATA      CPARAS( 42)/'CONSTM  '/, ITYPE( 42) / 3 /
      DATA      CPARAS( 43)/'ANGLE   '/, ITYPE( 43) / 3 /
      DATA      CPARAS( 44)/'LARROW  '/, ITYPE( 44) / 2 /
      DATA      CPARAS( 45)/'LATONE  '/, ITYPE( 45) / 2 /
      DATA      CPARAS( 46)/'IATONE  '/, ITYPE( 46) / 1 /
      DATA      CPARAS( 47)/'IWS     '/, ITYPE( 47) / 0 /
      DATA      CPARAS( 48)/'ITR     '/, ITYPE( 48) / 1 /
      DATA      CPARAS( 49)/'IBGCLI  '/, ITYPE( 49) / 1 /
      DATA      CPARAS( 50)/'VXMIN   '/, ITYPE( 50) / 3 /
      DATA      CPARAS( 51)/'VXMAX   '/, ITYPE( 51) / 3 /
      DATA      CPARAS( 52)/'VYMIN   '/, ITYPE( 52) / 3 /
      DATA      CPARAS( 53)/'VYMAX   '/, ITYPE( 53) / 3 /
      DATA      CPARAS( 54)/'UXMIN   '/, ITYPE( 54) / 3 /
      DATA      CPARAS( 55)/'UXMAX   '/, ITYPE( 55) / 3 /
      DATA      CPARAS( 56)/'UYMIN   '/, ITYPE( 56) / 3 /
      DATA      CPARAS( 57)/'UYMAX   '/, ITYPE( 57) / 3 /
      DATA      CPARAS( 58)/'VXOFF   '/, ITYPE( 58) / 3 /
      DATA      CPARAS( 59)/'VYOFF   '/, ITYPE( 59) / 3 /
      DATA      CPARAS( 60)/'PLX     '/, ITYPE( 60) / 3 /
      DATA      CPARAS( 61)/'PLY     '/, ITYPE( 61) / 3 /
      DATA      CPARAS( 62)/'PLROT   '/, ITYPE( 62) / 3 /
      DATA      CPARAS( 63)/'SIMFAC  '/, ITYPE( 63) / 3 /
      DATA      CPARAS( 64)/'STLAT1  '/, ITYPE( 64) / 3 /
      DATA      CPARAS( 65)/'STLAT2  '/, ITYPE( 65) / 3 /
      DATA      CPARAS( 66)/'TXMIN   '/, ITYPE( 66) / 3 /
      DATA      CPARAS( 67)/'TXMAX   '/, ITYPE( 67) / 3 /
      DATA      CPARAS( 68)/'TYMIN   '/, ITYPE( 68) / 3 /
      DATA      CPARAS( 69)/'TYMAX   '/, ITYPE( 69) / 3 /
      DATA      CPARAS( 70)/'CXMIN   '/, ITYPE( 70) / 3 /
      DATA      CPARAS( 71)/'CXMAX   '/, ITYPE( 71) / 3 /
      DATA      CPARAS( 72)/'CYMIN   '/, ITYPE( 72) / 3 /
      DATA      CPARAS( 73)/'CYMAX   '/, ITYPE( 73) / 3 /
      DATA      CPARAS( 74)/'RSAT    '/, ITYPE( 74) / 3 /
      DATA      CPARAS( 75)/'LDEG    '/, ITYPE( 75) / 2 /
      DATA      CPARAS( 76)/'NFRAME  '/, ITYPE( 76) / 1 /
      DATA      CPARAS( 77)/'NPAGE   '/, ITYPE( 77) / 1 /
      DATA      CPARAS( 78)/'NLEVEL  '/, ITYPE( 78) / 1 /
      DATA      CPARAS( 79)/'FACTOR  '/, ITYPE( 79) / 3 /
      DATA      CPARAS( 80)/'INDEX   '/, ITYPE( 80) / 1 /
      DATA      CPARAS( 81)/'LCORNER '/, ITYPE( 81) / 2 /
      DATA      CPARAS( 82)/'LTITLE  '/, ITYPE( 82) / 2 /
      DATA      CPARAS( 83)/'CORNER  '/, ITYPE( 83) / 3 /
      DATA      CPARAS( 84)/'XPAD    '/, ITYPE( 84) / 3 /
      DATA      CPARAS( 85)/'YPAD    '/, ITYPE( 85) / 3 /
      DATA      CPARAS( 86)/'LWIDE   '/, ITYPE( 86) / 2 /
      DATA      CPARAS( 87)/'ITR3    '/, ITYPE( 87) / 1 /
      DATA      CPARAS( 88)/'TILT3   '/, ITYPE( 88) / 3 /
      DATA      CPARAS( 89)/'ANGLE3  '/, ITYPE( 89) / 3 /
      DATA      CPARAS( 90)/'XOFF3   '/, ITYPE( 90) / 3 /
      DATA      CPARAS( 91)/'YOFF3   '/, ITYPE( 91) / 3 /
      DATA      CPARAS( 92)/'XOBJ3   '/, ITYPE( 92) / 3 /
      DATA      CPARAS( 93)/'YOBJ3   '/, ITYPE( 93) / 3 /
      DATA      CPARAS( 94)/'ZOBJ3   '/, ITYPE( 94) / 3 /
      DATA      CPARAS( 95)/'XEYE3   '/, ITYPE( 95) / 3 /
      DATA      CPARAS( 96)/'YEYE3   '/, ITYPE( 96) / 3 /
      DATA      CPARAS( 97)/'ZEYE3   '/, ITYPE( 97) / 3 /
      DATA      CPARAS( 98)/'IXC3    '/, ITYPE( 98) / 1 /
      DATA      CPARAS( 99)/'IYC3    '/, ITYPE( 99) / 1 /
      DATA      CPARAS(100)/'SEC3    '/, ITYPE(100) / 3 /
      DATA      CPARAS(101)/'LFGBG   '/, ITYPE(101) / 2 /
      DATA      CPARAS(102)/'L2TO3   '/, ITYPE(102) / 2 /
      DATA      CPARAS(103)/'VXMIN3  '/, ITYPE(103) / 3 /
      DATA      CPARAS(104)/'VXMAX3  '/, ITYPE(104) / 3 /
      DATA      CPARAS(105)/'VYMIN3  '/, ITYPE(105) / 3 /
      DATA      CPARAS(106)/'VYMAX3  '/, ITYPE(106) / 3 /
      DATA      CPARAS(107)/'VZMIN3  '/, ITYPE(107) / 3 /
      DATA      CPARAS(108)/'VZMAX3  '/, ITYPE(108) / 3 /
      DATA      CPARAS(109)/'UXMIN3  '/, ITYPE(109) / 3 /
      DATA      CPARAS(110)/'UXMAX3  '/, ITYPE(110) / 3 /
      DATA      CPARAS(111)/'UYMIN3  '/, ITYPE(111) / 3 /
      DATA      CPARAS(112)/'UYMAX3  '/, ITYPE(112) / 3 /
      DATA      CPARAS(113)/'UZMIN3  '/, ITYPE(113) / 3 /
      DATA      CPARAS(114)/'UZMAX3  '/, ITYPE(114) / 3 /
      DATA      CPARAS(115)/'VXORG3  '/, ITYPE(115) / 3 /
      DATA      CPARAS(116)/'VYORG3  '/, ITYPE(116) / 3 /
      DATA      CPARAS(117)/'VZORG3  '/, ITYPE(117) / 3 /
      DATA      CPARAS(118)/'SIMFAC3 '/, ITYPE(118) / 3 /
      DATA      CPARAS(119)/'LXLOG3  '/, ITYPE(119) / 2 /
      DATA      CPARAS(120)/'LYLOG3  '/, ITYPE(120) / 2 /
      DATA      CPARAS(121)/'LZLOG3  '/, ITYPE(121) / 2 /
      DATA      CPARAS(122)/'LMRKFNT '/, ITYPE(122) / 2 /

*     / LONG  NAME /

      DATA      CPARAL(  1) / 'INTERPOLATION_ANGLE_X' /
      DATA      CPARAL(  2) / 'INTERPOLATION_ANGLE_Y' /
      DATA      CPARAL(  3) / 'ENABLE_CLIPPING' /
      DATA      CPARAL(  4) / 'ENABLE_LINE_LABELING' /
      DATA      CPARAL(  5) / 'ENABLE_LINEAR_INTERPOLATION' /
      DATA      CPARAL(  6) / 'ENABLE_GREATCIRCLE_INTERPOLATION' /
      DATA      CPARAL(  7) / 'ENABLE_SOFTFILL' /
      DATA      CPARAL(  8) / 'ENABLE_COLOR_SUBSTITUTION' /
      DATA      CPARAL(  9) / 'BOUNDARY_DIRECTION' /
      DATA      CPARAL( 10) / 'LINE_BIT_LENGTH' /
      DATA      CPARAL( 11) / 'LINE_RESUME_MODE' /
      DATA      CPARAL( 12) / 'PATTERN_BIT_LENGTH' /
      DATA      CPARAL( 13) / 'ENABLE_CONTROL_CHAR' /
      DATA      CPARAL( 14) / 'SCRIPT_HEIGHT' /
      DATA      CPARAL( 15) / 'SCRIPT_SHIFT' /
      DATA      CPARAL( 16) / 'BEGIN_SUPERSCRIPT' /
      DATA      CPARAL( 17) / 'BEGIN_SUBSCRIPT' /
      DATA      CPARAL( 18) / 'END_SCRIPT' /
      DATA      CPARAL( 19) / 'USE_FULL_WINDOW' /
      DATA      CPARAL( 20) / 'POLIMARKER_HEIGHT' /
      DATA      CPARAL( 21) / 'POLIMARKER_INTERVAL' /
      DATA      CPARAL( 22) / '****RFAROT  ' /
      DATA      CPARAL( 23) / 'TONE_CYCLE_LENGTH' /
      DATA      CPARAL( 24) / 'FONT_NUMBER' /
      DATA      CPARAL( 25) / 'COLORMAP_NUMBER' /
      DATA      CPARAL( 26) / 'ENABLE_PROPORTINAL_FONT' /
      DATA      CPARAL( 27) / 'ENABLE_LINE_LABEL_ROTATION' /
      DATA      CPARAL( 28) / 'LINE_LABEL_ROTATION_ANGLE' /
      DATA      CPARAL( 29) / 'LINE_LABEL_SPACE' /
      DATA      CPARAL( 30) / 'LINE_CYCLE_LENGTH' /
      DATA      CPARAL( 31) / 'LINE_START_POSITION' /
      DATA      CPARAL( 32) / 'LABEL_CHAR_INDEX' /
      DATA      CPARAL( 33) / 'ENABLE_LINE_BUFFERING' /
      DATA      CPARAL( 34) / 'LINE_BUFFERING_LENGTH' /
      DATA      CPARAL( 35) / 'RESUME_POSITION_AFTER_BUFFERING' /
      DATA      CPARAL( 36) / 'DISABLE_LINE_LABEL_AT_CURVE' /
      DATA      CPARAL( 37) / 'LINE_LABEL_THRESHOLD_CURVATURE' /
      DATA      CPARAL( 38) / 'FIX_ARROWHEAD_PROPORTION' /
      DATA      CPARAL( 39) / 'ENABLE_ARROWHEAD_MAPPING' /
      DATA      CPARAL( 40) / 'ARROWHEAD_PROPOTION' /
      DATA      CPARAL( 41) / 'ARROWHEAD_SIZE' /
      DATA      CPARAL( 42) / 'ARROWHEAD_SIZE_MAP' /
      DATA      CPARAL( 43) / 'ARROWHEAD_ANGLE' /
      DATA      CPARAL( 44) / '----LARROW  ' /
      DATA      CPARAL( 45) / 'ENABLE_ARROWHEAD_SHADE' /
      DATA      CPARAL( 46) / 'ARROWHEAD_SHADE_PATTERN' /
      DATA      CPARAL( 47) / '++++IWS     ' /
      DATA      CPARAL( 48) / '++++ITR     ' /
      DATA      CPARAL( 49) / 'BACKGROUND_COLOR_INDEX' /
      DATA      CPARAL( 50) / '++++VXMIN   ' /
      DATA      CPARAL( 51) / '++++VXMAX   ' /
      DATA      CPARAL( 52) / '++++VYMIN   ' /
      DATA      CPARAL( 53) / '++++VYMAX   ' /
      DATA      CPARAL( 54) / '++++UXMIN   ' /
      DATA      CPARAL( 55) / '++++UXMAX   ' /
      DATA      CPARAL( 56) / '++++UYMIN   ' /
      DATA      CPARAL( 57) / '++++UYMAX   ' /
      DATA      CPARAL( 58) / '++++VXOFF   ' /
      DATA      CPARAL( 59) / '++++VYOFF   ' /
      DATA      CPARAL( 60) / '++++PLX     ' /
      DATA      CPARAL( 61) / '++++PLY     ' /
      DATA      CPARAL( 62) / '++++PLROT   ' /
      DATA      CPARAL( 63) / '++++SIMFAC  ' /
      DATA      CPARAL( 64) / '++++STLAT1  ' /
      DATA      CPARAL( 65) / '++++STLAT2  ' /
      DATA      CPARAL( 66) / '++++TXMIN   ' /
      DATA      CPARAL( 67) / '++++TXMAX   ' /
      DATA      CPARAL( 68) / '++++TYMIN   ' /
      DATA      CPARAL( 69) / '++++TYMAX   ' /
      DATA      CPARAL( 70) / '++++CXMIN   ' /
      DATA      CPARAL( 71) / '++++CXMAX   ' /
      DATA      CPARAL( 72) / '++++CYMIN   ' /
      DATA      CPARAL( 73) / '++++CYMAX   ' /
      DATA      CPARAL( 74) / 'SATELLITE_ALTITUDE' /
      DATA      CPARAL( 75) / 'USE_DEGREE' /
      DATA      CPARAL( 76) / '****NFRAME  ' /
      DATA      CPARAL( 77) / '****NPAGE   ' /
      DATA      CPARAL( 78) / '****NLEVEL  ' /
      DATA      CPARAL( 79) / '****FACTOR  ' /
      DATA      CPARAL( 80) / 'CORNERMARK_INDEX' /
      DATA      CPARAL( 81) / 'DRAW_CORNERMARK' /
      DATA      CPARAL( 82) / 'DRAW_PAGE_TITLE' /
      DATA      CPARAL( 83) / 'CORNERMARK_LENGTH' /
      DATA      CPARAL( 84) / '****XPAD    ' /
      DATA      CPARAL( 85) / '****YPAD    ' /
      DATA      CPARAL( 86) / '****LWIDE   ' /
      DATA      CPARAL( 87) / '++++ITR3    ' /
      DATA      CPARAL( 88) / '++++TILT3   ' /
      DATA      CPARAL( 89) / '++++ANGLE3  ' /
      DATA      CPARAL( 90) / '++++XOFF3   ' /
      DATA      CPARAL( 91) / '++++YOFF3   ' /
      DATA      CPARAL( 92) / '++++XOBJ3   ' /
      DATA      CPARAL( 93) / '++++YOBJ3   ' /
      DATA      CPARAL( 94) / '++++ZOBJ3   ' /
      DATA      CPARAL( 95) / '++++XEYE3   ' /
      DATA      CPARAL( 96) / '++++YEYE3   ' /
      DATA      CPARAL( 97) / '++++ZEYE3   ' /
      DATA      CPARAL( 98) / '++++IXC3    ' /
      DATA      CPARAL( 99) / '++++IYC3    ' /
      DATA      CPARAL(100) / '++++SEC3    ' /
      DATA      CPARAL(101) / '****LFGBG   ' /
      DATA      CPARAL(102) / '****L2TO3   ' /
      DATA      CPARAL(103) / '++++VXMIN3  ' /
      DATA      CPARAL(104) / '++++VXMAX3  ' /
      DATA      CPARAL(105) / '++++VYMIN3  ' /
      DATA      CPARAL(106) / '++++VYMAX3  ' /
      DATA      CPARAL(107) / '++++VZMIN3  ' /
      DATA      CPARAL(108) / '++++VZMAX3  ' /
      DATA      CPARAL(109) / '++++UXMIN3  ' /
      DATA      CPARAL(110) / '++++UXMAX3  ' /
      DATA      CPARAL(111) / '++++UYMIN3  ' /
      DATA      CPARAL(112) / '++++UYMAX3  ' /
      DATA      CPARAL(113) / '++++UZMIN3  ' /
      DATA      CPARAL(114) / '++++UZMAX3  ' /
      DATA      CPARAL(115) / '++++VXORG3  ' /
      DATA      CPARAL(116) / '++++VYORG3  ' /
      DATA      CPARAL(117) / '++++VZORG3  ' /
      DATA      CPARAL(118) / '++++SIMFAC3 ' /
      DATA      CPARAL(119) / '++++LXLOG3  ' /
      DATA      CPARAL(120) / '++++LYLOG3  ' /
      DATA      CPARAL(121) / '++++LZLOG3  ' /
      DATA      CPARAL(122) / 'USE_DCLMARKER_FONT ' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','SGPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','SGPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','SGPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','SGPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL SGIQID(CPARAS(IDX), ID)
          CALL SGIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL SGLQID(CPARAS(IDX), ID)
          CALL SGLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL SGRQID(CPARAS(IDX), ID)
          CALL SGRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','SGPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL SGIQID(CPARAS(IDX), ID)
          CALL SGISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL SGLQID(CPARAS(IDX), ID)
          CALL SGLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL SGRQID(CPARAS(IDX), ID)
          CALL SGRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','SGPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!  SLpack module
!-------------------------------------------------
module slpack
  use dcl_common
  interface DclSetFrameSize
    subroutine slsize(size)  !第1フレームの再設定
      character(len=3), intent(in) :: size  !フレームの大きさと向き
    end subroutine

    subroutine slform(width,height)  !第1フレームの再設定
      real,      intent(in) :: width       !フレームの横,縦の実長, 単位cm
      real,      intent(in) :: height
    end subroutine
  end interface

  contains
!-----------------------------------------------------------------------
!主要ルーチン

    subroutine DclDivideFrame(direction,x_num,y_num) !フレームの分割
      character(len=1), intent(in) :: direction  !方向を指定
      integer,   intent(in) :: x_num          !X方向, Y方向の分割数
      integer,   intent(in) :: y_num

      call prcopn('DclDivideFrame')
      call sldiv(direction,x_num,y_num)
      call prccls('DclDivideFrame')
    end subroutine

    subroutine DclSetFrameMargin(left, right, bottom, top)   !マージンの設定． 
      real,      intent(in) :: left, right, bottom, top

      call prcopn('DclSetFrameMargin')
      call slmgn(left, right, bottom, top)
      call prccls('DclSetFrameMargin')
    end subroutine

    subroutine DclSetAspectRatio(x,y)  !縦横比の設定．   
      real, intent(in)           :: x  !フレームの縦横比を与える
      real, intent(in), optional :: y  !フレームの縦横比を与える

      call prcopn('DclSetAspectRatio')
      if(present(y)) then
        yy = y
      else
        yy = 1.
      end if

      call slrat(x,yy)
      call prccls('DclSetAspectRatio')
    end subroutine

    subroutine DclSetFrameTitle(title,side,x_position,y_position,height,num)
      character(len=*),  intent(in) :: title
      character(len=1),  intent(in) :: side
      real,              intent(in) :: x_position, y_position 
      real,              intent(in) :: height
      integer, optional, intent(in) :: num         !何番目の文字列かを指定する

      call prcopn('DclSetFrameTitle')
      if(present(num)) then
        nt = num
      else
        nt = 1
      end if
      call slsttl(title,side,x_position,y_position,height,nt) 
      call prccls('DclSetFrameTitle')
    end subroutine
!--------------------------------------------------------------------
!作画境界
    subroutine DclDrawViewPortFrame(index)  !ビューポートの枠を描く．
      integer,   intent(in) :: index  !線分のラインインデクス 

      call sgoopn('DclDrawViewPortFrame', ' ')
      call slpvpr(index)
      call sgocls('DclDrawViewPortFrame')
    end subroutine

    subroutine DclDrawDeviceWindowFrame(index)  !ウインドウの枠を描く
      integer,   intent(in) :: index  !線分のラインインデクス 

      call sgoopn('DclDrawDeviceWindowFrame', ' ')
      call slpwwr(index)
      call sgocls('DclDrawDeviceWindowFrame')
    end subroutine

    subroutine DclDrawDeviceViewPortFrame(index)  !最大作画領域の枠を描
      integer,   intent(in) :: index    !線分のラインインデクス 

      call sgoopn('DclDrawDeviceViewPortFrame', ' ')
      call slpwvr(index) 
      call sgocls('DclDrawDeviceViewPortFrame')
    end subroutine

    subroutine DclDrawViewPortCorner(index,size)  !ビューポートのコーナーマークを描く
      integer,   intent(in) :: index    !線分のラインインデクス 
      real,      intent(in) :: size    !コーナーマークの長さ

      call sgoopn('DclDrawViewPortCorner', ' ')
      call slpvpc(index,size)
      call sgocls('DclDrawViewPortCorner')
    end subroutine                             

    subroutine DclDrawDeviceWindowCorner(index,size)  !ウインドウのコーナーマークを描く
      integer,   intent(in) :: index    !線分のラインインデクス 
      real,      intent(in) :: size     !コーナーマークの長さ

      call sgoopn('DclDrawDeviceWindowCorner', ' ')
      call slpwwc(index,size)
      call sgocls('DclDrawDeviceWindowCorner')
    end subroutine

    subroutine DclDrawDeviceViewPortCorner(index,size) 
      integer,   intent(in) :: index  !線分のラインインデクス 
      real,      intent(in) :: size    !コーナーマークの長さ

      call sgoopn('DclDrawDeviceViewPortCorner', ' ')
      call slpwvc(index,size)
      call sgocls('DclDrawDeviceViewPortCorner')
    end subroutine

end module

*-----------------------------------------------------------------------
*     UYPTMK : PLOT TICKMARKS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPTMK(CSIDE,ISLCT,UY,N)

      REAL      UY(*)
      CHARACTER CSIDE*1

      LOGICAL   LUYCHK,LCHREQ
      CHARACTER CSLCT*1


      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYPTMK','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UYPTMK','''ISLCT'' IS INVALID.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UYPTMK','NUMBER OF POINTS IS INVALID.')
      END IF

      WRITE(CSLCT,'(I1)') ISLCT

      CALL UZRGET('ROFFY'//CSIDE,ROFFY)
      CALL UZRGET('ROFGY'//CSIDE,ROFGY)
      CALL UZIGET('INDEXT'//CSLCT,INDEX)
      CALL UZRGET('RSIZET'//CSLCT,RSIZE)
      CALL UZIGET('INNER',INNER)
      JSGN=SIGN(1,INNER)

      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
        IF (LCHREQ(CSIDE,'L')) THEN
          POSX=UXMN
          IFLAG=-1
        ELSE
          POSX=UXMX
          IFLAG=+1
        END IF
      ELSE
        CALL UZRGET('UXUSER',POSX)
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      RTICK=-RSIZE*JSGN*IFLAG

      IF (IFLAG.GE.0) THEN
        ROFFY=MAX(ROFGY+RTICK,ROFFY)
      ELSE
        ROFFY=MIN(ROFGY+RTICK,ROFFY)
      END IF

      CALL UYPTMZ(UY,N,POSX,ROFGY,RTICK,INDEX)

      CALL UZRSET('ROFFY'//CSIDE,ROFFY)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZM3ZU(N,UPX,UPY,UPZ)

      REAL      UPX(*),UPY(*),UPZ(*)

      LOGICAL   LFLAG,LCLIPZ

      COMMON    /SZBPM1/ LMISS,RMISS,NPM
      LOGICAL   LMISS
      COMMON    /SZBPM2/ CMARK
      CHARACTER CMARK*1
      COMMON    /SZBTX3/ LCLIP
      LOGICAL   LCLIP

      SAVE


      LCLIPZ=LCLIP
      LCLIP=.FALSE.
      CALL STEPR2

      DO 10 I=1,N,NPM
        LFLAG=LMISS .AND. 
     +      (UPX(I).EQ.RMISS .OR. UPY(I).EQ.RMISS .OR. UPZ(I).EQ.RMISS)
        IF (.NOT.LFLAG) THEN
          CALL STFTR3(UPX(I), UPY(I), UPZ(I), VX, VY, VZ)
          CALL STFPR3(VX, VY, VZ, RX, RY)
          CALL SZTXZV(RX,RY,CMARK)
        END IF
   10 CONTINUE

      LCLIP=LCLIPZ
      CALL STRPR2

      END

*-----------------------------------------------------------------------
*     PROCESS TABLE HANDLER
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE PRCOPN(CPROC)

      CHARACTER CPROC*(*)

      PARAMETER (MAXLVL=16)

      CHARACTER CMSGX*200,CPROCZ(0:MAXLVL)*32

      SAVE

      DATA NLEVEL    / 0 /
      DATA CPROCZ(0) /'MAIN  '/


      NLEVEL = NLEVEL + 1
      CPROCZ(NLEVEL) = CPROC

      RETURN
*-----------------------------------------------------------------------
      ENTRY PRCCLS(CPROC)

      IF (CPROC .EQ. CPROCZ(NLEVEL)) THEN
        CPROCZ(NLEVEL) = ' '
        NLEVEL = NLEVEL - 1
      ELSE
        CALL GLIGET('MSGUNIT',IUNIT)
        CALL GLIGET('NLNSIZE',LNSIZE)
        N0 = MIN(NLEVEL, 1)
        CMSGX='*** ERROR (PRCCLS IN '//CPROCZ(N0)//
     &        ') * PROCESS '//CPROCZ(NLEVEL)//
     &        ' HAS NOT BEEN CLOSED YET.'
        CALL MSZDMP(CMSGX,IUNIT,LNSIZE)
        CALL OSABRT
        STOP
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY PRCLVL(NLEV)

      NLEV = NLEVEL

      RETURN
*-----------------------------------------------------------------------
      ENTRY PRCNAM(NLEV, CPROC)

      IF (NLEV .LE. NLEVEL) THEN
        CPROC = CPROCZ(NLEV)
      ELSE
        CALL GLIGET('MSGUNIT',IUNIT)
        CALL GLIGET('NLNSIZE',LNSIZE)
        N0 = MIN(NLEVEL, 1)
        CMSGX='*** ERROR (PRCNAM IN '//CPROCZ(N0)//
     &        ') * TOO LARGE PROCESS LEVEL (NLEV).'
        CALL MSZDMP(CMSGX,IUNIT,LNSIZE)
        CALL OSABRT
        STOP
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UXYZ10

      PARAMETER ( ID0=19811201, ND=180, RND=ND )


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL UZFACT( 0.7 )
      CALL UZLSET( 'LOFFSET',.TRUE.)

      CALL GRFRM

      CALL SGSWND( 0.0, RND, 0.0, 100.0 )
      CALL SGSVPT( 0.4, 0.9, 0.3, 0.8 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SLPVPR( 1 )

      CALL UCXACL( 'B', ID0, ND )
      CALL UXSAXS( 'B' )
      CALL UXAXDV( 'B', 10.0, 20.0 )
      CALL UXSTTL( 'B', 'DAY NUMBER', 0.0 )
      CALL UCXACL( 'T', ID0, ND )

      CALL UYAXDV( 'L', 5.0, 10.0 )
      CALL UYAXDV( 'R', 5.0, 10.0 )
      CALL UYSTTL( 'L', 'CELSIUS SCALE', 0.0 )
      CALL UYSAXS( 'L' )
      CALL UZRSET( 'YOFFSET', 273.15 )
      CALL UZRSET( 'YFACT  ', 1.0 )
      CALL UYAXDV( 'L', 5.0, 10.0 )
      CALL UYSTTL( 'L', 'KELVIN SCALE', 0.0 )
      CALL UYSAXS( 'L' )
      CALL UZRSET( 'YOFFSET', 32.0 )
      CALL UZRSET( 'YFACT  ', 1.8 )
      CALL UYAXDV( 'L', 10.0, 20.0 )
      CALL UYSTTL( 'L', 'FAHRENHEIT SCALE', 0.0 )

      CALL UXSTTL( 'T', '( LOFSET=.TRUE. )', 0.0 )
      CALL UXSTTL( 'T', 'UXSAXS/UYSAXS', 0.0 )

      CALL GRCLS

      END

      PROGRAM QUICK3

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL P(NX,NY)

*-- 球面調和関数 ----
      DO 20 J=1,NY
        DO 10 I=1,NX
          ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
   10   CONTINUE
   20 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS
      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

      program cslib01

      PARAMETER (NX=100, NY=100, LEVEL=256)
      REAL R(NX,NY),B(NX,NY),G(NX,NY)
      REAL RC(NX,NY),BC(NX,NY),GC(NX,NY)
      INTEGER I

	  do i=1,nx
		do j=1,ny
			r(i,j) = exp(-((i-nx/2. )**2.  + (j-ny/2.)**2. ) / 5000.)
			g(i,j) = exp(-((i-nx/1.1)**2.  + (j-ny/1.2)**2.) / 1000.)
			b(i,j) = exp(-((i-ny/3. )**2.  + (j-ny/5.)**2. ) / 3000.)
		end do
      end do
      CALL RNORML(R,RC,NX,NY,0.0,1.0)
      CALL RNORML(G,GC,NX,NY,0.2,1.0)
      CALL RNORML(B,BC,NX,NY,0.0,1.0)

      CALL SWISET('WINDOW_HEIGHT', 300)
      CALL SWISET('WINDOW_WIDTH', 300)

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSWND( -1., 1., -1., 1.)
      CALL GRSVPT(.1, .9, .1, .9)
      CALL GRSTRN(1)
      CALL GRSTRF

      call prcopn('DclPaintGrid3')
      call uipda3(rc, gc, bc, nx, nx, ny)
      call prccls('DclPaintGrid3')

      CALL UXAXDV('T', .1, .5)
      CALL UXAXDV('B', .1, .5)
      CALL UYAXDV('L', .1, .5)
      CALL UYAXDV('R', .1, .5)

      CALL GRCLS


      end

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLINIT(WXMAX,WYMAX,FACT)

      CHARACTER CSZEZ*(*)

      LOGICAL   LCHREQ,LCHRD
      CHARACTER CSIZE*3,CS1*1,CS2*1,CS3*1

      COMMON    /SLBLK1/ XMIN,XMAX,YMIN,YMAX,NN
      PARAMETER (MAXFR=1000,MAXLEV=3)
      INTEGER   NN(0:MAXLEV)
      REAL      XMIN(MAXFR),XMAX(MAXFR),YMIN(MAXFR),YMAX(MAXFR)

      EXTERNAL  LCHREQ,LENC,LCHRD

      SAVE


      IF (.NOT.(WXMAX.GT.0 .AND. WYMAX.GT.0)) THEN
        CALL MSGDMP('E','SLINIT',
     +    'WIDTH OF LAYOUT RECTANGLE IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(FACT.GT.0)) THEN
        CALL MSGDMP('E','SLINIT','SCALING FACTOR IS LESS THAN ZERO.')
      END IF

      NN(0)=1
      XMIN(1)=0
      XMAX(1)=WXMAX
      YMIN(1)=0
      YMAX(1)=WYMAX

      NN(1)=1
      XMIN(2)=0
      XMAX(2)=WXMAX
      YMIN(2)=0
      YMAX(2)=WYMAX

      CALL SGISET('NLEVEL',1)
      CALL SGRSET('FACTOR',FACT)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SLSIZE(CSZEZ)

      CSIZE=CSZEZ
      CS1=CSIZE(1:1)
      CS2=CSIZE(2:2)
      CS3=CSIZE(3:3)
      IF (.NOT.(LCHREQ(CS1,'A') .OR. LCHREQ(CS1,'B'))) THEN
        CALL MSGDMP('E','SLSIZE','SIZE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.LCHRD(CS2)) THEN
        CALL MSGDMP('E','SLSIZE','SIZE PARAMETER IS INVALID.')
      END IF

      CALL SLQSIZ(CSIZE,DXX,DYY)

      IF (LCHREQ(CS3,'Y') .OR. LCHREQ(CS3,'L')) THEN
        DX=DXX
        DY=DYY
      ELSE IF (LCHREQ(CS3,'T') .OR. LCHREQ(CS3,'P')) THEN
        DX=DYY
        DY=DXX
      ELSE
        IF (.NOT.(LENC(CSIZE).EQ.2 .OR. LCHREQ(CS3,'A'))) THEN
          CALL MSGDMP('W','SLSIZE','SIZE PARAMETER IS INVALID.')
          CALL MSGDMP('M','-CNT.-',
     +      ''''//CSIZE(1:2)//'A'//''' IS ASSUMED.')
        END IF
        IF (XMAX(1)-XMIN(1).GT.YMAX(1)-YMIN(1)) THEN
          DX=DXX
          DY=DYY
        ELSE
          DX=DYY
          DY=DXX
        END IF
      END IF

      CALL SGRGET('FACTOR',FACTR)

      BWX=(XMAX(2)-XMIN(2))*FACTR
      BWY=(YMAX(2)-YMIN(2))*FACTR

      IF (BWX.LT.DX .OR. BWY.LT.DY) THEN
        CALL MSGDMP('W','SLSIZE',
     +    'SELECTED SIZE '''//CSIZE//''' CANNOT BE ASSIGNED.')
        CALL MSGDMP('M','-CNT.-','DO NOTHING.')
        RETURN
      END IF

      XX=(1-DX/BWX)/2
      YY=(1-DY/BWY)/2
      CALL SLMGNZ(XMIN(1),XMAX(1),YMIN(1),YMAX(1),XX,XX,YY,YY)

      XMIN(2)=XMIN(1)
      XMAX(2)=XMAX(1)
      YMIN(2)=YMIN(1)
      YMAX(2)=YMAX(1)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SLFORM(DXA,DYA)

      DX=DXA
      DY=DYA

      CALL SGRGET('FACTOR',FACTR)

      BWX=(XMAX(2)-XMIN(2))*FACTR
      BWY=(YMAX(2)-YMIN(2))*FACTR

      IF (BWX.LT.DX .OR. BWY.LT.DY) THEN
        CALL MSGDMP('W','SLFORM','SELECTED SIZE CANNOT BE ASSIGNED.')
        CALL MSGDMP('M','-CNT.-','DO NOTHING.')
        RETURN
      END IF

      XX=(1-DX/BWX)/2
      YY=(1-DY/BWY)/2
      CALL SLMGNZ(XMIN(1),XMAX(1),YMIN(1),YMAX(1),XX,XX,YY,YY)

      XMIN(2)=XMIN(1)
      XMAX(2)=XMAX(1)
      YMIN(2)=YMIN(1)
      YMAX(2)=YMAX(1)

      RETURN
      END

      PROGRAM U2D3

      PARAMETER( NX=37, NY=37, MY=7 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL      P(NX,NY), UY1(NY), UY2(MY)
      CHARACTER CH(MY)*3

      DATA      CH/ 'SP ', '60S', '30S', 'EQ ', '30N', '60N', 'NP ' /

      DO 10 J=1,NY
      DO 10 I=1,NX
        ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
        ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
        SLAT = SIN(ALAT)
        UY1(J) = SLAT
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
   10 CONTINUE

      DO 20 J=1,MY
        UY2(J) = SIN( ( YMIN + (YMAX-YMIN)*(J-1)/(MY-1) ) * DRAD )
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, -1.,  1. )
      CALL GRSVPT(  0.2,  0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UXAXDV( 'B', 10., 60. )
      CALL UXAXDV( 'T', 10., 60. )
      CALL UXSTTL( 'B', 'LONGITUDE', 0. )

      CALL UYAXDV( 'L', 0.1, 0.5 )
      CALL UYSTTL( 'L', 'SINE LATITUDE', 0. )

      CALL UZLSET( 'LABELYR', .TRUE. )
      CALL UYAXLB( 'R', UY1, NY, UY2, CH, 3, MY )
      CALL UYSTTL( 'R', 'LATITUDE', 0. )

      CALL UWSGXB( XMIN, XMAX, NX )
      CALL UWSGYA( UY1, NY )

      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLPAGE(LEV,IFRM,IPAGE)

      COMMON    /SLBLK1/ XMIN,XMAX,YMIN,YMAX,NN
      PARAMETER (MAXFR=1000,MAXLEV=3)
      INTEGER   NN(0:MAXLEV)
      REAL      XMIN(MAXFR),XMAX(MAXFR),YMIN(MAXFR),YMAX(MAXFR)

      CALL SGIGET('NLEVEL',LEVC)

      IF (.NOT.(0.LE.LEV .AND. LEV.LE.LEVC)) THEN
        CALL MSGDMP('E','SLPAGE','LEVEL NUMBER IS INVALID.')
      END IF
      IF (IFRM.LE.0) THEN
        CALL MSGDMP('E','SLPAGE','FRAME NUMBER IS LESS THAN ZERO.')
      END IF

      IPAGE=(IFRM-1)/NN(LEV)+1
      IFRM=MOD(IFRM-1,NN(LEV))+1

      END

*-----------------------------------------------------------------------
      PROGRAM SGPK04

      PARAMETER(N=41)
      DIMENSION X(N), Y(N)


      DT = 4.* 3.14159 / (N-1)
      DO 10 I=1,N
        Y(I) = SIN(DT*(I-1))*0.15
        X(I) = REAL(I-1)/REAL(N-1)
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)
      CALL SGFRM
      CALL SGSWND( 0.0, 1.0, -0.8, 0.2)
      CALL SGSVPT( 0.1, 0.9,  0.1, 0.9)
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SGLSET('LCLIP', .TRUE.)
      CALL SLPVPR(1)

      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (1列目)

      CALL SGSWND( 0.0, 1.0, -0.7, 0.3)
      CALL SGSTRF
      CALL SGSPMT(2)                         ! <-- マーカー TYPE 設定(+)
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (2列目)

      CALL SGSWND( 0.0, 1.0, -0.6, 0.4)
      CALL SGSTRF
      CALL SGSPMT(3)                         ! <-- マーカー TYPE 設定(*)
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (3列目)

      CALL SGSWND( 0.0, 1.0, -0.5, 0.5)
      CALL SGSTRF
      CALL SGSPMT(4)                         ! <-- マーカー TYPE 設定(o)
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (4列目)

      CALL SGSWND( 0.0, 1.0, -0.4, 0.6)
      CALL SGSTRF
      CALL SGSPMI(2)                         ! <-- マーカー INDEX 設定
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (5列目)

      CALL SGSWND( 0.0, 1.0, -0.3, 0.7)
      CALL SGSTRF
      CALL SGSPMI(3)
      CALL SGSPMT(2)

      CALL SGPLU(N, X, Y)                    ! <-- 折れ線描画
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (6列目)

      N1=N/4
      Y(N1-1) = 999.                         ! <-- 欠損値
      Y(N1  ) = 999.
      Y(N1+1) = 999.

      N2=N1*3
      Y(N2-1) = 999.
      Y(N2+1) = 999.

      CALL SGSWND( 0.0, 1.0, -0.2, 0.8)
      CALL SGSTRF
      CALL GLLSET('LMISS',.TRUE.)
      CALL SGSPMI(2)
      CALL SGSPMT(3)

      CALL SGPLU(N, X, Y)                    ! <-- 折れ線描画
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (7列目)

      CALL SGCLS

      END

*-----------------------------------------------------------------------
      PROGRAM UXYZ03


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL GRFRM

      CALL SGSWND( -50.0, +50.0, 1.0E3, 0.4 )
      CALL SGSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL SGSTRN( 2 )
      CALL SGSTRF

      CALL UXAXDV( 'B', 5.0, 20.0 )
      CALL UXAXDV( 'T', 5.0, 20.0 )
      CALL UXSTTL( 'B', 'LATITUDE', 0.0 )

      CALL ULISET( 'IYTYPE', 3 )
      CALL ULYLOG( 'L', 3, 9 )
      CALL ULYLOG( 'R', 3, 9 )
      CALL UYSTTL( 'L', 'PRESSURE (MB)', 0.0 )

      CALL UXMTTL( 'T', 'UXAXDV/ULYLOG', 0.0 )

      CALL GRCLS

      END

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program arrow

  use dcl
  integer,parameter :: nd=12
  real,parameter :: ddeg=360.0/nd, dd=0.25
  real :: rx(nd), ry(nd)

    do n = 1, nd
      rx(n) = dd*n*cos(DCL_PI/180*ddeg*(n-1))
      ry(n) = dd*n*sin(DCL_PI/180*ddeg*(n-1))
    end do

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( 0.0, 10.0, 0.0, 10.0 )
    call DclSetViewPort( 0.0, 1.0, 0.0, 1.0 )
    call DclSetTransFunction

    x1 = 3.0
    y1 = 7.0
    do n = 1, nd
      call DclDrawArrow( x1, y1, x1+rx(n), y1+ry(n) )
    end do

    call DclSetParm( 'FIX_ARROWHEAD_PROPORTION', .false. )
    call DclSetParm( 'ARROWHEAD_SIZE', 0.05 )
    x1 = 7.0
    y1 = 7.0
    do n = 1, nd
      call DclDrawArrow( x1, y1, x1+rx(n), y1+ry(n), index=2 )
    end do

    do i = 1, 8
      call DclSetParm( 'ARROWHEAD_ANGLE', 10.0*i )
      call DclDrawArrow( real(i), 2.0, real(i)+1, 3.0 )
    end do

    call DclCloseGraphics

end program

!-------------------------------------------------
!  DATElib Module
!-------------------------------------------------
module datelib
  use dcl_common
  
contains
!----------------------------------------------------------------
    function DclGetDate()
      type(dcl_date) :: DclGetDate

      call prcopn('DclGetDate')
      call dateq3(DclGetDate%year,DclGetDate%month,DclGetDate%day) 
      call prccls('DclGetDate')
    end function
!----------------------------------------------------------------
    function DclAddDate(date, n) 
      type(dcl_date) :: DclAddDate
      type(dcl_date), intent(in) :: date
      integer,        intent(in) :: n 

      call prcopn('DclAddDate')
      call datef3(n, date%year,      date%month,      date%day, &
            &        DclAddDate%year,DclAddDate%month,DclAddDate%day)
      call prccls('DclAddDate')
    end function
!----------------------------------------------------------------
    function DclDiffDate(date1, date2)
      integer                    :: DclDiffDate
      type(dcl_date), intent(in) :: date1, date2
      
      call prcopn('DclDiffDate')
      DclDiffDate = ndate3(date1%year, date1%month, date1%day, &
                  &        date2%year, date2%month, date2%day)
      call prccls('DclDiffDate')
    end function
!----------------------------------------------------------------
    subroutine DclFormatDate(cform,date)
      type(dcl_date),   intent(in)    :: date
      character(len=*), intent(inout) :: cform    !日付のフォーマット

      call prcopn('DclFormatDate')
      call datec3(cform,date%year,date%month,date%day)
      call prccls('DclFormatDate')
    end subroutine
!----------------------------------------------------------------
    function DclDayOfWeek(date)
      integer ::  DclDayOfWeek
      type(dcl_date),   intent(in)    :: date

      call prcopn('DclDayOfWeek')
      DclDayOfWeek = iweek3(date%year,date%month,date%day)  
      call prccls('DclDayOfWeek')
    end function
!----------------------------------------------------------------
    function DclLengthOfMonth(year,month)  !year年month月は何日あるかを返す．
      integer,   intent(in) :: year                 !年
      integer,   intent(in) :: month                 !月
      integer               :: DclLengthOfMonth 

      call prcopn('DclLengthOfMonth')
      DclLengthOfMonth = ndmon(year,month) 
      call prccls('DclLengthOfMonth')
    end function
!----------------------------------------------------------------
    function DclLengthOfYear(year)                !year年は何日あるかを返す．
      integer, intent(in) :: year                 !年
      integer             :: DclLengthOfYear    !指定した年の日数を与える関数値

      call prcopn('DclLengthOfYear')
      DclLengthOfYear = ndyear(year)  
      call prccls('DclLengthOfYear')
    end function
!----------------------------------------------------------------
end module

*-----------------------------------------------------------------------
      SUBROUTINE PASSF (NAC,IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,WA(*)      ,C2(IDL1,IP),
     2                CH2(IDL1,IP)
      IDOT = IDO/2
      NT = IP*IDL1
      IPP2 = IP+2
      IPPH = (IP+1)/2
      IDP = IP*IDO
C
      IF (IDO .LT. L1) GO TO 106
      DO 103 J=2,IPPH
         JC = IPP2-J
         DO 102 K=1,L1
            DO 101 I=1,IDO
               CH(I,K,J) = CC(I,J,K)+CC(I,JC,K)
               CH(I,K,JC) = CC(I,J,K)-CC(I,JC,K)
  101       CONTINUE
  102    CONTINUE
  103 CONTINUE
      DO 105 K=1,L1
         DO 104 I=1,IDO
            CH(I,K,1) = CC(I,1,K)
  104    CONTINUE
  105 CONTINUE
      GO TO 112
  106 DO 109 J=2,IPPH
         JC = IPP2-J
         DO 108 I=1,IDO
            DO 107 K=1,L1
               CH(I,K,J) = CC(I,J,K)+CC(I,JC,K)
               CH(I,K,JC) = CC(I,J,K)-CC(I,JC,K)
  107       CONTINUE
  108    CONTINUE
  109 CONTINUE
      DO 111 I=1,IDO
         DO 110 K=1,L1
            CH(I,K,1) = CC(I,1,K)
  110    CONTINUE
  111 CONTINUE
  112 IDL = 2-IDO
      INC = 0
      DO 116 L=2,IPPH
         LC = IPP2-L
         IDL = IDL+IDO
         DO 113 IK=1,IDL1
            C2(IK,L) = CH2(IK,1)+WA(IDL-1)*CH2(IK,2)
            C2(IK,LC) = -WA(IDL)*CH2(IK,IP)
  113    CONTINUE
         IDLJ = IDL
         INC = INC+IDO
         DO 115 J=3,IPPH
            JC = IPP2-J
            IDLJ = IDLJ+INC
            IF (IDLJ .GT. IDP) IDLJ = IDLJ-IDP
            WAR = WA(IDLJ-1)
            WAI = WA(IDLJ)
            DO 114 IK=1,IDL1
               C2(IK,L) = C2(IK,L)+WAR*CH2(IK,J)
               C2(IK,LC) = C2(IK,LC)-WAI*CH2(IK,JC)
  114       CONTINUE
  115    CONTINUE
  116 CONTINUE
      DO 118 J=2,IPPH
         DO 117 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)
  117    CONTINUE
  118 CONTINUE
      DO 120 J=2,IPPH
         JC = IPP2-J
         DO 119 IK=2,IDL1,2
            CH2(IK-1,J) = C2(IK-1,J)-C2(IK,JC)
            CH2(IK-1,JC) = C2(IK-1,J)+C2(IK,JC)
            CH2(IK,J) = C2(IK,J)+C2(IK-1,JC)
            CH2(IK,JC) = C2(IK,J)-C2(IK-1,JC)
  119    CONTINUE
  120 CONTINUE
      NAC = 1
      IF (IDO .EQ. 2) RETURN
      NAC = 0
      DO 121 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  121 CONTINUE
      DO 123 J=2,IP
         DO 122 K=1,L1
            C1(1,K,J) = CH(1,K,J)
            C1(2,K,J) = CH(2,K,J)
  122    CONTINUE
  123 CONTINUE
      IF (IDOT .GT. L1) GO TO 127
      IDIJ = 0
      DO 126 J=2,IP
         IDIJ = IDIJ+2
         DO 125 I=4,IDO,2
            IDIJ = IDIJ+2
            DO 124 K=1,L1
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)+WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)-WA(IDIJ)*CH(I-1,K,J)
  124       CONTINUE
  125    CONTINUE
  126 CONTINUE
      RETURN
  127 IDJ = 2-IDO
      DO 130 J=2,IP
         IDJ = IDJ+IDO
         DO 129 K=1,L1
            IDIJ = IDJ
            DO 128 I=4,IDO,2
               IDIJ = IDIJ+2
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)+WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)-WA(IDIJ)*CH(I-1,K,J)
  128       CONTINUE
  129    CONTINUE
  130 CONTINUE
      RETURN
      END

!-------------------------------------------------
!interface module of lrllib
!-------------------------------------------------
module lrl_interface
  interface

    function lreq(x,y)                            !xとyが等しいかどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      logical lreq                                !xとyが等しいとき .true.である論理関数値
    end function
      
    function lrne(x,y)                            !xとyが等しくないかどうか調べる．
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      logical lrne                                !xとyが等しくないとき .true.である論理関数値
    end function
      
    function lrlt(x,y)                            !xがyより小さいかどうか調べる．
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      logical lrlt                                !xがyより小さいとき .true.である論理関数値
    end function
      
    function lrle(x,y)                            !xがy以下かどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      logical lrle                                !xがy以下のとき .true.である論理関数値
    end function
      
    function lrgt(x,y)                            !xがyより大きいかどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      logical lrgt                                !xがyより大きいとき .true.である論理関数値
    end function
      
    function lrge(x,y)                            !xがy以上かどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      logical lrge                                !xがy以上のとき .true.である論理関数値
    end function
      
    function lreqa(x,y,epsl)                      !xが誤差epslの範囲でy と等しいかどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      real,      intent(in) :: epsl               !大小関係を調べるときの誤差
      logical lreqa                               !xとyが等しいとき .true.である論理関数値
    end function
      
    function lrnea(x,y,epsl)                      !xが誤差epslの範囲でyと等しくないかどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      real,      intent(in) :: epsl               !大小関係を調べるときの誤差
      logical lrnea                               !xとyが等しくないとき  .true.である論理関数値
    end function
      
    function lrlta(x,y,epsl)                      !xが誤差epslの範囲でy より小さいかどうか調べる．
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      real,      intent(in) :: epsl               !大小関係を調べるときの誤差
      logical lrlta                               !xがyより小さいとき .true.である論理関数値
    end function
      
    function lrlea(x,y,epsl)                      !xが誤差epslの範囲でy 以下かどうか調べる．
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      real,      intent(in) :: epsl               !大小関係を調べるときの誤差
      logical lrlea                               !xがy以下のとき .true.である論理関数値
    end function
      
    function lrgta(x,y,epsl)                      !xが誤差epslの範囲でy より大きいかどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      real,      intent(in) :: epsl               !大小関係を調べるときの誤差
      logical lrgta                               !xがyより大きいとき .true.である論理関数値
    end function
      
    function lrgea(x,y,epsl)                      !xが誤差epslの範囲でy 以上かどうか調べる
      real,      intent(in) :: x                  !調べる2つの実数値
      real,      intent(in) :: y
      real,      intent(in) :: epsl               !大小関係を調べるときの誤差
      logical lrgea                               !xがy以上のとき .true.である論理関数値
    end function

  end interface
end module
!lrllib library end ----

*-----------------------------------------------------------------------
*     UCLQNP / UCLQID / UCLQCP / UCLQVL / UCLSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 1)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      CPARAS( 1) /'LOWER   '/, LX( 1) /.FALSE./

      DATA      CPARAL( 1) / 'ENABLE_LOWERCASE_MONTH'  /

      DATA      LFIRST/.TRUE./


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UCLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UCLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UCLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UC', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','UCLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UC', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','UCLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCSTRF

      LOGICAL   LDEG, LXLOG, LYLOG, LZLOG


      CALL SGIGET('ITR3',ITR3)
      CALL SGLGET('LDEG',LDEG)
      CALL SCQLOG(LXLOG, LYLOG, LZLOG)

      IF (ITR3.EQ.1) THEN

*       / LINEAR AND LOG /

        CALL SCQVPT(VXMIN, VXMAX, VYMIN, VYMAX, VZMIN, VZMAX)

        IF (.NOT.(VXMIN.LT.VXMAX .AND. VYMIN.LT.VYMAX
     +                           .AND. VZMIN.LT.VZMAX)) THEN
          CALL MSGDMP('E','SCSTRF','VIEWPORT DEFINITION IS INVALID.')
        END IF

        CALL SCQWND(UXMIN, UXMAX, UYMIN, UYMAX, UZMIN, UZMAX)

        IF (.NOT. LXLOG) THEN
          CX  = (VXMAX-VXMIN) / (UXMAX-UXMIN)
          VX0 = VXMIN - CX*UXMIN
        ELSE
          IF (UXMIN*UXMAX.LE.0) THEN
            CALL MSGDMP('E','SCSTRF',
     +           'THE REGION STRADDLES 0 FOR LOG TRANSFORMATION (X).')
          END IF
          CX = (VXMAX-VXMIN) / LOG10(UXMAX/UXMIN)
          VX0 = VXMIN - CX*LOG10(ABS(UXMIN))
        END IF

        IF (.NOT. LYLOG) THEN
          CY = (VYMAX-VYMIN) / (UYMAX-UYMIN)
          VY0 = VYMIN - CY*UYMIN
        ELSE
          IF (UYMIN*UYMAX.LE.0) THEN
            CALL MSGDMP('E','SCSTRF',
     +           'THE REGION STRADDLES 0 FOR LOG TRANSFORMATION (Y).')
          END IF
          CY = (VYMAX-VYMIN) / LOG10(UYMAX/UYMIN)
          VY0 = VYMIN - CY*LOG10(ABS(UYMIN))
        END IF

        IF (.NOT. LZLOG) THEN
          CZ = (VZMAX-VZMIN) / (UZMAX-UZMIN)
          VZ0 = VZMIN - CZ*UZMIN
        ELSE
          IF (UZMIN*UZMAX.LE.0) THEN
            CALL MSGDMP('E','SCSTRF',
     +           'THE REGION STRADDLES 0 FOR LOG TRANSFORMATION (Z).')
          END IF
          CZ = (VZMAX-VZMIN) / LOG10(UZMAX/UZMIN)
          VZ0 = VZMIN - CZ*LOG10(ABS(UZMIN))
        END IF

        CALL STSTR3(ITR3, CX, CY, CZ, VX0, VY0, VZ0)
        CALL STSLG3(LXLOG, LYLOG, LZLOG)
        CALL STSRD3(.FALSE., .FALSE., .FALSE.)

      ELSE IF (ITR3.EQ.2) THEN

*       / CYLINDRICAL /

        CALL SGRGET('SIMFAC3', FAC)
        CALL SGRGET('VXORG3', VX0)
        CALL SGRGET('VYORG3', VY0)
        CALL SGRGET('VZORG3', VZ0)

        CALL STSTR3(ITR3, FAC, FAC, FAC, VX0, VY0, VZ0)
        CALL STSLG3(.FALSE., .FALSE., .FALSE.)
        CALL STSRD3(.FALSE., LDEG, .FALSE.)

      ELSE IF (ITR3.EQ.3) THEN

*       / SPHERICAL /

        CALL SGRGET('SIMFAC3', FAC)
        CALL SGRGET('VXORG3', VX0)
        CALL SGRGET('VYORG3', VY0)
        CALL SGRGET('VZORG3', VZ0)

        CALL STSTR3(ITR3, FAC, FAC, FAC, VX0, VY0, VZ0)
        CALL STSLG3(.FALSE., .FALSE., .FALSE.)
        CALL STSRD3(.FALSE., LDEG, LDEG)

      ELSE

        CALL MSGDMP('E','SCSTRF',
     +       'TRANSFORMATION FUNCTION NUMBER IS INVALID.')

      END IF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMBNDP(VXMIN, VXMAX, VYMIN, VYMAX)


      CALL GLRGET('RUNDEF', RUNDEF)

      CALL UMQPTN(NDATA)
      IF (NDATA .EQ. 0 ) RETURN
      IF (VXMIN .EQ. RUNDEF) THEN
        CALL UMQPNT(1, UXZ, UYZ)
        CALL STFTRF(UXZ, UYZ, VXMIN, VYMIN)
        VXMAX = VXMIN
        VYMAX = VYMIN
      END IF

      DO 40 I=1, NDATA
        CALL UMQPNT(I, UXZ, UYZ)
        CALL STFTRF(UXZ, UYZ, VX, VY)
        VXMIN = MIN (VXMIN, VX)
        VXMAX = MAX (VXMAX, VX)
        VYMIN = MIN (VYMIN, VY)
        VYMAX = MAX (VYMAX, VY)
   40 CONTINUE

      END

*-----------------------------------------------------------------------
*     IUFOPN
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      INTEGER FUNCTION IUFOPN()

      PARAMETER (IUMIN=1,IUMAX=99)

      LOGICAL   LEXIST,LOPEN


      DO 10 IU=IUMIN,IUMAX
        INQUIRE(UNIT=IU,EXIST=LEXIST,OPENED=LOPEN)
*       / THE FOLLOWING 1 LINE IS JUST FOR CONVENIENCE /
        LEXIST=.TRUE.
        IF (LEXIST .AND. .NOT.LOPEN) THEN
          IUFOPN=IU
          RETURN
        END IF
   10 CONTINUE

      CALL MSGDMP('E','IUFOPN','THERE IS NO UNIT TO BE OPENED.')

      END

*=======================================================================
*     USGRPH  FIGURE FOR STANDARD UNIT.
*=======================================================================

      WRITE(*,*) 'workstation no.? '
      READ (*,*) IWS
      CALL GROPN(IWS)
      CALL GRFRM

*------------------------ USPACK ROUTINES ------------------------------

      CALL USCSET('CXTTL' , 'X-TITLE')
      CALL USCSET('CYTTL' , 'Y-TITLE')
      CALL USCSET('CXUNIT', 'XSUB')
      CALL USCSET('CYUNIT', 'YSUB')
      CALL SGPSET('UYMIN' ,    0.)
      CALL SGPSET('UYMAX' , 5000.)
      CALL SGPSET('UXMIN' ,    0.)
      CALL SGPSET('UXMAX' , 2000.)
      CALL UZPSET('INNER' , -1)

      CALL USPFIT
      CALL GRSTRF
      CALL USDAXS

*-----------------------------------------------------------------------

      CALL UZPGET('RSIZET2', RSZT2)
      CALL UZPGET('RSIZEL1', RSZL1)
      CALL UZPGET('RSIZEC1', RSZC1)
      CALL UZPGET('PAD1',    PAD1)
      CALL USPGET('MXDGTY',  MXDGTY)
      CALL USPGET('MXDGTSY', MXDGTS)
      CALL USPGET('SOFFYLT', SOFFY)
      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      X1 = RSZT2
      X2 = (MXDGTY+PAD1) * RSZL1
      X3 = (1+PAD1)      * RSZC1

      Y1 = RSZT2
      Y2 = (1+PAD1) * RSZL1
      Y3 = (1+PAD1) * RSZL1
      Y4 = (1+PAD1) * RSZC1

      SX = RSZT2+(MXDGTS+PAD1)*RSZL1
      SY = SOFFY

*----------------------------- Y-AXIS ----------------------------------

      CALL SGPSET('LPROP', .FALSE.)
      CALL SGSTXS(0.02)

      VY1 = (VYMIN+VYMAX)/2.
      VY2 = VY1 + (VYMAX-VYMIN)/5.*2.
      VY0 = (VY1+VY2)/2

      VX1 = VXMIN - X1
      VX2 = VX1   - X2
      VX3 = VX2   - X3

      CALL SGLNV(VX1, VY1, VX1, VY2)
      CALL SGLNV(VX2, VY1, VX2, VY2)
      CALL SGLNV(VX3, VY1, VX3, VY2)

      CALL SGLAV(VX3, VY0, VX2, VY0)
      CALL SGLAV(VX2, VY0, VX3, VY0)

      CALL SGLAV(VX2, VY0, VX1, VY0)
      CALL SGLAV(VX1, VY0, VX2, VY0)

      CALL SGLAV(VXMIN+0.02, VY0, VXMIN, VY0)

      CALL SGTXV(VXMIN+0.02,   VY0+0.02, 'x_1"')
      CALL SGTXV((VX1+VX2)/2., VY0+0.02, 'x_2"')
      CALL SGTXV((VX2+VX3)/2., VY0+0.02, 'x_3"')

*---------------------------- SUB LABEL --------------------------------

      VY0 = VYMAX + SY*1.5
      VY1 = VYMAX + SY*2

      CALL SGLNV(VXMIN   , VYMAX, VXMIN   , VY1)
      CALL SGLNV(VXMIN-SX, VYMAX, VXMIN-SX, VY1)

      CALL SGLAV(VXMIN-SX, VY0, VXMIN   , VY0)
      CALL SGLAV(VXMIN   , VY0, VXMIN-SX, VY0)
      CALL SGTXV(VXMIN-SX/2., VY0+0.02, 's_x"')

      CALL SGLNV(VXMIN-X2/2., VYMAX+SY, VXMIN+X2/2., VYMAX+SY)
      CALL SGLAV(VXMIN+X2/3., VYMAX+SY, VXMIN+X2/3., VYMAX)
      CALL SGLAV(VXMIN+X2/3., VYMAX   , VXMIN+X2/3., VYMAX+SY)

      CALL SGTXV(VXMIN+X2/2., VYMAX+SY/2., 's_y"')

*----------------------------- X-AXIS ----------------------------------

      VY1 = VYMIN - Y1
      VY2 = VY1  - Y2
      VY3 = VY2  - Y3
      VY4 = VY3  - Y4

      VX1 = VXMIN + (VXMAX-VXMIN)*2/3.
      VX2 = VXMAX + X2
      VX0 = VX2 - 0.03

      CALL SGLNV(VX1, VY1, VX2, VY1)
      CALL SGLNV(VX1, VY2, VX2, VY2)
      CALL SGLNV(VX1, VY3, VX2, VY3)
      CALL SGLNV(VX1, VY4, VX2, VY4)
      CALL SGLNV(VXMAX, VYMIN, VX2, VYMIN)

      CALL SGLAV(VX0, VY4, VX0, VY3)
      CALL SGLAV(VX0, VY3, VX0, VY4)
      
      CALL SGLAV(VX0, VY3, VX0, VY2)
      CALL SGLAV(VX0, VY2, VX0, VY3)
      
      CALL SGLAV(VX0, VY2, VX0, VY1)
      CALL SGLAV(VX0, VY1, VX0, VY2)
      
      CALL SGLAV(VX0, VYMIN+0.02, VX0, VYMIN)

      CALL SGTXV(VX2, VYMIN+0.02,   'y_1"')
      CALL SGTXV(VX2, (VY1+VY2)/2., 'y_2"')
      CALL SGTXV(VX2, (VY2+VY3)/2., 'y_3"')
      CALL SGTXV(VX2, (VY3+VY4)/2., 'y_4"')

      CALL GRCLS
      STOP
      END

!-------------------------------------------------d
!interface module of ulpack
!-------------------------------------------------
module ul_interface
  interface
    subroutine ulxlog(cside,nlbl,nticks)          !対数座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      integer,   intent(in) :: nlbl               !1桁の範囲に描くラベルの数
      integer,   intent(in) :: nticks             !1桁の範囲に描く目盛の数
    end subroutine
      
    subroutine ulylog(cside,nlbl,nticks)          !対数座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      integer,   intent(in) :: nlbl               !1桁の範囲に描くラベルの数
      integer,   intent(in) :: nticks             !1桁の範囲に描く目盛の数
    end subroutine
      
    subroutine ulxsfm(cfmt)                       !フォーマットを設定する
      character(len=*), intent(in) :: cfmt        !文字書式仕様あるいはサブルーチンchvalが解釈するオプション
    end subroutine
      
    subroutine ulysfm(cfmt)                       !フォーマットを設定する
      character(len=*), intent(in) :: cfmt        !文字書式仕様あるいはサブルーチンchvalが解釈するオプション
    end subroutine
      
    subroutine ulxqfm(cfmt)                       !フォーマット参照する
      character(len=*), intent(out) :: cfmt
    end subroutine
      
    subroutine ulyqfm(cfmt)                       !フォーマット参照する
      character(len=*), intent(out) :: cfmt
    end subroutine
      
    subroutine ulsxbl(bl,nbl)                     !x軸ラベルを描く位置を指定する．
      real,      intent(in), dimension(nbl) :: bl !1桁の範囲に描くラベルの位置
      integer,   intent(in) :: nbl                !配列blの長さ
    end subroutine
      
    subroutine ulsybl(bl,nbl)                     !y軸ラベルを描く位置を指定する．
      real,      intent(in), dimension(nbl) :: bl !1桁の範囲に描くラベルの位置
      integer,   intent(in) :: nbl                !配列blの長さ
    end subroutine
      
    subroutine ulqxbl(bl,nbl)                     !x軸ラベルを描く位置を参照する．
      real,      intent(out), dimension(nbl) :: bl
      integer,   intent(in) :: nbl
    end subroutine
      
    subroutine ulqybl(bl,nbl)                     !y軸ラベルを描く位置を参照する．
      real,      intent(out), dimension(nbl) :: bl
      integer,   intent(in) :: nbl
    end subroutine
      
    subroutine ulpget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uliget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ulrget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ullget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ulpset(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uliset(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ulrset(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ullset(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ulpstx(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ulistx(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ulrstx(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ullstx(cp,ipara)                   !内部変数を設定
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ulpqnp(ncp)                        !内部変数の総数を求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine ulpqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine ulpqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する
      character(len=*), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine ulpqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine ulpsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine

  end interface
end module
!ulpack library end ----

*-----------------------------------------------------------------------
      SUBROUTINE CFFTB1 (N,C,CH,WA,IFAC)
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDOT = IDO+IDO
         IDL1 = IDOT*L1
         IF (IP .NE. 4) GO TO 103
         IX2 = IW+IDOT
         IX3 = IX2+IDOT
         IF (NA .NE. 0) GO TO 101
         CALL PASSB4 (IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 102
  101    CALL PASSB4 (IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102    NA = 1-NA
         GO TO 115
  103    IF (IP .NE. 2) GO TO 106
         IF (NA .NE. 0) GO TO 104
         CALL PASSB2 (IDOT,L1,C,CH,WA(IW))
         GO TO 105
  104    CALL PASSB2 (IDOT,L1,CH,C,WA(IW))
  105    NA = 1-NA
         GO TO 115
  106    IF (IP .NE. 3) GO TO 109
         IX2 = IW+IDOT
         IF (NA .NE. 0) GO TO 107
         CALL PASSB3 (IDOT,L1,C,CH,WA(IW),WA(IX2))
         GO TO 108
  107    CALL PASSB3 (IDOT,L1,CH,C,WA(IW),WA(IX2))
  108    NA = 1-NA
         GO TO 115
  109    IF (IP .NE. 5) GO TO 112
         IX2 = IW+IDOT
         IX3 = IX2+IDOT
         IX4 = IX3+IDOT
         IF (NA .NE. 0) GO TO 110
         CALL PASSB5 (IDOT,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 111
  110    CALL PASSB5 (IDOT,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111    NA = 1-NA
         GO TO 115
  112    IF (NA .NE. 0) GO TO 113
         CALL PASSB (NAC,IDOT,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         GO TO 114
  113    CALL PASSB (NAC,IDOT,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114    IF (NAC .NE. 0) NA = 1-NA
  115    L1 = L2
         IW = IW+(IP-1)*IDOT
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      N2 = N+N
      DO 117 I=1,N2
         C(I) = CH(I)
  117 CONTINUE
      RETURN
      END

!-------------------------------------------------
!interface module of grpack
!-------------------------------------------------
module gr_interface
  interface
!-------------------------------------------------
!コントロール
    subroutine gropn(iws)                         !図形出力装置をオープン
      integer,   intent(in) :: iws                !ワークステーション番号
    end subroutine
      
    subroutine grfrm                            !新しい作画領域を設定する
    end subroutine
      
    subroutine grfig                            !初期化
    end subroutine
      
    subroutine grcls                            !図形出力装置をクローズ.
    end subroutine
!-------------------------------------------------
!正規化変換
    subroutine grsvpt(vxmin,vxmax,vymin,vymax)    !正規化変換のためのビューポートを設定．
      real,      intent(in) :: vxmin              !ビューポート
      real,      intent(in) :: vxmax
      real,      intent(in) :: vymin
      real,      intent(in) :: vymax
    end subroutine
      
    subroutine grswnd(uxmin,uxmax,uymin,uymax)    !正規化変換のためのパラメータを設定．
      real,      intent(in) :: uxmin              !ウインドウ
      real,      intent(in) :: uxmax
      real,      intent(in) :: uymin
      real,      intent(in) :: uymax
    end subroutine
      
    subroutine grssim(simfac,vxoff,vyoff)         !正規化変換のためのパラメータを設定．
      real,      intent(in) :: simfac             !相似変換のスケーリングファクター
      real,      intent(in) :: vxoff              !原点のオフセット
      real,      intent(in) :: vyoff
    end subroutine
      
    subroutine grsmpl(plx,ply,plrot)              !正規化変換のためのパラメータを設定．
      real,      intent(in) :: plx                !地図投影の際の回転角
      real,      intent(in) :: ply
      real,      intent(in) :: plrot
    end subroutine
      
    subroutine grstrn(itr)                        !正規化変換の変換関数番号を指定．
      integer,   intent(in) :: itr                !変換関数番号
    end subroutine
      
    subroutine grstrf()                           !正規化変換を確定．
    end subroutine

  end interface
end module
!grpack library end ----

*-----------------------------------------------------------------------
C     SUBROUTINE COSTI(N,WSAVE)
C
C     SUBROUTINE COSTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     SUBROUTINE COST. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N-1 IS A PRODUCT OF SMALL PRIMES.
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             DIFFERENT WSAVE ARRAYS ARE REQUIRED FOR DIFFERENT VALUES
C             OF N. THE CONTENTS OF WSAVE MUST NOT BE CHANGED BETWEEN
C             CALLS OF COST.
C
      SUBROUTINE COSTI (N,WSAVE)
      DIMENSION       WSAVE(*)
      EXTERNAL RFPI
C
      PI = RFPI()
      IF (N .LE. 3) RETURN
      NM1 = N-1
      NP1 = N+1
      NS2 = N/2
      DT = PI/FLOAT(NM1)
      FK = 0.
      DO 101 K=2,NS2
         KC = NP1-K
         FK = FK+1.
         WSAVE(K) = 2.*SIN(FK*DT)
         WSAVE(KC) = 2.*COS(FK*DT)
  101 CONTINUE
      CALL RFFTI (NM1,WSAVE(N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVBRLZ(N,UPX,UPY,ITYPE,INDEX,RSIZE)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG, LMISS, LXUNI
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.2) THEN
        CALL MSGDMP('E','UVBRLZ','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UVBRLZ','LINE TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UVBRLZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UVBRLZ','LINE INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UVBRLZ','BAR SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UVBRLZ','BAR SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      IF (UPY(1).EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'UVBRLZ', 'RUNDEF CAN NOT BE UESED FOR UPY.')
      END IF

      WRITE(COBJ,'(2I8)') ITYPE,INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVBRLZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)
      CALL SZOPLU

      LXUNI = UPX(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/(N-1)
      END IF

      CALL SZOPLV

      LFLAG=.FALSE.
      DO 20 I=1,N
        IF (LXUNI) THEN
          UXX = UXMIN + DX*(I-1)
        ELSE
          UXX = UPX(I)
        END IF

        IF ((UXX.EQ.RMISS .OR. UPY(I).EQ.RMISS) .AND. LMISS) THEN
          LFLAG=.FALSE.
        ELSE
          CALL STFTRF(UXX, UPY(I), VXX, VYY)
          IF (LFLAG) THEN
            CALL SZPLLV(VXX-RSIZE/2.,VYY)
            CALL SZPLLV(VXX+RSIZE/2.,VYY)
          ELSE
            CALL SZMVLV(VXX-RSIZE/2.,VYY)
            CALL SZPLLV(VXX+RSIZE/2.,VYY)
            LFLAG=.TRUE.
          END IF
        END IF
   20 CONTINUE

      CALL SZCLLV
      CALL SWOCLS('UVBRLZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSNTR(UXMIN, UXMAX, UYMIN, UYMAX,
     +                  VXMIN, VXMAX, VYMIN, VYMAX, ITR)


      CALL MSGDMP('M','SGSNTR','THIS IS OLD INTERFACE.')

      IF (.NOT.(1.LE.ITR .AND. ITR.LE.4))
     +     CALL MSGDMP('W', 'SGSNTR', 'INVALID TRANSFORMATION NUMBER.')

      CALL SGSWND(UXMIN, UXMAX, UYMIN, UYMAX)
      CALL SGSVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGSTRN(ITR)
      CALL SGSTRF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQNTR(UXMIN, UXMAX, UYMIN, UYMAX,
     +             VXMIN, VXMAX, VYMIN, VYMAX, ITR)


      CALL MSGDMP('M','SGQNTR','THIS IS OLD INTERFACE.')

      CALL SGQTRN(ITR)
      IF (.NOT.(1.LE.ITR .AND. ITR.LE.4))
     +     CALL MSGDMP('W', 'SGQNTR', 'INVALID TRANSFORMATION NUMBER.')

      CALL SGQWND(UXMIN, UXMAX, UYMIN, UYMAX)
      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVDIFZ(N,UPX,UPY1,UPY2,ITPAT1,ITPAT2)

      REAL      UPX(*),UPY1(*),UPY2(*)

      LOGICAL   LMISS, LXUNI, LYC1, LYC2
      CHARACTER COBJ*80

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UVDIFZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','UVDIFZ','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LT.0) THEN
        CALL MSGDMP('E','UVDIFZ','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP)
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      CALL STFPR2(0., 0., RX0, RY0)
      CALL STFPR2(0., 1., RX1, RY1)
      CALL STFPR2(1., 0., RX2, RY2)

      ROT = (RX2-RX0)*(RY1-RY0) - (RY2-RY0)*(RX1-RX0)

      IF (ROT.GT.0) THEN
        IR = 0
      ELSE
        IR = 1
      END IF

      WRITE(COBJ,'(2I8)') ITPAT1, ITPAT2
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVDIFZ',COBJ)

      LXUNI = UPX(1).EQ.RUNDEF
      LYC1  = UPY1(1).EQ.RUNDEF
      LYC2  = UPY2(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/(N-1)
      END IF

      IF (LYC1 .OR. LYC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N-1
        IF (LXUNI) THEN
          UXP = UXMIN + DX*(I-1)
          UXN = UXMIN + DX*I
        ELSE
          UXP = UPX(I)
          UXN = UPX(I+1)
        END IF

        IF (LYC1) THEN
          UY1P = UREF
          UY1N = UREF
        ELSE
          UY1P = UPY1(I)
          UY1N = UPY1(I+1)
        END IF

        IF (LYC2) THEN
          UY2P = UREF
          UY2N = UREF
        ELSE
          UY2P = UPY2(I)
          UY2N = UPY2(I+1)
        END IF

        IF (.NOT.
     #    ((UXP .EQ.RMISS .OR. UXN .EQ.RMISS .OR.
     #      UY1P.EQ.RMISS .OR. UY1N.EQ.RMISS .OR.
     #      UY2P.EQ.RMISS .OR. UY2N.EQ.RMISS) .AND. LMISS)) THEN

          CALL STFTRF(UXP, UY1P, VXP, VY1P)
          CALL STFTRF(UXP, UY2P, VXP, VY2P)
          CALL STFTRF(UXN, UY1N, VXN, VY1N)
          CALL STFTRF(UXN, UY2N, VXN, VY2N)

          IF ((VY2P-VY1P)*(VY2N-VY1N) .GE. 0) THEN
            IF (VY2P.GE.VY1P) THEN
              IRMODE = 0
            ELSE
              IRMODE = 1
            END IF
            IRMODR = MOD(IRMODE+IR, 2)

            IF (UY2P .GT. UY1P) THEN
              CALL SZSTNI(ITPAT1)
            ELSE
              CALL SZSTNI(ITPAT2)
            END IF

            CALL SZOPTV
            CALL SZSTTV(VXP, VY2P)
            CALL SZSTTV(VXP, VY1P)
            CALL SZSTTV(VXN, VY1N)
            CALL SZSTTV(VXN, VY2N)
            CALL SZSTTV(VXP, VY2P)
            CALL SZCLTV
          ELSE
            DYP = ABS(VY2P-VY1P)
            DYN = ABS(VY2N-VY1N)
            VXC = (VXP*DYN  + VXN*DYP ) / (DYP + DYN)
            VYC = (VY1P*DYN + VY1N*DYP) / (DYP + DYN)

            IF (VY2P.GE.VY1P) THEN
              IRMODE = 0
            ELSE
              IRMODE = 1
            END IF
            IRMODR = MOD(IRMODE+IR, 2)

            IF (UY2P .GT. UY1P) THEN
              CALL SZSTNI(ITPAT1)
            ELSE
              CALL SZSTNI(ITPAT2)
            END IF

            CALL SZOPTV
            CALL SZSTTV(VXP, VY2P)
            CALL SZSTTV(VXP, VY1P)
            CALL SZSTTV(VXC, VYC )
            CALL SZSTTV(VXP, VY2P)
            CALL SZCLTV

            IRMODE = MOD(IRMODE+1,  2)
            IRMODR = MOD(IRMODE+IR, 2)

            IF (UY2N .GT. UY1N) THEN
              CALL SZSTNI(ITPAT1)
            ELSE
              CALL SZSTNI(ITPAT2)
            END IF

            CALL SZOPTV
            CALL SZSTTV(VXN, VY1N)
            CALL SZSTTV(VXN, VY2N)
            CALL SZSTTV(VXC, VYC )
            CALL SZSTTV(VXN, VY1N)
            CALL SZCLTV
          END IF
        END IF
   20 CONTINUE

      CALL SWOCLS('UVDIFZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SCPKT7

      PARAMETER( NX=37 )
      PARAMETER(  XMIN=   0,  XMAX=360,  YMIN=-1,  YMAX= 1 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )

      REAL ALON(NX), ALAT(NX), R(NX), A(NX)


      DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
        ALAT(I) = YMIN + (YMAX-YMIN)*(I-1)/(NX-1)
        R   (I) = 1.
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM
      CALL SGLSET('LDEG', .TRUE.)

*---------------- 3-D ------------------

      CALL SCSORG(1., 0., 0., 0.)
      CALL SCSTRN(2)
      CALL SCSTRF

      CALL SCSEYE(  5., 1.,  2. )
      CALL SCSOBJ(  0.0,  0.0,  0.0 )
      CALL SCSPRJ

      DO 100 I=1, NX
        DO 110 J=1, NX
          A(J) = ALAT(I)
  110   CONTINUE
        CALL SCPLU(NX, R, ALON, A)
  100 CONTINUE

      DO 200 I=1, NX
        DO 210 J=1, NX
          A(J) = ALON(I)
  210   CONTINUE
        CALL SCPLU(NX, R, A, ALAT)
  200 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     3-D TRANSFORMATION
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE STFTR3(UX, UY, UZ, VX, VY, VZ)

      LOGICAL   LXRD, LYRD, LZRD, LXLG, LYLG, LZLG

      LOGICAL   LMISS, LXRDZ, LYRDZ, LZRDZ, LXLGZ, LYLGZ, LZLGZ

      EXTERNAL  RFPI

      SAVE


      IF (LMISS .AND. 
     #    (UX.EQ.RMISS .OR. UY.EQ.RMISS .OR. UZ.EQ.RMISS)) THEN
        VX = RMISS
        VY = RMISS
        VZ = RMISS
        RETURN
      END IF

      XX = UX
      YY = UY
      ZZ = UZ

      IF (ITRZ.EQ.1) THEN
        IF (LXLGZ.OR.LYLGZ.OR.LZLGZ) 
     +       CALL SCQWND(UXMIN3,UXMAX3,UYMIN3,UYMAX3,UZMIN3,UZMAX3)
        IF (LXLGZ) THEN
          XX = SIGN(1.0,UXMIN3)*XX
          IF (XX.GT.0.0) THEN
            XX = LOG10(XX)
          ELSE
            CALL MSGDMP('E','STFTR3',
     +           'UX HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
          END IF
        END IF
        IF (LYLGZ) THEN
          YY = SIGN(1.0,UYMIN3)*YY
          IF (YY.GT.0.0) THEN
            YY = LOG10(YY)
          ELSE
            CALL MSGDMP('E','STFTR3',
     +           'UY HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
          END IF
        END IF
        IF (LZLGZ) THEN
          ZZ = SIGN(1.0,UZMIN3)*ZZ
          IF (ZZ.GT.0.0) THEN
            ZZ = LOG10(ZZ)
          ELSE
            CALL MSGDMP('E','STFTR3',
     +           'UZ HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
          END IF
        END IF
        XXX = XX
        YYY = YY
        ZZZ = ZZ
      ELSE IF (ITRZ.EQ.2) THEN
        IF (LXLGZ.OR.LZLGZ) 
     +       CALL SCQWND(UXMIN3,UXMAX3,UYMIN3,UYMAX3,UZMIN3,UZMAX3)
        IF (LXLGZ) THEN 
          XX = SIGN(1.0,UXMIN3)*XX
          IF (XX.GT.0.0) THEN
            XX = LOG10(XX)
          ELSE
            CALL MSGDMP('E','STFTR3',
     +           'UX HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
          END IF
        END IF
        IF (LYRDZ) YY = YY*CP
        IF (LZLGZ) THEN
          ZZ = SIGN(1.0,UZMIN3)*ZZ
          IF (ZZ.GT.0.0) THEN
            ZZ = LOG10(ZZ)
          ELSE
            CALL MSGDMP('E','STFTR3',
     +           'UZ HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
          END IF
        END IF
        ZZZ = ZZ
        CALL CT2PC(XX,YY,XXX,YYY)
      ELSE IF (ITRZ.EQ.3) THEN
        IF (LXLGZ) 
     +     CALL SCQWND(UXMIN3,UXMAX3,UYMIN3,UYMAX3,UZMIN3,UZMAX3)
        IF (LXLGZ) THEN
          XX = SIGN(1.0,UXMIN3)*XX
          IF (XX.GT.0.0) THEN
            XX = LOG10(XX)
          ELSE
            CALL MSGDMP('E','STFTR3',
     +           'UX HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
          END IF
        END IF
        IF(LYRDZ) YY = YY*CP
        IF(LZRDZ) ZZ = ZZ*CP
        CALL CT3SC(XX, YY, ZZ, XXX, YYY, ZZZ)
      END IF

      VX = CX*XXX + VX0
      VY = CY*YYY + VY0
      VZ = CZ*ZZZ + VZ0

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSTR3(ITR, CXA, CYA, CZA, VXOFF, VYOFF, VZOFF)

      ITRZ = ITR
      CX  = CXA
      CY  = CYA
      CZ  = CZA
      VX0 = VXOFF
      VY0 = VYOFF
      VZ0 = VZOFF
      CP  = RFPI()/180

      CALL GLLGET('LMISS',LMISS)
      CALL GLRGET('RMISS',RMISS)

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSRD3(LXRD, LYRD, LZRD)

      LXRDZ = LXRD
      LYRDZ = LYRD
      LZRDZ = LZRD

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSLG3(LXLG, LYLG, LZLG)

      LXLGZ = LXLG
      LYLGZ = LYLG
      LZLGZ = LZLG

      END

*-----------------------------------------------------------------------
*     UDRQNP / UDRQID / UDRQCP / UDRQVL / UDRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 3)
      PARAMETER (RUNDEF = -999.)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'RSIZEL  ' /, RX(1) / RUNDEF /
      DATA      CPARAS(2) / 'RSIZET  ' /, RX(2) / RUNDEF /
      DATA      CPARAS(3) / 'XTTL    ' /, RX(3) / 0.0 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'CONTOUR_LABEL_HEIGHT' /
      DATA      CPARAL(2) / 'CONTOUR_MESSAGE_HEIGHT' /
      DATA      CPARAL(3) / 'CONTOUR_MESSAGE_POSITION' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UDRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UDRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UDRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UD', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
        IF ((IDX.EQ.1 .OR. IDX.EQ.2) .AND. RPARA.EQ.RUNDEF) THEN
          CALL UZRGET('RSIZEL1', RPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UDRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UD', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UDRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!interface module of vralib
!-------------------------------------------------
module vra_interface
  interface

    subroutine vrfna(rx,ry,n,jx,jy,rfna)          !RXにRFNAを作用させてRYに代入する
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(out), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      external rfna                               !引数が1個である実数型関数名
    end subroutine
      
    subroutine vrinc(rx,ry,n,jx,jy,rr)            !RXにRRを加えてRYに代入する
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(out), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      real,      intent(in) :: rr                 !加える実数値
    end subroutine
      
    subroutine vrfct(rx,ry,n,jx,jy,rr)            !RXにRRを掛けてRYに代入する．     
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(out), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      real,      intent(in) :: rr                 !掛ける実数値
    end subroutine
      
    subroutine vrcon(rx,ry,n,jx,jy,rr)            !RRをRYに代入する．   
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(out), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      real,      intent(in) :: rr                 !代入する実数値
    end subroutine
      
    subroutine vrset(rx,ry,n,jx,jy)               !RXをRYに代入する． 
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(out), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
    end subroutine
!-------------------------------------------
    subroutine radd(rx,n,jx,rr)                   !RXにRRを加える．   
      real,      intent(inout), dimension(*) :: rx !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      real,      intent(in) :: rr                 !加える実数値
    end subroutine
      
    subroutine rmlt(rx,n,jx,rr)                   !RXにRRを掛ける．
      real,      intent(inout), dimension(*) :: rx !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      real,      intent(in) :: rr                 !掛ける実数値
    end subroutine
      
    subroutine rset(rx,n,jx,rr)                   !RXにRRを代入する．  
      real,      intent(inout), dimension(*) :: rx !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      real,      intent(in) :: rr                 !代入する実数値
    end subroutine

  end interface
end module
!vralib library end ----

*-----------------------------------------------------------------------
*     UZFACT
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UZFACT(RFACT)


      IF (RFACT.LE.0) THEN
        CALL MSGDMP('E','UZFACT','FACTOR IS LESS THAN ZERO.')
      END IF

      CALL UZRGET('RSIZET1',RSIZT1)
      CALL UZRGET('RSIZET2',RSIZT2)
      CALL UZRGET('RSIZEL1',RSIZL1)
      CALL UZRGET('RSIZEL2',RSIZL2)
      CALL UZRGET('RSIZEC1',RSIZC1)
      CALL UZRGET('RSIZEC2',RSIZC2)

      CALL UZRSET('RSIZET1',RSIZT1*RFACT)
      CALL UZRSET('RSIZET2',RSIZT2*RFACT)
      CALL UZRSET('RSIZEL1',RSIZL1*RFACT)
      CALL UZRSET('RSIZEL2',RSIZL2*RFACT)
      CALL UZRSET('RSIZEC1',RSIZC1*RFACT)
      CALL UZRSET('RSIZEC2',RSIZC2*RFACT)

      END

!-------------------------------------------------
!interface module of uwpack
!-------------------------------------------------
module uw_interface
  interface

    subroutine uwsgxa(xp,nx)                      !格子点配列の格子点座標を各座標値で設定する．
      real,      intent(in), dimension(nx) :: xp  !長さnxの配列． x座標をu座標系の値で指定する
      integer,   intent(in) :: nx                 !配列xpの長さ
    end subroutine
      
    subroutine uwqgxa(xp,nx)                      !現在設定されている格子点の座標値
      real,      intent(out), dimension(nx) :: xp
      integer,   intent(in) :: nx
    end subroutine
      
    subroutine uwsgya(yp,ny)                      !格子点配列の格子点座標を各座標値で設定する．
      real,      intent(in), dimension(ny) :: yp  !長さnyの配列． y座標をu座標系の値で指定する
      integer,   intent(in) :: ny                 !配列xpの長さ
    end subroutine
      
    subroutine uwqgya(yp,ny)                      !現在設定されている格子点の座標値
      real,      intent(out), dimension(ny) :: yp
      integer,   intent(in) :: ny
    end subroutine
      
    subroutine uwsgxb(uxmin,uxmax,nx)             !格子点座標を最小値,最大値,格子点数で設定する．
      real,      intent(in) :: uxmin              !u座標系におけるx座標の最小値
      real,      intent(in) :: uxmax              !u座標系におけるx座標の最大値
      integer,   intent(in) :: nx                 !x方向の格子点数．
    end subroutine
      
    subroutine uwsgyb(uymin,uymax,ny)             !格子点座標を最小値,最大値,格子点数で設定する．
      real,      intent(in) :: uymin              !u座標系におけるy座標の最小値
      real,      intent(in) :: uymax              !u座標系におけるy座標の最大値
      integer,   intent(in) :: ny                 !y方向の格子点数．
    end subroutine
      
    subroutine uwqgxb(uxmin,uxmax,nx)             !格子点座標の最小値,最大値,格子点数の参照
      real,      intent(out) :: uxmin             !u座標系におけるx座標の最小値
      real,      intent(out) :: uxmax             !u座標系におけるx座標の最大値
      integer,   intent(out) :: nx                 !x方向の格子点数．
    end subroutine
      
    subroutine uwqgyb(uymin,uymax,ny)             !格子点座標の最小値,最大値,格子点数の参照
      real,      intent(out) :: uymin             !u座標系におけるy座標の最小値
      real,      intent(out) :: uymax             !u座標系におけるy座標の最大値
      integer,   intent(out) :: ny                 !y方向の格子点数
    end subroutine
      
    subroutine uwqgxz(lsetx)                      !格子点が定義されているかどうかを調べる．
      logical,   intent(out) :: lsetx             !格子点が定義されているかどうかを調べる論理変数
    end subroutine
      
    subroutine uwqgyz(lsety)                      !格子点が定義されているかどうかを調べる．
      logical,   intent(out) :: lsety             !格子点が定義されているかどうかを調べる論理変数
    end subroutine
      
    subroutine uwsgxz(lsetx)
      logical,   intent(in) :: lsetx
    end subroutine
      
    subroutine uwsgyz(lsety)
      logical,   intent(in) :: lsety
    end subroutine
      
    function ruwgx(ix)                            !格子点の座標値を返す．
      integer,   intent(in) :: ix                 !格子点の番号
      real ruwgx                                  !格子点のu座標系の座標値
    end function
      
    function ruwgy(iy)                            !格子点の座標値を返す．
      integer,   intent(in) :: iy                 !格子点の番号
      real ruwgy                                  !格子点のu座標系の座標値
    end function
      
    function iuwgx(ux)                            !座標値に最も近い格子番号を返す．
      real,      intent(in) :: ux                 !座標値
      integer iuwgx                               !格子点番号
    end function
      
    function iuwgy(uy)                            !座標値に最も近い格子番号を返す．
      real,      intent(in) :: uy                 !格子点の番号
      integer iuwgy                               !格子点番号
    end function
      
    subroutine uwqgxi(ux,iux,fracx)               !与えられた座標値よりも小さい最大の格子点番号を返す． 次のグリッドとの間の位置も返す．
      real,      intent(in) :: ux                 !座標値
      integer,   intent(out) :: iux               !格子点番号
      real,      intent(out) :: fracx             !次の格子点との間での位置．
    end subroutine
      
    subroutine uwqgyi(uy,iuy,fracy)               !与えられた座標値よりも小さい最大の格子点番号を返す． 次のグリッドとの間の位置も返す．
      real,      intent(in) :: uy                 !座標値
      integer,   intent(out) :: iuy               !格子点番号
      real,      intent(out) :: fracy             !次の格子点との間での位置
    end subroutine
      
    subroutine uwdflt(nx,ny)                      !等間隔グリッドを設定する．
      integer,   intent(in) :: nx                 !グリッド数
      integer,   intent(in) :: ny                 !グリッド数
    end subroutine

  end interface
end module
!uwpack library end ----

*-----------------------------------------------------------------------
*     UGIQNP / UGIQID / UGIQCP / UGIQVL / UGISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 10)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'INDEX   ' /, IX( 1) / 3 /
      DATA      CPARAS( 2) / 'ICENT   ' /, IX( 2) / 0 /
      DATA      CPARAS( 3) / 'ITYPE1  ' /, IX( 3) / 5 /
      DATA      CPARAS( 4) / 'ITYPE2  ' /, IX( 4) / 1 /
      DATA      CPARAS( 5) / 'IXINT   ' /, IX( 5) / 1 /
      DATA      CPARAS( 6) / 'IYINT   ' /, IX( 6) / 1 /
      DATA      CPARAS( 7) / 'IUNTTL  ' /, IX( 7) / 0 /
      DATA      CPARAS( 8) / 'IUINDX  ' /, IX( 8) / 3 /
      DATA      CPARAS( 9) / 'IUTXRO  ' /, IX( 9) / 0 /
      DATA      CPARAS(10) / 'IUTYRO  ' /, IX(10) / 90 /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'VECTOR_INDEX' /
      DATA      CPARAL( 2) / 'VECTOR_GRID_POSITION' /
      DATA      CPARAL( 3) / 'MISS_VECTOR_MARKER_TYPE' /
      DATA      CPARAL( 4) / 'SMALL_VECTOR_MARKER_TYPE' /
      DATA      CPARAL( 5) / '****IXINT   ' /
      DATA      CPARAL( 6) / '****IYINT   ' /
      DATA      CPARAL( 7) / '****IUNTTL  ' /
      DATA      CPARAL( 8) / 'UNIT_VECTOR_TITLE_INDEX' /
      DATA      CPARAL( 9) / 'UNIT_VECTOR_X_TITLE_ANGLE' /
      DATA      CPARAL(10) / 'UNIT_VECTOR_Y_TITLE_ANGLE' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UGIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UGIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UGIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UG', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','UGIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UG', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','UGISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UUMRKZ(N,UPX,UPY,ITYPE,INDEX,RSIZE)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG, LMISS, LXUNI, LYUNI
      CHARACTER CMARK*1, CSGI*1, COBJ*80

      COMMON    /SZBTX3/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UUMRKZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UUMRKZ','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UUMRKZ','MARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UUMRKZ','MARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UUMRKZ','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UUMRKZ','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLLGET('LMISS' , LMISS)
      CALL GLRGET('RMISS' , RMISS)
      CALL SGRGET('PMFACT', PMF)
      CALL SGIGET('NPMSKIP',NPM)

      CMARK=CSGI(ITYPE)

      WRITE(COBJ,'(2I8,F8.5)') ITYPE,INDEX,RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('UUMRKZ',COBJ)

      CALL SZTXOP(RSIZE*PMF,0,0,INDEX)

      LXUNI = UPX(1).EQ.RUNDEF
      LYUNI = UPY(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF(UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF(UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/(N-1)
      END IF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF(UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF(UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/(N-1)
      END IF

      DO 10 I=1,N,NPM
        IF (LXUNI) THEN
          UXX = UXMIN + DX*(I-1)
        ELSE
          UXX = UPX(I)
        END IF

        IF (LYUNI) THEN
          UYY = UYMIN + DY*(I-1)
        ELSE
          UYY = UPY(I)
        END IF

        LFLAG=LMISS .AND. (UXX.EQ.RMISS .OR. UYY.EQ.RMISS)
        IF (.NOT.LFLAG) THEN
          CALL SZTXZU(UXX,UYY,CMARK)
        END IF
   10 CONTINUE

      CALL SZTXCL
      CALL SWOCLS('UUMRKZ')

      END

program sample06

  use dcl
  integer,parameter :: nx=36, ny=36
  real,parameter :: xmin=0., xmax=360., ymin=-90., ymax=90.
  real,dimension(0:nx,0:ny) :: p

!-- 球面調和関数 ----

    do j=0,ny
      do i=0,nx
        alon = ( xmin + (xmax-xmin)*i/nx ) * DCL_PI/180.
        alat = ( ymin + (ymax-ymin)*j/ny ) * DCL_PI/180.
        p(i,j) = sqrt(1-sin(alat)**2) * sin(alat) * cos(alon)
      end do
    end do

!-- グラフ ----

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransFunction

    call DclShadeContour( p )

    call DclDrawScaledAxis

    call DclDrawContour( p )

    call DclCloseGraphics

end program

SUBROUTINE WR_USGI_(A,B,C) BIND(C,NAME='usgi__')
  USE iso_c_binding
  INTEGER(c_int),VALUE :: B
  CHARACTER(1,c_char) :: A(B)
  INTEGER(c_int) :: C(*)
  CHARACTER(3) :: USGI

  CALL CHAR_TRIM(USGI(C),A,3)

END

SUBROUTINE WR_CSGI_(A,B,C) BIND(C,NAME='csgi__')
  USE iso_c_binding
  CHARACTER(1,c_char) :: A
  INTEGER(c_int),VALUE :: B
  INTEGER(c_int) :: C(*)
  CHARACTER(1) :: CSGI

  A=CSGI(C)

END

INTEGER(c_int) FUNCTION WR_IAND_(A,B) BIND(C,NAME='iand__')
  USE iso_c_binding
  INTEGER(c_int) :: A(*)
  INTEGER(c_int) :: B(*)
  CALL iand(A,B)
END

INTEGER(c_int) FUNCTION WR_IOR_(A,B) BIND(C,NAME='ior__')
  USE iso_c_binding
  INTEGER(c_int) :: A(*)
  INTEGER(c_int) :: B(*)
  CALL ior(A,B)
END


INTEGER(c_int) FUNCTION WR_USAXLB_(A,B,C,D,E,F,G,H,I) BIND(C,NAME='usaxlb__')
  USE iso_c_binding

  CHARACTER(1,c_char) :: A(*)
  REAL(c_float) :: B(*)
  INTEGER(c_int) :: C(*)
  REAL(c_float) :: D(*)
  CHARACTER(1,c_char) :: E(*)
  INTEGER(c_int) :: F
  INTEGER(c_int) :: G
  INTEGER(c_int),VALUE :: H
  INTEGER(c_int),VALUE :: I
  CHARACTER(F) :: EA(G)
  CHARACTER(:,C_char),ALLOCATABLE :: AA

  Allocate(Character(H,C_char) :: AA )

  CALL CHAR_TRIM(A,AA,H)
  CALL CHAR_TRIM2(E,EA,F,G,I)

  WR_USAXLB_=usaxlb(AA,B,C,D,EA,F,G)

END


INTEGER(c_int) FUNCTION WR_UXAXLB_(A,B,C,D,E,F,G,H,I) BIND(C,NAME='uxaxlb__')
  USE iso_c_binding

  CHARACTER(1,c_char) :: A(*)
  REAL(c_float) :: B(*)
  INTEGER(c_int) :: C(*)
  REAL(c_float) :: D(*)
  CHARACTER(1,c_char) :: E(*)
  INTEGER(c_int) :: F
  INTEGER(c_int) :: G
  INTEGER(c_int),VALUE :: H
  INTEGER(c_int),VALUE :: I
  CHARACTER(F) :: EA(G)
  CHARACTER(:,C_char),ALLOCATABLE :: AA

  Allocate(Character(H,C_char) :: AA )

  CALL CHAR_TRIM(A,AA,H)
  CALL CHAR_TRIM2(E,EA,F,G,I)

  WR_UXAXLB_=uxaxlb(AA,B,C,D,EA,F,G)
END

INTEGER(c_int) FUNCTION WR_UYAXLB_(A,B,C,D,E,F,G,H,I) BIND(C,NAME='uyaxlb__')
  USE iso_c_binding

  CHARACTER(1,c_char) :: A(*)
  REAL(c_float) :: B(*)
  INTEGER(c_int) :: C(*)
  REAL(c_float) :: D(*)
  CHARACTER(1,c_char) :: E(*)
  INTEGER(c_int) :: F
  INTEGER(c_int) :: G
  INTEGER(c_int),VALUE :: H
  INTEGER(c_int),VALUE :: I
  CHARACTER(:,C_char),ALLOCATABLE :: AA
  CHARACTER(F) :: EA(G)

  Allocate(Character(H,C_char) :: AA )

  CALL CHAR_TRIM(A,AA,H)
  CALL CHAR_TRIM2(E,EA,F,G,I)

  WR_UYAXLB_=uyaxlb(AA,B,C,D,EA,F,G)
END

INTEGER(c_int) FUNCTION WR_USPLBL_(A,B,C,D,E,F,G,H) BIND(C,NAME='usplbl__')
  USE iso_c_binding

  CHARACTER(1,c_char) :: A(*)
  INTEGER(c_int) :: B(*)
  REAL(c_float) :: C(*)
  CHARACTER(1,c_char) :: D(*)
  INTEGER(c_int) :: E
  INTEGER(c_int) :: F
  INTEGER(c_int),VALUE :: G
  INTEGER(c_int),VALUE :: H
  CHARACTER(E) :: DA(F)
  CHARACTER(:,C_char),ALLOCATABLE :: AA

  Allocate(Character(G,C_char) :: AA )

  CALL CHAR_TRIM(A,AA,G)
  CALL CHAR_TRIM2(D,DA,E,F,H)

  WR_USPLBL_=usplbl(AA,B,C,DA,E,F)
END

INTEGER(c_int) FUNCTION WR_UXPLBL_(A,B,C,D,E,F,G,H) BIND(C,NAME='uxplbl__')
  USE iso_c_binding

  CHARACTER(1,c_char) :: A(*)
  INTEGER(c_int) :: B(*)
  REAL(c_float) :: C(*)
  CHARACTER(1,c_char) :: D(*)
  INTEGER(c_int) :: E
  INTEGER(c_int) :: F
  INTEGER(c_int),VALUE :: G
  INTEGER(c_int),VALUE :: H
  CHARACTER(E) :: DA(F)
  CHARACTER(:,C_char),ALLOCATABLE :: AA

  Allocate(Character(G,C_char) :: AA )

  CALL CHAR_TRIM(A,AA,G)
  CALL CHAR_TRIM2(D,DA,E,F,H)

  WR_UXPLBL_=uxplbl(AA,B,C,DA,E,F)
END

INTEGER(c_int) FUNCTION WR_UYPLBL_(A,B,C,D,E,F,G,H) BIND(C,NAME='uyplbl__')
  USE iso_c_binding

  CHARACTER(1,c_char) :: A(*)
  INTEGER(c_int) :: B(*)
  REAL(c_float) :: C(*)
  CHARACTER(1,c_char) :: D(*)
  INTEGER(c_int) :: E
  INTEGER(c_int) :: F
  INTEGER(c_int),VALUE :: G
  INTEGER(c_int),VALUE :: H
  CHARACTER(E) :: DA(F)
  CHARACTER(:,C_char),ALLOCATABLE :: AA

  Allocate(Character(G,C_char) :: AA )

  CALL CHAR_TRIM(A,AA,G)
  CALL CHAR_TRIM2(D,DA,E,F,H)

  WR_UYPLBL_=uyplbl(AA,B,C,DA,E,F)
END

INTEGER(c_int) FUNCTION WR_UXPLBA_(A,B,C,D,E,F,G,H,I,J,K) BIND(C,NAME='uxplba__')
  USE iso_c_binding
  REAL(c_float) :: A(*)
  CHARACTER(1,c_char) :: B(*)
  INTEGER(c_int) :: C
  INTEGER(c_int) :: D
  REAL(c_float) :: E(*)
  REAL(c_float) :: F(*)
  REAL(c_float) :: G(*)
  INTEGER(c_int) :: H(*)
  INTEGER(c_int) :: I(*)
  INTEGER(c_int) :: J(*)
  INTEGER(c_int),VALUE :: K
! CVBCL 10
  CHARACTER(C) :: BA(D)

  CALL CHAR_TRIM2(B,BA,C,D,K)


  WR_UXPLBA_=uxplba(A,BA,C,D,E,F,G,H,I,J)
END

INTEGER(c_int) FUNCTION WR_UYPLBA_(A,B,C,D,E,F,G,H,I,J,K) BIND(C,NAME='uyplba__')
  USE iso_c_binding
  REAL(c_float) :: A(*)
  CHARACTER(1,c_char) :: B(*)
  INTEGER(c_int) :: C
  INTEGER(c_int) :: D
  REAL(c_float) :: E(*)
  REAL(c_float) :: F(*)
  REAL(c_float) :: G(*)
  INTEGER(c_int) :: H(*)
  INTEGER(c_int) :: I(*)
  INTEGER(c_int) :: J(*)
  INTEGER(c_int),VALUE :: K
! CVBCL 10
  CHARACTER(C) :: BA(D)

  CALL CHAR_TRIM2(B,BA,C,D,K)

  WR_UYPLBA_=uyplba(A,BA,C,D,E,F,G,H,I,J)
END

INTEGER(c_int) FUNCTION WR_UXPLBB_(A,B,C,D,E,F,G,H,I,J,K,L,M,N) BIND(C,NAME='uxplbb__')
  USE iso_c_binding
  REAL(c_float) :: A(*)
  CHARACTER(1,c_char) :: B(*)
  INTEGER(c_int) :: C
  INTEGER(c_int) :: D
  REAL(c_float) :: E(*)
  REAL(c_float) :: F(*)
  REAL(c_float) :: G(*)
  INTEGER(c_int) :: H(*)
  INTEGER(c_int) :: I(*)
  INTEGER(c_int) :: J(*)
  REAL(c_float) :: K(*)
  INTEGER(c_int) :: L(*)
  INTEGER(c_int) :: M(*)
  INTEGER(c_int),VALUE :: N
! CVBCL 13
  CHARACTER(C) :: BA(D)

  CALL CHAR_TRIM2(B,BA,C,D,N)

  WR_UXPLBB_=uxplbb(A,BA,C,D,E,F,G,H,I,J,K,L,M)
END

INTEGER(c_int) FUNCTION WR_UYPLBB_(A,B,C,D,E,F,G,H,I,J,K,L,M,N) BIND(C,NAME='uyplbb__')
  USE iso_c_binding
  REAL(c_float) :: A(*)
  CHARACTER(1,c_char) :: B(*)
  INTEGER(c_int) :: C
  INTEGER(c_int) :: D
  REAL(c_float) :: E(*)
  REAL(c_float) :: F(*)
  REAL(c_float) :: G(*)
  INTEGER(c_int) :: H(*)
  INTEGER(c_int) :: I(*)
  INTEGER(c_int) :: J(*)
  REAL(c_float) :: K(*)
  INTEGER(c_int) :: L(*)
  INTEGER(c_int) :: M(*)
  INTEGER(c_int),VALUE :: N
! CVBCL 13
  CHARACTER(C) :: BA(D)

  CALL CHAR_TRIM2(B,BA,C,D,N)

  WR_UYPLBB_=uyplbb(A,BA,C,D,E,F,G,H,I,J,K,L,M)
END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTXZR(RX,RY,CHARS,RSIZE,IROTA,ICENT,INDEX)

      CHARACTER CHARS*(*)


      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGTXZR','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGTXZR','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','SGTXZR','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGTXZR','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGTXZR','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL SZTXOP(RSIZE,IROTA,ICENT,INDEX)
      CALL SZTXZR(RX,RY,CHARS)
      CALL SZTXCL

      END

program calendar

  use dcl
  integer,parameter :: days=90
  type(dcl_date) :: date

    date%year = 1991
    date%month = 4
    date%day = 1

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( 0.0, real(days), -1.0, +1.0 )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransFunction

    call DclDrawAxisCalendar( 'bt', date, nd=days )

    call DclDrawAxis( 'l', 0.25, 0.05 )
!    call DclSetParm( 'AXIS:labelyr', .true. )
!    call uysfmt( '(f6.2)' )
!!    call DclSetYLabelFormat( '(f6.2)' )
    call DclDrawAxis( 'r', 0.25, 0.05 )
    call DclDrawTitle( 'l', 'Correlation', 0.0 )

    call DclDrawTitle( 't', 'Calendar', 0.0, 2 )

    call DclCloseGraphics

end program

!-------------------------------------------------
!  OSlib Module
!-------------------------------------------------
module oslib
  use dcl_common
  contains

    subroutine DclExecCommand(command)          !os コマンドを実行する．
      character(len=*), intent(in) :: command   !コマンド名

      call prcopn('DclExecCommand')
      call osexec(command)
      call prccls('DclExecCommand')
    end subroutine
      
    subroutine DclGetEnv(name,value)            !環境変数の値を取得する．
      character(len=*), intent(in)  :: name     !環境変数名
      character(len=*), intent(out) :: value    !環境変数の値

      call prcopn('DclGetEnv')
      call osgenv(name,value)  
      call prccls('DclGetEnv')
    end subroutine
      
    function DclGetArgumentNum()                !コマンドライン引数の数 N を得る．
      integer :: DclGetArgumentNum              !コマンドライン引数の数

      call prcopn('DclGetArgumentNum')
      call osqarn(DclGetArgumentNum)
      call prccls('DclGetArgumentNum')
    end function
      
    subroutine DclGetArgument(n,arg)            !N 番目のコマンドライン引数を得る． 
      integer,           intent(in) :: n        !コマンドライン引数の位置
      character(len=*), intent(out) :: arg      !n 番目のコマンドライン引数

      call prcopn('DclGetArgument')
      call osgarg(n,arg)
      call prccls('DclGetArgument')
    end subroutine
      
    subroutine DclAbort()                       !エラー処理をおこなって強制終了する．
      call prcopn('DclAbort')
      call osabrt() 
      call prccls('DclAbort')
    end subroutine

end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCSWND(UXMIN, UXMAX, UYMIN, UYMAX, UZMIN, UZMAX)


      CALL SGRSET('UXMIN3',UXMIN)
      CALL SGRSET('UXMAX3',UXMAX)
      CALL SGRSET('UYMIN3',UYMIN)
      CALL SGRSET('UYMAX3',UYMAX)
      CALL SGRSET('UZMIN3',UZMIN)
      CALL SGRSET('UZMAX3',UZMAX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCQWND(UXMIN, UXMAX, UYMIN, UYMAX, UZMIN, UZMAX)

      CALL SGRGET('UXMIN3',UXMIN)
      CALL SGRGET('UXMAX3',UXMAX)
      CALL SGRGET('UYMIN3',UYMIN)
      CALL SGRGET('UYMAX3',UYMAX)
      CALL SGRGET('UZMIN3',UZMIN)
      CALL SGRGET('UZMAX3',UZMAX)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPMZU(N,UPX,UPY,ITYPE,INDEX,RSIZE)

      REAL      UPX(*),UPY(*)


      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMZU','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPMZU','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPMZU','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPMZU','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGPMZU','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGPMZU','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZPMOP(ITYPE,INDEX,RSIZE)
      CALL SZPMZU(N,UPX,UPY)
      CALL SZPMCL

      END

*-----------------------------------------------------------------------
*     LCHREQ FOR ASCII CHARACTER CODE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      LOGICAL FUNCTION LCHREQ(CH1,CH2)

      CHARACTER CH1*(*),CH2*(*)


      LCHREQ=.TRUE.
      LCH1=LEN(CH1)
      LCH2=LEN(CH2)
      LCHMAX=MAX(LCH1,LCH2)
      LCHMIN=MIN(LCH1,LCH2)

      DO 10 I=1,LCHMIN
        IDX1=ICHAR(CH1(I:I))
        IDX2=ICHAR(CH2(I:I))
        IF (IDX1.NE.IDX2) THEN
          IF (65.LE.IDX1 .AND. IDX1.LE.90) THEN
            LCHREQ=(IDX2-IDX1).EQ.32
          ELSE IF (97.LE.IDX1 .AND. IDX1.LE.122) THEN
            LCHREQ=(IDX1-IDX2).EQ.32
          ELSE
            LCHREQ=.FALSE.
          END IF
          IF (.NOT.LCHREQ) RETURN
        END IF
   10 CONTINUE
      IF (LCH1.EQ.LCH2) RETURN

      IBLK=ICHAR(' ')
      IF (LCH1.GT.LCH2) THEN
        DO 20 I=LCHMIN+1,LCHMAX
          LCHREQ=ICHAR(CH1(I:I)).EQ.IBLK
          IF (.NOT.LCHREQ) RETURN
   20   CONTINUE
      ELSE
        DO 30 I=LCHMIN+1,LCHMAX
          LCHREQ=ICHAR(CH2(I:I)).EQ.IBLK
          IF (.NOT.LCHREQ) RETURN
   30   CONTINUE
      END IF

      END

program label

  use dcl
  integer,parameter :: nmax = 40
  real,dimension(0:nmax) :: x,y1,y2,y3,y4,y5,y6

    x  = (/( n,n=0,nmax )/) / real(nmax) ! 0≦x≦1
    y1 = sin( 2.*DCL_PI * x ) + 1.5      ! y = sin(2πx)+C
    y2 = sin( 2.*DCL_PI * x ) + 1.0
    y3 = sin( 2.*DCL_PI * x ) + 0.5
    y4 = sin( 2.*DCL_PI * x ) - 0.5
    y5 = sin( 2.*DCL_PI * x ) - 1.0
    y6 = sin( 2.*DCL_PI * x ) - 1.5

!-- グラフ ----

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetParm( 'ENABLE_LINE_LABELING', .true. ) ! ラベルつき折れ線

    call DclSetWindow( 0., 1., -3., 3. )        ! ウィンドウの設定
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )   ! ビューポートの設定
    call DclSetTransFunction                    ! 正規変換の確定

    call DclDrawScaledAxis                      ! 座標軸を描く

    call DclSetLineText( 'k=1' )                ! ラベルの文字列
    call DclDrawLine( x, y1 )

    call DclNextLineText  ! ラベルの最後の文字番号を増やす
    call DclDrawLine( x, y2 )

    call DclNextLineText
    call DclDrawLine( x, y3, type=2 )

    call DclSetLineTextSize( 0.01 )             ! ラベルの文字列の高さ
    call DclSetLineText( 'Small Label' )
    call DclDrawLine( x, y4, index=2 )
    call DclSetLineTextSize( 0.02 )             ! 高さ元に戻す

    call DclSetLineText( 'a' )
    call DclSetParm( 'LINE_CYCLE_LENGTH', 5. )    ! ラベルの間隔
    call DclDrawLine( x, y5, type=2 )

    call DclSetLineText( 'zzz' )
    call DclSetParm( 'LINE_START_POSITION', 0.9 )! ラベルの書き始め
    call DclDrawLine( x, y6, type=4 )

    call DclCloseGraphics


end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SCPKT3

      PARAMETER ( NX=73, NY=37 )
      PARAMETER ( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )

      REAL      P1(NX,NY), P2(NX,NY)

      EXTERNAL  ISGTRC


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      OPEN(11,FILE='t810630.dat',FORM='FORMATTED')
      OPEN(12,FILE='t811231.dat',FORM='FORMATTED')
      DO 10 J=1,NY
        READ(11,'(10F8.3)') (P1(I,J),I=1,NX)
        READ(12,'(10F8.3)') (P2(I,J),I=1,NX)
   10 CONTINUE
      CLOSE(11)
      CLOSE(12)

      DO 20 IR=190,245,5
        R=IR
        AMIN=R
        AMAX=R+5
*       IDX=(R-180)*1.4*1000+999
        IDX=INT((R-170)*1.25)*1000+999
        CALL UESTLV(AMIN,AMAX,IDX)
   20 CONTINUE 

      CALL SGOPN( IWS )

      CALL SGLSET( 'LSOFTF', .FALSE. )
      CALL UMLSET( 'LGRIDMJ', .FALSE. )
      CALL UMRSET( 'DGRIDMN', 30.0 )
      CALL UMISET( 'ITYPEMN', 1 )
      CALL UMISET( 'ITYPEOUT', 1 )
      CALL SGFRM

      CALL SGLSET( 'L2TO3', .TRUE. )
*     CALL SCSEYE(-1.0, -1.5,  2.0 )
      CALL SCSOBJ( 0.5,  0.5,  0.0 )
      CALL SCSPLN( 1, 2, -0.3)
      CALL SCSPRJ

      CALL SGSSIM( 0.12, 0.0, 0.0 )
      CALL SGSMPL( 180.0, 90.0, 0.0 )
      CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSTXY( -180.0, 180.0, -90.0, 90.0 )
      CALL SGSTRN( ISGTRC('MER') )
      CALL SGSTRF

      CALL SGLSET( 'LCLIP', .TRUE. )
      CALL SLPWWR( 1 )

      CALL UETONE( P1, NX, NX, NY )
      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB
      CALL SLPVPR( 1 )

      CALL SGLSET( 'LCLIP', .FALSE. )
      CALL SGTXZV( 0.5, 0.95, 'Temp. : 10 hPa : Jun 30, 1981',
     +             0.025, 0, 0, 3 )

      CALL SCSPLN( 1, 2, 0.4)
*     CALL SGRSET( 'YOFF3', -0.25 )
      CALL SCSPRJ

      CALL SGLSET( 'LCLIP', .TRUE. )
      CALL SLPWWR( 1 )

      CALL UETONE( P2, NX, NX, NY )
      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB
      CALL SLPVPR( 1 )

      CALL SGLSET( 'LCLIP', .FALSE. )
      CALL SGTXZV( 0.5, 0.95, 'Temp. : 10 hPa : Dec 31, 1981',
     +             0.025, 0, 0, 3 )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE CFSRCH(CPLIST,NP,CFLIST,NF,CFNAME)

      CHARACTER CPLIST(*)*1024,CFLIST(*)*1024,CFNAME*(*)

      CHARACTER CDSN*1024
      LOGICAL   LEXIST

      EXTERNAL  LENC


      DO 10 M=1,NP
        DO 20 N=1,NF
          CDSN=CPLIST(M)(1:LENC(CPLIST(M)))//CFLIST(N)
          CALL CLADJ(CDSN)
          INQUIRE(FILE=CDSN,EXIST=LEXIST)
          IF (LEXIST) THEN
            IF (LENC(CDSN).LE.LEN(CFNAME)) THEN
              CFNAME=CDSN
              RETURN
            ELSE
              CALL MSGDMP('E','CFSRCH',
     +          'LENGTH OF CHARACTER IS TOO SHORT TO STORE FILE NAME.')
            END IF
          END IF
   20   CONTINUE
   10 CONTINUE

      CFNAME=' '

      END

*-----------------------------------------------------------------------
      PROGRAM FFTL02


      CALL TFFTPK(IER)

      END
*-----------------------------------------------------------------------
      SUBROUTINE TFFTPK (IERROR)
C
C
C PURPOSE                TO DEMONSTRATE THE USE OF FFTPACK, AND TO
C                        TEST THE PERFORMANCE OF FFTPACK ON ONE
C                        WELL-CONDITIONED PROBLEM.
C
C USAGE                  CALL TFFTPK (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          INTEGER VARIABLE SET TO ZERO IF FFTPACK
C                          CORRECTLY SOLVED THE TEST PROBLEM, AND
C                          ONE IF FFTPACK FAILED.
C
C I/O                    IF THE TEST SUCCEEDS(FAILS), THE MESSAGE
C
C                           FFTPACK TEST SUCCESSFUL (UNSUCCESSFUL)
C
C                        IS WRITTEN ON UNIT 6. IN THE CASE OF FAILURE,
C                        ADDITIONAL MESSAGES ARE WRITTEN IDENTIFYING THE
C                        FAILURE MORE EXPLICITLY.
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       NONE
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                WRITTEN BY MEMBERS OF THE SCIENTIFIC
C                        COMPUTING DIVISION OF NCAR,
C                        BOULDER COLORADO.
C
C ALGORITHM              FOR EACH OF THE ROUTINES, RFFTF, RFFTB, EZFFTF,
C                        AND EZFFTB IN THE FFTPACK PACKAGE A SIMILAR
C                        TEST IS RUN. AN APPROPIATE VECTOR, FOR WHICH
C                        THE EXACT TRANSFORM IS KNOWN IS USED AS THE
C                        INPUT VECTOR. THE ROUTINE IS CALLED TO PERFORM
C                        THE TRANSFORM. THE CALCULATED TRANSFORM VECTOR
C                        IS COMPARED WITH THE EXACT TRANSFORM TO SEE
C                        WHETHER THE PERFORMANCE CRITERION IS MET WITHIN
C                        THE SPECIFED TOLERANCE.
C
C                        FOR RFFTF AND EZFFTF, A REAL VECTOR, THE ELEMEN
C                        WHICH ARE EQUAL TO ONE, IS USED AS INPUT. THE
C                        TRANSFORMED VECTOR HAS THE FIRST ELEMENT EQUAL
C                        TO THE LENGTH OF THE INPUT VECTOR. ALL OTHER
C                        ELEMENTS ARE EQUAL TO ZERO.
C
C                        FOR RFFTB AND EZFFTB, THE INPUT VECTOR HAS FIRS
C                        ELEMENT EQUAL TO ONE AND ALL THE OTHER ELEMENTS
C                        EQUAL TO ZERO. THE TRANSFORMED VECTOR HAS ALL
C                        COMPONENTS EQUAL TO ONE.
C
C PORTABILITY            ANSI STANDARD
C
C
      PARAMETER( N=36 )
      INTEGER DIM1, DIM2
      PARAMETER( DIM1=2*N+15, DIM2=3*N+15, ND2=N/2 )
      REAL RLDAT(N), WRFFT(DIM1), WEZFFT(DIM2), A(ND2), B(ND2)
      DATA TOL/0.01/
C
C STATEMENT FUNCTION SMALL(EX) IS FOR TESTING WHETHER X IS CLOSE TO ZERO
C INDEPENDENTLY OF MACHINE WORD SIZE. SMALL(EX) IS EXACTLY ZERO ONLY IF
C ABS(X) .LT. EPS/TOL, WHERE EPS IS THE MACHINE PRECESION AND TOL IS A
C TOLERANCE FACTOR USED TO CONTROL THE STRICTNESS OF THE TEST.
C
      SMALL(EX) = TRUNC(1.0+TOL*ABS(EX))-1.0
C
C CALL INITIALIZATION ROUTINE FOR RFFTF AND RFFTB.
C
      CALL RFFTI( N, WRFFT )
C
C TEST OF RFFTF.
C
      DO 10 I = 1,N
 10   RLDAT(I) = 1.0
C
      CALL RFFTF( N, RLDAT, WRFFT )
C
C TEST RESULTS OF RFFTF
C
      ERROR = ABS( FLOAT(N) - RLDAT(1) )
      DO 15 I = 2,N
 15   ERROR = AMAX1( ERROR, ABS(RLDAT(I)) )
      IF( SMALL(ERROR) .EQ. 0 ) THEN
          IER1 = 0
      ELSE
          IER1 = 1
          WRITE(*,1001)
      END IF
C
C TEST OF RFFTB.
C
      RLDAT(1) = 1.0
      DO 20 I = 2,N
 20   RLDAT(I) = 0.0
C
      CALL RFFTB( N, RLDAT, WRFFT )
C
C TEST RESULTS OF RFFTB
C
      ERROR = 0.0
      DO 25 I = 1,N
 25   ERROR = AMAX1( ERROR, ABS(1.0 - RLDAT(I)) )
      IF( SMALL(ERROR) .EQ. 0 ) THEN
          IER2 = 0
      ELSE
          IER2 = 1
          WRITE(*,1002)
      END IF
C
C CALL INITIALIZATION ROUTINE EZFFTI FOR EZFFTF AND EZFFTB
C
      CALL EZFFTI( N, WEZFFT )
C
C TEST OF EZFFTF.
C
      DO 30 I = 1,N
 30   RLDAT(I) = 1.0
C
      CALL EZFFTF( N, RLDAT, AZERO, A, B, WEZFFT )
C
C TEST RESULTS OF EZFFTF
C
      ERROR = ABS( AZERO - 1.0 )
      DO 35 I = 1,ND2
 35   ERROR = AMAX1( ABS(A(I))+ABS(B(I)), ERROR )
      IF( SMALL(ERROR) .EQ. 0 ) THEN
          IER3 = 0
      ELSE
          IER3 = 1
          WRITE(*,1003)
      END IF
C
C TEST OF EZFFTB.
C
      AZERO = 1.0
      DO 40 I = 1,ND2
      A(I) = 0.0
 40   B(I) = 0.0
C
      CALL EZFFTB( N, RLDAT, AZERO, A, B, WEZFFT )
C
C TEST RESULTS OF EZFFTB
C
      ERROR = 0.0
      DO 45 I = 1,N
 45   ERROR = AMAX1( ABS(1.0 - RLDAT(I)), ERROR)
      IF( SMALL(ERROR) .EQ. 0 ) THEN
          IER4 = 0
      ELSE
          IER4 = 1
          WRITE(*,1004)
      END IF
C
C
      IERROR = IER1 + IER2 + IER3 + IER4
      IF(IERROR .EQ. 0 ) THEN
         WRITE(*,998)
      ELSE
         IERROR = 1
         WRITE(*,999)
      END IF
  998 FORMAT(' FFTPACK TEST SUCCESSFUL')
  999 FORMAT(' FFTPACK TEST UNSUCCESSFUL')
 1001 FORMAT(' IN FFTPACK, ENTRY RFFTF RESULTS IN ERROR')
 1002 FORMAT(' IN FFTPACK, ENTRY RFFTB RESULTS IN ERROR')
 1003 FORMAT(' IN FFTPACK, ENTRY EZFFTF RESULTS IN ERROR')
 1004 FORMAT(' IN FFTPACK, ENTRY EZFFTB RESULTS IN ERROR')
      RETURN
      END
      FUNCTION TRUNC(X)
C
C TRUNC IS A PORTABLE FORTRAN FUNCTION WHICH TRUNCATES A VALUE TO THE
C MACHINE SINGLE PRECISION WORD SIZE, REGARDLESS OF WHETHER LONGER
C PRECISION INTERNAL REGISTERS ARE USED FOR FLOATING POINT ARITHMETIC IN
C COMPUTING THE VALUE INPUT TO TRUNC.  THE METHOD USED IS TO FORCE A
C STORE INTO MEMORY BY USING A COMMON BLOCK IN ANOTHER SUBROUTINE.
C
      COMMON /VALUE/ V
      CALL STORES(X)
      TRUNC=V
      RETURN
      END
      SUBROUTINE STORES(X)
C
C FORCES THE ARGUMENT VALUE X TO BE STORED IN MEMORY LOCATION V.
C
      COMMON /VALUE/ V
      V=X
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVBXFZ(N,UPX,UPY1,UPY2,ITYPE,INDEX)

      REAL      UPX(*),UPY1(*),UPY2(*)

      LOGICAL   LMISS, LXUNI, LYC1, LYC2
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UVBXFZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UVBXFZ','LINE TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UVBXFZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UVBXFZ','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      WRITE(COBJ,'(2I8)') ITYPE, INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVBXFZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)

      LXUNI = UPX(1).EQ.RUNDEF
      LYC1  = UPY1(1).EQ.RUNDEF
      LYC2  = UPY2(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/N
      END IF

      IF (LYC1 .OR. LYC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LXUNI) THEN
          UX1 = UXMIN + DX*(I-1)
          UX2 = UXMIN + DX*I
        ELSE
          UX1 = UPX(I)
          UX2 = UPX(I+1)
        END IF

        IF (LYC1) THEN
          UY1 = UREF
        ELSE
          UY1 = UPY1(I)
        END IF

        IF (LYC2) THEN
          UY2 = UREF
        ELSE
          UY2 = UPY2(I)
        END IF

        IF (.NOT.
     #    ((UX1.EQ.RMISS .OR. UX1.EQ.RMISS .OR.
     #      UY1.EQ.RMISS .OR. UY2.EQ.RMISS) .AND. LMISS)) THEN

          CALL SZOPLU
          CALL SZMVLU(UX1, UY2)
          CALL SZPLLU(UX2, UY2)
          CALL SZPLLU(UX2, UY1)
          CALL SZPLLU(UX1, UY1)
          CALL SZPLLU(UX1, UY2)
          CALL SZCLLU

        END IF
   20 CONTINUE

      CALL SWOCLS('UVBXFZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2D4

      PARAMETER( NX=21, NY=21 )
      PARAMETER( XMIN=-10, XMAX=10, YMIN=-10, YMAX=10 )
      PARAMETER( KMAX=5, PMIN=0, PMAX=1 )
      REAL U(NX,NY), V(NX,NY), P(NX,NY)

      DO 10 J=1,NY
      DO 10 I=1,NX
        X = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
        Y = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
        U(I,J) =  X
        V(I,J) = -Y
        P(I,J) = EXP( -X**2/64 -Y**2/25 )
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS
      CALL UGVECT( U, NX, V, NX, NX, NY )
      CALL UDCNTR( P, NX, NX, NY )

      DP = (PMAX-PMIN)/KMAX
      DO 20 K=1,KMAX
        TLEV1 = (K-1)*DP
        TLEV2 = TLEV1 + DP
        IPAT  = 600 + K - 1
        CALL UESTLV( TLEV1, TLEV2, IPAT )
   20 CONTINUE

      CALL UETONE( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     SLZTTL : PLOT TEXT BETWEEN WS-WINDOW AND MAX-DRAWING-REGION
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLZTTL(CSIDE,CTTL,PX,PY,RSIZE,INDEX)

      CHARACTER CTTL*(*),CSIDE*(*)

      LOGICAL   LWIDE,LCHREQ
      CHARACTER CS*1

      EXTERNAL  LCHREQ,LENC


      CS=CSIDE(1:1)

      CALL STQWTR(VXMN1,VXMX1,VYMN1,VYMX1,WXMN1,WXMX1,WYMN1,WYMX1,ITR)
      IF (ITR.EQ.1) THEN
        CALL STQWRC(WXMIN,WXMAX,WYMIN,WYMAX)
      ELSE
        CALL STQWRC(WXMIN,WXMAX,WYMAX,WYMIN)
      END IF

      CALL SZQCLL(CXMIN,CXMAX,CYMIN,CYMAX,0)

      CALL STIWTR(WXMIN,WYMIN,VXMN2,VYMN2)
      CALL STIWTR(WXMAX,WYMAX,VXMX2,VYMX2)

      CALL SGRGET('XPAD',XPAD)
      CALL SGRGET('YPAD',YPAD)
      CALL SGLGET('LWIDE',LWIDE)

      CALL SZSCLL(VXMN2,VXMX2,VYMN2,VYMX2,0)

      NCHAR=LENC(CTTL)
      NLINE=1
      TLWX=RSIZE*(XPAD+NCHAR)
      TLWY=RSIZE*(YPAD+NLINE)

      IF (LWIDE) THEN
        VXMIN=VXMN2
        VXMAX=VXMX2
      ELSE
        VXMIN=VXMN1
        VXMAX=VXMX1
      END IF
      IF (LCHREQ(CS,'T')) THEN
        VYMIN=VYMX1
        VYMAX=VYMX2
      ELSE IF (LCHREQ(CS,'B')) THEN
        VYMIN=VYMN2
        VYMAX=VYMN1
      ELSE
        CALL MSGDMP('E','SLZTTL','INVALID SIDE PARAMETER.')
      END IF

      XCENT=(VXMIN+VXMAX)/2
      YCENT=(VYMIN+VYMAX)/2
      DWX=((VXMAX-VXMIN)-TLWX)/2
      DWY=((VYMAX-VYMIN)-TLWY)/2

      IF (DWX.LT.0) THEN
        CALL MSGDMP('W','SLZTTL','SPACE FOR TITLE IS NOT ENOUGH.')
        CALL MSGDMP('M','-CNT.-','PX = 0.0 IS ASSUMED.')
        DWX=0
      END IF
      IF (DWY.LT.0) THEN
        CALL MSGDMP('W','SLZTTL','SPACE FOR TITLE IS NOT ENOUGH.')
        CALL MSGDMP('M','-CNT.-','PY = 0.0 IS ASSUMED.')
        DWY=0
      END IF

      XTL=XCENT+DWX*PX
      YTL=YCENT+DWY*PY
      CALL SGTXZR(XTL,YTL,CTTL,RSIZE,0,0,INDEX)

      CALL SZSCLL(CXMIN,CXMAX,CYMIN,CYMAX,0)

      END

*-----------------------------------------------------------------------
C     SUBROUTINE SINTI(N,WSAVE)
C
C     SUBROUTINE SINTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     SUBROUTINE SINT. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N+1 IS A PRODUCT OF SMALL PRIMES.
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WITH AT LEAST INT(2.5*N+15) LOCATIONS.
C             DIFFERENT WSAVE ARRAYS ARE REQUIRED FOR DIFFERENT VALUES
C             OF N. THE CONTENTS OF WSAVE MUST NOT BE CHANGED BETWEEN
C             CALLS OF SINT.
C
      SUBROUTINE SINTI (N,WSAVE)
      DIMENSION       WSAVE(*)
      EXTERNAL RFPI
C
      PI = RFPI()
      IF (N .LE. 1) RETURN
      NS2 = N/2
      NP1 = N+1
      DT = PI/FLOAT(NP1)
      DO 101 K=1,NS2
         WSAVE(K) = 2.*SIN(K*DT)
  101 CONTINUE
      CALL RFFTI (NP1,WSAVE(NS2+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     TOMS OZONE DISTRIBUTION (MONTHLY MEAN CLIMATOLOGY)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM XIMG01

      PARAMETER (KXBK=12,IXBK=KXBK*2+1,JXBK=37)
      PARAMETER (IXBG=73,JXBG=37)
      PARAMETER (IXGX=361,JXGX=181)
      PARAMETER (NCL=100, NCL1=NCL+1)

      INTEGER   IPATN(NCL)
      REAL      BKDATA(IXBK,JXBK),BGDATA(IXBG,JXBG),GXDATA(IXGX,JXGX),
     +          TLEVN(NCL1)
      CHARACTER CDSN*80

      EXTERNAL  ISGTRC


      DO 10 I=1, NCL
        IPATN(I) = MAX(11, I) *1000 + 999
   10 CONTINUE

      DO 20 I=1,NCL+1
        TLEVN(I) = I*3.0 + 200
   20 CONTINUE

      CDSN='tomsclm.dat'
      OPEN(11,FILE=CDSN,FORM='FORMATTED')

      CALL SWLSTX('LWAIT', .TRUE.)
      CALL SWLSTX('LWAIT0', .FALSE.)
      CALL SWLSTX('LALT', .FALSE.)
      CALL SWISTX('IPOSX', 200)
      CALL SWISTX('IPOSY', 200)
      CALL SWISTX('IWIDTH',  800)
      CALL SWISTX('IHEIGHT', 400)

      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GLLSET('LMISS', .TRUE.)
      CALL GLRGET('RMISS', RMISS)
      CALL SGLSET('LFULL', .TRUE.)
      CALL SGLSET('LSOFTF', .FALSE.)
      CALL UMLSET('LGLOBE', .TRUE.)
      CALL SLRAT(1.0, 0.5)

      DO 100 M=1, 12

        READ(11,'(TR9,I2)') MON
        DO 30 J=1,JXBK
          READ(11,'(F8.3,8F8.3,2(/TR8,8F8.3))')
     +         (BKDATA(I,J),I=1,IXBK)
   30   CONTINUE
        CALL BKTOBG(BKDATA,BGDATA)
        CALL RSET0(GXDATA,IXGX*JXGX,1,RMISS)
        DO 40 J=1,JXBG
          JJ=(J-1)*5+1
          CALL VRSET(BGDATA(1,J),GXDATA(1,JJ),IXBG,1,5)
          CALL VRINTR(GXDATA(1,JJ),IXGX,1)
   40   CONTINUE
        DO 50 I=1,IXGX
          CALL VRINTR(GXDATA(I,1),JXGX,IXGX)
   50   CONTINUE

        CALL GRFRM

        CALL GRSWND(0., 360., -90., 90.)
        CALL GRSMPL(180., 90., 0.)
        CALL GRSTRN(ISGTRC('HMR'))
        CALL UMPFIT
        CALL GRSTRF

        CALL UEITLV
        CALL UESTLN(TLEVN, IPATN, NCL)
        CALL UETONF(GXDATA, IXGX, IXGX, JXGX)
        CALL SLPWWR(1)

        CALL SLPWWR(1)
        CALL UMPGRD
        CALL UMPLIM
        CALL UMPMAP('coast_world')

  100 CONTINUE

      CALL GRCLS

      END
*-----------------------------------------------------------------------
*     BKTOBG
*-----------------------------------------------------------------------
      SUBROUTINE BKTOBG(BKDATA,BGDATA)

      PARAMETER (IXBG=73,JXBG=37)

      REAL      BKDATA(*),BGDATA(IXBG,JXBG)


      CALL GLRGET('RMISS',RMISS)
*     CALL DTPGET('MAXWN',KX)
      KX=12
      IXBK=KX*2+1
      JXBK=JXBG

      DO 10 J=1,JXBG
        IDXBK=IXBK*(J-1)+1
        IF (BKDATA(IDXBK).EQ.RMISS) THEN
          CALL RSET0(BGDATA(1,J),IXBG,1,RMISS)
        ELSE
          CALL FFTEZB(BKDATA(IDXBK),KX,BGDATA(1,J),IXBG-1)
          BGDATA(IXBG,J)=BGDATA(1,J)
        END IF
   10 CONTINUE

      END
*-----------------------------------------------------------------------
      SUBROUTINE FFTEZB(FC,MAXWN,X,NX)

      REAL      X(NX),FC(0:MAXWN*2)

      PARAMETER (NMAX=512,NWORK=NMAX*2+15)

      REAL      Y(NMAX+1),WSAVE(NWORK)
      CHARACTER CMSG*80

      SAVE

      DATA      NN/0/


      IF (NX.GT.NMAX) THEN
        CMSG='WORKING AREA IS NOT ENOUGH / NX SHOULD BE .LE. ####.'
        WRITE(CMSG(48:51),'(I4)') NMAX
        CALL MSGDMP('E','FFTEZB',CMSG)
      END IF
      IF (NX.LT.MAXWN*2) THEN
        CMSG='MAXWN CANNOT BE CALCULATED / NX SOULD BE .GE. MAXWN*2.'
        CALL MSGDMP('E','FFTEZB',CMSG)
      END IF

      IF (NX.NE.NN) THEN
        CALL RFFTI(NX,WSAVE)
        NN=NX
      END IF

      CALL RSET0(Y,NX+1,1,0.0)
      CALL VRSET(FC,Y,MAXWN*2+1,1,1)
      CALL RMLT0(Y(2),MAXWN,2,+0.5)
      CALL RMLT0(Y(3),MAXWN,2,-0.5)
      CALL RFFTB(NX,Y,WSAVE)
      CALL VRSET(Y,X,NX,1,1)

      END

*-----------------------------------------------------------------------
*     UMPGET / UMPSET / UMPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMPGET(CP,IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL UMPQID(CP, IDX)
      CALL UMPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPSET(CP, IPARA)

      CALL UMPQID(CP, IDX)
      CALL UMPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPSTX(CP, IPARA)

      IP = IPARA
      CALL UMPQID(CP, IDX)
      CALL UMPQIT(IDX, IT)
      CALL UMPQCP(IDX, CX)
      CALL UMPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UM', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL UMIQID(CP, IDX)
        CALL UMISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UM', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL UMLQID(CP, IDX)
        CALL UMLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UM', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL UMRQID(CP, IDX)
        CALL UMRSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
C     SUBROUTINE SINQF(N,X,WSAVE)
C
C     SUBROUTINE SINQF COMPUTES THE FAST FOURIER TRANSFORM OF QUARTER
C     WAVE DATA. THAT IS , SINQF COMPUTES THE COEFFICIENTS IN A SINE
C     SERIES REPRESENTATION WITH ONLY ODD WAVE NUMBERS. THE TRANSFORM
C     IS DEFINED BELOW AT OUTPUT PARAMETER X.
C
C     SINQB IS THE UNNORMALIZED INVERSE OF SINQF SINCE A CALL OF SINQF
C     FOLLOWED BY A CALL OF SINQB WILL MULTIPLY THE INPUT SEQUENCE X
C     BY 4*N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE SINQF MUST BE
C     INITIALIZED BY CALLING SUBROUTINE SINQI(N,WSAVE).
C
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE ARRAY X TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C
C     X       AN ARRAY WHICH CONTAINS THE SEQUENCE TO BE TRANSFORMED
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             IN THE PROGRAM THAT CALLS SINQF. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE SINQI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C
C     OUTPUT PARAMETERS
C
C     X       FOR I=1,...,N
C
C                  X(I) = (-1)**(I-1)*X(N)
C
C                     + THE SUM FROM K=1 TO K=N-1 OF
C
C                     2*X(K)*SIN((2*I-1)*K*PI/(2*N))
C
C                  A CALL OF SINQF FOLLOWED BY A CALL OF
C                  SINQB WILL MULTIPLY THE SEQUENCE X BY 4*N.
C                  THEREFORE SINQB IS THE UNNORMALIZED INVERSE
C                  OF SINQF.
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT
C             BE DESTROYED BETWEEN CALLS OF SINQF OR SINQB.
C
      SUBROUTINE SINQF (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      NS2 = N/2
      DO 101 K=1,NS2
         KC = N-K
         XHOLD = X(K)
         X(K) = X(KC+1)
         X(KC+1) = XHOLD
  101 CONTINUE
      CALL COSQF (N,X,WSAVE)
      DO 102 K=2,N,2
         X(K) = -X(K)
  102 CONTINUE
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      INTEGER FUNCTION IMAX1(IX,N,JX)

      INTEGER   IX(*)

      LOGICAL   MADA


      CALL GLIGET('IMISS',IMISS)
      MADA=.TRUE.
      DO 10 I=1,JX*(N-1)+1,JX
        IF (MADA) THEN
          IF (IX(I).NE.IMISS) THEN
            IMAX1=IX(I)
            MADA=.FALSE.
          END IF
        ELSE
          IF (IX(I).NE.IMISS .AND. IX(I).GT.IMAX1) THEN
            IMAX1=IX(I)
          END IF
        END IF
   10 CONTINUE
      IF (MADA) THEN
        IMAX1=IMISS
      END IF

      END

!-------------------------------------------------
!  UEpack Module
!-------------------------------------------------
module uepack
  use dcl_common

  interface DclSetShadeLevel
     module procedure DclSetShadeA, DclSetShadeB, DclSetShadeV, DclSetShadeN
  end interface

  private :: DclSetShadeA, DclSetShadeB, DclSetShadeV, DclSetShadeN

  contains
!------------------------------2次元等値線図のぬりわけをおこなう．
    subroutine DclShadeContour(z)
      real,      intent(in), dimension(:,:) :: z

      call sgoopn('DclShadeContour', ' ')
      nx = size(z,1)
      ny = size(z,2)
      call uetone(z,nx,nx,ny)   
      call sgocls('DclShadeContour')
    end subroutine
!------------------------------2次元等値線図のぬりわけをおこなう．
    subroutine DclShadeContourEx(z)
      real,      intent(in), dimension(:,:) :: z

      call sgoopn('DclShadeContourEX', ' ')
      nx = size(z,1)
      ny = size(z,2)
      call uetonf(z,nx,nx,ny)  
      call sgocls('DclShadeContourEX')
    end subroutine
!------------------------------トーンレベル値を最小値・最大値,きざみ値で設定する．
    subroutine   DclSetShadeA(xmin,xmax,dx)
      real,      intent(in) :: xmin,xmax    !トーンレベルの最小・最大値
      real,      intent(in) :: dx           !dx > 0 のときdxをきざみ幅

      call prcopn('DclSetShadeLevel')
      call uegtla(xmin,xmax,dx) 
      call prccls('DclSetShadeLevel')
    end subroutine
!------------------------------トーンレベル値を配列,きざみ値で設定する．
    subroutine DclSetShadeB(z,dx)
      real,      intent(in), dimension(:,:) :: z
      real,      intent(in) :: dx            !dx > 0 のときdxをきざみ幅

      call prcopn('DclSetShadeLevel')
      nx = size(z,1)
      ny = size(z,2)
      call uegtlb(z,nx,nx,ny,dx) 
      call prccls('DclSetShadeLevel')
     end subroutine
!------------------------------ ぬりわけるレベルとパターンを1レベルごと指定する．
    subroutine DclSetShadeV(level1,level2,pattern)
      real,      intent(in) :: level1,level2  !ぬりわけるレベルの下限上限値
      integer,   intent(in) :: pattern        !トーンパターン番号

      call prcopn('DclSetShadeLevel')
      call uestlv(level1,level2,pattern)
      call prccls('DclSetShadeLevel')
    end subroutine
!----------------------------- ぬりわけるレベルとパターンを配列で複数レベル指定する．
    subroutine DclSetShadeN(level,pattern)
      integer, intent(in), dimension(:) :: pattern 
      real,    intent(in), dimension(size(pattern)) :: level 

      call prcopn('DclSetShadeLevel')
      call uestln(level,pattern,size(pattern)) 
      call prccls('DclSetShadeLevel')
    end subroutine
!-------------------------------第iton番目のトーンレベルの属性
    subroutine DclGetShadeLevel(number, level1, level2, pattern) 
      integer,   intent(in) :: number
      real,      intent(out) :: level1, level2
      integer,   intent(out) :: pattern

      call prcopn('DclGetShadeLevel')
      call ueqtlv(level1,level2,pattern,number) 
      call prccls('DclGetShadeLevel')
    end subroutine
!------------------------------現在設定されているトーンレベルの数
    function DclGetShadeLevelNumber()
      integer :: DclGetShadeLevelNumber

      call prcopn('DclGetShadeLevelNumber')
      call ueqntl(DclGetShadeLevelNumber)  
      call prccls('DclGetShadeLevelNumber')
    end function
!-----------------------------トーンレベルを無効にする．
    subroutine DclClearShadeLevel()

      call prcopn('DclClearShadeLevel')
      call ueitlv() 
      call prccls('DclClearShadeLevel')
    end subroutine
      
end module

!-------------------------------------------------
!  UDpack Module
!-------------------------------------------------
module udpack
  use dcl_common
  interface DclSetContourLevel
     module procedure DclSetContourA, DclSetContourB
  end interface
  private :: DclSetContourA, DclSetContourB

  contains

    subroutine DclDrawContour(z)    !2次元等高線図を描く
      real,      intent(in), dimension(:,:) :: z
      integer, dimension((size(z,1)+2)*(size(z,2)+2)*6/32+4) :: ibr

      call sgoopn('DclDrawContour', ' ')
      nx = size(z,1)
      ny = size(z,2)
      nbr = (size(z,1)+2)*(size(z,2)+2)*6/32+4
      call udcntz(z,nx,nx,ny,ibr,nbr) 
      call sgocls('DclDrawContour')
    end subroutine

    subroutine DclSetContourA(xmin, xmax, dx)  !コンターレベル値を設定する．
      real,      intent(in) :: xmin,xmax       !コンターレベルの最小最大値
      real,      intent(in) :: dx                 !きざみ幅

      call prcopn('DclSetContourLevel')
      call udgcla(xmin,xmax,dx)     
      call prccls('DclSetContourLevel')
    end subroutine
      
    subroutine DclSetContourB(z,dx)  !コンターレベル値を配列で設定する．
      real,      intent(in), dimension(:,:) :: z  ! 2次元配列
      real,      intent(in) :: dx                 !きざみ幅

      call prcopn('DclSetContourLevel')
      nx = size(z,1)
      ny = size(z,2)

      call udgclb(z,nx,nx,ny,dx)  
      call prccls('DclSetContourLevel')
    end subroutine

!-----------------------------------------------------
!   コンターラインの属性を指定して1本のコンターレベルを設定する．
    subroutine DclSetContourLine(level,index ,type ,label ,height)
      real,             intent(in)           :: level
      integer,          intent(in), optional :: index,type 
      character(len=*), intent(in), optional :: label
      real,             intent(in), optional :: height
      logical                                :: ldash
      character(len=8)                       :: label0

      call prcopn('DclSetContourLine')
      if(present(type)) then
        itype0 = type
      else
        call udlget('ldash', ldash)
        if(ldash .and. level<0.) then
          call udiget('idash', itype0)
        else
          call udiget('isolid', itype0)
        end if
      end if
        
      if(present(index))  then ; index0 = index
                          else ; call udiget('indxmn', index0)
      end if

      if(present(label))  then ; label0 = label
                          else ; label0 = " "
      end if

      if(present(height)) then ; height0 = height
                          else ; height0 = 0.
      end if

      call udsclv(level,index0,itype0,label0,height0) 
      call prccls('DclSetContourLine')
    end subroutine

!-----------------------------------------------------
!   第nl番目のコンターレベルの属性
    subroutine DclGetContourLine(number,level,index,type,label,height) 

      integer,          intent(in)            :: number
      real,             intent(out), optional :: level
      integer,          intent(out), optional :: index,type 
      character(len=*), intent(out), optional :: label
      real,             intent(out), optional :: height
      character(len=8)                        :: label0

      call prcopn('DclGetContourLine')
      call udqclv(zlev0,index0,itype0,label0,height0,number) 

      if(present(level))  level = zlev0
      if(present(type ))  type  = itype0
      if(present(index))  index = index0
      if(present(label))  label = label0
      if(present(height)) height = height0

      call prccls('DclGetContourLine')
    end subroutine
      
    function DclGetContourLevelNumber()        !現在設定されているコンターレベルの総本数
      integer :: DclGetContourLevelNumber

      call prcopn('DclGetContourLevelNumber')
      call udqcln(DclGetContourLevelNumber)  
      call prccls('DclGetContourLevelNumber')
    end function
      
    subroutine DclDelContourLevel(level)        !あるコンターレベルを削除する．
      real,      intent(in) :: level            !削除するコンターレベルの値

      call prcopn('DclDelContourLevel')
      call uddclv(level)
      call prccls('DclDelContourLevel')
    end subroutine
      
    subroutine DclClearContourLevel()          !コンターレベルを無効にする．
      call prcopn('DclClearContourLevel')
      call udiclv() 
      call prccls('DclClearContourLevel')
    end subroutine
      
    function DclGetContourInterval(nlev)       !コンターレベルの間隔を求める．
      integer,   intent(in) :: nlev            !何番目のコンター間隔を調べるか指定する

      call prcopn('DclGetContourInterval')
      DclGetContourInterval = rudlev(nlev) 
      call prccls('DclGetContourInterval')
    end function
      
    subroutine DclSetContourLabelFormat(format)  !コンターラベルのフォーマットを指定する．
      character(len=*), intent(in) :: format     !指定するフォーマット（長さは16文字以下）

      call prcopn('DclSetContourLabelFormat')
      call udsfmt(format) 
      call prccls('DclSetContourLabelFormat')
    end subroutine
      
    subroutine DclGetContourLabelFormat(format)  !現在設定されているフォーマット
      character(len=*), intent(out) :: format

      call prcopn('DclGetContourLabelFormat')
      call udqfmt(format)  
      call prccls('DclGetContourLabelFormat')
    end subroutine

end module

!-------------------------------------------------
!  GNMlib Module
!-------------------------------------------------
module gnmlib
  use dcl_common
  contains
!-----------------------------------------------------------------
    subroutine DclGoodNumExLT(value,mantissa,exponent)  
      real,      intent(in)  :: value                   !調べる実数値
      real,      intent(out) :: mantissa                !きりのよい数の仮数部
      integer,   intent(out) :: exponent                !きりのよい数の指数部

      call prcopn('DclGoodNumExLT')
      call gnlt(value,mantissa,exponent)
      call prccls('DclGoodNumExLT')
    end subroutine
      
    subroutine DclGoodNumExGT(value,mantissa,exponent) 
      real,      intent(in)  :: value                   !調べる実数値
      real,      intent(out) :: mantissa                !きりのよい数の仮数部
      integer,   intent(out) :: exponent                !きりのよい数の指数部

      call prcopn('DclGoodNumExGT')
      call gngt(value,mantissa,exponent)
      call prccls('DclGoodNumExGT')
    end subroutine
      
    subroutine DclGoodNumExLE(value,mantissa,exponent) 
      real,      intent(in)  :: value                   !調べる実数値
      real,      intent(out) :: mantissa                !きりのよい数の仮数部
      integer,   intent(out) :: exponent                !きりのよい数の指数部

      call prcopn('DclGoodNumExLE')
      call gnle(value,mantissa,exponent)
      call prccls('DclGoodNumExLE')
    end subroutine
      
    subroutine DclGoodNumExGE(value,mantissa,exponent) 
      real,      intent(in)  :: value                   !調べる実数値
      real,      intent(out) :: mantissa                !きりのよい数の仮数部
      integer,   intent(out) :: exponent                !きりのよい数の指数部

      call prcopn('DclGoodNumExGE')
      call gnge(value,mantissa,exponent)
      call prccls('DclGoodNumExGE')
    end subroutine
      
    subroutine DclSetGoodNumList(list)
      real, intent(in), dimension(:) :: list !きりのよい数を昇順に納めた実数型配列．

      call prcopn('DclSetGoodNumList')
      call gnsblk(list, size(list))
      call prccls('DclSetGoodNumList')
    end subroutine
      
    subroutine DclGetGoodNumList(list)
      real, intent(out), dimension(:) :: list !きりのよい数を昇順に納めた実数型配列

      call prcopn('DclGetGoodNumList')
      call gnqblk(list, size(list))
      call prccls('DclGetGoodNumList')
    end subroutine
      
    subroutine DclSaveGoodNumList()
      call prcopn('DclSaveGoodNumList')
      call gnsave()
      call prccls('DclSaveGoodNumList')
    end subroutine
      
    subroutine DclRestoreGoodNumList() 
      call prcopn('DclRestoreGoodNumList')
      call gnrset()
      call prccls('DclRestoreGoodNumList')
    end subroutine
!-----------------------------------------------------------------      
    function DclGoodNumLT(value)
      real, intent(in) :: value 
      real             :: DclGoodNumLT

      call prcopn('DclGoodNumLT')
      DclGoodNumLT = rgnlt(value)
      call prccls('DclGoodNumLT')
    end function
      
    function DclGoodNumLE(value) 
      real, intent(in) :: value  
      real             :: DclGoodNumLE

      call prcopn('DclGoodNumLE')
      DclGoodNumLE = rgnle(value) 
      call prccls('DclGoodNumLE')
    end function
      
    function DclGoodNumGT(value) 
      real, intent(in) :: value
      real             :: DclGoodNumGT

      call prcopn('DclGoodNumGT')
      DclGoodNumGT = rgngt(value) 
      call prccls('DclGoodNumGT')
    end function
      
    function DclGoodNumGE(value)
      real, intent(in) :: value 
      real             :: DclGoodNumGE

      call prcopn('DclGoodNumGE')
      DclGoodNumGE = rgnge(value)
      call prccls('DclGoodNumGE')
    end function

end module

*-----------------------------------------------------------------------
*     POLYMARKER PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCPMU(N,UPX,UPY,UPZ)

      REAL      UPX(*),UPY(*),UPZ(*),VPX(*),VPY(*),VPZ(*)

      SAVE

      DATA      ITYPEZ/1/,INDEXZ/1/,RSIZEZ/0.01/


      IF (N.LT.1) THEN
        CALL MSGDMP('E','SCPMU','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SCPMU','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SCPMU','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SCPMU','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SCPMU','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SCPMU','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZM3OP(ITYPEZ,INDEXZ,RSIZEZ)
      CALL SZM3ZU(N,UPX,UPY,UPZ)
      CALL SZM3CL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCPMV(N,VPX,VPY,VPZ)

      IF (N.LT.1) THEN
        CALL MSGDMP('E','SCPMV','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SCPMV','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SCPMV','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SCPMV','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SCPMV','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SCPMV','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZM3OP(ITYPEZ,INDEXZ,RSIZEZ)
      CALL SZM3ZV(N,VPX,VPY,VPZ)
      CALL SZM3CL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCSPMT(ITYPE)

      ITYPEZ=ITYPE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCQPMT(ITYPE)

      ITYPE=ITYPEZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCSPMI(INDEX)

      INDEXZ=INDEX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCQPMI(INDEX)

      INDEX=INDEXZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCSPMS(RSIZE)

      RSIZEZ=RSIZE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCQPMS(RSIZE)

      RSIZE=RSIZEZ

      RETURN
      END

!-------------------------------------------------
!  CTRlib Module
!-------------------------------------------------
module ctrlib
  use dcl_common

  interface DclConv2D
    module procedure DclP2C, DclE2C, DclB2C, DclH2C
  end interface
  private :: DclP2C, DclE2C, DclB2C, DclH2C

  contains
!-------------------------------------------------
  function DclP2C(point)    !極座標->直角座標
    type(polar), intent(in) :: point 
    type(cartesian)         :: DclP2C

    call prcopn('DclConv2D')
    call ct2pc(point%r, point%theta, DclP2C%x, DclP2C%y)
    call prccls('DclConv2D')
  end function
!-------------------------------------------------
  function DclE2C(point)  !楕円座標->直角座標
    type(elliptic), intent(in) :: point
    type(cartesian)            :: DclE2C

    call prcopn('DclConv2D')
    call ct2ec(point%u, point%v, DclE2C%x, DclE2C%y)
    call prccls('DclConv2D')
  end function
!-------------------------------------------------
  function DclB2C(point)   !双極座標->直角座標
    type(bipolar), intent(in) :: point
    type(cartesian)           :: DclB2C

    call prcopn('DclConv2D')
    call ct2bc(point%u, point%v,DclB2C%x, DclB2C%y)
    call prccls('DclConv2D')
  end function
!-------------------------------------------------
  function DclH2C(point)    !直角双曲線座標->直角座標
    type(hyperbolic), intent(in) :: point
    type(cartesian)              :: DclH2C

    call prcopn('DclConv2D')
    call ct2hc(point%u, point%v, DclH2C%x, DclH2C%y)   
    call prccls('DclConv2D')
  end function
!-------------------------------------------------
  function DclConvPolar(point)  !直角座標->極座標
    type(cartesian), intent(in) :: point
    type(polar)                 :: DclConvPolar

    call prcopn('DclConvPolar')
    call ct2cp(point%x, point%y, DclConvPolar%r, DclConvPolar%theta)
    call prccls('DclConvPolar')
  end function
!-------------------------------------------------
  function DclConvHyperbolic(point)   !直角双曲線座標->直角座標
    type(cartesian), intent(in) :: point
    type(hyperbolic)            :: DclConvHyperbolic

    call prcopn('DclConvHyperbolic')
    call ct2ch(point%x, point%y, DclConvHyperbolic%u, DclConvHyperbolic%v) 
    call prccls('DclConvHyperbolic')
  end function
!-------------------------------------------------
  function DclConv3D(point)   !3次元球面座標->直角座標
    type(spherical),intent(in) :: point
    type(cartesian3D)          :: DclConv3D

    call prcopn('DclConv3D')
    call ct3sc(point%r, point%theta, point%phi, &
           &   DclConv3D%x, DclConv3D%y,     DclConv3D%z) 
    call prccls('DclConv3D')
  end function
!-------------------------------------------------
  function DclConvSpherical(point)    !3次元球面座標と直角座標の変換をする．
    type(cartesian3D), intent(in) :: point
    type(spherical)               :: DclConvSpherical

    call prcopn('DclConvSpherical')
    call ct3cs(point%x, point%y, point%z, & 
      &DclConvSpherical%r, DclConvSpherical%theta, DclConvSpherical%phi)
    call prccls('DclConvSpherical')
  end function
!-------------------------------------------------
  function DclRotate2D(theta,point)   !2次元直角座標を回転する．
    real, intent(in) :: theta
    type(cartesian), intent(in) :: point
    type(cartesian)             :: DclRotate2D

    call prcopn('DclRotate2D')
    call cr2c(theta, point%x, point%y, &
            & DclRotate2D%x, DclRotate2D%y) 
    call prccls('DclRotate2D')
  end function
!-------------------------------------------------
  function DclRotate3D(theta,phi,psi, point) !3次元直角座標を回転する．
    real,        intent(in) :: theta, phi, psi   !euler の回転角 (θ, φ, ψ)
    type(cartesian3D), intent(in) :: point
    type(cartesian3D)             :: DclRotate3D
    
    call prcopn('DclRotate3D')
    call cr3c(theta,phi,psi, point%x, point%y, point%z, &
          &   DclRotate3D%x, DclRotate3D%y, DclRotate3D%z)
    call prccls('DclRotate3D')
  end function
!-------------------------------------------------
  function DclRotateSpherical(theta,phi,psi,point) !球面座標を回転する．
    real,      intent(in) :: theta, phi, psi           !euler の回転角 (θ, φ, ψ)
    type(spherical), intent(in) :: point
    type(spherical)             :: DclRotateSpherical

    call prcopn('DclRotateSpherical')
    DclRotateSpherical%r = point%r
    call cr3s(theta,phi,psi, point%theta, point%phi, &
      & DclRotateSpherical%theta, DclRotateSpherical%phi)
    call prccls('DclRotateSpherical')
  end function

end module

program sample12

  use dcl
  integer,parameter :: n=100
  real(selected_real_kind(12)) :: a, r
  real, dimension(n)           :: x, y

!-- データ ----

    r = 0.2d0
    a = 3.6d0
    r0 = 0.
    do i=1, n
      r = a*r*(1.d0-r)
      r0 = r0 + r*4 - 2.58
      x2 = (i-50)**2
      rexp0 = 4.*i/n
      x(i) = 10**rexp0
      y(i) = 1.e5*exp(-x2) + 10.**r0
    end do
    y(20) = 1.e4
    y(40) = 2.e3
    y(65) = 3.e4
    y(70) = 5.e2

!-- グラフ ----

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetTransNumber( DCL_LOG_LOG )
    call DclDrawScaledGraph( x, y )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     UCXAMN : PLOT MONTH AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCXAMN(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      PARAMETER (N=50)

      REAL      UX(N)
      CHARACTER CH(N)*9,CMON*9
      LOGICAL   LABEL,LUXCHK,LBTWN


      IF (.NOT.LUXCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCXAMN','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCXAMN','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCXAMN','DATE LENGTH IS LESS THAN 0.')
      END IF

      NC=NUCCHR('X',ND)
      MC=ABS(NC)
      IF (MC.EQ.0) THEN
        CALL MSGDMP('W','UCXAMN','NO MONTH-AXIS.')
        RETURN
      END IF

      CALL UXPAXS(CSIDE,2)

      NN=1
      UX(NN)=0
      CALL DATE13(JD0,IY0,MO0,ID0)

      DO 10 I=1,ND
        CALL DATEF3(I,IY0,MO0,ID0,IYI,MOI,IDI)
        CALL DATE32(IYI,MOI,IDI,ITDI)
        IML=NDMON(IYI,MOI)
        IF (IDI.EQ.IML .OR. I.EQ.ND) THEN
          NN=NN+1
          IF (NN.GT.N) THEN
            CALL MSGDMP('E','UCXAMN','WORKING AREA IS NOT ENOUGH.')
          END IF
          UX(NN)=I
          CH(NN-1)=' '
          CH(NN-1)(1:MC)=CMON(MOI)
          IF (NC.LT.0 .AND. MC.GE.2) THEN
            CALL CLOWER(CH(NN-1)(2:MC))
          END IF
        END IF
   10 CONTINUE

      CALL UZIGET('ICENTX'//CSIDE,ICENT)
      CALL UZIGET('IROTLX'//CSIDE,IROTA)
      CALL UZIGET('IROTCX'//CSIDE,IROTC)
      CALL UZLGET('LBTWN',LBTWN)

      CALL UZISET('ICENTX'//CSIDE,0)
      CALL UZISET('IROTLX'//CSIDE,IROTC)
      CALL UZLSET('LBTWN',.TRUE.)

      CALL UXPTMK(CSIDE,2,UX,NN)
      CALL UZLGET('LABELX'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UXPLBL(CSIDE,2,UX,CH,9,NN)
      END IF

      CALL UZISET('ICENTX'//CSIDE,ICENT)
      CALL UZISET('IROTLX'//CSIDE,IROTA)
      CALL UZLSET('LBTWN',LBTWN)

      END

*-----------------------------------------------------------------------
*     USPGET / USPSET (OLD INTERFACE)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USPGET(CP,IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CMSG*80, CPP*12

*     ----------------------
      ENTRY USIGET(CP,IPARA)
      ENTRY USRGET(CP,IPARA)
      ENTRY USLGET(CP,IPARA)
*     ----------------------

      IF(CP.EQ.'RUNDEF' .OR. CP.EQ.'IUNDEF') THEN
        CALL GLPGET(CP, IPARA)
        CMSG = 'THIS IS OLD INTERFACE ('//CP//') - USE GLPGET.'
        CALL MSGDMP('W', 'USPGET', CMSG)
      ELSEIF (CP.EQ.'VXMIN' .OR. CP.EQ.'VYMIN' .OR.
     #        CP.EQ.'VXMAX' .OR. CP.EQ.'VYMAX' .OR. CP.EQ.'ITR')  THEN
        CALL SGPGET(CP, IPARA)
        CMSG = 'THIS IS OLD INTERFACE ('//CP//') - USE SGPGET.'
        CALL MSGDMP('W', 'USPGET', CMSG)
      ELSEIF (CP.EQ.'XMIN' .OR. CP.EQ.'YMIN' .OR.
     #        CP.EQ.'XMAX' .OR. CP.EQ.'YMAX')  THEN
        CPP = 'U'//CP
        CALL SGPGET(CPP, IPARA)
        CMSG = 'THIS IS OLD INTERFACE ('//CP//
     #               ') - USE SGPGET (U'//CP//').'
        CALL MSGDMP('W', 'USPGET', CMSG)
      ELSE
        CALL USPQID(CP,IDX)
        CALL USPQVL(IDX,IPARA)
      ENDIF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPSET(CP,IPARA)

*     ----------------------
      ENTRY USISET(CP,IPARA)
      ENTRY USRSET(CP,IPARA)
      ENTRY USLSET(CP,IPARA)
*     ----------------------

      IF(CP.EQ.'RUNDEF' .OR. CP.EQ.'IUNDEF') THEN
        CALL GLPSET(CP, IPARA)
        CMSG = 'THIS IS OLD INTERFACE ('//CP//') - USE GLPSET.'
        CALL MSGDMP('W', 'USPSET', CMSG)
      ELSEIF (CP.EQ.'VXMIN' .OR. CP.EQ.'VYMIN' .OR.
     #        CP.EQ.'VXMAX' .OR. CP.EQ.'VYMAX' .OR. CP.EQ.'ITR')  THEN
        CALL SGPSET(CP, IPARA)
        CMSG = 'THIS IS OLD INTERFACE ('//CP//') - USE SGPSET.'
        CALL MSGDMP('W', 'USPSET', CMSG)
      ELSEIF (CP.EQ.'XMIN' .OR. CP.EQ.'YMIN' .OR.
     #        CP.EQ.'XMAX' .OR. CP.EQ.'YMAX')  THEN
        CPP = 'U'//CP
        CALL SGPSET(CPP, IPARA)
        CMSG = 'THIS IS OLD INTERFACE ('//CP//
     #         ') - USE SGPSET (U'//CP//').'
        CALL MSGDMP('W', 'USPSET', CMSG)
      ELSE
        CALL USPQID(CP,IDX)
        CALL USPSVL(IDX,IPARA)
      ENDIF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPSTX(CP,IPARA)

*     ----------------------
      ENTRY USISTX(CP,IPARA)

      CX=CP
      IP=IPARA
      CALL RTIGET('US',CX,IP,1)
      GO TO 10
*
      ENTRY USRSTX(CP,IPARA)

      CX=CP
      IP=IPARA
      CALL RTRGET('US',CX,IP,1)
      GO TO 10
*
      ENTRY USLSTX(CP,IPARA)

      CX=CP
      IP=IPARA
      CALL RTLGET('US',CX,IP,1)
*     ----------------------

 10   CONTINUE
      CALL USPQID(CX,IDX)
      CALL USPSVL(IDX,IP)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UUPK06

      PARAMETER(N=100, M=5)
      REAL Y1(N), Y2(N), A(M)

*-----------------------------------------------------------------------

      DT = 1./(N-1)
      PI = 3.14159
      DO 50 J=1, M
        JJ = J*2-1
        A(J) = (-1)**J *2./(JJ*PI)
  50  CONTINUE

      DO 100 I=1, N
        T     = DT*(I-1)*2*PI
        Y1(I) = A(1)*COS(T)
        Y2(I) = 0.
        DO 150 J=1, M
          JJ = J*2-1
          YY = A(J)*COS(JJ*T)
          Y2(I)  = Y2(I) + YY
  150   CONTINUE


  100 CONTINUE

*-----------------------------------------------------------------------

      CALL GLRGET('RUNDEF', RUNDEF)
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL SGLSET('LCLIP', .TRUE.)

      CALL USSPNT(N, RUNDEF, Y1)
      CALL USSPNT(N, RUNDEF, Y2)
      CALL GRSWND(0., 1., RUNDEF, RUNDEF)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UUSARP(5999, 4999)
      CALL UVDIF(N, RUNDEF, Y1, Y2)
      CALL UULIN(N, RUNDEF, Y1)
      CALL UULIN(N, RUNDEF, Y2)

      CALL GRFRM
      CALL SGLSET('LCLIP', .TRUE.)

      CALL USSPNT(N, Y1, RUNDEF)
      CALL USSPNT(N, Y2, RUNDEF)
      CALL GRSWND(RUNDEF, RUNDEF, 0., 1.)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UHDIF(N, Y1, Y2, RUNDEF)
      CALL UULIN(N, Y1, RUNDEF)
      CALL UULIN(N, Y2, RUNDEF)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
      SUBROUTINE RADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)
      EXTERNAL RFPI
      TPI = 2.0*RFPI()
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP+2
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IF (IDO .EQ. 1) GO TO 119
      DO 101 IK=1,IDL1
         CH2(IK,1) = C2(IK,1)
  101 CONTINUE
      DO 103 J=2,IP
         DO 102 K=1,L1
            CH(1,K,J) = C1(1,K,J)
  102    CONTINUE
  103 CONTINUE
      IF (NBD .GT. L1) GO TO 107
      IS = -IDO
      DO 106 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 105 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 104 K=1,L1
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  104       CONTINUE
  105    CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J=2,IP
         IS = IS+IDO
         DO 109 K=1,L1
            IDIJ = IS
            DO 108 I=3,IDO,2
               IDIJ = IDIJ+2
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  108       CONTINUE
  109    CONTINUE
  110 CONTINUE
  111 IF (NBD .LT. L1) GO TO 115
      DO 114 J=2,IPPH
         JC = IPP2-J
         DO 113 K=1,L1
            DO 112 I=3,IDO,2
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  112       CONTINUE
  113    CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J=2,IPPH
         JC = IPP2-J
         DO 117 I=3,IDO,2
            DO 116 K=1,L1
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  116       CONTINUE
  117    CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  120 CONTINUE
  121 DO 123 J=2,IPPH
         JC = IPP2-J
         DO 122 K=1,L1
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)
  122    CONTINUE
  123 CONTINUE
C
      AR1 = 1.
      AI1 = 0.
      DO 127 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 124 IK=1,IDL1
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)
            CH2(IK,LC) = AI1*C2(IK,IP)
  124    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 126 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 125 IK=1,IDL1
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      DO 129 J=2,IPPH
         DO 128 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)
  128    CONTINUE
  129 CONTINUE
C
      IF (IDO .LT. L1) GO TO 132
      DO 131 K=1,L1
         DO 130 I=1,IDO
            CC(I,1,K) = CH(I,K,1)
  130    CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I=1,IDO
         DO 133 K=1,L1
            CC(I,1,K) = CH(I,K,1)
  133    CONTINUE
  134 CONTINUE
  135 DO 137 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 136 K=1,L1
            CC(IDO,J2-2,K) = CH(1,K,J)
            CC(1,J2-1,K) = CH(1,K,JC)
  136    CONTINUE
  137 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IF (NBD .LT. L1) GO TO 141
      DO 140 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 139 K=1,L1
            DO 138 I=3,IDO,2
               IC = IDP2-I
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  138       CONTINUE
  139    CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 143 I=3,IDO,2
            IC = IDP2-I
            DO 142 K=1,L1
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  142       CONTINUE
  143    CONTINUE
  144 CONTINUE
      RETURN
      END

      SUBROUTINE UIC3D(U, V, W,IRGB)

      LOGICAL LSET

      DATA IR1, IR2 / Z'00', Z'FF'/
      DATA IG1, IG2 / Z'00', Z'FF'/
      DATA IB1, IB2 / Z'00', Z'FF'/

      DATA LSET /.FALSE./

      SAVE

      JR = IR1 - U * (IR1 -IR2)
      JG = IG1 - V * (IG1 -IG2)
      JB = IB1 - W * (IB1 -IB2)

      CALL UIFPAC(JR, JG, JB, IRGB)


      RETURN

*-----------------------------------------------------------------------
      ENTRY UI3INI(UMIN, UMAX, VMIN, VMAX, WMIN, WMAX)

      IF(.NOT.LSET) THEN
        U1 = UMIN
        U2 = UMAX
        V1 = VMIN
        V2 = VMAX
        W1 = WMIN
        W2 = WMAX
      END IF

      DU = U2-U1
      DV = V2-V1
      DW = W2-W1

      RETURN

      END

*-----------------------------------------------------------------------
C     SUBROUTINE CFFTI(N,WSAVE)
C
C     SUBROUTINE CFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH CFFTF AND CFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4*N+15
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH CFFTF AND CFFTB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF CFFTF OR CFFTB.
C
      SUBROUTINE CFFTI (N,WSAVE)
      DIMENSION       WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      IW1 = N+N+1
      IW2 = IW1+N+N
      CALL CFFTI1 (N,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

*-----------------------------------------------------------------------
*     UEITLV / UESTLV
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEITLV

      LOGICAL   LSET, LREQ1
      EXTERNAL  LREQ1

      LOGICAL   LSETZ
      CHARACTER CMSG*80

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)

      SAVE

      DATA      LSETZ/.FALSE./

      NT=0
      LSETZ=.FALSE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY UESTLV(TLEV1,TLEV2,IPAT)

*     / INITIALIZATION /

      IF (.NOT.LSETZ) THEN
        CALL GLRGET('RMISS   ',RMISS )
        CALL GLRGET('REALMAX ',REALMX)
        CALL ISET0(IPT,NT,1,0)
        NT=0
        LSETZ  = .TRUE.
        LASCND = .TRUE.
      END IF

*     / CHECK TONE LEVEL /

      IF (TLEV1.EQ.RMISS .OR. TLEV2.EQ.RMISS) THEN
        IF (TLEV1.EQ.TLEV2) THEN
          CMSG='TLEV1 AND TLEV2 ARE MISSING VALUES.'
          CALL MSGDMP('E','UESTLV',CMSG)
        END IF
      ELSE
        IF (TLEV1.GE.TLEV2) THEN
          CMSG='TLEV1 IS GREATER THAN OR EQUAL TO TLEV2.'
          CALL MSGDMP('E','UESTLV',CMSG)
        END IF
      END IF

*     / CHECK IPAT /

      IF (IPAT.LT.0) THEN
        CMSG='TONE PATTERN NUMBER IS LESS THAN ZERO.'
        CALL MSGDMP('E','UESTLV',CMSG)
      END IF

*     / CHECK NUMBER OF TONE /

      IF (NT+1.GT.MAXNT) THEN
        CMSG='NUMBER OF TONE IS IN EXCESS OF MAXIMUM (###).'
        WRITE(CMSG(41:43),'(I3)') MAXNT
        CALL MSGDMP('E','UESTLV',CMSG)
      END IF

      NT=NT+1
      IF (TLEV1.EQ.RMISS) THEN
        TL1(NT)=-REALMX
      ELSE
        TL1(NT)=TLEV1
      END IF
      IF (TLEV2.EQ.RMISS) THEN
        TL2(NT)=+REALMX
      ELSE
        TL2(NT)=TLEV2
      END IF
      IPT(NT)=IPAT

      IF (NT.NE.1) THEN
        LASCND =  LASCND .AND. LREQ1(TL1(NT),TL2(NT-1))
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEQTLV(TLEV1,TLEV2,IPAT,ITON)

      IF (ITON.LT.1.OR.ITON.GT.NT)THEN
        CMSG='LEVEL (##) OF TONE PATTERN IS OUT OF RANGE (1-##).'
        WRITE(CMSG(8:9),'(I2)') ITON
        WRITE(CMSG(47:48),'(I2)') NT
        CALL MSGDMP('E','UEQTLV',CMSG)
      END IF

      IF (TL1(ITON).EQ.-REALMX) THEN
        TLEV1=RMISS
      ELSE
        TLEV1=TL1(ITON)
      END IF
      IF (TL2(ITON).EQ.+REALMX) THEN
        TLEV2=RMISS
      ELSE
        TLEV2=TL2(ITON)
      END IF
      IPAT=IPT(ITON)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEQNTL(NTON)

      NTON=NT

      RETURN
*-----------------------------------------------------------------------
      ENTRY UESTLZ(LSET)

      LSETZ=LSET

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEQTLZ(LSET)

      LSET=LSETZ

      RETURN
      END

program anim

  use dcl

  integer,parameter :: nmax=40, kmax=40
  real :: x(0:nmax), y(0:nmax)
  character(len=5) :: title

    dt = 2.*3.14159 / nmax

    call DclSetParm('alternate',.true.)
    call DclSetParm('wait',.false.)
    call DclOpenGraphics(1)

    do k = 1,kmax
      x = (/ (dt*n, n=0,nmax) /)
      y = sin( x + dt*k/kmax*nmax )

      call DclNewFrame
      call DclSetWindow(  0., 2.*3.14159,  -1.5,   1.5 )
      call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
      call DclSetTransFunction

      call DclDrawScaledAxis
      title(1:2) = 't='
      write(title(3:5),'(i3)') k
      call DclDrawTitle('t',title)

      call DclDrawLine( x, y )
    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM ULPK02

      PARAMETER (NBL=2)

      REAL      BL(NBL)
      CHARACTER CTL*64

      DATA      BL/1.0,3.0/


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(+ABS(IWS))

      CALL SGLSET('LFULL',.TRUE.)
      CALL UZFACT(0.7)
      CALL SLRAT(1.0,0.75)
      CALL SLDIV('Y',7,1)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.2,200.,0.15,200.)
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IYTYPE',1)
      CALL ULYLOG('L',1,9)
      CTL='ULYLOG (IYTYPE=1,NLBL=1,NTCK=9)'
      CALL UYSTTL('L',CTL,0.0)

      CALL SGLSET('LCNTL',.TRUE.)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.2,200.,0.15,200.)
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IYTYPE',1)
      CALL ULYLOG('L',3,9)
      CTL='ULYLOG (IYTYPE=1,NLBL=3,NTCK=9)'
      CALL UYSTTL('L',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.2,200.,0.15,200.)
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IYTYPE',2)
      CALL ULYLOG('L',3,9)
      CTL='ULYLOG (IYTYPE=2,NLBL=3,NTCK=9)'
      CALL UYSTTL('L',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.2,200.,0.15,200.)
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IYTYPE',3)
      CALL ULYLOG('L',3,9)
      CTL='ULYLOG (IYTYPE=3,NLBL=3,NTCK=9)'
      CALL UYSTTL('L',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.2,200.,0.15,200.)
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IYTYPE',4)
      CALL ULYLOG('L',3,9)
      CTL='ULYLOG (IYTYPE=4,NLBL=3,NTCK=9)'
      CALL UYSTTL('L',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.2,200.,0.15,200.)
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULYSFM('(F5.1)')
      CALL ULISET('IYTYPE',3)
      CALL ULYLOG('L',3,9)
      CTL='ULYLOG (IYTYPE=3,NLBL=3,NTCK=9)'
      CALL UYSTTL('L',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.2,200.,0.15,200.)
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IYTYPE',1)
      CALL ULISET('IYCHR',194)
      CALL ULSYBL(BL,NBL)
      CALL ULYLOG('L',4,5)
      CTL='ULYLOG (IYTYPE=1,NLBL=4,NTCK=5)'
      CALL UYSTTL('L',CTL,0.0)

      CALL SGCLS

      END

*--------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*--------------------------------------------------------------------
      PROGRAM G2PK01

      PARAMETER(NX=15,NY=15)

      REAL UX(NX), UY(NY)
      REAL UYW(NX), UXW(NY) 
      REAL CX(NX,NY), CY(NX,NY)
      REAL Z(NX,NY)


*     / SET PARAMETERS /

      DO 10 I=1,NX
        UX(I)=(I-1.0)/(NX-1.0)
   10 CONTINUE
      DO 15 J=1,NY
        UY(J)=(J-1.0)/(NY-1.0)
   15 CONTINUE

      DO 25 J=1,NY
        DO 20 I=1,NX
          CX(I,J) = UX(I) + 0.1*UY(J)
          CY(I,J) = 0.2*UX(I) + UY(J)
   20   CONTINUE
   25 CONTINUE

      CXMIN = 0.0
      CXMAX = 1.1
      CYMIN = 0.0
      CYMAX = 1.1

*     / GRAPHIC /

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSVPT(0.15,0.85,0.15,0.85)
      CALL GRSWND(UX(1),UX(NX),UY(1),UY(NY))
      CALL G2SCTR(NX,NY,UX,UY,CX,CY)
      CALL GRSTRN(51)
      CALL SGSCWD(CXMIN,CXMAX,CYMIN,CYMAX)
      CALL GRSTRF

      CALL SGLSET('LCLIP',.TRUE.)

*     / TONE /

      DO 35 J=1,NY
        DO 30 I=1,NX
          Z(I,J) = UX(I) + UY(J)
   30   CONTINUE
   35 CONTINUE

      CALL UELSET('LTONE',.TRUE.)
      CALL UWSGXA(UX,NX)
      CALL UWSGYA(UY,NY)
      CALL UETONE(Z, NX, NX, NY)

*     / GRID LINES /

      DO 45 J=1,NY
        DO 40 I=1,NX
          UYW(I) = UY(J)
   40   CONTINUE
        CALL SGPLU(NX,UX,UYW)
   45 CONTINUE

      DO 55 I=1,NX
        DO 50 J=1,NY
          UXW(J) = UX(I)
   50   CONTINUE
        CALL SGPLU(NY,UXW,UY)
   55 CONTINUE

*     / AXES (Switch to ITR==1) /

      CALL GRSWND(CXMIN,CXMAX,CYMIN,CYMAX)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL USDAXS
      CALL UXSTTL('T','BOTH X & Y TRANSFORMED',0.0)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UXPLBA : PLOT LABELS ( AT THE POINTS )
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPLBA(UX,CH,NC,N,UPY,ROFFX,RSIZE,IROTA,ICENT,INDEX)

      REAL      UX(*)
      CHARACTER CH(*)*(*)

      LOGICAL   LCLIPZ


      IF (NC.LE.0) THEN
        CALL MSGDMP('E','UXPLBA',
     +       'CHARACTER LENGTH IS LESS THAN OR EQUAL TO ZERO.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UXPLBA','NUMBER OF POINTS IS INVALID.')
      END IF
      IF (RSIZE.LE.0) THEN
        CALL MSGDMP('E','UXPLBA','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','UXPLBA','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.LE.0) THEN
        CALL MSGDMP('E','UXPLBA','TEXT INDEX IS INVALID.')
      END IF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)

      CALL SZTXOP(RSIZE,IROTA*90,ICENT,INDEX)
      DO 10 I=1,N
        LC = LENC(CH(I))
        CALL STFTRF(UX(I),UPY,VPX,VPY)
        VPY=VPY+ROFFX
        CALL SZTXZV(VPX,VPY,CH(I)(1:LC))
   10 CONTINUE
      CALL SZTXCL

      CALL SGLSET('LCLIP',LCLIPZ)

      END

*-----------------------------------------------------------------------
*     FONT LOADING
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZFONT(IFONT,IPOSX,NCHAR,CKX,CKY,LEN)

      INTEGER   IPOSX(NCHAR)
      CHARACTER CKX(LEN)*1,CKY(LEN)*1

      PARAMETER (MAXFS=2)

      CHARACTER CPARA*8,CDSN*1024

      EXTERNAL  IUFOPN

      SAVE


*     / CHECK FONT NUMBER /

      IF (.NOT.(1.LE.IFONT .AND. IFONT.LE.MAXFS)) THEN
        CALL MSGDMP('E','SZFONT','FONT NUMBER IS OUT OF RANGE.')
      END IF

*     / INQUIRE FONT FILE NAMES /

      CPARA='FONT#'
      CALL CHNGI(CPARA,'#',IFONT,'(I1)')
      CALL SWQFNM(CPARA,CDSN)
      IF (CDSN.EQ.' ') THEN
        CALL MSGDMP('E','SZFONT','FONT FILE DOES NOT EXIST.')
      END IF

*     / OPEN FONT FILE : MAYBE SYSTEM DEPENDENT /

      IU=IUFOPN()
      OPEN(IU,FILE=CDSN,FORM='UNFORMATTED')
      REWIND(IU)

*     / LOAD TEXT FONT /

      READ(IU) IPOSX
      READ(IU) CKX
      READ(IU) CKY

*     / CLOSE FONT FILE /

      CLOSE(IU)

      END

!-------------------------------------------------
!  SYSlib Module
!-------------------------------------------------
module syslib
  use dcl_common
  contains
!------------------------------------------------------------
    subroutine DclMessageDump(level,name,message)  !メッセージを出力する．
      character(len=1), intent(in) :: level
      character(len=6), intent(in) :: name 
      character(len=*), intent(in) :: message
      
      call prcopn('DclMessageDump')
      call msgdmp(level,name,message)
      call prccls('DclMessageDump')
    end subroutine
!------------------------------------------------------------
 
    function DclCompChar(ch1,ch2)
      logical DclCompChar, lchreq
      character(len=*), intent(in) :: ch1, ch2

      call prcopn('DclCompChar')
      DclCompChar = lchreq(ch1,ch2) 
      call prccls('DclCompChar')
    end function
      
    function DclGetUnitNum()  !利用可能なもっとも小さい入出力装置番号を返す．
      integer DclGetUnitNum

      call prcopn('DclGetUnitNum')
      DclGetUnitNum = iufopn()
      call prccls('DclGetUnitNum')
    end function
end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHBXFZ(N,UPX1,UPX2,UPY,ITYPE,INDEX)

      REAL      UPX1(*),UPX2(*),UPY(*)

      LOGICAL   LMISS, LYUNI, LXC1, LXC2
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UHBXFZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UHBXFZ','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UHBXFZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UHBXFZ','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      WRITE(COBJ,'(2I8)') ITYPE, INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHBXFZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)

      LYUNI = UPY(1).EQ.RUNDEF
      LXC1  = UPX1(1).EQ.RUNDEF
      LXC2  = UPX2(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/N
      END IF

      IF (LXC1 .OR. LXC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LYUNI) THEN
          UY1 = UYMIN + DY*(I-1)
          UY2 = UYMIN + DY*I
        ELSE
          UY1 = UPY(I)
          UY2 = UPY(I+1)
        END IF

        IF (LXC1) THEN
          UX1 = UREF
        ELSE
          UX1 = UPX1(I)
        END IF

        IF (LXC2) THEN
          UX2 = UREF
        ELSE
          UX2 = UPX2(I)
        END IF

        IF (.NOT.
     #    ((UX1.EQ.RMISS .OR. UX1.EQ.RMISS .OR.
     #      UY1.EQ.RMISS .OR. UY2.EQ.RMISS) .AND. LMISS)) THEN

          CALL SZOPLU
          CALL SZMVLU(UX1, UY2)
          CALL SZPLLU(UX2, UY2)
          CALL SZPLLU(UX2, UY1)
          CALL SZPLLU(UX1, UY1)
          CALL SZPLLU(UX1, UY2)
          CALL SZCLLU

        END IF
   20 CONTINUE

      CALL SWOCLS('UHBXFZ')

      END

      PROGRAM U2D3

      PARAMETER( NX=21, NY=21 )
      PARAMETER( XMIN=-1, XMAX=1, YMIN=-1, YMAX=1 )
      PARAMETER( DX=(XMAX-XMIN)/(NX-1), DY=(YMAX-YMIN)/(NY-1) )
      REAL U(NX,NY), V(NX,NY)

*-- データ ----
      DO 10 J=1,NY
      DO 10 I=1,NX
        X = XMIN + (I-1)*DX
        Y = YMIN + (J-1)*DY
        U(I,J) =   X
        V(I,J) = - Y
   10 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'X', 'km', 'Y', 'km' )
      CALL USDAXS

      CALL UGVECT( U, NX, V, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     USPQNP / USPQID / USPQCP / USPQVL / USPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 49)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

* ---- SHORT NAME ----

*     / CONTROL PARAMETERS /

      DATA      CPARAS( 1) / 'IRESET  ' /, ITYPE( 1) / 1 /

*     / PARAMETERS FOR USDAXS /

      DATA      CPARAS( 2) / 'LXINV   ' /, ITYPE( 2) / 2 /
      DATA      CPARAS( 3) / 'LYINV   ' /, ITYPE( 3) / 2 /
      DATA      CPARAS( 4) / 'LMATCH  ' /, ITYPE( 4) / 2 /
      DATA      CPARAS( 5) / 'RMRGN   ' /, ITYPE( 5) / 3 /

*     / PARAMETERS FOR USUSCU /

      DATA      CPARAS( 6) / 'XOFF    ' /, ITYPE( 6) / 3 /
      DATA      CPARAS( 7) / 'YOFF    ' /, ITYPE( 7) / 3 /
      DATA      CPARAS( 8) / 'XFAC    ' /, ITYPE( 8) / 3 /
      DATA      CPARAS( 9) / 'YFAC    ' /, ITYPE( 9) / 3 /
      DATA      CPARAS(10) / 'DXT     ' /, ITYPE(10) / 3 /
      DATA      CPARAS(11) / 'DYT     ' /, ITYPE(11) / 3 /
      DATA      CPARAS(12) / 'DXL     ' /, ITYPE(12) / 3 /
      DATA      CPARAS(13) / 'DYL     ' /, ITYPE(13) / 3 /
      DATA      CPARAS(14) / 'TFACT   ' /, ITYPE(14) / 3 /
      DATA      CPARAS(15) / 'MXDGTX  ' /, ITYPE(15) / 1 /
      DATA      CPARAS(16) / 'MXDGTY  ' /, ITYPE(16) / 1 /
      DATA      CPARAS(17) / 'NBLANK1 ' /, ITYPE(17) / 1 /
      DATA      CPARAS(18) / 'NBLANK2 ' /, ITYPE(18) / 1 /

*     / PARAMETERS FOR USUSCL /

      DATA      CPARAS(19) / 'NLBLX   ' /, ITYPE(19) / 1 /
      DATA      CPARAS(20) / 'NLBLY   ' /, ITYPE(20) / 1 /
      DATA      CPARAS(21) / 'NTICKSX ' /, ITYPE(21) / 1 /
      DATA      CPARAS(22) / 'NTICKSY ' /, ITYPE(22) / 1 /
      DATA      CPARAS(23) / 'ITYPEX  ' /, ITYPE(23) / 1 /
      DATA      CPARAS(24) / 'ITYPEY  ' /, ITYPE(24) / 1 /

*     / PARAMETERS FOR USXSUB & USYSUB /

      DATA      CPARAS(25) / 'MXDGTSX ' /, ITYPE(25) / 1 /
      DATA      CPARAS(26) / 'MXDGTSY ' /, ITYPE(26) / 1 /
      DATA      CPARAS(27) / 'LPRTCT  ' /, ITYPE(27) / 2 /
      DATA      CPARAS(28) / 'LXSUB   ' /, ITYPE(28) / 2 /
      DATA      CPARAS(29) / 'LYSUB   ' /, ITYPE(29) / 2 /

*     / FOLLOWING 20 PARAMETERS ARE RESET BY USINIZ /

      DATA      CPARAS(30) / 'SOFFXTR ' /, ITYPE(30) / 3 /
      DATA      CPARAS(31) / 'SOFFXBR ' /, ITYPE(31) / 3 /
      DATA      CPARAS(32) / 'SOFFXUR ' /, ITYPE(32) / 3 /
      DATA      CPARAS(33) / 'SOFFXTL ' /, ITYPE(33) / 3 /
      DATA      CPARAS(34) / 'SOFFXBL ' /, ITYPE(34) / 3 /
      DATA      CPARAS(35) / 'SOFFXUL ' /, ITYPE(35) / 3 /
      DATA      CPARAS(36) / 'SOFFYRT ' /, ITYPE(36) / 3 /
      DATA      CPARAS(37) / 'SOFFYLT ' /, ITYPE(37) / 3 /
      DATA      CPARAS(38) / 'SOFFYUT ' /, ITYPE(38) / 3 /
      DATA      CPARAS(39) / 'SOFFYRB ' /, ITYPE(39) / 3 /
      DATA      CPARAS(40) / 'SOFFYLB ' /, ITYPE(40) / 3 /
      DATA      CPARAS(41) / 'SOFFYUB ' /, ITYPE(41) / 3 /
      DATA      CPARAS(42) / 'ROFFXT  ' /, ITYPE(42) / 3 /
      DATA      CPARAS(43) / 'ROFFXB  ' /, ITYPE(43) / 3 /
      DATA      CPARAS(44) / 'ROFFYR  ' /, ITYPE(44) / 3 /
      DATA      CPARAS(45) / 'ROFFYL  ' /, ITYPE(45) / 3 /

      DATA      CPARAS(46) / 'XDTMIN  ' /, ITYPE(46) / 3 /
      DATA      CPARAS(47) / 'XDTMAX  ' /, ITYPE(47) / 3 /
      DATA      CPARAS(48) / 'YDTMIN  ' /, ITYPE(48) / 3 /
      DATA      CPARAS(49) / 'YDTMAX  ' /, ITYPE(49) / 3 /

* ---- LONG NAME ----

*     / CONTROL PARAMETERS /

      DATA      CPARAL( 1) / '****IRESET  ' /

*     / PARAMETERS FOR USDAXS /

      DATA      CPARAL( 2) / 'INV_X_AXIS' /
      DATA      CPARAL( 3) / 'INV_Y_AXIS' /
      DATA      CPARAL( 4) / 'ENABLE_XY_MATCHING' /
      DATA      CPARAL( 5) / 'MARGIN_WIDTH' /

*     / PARAMETERS FOR USUSCU /

      DATA      CPARAL( 6) / 'X_LABEL_OFFSET' /
      DATA      CPARAL( 7) / 'Y_LABEL_OFFSET' /
      DATA      CPARAL( 8) / 'X_LABEL_FACTOR' /
      DATA      CPARAL( 9) / 'Y_LABEL_FACTOR' /
      DATA      CPARAL(10) / 'X_TICK_INTERVAL' /
      DATA      CPARAL(11) / 'Y_TICK_INTERVAL' /
      DATA      CPARAL(12) / 'X_LABEL_INTERVAL' /
      DATA      CPARAL(13) / 'Y_LABEL_INTERVAL' /
      DATA      CPARAL(14) / 'MAX_TICK_INTERVAL' /
      DATA      CPARAL(15) / 'X_LABEL_MAX_CHAR' /
      DATA      CPARAL(16) / 'X_LABEL_MAX_CHAR' /
      DATA      CPARAL(17) / 'LABEL_GAP_PARALLEL' /
      DATA      CPARAL(18) / 'LABEL_GAP_RIGHT_ANGLE' /

*     / PARAMETERS FOR USUSCL /

      DATA      CPARAL(19) / 'LOG_X_LABEL_NUMBER' /
      DATA      CPARAL(20) / 'LOG_Y_LABEL_NUMBER' /
      DATA      CPARAL(21) / 'LOG_X_TICKS_NUMBER' /
      DATA      CPARAL(22) / 'LOG_X_TICKS_NUMBER' /
      DATA      CPARAL(23) / 'LOG_X_LABEL_FORMAT' /
      DATA      CPARAL(24) / 'LOG_X_LABEL_FORMAT' /

*     / PARAMETERS FOR USXSUB & USYSUB /

      DATA      CPARAL(25) / 'X_SUBLABEL_MAX_CHAR' /
      DATA      CPARAL(26) / 'Y_SUBLABEL_MAX_CHAR' /
      DATA      CPARAL(27) / 'PROTECT_REGION' /
      DATA      CPARAL(28) / 'DRAW_X_SUBLABEL' /
      DATA      CPARAL(29) / 'DRAW_Y_SUBLABEL' /

*     / FOLLOWING 20 PARAMETERS ARE RESET BY USINIZ /

      DATA      CPARAL(30) / '****SOFFXTR ' /
      DATA      CPARAL(31) / '****SOFFXBR ' /
      DATA      CPARAL(32) / '****SOFFXUR ' /
      DATA      CPARAL(33) / '****SOFFXTL ' /
      DATA      CPARAL(34) / '****SOFFXBL ' /
      DATA      CPARAL(35) / '****SOFFXUL ' /
      DATA      CPARAL(36) / '****SOFFYRT ' /
      DATA      CPARAL(37) / '****SOFFYLT ' /
      DATA      CPARAL(38) / '****SOFFYUT ' /
      DATA      CPARAL(39) / '****SOFFYRB ' /
      DATA      CPARAL(40) / '****SOFFYLB ' /
      DATA      CPARAL(41) / '****SOFFYUB ' /
      DATA      CPARAL(42) / '****ROFFXT  ' /
      DATA      CPARAL(43) / '****ROFFXB  ' /
      DATA      CPARAL(44) / '****ROFFYR  ' /
      DATA      CPARAL(45) / '****ROFFYL  ' /

      DATA      CPARAL(46) / '****XDTMIN  ' /
      DATA      CPARAL(47) / '****XDTMAX  ' /
      DATA      CPARAL(48) / '****YDTMIN  ' /
      DATA      CPARAL(49) / '****YDTMAX  ' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','USPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','USPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','USPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','USPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL USIQID(CPARAS(IDX), ID)
          CALL USIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL USLQID(CPARAS(IDX), ID)
          CALL USLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL USRQID(CPARAS(IDX), ID)
          CALL USRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','USPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL USIQID(CPARAS(IDX), ID)
          CALL USISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL USLQID(CPARAS(IDX), ID)
          CALL USLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL USRQID(CPARAS(IDX), ID)
          CALL USRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','USPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE GRSTRF


      CALL GLRGET('RUNDEF',RUNDEF)

      CALL SGIGET('ITR',ITR)

      CALL SGRGET('VXMIN',VXMIN)
      IF (VXMIN.EQ.RUNDEF) THEN
        CALL MSGDMP('E','GRSTRF','VXMIN IS NOT DEFINED.')
      END IF
      CALL SGRGET('VXMAX',VXMAX)
      IF (VXMAX.EQ.RUNDEF) THEN
        CALL MSGDMP('E','GRSTRF','VXMAX IS NOT DEFINED.')
      END IF
      CALL SGRGET('VYMIN',VYMIN)
      IF (VYMIN.EQ.RUNDEF) THEN
        CALL MSGDMP('E','GRSTRF','VYMIN IS NOT DEFINED.')
      END IF
      CALL SGRGET('VYMAX',VYMAX)
      IF (VYMAX.EQ.RUNDEF) THEN
        CALL MSGDMP('E','GRSTRF','VYMAX IS NOT DEFINED.')
      END IF

      IF (1.LE.ITR .AND. ITR.LE.4) THEN
        CALL SGRGET('UXMIN',UXMIN)
        IF (UXMIN.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','UXMIN IS NOT DEFINED.')
        END IF
        CALL SGRGET('UXMAX',UXMAX)
        IF (UXMAX.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','UXMAX IS NOT DEFINED.')
        END IF
        CALL SGRGET('UYMIN',UYMIN)
        IF (UYMIN.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','UYMIN IS NOT DEFINED.')
        END IF
        CALL SGRGET('UYMAX',UYMAX)
        IF (UYMAX.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','UYMAX IS NOT DEFINED.')
        END IF
      ELSE IF (5.LE.ITR .AND. ITR.LE.7) THEN
        CALL SGRGET('SIMFAC',SIMFAC)
        IF (SIMFAC.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','SIMFAC IS NOT DEFINED.')
        END IF
        CALL SGRGET('VXOFF',VXOFF)
        IF (VXOFF.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','VXOFF IS NOT DEFINED.')
        END IF
        CALL SGRGET('VYOFF',VYOFF)
        IF (VYOFF.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','VYOFF IS NOT DEFINED.')
        END IF
      ELSE IF (10.LE.ITR .AND. ITR.LE.24 .OR.
     +         30.LE.ITR .AND. ITR.LE.34 ) THEN
        CALL SGRGET('SIMFAC',SIMFAC)
        IF (SIMFAC.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','SIMFAC IS NOT DEFINED.')
        END IF
        CALL SGRGET('VXOFF',VXOFF)
        IF (VXOFF.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','VXOFF IS NOT DEFINED.')
        END IF
        CALL SGRGET('VYOFF',VYOFF)
        IF (VYOFF.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','VYOFF IS NOT DEFINED.')
        END IF
        CALL SGRGET('PLX',PLX)
        IF (PLX.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','PLX IS NOT DEFINED.')
        END IF
        CALL SGRGET('PLY',PLY)
        IF (PLY.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','PLY IS NOT DEFINED.')
        END IF
        CALL SGRGET('PLROT',PLROT)
        IF (PLROT.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','PLROT IS NOT DEFINED.')
        END IF
        CALL SGRGET('TXMIN',TXMIN)
        IF (TXMIN.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','TXMIN IS NOT DEFINED.')
        END IF
        CALL SGRGET('TXMAX',TXMAX)
        IF (TXMAX.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','TXMAX IS NOT DEFINED.')
        END IF
        CALL SGRGET('TYMIN',TYMIN)
        IF (TYMIN.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','TYMIN IS NOT DEFINED.')
        END IF
        CALL SGRGET('TYMAX',TYMAX)
        IF (TYMAX.EQ.RUNDEF) THEN
          CALL MSGDMP('E','GRSTRF','TYMAX IS NOT DEFINED.')
        END IF
      END IF

      CALL SGSTRF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLAZV(VX1,VY1,VX2,VY2,ITYPE,INDEX)


      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGLAZV','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLAZV','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLAZV','LINE INDEX IS INVALID.')
      END IF

      CALL SZLAOP(ITYPE,INDEX)
      CALL SZLAZV(VX1,VY1,VX2,VY2)
      CALL SZLACL

      END

*-----------------------------------------------------------------------
C     SUBROUTINE COSQI(N,WSAVE)
C
C     SUBROUTINE COSQI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH COSQF AND COSQB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE ARRAY TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH COSQF AND COSQB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF COSQF OR COSQB.
C
      SUBROUTINE COSQI (N,WSAVE)
      DIMENSION       WSAVE(*)
      EXTERNAL RFPI
C
      PIH = 0.5*RFPI()
      DT = PIH/FLOAT(N)
      FK = 0.
      DO 101 K=1,N
         FK = FK+1.
         WSAVE(K) = COS(FK*DT)
  101 CONTINUE
      CALL RFFTI (N,WSAVE(N+1))
      RETURN
      END

      PROGRAM TMPK1
      IMPLICIT NONE
      INTEGER NX, NY, THRES
      PARAMETER (NX=101, NY=101, THRES=1)
      REAL DX, DY
      PARAMETER (DX=6.2832/REAL(NX-1), DY=6.2832/REAL(NY-1))
      REAL ARROW_THRES
      PARAMETER (ARROW_THRES=1.0)
      REAL U(NX,NY), V(NX,NY)
      REAL X(NX), Y(NY)
      INTEGER I, J, SKIP, IWS
 
      WRITE(*,*) "SKIP NUM INPUT"
      READ(*,*) SKIP

      X=(/(DX*REAL(I-1),I=1,NX)/)
      Y=(/(DY*REAL(I-1),I=1,NY)/)
    
      DO 21 J=1,NY
         DO 20 I=1,NX
            U(I,J)=-COS(Y(J))
            V(I,J)=COS(X(I))
 20      CONTINUE
 21   CONTINUE
    
      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM
      CALL GRSWND( X(1), X(NX), Y(1), Y(NY) )
      CALL USPFIT
      CALL GRSTRF
      CALL USDAXS

C      CALL UETONF( U, NX, NX, NY )
C      CALL UDCNTR( V, NX, NX, NY )
C-- 流線描画
      CALL TMISET( 'SKIPINTV', SKIP )
      CALL TMSTLC( X, Y, U, V, NX, NY )

      CALL GRCLS

      END PROGRAM

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TEST01

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=  0, XMAX=360, YMIN=-90, YMAX=+90 )
      PARAMETER ( DX1=20, DX2=60, DY1=10, DY2=30 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05, DP=0.2 )

      REAL      P(NX,NY)


      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
   10   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )

      CALL GLRGET( 'RMISS', RMISS )
      CALL SGLSET( 'LSOFTF', .FALSE. )

      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UESTLV( RMISS,  -DP, 201 )
      CALL UESTLV(    DP, DP*2, 401 )
      CALL UESTLV( DP*2, RMISS, 402 )
      CALL UETONE( P, NX, NX, NY )

      CALL UXAXDV( 'B', DX1, DX2 )
      CALL UXAXDV( 'T', DX1, DX2 )
      CALL UXSTTL( 'B', 'LONGITUDE', 0.0 )

      CALL UYAXDV( 'L', DY1, DY2 )
      CALL UYAXDV( 'R', DY1, DY2 )
      CALL UYSTTL( 'L', 'LATITUDE', 0.0 )

      CALL UDGCLB( P, NX, NX, NY, DP )
      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     USPACK SUB-LABEL (X)                            S.Sakai  90/08/18
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USXSUB(CXA, CYA, CLABEL, RLBL)

      CHARACTER CLABEL*(*), CXS*1, CYS*1, CXA*1, CYA*1, CP*8
      LOGICAL   LPRTCT,LCLIPZ


      CXS = CXA
      CYS = CYA
      CALL CUPPER(CXS)
      CALL CUPPER(CYS)

      IF(CYS.NE.'L' .AND. CYS.NE.'R')
     #   CALL MSGDMP('E', 'USXSUB', 'INVALID CYS')
      IF(CXS.NE.'T' .AND. CXS.NE.'B'.AND. CXS.NE.'U')
     #   CALL MSGDMP('E', 'USXSUB', 'INVALID CXS')

      CP = 'ROFFX' //CXS
      CALL UZRGET(CP, ROFFX )
      CP = 'ICENTX'//CXS
      CALL UZIGET(CP, ICENTX)
      CP = 'IROTLX'//CXS
      CALL UZIGET(CP, IROTLX)
      CALL UZRGET('RSIZEL1', RSIZEL)
      CALL UZRGET('RSIZET2', RSIZET)
      CALL UZIGET('INDEXL1', INDEX )
      CALL UZIGET('INNER'  , INNER )
      CALL UZRGET('PAD1'   , PAD1  )

      CALL SZQTXW(CLABEL, NCH, WSUB, HSUB)
      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      IROTLY = MOD(IROTLY, 4)
      WSUB = WSUB*RSIZEL
      WLBL = RLBL*RSIZEL
      WPAD = PAD1*RSIZEL

      IC = 1
      IF(IROTLX.GE.2) IC = -1
      ICX = IC*ICENTX

*======================= < HORIZONTAL LABEL > ==========================

      IF(IROTLX.EQ.0 .OR. IROTLX.EQ.2) THEN
        IF(CYS.EQ.'R') THEN
          ICENTX = IC
          POSX = VXMAX - WLBL/2*(ICX-1)
        ELSE
          ICENTX = -IC
          POSX = VXMIN - WLBL/2*(ICX+1)
        ENDIF

        IF(CXS.EQ.'B') THEN
          POSY  = VYMIN
          IFLAG = -1
        ELSEIF(CXS.EQ.'T') THEN
          POSY  = VYMAX
          IFLAG = +1
        ELSE
          CALL UZRGET('UYUSER', UYUSR)
          CALL UZIGET('IFLAG', IFLAG)
          IFLAG = SIGN(1, IFLAG)
          CALL STFTRF(1., UYUSR, VX, POSY)
        ENDIF
        ROFFX = ROFFX + RSIZEL*IFLAG*(1.+PAD1)
        POSY  = POSY  + ROFFX - RSIZEL*IFLAG/2.
        CP = 'ROFFX' //CXS
        CALL UZRSET(CP, ROFFX )

*======================= < VERTICAL LABEL > ============================

      ELSE
        CALL USIGET('MXDGTSX', MXDGT )
        CALL USLGET('LPRTCT' , LPRTCT)
        CP = 'SOFFX'//CXS//CYS
        CALL USRGET(CP, RSOFF )
        IF(LPRTCT .AND. CXS.EQ.'U')
     #    CALL MSGDMP('M', 'USXSUB', 'Y-LABEL REGION IS NOT PROTECTED.')

        IF(CYS .EQ. 'R') THEN
          POSX  = VXMAX + RSOFF + RSIZEL*(0.5+PAD1)
          RSOFF = RSOFF + RSIZEL*(1.+PAD1)
        ELSE
          POSX  = VXMIN + RSOFF - RSIZEL*(0.5+PAD1)
          RSOFF = RSOFF - RSIZEL*(1.+PAD1)
        ENDIF

        CP = 'SOFFX'//CXS//CYS
        CALL USRSET(CP, RSOFF)

        CP = 'ROFFY'//CYS
        CALL USRGET(CP, ROFFY)

        ROFFY = MAX(RSOFF, ROFFY)

*-----------------------------------------------------------------------
*       IFLAG =  1 : LABEL IS RIGHT SIDE OF THE AXIS.
*       IFLAG = -1 : LABEL IS LEFT  SIDE OF THE AXIS.

        CP = 'ROFGX'//CXS
        CALL UZRGET(CP , ROFG)
        IF(INNER.LT.0) WPAD = WPAD - INNER*RSIZET
        IF(CXS.EQ.'B') THEN
          IFLAG = -1
          VYP  = -(VYMIN+ROFG)
        ELSEIF(CXS.EQ.'T') THEN
          IFLAG = 1
          VYP  = VYMAX+ROFG
        ELSEIF(CXS.EQ.'U') THEN
          CALL UZRGET('UYUSER', UYUSR)
          CALL UZIGET('IFLAG', IFLAG)
          CALL STFTRF(1., UYUSR, VX, VYP)
          VYP = VYP + ROFG
          CP = 'ROFFY'//CYS
          CALL USRSET(CP, ROFFY)
        ENDIF

        POSY = VYP + WPAD + WLBL*(ICX*IFLAG+1)/2.
        YMIN = VYP + WPAD
        YMAX = VYP + WPAD + MXDGT*RSIZEL

*------------------------ boundary check -------------------------------

        YLMIN = POSY - WSUB*(ICX*IFLAG+1)/2.
        IF(YLMIN.LT.YMIN) THEN
          ICX    = -IFLAG
          POSY   = YMIN
        ENDIF

        YLMAX = POSY - WSUB*(ICX*IFLAG-1)/2.
        IF(.NOT.LPRTCT .AND. YLMAX.GT.YMAX) THEN
          ICX    = IFLAG
          POSY   = YMAX
        ENDIF

        YLMIN = POSY - WSUB*(ICX*IFLAG+1)/2.
        IF(YLMIN.LT.VYP) THEN
          IF(CXS.EQ.'U') THEN
            ICX = 0
            POSY = (VYP+YMAX)/2.
          ELSE
            CP = 'ROFFY'//CYS
            CALL USRSET(CP, ROFFY)
          ENDIF
        ENDIF

        ICENTX = ICX/IC
        POSY = ABS(POSY)
      ENDIF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)
      CALL SGTXZV(POSX, POSY, CLABEL, RSIZEL, IROTLX*90, ICENTX, INDEX)
      CALL SGLSET('LCLIP',LCLIPZ)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SYSL02

      LOGICAL LMISS
      CHARACTER CMSG*120


      CALL GLLSTX('LMISS   ',.TRUE.)
      CALL GLLGET('LMISS   ',LMISS )
      WRITE(*,*) '--- LMISS    WAS CHANGED TO ',LMISS
      CALL GLISTX('IMISS   ',  -999)
      CALL GLIGET('IMISS   ',IMISS )
      WRITE(*,*) '--- IMISS    WAS CHANGED TO ',IMISS
      CALL GLRSTX('RMISS   ',-999.0)
      CALL GLRGET('RMISS   ',RMISS )
      WRITE(*,*) '--- RMISS    WAS CHANGED TO ',RMISS

      CALL GLISTX('NLNSIZE ',    60)
      CALL GLIGET('NLNSIZE ',NLINES)
      WRITE(*,*) '--- NLNSIZE  WAS CHANGED TO ',NLINES
      CALL GLISTX('MAXMSG  ',     5)
      CALL GLIGET('MAXMSG  ',MAXMSG)
      WRITE(*,*) '--- MAXMSG   WAS CHANGED TO ',MAXMSG
      CMSG='1234567890123456789012345678901234567890'
     +   //'1234567890123456789012345678901234567890'
     +   //'1234567890123456789012345678901234567890'
      DO 10 N=1,5
        CALL MSGDMP('M','TMSGDM','TEST PROGRAM FOR MSGDMP.')
        CALL MSGDMP('W','TMSGDM',CMSG)
   10 CONTINUE
*     CALL MSGDMP('E','TMSGDM','TEST PROGRAM FOR MSGDMP.')

      END

!-------------------------------------------------
!     interface module of scpack
!-------------------------------------------------
module sc_interface
    interface
!-----------------------------------------------------------------------
!正規化変換 
        subroutine scsvpt(vxmin3,vxmax3,vymin3,vymax3,vzmin3,vzmax3) !ビューポートの設定
            real,      intent(in) :: vxmin3  !直角直線座標のビューポート
            real,      intent(in) :: vxmax3
            real,      intent(in) :: vymin3
            real,      intent(in) :: vymax3
            real,      intent(in) :: vzmin3        
            real,      intent(in) :: vzmax3
        end subroutine

        subroutine scswnd(uxmin3,uxmax3,uymin3,uymax3,uzmin3,uzmax3) !ウインドウの設定．
            real,      intent(in) :: uxmin3      !直角直線座標のウインドウ
            real,      intent(in) :: uxmax3
            real,      intent(in) :: uymin3
            real,      intent(in) :: uymax3
            real,      intent(in) :: uzmin3    
            real,      intent(in) :: uzmax3
        end subroutine

        subroutine scslog(lxlog3,lylog3,lzlog3) !対数軸の設定．
            logical,   intent(in) :: lxlog3      !直角直線座標の対数軸指定
            logical,   intent(in) :: lylog3
            logical,   intent(in) :: lzlog3
        end subroutine

        subroutine scsorg(simfac,vxorg3,vyorg3,vzorg3) !スケーリングファクターと原点の設定
            real,      intent(in) :: simfac      !円筒座標，球座標のスケーリングファクター
            real,      intent(in) :: vxorg3      !円筒座標，球座標の原点の位置
            real,      intent(in) :: vyorg3
            real,      intent(in) :: vzorg3
        end subroutine

        subroutine scstrn(itr3) !変換関数番号の設定
            integer,   intent(in) :: itr3  !変換関数番号
        end subroutine

        subroutine scstrf() !変換関数の確定． 
        end subroutine
        
        !パラメタ参照ルーチン
        subroutine scqvpt(vxmin3,vxmax3,vymin3,vymax3,vzmin3,vzmax3)
            real,      intent(out) :: vxmin3     !直角直線座標のビューポート
            real,      intent(out) :: vxmax3
            real,      intent(out) :: vymin3
            real,      intent(out) :: vymax3
            real,      intent(out) :: vzmin3
            real,      intent(out) :: vzmax3
        end subroutine

        subroutine scqwnd(uxmin3,uxmax3,uymin3,uymax3,uzmin3,uzmax3) 
            real,      intent(out) :: uxmin3     !直角直線座標のウインドウ
            real,      intent(out) :: uxmax3
            real,      intent(out) :: uymin3
            real,      intent(out) :: uymax3
            real,      intent(out) :: uzmin3
            real,      intent(out) :: uzmax3
        end subroutine

        subroutine scqlog(lxlog3,lylog3,lzlog3) 
            logical,   intent(out) :: lxlog3     !直角直線座標の対数軸指定
            logical,   intent(out) :: lylog3
            logical,   intent(out) :: lzlog3
        end subroutine

        subroutine scqorg(simfac,vxorg3,vyorg3,vzorg3) 
            real,      intent(out) :: simfac     !スケーリングファクター
            real,      intent(out) :: vxorg3     !円筒座標，球座標の原点の位置
            real,      intent(out) :: vyorg3
            real,      intent(out) :: vzorg3
        end subroutine

        subroutine scqtrn(itr3) 
            integer,   intent(out) :: itr3        !変換関数番号
        end subroutine
!-----------------------------------------------------------------------------
!透視変換
        subroutine scseye(xeye3, yeye3, zeye3)  !視点の設定．
            real,      intent(in) :: xeye3
            real,      intent(in) :: yeye3
            real,      intent(in) :: zeye3
        end subroutine

        subroutine scsobj(xobj3, yobj3, zobj3)  !焦点の設定
            real,      intent(in) :: xobj3
            real,      intent(in) :: yobj3
            real,      intent(in) :: zobj3
        end subroutine

        subroutine scspln(ixc3, iyc3, sec3)  !2次元平面の割付
            integer,   intent(in) :: ixc3
            integer,   intent(in) :: iyc3
            real,      intent(in) :: sec3
        end subroutine
 
        subroutine scsprj()  !透視変換の確定． 
        end subroutine

        !パラメタ参照ルーチン
        subroutine scqeye(xeye3, yeye3, zeye3)
            real,      intent(out) :: xeye3
            real,      intent(out) :: yeye3
            real,      intent(out) :: zeye3
        end subroutine

        subroutine scqobj(xobj3, yobj3, zobj3) 
            real,      intent(out) :: xobj3
            real,      intent(out) :: yobj3
            real,      intent(out) :: zobj3
        end subroutine
 
         subroutine scqpln(ixc3, iyc3, sec3) 
            integer,   intent(out) :: ixc3
            integer,   intent(out) :: iyc3
            real,      intent(out) :: sec3
        end subroutine
!-----------------------------------------------------------------------------
!ポリライン
        subroutine scplzu(n,upx,upy,upz,index)  !u 座標系で折れ線を描く．  
            integer,   intent(in) :: n                 !配列UPX, UPY, UPZ の長さ
            real,      intent(in), dimension(*) :: upx !折れ線を結ぶ点のU座標
            real,      intent(in), dimension(*) :: upy 
            real,      intent(in), dimension(*) :: upz
            integer,   intent(in) :: index
        end subroutine

        subroutine scplzv(n,vpx,vpy,vpz,index)   !v 座標系で折れ線を描く．    
            integer,   intent(in) :: n                 !配列VPX, VPY, VPZ の長さ
            real,      intent(in), dimension(*) :: vpx !折れ線を結ぶ点のV座標
            real,      intent(in), dimension(*) :: vpy 
            real,      intent(in), dimension(*) :: vpz
            integer,   intent(in) :: index
        end subroutine

        subroutine scplu(n,upx,upy,upz)  !u 座標系で折れ線を描く．  
            integer,   intent(in) :: n                 !配列UPX, UPY, UPZ の長さ
            real,      intent(in), dimension(*) :: upx !折れ線を結ぶ点のR座標
            real,      intent(in), dimension(*) :: upy 
            real,      intent(in), dimension(*) :: upz
        end subroutine

        subroutine scplv(n,vpx,vpy,vpz) !v 座標系で折れ線を描く．
            integer,   intent(in) :: n                 !配列VPX, VPY, VPZ の長さ
            real,      intent(in), dimension(*) :: vpx !折れ線を結ぶ点のV座標系
            real,      intent(in), dimension(*) :: vpy
            real,      intent(in), dimension(*) :: vpz
        end subroutine

        subroutine scspli(index)  !ラインインデクスの設定．
            integer,   intent(in) :: index  !折れ線のラインインデクス 
        end subroutine
        
                 !パラメタ参照ルーチン
        subroutine scqpli(index)
            integer,   intent(out) :: index     !折れ線のラインインデクス 
        end subroutine
!------------------------------------------------------------------------------
! ポリマーカー
        subroutine scpmzu(n,upx,upy,upz,itype,index,rsize)  !u 座標系でマーカー列を描く
            integer,   intent(in) :: n                  !配列UPX, UPY, UPZの長さ
            real,      intent(in), dimension(*) :: upx  !マーカーを打つ点のU座標
            real,      intent(in), dimension(*) :: upy
            real,      intent(in), dimension(*) :: upz    
            integer,   intent(in) :: itype              !マーカータイプ  
            integer,   intent(in) :: index              !マーカーのラインインデクス
            real,      intent(in) :: rsize              !マーカーのサイズ
        end subroutine

        subroutine scpmzv(n,vpx,vpy,vpz,itype,index,rsize)  !v 座標系でマーカー列を描く．    
            integer,   intent(in) :: n                  !配列UPX, UPY, UPZの長さ
            real,      intent(in), dimension(*) :: vpx  !マーカーを打つ点のv座標 
            real,      intent(in), dimension(*) :: vpy
            real,      intent(in), dimension(*) :: vpz
            integer,   intent(in) :: itype              !マーカータイプ  
            integer,   intent(in) :: index              !マーカーのラインインデクス
            real,      intent(in) :: rsize              !マーカーのサイズ
        end subroutine

        subroutine scpmu(n,upx,upy,upz) !u 座標系でマーカー列を描く． 
            integer,   intent(in) :: n                  !配列UPX, UPY, UPZの長さ
            real,      intent(in), dimension(*) :: upx  !マーカーを打つ点のU座標
            real,      intent(in), dimension(*) :: upy    
            real,      intent(in), dimension(*) :: upz
        end subroutine

        subroutine scpmv(n,vpx,vpy,vpz)  !v 座標系でマーカー列を描く
            integer,   intent(in) :: n                  !配列VPX, VPY, VPZの長さ
            real,      intent(in), dimension(*) :: vpx  !マーカーを打つ点のU座標 
            real,      intent(in), dimension(*) :: vpy  
            real,      intent(in), dimension(*) :: vpz
        end subroutine

        subroutine scspmt(itype)  !マーカータイプの設定．    
            integer,   intent(in) :: itype  !マーカータイプ
        end subroutine

        subroutine scspmi(index)  !マーカーのラインインデクスの設定  
            integer,   intent(in) :: index  !マーカーを描く線のラインインデクス 
        end subroutine

        subroutine scspms(rsize)  !マーカーの大きさ設定．      
            real,      intent(in) :: rsize  !マーカーの大きさ
        end subroutine
                
                ! パラメタ参照ルーチン
        subroutine scqpmt(itype)
            integer,   intent(out) :: itype !マーカータイプ
        end subroutine

        subroutine scqpmi(index)
            integer,   intent(out) :: index    !マーカーを描く線のラインインデクス
        end subroutine

        subroutine scqpms(rsize)  
            real,      intent(out) :: rsize    !マーカーの大きさをR-座標系における単位で指定
        end subroutine
!--------------------------------------------------------------------
!トーン
        subroutine sctnzu(upx,upy,upz,itpat1,itpat2)  ! u 座標系で多角形領域の塗りつぶし
            real,      intent(in), dimension(3) :: upx  !三角形を定義する頂点のU座標          
            real,      intent(in), dimension(3) :: upy    
            real,      intent(in), dimension(3) :: upz
            integer,   intent(in) :: itpat1            !表と裏のトーンパターン番号
            integer,   intent(in) :: itpat2
        end subroutine

        subroutine sctnzv(vpx,vpy,vpz,itpat1,itpat2) !v 座標系で多角形領域の塗りつぶし．
            real,      intent(in), dimension(3) :: vpx  !三角形を定義する頂点のV座標
            real,      intent(in), dimension(3) :: vpy    
            real,      intent(in), dimension(3) :: vpz
            integer,   intent(in) :: itpat1                !表と裏のトーンパターン番号
            integer,   intent(in) :: itpat2
        end subroutine

        subroutine sctnu(upx,upy,upz)  !u 座標系で多角形領域の塗りつぶし．
            real,      intent(in), dimension(3) :: upx  !三角形を定義する頂点のU座標
            real,      intent(in), dimension(3) :: upy
            real,      intent(in), dimension(3) :: upz
        end subroutine

        subroutine sctnv(vpx,vpy,vpz) !v 座標系で多角形領域の塗りつぶし．
            real,      intent(in), dimension(3) :: vpx  !三角形を定義する頂点のV座標
            real,      intent(in), dimension(3) :: vpy    
            real,      intent(in), dimension(3) :: vpz
        end subroutine

        subroutine scstnp(itpat1,itpat2)  !トーンパターン番号設定． 
            integer,   intent(in) :: itpat1  !表と裏のトーンパターン番号（初期値は1)
            integer,   intent(in) :: itpat2
        end subroutine

        subroutine scqtnp(itpat1,itpat2)  !現在設定されているトーンパターン番号 
            integer,   intent(out) :: itpat1  !表と裏のトーンパターン番号
            integer,   intent(out) :: itpat2
        end subroutine
    end interface
end module

*-----------------------------------------------------------------------
C     SUBROUTINE EZFFTF(N,R,AZERO,A,B,WSAVE)
C
C     SUBROUTINE EZFFTF COMPUTES THE FOURIER COEFFICIENTS OF A REAL
C     PERODIC SEQUENCE (FOURIER ANALYSIS). THE TRANSFORM IS DEFINED
C     BELOW AT OUTPUT PARAMETERS AZERO,A AND B. EZFFTF IS A SIMPLIFIED
C     BUT SLOWER VERSION OF RFFTF.
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE ARRAY R TO BE TRANSFORMED.  THE METHOD
C             IS MUST EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES.
C
C     R       A REAL ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C             TO BE TRANSFORMED. R IS NOT DESTROYED.
C
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             IN THE PROGRAM THAT CALLS EZFFTF. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE EZFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY EZFFTF AND EZFFTB.
C
C     OUTPUT PARAMETERS
C
C     AZERO   THE SUM FROM I=1 TO I=N OF R(I)/N
C
C     A,B     FOR N EVEN B(N/2)=0. AND A(N/2) IS THE SUM FROM I=1 TO
C             I=N OF (-1)**(I-1)*R(I)/N
C
C             FOR N EVEN DEFINE KMAX=N/2-1
C             FOR N ODD  DEFINE KMAX=(N-1)/2
C
C             THEN FOR  K=1,...,KMAX
C
C                  A(K) EQUALS THE SUM FROM I=1 TO I=N OF
C
C                       2./N*R(I)*COS(K*(I-1)*2*PI/N)
C
C                  B(K) EQUALS THE SUM FROM I=1 TO I=N OF
C
C                       2./N*R(I)*SIN(K*(I-1)*2*PI/N)
C
C
      SUBROUTINE EZFFTF (N,R,AZERO,A,B,WSAVE)
      DIMENSION       R(*)       ,A(*)       ,B(*)       ,WSAVE(*)
C
      IF (N-2) 101,102,103
  101 AZERO = R(1)
      RETURN
  102 AZERO = .5*(R(1)+R(2))
      A(1) = .5*(R(1)-R(2))
      RETURN
  103 DO 104 I=1,N
         WSAVE(I) = R(I)
  104 CONTINUE
      CALL RFFTF (N,WSAVE,WSAVE(N+1))
      CF = 2./FLOAT(N)
      CFM = -CF
      AZERO = .5*CF*WSAVE(1)
      NS2 = (N+1)/2
      NS2M = NS2-1
      DO 105 I=1,NS2M
         A(I) = CF*WSAVE(2*I)
         B(I) = CFM*WSAVE(2*I+1)
  105 CONTINUE
      IF (MOD(N,2) .EQ. 1) RETURN
      A(NS2) = .5*CF*WSAVE(N)
      B(NS2) = 0.
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLAZU(UX1,UY1,UX2,UY2,ITYPE,INDEX)


      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGLAZU','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLAZU','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLAZU','LINE INDEX IS INVALID.')
      END IF

      CALL SZLAOP(ITYPE,INDEX)
      CALL SZLAZU(UX1,UY1,UX2,UY2)
      CALL SZLACL

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGTNXV(N,VPX,VPY,ITPAT,ICOLOR)

      REAL      VPX(*),VPY(*)
      LOGICAL   LFCATR
      INTEGER   ITPATX

      CALL SGIGET('IFCIDX',IFCIDX)

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGTNXV','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNXV','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPAT.EQ.0) THEN
        CALL MSGDMP('M','SGTNXV','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT.LT.0) THEN
        CALL MSGDMP('E','SGTNXV','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSTCL(ICOLOR)
      CALL SWSLCL(ICOLOR)


      ITPATX=IFCIDX*1000+MOD(ITPAT,1000)
      CALL SZTNOP(ITPATX)
      CALL SZTNZV(N,VPX,VPY)
      CALL SZTNCL

      CALL SWSFCM(.FALSE.)

      END

program layout03

  use dcl

  integer,parameter :: nmax=400
  real :: x(nmax), y(nmax)

!-- �ǡ��� 1 ----
    dt = 2.*3.14159 / (nmax-1)

    do n=1,nmax
      t = dt*(n-1)
      x(n) = 5.*sin(4.*t)
      y(n) = 5.*cos(5.*t)
    end do

!-- ����� 1 ----
    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow(  -6.,   6.,  -6.,   6. )
    call DclSetViewPort( 0.15, 0.45, 0.65, 0.95 )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSetTitle( 'x1', 'y1', '', '' )
    call DclDrawScaledAxis

    call DclDrawLine( x, y )

!-- �ǡ��� 2 ----
    iseed = 1
    x(1) = 2.*(rngu2(iseed)-0.5)
    do n=2,nmax
      x(n)   = 2.*(rngu2(iseed)-0.5)
      y(n-1) = x(n)
    end do
    y(nmax) = x(1)

!-- ����� 2 ----
    call DclNewFig

    call DclSetWindow(  -1.1,  1.1, -1.1, 1.1 )
    call DclSetViewPort(  0.15, 0.95,  0.1, 0.5 )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSetTitle( 'x2-title', 'y2-title', '', '' )
    call DclDrawScaledAxis

    call DclDrawMarker( x, y )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE CHNGR(CH,CA,RR,CFMT)

      CHARACTER CH*(*),CA*(*),CFMT*(*)

      CHARACTER CPAT*1024

      EXTERNAL  INDXNF


      NH=LEN(CH)
      NN=LEN(CA)
      CPAT=CA(1:NN)

      IF (.NOT.(NH.GE.NN)) THEN
        CALL MSGDMP('E','CHNGI','TEXT LENGTH IS TOO SHORT.')
      END IF

      ID1=INDXNF(CH,NH-NN+1,1,CA)
      ID2=ID1+NN-1
      IF (ID1.EQ.0) THEN
        CALL MSGDMP('W','CHNGC',
     +       'PATTERN < '//CPAT(1:NN)//' > WAS NOT FOUND.')
      ELSE
        WRITE(CH(ID1:ID2),CFMT,IOSTAT=IOS) RR
        IF (IOS.NE.0) THEN
          CALL MSGDMP('W','CHNGR','SUBSTITUTION ERROR.')
        END IF
      END IF

      END

*-----------------------------------------------------------------------
*     UDCNTZ
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDCNTZ(Z,MX,NX,NY,IBR,NBR2)

      INTEGER   IBR(NBR2)
      REAL      Z(MX,*)

      INTEGER   NS(2),NP(2),NQ(2)
      LOGICAL   LUDCHK,LOPEN,LMISS,LMADA,LOK,LSET,LMSG,
     +          LEPSL,LCHAR,LMAP,LCLIP,LPRINT,LEXIT,LCENT
      CHARACTER CMSG*80

      COMMON    /UDBLK1/ NB,LX,LY,NBR
      COMMON    /UDBLK2/ NL,CZL,IDX,ITY,HLV
      COMMON    /UDBLK3/ CLAB
      PARAMETER (NLX=50)
      INTEGER   IDX(NLX),ITY(NLX)
      REAL      CZL(NLX),HLV(NLX)
      CHARACTER CLAB(NLX)*8

      EXTERNAL  RVMIN,RVMAX,RUDLEV,LUDCHK

      SAVE


*     / GET INTERNAL PARAMETERS /

      CALL UDRGET('RSIZET  ',RSIZE )
      CALL UDRGET('XTTL    ',XTTL  )
      CALL UDLGET('LMSG    ',LMSG  )
      CALL UDLGET('LCENT   ',LCENT )
      CALL UDIGET('NLEV    ',NLEV  )
      CALL UDIGET('INDXMJ  ',INDEX )

      CALL GLLGET('LMISS',LMISS)
      CALL GLRGET('RMISS',RMISS)
      CALL GLIGET('NBITSPW',NB)
      CALL GLLGET('LEPSL',LEPSL)
      CALL SGLGET('LCHAR',LCHAR)

      CALL STQTRF(LMAP)

*     / SET INTERNAL PARAMETER /

      CALL GLLSET('LEPSL',.TRUE.)
      CALL SGLSET('LCHAR',.TRUE.)

*     / CHECK WORKING ARRAY SIZE /

      NBR=NBR2/2
      LX=NX+2
      LY=NY+2
      NWRD=LX*LY*2/NB+1
      IF (NWRD.GT.NBR) THEN
        CALL MSGDMP('M','UDCNTR','WORKING AREA IS NOT ENOUGH.')
        CMSG='NBR2/2 SHOULD BE LARGER THAN (NX+2)*(NY+2)/##+1.'
        WRITE(CMSG(44:45),'(I2)') NB/2
        CALL MSGDMP('E','-CNT.-',CMSG)
      END IF

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX,NY)

*     / CHECK MIN & MAX /

      NS(1)=MX
      NS(2)=NY
      NP(1)=1
      NP(2)=1
      NQ(1)=NX
      NQ(2)=NY
      RMINZ=RVMIN(Z,NS,NP,NQ,2)
      RMAXZ=RVMAX(Z,NS,NP,NQ,2)

      LMADA=LMISS .AND. RMINZ.EQ.RMISS .AND. RMAXZ.EQ.RMISS

      IF (LMADA .OR. RMINZ.EQ.RMAXZ) THEN

*       / MESSAGE FOR MISSING OR CONSTANT FIELD /

        IF (LMADA) THEN
          CMSG='MISSING FIELD.'
        ELSE
          CMSG='CONSTANT (##########) FIELD.'
          WRITE(CMSG(11:20),'(1P,E10.3)') RMINZ
        END IF
        CALL MSGDMP('W','UDCNTR',CMSG)

        LPRINT=LMSG
        LEXIT=.TRUE.

      ELSE

*       / GENERATE CONTOUR LEVELS IF THEY HAVE NOT BEEN GENERATED YET /

        CALL UDQCLZ(LSET)
        IF (.NOT.LSET) THEN
          CALL UDGCLB(Z,MX,NX,NY,-REAL(NLEV))
          CALL UDSCLZ(.FALSE.)
        END IF

*       / CHECK INAPPROPRIATE DATA /

        DO 10 K=1,NY
          DO 15 J=1,NX

            LOK=.NOT.(LMISS .AND. Z(J,K).EQ.RMISS)

            DO 20 I=1,NL
              IF (LOK .AND. Z(J,K).EQ.CZL(I)) THEN
                XXX=RUDVAL(Z(J,K),CZL(I))
                CMSG='INAPPROPRIATE DATA WILL BE MODIFIED INTERNALLY.'
                CALL MSGDMP('M','UDCNTR',CMSG)
                WRITE(CMSG(1:80),500) J,K,Z(J,K),XXX
  500           FORMAT('Z(',I3,',',I3,')=',G16.9,' ===> ',G16.9)
                CALL MSGDMP('M','-CNT.-',CMSG)
              END IF
   20       CONTINUE

   15     CONTINUE
   10   CONTINUE

*       / CONTOUR INTERVAL /

        DZ=RUDLEV(1)
        CMSG='CONTOUR INTERVAL =##########'
        WRITE(CMSG(19:28),'(1P,E10.3)') DZ

        LPRINT=NL.GE.2 .AND. LMSG
        LEXIT=.FALSE.

      END IF

*     / PRINT MESSAGE /

      IF (LPRINT) THEN
        CALL SGLGET('LCLIP', LCLIP)
        CALL SGLSET('LCLIP',.FALSE.)
        CALL SGQVPT(VXMN,VXMX,VYMN,VYMX)
        XPT=(VXMN+VXMX)/2
        IF (LMAP.AND.LCENT) THEN
          YPT=VYMN/2
        ELSE
          CALL UZRGET('ROFFXB',ROFFX)
          CALL UZRGET('PAD1',PAD)
          YPT=VYMN+ROFFX-RSIZE*(PAD*2+1.5)
          ROFFX=ROFFX-RSIZE*(PAD+1.0)*2
          CALL UZRSET('ROFFXB',ROFFX)
        END IF
        CALL CUPPER(CMSG)
        CALL SGTXZV(XPT,YPT,CMSG,RSIZE,0,0,INDEX)
        CALL SGLSET('LCLIP',LCLIP)
        IF (LEXIT) GO TO 100
      END IF

*     / CHECK BOUND /

      CALL UDICLR(IBR,NBR*2)

      DO 25 K=0,1
        K1=1-K
        DO 30 IY=1,NY-K
          IY1=IY+K
          DO 35 IX=1,NX-K1
            IX1=IX+K1
            IF (.NOT.(LMISS .AND.
     +        (Z(IX1,IY).EQ.RMISS .OR. Z(IX,IY1).EQ.RMISS))) THEN
              CALL UDBSET(IX,IY,K,1,IBR)
            END IF
   35     CONTINUE
   30   CONTINUE
   25 CONTINUE

      DO 40 K=0,1
        K1=1-K
        DO 45 IY=1,NY-K
          IY1=IY+K1
          IY2=IY-K1
          DO 50 IX=1,NX-K1
            IX1=IX+K
            IX2=IX-K
            IF (.NOT.LUDCHK(IX1,IY1,K,1,IBR)
     +          .AND. .NOT.LUDCHK(IX2,IY2,K,1,IBR)) THEN
              CALL UDBCLR(IX,IY,K,1,IBR)
            END IF
   50     CONTINUE
   45   CONTINUE
   40 CONTINUE

*     / DRAW CONTOURS /

      DO 55 LC=1,NL

*       / INITIALIZE /

        CX=CZL(LC)
        IF (.NOT.(RMINZ.LT.CX .AND. CX.LT.RMAXZ)) GO TO 55

        IF (HLV(LC).LE.0) THEN
          CALL SZCRST
        ELSE
          NLAB=LENC(CLAB(LC))
          CALL SZSCHZ(CLAB(LC)(1:NLAB),HLV(LC))
        END IF
        CALL SZSLTI(ITY(LC),IDX(LC))

        CALL UDICLR(IBR,NBR)

*       / CHECK BRANCH /

        NN=0
        DO 60 K=0,1
          K1=1-K
          DO 65 IY=1,NY-K
            IY1=IY+K
            DO 70 IX=1,NX-K1
              IX1=IX+K1
              IF (Z(IX1,IY).EQ.CX) THEN
                ZZ1=RUDVAL(Z(IX1,IY),CX)
              ELSE
                ZZ1=Z(IX1,IY)
              END IF
              IF (Z(IX,IY1).EQ.CX) THEN
                ZZ2=RUDVAL(Z(IX,IY1),CX)
              ELSE
                ZZ2=Z(IX,IY1)
              END IF
              IF (LUDCHK(IX,IY,K,1,IBR)) then
                if ((ZZ1-CX)*(ZZ2-CX).LT.0) THEN
                  CALL UDBSET(IX,IY,K,0,IBR)
                  NN=NN+1
                end if
              END IF
   70       CONTINUE
   65     CONTINUE
   60   CONTINUE

        IF (NN.NE.0) THEN

*         / BOUND TO BOUND CONTOURS /

          DO 75 K=0,1
            K1=1-K
            DO 80 IY=1,NY-K
              DO 85 IX=1,NX-K1
                IF (LUDCHK(IX,IY,K,0,IBR)) THEN
                  IX1=IX+K
                  IX2=IX-K
                  IY1=IY+K1
                  IY2=IY-K1
                  LOPEN=.NOT.(LUDCHK(IX1,IY1,K,1,IBR)
     +                  .AND. LUDCHK(IX2,IY2,K,1,IBR))
                  IF (LOPEN) THEN
                    CALL UDLINE(Z,MX,IX,IY,K,CX,LOPEN,IBR)
                  END IF
                END IF
   85         CONTINUE
   80       CONTINUE
   75     CONTINUE

*         / CLOSED CONTOURS /

          K=0
          K1=1-K
          DO 90 IY=1,NY-K
            DO 95 IX=1,NX-K1
              IF (LUDCHK(IX,IY,K,0,IBR)) THEN
                IX1=IX+K
                IX2=IX-K
                IY1=IY+K1
                IY2=IY-K1
                LOPEN=.NOT.(LUDCHK(IX1,IY1,K,1,IBR)
     +                .AND. LUDCHK(IX2,IY2,K,1,IBR))
                IF (.NOT.LOPEN) THEN
                  CALL UDLINE(Z,MX,IX,IY,K,CX,LOPEN,IBR)
                END IF
              END IF
   95       CONTINUE
   90     CONTINUE

        END IF

   55 CONTINUE

*     / RESET INTERNAL PARAMETER /

  100 CALL GLLSET('LEPSL',LEPSL)
      CALL SGLSET('LCHAR',LCHAR)

      END

!-------------------------------------------------
!  RFAlib Module
!-------------------------------------------------
module rfblib
  use dcl_common
  contains

    function DclGetPRD(x,y)                        !内積を求める
      real, intent(in), dimension(:) :: x
      real, intent(in), dimension(:) :: y
      real                           :: DclGetPRD

      call prcopn('DclGetPRD')
      DclGetPRD = rprd(x,y,size(x),1,1)
      call prccls('DclGetPRD')
    end function
      
    function DclGetCOV(x,y)                        !共分散を求める
      real, intent(in), dimension(:) :: x
      real, intent(in), dimension(:) :: y
      real                           :: DclGetCOV

      call prcopn('DclGetCOV')
      DclGetCOV = rcov(x,y,size(x),1,1)
      call prccls('DclGetCOV')
    end function
      
    function DclGetCOR(x,y)                        !相関係数を求める
      real, intent(in), dimension(:) :: x
      real, intent(in), dimension(:) :: y
      real                           :: DclGetCOR

      call prcopn('DclGetCOR')
      DclGetCOR = rcor(x,y,size(x),1,1)
      call prccls('DclGetCOR')
    end function
      
end module

!-------------------------------------------------
!interface module of uspack
!-------------------------------------------------
module us_interface
  interface
!---------------------------------------------------------------
    subroutine usgrph(n, x, y)                    !座標軸とグラフを描く．
      integer,   intent(in) :: n                  !x,y のデータ数．
      real,      intent(in), dimension(*) :: x    !折れ線グラフのx座標
      real,      intent(in), dimension(*) :: y    !折れ線グラフのy座標
    end subroutine
!--------------------------------------------------------
    subroutine usspnt(n, x, y)                    !ウインドウ範囲に含めたいデータの指定．
      integer,   intent(in) :: n                  !x,y のデータ数
      real,      intent(in), dimension(*) :: x    !x座標
      real,      intent(in), dimension(*) :: y    !y座標
    end subroutine
      
    subroutine uspfit()                           !usspntで設定されたデータの最大最小値，正規化変換のパラメタを決める．
    end subroutine
!--------------------------------------------------------
    subroutine usdaxs()                           !デフォルトの座標軸を描く． タイトルが指定されていればタイトルも書く．
    end subroutine
      
    subroutine usxaxs(cxside)                     !現在設定されている正規化変換に対して,座標軸を一本描く．
      character(len=1), intent(in) :: cxside      !座標軸の位置.
    end subroutine
      
    subroutine usyaxs(cyside)                     !現在設定されている正規化変換に対して座標軸を一本描く．
      character(len=1), intent(in) :: cyside      !座標軸の位置 
    end subroutine
      
    subroutine ussttl(cxttl, cxunit, cyttl, cyunit) !座標軸のタイトル,サブラベルの中の単位を指定．
      character(len=*), intent(in) :: cxttl       !x座標軸のタイトル
      character(len=*), intent(in) :: cxunit      !x座標軸の単位
      character(len=*), intent(in) :: cyttl       !y座標軸のタイトル
      character(len=*), intent(in) :: cyunit      !y座標軸の単位
    end subroutine
!--------------------------------------------------------
    subroutine uspget(cp, ipara)                  !内部変数を参照
      character(len=*), intent(in) :: cp          !パラメータ名
      integer,   intent(out) :: ipara             !パラメータ値
    end subroutine
      
    subroutine usiget(cp, ipara)                  !内部変数を参照
      character(len=*), intent(in) :: cp          !パラメータ名
      integer,   intent(out) :: ipara             !パラメータ値
    end subroutine
      
    subroutine usrget(cp, ipara)                  !内部変数を参照
      character(len=*), intent(in) :: cp          !パラメータ名
      real,   intent(out) :: ipara             !パラメータ値
    end subroutine
      
    subroutine uslget(cp, ipara)                  !内部変数を参照
      character(len=*), intent(in) :: cp          !パラメータ名
      logical,   intent(out) :: ipara             !パラメータ値
    end subroutine
      
    subroutine uspset(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !パラメータ名
      integer,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine usiset(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !パラメータ名
      integer,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine usrset(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !パラメータ名
      real,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine uslset(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !パラメータ名
      logical,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine uspstx(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !ラメータ名
      integer,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine usistx(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !ラメータ名
      integer,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine usrstx(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !ラメータ名
      real,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine uslstx(cp, ipara)                  !内部変数を設定
      character(len=*), intent(in) :: cp          !ラメータ名
      logical,   intent(in) :: ipara              !パラメータ値
    end subroutine
      
    subroutine uscget(cp, cpara)                  !文字パラメータを参照する
      character(len=*), intent(in) :: cp          !パラメータ名
      character(len=*), intent(out) :: cpara      !パラメータ値
    end subroutine
      
    subroutine uscset(cp, cpara)                  !文字パラメータを設定する
      character(len=*), intent(in) :: cp          !パラメータ名
      character(len=*), intent(in) :: cpara       !パラメータ値
    end subroutine
      
    subroutine uscstx(cp, cpara)                  !文字パラメータを設定する
      character(len=*), intent(in) :: cp          !パラメータ名
      character(len=*), intent(in) :: cpara       !パラメータ値
    end subroutine
      
    subroutine uspqnp(ncp)                        !内部変数の総数を求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine uspqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine uspqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する
      character(len=*), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine uspqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine uspsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine
      
    subroutine uscqnp(ncp)                        !内部変数の総数を求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine uscqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine uscqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する
      character(len=*), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine uscqvl(idx,cpara)                  !idxの位置にある内部変数の値を参照する
      integer,   intent(in) :: idx
      character(len=*), intent(out) :: cpara
    end subroutine
      
    subroutine uscsvl(idx,cpara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      character(len=*), intent(in) :: cpara
    end subroutine
      
    subroutine usinit()                           !初期値に戻す．
    end subroutine

  end interface
end module
!uspack library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZT3ZV(VPX,VPY,VPZ)

      REAL      VPX(3), VPY(3), VPZ(3), RX(3), RY(3)

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN4/ ITPT1, ITPT2

      SAVE

      DATA      ITPATZ /0/


      DO 10 I=1, 3
        CALL STFPR3 (VPX(I), VPY(I), VPZ(I), RX(I), RY(I))
   10 CONTINUE

      ROT = (RX(2)-RX(1))*(RY(3)-RY(1)) - (RX(3)-RX(1))*(RY(2)-RY(1))

      IF (ROT .GT. 0) THEN
        IRMODR = MOD(IRMODE, 2)
        ITPAT = ITPT1
      ELSE IF (ROT .LT. 0) THEN
        IRMODR = MOD(IRMODE+1, 2)
        ITPAT = ITPT2
      ELSE
        RETURN
      END IF

      IF (ITPAT.NE.ITPATZ) THEN
        CALL SZSTNI(ITPAT)
        ITPATZ = ITPAT
      END IF

      CALL SZOPTR
      DO 20 I=1,3
        CALL SZSTTR(RX(I),RY(I))
   20 CONTINUE
      CALL SZSTTR(RX(1),RY(1))
      CALL SZCLTR

      END

      PROGRAM LAY3

      WRITE(*,*) 'WORKSTATION ID ? '
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )

      CALL SGLSET( 'LFULL', .TRUE. )
      CALL SLMGN( 0., 0., 0.08, 0.08 )
      CALL SLRAT( 1., 0.6 )
      CALL SLSTTL( 'FIGURE TITLE', 'T',  0.,  0., 0.03, 1 )
      CALL SLSTTL( 'PROGRAM.NAME', 'B', -1., -1., 0.02, 2 )
      CALL SLSTTL( 'page:#PAGE',   'B',  1., -1., 0.02, 3 )

      CALL SGFRM
      CALL SLPVPR( 1 )
      CALL SGTXV( 0.5, 0.5, 'FIGURE' )

      CALL SGCLS

      END

!-------------------------------------------------
!interface module of intlib
!-------------------------------------------------
module intlib
  use dcl_common
  contains

    function DclIntLT(value)           !valueより小さい最大の整数を求める
      real, intent(in) :: value        !調べる実数値
      integer          :: DclIntLT     !valueより小さい最大の整数関数値

      call prcopn('DclIntLT')
      DclIntLT = irlt(value) 
      call prccls('DclIntLT')
    end function
      
    function DclIntLE(value)           !value以下の最大の整数を求める
      real, intent(in) :: value        !調べる実数値
      integer          :: DclIntLE     !value以下の最大の整数関数値

      call prcopn('DclIntLE')
      DclIntLE = irle(value)  
      call prccls('DclIntLE')
    end function
      
    function DclIntGT(value)           !valueより大きい最小の整数を求める
      real, intent(in) :: value        !調べる実数値
      integer          :: DclIntGT     !valueより大きい最大の整数関数値

      call prcopn('DclIntGT')
      DclIntGT = irgt(value) 
      call prccls('DclIntGT')
    end function
      
    function DclIntGE(value)           !value以上の最小の整数を求める
      real, intent(in) :: value        !調べる実数値
      integer          :: DclIntGE     !value以上の最大の整数関数値

      call prcopn('DclIntGE')
      DclIntGE = irge(value) 
      call prccls('DclIntGE')
    end function

end module

*-----------------------------------------------------------------------
*     CLIPPING ON TC - X
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPCLX(TX0, TY0, TX1, TY1, LVALID, LBOUND)

      PARAMETER (EPSIL=1.E-5)

      REAL      XB(2)
      LOGICAL   LCONT, LMOVE, LPOLE, LBRDR, LINNR, LVALID,
     +          LREQA, LRNEA, LBOUND

      EXTERNAL  RFPI, LREQA, LRNEA

      SAVE

      LBRDR (X) = LREQA(XB(1), X, EPSIL) .OR. LREQA(X, XB(2), EPSIL)
      LINNR (X) = XB(1).LT. X  .AND. X .LT. XB(2)
      LPOLE (Y) = LREQA(ABS(Y), PI2, EPSIL)


      PI = RFPI()
      PI2 = PI/2

      PX0 = TX0
      PY0 = TY0
      PX1 = TX1
      PY1 = TY1

      DXX = SZXMOD(PX1 - PX0)
      PXX = PX0 + DXX

      IF ( LBRDR(PX0) .AND. LBOUND ) THEN
        IF ( LBRDR(PX1) ) THEN
          IF ( LRNEA(PXX, PX1, EPSIL)) THEN
            NMOD = 2
            NEND = 2
          ELSE
            NMOD = 3
            NEND = 3
          END IF
        ELSE IF ( LINNR(PX1) ) THEN
          NMOD = 3
          NEND = 3
          IF ( LRNEA(PXX, PX1, EPSIL) ) NMOD = 2
        ELSE
          LVALID = .FALSE.
          RETURN
        END IF
      ELSE IF ( LINNR(PX0) .AND. .NOT. LBRDR(PX0) ) THEN
        IF ( LBRDR(PX1) .AND. LBOUND) THEN
          NMOD = 1
          NEND = 1
          IF ( LRNEA(PXX, PX1, EPSIL) ) NEND = 2
        ELSE IF ( LINNR(PX1) .AND. .NOT.LBRDR(PX1) ) THEN
          NMOD = 3
          NEND = 3
          IF ( LRNEA(PXX, PX1, EPSIL) ) NMOD = 1
        ELSE
          NMOD = 1
          NEND = 1
        END IF
      ELSE
        IF (LBRDR(PX1) .AND. LBOUND ) THEN
          NMOD = 2
          NEND = 2
        ELSE IF ( LINNR(PX1) ) THEN
          NMOD = 2
          NEND = 3
        ELSE
          LVALID = .FALSE.
          RETURN
        END IF
      END IF
      LVALID = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZGCLX(TX, TY, LCONT, LMOVE)

*     NMOD 1: PLOT TO BOUNDARY
*          2: MOVE TO BOUNDARY
*          3: PLOT TO (TX1, TY1)

      LMOVE = NMOD.EQ.2
      IF(NMOD.EQ.3 ) THEN
        TX = PX1
        TY = PY1
      ELSE IF(NMOD.EQ.1 .AND. LBRDR(PX1)) THEN
        TX = PXX
        TY = PY1
      ELSE
        IF (NMOD.EQ.1) THEN
          CXX = PX0+DXX/2
        ELSE IF (NMOD.EQ.2) THEN
          CXX = PX1-DXX/2
        END IF

        IF (ABS(CXX-XB(1)).LT.ABS(CXX-XB(2))) THEN
          TX = XB(1)
        ELSE
          TX = XB(2)
        END IF

        IF (LPOLE(PY1)) THEN
          TY = PY1
        ELSE IF (LPOLE(PY0)) THEN
          TY = PY0
        ELSE IF (LREQA(DXX, 0., EPSIL*10)) THEN
          TY = PY1
        ELSE IF (LREQA(ABS(DXX), PI, EPSIL*10)) THEN
          TY = SIGN(PI2, PY0+PY1)
        ELSE
          CALL SZSGCL(PX0, PY0, PX1, PY1)
          CALL SZQGCY(TX, TY)
        END IF
      END IF

      NMOD = NMOD+1
      LCONT = NMOD.LE.NEND

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSCLX(XBND1, XBND2)

      XB(1) = XBND1
      XB(2) = XBND2

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQCLX(XBND1, XBND2)

      XBND1 = XB(1)
      XBND2 = XB(2)

      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE INORML(V,W,N,M,X,Y)

      INTEGER V(N,M)
      REAL    W(N,M),R
      REAL    MAX,MIN

      MAX = 0.0
      MIN = 0.0

      DO 10 I=1,N
      DO 20 J=1,M
        IF (V(I,J).GE.MAX) THEN
          MAX=V(I,J)
        ENDIF
        IF (V(I,J).LE.MIN) THEN
          MIN=V(I,J)
        ENDIF
 20   CONTINUE
 10   CONTINUE

      IF (MAX.NE.MIN) THEN
        R = (Y-X)/(MAX-MIN)
      ENDIF

      IF (MAX.NE.MIN) THEN
      DO 30 I=1,N
      DO 40 J=1,M
        W(I,J)=X+R*(V(I,J)-MIN)
 40   CONTINUE
 30   CONTINUE
      ELSE IF (MAX.GE.Y) THEN
      DO 50 I=1,N
      DO 60 J=1,M
        W(I,J) = Y
 60   CONTINUE
 50   CONTINUE
      ELSE IF (MIN.LE.X) THEN
      DO 70 I=1,N
      DO 80 J=1,M
        W(I,J) = X
 80   CONTINUE
 70   CONTINUE
      ELSE
      DO 90 I=1,N
      DO 100 J=1,M
        W(I,J) = V(I,J)
 100  CONTINUE
  90  CONTINUE
      END IF


      RETURN
      END

*-----------------------------------------------------------------------
*     UERQNP / UERQID / UERQCP / UERQVL / UERSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UERQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 1)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'RLEV    ' /, RX(1) / 0.0 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'DEFAULT_SHADE_THRESHOLD' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UERQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UERQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UERQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UERQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UERQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UERQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UERQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UE', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','UERQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UERSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UE', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UERSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UERQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZL3ZU(N,U3X,U3Y,U3Z)

      REAL      U3X(N),U3Y(N),U3Z(N)

      LOGICAL   LFLAG

      COMMON    /SZBPL1/ LMISS,RMISS
      LOGICAL   LMISS

      SAVE


      CALL SZOPL3

      IF (.NOT.LMISS) THEN
        CALL STFTR3(U3X(1), U3Y(1), U3Z(1), VX, VY, VZ)
        CALL SZMVL3(VX, VY, VZ)
        DO 10 I=2,N
          CALL STFTR3(U3X(I), U3Y(I), U3Z(I), VX, VY, VZ)
          CALL SZPLL3(VX, VY, VZ)
   10   CONTINUE
      ELSE
        LFLAG=.FALSE.
        DO 20 I=1,N
          IF (U3X(I).EQ.RMISS .OR. U3Y(I).EQ.RMISS
     +                        .OR. U3Z(I).EQ.RMISS) THEN
            LFLAG=.FALSE.
          ELSE IF (LFLAG) THEN
            CALL STFTR3(U3X(I), U3Y(I), U3Z(I), VX, VY, VZ)
            CALL SZPLL3(VX, VY, VZ)
          ELSE
            CALL STFTR3(U3X(I), U3Y(I), U3Z(I), VX, VY, VZ)
            CALL SZMVL3(VX, VY, VZ)
            LFLAG=.TRUE.
          END IF
   20   CONTINUE
      END IF

      CALL SZCLL3

      END

*-----------------------------------------------------------------------
*     UXAXNM : PLOT X-AXIS (SPECIFY NUMBERS)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXAXNM(CSIDE,UX1,N1,UX2,N2)

      REAL      UX1(*),UX2(*)
      CHARACTER CSIDE*1

      LOGICAL   LABEL,LUXCHK


      IF (.NOT.(LUXCHK(CSIDE))) THEN
        CALL MSGDMP('E','UXAXNM','SIDE PARAMETER IS INVALID.')
      END IF

      CALL UXSOFF

      CALL UXPAXS(CSIDE,2)

      IF (N1.GE.1) THEN
        CALL UXPTMK(CSIDE,1,UX1,N1)
      END IF

      IF (N2.GE.1) THEN
        CALL UXPTMK(CSIDE,2,UX2,N2)
        CALL UZLGET('LABELX'//CSIDE,LABEL)
        IF (LABEL) THEN
          CALL UXPNUM(CSIDE,1,UX2,N2)
        END IF
      END IF

      CALL UXROFF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UMPK02

      PARAMETER (NP=14)

      INTEGER   NTR(NP)
      CHARACTER CTTL*32

      DATA NTR /   10,   11,   12,   13,   14,   15,
     +             20,   21,   22,   23,   30,   31,   32,   33/


      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( -ABS(IWS) )

      CALL SLRAT( 2.0, 3.0 )
      CALL SLDIV( 'Y', 2, 3 )

      CALL UMISET( 'INDEXMJ', 1 )
      CALL UMISET( 'ITYPEMN', 1 )

      DO 10 I=1,NP

        CALL GRFRM

*       CALL GRSMPL( 0.0, 90.0, 0.0 )
        CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
        CALL GRSTRN( NTR(I) )
        CALL UMPFIT
        CALL GRSTRF

        CALL SGLSET( 'LCLIP', .TRUE. )
        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( NTR(I), CTTL )
        CALL SGTXZR( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB

        IF ( NTR(I).EQ.23 ) THEN
          CALL GRFRM
          CALL GRFRM
        END IF

   10 CONTINUE

      CALL GRCLS

      END

!-------------------------------------------------
!  CHGlib Module
!-------------------------------------------------
module chglib
  use dcl_common
  contains

    subroutine DclToUpper(ch)                         !文字列を大文字化化する．
      character(len=*), intent(inout) :: ch       !処理する文字列

      call prcopn('DclToUpper')
      call cupper(ch) 
      call prccls('DclToUpper')
    end subroutine
      
    subroutine DclToLower(ch)                         !文字列を小文字化する．
      character(len=*), intent(inout) :: ch       !処理する文字列

      call prcopn('DclToLower')
      call clower(ch) 
      call prccls('DclToLower')
    end subroutine

end module

*-----------------------------------------------------------------------
*     GET EXTERNAL PARAMETER FROM COMMAND LINE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE RPNOPT

      LOGICAL   LPARA
      CHARACTER CPFIX*(*), CP*(*), CPARA*(*)

      LOGICAL   LCHREQ, LFROMC
      CHARACTER CARG*80, CPX*80, CSEP*1, COPT*1, CDIV*1,
     +          CSEPX*1, COPTX*1, CDIVX*1

      EXTERNAL  LCHREQ, LENC, IFROMC, LFROMC, RFROMC

      SAVE

      DATA      CSEPX / '_' /, COPTX / '-' /, CDIVX / '=' /


      CALL OSGENV('DCLENVCHAR',CSEP)
      IF (CSEP.EQ.' ') CSEP=CSEPX

      CALL OSGENV('DCLOPTCHAR',COPT)
      IF (COPT.EQ.' ') COPT=COPTX

      CALL OSGENV('DCLSETCHAR',CDIV)
      IF (CDIV.EQ.' ') CDIV=CDIVX

      RETURN
*-----------------------------------------------------------------------
*     GET INTEGER PARAMETER WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTIOPT(CPFIX, CP, IPARA)

      CPX = COPT//CPFIX(1:LENC(CPFIX))//CSEP//CP

      CALL OSQARN(MAX)
      DO 10 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP.NE.0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            IPARA = IFROMC(CARG(NP+1:LENC(CARG)))
            RETURN
          END IF
        END IF
 10   CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET LOGICAL PARAMETER WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTLOPT(CPFIX, CP, LPARA)

      CPX = COPT//CPFIX(1:LENC(CPFIX))//CSEP//CP

      CALL OSQARN(MAX)
      DO 20 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP .NE .0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            LPARA = LFROMC(CARG(NP+1:LENC(CARG)))
            RETURN
          END IF
        END IF
   20 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET REAL PARAMETER WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTROPT(CPFIX, CP, RPARA)

      CPX = COPT//CPFIX(1:LENC(CPFIX))//CSEP//CP

      CALL OSQARN(MAX)
      DO 30 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP .NE .0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            RPARA = RFROMC(CARG(NP+1:LENC(CARG)))
            RETURN
          END IF
        END IF
   30 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET CHARACTER PARAMETER WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTCOPT(CPFIX, CP, CPARA)

      CPX = COPT//CPFIX(1:LENC(CPFIX))//CSEP//CP

      CALL OSQARN(MAX)
      DO 40 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP .NE. 0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            CPARA = CARG(NP+1:LENC(CARG))
            RETURN
          END IF
        END IF
   40 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET INTEGER PARAMETER WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLIOPT(CP, IPARA)

      CPX = COPT//CP

      CALL OSQARN(MAX)
      DO 50 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP.NE.0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            IPARA = IFROMC(CARG(NP+1:LENC(CARG)))
            RETURN
          END IF
        END IF
   50 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET LOGICAL PARAMETER WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLLOPT(CP, LPARA)

      CPX = COPT//CP

      CALL OSQARN(MAX)
      DO 60 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP.NE.0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            LPARA = LFROMC(CARG(NP+1:LENC(CARG)))
            RETURN
          END IF
        END IF
   60 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET REAL PARAMETER WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLROPT(CP, RPARA)

      CPX = COPT//CP

      CALL OSQARN(MAX)
      DO 70 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP.NE.0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            RPARA = RFROMC(CARG(NP+1:LENC(CARG)))
            RETURN
          END IF
        END IF
   70 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET CHARACTER PARAMETER WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLCOPT(CP, CPARA)

      CPX = COPT//CP

      CALL OSQARN(MAX)
      DO 80 N = 1, MAX
        CALL OSGARG(N, CARG)
        NP = INDEX(CARG, CDIV)
        IF (NP .NE. 0) THEN
          IF (LCHREQ(CARG(1:NP-1), CPX)) THEN
            CPARA = CARG(NP+1:LENC(CARG))
            RETURN
          END IF
        END IF
   80 CONTINUE

      RETURN
      END

!-------------------------------------------------
!interface module of vrblib
!-------------------------------------------------
module vrb_interface
  interface

    subroutine vrfnb(rx,ry,rz,n,jx,jy,jz,rfnb)    !RXとRYにRFNBを作用させてRZに代入する
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      real,      intent(out), dimension(*) :: rz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ry, rzにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
      external rfnb                               !引数が2個である実数型関数名
    end subroutine
      
    subroutine vradd(rx,ry,rz,n,jx,jy,jz)         !RXとRYを加えてRZに代入する
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      real,      intent(out), dimension(*) :: rz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ry, rzにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine
      
    subroutine vrsub(rx,ry,rz,n,jx,jy,jz)         !RXからRYを引いてRZに代入する．
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      real,      intent(out), dimension(*) :: rz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ry, rzにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine
      
    subroutine vrmlt(rx,ry,rz,n,jx,jy,jz)         !RXとRYを掛けてRZに代入する．
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      real,      intent(out), dimension(*) :: rz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ry, rzにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine
      
    subroutine vrdiv(rx,ry,rz,n,jx,jy,jz)         !RXをRYで割ってRZに代入する．
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      real,      intent(out), dimension(*) :: rz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ry, rzにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine

  end interface
end module
!vrblib library end ----

!-------------------------------------------------
!interface module of ugpack
!-------------------------------------------------
module ugpack
  use dcl_common
  contains
!-----------------------------2次元ベクトル場を描く．
    subroutine DclDrawVectors(u,v)
      real, intent(in), dimension(:,:)                 :: u 
      real, intent(in), dimension(size(u,1),size(u,2)) :: v 

      call sgoopn('DclDrawVectors', ' ')
      nx = size(u,1)
      ny = size(u,2)
      call ugvect(u,nx,v,nx,nx,ny)
      call sgocls('DclDrawVectors')
    end subroutine
!-----------------------------ユニットベクトルにつけるタイトルを設定する．
    subroutine DclSetUnitVectorTitle(side,title) 
      character(len=1), intent(in) :: side  !タイトル位置を指定する
      character(len=*), intent(in) :: title  !タイトル

      call prcopn('DclSetUnitVectorTitle')
      call ugsut(side,title) 
      call prccls('DclSetUnitVectorTitle')
    end subroutine
      
end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM ULPK01

      PARAMETER (NBL=2)

      REAL      BL(NBL)
      CHARACTER CTL*64

      DATA      BL/1.0,3.0/


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(-ABS(IWS))

      CALL SGLSET('LFULL',.TRUE.)
      CALL UZFACT(0.7)
      CALL SLRAT(0.75,1.0)
      CALL SLDIV('T',1,7)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.15,200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',1)
      CALL ULXLOG('B',1,9)
      CTL='ULXLOG (IXTYPE=1,NLBL=1,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGLSET('LCNTL',.TRUE.)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.15,200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',1)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=1,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.15,200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',2)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=2,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.15,200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',3)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=3,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.15,200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',4)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=4,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.15,200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULXSFM('(F5.1)')
      CALL ULISET('IXTYPE',3)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=3,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(0.15,200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',1)
      CALL ULISET('IXCHR',194)
      CALL ULSXBL(BL,NBL)
      CALL ULXLOG('B',4,5)
      CTL='ULXLOG (IXTYPE=1,NLBL=4,NTCK=5)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGCLS

      END

program miss02

  use dcl

  integer,parameter :: nx=36, ny=36
  real,parameter :: xmin=0, xmax=360, ymin=-90, ymax=90
  real,parameter :: pi=3.14159, drad=pi/180
  real :: p(0:nx,0:ny)

    call DclGetParm( 'MISSING_REAL', rmiss )
    call DclSetParm( 'INTERPRET_MISSING_VALUE', .true. )

    do j=0,ny
      alat = ( ymin + (ymax-ymin) * j/ny ) * drad
      slat = sin(alat)
      do i=0,nx
        alon = ( xmin + (xmax-xmin) * i/nx ) * drad
        p(i,j) = 3*sqrt(1-slat**2)*slat*cos(alon) - 0.5*(3*slat**2-1)

        if( i==6 .and. j==6 ) then
          p(i,j) = rmiss
        end if
        if( ( 8 <= i .and. i <= 24) .and. j==30 ) then
          p(i,j) = rmiss
        end if
        if( (22 <= i .and. i <= 30) .and. (12 <= j .and. j <= 20) ) then
          p(i,j) = rmiss
        end if
      end do
    end do

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort(  0.2,  0.8,  0.2,  0.8 )
    call DclSetTransFunction

    call DclShadeContour( p )
    call DclDrawScaledAxis
    call DclDrawContour( p )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
      SUBROUTINE CLRGSV(R,G,B,H,S,V,N,M)

      INTEGER R(N,M),G(N,M),B(N,M)
      REAL    H(N,M),S(N,M),V(N,M)
      INTEGER MAX,MIN

      DO 10 I=1,N
      DO 20 J=1,M
      IF ((R(I,J).GE.G(I,J)) .AND.(R(I,J).GE.B(I,J))) THEN
        MAX=R(I,J)
      ELSE IF (G(I,J).GE.B(I,J)) THEN
        MAX=G(I,J)
      ELSE
        MAX=B(I,J)
      ENDIF
      IF (( R(I,J).LE.G(I,J) ) .AND. ( R(I,J).LE.B(I,J))) THEN
        MIN=R(I,J)
      ELSE IF (G(I,J).LE.B(I,J)) THEN
        MIN=G(I,J)
      ELSE
        MIN=B(I,J)
      ENDIF

      IF (MAX.EQ.R(I,J))THEN
        H(I,J) = 60.0 * (G(I,J)-B(I,J))/(MAX-MIN)
      ELSE IF (MAX.EQ.G(I,J))THEN
        H(I,J) = 60.0 * (B(I,J)-R(I,J))/(MAX-MIN) + 120.0
      ELSE
        H(I,J) = 60.0 * (R(I,J)-G(I,J))/(MAX-MIN) + 240.0
      ENDIF

      H(I,J) = MOD(H(I,J),360.0)
      S(I,J) = (MAX-MIN)/MAX
      V(I,J) = (R(I,J) + G(I,J) +B(I,J)) / 3.0
 20   CONTINUE
 10   CONTINUE

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGKSX1


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN( IWS )

*     / FIRST PAGE /

      CALL SGFRM

      CALL SGQWND( UX1, UX2, UY1, UY2 )

      UXC=(UX1+UX2)/2
      UYC=(UY1+UY2)/2

      CALL SGLNZU( UX1, UY1, UX2, UY1, 1 )
      CALL SGLNZU( UX2, UY1, UX2, UY2, 1 )
      CALL SGLNZU( UX2, UY2, UX1, UY2, 1 )
      CALL SGLNZU( UX1, UY2, UX1, UY1, 1 )

      CALL SGTXZU( UXC, UYC, 'SGKS TEST : PAGE 1', 0.03, 0, 0, 3 )

*     / SECOND PAGE /

      CALL SGLSET( 'LFULL', .TRUE. )

      CALL SGFRM

      CALL SGQWND( UX1, UX2, UY1, UY2 )

      UXC=(UX1+UX2)/2
      UYC=(UY1+UY2)/2

      CALL SGLNZU( UX1, UY1, UX2, UY1, 1 )
      CALL SGLNZU( UX2, UY1, UX2, UY2, 1 )
      CALL SGLNZU( UX2, UY2, UX1, UY2, 1 )
      CALL SGLNZU( UX1, UY2, UX1, UY1, 1 )

      CALL SGTXZV( UXC, UYC, 'SGKS TEST : PAGE 2', 0.03, 0, 0, 3 )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZTXOP(RSIZE,IROTA,ICENT,INDEX)

      PARAMETER (WIDE=24)

      CHARACTER COBJ*80

      COMMON    /SZBTX1/ QSIZE,CT,ST,ICENTZ
      COMMON    /SZBTX2/ LCNTL,JSUP,JSUB,JRST,SMALL,SHIFT
      LOGICAL   LCNTL
      COMMON    /SZBTX3/ LCLIP
      LOGICAL   LCLIP

      SAVE


      CALL SGIGET('IFONT',IFONT)

      QSIZE=RSIZE/WIDE
      THETA=RD2R(REAL(IROTA))
      CT=QSIZE*COS(THETA)
      ST=QSIZE*SIN(THETA)

      ICENTZ=ICENT

      CALL SGLGET('LCNTL',LCNTL)
      CALL SGIGET('ISUP',ISUP)
      CALL SGIGET('ISUB',ISUB)
      CALL SGIGET('IRST',IRST)
      CALL SGRGET('SMALL',SMALL)
      CALL SGRGET('SHIFT',SHIFT)
      CALL SGLGET('LCLIP',LCLIP)
      CALL SGIGET('IWS',IWS)

      JSUP=ISUP+1
      JSUB=ISUB+1
      JRST=IRST+1

      CALL SZQIDX(INDEXZ)
      CALL SZSIDX(INDEX)

      WRITE(COBJ,'(F8.5,5I8)') RSIZE,IROTA,ICENT,INDEX,IFONT,IWS
*     WRITE(COBJ,'(F8.5,5I8)') RSIZE,IROTA,ICENT,INDEX,IWS
      CALL CDBLK(COBJ)
      CALL SWOOPN('SZTX',COBJ)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZTXCL

      CALL SZSIDX(INDEXZ)

      CALL SWOCLS('SZTX')

      RETURN
      END

*-----------------------------------------------------------------------
C     SUBROUTINE SINQB(N,X,WSAVE)
C
C     SUBROUTINE SINQB COMPUTES THE FAST FOURIER TRANSFORM OF QUARTER
C     WAVE DATA. THAT IS , SINQB COMPUTES A SEQUENCE FROM ITS
C     REPRESENTATION IN TERMS OF A SINE SERIES WITH ODD WAVE NUMBERS.
C     THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER X.
C
C     SINQF IS THE UNNORMALIZED INVERSE OF SINQB SINCE A CALL OF SINQB
C     FOLLOWED BY A CALL OF SINQF WILL MULTIPLY THE INPUT SEQUENCE X
C     BY 4*N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE SINQB MUST BE
C     INITIALIZED BY CALLING SUBROUTINE SINQI(N,WSAVE).
C
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE ARRAY X TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C
C     X       AN ARRAY WHICH CONTAINS THE SEQUENCE TO BE TRANSFORMED
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             IN THE PROGRAM THAT CALLS SINQB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE SINQI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C
C     OUTPUT PARAMETERS
C
C     X       FOR I=1,...,N
C
C                  X(I)= THE SUM FROM K=1 TO K=N OF
C
C                    4*X(K)*SIN((2K-1)*I*PI/(2*N))
C
C                  A CALL OF SINQB FOLLOWED BY A CALL OF
C                  SINQF WILL MULTIPLY THE SEQUENCE X BY 4*N.
C                  THEREFORE SINQF IS THE UNNORMALIZED INVERSE
C                  OF SINQB.
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT
C             BE DESTROYED BETWEEN CALLS OF SINQB OR SINQF.
C
      SUBROUTINE SINQB (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
C
      IF (N .GT. 1) GO TO 101
      X(1) = 4.*X(1)
      RETURN
  101 NS2 = N/2
      DO 102 K=2,N,2
         X(K) = -X(K)
  102 CONTINUE
      CALL COSQB (N,X,WSAVE)
      DO 103 K=1,NS2
         KC = N-K
         XHOLD = X(K)
         X(K) = X(KC+1)
         X(KC+1) = XHOLD
  103 CONTINUE
      RETURN
      END

*-----------------------------------------------------------------------
*     LOWER LEVEL APPLICATIONS
*-----------------------------------------------------------------------
*     UXPAXS : PLOT HOLIZONTAL LINE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPAXS(CSIDE,ISLCT)

      CHARACTER CSIDE*1

      LOGICAL   LUXCHK,LCHREQ,LCLIPZ
      CHARACTER CSLCT*1


      IF (.NOT.(LUXCHK(CSIDE))) THEN
        CALL MSGDMP('E','UXPAXS','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UXPAXS','''ISLCT'' IS INVALID')
      END IF

      CALL UZRGET('ROFFX'//CSIDE,ROFFX)
      CALL UZRGET('ROFGX'//CSIDE,ROFGX)
      IF (ROFFX.NE.ROFGX) RETURN

      WRITE(CSLCT,'(I1)') ISLCT

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)
      CALL UZIGET('INDEXT'//CSLCT,INDEX)

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        IF (LCHREQ(CSIDE,'B')) THEN
          POSY=UYMN
        ELSE
          POSY=UYMX
        END IF
      ELSE
        CALL UZRGET('UYUSER',POSY)
      END IF

      CALL STFTRF(UXMN,POSY,VX1,VY1)
      CALL STFTRF(UXMX,POSY,VX2,VY2)
      CALL SGLNZV(VX1,VY1+ROFGX,VX2,VY2+ROFGX,INDEX)

      CALL SGLSET('LCLIP',LCLIPZ)

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGLNXU(UX1,UY1,UX2,UY2,INDEX,ICOLOR)

      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGLNXU','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLNXU','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLNXU','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZLNOP(INDEX)
      CALL SZLNZU(UX1,UY1,UX2,UY2)
      CALL SZLNCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
C     SUBROUTINE CFFTB(N,C,WSAVE)
C
C     SUBROUTINE CFFTB COMPUTES THE BACKWARD COMPLEX DISCRETE FOURIER
C     TRANSFORM (THE FOURIER SYNTHESIS). EQUIVALENTLY , CFFTB COMPUTES
C     A COMPLEX PERIODIC SEQUENCE FROM ITS FOURIER COEFFICIENTS.
C     THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER C.
C
C     A CALL OF CFFTF FOLLOWED BY A CALL OF CFFTB WILL MULTIPLY THE
C     SEQUENCE BY N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE CFFTB MUST BE
C     INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C
C     N      THE LENGTH OF THE COMPLEX SEQUENCE C. THE METHOD IS
C            MORE EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES.
C
C     C      A COMPLEX ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C
C     WSAVE   A REAL WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4N+15
C             IN THE PROGRAM THAT CALLS CFFTB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY CFFTF AND CFFTB.
C
C     OUTPUT PARAMETERS
C
C     C      FOR J=1,...,N
C
C                C(J)=THE SUM FROM K=1,...,N OF
C
C                      C(K)*EXP(I*(J-1)*(K-1)*2*PI/N)
C
C                            WHERE I=SQRT(-1)
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SUBROUTINE CFFTF OR CFFTB
C
      SUBROUTINE CFFTB (N,C,WSAVE)
      DIMENSION       C(*)       ,WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      IW1 = N+N+1
      IW2 = IW1+N+N
      CALL CFFTB1 (N,C,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

!-------------------------------------------------
!  MAPlib Module
!-------------------------------------------------
module maplib
  use dcl_common

  contains
!------------------------------------------------- 正距円筒図法
  function DclCylindrical_F(point)  
    type(map), intent(in) :: point
    type(cartesian)       :: DclCylindrical_F

    call prcopn('DclCylindrical_F')
    call mpfcyl(point%lon, point%lat, DclCylindrical_F%x, DclCylindrical_F%y)
    call prccls('DclCylindrical_F')
  end function
!------------------------------------------------- メルカトール図法
  function DclMercator_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclMercator_F

    call prcopn('DclMercator_F')
    call mpfmer(point%lon,point%lat,DclMercator_F%x,DclMercator_F%y)
    call prccls('DclMercator_F')
  end function
!------------------------------------------------- モルワイデ図法
  function DclMollweide_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclMollweide_F

    call prcopn('DclMollweide_F')
    call mpfmwd(point%lon,point%lat,DclMollweide_F%x,DclMollweide_F%y)
    call prccls('DclMollweide_F')
  end function
!------------------------------------------------- モルワイデ図法(もどき)
  function DclMollweideLike_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclMollweideLike_F

    call prcopn('DclMollweideLike_F')
    call mpfmwl(point%lon,point%lat,DclMollweideLike_F%x,DclMollweideLike_F%y)
    call prccls('DclMollweideLike_F')
  end function
!------------------------------------------------- ハンメル図法
  function DclHammer_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclHammer_F

    call prcopn('DclHammer_F')
    call mpfhmr(point%lon,point%lat,DclHammer_F%x,DclHammer_F%y)
    call prccls('DclHammer_F')
  end function
!------------------------------------------------- エッケルト第6図法
  function DclEckert6_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclEckert6_F

    call prcopn('DclEckert6_F')
    call mpfek6(point%lon,point%lat,DclEckert6_F%x,DclEckert6_F%y) 
    call prccls('DclEckert6_F')
  end function
!------------------------------------------------- 北田楕円図法
  function DclKitada_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclKitada_F

    call prcopn('DclKitada_F')
    call mpfktd(point%lon,point%lat,DclKitada_F%x,DclKitada_F%y)
    call prccls('DclKitada_F')
  end function
!------------------------------------------------- ランベルト正積円錐図法
  function DclConicalA_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclConicalA_F

    call prcopn('DclConicalA_F')
    call mpfcoa(point%lon,point%lat,DclConicalA_F%x,DclConicalA_F%y)
    call prccls('DclConicalA_F')
  end function
!------------------------------------------------- 正距円錐図法
  function DclConical_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclConical_F

    call prcopn('DclConical_F')
    call mpfcon(point%lon,point%lat,DclConical_F%x,DclConical_F%y)
    call prccls('DclConical_F')
  end function
!------------------------------------------------- ランベルト正角円錐図法
  function DclConicalC_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclConicalC_F

    call prcopn('DclConicalC_F')
    call mpfcoc(point%lon,point%lat,DclConicalC_F%x,DclConicalC_F%y)
    call prccls('DclConicalC_F')
  end function
!------------------------------------------------- ボンヌ図法
  function DclBonnes_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclBonnes_F

    call prcopn('DclBonnes_F')
    call mpfbon(point%lon,point%lat,DclBonnes_F%x,DclBonnes_F%y) 
    call prccls('DclBonnes_F')
  end function
!------------------------------------------------- 正射図法/satellite view
  function DclOrthographic_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclOrthographic_F

    call prcopn('DclOrthographic_F')
    call mpfotg(point%lon,point%lat,DclOrthographic_F%x,DclOrthographic_F%y) 
    call prccls('DclOrthographic_F')
  end function
!------------------------------------------------- ポーラーステレオ図法
  function DclPolarStereo_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclPolarStereo_F

    call prcopn('DclPolarStereo_F')
    call mpfpst(point%lon,point%lat,DclPolarStereo_F%x,DclPolarStereo_F%y) 
    call prccls('DclPolarStereo_F')
  end function
!------------------------------------------------- 正距方位図法
  function DclAzimuthal_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclAzimuthal_F

    call prcopn('DclAzimuthal_F')
    call mpfazm(point%lon,point%lat,DclAzimuthal_F%x,DclAzimuthal_F%y)
    call prccls('DclAzimuthal_F')
  end function
!------------------------------------------------- ランベルト正積方位図法
  function DclAzimuthalA_F(point)
    type(map), intent(in) :: point
    type(cartesian)       :: DclAzimuthalA_F

    call prcopn('DclAzimuthalA_F')
    call mpfaza(point%lon,point%lat,DclAzimuthalA_F%x,DclAzimuthalA_F%y)
    call prccls('DclAzimuthalA_F')
  end function
    
!===========================================================
!------------------------------------------------- 正距円筒図法
  function DclCylindrical_B(point) 
    type(cartesian), intent(in) :: point
    type(map)                   :: DclCylindrical_B

    call prcopn('DclCylindrical_B')
    call mpicyl(point%x,point%y,DclCylindrical_B%lon,DclCylindrical_Blat)
    call prccls('DclCylindrical_B')
  end function
!------------------------------------------------- メルカトール図法
  function DclMercator_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclMercator_B

    call prcopn('DclMercator_B')
    call mpimer(point%x,point%y,DclMercator_B%lon,DclMercator_B%lat)
    call prccls('DclMercator_B')
  end function
!------------------------------------------------- モルワイデ図法
  function DclMollweide_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclMollweide_B

    call prcopn('DclMollweide_B')
    call mpimwd(point%x,point%y,DclMollweide_B%lon,DclMollweide_B%lat)
    call prccls('DclMollweide_B')
  end function
!------------------------------------------------- モルワイデ図法（もどき）
  function DclMollweideLike_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclMollweideLike_B

    call prcopn('DclMollweideLike_B')
    call mpimwl(point%x,point%y,DclMollweideLike_B%lon,DclMollweideLike_B%lat)
    call prccls('DclMollweideLike_B')
  end function
!------------------------------------------------- ハンメル図法
  function DclHammer_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclHammer_B

    call prcopn('DclHammer_B')
    call mpihmr(point%x,point%y,DclHammer_B%lon,DclHammer_B%lat)
    call prccls('DclHammer_B')
  end function
 !------------------------------------------------- エッケルト第6図法
  function DclEckert6_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclEckert6_B

    call prcopn('DclEckert6_B')
    call mpiek6(point%x,point%y,DclEckert6_B%lon,DclEckert6_B%lat)
    call prccls('DclEckert6_B')
  end function
!------------------------------------------------- 北田楕円図法
  function DclKitada_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclKitada_B

    call prcopn('DclKitada_B')
    call mpiktd(point%x,point%y,DclKitada_B%lon,DclKitada_B%lat)
    call prccls('DclKitada_B')
  end function
!------------------------------------------------- 正距円錐図法
  function DclConical_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclConical_B

    call prcopn('DclConical_B')
    call mpicon(point%x,point%y,DclConical_B%lon,DclConical_B%lat)
    call prccls('DclConical_B')
  end function
!------------------------------------------------- ランベルト正積円錐図法
  function DclConicalA_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclConicalA_B

    call prcopn('DclConicalA_B')
    call mpicoa(point%x,point%y,DclConicalA_B%lon,DclConicalA_B%lat)
    call prccls('DclConicalA_B')
  end function
!------------------------------------------------- ランベルト正角円錐図法
  function DclConicalC_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclConicalC_B

    call prcopn('DclConicalC_B')
    call mpicoc(point%x,point%y,DclConicalC_B%lon,DclConicalC_B%lat)
    call prccls('DclConicalC_B')
  end function
!------------------------------------------------- ボンヌ図法
  function DclBonnes_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclBonnes_B

    call prcopn('DclBonnes_B')
    call mpibon(point%x,point%y,DclBonnes_B%lon,DclBonnes_B%lat) 
    call prccls('DclBonnes_B')
  end function
!------------------------------------------------- 正射図法および satellite view
  function DclOrthographic_B(point) 
    type(cartesian), intent(in) :: point
    type(map)                   :: DclOrthographic_B

    call prcopn('DclOrthographic_B')
    call mpiotg(point%x,point%y,DclOrthographic_B%lon,DclOrthographic_B%lat)  
    call prccls('DclOrthographic_B')
  end function
!------------------------------------------------- ポーラーステレオ図法
  function DclPolarStereo_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclPolarStereo_B

    call prcopn('DclPolarStereo_B')
    call mpipst(point%x,point%y,DclPolarStereo_B%lon,DclPolarStereo_B%lat) 
    call prccls('DclPolarStereo_B')
  end function
!------------------------------------------------- 正距方位図法
  function DclAzimuthal_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclAzimuthal_B

    call prcopn('DclAzimuthal_B')
    call mpiazm(point%x,point%y,DclAzimuthal_B%lon,DclAzimuthal_B%lat)
    call prccls('DclAzimuthal_B')
  end function
!------------------------------------------------- ランベルト正積方位図法
  function DclAzimuthalA_B(point)
    type(cartesian), intent(in) :: point
    type(map)                   :: DclAzimuthalA_B

    call prcopn('DclAzimuthalA_B')
    call mpiaza(point%x,point%y,DclAzimuthalA_B%lon,DclAzimuthalA_B%lat) 
    call prccls('DclAzimuthalA_B')
  end function

!========================================================

  subroutine DclSetConical(lat)         !標準緯線の指定
    real,      intent(in) :: lat

    call prcopn('DclSetConical')
    call mpscon(lat)
    call prccls('DclSetConical')
  end subroutine
    
  subroutine DclSetConicalA(lat)        !標準緯線の指定
    real,      intent(in) :: lat

    call prcopn('DclSetConicalA')
    call mpscoa(lat) 
    call prccls('DclSetConicalA')
  end subroutine
    
  subroutine DclSetConicalC(lat1,lat2) !標準緯線の指定
    real,      intent(in) :: lat1,lat2 
 
    call prcopn('DclSetConicalC')
    call mpscoc(lat1,lat2)
    call prccls('DclSetConicalC')
  end subroutine
    
  subroutine DclSetBonnes(lat)          !標準緯線の指定
    real,      intent(in) :: lat

    call prcopn('DclSetBonnes')
    call mpsbon(lat)
    call prccls('DclSetBonnes')
  end subroutine
    
  subroutine DclSetOrthographic(rsat)    !軌道半径の設定
    real,      intent(in) :: rsat

    call prcopn('DclSetOrthographic')
    call mpsotg(rsat)
    call prccls('DclSetOrthographic')
  end subroutine
    
end module

*-----------------------------------------------------------------------
*     COMMON SETTING FOR LINE SEGMENT
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZSLTI(ITYPE,INDEX)

      COMMON    /SZBLS1/ LLNINT,LGCINT,RDXR,RDYR
      LOGICAL   LLNINT,LGCINT
      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP
      COMMON    /SZBLS3/ LCHAZ
      LOGICAL   LCHAZ

      SAVE


      CALL SGLGET('LLNINT',LLNINT)
      CALL SGLGET('LGCINT',LGCINT)
      CALL SGRGET('RDX',RDX)
      CALL SGRGET('RDY',RDY)
      CALL SGLGET('LCLIP',LCLIP)
      CALL SGLGET('LCHAR',LCHAZ)
      CALL STFRAD(RDX, RDY, RDXR, RDYR)

      CALL SZSIDX(INDEX)
      CALL SZSTYP(ITYPE)

      END

*-----------------------------------------------------------------------
*     CLIPPING ON TC - Y
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPCLY(TX0, TY0, TX1, TY1, LVALID, LBOUND)

      PARAMETER (EPSIL=1.E-5)

      REAL      YB(2), XX(2), YY(2)
      LOGICAL   LVALID, LBOUND, LCONT, LIN0, LIN1, LRLTA, LRLEA

      EXTERNAL  LRLTA, LRLEA

      SAVE


      IF (LBOUND) THEN
        IF ( LRLTA(TY0, YB(1), EPSIL)) THEN
          IB0 = 1
        ELSE IF ( LRLTA(YB(2), TY0, EPSIL)) THEN
          IB0 = 2
        ELSE
          IB0 = 0
        END IF

        IF ( LRLTA(TY1, YB(1), EPSIL)) THEN
          IB1 = 1
        ELSE IF ( LRLTA(YB(2), TY1, EPSIL)) THEN
          IB1 = 2
        ELSE
          IB1 = 0
        END IF
      ELSE
        IF ( LRLEA(TY0, YB(1), EPSIL)) THEN
          IB0 = 1
        ELSE IF ( LRLEA(YB(2), TY0, EPSIL)) THEN
          IB0 = 2
        ELSE
          IB0 = 0
        END IF

        IF ( LRLEA(TY1, YB(1), EPSIL)) THEN
          IB1 = 1
        ELSE IF ( LRLEA(YB(2), TY1, EPSIL)) THEN
          IB1 = 2
        ELSE
          IB1 = 0
        END IF
      END IF

      LIN0 =  IB0.EQ.0
      LIN1 =  IB1.EQ.0
      LVALID = LIN0.OR.LIN1

      IF (LVALID) THEN
        IF (LIN0 .AND. LIN1) THEN
          XX(2) = TX1
          YY(2) = TY1
          N = 2
          RETURN

        ELSE
          IF (.NOT.LIN0) THEN
            CALL SZSGCL(TX1, TY1, TX0, TY0)
            YY(1) = YB(IB0)
            CALL SZQGCX(YY(1), XX(1))
            XX(2) = TX1
            YY(2) = TY1
            N = 1
          END IF

          IF (.NOT.LIN1) THEN
            CALL SZSGCL(TX0, TY0, TX1, TY1)
            YY(2) = YB(IB1)
            CALL SZQGCX(YY(2), XX(2))
            N=2
          END IF

        END IF
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZGCLY(TX, TY, LCONT)

      LCONT = N.EQ.1
      TX = XX(N)
      TY = YY(N)
      N  = N + 1

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSCLY(YBND1, YBND2)

      YB(1) = YBND1
      YB(2) = YBND2

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQCLY(YBND1, YBND2)

      YBND1 = YB(1)
      YBND2 = YB(2)

      RETURN
      END

!-------------------------------------------------
!interface module of chklib
!-------------------------------------------------
module chk_interface
  interface

    function lchrb(c)                             !空白かどうかを判別する．
      character(len=1), intent(in) :: c           !文字種類を調べる長さ1の文字型の引数
      logical lchrb                               !c が空白なら .true., そうでなければ.false.を返す論理型関数値
    end function
      
    function lchrc(c)                             !通貨記号かどうかを判別する
      character(len=1), intent(in) :: c           !文字種類を調べる長さ1の文字型の引数
      logical lchrc                               !c が通貨記号なら .true., そうでなければ.false.を返す論理型関数値
    end function
      
    function lchrs(c)                             !特殊文字かどうかを判別する
      character(len=1), intent(in) :: c           !文字種類を調べる長さ1の文字型の引数
      logical lchrs                               !c が特殊文字なら .true., そうでなければ.false.を返す論理型関数値．
    end function
      
    function lchrl(c)                             !英字かどうかを判別する
      character(len=1), intent(in) :: c           !文字種類を調べる長さ1の文字型の引数
      logical lchrl                               !c が英字なら .true., そうでなければ.false.を返す論理型関数値．
    end function
      
    function lchrd(c)                             !数字かどうかを判別する
      character(len=1), intent(in) :: c           !文字種類を調べる長さ1の文字型の引数
      logical lchrd                               !c が数字なら .true., そうでなければ.false.を返す論理型関数値
    end function
      
    function lchra(c)                             !英数字かどうかを判別する
      character(len=1), intent(in) :: c           !文字種類を調べる長さ1の文字型の引数
      logical lchra                               !c が英数字なら .true., そうでなければ.false.を返す論理型関数値
    end function
      
    function lchrf(c)                             !fortran文字かどうかを判別する
      character(len=1), intent(in) :: c           !文字種類を調べる長さ1の文字型の引数
      logical lchrf                               !c がfortran文字なら .true., そうでなければ.false.を返す論理型関数値
    end function
      
    function lchr(char,cref)                      !文字列の種類を判別する． 調べる文字列の種類は，テンプレートとして別の文字列で与える．
      character(len=*), intent(in) :: char        !文字種類を調べる文字列
      character(len=*), intent(in) :: cref        !文字列の種類を与えるテンプレート文字列
      logical lchr                                !charがcrefで指定した 文字種と一致していれば.true., そうでなければ .false.を返す論理型関数値
    end function

  end interface
end module
!chklib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVERBZ(N,UPX,UPY1,UPY2,ITYPE,INDEX,RSIZE)

      REAL      UPX(*),UPY1(*),UPY2(*)

      LOGICAL   LMISS, LXUNI
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      COMMON    /SZBTX3/ LCLIPT
      LOGICAL   LCLIP, LCLIPT


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UVERBZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UVERBZ','LINE TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UVERBZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UVERBZ','LINE INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UVERBZ','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UVERBZ','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      LCLIPT = LCLIP
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      IF (UPY1(1).EQ.RUNDEF .OR. UPY2(1).EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'UVERBZ',
     #       'RUNDEF CAN NOT BE UESED FOR UPY1 OR UPY2')
      END IF

      WRITE(COBJ,'(2I8,F8.5)') ITYPE, INDEX, RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVERBZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)

      LXUNI = UPX(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/(N-1)
      END IF

      DO 20 I=1,N
        IF (LXUNI) THEN
          UXX = UXMIN + DX*(I-1)
        ELSE
          UXX = UPX(I)
        END IF

        IF (.NOT.
     #     ((UXX.EQ.RMISS .OR. UPY1(I).EQ.RMISS .OR. UPY2(I).EQ.RMISS)
     #     .AND. LMISS)) THEN

          CALL STFTRF(UXX, UPY1(I), VXX, VY1)
          CALL STFTRF(UXX, UPY2(I), VXX, VY2)

          CALL SZOPLV
          CALL SZMVLV(VXX, VY1)
          CALL SZPLLV(VXX, VY2)
          CALL SZCLLV

          CALL SZOPSV
          CALL SZMVSV(VXX-RSIZE/2., VY2)
          CALL SZPLSV(VXX+RSIZE/2., VY2)
          CALL SZMVSV(VXX-RSIZE/2., VY1)
          CALL SZPLSV(VXX+RSIZE/2., VY1)
          CALL SZCLSV
        END IF
   20 CONTINUE

      CALL SWOCLS('UVERBZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      REAL FUNCTION RFROMC(CX)

      CHARACTER CX*(*)

      CHARACTER CMSG*80

*     EXTERNAL  LENY,LENZ,INDXMF,IFROMC,FFROMC
      EXTERNAL  LENZ,INDXMF,IFROMC,FFROMC


*     LC1=LENY(CX)+1
      LC2=LENZ(CX)

      IF (LC2.EQ.0) THEN
        CMSG='THERE IS NO VALID CHARACTER.'
        CALL MSGDMP('E','FFROMC',CMSG)
      END IF

      IEXP=INDXMF(CX,LC2,1,'E')

      IF (IEXP.EQ.0) THEN
        RFROMC=FFROMC(CX)
      ELSE
        RFROMC=FFROMC(CX(1:IEXP-1))*10.0**IFROMC(CX(IEXP+1:LC2))
      END IF
          
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLDIV(CFORM,IX,IY)

      CHARACTER CFORM*(*)

      LOGICAL   LCHREQ
      CHARACTER CF1*1

      COMMON    /SLBLK1/ XMIN,XMAX,YMIN,YMAX,NN
      PARAMETER (MAXFR=1000,MAXLEV=3)
      INTEGER   NN(0:MAXLEV)
      REAL      XMIN(MAXFR),XMAX(MAXFR),YMIN(MAXFR),YMAX(MAXFR)

      EXTERNAL  LCHREQ,ISUM0

      SAVE


      CF1=CFORM(1:1)
      IF (.NOT.(LCHREQ(CF1,'T') .OR. LCHREQ(CF1,'Y')
     +     .OR. LCHREQ(CF1,'L') .OR. LCHREQ(CF1,'S'))) THEN
        CALL MSGDMP('E','SLDIV ','DIVISION DIRECTION IS INVALID.')
      END IF

      CALL SGIGET('NLEVEL',LEV)

      IF (LEV.GE.MAXLEV) THEN
        CALL MSGDMP('E','SLDIV ',
     +    'NUMBER OF DIVISION IS IN EXCESS OF MUXIMUM.')
      END IF

      LEV=LEV+1
      NXY=IX*IY
      NN(LEV)=NXY*NN(LEV-1)
      ND=ISUM0(NN,LEV+1,1)
      IF (ND.GT.MAXFR) THEN
        CALL MSGDMP('E','SLDIV ',
     +    'TOTAL FRAME NUMBER IS IN EXCESS OF MAXIMUM.')
      END IF

      L1=ISUM0(NN,LEV-1,1)+1
      L2=ISUM0(NN,LEV,1)
      LN=L2+1-NXY
      DO 10 LI=L1,L2
        LN=LN+NXY
        CALL SLDIVZ(XMIN(LI),XMAX(LI),YMIN(LI),YMAX(LI),CFORM,IX,IY,
     +              XMIN(LN),XMAX(LN),YMIN(LN),YMAX(LN))
   10 CONTINUE

      CALL SGISET('NLEVEL',LEV)

      END

*-----------------------------------------------------------------------
*     UZPQNP / UZPQID / UZPQCP / UZPQVL / UZPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UZPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 68)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'UXUSER  ' /, ITYPE( 1) / 3 /
      DATA      CPARAS( 2) / 'UYUSER  ' /, ITYPE( 2) / 3 /

      DATA      CPARAS( 3) / 'ROFFXB  ' /, ITYPE( 3) / 3 /
      DATA      CPARAS( 4) / 'ROFFXT  ' /, ITYPE( 4) / 3 /
      DATA      CPARAS( 5) / 'ROFFXU  ' /, ITYPE( 5) / 3 /
      DATA      CPARAS( 6) / 'ROFFYL  ' /, ITYPE( 6) / 3 /
      DATA      CPARAS( 7) / 'ROFFYR  ' /, ITYPE( 7) / 3 /
      DATA      CPARAS( 8) / 'ROFFYU  ' /, ITYPE( 8) / 3 /

      DATA      CPARAS( 9) / 'ROFGXB  ' /, ITYPE( 9) / 3 /
      DATA      CPARAS(10) / 'ROFGXT  ' /, ITYPE(10) / 3 /
      DATA      CPARAS(11) / 'ROFGXU  ' /, ITYPE(11) / 3 /
      DATA      CPARAS(12) / 'ROFGYL  ' /, ITYPE(12) / 3 /
      DATA      CPARAS(13) / 'ROFGYR  ' /, ITYPE(13) / 3 /
      DATA      CPARAS(14) / 'ROFGYU  ' /, ITYPE(14) / 3 /

      DATA      CPARAS(15) / 'LABELXB ' /, ITYPE(15) / 2 /
      DATA      CPARAS(16) / 'LABELXT ' /, ITYPE(16) / 2 /
      DATA      CPARAS(17) / 'LABELXU ' /, ITYPE(17) / 2 /
      DATA      CPARAS(18) / 'LABELYL ' /, ITYPE(18) / 2 /
      DATA      CPARAS(19) / 'LABELYR ' /, ITYPE(19) / 2 /
      DATA      CPARAS(20) / 'LABELYU ' /, ITYPE(20) / 2 /
      DATA      CPARAS(21) / 'IROTLXB ' /, ITYPE(21) / 1 /
      DATA      CPARAS(22) / 'IROTLXT ' /, ITYPE(22) / 1 /
      DATA      CPARAS(23) / 'IROTLXU ' /, ITYPE(23) / 1 /
      DATA      CPARAS(24) / 'IROTLYL ' /, ITYPE(24) / 1 /
      DATA      CPARAS(25) / 'IROTLYR ' /, ITYPE(25) / 1 /
      DATA      CPARAS(26) / 'IROTLYU ' /, ITYPE(26) / 1 /

      DATA      CPARAS(27) / 'IROTCXB ' /, ITYPE(27) / 1 /
      DATA      CPARAS(28) / 'IROTCXT ' /, ITYPE(28) / 1 /
      DATA      CPARAS(29) / 'IROTCXU ' /, ITYPE(29) / 1 /
      DATA      CPARAS(30) / 'IROTCYL ' /, ITYPE(30) / 1 /
      DATA      CPARAS(31) / 'IROTCYR ' /, ITYPE(31) / 1 /
      DATA      CPARAS(32) / 'IROTCYU ' /, ITYPE(32) / 1 /

      DATA      CPARAS(33) / 'ICENTXB ' /, ITYPE(33) / 1 /
      DATA      CPARAS(34) / 'ICENTXT ' /, ITYPE(34) / 1 /
      DATA      CPARAS(35) / 'ICENTXU ' /, ITYPE(35) / 1 /
      DATA      CPARAS(36) / 'ICENTYL ' /, ITYPE(36) / 1 /
      DATA      CPARAS(37) / 'ICENTYR ' /, ITYPE(37) / 1 /
      DATA      CPARAS(38) / 'ICENTYU ' /, ITYPE(38) / 1 /

      DATA      CPARAS(39) / 'INDEXT0 ' /, ITYPE(39) / 1 /
      DATA      CPARAS(40) / 'INDEXT1 ' /, ITYPE(40) / 1 /
      DATA      CPARAS(41) / 'INDEXT2 ' /, ITYPE(41) / 1 /

      DATA      CPARAS(42) / 'INDEXL0 ' /, ITYPE(42) / 1 /
      DATA      CPARAS(43) / 'INDEXL1 ' /, ITYPE(43) / 1 /
      DATA      CPARAS(44) / 'INDEXL2 ' /, ITYPE(44) / 1 /

      DATA      CPARAS(45) / 'RSIZET0 ' /, ITYPE(45) / 3 /
      DATA      CPARAS(46) / 'RSIZET1 ' /, ITYPE(46) / 3 /
      DATA      CPARAS(47) / 'RSIZET2 ' /, ITYPE(47) / 3 /

      DATA      CPARAS(48) / 'RSIZEL0 ' /, ITYPE(48) / 3 /
      DATA      CPARAS(49) / 'RSIZEL1 ' /, ITYPE(49) / 3 /
      DATA      CPARAS(50) / 'RSIZEL2 ' /, ITYPE(50) / 3 /

      DATA      CPARAS(51) / 'RSIZEC0 ' /, ITYPE(51) / 3 /
      DATA      CPARAS(52) / 'RSIZEC1 ' /, ITYPE(52) / 3 /
      DATA      CPARAS(53) / 'RSIZEC2 ' /, ITYPE(53) / 3 /

      DATA      CPARAS(54) / 'LOFFSET ' /, ITYPE(54) / 2 /
      DATA      CPARAS(55) / 'XOFFSET ' /, ITYPE(55) / 3 /
      DATA      CPARAS(56) / 'YOFFSET ' /, ITYPE(56) / 3 /
      DATA      CPARAS(57) / 'XFACT   ' /, ITYPE(57) / 3 /
      DATA      CPARAS(58) / 'YFACT   ' /, ITYPE(58) / 3 /

      DATA      CPARAS(59) / 'PAD1    ' /, ITYPE(59) / 3 /
      DATA      CPARAS(60) / 'PAD2    ' /, ITYPE(60) / 3 /
      DATA      CPARAS(61) / 'IFLAG   ' /, ITYPE(61) / 1 /
      DATA      CPARAS(62) / 'LBTWN   ' /, ITYPE(62) / 2 /

      DATA      CPARAS(63) / 'RBTWN   ' /, ITYPE(63) / 3 /
      DATA      CPARAS(64) / 'LBOUND  ' /, ITYPE(64) / 2 /
      DATA      CPARAS(65) / 'LBMSG   ' /, ITYPE(65) / 2 /
      DATA      CPARAS(66) / 'INNER   ' /, ITYPE(66) / 1 /

      DATA      CPARAS(67) / 'IUNDEF  ' /, ITYPE(67) / 1 /
      DATA      CPARAS(68) / 'RUNDEF  ' /, ITYPE(68) / 3 /

*     / LONG NAME /

      DATA      CPARAL( 1) / '++++UXUSER  ' /
      DATA      CPARAL( 2) / '++++UYUSER  ' /

      DATA      CPARAL( 3) / '****ROFFXB  ' /
      DATA      CPARAL( 4) / '****ROFFXT  ' /
      DATA      CPARAL( 5) / '****ROFFXU  ' /
      DATA      CPARAL( 6) / '****ROFFYL  ' /
      DATA      CPARAL( 7) / '****ROFFYR  ' /
      DATA      CPARAL( 8) / '****ROFFYU  ' /

      DATA      CPARAL( 9) / '****ROFGXB  ' /
      DATA      CPARAL(10) / '****ROFGXT  ' /
      DATA      CPARAL(11) / '****ROFGXU  ' /
      DATA      CPARAL(12) / '****ROFGYL  ' /
      DATA      CPARAL(13) / '****ROFGYR  ' /
      DATA      CPARAL(14) / '****ROFGYU  ' /

      DATA      CPARAL(15) / 'DRAW_BOTTOM_LABEL' /
      DATA      CPARAL(16) / 'DRAW_TOP_LABEL' /
      DATA      CPARAL(17) / 'DRAW_HORIZONTAL_LABEL' /
      DATA      CPARAL(18) / 'DRAW_LEFT_LABEL' /
      DATA      CPARAL(19) / 'DRAW_RIGHT_LABEL' /
      DATA      CPARAL(20) / 'DRAW_VERTICAL_LABEL' /

      DATA      CPARAL(21) / 'BOTTOM_LABAL_ANGLE' /
      DATA      CPARAL(22) / 'TOP_LABEL_ANGLE' /
      DATA      CPARAL(23) / 'HORIZONTAL_LABEL_ANGLE' /
      DATA      CPARAL(24) / 'LEFT_LABEL_ANGLE' /
      DATA      CPARAL(25) / 'RIGHT_LABEL_ANGLE' /
      DATA      CPARAL(26) / 'VERTICAL_LABEL_ANGLE' /

      DATA      CPARAL(27) / 'BOTTOM_TITLE_ANGLE' /
      DATA      CPARAL(28) / 'TOP_TITLE_ANGLE' /
      DATA      CPARAL(29) / 'HORIZONTAL_TITLE_ANGLE' /
      DATA      CPARAL(30) / 'LEFT_TITLE_ANGLE' /
      DATA      CPARAL(31) / 'RIGHT_TITLE_ANGLE' /
      DATA      CPARAL(32) / 'VERTICAL_TITLE_ANGLE' /

      DATA      CPARAL(33) / 'BOTTOM_LABEL_CENTERING' /
      DATA      CPARAL(34) / 'TOP_LABEL_CENTERING' /
      DATA      CPARAL(35) / 'HORIZONTAL_LABEL_CENTERING' /
      DATA      CPARAL(36) / 'LEFT_LABEL_CENTERING' /
      DATA      CPARAL(37) / 'RIGHT_LABEL_CENTERING' /
      DATA      CPARAL(38) / 'VERTICAL_LABEL_CENTERING' /

      DATA      CPARAL(39) / 'AXIS_LINE_INDEX0' /
      DATA      CPARAL(40) / 'AXIS_LINE_INDEX1' /
      DATA      CPARAL(41) / 'AXIS_LINE_INDEX2' /

      DATA      CPARAL(42) / 'LABEL_INDEX0' /
      DATA      CPARAL(43) / 'LABEL_INDEX1' /
      DATA      CPARAL(44) / 'LABEL_INDEX2' /

      DATA      CPARAL(45) / 'TICK_LENGTH0' /
      DATA      CPARAL(46) / 'TICK_LENGTH1' /
      DATA      CPARAL(47) / 'TICK_LENGTH2' /

      DATA      CPARAL(48) / 'LABEL_HEIGHT0' /
      DATA      CPARAL(49) / 'LABEL_HEIGHT1' /
      DATA      CPARAL(50) / 'LABEL_HEIGHT2' /

      DATA      CPARAL(51) / 'TITLE_HEIGHT0' /
      DATA      CPARAL(52) / 'TITLE_HEIGHT1' /
      DATA      CPARAL(53) / 'TITLE_HEIGHT2' /

      DATA      CPARAL(54) / 'LINEAR_OFFSET' /
      DATA      CPARAL(55) / 'X_AXIS_OFFSET' /
      DATA      CPARAL(56) / 'Y_AXIS_OFFSET' /
      DATA      CPARAL(57) / 'X_AXIS_FACTOR' /
      DATA      CPARAL(58) / 'Y_AXIS_FACTOR' /

      DATA      CPARAL(59) / '****PAD1    ' /
      DATA      CPARAL(60) / '****PAD2    ' /
      DATA      CPARAL(61) / 'LABEL_SIDE_FOR_USER_AXIS' /
      DATA      CPARAL(62) / 'ENABLE_SPAN_LABELING' /
      DATA      CPARAL(63) / 'SPAN_LABELING_CENTERING' /
      DATA      CPARAL(64) / 'TITLE_OVER_VIEWPORT' /
      DATA      CPARAL(65) / 'TITLE_OVER_VIEWPORT_MESSAGE' /
      DATA      CPARAL(66) / 'TICKMARK_SIDE' /

      DATA      CPARAL(67) / '----IUNDEF  ' /
      DATA      CPARAL(68) / '----RUNDEF  ' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG='PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UZPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UZPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UZPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','UZPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UZIQID(CPARAS(IDX), ID)
          CALL UZIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UZLQID(CPARAS(IDX), ID)
          CALL UZLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UZRQID(CPARAS(IDX), ID)
          CALL UZRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UZPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UZIQID(CPARAS(IDX), ID)
          CALL UZISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UZLQID(CPARAS(IDX), ID)
          CALL UZLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UZRQID(CPARAS(IDX), ID)
          CALL UZRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UZPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE SGPLXV(N,VPX,VPY,ITYPE,INDEX,ICOLOR)

      REAL      VPX(*),VPY(*)
      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGPLXV','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLXV','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPLXV','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPLXV','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPLXV','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZPLOP(ITYPE,INDEX)
      CALL SZPLZV(N,VPX,VPY)
      CALL SZPLCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLMGNZ(XAMIN,XAMAX,YAMIN,YAMAX,XL,XR,YB,YT)


      WXA=XAMAX-XAMIN
      WYA=YAMAX-YAMIN

      IF (WXA.LT.0 .OR. WYA.LT.0) THEN
        CALL MSGDMP('E','SLMGNZ','RECTANGLE DEFINITION IS INVALID.')
      END IF
      IF (XL.LT.0 .OR. XR.LT.0 .OR. YB.LT.0 .OR. YT.LT.0) THEN
        CALL MSGDMP('E','SLMGNZ','MARGIN PARAMETER IS LESS THAN ZERO.')
      END IF
      IF (XL+XR.GE.1.0 .OR. YB+YT.GE.1.0) THEN
        CALL MSGDMP('E','SLMGNZ',
     +    'SUM OF MARGIN PARAMETERS IS LARGER THAN 1.0.')
      END IF

      XAMIN=XAMIN+WXA*XL
      XAMAX=XAMAX-WXA*XR
      YAMIN=YAMIN+WYA*YB
      YAMAX=YAMAX-WYA*YT

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMBNDC(XMIN, XMAX, YMIN, YMAX)

      PARAMETER (NMAX = 360)

      EXTERNAL  RFPI


      CALL GLRGET('RUNDEF', RUNDEF)

      CALL UMQCWD(XCNTR, YCNTR, R)

      IF (XCNTR.EQ.RUNDEF .OR. YCNTR.EQ.RUNDEF .OR.
     +        R.EQ.RUNDEF ) RETURN

      CALL STFRAD(R, R, RR, RR)
      CALL STFRAD(XCNTR, YCNTR, UXC,   UYC)
      CALL STFROT(UXC,   UYC,   TXC,   TYC)

      IF (XMIN.EQ.RUNDEF) THEN
        CALL STFTRN(TXC,   TYC,   XMIN,  YMIN)
        XMAX = XMIN
        YMAX = YMIN
      END IF

      PI = RFPI()
      PSI0 = PI/2. - TYC
      DT = 2*PI/NMAX

      DO 10 I=1, NMAX
        TH = DT*I-PI
        XX = COS(PSI0)*COS(RR) + SIN(PSI0)*SIN(RR)*COS(TH)
	IF (XX.GE.1) THEN
          PSI = 0.
        ELSE IF (XX.LE.-1) THEN
          PSI = PI
        ELSE
          PSI = ACOS(XX)
        END IF
	
        IF (PSI0.EQ.0 .OR. PSI0.EQ.PI) THEN
          XLM = TH
	ELSE IF(PSI.EQ.0 .OR. PSI.EQ.PI) THEN
          XLM = 0.
        ELSE
          XX = (COS(RR)-COS(PSI)*COS(PSI0))/(SIN(PSI)*SIN(PSI0))
          IF (XX.GE.1) THEN
            XLM = 0
          ELSE IF (XX.LE.-1) THEN
            XLM = PI
          ELSE
            XLM = ACOS(XX)
          END IF
	  XLM = SIGN(XLM,TH)
        END IF
	
        TX = XMPLON(TXC + XLM)
	TY = PI/2. - PSI

	CALL STFTRN(TX, TY, VX, VY)
        XMAX = MAX (XMAX, VX)
        XMIN = MIN (XMIN, VX)
        YMAX = MAX (YMAX, VY)
        YMIN = MIN (YMIN, VY)
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UBPLZU(N,UPX,UPY,ITYPE,INDEX,CHARX,RSIZE)

      REAL      UPX(*),UPY(*)
      CHARACTER CHARX*(*)

      LOGICAL   LCHAR


      CALL MSGDMP('M','UBPLZU','THIS IS OLD INTERFACE - USE SGPLZU !')

      CALL SGLGET('LCHAR',LCHAR)
      CALL SGLSET('LCHAR',.TRUE.)

      CALL SGSPLC(CHARX)
      CALL SGSPLS(RSIZE)

      CALL SGPLZU(N,UPX,UPY,ITYPE,INDEX)

      CALL SGLSET('LCHAR',LCHAR)

      END

*-----------------------------------------------------------------------
*     TMSTLN : THE ROUTINE FOR DRAWING STREAM LINES
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD DENNOU CLUB. ALL RIGHTS RESERVED.
*-----------------------------------------------------------------------
      SUBROUTINE TMSTLN( X, Y, U, V, NX, NY, TRX, TRY, TOTNM )

      IMPLICIT NONE

*-- AGREENMENT
      INTEGER NX                  !* GRID NUMBERS FOR X-DIRECTION
      INTEGER NY                  !* GRID NUMBERS FOR Y-DIRECTION
      REAL    U(NX,NY)            !* VECTOR COMPONENT OF X-DIRECTION
      REAL    V(NX,NY)            !* VECTOR COMPONENT OF Y-DIRECTION
      REAL    X(NX)               !* GRID POINTS OF X-DIRECTION [UNIT:LENGTH]
      REAL    Y(NY)               !* GRID POINTS OF Y-DIRECTION [UNIT:LENGTH]
      REAL    TRX(NX*NY,2)        !* STREAM LINE OF X-COORDINATE
      REAL    TRY(NX*NY,2)        !* STREAM LINE OF Y-COORDINATE
      INTEGER TOTNM(NX*NY,2)      !* ARRAY NUMBER IN TOTAL STREAM LINES AT END

*-- INTERNAL VARIABLES
      INTEGER I, J, JD, K, L    !* TMP VALUES
      INTEGER COUNTER           !* NUMBER OF STREAM LINE
      INTEGER DCOUNTER          !* NUMBER OF STREAM LINE FOR DRAWING
      INTEGER NM(NX*NY,2)         !* ARRAY NUMBER IN EACH STREAM LINE
      INTEGER GRID_NUM(NX,NY)
      INTEGER ICOUNTER
      INTEGER DICOUNTER
      INTEGER TMPCOUNTER
      INTEGER THRES
      INTEGER SKIP
      INTEGER GLIM
      INTEGER NXBOUND(2)          !* BOUNDARY GRID NUMBER OF X COMPONENT
      INTEGER NYBOUND(2)          !* BOUNDARY GRID NUMBER OF Y COMPONENT
      REAL    ARROW_THRES
      REAL    DT
      REAL    DTX, DTY
      REAL    UNDEF             !* UNDEFINED VALUE FOR DCL
      REAL    TMPRX(NX*NY,2)
      REAL    TMPRY(NX*NY,2)
      REAL    TMPX(NX*NY)
      REAL    TMPY(NX*NY)
      CHARACTER(10) RCHARC
      CHARACTER(3)  ICHARC
      LOGICAL PFX, PFY, DTV

      CALL GLRGET( 'RMISS', UNDEF )

*-- GETTING TMPACK'S PARAMETERS
      CALL TMIGET( 'STLNGLIM', GLIM )
      CALL TMIGET( 'GRDTHRES', THRES )
      CALL TMIGET( 'SKIPINTV', SKIP )
      CALL TMRGET( 'ARRWINTV', ARROW_THRES )
      CALL TMLGET( 'PERIODX', PFX )
      CALL TMLGET( 'PERIODY', PFY )
      CALL TMLGET( 'FIXEDDT', DTV )
      CALL TMRGET( 'STLNDT', DT )
*      CALL TMVGET( THRES, SKIP, ARROW_THRES )  !* STPACK GETTING ROUTINE

      NXBOUND(1)=1
      NXBOUND(2)=NX
      NYBOUND(1)=1
      NYBOUND(2)=NY

      TRX(1:NX*NY,1:2)=0.0
      TRY(1:NX*NY,1:2)=0.0
      TOTNM(1:NX*NY,1:2)=0
      NM(1:NX*NY,1:2)=0

*-- CHECKING VARYING DT
      IF(DT.EQ.0.0)THEN
         DTV=.FALSE.
         CALL TMLSET( 'FIXEDDT', .FALSE. )
      END IF

*-- INITIALIZING GRID_NUM (COUNTER FOR PASSING STREAM LINES IN EACH GRID)
*-- 格子点通過流線のカウンタ変数を初期化
      DO 11 J=1,NY
         DO 10 I=1,NX
            GRID_NUM(I,J)=0
 10      CONTINUE
 11   CONTINUE

      COUNTER=1
      ICOUNTER=1
      DCOUNTER=1
      DICOUNTER=1

*-- DETERMINING "DT" (DT=DXMIN/VMAX)
*-- 以下で流線計算の際の積分における
*-- CFL 条件のようなものを決定する.
**      MAXV=0.0

**      DO 31 J=1,NY
**         DO 30 I=1,NX
**            IF(U(I,J).NE.UNDEF.AND.V(I,J).NE.UNDEF)THEN
**               VTMP=SQRT(U(I,J)**2+V(I,J)**2)
**               IF(VTMP.GT.MAXV)THEN
**                  MAXV=VTMP
**               END IF
**            END IF
** 30      CONTINUE
** 31   CONTINUE

**      MINR=X(2)-X(1)
**
**      DO 40 I=2,NX
**         XTMP=X(I)-X(I-1)
**         IF(XTMP.LT.MINR)THEN
**            MINR=XTMP
**         END IF
** 40   CONTINUE
**
**      DO 41 J=2,NY
**         XTMP=Y(J)-Y(J-1)
**         IF(XTMP.LT.MINR)THEN
**            MINR=XTMP
**         END IF
** 41   CONTINUE

*-- INITIALIZING

      IF(DT.LE.0.0)THEN
         DO 31 J=2,NY
            DO 30 I=2,NX
               IF(U(I,J).NE.UNDEF.AND.U(I-1,J).NE.UNDEF.AND.
     &            V(I,J).NE.UNDEF.AND.V(I,J-1).NE.UNDEF)THEN
                  IF(U(I,J)+U(I-1,J).NE.0.0)THEN
                     DTX=2.0*abs((X(I)-X(I-1))/(U(I,J)+U(I-1,J)))
                  ELSE
                     DTX=abs(DT)
                  END IF
                  IF(V(I,J)+V(I,J-1).NE.0.0)THEN
                     DTY=2.0*abs((Y(J)-Y(J-1))/(V(I,J)+V(I,J-1)))
                  ELSE
                     DTY=abs(DT)
                  END IF
        
                  IF(DT.NE.0.0)THEN
                     IF(ABS(DT).GT.DTX)THEN
                        DT=DTX
                     END IF
                     IF(ABS(DT).GT.DTY)THEN
                        DT=DTY
                     END IF
                  ELSE
                     IF(DTX.NE.0.0)THEN
                        DT=DTX
                     END IF
                     IF(DTY.NE.0.0)THEN
                        DT=DTY
                     END IF
                  END IF
               END IF
 30         CONTINUE
 31      CONTINUE
      END IF

      CALL MSGDMP( 'M', 'TMSTLN', 'CHECKING EACH PARAMETER' )
      WRITE(ICHARC(1:3),'(I3)') THRES
      CALL MSGDMP( 'M', 'TMSTLN', 'THRES       ===> '//ICHARC(1:3) )
      WRITE(ICHARC(1:3),'(I3)') SKIP
      CALL MSGDMP( 'M', 'TMSTLN', 'SKIP        ===> '//ICHARC(1:3) )
      WRITE(ICHARC(1:3),'(I3)') GLIM
      CALL MSGDMP( 'M', 'TMSTLN', 'GLIM        ===> '//ICHARC(1:3) ) 
      WRITE(RCHARC(1:10),'(1P,E10.3)') ARROW_THRES
      CALL MSGDMP( 'M', 'TMSTLN', 'ARROW THRES ===> '//RCHARC(1:10) )
      WRITE(RCHARC(1:10),'(1P,E10.3)') DT
      CALL MSGDMP( 'M', 'TMSTLN', 'DT          ===> '//RCHARC(1:10) ) 

*-- 以上の擬似 CFL 条件から時間積分ステップを決める.
**      DT=MINR/MAXV

*-- STARTING TO CALCULATE STREAM LINES.
*-- DETERMINING STARTING POINT BY USING A PARAMETER VALUE "SKIP".

*-- [1] 領域境界上を始点として流線計算を行う
*-- 以下の計算は [2] の 61, 60 ループの引数が異なるのみで,
*-- ループ内部の処理は全く同じである.
*-- 161 は X 軸境界, 261 は Y 軸境界を始点とする.
      DO 161 JD=1,2
         J=NYBOUND(JD)
         IF(MOD((J-1),SKIP).EQ.0.OR.J.EQ.NY)THEN
            DO 160 I=1,NX
               IF(MOD((I-1),SKIP).EQ.0.OR.I.EQ.NX)THEN
                  IF(U(I,J).NE.0.0.OR.V(I,J).NE.0.0)THEN  !* 格子点上で風速がゼロなら TMSLCL に入らない.
                     TMPRX(1,1)=X(I)
                     TMPRY(1,1)=Y(J)
                     TMPCOUNTER=COUNTER
                     IF(GRID_NUM(I,J).LE.THRES)THEN
                        DO 162 K=TMPCOUNTER,NX*NY  !* この閾値は取りすぎな気もする.
                           CALL TMRSET( 'STLNDT', ABS(DT) )
                           CALL TMSLCL( TMPRX(1,1), TMPRY(1,1),
     &                                  NX, NY, X, Y, U, V,
     &                                  TMPRX(:,1), TMPRY(:,1),
     &                                  NM(COUNTER,1), GRID_NUM )
                           COUNTER=COUNTER+1

                           !* サブルーチンの返り値へ値を入れる.
                           IF(NM(COUNTER-1,1).GT.1)THEN
                             IF(DCOUNTER.GT.1)THEN
                               TOTNM(DCOUNTER,1)=TOTNM(DCOUNTER-1,1)
     &                                           +NM(COUNTER-1,1)
                               DO 165 L=1,NM(COUNTER-1,1)
                                 TRX(TOTNM(DCOUNTER-1,1)+L,1)=TMPRX(L,1)
                                 TRY(TOTNM(DCOUNTER-1,1)+L,1)=TMPRY(L,1)
 165                           CONTINUE
                             ELSE
                               TOTNM(1,1)=NM(1,1)
                               TRX(1:NM(1,1),1)=TMPRX(1:NM(1,1),1)
                               TRY(1:NM(1,1),1)=TMPRY(1:NM(1,1),1)
                             END IF
                             DCOUNTER=DCOUNTER+1
                           END IF

*-- 流線が用意した配列以上に連続する場合, ここで終わるまで計算させる.
                           IF(NM(COUNTER-1,1).LT.NX*NY)THEN
                              IF(PFX.EQV..TRUE.)THEN  !* 終わっていれば, 周期境界なら境界上が開始点での逆計算へ, 周期境界でなければ次の流線計算へ.
                                IF(I.EQ.1.OR.I.EQ.NX)THEN
                                   GO TO 163
                                ELSE
                                   GO TO 990
                                END IF
                              ELSE
                                 GO TO 990
                              END IF

 990                          IF(PFY.EQV..TRUE.)THEN
                                IF(J.EQ.1.OR.J.EQ.NY)THEN
                                   GO TO 163
                                ELSE
                                   GO TO 160
                                END IF
                              ELSE
                                 GO TO 163  !* 終わっていれば逆向き計算へ.
                              END IF
                           ELSE  !* 用意した配列を越えて流線が続く場合の引き継ぎ
                              TMPRX(1,1)=TMPRX(NX*NY,1)
                              TMPRY(1,1)=TMPRY(NX*NY,1)
                           END IF

                           IF(K.EQ.NX*NY)THEN
                              GO TO 163
                           END IF

                           IF(COUNTER.EQ.NX*NY)THEN
                              GO TO 163
                           ELSE IF(COUNTER.GT.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF

 162                    CONTINUE

*-- CALCULATING INVERSE DIRECTION.
*-- "TMSLCL" CAN CALCULATE FORWARD DIRECTION FOR "DT>0",
*-- BACKWARD DIRECTION FOR "DT<0".
*-- 流線が領域内で開始されているので, 逆向きにも計算する.
*-- DT に負号をつけて逆探査開始.
*-- GRID_NUM(I,J) は前方計算でカウントされているので, このカウントを外しておく
 163                    IF(ICOUNTER.LT.NX*NY)THEN
                           GRID_NUM(I,J)=GRID_NUM(I,J)-1
                           TMPRX(1,2)=X(I)
                           TMPRY(1,2)=Y(J)
                        ELSE
                           CALL MSGDMP( 'W', 'TMSTLN', 
     &                                  'ARRAY WILL BE OVER FLOW.')
                           GO TO 100
                        END IF

                        TMPCOUNTER=ICOUNTER

                        DO 164 K=TMPCOUNTER,NX*NY
                           CALL TMRSET( 'STLNDT', -ABS(DT) )  ! 逆向き計算のため, 負号つき
                           CALL TMSLCL( TMPRX(1,2), 
     &                                  TMPRY(1,2),
     &                                  NX, NY, X, Y, U, V, 
     &                                  TMPX(:), TMPY(:),
     &                                  NM(ICOUNTER,2), GRID_NUM )

*-- 逆計算分を TRX, TRY に格納.
*-- ただし, 逆向き計算なので, 配列は逆から入れる.
                           IF(NM(ICOUNTER,2).GT.1)THEN
                              DO 170 L=1,NM(ICOUNTER,2)
                                 TMPRX(L,2)=TMPX(NM(ICOUNTER,2)-L+1)
                                 TMPRY(L,2)=TMPY(NM(ICOUNTER,2)-L+1)
 170                          CONTINUE

                              !* サブルーチンの返り値へ値を入れる.
                              IF(DICOUNTER.GT.1)THEN
                                TOTNM(DICOUNTER,2)=TOTNM(DICOUNTER-1,2)
     &                                             +NM(ICOUNTER,2)
                                DO 171 L=1,NM(ICOUNTER,2)
                                TRX(TOTNM(DICOUNTER-1,2)+L,2)=TMPRX(L,2)
                                TRY(TOTNM(DICOUNTER-1,2)+L,2)=TMPRY(L,2)
 171                            CONTINUE
                              ELSE
                                TOTNM(1,2)=NM(1,2)
                                TRX(1:NM(1,2),2)=TMPRX(1:NM(1,2),2)
                                TRY(1:NM(1,2),2)=TMPRY(1:NM(1,2),2)
                              END IF
                              DICOUNTER=DICOUNTER+1
                           END IF
                           ICOUNTER=ICOUNTER+1

*-- 流線が用意した配列以上に連続する場合, ここで終わるまで計算させる.
                           IF(NM(ICOUNTER-1,2).LT.NX*NY)THEN
                              GO TO 160  !* 終わっていれば次の流線計算へ
                           ELSE  !* 用意した配列を越えて流線が続く場合の引き継ぎ
                              TMPRX(1,2)=TMPX(NX*NY)
                              TMPRY(1,2)=TMPY(NX*NY)
                           END IF
                           IF(K.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
                           IF(ICOUNTER.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
 164                    CONTINUE
                     END IF
                  END IF
               END IF
 160        CONTINUE
         END IF
 161  CONTINUE

      COUNTER=COUNTER+1
      ICOUNTER=ICOUNTER+1

      DO 261 JD=1,2
         I=NXBOUND(JD)
         DO 260 J=2,NY-1  ! 端領域は上のループで行っている.
            IF(MOD((J-1),SKIP).EQ.0.OR.J.EQ.NY)THEN
               IF(MOD((I-1),SKIP).EQ.0.OR.I.EQ.NX)THEN
                  IF(U(I,J).NE.0.0.OR.V(I,J).NE.0.0)THEN  !* 格子点上で風速がゼロなら TMSLCL に入らない.
                     TMPRX(1,1)=X(I)
                     TMPRY(1,1)=Y(J)
                     TMPCOUNTER=COUNTER
                     IF(GRID_NUM(I,J).LE.THRES)THEN
                        DO 262 K=TMPCOUNTER,NX*NY  !* この閾値は取りすぎな気もする.
                           CALL TMRSET( 'STLNDT', ABS(DT) )
                           CALL TMSLCL( TMPRX(1,1), TMPRY(1,1),
     &                                  NX, NY, X, Y, U, V,
     &                                  TMPRX(:,1), TMPRY(:,1),
     &                                  NM(COUNTER,1), GRID_NUM )
                           COUNTER=COUNTER+1

                           !* サブルーチンの返り値へ値を入れる.
                           IF(NM(COUNTER-1,1).GT.1)THEN
                             IF(DCOUNTER.GT.1)THEN
                               TOTNM(DCOUNTER,1)=TOTNM(DCOUNTER-1,1)
     &                                           +NM(COUNTER-1,1)
                               DO 265 L=1,NM(COUNTER-1,1)
                                 TRX(TOTNM(DCOUNTER-1,1)+L,1)=TMPRX(L,1)
                                 TRY(TOTNM(DCOUNTER-1,1)+L,1)=TMPRY(L,1)
 265                           CONTINUE
                             ELSE
                               TOTNM(1,1)=NM(1,1)
                               TRX(1:NM(1,1),1)=TMPRX(1:NM(1,1),1)
                               TRY(1:NM(1,1),1)=TMPRY(1:NM(1,1),1)
                             END IF
                             DCOUNTER=DCOUNTER+1
                           END IF

*-- 流線が用意した配列以上に連続する場合, ここで終わるまで計算させる.
                           IF(NM(COUNTER-1,1).LT.NX*NY)THEN
                              IF(PFX.EQV..TRUE.)THEN !* 終わっていれば, 周期境界なら境界上が開始点での逆計算へ, 周期境界でなければ次の流線計算へ.
                                IF(I.EQ.1.OR.I.EQ.NX)THEN
                                   GO TO 263
                                ELSE
                                   GO TO 991
                                END IF
                              ELSE
                                 GO TO 991
                              END IF

 991                          IF(PFY.EQV..TRUE.)THEN
                                IF(J.EQ.1.OR.J.EQ.NY)THEN
                                   GO TO 263
                                ELSE
                                   GO TO 260
                                END IF
                              ELSE
                                 GO TO 263  !* 終わっていれば逆向き計算へ.
                              END IF
                           ELSE  !* 用意した配列を越えて流線が続く場合の引き継ぎ
                              TMPRX(1,1)=TMPRX(NX*NY,1)
                              TMPRY(1,1)=TMPRY(NX*NY,1)
                           END IF

                           IF(K.EQ.NX*NY)THEN
                              GO TO 263
                           END IF

                           IF(COUNTER.EQ.NX*NY)THEN
                              GO TO 263
                           ELSE IF(COUNTER.GT.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF

 262                    CONTINUE

*-- CALCULATING INVERSE DIRECTION.
*-- "TMSLCL" CAN CALCULATE FORWARD DIRECTION FOR "DT>0",
*-- BACKWARD DIRECTION FOR "DT<0".
*-- 流線が領域内で開始されているので, 逆向きにも計算する.
*-- DT に負号をつけて逆探査開始.
*-- GRID_NUM(I,J) は前方計算でカウントされているので, このカウントを外しておく
 263                    IF(ICOUNTER.LT.NX*NY)THEN
                           GRID_NUM(I,J)=GRID_NUM(I,J)-1
                           TMPRX(1,2)=X(I)
                           TMPRY(1,2)=Y(J)
                        ELSE
                           CALL MSGDMP( 'W', 'TMSTLN', 
     &                                  'ARRAY WILL BE OVER FLOW.')
                           GO TO 100
                        END IF

                        TMPCOUNTER=ICOUNTER

                        DO 264 K=TMPCOUNTER,NX*NY
                           CALL TMRSET( 'STLNDT', -ABS(DT) )  ! 逆向き計算のため, 負号つき
                           CALL TMSLCL( TMPRX(1,2), 
     &                                  TMPRY(1,2),
     &                                  NX, NY, X, Y, U, V, 
     &                                  TMPX(:), TMPY(:),
     &                                  NM(ICOUNTER,2), GRID_NUM )

*-- 逆計算分を TRX, TRY に格納.
*-- ただし, 逆向き計算なので, 配列は逆から入れる.
                           IF(NM(ICOUNTER,2).GT.1)THEN
                              DO 270 L=1,NM(ICOUNTER,2)
                                 TMPRX(L,2)=TMPX(NM(ICOUNTER,2)-L+1)
                                 TMPRY(L,2)=TMPY(NM(ICOUNTER,2)-L+1)
 270                          CONTINUE

                              !* サブルーチンの返り値へ値を入れる.
                              IF(DICOUNTER.GT.1)THEN
                                TOTNM(DICOUNTER,2)=TOTNM(DICOUNTER-1,2)
     &                                             +NM(ICOUNTER,2)
                                DO 271 L=1,NM(ICOUNTER,2)
                                TRX(TOTNM(DICOUNTER-1,2)+L,2)=TMPRX(L,2)
                                TRY(TOTNM(DICOUNTER-1,2)+L,2)=TMPRY(L,2)
 271                            CONTINUE
                              ELSE
                                TOTNM(1,2)=NM(1,2)
                                TRX(1:NM(1,2),2)=TMPRX(1:NM(1,2),2)
                                TRY(1:NM(1,2),2)=TMPRY(1:NM(1,2),2)
                              END IF
                              DICOUNTER=DICOUNTER+1
                           END IF
                           ICOUNTER=ICOUNTER+1

*-- 流線が用意した配列以上に連続する場合, ここで終わるまで計算させる.
                           IF(NM(ICOUNTER-1,2).LT.NX*NY)THEN
                              GO TO 260  !* 終わっていれば次の流線計算へ
                           ELSE  !* 用意した配列を越えて流線が続く場合の引き継ぎ
                              TMPRX(1,2)=TMPX(NX*NY)
                              TMPRY(1,2)=TMPY(NX*NY)
                           END IF
                           IF(K.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
                           IF(ICOUNTER.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
 264                    CONTINUE
                     END IF
                  END IF
               END IF
            END IF
 260     CONTINUE
 261  CONTINUE

      COUNTER=COUNTER+1
      ICOUNTER=ICOUNTER+1

*-- [2] 領域内部の空白域で流線計算を行う.
*-- GRID_NUM によって, 通過していない格子は検索されているので, 
*-- その格子について SKIP 間隔で流線計算を行う.
      DO 61 J=2,NY-1
         IF(MOD((J-1),SKIP).EQ.0.OR.J.EQ.NY)THEN
            DO 60 I=2,NX-1
               IF(MOD((I-1),SKIP).EQ.0.OR.I.EQ.NX)THEN
                  IF(U(I,J).NE.0.0.OR.V(I,J).NE.0.0)THEN  !* 格子点上で風速がゼロなら TMSLCL に入らない.
                     TMPRX(1,1)=X(I)
                     TMPRY(1,1)=Y(J)
                     TMPCOUNTER=COUNTER
                     IF(GRID_NUM(I,J).LE.THRES)THEN
                        DO 62 K=TMPCOUNTER,NX*NY  !* この閾値は取りすぎな気もする.
                           CALL TMRSET( 'STLNDT', ABS(DT) )
                           CALL TMSLCL( TMPRX(1,1), TMPRY(1,1),
     &                                  NX, NY, X, Y, U, V,
     &                                  TMPRX(:,1), TMPRY(:,1),
     &                                  NM(COUNTER,1), GRID_NUM )
                           COUNTER=COUNTER+1

                           !* サブルーチンの返り値へ値を入れる.
                           IF(NM(COUNTER-1,1).GT.1)THEN
                             IF(DCOUNTER.GT.1)THEN
                               TOTNM(DCOUNTER,1)=TOTNM(DCOUNTER-1,1)
     &                                           +NM(COUNTER-1,1)
                               DO 65 L=1,NM(COUNTER-1,1)
                                 TRX(TOTNM(DCOUNTER-1,1)+L,1)=TMPRX(L,1)
                                 TRY(TOTNM(DCOUNTER-1,1)+L,1)=TMPRY(L,1)
 65                            CONTINUE
                             ELSE
                               TOTNM(1,1)=NM(1,1)
                               TRX(1:NM(1,1),1)=TMPRX(1:NM(1,1),1)
                               TRY(1:NM(1,1),1)=TMPRY(1:NM(1,1),1)
                             END IF
                             DCOUNTER=DCOUNTER+1
                           END IF

*-- 流線が用意した配列以上に連続する場合, ここで終わるまで計算させる.
                           IF(NM(COUNTER-1,1).LT.NX*NY)THEN
                              IF(I.NE.1.AND.I.NE.NX.AND.
     &                           J.NE.1.AND.J.NE.NY)THEN
                                 GO TO 63  !* 終わっていれば逆計算へ (開始点が領域内側) .
                              ELSE  !* 終わっていれば, 周期境界なら境界上が開始点での逆計算へ, 周期境界でなければ次の流線計算へ.
                                 IF(PFX.EQV..TRUE.)THEN
                                   IF(I.EQ.1.OR.I.EQ.NX)THEN
                                      GO TO 63
                                   ELSE
                                      GO TO 999
                                   END IF
                                 ELSE
                                    GO TO 999
                                 END IF

 999                             IF(PFY.EQV..TRUE.)THEN
                                   IF(J.EQ.1.OR.J.EQ.NY)THEN
                                      GO TO 63
                                   ELSE
                                      GO TO 60
                                   END IF
                                 ELSE
                                    GO TO 60  !* 終わっていれば次の流線計算へ (開始点が領域境界)
                                 END IF
                              END IF
                           ELSE  !* 用意した配列を越えて流線が続く場合の引き継ぎ
                              TMPRX(1,2)=TMPX(NX*NY)
                              TMPRY(1,2)=TMPY(NX*NY)
                           END IF

                           IF(K.EQ.NX*NY)THEN
                              GO TO 63
                           END IF

                           IF(COUNTER.EQ.NX*NY)THEN
                              GO TO 63
                           ELSE IF(COUNTER.GT.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF

 62                     CONTINUE

*-- CALCULATING INVERSE DIRECTION.
*-- "TMSLCL" CAN CALCULATE FORWARD DIRECTION FOR "DT>0",
*-- BACKWARD DIRECTION FOR "DT<0".
*-- 流線が領域内で開始されているので, 逆向きにも計算する.
*-- DT に負号をつけて逆探査開始.
*-- GRID_NUM(I,J) は前方計算でカウントされているので, このカウントを外しておく
 63                     IF(ICOUNTER.LT.NX*NY)THEN
                           GRID_NUM(I,J)=GRID_NUM(I,J)-1
                           TMPRX(1,2)=X(I)
                           TMPRY(1,2)=Y(J)
                        ELSE
                           CALL MSGDMP( 'W', 'TMSTLN', 
     &                                  'ARRAY WILL BE OVER FLOW.')
                           GO TO 100
                        END IF

                        TMPCOUNTER=ICOUNTER

                        DO 64 K=TMPCOUNTER,NX*NY
                           CALL TMRSET( 'STLNDT', -ABS(DT) )  ! 逆向き計算のため, 負号つき
                           CALL TMSLCL( TMPRX(1,2), TMPRY(1,2),
     &                                  NX, NY, X, Y, U, V, 
     &                                  TMPX(:), TMPY(:),
     &                                  NM(ICOUNTER,2), GRID_NUM )

*-- 逆計算分を TRX, TRY に格納.
*-- ただし, 逆向き計算なので, 配列は逆から入れる.
                           IF(NM(ICOUNTER,2).GT.1)THEN
                              DO 70 L=1,NM(ICOUNTER,2)
                                 TMPRX(L,2)=TMPX(NM(ICOUNTER,2)-L+1)
                                 TMPRY(L,2)=TMPY(NM(ICOUNTER,2)-L+1)
 70                           CONTINUE

                              !* サブルーチンの返り値へ値を入れる.
                              IF(DICOUNTER.GT.1)THEN
                                TOTNM(DICOUNTER,2)=TOTNM(DICOUNTER-1,2)
     &                                             +NM(ICOUNTER,2)
                                DO 71 L=1,NM(ICOUNTER,2)
                                TRX(TOTNM(DICOUNTER-1,2)+L,2)=TMPRX(L,2)
                                TRY(TOTNM(DICOUNTER-1,2)+L,2)=TMPRY(L,2)
 71                             CONTINUE
                              ELSE
                                TOTNM(1,2)=NM(1,2)
                                TRX(1:NM(1,2),2)=TMPRX(1:NM(1,2),2)
                                TRY(1:NM(1,2),2)=TMPRY(1:NM(1,2),2)
                              END IF
                              DICOUNTER=DICOUNTER+1
                           END IF
                           ICOUNTER=ICOUNTER+1

*-- 流線が用意した配列以上に連続する場合, ここで終わるまで計算させる.
                           IF(NM(ICOUNTER-1,2).LT.NX*NY)THEN
                              GO TO 60  !* 終わっていれば次の流線計算へ
                           ELSE  !* 用意した配列を越えて流線が続く場合の引き継ぎ
                              TMPRX(1,2)=TMPX(NX*NY)
                              TMPRY(1,2)=TMPY(NX*NY)
                           END IF
                           IF(K.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
                           IF(ICOUNTER.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
 64                     CONTINUE
                     END IF
                  END IF
               END IF
 60         CONTINUE
         END IF
 61   CONTINUE

 100  CALL MSGDMP( 'M', 'TMSTLN', 'CALCULATING FINISHED.' )

      COUNTER=COUNTER-1

      CALL TMISET( 'STLNNUM', DCOUNTER )

      END SUBROUTINE TMSTLN

*-----------------------------------------------------------------------
*     USPACK AXIS (SPECIFIED MARK)                    S.Sakai  99/10/05
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USAXNM(CSIDE, DTICK, N1, DLABEL, N2)
      PARAMETER (N0 = 200)

      REAL       DTICK(N1), DLABEL(N2), DTZ(N0),DLZ(N0)
      CHARACTER  CSIDE*(*), CS
      EXTERNAL   LENZ
      LOGICAL    LOFF

      CALL UZLGET('LOFFSET', LOFF)
      CALL UZLSET('LOFFSET', .TRUE.)

      NCS = LENZ(CSIDE)
      DO 100 I=1, NCS
        CS = CSIDE(I:I)
        CALL CUPPER(CS)

        IF(CS.EQ.'T' .OR. CS.EQ.'B' .OR. CS.EQ.'H') THEN
          IF(CS.EQ.'H') CS='U'
          CALL USXINZ(CS,FACTOR,OFFSET)

          DO 200 N=1, N1
            DTZ(N) = (DTICK(N)-OFFSET)/FACTOR
  200     CONTINUE
          DO 210 N=1, N2
            DLZ(N) = (DLABEL(N)-OFFSET)/FACTOR
  210     CONTINUE

          CALL UXAXNM(CS, DTZ, N1, DLZ, N2)
          CALL USXTLZ

        ELSEIF(CS.EQ.'L' .OR. CS.EQ.'R' .OR. CS.EQ.'V') THEN
          IF(CS.EQ.'V') CS='U'
          CALL USYINZ(CS,FACTOR,OFFSET)

          DO 300 N=1, N1
            DTZ(N) = (DTICK(N)-OFFSET)/FACTOR
  300     CONTINUE
          DO 310 N=1, N2
            DLZ(N) = (DLABEL(N)-OFFSET)/FACTOR
  310     CONTINUE

          CALL UYAXNM(CS, DTZ, N1, DLZ, N2)
          CALL USYTLZ
        ENDIF

  100 CONTINUE
      CALL UZLSET('LOFFSET', LOFF)

      END

!-------------------------------------------------
!  CHKlib Module
!-------------------------------------------------
module chklib
  use dcl_common
  contains

    function DclCheckBlank(c)             !空白かどうかを判別する．
      character(len=1), intent(in) :: c
      logical DclCheckBlank, lchrb

      call prcopn('DclCheckBlank')
      DclCheckBlank = lchrb(c) 
      call prccls('DclCheckBlank')
    end function
      
    function DclCheckCurrency(c)          !通貨記号かどうかを判別する
      character(len=1), intent(in) :: c
      logical DclCheckCurrency, lchrc

      call prcopn('DclCheckCurrency')
      DclCheckCurrency = lchrc(c)
      call prccls('DclCheckCurrency')
    end function
      
    function DclCheckSpecial(c)           !特殊文字かどうかを判別する
      character(len=1), intent(in) :: c
      logical DclCheckSpecial, lchrs

      call prcopn('DclCheckSpecial')
      DclCheckSpecial = lchrs(c)
      call prccls('DclCheckSpecial')
    end function
      
    function DclCheckAlphabet(c)          !英字かどうかを判別する
      character(len=1), intent(in) :: c 
      logical DclCheckAlphabet, lchrl

      call prcopn('DclCheckAlphabet')
      DclCheckAlphabet = lchrl(c)
      call prccls('DclCheckAlphabet')
    end function
      
    function DclCheckNumber(c)            !数字かどうかを判別する
      character(len=1), intent(in) :: c 
      logical DclCheckNumber, lchrd

      call prcopn('DclCheckNumber')
      DclCheckNumber = lchrd(c) 
      call prccls('DclCheckNumber')
    end function
      
    function DclCheckAlphaNum(c)          !英数字かどうかを判別する
      character(len=1), intent(in) :: c
      logical DclCheckAlphaNum, lchra

      call prcopn('DclCheckAlphaNum')
      DclCheckAlphaNum = lchra(c)
      call prccls('DclCheckAlphaNum')
    end function
      
    function DclCheckFortran(c)           !fortran文字かどうかを判別する
      character(len=1), intent(in) :: c 
      logical DclCheckFortran, lchrf

      call prcopn('DclCheckFortran')
      DclCheckFortran = lchrf(c) 
      call prccls('DclCheckFortran')
    end function
      
    function DclCheckCharPattern(char,cref) !文字列の種類を判別する．
      character(len=*), intent(in) :: char  !文字種類を調べる文字列
      character(len=*), intent(in) :: cref  !文字列の種類を与えるテンプレート文字列
      logical DclCheckCharPattern, lchr

      call prcopn('DclCheckCharPattern')
      DclCheckCharPattern = lchr(char,cref)
      call prccls('DclCheckCharPattern')
    end function

end module

      PROGRAM KIHON6

      PARAMETER( NMAX=50 )
      REAL      X(0:NMAX), Y(0:NMAX)

      R    = 3.7
      X(0) = 1950
      Y(0) = 0.5
      DO 10 N=0,NMAX-1
        X(N+1) = X(N) + 1
        Y(N+1) = R*Y(N)*(1.-Y(N))
   10 CONTINUE

      DO 20 N=0,NMAX
        Y(N) = -4*Y(N) + 20.
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( 1950., 2000., 15., 20. )
      CALL GRSVPT(   0.2,   0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS
      CALL SGPLU( NMAX+1, X, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
      SUBROUTINE UIPDA3(U, V, W, MX, NX, NY)

      PARAMETER (MAXPXL=4000)
      REAL      U(MX, *), V(MX, *), W(MX, *) 
      INTEGER   IMAGE(MAXPXL)

      CALL UIPD3Z(U, V, W, MX, NX, NY, IMAGE, MAXPXL)

      END
*-----------------------------------------------------------------------
      SUBROUTINE UIPD3Z(U, V, W, MX, NX, NY, IMAGE, MAXPXL)

      REAL      U(MX, *), V(MX, *), W(MX, *)
      INTEGER   IMAGE(MAXPXL)
      INTEGER   NS(2), NP(2), NQ(2)
      LOGICAL   LMISS,LIMC,LFCC,LCX,LCY,LCNR
      DATA      NP /1,1/


*     / CHECK IMAGE CAPABILITY /
      CALL SWQIMC(LIMC)
      IF (.NOT.LIMC) THEN
        CALL MSGDMP('E','UIPGR2','NO IMAGE CAPABILITY.')
      END IF

      CALL SWQFCC(LFCC)
      IF (.NOT.LFCC) THEN
        CALL MSGDMP('E','UIPGR2','NO FULL COLOR CAPABILITY.')
      END IF

*     / GET INTERNAL PARAMETERS /

      CALL GLRGET('RUNDEF  ', RUNDEF)
      CALL GLIGET('IUNDEF  ', IUNDEF)
      CALL GLLGET('LMISS   ', LMISS )
      CALL GLRGET('RMISS   ', RMISS )

      CALL UIIGET('ICOLOR1 ', ICOLOR1)
      CALL UIIGET('ICOLOR2 ', ICOLOR2)
      CALL UIIGET('ICOLOR3 ', ICOLOR3)
      CALL UILGET('LCELLX  ', LCX)
      CALL UILGET('LCELLY  ', LCY)
      CALL UILGET('LCORNER ', LCNR)

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      NGX = NX
      NGY = NY
      IF(LCX) NGX = NGX + 1
      IF(LCY) NGY = NGY + 1
      CALL UWDFLT(NGX, NGY)

*     / INITIALIZE /

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      CALL STFPR2(VXMIN, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX1, WY1)
      CALL SWFINT(WX1, WY1, IX1, IY1)

      CALL STFPR2(VXMAX, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX2, WY2)
      CALL SWFINT(WX2, WY2, IX2, IY2)

      CALL STFPR2(VXMAX, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX3, WY3)
      CALL SWFINT(WX3, WY3, IX3, IY3)

      CALL STFPR2(VXMIN, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX4, WY4)
      CALL SWFINT(WX4, WY4, IX4, IY4)

      IXMIN  = MIN(IX1, IX2, IX3, IX4)
      IYMIN  = MIN(IY1, IY2, IY3, IY4)
      IXMAX  = MAX(IX1, IX2, IX3, IX4)
      IYMAX  = MAX(IY1, IY2, IY3, IY4)
      IWIDTH = IXMAX-IXMIN+1
      IHIGHT = IYMAX-IYMIN+1

      CALL SWIOPN(IXMIN, IYMIN, IWIDTH, IHIGHT, 
     +            WX1, WY1, WX2, WY2, WX3, WY3, WX4, WY4)

      NS(1) = MX
      NS(2) = NY
      NQ(1) = NX
      NQ(2) = NY

      UMIN = RVMIN(U, NS, NP, NQ, 2)
      UMAX = RVMAX(U, NS, NP, NQ, 2)
      VMIN = RVMIN(V, NS, NP, NQ, 2)
      VMAX = RVMAX(V, NS, NP, NQ, 2)
      WMIN = RVMIN(W, NS, NP, NQ, 2)
      WMAX = RVMAX(W, NS, NP, NQ, 2)

      CALL UI3INI(UMIN, UMAX, VMIN, VMAX,WMIN,WMAX)

*     / LOOP FOR EACH PIXEL /

      DO 30 J=1, IHIGHT
        DO 20 I=1, IWIDTH

          CALL SWIINT(I+IXMIN-1, J+IYMIN-1, WX, WY)
          CALL STIWTR(WX, WY, RX, RY)
          CALL STIPR2(RX, RY, VX, VY)
          CALL STITRF(VX, VY, UX, UY)

          IF (UX.EQ.RUNDEF) THEN
            IMAGE(I) = ICOLOR1
          ELSE
            CALL UWQGXI(UX,IX,FX)
            CALL UWQGYI(UY,IY,FY)

            IF (IX.EQ.IUNDEF .OR. IY.EQ.IUNDEF) THEN
              IMAGE(I) = ICOLOR2
            ELSE
              IF(LCX .AND. LCY) THEN
                IF (LMISS .AND. 
     +             (U(IX,IY).EQ.RMISS.OR.V(IX,IY).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  CALL UIC3D(U(IX,IY), V(IX,IY), W(IX,IY),IMAGE(I))
                END IF

              ELSE IF(LCX .AND. .NOT.LCY) THEN
                IF (LMISS .AND. 
     +             (U(IX,IY).EQ.RMISS .OR. U(IX,IY+1).EQ.RMISS .OR.
     +              V(IX,IY).EQ.RMISS .OR. V(IX,IY+1).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  UU = U(IX, IY  )*(1-FY) + U(IX  ,IY+1)*FY
                  VV = V(IX, IY  )*(1-FY) + V(IX  ,IY+1)*FY
                  WW = W(IX, IY  )*(1-FY) + W(IX  ,IY+1)*FY
                  CALL UIC3D(UU, VV, WW,IMAGE(I))
                END IF

              ELSE IF(.NOT.LCX .AND. LCY) THEN
                IF (LMISS .AND. 
     +             (U(IX,IY).EQ.RMISS .OR. U(IX+1,IY).EQ.RMISS .OR.
     +              V(IX,IY).EQ.RMISS .OR. V(IX+1,IY).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  UU = U(IX, IY  )*(1-FX) + U(IX+1,IY  )*FX
                  VV = V(IX, IY  )*(1-FX) + V(IX+1,IY  )*FX
                  WW = W(IX, IY  )*(1-FX) + W(IX+1,IY  )*FX
                  CALL UIC3D(UU, VV, WW,IMAGE(I))
                END IF

              ELSE IF(.NOT.LCX .AND. .NOT.LCY) THEN
                IF (.NOT. LMISS .OR. 
     +           (U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND. U(IX+1,IY+1).NE.RMISS .AND.
     +            V(IX,IY  ).NE.RMISS .AND. V(IX+1,IY  ).NE.RMISS .AND.
     +            V(IX,IY+1).NE.RMISS .AND. V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = (U(IX, IY  )*(1-FX) + U(IX+1,IY  )*FX)*(1-FY)
     +               + (U(IX, IY+1)*(1-FX) + U(IX+1,IY+1)*FX)*FY
                  
                  VV = (V(IX, IY  )*(1-FX) + V(IX+1,IY  )*FX)*(1-FY)
     +               + (V(IX, IY+1)*(1-FX) + V(IX+1,IY+1)*FX)*FY
                  
                  WW = (W(IX, IY  )*(1-FX) + W(IX+1,IY  )*FX)*(1-FY)
     +               + (W(IX, IY+1)*(1-FX) + W(IX+1,IY+1)*FX)*FY
                  
                  CALL UIC3D(UU, VV, WW,IMAGE(I))

                ELSE IF(LCNR .AND. (FX+FY).LE.1 .AND.
     +           (U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND.
     +            U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS                            )) THEN

                  UU = U(IX,  IY  )*(1-FX-FY) 
     +               + U(IX+1,IY )*FX + U(IX, IY+1)*FY

                  VV = V(IX,  IY  )*(1-FX-FY) 
     +               + V(IX+1,IY )*FX + V(IX, IY+1)*FY

                  WW = W(IX,  IY  )*(1-FX-FY) 
     +               + W(IX+1,IY )*FX + W(IX, IY+1)*FY

                  CALL UIC3D(UU, VV, WW,IMAGE(I))

                ELSE IF(LCNR .AND. (1-FX+FY).LE.1 .AND.
     +           (U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +                                      U(IX+1,IY+1).NE.RMISS .AND.
     +            V(IX,IY  ).NE.RMISS .AND. V(IX+1,IY  ).NE.RMISS .AND.
     +                                      V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = U(IX+1,IY  )*(FX-FY) 
     +               + U(IX  ,IY )*(1-FX) + U(IX+1, IY+1)*FY

                  VV = V(IX+1,IY  )*(FX-FY) 
     +               + V(IX  ,IY )*(1-FX) + V(IX+1, IY+1)*FY

                  WW = W(IX+1,IY  )*(FX-FY) 
     +               + W(IX  ,IY )*(1-FX) + W(IX+1, IY+1)*FY

                  CALL UIC3D(UU, VV, WW,IMAGE(I))

                ELSE IF(LCNR .AND. (1+FX-FY).LE.1 .AND.
     +           (U(IX,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND. U(IX+1,IY+1).NE.RMISS .AND.
     +            V(IX,IY  ).NE.RMISS .AND.
     +            V(IX,IY+1).NE.RMISS .AND. V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = U(IX  ,IY+1)*(FY-FX) 
     +               + U(IX+1,IY+1)*FX + U(IX, IY)*(1-FY)

                  VV = V(IX  ,IY+1)*(FY-FX) 
     +               + V(IX+1,IY+1)*FX + V(IX, IY)*(1-FY)

                  WW = W(IX  ,IY+1)*(FY-FX) 
     +               + W(IX+1,IY+1)*FX + W(IX, IY)*(1-FY)

                  CALL UIC3D(UU, VV, WW,IMAGE(I))

                ELSE IF(LCNR .AND. (2-FX-FY).LE.1 .AND.
     +           (                          U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND. U(IX+1,IY+1).NE.RMISS .AND.
     +                                      V(IX+1,IY  ).NE.RMISS .AND.
     +            V(IX,IY+1).NE.RMISS .AND. V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = U(IX+1,IY+1)*(FX+FY-1) 
     +               + U(IX  ,IY+1)*(1-FX) + U(IX+1, IY)*(1-FY)

                  VV = V(IX+1,IY+1)*(FX+FY-1) 
     +               + V(IX  ,IY+1)*(1-FX) + V(IX+1, IY)*(1-FY)

                  WW = W(IX+1,IY+1)*(FX+FY-1) 
     +               + W(IX  ,IY+1)*(1-FX) +W(IX+1, IY)*(1-FY)

                  CALL UIC3D(UU, VV, WW,IMAGE(I))

                ELSE
                  IMAGE(I) = ICOLOR3
                END IF
              END IF

            END IF
          END IF
   20   CONTINUE

        CALL SWICLR(IMAGE, IWIDTH)

   30 CONTINUE

      CALL SWICLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UCPK01

      PARAMETER (JD0=19920401)

      CHARACTER CTL*32


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(-ABS(IWS))

      CALL SGLSET('LFULL',.TRUE.)
      CALL UZFACT(0.7)
      CALL SLRAT(0.75,1.0)
      CALL SLDIV('T',1,7)

      CALL SGFRM
      CALL UZINIT
      ND=30
      CALL SGSWND(0.0,REAL(ND),0.0,1.0)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCXACL('B',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=90
      CALL SGSWND(0.0,REAL(ND),0.0,1.0)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCXACL('B',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=180
      CALL SGSWND(0.0,REAL(ND),0.0,1.0)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCXACL('B',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=400
      CALL SGSWND(0.0,REAL(ND),0.0,1.0)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCXACL('B',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=60
      CALL SGSWND(0.0,REAL(ND),0.0,1.0)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCXADY('B',JD0,ND)
      CTL='UCXADY (ND=60)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      ND=120
      CALL SGSWND(0.0,REAL(ND),0.0,1.0)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCXAMN('B',JD0,ND)
      CTL='UCXAMN (ND=120)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      ND=2000
      CALL SGSWND(0.0,REAL(ND),0.0,1.0)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCXAYR('B',JD0,ND)
      CTL='UCXAYR (ND=2000)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UMSPDF : DEFAULT
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMSPDF

      COMMON    /UMWK1/ITR, RUNDEF, IUNDEF, PI, CPR, CPD, CP

      SAVE


      CALL SGQMPL(PLX, PLY, PLROT)
      IF (PLX.NE.RUNDEF .AND. PLY.NE. RUNDEF .AND.
     +    PLROT.NE.RUNDEF ) RETURN

      CALL SGSMPL(0., CPD*90., 0.)

*------------------------ STANDARD LATITUDE ---------------------------

      CALL SGRGET('STLAT1',STLAT1)
      CALL SGRGET('STLAT2',STLAT2)

      IF (ITR.EQ.20 .OR. ITR.EQ.21 .OR. ITR.EQ.23) THEN
        IF (STLAT1 .EQ. RUNDEF) STLAT1 = CPD*35
        CALL SGRSET('STLAT1',STLAT1)
      ELSE IF (ITR .EQ. 22) THEN
        IF (STLAT1 .EQ. RUNDEF) STLAT1 = CPD*35
        IF (STLAT2 .EQ. RUNDEF) STLAT2 = CPD*45
        CALL SGRSET('STLAT1', STLAT1)
        CALL SGRSET('STLAT2', STLAT2)
      END IF

      END

!-------------------------------------------------
!interface module of fiolib
!-------------------------------------------------
module fio_interface
  interface

    subroutine fcopen(iou,cdsn,nrl,cact,icon)     !ファイルをオープンする．
      integer,   intent(in) :: iou                !入出力装置番号
      character(len=*), intent(in) :: cdsn        !ファイル名
      integer,   intent(in) :: nrl                !レコード長
      character(len=1), intent(in) :: cact        !入出力モードの指定
      integer,   intent(in) :: icon               !コンディションコード
    end subroutine
      
    subroutine fcclos(iou,icon)                   !ファイルをクローズする．
      integer,   intent(in) :: iou                !入出力装置番号
      integer,   intent(in) :: icon               !コンディションコード
    end subroutine
      
    subroutine fcslfc(clx)                        !行末の改行文字を設定する．
      character(len=*), intent(in) :: clx         !指定する改行文字
    end subroutine
      
    subroutine fcleol(iou,leol)                   !行末の改行制御をするかどうかを指定する．
      integer,   intent(in) :: iou                !入出力装置番号
      logical,   intent(in) :: leol               !改行制御の指定をする． .true.なら改行制御をする;.false.ならしない
    end subroutine
      
    subroutine fcnrec(iou,nrec)                   !レコード番号を指定する．
      integer,   intent(in) :: iou                !入出力装置番号
      integer,   intent(in) :: nrec               !レコード番号． 1以上の整数値
    end subroutine
      
    subroutine fcgetr(iou,cbuf,icon)              !1レコードを（文字列で）読み込む．
      integer,   intent(in) :: iou                !入出力装置番号
      character(len=*), intent(out) :: cbuf       !読み込むデータレコード
      integer,   intent(in) :: icon               !コンディションコード
    end subroutine
      
    subroutine fcputr(iou,cbuf,icon)              !1レコードを（文字列で）書き込む．
      integer,   intent(in) :: iou                !入出力装置番号
      character(len=*), intent(in) :: cbuf        !読み込むデータレコード
      integer,   intent(in) :: icon               !コンディションコード
    end subroutine
      
    subroutine fcgets(iou,ibuf,icon)              !1レコードを（配列で）読み込む．
      integer,   intent(in) :: iou                !入出力装置番号
      integer,   intent(out) :: ibuf              !読み込むデータレコード
      integer,   intent(in) :: icon               !コンディションコード
    end subroutine
      
    subroutine fcputs(iou,ibuf,icon)              !1レコードを（配列で）書き込む．
      integer,   intent(in) :: iou                !入出力装置番号
      integer,   intent(in) :: ibuf               !読み込むデータレコード
      integer,   intent(in) :: icon               !コンディションコード
    end subroutine
      
    subroutine fcrwnd(iou,icon)                   !リワインドする．
      integer,   intent(in) :: iou                !入出力装置番号
      integer,   intent(in) :: icon               !コンディションコード
    end subroutine

  end interface
end module
!fiolib library end ----

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program text

  use dcl

    call DclOpenGraphics
    call DclNewFrame

    do i=1,9
      call DclDrawLineNormalized( (/0.1,0.9/), (/0.1*i,0.1*i/) )
    end do
    call DclDrawLineNormalized( (/0.5,0.5/), (/0.05,0.95/), type=3 )

! 1段目
    call DclDrawTextNormalized(0.5,0.9,'Test')
! 2段目
    call DclDrawTextNormalized(0.5,0.8,'index3',index=3) ! index 設定
! 3段目
    call DclDrawTextNormalized(0.5,0.7,'SMALL',height=0.03) ! size 設定 (小)
! 4段目
    call DclDrawTextNormalized(0.5,0.6,'Left',centering=-1) ! 左揃え
! 5段目
    call DclDrawTextNormalized(0.5,0.5,'Rotate',angle=20.) ! 回転
! 6段目
    call DclDrawTextNormalized(0.5,0.4,'ABC|sup"XYZ_sub"') ! 上付・下付
! 7段目
    call DclSetParm('ENABLE_PROPORTIONAL_FONT',.true.)!プロポーショナルフォント
    call DclDrawTextNormalized(0.5,0.3,'Proportional',index=2)
! 8段目
    call DclSetParm('IFONT',2)
    call DclDrawTextNormalized(0.5,0.2,'Font2',index=2) ! 高品位フォント
! 9段目
    call DclDrawTextNormalized(0.5,0.1, &
&     achar(152)//achar(153)//achar(154)// & ! ギリシャ小文字
&     achar(145)//achar(151)//achar(148)// & ! ギリシャ大文字
&     achar(189)//achar(217)//achar(218) ) ! 記号

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM MAP3D4

      PARAMETER(  XMIN= -50,  XMAX= 50,  YMIN= -50,  YMAX= 50 )
      PARAMETER( VXMIN=0., VXMAX=0.8, VYMIN=0., VYMAX=0.8 )
      PARAMETER(  ZMIN= -50,  ZMAX= 50 )
      PARAMETER( VZMIN=0., VZMAX=0.8 )
      PARAMETER( XVP3=2.5, YVP3=-1., ZVP3=1.5 )
      PARAMETER( XFC3=(VXMAX-VXMIN)/2, YFC3=(VYMAX-VYMIN)/2 )
      PARAMETER( ZFC3=(VZMAX-VZMIN)/2 )

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGISET( 'IFONT'   , 2 )

      CALL SGFRM

*-- X-Y PLANE ----
      CALL SGSWND(  XMIN,  XMAX,  YMIN,  YMAX )
      CALL SGSVPT( VXMIN, VXMAX, VYMIN, VYMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 2, VZMAX)
      CALL SCSEYE( XVP3, YVP3, ZVP3 )
      CALL SCSOBJ( XFC3, YFC3, ZFC3 )
      CALL SCSPRJ

      CALL APLOT( 1 )

*-- X-Z PLANE ----
      CALL SGSWND(  XMIN,  XMAX,  ZMIN,  ZMAX )
      CALL SGSVPT( VXMIN, VXMAX, VZMIN, VZMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 3, VYMIN)
      CALL SCSPRJ

      CALL APLOT( 2 )

*-- Y-Z PLANE ----
      CALL SGSWND(  YMIN,  YMAX,  ZMIN,  ZMAX )
      CALL SGSVPT( VYMIN, VYMAX, VZMIN, VZMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 2, 3, VXMAX)
      CALL SCSPRJ

      CALL APLOT( 3 )

      CALL SGCLS

      END
*-----------------------------------------------------------------------
      SUBROUTINE APLOT( IJK )

      PARAMETER( NMAX=40 )
      REAL X(0:NMAX), Y(0:NMAX)
      CHARACTER CTTL*2

      CALL SLPVPR( 1 )

      DT = 2.*3.14159 / NMAX
      DO 10 N=0,NMAX
        X(N) = 40.*SIN(N*DT)
        Y(N) = 40.*COS(N*DT)
   10 CONTINUE

      CALL SGPLU( NMAX+1, X, Y )

      DT = 2.*3.14159 / 3
      DO 20 N=0,3
        X(N) = 40.*SIN(N*DT)
        Y(N) = 40.*COS(N*DT)
   20 CONTINUE

      CALL SGPLU( 4, X, Y )

      CALL SGSTXS( 0.07 )
      CALL SGTXU( 0., 0., 'DENNOU' )
      WRITE(CTTL(1:2), '(I2.2)') IJK
      CALL SGTXU( 0., -30., CTTL )

      RETURN
      END

***********************************************************************
*     BACKWARD LEGENDRE TRANSFORMATION (MIDDLE LEVEL)
***********************************************************************
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SHLBWM(MM,JM,M,ISW,SM,WM,SD,PM,YC,R)

      REAL SM(M:MM)
      REAL WM(-JM:JM)
      REAL SD(0:MM+1),PM(0:MM+1,0:JM)
      REAL YC(0:JM)
      REAL R((MM+1)*(MM+1))
      REAL WS,WA

*     ISW=-1: X-DIFFERENTIAL, ISW=0: NORMAL, ISW=1: Y-DIFFERENTIAL

      IF((ISW.EQ.-1).AND.(M.EQ.0)) THEN
        DO 10 J=-JM,JM
          WM(J)=0
   10   CONTINUE
      ELSE
        CALL SHLSSD(MM,M,ISW,SM,SD,R)
        DO 20 J=0,JM
          CALL SHLBWL(MM,M,SD,WS,WA,PM(0,J))
          WM( J)=WS+WA
          WM(-J)=WS-WA
   20   CONTINUE
        IF((ISW.EQ.0).AND.(M.NE.0)) THEN
          DO 30 J=1,JM
            WM( J)=WM( J)*YC(J)
            WM(-J)=WM(-J)*YC(J)
   30     CONTINUE
        ELSE IF((ISW.EQ.1).AND.(M.EQ.0)) THEN
          DO 40 J=1,JM-1
            WM( J)=WM( J)/YC(J)
            WM(-J)=WM(-J)/YC(J)
   40     CONTINUE
          WM( JM)=0
          WM(-JM)=0
        END IF
      END IF

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGPMXU(N,UPX,UPY,ITYPE,INDEX,ICOLOR,RSIZE)

      REAL      UPX(*),UPY(*)
      LOGICAL   LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGPMXU','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMXU','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPMXU','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPMXU','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPMXU','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGPMXU','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGPMXU','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZPMOP(ITYPE,INDEX,RSIZE)
      CALL SZPMZU(N,UPX,UPY)
      CALL SZPMCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     ULPQNP / ULPQID / ULPQCP / ULPQVL / ULPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ULPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 4)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'IXCHR   ' /, ITYPE(1) / 1 /
      DATA      CPARAS(2) / 'IYCHR   ' /, ITYPE(2) / 1 /
      DATA      CPARAS(3) / 'IXTYPE  ' /, ITYPE(3) / 1 /
      DATA      CPARAS(4) / 'IYTYPE  ' /, ITYPE(4) / 1 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'LOG_X_LABEL_CHAR' /
      DATA      CPARAL(2) / 'LOG_Y_LABEL_CHAR' /
      DATA      CPARAL(3) / '****IXTYPE  ' /
      DATA      CPARAL(4) / '****IYTYPE  ' /

*     IXCHR /IYCHR  : CHARACTER NUMBER OF * FOR 5*10E1 IN X/Y-AXIS
*     IXTYPE/IXTYPE : 1-4  1 ... 10|2" 2*10|2" 5*10|2" 10|3"  ETC
*                          2 ... 10|2" 2       5       10|3"  ETC
*                          3 ... 100   200     500     1000   ETC
*                          4 ... 100   2       5       1000   ETC
*               FORMAT FOR 3 OR 4 DEPENDS ON THAT SET BY ULSFMT


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','ULPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','ULPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','ULPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','ULPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL ULIQID(CPARAS(IDX), ID)
          CALL ULIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL ULLQID(CPARAS(IDX), ID)
          CALL ULLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL ULRQID(CPARAS(IDX), ID)
          CALL ULRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','ULPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL ULIQID(CPARAS(IDX), ID)
          CALL ULISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL ULLQID(CPARAS(IDX), ID)
          CALL ULLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL ULRQID(CPARAS(IDX), ID)
          CALL ULRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','ULPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLSTTL(CTTL,CSIDE,PX,PY,HT,NT)

      CHARACTER CTTL*(*),CSIDE*(*)

      PARAMETER (MAXTTL=5)

      REAL      PXZ(MAXTTL),PYZ(MAXTTL),HTZ(MAXTTL)
      CHARACTER CTTLZ(MAXTTL)*2048,CSIDEZ(MAXTTL)*1,CTTLW*2048,CS*1
      LOGICAL   LSET(MAXTTL),LCHREQ,LTITLE

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      LSET/MAXTTL*.FALSE./


      CS=CSIDE(1:1)
      IF (.NOT.(LCHREQ(CS,'T') .OR. LCHREQ(CS,'B'))) THEN
        CALL MSGDMP('E','SLSTTL','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(-1.0.LE.PX .AND. PX.LE.+1.0
     +    .AND. -1.0.LE.PY .AND. PY.LE.+1.0)) THEN
        CALL MSGDMP('E','SLSTTL','POSITION PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(HT.GE.0)) THEN
        CALL MSGDMP('E','SLSTTL','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(1.LE.NT .AND. NT.LE.MAXTTL)) THEN
        CALL MSGDMP('E','SLSTTL','TITLE NUMBER IS OUT OF RANGE.')
      END IF

      LSET(NT)=.TRUE.

      IF(LENC(CTTL).GT.1024) THEN
        CALL MSGDMP('W','SLSTTL',
     *          'STRING LENGTH TOO LONG.SHORTEND.')
        CTTLZ(NT)=CTTL(1:1024)
      ELSE
        CTTLZ(NT)=CTTL(1:LENC(CTTL))
      END IF
      CSIDEZ(NT)=CS
      PXZ(NT)=PX
      PYZ(NT)=PY
      HTZ(NT)=HT

      RETURN
*-----------------------------------------------------------------------
      ENTRY SLDTTL(NT)

      IF (.NOT.(1.LE.NT .AND. NT.LE.MAXTTL)) THEN
        CALL MSGDMP('E','SLDTTL','TITLE NUMBER IS OUT OF RANGE.')
      END IF

      LSET(NT)=.FALSE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SLPTTL

      CALL SGIGET('INDEX',INDEX)
      CALL SGLGET('LTITLE',LTITLE)

      IF (.NOT.LTITLE) RETURN

      DO 10 I=1,MAXTTL
        IF (LSET(I)) THEN
          CALL SLTLCV(CTTLZ(I),CTTLW,LC)
          CALL SLZTTL(CSIDEZ(I),CTTLW(1:LC),PXZ(I),PYZ(I),HTZ(I),INDEX)
        END IF
   10 CONTINUE

      RETURN
      END

*-----------------------------------------------------------------------
*     SWPACK
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWDOPN

      INTEGER   IMAGE(*)
      REAL      WPX(*), WPY(*)
      LOGICAL   LFCATR, LWDATR, LCLATR, LTNATR, LIMATR, LPTATR
      CHARACTER COBJ*(*), COMM*(*), FONTNAME*(*), CHARS*(*)

      LOGICAL   LWAIT, LWAIT0, LWAIT1, LKEY, LDUMP, LALT,
     +          LCOLOR, LSEP, LPRINT, LFGBG, LOPEN, LCLIP
      CHARACTER CMSG*80, CLRMAP*1024, CBTMAP*1024,
     +          COUT*1024, CTTL*80, CMAP*80, DSPATH*80
      LOGICAL   LWND
      CHARACTER CIMGFMT*8
      REAL      RIMGCMP
      CHARACTER CNOPN*26

      INTEGER IDMPDGT
      LOGICAL LSTDOT

      REAL      RLWFACT

      LOGICAL   LFPROP, LCNTL
      INTEGER   ISUP, ISUB, IRST
      REAL      SMALL, SHIFT

      REAL VXMIN,VXMAX,VYMIN,VYMAX
      REAL WXMIN,WXMAX,WYMIN,WYMAX

      LOGICAL LVAL
      INTEGER   IVAL
      REAL RVAL

      INTEGER FNTNUM

      SAVE

      DATA      CNOPN / 'WORKSTATION IS NOT OPENED.' /
      DATA      LOPEN / .FALSE. /

*     / OPEN ( AND ACTIVATE ) WORKSTATION /

      CALL SGIGET('IWS', JWS)
      CALL SWIGET('IWS', IWS)
      CALL SWIGET('IFL', IFL)

      CMSG='GRPH1 : STARTED / IWS = ##.'
      CALL CHNGI(CMSG,'##',JWS,'(I2)')
      CALL MSGDMP('M','SWDOPN',CMSG)

*     / DEVICE DEPENDENT PARAMETERS /
      IF (IWS.EQ.1 .OR. IWS.EQ.2) THEN
        CALL SWIGET('IWIDTH ', IWIDTH)
        CALL SWIGET('IHEIGHT', IHEIGH)
        CALL SWIGET('ICLRMAP', ICLRMP)
        CALL SWLGET('LFGBG  ', LFGBG )
        CALL SWCGET('FNAME  ', COUT  )
        CALL SWCGET('TITLE  ', CTTL  )
        CALL SWIGET('IDMPDGT ', IDMPDGT)
        CALL SWIGET('IBGPAGE ',IBGPAGE)
        CALL SWCMLL
        CALL SWQFNM('CLRMAP ', CLRMAP)
        CALL GLCGET('DSPATH',  DSPATH)

        IF (CLRMAP.EQ.' ') THEN
          CALL MSGDMP('E','SWDOPN','COLORMAP FILE DOES NOT EXIST.')
        END IF

        IF (COUT.EQ.' ' .OR. COUT.EQ.'*') CALL OSGARG(0, COUT)
        IF (COUT.EQ.' ') THEN
          COUT = 'DCL'
          CALL CLOWER(COUT)
        END IF

        IF (CTTL.EQ.' ' .OR. CTTL.EQ.'*') CALL DCLVNM(CTTL)

      END IF

        CALL SWIGET('IPOSX  ', IPOSX )
        CALL SWIGET('IPOSY  ', IPOSY )
        CALL SWLGET('LWAIT  ', LWAIT )
        CALL SWLGET('LWAIT0 ', LWAIT0)
        CALL SWLGET('LWAIT1 ', LWAIT1)
        CALL SWLGET('LKEY   ', LKEY  )
        CALL SWLGET('LALT   ', LALT  )
        CALL SWLGET('LDUMP  ', LDUMP )
        CALL SWLGET('LSTDOT ', LSTDOT )

        CALL SWQFNM('BITMAP ', CBTMAP)
        IF (CBTMAP.EQ.' ') THEN
          CALL MSGDMP('E','SWDOPN','BITMAP FILE DOES NOT EXIST.')
        END IF

        CALL SWLGET('LWND   ', LWND  )
        CALL SWCGET('CIMGFMT ', CIMGFMT)
        CALL SWRGET('RIMGCMP ', RIMGCMP)

        CALL SWLGET('LSEP   ', LSEP  )

        CALL SWRGET('RLWFACT', RLWFACT)

        CALL SGLGET('LFPROP ', LFPROP)
        CALL SGLGET('LCNTL  ', LCNTL )
        CALL SGIGET('ISUP   ', ISUP  )
        CALL SGIGET('ISUB   ', ISUB  )
        CALL SGIGET('IRST   ', IRST  )
        CALL SGRGET('SMALL  ', SMALL )
        CALL SGRGET('SHIFT  ', SHIFT )

        CALL ZGLSET('lfprop  ',LENZ('lfprop'),LFPROP)
        CALL ZGLSET('lcntl   ',LENZ('lcntl') ,LCNTL)
        CALL ZGISET('isup    ',LENZ('isup')  ,ISUP)
        CALL ZGISET('isub    ',LENZ('isub')  ,ISUB)
        CALL ZGISET('irst    ',LENZ('irst')  ,IRST)
        CALL ZGRSET('small   ',LENZ('small') ,SMALL)
        CALL ZGRSET('shift   ',LENZ('shift') ,SHIFT)

        IF (CLRMAP.EQ.(DSPATH(1:LENC(DSPATH))//'colormap.x11')) THEN
          CALL SWQCMF(ICLRMP,CMAP)
          CALL SWCSET('CLRMAP ',CMAP)
        END IF

        CALL SWCSET('CLRMAP',CMAP)
        CALL SWQFNM('CLRMAP ', CLRMAP)

        IF (CLRMAP.EQ.' ') THEN
          CALL MSGDMP('E','SWDOPN','COLORMAP FILE DOES NOT EXIST.')
        END IF

        CALL ZGDOPN(JWS, IWIDTH, IHEIGH, IPOSX, IPOSY, IDMPDGT,
     +       IBGPAGE,RLWFACT,
     +       LWAIT, LWAIT0, LWAIT1, LALT, LSTDOT,LKEY, LDUMP, LWND,
     +       LFGBG,LSEP,IFL,CIMGFMT, RIMGCMP, CLRMAP, CBTMAP, COUT,
     +       CTTL)

      LOPEN = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWDCLS

*     / ( DEACTIVATE AND ) CLOSE WORKSTATION /

      CALL ZGDCLS
      CMSG='GRPH1 : TERMINATED.'
      CALL MSGDMP('M','SWDCLS',CMSG)
      LOPEN = .FALSE.

      RETURN
*-----------------------------------------------------------------------
*     PAGE
*-----------------------------------------------------------------------
      ENTRY SWPOPN

*     / OPEN PAGE ( OR SCREEN ) /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWPOPN', CNOPN)
      CALL ZGPOPN

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWFLSH

*     / PAGE FLASH EXPLICIT /

      CALL ZGFLASH()

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPCLS

*     / CLOSE PAGE ( OR SCREEN ) /
      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWPCLS', CNOPN)
      NPAGE=NPAGE+1
      CMSG='GRPH1 : PAGE = ### COMPLETED.'
      CALL CHNGI(CMSG,'###',NPAGE,'(I3)')
      CALL MSGDMP('M','SWPCLS',CMSG)
      CALL ZGPCLS

      RETURN
*-----------------------------------------------------------------------
*     OBJECT
*-----------------------------------------------------------------------
      ENTRY SWOOPN(COBJ, COMM)

*     / OPEN OBJECT /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWOOPN', CNOPN)
      CALL ZGOOPN(COBJ, COMM)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWOCLS(COBJ)

*     / CLOSE OBJECT /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWOCLS', CNOPN)
      CALL ZGOCLS(COBJ)

      RETURN
*-----------------------------------------------------------------------
*     FULL COLOR (2000/12/10 TEST)
*-----------------------------------------------------------------------
      ENTRY SWQFCC(LFCATR)

*     / INQUIRE FULL COLOR CAPABILITY /

      LFCATR = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWSFCM(LFCMOD)

*     / SET FULL COLOR MODE /

      CALL ZGSFCM(LFCMOD)

      RETURN
*-----------------------------------------------------------------------
*     LINE
*-----------------------------------------------------------------------
      ENTRY SWSWDI(IWDIDX)

*     / SET LINE WIDTH INDEX /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWSWDI', CNOPN)
      CALL ZGSWDI(IWDIDX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWSCLI(ICLIDX,LFCATR)

*     / SET LINE COLOR INDEX /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWSCLI', CNOPN)
      CALL ZGSCLI(ICLIDX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWSLCL(ICOLOR)

*     / SET LINE COLOR IN 24BIT RGB /

      CALL ZGSLCL(ICOLOR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWSFW(IWIDX)

*     / SET FONT WEIGHT /

      CALL ZGSFW(IWIDX)

      RETURN

*-----------------------------------------------------------------------
*     OPEN
*-----------------------------------------------------------------------
      ENTRY SWGOPN

*     / OPEN GRAPHIC SEGMENT /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWGOPN', CNOPN)
      CALL ZGGOPN

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWGMOV(WX,WY)

*     / PEN-UP MOVE /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWGMOV', CNOPN)
      CALL ZGGMOV(WX,WY)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWGPLT(WX,WY)

*     / PEN-DOWN MOVE /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWGPLT', CNOPN)
      CALL ZGGPLT(WX,WY)

      RETURN
*-----------------------------------------------------------------------
*     CLOSE
*-----------------------------------------------------------------------
      ENTRY SWGCLS

*     / CLOSE GRAPHIC SEGMENT /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWGCLS', CNOPN)
      CALL ZGGCLS

      RETURN
*-----------------------------------------------------------------------
*     TONE
*-----------------------------------------------------------------------
      ENTRY SWSTCL(ICOLOR)

*     / SET TONE COLOR IN 24BIT RGB /

      CALL ZGSTCL(ICOLOR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWGTON(NP,WPX,WPY,ITPAT)

*     / HARD FILL /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWGTON', CNOPN)
      CALL ZGGTON(NP,WPX,WPY,ITPAT)

      RETURN
*-----------------------------------------------------------------------
*     IMAGE
*-----------------------------------------------------------------------
      ENTRY SWIOPN(IWX,IWY,IMW,IMH,
     +             WX1, WY1, WX2, WY2, WX3, WY3, WX4, WY4)

*     / OPEN IMAGE /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWIOPN', CNOPN)
      CALL ZGIOPN(IWX, IWY, IMW, IMH)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWIDAT(IMAGE, NLEN)

*     / IMAGE DATA /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWIDAT', CNOPN)
      CALL ZGIDAT(IMAGE, NLEN)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWICLR(IMAGE, NLEN)

*     / IMAGE DATA (FULL COLOR) /
      
      CALL ZGICLR(IMAGE, NLEN)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWICLS

*     / IMAGE CLOSE /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWICLS', CNOPN)
      CALL ZGICLS

      RETURN
*-----------------------------------------------------------------------
*     MOUSE
*-----------------------------------------------------------------------
      ENTRY SWQPNT(WX,WY,MB)

*     / INQUIRE POSITION OF POINTER /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWQPNT', CNOPN)
      CALL ZGQPNT(WX,WY,MB)

      RETURN
*-----------------------------------------------------------------------
*     TRANSFORMATION
*-----------------------------------------------------------------------
      ENTRY SWFINT(WX, WY, IWX, IWY)

*     / REAL TO INT /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWFINT', CNOPN)
      CALL ZGFINT(WX, WY, IWX, IWY)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWIINT(IWX, IWY, WX, WY)

*     / INT TO REAL /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWIINT', CNOPN)
      CALL ZGIINT(IWX, IWY, WX, WY)

      RETURN
*-----------------------------------------------------------------------
*     INQUIRY
*-----------------------------------------------------------------------
      ENTRY SWQWDC(LWDATR)

*     / INQUIRE LINE WIDTH CAPABILITY /

      CALL ZGQWDC(LWDATR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQCLC(LCLATR)

*     / INQUIRE LINE COLOR CAPABILITY /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWQCLC', CNOPN)
      CALL ZGQCLC(LCLATR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQTNC(LTNATR)

*     / INQUIRE HARD FILL CAPABILITY /

      CALL ZGQTNC(LTNATR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQIMC(LIMATR)

*     / INQUIRE BIT IMAGE CAPABILITY /

      CALL ZGQIMC(LIMATR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQPTC(LPTATR)

*     / INQUIRE MOUSE POINT CAPABILITY /

      CALL ZGQPTC(LPTATR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)

*     / INQUIRE WORKSTATION RECTANGLE /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWQRCT', CNOPN)
      CALL ZGQRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWSROT(IWTROT)

*     / SET FRAME ROTATION FLAG /

      IF (.NOT. LOPEN)
     +   CALL MSGDMP('E', 'SWSROT', CNOPN)
      CALL ZGSROT(IWTROT)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCLCH()

*     / CHANGE COLORMAP IMMIDIATELY /

      CALL SWIGET('ICLRMAP', ICLRMP)
      CALL SWQCMF(ICLRMP,CMAP)
      CALL SWCSET('CLRMAP',CMAP)
      CALL SWQFNM('CLRMAP ', CLRMAP)
      CALL SWLGET('LFGBG', LFGBG)
      IF (CLRMAP.EQ.' ') THEN
        CALL MSGDMP('E','SWDOPN','COLORMAP FILE DOES NOT EXIST.')
      END IF

      CALL ZGCLINI(CLRMAP,LFGBG)

      RETURN
*-----------------------------------------------------------------------
*     TEXT
*-----------------------------------------------------------------------
      ENTRY SWQTXW(CHARS,NCHZ,WXCH,WYCH)

*       / PASS SG* PARAMETERS TO ZGPACK /
      CALL SGLGET('LCNTL',LCNTL)
      CALL ZGLSET('lcntl ',LENZ('lcntl'), LCNTL)
      IF (LCNTL) THEN
        CALL SGIGET('ISUB', ISUB)
        CALL SGIGET('ISUP', ISUP)
        CALL SGIGET('IRST', IRST)
        CALL SGRGET('SMALL', SMALL)
        CALL SGRGET('SHIFT', SHIFT)
        CALL ZGISET('isub ',LENZ('isub'), ISUB)
        CALL ZGISET('isup ',LENZ('isup'), ISUP)
        CALL ZGISET('irst ',LENZ('irst'), IRST)
        CALL ZGRSET('small ',LENZ('small'), SMALL)
        CALL ZGRSET('shift ',LENZ('shift'), SHIFT)
      END IF

      CALL ZGQTXW(CHARS,NCHZ,WXCH,WYCH)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWFTFC(FONTNAME)

      CALL ZGFTFC(FONTNAME)

      RETURN

*-----------------------------------------------------------------------
      ENTRY SWFTNM(FNTNUM)

      CALL ZGNUMFONTS(FNTNUM)

      RETURN

*-----------------------------------------------------------------------
      ENTRY SWSLFT(FONTNAME)
      IF(IWS.EQ.2 .AND. IFL.NE.1) THEN
        CALL MSGDMP('M','SWSLFT',
     *    'DIALOG NEEDS WINDOW.DEFAULT FONT IS USED')
      ELSE
        CALL ZGSELECTFONT(FONTNAME)
      END IF

      RETURN

*-----------------------------------------------------------------------
      ENTRY SWGTFT(INUM,FONTNAME,IFMAX)

      CALL ZGFONTNAME(INUM,FONTNAME,IFMAX)

      RETURN

*-----------------------------------------------------------------------
      ENTRY SWLSFT()

      CALL ZGLISTFONTS()

      RETURN

*-----------------------------------------------------------------------
      ENTRY SWTXT(WX,WY,QSIZEXRATE,CHARS,NCZ,IROTA,ICENTZ)

      CALL SGPGET('LCLIP',LCLIP)
      CALL ZGRCLP()
      IF (LCLIP) THEN
        CALL SGQVPT(VXMIN,VXMAX,VYMIN,VYMAX)
        CALL STFWTR(VXMIN,VYMIN,WXMIN,WYMIN)
        CALL STFWTR(VXMAX,VYMAX,WXMAX,WYMAX)
        CALL ZGCLIP(WXMIN,WXMAX,WYMIN,WYMAX)
      ENDIF
*       / PASS SG* PARAMETERS TO ZGPACK /
      CALL SGLGET('LCNTL',LCNTL)
      CALL ZGLSET('lcntl ',LENZ('lcntl'), LCNTL)
      IF (LCNTL) THEN
        CALL SGIGET('ISUB', ISUB)
        CALL SGIGET('ISUP', ISUP)
        CALL SGIGET('IRST', IRST)
        CALL SGRGET('SMALL', SMALL)
        CALL SGRGET('SHIFT', SHIFT)
        CALL ZGISET('isub ',LENZ('isub'), ISUB)
        CALL ZGISET('isup ',LENZ('isup'), ISUP)
        CALL ZGISET('irst ',LENZ('irst'), IRST)
        CALL ZGRSET('small ',LENZ('small'), SMALL)
        CALL ZGRSET('shift ',LENZ('shift'), SHIFT)
      END IF
      CALL ZGTXT(WX,WY,QSIZEXRATE,CHARS,NCZ,IROTA,ICENTZ)
      RETURN

      END

      PROGRAM MAP3D5

      PARAMETER( NX=21, NY=21 )
      PARAMETER(  XMIN=-10,  XMAX= 10,  YMIN=-10,  YMAX= 10 )
      PARAMETER( VXMIN=0.2, VXMAX=0.8, VYMIN=0.1, VYMAX=0.5 )
      PARAMETER(  ZMIN=0.0,  ZMAX= 20 )
      PARAMETER( VZMIN=0.0, VZMAX=0.6 )
      PARAMETER( XVP3=-0.7, YVP3=-0.7, ZVP3=1.2 )
      PARAMETER( XFC3=(VXMAX-VXMIN)/2, YFC3=(VYMAX-VYMIN)/2 )
      PARAMETER( ZFC3=(VZMAX-VZMIN)/2 )
      PARAMETER( DX1=1, DX2=5, DY1=1, DY2=4, DZ1=1, DZ2=5 )
      PARAMETER( KMAX=5, PMIN=0, PMAX=1 )
      REAL U(NX,NY), V(NX,NY), P(NX,NY)

      DO 10 J=1,NY
      DO 10 I=1,NX
        X = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
        Y = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
        U(I,J) =  X
        V(I,J) = -Y
        P(I,J) = EXP( -X**2/64 -Y**2/25 )
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

*-- X-Y 平面: 下レベル ----
      CALL SGSWND(  XMIN,  XMAX,  YMIN,  YMAX )
      CALL SGSVPT( VXMIN, VXMAX, VYMIN, VYMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 2, VZMIN )
      CALL SCSEYE( XVP3, YVP3, ZVP3 )
      CALL SCSOBJ( XFC3, YFC3, ZFC3 )
      CALL SCSPRJ

      CALL UXAXDV( 'B', DX1, DX2 )
      CALL UXAXDV( 'T', DX1, DX2 )
      CALL UXSTTL( 'B', 'X-axis', 0. )

      CALL UYAXDV( 'L', DY1, DY2 )
      CALL UYAXDV( 'R', DY1, DY2 )
      CALL UYSTTL( 'L', 'Y-axis', 0. )

      CALL UGPSET( 'RSIZET', 0.014 )
      CALL UGVECT( U, NX, V, NX, NX, NY )

*-- X-Y 平面: 上レベル ----
      VZLEV = VZMIN + (VZMAX-VZMIN)*.6
      CALL SCSPLN( 1, 2, VZLEV )
      CALL SCSPRJ

      DP = (PMAX-PMIN)/KMAX
      DO 20 K=1,KMAX
        TLEV1 = (K-1)*DP
        TLEV2 = TLEV1 + DP
        IPAT  = 600 + K - 1
        CALL UESTLV( TLEV1, TLEV2, IPAT )
   20 CONTINUE
      CALL UETONE( P, NX, NX, NY )

      CALL UDPSET( 'LMSG' , .FALSE. )
      CALL UDGCLB( P, NX, NX, NY, 0.1 )
      CALL UDCNTR( P, NX, NX, NY )
      CALL SLPVPR( 1 )

*-- X-Z 平面 ----
      CALL SGSWND(  XMIN,  XMAX,  ZMIN,  ZMAX )
      CALL SGSVPT( VXMIN, VXMAX, VZMIN, VZMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 3, VYMAX )
      CALL SCSPRJ

      CALL UZINIT
      CALL UYAXDV( 'L', DZ1, DZ2 )
      CALL UYSTTL( 'L', 'Z-axis', 0. )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGTNXR(N,RPX,RPY,ITPAT,ICOLOR)

      REAL      RPX(*),RPY(*)
      LOGICAL   LFCATR
      INTEGER   ITPATX

      CALL SGIGET('IFCIDX',IFCIDX)

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGTNXR','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNXR','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPAT.EQ.0) THEN
        CALL MSGDMP('M','SGTNXR','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT.LT.0) THEN
        CALL MSGDMP('E','SGTNXR','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSTCL(ICOLOR)
      CALL SWSLCL(ICOLOR)

      ITPATX=IFCIDX*1000+MOD(ITPAT,1000)
      CALL SZTNOP(ITPATX)
      CALL SZTNZR(N,RPX,RPY)
      CALL SZTNCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     USER SUPPLIED FUNCTION (SAMPLE: additional map projections)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
*
*     An original transformation can be defined by the user
*     when the following entries are provided:
*
*         STFUSR(UX,UY,XX,YY)    The forward transformation
*         STIUSR(XX,XY,UX,UY)    The inverse transformation
*         STSUSR                 Initialization of functions
*
*-----------------------------------------------------------------------
      SUBROUTINE STFUSR(XLON, YLAT, X, Y)

        INTEGER JPROJ
        CHARACTER CTTL*(*)
        LOGICAL LDEG
        PARAMETER (NCYC = 100)
        PARAMETER (NCYA = 101)
        PARAMETER (NCYB = 102)
        PARAMETER (NGLB = 103)
        PARAMETER (NCCT = 104)
        EXTERNAL RFPI
        DATA JPROJ /-1/
        SAVE JPROJ

        IF (JPROJ .EQ. NCYC) THEN
          CALL MPFCYC(XLON, YLAT, X, Y)
        ELSEIF (JPROJ .EQ. NCYA) THEN
          CALL MPFCYA(XLON, YLAT, X, Y)
        ELSEIF (JPROJ .EQ. NCYB) THEN
          CALL MPFCYB(XLON, YLAT, X, Y)
        ELSEIF (JPROJ .EQ. NGLB) THEN
          CALL MPFGLB(XLON, YLAT, X, Y)
        ELSEIF (JPROJ .EQ. NCCT) THEN
          CALL MPFCCT(XLON, YLAT, X, Y)
        ELSE
          WRITE(*, *) 'CALL STNUSR(i) before calling STFUSR'
          STOP 16
        ENDIF
      RETURN

*-----------------------------------------------------------------------
      ENTRY STIUSR(X, Y, XLON, YLAT)
        IF (JPROJ .EQ. NCYC) THEN
          CALL MPICYC(X, Y, XLON, YLAT)
        ELSEIF (JPROJ .EQ. NCYA) THEN
          CALL MPICYA(X, Y, XLON, YLAT)
        ELSEIF (JPROJ .EQ. NCYB) THEN
          CALL MPICYB(X, Y, XLON, YLAT)
        ELSEIF (JPROJ .EQ. NGLB) THEN
          CALL MPIGLB(X, Y, XLON, YLAT)
        ELSEIF (JPROJ .EQ. NCCT) THEN
          CALL MPICCT(X, Y, XLON, YLAT)
        ELSE
          WRITE(*, *) 'CALL STNUSR(i) before calling STIUSR'
          STOP 16
        ENDIF
      RETURN

*-----------------------------------------------------------------------
      ENTRY STSUSR
        CALL SGLGET('LDEG', LDEG)
        IF (LDEG) THEN
          CP = RFPI()/180
        ELSE
          CP = 1
        ENDIF
        ITR = 99

        CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

        CALL SGQSIM(SIMFAC, VXOFF, VYOFF)
        CALL SGQMPL(PLX, PLY, PLROT)

        VX0 = (VXMAX + VXMIN)/2 + VXOFF
        VY0 = (VYMAX + VYMIN)/2 + VYOFF

        CALL STSRAD(LDEG, LDEG)
        CALL STSROT(RFPI()/2 - CP*PLY, CP*PLX, CP*PLROT)
        CALL STSTRF(.TRUE.)
*       CALL STSTRN(ITR, SIMFAC, SIMFAC, VX0, VY0)
        CALL STSTRI(ITR)
        CALL STSTRP(SIMFAC, SIMFAC, VX0, VY0)

*       / SET CLIPPING REGION /

        CALL SGQTXY(TXMIN, TXMAX, TYMIN, TYMAX)
        CALL SZSCLX(CP*TXMIN, CP*TXMAX)
        CALL SZSCLY(CP*TYMIN, CP*TYMAX)

*       / SATELITE VIEW /

        CALL SGRGET('RSAT',RSAT)
        CALL MPSOTG(RSAT)

*       / SET STANDARD LATITUDE /

        CALL SGRGET('STLAT1',STLAT1)
        CALL SGRGET('STLAT2',STLAT2)

*       / JPROJ-DRIVEN CONFIG /
        IF (JPROJ .EQ. NCYB) THEN
          CALL MPSCYB(CP * STLAT1)
        ELSEIF (JPROJ .EQ. NCCT) THEN
          CALL MPSCCT(CP * STLAT1)
        ENDIF
      RETURN

*-----------------------------------------------------------------------
      ENTRY STNUSR(KPROJ)
        JPROJ = KPROJ
      RETURN

*-----------------------------------------------------------------------
      ENTRY STCUSR(I, CTTL)
        IF (I .EQ. NCYC) THEN
          CTTL = 'CENTRAL CYLINDRICAL'
        ELSEIF (I .EQ. NCYA) THEN
          CTTL = 'EQ.-AREA CYLINDRICAL'
        ELSEIF (I .EQ. NCYB) THEN
          CTTL = 'BRAUN CYLINDRICAL'
        ELSEIF (I .EQ. NGLB) THEN
          CTTL = 'BACON''S GLOBULAR'
        ELSEIF (I .EQ. NCCT) THEN
          CTTL = 'CENTRAL CONICAL'
        ELSE
          CTTL = ' '
        ENDIF
      RETURN

      END

*-----------------------------------------------------------------------
*     ARROW SUBPRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZLAOP(ITYPE,INDEX)

      LOGICAL   LDEG
      CHARACTER COBJ*80

      COMMON    /SZBLA1/ LARRWZ,LPROPZ,AFACTZ,CONSTZ,ANGLEZ,
     +                   LATONZ,LUARWZ,CONSMZ,RDUNIT
      LOGICAL   LARRWZ,LPROPZ,LATONZ,LUARWZ

      EXTERNAL  RFPI

      SAVE


      LARRWZ=.TRUE.

      CALL SGLGET('LPROP',LPROPZ)
      CALL SGRGET('AFACT',AFACTZ)
      CALL SGRGET('CONST',CONSTZ)
      CALL SGRGET('ANGLE',ANGLEZ)
      CALL SGLGET('LATONE',LATONZ)
      CALL SGIGET('IATONE',IATONZ)
      CALL SGLGET('LUARW',LUARWZ)
      CALL SGRGET('CONSTM',CONSMZ)
      CALL SGLGET('LDEG',LDEG)

      IF (LDEG) THEN
        RDUNIT=RFPI()/180
      ELSE
        RDUNIT=1
      END IF

      WRITE(COBJ,'(2I8)') ITYPE,INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('SZLA',COBJ)

      CALL SZSLTI(ITYPE,INDEX)

      IF (LATONZ) THEN
        CALL SZQIDX(INDEX)
        IF (IATONZ/1000.EQ.0) IATONE=IATONZ+(INDEX/10)*1000
        CALL SZTNOP(IATONE)
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZLACL

      LARRWZ=.FALSE.

      CALL SZPLCL

      IF (LATONZ) CALL SZTNCL

      CALL SWOCLS('SZLA')

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGFONT

      CHARACTER CH*3,USGI*3,CTTL*32
      CHARACTER FONTNAME*70

      INTEGER   ISYS

      DATA      CTTL/'FONT NO. = #'/


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS
      WRITE(*,*) ' STROKE FONT(1) / SYSTEM FONT(2)  ? ;'
      READ(*,*)ISYS

      CALL SGLSET('LCNTL', .FALSE.)
      IF (ISYS.EQ.2) THEN
        CALL SWLSET('LSYSFNT', .TRUE.)
        WRITE(*,*) ' FONT NO (1,2) (I) OR DIALOG(3) ? ;'
        READ(*,*) N
      ELSE
        CALL SWLSET('LSYSFNT', .FALSE.)
        WRITE(*,*) ' FONT NO (1,2) (I)  ? ;'
        READ(*,*) N
      END IF


      CALL SGOPN( IWS )
      IF (ISYS.EQ.2 .AND. N.EQ.3)THEN
        CALL SWSLFT(FONTNAME)
        CALL SWCSET('FONTNAME', FONTNAME)
      END IF

      CALL SGLSET('LCNTL',.FALSE.)

      CALL SLMGN( 0.1, 0.1, 0.1, 0.1 )
      CALL SLRAT( 1.0, 1.0 )

      CALL SGFRM

      CALL SGISET( 'IFONT', N )

      CALL SGSWND( 0.0, 16.0, 0.0, 16.0 )
      CALL SGSVPT( 0.05, 0.95, 0.0, 0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      DO 10 I=0,16
        CALL SGLNZU( REAL(I), 0.0, REAL(I), 16.0, 2 )
        CALL SGLNZU( 0.0, REAL(I), 16.0, REAL(I), 2 )
   10 CONTINUE

      WRITE(CTTL(12:12),'(I1)') N

      CALL SGTXZV( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

      DO 15 I=0,255
        UX=I/16+0.5
        UY=16-MOD(I,16)-0.5
        CALL SGTXZU( UX, UY, USGI(I), 0.035, 0, 0, 3 )
        UX=UX+0.48
        UY=UY+0.38
        WRITE(CH,'(I3)') I
        CALL SGTXZU( UX, UY, CH, 0.01, 0, +1, 1 )
   15 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UZRQNP / UZRQID / UZRQCP / UZRQVL / UZRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UZRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 31)
      PARAMETER (RUNDEF = -999.)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'UXUSER  ' /, RX( 1) / RUNDEF /
      DATA      CPARAS( 2) / 'UYUSER  ' /, RX( 2) / RUNDEF /
      DATA      CPARAS( 3) / 'ROFFXB  ' /, RX( 3) / 0. /
      DATA      CPARAS( 4) / 'ROFFXT  ' /, RX( 4) / 0. /
      DATA      CPARAS( 5) / 'ROFFXU  ' /, RX( 5) / 0. /
      DATA      CPARAS( 6) / 'ROFFYL  ' /, RX( 6) / 0. /
      DATA      CPARAS( 7) / 'ROFFYR  ' /, RX( 7) / 0. /
      DATA      CPARAS( 8) / 'ROFFYU  ' /, RX( 8) / 0. /
      DATA      CPARAS( 9) / 'ROFGXB  ' /, RX( 9) / 0. /
      DATA      CPARAS(10) / 'ROFGXT  ' /, RX(10) / 0. /
      DATA      CPARAS(11) / 'ROFGXU  ' /, RX(11) / 0. /
      DATA      CPARAS(12) / 'ROFGYL  ' /, RX(12) / 0. /
      DATA      CPARAS(13) / 'ROFGYR  ' /, RX(13) / 0. /
      DATA      CPARAS(14) / 'ROFGYU  ' /, RX(14) / 0. /
      DATA      CPARAS(15) / 'RSIZET0 ' /, RX(15) / RUNDEF /
      DATA      CPARAS(16) / 'RSIZET1 ' /, RX(16) / 0.007 /
      DATA      CPARAS(17) / 'RSIZET2 ' /, RX(17) / 0.014 /
      DATA      CPARAS(18) / 'RSIZEL0 ' /, RX(18) / RUNDEF /
      DATA      CPARAS(19) / 'RSIZEL1 ' /, RX(19) / 0.021 /
      DATA      CPARAS(20) / 'RSIZEL2 ' /, RX(20) / 0.028 /
      DATA      CPARAS(21) / 'RSIZEC0 ' /, RX(21) / RUNDEF /
      DATA      CPARAS(22) / 'RSIZEC1 ' /, RX(22) / 0.028 /
      DATA      CPARAS(23) / 'RSIZEC2 ' /, RX(23) / 0.035 /
      DATA      CPARAS(24) / 'XOFFSET ' /, RX(24) / 0.0 /
      DATA      CPARAS(25) / 'YOFFSET ' /, RX(25) / 0.0 /
      DATA      CPARAS(26) / 'XFACT   ' /, RX(26) / 1.0 /
      DATA      CPARAS(27) / 'YFACT   ' /, RX(27) / 1.0 /
      DATA      CPARAS(28) / 'PAD1    ' /, RX(28) / 0.7 /
      DATA      CPARAS(29) / 'PAD2    ' /, RX(29) / 1.5 /
      DATA      CPARAS(30) / 'RBTWN   ' /, RX(30) / 0.0 /
      DATA      CPARAS(31) / 'RUNDEF  ' /, RX(31) / RUNDEF /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'X_INTERSECTION  ' /
      DATA      CPARAL( 2) / 'Y_INTERSECTION  ' /
      DATA      CPARAL( 3) / '****ROFFXB  ' /
      DATA      CPARAL( 4) / '****ROFFXT  ' /
      DATA      CPARAL( 5) / '****ROFFXU  ' /
      DATA      CPARAL( 6) / '****ROFFYL  ' /
      DATA      CPARAL( 7) / '****ROFFYR  ' /
      DATA      CPARAL( 8) / '****ROFFYU  ' /
      DATA      CPARAL( 9) / '****ROFGXB  ' /
      DATA      CPARAL(10) / '****ROFGXT  ' /
      DATA      CPARAL(11) / '****ROFGXU  ' /
      DATA      CPARAL(12) / '****ROFGYL  ' /
      DATA      CPARAL(13) / '****ROFGYR  ' /
      DATA      CPARAL(14) / '****ROFGYU  ' /
      DATA      CPARAL(15) / 'TICK_LENGTH0' /
      DATA      CPARAL(16) / 'TICK_LENGTH1' /
      DATA      CPARAL(17) / 'TICK_LENGTH2' /
      DATA      CPARAL(18) / 'LABEL_HEIGHT0' /
      DATA      CPARAL(19) / 'LABEL_HEIGHT1' /
      DATA      CPARAL(20) / 'LABEL_HEIGHT2' /
      DATA      CPARAL(21) / 'TITLE_HEIGHT0' /
      DATA      CPARAL(22) / 'TITLE_HEIGHT1' /
      DATA      CPARAL(23) / 'TITLE_HEIGHT2' /
      DATA      CPARAL(24) / 'X_AXIS_OFFSET' /
      DATA      CPARAL(25) / 'Y_AXIS_OFFSET' /
      DATA      CPARAL(26) / 'X_AXIS_FACTOR' /
      DATA      CPARAL(27) / 'Y_AXIS_FACTOR' /
      DATA      CPARAL(28) / '****PAD1    ' /
      DATA      CPARAL(29) / '****PAD2    ' /
      DATA      CPARAL(30) / 'SPAN_LABELING_CENTERING' /
      DATA      CPARAL(31) / '----RUNDEF  ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UZRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UZRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UZRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UZ', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','UZRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UZ', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UZRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRSAV(IU)

      WRITE(UNIT=IU,IOSTAT=IOS) RX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZRSAV','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZRRST(IU)

      READ(UNIT=IU,IOSTAT=IOS) RX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZRRST','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USYINZ(CSA, FACA, OFFA)
      CHARACTER CSA, CS, CPOS
      CHARACTER*32  CSBLBL, CTTL, CTITLE, CUNIT, CSUB
      CHARACTER*16  CMIN, CMAX, CFMT0, CFMT1
      LOGICAL LOFF, LSUB, LABEL

      SAVE OFF0, FAC0, OFF1, FAC1, CFMT0, CFMT1, CS, FACTOR, OFFSET

      CALL GLRGET('RUNDEF',  RUNDEF)

      CS = CSA
      CALL UZRGET('ROFFY'//CS,ROFF)
      CALL UZRGET('ROFGY'//CS,ROFG)
      IF (ROFF.NE.ROFG)  CALL UYSAXS(CS)

      CALl UZRGET('RSIZEL1', SIZEL)
      CALL USRSET('SOFFY'//CS//'T',  SIZEL*0.86)
      CALL USRSET('SOFFY'//CS//'B', -SIZEL*0.86)

      CALL UZLGET('LOFFSET', LOFF)
      IF(LOFF) THEN
        CALL UZRGET('YOFFSET', OFF0)
        CALL UZRGET('YFACT',   FAC0)
      ELSE
        OFF0 = 0.
        FAC0 = 1.
      END IF

      CALL USRGET('YOFF',  OFF1)
      CALL USRGET('YFAC',  FAC1)
      IF(OFF1.EQ.RUNDEF) OFF1 = 0.
      IF(FAC1.EQ.RUNDEF) FAC1 = 1.
      OFFA = OFF1
      FACA = FAC1

      FACTOR = FAC0/FAC1
      OFFSET = (OFF0-OFF1)/FAC1
      CALL UZLSET('LOFFSET', .TRUE.)
      CALL UZRSET('YOFFSET', OFFSET)
      CALL UZRSET('YFACT',   FACTOR)

      CALL UZCGET('CYFMT', CFMT0)
      CALL USCGET('CYFMT', CFMT1)
      IF(CFMT1 .EQ. ' ') CFMT1 = CFMT0
      CALL UZCSET('CYFMT', CFMT1)

      RETURN
*-------------------------------------------------------------
      ENTRY USYTLZ

      CALL SGQWND(XMIN,XMAX,YMIN,YMAX)

      CALL UZLGET('LABELY'//CS, LABEL)
      CALL USCGET('CYUNIT', CUNIT)
      CALL USCGET('CYTTL ', CTTL)

      IF(LABEL) THEN
        CSUB = CSBLBL(FAC1, OFF1, CUNIT)
        CALL USLGET('LYSUB', LSUB)
        IF(LENZ(CSUB).NE.0) THEN
          IF(LSUB) THEN
            CALL CHVAL(CFMT1,YMIN*FACTOR+OFFSET,CMIN)
            CALL CHVAL(CFMT1,YMAX*FACTOR+OFFSET,CMAX)
            RLEN = MAX(LENZ(CMIN), LENZ(CMAX))

            CALL USCGET('CYSPOS', CPOS)
            CALL USYSUB(CS, CPOS, CSUB, RLEN)
            CTITLE = CTTL
          ELSE
            NLT = LENZ(CTTL)
            CTITLE = CTTL(1:NLT+1) // CSUB
          ENDIF
        ELSE
          CTITLE = CTTL
        ENDIF

        CALL CLADJ(CTITLE)
        IF(LENZ(CTITLE).NE.0) CALL UYSTTL(CS, CTITLE, 0.)
      ENDIF

      CALL UZRSET('YOFFSET', OFF0)
      CALL UZRSET('YFACT',   FAC0)
      CALL UZCSET('CYFMT',   CFMT0)

      END

!-------------------------------------------------
!interface module of hexlib
!-------------------------------------------------
module hex_interface
  interface

    subroutine hexdic(ip,cp)                      !ビットパターンを16進表現の文字列化する．
      integer,   intent(in) :: ip                 !ビットパターンを調べる 1語長の引数
      character(len=*), intent(out) :: cp         !16進表現の文字列を返す文字型の引数
    end subroutine
      
    subroutine hexdci(cp,ip)                      !16進表現の文字列をビットパターン化する．
      character(len=*), intent(in) :: cp          !16進表現の文字列を与える文字型の引数
      integer,   intent(out) :: ip                !ビットパターンを返す 1語長の引数
    end subroutine

  end interface
end module
!hexlib library end ----

*-----------------------------------------------------------------------
*     PLOT ROUTINE ON TC (GREAT CIRCLE INTERPOLATION)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZOPLT

      PARAMETER (EPSIL = 1.E-5)

      LOGICAL   LFIRST, LCONT1, LCONT2, LCONT3,
     +          LMOVEX, LVLDX, LVLDY, LREQA

      EXTERNAL  XMPLON, LREQA

      SAVE


      CALL SZOPLV

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZMVLT(TX, TY)

      TX0 = XMPLON(TX)
      TY0 = TY
      LFIRST = .TRUE.

      CALL SZPCLY(TX0, TY0, TX0, TY0, LVLDY, .TRUE.)
      CALL SZPCLX(TX0, TY0, TX0, TY0, LVLDX, .TRUE.)
      IF (LVLDX .AND. LVLDY) THEN
        CALL STFTRN(TX0, TY0, VX, VY)
        CALL SZMVLV(VX, VY)
        LFIRST = .FALSE.
      END IF

      BX0 = TX0
      BY0 = TY0
      CX0 = TX0
      CY0 = TY0

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZPLLT(TX, TY)

      TX1 = XMPLON(TX)
      TY1 = TY
      IF (.NOT. LFIRST .AND.
     +     LREQA(TX1, TX0, EPSIL) .AND. LREQA(TY1, TY0, EPSIL)) RETURN

      CALL SZPIPT(TX0, TY0, TX1, TY1, 0)
   10 CONTINUE
        CALL SZGIPT(BX1, BY1, LCONT1)
        CALL SZPCLY(BX0, BY0, BX1, BY1, LVLDY, .TRUE.)
        IF (LVLDY) THEN
   20     CONTINUE
            CALL SZGCLY(CX1, CY1, LCONT2)
            CX1 = XMPLON(CX1)
            CALL SZPCLX(CX0, CY0, CX1, CY1, LVLDX, .TRUE.)
            IF (LVLDX) THEN
   30         CONTINUE
                CALL SZGCLX(XX, YY, LCONT3, LMOVEX)
                CALL STFTRN(XX, YY, VX, VY)
                IF (LMOVEX.OR.LCONT2.OR.LFIRST) THEN
                  CALL SZMVLV(VX, VY)
                  LFIRST = .FALSE.
                ELSE
                  CALL SZPLLV(VX, VY)
                END IF
              IF (LCONT3) GO TO 30
            END IF
            CX0 = CX1
            CY0 = CY1
          IF (LCONT2) GO TO 20
        END IF
        BX0 = BX1
        BY0 = BY1
      IF (LCONT1) GO TO 10

      TX0=TX1
      TY0=TY1

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCLLT

      CALL SZCLLV

      RETURN
      END

*-----------------------------------------------------------------------
      PROGRAM UXYZ02


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL GRFRM

      CALL SGSWND( 1.0E0, 1.0E5, 1.0E3, 1.0E0 )
      CALL SGSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL SGSTRN( 4 )
      CALL SGSTRF

      CALL ULXLOG( 'B', 1, 9 )
      CALL ULXLOG( 'T', 1, 9 )
      CALL UXSTTL( 'B', '[X]', 1.0 )

      CALL ULYLOG( 'L', 3, 9 )
      CALL ULYLOG( 'R', 3, 9 )
      CALL UYSTTL( 'L', '[Y]', 1.0 )

      CALL UXMTTL( 'T', 'ULXLOG/ULYLOG', 0.0 )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHBXAZ(N,UPX1,UPX2,UPY,ITPAT1,ITPAT2)

      REAL      UPX1(*),UPX2(*),UPY(*)

      LOGICAL   LMISS, LYUNI, LXC1, LXC2
      CHARACTER COBJ*80

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UHBXAZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','UHBXAZ','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LT.0) THEN
        CALL MSGDMP('E','UHBXAZ','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      CALL STFPR2(0., 0., RX0, RY0)
      CALL STFPR2(0., 1., RX1, RY1)
      CALL STFPR2(1., 0., RX2, RY2)

      ROT = (RX2-RX0)*(RY1-RY0) - (RY2-RY0)*(RX1-RX0)

      IRMODE = 0
      IF (ROT.GT.0) THEN
        IRMODR = IRMODE
      ELSE
        IRMODR = MOD(IRMODE+1, 2)
      END IF

      WRITE(COBJ,'(2I8)') ITPAT1, ITPAT2
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHBXAZ',COBJ)

      LYUNI = UPY(1).EQ.RUNDEF
      LXC1  = UPX1(1).EQ.RUNDEF
      LXC2  = UPX2(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/N
      END IF

      IF (LXC1 .OR. LXC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LYUNI) THEN
          UY1 = UYMIN + DY*(I-1)
          UY2 = UYMIN + DY*I
        ELSE
          UY1 = UPY(I)
          UY2 = UPY(I+1)
        END IF

        IF (LXC1) THEN
          UX1 = UREF
        ELSE
          UX1 = UPX1(I)
        END IF

        IF (LXC2) THEN
          UX2 = UREF
        ELSE
          UX2 = UPX2(I)
        END IF

        IF (.NOT.
     #    ((UX1.EQ.RMISS .OR. UX1.EQ.RMISS .OR.
     #      UY1.EQ.RMISS .OR. UY2.EQ.RMISS) .AND. LMISS)) THEN

          CALL STFTRF(UX1, UY1, VX1, VY1)
          CALL STFTRF(UX2, UY2, VX2, VY2)

          IF (UX2 .GT. UX1) THEN
            CALL SZSTNI(ITPAT1)
          ELSE
            CALL SZSTNI(ITPAT2)
          END IF

          IF ((VY2-VY1)*(VX2-VX1).LT.0) THEN
            VXX = VX1
            VX1 = VX2
            VX2 = VXX
          END IF

          CALL SZOPTV
          CALL SZSTTV(VX1, VY1)
          CALL SZSTTV(VX2, VY1)
          CALL SZSTTV(VX2, VY2)
          CALL SZSTTV(VX1, VY2)
          CALL SZSTTV(VX1, VY1)
          CALL SZCLTV

        END IF
   20 CONTINUE

      CALL SWOCLS('UHBXAZ')

      END

*-----------------------------------------------------------------------
*     USPACK DRAW X-AXIS (LOG)                         DCL 5.0 95/09/04
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USXAXL(CXS)
      CHARACTER CXS*(*), CUNIT*32, CXSUB*32, CSBLBL*32, CPOS*1, CP*8
      LOGICAL LAB1
      EXTERNAL CSBLBL, LENZ

      CALL USIGET('NLBLX'  , NLBL)
      CALL USIGET('NTICKSX', NTICKS)
      CALL USIGET('ITYPEX' , ITYPEX)
      CALL USRGET('XFAC'   , XFAC)
      CALL USCGET('CXUNIT' , CUNIT)

      CALL ULIGET('IXTYPE', IT)
      CALL ULISET('IXTYPE', ITYPEX)

      CALL SGQTRN(ITR)
      IF(.NOT.(ITR.EQ.3 .OR. ITR.EQ.4))
     &   CALL MSGDMP('E', 'USXAXL', 'INVALID TRANSFORMATION NUMBER.')
      CALL SGQWND(XMIN, XMAX, YMIN, YMAX)

      XMINA = XMIN*XFAC
      XMAXA = XMAX*XFAC
      CALL SGSWND(XMINA, XMAXA, YMIN, YMAX)
      CALL SGSTRF

*---------------------------- X-AXIS -----------------------------------

      NXS = MIN(LEN(CXS), 2)
      DO 100 I=1, NXS
        CALL ULXLOG(CXS(I:I), NLBL, NTICKS)
        CP = 'LABELX'//CXS(I:I)
        CALL UZLGET(CP, LAB1)
        IF(LAB1) THEN
          CXSUB = CSBLBL(XFAC, 0., CUNIT)
          IF(LENZ(CXSUB).NE.0) THEN
            CALL USCGET('CXSPOS', CPOS)
            CALL USXSUB(CXS(I:I), CPOS, CXSUB, 3.)
          ENDIF
        ENDIF
  100 CONTINUE

*------------------------------ ----------------------------------------

      CALL SGSWND(XMIN, XMAX, YMIN, YMAX)
      CALL SGSTRF
      CALL ULISET('IXTYPE', IT)

      RETURN
      END

*-----------------------------------------------------------------------
*     UDLQNP / UDLQID / UDLQCP / UDLQVL / UDLSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDLQNP(NCP)

      INTEGER   NCP
      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 4)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'LDASH   ' /, LX(1) / .TRUE. /
      DATA      CPARAS(2) / 'LABEL   ' /, LX(2) / .TRUE. /
      DATA      CPARAS(3) / 'LMSG    ' /, LX(3) / .TRUE. /
      DATA      CPARAS(4) / 'LCENT   ' /, LX(4) / .TRUE. /

*     / LONG NAME /

      DATA      CPARAL(1) / 'ENABLE_NEGATIVE_CONTOUR' /
      DATA      CPARAL(2) / 'ENABLE_LABELED_CONTOUR' /
      DATA      CPARAL(3) / 'ENABLE_CONTOUR_MESSAGE' /
      DATA      CPARAL(4) / 'ENABLE_MESSAGE_CENTERING' /

      DATA      LFIRST / .TRUE. /

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UDLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UDLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UDLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UD', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','UDLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UD', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','UDLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-----------------------------------------------------------------------
program uxyz08
  use dcl

  real,parameter :: x1=-180., x2=+180., dx1=10., dx2=60.
  real,parameter :: y1= -90., y2= +90., dy1=10., dy2=30.

    call DclOpenGraphics()

    call DclNewFrame

    call DclSetWindow( x1, x2, y1, y2 )
    call DclSetViewPort( 0.2, 0.8, 0.3, 0.7 )
    call DclSetTransNumber( DCL_UNI_UNI )
    call DclSetTransFunction

    call DclSetParm( 'AXIS:inner', -1 )
    call DclSetParm( 'AXIS:uxuser', 0.0 )
    call DclSetParm( 'AXIS:uyuser', 0.0 )
    call DclSetParm( 'AXIS:labelxu', .false. )
    call DclSetParm( 'AXIS:labelyu', .false. )

    call DclDrawXAxis( 'b', dx2, dx1 )
    call DclDrawXAxis( 't', dx2, dx1 )
    call DclDrawXSubTitle( 'b', 'Longitude', 0.0 )

    call DclDrawYAxis( 'l', dy2, dy1 )
    call DclDrawYAxis( 'r', dy2, dy1 )
    call DclDrawYSubTitle( 'l', 'Latitude', 0.0 )

    call DclDrawXMainTitle( 't', 'DclDrawXAxis', 0.0 )

    call DclSetAxisFactor( 0.5 )
    call DclDrawXAxis( 'u', dx2, dx1 )
    call DclDrawXSubTitle( 'u', 'EQ', +0.9 )
    call DclDrawYAxis( 'u', dy2, dy1 )
    call DclDrawYSubTitle( 'u', 'GM', -0.9 )
    call DclSetParm( 'AXIS:inner', +1 )
    call DclDrawXAxis( 'u', dx2, dx1 )
    call DclDrawYAxis( 'u', dy2, dy1 )

    call DclCloseGraphics

end program

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program calendar2

  use dcl
  integer,parameter :: days=720
  type(dcl_date) :: date

    date%year = 1981
    date%month = 12
    date%day = 1

    call DclOpenGraphics()
    call DclSetAxisFactor( 0.8 )
    call DclNewFrame

    call DclSetWindow( -180.0, 180.0, real(days), 0.0 )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransFunction

    call DclDrawAxis( 'bt', 10.0, 60.0 )
    call DclDrawTitle( 'b', 'Longitude', 0.0 )

    call DclDrawAxisCalendar( 'l', date, nd=days )
    call DclSetParm( 'DRAW_RIGHT_LABEL', .true. )
    call DclDrawAxis( 'r', 20.0, 100.0 )
    call DclSetParm( 'RIGHT_TITLE_ANGLE', -1 )
    call DclDrawTitle( 'r', 'Day Number', 0.0 )

    call DclDrawTitle( 't', 'Calendar', sw=2 )

    call DclCloseGraphics

end program

      PROGRAM QUICK2

      PARAMETER( NMAX=400 )
      REAL X(NMAX), Y(NMAX)

*-- リサジューの図 ----
      DT = 3.14159 / (NMAX-1)
      DO 10 N=1,NMAX
        T = DT*(N-1)
        X(N) = 1.E 5*SIN( 6.*T)
        Y(N) = 1.E-4*COS(14.*T) + 1.
   10 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM
      CALL USGRPH( NMAX, X, Y )
      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      REAL FUNCTION RVMIN1(RX,NS,NP,NQ,ND)

      INTEGER   NS(*),NP(*),NQ(*)
      REAL      RX(*)

      PARAMETER (MD=10)

      INTEGER   NZX(MD),NAD(MD)
      LOGICAL   LMADA


      IF (.NOT.(1.LE.ND .AND. ND.LE.MD)) THEN
        CALL MSGDMP('E','RVMIN1',
     +       'NUMBER OF DIMENSION SHOULD BE 1<= ND <= 10.')
      END IF

      DO 10 N=1,ND
        IF (.NOT.(1.LE.NP(N) .AND. NP(N).LE.NQ(N)
     +       .AND. NQ(N).LE.NS(N))) THEN
          CALL MSGDMP('E','RVMIN1',
     +         'RELATION SHOULD BE 1 <= NP(N) <= NQ(N) <= NS(N).')
        END IF
   10 CONTINUE

      CALL GLRGET('RMISS',RMISS)

      CALL DXFLOC(ND,NS,NP,N1)
      CALL DXFLOC(ND,NS,NQ,N2)

      LMADA=.TRUE.

      NDX=1
      DO 20 NN=1,ND
        NZX(NN)=NP(NN)
        NAD(NN)=(NS(NN)-(NQ(NN)-NP(NN)+1))*NDX
        NDX=NDX*NS(NN)
   20 CONTINUE

      N=N1
   30 CONTINUE

        DO 40 NN=1,ND
          IF (NZX(NN).GT.NQ(NN)) THEN
            NZX(NN)=NP(NN)
            NZX(NN+1)=NZX(NN+1)+1
            N=N+NAD(NN)
          ELSE
            GO TO 50
          END IF
   40   CONTINUE
   50   CONTINUE

        IF (LMADA) THEN
          IF (RX(N).NE.RMISS) THEN
            RVMIN1=RX(N)
            LMADA=.FALSE.
          END IF
        ELSE
          IF (RX(N).NE.RMISS .AND. RX(N).LT.RVMIN1) THEN
            RVMIN1=RX(N)
          END IF
        END IF

        NZX(1)=NZX(1)+1
        N=N+1

      IF (N.LE.N2) GO TO 30

      IF (LMADA) THEN
        RVMIN1=RMISS
      END IF

      END

*-----------------------------------------------------------------------
      PROGRAM SGPK05

      PARAMETER (N=9)
      DIMENSION Y(N)


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)
      CALL SGFRM

      X1 = 0.1
      X2 = 0.9
      XC = 0.5

      CALL SGSLNI(1)
      DO 10 I=1, N
        Y(I) = 0.1 * (10-I)
        CALL SGLNV(X1, Y(I), X2, Y(I))
  10  CONTINUE
      CALL SGLNV(XC, 0.05, XC, 0.95)

      CALL SGTXV(XC, Y(1), 'SGTXV TEST') ! <-- テキスト 1 段目

      CALL SGSTXI(2)                     ! <-- テキスト INDEX 設定
      CALL SGTXV(XC, Y(2), 'INDEX2')     ! <-- テキスト 2 段目

      CALL SGSTXI(3)                     ! <-- テキスト INDEX 設定
      CALL SGTXV(XC, Y(3), 'INDEX3')     ! <-- テキスト 3 段目

      CALL SGSTXI(4)

      CALL SGSTXS(0.03)                  ! <-- テキスト SIZE 設定 (小)
      CALL SGTXV(XC, Y(4), 'SMALL')      ! <-- テキスト 4 段目

      CALL SGSTXS(0.07)                  ! <-- テキスト SIZE 設定 (大)
      CALL SGTXV(XC, Y(5), 'LARGE')      ! <-- テキスト 5 段目

      CALL SGSTXS(0.05)

      CALL SGSTXI(5)

      CALL SGSTXC(-1)                    ! <-- 左揃え
      CALL SGTXV(XC, Y(6), 'LEFT')       ! <-- テキスト 6 段目

      CALL SGSTXC(0)                     ! <-- 中央揃え
      CALL SGTXV(XC, Y(7), 'CENTER')     ! <-- テキスト 7 段目

      CALL SGSTXC(1)                     ! <-- 右揃え
      CALL SGTXV(XC, Y(8), 'RIGHT')      ! <-- テキスト 8 段目

      CALL SGSTXC(0)

      CALL SGSTXI(4)
      CALL SGSTXR(20)                    ! <-- テキスト回転
      CALL SGTXV(XC, Y(9), 'ROTATION')   ! <-- テキスト 9 段目

      CALL SGCLS

      END

      PROGRAM TMPK2
      IMPLICIT NONE
      INTEGER NX, NY, THRES
      PARAMETER (NX=101, NY=101, THRES=1)
      REAL DX, DY, DYT
      PARAMETER (DX=6.2832/REAL(NX-1), DY=6.2832/REAL(NY-1))
      PARAMETER (DYT=360.0/REAL(NY-1))
      REAL ARROW_THRES
      PARAMETER (ARROW_THRES=1.0)
      REAL U(NX,NY), V(NX,NY)
      REAL X(NX), Y(NY), XT(NY), YT(NY)
      INTEGER I, J, SKIP, IWS
    
      WRITE(*,*) "SKIP NUM INPUT"
      READ(*,*) SKIP

      X=(/(DX*REAL(I-1),I=1,NX)/)
      Y=(/(DY*REAL(I-1-NY/2),I=1,NY)/)
      YT=(/(DYT*REAL(I-1-NY/2),I=1,NY)/)
      XT=(/(X(NX),I=1,NY)/)

      DO 21 J=1,NY
         DO 20 I=1,NX
            U(I,J)=-COS(Y(J))
            V(I,J)=COS(X(I))
 20      CONTINUE
 21   CONTINUE
    
      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM
      CALL GRSWND( X(1), X(NX), YT(1), YT(NY) )
      CALL GRSVPT( 0.2, 0.8, 0.2, 0.8 )
C      CALL USPFIT
      call GRSSIM( 0.5*0.6/x(nx), 0.0, 0.0 )
      CALL GRSTRN( 5 )
      CALL GRSTRF
C      CALL USDAXS
      CALL UZRSET( 'UYUSER', 0.0 )
      CALL UXPAXS( 'U', 1 )
      CALL UZRSET( 'UYUSER', -180.0 )
      CALL UXPAXS( 'U', 1 )

C      CALL UETONF( U, NX, NX, NY )
C      CALL UDCNTR( V, NX, NX, NY )
C-- 流線描画
      CALL TMISET( 'SKIPINTV', SKIP )
      CALL TMLSET( 'PERIODY', .TRUE. )
      CALL TMLSET( 'NODRSHRT', .TRUE. )
      CALL TMSTLA( X, YT, U, V, NX, NY )

      CALL UULIN( NY, XT, YT )

      CALL GRCLS

      END PROGRAM

*-----------------------------------------------------------------------
*     TONE ROUTINE ON VC (CLIPPING)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZOPTV

      PARAMETER (NMAX=16384, NLMAX=100, EPSIL = 1.E-5, EP2 = 1.E-3)

      INTEGER   NBGN(NLMAX), NLEN(NLMAX), NSTAT(NLMAX)
      REAL      VXX (NMAX),  VYY (NMAX),  POS  (NLMAX)
      REAL      XB(2), YB(2), BDX(4), BDY(4)
      LOGICAL   LFIRST, LVALID, LMOVE, LCONT, LREQA

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP

      EXTERNAL  IMOD

      SAVE

      POSBD(X,Y) =
     +     (-1)**(NINT(((XB(2)-X)/XWIDTH+(YB(2)-Y)/YWIDTH)/2) + IRMODE)
     +     *((XB(2)-X)/XWIDTH + (Y-YB(1))/YWIDTH) + 2

*     POSBD RAGES FROM 0 TO 4. (AT UPPER LEFT CORNER)
*     ANTI-CLOCK WISE (IMODE=0), CLOCK WISE (IMODE=1)


      CALL SZQCLL(XB(1), XB(2), YB(1), YB(2), 1)
      XWIDTH = XB(2) - XB(1)
      YWIDTH = YB(2) - YB(1)

      DO 5 I=1, 4
        BDX(I) = XB(MOD((I+3+IRMODE)/2, 2) + 1)
        BDY(I) = YB(MOD((I+2-IRMODE)/2, 2) + 1)
    5 CONTINUE

      NN = 0
      NLINE = 0
      LFIRST = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSTTV(VX, VY)

      IF (LCLIP) THEN

        IF (LFIRST) THEN
          VX0 = VX
          VY0 = VY
          LFIRST = .FALSE.
        ELSE
          IF (LREQA(VX0, VX, EPSIL).AND.LREQA(VY0, VY, EPSIL)) RETURN
        END IF

        CALL SZPCLL(VX0, VY0, VX, VY, LVALID, 1)

        IF (LVALID) THEN
   10     CONTINUE
            NN = NN+1
            IF (NN.GT.NMAX) CALL MSGDMP('E', 'SZSTTV',
     +         'WORKING AREA OVER FLOW (TOO MANY POINTS)')
            CALL SZGCLL(VXX(NN), VYY(NN), LCONT, LMOVE, 1)
            IF (LMOVE) THEN
              NLINE = NLINE +1
              IF (NLINE.GT.NLMAX) CALL MSGDMP('E', 'SZSTTV',
     +           'WORKING AREA OVER FLOW (TOO MANY LINES)')
              NBGN(NLINE) = NN
            END IF
          IF (LCONT) GO TO 10
        END IF
        VX0 = VX
        VY0 = VY

      ELSE

        LFIRST = .FALSE.
        NN = NN + 1
        IF (NN.GT.NMAX) CALL MSGDMP('E', 'SZSTTV',
     +     'WORKING AREA OVER FLOW (TOO MANY POINTS)')
        VXX(NN) = VX
        VYY(NN) = VY

      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCLTV

      IF (LFIRST) RETURN

      IF (NLINE.EQ.0) THEN

        IF (NN.GE.3) THEN
          CALL SZOPTP
          DO 200 I=1, NN
            CALL SZSTTP(VXX(I), VYY(I))
  200     CONTINUE
          CALL SZCLTP
        END IF
        RETURN

      ELSE

*       / PREPEARIG /

        DO 300 I=1, NLINE-1
          NLEN(I) = NBGN(I+1) - NBGN(I)
  300   CONTINUE
        NLEN(NLINE) = NN - NBGN(NLINE) + NBGN(1)

        DO 310 I=1, NLINE
          NSTAT(I) = 0
          IF (NLEN(I).LE.2) NSTAT(I) = 2
          NBG = NBGN(I)
          POS(I) = POSBD(VXX(NBG), VYY(NBG))
  310   CONTINUE

*       / SCANNING STARTING POINT /

  400   CONTINUE

          NX = 0
          DO 410 ILINE=1, NLINE
            IF (NSTAT(ILINE).EQ.0) GO TO 420
  410     CONTINUE
          RETURN

  420     CONTINUE
          NSTAT(ILINE) = 1
          CALL SZOPTP
  430     CONTINUE
          NEND = NBGN(ILINE) + NLEN(ILINE) - 1

          DO 440 J = NBGN(ILINE), NEND
            NX = NX + 1
            JJ = MOD(J-1, NN) + 1
            CALL SZSTTP(VXX(JJ), VYY(JJ))
  440     CONTINUE
          NEND = MOD(NEND-1, NN) + 1
          POS0 = POSBD(VXX(NEND), VYY(NEND))

*         / SEARCH NEXT LINE /

          DIF0 = 4
          DO 450 I=1, NLINE
            IF (NSTAT(I).EQ.2) GO TO 450
            DIF = RMOD(POS(I) - POS0 + EP2, 4.)
            IF (DIF.GE.DIF0) GO TO 450
            IF (NLEN(I).LE.2) GO TO 450
            ILINE = I
            DIF0 = DIF
  450     CONTINUE

*         / BOUNDARY /

          POS1 = POS(ILINE)
          NS0 = POS0 + 1
          NS1 = POS1 + 1
          NST  = NS0 + 1
          NEND = NS0 + IMOD(NS1 - NS0, 4)
          IF (NS0.EQ.NS1 .AND. POS0.GT.POS1+EP2) NEND = NEND +4

          DO 600 I=NST, NEND
            II = IMOD(I-1, 4) + 1
            CALL SZSTTP(BDX(II), BDY(II))
  600     CONTINUE

          IF (NSTAT(ILINE).EQ.0) THEN
            NSTAT(ILINE) = 2
            GO TO 430
          END IF
          NSTAT(ILINE) = 2
          CALL SZCLTP

        GO TO 400

      END IF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPMZV(N,VPX,VPY)

      REAL      VPX(*),VPY(*)

      LOGICAL   LFLAG

      COMMON    /SZBPM1/ LMISS,RMISS,NPM
      LOGICAL   LMISS
      COMMON    /SZBPM2/ CMARK
      CHARACTER CMARK*1

      SAVE


      DO 10 I=1,N,NPM
        LFLAG=LMISS .AND. (VPX(I).EQ.RMISS .OR. VPY(I).EQ.RMISS)
        IF (.NOT.LFLAG) THEN
          CALL SZTXZV(VPX(I),VPY(I),CMARK)
        END IF
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DCLPAR

      LOGICAL   LCHREQ
      CHARACTER CGRP*3

      EXTERNAL  LCHREQ
      EXTERNAL  GLPQNP,GLPQCP,GLPQVL
      EXTERNAL  GLCQNP,GLCQCP,GLCQVL
      EXTERNAL  SGPQNP,SGPQCP,SGPQVL
      EXTERNAL  SWPQNP,SWPQCP,SWPQVL
      EXTERNAL  SWCQNP,SWCQCP,SWCQVL
      EXTERNAL  UCPQNP,UCPQCP,UCPQVL
      EXTERNAL  UDPQNP,UDPQCP,UDPQVL
      EXTERNAL  UEPQNP,UEPQCP,UEPQVL
      EXTERNAL  UGPQNP,UGPQCP,UGPQVL
      EXTERNAL  ULPQNP,ULPQCP,ULPQVL
      EXTERNAL  UMPQNP,UMPQCP,UMPQVL
      EXTERNAL  USPQNP,USPQCP,USPQVL
      EXTERNAL  UZPQNP,UZPQCP,UZPQVL


      CALL OSQARN(NP)
      IF (NP.EQ.0) THEN
        CALL GLIGET('IIUNIT',II)
        CALL GLIGET('IOUNIT',IO)
        WRITE(IO,*) ' GROUP NAME (C*3) (EX. GLP) ? ;'
        READ(II,*) CGRP
      ELSE
        CALL OSGARG(1,CGRP)
      END IF

      IF (LCHREQ(CGRP,'GLP')) THEN
        CALL DCLPPZ(GLPQNP,GLPQCP,GLPQVL)
      ELSE IF (LCHREQ(CGRP,'GLC')) THEN
        CALL DCLCPZ(GLCQNP,GLCQCP,GLCQVL)
      ELSE IF (LCHREQ(CGRP,'SGP')) THEN
        CALL DCLPPZ(SGPQNP,SGPQCP,SGPQVL)
      ELSE IF (LCHREQ(CGRP,'SWP')) THEN
        CALL DCLPPZ(SWPQNP,SWPQCP,SWPQVL)
      ELSE IF (LCHREQ(CGRP,'SWC')) THEN
        CALL DCLCPZ(SWCQNP,SWCQCP,SWCQVL)
      ELSE IF (LCHREQ(CGRP,'UCP')) THEN
        CALL DCLPPZ(UCPQNP,UCPQCP,UCPQVL)
      ELSE IF (LCHREQ(CGRP,'UDP')) THEN
        CALL DCLPPZ(UDPQNP,UDPQCP,UDPQVL)
      ELSE IF (LCHREQ(CGRP,'UEP')) THEN
        CALL DCLPPZ(UEPQNP,UEPQCP,UEPQVL)
      ELSE IF (LCHREQ(CGRP,'UGP')) THEN
        CALL DCLPPZ(UGPQNP,UGPQCP,UGPQVL)
      ELSE IF (LCHREQ(CGRP,'ULP')) THEN
        CALL DCLPPZ(ULPQNP,ULPQCP,ULPQVL)
      ELSE IF (LCHREQ(CGRP,'UMP')) THEN
        CALL DCLPPZ(UMPQNP,UMPQCP,UMPQVL)
      ELSE IF (LCHREQ(CGRP,'USP')) THEN
        CALL DCLPPZ(USPQNP,USPQCP,USPQVL)
      ELSE IF (LCHREQ(CGRP,'UZP')) THEN
        CALL DCLPPZ(UZPQNP,UZPQCP,UZPQVL)
      END IF

      END
*-----------------------------------------------------------------------
      SUBROUTINE DCLPPZ(XXPQNP,XXPQCP,XXPQVL)

      LOGICAL   LP
      CHARACTER CP*8,CP1*1

      EQUIVALENCE (IP,RP,LP)


      CALL GLIGET('IOUNIT',IU)

      CALL XXPQNP(NCP)
      DO 10 N=1,NCP
        CALL XXPQCP(N,CP)
        CALL XXPQVL(N,IP)
        CP1=CP(1:1)
        CALL CUPPER(CP1)
        IF (      CP1.EQ.'I' .OR. CP1.EQ.'J' .OR. CP1.EQ.'K'
     +       .OR. CP1.EQ.'M' .OR. CP1.EQ.'N' ) THEN
          WRITE(IU,'(A8,A3,I10)') CP,' = ',IP
        ELSE IF ( CP1.EQ.'L') THEN
          WRITE(IU,'(A8,A3,L10)') CP,' = ',LP
        ELSE
          WRITE(IU,'(A8,A3,1P,E16.8)') CP,' = ',RP
        END IF
   10 CONTINUE

      END
*-----------------------------------------------------------------------
      SUBROUTINE DCLCPZ(XXCQNP,XXCQCP,XXCQVL)

      LOGICAL   LP
      CHARACTER CP*8,CPARA*1024

      EQUIVALENCE (IP,RP,LP)


      CALL GLIGET('IOUNIT',IU)

      CALL XXCQNP(NCP)
      DO 10 N=1,NCP
        CALL XXCQCP(N,CP)
        CALL XXCQVL(N,CPARA)
        WRITE(IU,'(A8,A3,A)') CP,' = ',CPARA(1:LENC(CPARA))
   10 CONTINUE

      END

*-----------------------------------------------------------------------
C     SUBROUTINE RFFTF(N,R,WSAVE)
C
C     SUBROUTINE RFFTF COMPUTES THE FOURIER COEFFICIENTS OF A REAL
C     PERODIC SEQUENCE (FOURIER ANALYSIS). THE TRANSFORM IS DEFINED
C     BELOW AT OUTPUT PARAMETER R.
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE ARRAY R TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C             N MAY CHANGE SO LONG AS DIFFERENT WORK ARRAYS ARE PROVIDED
C
C     R       A REAL ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C             TO BE TRANSFORMED
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.
C             IN THE PROGRAM THAT CALLS RFFTF. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE RFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY RFFTF AND RFFTB.
C
C
C     OUTPUT PARAMETERS
C
C     R       R(1) = THE SUM FROM I=1 TO I=N OF R(I)
C
C             IF N IS EVEN SET L =N/2   , IF N IS ODD SET L = (N+1)/2
C
C               THEN FOR K = 2,...,L
C
C                  R(2*K-2) = THE SUM FROM I = 1 TO I = N OF
C
C                       R(I)*COS((K-1)*(I-1)*2*PI/N)
C
C                  R(2*K-1) = THE SUM FROM I = 1 TO I = N OF
C
C                      -R(I)*SIN((K-1)*(I-1)*2*PI/N)
C
C             IF N IS EVEN
C
C                  R(N) = THE SUM FROM I = 1 TO I = N OF
C
C                       (-1)**(I-1)*R(I)
C
C      *****  NOTE
C                  THIS TRANSFORM IS UNNORMALIZED SINCE A CALL OF RFFTF
C                  FOLLOWED BY A CALL OF RFFTB WILL MULTIPLY THE INPUT
C                  SEQUENCE BY N.
C
C     WSAVE   CONTAINS RESULTS WHICH MUST NOT BE DESTROYED BETWEEN
C             CALLS OF RFFTF OR RFFTB.
C
      SUBROUTINE RFFTF (N,R,WSAVE)
      DIMENSION       R(*)       ,WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      CALL RFFTF1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     TMSTLC : THE ROUTINE FOR DRAWING STREAM LINES
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD DENNOU CLUB. ALL RIGHTS RESERVED.
*-----------------------------------------------------------------------
      SUBROUTINE TMSTLC( X, Y, U, V, NX, NY )

      IMPLICIT NONE

*-- AGREENMENT
      INTEGER  NX        !* GRID NUMBERS FOR X-DIRECTION
      INTEGER  NY        !* GRID NUMBERS FOR Y-DIRECTION
      REAL     U(NX,NY)  !* VECTOR COMPONENT OF X-DIRECTION
      REAL     V(NX,NY)  !* VECTOR COMPONENT OF Y-DIRECTION
      REAL     X(NX)     !* GRID POINTS OF X-DIRECTION [UNIT:LENGTH]
      REAL     Y(NY)     !* GRID POINTS OF Y-DIRECTION [UNIT:LENGTH]

*-- INTERNAL VARIABLES
      REAL     TRX(NX*NY,2)     !* STREAM LINE OF X-COORDINATE
      REAL     TRY(NX*NY,2)     !* STREAM LINE OF Y-COORDINATE
      INTEGER  I, J, K          !* TMP VALUES
      INTEGER  COUNTER          !* NUMBER OF STREAM LINE FOR DRAW
      INTEGER  TOTNM(NX*NY,2)   !* ARRAY NUMBER IN TOTAL STREAM LINES AT END
      INTEGER  TOTSNM(NX*NY,2)  !* ARRAY NUMBER IN TOTAL STREAM LINES AT START
      REAL     ARROW_THRES
      REAL     DXA, DYA
      REAL     ARROW_LENG
      REAL     VXMIN, VXMAX, VYMIN, VYMAX
      REAL     UXMIN, UXMAX, UYMIN, UYMAX
      REAL     VXRATIO, VYRATIO
      REAL     CIRC_FLAG
      REAL     UNDEF
      INTEGER  N, M, IBLKGE, ARRCNT
      LOGICAL  NO_SHORT, END_ARR

*-- GETTING TMPACK'S PARAMETERS
      CALL TMRGET( 'ARRWINTV', ARROW_THRES )
      CALL TMLGET( 'NODRSHRT', NO_SHORT )
      CALL TMLGET( 'ENDARROW', END_ARR )
      CALL GLRGET( 'RMISS', UNDEF )
      CALL GLLSET( 'LMISS', .TRUE. )

*-- GETTING VIEWPORT PARAMETERS
      CALL SGQVPT( VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGQWND( UXMIN, UXMAX, UYMIN, UYMAX)
      VXRATIO=(VXMAX-VXMIN)/(UXMAX-UXMIN)
      VYRATIO=(VYMAX-VYMIN)/(UYMAX-UYMIN)

*-- DOING TMSTLN ROUTINE
      CALL TMSTLN( X, Y, U, V, NX, NY, TRX, TRY, TOTNM )

*-- GETTING STREAM LINE NUMBERS
      CALL TMIGET( 'STLNNUM', COUNTER )

*-- SETTING PARAMETER FOR ARROW. (NOW, CONSTANT VALUES)
      CALL SGLSET('LPROP',.FALSE.)
      CALL SGRSET('CONST',0.01)

*-- SETTING START NUMBERS IN TOTAL STREAM LINES
      TOTSNM(1,1:2)=1
      DO 10 I=2,COUNTER
         TOTSNM(I,1)=TOTNM(I-1,1)+1
         TOTSNM(I,2)=TOTNM(I-1,2)+1
 10   CONTINUE

*-- DRAWING STREAM LINES
      DO 82 K=1,2
         DO 81 I=1,COUNTER

*-- CALCULATING THE INTERVAL LENGTH OF DRAWING ARROWS.
            ARROW_LENG=0.0
            ARRCNT=0
            IF(((TOTNM(I,K)-TOTSNM(I,K)+1).GT.1).AND.
     &         ((TOTNM(I,K)-TOTSNM(I,K)+1).LE.NX*NY))THEN
               DO 80 J=TOTSNM(I,K)+1,TOTNM(I,K)
                  IF(TRX(J,K).NE.UNDEF.AND.TRY(J,K).NE.UNDEF.AND.
     &               TRX(J-1,K).NE.UNDEF.AND.TRY(J-1,K).NE.UNDEF
     &               )THEN
                     DXA=(TRX(J,K)-TRX(J-1,K))*VXRATIO
                     DYA=(TRY(J,K)-TRY(J-1,K))*VYRATIO
                     ARROW_LENG=ARROW_LENG+SQRT(DXA*DXA+DYA*DYA)
                     IF(ARROW_LENG.GE.ARROW_THRES)THEN
                        CALL SGLAU( TRX(J-1,K), TRY(J-1,K),
     &                              TRX(J,K), TRY(J,K) )
                        ARROW_LENG=0.0
                        ARRCNT=ARRCNT+1
                     END IF
                  END IF
 80            CONTINUE

*-- IF NO_SHORT IS TRUE, NO DRAWING STREAM LINE WHOSE ARROW NUMBER IS ZERO
*-- 流線の始点と終点が近似点にいれば, 閉じた流線とみなして描く.
*-- 矢羽は終点に描く.
               IF(ARRCNT.EQ.0)THEN
                  IF(NO_SHORT.EQV..TRUE.)THEN
                     IF((TOTNM(I,K)-TOTSNM(I,K)+1).LE.2)THEN
                        GO TO 81
                     ELSE
                        N=IBLKGE( X, NX, TRX(TOTSNM(I,K),K) )
                        M=IBLKGE( X, NX, TRX(TOTNM(I,K),K) )
                        IF(ABS(N-M).GT.1)THEN
                           GO TO 81
                        ELSE
*-- 一周しているのか, 短いだけなのかのチェック
*--  始点, 終点, 終点１つ前の順に増減していれば一周.
                           CIRC_FLAG=
     &                        (TRX(TOTNM(I,K),K)-TRX(TOTNM(I,K)-1,K))
     &                        *(TRX(TOTSNM(I,K),K)-TRX(TOTNM(I,K),K))
                           IF(CIRC_FLAG.LT.0.0)THEN  ! 単に短いだけ
                              GO TO 81
                           ELSE
                              N=IBLKGE( Y, NY, TRY(TOTSNM(I,K),K) )
                              M=IBLKGE( Y, NY, TRY(TOTNM(I,K),K) )
                              IF(ABS(N-M).GT.1)THEN
                                 GO TO 81
                              ELSE
                                 CIRC_FLAG=
     &                         (TRY(TOTNM(I,K),K)-TRY(TOTNM(I,K)-1,K))
     &                         *(TRY(TOTSNM(I,K),K)-TRY(TOTNM(I,K),K))
                                 IF(CIRC_FLAG.LT.0.0)THEN
                                    GO TO 81
!                                 ELSE
!                                 CALL SGLAU( TRX(TOTNM(I,K)-1,K), TRY(TOTNM(I,K)-1,K),
!     &                                       TRX(TOTNM(I,K),K), TRY(TOTNM(I,K),K) )
                                 END IF
                              END IF
                           END IF
                        END IF
                     END IF
                  ELSE
                     IF(END_ARR.EQV..TRUE.)THEN
                        CALL SGLAU( TRX(TOTNM(I,K)-1,K),
     &                              TRY(TOTNM(I,K)-1,K),
     &                              TRX(TOTNM(I,K),K),
     &                              TRY(TOTNM(I,K),K) )
                     END IF
                  END IF
               END IF

               CALL UULIN( (TOTNM(I,K)-TOTSNM(I,K)+1),
     &                     TRX(TOTSNM(I,K):TOTNM(I,K),K),
     &                     TRY(TOTSNM(I,K):TOTNM(I,K),K) )

            END IF

 81      CONTINUE

 82   CONTINUE

      CALL MSGDMP( 'M', 'TMSTLC', 'DRAWING FINISHED.' )

      END SUBROUTINE TMSTLC

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPLZU(N,UPX,UPY)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG

      COMMON    /SZBPL1/ LMISS,RMISS
      LOGICAL   LMISS

      SAVE


      CALL SZOPLU

      IF (.NOT.LMISS) THEN
        CALL SZMVLU(UPX(1),UPY(1))
        DO 10 I=2,N
          CALL SZPLLU(UPX(I),UPY(I))
   10   CONTINUE
      ELSE
        LFLAG=.FALSE.
        DO 20 I=1,N
          IF (UPX(I).EQ.RMISS .OR. UPY(I).EQ.RMISS) THEN
            LFLAG=.FALSE.
          ELSE IF (LFLAG) THEN
            CALL SZPLLU(UPX(I),UPY(I))
          ELSE
            CALL SZMVLU(UPX(I),UPY(I))
            LFLAG=.TRUE.
          END IF
   20   CONTINUE
      END IF

      CALL SZCLLU

      END

!-------------------------------------------------
!     UUpack module
!-------------------------------------------------
module uupack
  use dcl_common
  contains
!-----------------------------------------------

    subroutine DclSetErrorBarLineType(type)  !エラーバーのラインタイプを指定する．  
      integer,   intent(in) :: type

      call prcopn('DclSetErrorBarLineType')
      call uusebt(type)
      call prccls('DclSetErrorBarLineType')
    end subroutine

    function DclGetErrorBarLineType()   
      integer  :: DclGetErrorBarLineType

      call prcopn('DclGetErrorBarLineType')
      call uuqebt(DclGetErrorBarLineType)
      call prccls('DclGetErrorBarLineType')
    end function

    subroutine DclSetErrorBarLineIndex(index)  !エラーバーのラインインデクスを指定する．
      integer,   intent(in) :: index

      call prcopn('DclSetErrorBarLineIndex')
      call uusebi(index) 
      call prccls('DclSetErrorBarLineIndex')
    end subroutine

    function DclGetErrorBarLineIndex()
      integer  :: DclGetErrorBarLineIndex

      call prcopn('DclGetErrorBarLineIndex')
      call uuqebi(DclGetErrorBarLineIndex) 
      call prccls('DclGetErrorBarLineIndex')
    end function

    subroutine DclSetErrorBarWidth(width)  !エラーバーの横幅を指定する．
      real,      intent(in) :: width

      call prcopn('DclSetErrorBarWidth')
      call uusebs(width)
      call prccls('DclSetErrorBarWidth')
    end subroutine
    
    function DclGetErrorBarWidth()
      real     :: DclGetErrorBarWidth

      call prcopn('DclGetErrorBarWidth')
      call uuqebs(DclGetErrorBarWidth)
      call prccls('DclGetErrorBarWidth')
    end function
    
    subroutine DclSetBarWidth(width)  !棒グラフの横巾を指定する．
      real,      intent(in) :: width

      call prcopn('DclSetBarWidth')
      call uusbrs(width)
      call prccls('DclSetBarWidth')
    end subroutine

    function DclGetBarWidth()
      real     :: DclGetBarWidth

      call prcopn('DclGetBarWidth')
      call uuqbrs(DclGetBarWidth)
      call prccls('DclGetBarWidth')
    end function

    subroutine DclSetAreaPattern(pattern1,pattern2)  ! 内部領域を塗るトーンパターンを指定する．
      integer,   intent(in) :: pattern1, pattern2

      call prcopn('DclSetAreaPattern')
      call uusarp(pattern1,pattern2)
      call prccls('DclSetAreaPattern')
    end subroutine

    subroutine DclGetAreaPattern(pattern1,pattern2)
      integer,   intent(out) :: pattern1, pattern2

      call prcopn('DclGetAreaPattern')
      call uuqarp(pattern1,pattern2)
      call prccls('DclGetAreaPattern')
    end subroutine

    subroutine DclSetFrameType(type)  !枠の属性を指定する．
      integer,   intent(in) :: type

      call prcopn('DclSetFrameType')
      call uusfrt(type)
      call prccls('DclSetFrameType')
    end subroutine

    function DclGetFrameType()
      integer  :: DclGetFrameType

      call prcopn('DclGetFrameType')
      call uuqfrt(DclGetFrameType)
      call prccls('DclGetFrameType')
    end function

    subroutine DclSetFrameIndex(index)  !枠のラインインデクスを指定する．
      integer,   intent(in) :: index

      call prcopn('DclSetFrameIndex')
      call uusfri(index)
      call prccls('DclSetFrameIndex')
    end subroutine

    function DclGetFrameIndex()
      integer :: DclGetFrameIndex

      call prcopn('DclGetFrameIndex')
      call uuqfri(DclGetFrameIndex)
      call prccls('DclGetFrameIndex')
    end function
    
end module

*-----------------------------------------------------------------------
*     UDGCLB
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDGCLB(Z,MX,NX,NY,DX)

      REAL      Z(MX,*)

      INTEGER   NS(2),NP(2),NQ(2)

      EXTERNAL  RVMIN,RVMAX,RGNGE,IRLE,IRGE


      CALL GLLGET('LMISS',LMISS)
      CALL GLRGET('RMISS',RMISS)

      NS(1)=MX
      NS(2)=NY
      NP(1)=1
      NP(2)=1
      NQ(1)=NX
      NQ(2)=NY
      XMIN=RVMIN(Z,NS,NP,NQ,2)
      XMAX=RVMAX(Z,NS,NP,NQ,2)

      IF (XMIN.EQ.XMAX) RETURN

      IF (DX.GT.0) THEN
        DZ=DX
      ELSE IF (DX.EQ.0) THEN
        CALL UDIGET('NLEV',NLEV)
        DZ=RGNGE((XMAX-XMIN)/NLEV)
      ELSE
        NL=MAX(1,NINT(ABS(DX)))
        DZ=RGNGE((XMAX-XMIN)/NL)
      END IF
      ZMIN=IRLE(XMIN/DZ)*DZ
      ZMAX=IRGE(XMAX/DZ)*DZ

      CALL UDGCLA(ZMIN,ZMAX,DZ)

      END

      PROGRAM USPAC2

      PARAMETER( NMAX=201, IMAX=5 )
      REAL X(NMAX), Y0(NMAX), Y1(NMAX), Y2(NMAX), A(IMAX)

      PI = 3.14159
      DO 10 I=1,IMAX
        II = 2*I - 1
        A(I) = (-1)**I *2./(II*PI)
   10 CONTINUE

      DO 20 N=1,NMAX
        X(N)  = 1.*(N-1)/(NMAX-1)
        T     = 2.*PI*X(N)
        IF(T.LT.PI/2. .OR. T.GE.PI*3./2.) THEN
          Y0(N) = 0.
        ELSE
          Y0(N) = 1.
        END IF
        Y1(N) = 0.5 + A(1)*COS(T) 
        Y2(N) = 0.5
        DO 30 I=1,IMAX
          II = 2*I - 1
          Y2(N) = Y2(N) + A(I)*COS(II*T)
   30   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL USSPNT( NMAX, X, Y0 )
      CALL USSPNT( NMAX, X, Y1 )
      CALL USSPNT( NMAX, X, Y2 )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'FREQUENCY', '/DAY', 'RESPONSE', ' ' )
      CALL USDAXS

      CALL UULIN( NMAX, X, Y0 )
      CALL UUSLNT( 2 )
      CALL UUSLNI( 3 )
      CALL UULIN( NMAX, X, Y1 )
      CALL UUSLNT( 3 )
      CALL UULIN( NMAX, X, Y2 )

      CALL GRCLS

      END

program layout04

  use dcl

    call DclOpenGraphics()

    call DclSetParm( 'GRAPH:lfull', .true. )
    call DclSetFrameMargin( 0., 0., 0.08, 0.08 )
    call DclSetAspectRatio( 1., 0.6 )
    call DclSetFrameTitle( 'figure title', 't',  0.,  0., 0.03, 1 )
    call DclSetFrameTitle( 'program.name', 'b', -1., -1., 0.02, 2 )
    call DclSetFrameTitle( 'page:#page',   'b',  1., -1., 0.02, 3 )

    call DclNewFrame
    call DclSetViewPort( 0.1,0.9,0.06,0.54 )
    call DclDrawViewportFrame( 1 )
    call DclDrawTextNormalized( 0.5, 0.5, 'figure' )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     UEZCHK
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEZCHK(Z,MX,NX,NY,CNAME,ISTAT)

      REAL      Z(MX,*)
      CHARACTER CNAME*(*)

      INTEGER   NSX(2),NPX(2),NQX(2)
      LOGICAL   LMISS,LSET,LTONE,LMADA
      CHARACTER CMSG*80

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)


*     / GET INTERNAL PARAMETERS /

      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )

*     / CHECK MIN & MAX /

      NSX(1)=MX
      NSX(2)=NY
      NPX(1)=1
      NPX(2)=1
      NQX(1)=NX
      NQX(2)=NY
      RMINZ=RVMIN(Z,NSX,NPX,NQX,2)
      RMAXZ=RVMAX(Z,NSX,NPX,NQX,2)

      LMADA = LMISS .AND. RMINZ.EQ.RMISS .AND. RMAXZ.EQ.RMISS
      ISTAT = 0

      IF (LMADA .OR. RMINZ.EQ.RMAXZ) THEN

*       / MESSAGE FOR MISSING OR CONSTANT FIELD /

        IF (LMADA) THEN
          CMSG='MISSING FIELD.'
          ISTAT = 1
        ELSE
          CMSG='CONSTANT (##########) FIELD.'
          WRITE(CMSG(11:20),'(1P,E10.3)') RMINZ
          ISTAT = 2
        END IF
        CALL MSGDMP('W',CNAME,CMSG)
      END IF

*     / GENERATE TONE LEVELS IF THEY HAVE NOT BEEN GENERATED YET /

      CALL UEQTLZ(LSET)
      IF (.NOT.LSET) THEN
        CALL UELGET('LTONE',LTONE)
        IF (LTONE) THEN
          CALL UEIGET('NLEV',NLEV)
          CALL UEGTLB(Z,MX,NX,NY,-REAL(NLEV))
        ELSE
          CALL UEIGET('IPAT',IPAT)
          CALL UERGET('RLEV',RLEV)
          CALL UESTLV(RMISS,RLEV,IPAT)
        END IF
        CALL UESTLZ(.FALSE.)
      END IF

      END

!-------------------------------------------------
!  UZpack module
!-------------------------------------------------
module uzpack
  use dcl_common
  contains

!------------------------------ !文字の大きさ等をすべて何倍かする．
    subroutine DclSetAxisFactor(fact)
      real,      intent(in) :: fact       !倍率

      call prcopn('DclSetAxisFactor')
      call uzfact(fact) 
      call prccls('DclSetAxisFactor')
    end subroutine
end module

*-----------------------------------------------------------------------
*     UMSPWD : WINDOW MODE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMSPWD

      COMMON    /UMWK1/ITR, RUNDEF, IUNDEF, PI, CPR, CPD, CP

      SAVE


      CALL SGQMPL(PLX, PLY, PLROT)
      IF (PLX.NE.RUNDEF .AND. PLY.NE. RUNDEF .AND.
     +    PLROT.NE.RUNDEF ) RETURN

      CALL SGQWND (UXMIN, UXMAX, UYMIN, UYMAX)

      IF (UXMIN.EQ.RUNDEF .OR. UXMAX.EQ.RUNDEF .OR.
     +    UYMIN.EQ.RUNDEF .OR. UYMAX.EQ.RUNDEF ) RETURN

      DX = UXMAX - UXMIN
      IF ( DX .LE. 0. ) DX = DX + 2*PI*CPR
      PLX = UXMIN + DX/2.

      IF (ITR.GE.30) THEN
        PLY = (UYMIN+UYMAX)/2.
      ELSE
        PLY =  CPD*90.
      END IF

      CALL SGSMPL(PLX, PLY, 0.)

*------------------------ STANDARD LATITUDE ---------------------------

      CALL SGRGET('STLAT1',STLAT1)
      CALL SGRGET('STLAT2',STLAT2)

      IF (ITR.EQ.20 .OR. ITR.EQ.21 .OR. ITR.EQ.23) THEN
        IF (UYMIN.NE.RUNDEF .AND. UYMAX.NE.RUNDEF) THEN
	  IF (STLAT1 .EQ. RUNDEF) STLAT1 =  (UYMIN+UYMAX)/2.
          IF (STLAT1 .EQ. 0.) CALL MSGDMP ('E', 'UMSPWD',
     +                 'INVALID WINDOW FOR CONICAL PROJECTION.')
        ELSE
          IF (STLAT1 .EQ. RUNDEF) STLAT1 = CPD*35
        END IF
        CALL SGRSET('STLAT1',STLAT1)
      ELSE IF (ITR .EQ. 22) THEN
        IF (UYMIN.NE.RUNDEF .AND. UYMAX.NE.RUNDEF) THEN
          IF (STLAT1 .EQ. RUNDEF) STLAT1 = UYMIN
          IF (STLAT2 .EQ. RUNDEF) STLAT2 = UYMAX
	ELSE
          IF (STLAT1 .EQ. RUNDEF) STLAT1 = CPD*35
          IF (STLAT2 .EQ. RUNDEF) STLAT2 = CPD*45
        END IF
        CALL SGRSET('STLAT1', STLAT1)
        CALL SGRSET('STLAT2', STLAT2)
      END IF

      END

*-----------------------------------------------------------------------
*     UMSPPT : SET MAP POLE (POINTS)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMSPPT

      COMMON    /UMWK1/ITR, RUNDEF, IUNDEF, PI, CPR, CPD, CP

      SAVE


      CALL SGQMPL(PLX, PLY, PLROT)
      IF (PLX.NE.RUNDEF .AND. PLY.NE. RUNDEF .AND.
     +    PLROT.NE.RUNDEF ) RETURN

      CALL UMQPTN(NDATA)
      IF (NDATA.EQ.0) RETURN

      X2 = 0
      Y2 = 0
      CALL UMQPNT(1, UXZ, UYZ)
      DO 20 I=1, NDATA
        CALL UMQPNT(I, UXZ, UYZ)
        YMAX = MAX(YMAX, UYZ)
        YMIN = MIN(YMIN, UYZ)
        UXR = UXZ/CPR
        UYR = UYZ/CPR
        X2 = X2 + COS(UXR)
        Y2 = Y2 + SIN(UXR)
        CALL CT3SC(1., PI/2.-UYR, UXR, X, Y, Z)
        X3 = X3+X
        Y3 = Y3+Y
        Z3 = Z3+Z
   20 CONTINUE
      UXC = ATAN2(Y2,X2)*CPR
      UYC = (YMAX + YMIN)/2.

      IF (10.LE.ITR .AND. ITR.LE.19) THEN
        PLX = UXC
        PLY = 90.*CPD
      ELSE IF (20.LE.ITR .AND. ITR.LE.24) THEN
        PLX = UXC
        PLY = 90.*CPD

        IF (UYC .EQ. 0) CALL MSGDMP ('E', 'UMSPPT',
     +    'INVALID WINDOW FOR CONICAL PROJECTION.')
        CALL SGRGET('STLAT1',STLAT1)
        CALL SGRGET('STLAT2',STLAT2)

        IF (ITR .EQ. 22) THEN
          IF (STLAT1 .EQ. RUNDEF) STLAT1 = MAX(YMIN, -89.*CPD)
          IF (STLAT2 .EQ. RUNDEF) STLAT2 = MIN(YMAX,  89.*CPD)
          CALL SGRSET('STLAT1', STLAT1)
          CALL SGRSET('STLAT2', STLAT2)
        ELSE
          IF (STLAT1 .EQ. RUNDEF) STLAT1 =  UYC
          CALL SGRSET('STLAT1',STLAT1)
        END IF
      ELSE IF (30.LE.ITR .AND. ITR.LE.34) THEN
        CALL CT3CS(X3, Y3, Z3, R, TH, UXR)
        PLX = UXR*CPR
        PLY = (PI/2.-TH)*CPR
      END IF

      CALL SGSMPL(PLX, PLY, 0.)

      END

*-----------------------------------------------------------------------
*      USPACK NUMBER OF DIGIT                        S. Sakai  89/03/23
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USZDGT(UMIN,  UMAX,  DUL,   MAXDGT,
     #                  UOFF,  UFACT, NDGT,  LDGT)
      CHARACTER CDUL*12

      CALL GLRGET('RUNDEF', RUNDEF)
      IF(UMIN.GE.UMAX) CALL MSGDMP('E', 'USZDGT', 'NMIN MUST BE < NMAX')
      IF(DUL.LE.0) CALL MSGDMP('E', 'USZDGT', 'DUL MUST BE POSITIVE.')

      NMAX = IRLE(UMAX/DUL)
      NMIN = IRGE(UMIN/DUL)
      IF(UOFF.EQ.RUNDEF) THEN
        IUOFF = 0
        I1 = 1
      ELSE
        IUOFF = NINT(UOFF/DUL)
        I1 = 2
      ENDIF

*-----------------------------------------------------------------------

      DO 100 I = I1, 2
        UMAXF = (NMAX - IUOFF)*DUL
        UMINF = (NMIN - IUOFF)*DUL

        IF(UMINF.NE.0) NMN = IRLE( LOG10( ABS(UMINF) ) )
        IF(UMAXF.NE.0) NMX = IRLE( LOG10( ABS(UMAXF) ) )
        IF(UMINF.EQ.0) NMN = NMX
        IF(UMAXF.EQ.0) NMX = NMN

        NMXS = 0
        NMNS = 0
        IF(UMAXF.LT.0) NMXS = 1
        IF(UMINF.LT.0) NMNS = 1

        NDMAX = MAX(NMX, NMN)
        NDMAXS = MAX(NMX+NMXS, NMN+NMNS)
        WRITE(CDUL, '(E12.5)') DUL
        READ(CDUL, '(T10,I3)') NDD
        DO 50 J=4, 9
          IF(CDUL(J:J) .EQ. '0') GOTO 55
          NDD = NDD - 1
   50   CONTINUE
   55   CONTINUE

        NDTRY = NDMAXS - NDD + 1
        IF(NDTRY.LE.MAXDGT) GOTO 200

        NOFF = IRLE(LOG10(UMAXF-UMINF))
        DL = 1.D1**(NOFF+1)
        UOFF = IRLT(UMAXF/DL) * DL
        IUOFF = IRLE( UOFF / DUL )
  100 CONTINUE

      CALL MSGDMP('W', 'USLDGT',
     #            'LABEL WIDTH IS GREATER THAN MAXDGT')
  200 CONTINUE

      UOFF = DUL*IUOFF

*-----------------------------------------------------------------------

      IF(UFACT.NE.RUNDEF) THEN
        NFAC = IRLE(LOG10(UFACT))
        NDMAXS = NDMAXS - NFAC
        NDMAX  = NDMAX  - NFAC
        NDD    = NDD    - NFAC
      ENDIF

      IF(NDD.GE.0) THEN
        NDGT = NDMAXS + 1
        LDGT = 0
      ELSEIF(NDMAX .LE. 0) THEN
        NDGT = -NDD + 2
        IF(UMINF.LT.0) NDGT = NDGT+1
        LDGT = -NDD
      ELSE
        NDGT = NDMAXS - NDD + 2
        LDGT = -NDD
      ENDIF

      IF(UFACT.NE.RUNDEF) THEN
        IF(NDGT.GT.MAXDGT) CALL MSGDMP('W', 'USLDGT',
     #              'LABEL WIDTH IS GREATER THAN MAXDGT')
      ELSE
        IF(NDGT.LE.MAXDGT) THEN
          UFACT = 1.
        ELSE
          NDGT = NDMAXS - NDD + 1
          LDGT = 0
          UFACT = 1.D1**NDD
        ENDIF
      ENDIF

      RETURN
      END

*-----------------------------------------------------------------------
*     UIRQNP / UIRQID / UIRQCP / UIRQVL / UIRSVL
*-----------------------------------------------------------------------
      SUBROUTINE UIRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 5)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*9
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'HEIGHT   ' /, RX(1) / 1.0  /
      DATA      CPARAS(2) / 'DENSITY  ' /, RX(2) / 0.8  /
      DATA      CPARAS(3) / 'DIRECTION' /, RX(3) / 45.0 /
      DATA      CPARAS(4) / 'XLON     ' /, RX(4) / 90.0 /
      DATA      CPARAS(5) / 'YLAT     ' /, RX(5) / 45.0 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'EMBOSSMENT_HEIGHT ' /
      DATA      CPARAL(2) / 'EMBOSSMENT_DENSITY' /
      DATA      CPARAL(3) / 'LIGHT_DIRECTION' /
      DATA      CPARAL(4) / 'LIGHT_LONGITUDE' /
      DATA      CPARAL(5) / 'LIGHT_LATITUDE ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UIRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UIRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UIRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UI', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','UIRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UI', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UIRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVBRFZ(N,UPX,UPY1,UPY2,ITYPE,INDEX,RSIZE)

      REAL      UPX(*),UPY1(*),UPY2(*)

      LOGICAL   LMISS, LXUNI, LYC1, LYC2
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UVBRFZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UVBRFZ','LINE TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UVBRFZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UVBRFZ','LINE INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UVBRFZ','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UVBRFZ','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS )
      CALL GLLGET('LMISS' , LMISS )

      WRITE(COBJ,'(2I8,F8.5)') ITYPE, INDEX, RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVBRFZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)

      LXUNI = UPX(1).EQ.RUNDEF
      LYC1  = UPY1(1).EQ.RUNDEF
      LYC2  = UPY2(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/(N-1)
      END IF

      IF (LYC1 .OR. LYC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LXUNI) THEN
          UXX = UXMIN + DX*(I-1)
        ELSE
          UXX = UPX(I)
        END IF

        IF (LYC1) THEN
          UYY1 = UREF
        ELSE
          UYY1 = UPY1(I)
        END IF

        IF (LYC2) THEN
          UYY2 = UREF
        ELSE
          UYY2 = UPY2(I)
        END IF

        IF (.NOT.
     #    ((UXX.EQ.RMISS .OR. UYY1.EQ.RMISS .OR. UYY2.EQ.RMISS)
     #     .AND. LMISS)) THEN

          CALL STFTRF(UXX, UYY1, VXX, VY1)
          CALL STFTRF(UXX, UYY2, VXX, VY2)

          CALL SZOPLV
          CALL SZMVLV(VXX-RSIZE/2., VY2)
          CALL SZPLLV(VXX+RSIZE/2., VY2)
          CALL SZPLLV(VXX+RSIZE/2., VY1)
          CALL SZPLLV(VXX-RSIZE/2., VY1)
          CALL SZPLLV(VXX-RSIZE/2., VY2)
          CALL SZCLLV
        END IF
   20 CONTINUE

      CALL SWOCLS('UVBRFZ')

      END

program sample_2d02

  use dcl
  integer,parameter :: nx=18, ny=18
  real,parameter :: xmin=0, xmax=360, dx1=10, dx2=60
  real,parameter :: ymin=-90, ymax=90
  real,parameter :: pi=3.141592, drad=pi/180, dz=0.05
  integer,parameter :: my=6, nc=3

  real ::      p(0:nx, 0:ny), uy1(0:ny), uy2(0:my)
  character(len=nc),dimension(0:my) :: ch

    ch = (/ 'SP ', '60S', '30S', 'EQ ', '30N', '60N', 'NP ' /)

    do j = 0, ny
      alat = ( ymin + (ymax-ymin) * j/ny ) * drad
      slat = sin(alat)
      uy1(j) = slat
      do i = 0, nx
        alon = ( xmin + (xmax-xmin) * i/nx ) * drad
        p(i,j) = cos(alon) * (1-slat**2) * sin(2*pi*slat) + dz
      end do
    end do

    do j = 0, my
      alat = ( ymin + (ymax-ymin) * j/my ) * drad
      slat = sin(alat)
      uy2(j) = slat
    end do

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( xmin, xmax, uy1(1), uy1(ny) )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransFunction

    call DclDrawAxis( 'bt', dx2, dx1 )
    call DclDrawTitle( 'b', 'LONGITUDE', 0.0 )

    call DclDrawAxisSpecify( 'lr', uy2, uy1, ch )
    call DclDrawTitle( 'l', 'LATITUDE', 0.0 )

    call DclSetXEvenGrid( xmin, xmax, nx+1 )
    call DclSetYGrid( uy1 )

    call DclSetContourLabelFormat( '(f6.1)' )
    call DclSetContourLevel( p, 0.2 )
    call DclSetContourLine( 0.1, index=1, type=4, height=0.01 )

    call DclDrawContour( p )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2DF03

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=0, XMAX=360, DX1=10, DX2=60 )
      PARAMETER ( YMIN=-90, YMAX=90, MY=7, NC=3 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05 )

      PARAMETER ( XMNZ=60, XMXZ=300, NXZ=13, IXZ1=4 )
      PARAMETER ( IYZ1=4, NYZ=13 )

      REAL      P(NX, NY), UY1(NY), UY2(MY)
      CHARACTER CH(MY)*(NC)

      DATA      CH/ 'SP ', '60S', '30S', 'EQ ', '30N', '60N', 'NP ' /


      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
   10   CONTINUE
   20 CONTINUE

      DO 30 J = 1, NY
        UY1(J) = SIN( ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD )
   30 CONTINUE
      DO 40 J = 1, MY
        UY2(J) = SIN( ( YMIN + (YMAX-YMIN) * (J-1) / (MY-1) ) * DRAD )
   40 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, UY1(1), UY1(NY) )
      CALL GRSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UXAXDV( 'B', DX1, DX2 )
      CALL UXAXDV( 'T', DX1, DX2 )
      CALL UXSTTL( 'B', 'LONGITUDE', 0.0 )

      CALL UYAXLB( 'L', UY1, NY, UY2, CH, NC, MY )
      CALL UYAXLB( 'R', UY1, NY, UY2, CH, NC, MY )
      CALL UYSTTL( 'L', 'LATITUDE', 0.0 )

      CALL UWSGXB( XMNZ, XMXZ, NXZ )
      CALL UWSGYA( UY1(IYZ1), NYZ )

      CALL UDCNTR( P(IXZ1,IYZ1), NX, NXZ, NYZ )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEAREA(XP,YP,ZP,VLVM,AX,AY,NP,NI,NG)

      INTEGER  NP(2),NI(2)
      REAL     XP(4),YP(4),ZP(4),VLVM(2),AX(*),AY(*)

      INTEGER  NNM(2),MM(2)
      REAL     XCM(4,2),YCM(4,2)
      LOGICAL  LPM(4,2),LCM(4,2),LBM(4,2),LCRNR,LSTRP

      SAVE


*     / FIND MIN. & MAX. VALUES AND CHECK STATUS OF EACH CORNER /

      ZPMAX=-REALMX
      ZPMIN=+REALMX
      DO 20 N=1,4
        IF (ZP(N).GT.ZPMAX) ZPMAX=ZP(N)
        IF (ZP(N).LT.ZPMIN) ZPMIN=ZP(N)
        LPM(N,1)=ZP(N).GE.VLVM(1)
        LPM(N,2)=ZP(N).LE.VLVM(2)
   20 CONTINUE

      DO 60 M=1,2

*       / CALCULATE CROSSING POINTS /

        NNM(M)=0
        DO 30 N=1,4
          N1=N
          N2=MOD(N,4)+1
          IF (LPM(N1,M).NEQV.LPM(N2,M)) THEN
            LCM(N,M)=.TRUE.
            NNM(M)=NNM(M)+1
            FC=(VLVM(M)-ZP(N1))/(ZP(N2)-ZP(N1))
            XCM(N,M)=XP(N1)+(XP(N2)-XP(N1))*FC
            YCM(N,M)=YP(N1)+(YP(N2)-YP(N1))*FC
          ELSE
            LCM(N,M)=.FALSE.
          END IF
   30   CONTINUE

*       / CHECK STATUS OF EACH LINE /

        DO 40 N=1,4
          N1=N
          N2=MOD(N+2,4)+1
          LBM(N,M)=.NOT.(LCM(N1,M).AND.LCM(N2,M))
   40   CONTINUE

*       / TREAT THE CONDITION WITH 4 LINES /

        IF (NNM(M).EQ.4) THEN
          NX=0
          RTMIN=+REALMX
          DO 50 N=1,4
            N1=N
            N2=MOD(N,4)+1
            RTX=SQRT((XCM(N2,M)-XCM(N1,M))**2+(YCM(N2,M)-YCM(N1,M))**2)
            IF (RTX.LT.RTMIN) THEN
              RTMIN=RTX
              NX=N
            END IF
   50     CONTINUE
          NL=MOD(NX-1,2)+1
          LBM(NL  ,M)=.TRUE.
          LBM(NL+2,M)=.TRUE.
        END IF

   60 CONTINUE

*     / SET CROSSING POINTS /

      NQ=0
      IF (NNM(1).EQ.0 .AND. NNM(2).EQ.0) THEN
        IF (VLVM(1).LE.ZPMIN .AND. ZPMAX.LE.VLVM(2)) THEN
          CALL VRSET0(XP,AX,4,1,1)
          CALL VRSET0(YP,AY,4,1,1)
          NQ=4
        END IF
      ELSE
        DO 80 N=1,4
          IF (LPM(N,1).AND.LPM(N,2)) THEN
            NQ=NQ+1
            AX(NQ)=XP(N)
            AY(NQ)=YP(N)
          END IF
          MMP=0
          IF (LCM(N,1).AND.LCM(N,2)) THEN
            MMP=2
            IF (LPM(N,1)) THEN
              MM(1)=2
              MM(2)=1
            ELSE
              MM(1)=1
              MM(2)=2
            END IF
          ELSE IF (LCM(N,1)) THEN
            MMP=1
            MM(1)=1
          ELSE IF (LCM(N,2)) THEN
            MMP=1
            MM(1)=2
          END IF
          DO 70 MP=1,MMP
            NQ=NQ+1
            AX(NQ)=XCM(N,MM(MP))
            AY(NQ)=YCM(N,MM(MP))
   70     CONTINUE
   80   CONTINUE
      END IF

*     / FIND THE NUMBER OF AREAS AND DO SOME TREATMENT /

      NG=0
      IF (NNM(1).EQ.4 .OR. NNM(2).EQ.4) THEN
        IF (LBM(2,1).AND.LBM(4,1).AND.LBM(2,2).AND.LBM(4,2)) THEN
          LCRNR=LPM(1,1).AND.LPM(1,2)
          LSTRP=(LPM(1,1).NEQV.LPM(1,2)) .AND. (LCM(1,1).AND.LCM(1,2))
          IF (LCRNR .OR. LSTRP) THEN
            IF (LCRNR) THEN
              NPT=3
            ELSE IF (LSTRP) THEN
              NPT=4
            END IF
            NG=2
            NP(1)=NQ-NPT
            NP(2)=NPT
            NI(1)=3
            NI(2)=NI(1)+NP(1)
            AX(NQ+1)=AX(1)
            AX(NQ+2)=AX(2)
            AY(NQ+1)=AY(1)
            AY(NQ+2)=AY(2)
          END IF
        ELSE IF (LBM(1,1).AND.LBM(3,1).AND.LBM(1,2).AND.LBM(3,2)) THEN
          LCRNR=LPM(2,1).AND.LPM(2,2)
          LSTRP=(LPM(2,1).NEQV.LPM(2,2)) .AND. (LCM(1,1).AND.LCM(1,2))
          IF (LCRNR .OR. LSTRP) THEN
            IF (LCRNR) THEN
              NPT=3
            ELSE
              NPT=4
            END IF
            NG=2
            NP(1)=NPT
            NP(2)=NQ-NPT
            NI(1)=1
            NI(2)=NI(1)+NP(1)
          END IF
        END IF
      END IF

      IF (NG.EQ.0 .AND. NQ.NE.0) THEN
        NG=1
        NP(1)=NQ
        NI(1)=1
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEAINT

      CALL GLRGET('REALMAX ',REALMX)

      RETURN
      END

*-----------------------------------------------------------------------
*     UDBSET
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDBSET(I,J,K,L,IBR)

      INTEGER   IBR(NBR,0:*)

      PARAMETER (MAXNB=32)

      INTEGER   MASK(MAXNB)
      LOGICAL   LFRST
      CHARACTER CBPAT*(MAXNB)

      COMMON    /UDBLK1/ NB,LX,LY,NBR

      SAVE

      DATA      LFRST/.TRUE./


      IF (LFRST) THEN
        IF (NB.NE.MAXNB) THEN
          CALL MSGDMP('E','UDBSET','MAXNB IS INAPPROPRIATE.')
        END IF
        DO 15 JJ=1,MAXNB
          DO 10 II=1,MAXNB
            IF (II.EQ.JJ) THEN
              CBPAT(II:II)='1'
            ELSE
              CBPAT(II:II)='0'
            END IF
   10     CONTINUE
          CALL CRVRS(CBPAT)
          CALL BITPCI(CBPAT,MASK(JJ))
   15   CONTINUE
        LFRST=.FALSE.
      END IF

      NN=LX*(LY*K+J)+I
      N1=NN/NB+1
      N2=MOD(NN,NB)
      IBR(N1,L)=IOR(IBR(N1,L),MASK(N2+1))

      END

*-----------------------------------------------------------------------
*     FONT LOADING
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZFINT(NCNT)

      INTEGER   JPOSX(*)
      REAL      WX1(*),WX2(*)
      CHARACTER CLX(*)*1,CLY(*)*1

      PARAMETER (NCHAR=256,LEN=6000)
      PARAMETER (MAXFS=2)
      PARAMETER (WUNIT=24,WUNIT2=WUNIT/2,PAD=0)

      INTEGER   IPOSX(NCHAR)
      REAL      VX1(NCHAR),VX2(NCHAR)
      LOGICAL   LPROP,LPROPZ
      CHARACTER CKX(LEN)*1,CKY(LEN)*1
      CHARACTER CPARA*8,CDSN*1024

      EXTERNAL  IUFOPN

      SAVE

      DATA      NCNTZ/0/
      DATA      IFONTZ/0/
      DATA      LPROPZ/.FALSE./


*     / CHECK FONT NUMBER & LFPROP OPTION /

      CALL SGIGET('IFONT',IFONT)
      CALL SGLGET('LFPROP',LPROP)

      IF (.NOT.(1.LE.IFONT .AND. IFONT.LE.MAXFS)) THEN
        CALL MSGDMP('E','SZINIT','FONT NUMBER IS OUT OF RANGE.')
      END IF

      IF ((IFONT.EQ.IFONTZ) .AND. (LPROPZ.EQV.LPROP)) THEN
        NCNT=NCNTZ
        RETURN
      ELSE
        NCNTZ=NCNTZ+1
        NCNT=NCNTZ
      END IF

*     / FONT LOADING /

      IF (IFONT.NE.IFONTZ) THEN

*       / INQUIRE FONT FILE NAMES /

        CPARA='FONT#'
        CALL CHNGI(CPARA,'#',IFONT,'(I1)')
        CALL SWQFNM(CPARA,CDSN)
        IF (CDSN.EQ.' ') THEN
          CALL MSGDMP('E','SZFONT','FONT FILE DOES NOT EXIST.')
        END IF

*       / OPEN FONT FILE : MAYBE SYSTEM DEPENDENT /

        IU=IUFOPN()
        OPEN(IU,FILE=CDSN,FORM='UNFORMATTED')
        REWIND(IU)

*       / LOAD TEXT FONT /

        READ(IU) IPOSX
        READ(IU) CKX
        READ(IU) CKY

*       / CLOSE FONT FILE /

        CLOSE(IU)

        IFONTZ=IFONT

      END IF

*     / FONT WIDTH /

      IF (LPROP) THEN

        DO 10 N=1,NCHAR
          IPS=IPOSX(N)
          VX1(N)=ICHAR(CKX(IPS))-64-PAD
          VX2(N)=ICHAR(CKY(IPS))-64+PAD
  10    CONTINUE

      ELSE

        CALL RSET0(VX1,NCHAR,1,-WUNIT2)
        CALL RSET0(VX2,NCHAR,1,+WUNIT2)

      END IF

      LPROPZ=LPROP

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQFNT(JPOSX,CLX,CLY)

      IF (NCNTZ.EQ.0) THEN
        CALL MSGDMP('E','SZQFNT','FONT FILE HAS NOT BEEN LOADED.')
      END IF

      CALL VISET0(IPOSX,JPOSX,NCHAR,1,1)
      DO 20 N=1,LEN
        CLX(N)=CKX(N)
        CLY(N)=CKY(N)
   20 CONTINUE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQFNW(WX1,WX2)

      IF (NCNTZ.EQ.0) THEN
        CALL MSGDMP('E','SZQFNW','FONT FILE HAS NOT BEEN LOADED.')
      END IF

      CALL VRSET0(VX1,WX1,NCHAR,1,1)
      CALL VRSET0(VX2,WX2,NCHAR,1,1)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE VRRNM0(RX,RY,N,JX,JY,NB)

      REAL      RX(*),RY(*)


      IF (.NOT.(1.LE.NB .AND. NB.LE.N)) THEN
        CALL MSGDMP('E','VRRNM0','AVERAGING LENGTH IS INVALID.')
      END IF
      IF (MOD(NB,2).EQ.0) THEN
        CALL MSGDMP('E','VRRNM0','AVERAGING LENGTH IS EVEN NUMBER.')
      END IF

      CALL GLRGET('RMISS',RMISS)

      NB2=NB/2
      KX=1-JX
      KY=1-JY
      DO 10 J=1,N
        KX=KX+JX
        KY=KY+JY
        IF (1+NB2.LE.J .AND. J.LE.N-NB2) THEN
          RY(KY)=RAVE0(RX(KX-JX*NB2),NB,JX)
        ELSE
          RY(KY)=RMISS
        END IF
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     TMSTLA : THE ROUTINE FOR DRAWING STREAM LINES (COORD. OF ANNULAR)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD DENNOU CLUB. ALL RIGHTS RESERVED.
*-----------------------------------------------------------------------
      SUBROUTINE TMSTLA( R, T, U, V, NX, NY )

      IMPLICIT NONE

*-- AGREENMENT
      INTEGER  NX        !* GRID NUMBERS FOR X-DIRECTION
      INTEGER  NY        !* GRID NUMBERS FOR Y-DIRECTION
      REAL     U(NX,NY)  !* VECTOR COMPONENT OF X-DIRECTION
      REAL     V(NX,NY)  !* VECTOR COMPONENT OF Y-DIRECTION
      REAL     R(NX)     !* GRID POINTS OF RADIAL DIR. [UNIT:LENGTH]
      REAL     T(NY)     !* GRID POINTS OF TANGENT DIR. [UNIT:DEGREE]

*-- INTERNAL VARIABLES
      REAL     TRX(NX*NY,2)     !* STREAM LINE OF X-COORDINATE
      REAL     TRY(NX*NY,2)     !* STREAM LINE OF Y-COORDINATE
      INTEGER  I, J, K          !* TMP VALUES
      INTEGER  COUNTER          !* NUMBER OF STREAM LINE
      INTEGER  TOTNM(NX*NY,2)   !* ARRAY NUMBER IN TOTAL STREAM LINES AT END
      INTEGER  TOTSNM(NX*NY,2)  !* ARRAY NUMBER IN TOTAL STREAM LINES AT START
      REAL     X(NX), Y(NY)
      REAL     TMPU(NX,NY), TMPV(NX,NY)
      REAL     ARROW_THRES
      REAL     DXA, DYA
      REAL     ARROW_LENG
      REAL     VXMIN, VXMAX, VYMIN, VYMAX
      REAL     UXMIN, UXMAX, UYMIN, UYMAX
      REAL     VRRATIO
      REAL     RCOE
      REAL     CIRC_FLAG
      REAL     UNDEF
      INTEGER  N, M, IBLKGE, ARRCNT
      LOGICAL  NO_SHORT, END_ARR

*-- EXTERNAL FUNCTION
      REAL     RFPI
      EXTERNAL RFPI

      RCOE=RFPI()/180.0

*-- GETTING TMPACK'S PARAMETERS
      CALL TMRGET( 'ARRWINTV', ARROW_THRES )
      CALL TMLGET( 'NODRSHRT', NO_SHORT )
      CALL TMLGET( 'ENDARROW', END_ARR )

      CALL GLRGET( 'RMISS', UNDEF )
      CALL GLLSET( 'LMISS', .TRUE. )

*-- GETTING VIEWPORT PARAMETERS
      CALL SGQVPT( VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGQWND( UXMIN, UXMAX, UYMIN, UYMAX)
      VRRATIO=(VXMAX-VXMIN)/(UXMAX-UXMIN)

*-- CONVERTING DEGREE TO RADIAN
      DO 11 I=1,NX
         X(I)=R(I)
 11   CONTINUE
      DO 12 J=1,NY
         Y(J)=T(J)*RCOE
 12   CONTINUE

*-- CONVERTING VECTORS TO THEMSELVES INCLUDING SCALE PARAMETER
      DO 20 J=1,NY
         DO 21 I=1,NX
            IF(U(I,J).NE.UNDEF.AND.V(I,J).NE.UNDEF
     &         .AND.R(I).NE.0.0)THEN
               TMPU(I,J)=U(I,J)
               TMPV(I,J)=V(I,J)/R(I)
            ELSE
               TMPU(I,J)=UNDEF
               TMPV(I,J)=UNDEF
            END IF
 21      CONTINUE
 20   CONTINUE

*-- DOING TMSTLN ROUTINE
      CALL TMSTLN( X, Y, TMPU, TMPV, NX, NY, TRX, TRY, TOTNM )

*-- GETTING STREAM LINE NUMBERS
      CALL TMIGET( 'STLNNUM', COUNTER )

*-- SETTING START NUMBERS IN TOTAL STREAM LINES
      TOTSNM(1,1:2)=1
      DO 10 I=2,COUNTER
         TOTSNM(I,1)=TOTNM(I-1,1)+1
         TOTSNM(I,2)=TOTNM(I-1,2)+1
 10   CONTINUE

*-- CONVERTING TRY(RADIAN) TO TRY(DEGREE)
      DO 32 K=1,2
         DO 30 I=1,COUNTER
            DO 31 J=TOTSNM(I,K),TOTNM(I,K)
               IF(TRX(J,K).NE.UNDEF.AND.TRY(J,K).NE.UNDEF)THEN
                  TRY(J,K)=TRY(J,K)/RCOE
               END IF
 31         CONTINUE
 30      CONTINUE
 32   CONTINUE

*-- SETTING PARAMETER FOR ARROW. (NOW, CONSTANT VALUES)
      CALL SGLSET('LPROP',.FALSE.)
      CALL SGRSET('CONST',0.01)

*-- DRAWING STREAM LINES
      DO 82 K=1,2
         DO 81 I=1,COUNTER

*-- CALCULATING THE INTERVAL LENGTH OF DRAWING ARROWS.
            ARROW_LENG=0.0
            ARRCNT=0
            IF(((TOTNM(I,K)-TOTSNM(I,K)+1).GT.1).AND.
     &         ((TOTNM(I,K)-TOTSNM(I,K)+1).LE.NX*NY))THEN
               DO 80 J=TOTSNM(I,K)+1,TOTNM(I,K)
                  IF(TRX(J,K).NE.UNDEF.AND.TRY(J,K).NE.UNDEF.AND.
     &               TRX(J-1,K).NE.UNDEF.AND.TRY(J-1,K).NE.UNDEF
     &               )THEN
                     DXA=(TRX(J,K)-TRX(J-1,K))*VRRATIO
                     DYA=(TRY(J,K)-TRY(J-1,K))*VRRATIO
     &                                        *TRX(J,K)*RCOE
                     ARROW_LENG=ARROW_LENG+SQRT(DXA*DXA+DYA*DYA)
                     IF(ARROW_LENG.GE.ARROW_THRES)THEN
                        CALL SGLAU( TRX(J-1,K), TRY(J-1,K),
     &                              TRX(J,K), TRY(J,K) )
                        ARROW_LENG=0.0
                        ARRCNT=ARRCNT+1
                     END IF
                  END IF
 80            CONTINUE

*-- IF NO_SHORT IS TRUE, NO DRAWING STREAM LINE WHOSE ARROW NUMBER IS ZERO
*-- 流線の始点と終点が近似点にいれば, 閉じた流線とみなして描く.
*-- 矢羽は終点に描く.
               IF(ARRCNT.EQ.0)THEN
                  IF(NO_SHORT.EQV..TRUE.)THEN
                     IF((TOTNM(I,K)-TOTSNM(I,K)+1).LE.2)THEN
                        GO TO 81
                     ELSE
                        N=IBLKGE( R, NX, TRX(TOTSNM(I,K),K) )
                        M=IBLKGE( R, NX, TRX(TOTNM(I,K),K) )
                        IF(ABS(N-M).GT.1)THEN
                           GO TO 81
                        ELSE
*-- 一周しているのか, 短いだけなのかのチェック
*--  始点, 終点, 終点１つ前の順に増減していれば一周.
                           CIRC_FLAG=
     &                        (TRX(TOTNM(I,K),K)-TRX(TOTNM(I,K)-1,K))
     &                        *(TRX(TOTSNM(I,K),K)-TRX(TOTNM(I,K),K))
                           IF(CIRC_FLAG.LT.0.0)THEN  ! 単に短いだけ
                              GO TO 81
                           ELSE
                              N=IBLKGE( T, NY, TRY(TOTSNM(I,K),K) )
                              M=IBLKGE( T, NY, TRY(TOTNM(I,K),K) )
                              IF(ABS(N-M).GT.1)THEN
                                 GO TO 81
                              ELSE
                                 CIRC_FLAG=
     &                         (TRY(TOTNM(I,K),K)-TRY(TOTNM(I,K)-1,K))
     &                         *(TRY(TOTSNM(I,K),K)-TRY(TOTNM(I,K),K))
                                 IF(CIRC_FLAG.LT.0.0)THEN
                                    GO TO 81
!                                 ELSE
!                                 CALL SGLAU( TRX(TOTNM(I,K)-1,K), TRY(TOTNM(I,K)-1,K),
!     &                                       TRX(TOTNM(I,K),K), TRY(TOTNM(I,K),K) )
                                 END IF
                              END IF
                           END IF
                        END IF
                     END IF
                  ELSE
                     IF(END_ARR.EQV..TRUE.)THEN
                        CALL SGLAU( TRX(TOTNM(I,K)-1,K),
     &                              TRY(TOTNM(I,K)-1,K),
     &                              TRX(TOTNM(I,K),K),
     &                              TRY(TOTNM(I,K),K) )
                     END IF
                  END IF
               END IF

               CALL UULIN( (TOTNM(I,K)-TOTSNM(I,K)+1),
     &                     TRX(TOTSNM(I,K):TOTNM(I,K),K),
     &                     TRY(TOTSNM(I,K):TOTNM(I,K),K) )

            END IF

 81      CONTINUE

 82   CONTINUE

      CALL MSGDMP( 'M', 'TMSTLA', 'DRAWING FINISHED.' )

      END SUBROUTINE TMSTLA

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGWTRF(VX,VY,WX,WY)


      CALL MSGDMP('M','SGWTRF','THIS IS OLD INTERFACE - USE STFWTR !')

      CALL STFWTR(VX,VY,WX,WY)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSWTR(VXMIN,VXMAX,VYMIN,VYMAX,
     +             WXMIN,WXMAX,WYMIN,WYMAX,IWTRF)

      CALL MSGDMP('M','SGSWTR','THIS IS OLD INTERFACE - USE STSWTR !')

      CALL STSWTR(VXMIN,VXMAX,VYMIN,VYMAX,
     +            WXMIN,WXMAX,WYMIN,WYMAX,IWTRF)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQWTR(VXMIN,VXMAX,VYMIN,VYMAX,
     +             WXMIN,WXMAX,WYMIN,WYMAX,IWTRF)

      CALL MSGDMP('M','SGQWTR','THIS IS OLD INTERFACE - USE STQWTR !')

      CALL STQWTR(VXMIN,VXMAX,VYMIN,VYMAX,
     +            WXMIN,WXMAX,WYMIN,WYMAX,IWTRF)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSWRC(WSXMN,WSXMX,WSYMN,WSYMX)

      CALL MSGDMP('M','SGSWRC','THIS IS OLD INTERFACE - USE STSWRC !')

      CALL STSWRC(WSXMN,WSXMX,WSYMN,WSYMX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQWRC(WSXMN,WSXMX,WSYMN,WSYMX)

      CALL MSGDMP('M','SGQWRC','THIS IS OLD INTERFACE - USE STQWRC !')

      CALL STQWRC(WSXMN,WSXMX,WSYMN,WSYMX)

      RETURN
      END

*-----------------------------------------------------------------------
*     UYAXNM : PLOT Y-AXIS (SPECIFY NUMBERS)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYAXNM(CSIDE,UY1,N1,UY2,N2)

      REAL      UY1(*),UY2(*)
      CHARACTER CSIDE*1

      LOGICAL   LABEL,LUYCHK


      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYAXNM','SIDE PARAMETER IS INVALID.')
      END IF

      CALL UYSOFF

      CALL UYPAXS(CSIDE,2)

      IF (N1.GE.1) THEN
        CALL UYPTMK(CSIDE,1,UY1,N1)
      END IF

      IF (N2.GE.1) THEN
        CALL UYPTMK(CSIDE,2,UY2,N2)
        CALL UZLGET('LABELY'//CSIDE,LABEL)
        IF (LABEL) THEN
          CALL UYPNUM(CSIDE,1,UY2,N2)
        END IF
      END IF

      CALL UYROFF

      END

*-----------------------------------------------------------------------
*     UCIQNP / UCIQID / UCIQCP / UCIQVL / UCISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 3)
      PARAMETER (IUNDEF = -999)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      CPARAS( 1) /'NDAY    '/, IX( 1) /IUNDEF/
      DATA      CPARAS( 2) /'NCHAR   '/, IX( 2) /IUNDEF/
      DATA      CPARAS( 3) /'IUNDEF  '/, IX( 3) /IUNDEF/

      DATA      CPARAL( 1) / 'DAY_INTERVAL' /
      DATA      CPARAL( 2) / 'MONTH_NAME_LENGTH' /
      DATA      CPARAL( 3) / '----IUNDEF  ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UCIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UCIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UCIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UC', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','UCIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UC', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','UCISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
      PROGRAM SGLTYP

      PARAMETER (N=2)

      REAL      X(N),Y(N)
      CHARACTER CPAT*16,CTTL*16


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)

      CALL SGFRM

      CALL SGTXZV(0.5,0.9,'LINE TYPE',0.04,0,0,3)

      X(1)=0.4
      X(2)=0.8

      DO 10 I=1,5

        IF (1.LE.I .AND. I.LE.4) THEN
          ITYPE=I
        ELSE
          CPAT='0011111111001001'
          CALL BITPCI(CPAT,ITYPE)
          CALL SGSPLT(ITYPE)
        END IF

        CTTL='ITYPE = #####'
        WRITE(CTTL(9:13),'(I5)') ITYPE

        Y(1)=0.7-(I-1)*0.12
        Y(2)=Y(1)

        CALL SGTXZV(0.1,Y(1),CTTL,0.02,0,-1,3)
        IF (I.EQ.5) THEN
          CALL SGTXZV(0.1,Y(1)-0.05,'('//CPAT//')',0.015,0,-1,3)
        END IF
        CALL SGPLZV(N,X,Y,ITYPE,3)

   10 CONTINUE

      CALL SGCLS

      END

      PROGRAM LAY1

      CHARACTER*7  CTXT
      DATA CTXT/'FRAME??'/

      CALL SWCSTX('FNAME','lay1')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )

      CALL SLMGN( 0.1, 0.1, 0.05, 0.05 )
      CALL SLDIV( 'Y', 3, 2 )
      CALL SLMGN( 0.05, 0.05, 0.05, 0.05 )

      DO 10 I=1,12
        CALL SGFRM
        CALL SLPVPR( 1 )
        WRITE(CTXT(6:7),'(I2.2)') I
        CALL SGTXV( 0.5, 0.5, CTXT )
   10 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     COLOR TO TONE CONVERSION TABLE LOADING
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZCLTN(ICPAT,MAXCLI)

      INTEGER   ICPAT(*)

      CHARACTER CFILE*1024

      EXTERNAL  IUFOPN

      SAVE


*     / INITIALIZE /

      DO 10 I=1,MAXCLI
        ICPAT(I)=-1
   10 CONTINUE

*     / OPEN TABLE FILE : MAYBE SYSTEM DEPENDENT /

      CALL SWQFNM('CL2TN',CFILE)
      IF (CFILE.EQ.' ') THEN
        CALL MSGDMP('E','SZCLTN',
     +       'COLOR TO TONE CONVERSION TABLE DOES NOT EXIST.')
      END IF

      IU=IUFOPN()
      OPEN(IU,FILE=CFILE,FORM='FORMATTED')
      REWIND(IU)

*     / LOAD CONVERSION TABLE /

   20 CONTINUE
        READ(IU,*,IOSTAT=IOS) ICI,IPAT
        IF (ICI.GT.MAXCLI .OR. ICI.LE.0) THEN
          CALL MSGDMP('E','SZCLTN','COLOR INDEX IS INVALID')
        END IF
        ICPAT(ICI)=IPAT
      IF (IOS.EQ.0) GO TO 20

*     / CLOSE TABLE FILE /

      CLOSE(IU)

      END

!-------------------------------------------------
!interface module of fnclib
!-------------------------------------------------
module fnc_interface
  interface

    function igus(rx)                             !RXを越えない最大の整数を返す
      real,      intent(in) :: rx                 !調べる実数値
      integer igus                                !最大の整数 [ rx ]関数値
    end function
      
    function imod(ix,id)                          !数学的な剰余を求める．整数用
      integer,   intent(in) :: ix                 !調べる整数値
      integer,   intent(in) :: id                 !除数
      integer imod                                !剰余関数値
    end function
      
    function rmod(rx,rd)                          !数学的な剰余を求める.実数用
      real,      intent(in) :: rx                 !調べる実数値
      real,      intent(in) :: rd                 !除数
      real rmod                                   !剰余関数値
    end function
      
    function rexp(rx,ib,ie)                       !rx ib^ie を求める．
      real,      intent(in) :: rx
      integer,   intent(in) :: ib
      integer,   intent(in) :: ie
      real rexp                                   !求める関数値
    end function
      
    function rfpi()                               !円周率 π を返す．
      real rfpi                                   !円周率 πを返す実数関数値
    end function
      
    function rd2r(x)                              !角度の変換をおこなう．
      real,      intent(in) :: x                  !「ラジアン」を単位とする実数値
      real rd2r                                   !「ラジアン」を単位とした値を返す実数関数値
    end function
      
    function rr2d(x)                              !角度の変換をおこなう．
      real,      intent(in) :: x                  !「度」 を単位とする実数値
      real rr2d                                   !度」を単位とした値を返す実数関数値
    end function

  end interface
end module
!fnclib library end ----

!-------------------------------------------------
!interface module of rnmlib
!-------------------------------------------------
module rnm_interface
  interface

    subroutine vrrnm(rx,ry,n,jx,jy,nb)            !移動平均を計算する． ．
      real,      intent(in), dimension(*) :: rx !移動平均を計算する実数型の配列
      real,      intent(out), dimension(*) :: ry !計算結果を納める実数型の配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: nb                 !移動平均をとるデータ長
    end subroutine
      
    subroutine vrrnm0(rx,ry,n,jx,jy,nb)           !移動平均を計算する（欠損値処理をしない）.
      real,      intent(in), dimension(*) :: rx !移動平均を計算する実数型の配列
      real,      intent(out), dimension(*) :: ry !計算結果を納める実数型の配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: nb                 !移動平均をとるデータ長
    end subroutine
      
    subroutine vrrnm1(rx,ry,n,jx,jy,nb)           !移動平均を計算する （欠損値処理をする）.
      real,      intent(in), dimension(*) :: rx !移動平均を計算する実数型の配列
      real,      intent(out), dimension(*) :: ry !計算結果を納める実数型の配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: nb                 !移動平均をとるデータ長
    end subroutine

  end interface
end module
!rnmlib library end ----

*-----------------------------------------------------------------------
*     GBYTES
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE GBYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)

      IMPLICIT  INTEGER (A-Z)

      INTEGER   NPACK(*),ISAM(*)

      PARAMETER (BPERI=32)

      INTEGER   MASK(BPERI)

      SAVE

      EXTERNAL  ISHIFT

      DATA      NCALL/0/


      IF (NCALL.EQ.0) THEN
        CALL GLIGET('NBITSPW',NBITPW)
        IF (NBITPW.NE.BPERI) THEN
          CALL MSGDMP('E','GBYTES',
     +      'NUMBER OF BITS PER ONE WORD IS INVALID / '//
     +      'CHECK BPERI IN THE PARAMETER STATEMENT OF GBYTES '//
     +      'AND CHANGE IT CORRECTLY.')
        END IF
        MASK(1)=1
        DO 10 I=2,BPERI
          MASK(I)=IOR(ISHIFT(MASK(I-1),1),1)
   10   CONTINUE
        NCALL=1
      END IF

      IF (.NOT.(NBITS.LE.BPERI .AND. NBITS.GT.0)) THEN
        CALL MSGDMP('E','GBYTES','NBITS OUT OF RANGE.')
      END IF

      MSK1=MASK(NBITS)
      BITSEP=NBITS+NSKIP
      DO 20 I=1,ITER
        BPO=IBIT+(I-1)*BITSEP
        WPO=BPO/BPERI+1
        RBITS=BPERI*WPO-BPO
        SHFT=NBITS-RBITS
        IF (SHFT.LE.0) THEN
          ISAM(I)=IAND(MSK1,ISHIFT(NPACK(WPO),SHFT))
        ELSE
          BTMPL=ISHIFT(IAND(NPACK(WPO),MASK(RBITS)),SHFT)
          BTMPR=IAND(ISHIFT(NPACK(WPO+1),SHFT-BPERI),MASK(SHFT))
          ISAM(I)=IOR(BTMPL,BTMPR)
        END IF
   20 CONTINUE

      END

*-----------------------------------------------------------------------
*     ODPQNP / ODPQID / ODPQCP / ODPQVL / ODPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ODPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 16)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'LBAR    ' /, ITYPE(1) / 2 /
      DATA      CPARAS(2) / 'EPSILON ' /, ITYPE(2) / 3 /
      DATA      CPARAS(3) / 'MAXSTEP ' /, ITYPE(3) / 1 /
      DATA      CPARAS(4) / 'NSTEP   ' /, ITYPE(4) / 1 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'LBAR    ' /
      DATA      CPARAL(2) / 'EPSILON ' /
      DATA      CPARAL(3) / 'MAXSTEP ' /
      DATA      CPARAL(4) / 'NSTEP   ' /

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','ODPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','ODPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','ODPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','ODPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL ODIQID(CPARAS(IDX), ID)
          CALL ODIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL ODLQID(CPARAS(IDX), ID)
          CALL ODLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL ODRQID(CPARAS(IDX), ID)
          CALL ODRQVL(ID, IPARA)
        END IF
      ELSE
         CALL MSGDMP('E','ODPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL ODIQID(CPARAS(IDX), ID)
          CALL ODISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL ODLQID(CPARAS(IDX), ID)
          CALL ODLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL ODRQID(CPARAS(IDX), ID)
          CALL ODRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','ODPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!interface module of sublib
!-------------------------------------------------
module sub_interface
  interface

    subroutine vignn(ix,n,jx)                     !自然数列を生成して整数型配列で返す．
      integer,   intent(out), dimension(*) :: ix   !自然数列を返す整数型配列
      integer,   intent(in) :: n                  !数列を構成する配列要素の個数
      integer,   intent(in) :: jx                 !数列を構成する配列要素の間隔
    end subroutine
      
    subroutine vrgnn(rx,n,jx)                     !自然数列を生成して実数型配列で返す．
      real,      intent(out), dimension(*) :: rx   !自然数列を返す実数型配列
      integer,   intent(in) :: n                  !数列を構成する配列要素の個数
      integer,   intent(in) :: jx                 !数列を構成する配列要素の間隔
    end subroutine
      
    subroutine dxfloc(nd,ns,np,ncp)               !添字の値から配列要素の位置を求める．
      integer,   intent(in) :: nd                 !配列の次元数
      integer,   intent(in), dimension(*) :: ns   !配列の寸法を収めた長さndの 整数型配列
      integer,   intent(in), dimension(*) :: np   !配列の添字を収めた長さ ndの整数型配列
      integer,   intent(out) :: ncp               !配列要素の位置． dxflocでは出力パラメータ
    end subroutine
      
    subroutine dxiloc(nd,ns,np,ncp)               !: 配列要素の位置から添字の値を求める
      integer,   intent(in) :: nd                 !配列の次元数
      real,      intent(in), dimension(*) :: ns   !配列の寸法を収めた長さndの 整数型配列
      integer,   intent(out), dimension(*) :: np  !配列の添字を収めた長さ ndの整数型配列
      integer,   intent(in) :: ncp                !配列要素の位置． dxflocでは出力パラメータ
    end subroutine

  end interface
end module
!sublib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGKSX2

      REAL      UX(5), UY(5), VX(5), VY(5)

      DATA      UX / 2.0, 4.0, 5.0, 7.0, 8.0 /
      DATA      UY / 4.0, 5.0, 4.0, 5.0, 4.0 /
      DATA      VX / 0.2, 0.4, 0.5, 0.7, 0.8 /
      DATA      VY / 0.5, 0.6, 0.5, 0.6, 0.5 /


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN( IWS )

*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN WC.
*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN NDC.
*     TRANSFORMATION FUNCTION : LINEAR*LINEAR
*     NO-CLIPPING, FONT NO.=1

      CALL SGFRM

      CALL SGISET( 'IFONT', 1 )

      CALL SGSWND( 0.0, 10.0, 0.0, 10.0 )
      CALL SGSVPT( 0.0, 1.0, 0.0, 1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGLNZU( 0.1, 0.1, 9.9, 0.1, 1 )
      CALL SGLNZU( 9.9, 0.1, 9.9, 9.9, 1 )
      CALL SGLNZU( 9.9, 9.9, 0.1, 9.9, 1 )
      CALL SGLNZU( 0.1, 9.9, 0.1, 0.1, 1 )

      CALL SGPLZU( 5, UX, UY, 2, 3 )
      CALL SGPMZU( 5, UX, UY, 5, 3, 0.04 )
      CALL STFTRF( UX(1), UY(1), VX1, VY1 )
      CALL STFTRF( UX(4), UY(4), VX2, VY2 )
      CALL SGLNZV( VX1, VY1, VX2, VY2, 2 )
      CALL SGTXZU( 5.0, 8.5, 'TESTU', 0.1, 0, 0, 3 )

      CALL SGSWND( 2.5, 7.5, 2.5, 7.5 )
      CALL SGSVPT( 0.25, 0.75, 0.25, 0.75 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGPLZV( 5, VX, VY, 3, 1 )
      CALL SGPMZV( 5, VX, VY, 4, 1, 0.02 )
      CALL SGTXZV( 0.5, 0.75, 'TESTV', 0.1, 0, 0, 3 )

*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN WC.
*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN NDC.
*     TRANSFORMATION FUNCTION : LINEAR*LINEAR
*     CLIPPING, FONT NO.=2

      CALL SGFRM

      CALL SGISET( 'IFONT', 2 )

      CALL SGSWND( 0.0, 10.0, 0.0, 10.0 )
      CALL SGSVPT( 0.0, 1.0, 0.0, 1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGLNZU( 0.1, 0.1, 9.9, 0.1, 1 )
      CALL SGLNZU( 9.9, 0.1, 9.9, 9.9, 1 )
      CALL SGLNZU( 9.9, 9.9, 0.1, 9.9, 1 )
      CALL SGLNZU( 0.1, 9.9, 0.1, 0.1, 1 )

      CALL SGPLZU( 5, UX, UY, 2, 3 )
      CALL SGPMZU( 5, UX, UY, 5, 3, 0.04 )
      CALL STFTRF( UX(1), UY(1), VX1, VY1 )
      CALL STFTRF( UX(4), UY(4), VX2, VY2 )
      CALL SGLNZV( VX1, VY1, VX2, VY2, 2 )
      CALL SGTXZU( 5.0, 8.5, 'TESTU', 0.1, 0, 0, 3 )

      CALL SGSWND( 2.5, 7.5, 2.5, 7.5 )
      CALL SGSVPT( 0.25, 0.75, 0.25, 0.75 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGLSET( 'LCLIP', .TRUE. )
      CALL SLPVPR( 1 )
      CALL SGPLZV( 5, VX, VY, 3, 1 )
      CALL SGPMZV( 5, VX, VY, 4, 1, 0.02 )
      CALL SGTXZV( 0.5, 0.75, 'TESTV', 0.1, 0, 0, 3 )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
      PROGRAM USPK09

      PARAMETER(N=200, M=5)
      REAL X(N), Y(N), YC(N,M), A(M)

      DT = 1./(N-1)
      PI = 3.14159
      DO 50 J=1, M
        JJ = J*2-1
        A(J) = (-1)**J *2./(JJ*PI)
  50  CONTINUE

      DO 100 I=1, N
        T    = DT*(I-1)*2*PI
        X(I) = DT*(I-1)
        Y(I) = 0.
        DO 150 J=1, M
          JJ = J*2-1
          YC(I,J) = A(J)*COS(JJ*T)
          Y(I)  = Y(I) + YC(I,J)
  150   CONTINUE
  100 CONTINUE

*--------------------------- 1ST PAGE ----------------------------------

      CALL SWCSTX('FNAME','USPK09')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GLRGET('RUNDEF',RUNDEF)

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSVPT(0.2, 0.8, 0.2, 0.6)
      CALL USSPNT(N*M, RUNDEF, YC)

      CALL USSTTL('X-AXIS', ' ', 'COMPONENTS', ' ')
      CALL USGRPH(N, X, YC)

      DO 200 J=2,M
        IP = MOD(J-1,4) + 1
        CALL UULINZ(N, X, YC(1,J), 1, IP)
  200 CONTINUE

*     --- NEW FIG ---
      CALL GRFIG
      CALL GRSVPT(0.2, 0.8, 0.62, 0.82)
      CALL UZLSET('LABELXB', .FALSE.)

      CALL USSTTL('X-AXIS', ' ', 'TOTAL', ' ')
      CALL USGRPH(N, X, Y)

*--------------------------- 2ND PAGE ----------------------------------

      CALL GRFRM
      CALL GRSVPT(0.2, 0.8, 0.2, 0.6)

      CALL UZFACT(0.5)
      CALL UZLSET('LABELXB', .TRUE.)

      CALL USSPNT(N*M, RUNDEF, YC)
      CALL USSTTL('X-AXIS', ' ', 'COMPONENTS', ' ')
      CALL USGRPH(N, X, YC)

      DO 300 J=2,M
        IP = MOD(J-1,4) + 1
        CALL UULINZ(N, X, YC(1,J), 1, IP)
  300 CONTINUE

*     --- NEW FIG ---
      CALL GRFIG
      CALL GRSVPT(0.2, 0.8, 0.62, 0.82)
      CALL UZLSET('LABELXB', .FALSE.)

      CALL USSTTL('X-AXIS', ' ', 'TOTAL', ' ')
      CALL USGRPH(N, X, Y)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UYPLBA : PLOT LABELS ( AT THE POINTS )
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPLBA(UY,CH,NC,N,UPX,ROFFY,RSIZE,IROTA,ICENT,INDEX)

      REAL      UY(*)
      CHARACTER CH(*)*(*)

      LOGICAL   LCLIPZ


      IF (NC.LE.0) THEN
        CALL MSGDMP('E','UYPLBA',
     +       'CHARACTER LENGTH IS LESS THAN OR EQUAL TO ZERO.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UYPLBA','NUMBER OF POINTS IS INVALID.')
      END IF
      IF (RSIZE.LE.0) THEN
        CALL MSGDMP('E','UYPLBA','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','UYPLBA','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.LE.0) THEN
        CALL MSGDMP('E','UYPLBA','TEXT INDEX IS INVALID.')
      END IF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)

      CALL SZTXOP(RSIZE,IROTA*90,ICENT,INDEX)
      DO 10 I=1,N
        LC = LENC(CH(I))
        CALL STFTRF(UPX,UY(I),VPX,VPY)
        VPX=VPX+ROFFY
        CALL SZTXZV(VPX,VPY,CH(I)(1:LC))
   10 CONTINUE
      CALL SZTXCL

      CALL SGLSET('LCLIP',LCLIPZ)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTXZV(VX,VY,CHARS,RSIZE,IROTA,ICENT,INDEX)

      CHARACTER CHARS*(*)


      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGTXZV','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGTXZV','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','SGTXZV','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGTXZV','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGTXZV','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL SZTXOP(RSIZE,IROTA,ICENT,INDEX)
      CALL SZTXZV(VX,VY,CHARS)
      CALL SZTXCL

      END

*-----------------------------------------------------------------------
*     NORMALIZATION TRANSFORMATION (INCLUDING MAP PROJECTION)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE STFTRF(UX, UY, VX, VY)

      LOGICAL   LMAPA

      LOGICAL   LMISS, LMAP

      SAVE


      IF (LMISS .AND. (UX.EQ.RMISS .OR. UY.EQ.RMISS)) THEN
        VX = RMISS
        VY = RMISS
        RETURN
      END IF

      CALL STFRAD(UX, UY, UX1, UY1)

      IF (LMAP) THEN
        CALL STFROT(UX1, UY1, TX, TY)
        CALL STFTRN(TX,  TY,  VX, VY)
      ELSE
        CALL STFTRN(UX1, UY1, VX, VY)
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY STITRF(VX, VY, UX, UY)

      IF (LMAP) THEN
        CALL STITRN(VX, VY, TX, TY)
        IF (TX.EQ.RNA .OR. TY.EQ.RNA) THEN
          UX = RNA
          UY = RNA
          RETURN
        END IF
        CALL STIROT(TX, TY, UX1, UY1)
      ELSE
        CALL STITRN(VX, VY, UX1, UY1)
      END IF

      CALL STIRAD(UX1, UY1, UX, UY)

      RETURN
*-----------------------------------------------------------------------
      ENTRY STQTRF(LMAPA)

      LMAPA = LMAP

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSTRF(LMAPA)

      LMAP = LMAPA
      CALL GLLGET('LMISS',LMISS)
      CALL GLRGET('RMISS',RMISS)
      CALL GLRGET('RUNDEF',RNA)

      END

*-----------------------------------------------------------------------
*     USPACK DRAW Y-AXIS (LOG)                        DCL 5.0  95/09/04
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USYAXL(CYS)
      CHARACTER CYS*(*), CUNIT*32, CYSUB*32, CSBLBL*32, CPOS*1, CP*8
      LOGICAL LAB1
      EXTERNAL CSBLBL, LENZ

      CALL USIGET('NLBLY'  , NLBL)
      CALL USIGET('NTICKSY', NTICKS)
      CALL USIGET('ITYPEY' , ITYPEY)
      CALL USRGET('YFAC'   , YFAC)
      CALL USCGET('CYUNIT' , CUNIT)

      CALL ULIGET('IYTYPE', IT)
      CALL ULISET('IYTYPE', ITYPEY)

      CALL SGQTRN(ITR)
      IF(.NOT.(ITR.EQ.2 .OR. ITR.EQ.4))
     &   CALL MSGDMP('E', 'USXAXL', 'INVALID TRANSFORMATION NUMBER.')
      CALL SGQWND(XMIN, XMAX, YMIN, YMAX)

      YMINA = YMIN*YFAC
      YMAXA = YMAX*YFAC
      CALL SGSWND(XMIN, XMAX, YMINA, YMAXA)
      CALL SGSTRF

*---------------------------- Y-AXIS -----------------------------------

      NYS = MIN(LEN(CYS), 2)
      DO 100 I=1, NYS
        CALL ULYLOG(CYS(I:I), NLBL, NTICKS)
        CP = 'LABELY'//CYS(I:I)
        CALL UZLGET(CP, LAB1)
        IF(LAB1) THEN
          CYSUB = CSBLBL(YFAC, 0., CUNIT)
          IF(LENZ(CYSUB).NE.0) THEN
            CALL USCGET('CYSPOS', CPOS)
            CALL USYSUB(CYS(I:I), CPOS, CYSUB, 3.)
          ENDIF
        ENDIF
  100 CONTINUE

*-----------------------------------------------------------------------

      CALL SGSWND(XMIN, XMAX, YMIN, YMAX)
      CALL SGSTRF
      CALL ULISET('IYTYPE', IT)

      RETURN
      END

*-----------------------------------------------------------------------
* INV MAP PROJECTION (NEWTON METHOD ON SPHERE)      2007-11-10 E. TOYODA
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE MPNWTN(X, Y, XLON, YLAT, FUNC, XCYC)
        LOGICAL XCYC
        PARAMETER (EPSX = 1.0E-4)
        PARAMETER (EPS = 1.0E-4)
        PARAMETER (CONVT = 3.0E-5)
        PARAMETER (XMRGN = 0.01)
        PARAMETER (DETMIN = 1.0E-7)
        PARAMETER (IMAX = 40)
        PARAMETER (PI = ATAN(1.0) * 4.0)
        ACCEL = 1.0
        I = 0
  100   CONTINUE
          IF (XLON .GT. 0.0) THEN
            XLON2 = XLON - EPS
          ELSE
            XLON2 = XLON + EPS
          ENDIF
          IF (YLAT .GT. 0.0) THEN
            YLAT2 = YLAT - EPS
          ELSE
            YLAT2 = YLAT + EPS
          ENDIF
          CALL FUNC(XLON, YLAT, X0, Y0)
          CALL FUNC(XLON2, YLAT, X1, Y1)
          CALL FUNC(XLON, YLAT2, X2, Y2)
C         print "('foot:',4f13.6)", degree(xlon), degree(xlon2),
C    +     degree(ylat), degree(ylat2)
          XL = (X1 - X0) / (XLON2 - XLON)
          XB = (X2 - X0) / (YLAT2 - YLAT)
          YL = (Y1 - Y0) / (XLON2 - XLON)
          YB = (Y2 - Y0) / (YLAT2 - YLAT)
          DX = X - X0
          DY = Y - Y0
          DET = XL * YB - XB * YL
          IF (ABS(DET) .LT. DETMIN) THEN
C           print "('singularity')"
            GOTO 110
          ENDIF
          RDET = ACCEL / DET
C         print "('det=',f15.8)", det
          CX = RDET * (YB * DX - XB * DY)
          CY = RDET * (-YL * DX + XL * DY)
C         print "('corr=',2f13.6)", degree(cx), degree(cy)
          XLON = XLON + CX
          IF (XLON .GT. PI + EPSX) THEN
C           print "(' xlon > 180')"
            IF (XCYC) THEN
              XLON = XLON - 2.0 * PI
            ELSE
              XLON = PI - XMRGN
            ENDIF
            ACCEL = 0.5
          ELSE IF (XLON .LT. -PI - EPSX) THEN
C           print "(' xlon < -180')"
            IF (XCYC) THEN
              XLON = XLON + 2.0 * PI
            ELSE
              XLON = -PI + XMRGN
            ENDIF
            ACCEL = 0.5
          ENDIF
          YLAT = YLAT + CY
          IF (YLAT .GT. 0.5 * PI) THEN
C           print "(' ylat > 90')"
            YLAT = 0.5 * PI - XMRGN
            ACCEL = 0.5
          ELSE IF (YLAT .LT. -0.5 * PI) THEN
C           print "(' ylat < -90')"
            YLAT = -0.5 * PI + XMRGN
            ACCEL = 0.5
          ENDIF
          DIST = MAX(ABS(CX), ABS(CY))
          IF (DIST .LT. CONVT) GOTO 110
          I = I + 1
          IF (I .GT. IMAX) GOTO 911
        GOTO 100
  110   CONTINUE
        RETURN

  911   CONTINUE   
        CALL GLRGET('RUNDEF',RNA)
        XLON = RNA
        YLAT = RNA
      END

*-----------------------------------------------------------------------
*     TEXT WIDTH AND HEIGHT INQUIRY
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZQTXW(CHARS,NC,WXCH,WYCH)

      CHARACTER CHARS*(*)

      PARAMETER (NWX=256)
      PARAMETER (WUNIT=24)
      PARAMETER (NCHARZ=2048)

      REAL      WX1(NWX),WX2(NWX)
      LOGICAL   LCNTL, LSYSFNT, LFPROP, LMRKFNT,LCNTLZ
      CHARACTER CSGI*1,CSUP*1,CSUB*1,CRST*1
      CHARACTER FONTNAME*70
      REAL      SMALL, SHIFT
      INTEGER   ISUBZ, ISUPZ, IRSTZ, IFONT, INDEX
      CHARACTER CHARZ*(NCHARZ)

      EXTERNAL  LENC,INDXCF,NINDXC,CSGI,ISGC

      SAVE

      DATA      NCNTZ/0/


*     / GET FONT INFORMATION /

      CALL SZFINT(NCNT)
      IF (NCNTZ.NE.NCNT) THEN
        CALL SZQFNW(WX1,WX2)
        NCNTZ=NCNT
      END IF

      CALL SZTXNO(CHARS,CHARZ,LCNTLZ)
      NCHZ=LENC(CHARZ)

*     / FOR SYSTEM FONTS /
*     / PROCCESS IF NOT MARKER /
      CALL SWLGET("LSYSFNT", LSYSFNT)
      IF(LSYSFNT) THEN
      CALL SZQIDX(INDEX)
      CALL SWCGET("FONTNAME",FONTNAME)
*     / WHEN FONTNAME IS NOT GIVEN /
      IF (LENZ(FONTNAME) == 0) THEN
        CALL SGLGET('LFPROP', LFPROP)
        IF (LFPROP) THEN
          CALL SGIGET('IFONT', IFONT)
          IF(IFONT.EQ.1)THEN
            FONTNAME = 'Sans'
          ELSE IF (IFONT.EQ.2)THEN
            FONTNAME = 'Serif'
          END IF
        ELSE
          FONTNAME = 'Monospace'
        END IF
        CALL SWFTFC(FONTNAME)
        CALL SWSFW(MAX(MOD(INDEX,10),1))
      ELSE
        CALL SWFTFC(FONTNAME)
      END IF

      IDX=ISGC(CHARZ(1:1))
      CALL SGLGET('LMRKFNT',LMRKFNT)
      IF (IDX.GT.18 .OR. LMRKFNT) THEN
        IF (IDX.LT.18) THEN
          CALL SWSFW(MAX(MOD(INDEX,10),1))
        END IF
        CALL SWQTXW(CHARZ,NCHZ,WXCH,WYCH)
        GO TO 40
      END IF
      END IF


*     / CHECK LCNTL OPTION /

      CALL SGLGET('LCNTL',LCNTL)
      LCNTLZ=.TRUE.

      IF (LCNTLZ) THEN

*       / CONTROL CHARACTERS ARE EFFECTIVE /

*        CALL SGIGET('ISUP',ISUP)
*        CALL SGIGET('ISUB',ISUB)
*        CALL SGIGET('IRST',IRST)
        CALL SGRGET('SMALL',SMALL)
        CALL SGRGET('SHIFT',SHIFT)

        ISUPZ=29
        ISUBZ=30
        IRSTZ=31
        CSUP=CSGI(ISUPZ)
        CSUB=CSGI(ISUBZ)
        CRST=CSGI(IRSTZ)

        NC=0
        NCTL=0
        NSUP=0
        NSUB=0
        ICHK=0

        MSUP=NINDXC(CHARZ,NCHZ,1,CSUP)
        MSUB=NINDXC(CHARZ,NCHZ,1,CSUB)
        MRST=NINDXC(CHARZ,NCHZ,1,CRST)
        IF (MRST.NE.(MSUP+MSUB)) THEN
          CALL MSGDMP('E','SZQTXW',
     +      'CONTROL CHARACTERS ARE NOT IN GOOD AGREEMENT.')
        END IF

   10   CONTINUE
          ID1=ICHK+1
          ID2=NCHZ
          NCHAR=ID2-ID1+1
          IDXRST=INDXCF(CHARZ(ID1:ID2),NCHAR,1,CRST)
          IF (IDXRST.GT.0) THEN
            ID3=ID1+IDXRST-1
            NDXSUP=NINDXC(CHARZ(ID1:ID3),IDXRST,1,CSUP)
            NDXSUB=NINDXC(CHARZ(ID1:ID3),IDXRST,1,CSUB)
            IF (NDXSUP.EQ.1 .NEQV. NDXSUB.EQ.1) THEN
              NCTL=NCTL+1
              IF (NDXSUP.EQ.1) THEN
                IDXSUP=INDXCF(CHARZ(ID1:ID3),IDXRST,1,CSUP)
                NCH=IDXRST-IDXSUP-1
                IF (NCH.GE.1) THEN
                  NSUP=NSUP+NCH
                ELSE
                  CALL MSGDMP('E','SZQTXW','NO VALID SUP CHARACTER.')
                END IF
              ELSE IF (NDXSUB.EQ.1) THEN
                IDXSUB=INDXCF(CHARZ(ID1:ID3),IDXRST,1,CSUB)
                NCH=IDXRST-IDXSUB-1
                IF (NCH.GE.1) THEN
                  NSUB=NSUB+NCH
                ELSE
                  CALL MSGDMP('E','SZQTXW','NO VALID SUB CHARACTER.')
                END IF
              END IF
              ICHK=ICHK+IDXRST
            ELSE
              CALL MSGDMP('E','SZQTXW',
     +          'CONTROL CHARACTERS ARE NOT IN GOOD AGREEMENT.')
            END IF
          END IF
        IF (.NOT.(IDXRST.EQ.0 .OR. ICHK.EQ.NCHZ)) GO TO 10

        DZ=MAX(0.5,SHIFT+SMALL/2)-0.5

        RFACT=1
        WXCH=0
        DO 20 N=1,NCHZ
          ICH=ISGC(CHARZ(N:N))
          IDX=ICH+1
          IF (ICH.EQ.ISUPZ .OR. ICH.EQ.ISUBZ) THEN
            RFACT=SMALL
            GO TO 20
          ELSE IF (ICH.EQ.IRSTZ) THEN
            RFACT=1
            GO TO 20
          END IF
          WXCH=WXCH+(WX2(IDX)-WX1(IDX))/WUNIT*RFACT
  20    CONTINUE

        WYCH=1
        IF (NSUP.GE.1) THEN
          WYCH=WYCH+DZ
        END IF
        IF (NSUB.GE.1) THEN
          WYCH=WYCH+DZ
        END IF

      ELSE

*       / CONTROL CHARACTERS ARE NOT EFFECTIVE /

        WXCH=0
        DO 30 N=1,NCHZ
          IDX=ISGC(CHARZ(N:N))+1
          WXCH=WXCH+(WX2(IDX)-WX1(IDX))/WUNIT
  30    CONTINUE
        WYCH=1

      END IF

  40  CONTINUE

      END

!-------------------------------------------------
!interface module of intlib
!-------------------------------------------------
module int_interface
  interface

    function irlt(rx)                             !rxより小さい最大の整数を求める
      real,      intent(in) :: rx                 !調べる実数値
      integer irlt                                !rxより小さい最大の整数関数値
    end function
      
    function irle(rx)                             !rx以下の最大の整数を求める
      real,      intent(in) :: rx                 !調べる実数値
      integer irle                                !rx以下の最大の整数関数値
    end function
      
    function irgt(rx)                             !rxより大きい最小の整数を求める
      real,      intent(in) :: rx                 !調べる実数値
      integer irgt                                !rxより大きい最大の整数関数値
    end function
      
    function irge(rx)                             !rx以上の最小の整数を求める
      real,      intent(in) :: rx                 !調べる実数値
      integer irge                                !rx以上の最大の整数関数値
    end function

  end interface
end module
!intlib library end ----

*-----------------------------------------------------------------------
*     FILL AREA PRIMITIVE (SOFT FILL - BASIC)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZTNSV(N,VPX,VPY,IROTA,RSPCE,ITYPE,INDEX)

      REAL      VPX(*),VPY(*)

      PARAMETER (NCMAX=200)

      REAL      SX(NCMAX)
      LOGICAL   LSX,LSY

      EXTERNAL  IMOD,IGUS,INDXRF,RMAX0,RMIN0,RD2R

      SAVE


      CALL SGRGET('BITLEN',BITLEN)
      CALL SGIGET('NBITS',NBITS)
      CALL SGRGET('RFAROT',ROT)

      CYCLE=BITLEN*NBITS

      ROTA=IMOD(IROTA+90,180)-90+ROT
      XCOS=COS(RD2R(ROTA))
      XSIN=SIN(RD2R(ROTA))

      DB1=+XCOS*VPX(1)+XSIN*VPY(1)
      DBMIN=DB1
      DBMAX=DB1
      DO 10 I=2,N
        DBI=+XCOS*VPX(I)+XSIN*VPY(I)
        IF (DBI.LT.DBMIN) THEN
          DBMIN=DBI
        END IF
        IF (DBI.GT.DBMAX) THEN
          DBMAX=DBI
        END IF
   10 CONTINUE
      DBMIN=IGUS(DBMIN/CYCLE)*CYCLE-CYCLE
      DBMAX=IGUS(DBMAX/CYCLE)*CYCLE+CYCLE

      DA1=-XSIN*VPX(1)+XCOS*VPY(1)
      DAMIN=DA1
      DAMAX=DA1
      DO 15 I=1,N
        DAI=-XSIN*VPX(I)+XCOS*VPY(I)
        IF (DAI.LT.DAMIN) THEN
          DAMIN=DAI
        END IF
        IF (DAI.GT.DAMAX) THEN
          DAMAX=DAI
        END IF
   15 CONTINUE
      DAMIN=IGUS(DAMIN/RSPCE)*RSPCE-RSPCE
      DAMAX=IGUS(DAMAX/RSPCE)*RSPCE+RSPCE

      CALL SGIGET('MOVE',MOVEZ)
      CALL SZQIDX(INDEXZ)
      CALL SZQTYP(ITYPEZ)

      CALL SGISET('MOVE',1)
      CALL SZSIDX(INDEX)
      CALL SZSTYP(ITYPE)

*     DO 30 DA=DAMIN,DAMAX,RSPCE
      NCNT=MAX(INT((DAMAX-DAMIN+RSPCE)/RSPCE),0)
      DO 30 IDA=1,NCNT
        DA=DAMIN+RSPCE*(IDA-1)
        XA=-XSIN*DA
        YA=+XCOS*DA
        X1=XA+XCOS*DBMIN
        Y1=YA+XSIN*DBMIN
        X2=XA+XCOS*DBMAX
        Y2=YA+XSIN*DBMAX
        NP=0
        DO 20 I=1,N
          IB=IMOD(I-2,N)+1
          IC=I
          IA=IMOD(I,N)+1
          X3=VPX(IC)
          Y3=VPY(IC)
          X4=VPX(IA)
          Y4=VPY(IA)
          D=-(X2-X1)*(Y4-Y3)+(Y2-Y1)*(X4-X3)
          IF (D.NE.0) THEN
            SXX=(-(Y4-Y3)*(X3-X1)+(X4-X3)*(Y3-Y1))/D
            TXX=(-(Y2-Y1)*(X3-X1)+(X2-X1)*(Y3-Y1))/D
            LSX=0.LT.SXX .AND. SXX.LT.1
            LSY=0.LT.TXX .AND. TXX.LT.1
*           IF (0.LT.SXX .AND. SXX.LT.1 .AND.
*    +          0.LT.TXX .AND. TXX.LT.1 ) THEN
            IF (LSX .AND. LSY) THEN
              NP=NP+1
              SX(NP)=SXX
            ELSE IF (TXX.EQ.0) THEN
              DAIB=-XSIN*VPX(IB)+XCOS*VPY(IB)
              DAIA=-XSIN*VPX(IA)+XCOS*VPY(IA)
              IF ((DAIB-DA)*(DAIA-DA).LT.0) THEN
                NP=NP+1
                SX(NP)=SXX
              END IF
            END IF
          END IF
   20   CONTINUE

        IF (NP.GT.NCMAX) THEN
          CALL MSGDMP('E','SZTNSV','WORKING AREA OVERFLOW.')
        END IF

        IF (NP.GT.0) THEN
          SZMAX=RMAX0(SX,NP,1)
          CALL SZOPLV
          CALL SZMVLV(X1,Y1)
          DO 25 J=1,NP
            SZ=RMIN0(SX,NP,1)
            IZ=INDXRF(SX,NP,1,SZ)
            XS=X1+SZ*(X2-X1)
            YS=Y1+SZ*(Y2-Y1)
            IF (MOD(J,2).NE.0) THEN
              CALL SZMVLV(XS,YS)
            ELSE
              CALL SZPLLV(XS,YS)
            END IF
            SX(IZ)=SZMAX
   25     CONTINUE
          CALL SZCLLV
        END IF
   30 CONTINUE

      CALL SGISET('MOVE',MOVEZ)
      CALL SZSIDX(INDEXZ)
      CALL SZSTYP(ITYPEZ)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHONC

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

      CALL SGSWND( 0.0, 10.0, 0.0, 10.0 )
      CALL SGSVPT( 0.0,  1.0, 0.0,  1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

*-- デフォルト ----
      Y1 = 9.0
      DO 10 I=1,8
        X1 = I
        X2 = X1 + 0.1*I
        Y2 = Y1 + 0.1*I
        CALL SGLAU( X1, Y1, X2, Y2 )
   10 CONTINUE

*-- 線分のラインタイプ ----
      Y1 = 8.0
      Y2 = 8.6
      DO 20 I=1,4
        X1 = 2*I - 1
        X2 = X1 + 0.6
        CALL SGSLAT( I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   20 CONTINUE

      CALL SGSLAT( 1 )

*-- 線分のラインインデクス ----
      Y1 = 7.0
      Y2 = 7.6
      DO 30 I=1,4
        X1 = 2*I
        X2 = X1 + 0.6
        CALL SGSLAI( I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   30 CONTINUE

      CALL SGSLAI( 1 )

*-- 矢じり部分の長さ ----
      CALL SGLSET( 'LPROP', .FALSE. )
      CALL SGRSET( 'CONST', 0.03 )

      Y1 = 6.0
      DO 40 I=1,8
        X1 = I
        X2 = X1 + 0.1*I
        Y2 = Y1 + 0.1*I
        CALL SGLAU( X1, Y1, X2, Y2 )
   40 CONTINUE

      CALL SGLSET( 'LPROP', .TRUE. )

*-- 矢じり部分の角度 ----
      Y1 = 5.0
      Y2 = 5.6
      DO 50 I=1,8
        X1 = I
        X2 = X1 + 0.6
        CALL SGRSET( 'ANGLE', 10.0*I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   50 CONTINUE

*-- 矢じり部分のぬりつぶし ----
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL SGLSET( 'LATONE', .TRUE. )
      CALL SGISET( 'IATONE', 655 )

      Y1 = 4.0
      Y2 = 4.6
      DO 60 I=1,8
        X1 = I
        X2 = X1 + 0.6
        CALL SGRSET( 'ANGLE', 10.*I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   60 CONTINUE

*-- ラインサブプリミティブ ----
*-- デフォルト ----
        CALL SGLNU( 0., 3., 10., 3. )

*-- 線分のラインインデクス ----
      Y1 = 0.5
      Y2 = 2.5
      DO 70 I=1,4
        X1 = 2*I - 1
        X2 = X1 + 2.0
        CALL SGSLNI( I )
        CALL SGLNU( X1, Y1, X2, Y2 )
   70 CONTINUE

      CALL SGCLS

      END

      PROGRAM KIHONC

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

      CALL SGSWND( 0.0, 10.0, 0.0, 10.0 )
      CALL SGSVPT( 0.0,  1.0, 0.0,  1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

*-- デフォルト ----
      Y1 = 9.0
      DO 10 I=1,8
        X1 = I
        X2 = X1 + 0.1*I
        Y2 = Y1 + 0.1*I
        CALL SGLAU( X1, Y1, X2, Y2 )
   10 CONTINUE

*-- 線分のラインタイプ ----
      Y1 = 8.0
      Y2 = 8.6
      DO 20 I=1,4
        X1 = 2*I - 1
        X2 = X1 + 0.6
        CALL SGSLAT( I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   20 CONTINUE

      CALL SGSLAT( 1 )

*-- 線分のラインインデクス ----
      Y1 = 7.0
      Y2 = 7.6
      DO 30 I=1,4
        X1 = 2*I
        X2 = X1 + 0.6
        CALL SGSLAI( I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   30 CONTINUE

      CALL SGSLAI( 1 )

*-- 矢じり部分の長さ ----
      CALL SGLSET( 'LPROP', .FALSE. )
      CALL SGRSET( 'CONST', 0.03 )

      Y1 = 6.0
      DO 40 I=1,8
        X1 = I
        X2 = X1 + 0.1*I
        Y2 = Y1 + 0.1*I
        CALL SGLAU( X1, Y1, X2, Y2 )
   40 CONTINUE

      CALL SGLSET( 'LPROP', .TRUE. )

*-- 矢じり部分の角度 ----
      Y1 = 5.0
      Y2 = 5.6
      DO 50 I=1,8
        X1 = I
        X2 = X1 + 0.6
        CALL SGRSET( 'ANGLE', 10.0*I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   50 CONTINUE

*-- 矢じり部分のぬりつぶし ----
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL SGLSET( 'LATONE', .TRUE. )
      CALL SGISET( 'IATONE', 655 )

      Y1 = 4.0
      Y2 = 4.6
      DO 60 I=1,8
        X1 = I
        X2 = X1 + 0.6
        CALL SGRSET( 'ANGLE', 10.*I )
        CALL SGLAU( X1, Y1, X2, Y2 )
   60 CONTINUE

*-- ラインサブプリミティブ ----
*-- デフォルト ----
        CALL SGLNU( 0., 3., 10., 3. )

*-- 線分のラインインデクス ----
      Y1 = 0.5
      Y2 = 2.5
      DO 70 I=1,4
        X1 = 2*I - 1
        X2 = X1 + 2.0
        CALL SGSLNI( I )
        CALL SGLNU( X1, Y1, X2, Y2 )
   70 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UXSAXS : OFFSET FOR NEW AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXSAXS(CSIDE)

      CHARACTER CSIDE*1

      LOGICAL   LUXCHK,LCHREQ


      IF (.NOT.LUXCHK(CSIDE)) THEN
        CALL MSGDMP('E','UXSAXS','SIDE PARAMETER IS INVALID.')
      END IF

      CALL UZRGET('ROFFX'//CSIDE,ROFFX)
      CALL UZRGET('RSIZET2',RSIZET)
      CALL UZRGET('RSIZEC2',RSIZEC)
      CALL UZRGET('PAD2',PAD)
      CALL UZIGET('INNER',INNER)
      JSGN=SIGN(1,INNER)

      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        IF (LCHREQ(CSIDE,'B')) THEN
          IFLAG=-1
        ELSE
          IFLAG=+1
        END IF
      ELSE
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      RTICK=-RSIZET*JSGN*IFLAG

      IF (IFLAG.GE.0) THEN
        ROFFX=MAX(ROFFX-RTICK,ROFFX)+RSIZEC*PAD
      ELSE
        ROFFX=MIN(ROFFX-RTICK,ROFFX)-RSIZEC*PAD
      END IF

      CALL UXSAXZ(CSIDE,ROFFX)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLQSIZ(CSIZE,DX,DY)

      CHARACTER CSIZE*(*)

      LOGICAL   LCHREQ,LCHRD
      CHARACTER CS1*1,CS2*1

      EXTERNAL  LCHREQ,LCHRD


      CS1=CSIZE(1:1)
      CS2=CSIZE(2:2)
      IF (LCHREQ(CS1,'A')) THEN
        DX=118.9
        DY=84.1
      ELSE IF (LCHREQ(CS1,'B')) THEN
        DX=145.6
        DY=103.0
      ELSE
        CALL MSGDMP('E','SLQSIZ','SIZE PARAMETER IS INVALID.')
      END IF

      IF (.NOT.LCHRD(CS2)) THEN
        CALL MSGDMP('E','SLQSIZ','SIZE PARAMETER IS INVALID.')
      END IF

      READ(CS2,'(I1)') NS
      DO 10 I=1,NS
        DX2=DX/2
        DX=DY
        DY=DX2
   10 CONTINUE

      END

program layout02

  use dcl

  character(len=7) :: ctxt = 'frame??'

    call DclOpenGraphics()

    call DclSetFrameMargin( 0.1, 0.1, 0.05, 0.05 )
    call DclDivideFrame( 'y', 3, 2 )
    call DclSetFrameMargin( 0.05, 0.05, 0.05, 0.05 )

    do i=1,12
      call DclNewFrame
      call DclSetViewPort( 0.1,0.9,0.1,0.9 )
      call DclDrawViewPortFrame( 1 )
      write(ctxt(6:7),'(i2.2)') i
      call DclDrawTextNormalized( 0.5, 0.5, ctxt )
    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     CLIPPING ON VC
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPCLL(VX0,VY0,VX1,VY1,LVALID,II)

      LOGICAL   LVALID,LCONT,LMOVE

      INTEGER   ISTART(0:1),INDX(4)
      REAL      XLIM(2,0:1),YLIM(2,0:1),VX(2,0:1),VY(2,0:1),XJ(4),YJ(4)

      SAVE


      IF (VX0.LT.XLIM(1,II)) THEN
        KX0=0
      ELSE IF (VX0.GT.XLIM(2,II)) THEN
        KX0=2
      ELSE
        KX0=1
      END IF
      IF (VY0.LT.YLIM(1,II)) THEN
        KY0=0
      ELSE IF (VY0.GT.YLIM(2,II)) THEN
        KY0=2
      ELSE
        KY0=1
      END IF
      K0=KX0+3*KY0

      IF (VX1.LT.XLIM(1,II)) THEN
        KX1=0
      ELSE IF (VX1.GT.XLIM(2,II)) THEN
        KX1=2
      ELSE
        KX1=1
      END IF
      IF (VY1.LT.YLIM(1,II)) THEN
        KY1=0
      ELSE IF (VY1.GT.YLIM(2,II)) THEN
        KY1=2
      ELSE
        KY1=1
      END IF
      K1=KX1+3*KY1

      LVALID=.TRUE.

      IF (K1.EQ.4 .AND. K0.EQ.4) THEN

*       / VISIBLE /

        ISTART(II)=2
        VX(2,II)=VX1
        VY(2,II)=VY1
        RETURN

      ELSE IF (K1.EQ.4 .OR. K0.EQ.4) THEN

*       / HALF VISIBLE /

        IF (KX1.EQ.1 .AND. KX0.EQ.1) THEN

*         / CROSSES VERTICAL EDGE /

          KYL=MAX(KY1,KY0)/2+1
          YI=YLIM(KYL,II)
          XI=VX0+(YI-VY0)/(VY1-VY0)*(VX1-VX0)

        ELSE IF (KY1.EQ.1 .AND. KY0.EQ.1) THEN

*         / CROSSES HORIZONTAL EDGE /

          KXL=MAX(KX1,KX0)/2+1
          XI=XLIM(KXL,II)
          YI=VY0+(XI-VX0)/(VX1-VX0)*(VY1-VY0)

        ELSE

*         / CROSSES DIAGONAL CORNERS /

          KXL=MAX(KX1,KX0)/2+1
          KYL=MAX(KY1,KY0)/2+1
          DYDX=(VY1-VY0)/(VX1-VX0)
          YC=VY1-DYDX*VX1
          XI=XLIM(KXL,II)
          YI=YC+DYDX*XI
          IF (YI.LT.YLIM(1,II) .OR. YI.GT.YLIM(2,II)) THEN
            YI=YLIM(KYL,II)
            XI=(YI-YC)/DYDX
          END IF
        END IF

        IF (K1.EQ.4) THEN
          ISTART(II)=1
          VX(1,II)=XI
          VY(1,II)=YI
          VX(2,II)=VX1
          VY(2,II)=VY1
        ELSE
          ISTART(II)=2
          VX(2,II)=XI
          VY(2,II)=YI
        END IF

      ELSE IF ((ABS(KX1-KX0)+ABS(KY1-KY0)).GE.2) THEN

*       / LINE GOES THROUGH WINDOWED SECTION, BUT STARTS AND ENDS
*         ELSEWHERE.  TEST TO SEE IF VERTICAL OR HORIZONTAL. /

        ISTART(II)=1
        IF (VX1.EQ.VX0) THEN
          VX(1,II)=VX1
          VY(1,II)=YLIM(1,II)
          VX(2,II)=VX1
          VY(2,II)=YLIM(2,II)
          IF (MOD(KX0,2).EQ.0) LVALID=.FALSE.
        ELSE IF (VY1.EQ.VY0) THEN
          VX(1,II)=XLIM(1,II)
          VY(1,II)=VY1
          VX(2,II)=XLIM(2,II)
          VY(2,II)=VY1
          IF (MOD(KY0,2).EQ.0) LVALID=.FALSE.
        ELSE
          DYDX=(VY1-VY0)/(VX1-VX0)
          DXDY=1.0/DYDX
          YC=VY1-DYDX*VX1
          YJ(1)=YLIM(2,II)
          XJ(1)=DXDY*(YJ(1)-YC)
          XJ(2)=XLIM(1,II)
          YJ(2)=YC+DYDX*XJ(2)
          XJ(3)=XLIM(2,II)
          YJ(3)=YC+DYDX*XJ(3)
          YJ(4)=YLIM(1,II)
          XJ(4)=DXDY*(YJ(4)-YC)
          KK=0
          IF (XJ(1).GE.XLIM(1,II) .AND. XJ(1).LE.XLIM(2,II)) THEN
            KK=KK+1
            INDX(KK)=1
          END IF
          IF (YJ(2).GE.YLIM(1,II) .AND. YJ(2).LE.YLIM(2,II)) THEN
            KK=KK+1
            INDX(KK)=2
          END IF
          IF (YJ(3).GE.YLIM(1,II) .AND. YJ(3).LE.YLIM(2,II)) THEN
            KK=KK+1
            INDX(KK)=3
          END IF
          IF (XJ(4).GE.XLIM(1,II) .AND. XJ(4).LE.XLIM(2,II)) THEN
            KK=KK+1
            INDX(KK)=4
          END IF
          IF (KK.GE.1) THEN
            I1=INDX(1)
            I2=INDX(KK)
            VX(1,II)=XJ(I1)
            VY(1,II)=YJ(I1)
            VX(2,II)=XJ(I2)
            VY(2,II)=YJ(I2)
          ELSE
            LVALID=.FALSE.
          END IF
        END IF
      ELSE
        LVALID=.FALSE.
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZGCLL(XX, YY, LCONT, LMOVE, II)

      XX=VX(ISTART(II),II)
      YY=VY(ISTART(II),II)
      LCONT=ISTART(II).EQ.1
      LMOVE=ISTART(II).EQ.1
      ISTART(II)=ISTART(II)+1

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSCLL(VXMIN,VXMAX,VYMIN,VYMAX,II)

      XLIM(1,II)=VXMIN
      XLIM(2,II)=VXMAX
      YLIM(1,II)=VYMIN
      YLIM(2,II)=VYMAX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQCLL(VXMIN,VXMAX,VYMIN,VYMAX,II)

      VXMIN=XLIM(1,II)
      VXMAX=XLIM(2,II)
      VYMIN=YLIM(1,II)
      VYMAX=YLIM(2,II)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPLZV(N,VPX,VPY)

      REAL      VPX(*),VPY(*)

      LOGICAL   LFLAG

      COMMON    /SZBPL1/ LMISS,RMISS
      LOGICAL   LMISS

      SAVE


      CALL SZOPLV

      IF (.NOT.LMISS) THEN
        CALL SZMVLV(VPX(1),VPY(1))
        DO 10 I=2,N
          CALL SZPLLV(VPX(I),VPY(I))
   10   CONTINUE
      ELSE
        LFLAG=.FALSE.
        DO 20 I=1,N
          IF (VPX(I).EQ.RMISS .OR. VPY(I).EQ.RMISS) THEN
            LFLAG=.FALSE.
          ELSE IF (LFLAG) THEN
            CALL SZPLLV(VPX(I),VPY(I))
          ELSE
            CALL SZMVLV(VPX(I),VPY(I))
            LFLAG=.TRUE.
          END IF
   20   CONTINUE
      END IF

      CALL SZCLLV

      END

*-----------------------------------------------------------------------
      SUBROUTINE UIPDAZ(Z, MX, NX, NY, IMAGE,MAXPXL)

      PARAMETER (PI = 3.1415, CPI =PI/180.)
      REAL      Z(MX,*)
      INTEGER   IMAGE(MAXPXL)
      INTEGER   NS(2), NP(2), NQ(2)
      LOGICAL   LMISS,LIMC,LFCC,LCX,LCY,LCNR,LSHDW,LDEG,LMAP,LSPHE
      DATA      NP /1,1/

*     / CHECK IMAGE CAPABILITY /

      CALL SWQIMC(LIMC)
      IF (.NOT.LIMC) THEN
        CALL MSGDMP('E','UIPDAT','NO IMAGE CAPABILITY.')
      END IF

      CALL SWQFCC(LFCC)
      IF (.NOT.LFCC) THEN
        CALL MSGDMP('E','UIPDAT','NO FULL COLOR CAPABILITY.')
      END IF

*     / GET INTERNAL PARAMETERS /

      CALL GLRGET('RUNDEF  ', RUNDEF)
      CALL GLIGET('IUNDEF  ', IUNDEF)
      CALL GLLGET('LMISS   ', LMISS )
      CALL GLRGET('RMISS   ', RMISS )

      CALL UIIGET('ICOLOR1 ', ICOLOR1)
      CALL UIIGET('ICOLOR2 ', ICOLOR2)
      CALL UIIGET('ICOLOR3 ', ICOLOR3)
      CALL UILGET('LCELLX  ', LCX)
      CALL UILGET('LCELLY  ', LCY)
      CALL UILGET('LCORNER ', LCNR)
      CALL UILGET('LEMBOSS ', LSHDW)
      CALL UILGET('LSPHERE ', LSPHE)
      CALL UIRGET('DENSITY ', DENSTY)

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      NGX = NX
      NGY = NY
      IF(LCX) NGX = NGX + 1
      IF(LCY) NGY = NGY + 1
      CALL UWDFLT(NGX, NGY)

*     / INITIALIZE /


      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      CALL STFPR2(VXMIN, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX1, WY1)
      CALL SWFINT(WX1, WY1, IX1, IY1)

      CALL STFPR2(VXMAX, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX2, WY2)
      CALL SWFINT(WX2, WY2, IX2, IY2)

      CALL STFPR2(VXMAX, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX3, WY3)
      CALL SWFINT(WX3, WY3, IX3, IY3)

      CALL STFPR2(VXMIN, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX4, WY4)
      CALL SWFINT(WX4, WY4, IX4, IY4)

      IXMIN  = MIN(IX1, IX2, IX3, IX4)
      IYMIN  = MIN(IY1, IY2, IY3, IY4)
      IXMAX  = MAX(IX1, IX2, IX3, IX4)
      IYMAX  = MAX(IY1, IY2, IY3, IY4)
      IWIDTH = IXMAX-IXMIN+1
      IHIGHT = IYMAX-IYMIN+1
      
      CALL SWIOPN(IXMIN, IYMIN, IWIDTH, IHIGHT, 
     +            WX1, WY1, WX2, WY2, WX3, WY3, WX4, WY4)

      NS(1) = MX
      NS(2) = NY
      NQ(1) = NX
      NQ(2) = NY

      ZMIN = RVMIN(Z, NS, NP, NQ, 2)
      ZMAX = RVMAX(Z, NS, NP, NQ, 2)
      CALL UICINI(ZMIN, ZMAX)

      IF(LSHDW) THEN
        CALL SGIGET('ITR ', ITR )
        CALL SGLGET('LDEG', LDEG)
        LMAP = 10.LE.ITR .AND. ITR.LE.39

        AVE = 0.
        NN = 0.
        NXINT = MAX(1, NX/500)
        NYINT = MAX(1, NY/500)
        DO 11 IX=1, NX-1, NXINT
          DO 10 IY=1, NY-1, NYINT
            IF (.NOT. LMISS .OR. 
     +         (Z(IX,IY  ).NE.RMISS .AND. Z(IX+1,IY  ).NE.RMISS .AND.
     +          Z(IX,IY+1).NE.RMISS .AND. Z(IX+1,IY+1).NE.RMISS)) THEN
              Y1 = RUWGY(IY  )
              Y2 = RUWGY(IY+1)
              DX = (RUWGX(IX+1) - RUWGX(IX))
              DY = (Y2 - Y1)
              IF(LMAP)THEN
                YY = (Y1+Y2)/2.
                IF(LDEG) YY = CPI*YY
                DX = DX*COS(YY)
              END IF
              ZX = (Z(IX+1, IY) - Z(IX, IY)) / DX
              ZY = (Z(IX, IY+1) - Z(IX, IY)) / DY
              AVE = AVE + ABS(ZX) + ABS(ZY)
              NN  = NN +2
            END IF
 10       CONTINUE
 11     CONTINUE
        CALL UIRGET('EMBOSSMENT_HEIGHT', HEIGHT)
        AVE = AVE/NN*2/HEIGHT

        IF(LSPHE) THEN
          CALL UIRGET('LIGHT_LONGITUDE', PHI)
          CALL UIRGET('LIGHT_LATITUDE ', THE)
          EX0 = COS(THE*CPI)*COS(PHI*CPI)
          EY0 = COS(THE*CPI)*SIN(PHI*CPI)
          EZ0 = SIN(THE*CPI)
        ELSE
          CALL UIRGET('LIGHT_DIRECTION', THETA)
          EX =  SIN(THETA*CPI)
          EY = -COS(THETA*CPI)
          EZ = 0.
        END IF
      END IF

*     / LOOP FOR EACH PIXEL /

      DO 30 J=1, IHIGHT
        DO 20 I=1, IWIDTH

          CALL SWIINT(I+IXMIN-1, J+IYMIN-1, WX, WY)
          CALL STIWTR(WX, WY, RX, RY)
          CALL STIPR2(RX, RY, VX, VY)
          CALL STITRF(VX, VY, UX, UY)

          IF (UX.EQ.RUNDEF) THEN
            IMAGE(I) = ICOLOR1
          ELSE
            CALL UWQGXI(UX,IX,FX)
            CALL UWQGYI(UY,IY,FY)

            IF(LSHDW) THEN
              Y1 = RUWGY(IY  )
              Y2 = RUWGY(IY+1)
              X1 = RUWGX(IX  )
              X2 = RUWGX(IX+1)
              DX = (X2 - X1)*AVE
              DY = (Y2 - Y1)*AVE
              IF(LMAP)THEN
                XX = (X1+X2)/2.
                YY = (Y1+Y2)/2.
                IF(LDEG) THEN
                  XX = 3.141592/180.*XX
                  YY = 3.141592/180.*YY
                END IF
                DX = DX*COS(YY)
                IF(LSPHE) THEN
                  CALL CR3C(-YY+PI/2.,+XX,-PI/2.,EX0,EY0,EZ0,EX,EY,EZ)
                END IF
              END IF
            END IF

            IF (IX.EQ.IUNDEF .OR. IY.EQ.IUNDEF) THEN
              IMAGE(I) = ICOLOR2
            ELSE
              IF(LCX .AND. LCY) THEN
                IF (LMISS .AND. Z(IX, IY).EQ.RMISS) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  ZZ =  Z(IX, IY  )
                  CALL UICRGB(ZZ, 0., IMAGE(I))
                END IF

              ELSE IF(LCX .AND. .NOT.LCY) THEN
                IF (LMISS .AND. 
     +             (Z(IX,IY).EQ.RMISS .OR. Z(IX,IY+1).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  ZZ = Z(IX, IY  )*(1-FY) + Z(IX  ,IY+1)*FY
                  CALL UICRGB(ZZ, 0., IMAGE(I))
                END IF

              ELSE IF(.NOT.LCX .AND. LCY) THEN
                IF (LMISS .AND. 
     +             (Z(IX,IY).EQ.RMISS .OR. Z(IX+1,IY).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  ZZ = Z(IX, IY  )*(1-FX) + Z(IX+1,IY  )*FX
                  CALL UICRGB(ZZ, 0., IMAGE(I))
                END IF

              ELSE IF(.NOT.LCX .AND. .NOT.LCY) THEN
                IF (.NOT. LMISS .OR. 
     +           (Z(IX,IY  ).NE.RMISS .AND. Z(IX+1,IY  ).NE.RMISS .AND.
     +            Z(IX,IY+1).NE.RMISS .AND. Z(IX+1,IY+1).NE.RMISS)) THEN
                  ZZ = (Z(IX, IY  )*(1-FX) + Z(IX+1,IY  )*FX)*(1-FY)
     +               + (Z(IX, IY+1)*(1-FX) + Z(IX+1,IY+1)*FX)*FY
                  
                  IF(LSHDW) THEN
                    ZX = ((Z(IX+1, IY  ) - Z(IX,   IY  ))*(1.-FY)
     +                 +  (Z(IX+1, IY+1) - Z(IX,   IY+1))*FY)/DX
                    ZY = ((Z(IX,   IY+1) - Z(IX,   IY  ))*(1.-FX)
     +                 +  (Z(IX+1, IY+1) - Z(IX+1, IY  ))*FX)/DY
                    CALL UISHDW(ZX, ZY, EX, EY, EZ, CMSK)
                  ELSE
                    CMSK = 0.
                  END IF
                  CALL UICRGB(ZZ, CMSK*DENSTY, IMAGE(I))

                ELSE IF(LCNR .AND. (FX+FY).LE.1 .AND.
     +           (Z(IX,IY  ).NE.RMISS .AND. Z(IX+1,IY  ).NE.RMISS .AND.
     +            Z(IX,IY+1).NE.RMISS .AND. Z(IX+1,IY+1).EQ.RMISS)) THEN
                  ZZ = Z(IX,  IY  )*(1-FX-FY) 
     +               + Z(IX+1,IY )*FX + Z(IX, IY+1)*FY

                  IF(LSHDW) THEN
                    ZX = (Z(IX+1, IY  ) - Z(IX,   IY  ))/DX
                    ZY = (Z(IX,   IY+1) - Z(IX,   IY  ))/DY
                    CALL UISHDW(ZX, ZY, EX, EY, EZ, CMSK)
                  ELSE
                    CMSK = 0.
                  END IF
                  CALL UICRGB(ZZ, CMSK*DENSTY, IMAGE(I))

                ELSE IF(LCNR .AND. (1-FX+FY).LE.1 .AND.
     +           (Z(IX,IY  ).NE.RMISS .AND. Z(IX+1,IY  ).NE.RMISS .AND.
     +            Z(IX,IY+1).EQ.RMISS .AND. Z(IX+1,IY+1).NE.RMISS)) THEN
                  ZZ = Z(IX+1,IY  )*(FX-FY) 
     +               + Z(IX  ,IY )*(1-FX) + Z(IX+1, IY+1)*FY

                  IF(LSHDW) THEN
                    ZX = (Z(IX+1, IY  ) - Z(IX,   IY  ))/DX
                    ZY = (Z(IX+1, IY+1) - Z(IX+1, IY  ))/DY
                    CALL UISHDW(ZX, ZY, EX, EY, EZ, CMSK)
                  ELSE
                    CMSK = 0.
                  END IF
                  CALL UICRGB(ZZ, CMSK*DENSTY, IMAGE(I))

                ELSE IF(LCNR .AND. (1+FX-FY).LE.1 .AND.
     +           (Z(IX,IY  ).NE.RMISS .AND. Z(IX+1,IY  ).EQ.RMISS .AND.
     +            Z(IX,IY+1).NE.RMISS .AND. Z(IX+1,IY+1).NE.RMISS)) THEN
                  ZZ = Z(IX  ,IY+1)*(FY-FX) 
     +               + Z(IX+1,IY+1)*FX + Z(IX, IY)*(1-FY)

                  IF(LSHDW) THEN
                    ZX = (Z(IX+1, IY+1) - Z(IX,   IY+1))/DX
                    ZY = (Z(IX,   IY+1) - Z(IX,   IY  ))/DY
                    CALL UISHDW(ZX, ZY, EX, EY, EZ, CMSK)
                  ELSE
                    CMSK = 0.
                  END IF
                  CALL UICRGB(ZZ, CMSK*DENSTY, IMAGE(I))

                ELSE IF(LCNR .AND. (2-FX-FY).LE.1 .AND.
     +           (Z(IX,IY  ).EQ.RMISS .AND. Z(IX+1,IY  ).NE.RMISS .AND.
     +            Z(IX,IY+1).NE.RMISS .AND. Z(IX+1,IY+1).NE.RMISS)) THEN
                  ZZ = Z(IX+1,IY+1)*(FX+FY-1) 
     +               + Z(IX  ,IY+1)*(1-FX) + Z(IX+1, IY)*(1-FY)

                  IF(LSHDW) THEN
                    ZX = (Z(IX+1, IY+1) - Z(IX,   IY+1))/DX
                    ZY = (Z(IX+1, IY+1) - Z(IX+1, IY  ))/DY
                    CALL UISHDW(ZX, ZY, EX, EY, EZ, CMSK)
                  ELSE
                    CMSK = 0.
                  END IF
                  CALL UICRGB(ZZ, CMSK*DENSTY, IMAGE(I))

                ELSE
                  IMAGE(I) = ICOLOR3
                END IF
              END IF

            END IF
          END IF
   20   CONTINUE

        CALL SWICLR(IMAGE, IWIDTH)
   30 CONTINUE

      CALL SWICLS

      END
*-----------------------------------------------------------------------
      SUBROUTINE UISHDW(DX, DY, EX, EY, EZ, CC)

        IF(DX .NE. 0. .AND. DY.NE.0.) THEN
          A  = 1./DX
          B  = 1./DY
          AB = SQRT(A**2+B**2)

          C  = ABS(A*B)/AB
          CS = SQRT(1.+C**2)

          VX = SIGN(B,A)/AB/CS
          VY = SIGN(A,B)/AB/CS
          VZ = C/CS
        ELSE IF(DX .NE. 0.) THEN
          A  = 1./DX
          CS = SQRT(1.+A**2)

          VX = SIGN(1.,A)/CS
          VY = 0.
          VZ = ABS(A)/CS
        ELSE IF(DY .NE. 0.) THEN
          B  = 1./DY
          CS = SQRT(1.+B**2)

          VX = 0.
          VY = SIGN(1.,B)/CS
          VZ = ABS(B)/CS
        ELSE
          VX = 0.
          VY = 0.
          VZ = 1.
        END IF

        CC = VX*EX + VY*EY + VZ*EZ

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      REAL FUNCTION R4IBM(II)

      LOGICAL   LFRST

      SAVE

      EXTERNAL  ISHIFT

      DATA      LFRST/.TRUE./


      IF (LFRST) THEN
        ISMASK=0
        CALL SBYTE(ISMASK,2** 1-1,0, 1)
        IEMASK=0
        CALL SBYTE(IEMASK,2** 7-1,1, 7)
        IXMASK=0
        CALL SBYTE(IXMASK,2**24-1,8,24)
        LFRST=.FALSE.
      END IF

      IF (II.EQ.0) THEN
        R4IBM=0
        RETURN
      END IF

      IS=ISHIFT(IAND(ISMASK,II),-31)
      IE=ISHIFT(IAND(IEMASK,II),-24)
      IX=IAND(IXMASK,II)

      IF (IS.NE.0) THEN
        R4IBM = - (IX/2.0**20) * 16.0**(IE-65)
      ELSE
        R4IBM = + (IX/2.0**20) * 16.0**(IE-65)
      END IF

      END

*-----------------------------------------------------------------------
*     USPACK AUTO SCALING ROUTINE (LOG)                DCL 5.0 95/09/04
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USUSCL(CAXIS, UMIN,  UMAX,  VMIN,  VMAX)

      REAL        SC(4)
      CHARACTER   CAXIS*1, CP*8
      DATA        SC / 1., 2., 5., 10./

*----------------------- ARGUMENT CHECK --------------------------------

      IF(CAXIS.NE.'X' .AND. CAXIS.NE.'Y')
     #   CALL MSGDMP('E', 'USUSCL', 'INVALID CAXIS')

      IF(VMIN.GE.VMAX)
     #   CALL MSGDMP('E', 'USUSCL', 'VMIN>VMAX')

*--------------------------- PARAMETERS --------------------------------

      CP = 'MXDGT'//CAXIS
      CALL USIGET(CP, MXDGT)

      CALL GLRGET('RUNDEF' , RUNDEF)
      CALL GLIGET('IUNDEF' , IUNDEF)
      CALL UZRGET('RSIZEL1', CW)

*--------------------------- ITYPE & UFAC ------------------------------

      CALL GNSAVE
      CALL GNSBLK(SC, 4)
      CALL GNGE(MAX(UMAX,UMIN), BUMAX, IPMAX)
      CALL GNLE(MIN(UMIN,UMAX), BUMIN, IPMIN)
      CALL GNRSET

      IF(IPMAX.LE.IPMIN+1) THEN
        ITYPE = 1
!        IF(IPMAX+1.GT.MXDGT .OR. 2-IPMIN.GT.MXDGT) THEN
!          UFAC = 1.D1**IPMIN
!        ELSE
!        ENDIF
      ELSE
        ITYPE = 2
      ENDIF
      UFAC = 1.
!
      CP = CAXIS//'FAC'
      CALL USRGET(CP, UFACA)
      IF(UFACA .EQ.RUNDEF) CALL USRSET(CP, UFAC)

      CP = 'ITYPE'//CAXIS
      CALL USIGET(CP, ITYPEA)
      IF(ITYPEA.EQ.IUNDEF) CALL USISET(CP, ITYPE)

*--------------------------- NLBL & NTISCKS ----------------------------

      DV = (VMAX-VMIN) / ABS(LOG10(UMAX)-LOG10(UMIN)) / CW
      IF(DV.GE.10.) THEN
        NLBL   = 3
        NTICKS = 9
      ELSEIF(DV.GE.5.) THEN
        NLBL   = 1
        NTICKS = 9
      ELSEIF(DV.GE.2.5) THEN
        NLBL   = 1
        NTICKS = 5
      ELSE
        NLBL   = 1
        NTICKS = 2
      ENDIF

      CP = 'NLBL'//CAXIS
      CALL USIGET(CP, NLBLA)
      IF(NLBLA .EQ.IUNDEF) CALL USISET(CP, NLBL)

      CP = 'NTICKS'//CAXIS
      CALL USIGET(CP, NTICKA)
      IF(NTICKA.EQ.IUNDEF) CALL USISET(CP, NTICKS)

      RETURN
      END

*-----------------------------------------------------------------------
*     TONE ROUTINE ON VC (SOFT FILL - BUFFERING)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZOPTS

      PARAMETER (NMAX=8192)
      PARAMETER (NPAT=5,NBITS=16)

      INTEGER   IPAT(NPAT)
      REAL      VPX(NMAX),VPY(NMAX)
      LOGICAL   LFRST,LBITS,LDBLE,LUNDF,LRTRN
      CHARACTER CPAT(NPAT)*(NBITS),CMSG*80

      SAVE

      DATA      CPAT(1)/'1000000000000000'/
      DATA      CPAT(2)/'1000000010000000'/
      DATA      CPAT(3)/'1000100010001000'/
      DATA      CPAT(4)/'1010101010101010'/
      DATA      CPAT(5)/'1111111111111111'/

      DATA      LFRST/.TRUE./


      IF (LRTRN) RETURN

      NN=0
      IF (.NOT.LBITS) THEN
        CALL SGISET('NBITS',NBITS)
      END IF
      IF (L3.EQ.0) THEN
        CALL SGRSET('BITLEN',RL1)
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSTTS(VX,VY)

      IF (LRTRN) RETURN

      NN=NN+1
      IF (NN.GT.NMAX)
     +     CALL MSGDMP('E', 'SZSTTS', 'WORKING AREA OVER FLOW')

      VPX(NN)=VX
      VPY(NN)=VY

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCLTS

      IF (LRTRN) RETURN

      CALL SZTNSV(NN,VPX,VPY,IROTA,RSPCE,ITYPE,INDEX)
      IF (LDBLE) THEN
        CALL SZTNSV(NN,VPX,VPY,IROTA+90,RSPCE,ITYPE,INDEX)
      END IF

      IF (.NOT.LBITS) THEN
        CALL SGISET('NBITS',NBITSZ)
      END IF
      IF (L3.EQ.0) THEN
        CALL SGRSET('BITLEN',BITLNZ)
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZTITS(ITPAT)

      L1=MOD(ITPAT,10)
      L2=MOD(ITPAT/10,10)
      L3=MOD(ITPAT/100,10)
      LP=MOD(ITPAT,1000)
      LC=ITPAT/1000

      LUNDF=.FALSE.
      LRTRN=.FALSE.
      IF (0.LE.L3 .AND. L3.LE.6) THEN
        IF (L1.EQ.0) THEN
          LRTRN=.TRUE.
        ELSE IF (L1.GT.5) THEN
          LUNDF=.TRUE.
        END IF
        IF (L2.EQ.0) THEN
          L2=1
        ELSE IF (L2.GT.5) THEN
          LUNDF=.TRUE.
        END IF
      END IF
      IF (7.LE.L3 .AND. L3.LE.8) THEN
        LUNDF=.TRUE.
      END IF
      IF (L3.EQ.9) THEN
        IF (LP.NE.999) THEN
          LUNDF=.TRUE.
        END IF
      END IF

      IF (LUNDF) THEN
        CMSG='PATTERN NUMBER ### IS NOT DEFINED.'
        WRITE(CMSG(16:18),'(I3)') LP
        CALL MSGDMP('M','SZTNSR',CMSG)
        LRTRN=.TRUE.
      END IF

      IF (LRTRN) RETURN

      IF (LFRST) THEN
        CALL SGIGET('NBITS',NBITSZ)
        CALL SGRGET('BITLEN',BITLNZ)
        CALL SGRGET('TNBLEN',BITLEN)
        LBITS=NBITSZ.EQ.NBITS
        DO 10 I=1,NPAT
          CALL BITPCI(CPAT(I),IPAT(I))
   10   CONTINUE
        LFRST=.FALSE.
      END IF

      DW=BITLEN*NBITS

      LDBLE=.FALSE.

      IF (L3.EQ.0) THEN
        IL1=(L1+1)/2
        IF (MOD(L1,2).EQ.0) THEN
          RL1=BITLEN/SQRT(2.0)
        ELSE
          RL1=BITLEN
        END IF
        IROTA=45*MOD(L1+1,2)
        RSPCE=RL1*NBITS/IL1
        ITYPE=IPAT(IL1)
        INDEX=LC*10+L2
      ELSE IF (1.LE.L3 .AND. L3.LE.4) THEN
        IF (MOD(L3,2).EQ.0) THEN
          DW=DW/SQRT(2.0)
        END IF
        IROTA=45*(L3-1)
        RSPCE=DW/L1
        ITYPE=1
        INDEX=LC*10+L2
      ELSE IF (5.LE.L3 .AND. L3.LE.6) THEN
        LDBLE=.TRUE.
        IF (L3.EQ.5) THEN
          L3=1
        ELSE
          L3=2
        END IF
        IF (MOD(L3,2).EQ.0) THEN
          DW=DW/SQRT(2.0)
        END IF
        IROTA=45*(L3-1)
        RSPCE=DW/L1
        ITYPE=1
        INDEX=LC*10+L2
      ELSE IF (L3.EQ.9) THEN
        IROTA=0
        RSPCE=DW/5
        ITYPE=1
        INDEX=LC*10+5
      END IF

      END

*-----------------------------------------------------------------------
*     SLPWWR : PLOT MAXIMUM-DRAWING-REGION RECTANGLE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLPWVR(INDEX)


      IF (INDEX.LE.0) THEN
        IF (INDEX.EQ.0) THEN
          CALL MSGDMP('M','SLPWVR','LINE INDEX IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPWVR','LINE INDEX IS LESS THAN ZERO.')
        END IF
      END IF

      CALL STQWTR(RXMN,RXMX,RYMN,RYMX,WXMN,WXMX,WYMN,WYMX,ITR)
      IF (ITR.EQ.1) THEN
        CALL STQWRC(WXMIN,WXMAX,WYMIN,WYMAX)
      ELSE
        CALL STQWRC(WXMIN,WXMAX,WYMAX,WYMIN)
      END IF

      CALL SZQCLL(CXMIN,CXMAX,CYMIN,CYMAX,0)

      CALL STIWTR(WXMIN,WYMIN,RXMIN,RYMIN)
      CALL STIWTR(WXMAX,WYMAX,RXMAX,RYMAX)

      CALL SZSCLL(RXMIN,RXMAX,RYMIN,RYMAX,0)
      CALL SZSLTI(1,INDEX)

      CALL SZOPLR
      CALL SZMVLR(RXMIN,RYMIN)
      CALL SZPLLR(RXMAX,RYMIN)
      CALL SZPLLR(RXMAX,RYMAX)
      CALL SZPLLR(RXMIN,RYMAX)
      CALL SZPLLR(RXMIN,RYMIN)
      CALL SZCLLR

      CALL SZSCLL(CXMIN,CXMAX,CYMIN,CYMAX,0)

      END

      PROGRAM LAY2

      PARAMETER( NMAX=401, XMIN=1600, XMAX=2000 )
      REAL X(NMAX), Y(NMAX)

*-- データ ----
      Y0 = 0.5
      DO 10 N=1,NMAX
        X(N) = XMIN + (XMAX-XMIN)*(N-1)/(NMAX-1)
        Y(N) = 5.*Y0 + 10.
        Y0   = 3.7*Y0*(1.-Y0)
   10 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SGLSET( 'LFULL', .TRUE. )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX,  11.0, 15.0 )
      CALL GRSVPT( 0.15, 0.95,  0.15, 0.65 )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'TIME', 'YEAR', 'TEMPERATURE', 'DEG' )
      CALL USDAXS

      CALL UULIN( NMAX, X, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWCQNP(NCP)

      CHARACTER CP*(*), CVAL*(*)
      PARAMETER (NPARA = 17)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CX(NPARA)*80, CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

      DATA      CPARAS( 1)/'WSNAME01'/, CX( 1)/'DISP    '/
      DATA      CPARAS( 2)/'WSNAME02'/, CX( 2)/'FILES   '/
      DATA      CPARAS( 3)/'FNAME   '/, CX( 3)/'dcl     '/
      DATA      CPARAS( 4)/'TITLE   '/, CX( 4)/'*       '/
      DATA      CPARAS( 5)/'CLRMAP  '/, CX( 5)/'colormap'/
      DATA      CPARAS( 6)/'BITMAP  '/, CX( 6)/'bitmap  '/
      DATA      CPARAS( 7)/'CL2TN   '/, CX( 7)/'cl2tnmap'/
      DATA      CPARAS( 8)/'FONT1   '/, CX( 8)/'font1u  '/
      DATA      CPARAS( 9)/'FONT2   '/, CX( 9)/'font2u  '/
      DATA      CPARAS( 10)/'LPR     '/, CX(10)/'lpr     '/
      DATA      CPARAS( 11)/'CIMGFMT '/, CX(11)/'png     '/
      DATA      CPARAS( 12)/'CMAPLIST'/, CX(12)/'cmaplist'/
      DATA      CPARAS( 13)/'FLNAME01'/, CX(13)/'PNG     '/
      DATA      CPARAS( 14)/'FLNAME02'/, CX(14)/'EPS     '/
      DATA      CPARAS( 15)/'FLNAME03'/, CX(15)/'SVG     '/
      DATA      CPARAS( 16)/'FLNAME04'/, CX(16)/'PDF     '/
      DATA      CPARAS( 17)/'FONTNAME'/, CX(17)/'        '/


      DATA      CPARAL( 1)/'DEVICE_NAME01'/
      DATA      CPARAL( 2)/'DEVICE_NAME02'/
      DATA      CPARAL( 3)/'FRAME_NAME'/
      DATA      CPARAL( 4)/'TITLE'/
      DATA      CPARAL( 5)/'COLORMAP'/
      DATA      CPARAL( 6)/'BITMAP'/
      DATA      CPARAL( 7)/'COLOR_TO_TONE_MAP'/
      DATA      CPARAL( 8)/'FONT1'/
      DATA      CPARAL( 9)/'FONT2'/
      DATA      CPARAL(10)/'LPR'/
      DATA      CPARAL(11)/'IMAGE_FORMAT'/
      DATA      CPARAL(12)/'COLORMAP_LIST'/
      DATA      CPARAL(13)/'FILE_NAME01'/
      DATA      CPARAL(14)/'FILE_NAME02'/
      DATA      CPARAL(15)/'FILE_NAME03'/
      DATA      CPARAL(16)/'FILE_NAME04'/
      DATA      CPARAL(17)/'FONTNAME'/

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E', 'SWCQID', CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E', 'SWCQCP', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E', 'SWCQCL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQVL(IDX, CVAL)

      IF (LFIRST) THEN
        CALL RTCGET('SW', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CVAL = CX(IDX)
      ELSE
        CALL MSGDMP('E', 'SWCQVL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCSVL(IDX, CVAL)

      IF (LFIRST) THEN
        CALL RTCGET('SW', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CX(IDX) = CVAL
      ELSE
        CALL MSGDMP('E', 'SWCSVL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!  LRLlib Module
!-------------------------------------------------
module lrllib
  use dcl_common
  contains
!-------------------------------------------
    function DclEQ(x,y,epsilon)
      real, intent(in)           :: x, y
      real, intent(in), optional :: epsilon
      logical :: DclEQ, lreqa, lreq1

      call prcopn('DclEQ')
      if(present(epsilon)) then
        DclEQ = lreqa(x,y,epsilon)
      else
        DclEQ = lreq1(x,y)
      end if
      call prccls('DclEQ')
      
    end function
!-------------------------------------------
    function DclNE(x,y,epsilon) 
      real, intent(in)           :: x, y
      real, intent(in), optional :: epsilon
      logical :: DclNE, lrnea, lrne1
      
      call prcopn('DclNE')
      if(present(epsilon)) then
        DclNE = lrnea(x,y,epsilon)
      else
        DclNE = lrne1(x,y)
      end if
      call prccls('DclNE')
      
    end function
!-------------------------------------------
    function DclLT(x,y,epsilon)
      real, intent(in)           :: x, y
      real, intent(in), optional :: epsilon
      logical :: DclLT, lrlta, lrlt1
      
      call prcopn('DclLT')
      if(present(epsilon)) then
        DclLT = lrlta(x,y,epsilon)
      else
        DclLT = lrlt1(x,y)
      end if
      call prccls('DclLT')
      
    end function
!-------------------------------------------
    function DclLE(x,y,epsilon) 
      real, intent(in)           :: x, y
      real, intent(in), optional :: epsilon
      logical :: DclLE, lrlea, lrle1
      
      call prcopn('DclLE')
      if(present(epsilon)) then
        DclLE = lrlea(x,y,epsilon)
      else
        DclLE = lrle1(x,y)
      end if
      call prccls('DclLE')
      
    end function
!-------------------------------------------
    function DclGT(x,y,epsilon) 
      real, intent(in)           :: x, y
      real, intent(in), optional :: epsilon
      logical :: DclGT, lrgta, lrgt1
      
      call prcopn('DclGT')
      if(present(epsilon)) then
        DclGT = lrgta(x,y,epsilon)
      else
        DclGT = lrgt1(x,y)
      end if
      call prccls('DclGT')
      
    end function
!-------------------------------------------
    function DclGE(x,y,epsilon)
      real, intent(in)           :: x, y
      real, intent(in), optional :: epsilon
      logical :: DclGE, lrgea, lrge1
      
      call prcopn('DclGE')
      if(present(epsilon)) then
        DclGE = lrgea(x,y,epsilon)
      else
        DclGE = lrge1(x,y)
      end if
      call prccls('DclGE')
      
    end function
end module

!-------------------------------------------------
!     interface module of sgpack
!-------------------------------------------------
module sg_interface
    interface
!---------------------------------------------------------
!コントロール
        subroutine sgopn(iws)  !出力装置のオープン
            integer,   intent(in) :: iws !ワークステーション番号                        
        end subroutine
                                  
        subroutine sgfrm()  !フレームの設定．
        end subroutine

        subroutine sgcls()  !出力装置のクローズ
        end subroutine

        subroutine sgpget(cp,ipara) !内部変数の参照．
            character(len=*), intent(in) :: cp !内部変数の名前
            integer,   intent(out) :: ipara       !内部変数の値
        end subroutine

        subroutine sgiget(cp,ipara) 
            character(len=*), intent(in) :: cp !内部変数の名前
            integer,   intent(out) :: ipara       !内部変数の値
        end subroutine

        subroutine sgrget(cp,ipara) 
            character(len=*), intent(in) :: cp !内部変数の名前
            real,      intent(out) :: ipara       !内部変数の値
        end subroutine

        subroutine sglget(cp,ipara) 
            character(len=*), intent(in) :: cp !内部変数の名前
            logical,   intent(out) :: ipara       !内部変数の値
        end subroutine

        subroutine sgpset(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            integer,   intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sgiset(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            integer,   intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sgrset(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            real,      intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sglset(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            logical,   intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sgpstx(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            integer,   intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sgistx(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            integer,   intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sgrstx(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            real,      intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sglstx(cp,ipara)
            character(len=*), intent(in) :: cp !内部変数の名前
            logical,   intent(in) :: ipara       !内部変数の値
        end subroutine

        subroutine sgpwsn() !ワークステーション名のリスト
        end subroutine
!------------------------------------------------------------------------
!正規化変換
        subroutine sgsvpt(vxmin,vxmax,vymin,vymax)  !ビューポートの設定．
            real,      intent(in) :: vxmin  !ビューポート
            real,      intent(in) :: vxmax
            real,      intent(in) :: vymin
            real,      intent(in) :: vymax
        end subroutine

        subroutine sgswnd(uxmin,uxmax,uymin,uymax) !ウインドウの設定．
            real,      intent(in) :: uxmin !ウインドウ
            real,      intent(in) :: uxmax
            real,      intent(in) :: uymin
            real,      intent(in) :: uymax
        end subroutine

        subroutine sgssim(simfac,vxoff,vyoff)  !相似変換の設定．
            real,      intent(in) :: simfac  !スケーリングファクター
            real,      intent(in) :: vxoff     !原点のオフセット
            real,      intent(in) :: vyoff   
        end subroutine

        subroutine sgsmpl(plx,ply,plrot)  !地図投影の極の設定．
            real,      intent(in) :: plx   !地図投影の際の回転角
            real,      intent(in) :: ply   
            real,      intent(in) :: plrot
        end subroutine

        subroutine sgstrn(itr) !変換関数の番号による設定．
            integer,   intent(in) :: itr   !変換関数番号
        end subroutine

        subroutine sgtrsl(cts,ctl) !略称から名称を求める．
            character(len=*), intent(in) :: cts 
      character(len=*), intent(out) :: ctl
        end subroutine

        subroutine sgtrsn(cts,ntx) !略称から変換関数番号を求める．
            character(len=*), intent(in) :: cts 
      integer,   intent(out) :: ntx
        end subroutine

        subroutine sgtrls(ctl,cts) !名称から略称を求める．
      character(len=*), intent(in) :: ctl
            character(len=*), intent(out) :: cts 
        end subroutine

        subroutine sgtrln(ctl,ntx) !名称から変換関数番号を求める．
      character(len=*), intent(in) :: ctl
            integer,   intent(out) :: ntx
        end subroutine

        subroutine sgtrns(ntx,cts) !変換関数番号から略称を求める．
            integer,   intent(in) :: ntx
      character(len=*), intent(out) :: cts
        end subroutine

        subroutine sgtrnl(ntx,ctl) !変換関数番号から名称を求める．
            integer,   intent(in) :: ntx
      character(len=*), intent(out) :: ctl
        end subroutine

        subroutine sgstrf()  !変換関数の確定．   
        end subroutine

        subroutine sgqvpt(vxmin,vxmax,vymin,vymax) 
            real,      intent(out) :: vxmin      !ビューポート
            real,      intent(out) :: vxmax      
            real,      intent(out) :: vymin      
            real,      intent(out) :: vymax      
        end subroutine

        subroutine sgqwnd(uxmin,uxmax,uymin,uymax) 
            real,      intent(out) :: uxmin      !ウインドウ
            real,      intent(out) :: uxmax      
            real,      intent(out) :: uymin      
            real,      intent(out) :: uymax      
        end subroutine

        subroutine sgqsim(simfac,vxoff,vyoff)  
            real,      intent(out) :: simfac !相似変換のスケーリングファクター
            real,      intent(out) :: vxoff     !原点のオフセット
            real,      intent(out) :: vyoff  
        end subroutine

        subroutine sgqmpl(plx,ply,plrot)  
            real,      intent(out) :: plx     !地図投影の際の回転角
            real,      intent(out) :: ply     
            real,      intent(out) :: plrot     
        end subroutine

        subroutine sgqtrn(itr) 
            integer,   intent(out) :: itr     !変換関数番号
        end subroutine
!------------------------------------------------------------------------
!ポリラインプリミティブ
        subroutine sgplzu(n,upx,upy,itype,index) !u 座標系で折れ線を描く．  
            integer,   intent(in) :: n                 !配列UPX, UPYなどの長さ
            real,      intent(in), dimension(*) :: upx !U座標の値を与える
            real,      intent(in), dimension(*) :: upy !U座標の値を与える                                   
            integer,   intent(in) :: itype           !ラインタイプ．
            integer,   intent(in) :: index           !ラインインデクス
        end subroutine

        subroutine sgplzv(n,vpx,vpy,itype,index)  !v 座標系で折れ線を描く．    
            integer,   intent(in) :: n               !配列VPX, VPYなどの長さ
            real,      intent(in), dimension(*) :: vpx !V座標の値を与える
            real,      intent(in), dimension(*) :: vpy !V座標の値を与える
            integer,   intent(in) :: itype               !ラインタイプ．
            integer,   intent(in) :: index           !ラインインデクス
        end subroutine

        subroutine sgplzr(n,rpx,rpy,itype,index)  !r 座標系で折れ線を描く．  
            integer,   intent(in) :: n            !配列RPX, RPYなどの長さ
            real,      intent(in), dimension(*) :: rpx !r座標の値を与える
            real,      intent(in), dimension(*) :: rpy !r座標の値を与える
            integer,   intent(in) :: itype           !ラインタイプ
            integer,   intent(in) :: index           !ラインインデクス
        end subroutine

        subroutine sgplu(n,upx,upy) !u 座標系で折れ線を描く．
            integer,   intent(in) :: n           !配列UPX, UPYなどの長さ
            real,      intent(in), dimension(*) :: upx !u座標の値を与える
            real,      intent(in), dimension(*) :: upy 
        end subroutine

        subroutine sgplv(n,vpx,vpy)  !v 座標系で折れ線を描く． 
            integer,   intent(in) :: n           !配列VPX, VPYなどの長さ
            real,      intent(in), dimension(*) :: vpx !v座標の値を与える
            real,      intent(in), dimension(*) :: vpy 
        end subroutine

        subroutine sgplr(n,rpx,rpy)  !r 座標系で折れ線を描く．  
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: rpx !r座標の値を与える
            real,      intent(in), dimension(*) :: rpy 
        end subroutine

        subroutine sgsplt(itype)  !ラインタイプを設定する．   
            integer,   intent(in) :: itype    !線種
        end subroutine

        subroutine sgspli(index)  !ラインインデクスの設定．   
            integer,   intent(in) :: index    !ラインインデクス 
        end subroutine

        subroutine sgsplc(charx)  !ラベルの文字列設定．  
            character(len=*), intent(in) :: charx  !描く文字列（初期値は'A')
        end subroutine

        subroutine sgspls(rsize)  !ラベルの文字高設定  
            real,      intent(in) :: rsize  !文字列の高さをV座標系の単位で指定（初期値は0.02)                   
        end subroutine
 
        subroutine sgnplc()  !ラベルの最後の文字番号を増やす．
        end subroutine

        subroutine sgqplt(itype)  
            integer,   intent(out) :: itype       !折れ線の線種
        end subroutine

        subroutine sgqpli(index) 
            integer,   intent(out) :: index       !折れ線のラインインデクス
        end subroutine

        subroutine sgqplc(charx)   
            character(len=*), intent(out) :: charx !描く文字列（初期値は'A')
        end subroutine

        subroutine sgqpls(rsize)   
            real,      intent(out) :: rsize    !文字列の高さをV座標系の単位で指定する（初期値は0.02)
        end subroutine
!------------------------------------------------------------------------------
! ポリマーカープリミティブ
        subroutine sgpmzu(n,upx,upy,itype,index,rsize) !u 座標系でマーカー列を描く．  
            integer,   intent(in) :: n           !マーカーを打つ点のU座標
            real,      intent(in), dimension(*) :: upx
            real,      intent(in), dimension(*) :: upy 
            integer,   intent(in) :: itype           !マーカータイプ
            integer,   intent(in) :: index           !マーカーのラインインデクス
            real,      intent(in) :: rsize           !マーカーのサイズ．
        end subroutine

        subroutine sgpmzv(n,vpx,vpy,itype,index,rsize) !v 座標系でマーカー列を描く．    
            integer,   intent(in) :: n               !配列VPX, VPYのなど長さ
            real,      intent(in), dimension(*) :: vpx !マーカーを打つ点のV座標
            real,      intent(in), dimension(*) :: vpy
            integer,   intent(in) :: itype           !マーカータイプ
            integer,   intent(in) :: index           !マーカーのラインインデクス
            real,      intent(in) :: rsize           !マーカーのサイズ
        end subroutine

        subroutine sgpmzr(n,rpx,rpy,itype,index,rsize)  !r 座標系でマーカー列を描く．
            integer,   intent(in) :: n                 !配列RPX, RPYのなど長さ
            real,      intent(in), dimension(*) :: rpx !マーカーを打つ点のR座標
            real,      intent(in), dimension(*) :: rpy 
            integer,   intent(in) :: itype           !マーカータイプ
            integer,   intent(in) :: index           !マーカーのラインインデクス
            real,      intent(in) :: rsize           !マーカーのサイズ
        end subroutine

        subroutine sgpmu(n,upx,upy) !u 座標系でマーカー列を描く． 
            integer,   intent(in) :: n           !配列UPX, UPYのなど長さ
            real,      intent(in), dimension(*) :: upx !マーカーを打つ点のU座標
            real,      intent(in), dimension(*) :: upy !(X, Y)座標の値を与える
        end subroutine

        subroutine sgpmv(n,vpx,vpy)  !v 座標系でマーカー列を描く．    
            integer,   intent(in) :: n           !配列VPX, VPYのなど長さ
            real,      intent(in), dimension(*) :: vpx !マーカーを打つ点のV座標
            real,      intent(in), dimension(*) :: vpy 
        end subroutine

        subroutine sgpmr(n,rpx,rpy)  !r 座標系でマーカー列を描く．   
            integer,   intent(in) :: n           !配列RPX, RPYのなど長さ
            real,      intent(in), dimension(*) :: rpx !マーカーを打つ点のR座標
            real,      intent(in), dimension(*) :: rpy 
        end subroutine

        subroutine sgspmt(itype)  !マーカータイプの設定．    
            integer,   intent(in) :: itype    !マーカータイプ
        end subroutine

        subroutine sgspmi(index)  !マーカーのラインインデクスの設定  
            integer,   intent(in) :: index     !ラインインデクス 
        end subroutine
 
        subroutine sgspms(rsize)   !マーカーの大きさ設定．     
            real,      intent(in) :: rsize     !マーカーの大きさ
        end subroutine

        subroutine sgqpmt(itype)  
            integer,   intent(out) :: itype     !マーカータイプ
        end subroutine

        subroutine sgqpmi(index)
            integer,   intent(out) :: index     !ラインインデクス 
        end subroutine

        subroutine sgqpms(rsize)
            real,      intent(out) :: rsize     !マーカーの大きさ
        end subroutine
!------------------------------------------------------------------
!     テキスト
        subroutine sgtxzu(ux,uy,chars,rsize,irota,icent,index) !u 座標系で文字列を描く．
            real,      intent(in) :: ux          !U座標系における文字の位置
            real,      intent(in) :: uy          
            character(len=*), intent(in) :: chars !描く文字列
            real,      intent(in) :: rsize          !文字の高さ
            integer,   intent(in) :: irota          !文字列の角度
            integer,   intent(in) :: icent          !センタリングオプション
            integer,   intent(in) :: index          !文字のラインインデクス
        end subroutine

        subroutine sgtxzv(vx,vy,chars,rsize,irota,icent,index) !v 座標系で文字列を描く． 
            real,      intent(in) :: vx          !V座標系における文字の位置
            real,      intent(in) :: vy           
            character(len=*), intent(in) :: chars !描く文字列
            real,      intent(in) :: rsize          !文字の高さ
            integer,   intent(in) :: irota          !文字列の角度
            integer,   intent(in) :: icent          !センタリングオプション
            integer,   intent(in) :: index          !文字のラインインデクス
        end subroutine

        subroutine sgtxzr(rx,ry,chars,rsize,irota,icent,index) !r座標系で文字列を描く．  
            real,      intent(in) :: rx          !R座標系における文字の位置
            real,      intent(in) :: ry          
            character(len=*), intent(in) :: chars     !描く文字列
            real,      intent(in) :: rsize           !文字の高さ
            integer,   intent(in) :: irota          !文字列の角度
            integer,   intent(in) :: icent          !センタリングオプション
            integer,   intent(in) :: index           !文字のラインインデクス
        end subroutine

        subroutine sgtxu(ux,uy,chars)  !u 座標系で文字列を描く．    
            real,      intent(in) :: ux        !U座標系における文字の位置
            real,      intent(in) :: uy        
            character(len=*), intent(in) :: chars    !描く文字列
        end subroutine

        subroutine sgtxv(vx,vy,chars)  !v 座標系で文字列を描く．      
            real,      intent(in) :: vx        !V座標系における文字の位置
            real,      intent(in) :: vy
            character(len=*), intent(in) :: chars    !描く文字列
        end subroutine

        subroutine sgtxr(rx,ry,chars)  !r 座標系で文字列を描く．     
            real,      intent(in) :: rx              !R座標系における文字の位置
            real,      intent(in) :: ry        
            character(len=*), intent(in) :: chars    !描く文字列
        end subroutine
                                  
        subroutine sgstxs(rsize)  !文字の高さ設定．  
            real,      intent(in) :: rsize  !文字の高さ
        end subroutine
 
        subroutine sgstxr(irota)  !文字列の角度の設定．  
            integer,   intent(in) :: irota   !文字列の傾きを度の単位で与える 
        end subroutine

        subroutine sgstxi(index)  !文字列のラインインデクスの設定．                 
            integer,   intent(in) :: index     !ラインインデクス 
        end subroutine
 
        subroutine sgstxc(icent)  !文字列のセンタリングオプション設定
            integer,   intent(in) :: icent   !センタリングオプション
        end subroutine

        subroutine sgqtxs(rsize) 
            real,      intent(out) :: rsize  !文字の高さ
        end subroutine

        subroutine sgqtxr(irota)
            integer,   intent(out) :: irota      !文字列の傾きを度の単位で与える
        end subroutine

        subroutine sgqtxi(index) 
            integer,   intent(out) :: index      !ラインインデクス
        end subroutine

        subroutine sgqtxc(icent)  
            integer,   intent(out) :: icent   !センタリングオプション
        end subroutine
!---------------------------------------------------------------------------------------------
! トーンプリミティブ
        subroutine sgtnzu(n,upx,upy,itpat)  !u 座標系で多角形領域の塗りつぶし．
            integer,   intent(in) :: n           !配列UPX, UPYの長さ
            real,      intent(in), dimension(*) :: upx !多角形を定義する頂点のU座標
            real,      intent(in), dimension(*) :: upy 
            integer,   intent(in) :: itpat
        end subroutine

        subroutine sgtnzv(n,vpx,vpy,itpat)  !v 座標系で多角形領域の塗りつぶし
            integer,   intent(in) :: n           !配列VPX, VPYの長さ
            real,      intent(in), dimension(*) :: vpx !多角形を定義する頂点のV座標
            real,      intent(in), dimension(*) :: vpy 
            integer,   intent(in) :: itpat
        end subroutine

        subroutine sgtnzr(n,rpx,rpy,itpat)  !r 座標系で多角形領域の塗りつぶし．
            integer,   intent(in) :: n           !配列RPX, RPYの長さ
            real,      intent(in), dimension(*) :: rpx !多角形を定義する頂点のR座標
            real,      intent(in), dimension(*) :: rpy 
            integer,   intent(in) :: itpat
        end subroutine

        subroutine sgtnu(n,upx,upy)  !u 座標系で多角形領域の塗りつぶし．
            integer,   intent(in) :: n                !配列UPX, UPYの長さ
            real,      intent(in), dimension(*) :: upx !多角形を定義する頂点のU座標
            real,      intent(in), dimension(*) :: upy 
        end subroutine

        subroutine sgtnv(n,vpx,vpy)  !v 座標系で多角形領域の塗りつぶし
            integer,   intent(in) :: n           !配列VPX, VPYの長さ
            real,      intent(in), dimension(*) :: vpx !多角形を定義する頂点のV座標
            real,      intent(in), dimension(*) :: vpy 
        end subroutine

        subroutine sgtnr(n,rpx,rpy)  !r 座標系で多角形領域の塗りつぶし．
            integer,   intent(in) :: n           !配列RPX, RPYの長さ
            real,      intent(in), dimension(*) :: rpx !多角形を定義する頂点のR座標
            real,      intent(in), dimension(*) :: rpy 
        end subroutine

        subroutine sgstnp(itpat) ! トーンパターン番号設定
            integer,   intent(in) :: itpat  !トーンパターン番号
        end subroutine

        subroutine sgqtnp(itpat) !現在設定されているトーンパターン番号参照
            integer,   intent(out) :: itpat     !現在設定されているトーンパターン番号
        end subroutine
!--------------------------------------------------------------------------------------
!ラインサブプリミティブ
             subroutine sglnzu(ux1,uy1,ux2,uy2,index) !u座標系で線分を描く． 
            real,      intent(in) :: ux1    !U座標系における線分の始点の座標
            real,      intent(in) :: uy1            
            real,      intent(in) :: ux2    !U座標系における線分の終点の座標
            real,      intent(in) :: uy2
            integer,   intent(in) :: index    !SGSLNI参照
        end subroutine

        subroutine sglnzv(vx1,vy1,vx2,vy2,index) !v座標系で線分を描く． 
            real,      intent(in) :: vx1     !V座標系における線分の始点の座標
            real,      intent(in) :: vy1            
            real,      intent(in) :: vx2     !V座標系における線分の終点の座標
            real,      intent(in) :: vy2
            integer,   intent(in) :: index     !SGSLNI参照
        end subroutine

        subroutine sglnzr(rx1,ry1,rx2,ry2,index)  !r座標系で線分を描く 
            real,      intent(in) :: rx1      !R座標系における線分の始点の座標
            real,      intent(in) :: ry1            
            real,      intent(in) :: rx2      !R座標系における線分の終点の座標
            real,      intent(in) :: ry2
            integer,   intent(in) :: index       !SGSLNI参照
        end subroutine
 
        subroutine sglnu(ux1,uy1,ux2,uy2) !       u座標系で線分を描く．
            real,      intent(in) :: ux1      !U座標系における線分の始点の座標
            real,      intent(in) :: uy1
            real,      intent(in) :: ux2      !U座標系における線分の終点の座標
            real,      intent(in) :: uy2
        end subroutine

        subroutine sglnv(vx1,vy1,vx2,vy2)  !v座標系で線分を描く． 
            real,      intent(in) :: vx1  !V座標系における線分の始点の座標
            real,      intent(in) :: vy1  
            real,      intent(in) :: vx2  !V座標系における線分の終点の座標
            real,      intent(in) :: vy2
        end subroutine

        subroutine sglnr(rx1,ry1,rx2,ry2) 
            real,      intent(in) :: rx1  !R座標系における線分の始点の座標
            real,      intent(in) :: ry1
            real,      intent(in) :: rx2  !R座標系における線分の終点の座標
            real,      intent(in) :: ry2
        end subroutine
 
        subroutine sgslni(index)  !ラインインデクスを設定する．
            integer,   intent(in) :: index  !線分のラインインデクス 
        end subroutine
!-------------------------------------------------------------------------
!     アローサブプリミティブ
        subroutine sglazu(ux1,uy1,ux2,uy2,itype,index)  !u座標系で矢印付き線分を描く
            real,      intent(in) :: ux1    !U座標系における線分の始点の座標
            real,      intent(in) :: uy1
            real,      intent(in) :: ux2    !u座標系における線分の終点の座標
            real,      intent(in) :: uy2
            integer,   intent(in) :: itype  !ラインタイプ
            integer,   intent(in) :: index  !ラインインデクス
        end subroutine

        subroutine sglazv(vx1,vy1,vx2,vy2,itype,index) !v座標系で矢印付き線分を描く
            real,      intent(in) :: vx1  !U座標系における線分の始点の座標
            real,      intent(in) :: vy1
            real,      intent(in) :: vx2  !R座標系における線分の終点の座標
            real,      intent(in) :: vy2
            integer,   intent(in) :: itype  !ラインタイプ
            integer,   intent(in) :: index    !ラインインデクス
        end subroutine

        subroutine sglazr(rx1,ry1,rx2,ry2,itype,index) !r座標系で矢印付き線分を描く
            real,      intent(in) :: rx1   !r座標系における線分の始点の座標
            real,      intent(in) :: ry1
            real,      intent(in) :: rx2   !r座標系における線分の終点の座標
            real,      intent(in) :: ry2
            integer,   intent(in) :: itype !ラインタイプ
            integer,   intent(in) :: index !ラインインデクス
        end subroutine

        subroutine sglau(ux1,uy1,ux2,uy2) !u座標系で矢じり付き線分を描く． 
            real,      intent(in) :: ux1  !uU座標系における線分の始点の座標
            real,      intent(in) :: uy1
            real,      intent(in) :: ux2  !u座標系における線分の終点の座標
            real,      intent(in) :: uy2
        end subroutine

        subroutine sglav(vx1,vy1,vx2,vy2)     !v座標系で矢じり付き線分を描く． 
            real,      intent(in) :: vx1  !v座標系における線分の始点の座標
            real,      intent(in) :: vy1
            real,      intent(in) :: vx2  !v座標系における線分の終点の座標
            real,      intent(in) :: vy2
        end subroutine

        subroutine sglar(rx1,ry1,rx2,ry2)       !r座標系で矢じり付き線分を描く． 
            real,      intent(in) :: rx1    !r座標系における線分の始点の座標
            real,      intent(in) :: ry1
            real,      intent(in) :: rx2    !r座標系における線分の終点の座標
            real,      intent(in) :: ry2
        end subroutine

        subroutine sgslat(itype)  !描く線分のラインタイプを設定する． 
            integer,   intent(in) :: itype  !線分のラインタイプ 
        end subroutine

        subroutine sgslai(index) !描く線分の ラインインデクスを設定する
            integer,   intent(in) :: index  !線分のラインインデクス 
        end subroutine

        subroutine sgqlat(itype) !現在設定されているラインタイプ
            integer,   intent(out) :: itype   !線分のラインタイプ
        end subroutine

        subroutine sgqlai(index) !現在設定されているラインインデクス
            integer,   intent(out) :: index      !線分のラインインデクス 
        end subroutine
!---------------------------------------------------------------
!文字関数
        function csgi(ic) !文字番号に対応する文字を返す．
            integer,   intent(in) :: ic    !DCL文字番号
            character(len=1)      :: csgi  !DCL文字番号に対応する文字
        end function

        function isgc(ch)   !文字に対応する文字番号を返す．
            character(len=1),intent(in) :: ch    !与えるの文字（文字長は1)
            integer              :: isgc  !文字に対応するDCL文字番号
        end function
        end interface
      end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UUPK04

      PARAMETER(N=20, M=5)
      REAL  Y1(N), Y2(N), A(M)

      CALL GLRGET('RUNDEF', RUNDEF)

*-----------------------------------------------------------------------

      DT = 1./(N-1)
      PI = 3.14159
      DO 50 J=1, M
        JJ = J*2-1
        A(J) = (-1)**J *2./(JJ*PI)
  50  CONTINUE

      DO 100 I=1, N
        T     = DT*(I-1)*2*PI
        Y1(I) = A(1)*COS(T)
        Y2(I) = 0.
        DO 150 J=1, M
          JJ = J*2-1
          YY = A(J)*COS(JJ*T)
          Y2(I)  = Y2(I) + YY
  150   CONTINUE

  100 CONTINUE

*-----------------------------------------------------------------------

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL SGLSET('LCLIP', .TRUE.)

      CALL USSPNT(N, RUNDEF, Y1)
      CALL USSPNT(N, RUNDEF, Y2)
      CALL GRSWND(0., 1., RUNDEF, RUNDEF)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UUSARP(2999, 3999)
      CALL UVBRA(N, RUNDEF, Y1, Y2)
      CALL UVBRF(N, RUNDEF, Y1, Y2)

      CALL UUSLNI(41)
      CALL UVBRL(N, RUNDEF, Y1)
      CALL UUSLNT(3)
      CALL UVBRL(N, RUNDEF, Y2)

      CALL GRFRM

      CALL USSPNT(N, Y1, RUNDEF)
      CALL USSPNT(N, Y1, RUNDEF)
      CALL GRSWND(RUNDEF, RUNDEF, 0., 1.)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UUSARP(2999, 3999)
      CALL UHBRA(N, Y1, Y2, RUNDEF)
      CALL UHBRF(N, Y1, Y2, RUNDEF)

      CALL UUSLNI(41)
      CALL UHBRL(N, Y1, RUNDEF)
      CALL UUSLNT(3)
      CALL UHBRL(N, Y2, RUNDEF)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      INTEGER FUNCTION IFROMC(CX)

      CHARACTER CX*(*)

      CHARACTER CMSG*80

      EXTERNAL  LENY,LENZ,JFROMC


      LC1=LENY(CX)+1
      LC2=LENZ(CX)

      IF (LC2.EQ.0) THEN
        CMSG='THERE IS NO VALID CHARACTER.'
        CALL MSGDMP('E','IFROMC',CMSG)
      END IF

      IF (CX(LC1:LC1).EQ.'-') THEN
        ISGN=-1
        LC1=LC1+1
      ELSE IF (CX(LC1:LC1).EQ.'+') THEN
        ISGN=+1
        LC1=LC1+1
      ELSE
        ISGN=+1
      END IF

      IFROMC=ISGN*JFROMC(CX(LC1:LC2))

      END

      PROGRAM MISS2

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL P(NX,NY)

      CALL GLRGET( 'RMISS', RMISS )
      CALL GLLSET( 'LMISS', .TRUE. )

      DO 10 J=1,NY
      DO 10 I=1,NX
        ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
        ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
        SLAT = SIN(ALAT)
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
        IF( I.EQ.6 .AND. J.EQ.6 ) THEN
          P(I,J) = RMISS
        END IF
        IF( ( 8.LE.I .AND. I.LE.24) .AND. J.EQ.30 ) THEN
          P(I,J) = RMISS
        END IF
        IF( (22.LE.I .AND. I.LE.30) .AND. 
     +      (12.LE.J .AND. J.LE.20)       ) THEN
          P(I,J) = RMISS
        END IF
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UETONE( P, NX, NX, NY )
      CALL USDAXS
      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     INTERPOLATION ON UC (LINEAR INTERPOLATION)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPIPL(X0,Y0, X1, Y1, MODE)

      PARAMETER (EPSIL=1.E-5)

      LOGICAL   LINT, LCONT, LREQA

      COMMON    /SZBLS1/ LLNINT,LGCINT,RDXR,RDYR
      LOGICAL   LLNINT,LGCINT

      EXTERNAL  RFPI, LREQA

      SAVE

*     MODE = 0 : FOR LINE
*            1 : FOR TONE
*            2 : FOR ARROW
*         ELSE : FOR BOUNDARY


      PI = RFPI()

      IF (MODE.EQ.0) THEN
        LINT = LLNINT
      ELSE IF (MODE.EQ.1) THEN
        LINT = LLNINT .AND.
     +    .NOT. (LREQA(Y0,Y1,EPSIL) .AND. LREQA(ABS(Y0),PI/2,EPSIL))
      ELSE IF (MODE.EQ.2) THEN
        LINT = LLNINT
      ELSE
        LINT = .TRUE.
      ENDIF

      XX0 = X0
      YY0 = Y0
      XX1 = X1
      YY1 = Y1
      NN  = 1
      NEND = 1

      IF (.NOT.LINT) RETURN

      DX = X1-X0
      DY = Y1-Y0

      NEND = MAX (INT(ABS(DX/RDXR)), INT(ABS(DY/RDYR))) + 1
      IF (NEND .GE. 2) THEN
        DXX = DX/NEND
        DYY = DY/NEND
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZGIPL(X, Y, LCONT)

      LCONT = NN.LT.NEND
      IF (LCONT) THEN
        X = XX0+NN*DXX
        Y = YY0+NN*DYY
      ELSE
        X = XX1
        Y = YY1
      END IF
      NN = NN+1

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHON1

      PARAMETER( NMAX=50 )
      REAL X(0:NMAX), Y1(0:NMAX), Y2(0:NMAX), Y3(0:NMAX)

      DO 10 N=0,NMAX
        X (N) = REAL(N)/REAL(NMAX)
        Y1(N) = X(N)**3
        Y2(N) = X(N)**2
        Y3(N) = SQRT(X(N))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPLV( NMAX+1, X, Y1 )
      CALL SGPMV( NMAX+1, X, Y2 )
      CALL SGTXV( 0.5, 0.5, 'SGTXV' )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL SGTNV( NMAX+1, X, Y3 )

      CALL SGCLS

      END

!----------------------------------------------
!  GRpack Module
!----------------------------------------------

module grpack
  use dcl_common
  contains
!-------------------------------------------------------------
    function DclSelectDevice()
      integer :: DclSelectDevice

      call prcopn('DclSelectDevice')
      write(*,*) ' workstation id (i)  ? ;'
      call sgpwsn
      read(*,*) DclSelectDevice
      call prccls('DclSelectDevice')

    end function
!-------------------------------------------------------------
    subroutine DclOpenGraphics(ws_id)
      integer, intent(in), optional :: ws_id

      call prcopn('DclOpenGraphics')
      if(present(ws_id)) then
        iws = ws_id
      else
        write(*,*) ' workstation id (i)  ? ;'
        call sgpwsn
        read(*,*) iws
      end if

      call gropn(iws)
      call prccls('DclOpenGraphics')

    end subroutine
!-------------------------------------------------------------
    subroutine DclNewFrame
      call prcopn('DclNewFrame')
      call grfrm
      call prccls('DclNewFrame')
    end subroutine
!-------------------------------------------------------------
    subroutine DclNewFig
      call prcopn('DclNewFig')
      call grfig
      call prccls('DclNewFig')
    end subroutine
!-------------------------------------------------------------
    subroutine DclCloseGraphics
      call prcopn('DcCloseGraphics')
      call grcls
      call prccls('DcCloseGraphics')
    end subroutine
!-------------------------------------------------------------
    subroutine DclSetTransFunction
      call prcopn('DclSetTransFunction')
      call grstrf
      call prccls('DclSetTransFunction')
    end subroutine
!-------------------------------------------------------------
    subroutine DclSetTransNumber (num)
      integer, intent(in) :: num

      call prcopn('DclSetTransNumber')
      call grstrn(num)
      call prccls('DclSetTransNumber')
    end subroutine
!-------------------------------------------------------------
    subroutine DclSetMapProjectionAngle (longitude, latitude, rotation)
      real, intent(in), optional :: latitude, longitude, rotation
      real                       :: lat0,     lon0,      rot0

      call prcopn('DclSetMapProjectionAngle')
      call glrget('RUNDEF', rundef)

      if(present(longitude)) then; lon0 = longitude
                             else; lon0 = rundef
      end if

      if(present(latitude))  then; lat0 = latitude
                             else; lat0 = rundef
      end if
      
      if(present(rotation))  then; rot0 = rotation
                             else; rot0 = rundef
      end if

      call grsmpl(lon0, lat0, rot0)
      call prccls('DclSetMapProjectionAngle')

    end subroutine
!-------------------------------------------------------------
    subroutine DclSetSimilarity (factor,xoffset,yoffset)
      real, intent(in), optional :: factor, xoffset, yoffset
      real                       :: fac0,   xoff0,   yoff0

      call prcopn('DclSetSimilarity')
      call glrget('RUNDEF', rundef)

      if(present(factor))  then; fac0 = factor
                           else; fac0 = rundef
      end if

      if(present(xoffset)) then; xoff0 = xoffset
                           else; xoff0 = rundef
      end if
      
      if(present(yoffset)) then; yoff0 = yoffset
                           else; yoff0 = rundef
      end if

      call grssim(fac0, xoff0, yoff0)
      call prccls('DclSetSimilarity')
    end subroutine
!-------------------------------------------------------------
    subroutine DclSetMapProjectionWindow(xmin, xmax, ymin, ymax)
      real, intent(in), optional :: xmin,  xmax,  ymin,  ymax
      real                       :: xmin0, xmax0, ymin0, ymax0

      call prcopn('DclSetMapProjectionWindow')
      call glrget('RUNDEF', rundef)

      if(present(xmin)) then; xmin0 = xmin
                        else; xmin0 = rundef
      end if
      
      if(present(xmax)) then; xmax0 = xmax
                        else; xmax0 = rundef
      end if

      if(present(ymin)) then; ymin0 = ymin
                        else; ymin0 = rundef
      end if

      if(present(ymax)) then; ymax0 = ymax
                        else; ymax0 = rundef
      end if

      call grstxy(xmin0, xmax0, ymin0, ymax0)
      call prccls('DclSetMapProjectionWindow')
    end subroutine
!-------------------------------------------------------------
    subroutine DclSetViewPort(xmin,xmax,ymin,ymax)
      real, intent(in), optional :: xmin,  xmax,  ymin,  ymax
      real                       :: xmin0, xmax0, ymin0, ymax0

      call prcopn('DclSetViewPort')
      call glrget('RUNDEF', rundef)

      if(present(xmin)) then; xmin0 = xmin
                        else; xmin0 = rundef
      end if
      
      if(present(xmax)) then; xmax0 = xmax
                        else; xmax0 = rundef
      end if

      if(present(ymin)) then; ymin0 = ymin
                        else; ymin0 = rundef
      end if

      if(present(ymax)) then; ymax0 = ymax
                        else; ymax0 = rundef
      end if

      call grsvpt(xmin0, xmax0, ymin0, ymax0)
      call prccls('DclSetViewPort')
    end subroutine
!-------------------------------------------------------------
    subroutine DclSetWindow(xmin,xmax,ymin,ymax)
      real, intent(in), optional :: xmin,  xmax,  ymin,  ymax
      real                       :: xmin0, xmax0, ymin0, ymax0

      call prcopn('DclSetWindow')
      call glrget('RUNDEF', rundef)

      if(present(xmin)) then; xmin0 = xmin
                        else; xmin0 = rundef
      end if
      
      if(present(xmax)) then; xmax0 = xmax
                        else; xmax0 = rundef
      end if

      if(present(ymin)) then; ymin0 = ymin
                        else; ymin0 = rundef
      end if

      if(present(ymax)) then; ymax0 = ymax
                        else; ymax0 = rundef
      end if
      
      call grswnd(xmin0, xmax0, ymin0, ymax0)
      call prccls('DclSetWindow')
    end subroutine

end module

!-------------------------------------------------
!  SHTlib Module
!-------------------------------------------------
module shtrlib
!  use dcl_common
!  use sht_interface

  type list !作業領域などを格納するための連結リスト
    integer :: idx             ! 位置のインデックス
    type(list),pointer :: next ! 次のリストへのポインタ
    integer :: mm,jm,im        ! 格納する定数
    real, dimension(:), pointer :: array ! 格納する作業領域
  end type list

  type(list),pointer :: top,now,pre

  public
  private :: list,top,now,pre,seek
  save
  
contains
!------------------------
  function seek(idx) ! 連結リスト検索の関数
    ! idx に対応する位置があれば, 真となり, now がその位置へのポインタとなる.
    ! また, その位置が先頭でなければ, pre が前の位置へのポインタとなっている.
    ! idx に対応する位置がなければ, 偽となる.
    integer,intent(in) :: idx
    logical :: seek

    now => top

    do
      if(.not. associated(now)) then
        seek = .false.
        return
      else if(now%idx == idx) then
        seek = .true.
        return
      end if
      pre => now
      now => now%next
    end do
    
  end function seek
!-------------------------------------------------
  subroutine DclInitSHT(mm,jm,im,idx) ! 初期化ルーチン． 
    integer,intent(in)          :: mm    ! 切断波数
    integer,intent(in)          :: jm    ! 南北分割数の1/2
    integer,intent(in)          :: im    ! 東西分割数の1/2
    integer,intent(in),optional :: idx   ! 作業領域番号
    integer :: idxl, length

    call prcopn('DclInitSHT')
    idxl = 1; if(present(idx)) idxl = idx

    if(seek(idxl)) then
      call msgdmp('E','DclInitSHT','The working area has been allocated already.')
    else
      nullify(now)
      allocate(now)
      now%next => top
      top => now
      now%idx = idxl
      now%mm = mm
      now%jm = jm
      now%im = im
      length = (jm+1)*(4*jm+5*mm+14) + (mm+1)*(mm+1) +mm + 2 + 6*im + 15
      allocate(now%array(length))
      call shtint(mm,jm,im,now%array)
    end if
    call prccls('DclInitSHT')

  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocSHT(idx) ! 作業領域解放
    integer,optional :: idx    ! 作業領域番号
    integer :: idxl
    
    call prcopn('DclDeallocSHT')
    idxl = 1; if(present(idx)) idxl = idx

    if(associated(top)) then
      if(top%idx == idxl) then
        deallocate(top%array)
        now => top%next
        deallocate(top)
        top => now
      else
        if(seek(idxl)) then
          deallocate(now%array)
          pre%next => now%next
          deallocate(now)
        end if
      end if
    end if

    call prccls('DclDeallocSHT')

  end subroutine
!-------------------------------------------------
  function DclGetSpectrumNumber(n,m,idx) !スペクトルデータの格納位置を求める．
    integer :: DclGetSpectrumNumber
    integer,intent(in) :: n            ! 全波数
    integer,intent(in) :: m            ! 帯状波数
    integer,intent(in),optional :: idx ! 作業領域番号
    integer :: idxl, lr, li

    call prcopn('DclGetSpectrumNumber')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclGetSpectrumNumber','Working area has not been allocated yet.')
    end if

    call shtnml(now%mm,n,abs(m),lr,li)

    if(m >= 0) then              
      DclGetSpectrumNumber = lr   ! m >= 0 のときは実部の位置
    else
      DclGetSpectrumNumber = li   ! m <  0 のときは虚部の位置
    end if
    call prccls('DclGetSpectrumNumber')

  end function
!-------------------------------------------------
  subroutine DclOperateLaplacian(a,b,ind,idx)   !スペクトルデータに対してラプラシアンを演算する．
    real,intent(in),dimension(*) :: a   ! 入力配列
    real,intent(out),dimension(*) :: b  ! 出力配列
    integer,intent(in),optional :: ind  ! ラプラシアンの演算形式を指定
    integer,intent(in),optional :: idx  ! 作業領域番号
    integer :: idxl, indl

    call prcopn('DclOperateLaplacian')
    idxl = 1
    if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclOperateLaplacian','Working area has not been allocated yet.')
    end if

    indl = 1
    if(present(ind)) indl = ind
    
    call shtlap(now%mm,indl,a,b)
    call prccls('DclOperateLaplacian')
  end subroutine
!-------------------------------------------------
  subroutine DclSpectrumToGrid(s,w,g,isw,idx,m1,m2) ! スペクトルデータからグリッドデータへの変換
    real,intent(in),dimension(*),optional :: s   ! スペクトルデータ
    real,dimension(*) :: w                       ! ウエーブデータ
    real,intent(out),dimension(*),optional :: g  ! グリッドデータ
    integer,intent(in),optional :: isw           ! 変換の種類の指定
    integer,intent(in),optional :: idx           ! 作業領域番号
    integer,intent(in),optional :: m1, m2        ! 波数区間の最小最大値
    integer :: idxl, m1l, m2l, iswl

    call prcopn('DclSpectrumToGrid')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclSpectrumToGrid','Working area has not been allocated yet.')
    end if

    m1l = 0; if(present(m1)) m1l = m1
    m2l = now%mm; if(present(m2)) m2l = m2
    iswl = 0; if(present(isw)) iswl = isw

    if(present(s)) then
      if(present(g)) then
        call shtsga(now%mm,now%jm,now%im,iswl,m1l,m2l,s,w,g,now%array)
      else
        call shtswa(now%mm,now%jm,iswl,m1l,m2l,s,w,now%array)
      end if
    else
      if(present(g)) then
        call shtwga(now%mm,now%jm,now%im,m1l,m2l,w,g,now%array)
      else
        call msgdmp('E','DclSpectrumToGrid','Either S or G must be specified.')
      end if
    end if
    call prccls('DclSpectrumToGrid')
    
  end subroutine
!---------------------------------------------------------------------------
  subroutine DclGridToSpectrum(g,w,s,isw,idx) ! グリッドデータからスペクトルデータへの変換
    real,intent(in),dimension(*),optional :: g  ! グリッドデータ
    real,intent(out),dimension(*) :: w          ! ウエーブデータ
    real,intent(out),dimension(*),optional :: s ! スペクトルデータ
    integer,intent(in),optional :: isw          ! 変換の種類の指定    
    integer,intent(in),optional :: idx          ! 作業領域番号
    integer :: idxl, iswl

    call prcopn('DclGridToSpectrum')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclGridToSpectrum','Working area has not been allocated yet.')
    end if

    iswl = 0; if(present(isw)) iswl = isw
    
    if(present(g)) then
      if(present(s)) then
        call shtg2s(now%mm,now%jm,now%im,iswl,g,w,s,now%array)
      else
        call shtg2w(now%mm,now%jm,now%im,g,w,now%array)
      end if
    else
      if(present(s)) then
        call shtw2s(now%mm,now%jm,iswl,w,s,now%array)
      else
        call msgdmp('E','DclGridToSpectrum','Either G or S must be specified.')
      end if
    end if
    call prccls('DclGridToSpectrum')

  end subroutine
!---------------------------------------------------------------------------
  subroutine DclSpectrumToGridForWave(m,s,wr,wi,g,isw,idx) ! スペクトルデータからグリッドデータへの変換(波数指定)
    integer,intent(in) :: m                     ! 変換する波数
    real,intent(in),dimension(*),optional :: s  ! スペクトルデータ
    real,dimension(*) :: wr                     ! w^m(φ)の実数部分
    real,dimension(*) :: wi                     ! w^m(φ)の虚数部分
    real,intent(out),dimension(*),optional :: g ! グリッドデータ
    integer,intent(in),optional :: isw          ! 変換の種類の指定
    integer,intent(in),optional :: idx          ! 作業領域番号
    integer :: idxl, iswl

    call prcopn('DclSpectrumToGridForWave')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclSpectrumToGridForWave','Working area has not been allocated yet.')
    end if

    iswl = 0; if(present(isw)) iswl = isw

    if(present(s)) then
      if(present(g)) then
        call shtsgm(now%mm,now%jm,now%im,m,iswl,s,wr,wi,g,now%array)
      else
        call shtswm(now%mm,now%jm,m,iswl,s,wr,wi,now%array)
      end if
    else
      if(present(g)) then
        call shtwgm(now%mm,now%jm,now%im,m,wr,wi,g,now%array)        
      else
        call msgdmp('E', 'DclSpectrumToGridForWave', &
&         'Either S or G must be specified.')
      end if
    end if
    call prccls('DclSpectrumToGridForWave')

  end subroutine
!--------------------------------------------------------------------------
  subroutine DclSpectrumToGridForZonal(s,wz,g,isw,idx) ! スペクトルデータからグリッドデータへの変換(帯状成分)
    real,intent(in),dimension(*),optional :: s  ! スペクトルデータ
    real,dimension(*) :: wz                     ! w^0(φ)
    real,intent(out),dimension(*),optional :: g ! グリッドデータ
    integer,intent(in),optional :: isw          ! 変換の種類の指定
    integer,intent(in),optional :: idx          ! 作業領域番号
    integer :: idxl, iswl

    call prcopn('DclSpectrumToGridForZonal')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclSpectrumToGridForZonal','Working area has not been allocated yet.')
    end if

    iswl = 0; if(present(isw)) iswl = isw

    if(present(s)) then
      if(present(g)) then
        call shtsgz(now%mm,now%jm,now%im,iswl,s,wz,g,now%array)
      else
        call shtswz(now%mm,now%jm,iswl,s,wz,now%array)
      end if
    else
      if(present(g)) then
        call shtwgz(now%jm,now%im,wz,g)
      else
        call msgdmp('E','DclSpectrumToGridForZonal','Either S or G must be specified.')
      end if
    end if
    call prccls('DclSpectrumToGridForZonal')
    
  end subroutine
!--------------------------------------------------------------------------
  subroutine DclSpectrumToGridForLatitude(j,s,wj,gj,isw,idx,m1,m2) ! スペクトルデータからグリッドデータへの変換(緯度円指定)
    integer,intent(in) :: j                      ! 変換を行う緯度円の指定
    real,intent(in), dimension(*),optional :: s  ! スペクトルデータ
    real,dimension(*) :: wj                      ! w^m(φ_j)
    real,intent(out),dimension(*),optional :: gj ! グリッドデータ
    integer,intent(in),optional :: isw           ! 変換の種類の指定
    integer,intent(in),optional :: idx           ! 作業領域番号
    integer,intent(in),optional :: m1, m2        ! 波数区間の最小最大値
    integer :: idxl, iswl, m1l, m2l

    call prcopn('DclSpectrumToGridForLatitude')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclSpectrumToGridForLatitude','Working area has not been allocated yet.')
    end if

    iswl = 0; if(present(isw)) iswl = isw

    m1l = 0; if(present(m1)) m1l = m1
    m2l = now%mm; if(present(m2)) m2l = m2

    if(present(s)) then
      if(present(gj)) then
        call shtsgj(now%mm,now%jm,now%im,iswl,j,m1l,m2l,s,wj,gj,now%array)
      else
        call shtswj(now%mm,now%jm,iswl,j,m1l,m2l,s,wj,now%array)
      end if
    else
      if(present(gj)) then
        call shtwgj(now%mm,now%im,m1l,m2l,wj,gj,now%array)
      else
        call msgdmp('E','DclSpectrumToGridForLatitude','Either S or G must be specified.')
      end if
    end if
    call prccls('DclSpectrumToGridForLatitude')

  end subroutine
!------------------------------------------------------------------------
  subroutine DclGetLegendreFunctions(m,fun,idx) ! ルジャンドル陪関数の計算
    integer,intent(in) :: m              ! 帯状波数
    real,intent(out),dimension(*) :: fun ! ルジャンドル陪関数が格納される配列
    integer,intent(in),optional :: idx   ! 作業領域番号
    integer :: idxl

    call prcopn('DclGetLegendreFunctions')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclGetLegendreFunctions','Working area has not been allocated yet.')
    end if

    call shtfun(now%mm,now%jm,m,fun,now%array)
    call prccls('DclGetLegendreFunctions')
  end subroutine
!-------------------------------------------------
  subroutine DclLegendreTransform_F(m,wm,sm,isw,idx) ! ルジャンドル正変換
    integer,intent(in) :: m             ! 変換を行う帯状波数).
    real,intent(in),dimension(*) :: wm  ! ウエーブデータ
    real,intent(out),dimension(*) :: sm ! スペクトルデータ
    integer,intent(in),optional :: isw  ! 変換の種類の指定
    integer,intent(in),optional :: idx  ! 作業領域番号
    integer :: idxl, iswl

    call prcopn('DclLegendreTransform_F')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclLegendreTransform_F','Working area has not been allocated yet.')
    end if

    iswl = 0; if(present(isw)) iswl = isw

    call shtlfw(now%mm,now%jm,m,iswl,wm,sm,now%array)
    call prccls('DclLegendreTransform_F')
  end subroutine
!-------------------------------------------------
  subroutine DclLegendreTransform_B(m,sm,wm,isw,idx) ! ルジャンドル逆変換
    integer,intent(in) :: m             ! 変換を行う帯状波数.
    real,intent(in),dimension(*) :: sm  ! スペクトルデータ
    real,intent(out),dimension(*) :: wm ! ウエーブデータ
    integer,intent(in),optional :: isw  ! 変換の種類の指定
    integer,intent(in),optional :: idx  ! 作業領域番号
    integer :: idxl, iswl

    call prcopn('DclLegendreTransform_B')
    idxl = 1; if(present(idx)) idxl = idx

    if(.not. seek(idxl)) then
      call msgdmp('E','DclLegendreTransform_B','Working area has not been allocated yet.')
    end if

    iswl = 0; if(present(isw)) iswl = isw

    call shtlbw(now%mm,now%jm,m,iswl,sm,wm,now%array) 
    call prccls('DclLegendreTransform_B')
  end subroutine
!-------------------------------------------------
end module

      PROGRAM U2D4

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      PARAMETER( KXMN=9, KXMX=33, KYMN=7, KYMX=31 )
      REAL P(NX,NY), ALON(NX), ALAT(NY)

       DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
   10 CONTINUE
      DO 20 J=1,NY
        ALAT(J) = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
   20 CONTINUE

      DO 30 J=1,NY
        SLAT = SIN(ALAT(J)*DRAD)
      DO 30 I=1,NX
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON(I)*DRAD)
     +         - 0.5*(3*SLAT**2-1)
   30 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( ALON(KXMN), ALON(KXMX), ALAT(KYMN), ALAT(KYMX) )
      CALL GRSVPT(        0.2,        0.8,        0.2,        0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS
      CALL UDCNTR( P(KXMN,KYMN), NX, KXMX-KXMN+1, KYMX-KYMN+1 )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UDPQNP / UDPQID / UDPQCP / UDPQVL / UDPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 14)

      INTEGER   ITYPE(NPARA)
      LOGICAL   LCHREQ
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'INDXMJ  ' /, ITYPE( 1) / 1 /
      DATA      CPARAS( 2) / 'INDXMN  ' /, ITYPE( 2) / 1 /
      DATA      CPARAS( 3) / 'ISOLID  ' /, ITYPE( 3) / 1 /
      DATA      CPARAS( 4) / 'IDASH   ' /, ITYPE( 4) / 1 /
      DATA      CPARAS( 5) / 'LDASH   ' /, ITYPE( 5) / 2 /
      DATA      CPARAS( 6) / 'LABEL   ' /, ITYPE( 6) / 2 /
      DATA      CPARAS( 7) / 'ICYCLE  ' /, ITYPE( 7) / 1 /
      DATA      CPARAS( 8) / 'NLEV    ' /, ITYPE( 8) / 1 /
      DATA      CPARAS( 9) / 'RSIZEL  ' /, ITYPE( 9) / 3 /
      DATA      CPARAS(10) / 'RSIZET  ' /, ITYPE(10) / 3 /
      DATA      CPARAS(11) / 'XTTL    ' /, ITYPE(11) / 3 /
      DATA      CPARAS(12) / 'LMSG    ' /, ITYPE(12) / 2 /
      DATA      CPARAS(13) / 'LCENT   ' /, ITYPE(13) / 2 /
      DATA      CPARAS(14) / 'IUNDEF  ' /, ITYPE(14) / 1 /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'MAJOR_CONTOUR_INDEX' /
      DATA      CPARAL( 2) / 'MINOR_CONTOUR_INDEX' /
      DATA      CPARAL( 3) / 'POSITIVE_CONTOUR_TYPE' /
      DATA      CPARAL( 4) / 'NEGATIVE_CONTOUR_TYPE' /
      DATA      CPARAL( 5) / 'ENABLE_NEGATIVE_CONTOUR' /
      DATA      CPARAL( 6) / 'ENABLE_LABELED_CONTOUR' /
      DATA      CPARAL( 7) / 'MAJOR_CONTOUR_CYCLE' /
      DATA      CPARAL( 8) / 'CONTOUR_LEVEL_NUMBER' /
      DATA      CPARAL( 9) / 'CONTOUR_LABEL_HEIGHT' /
      DATA      CPARAL(10) / 'CONTOUR_MESSAGE_HEIGHT' /
      DATA      CPARAL(11) / 'CONTOUR_MESSAGE_POSITION' /
      DATA      CPARAL(12) / 'ENABLE_CONTOUR_MESSAGE' /
      DATA      CPARAL(13) / 'ENABLE_MESSAGE_CENTERING' /
      DATA      CPARAL(14) / '----IUNDEF  ' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UDPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UDPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UDPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','UDPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UDIQID(CPARAS(IDX), ID)
          CALL UDIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UDLQID(CPARAS(IDX), ID)
          CALL UDLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UDRQID(CPARAS(IDX), ID)
          CALL UDRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UDPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UDIQID(CPARAS(IDX), ID)
          CALL UDISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UDLQID(CPARAS(IDX), ID)
          CALL UDLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UDRQID(CPARAS(IDX), ID)
          CALL UDRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UDPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DATE01


      WRITE(*,*) '*** TEST FOR DATE CONVERSION'
      IDATE=19890215
      WRITE(*,*) 'IDATE = ',IDATE
      CALL DATE12(IDATE,IY,ITD)
      WRITE(*,*) 'AFTER CALLING DATE12(IDATE,IY,ITD)'
      WRITE(*,*) 'IY = ',IY,' : ITD = ',ITD
      CALL DATE21(JDATE,IY,ITD)
      WRITE(*,*) 'AFTER CALLING DATE21(JDATE,IY,ITD)'
      WRITE(*,*) 'JDATE = ',JDATE
      CALL DATE13(JDATE,IY,IM,ID)
      WRITE(*,*) 'AFTER CALLING DATE13(JDATE,IY,IM,ID)'
      WRITE(*,*) 'IY = ',IY,' : IM = ',IM,' : ID = ',ID
      CALL DATE31(KDATE,IY,IM,ID)
      WRITE(*,*) 'AFTER CALLING DATE31(KDATE,IY,IM,ID)'
      WRITE(*,*) 'KDATE = ',KDATE

      END

*-----------------------------------------------------------------------
      PROGRAM SLPK01

      CHARACTER*7  CTXT

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(-ABS(IWS))
      CALL SLMGN(0.1, 0.1, 0.05, 0.05)    ! <-- 第1レベルのマージン

      CALL SLDIV('S', 3, 5)               ! <-- フレーム分割 (第2レベル)
      CALL SLMGN(0.05, 0.05, 0.05, 0.05)  ! <-- 第2レベルのマージン
      CALL SLRAT(1., 1.)                  ! <-- 第2レベルの縦横比を指定
      CALL SGSTXI(2)
      CALL SGSTXS(0.1)

      DO 100 I=1, 15
        CALL SGFRM                        ! <--
        CALL SLPWWR(1)                    ! <    この中は普通に1ページ
        WRITE(CTXT, '(''FRAME'',I2.2)') I ! <    描画するのと同じ
        CALL SGTXV(0.5, 0.5, CTXT)        ! <--
  100 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     USPACK AXIS (UNIFORM TICK MARK)                 S.Sakai  99/09/30
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USAXDV(CSIDE, DTICK, DLBL)

      CHARACTER  CSIDE*(*), CS
      EXTERNAL   LENZ
      LOGICAL    LOFF

      CALL UZLGET('LOFFSET', LOFF)
      CALL UZLSET('LOFFSET', .TRUE.)

      NCS = LENZ(CSIDE)
      DO 100 I=1, NCS
        CS = CSIDE(I:I)
        CALL CUPPER(CS)

        IF(CS.EQ.'T' .OR. CS.EQ.'B' .OR. CS.EQ.'H') THEN
          IF(CS.EQ.'H') CS='U'
          CALL USXINZ(CS, FACTOR, OFFSET)
          CALL UXAXDV(CS, DTICK/FACTOR, DLBL/FACTOR)
          CALL USXTLZ

        ELSEIF(CS.EQ.'L' .OR. CS.EQ.'R' .OR. CS.EQ.'V') THEN
          IF(CS.EQ.'V') CS='U'
          CALL USYINZ(CS, FACTOR, OFFSET)
          CALL UYAXDV(CS, DTICK/FACTOR, DLBL/FACTOR)
          CALL USYTLZ
        ELSE
          CALL MSGDMP('E', 'USAXDV', 'INVALID SIDE NAME.')
        ENDIF

  100 CONTINUE
      CALL UZLSET('LOFFSET', LOFF)

      END

*-----------------------------------------------------------------------
*     INTERPOLATION ON TC (GREAT CIRCLE INTERPOLATION)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPIPT(TX0, TY0, TX1, TY1, MODE)

      PARAMETER (EPSIL=1.E-5)

      LOGICAL   LINTT, LREQA, LXMOD, LSTD, LCONT, LMAP

      COMMON    /SZBLS1/ LLNINT,LGCINT,RDXR,RDYR
      LOGICAL   LLNINT,LGCINT

      EXTERNAL  RFPI, LREQA

      SAVE

*     MODE=0 : FOR LINE
*          1 : FOR TONE
*          2 : FOR ARROW


      PI = RFPI()

      IF (MODE.EQ.0) THEN
        LINTT = LGCINT
      ELSE IF(MODE.EQ.1) THEN
        LINTT = LGCINT .AND.
     + .NOT. (LREQA(TY0,TY1,EPSIL) .AND. LREQA(ABS(TY0),PI/2,EPSIL))
      ELSE IF(MODE.EQ.2) THEN
        CALL STQTRF(LMAP)
        LINTT = LGCINT .AND. LMAP
      END IF

      XX0 = TX0
      YY0 = TY0
      XX1 = TX1
      YY1 = TY1
      NN  = 1
      NEND = 1

      IF (.NOT.LINTT) RETURN

      DX1 = SZXMOD (TX1 - TX0)
      DY1 = TY1-TY0

      ADX = ABS(DX1)
      ADY = ABS(DY1)

      IF (ADX.LT.RDXR .AND. ADY.LT.RDXR) RETURN

      LSTD  = .FALSE.
      IF ( LREQA(ABS(TY0), PI/2, EPSIL) ) THEN
        YLA = SIGN(PI/2, TY0)
        XLA = TX1
        LXMOD = ADX .GE. ADY
      ELSE IF ( LREQA(ABS(TY1), PI/2, EPSIL) ) THEN
        YLA = SIGN(PI/2, TY1)
        XLA = TX0
        LXMOD = ADX .GE. ADY
      ELSE IF ( LREQA(ADX, 0., EPSIL) ) THEN
        XLA = TX0
        LXMOD = .FALSE.
      ELSE IF ( LREQA(ADX, PI, EPSIL) ) THEN
        YLA = SIGN(PI/2, TY0+TY1)
        LXMOD = .TRUE.
      ELSE
*       / THE FOLLOWING PART IS NOT COMPLETE ! /
        LSTD  = .TRUE.
        LXMOD = ADX .GE. ADY
        CALL SZSGCL(TX0, TY0, TX1, TY1)
      END IF

      IF (LXMOD) THEN
        NEND = ADX/RDXR + 1
        DXX = DX1/NEND
      ELSE
        NEND = ADY/RDYR + 1
        DYY = DY1/NEND
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZGIPT(TX, TY, LCONT)

      LCONT = NN.LT.NEND
      IF (LCONT) THEN
        IF (LXMOD) THEN
          TX = XX0 + NN*DXX
          IF (LSTD) THEN
            CALL SZQGCY(TX, TY)
          ELSE
            TY = YLA
          END IF
        ELSE
          TY = YY0 + NN*DYY
          IF (LSTD) THEN
            CALL SZQGCX(TY, TX)
          ELSE
            TX = XLA
          END IF
        END IF
      ELSE
        TX = XX1
        TY = YY1
      END IF
      NN = NN+1

      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE SGPLXR(N,RPX,RPY,ITYPE,INDEX,ICOLOR)

      REAL      RPX(*),RPY(*)
      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGPLXR','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLXR','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPLXR','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPLXR','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPLXR','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZPLOP(ITYPE,INDEX)
      CALL SZPLZR(N,RPX,RPY)
      CALL SZPLCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     USLQNP / USLQID / USLQCP / USLQVL / USLSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 6)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

* ---- SHORT NAME ----
*     / PARAMETERS FOR USDAXS /
      DATA      CPARAS(1) / 'LXINV   ' /, LX(1) / .FALSE. /
      DATA      CPARAS(2) / 'LYINV   ' /, LX(2) / .FALSE. /
      DATA      CPARAS(3) / 'LMATCH  ' /, LX(3) / .FALSE. /
*     / PARAMETERS FOR USXSUB & USYSUB /
      DATA      CPARAS(4) / 'LPRTCT  ' /, LX(4) / .FALSE. /
      DATA      CPARAS(5) / 'LXSUB   ' /, LX(5) / .TRUE. /
      DATA      CPARAS(6) / 'LYSUB   ' /, LX(6) / .TRUE. /

* ---- LONG NAME ----
*     / PARAMETERS FOR USDAXS /
      DATA      CPARAL(1) / 'INV_X_AXIS' /
      DATA      CPARAL(2) / 'INV_Y_AXIS' /
      DATA      CPARAL(3) / 'ENABLE_XY_MATCHING' /
*     / PARAMETERS FOR USXSUB & USYSUB /
      DATA      CPARAL(4) / 'PROTECT_REGION' /
      DATA      CPARAL(5) / 'DRAW_X_SUBLABEL' /
      DATA      CPARAL(6) / 'DRAW_Y_SUBLABEL' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY USLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','USLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY USLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','USLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','USLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('US', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST=.FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','USLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('US', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','USLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     UDPGET / UDPSET / UDPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL UDPQID(CP, IDX)
      CALL UDPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPSET(CP, IPARA)

      CALL UDPQID(CP, IDX)
      CALL UDPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDPSTX(CP,IPARA)

      IP = IPARA
      CALL UDPQID(CP, IDX)
      CALL UDPQIT(IDX, IT)
      CALL UDPQCP(IDX, CX)
      CALL UDPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UD', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL UDIQID(CP, IDX)
        CALL UDISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UD', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL UDLQID(CP, IDX)
        CALL UDLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UD', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL UDRQID(CP, IDX)
        CALL UDRSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     USPACK AXIS (WITH LABEL)                        S.Sakai  99/10/05
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USAXLB(CSIDE, DTICK, N1, DLABEL, CH, NC, N2)
      PARAMETER (N0 = 200)

      REAL       DTICK(N1), DLABEL(N2), DTZ(N0),DLZ(N0)
      CHARACTER  CSIDE*(*), CS, CH(*)*(*)
      EXTERNAL   LENZ
      LOGICAL    LOFF

      CALL UZLGET('LOFFSET', LOFF)
      CALL UZLSET('LOFFSET', .TRUE.)

      NCS = LENZ(CSIDE)
      DO 100 I=1, NCS
        CS = CSIDE(I:I)
        CALL CUPPER(CS)

        IF(CS.EQ.'T' .OR. CS.EQ.'B' .OR. CS.EQ.'H') THEN
          IF(CS.EQ.'H') CS='U'
          CALL USXINZ(CS, FACTOR, OFFSET)

          DO 200 N=1, N1
            DTZ(N) = (DTICK(N)-OFFSET)/FACTOR
  200     CONTINUE
          DO 210 N=1, N2
            DLZ(N) = (DLABEL(N)-OFFSET)/FACTOR
  210     CONTINUE

          CALL UXAXLB(CS, DTZ, N1, DLZ, CH, NC, N2)
          CALL USXTLZ

        ELSEIF(CS.EQ.'L' .OR. CS.EQ.'R' .OR. CS.EQ.'V') THEN
          IF(CS.EQ.'V') CS='U'
          CALL USYINZ(CS, FACTOR, OFFSET)

          DO 300 N=1, N1
            DTZ(N) = (DTICK(N)-OFFSET)/FACTOR
  300     CONTINUE
          DO 310 N=1, N2
            DLZ(N) = (DLABEL(N)-OFFSET)/FACTOR
  310     CONTINUE

          CALL UYAXLB(CS, DTZ, N1, DLZ, CH, NC, N2)
          CALL USYTLZ
        ENDIF

  100 CONTINUE
      CALL UZLSET('LOFFSET', LOFF)

      END

!-------------------------------------------------
!interface module of maplib
!-------------------------------------------------
module map_interface
  interface

    subroutine mpfcyl(xlon,ylat,x,y)              !正距円筒図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpicyl(x,y,xlon,ylat)              !正距円筒図法の逆投影を行なう．
      real,      intent(in) :: x                 !x, y座標
      real,      intent(in) :: y
      real,      intent(out) :: xlon               !経度，緯度
      real,      intent(out) :: ylat
    end subroutine
      
    subroutine mpfmer(xlon,ylat,x,y)              !メルカトール図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpimer(x,y,xlon,ylat)              !メルカトール図法の逆投影を行なう．
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
    end subroutine
      
    subroutine mpfmwd(xlon,ylat,x,y)              !モルワイデ図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpimwd(x,y,xlon,ylat)              !モルワイデ図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpfmwl(xlon,ylat,x,y)              !モルワイデ図法（もどき）の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpimwl(x,y,xlon,ylat)              !モルワイデ図法（もどき）の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpfhmr(xlon,ylat,x,y)              !ハンメル図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpihmr(x,y,xlon,ylat)              !ハンメル図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpfek6(xlon,ylat,x,y)              !エッケルト第6図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpiek6(x,y,xlon,ylat)              !エッケルト第6図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpfktd(xlon,ylat,x,y)              !北田楕円図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpiktd(x,y,xlon,ylat)              !北田楕円図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpfcon(xlon,ylat,x,y)              !正距円錐図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpicon(x,y,xlon,ylat)              !正距円錐図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpscon(ylat1)                      !標準緯線の指定
      real,      intent(in) :: ylat1              !標準緯線の緯度
    end subroutine
      
    subroutine mpfcoa(xlon,ylat,x,y)              !ランベルト正積円錐図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpicoa(x,y,xlon,ylat)              !ランベルト正積円錐図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpscoa(ylat1)                      !標準緯線の指定
      real,      intent(in) :: ylat1
    end subroutine
      
    subroutine mpfcoc(xlon,ylat,x,y)              !ランベルト正角円錐図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpicoc(x,y,xlon,ylat)              !ランベルト正角円錐図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpscoc(ylat1,ylat2)                !標準緯線の指定
      real,      intent(in) :: ylat1              !標準緯線の緯度
      real,      intent(in) :: ylat2
    end subroutine
      
    subroutine mpfbon(xlon,ylat,x,y)              !ボンヌ図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpibon(x,y,xlon,ylat)              !ボンヌ図法の逆投影を行なう．
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
    end subroutine
      
    subroutine mpsbon(ylat1)                      !標準緯線の指定
      real,      intent(in) :: ylat1              !標準緯線の緯度
    end subroutine
      
    subroutine mpfotg(xlon,ylat,x,y)              !正射図法および satellite view の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpiotg(x,y,xlon,ylat)              !正射図法および satellite view の逆投影を行なう．
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
    end subroutine
      
    subroutine mpsotg(rsat)                       !軌道半径の設定
      real,      intent(in) :: rsat               !地球の半径を単位とする衛星の軌道半径
    end subroutine
      
    subroutine mpfpst(xlon,ylat,x,y)              !ポーラーステレオ図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpipst(x,y,xlon,ylat)              !ポーラーステレオ図法の逆投影を行なう．
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
    end subroutine
      
    subroutine mpfazm(xlon,ylat,x,y)              !正距方位図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                  !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpiazm(x,y,xlon,ylat)              !正距方位図法の逆投影を行なう．
      real,      intent(in) :: x                 !x, y座標
      real,      intent(in) :: y
      real,      intent(out) :: xlon               !経度，緯度
      real,      intent(out) :: ylat
    end subroutine
      
    subroutine mpfaza(xlon,ylat,x,y)              !ランベルト正積方位図法の投影を行なう．
      real,      intent(in) :: xlon               !経度，緯度
      real,      intent(in) :: ylat
      real,      intent(out) :: x                 !x, y座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine mpiaza(x,y,xlon,ylat)              !ランベルト正積方位図法の逆投影を行なう．
      real,      intent(in) :: x                  !x, y座標
      real,      intent(in) :: y
      real,      intent(out) :: xlon              !経度，緯度
      real,      intent(out) :: ylat
    end subroutine

  end interface
end module
!maplib library end ----

!-------------------------------------------------
!interface module of clcklib
!-------------------------------------------------
module clc_interface
  interface

    subroutine clckst()                           !時刻を初期化する．
    end subroutine
      
    subroutine clckgt(time)                       !clckstが呼ばれてからのcpu時間を求める．
      real,      intent(out) :: time              !clckstが呼ばれてからの時間, 単位は秒
    end subroutine
      
    subroutine clckdt(dt)                         !時間の分解能を返す．
      real,      intent(out) :: dt                !時間の分解能．単位は秒
    end subroutine

  end interface
end module
      

*-----------------------------------------------------------------------
*     UCYAYR : PLOT YEAR AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCYAYR(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      PARAMETER (N=50)

      REAL      UY(N)
      CHARACTER CH(N)*4
      LOGICAL   LABEL,LUYCHK,LBTWN


      IF (.NOT.LUYCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCYAYR','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCYAYR','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCYAYR','DATE LENGTH IS LESS THAN 0.')
      END IF

      CALL UYPAXS(CSIDE,2)

      NN=1
      UY(NN)=0
      CALL DATE13(JD0,IY0,MO0,ID0)

      DO 10 I=1,ND
        CALL DATEF3(I,IY0,MO0,ID0,IYI,MOI,IDI)
        CALL DATE32(IYI,MOI,IDI,ITDI)
        IYL=NDYEAR(IYI)
        IF (ITDI.EQ.IYL .OR. I.EQ.ND) THEN
          NN=NN+1
          IF (NN.GT.N) THEN
            CALL MSGDMP('E','UCYAYR','WORKING AREA IS NOT ENOUGH.')
          END IF
          UY(NN)=I
          WRITE(CH(NN-1),'(I4)') IYI
          CALL CLADJ(CH(NN-1)(1:4))
        END IF
   10 CONTINUE

      CALL SGQVPT(VX1,VX2,VY1,VY2)
      CALL UZRGET('RSIZEL2',RSIZE)
      NCHX=(VY2-VY1)/RSIZE

      CALL UZIGET('ICENTY'//CSIDE,ICENT)
      CALL UZIGET('IROTLY'//CSIDE,IROTA)
      CALL UZIGET('IROTCY'//CSIDE,IROTC)
      CALL UZLGET('LBTWN',LBTWN)

      CALL UZISET('ICENTY'//CSIDE,0)
      IF (NN*4.LE.NCHX) THEN
        CALL UZISET('IROTLY'//CSIDE,IROTC)
      ELSE
        CALL UZISET('IROTLY'//CSIDE,0)
      END IF
      CALL UZLSET('LBTWN',.TRUE.)

      CALL UZRGET('RSIZET2',RTICK2)
      CALL UZRSET('RSIZET2',RTICK2*1.5)
      CALL UYPTMK(CSIDE,2,UY,NN)
      CALL UZRSET('RSIZET2',RTICK2)

      CALL UZLGET('LABELY'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UYPLBL(CSIDE,2,UY,CH,4,NN)
      END IF

      CALL UZISET('ICENTY'//CSIDE,ICENT)
      CALL UZISET('IROTLY'//CSIDE,IROTA)
      CALL UZLSET('LBTWN',LBTWN)

      END

!-------------------------------------------------
!interface module of fmtlib
!-------------------------------------------------
module fmt_interface
  interface

    subroutine chval(cfmt,val,cval)               !数値を文字列化する
      character(len=*), intent(in) :: cfmt        !文字書式仕様あるい はchval が 解釈するオプション
      real,      intent(in) :: val                !文字化する実数値
      character(len=*), intent(out) :: cval       !文字化された実数値を返す
    end subroutine

  end interface
end module
!fmtlib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE GRINIT


      CALL GLRGET('RUNDEF', RUNDEF)

      CALL GRSVPT(RUNDEF, RUNDEF, RUNDEF, RUNDEF)
      CALL GRSWND(RUNDEF, RUNDEF, RUNDEF, RUNDEF)
      CALL GRSSIM(RUNDEF, RUNDEF, RUNDEF)
      CALL GRSMPL(RUNDEF, RUNDEF, RUNDEF)
      CALL GRSTXY(RUNDEF, RUNDEF, RUNDEF, RUNDEF)
      CALL GRSCWD(RUNDEF, RUNDEF, RUNDEF, RUNDEF)

      CALL SGRSTX('RSAT',   RUNDEF)
      CALL SGRSTX('STLAT1', RUNDEF)
      CALL SGRSTX('STLAT2', RUNDEF)

      END

!-------------------------------------------------
!interface module of umpack
!-------------------------------------------------
module um_interface
  interface

    subroutine umscnt(uxc, uyc, rot)              !投影面の「接点」を指定する．
      real,      intent(in) :: uxc                !接点の経度，緯度
      real,      intent(in) :: uyc
      real,      intent(in) :: rot                !中央の経線の傾き
    end subroutine
      
    subroutine umscwd(uxc, uyc, r)                !円形のウィンドウを設定する．
      real,      intent(in) :: uxc                !中心の経度，緯度
      real,      intent(in) :: uyc
      real,      intent(in) :: r                  !ウィンドウ半径
    end subroutine
      
    subroutine umspnt(n, uxp, uyp)                !地図に含める点を指定する．
      integer,   intent(in) :: n                  !点の数
      real,      intent(in), dimension(n) :: uxp  !点の経度，緯度
      real,      intent(in), dimension(n) :: uyp
    end subroutine
      
    subroutine umpfit()                           !地図投影の変換関数のパラメタを適切に決める．
    end subroutine
      
    subroutine umpglb()                           !地図の境界線（縁）と緯度線,経度線を描く．
    end subroutine
      
    subroutine umpgrd()                           !緯度線・経度線を描く．
    end subroutine
      
    subroutine umplim()                           !地図の境界線（縁）を描く．
    end subroutine
      
    subroutine umpmap(cdsn)                       !各種地図情報を描く．
      character(len=*), intent(in) :: cdsn        !地図情報ファイル名
    end subroutine
			
    subroutine umfmap(cdsn)                       !陸地塗り潰し
      character(len=*), intent(in) :: cdsn        !地図情報ファイル名
    end subroutine
			
    subroutine umpget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine umiget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine umrget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine umlget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine umpset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umiset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umrset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umlset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umpstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umistx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umrstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umlstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine umpqnp(ncp)                        !内部変数の総数を求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine umpqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine umpqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する
      character(len=*), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine umpqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine umpsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine

  end interface
end module
!umpack library end ----

*-----------------------------------------------------------------------
      SUBROUTINE SGLNXV(VX1,VY1,VX2,VY2,INDEX,ICOLOR)

      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGLNXV','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLNXV','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLNXV','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZLNOP(INDEX)
      CALL SZLNZV(VX1,VY1,VX2,VY2)
      CALL SZLNCL

      CALL SWSFCM(.FALSE.)

      END

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program sample_3d04

  use dcl
  real,parameter :: xmin= -50,  xmax= 50,  ymin= -50,  ymax= 50
  real,parameter :: vxmin=0., vxmax=0.8, vymin=0., vymax=0.8
  real,parameter :: zmin= -50,  zmax= 50
  real,parameter :: vzmin=0., vzmax=0.8
  real,parameter :: xvp3=2.5, yvp3=-1., zvp3=1.5 
  real,parameter :: xfc3=(vxmax-vxmin)/2, yfc3=(vymax-vymin)/2 
  real,parameter :: zfc3=(vzmax-vzmin)/2

    call DclOpenGraphics()
    call DclSetParm( 'GRAPH:ifont'   , 2 )

    call DclNewFrame

!-- x-y plane ----
    call DclSetWindow(  xmin,  xmax,  ymin,  ymax )
    call DclSetViewPort( vxmin, vxmax, vymin, vymax )
    call DclSetTransFunction

    call DclSet2DPlane( 1, 2, vzmax)
    call DclSet3DEyePoint( xvp3, yvp3, zvp3 )
    call DclSet3DObjectPoint( xfc3, yfc3, zfc3 )
    call DclSet3DProjection

    call aplot( 1 )

!-- x-z plane ----
    call DclSetWindow(  xmin,  xmax,  zmin,  zmax )
    call DclSetViewPort( vxmin, vxmax, vzmin, vzmax )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSet2DPlane( 1, 3, vymin)
    call DclSet3DProjection

    call aplot( 2 )

!-- y-z plane ----
    call DclSetWindow(  ymin,  ymax,  zmin,  zmax )
    call DclSetViewPort( vymin, vymax, vzmin, vzmax )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSet2DPlane( 2, 3, vxmax)
    call DclSet3DProjection

    call aplot( 3 )

    call DclCloseGraphics

end program
!-----------------------------------------------------------------------
subroutine aplot( ijk )

  use dcl
  integer,parameter :: nmax=40
  real :: x(0:nmax), y(0:nmax)
  character cttl*2

    call DclDrawViewPortFrame( 1 )

    dt = 2.*3.14159 / nmax
    do n=0,nmax
      x(n) = 40.*sin(n*dt)
      y(n) = 40.*cos(n*dt)
    end do

    call DclDrawLine( x, y )

    dt = 2.*3.14159 / 3
    do n=0,3
      x(n) = 40.*sin(n*dt)
      y(n) = 40.*cos(n*dt)
    end do

    call DclDrawLine( x(1:4), y(1:4) )

    call DclSetTextHeight( 0.07 )
    call DclDrawText( 0., 0., 'dennou' )
    write(cttl(1:2), '(i2.2)') ijk
    call DclDrawText( 0., -30., cttl )

    return
end subroutine

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USGRPX(N, X, YMIN, YMAX)

      REAL      X(*)


      CALL MSGDMP('W','USGRPX','THIS IS OLD INTERFACE - USE USGRPH !')

      CALL GLRGET('RUNDEF', RUNDEF)
      CALL SGRSET('UYMIN', YMIN)
      CALL SGRSET('UYMAX', YMAX)

      CALL USSPNT(N, X, RUNDEF)
      CALL USAXIS
      CALL UULIN(N, X, RUNDEF)

      END

!-------------------------------------------------
!interface module of uypack
!-------------------------------------------------
module uy_interface
  interface
!--------------------------------------------------------------------------
    subroutine uyaxdv(cside,dy1,dy2)              !目盛とラベルを描く間隔を指定して座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      real,      intent(in) :: dy1                !小さめの目盛を描く 間隔を指定する
      real,      intent(in) :: dy2                !大きめの目盛および ラベルを描く間隔を指定する
    end subroutine
      
    subroutine uyaxnm(cside,uy1,n1,uy2,n2)        !目盛とラベルを描く場所を指定して座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      real,      intent(in), dimension(n1) :: uy1 !小さめの目盛を描く 場所を格納した長さn1の配列
      integer,   intent(in) :: n1                 !配列ux1, uy1の長さ
      real,      intent(in), dimension(n2) :: uy2 !大きめの目盛およびラベルを描く場所を格納した長さn2の配列
      integer,   intent(in) :: n2                 !配列ux1, uy1の長さ
    end subroutine
      
    subroutine uyaxlb(cside,uy1,n1,uy2,ch,nc,n2)  !目盛とラベルを描く場所を指定して座標軸を描く
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      real,      intent(in), dimension(n1) :: uy1 !小さめの目盛を描く 場所を格納した長さn1の配列
      integer,   intent(in) :: n1                 !配列ux1, uy1の長さ
      real,      intent(in), dimension(n2) :: uy2 !大きめの目盛およびラベルを描く場所を格納した長さn2の配列
      character(len=nc), intent(in), dimension(n2) :: ch !描くラベルを格納した文字長nc,長さn2の文字型配列
      integer,   intent(in) :: nc                 !配列chの文字長
      integer,   intent(in) :: n2                 !配列ux2, uy2, chの長さ
    end subroutine
      
    subroutine uymttl(cside,cttl,py)              !大きめのタイトルを描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      character(len=*), intent(in) :: cttl        !描くタイトル
      real,      intent(in) :: py                 !-1から+1の間の実数値でタイトルを描く位置を指定する
    end subroutine
      
    subroutine uysttl(cside,cttl,py)              !小さめのタイトルを描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      character(len=*), intent(in) :: cttl        !描くタイトル
      real,      intent(in) :: py                 !-1から+1の間の実数値でタイトルを描く位置を指定する
    end subroutine
!----------------------------------------------------------------------------
    subroutine uypaxs(cside,islct)                !軸を示す線分を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      integer,   intent(in) :: islct              !描く軸の属性を指定する
    end subroutine
      
    subroutine uyptmk(cside,islct,uy,n)           !目盛を描く．
      character(len=1), intent(in) :: cside       !目盛を描く座標軸の場所を指定する
      integer,   intent(in) :: islct              !描く目盛の属性を指定する
      real,      intent(in), dimension(n) :: uy   !目盛を描く場所を格納した長さnの 配列
      integer,   intent(in) :: n                  !配列ux, uyの長さ
    end subroutine
      
    subroutine uyplbl(cside,islct,uy,ch,nc,n)     !文字列で指定したラベルを描く．
      character(len=1), intent(in) :: cside       !ラベルを描く座標軸を描く場所を指定する
      integer,   intent(in) :: islct              !描くラベルの属性を指定する
      real,      intent(in), dimension(n) :: uy   !ラベルを描く場所を格納した 長さnの配列
      character(len=nc), intent(in), dimension(n) :: ch !描くラベルを格納した文字長nc長さnの文字型配列
      integer,   intent(in) :: nc                 !配列chの文字長
      integer,   intent(in) :: n                  !配列ux, uy, chの長さ
    end subroutine
      
    subroutine uypnum(cside,islct,uy,n)           !数値で指定したラベルを描く．
      character(len=1), intent(in) :: cside       !ラベルを描く座標軸を描く場所を指定する
      integer,   intent(in) :: islct              !描くラベルの属性を指定する
      real,      intent(in), dimension(n) :: uy   !ラベルを描く場所を格納した 長さnの配列
      integer,   intent(in) :: n                  !配列ux, uyの長さ
    end subroutine
      
    subroutine uypttl(cside,islct,cttl,py)        !タイトルを描く．
      character(len=1), intent(in) :: cside       !タイトルを描く座標軸を描く場所を指定する
      integer,   intent(in) :: islct              !描くタイトルの属性を指定する
      character(len=*), intent(in) :: cttl        !描くタイトル
      real,      intent(in) :: py                 !-1から+1の間の実数値でタイトルを描く位置を指定する
    end subroutine
      
    subroutine uysaxs(cside)                      !軸をずらす。
      character(len=1), intent(in) :: cside 
    end subroutine

  end interface
end module
!uypack library end ----

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program sample_3d06

  use dcl
  integer,parameter :: nx=37, ny=37
  real,parameter ::  xmin=   0,  xmax=360,  ymin= -90,  ymax= 90
  real,parameter :: vxmin=-0.4, vxmax=0.4, vymin=-0.3, vymax=0.3
  real,parameter ::  zmin=-1.9,  zmax=1.9
  real,parameter :: vzmin=-0.2, vzmax=0.2
  real,parameter :: pi=3.14159, drad=pi/180

  real :: alon(nx), alat(ny), p(nx,ny)
  real :: xp(3), yp(3), zp(3)

    do i=1,nx
      alon(i) = xmin + (xmax-xmin)*(i-1)/(nx-1)
    end do
    do j=1,ny
      alat(j) = ymin + (ymax-ymin)*(j-1)/(ny-1)
    end do

    do j=1,ny
      slat = sin(alat(j)*drad)
      do i=1,nx
        p(i,j) = 3*sqrt(1-slat**2)*slat*cos(alon(i)*drad)-0.5*(3*slat**2-1)
      end do
    end do

    call DclOpenGraphics()
    call DclNewFrame

!-- x-y plane ----

    call DclSetWindow(  xmin,  xmax,  ymin,  ymax )
    call DclSetViewPort( vxmin, vxmax, vymin, vymax )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSet2DPlane( 1, 2, vzmin)
    call DclSet3DEyePoint( -1.1, -1.1, 2.5 )
    call DclSet3DObjectPoint(  0.0,  0.0, 0.0 )
    call DclSet3DProjection

    call DclDrawAxis( 'bt', 10., 60. )
    call DclDrawTitle( 'b', 'longitude', 0. )
    call DclDrawAxis( 'lr', 10., 30. )
    call DclDrawTitle( 'l', 'latitude', 0. )

!-- x-z plane ----

    call DclSetWindow(  xmin,  xmax,  zmin,  zmax )
    call DclSetViewPort( vxmin, vxmax, vzmin, vzmax )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSet2DPlane( 1, 3, vymax)
    call DclSet3DProjection

    call uzinit
    call DclDrawAxis( 't', 10., 60. )
    call DclSetParm( 'AXIS:labelxb', .false. )
    call DclDrawAxis( 'b', 10., 60. )
    call DclDrawAxis( 'lr', 0.2, 1.0 )
    call DclDrawTitle( 'l', 'amplitude', 0. )

!-- y-z plane ----

    call DclSetWindow(  ymin,  ymax,  zmin,  zmax )
    call DclSetViewPort( vymin, vymax, vzmin, vzmax )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSet2DPlane( 2, 3, vxmax)
    call DclSet3DProjection

    call uzinit
    call DclDrawAxis( 'tb', 10., 30. )
    call DclSetParm( 'AXIS:labelyl', .false. )
    call DclDrawAxis( 'lr', 0.2, 1.0 )

!---------------- 3-d ------------------

    call DclSet3DViewPort(vxmin, vxmax, vymin, vymax, vzmin, vzmax)
    call DclSet3DWindow( xmin,  xmax,  ymin,  ymax,  zmin,  zmax)
    call DclSet3DLogAxis(.false., .false., .false.)
    call DclSet3DTransNumber(1)
    call DclSet3DTransFunction

!    call szl3op(1)
!      call szt3op(2999,4999)

    do j=ny-1, 1, -1
     do i=nx-1, 1, -1
      xp(1) = alon(i)
      yp(1) = alat(j)
      zp(1) = p(i,j)
      xp(2) = alon(i)
      yp(2) = alat(j+1)
      zp(2) = p(i,j+1)
      xp(3) = alon(i+1)
      yp(3) = alat(j+1)
      zp(3) = p(i+1,j+1)

!        call szt3zu(xp, yp, zp)
!      call szl3zu(3, xp, yp, zp)
      call DclDraw3DLine( xp, yp, zp )

      xp(1) = alon(i+1)
      yp(1) = alat(j+1)
      zp(1) = p(i+1,j+1)
      xp(2) = alon(i+1)
      yp(2) = alat(j)
      zp(2) = p(i+1,j)
      xp(3) = alon(i)
      yp(3) = alat(j)
      zp(3) = p(i,j)

!        call szt3zu(xp, yp, zp)
!      call szl3zu(3, xp, yp, zp)
      call DclDraw3DLine( xp, yp, zp )
     end do
    end do

!    call szl3cl
!      call szt3cl

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE VRINTR(RX,N,JX)

      REAL    RX(*)
      LOGICAL LFLAG


      CALL GLRGET('RMISS',RMISS)

      LFLAG=.FALSE.

      KX=1-JX
      DO 15 J=1,N
        KX=KX+JX
        IF (LFLAG) THEN
          IF (RX(KX).EQ.RMISS) THEN
            IF (RX(KX-JX).NE.RMISS) THEN
              NMISS=1
            ELSE
              NMISS=NMISS+1
            END IF
          ELSE
            IF (RX(KX-JX).EQ.RMISS) THEN
              X1=RX(KX-(NMISS+1)*JX)
              XD=(RX(KX)-X1)/(NMISS+1)
              DO 10 NN=1,NMISS
                RX(KX-(NMISS+1-NN)*JX)=X1+XD*NN
   10         CONTINUE
            END IF
          END IF
        ELSE
          IF (RX(KX).NE.RMISS) THEN
            LFLAG=.TRUE.
          END IF
        END IF
   15 CONTINUE

      END

*-----------------------------------------------------------------------
*     INTEGER PARAMETER CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ODIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA=2)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ,LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      CPARAS( 1)/'MAXSTEP '/, IX( 1)/1000/
      DATA      CPARAS( 2)/'NSTEP   '/, IX( 2)/0/

      DATA      CPARAL( 1)/'MAXSTEP '/
      DATA      CPARAL( 2)/'NSTEP   '/

      DATA      LFIRST /.TRUE./

      NCP=NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODIQID(CP,IDX)

      DO 10 N=1,NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','ODIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODIQCP(IDX,CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','ODIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','ODIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODIQVL(IDX,IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('OD', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','ODIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODISVL(IDX,IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('OD', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','ODISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*--------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*--------------------------------------------------------------------
      PROGRAM G2PK02

      PARAMETER(NX=15,NY=15)

      REAL UX(NX), UY(NY)
      REAL UYW(NX), UXW(NY)
      REAL CX(NX,NY), CY(NX,NY)
      REAL Z(NX,NY)
      REAL TERRAIN(NX)


*     / SET PARAMETERS /

      CALL GLRGET('RUNDEF',RUNDEF)

      DO 10 I=1,NX
        UX(I)=(I-1.0)/(NX-1.0) - 0.5
        TERRAIN(I) = 0.1 * EXP(-24*UX(I)**2)
   10 CONTINUE
      DO 15 J=1,NY
        UY(J)=(J-1.0)/(NY-1.0)
   15 CONTINUE

      CX(1,1) = RUNDEF
      DO 25 J=1,NY
        DO 20 I=1,NX
          CY(I,J) = UY(J)*(1.0-TERRAIN(I)) + TERRAIN(I)
   20   CONTINUE
   25 CONTINUE

*     / GRAPHIC /

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSVPT(0.15,0.85,0.15,0.85)
      CALL GRSWND(UX(1),UX(NX),UY(1),UY(NY))
      CALL GRSTRN(51)
      CALL G2SCTR(NX, NY, UX,UY, CX,CY)
      CALL GRSTRF

*     / TONE /

      DO 35 J=1,NY
        DO 30 I=1,NX
          Z(I,J) = UX(I) * (1-UY(J))
   30   CONTINUE
   35 CONTINUE

      CALL UELSET('LTONE',.TRUE.)
      CALL UWSGXA(UX,NX)
      CALL UWSGYA(UY,NY)
      CALL UETONE(Z, NX, NX, NY)

*     / GRID LINES /

      DO 45 J=1,NY
        DO 40 I=1,NX
          UYW(I) = UY(J)
   40   CONTINUE
        CALL SGPLU(NX,UX,UYW)
   45 CONTINUE

      DO 55 I=1,NX
        DO 50 J=1,NY
          UXW(J) = UX(I)
   50   CONTINUE
        CALL SGPLU(NY,UXW,UY)
   55 CONTINUE

*     / AXES  (Switch to ITR==1) /

      CALL G2QCTM(CXMIN, CXMAX, CYMIN, CYMAX)
      CALL GRSWND(CXMIN,CXMAX,CYMIN,CYMAX)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL USDAXS
      CALL UXSTTL('T','TERRAIN FOLLOWING',0.0)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     SBYTES
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SBYTES (NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)

      IMPLICIT  INTEGER (A-Z)

      INTEGER   ISAM(*),NPACK(*)

      PARAMETER (BPERI=32)

      INTEGER   MASK(BPERI)

      SAVE

      EXTERNAL  ISHIFT

      DATA      NCALL/0/


      IF (NCALL.EQ.0) THEN
        CALL GLIGET('NBITSPW',NBITPW)
        IF (NBITPW.NE.BPERI) THEN
          CALL MSGDMP('E','SBYTES',
     +      'NUMBER OF BITS PER ONE WORD IS INVALID / '//
     +      'CHECK BPERI IN THE PARAMETER STATEMENT OF GBYTES '//
     +      'AND CHANGE IT CORRECTLY.')
        END IF
        MASK(1)=1
        DO 10 I=2,BPERI
          MASK(I)=IOR(ISHIFT(MASK(I-1),1),1)
   10   CONTINUE
        NCALL=1
      END IF

      IF (.NOT.(NBITS.LE.BPERI .AND. NBITS.GT.0)) THEN
        CALL MSGDMP('E','SBYTES','NBITS OUT OF RANGE.')
      END IF

      MSK1=MASK(NBITS)
      MSK2=MASK(BPERI-NBITS)
      BITSEP=NBITS+NSKIP
      DO 20 I=1,ITER
        SBITS=IAND(MSK1,ISAM(I))
        BPO=IBIT+(I-1)*BITSEP
        WPO=BPO/BPERI+1
        RBITS=BPERI*WPO-BPO
        UBITS=BPERI-RBITS
        IF (RBITS.GE.NBITS) THEN
          LSHIFT=BPERI-UBITS-NBITS
          NPACK(WPO)=IAND(NPACK(WPO),ISHIFT(MSK2,LSHIFT+NBITS))
          NPACK(WPO)=IOR(NPACK(WPO),ISHIFT(SBITS,LSHIFT))
        ELSE
          RSHIFT=RBITS-NBITS
          BTMP=ISHIFT(SBITS,RSHIFT)
          NPACK(WPO)=IAND(NPACK(WPO),ISHIFT(MASK(UBITS),RBITS))
          NPACK(WPO)=IOR(NPACK(WPO),BTMP)
          BTMP=ISHIFT(IAND(MASK(-RSHIFT),SBITS),BPERI+RSHIFT)
          NPACK(WPO+1)=IAND(NPACK(WPO+1),MASK(BPERI+RSHIFT))
          NPACK(WPO+1)=IOR(NPACK(WPO+1),BTMP)
        END IF
   20 CONTINUE

      END

*-----------------------------------------------------------------------
*     UYPLBL : PLOT LABELS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPLBL(CSIDE,ISLCT,UY,CH,NC,N)

      REAL      UY(*)
      CHARACTER CSIDE*1,CH(*)*(*)

      LOGICAL   LBTWN,LUYCHK,LCHREQ
      CHARACTER CSLCT*1


      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYPLBL','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UYPLBL','''ISLCT'' IS INVALID.')
      END IF
      IF (NC.LE.0) THEN
        CALL MSGDMP('E','UYPLBL',
     +       'CHARACTER LENGTH IS LESS THAN OR EQUAL TO ZERO.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UYPLBL','NUMBER OF POINTS IS INVALID.')
      END IF

      WRITE(CSLCT,'(I1)') ISLCT

      CALL UZRGET('ROFFY'//CSIDE,ROFFY)
      CALL UZRGET('RSIZEL'//CSLCT,RSIZE)
      CALL UZIGET('ICENTY'//CSIDE,ICENT)
      CALL UZIGET('IROTLY'//CSIDE,IROTA)
      CALL UZIGET('INDEXL'//CSLCT,INDEX)
      CALL UZRGET('PAD1',PAD)
      CALL UZLGET('LBTWN',LBTWN)
      IF (LBTWN) THEN
        CALL UZRGET('RBTWN',RBTWN)
        NCMAX=N-1
      ELSE
        NCMAX=N
      END IF

      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
        IF (LCHREQ(CSIDE,'L')) THEN
          POSX=UXMN
          IFLAG=-1
        ELSE
          POSX=UXMX
          IFLAG=+1
        END IF
      ELSE
        CALL UZRGET('UXUSER',POSX)
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      JROTA=MOD(IROTA+3,4)-2
      IF (JROTA.EQ.-2) THEN
        JROTA=0
      END IF

      RLC=1
      DO 10 I=1,NCMAX
        CALL SZQTXW(CH(I),LCW,WXCH,WYCH)
        IF (JROTA.EQ.0 .AND. WYCH.GT.RLC) THEN
          RLC=WYCH
        ELSE IF (JROTA.NE.0 .AND. WXCH.GT.RLC) THEN
          RLC=WXCH
        END IF
   10 CONTINUE

      IC=JROTA*ICENT*IFLAG
      ROFFZ=ROFFY+RSIZE*(PAD+RLC*(1+IC)*0.5)*IFLAG
      ROFFY=ROFFY+RSIZE*(PAD+RLC)*IFLAG

      IF (LBTWN) THEN
        CALL UYPLBB(UY,CH,NC,N,POSX,ROFFZ,RSIZE,IROTA,ICENT,INDEX,
     +              RBTWN,.TRUE.,.FALSE.)
      ELSE
        CALL UYPLBA(UY,CH,NC,N,POSX,ROFFZ,RSIZE,IROTA,ICENT,INDEX)
      END IF

      CALL UZRSET('ROFFY'//CSIDE,ROFFY)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGPK04

      PARAMETER(N=41)
      DIMENSION X(N), Y(N)


      DT = 4.* 3.14159 / (N-1)
      DO 10 I=1,N
        Y(I) = SIN(DT*(I-1))*0.15
        X(I) = REAL(I-1)/REAL(N-1)
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)
      CALL SGFRM
      CALL SGSWND( 0.0, 1.0, -0.8, 0.2)
      CALL SGSVPT( 0.1, 0.9,  0.1, 0.9)
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SGLSET('LCLIP', .TRUE.)
      CALL SLPVPR(1)

      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (1列目)

      CALL SGSWND( 0.0, 1.0, -0.7, 0.3)
      CALL SGSTRF
      CALL SGSPMT(2)                         ! <-- マーカー TYPE 設定(+)
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (2列目)

      CALL SGSWND( 0.0, 1.0, -0.6, 0.4)
      CALL SGSTRF
      CALL SGSPMT(3)                         ! <-- マーカー TYPE 設定(*)
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (3列目)

      CALL SGSWND( 0.0, 1.0, -0.5, 0.5)
      CALL SGSTRF
      CALL SGSPMT(4)                         ! <-- マーカー TYPE 設定(o)
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (4列目)

      CALL SGSWND( 0.0, 1.0, -0.4, 0.6)
      CALL SGSTRF
      CALL SGSPMI(2)                         ! <-- マーカー INDEX 設定
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (5列目)

      CALL SGSWND( 0.0, 1.0, -0.3, 0.7)
      CALL SGSTRF
      CALL SGSPMI(3)
      CALL SGSPMT(2)

      CALL SGPLU(N, X, Y)                    ! <-- 折れ線描画
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (6列目)

      N1=N/4
      Y(N1-1) = 999.                         ! <-- 欠損値
      Y(N1  ) = 999.
      Y(N1+1) = 999.

      N2=N1*3
      Y(N2-1) = 999.
      Y(N2+1) = 999.

      CALL SGSWND( 0.0, 1.0, -0.2, 0.8)
      CALL SGSTRF
      CALL GLLSET('LMISS',.TRUE.)
      CALL SGSPMI(2)
      CALL SGSPMT(3)

      CALL SGPLU(N, X, Y)                    ! <-- 折れ線描画
      CALL SGPMU(N, X, Y)                    ! <-- マーカー描画 (7列目)

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGPK06

      PARAMETER(N=37)
      DIMENSION X(N), Y(N)


      DT = 2.* 3.14159 / (N-1)
      R = 0.2
      DO 10 I=1, N
        X(I) = R*SIN(DT*(I-1)) + 0.5
        Y(I) = R*COS(DT*(I-1)) + 0.5
   10 CONTINUE

      XC = 0.5
      YC = 0.5

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)
*----------------------------- page 1 ---------------------------------
      CALL SGFRM
      CALL SGSTXI(3)
      CALL SGSPLI(2)

*                XMIN, XMAX, YMIN, YMAX
      CALL SGSWND( 0.,   1.,   0.,   1.)
      CALL SGSVPT( 0.,   1.,   0.,   1.)
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SLPVPR(1)
      CALL SGPLU(N, X, Y)                      ! <-- 円描画
      CALL SGTXU(XC, YC, 'SGTXU')              ! <-- テキスト

*----------------------------- page 2 ---------------------------------
      CALL SGFRM

*                 XMIN, XMAX, YMIN, YMAX
      CALL SGSWND( 0.0,  1.0,  0.0,  1.0)      ! <-- 1x1
      CALL SGSVPT( 0.1,  0.4,  0.6,  0.9)      ! <-- 小さな view port
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SLPVPR(1)
      CALL SGPLU(N, X, Y)                      ! <-- 円描画
      CALL SGTXU(XC, YC, 'SGTXU')              ! <-- テキスト

*                XMIN, XMAX, YMIN, YMAX
      CALL SGSWND( 0.0,  1.0,  0.3,  0.7)      ! <-- ゆがんだ window
      CALL SGSVPT( 0.6,  0.9,  0.6,  0.9)
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SLPVPR(1)
      CALL SGPLU(N, X, Y)                      ! <-- 円描画
      CALL SGTXU(XC, YC, 'SGTXU')              ! <-- テキスト

*                XMIN, XMAX, YMIN, YMAX
      CALL SGSWND( 0.0,  1.0, -0.5,  0.5)      ! <-- はみ出し window
      CALL SGSVPT( 0.1,  0.4,  0.1,  0.4)
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SLPVPR(1)
      CALL SGPLU(N, X, Y)                      ! <-- 円描画
      CALL SGTXU(XC, YC, 'SGTXU')              ! <-- テキスト

      CALL SGLSET('LCLIP', .TRUE.)             ! <-- クリッピング
*                XMIN, XMAX, YMIN, YMAX
      CALL SGSWND( 0.0,  1.0, -0.5,  0.5)
      CALL SGSVPT( 0.6,  0.9,  0.1,  0.4)
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SLPVPR(1)
      CALL SGPLU(N, X, Y)                      ! <-- 円描画
      CALL SGTXU(XC, YC, 'SGTXU')              ! <-- テキスト

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UMPK04

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=  0, XMAX=360, YMIN=-90, YMAX=+90 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05, DP=0.2 )

      REAL      P(NX,NY)


      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
   10   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )

      CALL GLRGET( 'RMISS', RMISS )
      CALL SGLSET( 'LSOFTF', .FALSE. )

      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL GRSSIM( 0.4, 0.0, 0.0 )
      CALL GRSMPL( 165.0, 60.0, 0.0 )
      CALL GRSTXY( -180.0, 180.0, 0.0, 90.0 )
      CALL GRSTRN( 30 )
      CALL GRSTRF
      CALL SGLSET( 'LCLIP', .TRUE. )

      CALL UESTLV( RMISS,  -DP, 201 )
      CALL UESTLV(    DP, DP*2, 401 )
      CALL UESTLV( DP*2, RMISS, 402 )
      CALL UETONE( P, NX, NX, NY )

      CALL UDGCLB( P, NX, NX, NY, DP )
      CALL UDCNTR( P, NX, NX, NY )

      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB

      CALL GRCLS

      END

!-------------------------------------------------
!interface module of blklib
!-------------------------------------------------
module blk_interface
  interface

    function iblklt(rx,n,rr)                      !rx(i-1)≦ rr<rx(i) を満たすiを求める. ただし rr<rx(1) のとき1, rx(n)≦ rr のときn+1を返す
      real,      intent(in), dimension(*) :: rx   !昇順に並んだ実数型配列
      integer,   intent(in) :: n                  !配列の寸法
      real,      intent(in) :: rr                 !調べる実数値
      integer iblklt                              !rx(i-1)≦ rr<rx(i) を満たすiを返す．
    end function
      
    function iblkle(rx,n,rr)                      !rx(i-1)<rr≦ rx(i) を満たすiを求める.ただし rr≦ rx(1) のとき1, rx(n)<rr のときn+1を返す
      real,      intent(in), dimension(*) :: rx   !昇順に並んだ実数型配列
      integer,   intent(in) :: n                  !配列の寸法
      real,      intent(in) :: rr                 !調べる実数値
      integer iblkle                              !rx(i-1)<rr≦ rx(i) を満たすiを返す． 
    end function
      
    function iblkgt(rx,n,rr)                      !rx(i)<rr≦ rx(i+1) を満たすiを求める．ただし rr≦ rx(1) のとき0, rx(n)<rr のときnを返す
      real,      intent(in), dimension(*) :: rx   !昇順に並んだ実数型配列
      integer,   intent(in) :: n                  !配列の寸法
      real,      intent(in) :: rr                 !調べる実数値
      integer iblkgt                              !rx(i)<rr≦ rx(i+1) を満たすiを返す．
    end function
      
    function iblkge(rx,n,rr)                      !rx(i)≦ rr< rx(i+1) を満たすiを求める.ただし rr<rx(1) のとき0, rx(n)≦ rr のときnを返す
      real,      intent(in), dimension(*) :: rx   !昇順に並んだ実数型配列
      integer,   intent(in) :: n                  !配列の寸法
      real,      intent(in) :: rr                 !調べる実数値
      integer iblkge                              !rx(i)≦ rr< rx(i+1) を満たすiを返す． 
    end function

  end interface
end module
!blklib library end ----

*-----------------------------------------------------------------------
*     PLOT ROUTINE ON VC (ENCODING TEXT)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZOPLC

      CHARACTER CH*(*)

      PARAMETER (MAXTMP=400)

      REAL      VXT(MAXTMP),VYT(MAXTMP)
      LOGICAL   LCHAR,LCSET,LROT,LBUFF,LCURV,LCPUT
      CHARACTER CHZ*1024

      COMMON    /SZBLS3/ LCHAZ
      LOGICAL   LCHAZ

      EXTERNAL  LENC,RR2D

      SAVE

      DATA      LCSET/.FALSE./


*     / OPEN DASH LINE & CHARACTER SEGMENT /

      LCHAR=LCHAZ.AND.LCSET

      IF (LCHAR) THEN

        CALL SGLGET('LROT',LROT)
        CALL SGIGET('IROT',IROT)
        CALL SGRGET('FWC',FWC)
        CALL SGRGET('CWL',CWL)
        CALL SGRGET('FFCT',FFCT)
        CALL SGIGET('INDEXC',INDEX)
        CALL SGLGET('LBUFF',LBUFF)
        CALL SGIGET('NBUFF',NBUFF)
        CALL SGRGET('RBUFF',RBUFF)
        CALL SGLGET('LCURV',LCURV)
        CALL SGRGET('RCURV',RCURV)

        IF (.NOT.(FWC.GE.1.0)) THEN
          CALL MSGDMP('E','SZOPLC','PARAMETER ''FWC'' IS LESS THAN 1.')
        END IF
        IF (.NOT.(CWL.GT.0.0)) THEN
          CALL MSGDMP('E','SZOPLC','PARAMETER ''CWL'' IS LESS THAN 0.')
        END IF
        IF (.NOT.(0.0.LT.FFCT .AND. FFCT.LT.1.0)) THEN
          CALL MSGDMP('E','SZOPLC',
     +         'PARAMETER ''FFCT'' IS NOT IN THE RANGE OF (0,1).')
        END IF
        IF (.NOT.(1.LE.NBUFF .AND. NBUFF.LE.MAXTMP)) THEN
          CALL MSGDMP('E','SZOPLC',
     +         'PARAMETER ''NBUFF'' IS NOT IN THE RANGE OF (1,MAXTMP).')
        END IF
        IF (.NOT.(0.0.LT.RBUFF .AND. RBUFF.LT.1.0)) THEN
          CALL MSGDMP('E','SZOPLC',
     +         'PARAMETER ''RBUFF'' IS NOT IN THE RANGE OF (0,1).')
        END IF
        IF (.NOT.(0.0.LT.RCURV .AND. RCURV.LT.FWC)) THEN
          CALL MSGDMP('E','SZOPLC',
     +         'PARAMETER ''RCURV'' IS NOT IN THE RANGE OF (0,FWC).')
        END IF

        CALL SZQTXW(CHZ,NCHZ,WXCH,WYCH)

        FC=WXCH*FWC
        FL=CWL

        WC=HZ*FC
        WL=HZ*FL
        XW=WL+WC
        XI=WL*FFCT

      END IF

      IF (LBUFF) NT=0

      CALL SZOPLD

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZMVLC(VX,VY)

*     / PEN-UP MOVE /

      IF (LBUFF .AND. NT.NE.0) THEN
        DO 5 N=1,NT
          CALL SZPLLD(VXT(N),VYT(N))
    5   CONTINUE
        NT=0
      END IF

      CALL SZMVLD(VX,VY)

      VX0=VX
      VY0=VY
      XL0=XI

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZPLLC(VX,VY)

*     / PEN-DOWN MOVE /

      IF (.NOT.LCHAR) THEN

*       / THERE IS NO TEXT IN THE CYCLE /

        CALL SZPLLD(VX,VY)

      ELSE

*       / THERE EXISTS A TEXT IN THE CYCLE /

   10   CONTINUE

          R=SQRT((VX-VX0)**2+(VY-VY0)**2)
          IF (R.EQ.0) RETURN

          XL=XL0+R

          IF (XL.LT.WL) THEN

*           / CURRENET POSITION IS IN THE LINE PART /

            CALL SZPLLD(VX,VY)

            VX0=VX
            VY0=VY
            XL0=XL

          ELSE IF (XL.LT.XW) THEN

*           / CURRENT POSITION IS IN THE CHARCTER PART /

            IF (XL0.LT.WL) THEN

*             / LAST POSITION WAS IN THE LINE PART /

              VX1=VX0+(VX-VX0)*(WL-XL0)/R
              VY1=VY0+(VY-VY0)*(WL-XL0)/R

              CALL SZPLLD(VX1,VY1)

            END IF

            VX0=VX
            VY0=VY
            XL0=XL

            IF (LBUFF) THEN

*           / BUFFERRING /

              NT=NT+1
              VXT(NT)=VX
              VYT(NT)=VY

              IF (NT.EQ.NBUFF) THEN

                DO 15 N=1,NT
                  CALL SZPLLD(VXT(N),VYT(N))
   15           CONTINUE
                XL0=WL*RBUFF
                NT=0

              END IF

            END IF

          ELSE

*           / CURRENT POSITION IS IN THE NEXT CYCLE /

            IF (XL0.LT.WL) THEN

*             / LAST POSITION WAS IN THE LINE PART /

              VX1=VX0+(VX-VX0)*(WL-XL0)/R
              VY1=VY0+(VY-VY0)*(WL-XL0)/R

              CALL SZPLLD(VX1,VY1)

            END IF

*           / POSITION OF TEXT /

            VX0=VX0+(VX-VX0)*(XW-XL0)/R
            VY0=VY0+(VY-VY0)*(XW-XL0)/R
            VXC=(VX0+VX1)/2
            VYC=(VY0+VY1)/2

            LCPUT=.TRUE.

            IF (LBUFF.AND.LCURV) THEN

*             / CHECK CURVATURE (RUN PATH) /

              XLC=SQRT((VX1-VX0)**2+(VY1-VY0)**2)
              IF (XLC.LE.HZ*WXCH*RCURV) THEN
                DO 20 N=1,NT
                  CALL SZPLLD(VXT(N),VYT(N))
   20           CONTINUE
                XL0=WL*RBUFF
                NT=0
                CALL SZPLLD(VX,VY)
                VX0=VX
                VY0=VY
                LCPUT=.FALSE.
              END IF

            END IF

            IF (LCPUT) THEN

*             / ROTATION OPTION /

              IF (LROT) THEN
                ITH=IROT
              ELSE
                ITH=MOD(RR2D(ATAN2(VY0-VY1,VX0-VX1))+270,180.0)-90
              END IF

*             / WRITE TEXT /

              CALL SZQIDX(INDEXZ)
              IF (INDEX.EQ.0) THEN
                INDEXY=INDEXZ
              ELSE
                INDEXY=INDEX
              END IF

              CALL SZCLLD

*             CALL SGTXZV(VXC,VYC,CHZ,HZ,ITH,0,INDEXY)
              CALL SZTXOP(HZ,ITH,0,INDEXY)
              CALL SZTXZV(VXC,VYC,CHZ)
              CALL SZTXCL

              CALL SZSIDX(INDEXZ)

              CALL SZOPLD
              CALL SZMVLD(VX0,VY0)

              XL0=0
              NT=0

            END IF

          END IF

        IF (.NOT.(XL.LT.XW)) GO TO 10

      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCLLC

*     / CLOSE DASHCHAR SEGMENT /

      IF (LBUFF .AND. NT.NE.0) THEN
        DO 25 N=1,NT
          CALL SZPLLD(VXT(N),VYT(N))
   25   CONTINUE
      END IF

      CALL SZCLLD

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSCHZ(CH,H)

      NC  = LENC(CH)
      CHZ = CH(1:NC)
      HZ  = H
      LCSET = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQCHZ(CH,H)

      IF (.NOT.LCSET) THEN
        CALL MSGDMP('E','SZQCHZ','TEXT HAS NOT BEEN SET YET.')
      END IF

      CH = CHZ
      H  = HZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCRST

      LCSET=.FALSE.

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPLZR(N,RPX,RPY)

      REAL      RPX(*),RPY(*)

      LOGICAL   LFLAG,LCLIPZ

      COMMON    /SZBPL1/ LMISS,RMISS
      LOGICAL   LMISS
      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP

      SAVE


      LCLIPZ=LCLIP
      LCLIP=.FALSE.
      CALL STEPR2

      CALL SZOPLV

      IF (.NOT.LMISS) THEN
        CALL SZMVLV(RPX(1),RPY(1))
        DO 10 I=2,N
          CALL SZPLLV(RPX(I),RPY(I))
   10   CONTINUE
      ELSE
        LFLAG=.FALSE.
        DO 20 I=1,N
          IF (RPX(I).EQ.RMISS .OR. RPY(I).EQ.RMISS) THEN
            LFLAG=.FALSE.
          ELSE IF (LFLAG) THEN
            CALL SZPLLV(RPX(I),RPY(I))
          ELSE
            CALL SZMVLV(RPX(I),RPY(I))
            LFLAG=.TRUE.
          END IF
   20   CONTINUE
      END IF

      CALL SZCLLV

      LCLIP=LCLIPZ
      CALL STRPR2

      END

*-----------------------------------------------------------------------
*     UZLQNP / UZLQID / UZLQCP / UZLQVL / UZLSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UZLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 10)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /
      DATA      CPARAS( 1) / 'LABELXB ' /, LX( 1) / .TRUE. /
      DATA      CPARAS( 2) / 'LABELXT ' /, LX( 2) / .FALSE. /
      DATA      CPARAS( 3) / 'LABELXU ' /, LX( 3) / .TRUE. /
      DATA      CPARAS( 4) / 'LABELYL ' /, LX( 4) / .TRUE. /
      DATA      CPARAS( 5) / 'LABELYR ' /, LX( 5) / .FALSE. /
      DATA      CPARAS( 6) / 'LABELYU ' /, LX( 6) / .TRUE. /
      DATA      CPARAS( 7) / 'LOFFSET ' /, LX( 7) / .FALSE. /
      DATA      CPARAS( 8) / 'LBTWN   ' /, LX( 8) / .FALSE. /
      DATA      CPARAS( 9) / 'LBOUND  ' /, LX( 9) / .FALSE. /
      DATA      CPARAS(10) / 'LBMSG   ' /, LX(10) / .TRUE. /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'DRAW_BOTTOM_LABEL' /
      DATA      CPARAL( 2) / 'DRAW_TOP_LABEL' /
      DATA      CPARAL( 3) / 'DRAW_HORIZONTAL_LABEL' /
      DATA      CPARAL( 4) / 'DRAW_LEFT_LABEL' /
      DATA      CPARAL( 5) / 'DRAW_RIGHT_LABEL' /
      DATA      CPARAL( 6) / 'DRAW_VERTICAL_LABEL' /
      DATA      CPARAL( 7) / 'ENABLE_LINEAR_OFFSET' /
      DATA      CPARAL( 8) / 'ENABLE_SPAN_LABELING' /
      DATA      CPARAL( 9) / 'TITLE_OVER_VIEWPORT' /
      DATA      CPARAL(10) / 'TITLE_OVER_VIEWPORT_MESSAGE' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
 10   CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UZLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UZLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UZLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UZ', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','UZLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UZ', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','UZLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLSAV(IU)

      WRITE(UNIT=IU,IOSTAT=IOS) LX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZLSAV','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZLRST(IU)

      READ(UNIT=IU,IOSTAT=IOS) LX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZLRST','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
      END

      PROGRAM KIHON8

      PARAMETER( XMIN=1., XMAX=100., YMIN=1., YMAX=100. )

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGLSET( 'LCLIP', .TRUE. )

      CALL SGFRM
*-- 直角一様座標(左上) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.1,  0.4,  0.6,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL BPLOT

*-- 片対数(y)座標(右上) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.6,  0.9,  0.6,  0.9 )
      CALL SGSTRN( 2 )
      CALL SGSTRF

      CALL BPLOT

*-- 片対数(x)座標(左下) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.1,  0.4,  0.1,  0.4 )
      CALL SGSTRN( 3 )
      CALL SGSTRF

      CALL BPLOT
      
*-- 対数座標(右下) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.6,  0.9,  0.1,  0.4 )
      CALL SGSTRN( 4 )
      CALL SGSTRF

      CALL BPLOT

      CALL SGCLS

      END
*-----------------------------------------------------------------------
      SUBROUTINE BPLOT

      PARAMETER( NMAX=50 )
      REAL X(NMAX), Y(NMAX)

      CALL SLPVPR( 1 )

*-- 一次関数 ----
      DO 10 N=1,NMAX
        X(N) = 2.*N
        Y(N) = X(N)
   10 CONTINUE

      CALL SGSPLT( 1 )
      CALL SGPLU( NMAX, X, Y )

*-- 指数関数 ----
      DO 20 N=1,NMAX
        Y(N) = EXP(0.05*X(N))
   20 CONTINUE

      CALL SGSPLT( 2 )
      CALL SGPLU( NMAX, X, Y )

*-- 対数関数 ----
      DO 30 N=1,NMAX
        Y(N) = 20.*LOG(X(N))
   30 CONTINUE

      CALL SGSPLT( 3 )
      CALL SGPLU( NMAX, X, Y )

*-- 文字列 ----
      CALL SGSTXS( 0.02 )
      CALL SGTXU( 30., 40., '(30,40)' )

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UUPK03

      PARAMETER (N=30)
      DOUBLE PRECISION A, R
      REAL Y(N)

*---------------------------- DATA DEFINITION --------------------------

      R = 0.2D0
      A = 3.7D0
      DO 100 I=1, N
        R = A*R*(1.D0-R)
        Y(I) = R
  100 CONTINUE
      Y(N/2) = 999.
      CALL GLLSET('LMISS', .TRUE.)
      CALL GLRGET('RUNDEF', RUNDEF)

*----------------------------- GRAPH -----------------------------------

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM

      CALL GRSWND(0., 1., RUNDEF, RUNDEF)
      CALL USSPNT(N, RUNDEF, Y)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UVBXL(N, RUNDEF, Y)

      CALL GRFRM

      CALL GRSWND(RUNDEF, RUNDEF, 0., 1.)
      CALL USSPNT(N, Y, RUNDEF)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UHBXL(N, Y, RUNDEF)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UZIQNP / UZIQID / UZIQCP / UZIQVL / UZISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UZIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 27)
      PARAMETER (IUNDEF = -999)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'IROTLXB ' /, IX( 1) / 0 /
      DATA      CPARAS( 2) / 'IROTLXT ' /, IX( 2) / 0 /
      DATA      CPARAS( 3) / 'IROTLXU ' /, IX( 3) / 0 /
      DATA      CPARAS( 4) / 'IROTLYL ' /, IX( 4) / 0 /
      DATA      CPARAS( 5) / 'IROTLYR ' /, IX( 5) / 0 /
      DATA      CPARAS( 6) / 'IROTLYU ' /, IX( 6) / 0 /

      DATA      CPARAS( 7) / 'IROTCXB ' /, IX( 7) / 0 /
      DATA      CPARAS( 8) / 'IROTCXT ' /, IX( 8) / 0 /
      DATA      CPARAS( 9) / 'IROTCXU ' /, IX( 9) / 0 /
      DATA      CPARAS(10) / 'IROTCYL ' /, IX(10) / +1 /
      DATA      CPARAS(11) / 'IROTCYR ' /, IX(11) / +1 /
      DATA      CPARAS(12) / 'IROTCYU ' /, IX(12) / +1 /

      DATA      CPARAS(13) / 'ICENTXB ' /, IX(13) / 0 /
      DATA      CPARAS(14) / 'ICENTXT ' /, IX(14) / 0 /
      DATA      CPARAS(15) / 'ICENTXU ' /, IX(15) / 0 /
      DATA      CPARAS(16) / 'ICENTYL ' /, IX(16) / +1 /
      DATA      CPARAS(17) / 'ICENTYR ' /, IX(17) / +1 /
      DATA      CPARAS(18) / 'ICENTYU ' /, IX(18) / +1 /

      DATA      CPARAS(19) / 'INDEXT0 ' /, IX(19) / IUNDEF /
      DATA      CPARAS(20) / 'INDEXT1 ' /, IX(20) / 1 /
      DATA      CPARAS(21) / 'INDEXT2 ' /, IX(21) / 3 /

      DATA      CPARAS(22) / 'INDEXL0 ' /, IX(22) / IUNDEF /
      DATA      CPARAS(23) / 'INDEXL1 ' /, IX(23) / 3 /
      DATA      CPARAS(24) / 'INDEXL2 ' /, IX(24) / 3 /

      DATA      CPARAS(25) / 'IFLAG   ' /, IX(25) / -1 /
      DATA      CPARAS(26) / 'INNER   ' /, IX(26) / +1 /

      DATA      CPARAS(27) / 'IUNDEF  ' /, IX(27) / IUNDEF /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'BOTTOM_LABEL_ANGLE' /
      DATA      CPARAL( 2) / 'TOP_LABEL_ANGLE' /
      DATA      CPARAL( 3) / 'HORIZONTAL_LABEL_ANGLE' /
      DATA      CPARAL( 4) / 'LEFT_LABEL_ANGLE' /
      DATA      CPARAL( 5) / 'RIGHT_LABEL_ANGLE' /
      DATA      CPARAL( 6) / 'VERTICAL_LABEL_ANGLE' /

      DATA      CPARAL( 7) / 'BOTTOM_TITLE_ANGLE' /
      DATA      CPARAL( 8) / 'TOP_TITLE_ANGLE' /
      DATA      CPARAL( 9) / 'HORIZONTAL_TITLE_ANGLE' /
      DATA      CPARAL(10) / 'LEFT_TITLE_ANGLE' /
      DATA      CPARAL(11) / 'RIGHT_TITLE_ANGLE' /
      DATA      CPARAL(12) / 'VERTICAL_TITLE_ANGLE' /

      DATA      CPARAL(13) / 'BOTTOM_LABEL_CENTERING' /
      DATA      CPARAL(14) / 'TOP_LABEL_CENTERING' /
      DATA      CPARAL(15) / 'HORIZONTAL_LABEL_CENTERING' /
      DATA      CPARAL(16) / 'LEFT_LABEL_CENTERING' /
      DATA      CPARAL(17) / 'RIGHT_LABEL_CENTERING' /
      DATA      CPARAL(18) / 'VERTICAL_LABEL_CENTERING' /

      DATA      CPARAL(19) / 'AXIS_LINE_INDEX0' /
      DATA      CPARAL(20) / 'AXIS_LINE_INDEX1' /
      DATA      CPARAL(21) / 'AXIS_LINE_INDEX2' /

      DATA      CPARAL(22) / 'LABEL_INDEX0' /
      DATA      CPARAL(23) / 'LABEL_INDEX1' /
      DATA      CPARAL(24) / 'LABEL_INDEX2' /

      DATA      CPARAL(25) / 'LABEL_SIDE_FOR_USER_AXIS' /
      DATA      CPARAL(26) / 'TICKMARK_SIDE' /

      DATA      CPARAL(27) / '----IUNDEF  ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UZIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UZIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UZIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UZ', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','UZIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UZ', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','UZISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZISAV(IU)

      WRITE(UNIT=IU,IOSTAT=IOS) IX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZISAV','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZIRST(IU)

      READ(UNIT=IU,IOSTAT=IOS) IX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZIRST','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
      END

!-------------------------------------------------
!interface module of misclib
!-------------------------------------------------
module mis_interface
  interface

    subroutine dclvnm(cv)                         !「電脳ライブラリ」のバージョン名を返す．
      character(len=*), intent(out) :: cv         !バージョン名を返す文字型の引数
    end subroutine
      
    subroutine cdblk(chr)                         !連続した2個以上の空白を1個の空白で置き換える．
      character(len=*), intent(inout) :: chr      !操作をほどこす文字列
    end subroutine
      
    function cns(ins)                             !調べる値が正なら'n', 負なら's'を返す ．
      integer,   intent(in) :: ins                !調べる整数値
      character cns*1                             !insが正なら'n',負なら's'を返す長さ1の文字型関数
    end function

  end interface
end module
!misclib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2DF01

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05 )

      REAL      P(NX,NY)


      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
   10   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS

      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGTCLR

      PARAMETER (NP=5,NT=10)
      PARAMETER (DD=0.07,DS=0.003)
      PARAMETER (DX=DD+DS*2,DY=1.0/NT)

      REAL      XBOX(NP),YBOX(NP)
      CHARACTER CHR*5

      DATA      XBOX/ 0.0, 1.0, 1.0, 0.0, 0.0/
      DATA      YBOX/ 0.0, 0.0, 1.0, 1.0, 0.0/


      WRITE(*,*) ' WORKSTATION ID (I) ? ; '
      CALL SGPWSN
      READ(*,*) IW

      CALL GLISET('MAXMSG',300)

      CALL SGOPN(IW)

      CALL SGIGET('IBGCLI',IBGCLI)
      CALL SGLSET('LFULL',.TRUE.)
      CALL SGLSET('LSOFTF',.FALSE.)
      CALL SGISET('INDEX',1)
      CALL SLRAT(0.85,1.0)
      CALL SLMGN(0.0,0.0,0.05,0.1)
      CALL SLSTTL('TEST OF SGTONE','T',0.0,-0.5,0.025,1)

      CALL SGFRM
      CALL SGSWND(0.0,1.0,0.0,1.0)
      CALL SGSTRN(1)
      DO 20 J=0,9
        DO 10 I=0,9
          X1=DX*I+DS+(1-DX*NT)/2
          X2=X1+DD
          Y1=DY*(9-J)+DS
          Y2=Y1+DD
          ICLR=I+J*10
          LEVEL=ICLR*1000+999
          IF (ICLR.EQ.0) ICLR=IBGCLI
          LEVELZ=ICLR*1000+999
          CALL SGSVPT(X1,X2,Y1,Y2)
          CALL SGSTRF
          WRITE(CHR,'(I5)') LEVEL
          CALL SGTNZU(NP,XBOX,YBOX,LEVELZ)
          CALL SGPLZU(NP,XBOX,YBOX,1,1)
          CALL SGTXZV(X2,Y2+(DY-DD)/2,CHR,0.01,0,1,1)
   10   CONTINUE
   20 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHON9

      PARAMETER( NMAX=40 )
      PARAMETER( PI=3.14159 )
      PARAMETER( XMIN=0., XMAX=4*PI, YMIN=-1., YMAX=1. )
      REAL X(0:NMAX), Y(0:NMAX)

      DT = XMAX/NMAX
      DO 10 N=0,NMAX
        X(N) = N*DT
        Y(N) = SIN(X(N))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

*--  ラインタイプ = 4 (デフォルト) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.7,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGSPLT( 4 )
      CALL SGPLU( NMAX+1, X, Y )

*--  ラインタイプ = 4 (BITLEN*2) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.5,  0.7 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGRSET( 'BITLEN', 0.006 )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGRSET( 'BITLEN', 0.003 )

*--  ビットパターン ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.3,  0.5 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL BITPCI( '1111111100100100', ITYPE )
      CALL SGSPLT( ITYPE )
      CALL SGPLU( NMAX+1, X, Y )

*--  ビットパターン(倍長) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.1,  0.3 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGISET( 'NBITS', 32 )
      CALL BITPCI( '10010010011111000111110001111100', ITYPE )
      CALL SGSPLT( ITYPE )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGCLS

      END

program map03

  use dcl
  integer,parameter :: nx=18, ny=18
  real,parameter :: xmin=  0, xmax=360, ymin=-90, ymax=+90
  real,parameter :: pi=3.141592, drad=pi/180, dz=0.05, dp=0.2
  real,dimension(0:nx,0:ny) :: p

    do j = 0, ny
      do i = 0, nx
        alon = ( xmin + (xmax-xmin) * i/nx ) * drad
        alat = ( ymin + (ymax-ymin) * j/ny ) * drad
        slat = sin(alat)
        p(i,j) = cos(alon) * (1-slat**2) * sin(2*pi*slat) + dz
      end do
    end do

    call DclOpenGraphics()

    rmiss = DclGetReal( 'GLOBAL:RMISS' )
    call DclSetParm( 'GRAPH:lsoftf', .false. )

    call DclNewFrame

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort( 0.1, 0.9, 0.1, 0.9 )
    call DclSetSimilarity( 0.4, 0.0, 0.0 )
    call DclSetMapProjectionAngle( 165.0, 60.0, 0.0 )
    call DclSetMapProjectionWindow( -180.0, 180.0, 0.0, 90.0 )
    call DclSetTransNumber( DCL_OTHOGAPHIC )
    call DclSetTransFunction
    call DclSetParm( 'GRAPH:lclip', .true. )

    call DclSetShadeLevel( rmiss,  -dp, 201 )
    call DclSetShadeLevel(    dp, dp*2, 401 )
    call DclSetShadeLevel( dp*2, rmiss, 402 )
    call DclShadeContour( p )

    call DclSetContourLevel( p, dp )
    call DclDrawContour( p )

    call DclDrawMap( 'coast_world' )
    call DclDrawGlobe()

    call DclCloseGraphics

end program

!-------------------------------------------------
!interface module of ctrlib
!-------------------------------------------------
module ctr_interface
  interface

    subroutine ct2pc(r,theta,x,y)                 !2次元極座標と直角座標の変換をする．
      real,      intent(in) :: r                  !極座標
      real,      intent(in) :: theta
      real,      intent(out) :: x                 !直角座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine ct2cp(x,y,r,theta)                 !2次元極座標と直角座標の変換をする．
      real,      intent(in) :: x                  !直角座標
      real,      intent(in) :: y
      real,      intent(out) :: r                 !極座標
      real,      intent(out) :: theta
    end subroutine
      
    subroutine ct2ec(u,v,x,y)                     !楕円座標と直角座標の変換をする．
      real,      intent(in) :: u                  !楕円座標
      real,      intent(in) :: v
      real,      intent(out) :: x                 !直角座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine ct2bc(u,v,x,y)                     !双極座標と直角座標の変換をする．
      real,      intent(in) :: u                  !双極座標
      real,      intent(in) :: v
      real,      intent(out) :: x                 !直角座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine ct2hc(u,v,x,y)                     !直角双曲線座標と直角座標の変換をする．
      real,      intent(in) :: u                  !直角双曲線座標
      real,      intent(in) :: v
      real,      intent(out) :: x                 !直角座標
      real,      intent(out) :: y
    end subroutine
      
    subroutine ct2ch(x,y,u,v)                     !直角双曲線座標と直角座標の変換をする．
      real,      intent(in) :: x                  !直角座標
      real,      intent(in) :: y
      real,      intent(out) :: u                 !直角双曲線座標
      real,      intent(out) :: v
    end subroutine
      
    subroutine ct3sc(r,theta,phi,x,y,z)           !3次元球面座標と直角座標の変換をする．
      real,      intent(in) :: r                  !極座標
      real,      intent(in) :: theta
      real,      intent(in) :: phi
      real,      intent(out) :: x                 !直角座標
      real,      intent(out) :: y
      real,      intent(out) :: z
    end subroutine
      
    subroutine ct3cs(x,y,z,r,theta,phi)           !3次元球面座標と直角座標の変換をする．
      real,      intent(in) :: x                  !直角座標
      real,      intent(in) :: y
      real,      intent(in) :: z
      real,      intent(out) :: r                 !極座標
      real,      intent(out) :: theta
      real,      intent(out) :: phi
    end subroutine
      
    subroutine cr2c(theta,x0,y0,x1,y1)            !2次元直角座標を回転する．
      real,      intent(in) :: theta              !回転角
      real,      intent(in) :: x0                 !回転前の座標値
      real,      intent(in) :: y0
      real,      intent(out) :: x1                !回転後の座標値
      real,      intent(out) :: y1
    end subroutine
      
    subroutine cr3c(theta,phi,psi,x0,y0,z0,x1,y1,z1) !3次元直角座標を回転する．
      real,      intent(in) :: theta              !euler の回転角 (θ, φ, ψ)
      real,      intent(in) :: phi
      real,      intent(in) :: psi
      real,      intent(in) :: x0                 !回転前の座標値
      real,      intent(in) :: y0
      real,      intent(in) :: z0
      real,      intent(out) :: x1                !回転後の座標値
      real,      intent(out) :: y1
      real,      intent(out) :: z1
    end subroutine
      
    subroutine cr3s(theta,phi,psi,theta0,phi0,theta1,phi1) !球面座標を回転する．
      real,      intent(in) :: theta              !euler の回転角 (θ, φ, ψ)
      real,      intent(in) :: phi
      real,      intent(in) :: psi
      real,      intent(in) :: theta0             !回転前の座標値
      real,      intent(in) :: phi0
      real,      intent(out) :: theta1            !回転後の座標値
      real,      intent(out) :: phi1
    end subroutine

  end interface
end module
!ctrlib library end ----

*-----------------------------------------------------------------------
*     LOGICAL PARAMETER CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ODLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA=1)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ,LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      CPARAS( 1)/'LBAR    '/, LX( 1) / .FALSE. /

      DATA      CPARAL( 1)/'LBAR    '/

      DATA      LFIRST /.TRUE./

      NCP=NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODLQID(CP,IDX)

      DO 10 N=1,NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','ODLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODLQCP(IDX,CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','ODLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','ODLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('OD', CPARAS, IX, NPARA)
        CALL RLLGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','ODLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODLSVL(IDX,LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('OD', CPARAS, IX, NPARA)
        CALL RLLGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','ODLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

program axis03

  use dcl

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( 1.0e0, 1.0e5, 1.0e3, 1.0e0 )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransNumber( DCL_LOG_LOG )
    call DclSetTransFunction

    call DclDrawAxisLog( 'bt', 1, 9 )
    call DclDrawTitle( 'b', '[x]', 1.0 )

    call DclDrawAxisLog( 'lr', 3, 9 )
    call DclDrawTitle( 'l', '[y]', 1.0 )

    call DclDrawTitle( 't', 'Log Axis', 0.0, 2 )

    call DclCloseGraphics

end program

!-------------------------------------------------
!interface module of vstlib
!-------------------------------------------------
module vst_interface
  interface
!------------------------------------------------------------
!1種類のベクトルデータを処理するサブルーチン．
    subroutine vs1int(wz,nw,ix)                   !1初期化をおこなう
      real,      intent(out), dimension(ix,2) :: wz !大きさが(ix,2)の2次元配列
      integer,   intent(out), dimension(ix) :: nw  !長さが(ix) の1 次元配列．何個のベクトルデータを処理したかを保持している
      integer,   intent(in) :: ix                 !wzの第1次元の寸法， およびnw, xの長さ
    end subroutine
      
    subroutine vs1din(wz,nw,ix,x)                 !データを読み込む．
      real,      intent(inout), dimension(ix,2) :: wz !大きさが(ix,2)の2次元配列
      integer,   intent(inout), dimension(ix) :: nw !長さが(ix) の1 次元配列．何個のベクトルデータを処理したかを保持している
      integer,   intent(in) :: ix                 !wzの第1次元の寸法， およびnw, xの長さ
      real,      intent(in), dimension(ix) :: x   !読み込むベクトルデータ．長さixの配列
    end subroutine
      
    subroutine vs1out(wz,nw,ix)                   !結果を求める．
      real,      intent(inout), dimension(ix,2) :: wz !大きさが(ix,2)の2次元配列
      integer,   intent(in), dimension(ix) :: nw  !長さが(ix) の1 次元配列．何個のベクトルデータを処理したかを保持している
      integer,   intent(in) :: ix                 !wzの第1次元の寸法， およびnw, xの長さ
    end subroutine
!------------------------------------------------------------
!2種類のベクトルデータを連続的に読み込んで平均と分散を求める
    subroutine vs2int(wz,nw,ix,iy)                !初期化をおこなう．
      real,      intent(out), dimension(ix,iy,5) :: wz !大きさが(ix,iy,5) の3次元配列
      integer,   intent(out), dimension(ix,iy) :: nw !大きさが(ix,iy,5)の3次元配列, 何個のベクトルデータを処理したかを保持している
      integer,   intent(in) :: ix                 !wzの第1 次元の寸法， nwの第1次元の寸法，およびxの長さ
      integer,   intent(in) :: iy                 !wzの第2 次元の寸法， nwの第2次元の寸法，およびyの長さ
    end subroutine
      
    subroutine vs2din(wz,nw,ix,iy,x,y)            !データを読み込む．
      real,      intent(inout), dimension(ix,iy,5) :: wz !大きさが(ix,iy,5) の3次元配列
      integer,   intent(inout), dimension(ix,iy) :: nw !大きさが(ix,iy,5)の3次元配列, 何個のベクトルデータを処理したかを保持している
      integer,   intent(in) :: ix                 !wzの第1 次元の寸法， nwの第1次元の寸法，およびxの長さ
      integer,   intent(in) :: iy                 !wzの第2 次元の寸法， nwの第2次元の寸法，およびyの長さ
      real,      intent(in), dimension(ix) :: x   !読み込むベクトルデータ．長さixの配列
      real,      intent(in), dimension(ix) :: y   !読み込むベクトルデータ．長さiyの配列
    end subroutine
      
    subroutine vs2out(wz,nw,ix,iy)                !結果を求める．
      real,      intent(inout), dimension(ix,iy,5) :: wz !大きさが(ix,iy,5) の3次元配列
      integer,   intent(in), dimension(ix,iy) :: nw !大きさが(ix,iy,5)の3次元配列, 何個のベクトルデータを処理したかを保持している
      integer,   intent(in) :: ix                 !読み込むベクトルデータ．長さixの配列
      integer,   intent(in) :: iy                 !読み込むベクトルデータ．長さiyの配列
    end subroutine

  end interface
end module
!vstlib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCPMZU(N,UPX,UPY,UPZ,ITYPE,INDEX,RSIZE)

      REAL      UPX(*),UPY(*),UPZ(*)


      IF (N.LT.1) THEN
        CALL MSGDMP('E','SCPMZU','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SCPMZU','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SCPMZU','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SCPMZU','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SCPMZU','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SCPMZU','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZM3OP(ITYPE,INDEX,RSIZE)
      CALL SZM3ZU(N,UPX,UPY,UPZ)
      CALL SZM3CL

      END

!-------------------------------------------------
!interface module of uxpack
!-------------------------------------------------
module ux_interface
  interface
!-----------------------------------------------------------------------------------
    subroutine uxaxdv(cside,dx1,dx2)              !目盛とラベルを描く間隔を指定して座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      real,      intent(in) :: dx1                !小さめの目盛を描く間隔を指定する
      real,      intent(in) :: dx2                !大きめの目盛およびラベルを描く間隔を指定する
    end subroutine
      
    subroutine uxaxnm(cside,ux1,n1,ux2,n2)        !目盛とラベルを描く場所を指定して座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      real,      intent(in), dimension(n1) :: ux1 !小さめの目盛を描く場所を格納した長さn1の配列
      integer,   intent(in) :: n1                 !配列ux1, uy1の長さ
      real,      intent(in), dimension(n2) :: ux2 !大きめの目盛およびラベルを描く場所を格納した長さn2の配列
      integer,   intent(in) :: n2                 !配列ux1, uy1の長さ
    end subroutine
      
    subroutine uxaxlb(cside,ux1,n1,ux2,ch,nc,n2)  !目盛とラベルを描く場所を指定して座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      real,      intent(in), dimension(n1) :: ux1 !小さめの目盛を描く 場所を格納した長さn1の配列
      integer,   intent(in) :: n1                 !配列ux1, uy1の長さ
      real,      intent(in), dimension(n2) :: ux2 !大きめの目盛およびラベルを描く場所を格納した長さn2の配列
      character(len=nc), intent(in), dimension(n2) :: ch !描くラベルを格納した文字長nc,長さn2の文字型配列
      integer,   intent(in) :: nc                 !配列chの文字長
      integer,   intent(in) :: n2                 !配列ux2, uy2, chの長さ
    end subroutine
      
    subroutine uxmttl(cside,cttl,px)              !大きめのタイトルを描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      character(len=*), intent(in) :: cttl        !描くタイトル
      real,      intent(in) :: px                 !-1から+1の間の実数値でタイトルを描く位置を指定する
    end subroutine
      
    subroutine uxsttl(cside,cttl,px)              !小さめのタイトルを描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      character(len=*), intent(in) :: cttl        !描くタイトル
      real,      intent(in) :: px                 !-1から+1の間の実数値でタイトルを描く位置を指定する
    end subroutine
!------------------------------------------------------------------
    subroutine uxpaxs(cside,islct)                !軸を示す線分を描く．
      character(len=1), intent(in) :: cside       !座標軸を描く場所を指定する
      integer,   intent(in) :: islct              !描く軸の属性を指定する
    end subroutine
      
    subroutine uxptmk(cside,islct,ux,n)           !目盛を描く．
      character(len=1), intent(in) :: cside       !目盛を描く座標軸の場所を指定する
      integer,   intent(in) :: islct              !描く目盛の属性を指定する
      real,      intent(in), dimension(n) :: ux   !目盛を描く場所を格納した長さnの 配列
      integer,   intent(in) :: n                  !配列ux, uyの長さ
    end subroutine
      
    subroutine uxplbl(cside,islct,ux,ch,nc,n)     !文字列で指定したラベルを描く．
      character(len=1), intent(in) :: cside       !ラベルを描く座標軸の場所を指定する
      integer,   intent(in) :: islct              !描くラベルの属性を指定する
      real,      intent(in), dimension(n) :: ux   !ラベルを描く場所を格納した長さnの 配列
      character(len=nc), intent(in), dimension(n) :: ch !描くラベルを格納した文字長nc長さnの文字型配列
      integer,   intent(in) :: nc                 !配列chの文字長
      integer,   intent(in) :: n                  !配列ux, uy, chの長さ
    end subroutine
      
    subroutine uxpnum(cside,islct,ux,n)           !数値で指定したラベルを描く．
      character(len=1), intent(in) :: cside       !ラベルを描く座標軸を描く場所を指定する
      integer,   intent(in) :: islct              !描くラベルの属性を指定する
      real,      intent(in), dimension(n) :: ux   !ラベルを描く場所を格納した長さnの 配列
      integer,   intent(in) :: n                  !配列ux, uyの長さ
    end subroutine
      
    subroutine uxpttl(cside,islct,cttl,px)        !タイトルを描く．
      character(len=1), intent(in) :: cside       !タイトルを描く座標軸を描く場所を指定する
      integer,   intent(in) :: islct              !描くタイトルの属性を指定する
      character(len=*), intent(in) :: cttl        !描くタイトル
      real,      intent(in) :: px                 !-1から+1の間の実数値でタイトルを描く位置を指定する
    end subroutine
      
    subroutine uxsaxs(cside)                      !軸をずらす。
      character(len=1), intent(in) :: cside 
    end subroutine

  end interface
end module
!uxpack library end ----

      PROGRAM HOP

      PARAMETER( NMAX=400 )
      REAL X(NMAX), Y(NMAX)

*-- リサジューの図 ----
      DT = 2.*3.14159 / (NMAX-1)

      DO 10 N=1,NMAX
        T = DT*(N-1)
        X(N) = 1.E 2*SIN(4.*T)
        Y(N) = 1.E-3*COS(5.*T) + 6.
   10 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL USSTTL( 'X-TITLE', 'x-unit', 'Y-TITLE', 'y-unit' )
      CALL USGRPH( NMAX, X, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZTXZR(RX,RY,CHARS)

      CHARACTER CHARS*(*)

      LOGICAL   LCLIPZ

      COMMON    /SZBTX3/ LCLIP
      LOGICAL   LCLIP

      SAVE


      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)
      LCLIP=.FALSE.
      CALL STEPR2

      CALL SZTXWV(RX,RY,CHARS)
      CALL SGLSET('LCLIP',LCLIPZ)
      LCLIP=LCLIPZ
      CALL STRPR2

      END

!-------------------------------------------------
!interface module of syslib
!-------------------------------------------------
module sys_interface
  interface
!------------------------------------------------------------
    subroutine glpget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine gliget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine glrget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,            intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine gllget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine glpset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine gliset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine glrset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine gllset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine glpstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine glistx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine glrstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine gllstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
!------------------------------------------------------------
    subroutine glpqnp(ncp)                        !内部変数の総数を求める．
      integer,   intent(out) :: ncp               !内部変数の値
    end subroutine
      
    subroutine glpqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine glpqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する．
      integer,   intent(in) :: idx
      character(len=*), intent(out) :: cp
    end subroutine
      
    subroutine glpqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する．
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine glpsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine
!------------------------------------------------------------
    subroutine glcget(cp,cpara)                   !文字型の内部変数を参照/変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      character(len=*), intent(out) :: cpara      !内部変数の値
    end subroutine
      
    subroutine glcset(cp,cpara)                   !文字型の内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      character(len=*), intent(in) :: cpara       !内部変数の値
    end subroutine
      
    subroutine glcstx(cp,cpara)                   !文字型の内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      character(len=*), intent(in) :: cpara       !内部変数の値
    end subroutine
      
    subroutine glcqnp(ncp)                        !内部変数の総数を求める．
      integer,   intent(out) :: ncp               !内部変数の値
    end subroutine
      
    subroutine glcqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine glcqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する．
      integer,   intent(in) :: idx
      character(len=*), intent(out) :: cp
    end subroutine
      
    subroutine glcqvl(idx,cpara)                  !idxの位置にある内部変数の値を参照する．
      integer,   intent(in) :: idx
      character(len=*), intent(out) :: cpara
    end subroutine
      
    subroutine glcsvl(idx,cpara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      character(len=*), intent(in) :: cpara
    end subroutine
!------------------------------------------------------------
    subroutine msgdmp(clev,csub,cmsg)             !メッセージを出力する．
      character(len=1), intent(in) :: clev        !メッセージのレベルを指定する
      character(len=6), intent(in) :: csub        !msgdmpを呼んでいるサブルーチン名を指定する
      character(len=*), intent(in) :: cmsg        !出力するメッセージ
    end subroutine
!------------------------------------------------------------
    subroutine rtpget(cpfix,cp,ipara,n)           !実行時オプションから内部変数を取得する．
      character(len=*), intent(in) :: cpfix       !変数名の前につける接頭辞
      character(len=*), intent(in), dimension(*) :: cp !変数名
      integer,   intent(out), dimension(*) :: ipara !変数の値
      integer,   intent(in) :: n                  !内部変数の数
    end subroutine
      
    subroutine rtcget(cpfix,cp,cpara,n)           !実行時オプションから内部変数を取得する．
      character(len=*), intent(in) :: cpfix       !変数名の前につける接頭辞
      character(len=*), intent(in), dimension(*) :: cp !変数名
      character(len=*), intent(out), dimension(*) :: cpara !変数の値
      integer,   intent(in) :: n                  !内部変数の数
    end subroutine
      
    subroutine rtpenv(cpfix,cp,ipara)             !環境変数の値を得る
      character(len=*), intent(in) :: cpfix
      character(len=*), intent(in), dimension(*) :: cp
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine rtpopt(cpfix,cp,ipara)             !コマンドラインオプションの値を得る
      character(len=*), intent(in) :: cpfix
      character(len=*), intent(in), dimension(*) :: cp
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine rtpxfl(cpfix,cp,ipara)             !外部ファイルからオプションの値を得る
      character(len=*), intent(in) :: cpfix
      character(len=*), intent(in), dimension(*) :: cp
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine rtcenv(cpfix,cp,cval)              !環境変数の値（文字型）を得る
      character(len=*), intent(in) :: cpfix
      character(len=*), intent(in), dimension(*) :: cp
      character(len=*), intent(out) :: cval
    end subroutine
      
    subroutine rtcopt(cpfix,cp,cval)              !コマンドラインオプションの値を得る
      character(len=*), intent(in) :: cpfix
      character(len=*), intent(in), dimension(*) :: cp
      character(len=*), intent(out) :: cval
    end subroutine
      
    subroutine rtcxfl(cpfix,cp,cval)              !外部ファイルからオプションの値を得る
      character(len=*), intent(in) :: cpfix
      character(len=*), intent(in), dimension(*) :: cp
      character(len=*), intent(out) :: cval
    end subroutine

    subroutine cfsrch(cpl,np,cfl,nf,cfn)            !パス名の先頭部分と末尾部分のリストの組合せから，存在するファイル名を探す．
      character(len=*), intent(in), dimension(np) :: cpl !パス名の先頭部分のリスト
      integer,   intent(in) :: np                 !配列cplの長さ
      character(len=*), intent(in), dimension(np) :: cfl !パス名の末尾部分のリスト
      integer,   intent(in) :: nf                 !配列cflの長さ
      character(len=*), intent(out) :: cfn        !最初に見つかったファイル名を返す文字型変数
    end subroutine
!------------------------------------------------------------
      
    function lchreq(ch1,ch2)                      !大文字・小文字の区別なく2つの文字列を比較する．
      logical lchreq                              !2つの文字列が等しいとき .true.を返す論理関数値
      character(len=*), intent(in) :: ch1         !比較する文字列
      character(len=*), intent(in) :: ch2         !比較する文字列
    end function
      
    function iufopn()                             !利用可能なもっとも小さい入出力装置番号を返す．
      integer iufopn                              !装置番号を返す整数値
    end function

  end interface
end module
!syslib library end ----

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program axis

  use dcl

    call DclOpenGraphics
    call DclNewFrame

    call DclSetWindow( 1985.0, 1990.0, -2.0, +2.0 )
    call DclSetViewPort( 0.2, 0.8, 0.3, 0.7 )
    call DclSetTransFunction

    call DclSetParm( 'ENABLE_SPAN_LABELING', .true. )
    call uxsfmt( '(i4)' )
    call DclDrawAxis( 'h', 0.25, 1.0, section=0.0 )
    call DclSetParm( 'ENABLE_SPAN_LABELING', .false. )
    call DclDrawTitle( 'h', 'year', +1.0 )


    call DclSetParm( 'TICKMARK_SIDE', -1 )
!    call DclSetYLabelFormat( '(F4.1)' )
    call DclDrawAxis( 'l', 0.25, 1. )
    call DclDrawTitle( 'l', 'S.O.Index', 0. )

    call DclDrawTitle( 't', 'Axis', 0.0, sw=2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
      SUBROUTINE SGLNXR(RX1,RY1,RX2,RY2,INDEX,ICOLOR)

      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGLNXR','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLNXR','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLNXR','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZLNOP(INDEX)
      CALL SZLNZR(RX1,RY1,RX2,RY2)
      CALL SZLNCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZL3ZV(N,V3X,V3Y,V3Z)

      REAL      V3X(N),V3Y(N),V3Z(N)

      LOGICAL   LFLAG

      COMMON    /SZBPL1/ LMISS,RMISS
      LOGICAL   LMISS

      SAVE


      CALL SZOPL3

      IF (.NOT.LMISS) THEN
        CALL SZMVL3(V3X(1),V3Y(1), V3Z(1))
        DO 10 I=2,N
          CALL SZPLL3(V3X(I),V3Y(I), V3Z(I))
   10   CONTINUE
      ELSE
        LFLAG=.FALSE.
        DO 20 I=1,N
          IF (V3X(I).EQ.RMISS .OR. V3Y(I).EQ.RMISS
     +                        .OR. V3Z(I).EQ.RMISS) THEN
            LFLAG=.FALSE.
          ELSE IF (LFLAG) THEN
            CALL SZPLL3(V3X(I),V3Y(I), V3Z(I))
          ELSE
            CALL SZMVL3(V3X(I),V3Y(I), V3Z(I))
            LFLAG=.TRUE.
          END IF
   20   CONTINUE
      END IF

      CALL SZCLL3

      END

*-----------------------------------------------------------------------
*     UGLQNP / UGLQID / UGLQCP / UGLQVL / UGLSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 7)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'LNRMAL  ' /, LX(1) / .TRUE. /
      DATA      CPARAS(2) / 'LEQRAT  ' /, LX(2) / .TRUE. /
      DATA      CPARAS(3) / 'LMSG    ' /, LX(3) / .TRUE. /
      DATA      CPARAS(4) / 'LMISSP  ' /, LX(4) / .FALSE. /
      DATA      CPARAS(5) / 'LSMALL  ' /, LX(5) / .FALSE. /
      DATA      CPARAS(6) / 'LUNIT   ' /, LX(6) / .FALSE. /
      DATA      CPARAS(7) / 'LUMSG   ' /, LX(7) / .TRUE. /

*     / LONG NAME /

      DATA      CPARAL(1) / 'ENABLE_VECTOR_NORMALIZING' /
      DATA      CPARAL(2) / 'FIX_VECTOR_PROPORTION' /
      DATA      CPARAL(3) / 'ENABLE_VECTOR_MESSAGE' /
      DATA      CPARAL(4) / 'ENABLE_MISS_VECTOR_MARKER' /
      DATA      CPARAL(5) / 'ENABLE_SMALL_VECTOR_MARKER' /
      DATA      CPARAL(6) / 'DRAW_UNIT_VECTOR' /
      DATA      CPARAL(7) / 'DRAW_UNIT_VECTOR_MESSAGE' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UGLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UGLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UGLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UG', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','UGLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UG', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','UGLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLNZU(UX1,UY1,UX2,UY2,INDEX)


      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLNZU','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLNZU','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZLNOP(INDEX)
      CALL SZLNZU(UX1,UY1,UX2,UY2)
      CALL SZLNCL

      END

*-----------------------------------------------------------------------
*     TMRQNP / TMRQID / TMRQCP / TMRQVL / TMRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE TMRQNP(NCP)
      IMPLICIT NONE

      CHARACTER CP*(*)

      INTEGER   NPARA
      REAL      RUNDEF
      PARAMETER (NPARA  = 2)
      PARAMETER (RUNDEF = -999.)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      INTEGER   LENC
      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'ARRWINTV' /, RX(1) / 0.05 /
      DATA      CPARAS(2) / 'STLNDT  ' /, RX(2) / 0.0 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'ARROW_DRAWING_INTERVAL' /
      DATA      CPARAL(2) / 'STLN_CALCULATING_INTERVAL' /

      DATA      LFIRST / .TRUE. /

      INTEGER   N, NCP
      INTEGER   IDX, IP, IN
      REAL      RPARA

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','TMRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','TMRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','TMRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('TM', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
        IF ((IDX.EQ.1 .OR. IDX.EQ.2) .AND. RPARA.EQ.RUNDEF) THEN
          CALL UZRGET('RSIZEL1', RPARA)
        END IF
      ELSE
        CALL MSGDMP('E','TMRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('TM', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','TMRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SUSWND(UXMIN,UXMAX,UYMIN,UYMAX,INTRF)


      CALL MSGDMP('M','SUSWND','THIS IS OLD INTERFACE - USE SGSWND !')

      CALL SGSWND(UXMIN,UXMAX,UYMIN,UYMAX)
      CALL SGSTRN(INTRF)
      CALL SGSTRF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM STEP2

      PARAMETER( NMAX=100 )
      REAL X(NMAX), Y(NMAX)

*-- データ ----
      ISEED = 1
      X(1) = 2.*(RNGU0(ISEED)-0.5)
      DO 10 N=2,NMAX
        X(N)   = 2.*(RNGU0(ISEED)-0.5)
        Y(N-1) = X(N)
   10 CONTINUE
      Y(NMAX) = X(1)

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL USSPNT( NMAX, X, Y )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'X-TITLE', 'x-unit', 'Y-TITLE', 'y-unit' )
      CALL USDAXS

      CALL UUSMKI( 5 )
      CALL UUSMKS( 0.015 )
      CALL UUMRK( NMAX/4, X( 1), Y( 1) )

      CALL UUSMKT( 2 )
      CALL UUMRK( NMAX/4, X(26), Y(26) )

      CALL UUSMKT( 3 )
      CALL UUMRK( NMAX/4, X(51), Y(51) )

      CALL UUSMKT( 4 )
      CALL UUMRK( NMAX/4, X(76), Y(76) )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UCXADY : PLOT DATE AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCXADY(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      PARAMETER (N=100)

      REAL      UX(N)
      CHARACTER CH(N)*2
      LOGICAL   LABEL,LBTWN,LUXCHK


      IF (.NOT.LUXCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCXADY','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCXADY','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCXADY','DATE LENGTH IS LESS THAN 0.')
      END IF

      CALL UXPAXS(CSIDE,2)

      ID=NUCDAY('X',ND)
      IF (ID.LE.0) THEN
        CALL MSGDMP('W','UCXADY','NO DAY-AXIS.')
        RETURN
      END IF

      CALL DATE12(JD0,IY0,IT0)
      NN=0
      DO 10 I=0,ND
        CALL DATEF2(I,IY0,IT0,IYI,ITI)
        CALL DATE23(IYI,MOI,IDI,ITI)
        IML=NDMON(IYI,MOI)
        IF ((IDI.LT.IML-ID/2 .AND. MOD(IDI,ID).EQ.0)
     +     .OR. IDI.EQ.IML) THEN
          NN=NN+1
          IF (NN.GT.N) THEN
            CALL MSGDMP('E','UCXADY','WORKING AREA IS NOT ENOUGH.')
          END IF
          UX(NN)=I
          WRITE(CH(NN)(1:2),'(I2)') IDI
          CALL CLADJ(CH(NN)(1:2))
        END IF
   10 CONTINUE

      IF (NN.EQ.0) THEN
        CALL MSGDMP('W','UCXADY','THERE IS NO TICKMARK / LABEL.')
        RETURN
      END IF

      CALL UZIGET('ICENTX'//CSIDE,ICENT)
      CALL UZIGET('IROTLX'//CSIDE,IROTA)
      CALL UZIGET('IROTCX'//CSIDE,IROTC)
      CALL UZLGET('LBTWN',LBTWN)

      CALL UZISET('ICENTX'//CSIDE,0)
      CALL UZISET('IROTLX'//CSIDE,IROTC)
      CALL UZLSET('LBTWN',.FALSE.)

      CALL UXPTMK(CSIDE,1,UX,NN)
      CALL UZLGET('LABELX'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UXPLBL(CSIDE,1,UX,CH,2,NN)
      END IF

      CALL UZISET('ICENTX'//CSIDE,ICENT)
      CALL UZISET('IROTLX'//CSIDE,IROTA)
      CALL UZLSET('LBTWN',LBTWN)

      END

*-----------------------------------------------------------------------
*     UXPTTL : PLOT TITLE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPTTL(CSIDE,ISLCT,CTTL,PX)

      CHARACTER CSIDE*1,CTTL*(*)

      REAL      UX(2)
      LOGICAL   LBOUND,LBMSG,LUXCHK,LCHREQ
      CHARACTER CSLCT*1


      IF (.NOT.(LUXCHK(CSIDE))) THEN
        CALL MSGDMP('E','UXPTTL','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UXPTTL','''ISLCT'' IS INVALID.')
      END IF
      NCTL=LEN(CTTL)
      IF (.NOT.(0.LT.NCTL)) THEN
        CALL MSGDMP('M','UXPTTL','CHARACTER LENGTH IS ZERO.')
        RETURN
      END IF

      WRITE(CSLCT,'(I1)') ISLCT

      CALL UZRGET('ROFFX'//CSIDE,ROFFX)
      CALL UZRGET('RSIZEC'//CSLCT,RSIZE)
      CALL UZIGET('IROTCX'//CSIDE,IROTA)
      CALL UZIGET('INDEXL'//CSLCT,INDEX)
      CALL UZRGET('PAD1',PAD)
      CALL UZLGET('LBOUND',LBOUND)
      CALL UZLGET('LBMSG',LBMSG)
      ICENT=0

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        IF (LCHREQ(CSIDE,'B')) THEN
          POSY=UYMN
          IFLAG=-1
        ELSE
          POSY=UYMX
          IFLAG=+1
        END IF
      ELSE
        CALL UZRGET('UYUSER',POSY)
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      UX(1)=UXMN
      UX(2)=UXMX

      JROTA=MOD(IROTA+2,4)-2
      IF (JROTA.EQ.-2) THEN
        JROTA=0
      END IF

      NC=LENC(CTTL)
      CALL SZQTXW(CTTL,LCW,WXCH,WYCH)
      IF (JROTA.EQ.0) THEN
        RLC=WYCH
      ELSE
        RLC=WXCH
      END IF

      IC=JROTA*ICENT*IFLAG
      ROFFZ=ROFFX+RSIZE*(PAD+RLC*(1+IC)*0.5)*IFLAG
      ROFFX=ROFFX+RSIZE*(PAD+RLC)*IFLAG

      CALL UXPLBB(UX,CTTL,NC,2,POSY,ROFFZ,RSIZE,IROTA,ICENT,INDEX,
     +            PX,LBOUND,LBMSG)

      CALL UZRSET('ROFFX'//CSIDE,ROFFX)

      END

program marker

  use dcl
  integer,parameter :: nmax=100
  real :: x(nmax), y(nmax)

!-- �ǡ��� ----
    iseed = 1
    x(1) = 2.*(rngu2(iseed)-0.5)
    do n=2,nmax
      x(n)   = 2.*(rngu2(iseed)-0.5)
      y(n-1) = x(n)
    end do
    y(nmax) = x(1)

!-- ����� ----

    call DclOpenGraphics()
    call DclNewFrame

    call DclScalingPoint( x, y )
    call DclFitScalingParm
    call DclSetTransFunction

    call DclSetTitle( 'x-title', 'y-title', 'x-unit', 'y-unit' )
    call DclDrawScaledAxis

    call DclSetMarkerIndex( 5 )
    call DclSetMarkerSize( 0.015 )
    call DclDrawMarker( x(1:25), y(1:25) )
    call DclDrawMarker( x(26:50), y(26:50)  ,type=2 )
    call DclDrawMarker( x(51:75), y(51:75)  ,type=3 )
    call DclDrawMarker( x(75:100), y(76:100),type=4 )

    call DclCloseGraphics

end program

!-------------------------------------------------
!     interface module of slpack
!-------------------------------------------------
module sl_interface
    interface
!-----------------------------------------------------------------------
!主要ルーチン
        subroutine slinit(wxmax,wymax,fact) !初期化
              real,      intent(in) :: wxmax  !最大作画範囲(W座標)                            
              real,      intent(in) :: wymax       
              real,      intent(in) :: fact    !単位長と実長との比
        end subroutine

        subroutine slsize(csize)  !第1フレームの再設定
            character(len=3), intent(in) :: csize  !フレームの大きさと向き
        end subroutine

        subroutine slform(dxa,dya)  !第1フレームの再設定
            real,      intent(in) :: dxa       !フレームの横,縦の実長, 単位cm
            real,      intent(in) :: dya
        end subroutine

        subroutine sldiv(cform,ix,iy) !フレームの分割
            character(len=1), intent(in) :: cform  !方向を指定
            integer,   intent(in) :: ix          !X方向, Y方向の分割数
            integer,   intent(in) :: iy
        end subroutine

        subroutine slmgn(xl,xr,yb,yt)   !マージンの設定． 
            real,      intent(in) :: xl  !左辺，右辺，下辺，上辺のマージン
            real,      intent(in) :: xr
            real,      intent(in) :: yb
            real,      intent(in) :: yt
        end subroutine

        subroutine slrat(rx,ry)  !縦横比の設定．   
            real,      intent(in) :: rx  !フレームの縦横比を与える
            real,      intent(in) :: ry
        end subroutine

        subroutine slsttl(cttl,cside,px,py,ht,nt)  !タイトルの設定．        
            character(len=*), intent(in) :: cttl  !描く文字列
            character(len=1), intent(in) :: cside !文字列を描く場所
            real,      intent(in) :: px         !文字列の位置を-1.0から+1.0までの実数値で指定
            real,      intent(in) :: py        
            real,      intent(in) :: ht         !文字の高さ(R座標)
            integer,   intent(in) :: nt         !何番目の文字列かを指定する
        end subroutine
!--------------------------------------------------------------------
!作画境界
        subroutine slpvpr(index)  !ビューポートの枠を描く．
            integer,   intent(in) :: index  !線分のラインインデクス 
        end subroutine

        subroutine slpwwr(index)  !ウインドウの枠を描く
            integer,   intent(in) :: index  !線分のラインインデクス 
        end subroutine

        subroutine slpwvr(index)  !最大作画領域の枠を描く．
            integer,   intent(in) :: index    !線分のラインインデクス 
        end subroutine

        subroutine slpvpc(index,rc)  !ビューポートのコーナーマークを描く
            integer,   intent(in) :: index    !線分のラインインデクス 
            real,      intent(in) :: rc    !コーナーマークの長さ
        end subroutine                             

        subroutine slpwwc(index,rc)  !ウインドウのコーナーマークを描く
            integer,   intent(in) :: index    !線分のラインインデクス 
            real,      intent(in) :: rc     !コーナーマークの長さ
        end subroutine

        subroutine slpwvc(index,rc)  !最大作画領域のコーナーマークを描く．
            integer,   intent(in) :: index  !線分のラインインデクス 
            real,      intent(in) :: rc    !コーナーマークの長さ
        end subroutine

   end interface
end module

*-----------------------------------------------------------------------
      PROGRAM SLPK04

      REAL X(5), Y(5)
      CHARACTER USGI*3

      DATA X / -7.5, 7.5, 7.5, -7.5, -7.5/
      DATA Y / -7.5,-7.5, 7.5,  7.5, -7.5/

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)

      XMAXF = 26.
      YMAXF = 18.5
      CALL SLFORM(XMAXF, YMAXF)        ! <-- 鐃緒申鐃緒申的鐃緒申鐃術誌申鐃緒申鐃順き鐃緒申鐃緒申鐃緒申鐃緒申
      CALL SLRAT(XMAXF, YMAXF)

      CALL SGLSET('LFULL', .TRUE.)
      CALL SGFRM

      CALL SGSWND(-XMAXF/2., XMAXF/2., -YMAXF/2., YMAXF/2.)
      CALL SGSTRF
      CALL SGPLU(5, X, Y)
      CALL SGTXZU(0., 0., '15cm '//USGI(194)//' 15cm', 0.05, 0, 0, 3)

      CALL SGCLS

      END

program map01

  use dcl
  integer,parameter :: np=14
  integer,dimension(np) :: ntr = (/ &
    10,   11,   12,   13,   14,   15,   20, &
    21,   22,   23,   30,   31,   32,   33 /)
  real,dimension(np) :: fct = (/ &
    0.12, 0.12, 0.14, 0.14, 0.14, 0.14, 0.11, &
    0.16, 0.12, 0.12, 0.40, 0.12, 0.12, 0.17 /)
  character(len=32) :: cttl

    call DclOpenGraphics( -abs(DclSelectDevice()) )

    call DclSetAspectRatio( 2.0, 3.0 )
    call DclDivideFrame( 'y', 2, 3 )

    call DclSetParm( 'MAP:LGRIDMN', .false. )
    call DclSetParm( 'MAP:INDEXMJ', 1 )

    do i=1,np

      call DclNewFrame

      call DclSetParm( 'GRAPH:stlat1', 45.0 )
      call DclSetParm( 'GRAPH:stlat2', 30.0 )
      call DclSetParm( 'MAP:dgridmj', 30. )

      call DclSetSimilarity( fct(i), 0.0, 0.0 )
      call DclSetMapProjectionAngle( 0.0, 90.0, 0.0 )
      call DclSetViewPort( 0.1, 0.9, 0.1, 0.9 )
      if ( ntr(i)==30 ) then
        call DclSetMapProjectionWindow( -180.0, 180.0,   0.0, 90.0 )
      else
        call DclSetMapProjectionWindow( -180.0, 180.0, -90.0, 90.0 )
      end if
      call DclSetTransNumber( ntr(i) )
      call DclSetTransFunction

      call DclSetParm( 'GRAPH:LCLIP', .true. )
      call DclDrawDeviceWindowFrame( 1 )
      call DclDrawViewPortFrame( 1 )
      call DclTransNumToLong( ntr(i), cttl )
      call DclDrawTextProjected( 0.5, 0.95, cttl, height=0.03, index=3 )

      call DclDrawMap( 'coast_world' )
      call DclDrawGlobe()

      if ( ntr(i)==23 ) then
        call DclNewFrame
        call DclNewFrame
      end if

    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
      SUBROUTINE RFFTI1 (N,WA,IFAC)
      DIMENSION       WA(*)      ,IFAC(*)    ,NTRYH(4)
      EXTERNAL RFPI
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 2.0*RFPI()
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 110 K1=1,NFM1
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         DO 109 J=1,IPM
            LD = LD+L1
            I = IS
            ARGLD = FLOAT(LD)*ARGH
            FI = 0.
            DO 108 II=3,IDO,2
               I = I+2
               FI = FI+1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IS = IS+IDO
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END

*-----------------------------------------------------------------------
C     SUBROUTINE EZFFTB(N,R,AZERO,A,B,WSAVE)
C
C     SUBROUTINE EZFFTB COMPUTES A REAL PERODIC SEQUENCE FROM ITS
C     FOURIER COEFFICIENTS (FOURIER SYNTHESIS). THE TRANSFORM IS
C     DEFINED BELOW AT OUTPUT PARAMETER R. EZFFTB IS A SIMPLIFIED
C     BUT SLOWER VERSION OF RFFTB.
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE OUTPUT ARRAY R.  THE METHOD IS MOST
C             EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES.
C
C     AZERO   THE CONSTANT FOURIER COEFFICIENT
C
C     A,B     ARRAYS WHICH CONTAIN THE REMAINING FOURIER COEFFICIENTS
C             THESE ARRAYS ARE NOT DESTROYED.
C
C             THE LENGTH OF THESE ARRAYS DEPENDS ON WHETHER N IS EVEN OR
C             ODD.
C
C             IF N IS EVEN N/2    LOCATIONS ARE REQUIRED
C             IF N IS ODD (N-1)/2 LOCATIONS ARE REQUIRED
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             IN THE PROGRAM THAT CALLS EZFFTB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE EZFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY EZFFTF AND EZFFTB.
C
C
C     OUTPUT PARAMETERS
C
C     R       IF N IS EVEN DEFINE KMAX=N/2
C             IF N IS ODD  DEFINE KMAX=(N-1)/2
C
C             THEN FOR I=1,...,N
C
C                  R(I)=AZERO PLUS THE SUM FROM K=1 TO K=KMAX OF
C
C                  A(K)*COS(K*(I-1)*2*PI/N)+B(K)*SIN(K*(I-1)*2*PI/N)
C
C     ********************* COMPLEX NOTATION **************************
C
C             FOR J=1,...,N
C
C             R(J) EQUALS THE SUM FROM K=-KMAX TO K=KMAX OF
C
C                  C(K)*EXP(I*K*(J-1)*2*PI/N)
C
C             WHERE
C
C                  C(K) = .5*CMPLX(A(K),-B(K))   FOR K=1,...,KMAX
C
C                  C(-K) = CONJG(C(K))
C
C                  C(0) = AZERO
C
C                       AND I=SQRT(-1)
C
C     *************** AMPLITUDE - PHASE NOTATION ***********************
C
C             FOR I=1,...,N
C
C             R(I) EQUALS AZERO PLUS THE SUM FROM K=1 TO K=KMAX OF
C
C                  ALPHA(K)*COS(K*(I-1)*2*PI/N+BETA(K))
C
C             WHERE
C
C                  ALPHA(K) = SQRT(A(K)*A(K)+B(K)*B(K))
C
C                  COS(BETA(K))=A(K)/ALPHA(K)
C
C                  SIN(BETA(K))=-B(K)/ALPHA(K)
C
      SUBROUTINE EZFFTB (N,R,AZERO,A,B,WSAVE)
      DIMENSION       R(*)       ,A(*)       ,B(*)       ,WSAVE(*)
C
      IF (N-2) 101,102,103
  101 R(1) = AZERO
      RETURN
  102 R(1) = AZERO+A(1)
      R(2) = AZERO-A(1)
      RETURN
  103 NS2 = (N-1)/2
      DO 104 I=1,NS2
         R(2*I) = .5*A(I)
         R(2*I+1) = -.5*B(I)
  104 CONTINUE
      R(1) = AZERO
      IF (MOD(N,2) .EQ. 0) R(N) = A(NS2+1)
      CALL RFFTB (N,R,WSAVE(N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHON2

      PARAMETER( NMAX=40, IMAX=4 )
      REAL X(0:NMAX), Y(0:NMAX,IMAX)

      DT = 4.* 3.14159 / NMAX
      DO 20 N=0,NMAX
        X(N) = REAL(N)/REAL(NMAX)
        DO 10 I=1,IMAX
          Y(N,I) = 0.2*SIN(N*DT) + 1. - 0.2*I
   10   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )

*-- ラインインデクス: frame 1 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPLV( NMAX+1, X, Y(0,1) )

      DO 30 I=2,IMAX
        CALL SGSPLI( 2*I )
        CALL SGPLV( NMAX+1, X, Y(0,I) )
   30 CONTINUE

      CALL SGSPLI( 1 )

*-- ラインタイプ: frame 2 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPLV( NMAX+1, X, Y(0,1) )

      DO 40 I=2,IMAX
        CALL SGSPLT( I )
        CALL SGPLV( NMAX+1, X, Y(0,I) )
   40 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UMIQNP / UMIQID / UMIQCP / UMIQVL / UMISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 11)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'INDEXMJ ' /, IX( 1) /    3 /
      DATA      CPARAS( 2) / 'INDEXMN ' /, IX( 2) /    1 /
      DATA      CPARAS( 3) / 'ITYPEMJ ' /, IX( 3) /    1 /
      DATA      CPARAS( 4) / 'ITYPEMN ' /, IX( 4) /    3 /
      DATA      CPARAS( 5) / 'INDEXBND' /, IX( 5) /    3 /
      DATA      CPARAS( 6) / 'MAXBND  ' /, IX( 6) /  300 /
      DATA      CPARAS( 7) / 'IGROUP  ' /, IX( 7) /    1 /
      DATA      CPARAS( 8) / 'INDEXOUT' /, IX( 8) /    1 /
      DATA      CPARAS( 9) / 'ITYPEOUT' /, IX( 9) /    1 /
      DATA      CPARAS(10) / 'IPATLAND' /, IX(10) / 1999 /
      DATA      CPARAS(11) / 'IPATLAKE' /, IX(11) / 9999 /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'MAP_MAJOR_LINE_INDEX' /
      DATA      CPARAL( 2) / 'MAP_MINOR_LINE_INDEX' /
      DATA      CPARAL( 3) / 'MAP_MAJOR_LINE_TYPE' /
      DATA      CPARAL( 4) / 'MAP_MINOR_LINE_TYPE' /
      DATA      CPARAL( 5) / 'MAP_BOUNDARY_INDEX' /
      DATA      CPARAL( 6) / 'MAP_BOUNDARY_LINE_MAX' /
      DATA      CPARAL( 7) / '****IGROUP  ' /
      DATA      CPARAL( 8) / 'MAP_OUTLINE_INDEX' /
      DATA      CPARAL( 9) / 'MAP_OUTLINE_TYPE' /
      DATA      CPARAL(10) / 'SHADE PATTERN ON LAND' /
      DATA      CPARAL(11) / 'SHADE PATTERN ON LAKE' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UMIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UMIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UMIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UM', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','UMIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UM', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','UMISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!     interface module of swpack
!-------------------------------------------------
module sw_interface
    interface
!--------------------------------------------------------------
!コントロールルーチン
        subroutine swdopn()  !デバイスのオープン
        end subroutine

        subroutine swdcls()  !デバイスのクローズ
        end subroutine

        subroutine swpopn()  !ページのオープン 
        end subroutine
                             
        subroutine swpcls()  !ページのクローズ 
        end subroutine

        subroutine swoopn(cobj,comm)  !オブジェクトのオープン 
            character(len=*), intent(in) :: cobj  !オブジェクト名
            character(len=*), intent(in) :: comm  !コメント
        end subroutine
                              
        subroutine swocls(cobj) !オブジェクトのクローズ  
            character(len=*), intent(in) :: cobj  !オブジェクト名
        end subroutine

        subroutine swpget(cp,ipara) ! 内部変数参照   
            character(len=*), intent(in) :: cp      !内部変数の名前
            integer,   intent(out) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swiget(cp,ipara)
            character(len=*), intent(in) :: cp      !内部変数の名前
            integer,   intent(out) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swrget(cp,ipara)
            character(len=*), intent(in) :: cp      !内部変数の名前
            real,      intent(out) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swlget(cp,ipara)
            character(len=*), intent(in) :: cp      !内部変数の名前
            logical,   intent(out) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine
                           
        subroutine swpset(cp,ipara)  !内部変数設定 
            character(len=*), intent(in) :: cp      !内部変数の名前
            integer,   intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swiset(cp,ipara)
            character(len=*), intent(in) :: cp      !内部変数の名前
            integer,   intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swrset(cp,ipara)
            character(len=*), intent(in) :: cp      !内部変数の名前
            real,      intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swlset(cp,ipara)
            character(len=*), intent(in) :: cp      !内部変数の名前
            logical,   intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine
                             
        subroutine swpstx(cp,ipara) !内部変数の設定 
            character(len=*), intent(in) :: cp      !内部変数の名前
            integer,   intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swistx(cp,ipara) 
            character(len=*), intent(in) :: cp      !内部変数の名前
            integer,   intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swrstx(cp,ipara) 
            character(len=*), intent(in) :: cp      !内部変数の名前
            real,      intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine

        subroutine swlstx(cp,ipara) 
            character(len=*), intent(in) :: cp      !内部変数の名前
            logical,   intent(in) :: ipara          !(整数・実数・論理型の）内部変数の値
        end subroutine
                         
        subroutine swcget(cp,cpara)    !文字型内部変数参照 
            character(len=*), intent(in) :: cp        !内部変数の名前
            character(len=*), intent(out) :: cpara  !(文字型の）内部変数の値
        end subroutine
                              
        subroutine swcset(cp,cpara)!文字型内部変数設定
            character(len=*), intent(in) :: cp       !内部変数の名前
            character(len=*), intent(in) :: cpara   !(文字型の）内部変数の値
        end subroutine

        subroutine  swcstx(cp,cpara)!文字型内部変数の設定
            character(len=*), intent(in) :: cp       !内部変数の名前
            character(len=*), intent(in) :: cpara    !(文字型の）内部変数の値
        end subroutine

        subroutine  swpqnp(ncp)
            integer,   intent(out) :: ncp
        end subroutine

        subroutine  swpqid(cp,idx)
            character(len=*), intent(in) :: cp
            integer,   intent(out) :: idx
        end subroutine

        subroutine  swpqcp(idx,cp)
            integer,   intent(in) :: idx
            character(len=*), intent(out) :: cp
        end subroutine

        subroutine  swpqvl(idx,cp)
            integer,   intent(in) :: idx
            character(len=*), intent(out) :: cp
        end subroutine

        subroutine  swpsvl(idx,cp)
            integer,   intent(in) :: idx
            character(len=*), intent(out) :: cp
        end subroutine

        subroutine  swcqnp(ncp)
            integer,   intent(out) :: ncp
        end subroutine

        subroutine  swcqid(cp,idx)
            character(len=*), intent(in) :: cp
            integer,   intent(out) :: idx
        end subroutine

        subroutine  swcqcp(idx,cp)
            integer,   intent(in) :: idx
            character(len=*), intent(out) :: cp
        end subroutine

        subroutine  swcqvl(idx,cval)
            integer,   intent(in) :: idx
            character(len=*), intent(out) :: cval
        end subroutine

        subroutine  swcsvl(idx,cval)
            integer,   intent(in) :: idx
            character(len=*), intent(out) :: cval
        end subroutine
!------------------------------------------------------------------------------------
!     描画ルーチン
        subroutine swswdi(iwdidx)  !線幅指定 
            integer,   intent(in) :: iwdidx         !線分の太さに関するインデクス
        end subroutine
                             
        subroutine swscli(iclidx)  !線色指定 
            integer,   intent(in) :: iclidx         !線分の色に関するインデクス
        end subroutine
                             
        subroutine swgopn()!プリミティブのオープン 
        end subroutine
                              
        subroutine swgcls()!プリミティブのクローズ 
        end subroutine
                            
        subroutine swgmov(wx,wy) ! ペンアップ
            real,      intent(in) :: wx             !ワークステーション座標
            real,      intent(in) :: wy
        end subroutine
                             
        subroutine swgplt(wx,wy) !ペンダウン
            real,      intent(in) :: wx             !ワークステーション座標
            real,      intent(in) :: wy
        end subroutine
                              
        subroutine swgton(np,wpx,wpy,itpat)  !ハードフィル
            integer,   intent(in) :: np               !配列WPX,WPYの大きさ
            real,      intent(in), dimension(*) :: wpx       !塗りつぶす領域の境界のX座標
            real,      intent(in), dimension(*) :: wpy       !塗りつぶす領域の境界のY座標
            integer,   intent(in) :: itpat                   !塗りつぶしパターン番号
        end subroutine
  
        subroutine swiopn(iwx,iwy,imw,imh)  !イメージオープン                            
            integer,   intent(in) :: iwx  !イメージの左上の座標
            integer,   intent(in) :: iwy
            integer,   intent(in) :: imw  !イメージの大きさ
            integer,   intent(in) :: imh
        end subroutine
                            
        subroutine swidat(image,nlen)  ! イメージデータ  
            integer,   intent(in) :: image       !イメージデータ
            integer,   intent(in) :: nlen       !イメージデータの長さ
        end subroutine
                           
        subroutine swicls()  !イメージクローズ  
        end subroutine
!---------------------------------------------------------------------------------
!     マウス
        subroutine swqpnt(wx,wy,mb)  !マウスポイント取得 
            real,      intent(out) :: wx    !マウスポイントの位置
            real,      intent(out) :: wy
            integer,   intent(out) :: mb    !ボタンの種類
        end subroutine

        subroutine swfint(wx,wy,iwx,iwy)  !ワークステーション座標からイメージ座標への変換  
            real,      intent(inout) :: wx       !ワークステーション座標
            real,      intent(inout) :: wy
            integer,   intent(inout) :: iwx       !イメージ座標
            integer,   intent(inout) :: iwy
        end subroutine
                              
        subroutine swiint(iwx,iwy,wx,wy) !イメージ座標からワークステーション座標への変換 
            real,      intent(inout) :: wx      !イメージ座標
            real,      intent(inout) :: wy
            integer,   intent(inout) :: iwx      !ワークステーション座標
            integer,   intent(inout) :: iwy
        end subroutine
!------------------------------------------------------------------------------------
!問い合わせなど
        subroutine swqwdc(lwd)  !線幅可変能力の取得  
            logical,   intent(out) :: lwd   !線幅を変える能力がある時 .TRUE. 
        end subroutine
                             
        subroutine swqclc(lcl)  !線色可変能力の取得
            logical,   intent(out) :: lcl    !線色を変える能力がある時 .TRUE. 
        end subroutine
                              
        subroutine swqtnc(ltn) !hard fill 能力の取得
            logical,   intent(out) :: ltn     !ハードフィルを行う能力がある時 .TRUE. 
        end subroutine
 
        subroutine swqimc(lim)  !イメージ描画能力の取得                             
            logical,   intent(out) :: lim     !イメージ描画を行う能力がある時 .TRUE. 
        end subroutine
                             
        subroutine swqptc(lpt) !ポインティング能力の取得 
            logical,   intent(out) :: lpt     !マウスポイントの位置を調べる能力がある時 .TRUE. 
        end subroutine
                               
        subroutine swqfnm(cpara,cfname) !各種データベースファイル名の取得
            character(len=*), intent(in) :: cpara     !データベース名を示す内部変数名
            character(len=*), intent(out) :: cfname     !データベースファイル名
        end subroutine
                              
        subroutine swqrct(xmin,xmax,ymin,ymax,fact)  !最大作画領域取得
            real,      intent(out) :: xmin  !作画領域の左下のX座標． 
            real,      intent(out) :: xmax  !作画領域の右上のX座標． 
            real,      intent(out) :: ymin  !作画領域の左下のY座標． 
            real,      intent(out) :: ymax  !作画領域の右上のY座標． 
            real,      intent(out) :: fact  !座標系の1単位の長さ(cm). 
        end subroutine
                             
        subroutine swsrot(iwtrot) !画面の回転指定  
            integer,   intent(in) :: iwtrot     !1 :正立; 2 :90度回転
        end subroutine
  end interface
end module                                                

*-----------------------------------------------------------------------
*     TONE PATTERN ATTRIBUTE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZSTNI(ITPAT)

      PARAMETER (MAXCLI=100)

      INTEGER   ICPAT(MAXCLI)
      LOGICAL   LFRST,LTNATR,LCLATR,LSOFTF,LHARD,LCL2TN,LMONOF,LMSG
      CHARACTER CMSG*80

      SAVE

      DATA      LFRST/.TRUE./, LMSG/.TRUE./


*     / INITIALIZE /

      ITPATZ=ITPAT
      CALL SGIGET('IBGCLI',IBGCLI)
      CALL SGIGET('IFCIDX',IFCIDX)

      IF (LFRST) THEN

        CALL SWQTNC(LTNATR)
        CALL SWQCLC(LCLATR)

        CALL SGLGET('LCL2TN',LCL2TN)

        IF (LCL2TN) THEN
          LMONOF=.TRUE.
        ELSE
          IF (LCLATR) THEN
            LMONOF=.FALSE.
          ELSE
            LMONOF=.TRUE.
          END IF
        END IF

        IF (LMONOF) THEN
          CALL SZCLTN(ICPAT, MAXCLI)
          CALL MSGDMP('M','SZSTNI',
     +         'COLOR TO TONE CONVERSION TABLE IS USED.')
        END IF

        LFRST=.FALSE.

      END IF

*     / SOFT FILL OR HARD FILL (FORCE TO SOFT FILL) /

      CALL SGLGET('LSOFTF',LSOFTF)

      LHARD=.FALSE.
      IF (LSOFTF) THEN
      ELSE
        LSOFTF=.TRUE.
        LHARD=.FALSE.
        IF (LMSG) THEN
          CALL MSGDMP('W','SZSTNI','HARD FILL IS OBSOLETE.SOFT FILLED')
          LMSG=.FALSE.
        END IF
      END IF

*     / COLOR TO TONE CONVERSION /

      IF (LMONOF) THEN
        LP=MOD(ITPATZ,1000)
        LC=ITPATZ/1000
        IF (LP.EQ.999 .AND. LC.NE.IBGCLI) THEN
          IF (1.LE.LC .AND. LC.LE.MAXCLI) THEN
            IF (ICPAT(LC).GE.0) THEN
              ITPATZ=ICPAT(LC)
            ELSE
              CMSG='COLOR NUMBER ## IS NOT DEFINED IN CL2TNMAP.'
              CALL CHNGI(CMSG,'##',LC,'(I2)')
              CALL MSGDMP('W','SWGTON',CMSG)
            END IF
          ELSE IF(LC.EQ.999)THEN
          ELSE
            CMSG='COLOR NUMBER ## IS NOT DEFINED IN CL2TNMAP.'
            CALL CHNGI(CMSG,'##',LC,'(I2)')
            CALL MSGDMP('W','SWGTON',CMSG)
          END IF
        END IF
      END IF

      ITCLIY=ITPATZ/1000
      ITPNMY=MOD(ITPATZ,1000)
      IF (ITCLIY.EQ.IBGCLI) THEN
        ITPATY=ITPNMY
      ELSE
        IF (ITCLIY.EQ.0) THEN
          ITCLIY=1
        END IF
        ITPATY=ITPNMY+ITCLIY*1000
      END IF

      IF ((ITPNMY .EQ. IFCIDX).OR.(ITPNMY .EQ. 999)) THEN
        LHARD=.TRUE.
      END IF
      CALL SZSTMD(LHARD)

      IF (LHARD) THEN
        CALL SZTITZ(ITPATZ)
      ELSE
        CALL SZTITS(ITPATY)
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQTNI(ITPAT)

      ITPAT=ITPATY

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DATE04

      CHARACTER CFORM*24


      WRITE(*,*) '*** TEST FOR CHARACTER DATE & DATE INQUIRY'
      WRITE(*,*) '*** TYPE-1'
      CFORM='YYYY,MM,DD'
      WRITE(*,*) 'CFORM = ',CFORM
      CALL DATEQ1(IDATE)
      CALL DATEC1(CFORM,IDATE)
      WRITE(*,*) 'AFTER CALLING DATEQ1(IDATE)'
      WRITE(*,*) '    AND       DATEC1(CFORM,IDATE)'
      WRITE(*,*) 'CFORM = ',CFORM
      WRITE(*,*) '*** TYPE-2'
      CFORM='CCCCCCCCC DD,YYYY'
      WRITE(*,*) 'CFORM = ',CFORM
      CALL DATEQ2(IY,ITD)
      CALL DATEC2(CFORM,IY,ITD)
      WRITE(*,*) 'AFTER CALLING DATEQ2(IY,ITD)'
      WRITE(*,*) '    AND       DATEC2(CFORM,IY,ITD)'
      WRITE(*,*) 'CFORM = ',CFORM
      WRITE(*,*) '*** TYPE-3'
      CFORM='YY/MM/DD (WWW)'
      WRITE(*,*) 'CFORM = ',CFORM
      CALL DATEQ3(IY,IM,ID)
      CALL DATEC3(CFORM,IY,IM,ID)
      WRITE(*,*) 'AFTER CALLING DATEQ3(IY,IM,ID)'
      WRITE(*,*) '    AND       DATEC3(CFORM,IY,IM,ID)'
      WRITE(*,*) 'CFORM = ',CFORM

      END

!-------------------------------------------------
!  SGpack Module
!-------------------------------------------------
module sgpack
  use dcl_common

  interface DclDrawLine
    module procedure DclDrawLine1, DclDrawLine2
  end interface  

  interface DclDrawLineNormalized
    module procedure DclDrawLineNormalized1, DclDrawLineNormalized2
  end interface  

  interface DclDrawLineProjected
    module procedure DclDrawLineProjected1, DclDrawLineProjected2
  end interface  

  private :: DclDrawLine1,           DclDrawLine2
  private :: DclDrawLineNormalized1, DclDrawLineNormalized2
  private :: DclDrawLineProjected1,  DclDrawLineProjected2

  contains
!---------------------------------------------------------
    subroutine DclPrintDeviceList() !ワークステーション名のリスト
      call prcopn('DclPrintDeviceList')
      call sgpwsn()
      call prccls('DclPrintDeviceList')
    end subroutine
!------------------------------------------------------------------------
!正規化変換
!---------------------------------
    subroutine DclTransShortToLong(short,long) !略称から名称を求める．
      character(len=*), intent(in)  :: short 
      character(len=*), intent(out) :: long

      call prcopn('DclTransShortToLong')
      call sgtrsl(short,long) 
      call prccls('DclTransShortToLong')
    end subroutine
!---------------------------------
    subroutine DclTransShortToNum(short,num) !略称から変換関数番号を求める．
      character(len=*), intent(in)  :: short 
      integer,          intent(out) :: num

      call prcopn('DclTransShortToNum')
      call sgtrsn(short,num)
      call prccls('DclTransShortToNum')
    end subroutine
!---------------------------------
    subroutine DclTransLongToShort(long,short) !名称から略称を求める．
      character(len=*), intent(in)  :: long
      character(len=*), intent(out) :: short 

      call prcopn('DclTransLongToShort')
      call sgtrls(long,short)
      call prccls('DclTransLongToShort')
    end subroutine
!---------------------------------
    subroutine DclTransLongToNum(long,num) !名称から変換関数番号を求める．
      character(len=*), intent(in)  :: long
      integer,          intent(out) :: num

      call prcopn('DclTransLongToNum')
      call sgtrln(long,num)
      call prccls('DclTransLongToNum')
    end subroutine
!---------------------------------
    subroutine DclTransNumToShort(num,short) !変換関数番号から略称を求める．
      integer,          intent(in)  :: num
      character(len=*), intent(out) :: short

      call prcopn('DclTransNumToShort')
      call sgtrns(num,short)
      call prccls('DclTransNumToShort')
    end subroutine
!---------------------------------
    subroutine DclTransNumToLong(num,long) !変換関数番号から名称を求める．
      integer,          intent(in) :: num
      character(len=*), intent(out) :: long

      call prcopn('DclTransNumToLong')
      call sgtrnl(num,long)
      call prccls('DclTransNumToLong')
    end subroutine
!---------------------------------
    subroutine DclGetViewPort(xmin, xmax, ymin, ymax) 
      real, intent(out), optional :: xmin, xmax, ymin, ymax !ビューポート

      call prcopn('DclGetViewPort')
      call sgqvpt(xmin0, xmax0, ymin0, ymax0) 
      if(present(xmin)) xmin = xmin0
      if(present(xmax)) xmax = xmax0
      if(present(ymin)) ymin = ymin0
      if(present(ymax)) ymax = ymax0
      call prccls('DclGetViewPort')
    end subroutine
!---------------------------------
    subroutine DclGetWindow(xmin, xmax, ymin, ymax) 
      real, intent(out), optional :: xmin, xmax, ymin, ymax !ウインドウ

      call prcopn('DclGetWindow')
      call sgqwnd(xmin0, xmax0, ymin0, ymax0) 
      if(present(xmin)) xmin = xmin0
      if(present(xmax)) xmax = xmax0
      if(present(ymin)) ymin = ymin0
      if(present(ymax)) ymax = ymax0
      call prccls('DclGetWindow')
    end subroutine
!---------------------------------
    subroutine DclGetSimilarity(factor, xoffset, yoffset)  
      real, intent(out), optional :: factor, xoffset, yoffset

      call prcopn('DclGetSimilarity')
      call sgqsim(factor0, xoff0, yoff0) 
      if(present(factor))  factor  = factor0 
      if(present(xoffset)) xoffset = xoff0 
      if(present(yoffset)) yoffset = yoff0 
      call prccls('DclGetSimilarity')
    end subroutine
!---------------------------------
    subroutine DclGetMapProjectionAngle(longitude,latitude,rotation)  
      real, intent(out), optional :: longitude,latitude,rotation 
      real                        :: lon, lat, rot

      call prcopn('DclGetMapProjectionAngle')
      call sgqmpl(lon, lat, rot)
      if(present(longitude)) longitude = lon
      if(present(latitude )) latitude  = lat
      if(present(rotation )) rotation  = rot
      call prccls('DclGetMapProjectionAngle')
    end subroutine
!---------------------------------
    function DclGetTransNumber() 
      integer :: DclGetTransNumber     !変換関数番号

      call prcopn('DclGetTransNumber')
      call sgqtrn(DclGetTransNumber) 
      call prccls('DclGetTransNumber')
    end function
!------------------------------------------------------------------------
!ポリラインプリミティブ
!---------------------------------
    subroutine DclDrawLine1 (x,y,type,index)  !折れ線を描く．
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional     :: type, index
      integer                             :: type0, index0
      
        call sgoopn('DclDrawLine', ' ')
        if(present(type))  then ; type0 = type
                           else ; call sgqplt(type0)
        end if
        
        if(present(index)) then ; index0 = index
                           else ; call sgqpli(index0)
        end if

        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclDrawLine', 'Length of x and y don''t match.')
        n = min(nx, ny)
        call sgplzu(n,x,y,type0,index0)
        call sgocls('DclDrawLine')
        
    end subroutine

!---------------------------------
    subroutine DclDrawLine2 (x1,y1,x2,y2,type,index)  !折れ線を描く．
      real,      intent(in)               :: x1, y1, x2, y2
      integer,   intent(in), optional     :: type, index
      integer                             :: type0, index0
      real,      dimension(2)             :: x, y
      
        call sgoopn('DclDrawLine', ' ')
        if(present(type))  then ; type0 = type
                           else ; call sgqplt(type0)
        end if
        
        if(present(index)) then ; index0 = index
                           else ; call sgqpli(index0)
        end if

        x(1) = x1 ; y(1) = y1
        x(2) = x2 ; y(2) = y2

        call sgplzu(2,x,y,type0,index0)
        call sgocls('DclDrawLine')
        
    end subroutine

!---------------------------------
    subroutine DclDrawLineNormalized1(x, y, type, index)
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional     :: type, index
      integer                             :: type0, index0
      
        call sgoopn('DclDrawLineNormalized', ' ')
        if(present(type))  then ; type0 = type
                           else ; call sgqplt(type0)
        end if
        
        if(present(index)) then ; index0 = index
                           else ; call sgqpli(index0)
        end if

        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclDrawLineNormalized', &
                           & 'Length of x and y don''t match.')
        n = min(nx, ny)

        call sgplzv(n, x, y, type0, index0)
        call sgocls('DclDrawLineNormalized')
    end subroutine
!---------------------------------
    subroutine DclDrawLineNormalized2(x1, y1, x2, y2, type, index)
      real,      intent(in)            :: x1, y1, x2, y2
      integer,   intent(in), optional  :: type, index
      integer                          :: type0, index0
      real,      dimension(2)          :: x, y
      
        call sgoopn('DclDrawLineNormalized', ' ')
        if(present(type))  then ; type0 = type
                           else ; call sgqplt(type0)
        end if
        
        if(present(index)) then ; index0 = index
                           else ; call sgqpli(index0)
        end if

        x(1) = x1 ; y(1) = y1
        x(2) = x2 ; y(2) = y2

        call sgplzv(2, x, y, type0, index0)
        call sgocls('DclDrawLineNormalized')
    end subroutine
!---------------------------------
    subroutine DclDrawLineProjected1(x,y,type,index)
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional     :: type, index
      integer                             :: type0, index0
      
        call sgoopn('DclDrawLineProjected', ' ')
        if(present(type))  then ; type0 = type
                           else ; call sgqplt(type0)
        end if
        
        if(present(index)) then ; index0 = index
                           else ; call sgqpli(index0)
        end if

        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclDrawLineProjected', &
                           & 'Length of x and y don''t match.')
        n = min(nx, ny)

        call sgplzr(n, x, y, type0, index0)
        call sgocls('DclDrawLineProjected')
    end subroutine
!---------------------------------
    subroutine DclDrawLineProjected2(x1,y1,x2,y2,type,index)
      real,    intent(in)           :: x1, y1, x2, y2
      integer, intent(in), optional :: type, index
      integer                       :: type0, index0
      real,    dimension(2)         :: x, y
      
        call sgoopn('DclDrawLineProjected', ' ')
        if(present(type))  then ; type0 = type
                           else ; call sgqplt(type0)
        end if
        
        if(present(index)) then ; index0 = index
                           else ; call sgqpli(index0)
        end if

        x(1) = x1 ; y(1) = y1
        x(2) = x2 ; y(2) = y2

        call sgplzr(2, x, y, type0, index0)
        call sgocls('DclDrawLineProjected')
    end subroutine
!---------------------------------
    subroutine DclSetLineType(type)  !ラインタイプを設定する．   
      integer, intent(in) :: type    !線種

      call prcopn('DclSetLineType')
      call sgsplt(type)
      call prccls('DclSetLineType')
    end subroutine
!---------------------------------
    subroutine DclSetLineIndex(index)  !ラインインデクスの設定．   
      integer,   intent(in) :: index    !ラインインデクス 

      call prcopn('DclSetLineIndex')
      call sgspli(index)
      call prccls('DclSetLineIndex')
    end subroutine
!---------------------------------
    subroutine DclSetLineText(text)  !ラベルの文字列設定．  
      character(len=*), intent(in) :: text  !描く文字列（初期値は'A')

      call prcopn('DclSetLineText')
      call sgsplc(text)
      call prccls('DclSetLineText')
    end subroutine
!---------------------------------
    subroutine DclSetLineTextSize(height)  !ラベルの文字高設定  
      real, intent(in) :: height  !文字列の高さ

      call prcopn('DclSetLineTextSize')
      call sgspls(height)
      call prccls('DclSetLineTextSize')
    end subroutine
!---------------------------------
    subroutine DclNextLineText()  !ラベルの最後の文字番号を増やす．

      call prcopn('DclNextLineText')
      call sgnplc()
      call prccls('DclNextLineText')
    end subroutine
!---------------------------------
    function DclGetLineType()  
      integer :: DclGetLineType 

      call prcopn('DclGetLineType')
      call sgqplt(DclGetLineType)
      call prccls('DclGetLineType')
    end function
!---------------------------------
    function DclGetLineIndex() 
      integer :: DclGetLineIndex

      call prcopn('DclGetLineIndex')
      call sgqpli(DclGetLineIndex) 
      call prccls('DclGetLineIndex')
    end function
!---------------------------------
    subroutine DclGetLineText(text)   
      character(len=*), intent(out) :: text !描く文字列（初期値は'A')

      call prcopn('DclGetLineText')
      call sgqplc(text) 
      call prccls('DclGetLineText')
    end subroutine
!---------------------------------
    function DclGetLineTextSize()   
      real :: DclGetLineTextSize

      call prcopn('DclGetLineTextSize')
      call sgqpls(DclGetLineTextSize)   
      call prccls('DclGetLineTextSize')
    end function
!------------------------------------------------------------------------------
! ポリマーカープリミティブ
!---------------------------------
    subroutine DclDrawMarker(x,y,type,index,height)
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional     :: type, index
      real,      intent(in), optional     :: height

      integer                             :: type0, index0
      real                                :: height0
        
        call sgoopn('DclDrawMarker', ' ')
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclDrawMarker', 'Length of x and y don''t match.')
        n = min(nx, ny)

        if(present(type)  ) then ; type0 = type
                            else ; call sgqpmt(type0)
        end if
        
        if(present(index) ) then ; index0 = index
                            else ; call sgqpmi(index0)
        end if
        
        if(present(height)) then ; height0 = height
                            else ; call sgqpms(height0)
        end if
        
        call sgpmzu(n,x,y,type0,index0, height0)
        call sgocls('DclDrawMarker')
    end subroutine
!---------------------------------
    subroutine DclDrawMarkerNormalized(x, y, type, index, height) 

      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional     :: type, index
      real,      intent(in), optional     :: height

      integer                             :: type0, index0
      real                                :: height0
        
        call sgoopn('DclDrawMarkerNormalized', ' ')
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclDrawMarkerNormalized', &
                               & 'Length of x and y don''t match.')
        n = min(nx, ny)

        if(present(type)  ) then ; type0 = type
                            else ; call sgqpmt(type0)
        end if
        
        if(present(index) ) then ; index0 = index
                            else ; call sgqpmi(index0)
        end if
        
        if(present(height)) then ; height0 = height
                            else ; call sgqpms(height0)
        end if
        
        call sgpmzv(n,x,y,type0,index0, height0)
        call sgocls('DclDrawMarkerNormalized')

    end subroutine
!---------------------------------
    subroutine DclDrawMarkerProjected(x, y, type, index, height)

      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional     :: type, index
      real,      intent(in), optional     :: height

      integer                             :: type0, index0
      real                                :: height0
        
        call sgoopn('DclDrawMarkerProjected', ' ')
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclDrawMarkerProjected', &
                               & 'Length of x and y don''t match.')
        n = min(nx, ny)

        if(present(type)  ) then ; type0 = type
                            else ; call sgqpmt(type0)
        end if
        
        if(present(index) ) then ; index0 = index
                            else ; call sgqpmi(index0)
        end if
        
        if(present(height)) then ; height0 = height
                            else ; call sgqpms(height0)
        end if
        
        call sgpmzr(n,x,y,type0,index0, height0)
        call sgocls('DclDrawMarkerProjected')

    end subroutine
!---------------------------------
    subroutine DclSetMarkerType(type)  !マーカータイプの設定．    
      integer, intent(in) :: type    !マーカータイプ

      call prcopn('DclSetMarkerType')
      call sgspmt(type)
      call prccls('DclSetMarkerType')
    end subroutine
!---------------------------------
    subroutine DclSetMarkerIndex(index)  !マーカーのラインインデクスの設定  
      integer,   intent(in) :: index     !ラインインデクス 

      call prcopn('DclSetMarkerIndex')
      call sgspmi(index)
      call prccls('DclSetMarkerIndex')
    end subroutine
!---------------------------------
    subroutine DclSetMarkerSize(height)   !マーカーの大きさ設定．     
      real,    intent(in) :: height    !マーカーの大きさ

      call prcopn('DclSetMarkerSize')
      call sgspms(height) 
      call prccls('DclSetMarkerSize')
    end subroutine
!---------------------------------
    function DclGetMarkerType()  
      integer :: DclGetMarkerType     !マーカータイプ

      call prcopn('DclGetMarkerType')
      call sgqpmt(DclGetMarkerType) 
      call prccls('DclGetMarkerType')
    end function
!---------------------------------
    function DclGetMarkerIndex()
      integer :: DclGetMarkerIndex     !ラインインデクス 

      call prcopn('DclGetMarkerIndex')
      call sgqpmi(DclGetMarkerIndex)
      call prccls('DclGetMarkerIndex')
    end function
!---------------------------------
    function DclGetMarkerSize()
      real :: DclGetMarkerSize     !マーカーの大きさ

      call prcopn('DclGetMarkerSize')
      call sgqpms(DclGetMarkerSize)
      call prccls('DclGetMarkerSize')
    end function
!------------------------------------------------------------------
!     テキスト
!---------------------------------
    subroutine DclDrawText(x, y, text, height, angle, centering, index) 
      real,             intent(in) :: x, y          !文字の位置
      character(len=*), intent(in) :: text          !文字列
      real,             intent(in) :: height, angle !文字の高さ
      integer,          intent(in) :: centering,index

      optional :: height, angle, centering,index

      real    :: height0
      integer :: angle0, cent0, index0

        call sgoopn('DclDrawText', ' ')
        if(present(height))    then ; height0 = height
                               else ; call sgqtxs(height0)
        end if

        if(present(angle) )    then ; angle0 = nint(angle)
                               else ; call sgqtxr(angle0)
        end if

        if(present(centering)) then ; cent0 = centering
                               else ; call sgqtxc(cent0)
        end if
        
        if(present(index) )    then ; index0 = index
                               else ; call sgqtxi(index0)
        end if

        call sgtxzu(x,y,text,height0,angle0,cent0,index0) 
        call sgocls('DclDrawText')
    end subroutine
!---------------------------------
    subroutine DclDrawTextNormalized(x, y, text, height, angle, centering, index)

      real,             intent(in) :: x, y          !文字の位置
      character(len=*), intent(in) :: text          !文字列
      real,             intent(in) :: height, angle !文字の高さ
      integer,          intent(in) :: centering,index

      optional :: height, angle, centering,index

      real    :: height0
      integer :: angle0, cent0, index0

        call sgoopn('DclDrawTextNormalized', ' ')
        if(present(height))    then ; height0 = height
                               else ; call sgqtxs(height0)
        end if

        if(present(angle) )    then ; angle0 = nint(angle)
                               else ; call sgqtxr(angle0)
        end if

        if(present(centering)) then ; cent0 = centering
                               else ; call sgqtxc(cent0)
        end if
        
        if(present(index) )    then ; index0 = index
                               else ; call sgqtxi(index0)
        end if

        call sgtxzv(x,y,text,height0,angle0,cent0,index0) 
        call sgocls('DclDrawTextNormalized')
    end subroutine
!---------------------------------
    subroutine DclDrawTextProjected(x, y, text, height, angle, centering, index)

      real,             intent(in) :: x, y          !文字の位置
      character(len=*), intent(in) :: text          !文字列
      real,             intent(in) :: height, angle !文字の高さ
      integer,          intent(in) :: centering,index

      optional :: height, angle, centering,index

      real    :: height0 
      integer :: angle0, cent0, index0

        call sgoopn('DclDrawTextProjected', ' ')
        if(present(height))    then ; height0 = height
                               else ; call sgqtxs(height0)
        end if

        if(present(angle) )    then ; angle0 = nint(angle)
                               else ; call sgqtxr(angle0)
        end if

        if(present(centering)) then ; cent0 = centering
                               else ; call sgqtxc(cent0)
        end if
        
        if(present(index) )    then ; index0 = index
                               else ; call sgqtxi(index0)
        end if

        call sgtxzr(x,y,text,height0,angle0,cent0,index0) 
        call sgocls('DclDrawTextProjected')
    end subroutine
!---------------------------------
    subroutine DclSetTextHeight(height)  !文字の高さ設定．  
      real,  intent(in) :: height  !文字の高さ

      call prcopn('DclSetTextHeight')
      call sgstxs(height)
      call prccls('DclSetTextHeight')
    end subroutine
!---------------------------------
    subroutine DclSetTextAngle(angle)  !文字列の角度の設定．  
      real,  intent(in) :: angle   !文字列の傾きを度の単位で与える 

      call prcopn('DclSetTextAngle')
      call sgstxr(nint(angle))
      call prccls('DclSetTextAngle')
    end subroutine
!---------------------------------
    subroutine DclSetTextIndex(index)  !文字列のラインインデクスの設定．                 
      integer,   intent(in) :: index     !ラインインデクス 

      call prcopn('DclSetTextIndex')
      call sgstxi(index) 
      call prccls('DclSetTextIndex')
    end subroutine
!---------------------------------
    subroutine DclSetTextPosition(centering)  !文字列のセンタリングオプション設定
      integer,   intent(in) :: centering   !センタリングオプション

      call prcopn('DclSetTextPosition')
      call sgstxc(centering)
      call prccls('DclSetTextPosition')
    end subroutine
!---------------------------------
    function DclGetTextHeight() 
      real :: DclGetTextHeight  !文字の高さ

      call prcopn('DclGetTextHeight')
      call sgqtxs(DclGetTextHeight) 
      call prccls('DclGetTextHeight')
    end function
!---------------------------------
    function DclGetTextAngle()
      real :: DclGetTextAngle      !文字列の傾きを度の単位で与える

      call prcopn('DclGetTextAngle')
      call sgqtxr(irot)
      DclGetTextAngle = irot
      call prccls('DclGetTextAngle')
    end function
!---------------------------------
    function DclGetTextIndex() 
      integer :: DclGetTextIndex      !ラインインデクス

      call prcopn('DclGetTextIndex')
      call sgqtxi(DclGetTextIndex) 
      call prccls('DclGetTextIndex')
    end function
!---------------------------------
    function DclGetTextPosition()  
      integer :: DclGetTextPosition   !センタリングオプション

      call prcopn('DclGetTextPosition')
      call sgqtxc(DclGetTextPosition)  
      call prccls('DclGetTextPosition')
    end function
!-------------------------------------------------------------
! トーンプリミティブ
!---------------------------------
    subroutine DclShadeRegion(x, y, pattern)  !u 座標系で多角形領域の塗りつぶし．
      real,    intent(in), dimension(:) :: x,y 
      integer, intent(in), optional     :: pattern

        call sgoopn('DclShadeRegion', ' ')
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclShadeRegion', &
                               & 'Length of x and y don''t match.')
        n = min(nx, ny)

        if(present(pattern)) then ; ipat0 = pattern
                             else ; call sgqtnp(ipat0)
        end if

        call sgtnzu(n,x,y,ipat0) 
        call sgocls('DclShadeRegion')
    end subroutine
!---------------------------------
    subroutine DclShadeRegionNormalized(x, y, pattern)
      real,    intent(in), dimension(:) :: x,y 
      integer, intent(in), optional     :: pattern

        call sgoopn('DclShadeRegionNormalized', ' ')
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclShadeRegionNormalized', &
                               & 'Length of x and y don''t match.')
        n = min(nx, ny)

        if(present(pattern)) then ; ipat0 = pattern
                             else ; call sgqtnp(ipat0)
        end if

        call sgtnzv(n,x,y,ipat0) 
        call sgocls('DclShadeRegionNormalized')
    end subroutine
!---------------------------------
    subroutine DclShadeRegionProjected(x, y, pattern)
      real,    intent(in), dimension(:) :: x,y 
      integer, intent(in), optional     :: pattern

        call sgoopn('DclShadeRegionProjected', ' ')
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclShadeRegionProjected', &
                               & 'Length of x and y don''t match.')
        n = min(nx, ny)

        if(present(pattern)) then ; ipat0 = pattern
                             else ; call sgqtnp(ipat0)
        end if

        call sgtnzr(n,x,y,ipat0) 
        call sgocls('DclShadeRegionProjected')
    end subroutine
!---------------------------------
    subroutine DclSetShadePattern(pattern) ! トーンパターン番号設定
      integer,   intent(in) :: pattern  !トーンパターン番号

      call prcopn('DclSetShadePattern')
      call sgstnp(pattern) 
      call prccls('DclSetShadePattern')
    end subroutine
!---------------------------------
    function DclGetShadePattern() !現在設定されているトーンパターン番号参照
      integer :: DclGetShadePattern     !現在設定されているトーンパターン番号

      call prcopn('DclGetShadePattern')
      call sgqtnp(DclGetShadePattern)
      call prccls('DclGetShadePattern')
    end function
!-------------------------------------------------------------------------
!     アローサブプリミティブ
!-------------------------------------------------------------------------
    subroutine DclDrawArrow(x1,y1,x2,y2,type,index)
      real,    intent(in)           :: x1, y1, x2, y2
      integer, intent(in), optional :: type, index

      integer :: type0

        call sgoopn('DclDrawArrow', ' ')
        if(present(type)  ) then ; type0 = type
                            else ; call sgqlat(type0)
        end if
        
        if(present(index) ) then ; index0 = index
                            else ; call sgqlai(index0)
        end if
        
        call sglazu(x1,y1,x2,y2,type0,index0)
        call sgocls('DclDrawArrow')
    end subroutine
!---------------------------------
    subroutine DclDrawArrowNormalized(x1,y1,x2,y2,type,index)
      real,    intent(in)           :: x1, y1, x2, y2
      integer, intent(in), optional :: type, index

      integer :: type0

        call sgoopn('DclDrawArrowNormalized', ' ')
        if(present(type)  ) then ; type0 = type
                            else ; call sgqlat(type0)
        end if
        
        if(present(index) ) then ; index0 = index
                            else ; call sgqlai(index0)
        end if
        
        call sglazv(x1,y1,x2,y2,type0,index0)
        call sgocls('DclDrawArrowNormalized')
    end subroutine
!---------------------------------
    subroutine DclDrawArrowProjected(x1,y1,x2,y2,type,index)
      real,    intent(in)           :: x1, y1, x2, y2
      integer, intent(in), optional :: type, index

      integer :: type0

        call sgoopn('DclDrawArrowProjected', ' ')
        if(present(type)  ) then ; type0 = type
                            else ; call sgqlat(type0)
        end if
        
        if(present(index) ) then ; index0 = index
                            else ; call sgqlai(index0)
        end if
        
        call sglazr(x1,y1,x2,y2,type0,index0)
        call sgocls('DclDrawArrowProjected')
    end subroutine
!---------------------------------
    subroutine DclSetArrowLineType(type)  !描く線分のラインタイプを設定する． 
      integer,   intent(in) :: type  !線分のラインタイプ 

      call prcopn('DclSetArrowLineType')
      call sgslat(type)
      call prccls('DclSetArrowLineType')
    end subroutine
!---------------------------------
    subroutine DclSetArrowLineIndex(index) !描く線分の ラインインデクスを設定する
      integer,   intent(in) :: index  !線分のラインインデクス 

      call prcopn('DclSetArrowLineIndex')
      call sgslai(index)
      call prccls('DclSetArrowLineIndex')
    end subroutine
!---------------------------------
    function DclGetArrowLineType() !現在設定されているラインタイプ
      integer :: DclGetArrowLineType   !線分のラインタイプ

      call prcopn('DclGetArrowLineType')
      call sgqlat(DclGetArrowLineType)
      call prccls('DclGetArrowLineType')
    end function
!---------------------------------
    function DclGetArrowLineIndex() !現在設定されているラインインデクス
      integer :: DclGetArrowLineIndex      !線分のラインインデクス 

      call prcopn('DclGetArrowLineIndex')
      call sgqlai(DclGetArrowLineIndex) 
      call prccls('DclGetArrowLineIndex')
    end function
!---------------------------------
end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCTNZU(UPX,UPY,UPZ,ITPAT1,ITPAT2)

      REAL      UPX(*),UPY(*),UPZ(*)


      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','SCTNZU','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LE.0) THEN
        CALL MSGDMP('E','SCTNZU','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZT3OP(ITPAT1, ITPAT2)
      CALL SZT3ZU(UPX,UPY,UPZ)
      CALL SZT3CL

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPLZU(N,UPX,UPY,ITYPE,INDEX)

      REAL      UPX(*),UPY(*)


      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLZU','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPLZU','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPLZU','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPLZU','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZPLOP(ITYPE,INDEX)
      CALL SZPLZU(N,UPX,UPY)
      CALL SZPLCL

      END

program sample_2d03

  use dcl
  integer,parameter :: nx=18, ny=18
  real,parameter :: xmin=  0, xmax=360, dx1=20, dx2=60
  real,parameter :: ymin=-90, ymax=+90, dy1=10, dy2=30
  real,parameter :: pi=3.141592, drad=pi/180, dz=0.05, dp=0.2
  real,dimension(0:nx,0:ny) :: p

    do j = 0, ny
      do i = 0, nx
        alon = ( xmin + (xmax-xmin) * i/nx ) * drad
        alat = ( ymin + (ymax-ymin) * j/ny ) * drad
        slat = sin(alat)
        p(i,j) = cos(alon) * (1-slat**2) * sin(2*pi*slat) + dz
      end do
    end do

    call DclOpenGraphics()
!    rmiss = DclGetReal( 'GLOBAL:rmiss' )
    call DclGetParm( 'GLOBAL:rmiss', rmiss )
    call DclSetParm( 'GRAPH:LSOFTF', .false. )
    call DclNewFrame

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransNumber( DCL_UNI_UNI )
    call DclSetTransFunction

    call DclSetShadeLevel( rmiss,  -dp, 201 )
    call DclSetShadeLevel(    dp, dp*2, 401 )
    call DclSetShadeLevel( dp*2, rmiss, 402 )
    call DclShadeContour( p )

    call DclDrawAxis( 'bt', dx2, dx1 )
    call DclDrawTitle( 'b', 'LONGITUDE', 0.0 )

    call DclDrawAxis( 'lr', dy2, dy1 )
    call DclDrawTitle( 'l', 'LATITUDE', 0.0 )

    call DclSetContourLevel( p, dp )
    call DclDrawContour( p )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHBRLZ(N,UPX,UPY,ITYPE,INDEX,RSIZE)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG, LMISS, LYUNI
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.2) THEN
        CALL MSGDMP('E','UHBRLZ','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UHBRLZ','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UHBRLZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UHBRLZ','LINE INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UHBRLZ','BAR SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UVBRLZ','BAR SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      IF (UPX(1).EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'UHBRLZ', 'RUNDEF CAN NOT BE UESED FOR UPY.')
      END IF

      WRITE(COBJ,'(2I8)') ITYPE,INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHBRLZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)
      CALL SZOPLU

      LYUNI = UPY(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/(N-1)
      END IF

      CALL SZOPLV

      LFLAG=.FALSE.
      DO 20 I=1,N
        IF (LYUNI) THEN
          UYY = UYMIN + DY*(I-1)
        ELSE
          UYY = UPY(I)
        END IF

        IF ((UYY.EQ.RMISS .OR. UPX(I).EQ.RMISS) .AND. LMISS) THEN
          LFLAG=.FALSE.
        ELSE
          CALL STFTRF(UPX(I), UYY, VXX, VYY)
          IF (LFLAG) THEN
            CALL SZPLLV(VXX,VYY-RSIZE/2.)
            CALL SZPLLV(VXX,VYY+RSIZE/2.)
          ELSE
            CALL SZMVLV(VXX,VYY-RSIZE/2.)
            CALL SZPLLV(VXX,VYY+RSIZE/2.)
            LFLAG=.TRUE.
          END IF
        END IF
   20 CONTINUE

      CALL SZCLLV
      CALL SWOCLS('UHBRLZ')

      END

!-------------------------------------------------
!interface module of chrlib
!-------------------------------------------------
module chr_interface
  interface

    subroutine cladj(chr)                         !文字列の左詰めをおこなう．
      character(len=*), intent(inout) :: chr      !操作をほどこす文字列
    end subroutine
      
    subroutine cradj(chr)                         !文字列の右詰めをおこなう．
      character(len=*), intent(inout) :: chr      !操作をほどこす文字列
    end subroutine
      
    subroutine crvrs(chr)                         !文字列を反転する．
      character(len=*), intent(inout) :: chr      !操作をほどこす文字列
    end subroutine
      
    function lenb(c)                              !先行する空白の数を求める．
      character(len=*), intent(in) :: c           !調べる文字列
      integer lenb                                !先行する空白の数を返す関数値
    end function
      
    function leny(c)                              !先行する空白の数を求める．
      character(len=*), intent(in) :: c           !調べる文字列
      integer leny                                !先行する空白の数を返す関数値
    end function
      
    function lenc(c)                              !後続する空白を除いた文字数を求める．
      character(len=*), intent(in) :: c           !調べる文字列
      integer lenc                                !後続する空白を除いた文字数を返す関数値
    end function
      
    function lenz(c)                              !後続する空白を除いた文字数を求める．
      character(len=*), intent(in) :: c           !調べる文字列
      integer lenz                                !後続する空白を除いた文字数を返す関数値
    end function

  end interface
end module
!chrlib library end ----
      

*-----------------------------------------------------------------------
*     UGSUT / UGDUT
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGSUT(CSIDE,CTTL)

      CHARACTER CSIDE*(*),CTTL*(*)

      PARAMETER (MAXTTL=10,MAXLEN=32)

      REAL      RSZ(MAXTTL)
      CHARACTER CSIDEZ(MAXTTL)*1,CTTLZ(MAXTTL)*(MAXLEN),CS1*1

      SAVE


*     / CHECK INPUT ARGUMENTS /

      CS1=CSIDE(1:1)
      CALL CUPPER(CS1)
      IF (.NOT.(CS1.EQ.'X' .OR. CS1.EQ.'Y')) THEN
        CALL MSGDMP('W','UGSUT ','SIDE PARAMETER IS INVALID.')
        CALL MSGDMP('M','-CNT.-','DO NOTHING.')
        RETURN
      END IF
      IF (LENZ(CTTL).GT.MAXLEN) THEN
        CALL MSGDMP('W','UGSUT ','LENGTH OF TITLE IS TOO LONG.')
        CALL MSGDMP('M','-CNT.-','DO NOTHING.')
        RETURN
      END IF

      CALL UGRGET('RUNDEF',RUNDEF)
      CALL UGIGET('IUNTTL',NTTL)
      CALL UGRGET('RHFACT',RHFACT)

      NTTL=NTTL+1
      IF (NTTL.EQ.1) THEN
        CALL UGRGET('VXUOFF',VXUOFF)
        CALL UGRGET('VYUOFF',VYUOFF)
        CALL UGRGET('VUTOFF',VUTOFF)
        XTOFF=VXUOFF+VUTOFF
        YTOFF=VYUOFF+VUTOFF
      ELSE
        CALL UGRGET('VXUOFF',XTOFF)
        CALL UGRGET('VYUOFF',YTOFF)
      END IF
      CSIDEZ(NTTL)=CS1
      CTTLZ(NTTL)=CTTL
      CALL UGRGET('RSIZEUT',RSIZE)
      IF (RSIZE.EQ.RUNDEF) THEN
        CALL UZRGET('RSIZEC2',RSZ(NTTL))
        CALL UGRSET('RSIZEUT',RSZ(NTTL))
      ELSE
        RSZ(NTTL)=RSIZE
      END IF

      IF (CS1.EQ.'X') THEN
        YTOFF=YTOFF+RSZ(NTTL)*RHFACT
      ELSE IF (CS1.EQ.'Y') THEN
        XTOFF=XTOFF+RSZ(NTTL)*RHFACT
      END IF

      CALL UGISET('IUNTTL',NTTL)
      CALL UGRSET('VXUOFF',XTOFF)
      CALL UGRSET('VYUOFF',YTOFF)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGDUT

*     / DRAW TITLES FOR UNIT VECTOR /

      CALL UGIGET('IUNTTL',NTTL)
      CALL UGRGET('RHFACT',RHFACT)

      IF (NTTL.LE.0) THEN
        RETURN
      ELSE
        CALL UGRGET('VXULOC',VXULOC)
        CALL UGRGET('VYULOC',VYULOC)
        CALL UGRGET('VXUNIT',VXUNIT)
        CALL UGRGET('VYUNIT',VYUNIT)
        CALL UGRGET('UXUNIT',UXUNIT)
        CALL UGRGET('UYUNIT',UYUNIT)
        CALL UGIGET('IUINDX',IUINDX)
        CALL UGRGET('VUTOFF',VUTOFF)
        XOFF=VXULOC-VUTOFF
        YOFF=VYULOC-VUTOFF
        DO 10 ITTL=1,NTTL
          CALL SGSTXS(RSZ(ITTL))
          IF (CSIDEZ(ITTL).EQ.'X') THEN
            XX=VXULOC+VXUNIT*0.5
            YY=YOFF-RSZ(ITTL)*RHFACT/2
            YOFF=YOFF-RSZ(ITTL)*RHFACT
            CALL UGIGET('IUTXRO',IUTXRO)
            IF (IUTXRO.NE.0 .AND. LENZ(CTTLZ(ITTL)).GE.2) THEN
              CALL MSGDMP('W','UGDUT ',
     &          'LENGTH OF TITLE IS TOO LONG TO CHANGE ROT')
              CALL SGSTXR(0)
            ELSE
              CALL SGSTXR(IUTXRO)
            END IF
          ELSE IF (CSIDEZ(ITTL).EQ.'Y') THEN
            XX=XOFF-RSZ(ITTL)*RHFACT/2
            YY=VYULOC+VYUNIT*0.5
            XOFF=XOFF-RSZ(ITTL)*RHFACT
            CALL UGIGET('IUTYRO',IUTYRO)
            IF (IUTYRO.NE.90 .AND. LENZ(CTTLZ(ITTL)).GE.2) THEN
              CALL MSGDMP('W','UGDUT ',
     &          'LENGTH OF TITLE IS TOO LONG TO CHANGE ROT')
              CALL SGSTXR(90)
            ELSE
              CALL SGSTXR(IUTYRO)
            END IF
          END IF
          CALL SGSTXI(IUINDX)
          CALL SGTXV(XX,YY,CTTLZ(ITTL))
   10   CONTINUE
      END IF

      CALL UGISET('IUNTTL',0)
      CALL UGRSET('VXUOFF',VXUOFF)
      CALL UGRSET('VYUOFF',VYUOFF)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCSPRJ

      LOGICAL LDEG, LPRJCT, LSYSFNT

      EXTERNAL RFPI


      CALL SCQOBJ(XOBJ, YOBJ, ZOBJ)
      CALL SCQEYE(XEYE, YEYE, ZEYE)

      CALL SGIGET('ITR3',ITR3)
      CALL SGRGET('XOFF3',XOFF)
      CALL SGRGET('YOFF3',YOFF)
      CALL SGRGET('TILT3',TILT)
      CALL SGRGET('ANGLE3',ANGLE)
      CALL SGLGET('LDEG',LDEG)

      IF (LDEG) THEN
        CP = RFPI()/180
      ELSE
        CP = 1
      END IF

      RZ  = SQRT((XEYE-XOBJ)**2 + (YEYE-YOBJ)**2 )
      RR  = SQRT((XEYE-XOBJ)**2 + (YEYE-YOBJ)**2 + (ZEYE-ZOBJ)**2)

      THE = ATAN2(RZ, ZEYE-ZOBJ)
      PHI = ATAN2(YEYE - YOBJ, XEYE - XOBJ)
      PSI = RFPI()/2 -  CP*TILT

      CALL STQWTR(RXMIN, RXMAX, RYMIN, RYMAX,
     +            WXMIN, WXMAX, WYMIN, WYMAX, IWTRF)
      X0 = (RXMIN+RXMAX)/2 + XOFF
      Y0 = (RYMIN+RYMAX)/2 + YOFF

      IF (ANGLE.EQ.0) THEN
        CALL MSGDMP('E', 'SCSPRJ', 'ANGLE MUST NOT BE ZERO.')
      ELSE
        FAC = ABS(.5/(RR*SIN(CP*ANGLE/2.)))
      END IF

      IF (ANGLE.LE.0) RR = -RR

      CALL STSPR3(XOBJ, YOBJ, ZOBJ, THE, PHI, PSI, FAC, RR, X0, Y0)

*     / 2-D PROJECTION /

      CALL SGLGET('L2TO3',LPRJCT)
      IF (LPRJCT) THEN
        CALL SGIGET('IXC3',IXC3)
        CALL SGIGET('IYC3',IYC3)
        CALL SGRGET('SEC3',SEC3)
        CALL STSPR2(IXC3, IYC3, SEC3)
      ELSE
        CALL STSPR2(0, 0, 0.)
      END IF

      CALL SWLGET('LSYSFNT',LSYSFNT)
      IF (LSYSFNT) THEN
        CALL MSGDMP('W', 'SCSPRJ',
     +    'SYSTEM FONT IS NOT SUPPORTED IN SCPACK.')
        CALL MSGDMP('W', 'SCSPRJ',
     +    'NOTE : LSYSFNT IS SET TO FALSE.')
        CALL SWLSET('LSYSFNT',.FALSE.)
      END IF

      END

*-----------------------------------------------------------------------
      PROGRAM U2DF06

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05 )

      REAL      P(NX,NY)


      CALL GLRGET( 'RMISS', RMISS )
      CALL GLLSET( 'LMISS', .TRUE. )

      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          IF ((I.EQ.3 .AND. J.EQ.15) .OR.
     +      ((9.LE.I .AND. I.LE.12) .AND. (7.LE.J .AND. J.LE.11))) THEN
            P(I,J)=RMISS
          ELSE
            P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
          END IF
   10   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )

      CALL SGLSET( 'LSOFTF', .TRUE.)

      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS

      CALL UDCNTR( P, NX, NX, NY )
      CALL UETONE( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     TMIQNP / TMIQID / TMIQCP / TMIQVL / TMISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE TMIQNP(NCP)
      IMPLICIT NONE

      CHARACTER CP*(*)

      INTEGER   NPARA
      INTEGER   IUNDEF
      PARAMETER (NPARA  = 4)
      PARAMETER (IUNDEF = -999)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      INTEGER   LENC
      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'GRDTHRES' /, IX(1) / 1 /
      DATA      CPARAS(2) / 'SKIPINTV' /, IX(2) / 1 /
      DATA      CPARAS(3) / 'STLNNUM ' /, IX(3) / 1 /
      DATA      CPARAS(4) / 'STLNGLIM' /, IX(4) / 100 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'GRID_PASSING_THRESHOLD' /
      DATA      CPARAL(2) / 'SKIPPING_POINT_INTERVAL' /
      DATA      CPARAL(3) / 'STREAM_LINE_NUMBERS' /
      DATA      CPARAL(4) / 'STREAM_LIMIT_INTERVAL' /

      DATA      LFIRST / .TRUE. /

      INTEGER   N, NCP
      INTEGER   IP, IDX, IPARA, IN

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','TMIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','TMIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','TMIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('TM', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','TMIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('TM', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','TMISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE SGTXXV(VX,VY,CHARS,RSIZE,IROTA,ICENT,INDEX,ICOLOR)

      CHARACTER CHARS*(*)
      LOGICAL   LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGTXXV','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF


      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGTXXV','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGTXXV','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','SGTXXV','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGTXXV','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGTXXV','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZTXOP(RSIZE,IROTA,ICENT,INDEX)
      CALL SZTXZV(VX,VY,CHARS)
      CALL SZTXCL

      CALL SWSFCM(.TRUE.)

      END

      PROGRAM MAP3D1

      PARAMETER( NP=14 )
      INTEGER   ITR(NP)
      REAL      FCT(NP)
      CHARACTER CTTL*32

      DATA ITR /   10,   11,   12,   13,   14,   15,
     +             20,   21,   22,   23,   30,   31,   32,   33/
      DATA FCT / 0.12, 0.12, 0.14, 0.14, 0.14, 0.14,
     +           0.11, 0.16, 0.12, 0.12, 0.40, 0.12, 0.12, 0.17/

      CALL SWCSTX('FNAME','map3d1')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION IS (I) ? ;'

      CALL SWCSTX('FNAME','MAP3D1')
      CALL SWLSTX('LSEP',.TRUE.)

      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( -ABS(IWS) )

      CALL SLRAT( 2., 3. )
      CALL SLDIV( 'Y', 2, 3 )

      CALL SGLSET( 'LCLIP', .TRUE. )
      CALL SGRSET( 'STLAT1', 45. )
      CALL SGRSET( 'STLAT2', 30. )

      CALL UMLSET( 'LGRIDMN', .FALSE. )
      CALL UMISET( 'INDEXMJ', 1 )

      CALL SGSTXS( 0.035 )
      CALL SGSTXI( 3 )

      DO 10 I=1,NP
        CALL SGFRM

        CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
        CALL SGSSIM( FCT(I), 0., 0. )
        CALL SGSMPL( 0., 90., 0. )
        IF ( ITR(I).EQ.30 ) THEN
          CALL SGSTXY( -180., 180.,   0., 90. )
        ELSE
          CALL SGSTXY( -180., 180., -90., 90. )
        END IF
        CALL SGSTRN( ITR(I) )
        CALL SGSTRF

        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( ITR(I), CTTL )
        CALL SGTXR( 0.5, 0.95, CTTL )
        CTTL = 'ITR='
        WRITE(CTTL(5:6),'(I2)') ITR(I)
        CALL SGTXR( 0.5, 0.05, CTTL )

        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB

        IF ( ITR(I).EQ.23 ) THEN
          CALL SGFRM
          CALL SGFRM
        END IF
   10 CONTINUE

      CALL SGCLS

      END

program sample_2d05

  use dcl
  integer,parameter :: nx=19, ny=19
  real,parameter :: xmin=0, xmax=360,  dx1=20, dx2=60
  real,parameter :: ymin=-90, ymax=90, dy1=10, dy2=30
  real,parameter :: pi=3.141592, drad=pi/180, dz=0.05
  real,dimension(nx,ny) :: p,u,v

    call DclGetParm( 'GLOBAL:rmiss', rmiss )
    call DclSetParm( 'GLOBAL:lmiss', .true. )

    do j = 1, ny
      do i = 1, nx
        alon = ( xmin + (xmax-xmin) * (i-1) / (nx-1) ) * drad
        alat = ( ymin + (ymax-ymin) * (j-1) / (ny-1) ) * drad
        slat = sin(alat)
        p(i,j) = cos(alon) * (1-slat**2) * sin(2*pi*slat) + dz
      end do
    end do

    do j = 1, ny
      do i = 1, nx
        if (j==1 .or. j==ny) then
          u(i,j)=rmiss
          v(i,j)=rmiss
        else
          u(i,j) = p(i,j-1) - p(i,j+1)
          v(i,j) = p(modulo(i,nx-1)+1,j) - p(modulo(i-2,nx-1)+1,j)
        end if
      end do
    end do

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransNumber( DCL_UNI_UNI )
    call DclSetTransFunction

    call DclDrawAxis( 'bt', dx2, dx1 )
    call DclDrawTitle( 'b', 'LONGITUDE', 0.0 )

    call DclDrawAxis( 'lr', dy2, dy1 )
    call DclDrawTitle( 'l', 'LATITUDE', 0.0 )

    call DclSetParm( 'CONTOUR:rsizel', 0.015 )
    call DclSetParm( 'CONTOUR:rsizet', 0.015 )
    call DclDrawContour( p )

    call DclSetParm( 'VECTOR:rsizet', 0.015 )
    call DclSetParm( 'VECTOR:lnrmal', .false. )
    call DclSetParm( 'VECTOR:xfact1', 0.025 )
    call DclSetParm( 'VECTOR:yfact1', 0.050 )
    call DclSetParm( 'VECTOR:lunit', .true. )
    call DclSetUnitVectorTitle( 'x', 'u' )
    call DclSetUnitVectorTitle( 'y', 'v' )
    call DclSetParm( 'VECTOR:vxunit', 0.05 )
    call DclSetParm( 'VECTOR:vyunit', 0.10 )
    call DclDrawVectors( u, v )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZM3ZV(N,VPX,VPY,VPZ)

      REAL      VPX(*),VPY(*),VPZ(*)

      LOGICAL   LFLAG,LCLIPZ

      COMMON    /SZBPM1/ LMISS,RMISS,NPM
      LOGICAL   LMISS
      COMMON    /SZBPM2/ CMARK
      CHARACTER CMARK*1
      COMMON    /SZBTX3/ LCLIP
      LOGICAL   LCLIP

      SAVE


      LCLIPZ=LCLIP
      LCLIP=.FALSE.
      CALL STEPR2

      DO 10 I=1,N,NPM
        LFLAG=LMISS .AND. 
     +      (VPX(I).EQ.RMISS .OR. VPY(I).EQ.RMISS .OR. VPZ(I).EQ.RMISS)
        IF (.NOT.LFLAG) THEN
          CALL STFPR3(VPX(I), VPY(I), VPZ(I), RX, RY)
          CALL SZTXZV(RX,RY,CMARK)
        END IF
   10 CONTINUE

      LCLIP=LCLIPZ
      CALL STRPR2

      END

*-----------------------------------------------------------------------
*     PLOT ROUTINE ON VC (DASH LINE)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZOPLD

      PARAMETER (MAXNB=32)

      INTEGER   M(MAXNB)
      REAL      A(MAXNB)
      LOGICAL   LDASH,LOPEN

      EXTERNAL  ISHIFT

      SAVE

      DATA      LDASH/.FALSE./


*     / OPEN DASH LINE SEGMENT /

      LOPEN=.TRUE.
      CALL SZOPLP

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZMVLD(VX,VY)

*     / PEN-UP MOVE /

      CALL SZMVLP(VX,VY)

      IF (LDASH) THEN

*       / DASH /

        IF (LOPEN) THEN

*         / BEGINNING OF DASH LINE /

          T=0.0
          LOPEN=.FALSE.

        ELSE

          S=SQRT((VX-VXM)**2+(VY-VYM)**2)
          IF (MOVE.EQ.1) THEN
            T=MOD(S+T,C)
          ELSE IF (MOVE.EQ.-1) THEN
            T=0.0
          END IF

        END IF

      END IF

      VXM=VX
      VYM=VY

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZPLLD(VX,VY)

*     / PEN-DOWN MOVE /

      IF (.NOT.LDASH) THEN

*       / SOLID /

        CALL SZPLLP(VX,VY)

      ELSE

*       / DASH /

        S=SQRT((VX-VXM)**2+(VY-VYM)**2)

        IF (S.EQ.0) RETURN

        DX=(VX-VXM)/S
        DY=(VY-VYM)/S

*       / FIND CURRENT POSITION INDEX /

        IX=0
   10   CONTINUE
          IX=IX+1
        IF (A(IX).LT.T) GO TO 10

*       / CHECK LENGTH OF LINE /

        IF (T+S.LE.C) THEN

*         / FIT IN THE CURRENT CYCLE /

          I=IX
   15     IF (T+S.LE.A(I)) GO TO 20
            IF (M(I).EQ.0) THEN
              CALL SZMVLP(VXM+DX*(A(I)-T),VYM+DY*(A(I)-T))
            ELSE IF (M(I).EQ.1) THEN
              CALL SZPLLP(VXM+DX*(A(I)-T),VYM+DY*(A(I)-T))
            END IF
            I=I+1
            GO TO 15
   20     CONTINUE
          IF (M(I).EQ.0) THEN
            CALL SZMVLP(VX,VY)
          ELSE IF (M(I).EQ.1) THEN
            CALL SZPLLP(VX,VY)
          END IF
          T=T+S

        ELSE

*         / CONTINUE TO THE NEXT CYCLE /

          DO 25 I=IX,NA
            IF (M(I).EQ.0) THEN
              CALL SZMVLP(VXM+DX*(A(I)-T),VYM+DY*(A(I)-T))
            ELSE IF (M(I).EQ.1) THEN
              CALL SZPLLP(VXM+DX*(A(I)-T),VYM+DY*(A(I)-T))
            END IF
   25     CONTINUE

          VXM=VXM+DX*(C-T)
          VYM=VYM+DY*(C-T)
          S=S-(C-T)
          T=0
          L=S/C

*         / PROCESS CYCLES /

          DO 35 J=1,L
            DO 30 I=1,NA
              IF (M(I).EQ.0) THEN
                CALL SZMVLP(VXM+DX*A(I),VYM+DY*A(I))
              ELSE IF (M(I).EQ.1) THEN
                CALL SZPLLP(VXM+DX*A(I),VYM+DY*A(I))
              END IF
   30       CONTINUE
            VXM=VXM+DX*C
            VYM=VYM+DY*C
            S=S-C
   35     CONTINUE

*         / FIND LAST POSITON INDEX /

          IX=0
   40     CONTINUE
            IX=IX+1
          IF (A(IX).LT.S) GO TO 40

*         / PROCESS REMAINING CYCLE /

          DO 45 I=1,IX-1
            IF (M(I).EQ.0) THEN
              CALL SZMVLP(VXM+DX*A(I),VYM+DY*A(I))
            ELSE IF (M(I).EQ.1) THEN
              CALL SZPLLP(VXM+DX*A(I),VYM+DY*A(I))
            END IF
   45     CONTINUE
          IF (M(IX).EQ.0) THEN
            CALL SZMVLP(VX,VY)
          ELSE IF (M(I).EQ.1) THEN
            CALL SZPLLP(VX,VY)
          END IF
          T=S

        END IF

      END IF

      VXM=VX
      VYM=VY

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCLLD

*     / CLOSE DASHLINE SEGMENT /

      CALL SZCLLP

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSTYZ(IPAT)

      CALL SGRGET('BITLEN',BL)
      CALL SGIGET('MOVE',MOVE)
      CALL SGIGET('NBITS',NB)

*     / GENERATE SOLID PATTERN /

      ISOLID=0
      DO 50 I=1,NB
        ISOLID=IOR(ISHIFT(ISOLID,1),1)
   50 CONTINUE

*     / CHECK IPAT /

      JPAT=IAND(ISOLID,IPAT)
      IF (JPAT.EQ.0 .OR. JPAT.EQ.ISOLID) THEN

*       / SOLID /

        LDASH=.FALSE.

      ELSE

*       / DASH /

        LDASH=.TRUE.

        NA=1
        MODE1=IAND(ISHIFT(JPAT,1-NB),1)
        A(1)=BL
        M(1)=MODE1
        MODEX=MODE1

        DO 55 I=2,NB
          MODEI=IAND(ISHIFT(JPAT,I-NB),1)
          IF (MODEI.NE.MODEX) THEN
            NA=NA+1
            A(NA)=A(NA-1)
            M(NA)=MODEI
            MODEX=MODEI
          END IF
          A(NA)=A(NA)+BL
   55   CONTINUE

*       / INITIALIZATION /

        C=A(NA)

      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQTYZ(IPAT)

      IPAT=JPAT

      RETURN
      END

*-----------------------------------------------------------------------
*     SLPWWC : PLOT WORKSTATION-WINDOW CORNER MARKS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLPWWC(INDEX,RC)


      IF (INDEX.LE.0) THEN
        IF (INDEX.EQ.0) THEN
          CALL MSGDMP('M','SLPWWC','LINE INDEX IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPWWC','LINE INDEX IS LESS THAN ZERO.')
        END IF
      END IF

      IF (RC.LE.0) THEN
        IF (RC.EQ.0) THEN
          CALL MSGDMP('E','SLPWWC',
     +         'LENGTH OF CORNER MARKS IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPWWC',
     +         'LENGTH OF CORNER MARKS IS LESS THAN ZERO.')
        END IF
      END IF

      CALL STQWTR(RXMIN,RXMAX,RYMIN,RYMAX,WXMIN,WXMAX,WYMIN,WYMAX,ITR)

      CALL SZSLTI(1,INDEX)

      CALL SZOPLR
      CALL SZMVLR(RXMIN   ,RYMIN+RC)
      CALL SZPLLR(RXMIN   ,RYMIN   )
      CALL SZPLLR(RXMIN+RC,RYMIN   )
      CALL SZCLLR
      CALL SZOPLR
      CALL SZMVLR(RXMAX-RC,RYMIN   )
      CALL SZPLLR(RXMAX   ,RYMIN   )
      CALL SZPLLR(RXMAX   ,RYMIN+RC)
      CALL SZCLLR
      CALL SZOPLR
      CALL SZMVLR(RXMAX   ,RYMAX-RC)
      CALL SZPLLR(RXMAX   ,RYMAX   )
      CALL SZPLLR(RXMAX-RC,RYMAX   )
      CALL SZCLLR
      CALL SZOPLR
      CALL SZMVLR(RXMIN+RC,RYMAX   )
      CALL SZPLLR(RXMIN   ,RYMAX   )
      CALL SZPLLR(RXMIN   ,RYMAX-RC)
      CALL SZCLLR

      END

*-----------------------------------------------------------------------
*     CHVAL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE CHVAL(CFMT,VAL,CVAL)

*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*
*     THIS ROUTINE RETURNS CHARACTERIZED VALUE "CVAL" OF "VAL" USING
*     USER SPECIFIED FORMAT "CFMT". IF ONE OF THE FOLLOWING OPTINONS IS
*     SPECIFIED AS "CFMT", FORMAT WILL BE GENERATED AUTOMATICALLY TO
*     REPRESENT 3 SIGNIFICANT DIGITS.
*
*     CFMT   (C*(*)) : FORMAT OR OPTION NAME (I/ ).
*                    : FORMAT SHOULD BEGIN WITH '('.
*                    : ONE OF THE FOLLOWING OPTIONS CAN BE SPECIFIED.
*                    : 'A' - FORMAT IS SET AUTOMATICALLY.
*                    : 'B' - 'A' AND TRAILING ZERO AND DECIMAL POINT ARE
*                    :       DELETED.
*                    : 'C' - 'B' AND ZERO BEFORE DECIMAL POINT AND '+'
*                    :       ARE DELETED.
*                    : 'D' - 'C' BUT ONLY FOR THE EXPONENT TYPE.
*     VAL    (R)     : NUMERIC VALUE THAT SHOULD BE CHARACTERIZED (I/ ).
*     CVAL   (C*(*)) : CHARACTERIZED VALUE OF "VAL" ( /O).
*                    : LEN(CVAL) SHOULD BE 8 OR MORE.
*
*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      CHARACTER CFMT*(*),CVAL*(*)

      CHARACTER CFMTX*16,CHX*16,CF*1,COPT*3
      LOGICAL   LFRST,LCHREQ,LON,LAT

      SAVE

      EXTERNAL  LCHREQ,LENC,INDXCF,RMOD

      DATA      LFRST/.TRUE./


*     / CHECK LENGTH OF OUTPUT CHARACTER /

      IF (LEN(CVAL).LT.8 .AND. LFRST) THEN
        CALL MSGDMP('W','CHVAL ','LENGTH OF CHARACTER IS LESS THAN 8.')
        LFRST=.FALSE.
      END IF

*     / CHECK MAIN OPTION /

      CF=CFMT(1:1)
      CALL CUPPER(CF)

*     / CHECK SUB OPTION /

      NC=LENC(CFMT)
      LON=.FALSE.
      LAT=.FALSE.
      IF (NC.GE.3) THEN
        IF (CFMT(2:2).EQ.'+') THEN
          COPT=CFMT(3:NC)
          IF (LCHREQ(COPT,'X') .OR. LCHREQ(COPT,'LON')) THEN
            LON=.TRUE.
          ELSE IF (LCHREQ(COPT,'Y') .OR. LCHREQ(COPT,'LAT')) THEN
            LAT=.TRUE.
          END IF
        END IF
      END IF

      IF (CF.NE.'(') THEN

*       / LONGITUDE (X) OR LATITUDE (Y) OPTION /

        IF (LON) THEN
          VALZ=RMOD(VAL+180,360.0)-180
        ELSE IF (LAT) THEN
          VALZ=VAL
        ELSE
          VALZ=VAL
        END IF

*       / AUTOMATIC GENERATION (NOT USER FORMAT) /

*       / PICK UP 3 SIGNIFICANT DIGITS AND EXPONENT /

        CFMTX='(1P,E9.2E2)'
        WRITE(CHX,CFMTX) VALZ
        READ(CHX(7:9),'(I3)') IE
        READ(CHX(1:5),'(F5.2)') RB
        VALX=RB*10.0**IE

*       / FORMAT /

        IF (0.LE.IE .AND. IE.LE.2) THEN

*         / DECIMAL /

          CFMTX='(F6. )'
          WRITE(CFMTX(5:5),'(I1)') 2-IE

        ELSE IF (3.LE.IE .AND. IE.LE.4) THEN

*         / INTEGER /

          CFMTX='(I6)'

        ELSE IF (-3.LE.IE .AND. IE.LE.-1) THEN

*         / DECIMAL OR EXPONENT /

*         / COUNT TRAILING ZERO /

          NZ=0
   10     IF (.NOT.(CHX(5-NZ:5-NZ).EQ.'0')) GO TO 15
            NZ=NZ+1
            GO TO 10
   15     CONTINUE

*         / IF -IE .LE. TRAILING ZERO +1 THEN DECIMAL ELSE EXPONENT /

          IF (-IE.LE.NZ) THEN
            CFMTX='(F6.2)'
          ELSE IF (-IE.LE.NZ+1) THEN
            CFMTX='(F6.3)'
          ELSE
            CFMTX='(1P,E8.2E1)'
          END IF

        ELSE IF (-9.LE.IE .AND. IE.LE.9) THEN

*         / EXPONENT ( SIGNIFICANT DIGITS = 3 ) /

          CFMTX='(1P,E8.2E1)'

        ELSE

*         / EXPONENT ( SIGNIFICANT DIGITS = 2 ) /

          CFMTX='(1P,E8.1E2)'

        END IF

      ELSE

*       / USER FORMAT /

        CFMTX=CFMT
        VALX=VAL

      END IF

*     / ENCODING /

      CHX=' '
      IF (LCHREQ(CFMTX(2:2),'I')) THEN
        WRITE(CHX,CFMTX) NINT(VALX)
      ELSE
        WRITE(CHX,CFMTX) VALX
      END IF

*     / CHECK BLANK BEFORE DECIMAL POINT (SYSTEM DEPENDENT) /

      IDXDC=INDXCF(CHX,LENC(CHX),1,'.')
      IF (IDXDC.NE.0) THEN
        ID1=IDXDC-1
        IF (CHX(ID1:ID1).EQ.' ') THEN
          CHX(ID1:ID1)='0'
        ELSE IF (CHX(ID1:ID1).EQ.'-') THEN
          CHX(ID1-1:ID1)='-0'
        END IF
      END IF

*     / LEFT ADJUST /

      CALL CLADJ(CHX)
      NC=LENC(CHX)
      IF (CHX(1:1).EQ.'+') THEN
        CVAL(1:NC-1)=CHX(2:NC)
        NC=NC-1
        CHX=CVAL(1:NC)
      END IF

*     / OPTION /

      IF (((CF.EQ.'B' .OR. CF.EQ.'C') .AND. INDXCF(CHX,NC,1,'.').NE.0)
     +  .OR. (CF.EQ.'D' .AND. INDXCF(CHX,NC,1,'E').NE.0)) THEN

*       / DELETE TRAILING ZERO AND DECIMAL POINT /

*       / CHECK EXPONENT OR DECIMAL /

        IDE=INDXCF(CHX,NC,1,'E')
        IF (IDE.EQ.0) THEN
*         / DECIMAL /
          MC=NC
        ELSE
*         / EXPONENT /
          MC=IDE-1
        END IF

*       / COUNT TRAILING ZERO /

   25   IF (.NOT.(CHX(MC:MC).EQ.'0')) GO TO 20
          MC=MC-1
          GO TO 25
   20   CONTINUE

*       / CHECK DECIMAL POINT /

        IF (CHX(MC:MC).EQ.'.') THEN
          MC=MC-1
        END IF

*       / AVAILABLE LENGTH /

        IF (IDE.EQ.0) THEN
          NC=MC
        ELSE
          CVAL=CHX(1:MC)//CHX(IDE:NC)
          NC=MC+NC-IDE+1
          CHX(1:NC)=CVAL(1:NC)
        END IF

*       / 'C' & 'D' OPTION /

        IF ((CF.EQ.'C' .OR. CF.EQ.'D') .AND. NC.GT.1) THEN

*         / DELETE ZERO BEFORE DECIMAL POINT /

          IF (CHX(1:1).EQ.'0') THEN
            CVAL=CHX(2:NC)
            NC=NC-1
            CHX(1:NC)=CVAL(1:NC)
          ELSE IF (CHX(1:1).EQ.'-' .AND. CHX(2:2).EQ.'0') THEN
            CVAL=CHX(1:1)//CHX(3:NC)
            NC=NC-1
            CHX(1:NC)=CVAL(1:NC)
          END IF

*         / DELETE '+' IN EXPONENT PART /

          IDP=INDXCF(CHX,NC,1,'+')
          IF (IDP.NE.0) THEN
            CVAL(1:NC-1)=CHX(1:IDP-1)//CHX(IDP+1:NC)
            NC=NC-1
            CHX(1:NC)=CVAL(1:NC)
          END IF

        END IF

      END IF

*     / RETURN CHARACTER /

      IF (CF.NE.'(') THEN
        IF (LON) THEN
          IF (VALZ.EQ.0 .OR. VALZ.EQ.-180) THEN
            IF (VALZ.EQ.0) THEN
              CVAL=CHX(1:NC)
            ELSE IF (VALZ.EQ.-180) THEN
              CVAL=CHX(2:NC)
            END IF
          ELSE
            IF (CHX(1:1).EQ.'-') THEN
              CVAL=CHX(2:NC)//'W'
            ELSE
              CVAL=CHX(1:NC)//'E'
            END IF
          END IF
        ELSE IF (LAT) THEN
          IF (VALZ.EQ.0) THEN
*           CVAL=CHX(1:NC)
            CVAL='EQ'
          ELSE
            IF (CHX(1:1).EQ.'-') THEN
              CVAL=CHX(2:NC)//'S'
            ELSE
              CVAL=CHX(1:NC)//'N'
            END IF
          END IF
        ELSE
          CVAL=CHX(1:NC)
          CALL CLOWER(CVAL)
        END IF
      ELSE
        CVAL=CHX(1:NC)
        CALL CLOWER(CVAL)
      END IF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UXYZ7

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( 1990., 1995., -2.0, 2.0 )
      CALL GRSVPT(   0.2,   0.8,  0.3, 0.7 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UZRSET( 'UYUSER', 0. )
      CALL UZLSET( 'LBTWN', .TRUE. )
      CALL UXSFMT( '(I4)' )
      CALL UXAXDV( 'U', 0.25, 1. )
      CALL UZLSET( 'LBTWN', .FALSE. )
      CALL UXSTTL( 'U', 'YEAR', 1. )

      CALL UZISET( 'INNER', -1 )
      CALL UYSFMT( '(F4.1)' )
      CALL UYAXDV( 'L', 0.25, 1. )
      CALL UYSTTL( 'L', 'S.O.Index', 0. )

      CALL UXMTTL( 'T', 'UXAXDV/UYAXDV', 0. )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UXPTMK : PLOT TICKMARKS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPTMK(CSIDE,ISLCT,UX,N)

      REAL      UX(*)
      CHARACTER CSIDE*1

      LOGICAL   LUXCHK,LCHREQ
      CHARACTER CSLCT*1


      IF (.NOT.(LUXCHK(CSIDE))) THEN
        CALL MSGDMP('E','UXPTMK','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UXPTMK','''ISLCT'' IS INVALID.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UXPTMK','NUMBER OF POINTS IS INVALID.')
      END IF

      WRITE(CSLCT,'(I1)') ISLCT

      CALL UZRGET('ROFFX'//CSIDE,ROFFX)
      CALL UZRGET('ROFGX'//CSIDE,ROFGX)
      CALL UZIGET('INDEXT'//CSLCT,INDEX)
      CALL UZRGET('RSIZET'//CSLCT,RSIZE)
      CALL UZIGET('INNER',INNER)
      JSGN=SIGN(1,INNER)

      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
        IF (LCHREQ(CSIDE,'B')) THEN
          POSY=UYMN
          IFLAG=-1
        ELSE
          POSY=UYMX
          IFLAG=+1
        END IF
      ELSE
        CALL UZRGET('UYUSER',POSY)
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      RTICK=-RSIZE*JSGN*IFLAG

      IF (IFLAG.GE.0) THEN
        ROFFX=MAX(ROFGX+RTICK,ROFFX)
      ELSE
        ROFFX=MIN(ROFGX+RTICK,ROFFX)
      END IF

      CALL UXPTMZ(UX,N,POSY,ROFGX,RTICK,INDEX)

      CALL UZRSET('ROFFX'//CSIDE,ROFFX)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE CHNGC(CH,CA,CB)

      CHARACTER CH*(*),CA*(*),CB*(*)

      CHARACTER CPAT*1024

      EXTERNAL  INDXNF


      NH=LEN(CH)
      NA=LEN(CA)
      NB=LEN(CB)
      CPAT=CA(1:NA)

      IF (.NOT.(NA.EQ.NB)) THEN
        CALL MSGDMP('E','CHNGC','CHARACTER LENGTH IS INCONSISTENT.')
      END IF
      NN=NA
      IF (.NOT.(NH.GE.NN)) THEN
        CALL MSGDMP('E','CHNGC','TEXT LENGTH IS TOO SHORT.')
      END IF

      ID1=INDXNF(CH,NH-NN+1,1,CA)
      ID2=ID1+NN-1
      IF (ID1.EQ.0) THEN
        CALL MSGDMP('W','CHNGC',
     +       'PATTERN < '//CPAT(1:NA)//' > WAS NOT FOUND.')
      ELSE
        CH(ID1:ID2)=CB
      END IF

      END

*-----------------------------------------------------------------------
*     UILQNP / UILQID / UILQCP / UILQVL / UILSVL
*-----------------------------------------------------------------------
      SUBROUTINE UILQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 7)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'LCELLX  ' /, LX(1) / .FALSE. /
      DATA      CPARAS(2) / 'LCELLY  ' /, LX(2) / .FALSE. /
      DATA      CPARAS(3) / 'LCORNER ' /, LX(3) / .FALSE. /
      DATA      CPARAS(4) / 'LCYCLE  ' /, LX(4) / .FALSE. /
      DATA      CPARAS(5) / 'LMASK   ' /, LX(5) / .FALSE. /
      DATA      CPARAS(6) / 'LEMBOSS ' /, LX(6) / .FALSE. /
      DATA      CPARAS(7) / 'LSPHERE ' /, LX(7) / .FALSE. /
      
*     / LONG NAME /

      DATA      CPARAL(1) / 'CELL_MODE_X ' /
      DATA      CPARAL(2) / 'CELL_MODE_Y ' /
      DATA      CPARAL(3) / 'FILL_CORNER ' /
      DATA      CPARAL(4) / 'CYCLE_COLOR ' /
      DATA      CPARAL(5) / 'MASK_COLOR  ' /
      DATA      CPARAL(6) / 'EMBOSS      ' /
      DATA      CPARAL(7) / 'SPHERICAL_MAPPING' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UILQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UILQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UILQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UILQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UILQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UILQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UILQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UE', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','UILQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UILSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UE', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','UILSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UILQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPMZR(N,RPX,RPY,ITYPE,INDEX,RSIZE)

      REAL      RPX(*),RPY(*)


      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMZR','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPMZR','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPMZR','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPMZR','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGPMZR','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGPMZR','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZPMOP(ITYPE,INDEX,RSIZE)
      CALL SZPMZR(N,RPX,RPY)
      CALL SZPMCL

      END

*-----------------------------------------------------------------------
      PROGRAM UXYZ05

      PARAMETER ( ID0=19910401, ND=90 )


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL GRFRM

      RND=ND
      CALL SGSWND( 0.0, RND, -1.0, +1.0 )
      CALL SGSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL UCXACL( 'B', ID0, ND )
      CALL UCXACL( 'T', ID0, ND )

      CALL UYAXDV( 'L', 0.05, 0.25 )
      CALL UZLSET( 'LABELYR', .TRUE. )
      CALL UYSFMT( '(F6.2)' )
      CALL UYAXDV( 'R', 0.05, 0.25 )
      CALL UYSTTL( 'L', 'CORRILATION', 0.0 )

      CALL UXMTTL( 'T', 'UCXACL/UYAXDV', 0.0 )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSTXY(TXMIN, TXMAX, TYMIN, TYMAX)


      CALL SGRSET('TXMIN',TXMIN)
      CALL SGRSET('TXMAX',TXMAX)
      CALL SGRSET('TYMIN',TYMIN)
      CALL SGRSET('TYMAX',TYMAX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQTXY(TXMIN, TXMAX, TYMIN, TYMAX)

      CALL SGRGET('TXMIN',TXMIN)
      CALL SGRGET('TXMAX',TXMAX)
      CALL SGRGET('TYMIN',TYMIN)
      CALL SGRGET('TYMAX',TYMAX)

      RETURN
      END

*-----------------------------------------------------------------------
*     NUCCHR
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      INTEGER FUNCTION NUCCHR(CS,ND)

      CHARACTER CS*(*)

      PARAMETER (NX=4)

      INTEGER   NCX(NX)
      LOGICAL   LOWER

      DATA      NCX/  1,  2,  3,  9/


      CALL UCIGET('IUNDEF',IUNDEF)
      CALL UCIGET('NCHAR ',NCHAR )

      IF (NCHAR.NE.IUNDEF) THEN
        NUCCHR=NCHAR
      ELSE
        CALL UCLGET('LOWER  ',LOWER)
        CALL UZRGET('RSIZEL2',RSIZE)
        CALL SGQVPT(VX1,VX2,VY1,VY2)
        IF (CS(1:1).EQ.'X') THEN
          WD=VX2-VX1
        ELSE IF (CS(1:1).EQ.'Y') THEN
          WD=VY2-VY1
        END IF
        MAXC=WD/RSIZE
        NMON=ND/28+1
        DO 10 N=NX,1,-1
          IF (NMON*NCX(N).LE.MAXC) THEN
            IF (LOWER) THEN
              NUCCHR=-NCX(N)
            ELSE
              NUCCHR=+NCX(N)
            END IF
            RETURN
          END IF
   10   CONTINUE
        NUCCHR=0
      END IF

      END

*-----------------------------------------------------------------------
*     UYSOFF / UYROFF
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYSOFF

      LOGICAL   LCALL,LOFF

      SAVE

      DATA      LCALL/.FALSE./

      FY(Y)=YFCT*Y+YOFF


*     / SCALING FACTOR FOR OFFSET /

      CALL UZLGET('LOFFSET',LOFF)
      IF (LOFF) THEN
        CALL UZRGET('YOFFSET',YOFF)
        CALL UZRGET('YFACT  ',YFCT)
      ELSE
        YOFF=0.0
        YFCT=1.0
      END IF

*     / INQUIRE NORMALIZATION TRANSFORMATION /

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)

      FYMN=FY(UYMN)
      FYMX=FY(UYMX)

*     / SET NORMALIZATION TRANSFORMATION /

      CALL SGSWND(UXMN,UXMX,FYMN,FYMX)
      CALL SGSTRF

      LCALL=.TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY UYROFF

      IF (.NOT.LCALL) THEN
        CALL MSGDMP('E','UYROFF','UYSOFF HAS NOT BEEN CALLED.')
      END IF

*     / RESET NORMALIZATION TRANSFORMATION /

      CALL SGSWND(UXMN,UXMX,UYMN,UYMX)
      CALL SGSTRF

      RETURN
      END

program axis06

  use dcl

  integer,parameter :: nx1=21, nx2= 5, ny2=18
  real,dimension(nx1) :: rx1 = (/ &
    -50,-45,-40,-35,-30,-25,-20,-15,-10, -5,  0, &
      5, 10, 15, 20, 25, 30, 35, 40, 45, 50 /)
  real,dimension(nx2) :: rx2 = (/ &
     -40 ,  -20 ,    0 ,   20 ,    40 /)
  real,dimension(ny2) :: ry2 = (/ &
    1000. , 850.  , 700.  , 500.  , 400.  , 300.  , &
     250. , 200.  , 150.  , 100.  , 70.   , 50.   , &
      30. , 10.   , 5.    , 2.    , 1.    , 0.4   /)
  character(len=4),dimension(nx2) :: cx2 = (/ &
    '40S ','20S ','EQ  ','20N ','40N ' /)
  character(len=4),dimension(ny2) :: cy2 = (/ &
    '1000','    ','    ','500 ','    ','    ', &
    '    ','200 ','    ','100 ','    ','50  ', &
    '30  ','10  ','5   ','2   ','1   ','.4  ' /)

    call DclOpenGraphics()

    call DclNewFrame

    call DclSetWindow( -50.0, +50.0, 1.0e3, 0.4 )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransNumber( DCL_UNI_LOG )
    call DclSetTransFunction

    call DclDrawAxisSpecify( 'b', rx2, rx1, label=cx2 )
    call DclDrawAxisSpecify( 't', rx2, rx1 )
    call DclDrawTitle( 'b', 'Latitude', 0.0 )

    call DclDrawAxisSpecify( 'l', ry2, label=cy2 )
    call DclDrawAxisSpecify( 'r', ry2 )
    call DclDrawTitle( 'l', 'Pressure (hPa)', 0.0 )

    call DclDrawTitle( 't', 'DclDrawAxisSpecify', 0.0, 2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     ULPGET / ULPSET / ULPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ULPGET(CP,IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL ULPQID(CP, IDX)
      CALL ULPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPSET(CP, IPARA)

      CALL ULPQID(CP, IDX)
      CALL ULPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULPSTX(CP, IPARA)

      IP = IPARA
      CALL ULPQID(CP, IDX)
      CALL ULPQIT(IDX, IT)
      CALL ULPQCP(IDX, CX)
      CALL ULPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UL', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL ULIQID(CP, IDX)
        CALL ULISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UL', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL ULLQID(CP, IDX)
        CALL ULLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UL', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL ULRQID(CP, IDX)
        CALL ULRSVL(IDX, IP)
      END IF

      RETURN
      END

!-------------------------------------------------
!interface module of reallib
!-------------------------------------------------
module rea_interface
  interface

    function r4ibm(rr)                            !IBM形式の4バイト実数表現を解釈する
      real,      intent(in) :: rr                 !ibm形式の4バイト実数値
      real r4ibm                                  !いま使用しているシステムにおける実数値を返す実数型関数値
    end function
      
    function r4ieee(rr)                           !IEEE形式の4バイト実数表現を解釈する．  
      real,      intent(in) :: rr                 !ibm形式の4バイト実数値
      real r4ieee                                 !いま使用しているシステムにおける実数値を返す実数型関数値
    end function

  end interface
end module
!reallib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SCPKT5

      PARAMETER( NX=37, NY=37 )
      PARAMETER(  XMIN=   0,  XMAX=360,  YMIN=-90,  YMAX= 90 )
      PARAMETER( VXMIN= 0.3, VXMAX=0.9, VYMIN=0.3, VYMAX=0.9 )
      PARAMETER(  ZMIN=-0.8,  ZMAX=0.8 )
      PARAMETER( VZMIN= 0.3, VZMAX=0.6 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )

      REAL ALON(NX), ALAT(NY), P(NX,NY)
      REAL XP(3), YP(3), ZP(3)


      DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
   10 CONTINUE
      DO 20 J=1,NY
        ALAT(J) = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
   20 CONTINUE

      DO 30 J=1,NY
        SLAT = SIN(ALAT(J)*DRAD)
        DO 30 I=1,NX
        P(I,J) = SQRT(1-SLAT**2)*SLAT*COS(ALON(I)*DRAD)
   30 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

*-- X-Y PLAIN ----

      CALL SGSWND(  XMIN,  XMAX,  YMIN,  YMAX )
      CALL SGSVPT( VXMIN, VXMAX, VYMIN, VYMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 2, VZMIN)
      CALL SCSEYE(  -0.8, -0.8,  0.9 )
      CALL SCSOBJ(  0.5,  0.5,  0.4 )
      CALL SCSPRJ

      CALL UXAXDV( 'B', 10., 60. )
      CALL UXAXDV( 'T', 10., 60. )
      CALL UXSTTL( 'B', 'LONGITUDE', 0. )
      CALL UYAXDV( 'L', 10., 30. )
      CALL UYAXDV( 'R', 10., 30. )
      CALL UYSTTL( 'L', 'LATITUDE', 0. )

*-- X-Z PLAIN ----

      CALL SGSWND(  XMIN,  XMAX,  ZMIN,  ZMAX )
      CALL SGSVPT( VXMIN, VXMAX, VZMIN, VZMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 3, VYMAX)
      CALL SCSPRJ

      CALL UZINIT
      CALL UXAXDV( 'T', 10., 60. )
      CALL UZLSET( 'LABELXB', .FALSE. )
      CALL UXAXDV( 'B', 10., 60. )
      CALL UYAXDV( 'L', 0.1, 0.5 )
      CALL UYAXDV( 'R', 0.1, 0.5 )
      CALL UYSTTL( 'L', 'AMPLITUDE', 0. )

*-- Y-Z PLAIN ----

      CALL SGSWND(  YMIN,  YMAX,  ZMIN,  ZMAX )
      CALL SGSVPT( VYMIN, VYMAX, VZMIN, VZMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 2, 3, VXMAX)
      CALL SCSPRJ

      CALL UZINIT
      CALL UXAXDV( 'T', 10., 30. )
      CALL UXAXDV( 'B', 10., 30. )
      CALL UZLSET( 'LABELYL', .FALSE. )
      CALL UYAXDV( 'L', 0.1, 0.5 )
      CALL UYAXDV( 'R', 0.1, 0.5 )

*---------------- 3-D ------------------

      CALL SCSVPT(VXMIN, VXMAX, VYMIN, VYMAX, VZMIN, VZMAX)
      CALL SCSWND( XMIN,  XMAX,  YMIN,  YMAX,  ZMIN,  ZMAX)
      CALL SCSLOG(.FALSE., .FALSE., .FALSE.)
      CALL SCSTRN(1)
      CALL SCSTRF

      CALL SZL3OP(1)
      CALL SZT3OP(2999,9999)

      DO 40 J=NY-1, 1, -1
      DO 40 I=NX-1, 1, -1
        XP(1) = ALON(I)
        YP(1) = ALAT(J)
        ZP(1) = P(I,J)
        XP(2) = ALON(I)
        YP(2) = ALAT(J+1)
        ZP(2) = P(I,J+1)
        XP(3) = ALON(I+1)
        YP(3) = ALAT(J+1)
        ZP(3) = P(I+1,J+1)

        CALL SZT3ZU(XP, YP, ZP)
        CALL SZL3ZU(3, XP, YP, ZP)

        XP(1) = ALON(I+1)
        YP(1) = ALAT(J+1)
        ZP(1) = P(I+1,J+1)
        XP(2) = ALON(I+1)
        YP(2) = ALAT(J)
        ZP(2) = P(I+1,J)
        XP(3) = ALON(I)
        YP(3) = ALAT(J)
        ZP(3) = P(I,J)

        CALL SZT3ZU(XP, YP, ZP)
        CALL SZL3ZU(3, XP, YP, ZP)

   40 CONTINUE

      CALL SZL3CL
      CALL SZT3CL

      CALL SGCLS

      END

*-----------------------------------------------------------------------
      PROGRAM UXYZ10

      PARAMETER ( ID0=19811201, ND=180, RND=ND )


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL UZFACT( 0.7 )
      CALL UZLSET( 'LOFFSET',.TRUE.)

      CALL GRFRM

      CALL SGSWND( 0.0, RND, 0.0, 100.0 )
      CALL SGSVPT( 0.4, 0.9, 0.3, 0.8 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SLPVPR( 1 )

      CALL UCXACL( 'B', ID0, ND )
      CALL UXSAXS( 'B' )
      CALL UXAXDV( 'B', 10.0, 20.0 )
      CALL UXSTTL( 'B', 'DAY NUMBER', 0.0 )
      CALL UCXACL( 'T', ID0, ND )

      CALL UYAXDV( 'L', 5.0, 10.0 )
      CALL UYAXDV( 'R', 5.0, 10.0 )
      CALL UYSTTL( 'L', 'CELSIUS SCALE', 0.0 )
      CALL UYSAXS( 'L' )
      CALL UZRSET( 'YOFFSET', 273.15 )
      CALL UZRSET( 'YFACT  ', 1.0 )
      CALL UYAXDV( 'L', 5.0, 10.0 )
      CALL UYSTTL( 'L', 'KELVIN SCALE', 0.0 )
      CALL UYSAXS( 'L' )
      CALL UZRSET( 'YOFFSET', 32.0 )
      CALL UZRSET( 'YFACT  ', 1.8 )
      CALL UYAXDV( 'L', 10.0, 20.0 )
      CALL UYSTTL( 'L', 'FAHRENHEIT SCALE', 0.0 )

      CALL UXSTTL( 'T', '( LOFSET=.TRUE. )', 0.0 )
      CALL UXSTTL( 'T', 'UXSAXS/UYSAXS', 0.0 )

      CALL GRCLS

      END

program axis05

  use dcl
  real,parameter :: rlat1=20., rlat2=80., dlat1=5., dlat2=10.
  integer,parameter :: days=180
  type(dcl_date) :: date

    date%year = 1981
    date%month = 12
    date%day = 1

    call DclOpenGraphics()

    call DclSetAxisFactor( 0.7 )
    call DclNewFrame

    call DclSetWindow( 0.0, real(days), rlat1, rlat2 )
    call DclSetViewPort( 0.2, 0.8, 0.4, 0.8 )
    call DclSetTransFunction

    call DclDrawViewPortFrame( 1 )

    call DclShiftAxis( 'b' )
    call DclDrawAxisCalendar( 'b', date, nd=days )
    call DclShiftAxis( 'b' )
    call DclDrawAxis( 'b', 20.0, 10.0 )
    call DclDrawTitle( 'b', 'Day Number', 0.0 )
    call DclShiftAxis( 't' )
    call DclDrawAxisCalendar( 't', date, nd=days )

    call DclShiftAxis( 'l' )
    call DclDrawAxis( 'l', dlat2, dlat1 )
    call DclShiftAxis( 'r' )
    call DclDrawAxis( 'r', dlat2, dlat1 )
    call DclDrawTitle( 'l', 'Latitude', 0.0 )

    call DclDrawTitle( 't', 'DclShiftAxis', 0.0, 2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHON3

      PARAMETER( NMAX=40, IMAX=7 )
      REAL X(0:NMAX), Y(0:NMAX,IMAX)

      DT = 4.* 3.14159 / NMAX
      DO 20 N=0,NMAX
        X(N) = REAL(N)/REAL(NMAX)
        DO 10 I=1,IMAX
          Y(N,I) = 0.2*SIN(N*DT) + 0.9 - 0.1*I
   10   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )

*-- マーカータイプ: frame 1 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPMV( NMAX+1, X, Y(0,1) )

      DO 30 I=2,IMAX
        ITYPE = I
        CALL SGSPMT( ITYPE )
        CALL SGPMV( NMAX+1, X, Y(0,I) )
   30 CONTINUE

*-- マーカーサイズ: frame 2 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGSPMT( 10 )
      CALL SGPMV( NMAX+1, X, Y(0,1) )

      DO 40 I=2,IMAX
        RSIZE = 0.005*(I-1)
        CALL SGSPMS( RSIZE )
        CALL SGPMV( NMAX+1, X, Y(0,I) )
   40 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UBPLZV(N,VPX,VPY,ITYPE,INDEX,CHARX,RSIZE)

      REAL      VPX(*),VPY(*)
      CHARACTER CHARX*(*)

      LOGICAL   LCHAR


      CALL MSGDMP('M','UBPLZV','THIS IS OLD INTERFACE - USE SGPLZV !')

      CALL SGLGET('LCHAR',LCHAR)
      CALL SGLSET('LCHAR',.TRUE.)

      CALL SGSPLC(CHARX)
      CALL SGSPLS(RSIZE)

      CALL SGPLZV(N,VPX,VPY,ITYPE,INDEX)

      CALL SGLSET('LCHAR',LCHAR)

      END

*-----------------------------------------------------------------------
*     SLPVPC : PLOT VIEWPORT CORNER MARKS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLPVPC(INDEX,RC)


      IF (INDEX.LE.0) THEN
        IF (INDEX.EQ.0) THEN
          CALL MSGDMP('M','SLPVPC','LINE INDEX IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPVPC','LINE INDEX IS LESS THAN ZERO.')
        END IF
      END IF

      IF (RC.LE.0) THEN
        IF (RC.EQ.0) THEN
          CALL MSGDMP('E','SLPVPC',
     +         'LENGTH OF CORNER MARKS IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPVPC',
     +         'LENGTH OF CORNER MARKS IS LESS THAN ZERO.')
        END IF
      END IF

      CALL SGQVPT(VXMIN,VXMAX,VYMIN,VYMAX)

      CALL SZSLTI(1,INDEX)

      CALL SZOPLV
      CALL SZMVLV(VXMIN   ,VYMIN+RC)
      CALL SZPLLV(VXMIN   ,VYMIN   )
      CALL SZPLLV(VXMIN+RC,VYMIN   )
      CALL SZCLLV
      CALL SZOPLV
      CALL SZMVLV(VXMAX-RC,VYMIN   )
      CALL SZPLLV(VXMAX   ,VYMIN   )
      CALL SZPLLV(VXMAX   ,VYMIN+RC)
      CALL SZCLLV
      CALL SZOPLV
      CALL SZMVLV(VXMAX   ,VYMAX-RC)
      CALL SZPLLV(VXMAX   ,VYMAX   )
      CALL SZPLLV(VXMAX-RC,VYMAX   )
      CALL SZCLLV
      CALL SZOPLV
      CALL SZMVLV(VXMIN+RC,VYMAX   )
      CALL SZPLLV(VXMIN   ,VYMAX   )
      CALL SZPLLV(VXMIN   ,VYMAX-RC)
      CALL SZCLLV

      END

*-----------------------------------------------------------------------
*     TMSLCL : MAIN SOLVER ROUTINE FOR CALCULATING STREAM LINES (RK4)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD DENNOU CLUB. ALL RIGHTS RESERVED.
*-----------------------------------------------------------------------
      SUBROUTINE TMSLCL( INI_X, INI_Y, NX, NY, X, Y, U, V, 
     &                   TRAJX, TRAJY, TRAJN, GRID_FLAG )
      IMPLICIT NONE
      REAL    INI_X                ! STARTING POINT (X) [UNIT:LENGTH]
      REAL    INI_Y                ! STARTING POINT (Y) [UNIT:LENGTH]
      INTEGER NX                   ! GRID NUMBER OF X-DIRECTION
      INTEGER NY                   ! GRID NUMBER OF Y-DIRECTION
      REAL    X(NX)                ! X-COORDINATE [UNIT:LENGTH]
      REAL    Y(NY)                ! Y-COORDINATE [UNIT:LENGTH]
      REAL    U(NX,NY)             ! VECTOR COMPONENT OF X-DIRECTION
      REAL    V(NX,NY)             ! VECTOR COMPONENT OF Y-DIRECTION
      REAL    TRAJX(NX*NY)         ! POSITIONS OF STREAM LINE (X) [UNIT:LENGTH]
      REAL    TRAJY(NX*NY)         ! POSITIONS OF STREAM LINE (Y) [UNIT:LENGTH]
      INTEGER TRAJN                ! RANGE OF DRAWING STREAM LINE (STEP>=TRAJN)
      INTEGER GRID_FLAG(NX,NY)     ! NUMBER OF PASSING STREAM LINES IN EACH GRID.

*-- INTERNAL VALUES
      INTEGER STEP                 ! CALCULATING STEP NUMBER.
      INTEGER THRES                ! NUMBER OF PERMITTING TO PASS STREAM LINE
                                   ! IN EACH GRID (RECOMMENDED VALUE = 1).
      INTEGER I, J, M, N, ID
      INTEGER STNX, STNY           ! STARTING GRID NUMBER OF X, Y COMPONENTS.
      INTEGER INI_M, INI_N         ! INITIAL GRID NUMBER OF X, Y COMPONENTS.
      INTEGER GLIM                 ! MINIMUM LIMIT OF STREAM LINE INTERVAL
      INTEGER SGRID                ! COUNTING THE EXISTING OF THE SAME GRID.
      REAL    K1, K2, K3, K4
      REAL    L1, L2, L3, L4
      REAL    X1, Y1
      REAL    DTTX, DTTY
      REAL    DT                   ! TIME INTERVAL TO CALCULATE STREAM LINE.
      REAL    UNDEF                ! UNDEFINED VALUE FOR (U,V)
      REAL    INTER_P(2)           ! POSITION IN INTERPOLATING POINT
      REAL    INTER_V(2)           ! VECTOR VALUE IN INTERPOLATING POINT
      CHARACTER(1) DTPM            ! FLAG OF FORWARD OR BACKWARD CALCULATING.
      LOGICAL CONTINU_FLAG(NX,NY)  ! FLAG VALUE TO PREVENT THE IDENTICAL 
                                   ! STREAM LINE FROM CONTINUOUS COUNTING
                                   ! IN EACH GRID.
                                   ! 次ステップで同じ格子点にいるのを
                                   ! カウントすることを防ぐためのフラグ.
      LOGICAL PFX, PFY             ! 周期境界かを判別する.
                                   ! 周期境界の場合, 配列の始まりと終わりの
                                   ! 要素数が一致していなければならない.
                                   ! つまり, X 方向に境界条件なら,
                                   ! I=1, NX は同じベクトルが入っている必要.
      LOGICAL DTV                  ! FLAG OF VARYING DT (AUTOMATIC).

*-- FUNCTION
      INTEGER IBLKGE      ! DCL FUNCTION
      REAL    ITRP2D      ! INTERPOLATING FUNCTION
                          ! (DEFINED IN BOTTOM OF THIS FILE)

*-- GETTING TMPACK PARAMETERS
      CALL TMRGET( 'STLNDT  ', DT )
      CALL TMIGET( 'STLNGLIM', GLIM )
      CALL TMIGET( 'GRDTHRES', THRES )
      CALL TMLGET( 'PERIODX ', PFX )
      CALL TMLGET( 'PERIODY ', PFY )
      CALL TMLGET( 'FIXEDDT ', DTV )

*-- CHECKING FORWARD OR BACKWARD
      IF(DT.GE.0.0)THEN
         DTPM(1:1)='F'
      ELSE
         DTPM(1:1)='B'
      END IF

*-- GETTING UNDEFINED VALUE
      CALL GLRGET( 'RMISS', UNDEF )

      STEP=NX*NY

*-- INITIALIZING FLAG VALUE FOR DOUBLE COUNTER
      DO 10 J=1,NY
         DO 11 I=1,NX
            CONTINU_FLAG(I,J)=.FALSE.
 11      CONTINUE
 10   CONTINUE

      SGRID=1

*-- CHECKING WHERE A STREAM LINE PASS GRIDS.
*-- WHEN COUNTING NUMBER EXCEEDS "THRES", STOPPING TO CALCULATE A STREAM LINE.
*-- 以下で, 計算最初の格子点をカウント.
      M=IBLKGE( X, NX, INI_X )
      N=IBLKGE( Y, NY, INI_Y )
      INI_M=M
      INI_N=N
      IF(M.EQ.NX)THEN  !* 下の処理で NX+1, NY+1 (領域外) を参照しないための処理.
         M=NX-1
      END IF
      IF(N.EQ.NY)THEN
         N=NY-1
      END IF
      IF((INI_X-X(M)).GE.(X(M+1)-INI_X))THEN  ! M+1 の点を通過
         IF((INI_Y-Y(N)).GE.(Y(N+1)-INI_Y))THEN  ! N+1 の点を通過
            GRID_FLAG(M+1,N+1)=GRID_FLAG(M+1,N+1)+1
            CONTINU_FLAG(M+1,N+1)=.TRUE.
         ELSE  ! N の点を通過
            GRID_FLAG(M+1,N)=GRID_FLAG(M+1,N)+1
            CONTINU_FLAG(M+1,N)=.TRUE.
         END IF
      ELSE  ! M の点を通過
         IF((INI_Y-Y(N)).GE.(Y(N+1)-INI_Y))THEN  ! N+1 の点を通過
            GRID_FLAG(M,N+1)=GRID_FLAG(M,N+1)+1
            CONTINU_FLAG(M,N+1)=.TRUE.
         ELSE  ! N の点を通過
            GRID_FLAG(M,N)=GRID_FLAG(M,N)+1
            CONTINU_FLAG(M,N)=.TRUE.
         END IF
      END IF

*-- SETTING INITIAL POINT FOR CALCULATING STREAM LINE
      TRAJX(1)=INI_X
      TRAJY(1)=INI_Y

*-- STARTING TO CALCULATE STREAM LINES
      DO 100 I=1,STEP-1

*-- IF THERE IS NO THE INITIAL POINT IN THE ANY GRID POINTS,
*-- SEARCHING THE GRID POINT WHICH DOES NOT EXCEED THE INITIAL POINT.
         INTER_P=(/TRAJX(I), TRAJY(I)/)

         DO 99 ID=1,4  !* RK4 scheme start
*-- RESEARCHING THE NEAREST GRID POINTS FOR INTERPOLATING
*-- 内挿用の近傍格子点探索

            M=IBLKGE( X, NX, INTER_P(1) )
            N=IBLKGE( Y, NY, INTER_P(2) )
*-- 以下の処理の都合上, 領域境界上にある場合は 1 格子内側へずらす.
*-- 内挿時には小さい方を参照点として計算するので, この処理をしても
*-- 本質的には影響しない.
            IF(INTER_P(1).EQ.X(NX))THEN
               M=NX-1
            END IF
            IF(INTER_P(2).EQ.Y(NY))THEN
               N=NY-1
            END IF

*-- WHEN A STREAM LINE COME AT BOUNDARIES OF DRAWING REGION OR
*-- A GRID POINT UNDEFINED FOR VECTOR VALUE,
*-- STOPPING TO CALCULATE THE STREAM LINE.
*-- AND, STANDARD OUTPUTTING ITS CONTENT.
*-- 速度場が UNDEF であれば, その時点でそれ以降のデータには UNDEF を
*-- 代入し, UNDEF 影響範囲内を通過した旨を伝える.
*-- また, INTERPO_SEARCH において検索点が領域外の場合もそれ以降計算不可能
*-- である旨を通知.
*-- この処理は RUNGE-KUTTA で計算する 4 回の傾き計算において
*-- 毎回行われる.
*-- ゆえに, 以下の IF 分は 4 回出てくる.
            IF(M.EQ.0.OR.M.EQ.NX)THEN
               IF(PFX.EQV..TRUE.)THEN
                  IF(M.EQ.0)THEN
                     M=NX-1
                  ELSE
                     M=1
                  END IF
               ELSE
                  TRAJN=I
                  GOTO 101
               END IF
            END IF

            IF(N.EQ.0.OR.N.EQ.NY)THEN
               IF(PFY.EQV..TRUE.)THEN
                  IF(N.EQ.0)THEN
                     N=NY-1
                  ELSE
                     N=1
                  END IF
               ELSE
                  TRAJN=I
                  GOTO 101
               END IF
            END IF

            IF(U(M,N).EQ.UNDEF.OR.U(M,N+1).EQ.UNDEF.OR.
     &         U(M+1,N).EQ.UNDEF.OR.U(M+1,N+1).EQ.UNDEF.OR.
     &         V(M,N).EQ.UNDEF.OR.V(M,N+1).EQ.UNDEF.OR.
     &         V(M+1,N).EQ.UNDEF.OR.V(M+1,N+1).EQ.UNDEF)THEN
               TRAJN=I
               GOTO 101
            END IF

            INTER_V(1)=ITRP2D(X(M:M+1),Y(N:N+1),U(M:M+1,N:N+1),INTER_P)
            INTER_V(2)=ITRP2D(X(M:M+1),Y(N:N+1),V(M:M+1,N:N+1),INTER_P)

            IF((INTER_V(1).EQ.0.0).AND.(INTER_V(2).EQ.0.0))THEN
               TRAJN=I
               GOTO 101
            END IF

            IF(.NOT.DTV)THEN
               IF(INTER_V(1).NE.0.0)THEN
                  DTTX=(X(M+1)-X(M))/INTER_V(1)
               ELSE
                  DTTX=0.0
               END IF
               IF(INTER_V(2).NE.0.0)THEN
                  DTTY=(Y(N+1)-Y(N))/INTER_V(2)
               ELSE
                  DTTY=0.0
               END IF
               IF(ABS(DTTX).GT.ABS(DTTY))THEN
                  DT=ABS(DTTY)
               ELSE
                  DT=ABS(DTTX)
               END IF
               IF(DTPM(1:1).EQ.'B')THEN
                  DT=-ABS(DT)
               END IF
            END IF

*-- CALCULATING THE EACH TENDENCY (K,L)
*-- 4 点の傾向を出す (RK4) ので, 4 回繰り返す.
*-- ただし, その時には INTER_P が毎回更新されており, この更新に伴い
*-- 傾向を求めるときのベクトル INTER_V も更新されている.
            IF(ID.EQ.1)THEN
               K1=DT*INTER_V(1)
               L1=DT*INTER_V(2)
*-- 一時的な流跡線の位置を計算
               X1=TRAJX(I)+0.5*K1
               Y1=TRAJY(I)+0.5*L1
               INTER_P=(/X1, Y1/)
            ELSE IF(ID.EQ.2)THEN
               K2=DT*INTER_V(1)
               L2=DT*INTER_V(2)
*-- 一時的な流跡線の位置を計算
               X1=TRAJX(I)+0.5*K2
               Y1=TRAJY(I)+0.5*L2
               INTER_P=(/X1, Y1/)
            ELSE IF(ID.EQ.3)THEN
               K3=DT*INTER_V(1)
               L3=DT*INTER_V(2)
*-- 一時的な流跡線の位置を計算
               X1=TRAJX(I)+K3
               Y1=TRAJY(I)+L3
               INTER_P=(/X1, Y1/)
            ELSE IF(ID.EQ.4)THEN
               K4=DT*INTER_V(1)
               L4=DT*INTER_V(2)
*-- 一時的な流跡線の位置を計算
               X1=TRAJX(I)+K4
               Y1=TRAJY(I)+L4
*               INTER_P=(/X1, Y1/)  !* ここは内挿計算に使わないので求めない.
            END IF

*-- ここまでで 1 サイクル
 99      CONTINUE

         X1=TRAJX(I)+(1.0/6.0)*(K1+2.0*K2+2.0*K3+K4)
         Y1=TRAJY(I)+(1.0/6.0)*(L1+2.0*L2+2.0*L3+L4)

*-- CHECKING THAT THERE IS A CALCULATING STREAM LINE IN THE DRAWING REGION.
*-- 計算した TRAJ が領域内に存在しているか確認
         IF(X1.LT.X(1).OR.X1.GT.X(NX))THEN
            IF(PFX.EQV..TRUE.)THEN  !* 周期境界の場合, 流線の位置を変化させ 1 つ前の流線位置に undef を代入する.
               IF(X1.LT.X(1))THEN
                  X1=X(NX)+(X1-X(1))
               ELSE
                  X1=X(1)+(X1-X(NX))
               END IF
               TRAJX(I)=UNDEF
               TRAJY(I)=UNDEF
            ELSE
               IF(X1.LT.X(1))THEN
                  TRAJX(I+1)=X(1)
                  TRAJY(I+1)=TRAJY(I)+((X(1)-TRAJX(I))/(X1-TRAJX(I)))  
     &                                *(Y1-TRAJY(I))
               ELSE
                  TRAJX(I+1)=X(NX)
                  TRAJY(I+1)=TRAJY(I)+((X(NX)-TRAJX(I))/(X1-TRAJX(I)))  
     &                                *(Y1-TRAJY(I))
               END IF
               TRAJN=I+1
               GOTO 101
            END IF
         END IF

         IF(Y1.LT.Y(1).OR.Y1.GT.Y(NY))THEN
            IF(PFY.EQV..TRUE.)THEN
               IF(Y1.LT.Y(1))THEN
                  Y1=Y(NY)+(Y1-Y(1))
               ELSE
                  Y1=Y(1)+(Y1-Y(NY))
               END IF
               TRAJX(I)=UNDEF
               TRAJY(I)=UNDEF
            ELSE
               IF(Y1.LT.Y(1))THEN
                  TRAJY(I+1)=Y(1)
                  TRAJX(I+1)=TRAJX(I)+((Y(1)-TRAJY(I))/(Y1-TRAJY(I)))  
     &                                *(X1-TRAJX(I))
               ELSE
                  TRAJY(I+1)=Y(NY)
                  TRAJX(I+1)=TRAJX(I)+((Y(NY)-TRAJY(I))/(Y1-TRAJY(I)))  
     &                                *(X1-TRAJX(I))
               END IF
               TRAJN=I+1
               GOTO 101
            END IF
         END IF

*-- CHECKING WHERE A STREAM LINE PASS GRIDS.
*-- WHEN COUNTING NUMBER EXCEEDS "THRES", STOPPING TO CALCULATE A STREAM LINE.
*-- 以下で, どの格子点を通過したかをカウントする.
*-- また, 通過数が THRES を越えていると, GOTO 101 で終了.
         IF((X1-X(M)).GE.(X(M+1)-X1))THEN  ! M+1 の点を通過
            IF((Y1-Y(N)).GE.(Y(N+1)-Y1))THEN  ! N+1 の点を通過
               IF(CONTINU_FLAG(M+1,N+1).EQV..FALSE.)THEN
                  GRID_FLAG(M+1,N+1)=GRID_FLAG(M+1,N+1)+1
                  CONTINU_FLAG=.FALSE.
                  CONTINU_FLAG(M+1,N+1)=.TRUE.
                  SGRID=1
                  IF(GRID_FLAG(M+1,N+1).GT.THRES)THEN
                     IF(M+1.NE.INI_M.OR.N+1.NE.INI_N)THEN  ! 初期点に戻ってくる場合の処理 (戻ってこないとこの IF 文に入る)
                        TRAJN=I
                        GOTO 101
                     ELSE
                        TRAJX(I+1)=X1
                        TRAJY(I+1)=Y1
                        TRAJN=I+1
                        GOTO 101
                     END IF
                  END IF
               ELSE  ! COUNTING THE EXISTING OF THE SAME GRID
                  SGRID=SGRID+1
               END IF
            ELSE  ! N の点を通過
               IF(CONTINU_FLAG(M+1,N).EQV..FALSE.)THEN
                  GRID_FLAG(M+1,N)=GRID_FLAG(M+1,N)+1
                  CONTINU_FLAG=.FALSE.
                  CONTINU_FLAG(M+1,N)=.TRUE.
                  SGRID=1
                  IF(GRID_FLAG(M+1,N).GT.THRES)THEN
                     IF(M+1.NE.INI_M.OR.N.NE.INI_N)THEN  ! 初期点に戻ってくる場合の処理 (戻ってこないとこの IF 文に入る)
                        TRAJN=I
                        GOTO 101
                     ELSE
                        TRAJX(I+1)=X1
                        TRAJY(I+1)=Y1
                        TRAJN=I+1
                        GOTO 101
                     END IF
                  END IF
               ELSE  ! COUNTING THE EXISTING OF THE SAME GRID
                  SGRID=SGRID+1
               END IF
            END IF
         ELSE  ! M の点を通過
            IF((Y1-Y(N)).GE.(Y(N+1)-Y1))THEN  ! N+1 の点を通過
               IF(CONTINU_FLAG(M,N+1).EQV..FALSE.)THEN
                  GRID_FLAG(M,N+1)=GRID_FLAG(M,N+1)+1
                  CONTINU_FLAG=.FALSE.
                  CONTINU_FLAG(M,N+1)=.TRUE.
                  SGRID=1
                  IF(GRID_FLAG(M,N+1).GT.THRES)THEN
                     IF(M.NE.INI_M.OR.N+1.NE.INI_N)THEN  ! 初期点に戻ってくる場合の処理 (戻ってこないとこの IF 文に入る)
                        TRAJN=I
                        GOTO 101
                     ELSE
                        TRAJX(I+1)=X1
                        TRAJY(I+1)=Y1
                        TRAJN=I+1
                        GOTO 101
                     END IF
                  END IF
               ELSE  ! COUNTING THE EXISTING OF THE SAME GRID
                  SGRID=SGRID+1
               END IF
            ELSE  ! N の点を通過
               IF(CONTINU_FLAG(M,N).EQV..FALSE.)THEN
                  GRID_FLAG(M,N)=GRID_FLAG(M,N)+1
                  CONTINU_FLAG=.FALSE.
                  CONTINU_FLAG(M,N)=.TRUE.
                  SGRID=1
                  IF(GRID_FLAG(M,N).GT.THRES)THEN
                     IF(M.NE.INI_M.OR.N.NE.INI_N)THEN  ! 初期点に戻ってくる場合の処理 (戻ってこないとこの IF 文に入る)
                        TRAJN=I
                        GOTO 101
                     ELSE
                        TRAJX(I+1)=X1
                        TRAJY(I+1)=Y1
                        TRAJN=I+1
                        GOTO 101
                     END IF
                  END IF
               ELSE  ! COUNTING THE EXISTING OF THE SAME GRID
                  SGRID=SGRID+1
               END IF
            END IF
         END IF

         TRAJX(I+1)=X1
         TRAJY(I+1)=Y1
         TRAJN=I+1

*-- 速度場がゼロ以外で Runge-Kutta 計算上たまたまゼロになることがある.
         IF(TRAJX(I).EQ.TRAJX(I+1).AND.TRAJY(I).EQ.TRAJY(I+1))THEN
            GO TO 101
         ELSE IF(ABS(TRAJX(I+1)-TRAJX(I)).LT.(X(M+1)-X(M))/REAL(GLIM)
     &           .AND.
     &           ABS(TRAJY(I+1)-TRAJY(I)).LT.(Y(N+1)-Y(N))/REAL(GLIM)
     &           )THEN
            CALL MSGDMP( 'M', 'TMSLCL', 'DETECTED STREAM .LT. GLIM.' ) 
            GO TO 101
         ELSE IF(SGRID>GLIM)THEN  ! PREVENTING FROM OSCILLATION IN A GRID.
            CALL MSGDMP( 'M', 'TMSLCL', 'DETECTED EXISTING SAME GRID.' )
            TRAJN=TRAJN-GLIM
            GO TO 101
         END IF

C      WRITE(*,*) "V CHECK", TRAJX(I:I+1), TRAJY(I:I+1), I 
 100  CONTINUE

 101  TRAJN=TRAJN

      END SUBROUTINE TMSLCL

*---------------------------------
* PRIVATE ROUTINE (INTERPOLATING FUNCTION)
*---------------------------------

      REAL FUNCTION ITRP2D( X, Y, Z, P )
      IMPLICIT NONE
      REAL X(2)
      REAL Y(2)
      REAL Z(2,2)
      REAL P(2)
      REAL VALX(2)
      REAL V
    
      ! Y(1) での X 方向の内挿点での値
      VALX(1)=Z(1,1)+(P(1)-X(1))*(Z(2,1)-Z(1,1))/(X(2)-X(1))
    
      ! Y(2) での X 方向の内挿点での値
      VALX(2)=Z(1,2)+(P(1)-X(1))*(Z(2,2)-Z(1,2))/(X(2)-X(1))
    
      ! X の内挿点からの Y 方向の内挿点での値(これが求める内挿点)
      V=VALX(1)+(P(2)-Y(1))*(VALX(2)-VALX(1))/(Y(2)-Y(1))
    
      ITRP2D=V

      RETURN
      END FUNCTION ITRP2D

*----------------------------------------------------------------------

      

*-----------------------------------------------------------------------
*     UDIQNP / UDIQID / UDIQCP / UDIQVL / UDISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 7)
      PARAMETER (IUNDEF = -999)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'INDXMJ  ' /, IX(1) / 3 /
      DATA      CPARAS(2) / 'INDXMN  ' /, IX(2) / 1 /
      DATA      CPARAS(3) / 'ISOLID  ' /, IX(3) / 1 /
      DATA      CPARAS(4) / 'IDASH   ' /, IX(4) / 3 /
      DATA      CPARAS(5) / 'ICYCLE  ' /, IX(5) / 2 /
      DATA      CPARAS(6) / 'NLEV    ' /, IX(6) / 12 /
      DATA      CPARAS(7) / 'IUNDEF  ' /, IX(7) / IUNDEF /

*     / LONG NAME /

      DATA      CPARAL(1) / 'MAJOR_CONTOUR_INDEX' /
      DATA      CPARAL(2) / 'MINOR_CONTOUR_INDEX' /
      DATA      CPARAL(3) / 'POSITIVE_CONTOUR_TYPE' /
      DATA      CPARAL(4) / 'NEGATIVE_CONTOUR_TYPE' /
      DATA      CPARAL(5) / 'MAJOR_CONTOUR_CYCLE' /
      DATA      CPARAL(6) / 'CONTOUR_LEVEL_NUMBER' /
      DATA      CPARAL(7) / '----IUNDEF  ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UDIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UDIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UDIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UD', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','UDIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UD', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','UDISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UDIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     LOWER LEVEL APPLICATIONS
*-----------------------------------------------------------------------
*     UYPAXS : PLOT VERTICAL LINE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPAXS(CSIDE,ISLCT)

      CHARACTER CSIDE*1

      LOGICAL   LUYCHK,LCHREQ,LCLIPZ
      CHARACTER CSLCT*1


      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYPAXS','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UYPAXS','''ISLCT'' IS INVALID')
      END IF

      CALL UZRGET('ROFFY'//CSIDE,ROFFY)
      CALL UZRGET('ROFGY'//CSIDE,ROFGY)
      IF (ROFFY.NE.ROFGY) RETURN

      WRITE(CSLCT,'(I1)') ISLCT

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)

      CALL UZIGET('INDEXT'//CSLCT,INDEX)

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        IF (LCHREQ(CSIDE,'L')) THEN
          POSX=UXMN
        ELSE
          POSX=UXMX
        END IF
      ELSE
        CALL UZRGET('UXUSER',POSX)
      END IF

      CALL STFTRF(POSX,UYMN,VX1,VY1)
      CALL STFTRF(POSX,UYMX,VX2,VY2)
      CALL SGLNZV(VX1+ROFGY,VY1,VX2+ROFGY,VY2,INDEX)

      CALL SGLSET('LCLIP',LCLIPZ)

      END

!----------------------------------------------
!  UIpack Module
!----------------------------------------------

module uipack
!  use dcl_common
  contains
!-------------------------------------------------------------
    subroutine DclPaintData(z)
      real, intent(in), dimension(:,:) :: z
      integer, allocatable, dimension(:)   :: image

      call prcopn('DclPaintGrid')

      nx = size(z,1)
      ny = size(z,2)
      call sgqvpt(vxmin, vxmax, vymin, vymax)

      call stfpr2(vxmin, vymin, rx, ry)
      call stfwtr(rx, ry, wx, wy)
      call swfint(wx, wy, ix1, iy1)

      call stfpr2(vxmax, vymax, rx, ry)
      call stfwtr(rx, ry, wx, wy)
      call swfint(wx, wy, ix2, iy2)

      iwidth = abs(ix1-ix2)+1
      allocate(image(iwidth))

      call uipdaz(z, nx, nx, ny,image,iwidth)				
      deallocate(image)  

      call prccls('DclPaintGrid')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetColorRange(zmin, zmax)
      real, intent(in) :: zmin, zmax

      call prcopn('DclSetColorRange')
      call uiscrg(zmin, zmax)
      call prccls('DclSetColorRange')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetColorSequence(color_level, irgb)
      real,    intent(in), dimension(:) :: color_level
      integer, intent(in), dimension(:) :: irgb

      n = size(color_level,1)
      call prcopn('DclSetColorSequence')
      call uiscsq(color_level, irgb, n)
      call prccls('DclSetColorSequence')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetColorFile(file_name)
      character (len=*), intent(in) :: file_name

      call prcopn('DclSetColorFile')
      call uiscfl(file_name)
      call prccls('DclSetColorFile')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetMaskRange(zmin, zmax)
      real, intent(in) :: zmin, zmax

      call prcopn('DclSetMaskRange')
      call uismrg(zmin, zmax)
      call prccls('DclSetMaskRange')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetMaskSequence(mask_level, mask)
      real,    intent(in), dimension(:) :: mask_level, mask

      n = size(mask_level,1)
      call prcopn('DclSetMaskSequence')
      call uismsq(mask_level, mask, n)
      call prccls('DclSetMaskSequence')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetMaskFile(file_name)
      character (len=*), intent(in) :: file_name

      call prcopn('DclSetMaskFile')
      call uismfl(file_name)
      call prccls('DclSetMaskFile')
    end subroutine

!-------------------------------------------------------------
    subroutine DclPaintColorBarX(xmin,xmax,ymin,ymax,zmin,zmax,cpos)
      real, intent(in) :: xmin, xmax, ymin, ymax, zmin, zmax
      character(len=*), intent(in), optional :: cpos
      character(len=2)                       :: cpos0

      if(present(cpos))  then
        cpos0 = cpos
      else
        cpos0 = 'TB'
      end if

      call prcopn('DclPaintColorBarX')
      call uixbar(xmin,xmax,ymin,ymax,zmin,zmax,cpos0)
      call prccls('DclPaintColorBarX')
    end subroutine

!-------------------------------------------------------------
    subroutine DclPaintColorBarY(xmin,xmax,ymin,ymax,zmin,zmax,cpos)
      real, intent(in) :: xmin, xmax, ymin, ymax, zmin, zmax
      character(len=*), intent(in), optional :: cpos
      character(len=2) :: cpos0

      if(present(cpos))  then
        cpos0 = cpos
      else
        cpos0 = 'LR'
      end if

      call prcopn('DclPaintColorBarY')
      call uiybar(xmin,xmax,ymin,ymax,zmin,zmax,cpos0)
      call prccls('DclPaintColorBarY')
    end subroutine

!=============================================================
    subroutine DclPaintData2(u, v)
      real, intent(in), dimension(:, :) :: u, v
      integer, allocatable, dimension(:)   :: image

      call prcopn('DclPaintGrid2')

      nu1 = size(u,1)
      nu2 = size(u,2)
      nv1 = size(v,1)
      nv2 = size(v,2)

      if(nu1 /= nv1 .or. nu2 /= nv2) then
        call msgdmp('E', 'DclPaintGrid2', 'Size of arrays are not consistent.')
      end if

      call sgqvpt(vxmin, vxmax, vymin, vymax)

      call stfpr2(vxmin, vymin, rx, ry)
      call stfwtr(rx, ry, wx, wy)
      call swfint(wx, wy, ix1, iy1)

      call stfpr2(vxmax, vymax, rx, ry)
      call stfwtr(rx, ry, wx, wy)
      call swfint(wx, wy, ix2, iy2)

      iwidth = abs(ix1-ix2)+1
      allocate(image(iwidth))

      call uipd2z(u, v, nu1, nu1, nu2, image, iwidth)
      deallocate(image)  

      call prccls('DclPaintGrid2')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetColorRange2(umin, umax, vmin, vmax)
      real, intent(in) :: umin, umax, vmin, vmax

      call prcopn('DclSetColorRange2')
      call uiscr2(umin, umax, vmin, vmax)
      call prccls('DclSetColorRange2')
    end subroutine

!-------------------------------------------------------------
    subroutine DclSetColorMap(irgb1, irgb2, irgb3, irgb4)
      integer, intent(in) :: irgb1, irgb2, irgb3, irgb4

      call prcopn('DclSetColorMap')
      call uiscmp(irgb1, irgb2, irgb3, irgb4)
      call prccls('DclSetColorMap')
    end subroutine

!-------------------------------------------------------------
    subroutine DclPaintColorMap(xmin,xmax,ymin,ymax,cpos)
      real, intent(in) :: xmin, xmax, ymin, ymax
      character(len=*), intent(in), optional :: cpos
      character(len=4) :: cpos0

      if(present(cpos))  then
        cpos0 = cpos
      else
        cpos0 = 'TBLR'
      end if

      call prcopn('DclPaintColorMap')
      call uipcmp(xmin,xmax,ymin,ymax,cpos0)
      call prccls('DclPaintColorMap')
    end subroutine

!=============================================================
    subroutine DclPackColor(ir, ig, ib, irgb)
      integer, intent(in)  :: ir, ig, ib
      integer, intent(out) :: irgb

      call prcopn('DclPackColor')
      call uifpac(ir, ig, ib, irgb)
      call prccls('DclPackColor')
    end subroutine

!-------------------------------------------------------------
    subroutine DclUnPackColor(irgb, ir, ig, ib)
      integer, intent(in)  :: irgb
      integer, intent(out) :: ir, ig, ib

      call prcopn('DclUnPackColor')
      call uiipac(irgb, ir, ig, ib)
      call prccls('DclUnPackColor')
    end subroutine

end module

      PROGRAM KIHON7

      CALL SWCSTX('FNAME','KIHON7')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
C      CALL SGLSET( 'LCLIP', .TRUE. )
*-- frame 1 ----
      CALL SGFRM
*                  XMIN,  XMAX,  YMIN, YMAX
      CALL SGSWND( -100., 100., -100., 100. )
      CALL SGSVPT(  0.0,   1.0,   0.0,  1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

*-- frame 2 ----
      CALL SGFRM
*-- 左上 ----      XMIN,  XMAX,  YMIN, YMAX
      CALL SGSWND( -100., 100., -100., 100. )
      CALL SGSVPT(   0.1,  0.4,   0.6,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

*-- 右上 ----       XMIN, XMAX, YMIN, YMAX
      CALL SGSWND( -100., 100., -40.,  40. )
      CALL SGSVPT(   0.6,  0.9,  0.6,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

*-- 左下 ----       XMIN, XMAX,  YMIN, YMAX
      CALL SGSWND( -100., 100., -200.,   0. )
      CALL SGSVPT(   0.1,  0.4,   0.1,  0.4 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

      
*-- 右下 ----       XMIN, XMAX, YMIN,  YMAX
      CALL SGSWND( -100., 100.,   0., -200. )
      CALL SGSVPT(   0.6,  0.9,  0.1,   0.4 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

      CALL SGCLS

      END
*-----------------------------------------------------------------------
      SUBROUTINE APLOT

      PARAMETER( NMAX=40 )
      REAL X(0:NMAX), Y(0:NMAX)

      CALL SLPVPR( 1 )

*-- 円形 ----
      DT = 2.*3.14159 / NMAX
      DO 10 N=0,NMAX
        X(N) = 40.*SIN(N*DT)
        Y(N) = 40.*COS(N*DT)
   10 CONTINUE

      CALL SGPLU( NMAX+1, X, Y )

*-- 三角形 ----
      DT = 2.*3.14159 / 3
      DO 20 N=0,3
        X(N) = 40.*SIN(N*DT)
        Y(N) = 40.*COS(N*DT)
   20 CONTINUE

      CALL SGPLU( 4, X, Y )

*-- 文字列 ----
      CALL SGTXU( 0., 0., 'SGTXU' )

      RETURN
      END

!-------------------------------------------------
!  RNMlib Module
!-------------------------------------------------
module rnmlib
  use dcl_common
  contains

    function DclRunningMean(x,length)  !移動平均を計算する． ．
      real, intent(in), dimension(:) :: x !移動平均を計算する実数型の配列
      integer, intent(in)            :: length
      real,      dimension(size(x)) :: DclRunningMean !計算結果を納める実数型の配列

      call prcopn('DclRunningMean')
      call vrrnm(x,DclRunningMean,size(x),1,1,length)
      call prccls('DclRunningMean')
    end function

end module

!-------------------------------------------------
!  SCpack Module
!-------------------------------------------------
module scpack
  use dcl_common
  contains
!-----------------------------------------------------------------------
!正規化変換 
    subroutine DclSet3DViewPort(xmin,xmax, ymin,ymax, zmin,zmax)
      real, intent(in) :: xmin, xmax, ymin, ymax, zmin, zmax

      call prcopn('DclSet3DViewPort')
      call scsvpt(xmin,xmax,ymin,ymax,zmin,zmax)
      call prccls('DclSet3DViewPort')
    end subroutine

    subroutine DclSet3DWindow(xmin,xmax,ymin,ymax,zmin,zmax) !ウインドウの設定．
      real, intent(in) :: xmin, xmax, ymin, ymax, zmin, zmax

      call prcopn('DclSet3DWindow')
      call scswnd(xmin,xmax,ymin,ymax,zmin,zmax)
      call prccls('DclSet3DWindow')
    end subroutine

    subroutine DclSet3DLogAxis(log_x,log_y,log_z) !対数軸の設定．
      logical,  intent(in) :: log_x, log_y, log_z      !直角直線座標の対数軸指定

      call prcopn('DclSet3DLogAxis')
      call scslog(log_x, log_y, log_z )
      call prccls('DclSet3DLogAxis')
    end subroutine

    subroutine DclSet3DOrigin(factor,x,y,z) !スケーリングファクターと原点の設定
      real, intent(in) :: factor   !円筒座標，球座標のスケーリングファクター
      real, intent(in) :: x, y, z  !円筒座標，球座標の原点の位置

      call prcopn('DclSet3DOrigin')
      call scsorg(factor, x, y, z)
      call prccls('DclSet3DOrigin')
    end subroutine

    subroutine DclSet3DTransNumber(number) !変換関数番号の設定
      integer,   intent(in) :: number  !変換関数番号

      call prcopn('DclSet3DTransNumber')
      call scstrn(number)
      call prccls('DclSet3DTransNumber')
    end subroutine

    subroutine DclSet3DTransFunction() !変換関数の確定． 
      call prcopn('DclSet3DTransFunction')
      call scstrf()
      call prccls('DclSet3DTransFunction')
    end subroutine
        
!パラメタ参照ルーチン
    subroutine DclGet3DViewPort(xmin,xmax,ymin,ymax,zmin,zmax)
      real, intent(out) :: xmin, xmax, ymin, ymax, zmin, zmax

      call prcopn('DclGet3DViewPort')
      call scqvpt(xmin,xmax,ymin,ymax,zmin,zmax)
      call prccls('DclGet3DViewPort')
    end subroutine

    subroutine DclGet3DWindow(xmin,xmax,ymin,ymax,zmin,zmax) 
      real, intent(out) :: xmin, xmax, ymin, ymax, zmin, zmax

      call prcopn('DclGet3DWindow')
      call scqwnd(xmin,xmax,ymin,ymax,zmin,zmax) 
      call prccls('DclGet3DWindow')
    end subroutine

    subroutine DclGet3DLogAxis(log_x,log_y,log_z) 
      logical, intent(out) :: log_x,log_y,log_z

      call prcopn('DclGet3DLogAxis')
      call scqlog(log_x,log_y,log_z) 
      call prccls('DclGet3DLogAxis')
    end subroutine

    subroutine DclGet3DOrigin(factor, x, y, z) 
      real, intent(out) :: factor   !円筒座標，球座標のスケーリングファクター
      real, intent(out) :: x, y, z  !円筒座標，球座標の原点の位置

      call prcopn('DclGet3DOrigin')
      call scqorg(factor, x, y, z)
      call prccls('DclGet3DOrigin')
    end subroutine

    function DclGet3DTransNumber()
      integer :: DclGet3DTransNumber        !変換関数番号

      call prcopn('DclGet3DTransNumber')
      call scqtrn(DclGet3DTransNumber) 
      call prccls('DclGet3DTransNumber')
    end function
!-----------------------------------------------------------------------------
!透視変換
    subroutine DclSet3DEyePoint(x, y, z)  !視点の設定．
      real, intent(in) :: x, y, z

      call prcopn('DclSet3DEyePoint')
      call scseye(x, y, z)
      call prccls('DclSet3DEyePoint')
    end subroutine

    subroutine DclSet3DObjectPoint(x, y, z)  !焦点の設定
      real, intent(in) :: x, y, z

      call prcopn('DclSet3DObjectPoint')
      call scsobj(x, y, z)
      call prccls('DclSet3DObjectPoint')
    end subroutine

    subroutine DclSet2DPlane(x_dir, y_dir, section)  !2次元平面の割付
      integer, intent(in) :: x_dir, y_dir
      real,    intent(in) :: section

      call prcopn('DclSet2DPlane')
      call scspln(x_dir, y_dir, section)
      call prccls('DclSet2DPlane')
    end subroutine
 
    subroutine DclSet3DProjection()  !透視変換の確定． 
      call prcopn('DclSet3DProjection')
      call scsprj()
      call prccls('DclSet3DProjection')
    end subroutine

!パラメタ参照ルーチン
    subroutine DclGet3DEyePoint(x, y, z)
      real, intent(out) :: x, y, z

      call prcopn('DclGet3DEyePoint')
      call scqeye(x, y, z)
      call prccls('DclGet3DEyePoint')
    end subroutine

    subroutine DclGet3DObjectPoint(x, y, z)
      real, intent(out) :: x, y, z

      call prcopn('DclGet3DObjectPoint')
      call scqobj(x, y, z)
      call prccls('DclGet3DObjectPoint')
    end subroutine

    subroutine DclGet2DPlane(x_dir, y_dir, section)
      integer, intent(out) :: x_dir, y_dir
      real,    intent(out) :: section

      call prcopn('DclGet2DPlane')
      call scqpln(x_dir, y_dir, section)
      call prccls('DclGet2DPlane')
    end subroutine

!-----------------------------------------------------------------------------
!ポリライン
    subroutine DclDraw3DLine(x,y,z,index)  !u 座標系で折れ線を描く．  
      real,    intent(in), dimension(:) :: x, y, z !折れ線を結ぶ点のU座標
      integer, intent(in), optional     :: index
        

        call sgoopn('DclDraw3DLine', ' ')

        if(present(index)) then; index0 = index
                           else; call scqpli(index0)
        end if

        nx = size(x)
        ny = size(y)
        nz = size(z)
        if(nx.ne.ny .or. ny.ne.nz) call msgdmp('M', 'DclDraw3DLine',  &
                                    & 'Length of x, y, z don''t match.')
        n = min(nx, ny, nz)

        call scplzu(n,x,y,z,index0) 
        call sgocls('DclDraw3DLine')
    end subroutine

    subroutine DclDraw3DLineNormalized(x,y,z,index)   !v 座標系で折れ線を描く
      real,    intent(in), dimension(:) :: x, y, z !折れ線を結ぶ点のU座標
      integer, intent(in), optional     :: index
        
        call sgoopn('DclDraw3DLineNormalized', ' ')
        if(present(index)) then; index0 = index
                           else; call scqpli(index0)
        end if

        nx = size(x)
        ny = size(y)
        nz = size(z)
        if(nx.ne.ny .or. ny.ne.nz) call msgdmp('M', 'DclDraw3DLineNormalized',  &
                                    & 'Length of x, y, z don''t match.')
        n = min(nx, ny, nz)

        call scplzv(n,x,y,z,index0) 
        call sgocls('DclDraw3DLineNormalized')
    end subroutine

    subroutine DclSet3DLineIndex(index)  !ラインインデクスの設定．
      integer,   intent(in) :: index  !折れ線のラインインデクス 

      call prcopn('DclSet3DLineIndex')
      call scspli(index)
      call prccls('DclSet3DLineIndex')
    end subroutine
        
    function DclGet3DLineIndex()
      integer  :: DclGet3DLineIndex     !折れ線のラインインデクス 

      call prcopn('DclGet3DLineIndex')
      call scqpli(DclGet3DLineIndex)
      call prccls('DclGet3DLineIndex')
    end function
    
!------------------------------------------------------------------------------
! ポリマーカー
    subroutine DclDraw3DMarker(x,y,z,type,index,height)  !u 座標系でマーカー列を描く
      real,    intent(in), dimension(:) :: x, y, z
      integer, intent(in), optional     :: type, index
      real,    intent(in), optional     :: height

      integer :: type0, index0

        call sgoopn('DclDraw3DMarker', ' ')
        if(present(type))   then; type0 = type
                            else; call scqpmt(type0)
        end if

        if(present(index))  then; index0 = index
                            else; call scqpmi(index0)
        end if

        if(present(height)) then; height0 = height
                            else; call scqpms(height0)
        end if

        nx = size(x)
        ny = size(y)
        nz = size(z)
        if(nx.ne.ny .or. ny.ne.nz) call msgdmp('M', 'DclDraw3DMarker',  &
                                    & 'Length of x, y, z don''t match.')
        n = min(nx, ny, nz)

        call scpmzu(n, x, y, z, type0, index0, height0)
        call sgocls('DclDraw3DMarker')
    end subroutine

    subroutine DclDraw3DMarkerNormalized(x,y,z,type,index,height)
      real,    intent(in), dimension(:) :: x, y, z
      integer, intent(in), optional     :: type, index
      real,    intent(in), optional     :: height

      integer :: type0, index0

        call sgoopn('DclDraw3DMarkerNormalized', ' ')
        if(present(type))   then; type0 = type
                            else; call scqpmt(type0)
        end if

        if(present(index))  then; index0 = index
                            else; call scqpmi(index0)
        end if

        if(present(height)) then; height0 = height
                            else; call scqpms(height0)
        end if

        nx = size(x)
        ny = size(y)
        nz = size(z)
        if(nx.ne.ny .or. ny.ne.nz) call msgdmp('M', 'DclDraw3DMarkerNormalized',  &
                                    & 'Length of x, y, z don''t match.')
        n = min(nx, ny, nz)

        call scpmzv(n, x, y, z, type0, index0, height0)
        call sgocls('DclDraw3DMarkerNormalized')
    end subroutine

    subroutine DclSet3DMarkerType(type)  !マーカータイプの設定．    
      integer,   intent(in) :: type  !マーカータイプ

      call prcopn('DclSet3DMarkerType')
      call scspmt(type)
      call prccls('DclSet3DMarkerType')
    end subroutine

    subroutine DclSet3DMarkerIndex(index)  !マーカーのラインインデクスの設定  
      integer,   intent(in) :: index  !マーカーを描く線のラインインデクス 

      call prcopn('DclSet3DMarkerIndex')
      call scspmi(index)
      call prccls('DclSet3DMarkerIndex')
    end subroutine

    subroutine DclSet3DMarkerSize(height)  !マーカーの大きさ設定．      
      real,      intent(in) :: height  !マーカーの大きさ

      call prcopn('DclSet3DMarkerSize')
      call scspms(height)
      call prccls('DclSet3DMarkerSize')
    end subroutine
                
! パラメタ参照ルーチン
    function DclGet3DMarkerType()
      integer :: DclGet3DMarkerType !マーカータイプ

      call prcopn('DclGet3DMarkerType')
      call scqpmt(DclGet3DMarkerType)
      call prccls('DclGet3DMarkerType')
    end function

    function DclGet3DMarkerIndex()
      integer :: DclGet3DMarkerIndex    !マーカーを描く線のラインインデクス

      call prcopn('DclGet3DMarkerIndex')
      call scqpmi(DclGet3DMarkerIndex)
      call prccls('DclGet3DMarkerIndex')
    end function

    function DclGet3DMarkerSize()  
      real :: DclGet3DMarkerSize    !マーカーの大きさをR-座標系における単位で指定

      call prcopn('DclGet3DMarkerSize')
      call scqpms(DclGet3DMarkerSize)  
      call prccls('DclGet3DMarkerSize')
    end function

!--------------------------------------------------------------------
!トーン
    subroutine DclDraw3DHatch(x,y,z,pattern1,pattern2)
      real,    intent(in), dimension(3) :: x, y, z
      integer, intent(in), optional     :: pattern1, pattern2

        call sgoopn('DclDraw3DHatch', ' ')
        if(present(pattern1)) then; itpat1 = pattern1
                              else; call scqtnp(itpat1,idummy) 
        end if

        if(present(pattern2)) then; itpat2 = pattern2
                              else; call scqtnp(idummy, itpat2) 
        end if

        call sctnzu(x,y,z,itpat1,itpat2) 
        call sgocls('DclDraw3DHatch')
    end subroutine

    subroutine DclDraw3DHatchNormalized(x,y,z,pattern1,pattern2)
      real,    intent(in), dimension(3) :: x, y, z
      integer, intent(in), optional     :: pattern1, pattern2

        call sgoopn('DclDraw3DHatchNormalized', ' ')
        if(present(pattern1)) then; itpat1 = pattern1
                              else; call scqtnp(itpat1,idummy) 
        end if

        if(present(pattern2)) then; itpat2 = pattern2
                              else; call scqtnp(idummy, itpat2) 
        end if

        call sctnzv(x,y,z,itpat1,itpat2) 
        call sgocls('DclDraw3DHatchNormalized')
    end subroutine

    subroutine DclSet3DHatchPattern(pattern1,pattern2)  !トーンパターン番号設定． 
      integer,   intent(in) :: pattern1,pattern2

      call prcopn('DclSet3DHatchPattern')
      call scstnp(pattern1,pattern2) 
      call prccls('DclSet3DHatchPattern')
    end subroutine

    subroutine DclGet3DHatchPattern(pattern1,pattern2)
      integer,   intent(out) :: pattern1,pattern2

      call prcopn('DclGet3DHatchPattern')
      call scqtnp(pattern1,pattern2) 
      call prccls('DclGet3DHatchPattern')
    end subroutine

end module

!-------------------------------------------------
!     interface module of szpack
!-------------------------------------------------
module sz_interface
    interface
!-----------------------------------------------------------
!インターフェイスルーチン
        subroutine szplop(itype,index) !ポリラインプリミティブの初期化
            integer,   intent(in) :: itype
            integer,   intent(in) :: index
        end subroutine
                                       
        subroutine szplzu(n,upx,upy)  !ポリラインプリミティブの描画  
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: upx
            real,      intent(in), dimension(*) :: upy
        end subroutine

        subroutine szplzv(n,vpx,vpy)  !ポリラインプリミティブの描画  
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: vpx
            real,      intent(in), dimension(*) :: vpy
        end subroutine

        subroutine szplzr(n,rpx,rpy)  !ポリラインプリミティブの描画  
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: rpx
            real,      intent(in), dimension(*) :: rpy
        end subroutine

        subroutine szplcl() !ポリラインプリミティブの終了．
        end subroutine

        subroutine szpmop(itype,index,rsize)  !ポリマーカープリミティブの初期化．
            integer,   intent(in) :: itype
            integer,   intent(in) :: index
            real,      intent(in) :: rsize
        end subroutine

        subroutine szpmzu(n,px,py)  !ポリマーカープリミティブの描画
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: px
            real,      intent(in), dimension(*) :: py
        end subroutine

           subroutine szpmzv(n,px,py) !ポリマーカープリミティブの描画
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: px
            real,      intent(in), dimension(*) :: py
        end subroutine

        subroutine szpmzr(n,px,py) !ポリマーカープリミティブの描画
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: px
            real,      intent(in), dimension(*) :: py
        end subroutine

        subroutine szpmcl()  !ポリマーカープリミティブの終了                 
        end subroutine


        subroutine sztnop(itpat)   !トーンプリミティブの初期化  ． 
            integer,   intent(in) :: itpat
        end subroutine

        subroutine sztnzu(n,px,py)  !トーンプリミティブの描画 
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: px
            real,      intent(in), dimension(*) :: py
        end subroutine

        subroutine sztnzv(n,px,py)  !トーンプリミティブの描画 
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: px
            real,      intent(in), dimension(*) :: py
        end subroutine

        subroutine sztnzr(n,px,py)  !トーンプリミティブの描画 
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: px
            real,      intent(in), dimension(*) :: py
        end subroutine

        subroutine sztncl() !トーンプリミティブの終了． 
        end subroutine


        subroutine sztxop(rsize,irota,icent,index) !テキストプリミティブの初期化． 
            real,      intent(in) :: rsize
            integer,   intent(in) :: irota
            integer,   intent(in) :: icent
            integer,   intent(in) :: index
        end subroutine

        subroutine sztxzu(x,y,chars) !テキストプリミティブの描画． 
            real,      intent(in) :: x
            real,      intent(in) :: y
            character(len=*), intent(in) :: chars
        end subroutine

        subroutine sztxzv(x,y,chars) !テキストプリミティブの描画． 
            real,      intent(in) :: x
            real,      intent(in) :: y
            character(len=*), intent(in) :: chars
        end subroutine

        subroutine sztxzr(x,y,chars) !テキストプリミティブの描画．
            real,      intent(in) :: x
            real,      intent(in) :: y
            character(len=*), intent(in) :: chars
        end subroutine

        subroutine sztxcl() !テキストプリミティブの終了． 
        end subroutine

        subroutine szlnop(index) !ラインサブプリミティブの初期化． 
            integer,   intent(in) :: index
        end subroutine

        subroutine szlnzu(x1,y1,x2,y2) !ラインサブプリミティブの描画． 
            real,      intent(in) :: x1
            real,      intent(in) :: y1
            real,      intent(in) :: x2
            real,      intent(in) :: y2
        end subroutine
        
        subroutine szlnzv(x1,y1,x2,y2) !ラインサブプリミティブの描画． 
            real,      intent(in) :: x1
            real,      intent(in) :: y1
            real,      intent(in) :: x2
            real,      intent(in) :: y2
        end subroutine
        
        subroutine szlnzr(x1,y1,x2,y2) !ラインサブプリミティブの描画． 
            real,      intent(in) :: x1
            real,      intent(in) :: y1
            real,      intent(in) :: x2
            real,      intent(in) :: y2
        end subroutine

        subroutine szlncl() !ラインサブプリミティブの終了
        end subroutine

        subroutine szlaop(itype,index) !アローサブプリミティブの初期化． 
            integer,   intent(in) :: itype
            integer,   intent(in) :: index
        end subroutine

        subroutine szlazu(x1,y1,x2,y2) !アローサブプリミティブの描画． 
            real,      intent(in) :: x1
            real,      intent(in) :: y1
            real,      intent(in) :: x2
            real,      intent(in) :: y2
        end subroutine
        
        subroutine szlazv(x1,y1,x2,y2) !アローサブプリミティブの描画． 
            real,      intent(in) :: x1
            real,      intent(in) :: y1
            real,      intent(in) :: x2
            real,      intent(in) :: y2
        end subroutine
        
        subroutine szlazr(x1,y1,x2,y2) !アローサブプリミティブの描画． 
            real,      intent(in) :: x1
            real,      intent(in) :: y1
            real,      intent(in) :: x2
            real,      intent(in) :: y2
        end subroutine

        subroutine szlacl() !アローサブプリミティブの終了
        end subroutine

!---------------------------------------------------------------------------------
!        折れ線ルーチン
        subroutine szoplu() !回転/正規化変換， 線形補間
        end subroutine

        subroutine szmvlu(ux,uy) 
            real,      intent(in) :: ux
            real,      intent(in) :: uy
        end subroutine

        subroutine szpllu(ux,uy) 
            real,      intent(in) :: ux
            real,      intent(in) :: uy
        end subroutine
        
        subroutine szcllu() 
        end subroutine



        subroutine szoplt() !地図投影，大円補間，地図境界でのクリッピング 
        end subroutine
        
        subroutine szmvlt(tx,ty)
            real,      intent(in) :: tx
            real,      intent(in) :: ty
        end subroutine
        
        subroutine szpllt(tx,ty)
            real,      intent(in) :: tx
            real,      intent(in) :: ty
        end subroutine
        
        subroutine szcllt() 
        end subroutine

        subroutine szoplv() !view port でのクリッピング
        end subroutine

        subroutine szmvlv(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szpllv(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szcllv() 
        end subroutine


        subroutine szoplc() !ラベルつき線分への展開 
        end subroutine

        subroutine szmvlc(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szpllc(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szcllc() 
        end subroutine

        subroutine szopld() !点線の展開
        end subroutine

        subroutine szmvld(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szplld(vx,vy)  
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szclld() 
        end subroutine

        subroutine szoplp() !透視変換
        end subroutine

        subroutine szmvlp(vx,vy)  
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szpllp(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szcllp() 
        end subroutine

        subroutine szoplr() !ws view port でのクリッピング
        end subroutine

        subroutine szmvlr(rx,ry) 
            real,      intent(in) :: rx
            real,      intent(in) :: ry
        end subroutine

        subroutine szpllr(rx,ry) 
            real,      intent(in) :: rx
            real,      intent(in) :: ry
        end subroutine

        subroutine szcllr() 
        end subroutine

        subroutine szoplz() !ws 変換，直線描画
        end subroutine

        subroutine szmvlz(rx,ry) 
            real,      intent(in) :: rx
            real,      intent(in) :: ry
        end subroutine

        subroutine szpllz(rx,ry) 
            real,      intent(in) :: rx
            real,      intent(in) :: ry
        end subroutine

        subroutine szcllz() 
        end subroutine
!-------------------------------------------------------------------------------
!        トーンルーチン
        subroutine szoptu() !回転/正規化変換， 線形補間
        end subroutine

        subroutine szsttu(ux,uy) 
            real,      intent(in) :: ux
            real,      intent(in) :: uy
        end subroutine

        subroutine szcltu() 
        end subroutine

        subroutine szoptt() !地図投影，大円補間，地図境界でのクリッピング 
        end subroutine

        subroutine szsttt(tx,ty) 
            real,      intent(in) :: tx
            real,      intent(in) :: ty
        end subroutine

        subroutine szcltt() 
        end subroutine

        subroutine szoptv() !view port でのクリッピング
        end subroutine

        subroutine szsttv(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szcltv() 
        end subroutine

        subroutine szoptp()  !投影変換，soft/hard fill の switching 
        end subroutine

        subroutine szsttp(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szcltp() 
        end subroutine

        subroutine szoptr() !ws view port でのクリッピング
        end subroutine

        subroutine szsttr(rx,ry) 
            real,      intent(in) :: rx
            real,      intent(in) :: ry
        end subroutine

        subroutine szcltr() 
        end subroutine

        subroutine szoptz() !ws 変換，バッファリング
        end subroutine

        subroutine szsttz(rx,ry) 
            real,      intent(in) :: rx
            real,      intent(in) :: ry
        end subroutine

        subroutine szcltz() 
        end subroutine

        subroutine szopts() !バッファリング（ソフトフィル)
        end subroutine

        subroutine szstts(vx,vy) 
            real,      intent(in) :: vx
            real,      intent(in) :: vy
        end subroutine

        subroutine szclts() 
        end subroutine

        subroutine sztnsv(n,vpx,vpy,irota,rspce,itype,index) !ソフトフィル
            integer,   intent(in) :: n
            real,      intent(in), dimension(*) :: vpx
            real,      intent(in), dimension(*) :: vpy
            integer,   intent(in) :: irota
            real,      intent(in) :: rspce
            integer,   intent(in) :: itype
            integer,   intent(in) :: index
        end subroutine
    end interface
end module

!-------------------------------------------------
!  UWpack Module
!-------------------------------------------------
module uwpack
  use dcl_common
  contains
!-------------------------------------------------
    subroutine DclSetXGrid(x)  !格子点配列の格子点座標を各座標値で設定する．
      real, intent(in), dimension(:) :: x  !x座標をu座標系の値で指定する

      call prcopn('DclSetXGrid')
      call uwsgxa(x,size(x))
      call prccls('DclSetXGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclGetXGrid(x)    !現在設定されている格子点の座標値
      real, intent(out), dimension(:) :: x

      call prcopn('DclGetXGrid')
      call uwqgxa(x,size(x)) 
      call prccls('DclGetXGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclSetYGrid(y)    !格子点配列の格子点座標を各座標値で設定する．
      real, intent(in), dimension(:) :: y  ! y座標をu座標系の値で指定する

      call prcopn('DclSetYGrid')
      call uwsgya(y, size(y))
      call prccls('DclSetYGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclGetYGrid(y)    !現在設定されている格子点の座標値
      real, intent(out), dimension(:) :: y

      call prcopn('DclGetYGrid')
      call uwqgya(y,size(y))
      call prccls('DclGetYGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclSetXEvenGrid(xmin,xmax,n)  !格子点座標を等間隔に設定する．
      real,   intent(in) :: xmin, xmax       !u座標系におけるx座標の最小最大値
      integer,intent(in) :: n                !x方向の格子点数．

      call prcopn('DclSetXEvenGrid')
      call uwsgxb(xmin,xmax,n) 
      call prccls('DclSetXEvenGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclSetYEvenGrid(ymin,ymax,n)  !格子点座標を等間隔に設定する．
      real,    intent(in) :: ymin,ymax       !u座標系におけるy座標の最小最大値
      integer, intent(in) :: n               !y方向の格子点数．

      call prcopn('DclSetYEvenGrid')
      call uwsgyb(ymin,ymax,n)   
      call prccls('DclSetYEvenGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclGetXEvenGrid(xmin,xmax,n)  !格子点座標の最小値,最大値,格子点数の参照
      real,   intent(out) :: xmin,xmax       !u座標系におけるx座標の最小値
      integer,intent(out) :: n               !x方向の格子点数．

      call prcopn('DclGetXEvenGrid')
      call uwqgxb(xmin,xmax,n)  
      call prccls('DclGetXEvenGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclGetYEvenGrid(ymin,ymax,n)  !格子点座標の最小値,最大値,格子点数の参照
      real,      intent(out) :: ymin,ymax    !u座標系におけるy座標の最小値
      integer,   intent(out) :: n            !y方向の格子点数

      call prcopn('DclGetYEvenGrid')
      call uwqgyb(ymin,ymax,n)       
      call prccls('DclGetYEvenGrid')
    end subroutine
!-------------------------------------------------
    function DclGetXGridValue(ix)            !格子点の座標値を返す．
      real                :: DclGetXGridValue
      integer, intent(in) :: ix              !格子点の番号

      call prcopn('DclGetXGridValue')
      DclGetXGridValue = ruwgx(ix)   
      call prccls('DclGetXGridValue')
    end function
!-------------------------------------------------
    function DclGetYGridValue(iy)            !格子点の座標値を返す．
      real                :: DclGetYGridValue
      integer, intent(in) :: iy              !格子点の番号

      call prcopn('DclGetYGridValue')
      DclGetYGridValue = ruwgy(iy)  
      call prccls('DclGetYGridValue')
    end function
!-------------------------------------------------
    function DclGetXGridNumber(x)            !座標値に最も近い格子番号を返す．
      integer             :: DclGetXGridNumber
      real,    intent(in) :: x               !座標値

      call prcopn('DclGetXGridNumber')
      DclGetXGridNumber = iuwgx(x) 
      call prccls('DclGetXGridNumber')
    end function
!-------------------------------------------------
    function DclGetYGridNumber(y)            !座標値に最も近い格子番号を返す．
      integer             :: DclGetYGridNumber
      real,    intent(in) :: y               !格子点の番号

      call prcopn('DclGetYGridNumber')
      DclGetYGridNumber = iuwgy(y) 
      call prccls('DclGetYGridNumber')
    end function
end module

*-----------------------------------------------------------------------
*     UCPGET / UCPSET / UCPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL UCPQID(CP, IDX)
      CALL UCPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPSET(CP, IPARA)

      CALL UCPQID(CP, IDX)
      CALL UCPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPSTX(CP, IPARA)

      IP = IPARA
      CALL UCPQID(CP, IDX)
      CALL UCPQIT(IDX, IT)
      CALL UCPQCP(IDX, CX)
      CALL UCPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UC', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL UCIQID(CP, IDX)
        CALL UCISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UC', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL UCLQID(CP, IDX)
        CALL UCLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UC', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL UCRQID(CP, IDX)
        CALL UCRSVL(IDX, IP)
      END IF

      RETURN
      END

!-----------------------------------------------------------------------
program ucpk01
  use dcl

  integer,parameter :: jd0=19920401
  character(len=32) :: ctl

    call DclOpenGraphics( -abs(DclSelectDevice()) )

    call DclSetParm( 'GRAPH:lfull',.true.)
    call DclSetAxisFactor(0.7)
    call DclSetAspectRatio(0.75,1.0)
    call DclDivideFrame('t',1,7)

    call DclNewFrame
    nd=30
    call DclSetWindow(0.0,real(nd),0.0,1.0)
    call DclSetViewPort(0.1,0.9,0.13,0.14)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawXAxisCalendar('b',jd0,nd)
    ctl='DclDrawXAxisCalendar (30days)'
    call DclDrawXSubTitle('b',ctl,0.0)

    call DclNewFrame
    nd=90
    call DclSetWindow(0.0,real(nd),0.0,1.0)
    call DclSetViewPort(0.1,0.9,0.13,0.14)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawXAxisCalendar('b',jd0,nd)
    ctl='DclDrawXAxisCalendar (90days)'
    call DclDrawXSubTitle('b',ctl,0.0)

    call DclNewFrame
    nd=180
    call DclSetWindow(0.0,real(nd),0.0,1.0)
    call DclSetViewPort(0.1,0.9,0.13,0.14)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawXAxisCalendar('b',jd0,nd)
    ctl='DclDrawXAxisCalendar (180days)'
    call DclDrawXSubTitle('b',ctl,0.0)

    call DclNewFrame
    nd=400
    call DclSetWindow(0.0,real(nd),0.0,1.0)
    call DclSetViewPort(0.1,0.9,0.13,0.14)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawXAxisCalendar('b',jd0,nd)
    ctl='DclDrawXAxisCalendar (400days)'
    call DclDrawXSubTitle('b',ctl,0.0)

    call DclNewFrame
    nd=60
    call DclSetWindow(0.0,real(nd),0.0,1.0)
    call DclSetViewPort(0.1,0.9,0.1,0.11)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawXAxisDay('b',jd0,nd)
    ctl='DclDrawXAxisDay (60days)'
    call DclDrawXSubTitle('b',ctl,0.0)

    call DclNewFrame
!    call uzinit
    nd=120
    call DclSetWindow(0.0,real(nd),0.0,1.0)
    call DclSetViewPort(0.1,0.9,0.1,0.11)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawXAxisMonth('b',jd0,nd)
    ctl='DclDrawXAxisMonth (120days)'
    call DclDrawXSubTitle('b',ctl,0.0)

    call DclNewFrame
!    call uzinit
    nd=2000
    call DclSetWindow(0.0,real(nd),0.0,1.0)
    call DclSetViewPort(0.1,0.9,0.1,0.11)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawXAxisYear('b',jd0,nd)
    ctl='DclDrawXAxisYear (2000days)'
    call DclDrawXSubTitle('b',ctl,0.0)

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPLZR(N,RPX,RPY,ITYPE,INDEX)

      REAL      RPX(*),RPY(*)


      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLZR','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPLZR','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPLZR','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPLZR','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZPLOP(ITYPE,INDEX)
      CALL SZPLZR(N,RPX,RPY)
      CALL SZPLCL

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZTNZR(N,RPX,RPY)

      REAL      RPX(*),RPY(*)

      LOGICAL   LCLIPZ

      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP

      SAVE


      LCLIPZ=LCLIP
      LCLIP=.FALSE.
      CALL STEPR2

      CALL SZOPTV
      DO 10 I=1,N
        CALL SZSTTV(RPX(I),RPY(I))
   10 CONTINUE
      CALL SZSTTV(RPX(1),RPY(1))
      CALL SZCLTV

      LCLIP=LCLIPZ
      CALL STRPR2

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ULXLOG ( CSIDE, NLBL, NTICKS )

*     CSIDE : 'T','B','U'
*     NLBL  : 1-4          ... Label buffer number used in the axis
*     NTICKS: 1-9          ... Number of small ticks in 10**N-10**(N+1)

      PARAMETER(MAXL=50,MAXS=200)
      DIMENSION BL(10),BS(10),UX1(MAXS),UX2(MAXL),UXT(MAXL)
      CHARACTER CH(MAXL)*18,CHR*8,CFMT*16,USGI*3,CSIDE,CHW*16
      LOGICAL LRLT,LRGT,LABEL,LEPSL,LCNTL,LUXCHK,LOFF,LSFNT

      SAVE

      IF(.NOT.LUXCHK(CSIDE))
     #   CALL MSGDMP('E', 'ULXLOG', 'INVALID CSIDE.')
      IF(NLBL.LT.1 .OR. NLBL.GT.4)
     #   CALL MSGDMP('E', 'ULXLOG', 'INVALID NLBL.')
      IF(NTICKS.LT.1 .OR. NTICKS.GT.9)
     #   CALL MSGDMP('E', 'ULXLOG', 'INVALID NTICKS.')

      CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)

      CALL UZLGET('LOFFSET', LOFF)
      IF(LOFF) THEN
        CALL UZRGET('XFACT',   FACTOR)
        XMIN = UXMIN/FACTOR
        XMAX = UXMAX/FACTOR
        CALL SGSWND(XMIN,XMAX,UYMIN,UYMAX)
        CALL SGSTRF
      ELSE
        XMIN = UXMIN
        XMAX = UXMAX
      ENDIF

      SGN = SIGN(1.0,XMIN)

      IF(SGN*XMIN.GT.SGN*XMAX)THEN
        XXX=XMIN
        XMIN=XMAX
        XMAX=XXX
      END IF

      CALL ULIGET('IXTYPE', ITYPE)
      CALL ULIGET('IXCHR' , IXCHR)
      CALL ULXLBL( BL, NB , NLBL)

      CALL SGIGET('ISUP', ISUP)
      CALL SGIGET('IRST', IRST)

      CALL GLLGET('LEPSL',LEPSL)
      CALL SGLGET('LCNTL',LCNTL)
      CALL SWLGET('LSYSFNT',LSFNT)
      CALL GLLSET('LEPSL',.TRUE.)
      CALL GNSAVE

*     SMALL TICKS

      CALL VRGNN(BS, 10, 1)
      BS(NTICKS+1)=10.
      CALL GNSBLK(BS,NTICKS+1)
      CALL GNLE(ABS(XMAX),BXMAX,IPMAX)
      CALL GNGE(ABS(XMIN),BXMIN,IPMIN)

      NBS=0
      DO 100 IP=IPMIN,IPMAX
      DO 100 IB=1,NTICKS
        IF(IP.EQ.IPMIN.AND.LRLT(BS(IB),BXMIN))GOTO 100
        IF(IP.EQ.IPMAX.AND.LRGT(BS(IB),BXMAX))GOTO 100
        NBS=NBS+1
        IF(NBS.GT.MAXS) CALL MSGDMP('E', 'ULXLOG', 'TOO MANY TICKS.')
        UX1(NBS)=SGN*BS(IB)*10.**IP
  100 CONTINUE

*     LARGE LABELS AND TICKS

      CALL GNSBLK(BL,NB+1)
      CALL GNLE(ABS(XMAX),BXMAX,IPMAX)
      CALL GNGE(ABS(XMIN),BXMIN,IPMIN)

      NBL=0
      NBT=0
      JTYPE = MOD(ITYPE, 2)

      DO 201 IP=IPMIN,IPMAX
      DO 201 IB=1,NB
        IF(IP.EQ.IPMIN.AND.LRLT(BL(IB),BXMIN))GOTO 201
        IF(IP.EQ.IPMAX.AND.LRGT(BL(IB),BXMAX))GOTO 201

        IF(IB.EQ.1)THEN
          NBT=NBT+1
          UXT(NBT)=SGN*10.**IP
        END IF

        NBL=NBL+1
        IF(NBL.GT.MAXL) CALL MSGDMP('E', 'ULXLOG', 'TOO MANY LABELS.')
        UX2(NBL)=SGN*BL(IB)*10.**IP


        IF(ITYPE.LE.2) THEN
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            IF(JTYPE.EQ.1 .AND. NB.NE.1) THEN
              WRITE(CH(NBL),'(I1,A3)') INT(BL(IB)), USGI(IXCHR)
            ELSE
              CH(NBL)=' '
            ENDIF
            WRITE(CHR,'(I8)') IP
            CALL CLADJ(CHR)
            CH(NBL)(5:18)='10\^{'//CHR(1:LENZ(CHR))//'}'
            CALL CLADJ(CH(NBL))
          END IF
        ELSE
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            CALL UZCGET('CXFMT', CFMT)
            CALL CHVAL(CFMT, ABS(UX2(NBL)), CH(NBL))
            CALL CLADJ(CH(NBL))
          ENDIF
        ENDIF
  201 CONTINUE

      IF(SGN.LT.0) THEN
         DO 301 IB=1,NBL
            CHW='-'//CH(IB)
            CH(IB)=CHW
  301    CONTINUE
      ENDIF

*     DRAW AXIS, TICKS, AND LABELS

      CALL UXPAXS(CSIDE,2)
      IF(NBS.NE.0) CALL UXPTMK(CSIDE,1,UX1,NBS)
      IF(NBT.NE.0) CALL UXPTMK(CSIDE,2,UXT,NBT)
      CALL UZLGET('LABELX'//CSIDE,LABEL)
      IF(LABEL) CALL UXPLBL(CSIDE,1,UX2,CH,16,NBL)

      CALL GLLSET('LEPSL',LEPSL)
      CALL GNRSET

      IF (LOFF) THEN
        CALL SGSWND(UXMIN,UXMAX,UYMIN,UYMAX)
        CALL SGSTRF
      ENDIF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UMPK03

      PARAMETER (NP=2)

      CHARACTER CTTL*32, CTR(NP)*3

      EXTERNAL  ISGTRC

      DATA CTR /'MER','CON'/


      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( ABS(IWS) )

      CALL SLRAT( 2.0, 1.0 )
      CALL SLDIV( 'Y', 2, 1 )

      DO 10 I=1,NP

        CALL GRFRM

        CALL GRSWND( 123.0, 147.0, 30.0, 46.0)
        CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
        CALL GRSTRN( ISGTRC(CTR(I)) )
        CALL UMPFIT
        CALL GRSTRF

        CALL SGLSET( 'LCLIP', .TRUE. )
        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( ISGTRC(CTR(I)), CTTL )
        CALL SGTXZR( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

*       CALL UMPMAP( 'coast_japan' )
        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB

   10 CONTINUE

      CALL GRCLS

      END

!-----------------------------------------------------------------------
!     random number generator (Fortran90 Standard)
!-----------------------------------------------------------------------
real function rngu0(iseed)

logical lfirst
integer, allocatable :: is(:)
data lfirst /.true./
save

  if (lfirst) then
    call random_seed(size=i)
    allocate (is(i))
    is = iseed
    call random_seed(put=is)
    lfirst = .false.
  end if
  call random_number(rngu0)
end

      PROGRAM COLOR2

      PARAMETER( NMAX=50 )
      REAL      X(0:NMAX), Y(0:NMAX)
      CHARACTER USGI*3, CTTL*32

      R    = 3.7
      X(0) = 1950
      Y(0) = 0.5
      DO 10 N=0,NMAX-1
        X(N+1) = X(N) + 1
        Y(N+1) = R*Y(N)*(1.-Y(N))
   10 CONTINUE
      YAVE = RAVE( Y, NMAX+1, 1 )
      DO 20 N=0,NMAX
        Y(N) = -4*(Y(N)-YAVE)
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( X(0), X(NMAX), -1.5, 2.0 )
      CALL GRSVPT(  0.2,     0.9,  0.2, 0.9 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL SGISET( 'IFONT', 2 )
      CALL UZISET( 'INDEXT1', 402 )
      CALL UZISET( 'INDEXT2', 404 )
      CALL UZISET( 'INDEXL1', 303 )
      CALL UZISET( 'INDEXL2', 123 )
      CALL UXAXDV( 'B', 2., 10. )
      CALL UXAXDV( 'T', 2., 10. )
      CALL UXSTTL( 'B', 'YEAR', 0. )

      CALL UYAXDV( 'L', 0.1, 0.5 )
      CALL UYAXDV( 'R', 0.1, 0.5 )
      CTTL = USGI(131) // 'T [K]'
      CALL UYSTTL( 'L',CTTL, 0. )

      CALL UXMTTL( 'T', 'INTERANNUAL VARIATION', 0. )

      CALL SGSPLI( 24 )
      CALL SGPLU( NMAX+1, X, Y )
      CALL GRCLS

      END

!-------------------------------------------------
!interface module of uepack
!-------------------------------------------------
module ue_interface
  interface
    subroutine uetone(z,mx,nx,ny)                 !2次元等値線図のぬりわけをおこなう．
      real,      intent(in), dimension(mx,*) :: z !mx, nyの2次元配列
      integer,   intent(in) :: mx                 !配列zの第1次元整合寸法
      integer,   intent(in) :: nx                 !作画に使う配列zの第1次元寸法
      integer,   intent(in) :: ny                 !作画に使う配列zの第2次元寸法
    end subroutine
      
    subroutine uetonf(z,mx,nx,ny)                 !2次元等値線図のぬりわけをおこなう．
      real,      intent(in), dimension(mx,*) :: z !mx, nyの2次元配列．作画にはnx nyの部分を使う
      integer,   intent(in) :: mx                 !配列zの第1次元整合寸法
      integer,   intent(in) :: nx                 !作画に使う配列zの第1次元寸法
      integer,   intent(in) :: ny                 !作画に使う配列zの第2次元寸法
    end subroutine
      
    subroutine uegtla(xmin,xmax,dx)               !トーンレベル値を最小値・最大値,きざみ値,レベル数で設定する．
      real,      intent(in) :: xmin               !トーンレベルの最小値
      real,      intent(in) :: xmax               !トーンレベルの最大値
      real,      intent(in) :: dx                 !dx > 0 のときdxをきざみ幅
    end subroutine
      
    subroutine uegtlb(z,mx,nx,ny,dx)              !コンターレベル値を格子点値を与える配列,きざみ値,レベル数で設定する．
      real,      intent(in), dimension(mx,*) :: z
      integer,   intent(in) :: mx                 !配列zの第1次元整合寸法
      integer,   intent(in) :: nx                 !作画に使う配列zの第1次元寸法
      integer,   intent(in) :: ny                 !作画に使う配列zの第2次元寸法
      real,      intent(in) :: dx                 !dx > 0 のときdxをきざみ幅
    end subroutine
      
    subroutine uestlv(tlev1,tlev2,ipat)           !ぬりわけるレベルとパターンを1レベルごと指定する．
      real,      intent(in) :: tlev1              !ぬりわけるレベルの下限値
      real,      intent(in) :: tlev2              !ぬりわけるレベルの上限値
      integer,   intent(in) :: ipat               !トーンパターン番号
    end subroutine
      
    subroutine ueqtlv(tlev1,tlev2,ipat,iton)      !第iton番目のトーンレベルの属性
      real,      intent(out) :: tlev1
      real,      intent(out) :: tlev2
      integer,   intent(out) :: ipat
      integer,   intent(in) :: iton
    end subroutine
      
    subroutine ueqntl(nton)                       !現在設定されているトーンレベルの数
      integer,   intent(out) :: nton
    end subroutine
      
    subroutine uestln(tlevn,ipatn,nton)           !ぬりわけるレベルとパターンを配列で複数レベル指定する．
      real,      intent(in), dimension(nton+1) :: tlevn !ぬりわけるレベルの値を格納する配列．
      integer,   intent(in), dimension(nton) :: ipatn !トーンパターン番号を格納する配列．
      integer,   intent(in) :: nton               !配列ipatnの大きさ
    end subroutine
      
    subroutine ueitlv()                           !トーンレベルを無効にする．
    end subroutine
      
    subroutine uepget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ueiget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uerget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uelget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uepset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ueiset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uerset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uelset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uepstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ueistx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uerstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uelstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uepqnp(ncp)                        !内部変数の総数を求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine uepqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine uepqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する
      character(len=*), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine uepqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine uepsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine
      
  end interface
end module
!uepack library end ----

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program regional

  use dcl
  integer,parameter :: np=2
  character(len=32) :: cttl
  character(len=3) :: ctr(np) = (/'MER','CON'/)

    call DclOpenGraphics

    call DclSetAspectRatio( 2.0, 1.0 )
    call DclDivideFrame( 'y', 2, 1 )

    do i=1,np
      call DclNewFrame

      call DclSetWindow( 123.0, 147.0, 30.0, 46.0)
      call DclSetViewPort( 0.1, 0.9, 0.1, 0.9 )
      call DclTransShortToNum(ctr(i),ntr)
      call DclSetTransNumber( ntr )
      call DclFitMapParm
      call DclSetTransFunction

      call DclSetParm( 'ENABLE_CLIPPING', .true. )
      call DclDrawDeviceWindowFrame( 1 )
      call DclDrawViewPortFrame( 1 )
      call DclTransShortToLong( ctr(i), cttl )
      call DclDrawTextProjected( 0.5, 0.95, cttl, height=0.03, index=3 )

!      call DclDrawMap( 'coast_japan' )
      call DclDrawMap( 'coast_world' )
      call DclDrawGlobe
    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGFNDL

      CHARACTER FONTNAME*1024,CTEXT*1024
      CHARACTER CSGI*1,NTEXT*1

      CALL SGOPN(1)
      CALL SGFRM

      CTEXT='Please choose a font set...'
      CALL SGTXZV(0.5, 0.75, CTEXT, 0.04, 0, 0, 3)
      CTEXT='(This is drawn by DCL stroke font)'
      CALL SGTXZV(0.5, 0.70, CTEXT, 0.03, 0, 0, 3)

      CALL SWLSET('LSYSFNT', .TRUE.)

      CALL SWSLFT(FONTNAME)
      NTEXT=CSGI(0)
      CTEXT='Selected font name: '//FONTNAME//NTEXT
      CALL SGTXZV(0.5, 0.50, CTEXT, 0.04, 0, 0, 3)

      CTEXT='(This is drawn by DCL defalt system font)'
      CALL SGTXZV(0.5, 0.45, CTEXT, 0.03, 0, 0, 3)

      CALL SWCSET('FONTNAME', FONTNAME)

      CTEXT='GFD Dennou Common Library 電脳ライブラリ αβΣΩ'
      CALL SGTXZV(0.5, 0.25, CTEXT, 0.03, 0, 0, 3)
      CTEXT='(This is drawn by the selected font)'
      CALL SGTXZV(0.5, 0.20, CTEXT, 0.03, 0, 0, 3)

      CALL SGCLS

      END

      PROGRAM KIHONA

      PARAMETER( NMAX=40 )
      PARAMETER( PI=3.14159 )
      PARAMETER( XMIN=0., XMAX=4*PI, YMIN=-1., YMAX=1. )
      REAL X(0:NMAX), Y(0:NMAX)

      DT = XMAX/NMAX
      DO 10 N=0,NMAX
        X(N) = N*DT
        Y(N) = SIN(X(N))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

      CALL SGLSET( 'LCHAR', .TRUE. )

*-- ラベルつき折れ線 ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.9,  1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGSPLC( 'A' )
      CALL SGSPLT( 1 )
      CALL SGPLU( NMAX+1, X, Y )

*-- 順序ラベル: A,B,C,... ----
      DO 20 I=1,2
        VYMIN = 0.9 - 0.1*I
        VYMAX = VYMIN + 0.1
        CALL SGSWND( XMIN, XMAX,  YMIN,  YMAX )
        CALL SGSVPT(   0.,   1., VYMIN, VYMAX )
        CALL SGSTRN( 1 )
        CALL SGSTRF

        CALL SGNPLC
        CALL SGPLU( NMAX+1, X, Y )
   20 CONTINUE

*-- 順序ラベル: K=1,K=2,... ----
      CALL SGSPLC( 'K=1' )

      DO 30 I=3,4
        VYMIN = 0.9 - 0.1*I
        VYMAX = VYMIN + 0.1
        CALL SGSWND( XMIN, XMAX,  YMIN,  YMAX )
        CALL SGSVPT(   0.,   1., VYMIN, VYMAX )
        CALL SGSTRN( 1 )
        CALL SGSTRF

        CALL SGSPLT( I-1 )
        CALL SGPLU( NMAX+1, X, Y )
        CALL SGNPLC
   30 CONTINUE

        CALL SGSPLT( 1 )

*--  ラベルの文字列の高さ ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.4,  0.5 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGSPLS( 0.01 )
      CALL SGSPLC( 'small' )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGSPLS( 0.02 )

*--  ラベルの角度 ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.3,  0.4 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGLSET( 'LROT', .TRUE. )
      CALL SGISET( 'IROT', 90 )
      CALL SGSPLC( 'ROT' )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGLSET( 'LROT', .FALSE. )

*--  ラベルの間隔 ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.2,  0.3 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGRSET( 'CWL', 5. )
      CALL SGSPLC( 'CWL' )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGRSET( 'CWL', 30. )

*--  ラベルの書き始め ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.1,  0.2 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGRSET( 'FFCT', 0.9 )
      CALL SGSPLC( 'FCT' )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UEGTLA
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEGTLA(XMIN,XMAX,DX)

      LOGICAL   LBOUND,LEPSL
      EXTERNAL  RGNGE,IRLE,IRGE


      IF (.NOT.(XMIN.LT.XMAX)) THEN
        CALL MSGDMP('E','UEGTLA','XMIN SHOULD BE LEAST THAN XMAX.')
      END IF

      CALL UEIGET('NLEV    ',NLEV  )
      CALL UEIGET('ITPAT   ',ITPAT )
      CALL UEIGET('ICOLOR1 ',ICLR1 )
      CALL UEIGET('ICOLOR2 ',ICLR2 )
      CALL UELGET('LBOUND  ',LBOUND)

      CALL GLLGET('LEPSL   ',LEPSL )

      CALL GLLSET('LEPSL   ',.TRUE.)

      IF (DX.GT.0) THEN
        DZ=DX
      ELSE IF (DX.EQ.0) THEN
        DZ=RGNGE((XMAX-XMIN)/NLEV)
      ELSE
        NL=MAX(1,NINT(ABS(DX)))
        DZ=RGNGE((XMAX-XMIN)/NL)
      END IF

      ZMIN=IRLE(XMIN/DZ)*DZ
      ZMAX=IRGE(XMAX/DZ)*DZ
      N=NINT((ZMAX-ZMIN)/DZ)

      CALL UEITLV

      DO 10 I=1,N

        TLEV1=DZ*NINT((ZMIN+(I-1)*DZ)/DZ)
        TLEV2=TLEV1+DZ
        IF (LBOUND .AND. I.EQ.1) TLEV1=MAX(TLEV1,XMIN)
        IF (LBOUND .AND. I.EQ.N) TLEV2=MIN(TLEV2,XMAX)

        IF (N.EQ.1) THEN
          IPAT=(ICLR2-ICLR1)/2*1000+ITPAT
        ELSE
          IPAT=NINT((ICLR2-ICLR1)/REAL(N-1)*(I-1)+ICLR1)*1000+ITPAT
        END IF

        CALL UESTLV(TLEV1,TLEV2,IPAT)

   10 CONTINUE

      CALL GLLSET('LEPSL   ',LEPSL )

      END

*-----------------------------------------------------------------------
*     UGPQNP / UGPQID / UGPQCP / UGPQVL / UGPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 37)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'INDEX   ' /, ITYPE( 1) / 1 /
      DATA      CPARAS( 2) / 'LNRMAL  ' /, ITYPE( 2) / 2 /
      DATA      CPARAS( 3) / 'LEQRAT  ' /, ITYPE( 3) / 2 /
      DATA      CPARAS( 4) / 'XFACT1  ' /, ITYPE( 4) / 3 /
      DATA      CPARAS( 5) / 'YFACT1  ' /, ITYPE( 5) / 3 /
      DATA      CPARAS( 6) / 'XFACT2  ' /, ITYPE( 6) / 3 /
      DATA      CPARAS( 7) / 'YFACT2  ' /, ITYPE( 7) / 3 /
      DATA      CPARAS( 8) / 'LMSG    ' /, ITYPE( 8) / 2 /
      DATA      CPARAS( 9) / 'ICENT   ' /, ITYPE( 9) / 1 /
      DATA      CPARAS(10) / 'LMISSP  ' /, ITYPE(10) / 2 /
      DATA      CPARAS(11) / 'ITYPE1  ' /, ITYPE(11) / 1 /
      DATA      CPARAS(12) / 'LSMALL  ' /, ITYPE(12) / 2 /
      DATA      CPARAS(13) / 'RSMALL  ' /, ITYPE(13) / 3 /
      DATA      CPARAS(14) / 'ITYPE2  ' /, ITYPE(14) / 1 /
      DATA      CPARAS(15) / 'RSIZEM  ' /, ITYPE(15) / 3 /
      DATA      CPARAS(16) / 'RSIZET  ' /, ITYPE(16) / 3 /
      DATA      CPARAS(17) / 'XTTL    ' /, ITYPE(17) / 3 /
      DATA      CPARAS(18) / 'IXINT   ' /, ITYPE(18) / 1 /
      DATA      CPARAS(19) / 'IYINT   ' /, ITYPE(19) / 1 /

*     < PARAMETERS FOR UNIT VECTOR >

      DATA      CPARAS(20) / 'LUNIT   ' /, ITYPE(20) / 2 /
      DATA      CPARAS(21) / 'LUMSG   ' /, ITYPE(21) / 2 /
      DATA      CPARAS(22) / 'VXUOFF  ' /, ITYPE(22) / 3 /
      DATA      CPARAS(23) / 'VYUOFF  ' /, ITYPE(23) / 3 /
      DATA      CPARAS(24) / 'VXULOC  ' /, ITYPE(24) / 3 /
      DATA      CPARAS(25) / 'VYULOC  ' /, ITYPE(25) / 3 /
      DATA      CPARAS(26) / 'UXUNIT  ' /, ITYPE(26) / 3 /
      DATA      CPARAS(27) / 'UYUNIT  ' /, ITYPE(27) / 3 /
      DATA      CPARAS(28) / 'VXUNIT  ' /, ITYPE(28) / 3 /
      DATA      CPARAS(29) / 'VYUNIT  ' /, ITYPE(29) / 3 /

*     < PARAMETERS FOR TITLES OF UNIT VECTOR >

      DATA      CPARAS(30) / 'IUNTTL  ' /, ITYPE(30) / 1 /
      DATA      CPARAS(31) / 'RSIZEUT ' /, ITYPE(31) / 3 /
      DATA      CPARAS(32) / 'IUINDX  ' /, ITYPE(32) / 1 /
      DATA      CPARAS(33) / 'IUTXRO  ' /, ITYPE(33) / 1 /
      DATA      CPARAS(34) / 'IUTYRO  ' /, ITYPE(34) / 1 /
      DATA      CPARAS(35) / 'VUTOFF  ' /, ITYPE(35) / 3 /
      DATA      CPARAS(36) / 'RHFACT  ' /, ITYPE(36) / 3 /
      DATA      CPARAS(37) / 'RUNDEF  ' /, ITYPE(37) / 3 /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'VECTOR_INDEX' /
      DATA      CPARAL( 2) / 'ENABLE_VECTOR_NORMALIZING' /
      DATA      CPARAL( 3) / 'FIX_VECTOR_PROPORTION' /
      DATA      CPARAL( 4) / 'VECTOR_SCALING_FACTOR_X' /
      DATA      CPARAL( 5) / 'VECTOR_SCALING_FACTOR_Y' /
      DATA      CPARAL( 6) / '****XFACT2  ' /
      DATA      CPARAL( 7) / '****YFACT2  ' /
      DATA      CPARAL( 8) / 'ENABLE_VECTOR_MESSAGE' /
      DATA      CPARAL( 9) / 'VECTOR_GRID_POSITION' /
      DATA      CPARAL(10) / 'ENABLE_MISS_VECTER_MARKER' /
      DATA      CPARAL(11) / 'MISS_VECTOR_MARKER_TYPE' /
      DATA      CPARAL(12) / 'ENABLE_SMALL_VECTOR_MARKER' /
      DATA      CPARAL(13) / 'SMALL_VECTOR_THRESHOLD' /
      DATA      CPARAL(14) / 'SMALL_VECTOR_MARKER_TYPE' /
      DATA      CPARAL(15) / 'MISS_VECTOR_MARKER_SIZE' /
      DATA      CPARAL(16) / 'VECTOR_MESSAGE_HEIGHT' /
      DATA      CPARAL(17) / 'VECTOR_MESSAGE_POSITION' /
      DATA      CPARAL(18) / '****IXINT   ' /
      DATA      CPARAL(19) / '****IYINT   ' /

*     < PARAMETERS FOR UNIT VECTOR >

      DATA      CPARAL(20) / 'DRAW_UNIT_VECTOR' /
      DATA      CPARAL(21) / 'DRAW_UNIT_VECTOR_MESSAGE' /
      DATA      CPARAL(22) / 'UNIT_VECTOR_X_OFFSET' /
      DATA      CPARAL(23) / 'UNIT_VECTOR_Y_OFFSET' /
      DATA      CPARAL(24) / 'UNIT_VECTOR_X_LOCATION' /
      DATA      CPARAL(25) / 'UNIT_VECTOR_Y_LOCATION' /
      DATA      CPARAL(26) / 'UNIT_VECTOR_X_LENGTH' /
      DATA      CPARAL(27) / 'UNIT_VECTOR_Y_LENGTH' /
      DATA      CPARAL(28) / 'UNIT_VECTOR_X_NORMALIZED_LENGTH' /
      DATA      CPARAL(29) / 'UNIT_VECTOR_Y_NORMALIZED_LENGTH' /

*     < PARAMETERS FOR TITLES OF UNIT VECTOR >

      DATA      CPARAL(30) / '****IUNTTL  ' /
      DATA      CPARAL(31) / 'UNIT_VECTOR_TITLE_HEIGHT' /
      DATA      CPARAL(32) / 'UNIT_VECTOR_TITLE_INDEX' /
      DATA      CPARAL(33) / 'UNIT_VECTOR_X_TITLE_ANGLE' /
      DATA      CPARAL(34) / 'UNIT_VECTOR_Y_TITLE_ANGLE' /
      DATA      CPARAL(35) / '****VUTOFF  ' /
      DATA      CPARAL(36) / '****RHFACT  ' /
      DATA      CPARAL(37) / '----RUNDEF  ' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UGPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UGPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UGPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','UGPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UGIQID(CPARAS(IDX), ID)
          CALL UGIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UGLQID(CPARAS(IDX), ID)
          CALL UGLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UGRQID(CPARAS(IDX), ID)
          CALL UGRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UGPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UGIQID(CPARAS(IDX), ID)
          CALL UGISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UGLQID(CPARAS(IDX), ID)
          CALL UGLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UGRQID(CPARAS(IDX), ID)
          CALL UGRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UGPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     UXPLBL : PLOT LABELS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPLBL(CSIDE,ISLCT,UX,CH,NC,N)

      REAL      UX(*)
      CHARACTER CSIDE*1,CH(*)*(*)

      LOGICAL   LBTWN,LUXCHK,LCHREQ
      CHARACTER CSLCT*1


      IF (.NOT.(LUXCHK(CSIDE))) THEN
        CALL MSGDMP('E','UXPLBL','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UXPLBL','''ISLCT'' IS INVALID.')
      END IF
      IF (NC.LE.0) THEN
        CALL MSGDMP('E','UXPLBL',
     +       'CHARACTER LENGTH IS LESS THAN OR EQUAL TO ZERO.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UXPLBL','NUMBER OF POINTS IS INVALID.')
      END IF

      WRITE(CSLCT,'(I1)') ISLCT

      CALL UZRGET('ROFFX'//CSIDE,ROFFX)
      CALL UZRGET('RSIZEL'//CSLCT,RSIZE)
      CALL UZIGET('ICENTX'//CSIDE,ICENT)
      CALL UZIGET('IROTLX'//CSIDE,IROTA)
      CALL UZIGET('INDEXL'//CSLCT,INDEX)
      CALL UZRGET('PAD1',PAD)
      CALL UZLGET('LBTWN',LBTWN)
      IF (LBTWN) THEN
        CALL UZRGET('RBTWN',RBTWN)
        NCMAX=N-1
      ELSE
        NCMAX=N
      END IF

      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
        IF (LCHREQ(CSIDE,'B')) THEN
          POSY=UYMN
          IFLAG=-1
        ELSE
          POSY=UYMX
          IFLAG=+1
        END IF
      ELSE
        CALL UZRGET('UYUSER',POSY)
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      JROTA=MOD(IROTA+2,4)-2
      IF (JROTA.EQ.-2) THEN
        JROTA=0
      END IF

      RLC=1
      DO 10 I=1,NCMAX
        CALL SZQTXW(CH(I),LCW,WXCH,WYCH)
        IF (JROTA.EQ.0 .AND. WYCH.GT.RLC) THEN
          RLC=WYCH
        ELSE IF (JROTA.NE.0 .AND. WXCH.GT.RLC) THEN
          RLC=WXCH
        END IF
   10 CONTINUE

      IC=JROTA*ICENT*IFLAG
      ROFFZ=ROFFX+RSIZE*(PAD+RLC*(1+IC)*0.5)*IFLAG
      ROFFX=ROFFX+RSIZE*(PAD+RLC)*IFLAG

      IF (LBTWN) THEN
        CALL UXPLBB(UX,CH,NC,N,POSY,ROFFZ,RSIZE,IROTA,ICENT,INDEX,
     +              RBTWN,.TRUE.,.FALSE.)
      ELSE
        CALL UXPLBA(UX,CH,NC,N,POSY,ROFFZ,RSIZE,IROTA,ICENT,INDEX)
      END IF

      CALL UZRSET('ROFFX'//CSIDE,ROFFX)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UXYZ6

      PARAMETER( ID0=19911201, ND=720, RND=ND )

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL UZFACT( 0.8 )
      CALL GRFRM

      CALL GRSWND( -180., 180., RND, 0.0 )
      CALL GRSVPT(   0.2,  0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UXAXDV( 'B', 10., 60. )
      CALL UXAXDV( 'T', 10., 60. )
      CALL UXSTTL( 'B', 'LONGITUDE', 0. )

      CALL UCYACL( 'L', ID0, ND )

      CALL UZLSET( 'LABELYR', .TRUE. )
      CALL UYAXDV( 'R', 20., 100. )
      CALL UZISET( 'IROTCYR', -1 )
      CALL UYSTTL( 'R', 'DAY NUMBER', 0. )

      CALL UXMTTL( 'T', 'UXAXDV/UCYACL', 0. )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     FILL PATTERN ON MAP (GEOGRAPHIC COORDINATE)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMFMAP(CDSN)

      CHARACTER CDSN*(*)

      PARAMETER (NPMAX=8192)

      REAL      XLAT(NPMAX),XLON(NPMAX)
      CHARACTER CDSNX*1024,CMSG*80
      LOGICAL   LFLAKE

      EXTERNAL  IUFOPN


*     / SET INTERNAL PARAMETERS /

      CALL SGISET('IRMODE', 0)

*     / GET INTERNAL PARAMETERS /

      CALL SGIGET('IBGCLI',IBGCLI)
      CALL UMIGET('IPATLAND',IPLAND)
      CALL UMIGET('IPATLAKE',IPLAKE)
      CALL UMLGET('LFILLAKE',LFLAKE)
      IF (.NOT. LFLAKE) IPLAKE = IBGCLI*1000+999

*     / INQUIRE OUTLINE FILE /
      CALL UMQFNM(CDSN,CDSNX)
      IF (CDSNX.EQ.' ') THEN
        CMSG='OUTLINE FILE = '//CDSN(1:LENC(CDSN))
        CALL MSGDMP('M','UMPMAP',CMSG)
        CALL MSGDMP('E','UMPMAP','OUTLINE FILE DOES NOT EXIST.')
      END IF

*     / OPEN OUTLINE FILE /

      IU=IUFOPN()
      OPEN(IU,FILE=CDSNX,FORM='UNFORMATTED',STATUS='OLD')
      REWIND(IU)

*     / READ OUTLINE DATA AND PLOT /

   10 CONTINUE
        READ(IU,IOSTAT=IOS) NPTS,IGID,XLATMX,XLATMN,XLONMX,XLONMN,
     +     (XLAT(I),XLON(I),I=1,NPTS/2)
        IF (IOS.EQ.0) THEN
          IF (NPTS .GT. 10 .OR.
     +      (XLON(1).EQ.XLON(NPTS/2) .AND. XLAT(1).EQ.XLAT(NPTS/2)))
     +        THEN
            IF (IGID.EQ.1) THEN
             CALL SGTNZU(NPTS/2,XLON,XLAT,IPLAND)
            ELSE IF (IGID.EQ.2) THEN
              CALL SGTNZU(NPTS/2,XLON,XLAT,IPLAKE)
            END IF
          END IF
        END IF
      IF (IOS.EQ.0) GO TO 10
   20 CONTINUE

      CLOSE(IU)

      END

*-----------------------------------------------------------------------
      SUBROUTINE RFFTF1 (N,C,CH,WA,IFAC)
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = IFAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IF (IP .NE. 4) GO TO 102
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL RADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  101    CALL RADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  102    IF (IP .NE. 2) GO TO 104
         IF (NA .NE. 0) GO TO 103
         CALL RADF2 (IDO,L1,C,CH,WA(IW))
         GO TO 110
  103    CALL RADF2 (IDO,L1,CH,C,WA(IW))
         GO TO 110
  104    IF (IP .NE. 3) GO TO 106
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 105
         CALL RADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 110
  105    CALL RADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))
         GO TO 110
  106    IF (IP .NE. 5) GO TO 108
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 107
         CALL RADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  107    CALL RADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  108    IF (IDO .EQ. 1) NA = 1-NA
         IF (NA .NE. 0) GO TO 109
         CALL RADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         NA = 1
         GO TO 110
  109    CALL RADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
         NA = 0
  110    L2 = L1
  111 CONTINUE
      IF (NA .EQ. 1) RETURN
      DO 112 I=1,N
         C(I) = CH(I)
  112 CONTINUE
      RETURN
      END

*-----------------------------------------------------------------------
*     UYAXDV : PLOT Y-AXIS (SPECIFY DIVISION)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYAXDV(CSIDE,DY1,DY2)

      PARAMETER (N=200)

      REAL      UY(N)
      CHARACTER CSIDE*1

      LOGICAL   LABEL,LEPSL,LREQ,LRLE,LUYCHK


*     / CHECK ARGUMENTS /

      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYAXDV','SIDE PARAMETER IS INVALID.')
      END IF
      IF (DY1.LE.0) THEN
        CALL MSGDMP('E','UYAXDV','MINOR DIVISION IS LESS THAN 0.')
      END IF
      IF (DY2.LE.0) THEN
        CALL MSGDMP('E','UYAXDV','MAJOR DIVISION IS LESS THAN 0.')
      END IF
      IF (DY1.LE.DY2) THEN
        DZ1=DY1
        DZ2=DY2
      ELSE
        CALL MSGDMP('W','UYAXDV',
     +    'MINOR DIVISION IS GREATER THAN MAJOR DIVISION.')
        DZ1=DY2
        DZ2=DY1
        CALL MSGDMP('M','-CNT.-','DY1 AND DY2 WERE SWITCHED.')
      END IF
      FRC=DZ2/DZ1-NINT(DZ2/DZ1)
      IF (ABS(FRC).GT.0.0001) THEN
        CALL MSGDMP('W','UYAXDV',
     +    'MAJOR DIVISION IS NOT MULTIPLE OF MINOR DIVISION.')
      END IF

*     / GET & SET INTERNAL PARAMETERS /

      CALL GLLGET('LEPSL',LEPSL)
      CALL GLRGET('REPSL',REPSL)
      CALL GLLSET('LEPSL',.TRUE.)

*     / SET SCALING FOR OFFSET /

      CALL UYSOFF

*     / INQUIRE NORMALIZATION TRANSFORMATION /

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)

      UYMNW=MIN(UYMN,UYMX)
      UYMXW=MAX(UYMN,UYMX)

*     / PLOT VERTICAL AXIS /

      CALL UYPAXS(CSIDE,2)

*     / GENERATE NUMBERS FOR MINOR TICKMARKS /

      NN=0
      RY=IRLE(UYMNW/DZ1)*DZ1
      IF (LREQ(UYMNW,RY)) THEN
        Y=RY
      ELSE
        Y=RY+DZ1
      END IF
   11 IF (.NOT.LRLE(Y,UYMXW)) GO TO 10
        NN=NN+1
        IF (ABS(Y).LT.DZ1*REPSL*NN) THEN
          Y=0
        END IF
        UY(NN)=Y
        Y=Y+DZ1
        GO TO 11
   10 CONTINUE

      IF (NN.EQ.0) THEN
        CALL MSGDMP('W','UYAXDV','THERE IS NO TICKMARK / LABEL.')
        GO TO 100
      ELSE IF (NN.GT.N) THEN
        CALL MSGDMP('E','UYAXDV','WORKING AREA IS NOT ENOUGH.')
      END IF

*     / IF DZ1.NE.DZ2 THEN PLOT MINOR TICKMARKS
*       ELSE SKIP TO THE PROCESS FOR MAJOR TICKMARKS /

      IF (DZ2.EQ.DZ1) GO TO 20

      CALL UYPTMK(CSIDE,1,UY,NN)

*     / GENERATE NUMBERS FOR MAJOR TICKMARKS AND LABELS /

      NN=0
      RY=IRLE(UYMNW/DZ2)*DZ2
      IF (LREQ(UYMNW,RY)) THEN
        Y=RY
      ELSE
        Y=RY+DZ2
      END IF
   16 IF (.NOT.LRLE(Y,UYMXW)) GO TO 15
        NN=NN+1
        IF (ABS(Y).LT.DZ2*REPSL*NN) THEN
          Y=0
        END IF
        UY(NN)=Y
        Y=Y+DZ2
        GO TO 16
   15 CONTINUE

   20 CONTINUE
      CALL UYPTMK(CSIDE,2,UY,NN)
      CALL UZLGET('LABELY'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UYPNUM(CSIDE,1,UY,NN)
      END IF

*     / RESET INTERNAL PARAMETER /

  100 CALL GLLSET('LEPSL',LEPSL)

*     / RESET SCALING FOR OFFSET /

      CALL UYROFF

      END

program miss01

  use dcl

  integer,parameter :: nmax=40
  real,parameter :: xmin=0., xmax=4*DCL_PI, ymin=-1., ymax=1.
  real :: x(0:nmax), y(0:nmax)

    x = (/( xmax*real(n)/nmax, n=0,nmax )/)
    y = sin(x)

    n1 = nmax/4
    y(n1-1:n1+1) = 999.

    n2 = n1*3
    y(n2-1) = 999.
    y(n2+1) = 999.

    call DclOpenGraphics()
    call DclNewFrame

!-- 欠損値処理なし ----
    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort(  0.1,  0.9,  0.7,  0.9 )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclDrawLine( x, y )

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort(  0.1,  0.9,  0.5,  0.7 )
    call DclSetTransFunction

    call DclDrawMarker( x, y, type=3 )

!-- 欠損値処理 ----
    call DclSetParm('INTERPRET_MISSING_VALUE', .true. )

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort(  0.1,  0.9,  0.3,  0.5 )
    call DclSetTransFunction

    call DclDrawLine( x, y )

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort(  0.1,  0.9,  0.1,  0.3 )
    call DclSetTransFunction

    call DclDrawMarker( x, y )

    call DclCloseGraphics

end program

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program sample_3d05

  use dcl
  integer,parameter :: nx=21, ny=21
  real,parameter ::  xmin=-10,  xmax= 10,  ymin=-10,  ymax= 10
  real,parameter :: vxmin=0.2, vxmax=0.8, vymin=0.1, vymax=0.5
  real,parameter ::  zmin=0.0,  zmax= 20
  real,parameter :: vzmin=0.0, vzmax=0.6
  real,parameter :: xvp3=-0.7, yvp3=-0.7, zvp3=1.2
  real,parameter :: xfc3=(vxmax-vxmin)/2, yfc3=(vymax-vymin)/2
  real,parameter :: zfc3=(vzmax-vzmin)/2
  real,parameter :: dx1=1, dx2=5, dy1=1, dy2=4, dz1=1, dz2=5, pmin=0, pmax=1
  integer,parameter :: kmax=5
  real :: u(nx,ny), v(nx,ny), p(nx,ny)

    do j=1,ny
      do i=1,nx
        x = xmin + (xmax-xmin)*(i-1)/(nx-1)
        y = ymin + (ymax-ymin)*(j-1)/(ny-1)
        u(i,j) =  x
        v(i,j) = -y
        p(i,j) = exp( -x**2/64 -y**2/25 )
      end do
    end do

    call DclOpenGraphics()
    call DclNewFrame

!-- x-y 平面: 下レベル ----
    call DclSetWindow(  xmin,  xmax,  ymin,  ymax )
    call DclSetViewPort( vxmin, vxmax, vymin, vymax )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSet2DPlane( 1, 2, vzmin )
    call DclSet3DEyePoint( xvp3, yvp3, zvp3 )
    call DclSet3DObjectPoint( xfc3, yfc3, zfc3 )
    call DclSet3DProjection

    call DclDrawAxis( 'bt', dx1, dx2 )
    call DclDrawTitle( 'b', 'x-axis', 0. )

    call DclDrawAxis( 'lr', dy1, dy2 )
    call DclDrawTitle( 'l', 'y-axis', 0. )

    call DclSetParm( 'VECTOR:rsizet', 0.014 )
    call DclDrawVectors( u, v )

!-- x-y 平面: 上レベル ----
    vzlev = vzmin + (vzmax-vzmin)*.6
    call DclSet2DPlane( 1, 2, vzlev )
    call DclSet3DProjection

    dp = (pmax-pmin)/kmax
    do k=1,kmax
      tlev1 = (k-1)*dp
      tlev2 = tlev1 + dp
      ipat  = 600 + k - 1
      call DclSetShadeLevel( tlev1, tlev2, ipat )
    end do
    call DclShadeContour( p )

    call DclSetParm( 'CONTOUR:lmsg' , .false. )
    call DclSetContourLevel( p, 0.1 )
    call DclDrawContour( p )
    call DclDrawViewPortFrame( 1 )

!-- x-z 平面 ----
    call DclSetWindow(  xmin,  xmax,  zmin,  zmax )
    call DclSetViewPort( vxmin, vxmax, vzmin, vzmax )
    call DclSetTransNumber( 1 )
    call DclSetTransFunction

    call DclSet2DPlane( 1, 3, vymax )
    call DclSet3DProjection

    call uzinit
    call DclDrawAxis( 'l', dz1, dz2 )
    call DclDrawTitle( 'l', 'z-axis', 0. )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     DETERMINE GRID SPACING
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMSGRD


      CALL UMRGET('DGRIDMJ', DGRMJX)
      CALL UMRGET('DGRIDMN', DGRMNX)
      CALL GLRGET('RUNDEF' , RUNDEF)

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CALL STITRF((VXMIN+VXMAX)/2., (VYMIN+VYMAX)/2., UXC, UYC)

      VR = SQRT((VXMAX-VXMIN)**2 + (VYMAX-VYMIN)**2)/SQRT(2.)
      IF (UXC.NE.RUNDEF .AND. UYC.NE.RUNDEF .AND.
     +   UYC.LT.89.    .AND. UYC.GT.-89.) THEN
        CALL STFTRF(UXC-0.5, UYC-0.5, VX1, VY1)
        CALL STFTRF(UXC+0.5, UYC+0.5, VX2, VY2)
	R = SQRT((VX2-VX1)**2 + (VY2-VY1)**2)/VR/0.01234
      ELSE
        CALL SGRGET('SIMFAC', R)
	R = R/VR
      END IF

      IF (R .LE. 1.) THEN
        DGRMJ = 90.
        DGRMN = 30.
      ELSE IF (R .LE. 2.) THEN
        DGRMJ = 45.
        DGRMN = 15.
      ELSE IF (R .LE. 3.) THEN
        DGRMJ = 30.
        DGRMN = 10.
      ELSE IF (R .LE. 4.) THEN
        DGRMJ = 20.
        DGRMN =  5.
      ELSE IF (R .LE. 8.) THEN
        DGRMJ = 10.
        DGRMN =  2.
      ELSE IF (R .LE. 15.) THEN
        DGRMJ =  5.
        DGRMN =  1.
      ELSE IF (R .LE. 30.) THEN
        DGRMJ =  2.
        DGRMN =  0.5
      ELSE
        DGRMJ =  1.
        DGRMN =  0.2
      END IF

      IF (DGRMJX.EQ.RUNDEF) CALL UMRSET('DGRIDMJ', DGRMJ)
      IF (DGRMNX.EQ.RUNDEF) CALL UMRSET('DGRIDMN', DGRMN)

      END

program errorbar

  use dcl
  integer,parameter :: n=20, m=5
  real,dimension(n) :: x0, x1, x2, y0, y1, y2
  real,dimension(m) :: a

!-----------------------------------------------------------------------

    dt = 1./(n-1)
    pi = 3.14159

    a = (/( (-1)**j *2./((j*2-1)*pi), j=1,m ) /)

    do i=1, n
      t     = dt*(i-1)*2*pi
      x0(i) = dt*(i-1)
      y1(i) = a(1)*cos(t)
      y2(i) = 0.
      do j=1, m
        jj = j*2-1
        yy = a(j)*cos(jj*t)
        y2(i)  = y2(i) + yy
      end do
    end do
    y0 = ( y1 + y2 )/2
    x1 = x0 - abs( y1 - y2 )/5
    x2 = x0 + abs( y1 - y2 )/5

!-----------------------------------------------------------------------

    call DclOpenGraphics()
    call DclNewFrame
    call DclSetParm( 'GRAPH:LCLIP', .true.)

    call DclScalingPoint( x0, y0)
    call DclScalingPoint( x1, y1)
    call DclScalingPoint( x2, y2)
    call DclFitScalingParm
    call DclSetTransFunction

    call DclDrawScaledAxis

    call DclDrawYErrorBar( x0, y1, y2)
    call DclDrawXErrorBar( x1, x2, y0, type=3, index=33)

    call DclDrawMarker( x0, y0, type=4, index=21 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     COLORMAP LIST LOADING
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWCMLL

      CHARACTER CTF*(*),CTD*(*)

      PARAMETER (NMAX=99)

      LOGICAL   LFIRST
      CHARACTER CTR1(NMAX)*80,CTR2(NMAX)*80,CFILE*1024,CMSG*80

      EXTERNAL  IUFOPN

      DATA      LFIRST/.TRUE./

      SAVE


      IF (.NOT.LFIRST) RETURN

*     / OPEN LIST FILE : MAYBE SYSTEM DEPENDENT /

      CALL SWQFNM('CMAPLIST',CFILE)
      IF (CFILE.EQ.' ') THEN
        CALL MSGDMP('E','SWCMLL','COLORMAP LIST DOES NOT EXIST.')
      END IF

      IU=IUFOPN()
      OPEN(IU,FILE=CFILE,FORM='FORMATTED')
      REWIND(IU)

*     / LOAD COLORMAP LIST /

      READ(IU,*,IOSTAT=IOS) NC
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','SWCMLL','COLORMAP LIST IS INVALID')
      END IF
      IF (NC.GT.NMAX) THEN
        CALL MSGDMP('E','SWCMLL','COLORMAP LIST OVERFLOWS')
      END IF

      DO 10 N=1,NC
        READ(IU,*,IOSTAT=IOS) CTR1(N),CTR2(N)
        IF (IOS.NE.0) THEN
          CALL MSGDMP('E','SWCMLL','COLORMAP LIST IS INVALID')
        END IF
   10 CONTINUE
      NNMAX=NC
      LFIRST=.FALSE.

*     / CLOSE TABLE FILE /

      CLOSE(IU)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQCMN(NN)

      IF (LFIRST) THEN
        CALL MSGDMP('E','SWQCMN',
     +       'COLORMAP LIST FILE SHOULD BE READ FIRST USING "SWCMLL"')
      END IF

      NN=NNMAX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQCMF(NTX,CTF)

      IF (LFIRST) THEN
        CALL MSGDMP('E','SWQCMF',
     +       'COLORMAP LIST FILE SHOULD BE READ FIRST USING "SWCMLL"')
      END IF

      IF (1.LE.NTX .AND. NTX.LE.NNMAX) THEN
        CTF=CTR1(NTX)
      ELSE
        CMSG='COLORMAP NUMBER <##> IS OUT OF RANGE.'
        CALL CHNGI(CMSG,'##',NTX,'(I2)')
        CALL MSGDMP('E','SWQCMF',CMSG)
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQCMD(NTX,CTD)

      IF (LFIRST) THEN
        CALL MSGDMP('E','SWQCMD',
     +       'COLORMAP LIST FILE SHOULD BE READ FIRST USING "SWCMLL"')
      END IF

      IF (1.LE.NTX .AND. NTX.LE.NNMAX) THEN
        CTD=CTR2(NTX)
      ELSE
        CMSG='COLORMAP NUMBER <##> IS OUT OF RANGE.'
        CALL CHNGI(CMSG,'##',NTX,'(I2)')
        CALL MSGDMP('E','SWQCMD',CMSG)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLRAT(RX,RY)

      IF (RX.LT.0 .OR. RY.LT.0) THEN
        CALL MSGDMP('E','SLRAT ',
     +    'PROPORTION PARAMETER IS LESS THAN ZERO.')
      END IF

      CALL SGIGET('NLEVEL',LEV)

      CALL SLQRCT(LEV,1,XAMIN,XAMAX,YAMIN,YAMAX)
      ARAT=(YAMAX-YAMIN)/(XAMAX-XAMIN)
      BRAT=RY/RX
      IF (ARAT.GE.BRAT) THEN
        XX=0
        YY=(1-BRAT/ARAT)/2
      ELSE
        XX=(1-ARAT/BRAT)/2
        YY=0
      END IF
      CALL SLMGN(XX,XX,YY,YY)

      END

*-----------------------------------------------------------------------
*     WORKSTATION TRANSFORMATION
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE STFWTR(RX,RY,WX,WY)

      LOGICAL   LWTRFZ,LGSWRC,LPRMSG,LRNE1

      EXTERNAL  LRNE1

      SAVE

      DATA      LWTRFZ/.FALSE./,LGSWRC/.FALSE./,LPRMSG/.TRUE./


      IF (.NOT.LWTRFZ) THEN
        CALL MSGDMP('E','STFWTR',
     +    'WORKSTATION TRANSFORMATION IS NOT DEFINED.')
      END IF
      IF (.NOT.LGSWRC) THEN
        CALL MSGDMP('E','STFWTR',
     +    'WORKSTATION RECTANGLE IS NOT DEFINED.')
      END IF

      WXX = CX*RX + WX0
      WYY = CY*RY + WY0
      IF (IWTRFZ.EQ.1) THEN
        WX =  WXX + WSXMNZ
        WY =  WYY + WSYMNZ
      ELSE IF (IWTRFZ.EQ.2) THEN
        WX =  WYY + WSXMNZ
        WY = -WXX + WSYMXZ
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY STIWTR(WX,WY,RX,RY)

      IF (.NOT.LWTRFZ) THEN
        CALL MSGDMP('E','STIWTR',
     +    'WORKSTATION TRANSFORMATION IS NOT DEFINED.')
      END IF
      IF (.NOT.LGSWRC) THEN
        CALL MSGDMP('E','STIWTR',
     +    'WORKSTATION RECTANGLE IS NOT DEFINED.')
      END IF

      IF (IWTRFZ.EQ.1) THEN
        WXX =  WX - WSXMNZ
        WYY =  WY - WSYMNZ
      ELSE IF (IWTRFZ.EQ.2) THEN
        WXX = -WY + WSYMXZ
        WYY =  WX - WSXMNZ
      END IF
      RX = (WXX - WX0) / CX
      RY = (WYY - WY0) / CY

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSWTR(RXMIN,RXMAX,RYMIN,RYMAX,
     +             WXMIN,WXMAX,WYMIN,WYMAX,IWTRF)

      IF (.NOT.(RXMIN.LT.RXMAX .AND. RYMIN.LT.RYMAX)) THEN
        CALL MSGDMP('E','STSWTR',
     +    'WORKSTATION WINDOW DEFINITION IS INVALID.')
      END IF
      IF (.NOT.((0.LE.RXMIN .AND. RXMAX.LE.1)
     +    .AND. (0.LE.RYMIN .AND. RYMAX.LE.1))) THEN
        CALL MSGDMP('E','STSWTR','WORKSTATION WINDOW IS NOT WITHIN '
     +    //'THE NORMALIZED DEVICE COORDINATE UNIT SQUARE.')
      END IF
      IF (.NOT.(IWTRF.EQ.1 .OR. IWTRF.EQ.2)) THEN
        CALL MSGDMP('E','STSWTR',
     +    'TRANSFORMATION FUNCTION NUMBER IS INVALID.')
      END IF

      RWN = (RYMAX-RYMIN) / (RXMAX-RXMIN)
      RVP = (WYMAX-WYMIN) / (WXMAX-WXMIN)

      IF (LRNE1(RWN,RVP).AND.LPRMSG) THEN
        CALL MSGDMP('W','STSWTR',
     +    'WORKSTATION VIEWPORT WAS MODIFIED.')
        LPRMSG=.FALSE.
      END IF

      DX  = WXMAX - WXMIN
      DY  = WYMAX - WYMIN
      DWX = MIN (DX,     DY/RWN)
      DWY = MIN (DX*RWN, DY    )

      WXMINZ = (WXMIN + WXMAX - DWX)/2
      WXMAXZ = (WXMIN + WXMAX + DWX)/2
      WYMINZ = (WYMIN + WYMAX - DWY)/2
      WYMAXZ = (WYMIN + WYMAX + DWY)/2

      RXMINZ = RXMIN
      RXMAXZ = RXMAX
      RYMINZ = RYMIN
      RYMAXZ = RYMAX

      IWTRFZ = IWTRF
      LWTRFZ = .TRUE.

      CX = (WXMAXZ-WXMINZ) / (RXMAXZ-RXMINZ)
      CY = (WYMAXZ-WYMINZ) / (RYMAXZ-RYMINZ)
      WX0 = WXMINZ - CX*RXMINZ
      WY0 = WYMINZ - CY*RYMINZ

      CALL SZSCLL(RXMINZ,RXMAXZ,RYMINZ,RYMAXZ,0)

      RETURN
*-----------------------------------------------------------------------
      ENTRY STQWTR(RXMIN,RXMAX,RYMIN,RYMAX,
     +             WXMIN,WXMAX,WYMIN,WYMAX,IWTRF)

      IF (.NOT.LWTRFZ) THEN
        CALL MSGDMP('E','STQWTR',
     +    'WORKSTATION TRANSFORMATION IS NOT DEFINED.')
      END IF

      RXMIN = RXMINZ
      RXMAX = RXMAXZ
      RYMIN = RYMINZ
      RYMAX = RYMAXZ

      WXMIN = WXMINZ
      WXMAX = WXMAXZ
      WYMIN = WYMINZ
      WYMAX = WYMAXZ

      IWTRF = IWTRFZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSWRC(WSXMN,WSXMX,WSYMN,WSYMX)

      IF (.NOT.(WSXMN.LT.WSXMX .AND. WSYMN.LT.WSYMX)) THEN
        CALL MSGDMP('E','STSWRC',
     +    'WORKSTATION RECTANGLE IS INVALID.')
      END IF

      WSXMNZ = WSXMN
      WSXMXZ = WSXMX
      WSYMNZ = WSYMN
      WSYMXZ = WSYMX
      LGSWRC = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY STQWRC(WSXMN,WSXMX,WSYMN,WSYMX)

      IF (.NOT.LGSWRC) THEN
        CALL MSGDMP('E','STQWRC',
     +    'WORKSTATION RECTANGLE IS NOT DEFINED.')
      END IF

      WSXMN = WSXMNZ
      WSXMX = WSXMXZ
      WSYMN = WSYMNZ
      WSYMX = WSYMXZ

      RETURN
      END

!-------------------------------------------------
!interface module of oslib
!-------------------------------------------------
module os_interface
  interface

    subroutine osexec(cmd)                        !os コマンドを実行する．
      character(len=*), intent(in) :: cmd         !コマンド名
    end subroutine
      
    subroutine osgenv(cename,cval)                !環境変数の値を取得する．
      character(len=*), intent(in) :: cename      !環境変数名
      character(len=*), intent(out) :: cval       !環境変数の値
    end subroutine
      
    subroutine osqarn(n)                          !コマンドライン引数の数 N を得る．
      integer,   intent(out) :: n                  !コマンドライン引数の数
    end subroutine
      
    subroutine osgarg(n,char)                     !N 番目のコマンドライン引数 CHAR を得る． 
      integer,   intent(in) :: n                  !コマンドライン引数の位置
      character(len=*), intent(out) :: char       !n 番目のコマンドライン引数
    end subroutine
      
    subroutine osabrt()                           !エラー処理をおこなって強制終了する．
    end subroutine

  end interface
end module
!oslib library end ----

*-----------------------------------------------------------------------
*     LUDCHK
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      LOGICAL FUNCTION LUDCHK(I,J,K,L,IBR)

      INTEGER   IBR(NBR,0:*)

      PARAMETER (MAXNB=32)

      INTEGER   MASK(MAXNB)
      LOGICAL   LFRST
      CHARACTER CBPAT*(MAXNB)

      COMMON    /UDBLK1/ NB,LX,LY,NBR

      SAVE

      DATA      LFRST/.TRUE./


      IF (LFRST) THEN
        IF (NB.NE.MAXNB) THEN
          CALL MSGDMP('E','LUDCHK','MAXNB IS INAPPROPRIATE.')
        END IF
        DO 15 JJ=1,MAXNB
          DO 10 II=1,MAXNB
            IF (II.EQ.JJ) THEN
              CBPAT(II:II)='1'
            ELSE
              CBPAT(II:II)='0'
            END IF
   10     CONTINUE
          CALL CRVRS(CBPAT)
          CALL BITPCI(CBPAT,MASK(JJ))
   15   CONTINUE
        LFRST=.FALSE.
      END IF

      NN=LX*(LY*K+J)+I
      N1=NN/NB+1
      N2=MOD(NN,NB)
      LUDCHK=IAND(IBR(N1,L),MASK(N2+1)).EQ.MASK(N2+1)

      END

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program line

  use dcl

    call DclOpenGraphics
    call DclNewFrame

! 正規座標系で線分を描く
    call DclDrawLineNormalized( (/0.1,0.9/),(/0.9,0.9/) )
    call DclDrawLineNormalized( (/0.1,0.5,0.9/),(/0.8,0.75,0.8/),index=3 )

! ユーザー座標系で線分を描く
!                       xmin, xmax, ymin, ymax
    call DclSetWindow  (  0., 360., -90.,  90. )
    call DclSetViewPort( 0.1,  0.9,  0.2,  0.7 )
    call DclSetTransFunction

    call DclDrawViewPortFrame(1) ! ビューポートの枠を描く

    call DclDrawLine( (/-40.,160./), (/45.,-45./), type=2 )
    call DclDrawLine( (/-40.,160./), (/-45.,45./), type=2 )

    call DclSetParm('ENABLE_CLIPPING',.true.) ! クリッピング制御する
    call DclDrawLine( (/200.,400./), (/45.,-45./), index=21 )
    call DclDrawLine( (/200.,400./), (/-45.,45./), index=21 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSTRF

      LOGICAL   LDEG, LINIT

      EXTERNAL  RFPI


      CALL SGLGET('LDEG',LDEG)
      CALL SGIGET('ITR',ITR)

      IF (LDEG) THEN
        CP = RFPI()/180
      ELSE
        CP = 1
      END IF

*     / VIEW PORT /

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      IF (.NOT.(VXMIN.LT.VXMAX .AND. VYMIN.LT.VYMAX)) THEN
        CALL MSGDMP('E','SGSTRF','VIEWPORT DEFINITION IS INVALID.')
      END IF

      CALL SZSCLL(VXMIN,VXMAX,VYMIN,VYMAX,1)

      IF (1.LE.ITR .AND. ITR.LE.4) THEN

*       / LINEAR AND LOG /

        CALL SGQWND(UXMIN, UXMAX, UYMIN, UYMAX)

        IF (ITR.LE.2) THEN
          CX  = (VXMAX-VXMIN) / (UXMAX-UXMIN)
          VX0 = VXMIN - CX*UXMIN
        ELSE
          IF (UXMIN*UXMAX.LE.0) THEN
            CALL MSGDMP('E','SGSTRF',
     +           'THE REGION STRADDLES 0 FOR LOG TRANSFORMATION (X).')
          END IF
          CX = (VXMAX-VXMIN) / LOG10(UXMAX/UXMIN)
          VX0 = VXMIN - CX*LOG10(ABS(UXMIN))
        END IF

        IF (MOD(ITR,2).EQ.1) THEN
          CY = (VYMAX-VYMIN) / (UYMAX-UYMIN)
          VY0 = VYMIN - CY*UYMIN
        ELSE
          IF (UYMIN*UYMAX.LE.0) THEN
            CALL MSGDMP('E','SGSTRF',
     +           'THE REGION STRADDLES 0 FOR LOG TRANSFORMATION (Y).')
          END IF
          CY = (VYMAX-VYMIN) / LOG10(UYMAX/UYMIN)
          VY0 = VYMIN - CY*LOG10(ABS(UYMIN))
        END IF

        CALL STSRAD(.FALSE., .FALSE.)
        CALL STSTRF(.FALSE.)
*       CALL STSTRN(ITR, CX, CY, VX0, VY0)
        CALL STSTRI(ITR)
        CALL STSTRP(CX, CY, VX0, VY0)

      ELSE IF (5.LE.ITR .AND. ITR.LE.6) THEN

*       / ORTHOGONAL CURVE /

        CALL SGQSIM(SIMFAC, VXOFF, VYOFF)

        VX0 = (VXMAX + VXMIN)/2 + VXOFF
        VY0 = (VYMAX + VYMIN)/2 + VYOFF

        CALL STSRAD(LDEG .AND. (ITR.EQ.6),
     +              LDEG .AND. (ITR.EQ.5 .OR. ITR.EQ.6))
        CALL STSTRF(.FALSE.)
*       CALL STSTRN(ITR, SIMFAC, SIMFAC, VX0, VY0)
        CALL STSTRI(ITR)
        CALL STSTRP(SIMFAC, SIMFAC, VX0, VY0)

      ELSE IF (10.LE.ITR .AND. ITR.LE.19 .OR.
     +         20.LE.ITR .AND. ITR.LE.24 .OR.
     +         30.LE.ITR .AND. ITR.LE.34 ) THEN

*       / MAP /

        CALL SGQSIM(SIMFAC, VXOFF, VYOFF)
        CALL SGQMPL(PLX, PLY, PLROT)

        VX0 = (VXMAX + VXMIN)/2 + VXOFF
        VY0 = (VYMAX + VYMIN)/2 + VYOFF

        CALL STSRAD(LDEG, LDEG)
        CALL STSROT(RFPI()/2 - CP*PLY, CP*PLX, CP*PLROT)
        CALL STSTRF(.TRUE.)
*       CALL STSTRN(ITR, SIMFAC, SIMFAC, VX0, VY0)
        CALL STSTRI(ITR)
        CALL STSTRP(SIMFAC, SIMFAC, VX0, VY0)

*       / SET CLIPPING REGION /

        CALL SGQTXY(TXMIN, TXMAX, TYMIN, TYMAX)
        CALL SZSCLX(CP*TXMIN, CP*TXMAX)
        CALL SZSCLY(CP*TYMIN, CP*TYMAX)

*       / SATELITE VIEW /

        CALL SGRGET('RSAT',RSAT)
        CALL MPSOTG(RSAT)

*       / SET STANDARD LATITUDE /

        CALL SGRGET('STLAT1',STLAT1)
        CALL SGRGET('STLAT2',STLAT2)

        IF (ITR.EQ.20) THEN
          CALL MPSCON(CP * STLAT1)
        ELSE IF (ITR.EQ.21) THEN
          CALL MPSCOA(CP * STLAT1)
        ELSE IF (ITR.EQ.22) THEN
          CALL MPSCOC(CP*STLAT1, CP*STLAT2)
        ELSE IF (ITR.EQ.23) THEN
          CALL MPSBON(CP * STLAT1)
        END IF

      ELSE IF (ITR.EQ.51) THEN

        CALL G2QCTI(LINIT)
        IF (.NOT.LINIT) CALL MSGDMP('E','SGSTRF',
     &                   '(ITR:51) NOT YET INITIALIZED. CALL G2SCTR.')

        CALL SGQCWD(CXMIN,CXMAX,CYMIN,CYMAX)

        CALL GLRGET('RUNDEF',RUNDEF)

        IF (CXMIN.EQ.RUNDEF .AND. CXMAX.EQ.RUNDEF .OR.
     &      CYMIN.EQ.RUNDEF .AND. CYMAX.EQ.RUNDEF) THEN
          CALL G2QCTM(CXMIN, CXMAX, CYMIN, CYMAX)
        END IF

        CALL SGQVPT(VXMIN,VXMAX,VYMIN,VYMAX)
        CX  = (VXMAX-VXMIN) / (CXMAX-CXMIN)
        VX0 = VXMIN - CX * CXMIN
        CY  = (VYMAX-VYMIN) / (CYMAX-CYMIN)
        VY0 = VYMIN - CY * CYMIN

        CALL STSRAD(.FALSE., .FALSE.)
        CALL STSTRF(.FALSE.)
*       CALL STSTRN(51,CX,CY,VX0,VY0)
        CALL STSTRI(51)
        CALL STSTRP(CX,CY,VX0,VY0)

      ELSE IF (ITR.EQ.99) THEN

        CALL STSTRI(99)
        CALL STSUSR

      ELSE

        CALL MSGDMP('E','SGSTRF',
     +       'TRANSFORMATION FUNCTION NUMBER IS INVALID.')

      END IF

      END

*-----------------------------------------------------------------------
*     UELQNP / UELQID / UELQCP / UELQVL / UELSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UELQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 2)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'LTONE   ' /, LX(1) / .FALSE. /
      DATA      CPARAS(2) / 'LBOUND  ' /, LX(2) / .TRUE. /

*     / LONG NAME /

      DATA      CPARAL(1) / 'ENABLE_AUTO_SHADE_LEVEL' /
      DATA      CPARAL(2) / '????LBOUND  ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UELQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UELQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UELQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UELQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UELQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UELQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UELQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UE', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','UELQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UELSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UE', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','UELSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UELQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SCPKT6

      PARAMETER( NX=37, NY=37 )
      PARAMETER(  XMIN=   0,  XMAX=360,  YMIN=0,  YMAX= 180 )

      REAL ALON(NX), ALAT(NY), P(NX,NY)
      REAL XP(3), YP(3), ZP(3)


      DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
   10 CONTINUE
      DO 20 J=1,NY
        ALAT(J) = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
   20 CONTINUE

      DO 30 J=1,NY
        DO 30 I=1,NX
        P(I,J) = 1.
   30 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM
      CALL SGLSET('LDEG', .TRUE.)

*---------------- 3-D ------------------

      CALL SCSORG(1., 0., 0., 0.)
      CALL SCSTRN(3)
      CALL SCSTRF

      CALL SCSEYE(  -5., -3.,  2. )
      CALL SCSOBJ(  0.0,  0.0,  0.0 )
      CALL SCSPRJ

      CALL SCSPLI(1)
      CALL SCSTNP(2999,4999)

      DO 40 J=NY-1, 1, -1
      DO 40 I=NX-1, 1, -1
        XP(1) = ALON(I)
        YP(1) = ALAT(J)
        ZP(1) = P(I,J)
        XP(2) = ALON(I)
        YP(2) = ALAT(J+1)
        ZP(2) = P(I,J+1)
        XP(3) = ALON(I+1)
        YP(3) = ALAT(J+1)
        ZP(3) = P(I+1,J+1)

        CALL SCTNU(ZP, YP, XP)
        CALL SCPLU(3, ZP, YP, XP)

        XP(1) = ALON(I+1)
        YP(1) = ALAT(J+1)
        ZP(1) = P(I+1,J+1)
        XP(2) = ALON(I+1)
        YP(2) = ALAT(J)
        ZP(2) = P(I+1,J)
        XP(3) = ALON(I)
        YP(3) = ALAT(J)
        ZP(3) = P(I,J)

        CALL SCTNU(ZP, YP, XP)
        CALL SCPLU(3, ZP, YP, XP)

   40 CONTINUE

      CALL SGCLS

      END

!-------------------------------------------------
!interface module of uvpack
!-------------------------------------------------
module uv_interface
  interface
!--------------------------------------------------------
    subroutine uverb (n,x,y1,y2)                  !エラーバーを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: y1   !エラーバーの両端の座標値
      real,      intent(in), dimension(*) :: y2
    end subroutine
      
    subroutine uverbz(n,x,y1,y2,itype,index,rsize) !エラーバーを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x
      real,      intent(in), dimension(*) :: y1   !エラーバーの両端の座標値
      real,      intent(in), dimension(*) :: y2
      integer,   intent(in) :: itype              !エラーバーのラインタイプ
      integer,   intent(in) :: index              !エラーバーのラインインデクス
      real,      intent(in) :: rsize              !エラーバーの幅
    end subroutine
!--------------------------------------------------------
    subroutine uvdif (n,x,y1,y2)                  !2本の折れ線の間をトーンパターンで塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: y1   !従属変数
      real,      intent(in), dimension(*) :: y2
    end subroutine
      
    subroutine uvdifz(n,x,y1,y2,itp1,itp2)        !2本の折れ線の間をトーンパターンで塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: y1   !従属変数
      real,      intent(in), dimension(*) :: y2
      integer,   intent(in) :: itp1               !トーンパターン番号．
      integer,   intent(in) :: itp2
    end subroutine
!--------------------------------------------------------
    subroutine uvbrf (n,x,y1,y2)                  !棒グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: y1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: y2
    end subroutine
      
    subroutine uvbrfz(n,x,y1,y2,itype,index,rsize) !棒グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: y1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: y2
      integer,   intent(in) :: itype              !枠のラインタイプ
      integer,   intent(in) :: index              !枠のラインインデクス
      real,      intent(in) :: rsize              !棒の幅
    end subroutine
      
    subroutine uvbra (n,x,y1,y2)                  !棒グラフの内部領域を塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: y1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: y2
    end subroutine
      
    subroutine uvbraz(n,x,y1,y2,itp1,itp2,rsize)  !棒グラフの内部領域を塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: y1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: y2
      integer,   intent(in) :: itp1               !トーンパターン番号．
      integer,   intent(in) :: itp2
      real,      intent(in) :: rsize              !棒の幅
    end subroutine
      
    subroutine uvbrl(n,x,yd)                      !棒グラフを線で結ぶ．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: yd   !棒の端の値
    end subroutine
      
    subroutine uvbrlz(n,x,yd,itype,index,rsize)   !棒グラフを線で結ぶ．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x    !独立変数
      real,      intent(in), dimension(*) :: yd   !棒の端の値
      integer,   intent(in) :: itype              !ラインタイプ
      integer,   intent(in) :: index              !ラインインデクス
      real,      intent(in) :: rsize              !棒の幅
    end subroutine
!--------------------------------------------------------
    subroutine uvbxf(n,x,y1,y2)                   !箱グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x  !独立変数
      real,      intent(in), dimension(*) :: y1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: y2
    end subroutine
      
    subroutine uvbxfz(n,x,y1,y2,itype,index)      !箱グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x  !独立変数
      real,      intent(in), dimension(*) :: y1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: y2
      integer,   intent(in) :: itype              !枠のラインタイプ
      integer,   intent(in) :: index              !枠のラインインデクス
    end subroutine
      
    subroutine uvbxa(n,x,y1,y2)                   !箱グラフの内部領域を塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x  !独立変数
      real,      intent(in), dimension(*) :: y1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: y2
    end subroutine
      
    subroutine uvbxaz(n,x,y1,y2,itp1,itp2)        !箱グラフの内部領域を塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x  !独立変数
      real,      intent(in), dimension(*) :: y1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: y2
      integer,   intent(in) :: itp1               !トーンパターン番号．
      integer,   intent(in) :: itp2
    end subroutine
      
    subroutine uvbxl(n,x,yd)                      !階段状のグラフを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x  !独立変数
      real,      intent(in), dimension(*) :: yd   !従属変数
    end subroutine
      
    subroutine uvbxlz(n,x,yd,itype,index)         !階段状のグラフを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: x  !独立変数
      real,      intent(in), dimension(*) :: yd   !従属変数
      integer,   intent(in) :: itype              !ラインタイプ
      integer,   intent(in) :: index              !ラインインデクス
    end subroutine

  end interface
end module
!uvpack library end ----

!-------------------------------------------------
!interface module of uhpack
!-------------------------------------------------
module uh_interface
  interface
    subroutine uherb (n,x1,x2,y)                  !エラーバーを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !エラーバーの両端の座標値
      real,      intent(in), dimension(*) :: x2
    end subroutine
      
    subroutine uherbz(n,x1,x2,y,itype,index,rsize) !エラーバーを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !エラーバーの両端の座標値
      real,      intent(in), dimension(*) :: x2
      integer,   intent(in) :: itype              !エラーバーのラインタイプ
      integer,   intent(in) :: index              !エラーバーのラインインデクス
      real,      intent(in) :: rsize              !エラーバーの幅
    end subroutine
!--------------------------------------------------------
    subroutine uhdif (n,x1,x2,y)                  !2本の折れ線の間をトーンパターンで塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !従属変数
      real,      intent(in), dimension(*) :: x2
    end subroutine
      
    subroutine uhdifz(n,x1,x2,y,itp1,itp2)        !2本の折れ線の間をトーンパターンで塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !従属変数
      real,      intent(in), dimension(*) :: x2
      integer,   intent(in) :: itp1               !トーンパターン番号．
      integer,   intent(in) :: itp2
    end subroutine
 !--------------------------------------------------------
    subroutine uhbrf (n,x1,x2,y)                  !棒グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: x2
    end subroutine
      
    subroutine uhbrfz(n,x1,x2,y,itype,index,rsize) !棒グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: x2
      integer,   intent(in) :: itype              !枠のラインタイプ
      integer,   intent(in) :: index              !枠のラインインデクス
      real,      intent(in) :: rsize              !棒の幅
    end subroutine
      
    subroutine uhbra (n,x1,x2,y)                  !棒グラフの内部領域を塗る
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: x2
    end subroutine
      
    subroutine uhbraz(n,x1,x2,y,itp1,itp2,rsize)  !棒グラフの内部領域を塗る
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: x1   !棒の両端の座標値
      real,      intent(in), dimension(*) :: x2
      integer,   intent(in) :: itp1               !トーンパターン番号．
      integer,   intent(in) :: itp2
      real,      intent(in) :: rsize              !棒の幅
    end subroutine
      
    subroutine uhbrl (n,xd,y)                     !棒グラフを線で結ぶ．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: xd   !棒の端の値
    end subroutine
      
    subroutine uhbrlz(n,xd,y,itype,index,rsize)   !棒グラフを線で結ぶ．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y    !独立変数
      real,      intent(in), dimension(*) :: xd   !棒の端の値
      integer,   intent(in) :: itype              !ラインタイプ
      integer,   intent(in) :: index              !ラインインデクス
      real,      intent(in) :: rsize              !棒の幅
    end subroutine
!--------------------------------------------------------
    subroutine uhbxf (n,x1,x2,y)                  !箱グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y  !独立変数
      real,      intent(in), dimension(*) :: x1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: x2
    end subroutine
      
    subroutine uhbxfz(n,x1,x2,y,itype,index)      !箱グラフの枠を描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y  !独立変数
      real,      intent(in), dimension(*) :: x1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: x2
      integer,   intent(in) :: itype              !枠のラインタイプ
      integer,   intent(in) :: index              !枠のラインインデクス
    end subroutine
      
    subroutine uhbxa (n,x1,x2,y)                  !箱グラフの内部領域を塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y  !独立変数
      real,      intent(in), dimension(*) :: x1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: x2
    end subroutine
      
    subroutine uhbxaz(n,x1,x2,y,itp1,itp2)        !箱グラフの内部領域を塗る．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y  !独立変数
      real,      intent(in), dimension(*) :: x1   !箱の両端の座標値
      real,      intent(in), dimension(*) :: x2
      integer,   intent(in) :: itp1               !トーンパターン番号．
      integer,   intent(in) :: itp2
    end subroutine
      
    subroutine uhbxl (n,xd,y)                     !階段状のグラフを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y  !独立変数
      real,      intent(in), dimension(*) :: xd   !従属変数
    end subroutine
      
    subroutine uhbxlz(n,xd,y,itype,index)         !階段状のグラフを描く．
      integer,   intent(in) :: n                  !配列の長さ
      real,      intent(in), dimension(*) :: y  !独立変数
      real,      intent(in), dimension(*) :: xd   !従属変数
      integer,   intent(in) :: itype              !ラインタイプ
      integer,   intent(in) :: index              !ラインインデクス
    end subroutine

  end interface
end module
!uhpack library end ----

module dcl_common
!  use dcl_f77

!-------------------- basic constants ------------------

  integer, parameter :: DCL_DISPLAY =1, DCL_PRINTER =2, DCL_PS_FILE =3

  integer, parameter :: DCL_UNI_UNI =1, DCL_UNI_LOG =2, DCL_LOG_UNI =3, &
                      & DCL_LOG_LOG =4, DCL_POLAR   =5, DCL_BIPOLAR =6, &
                      & DCL_ELLIPTIC=7
                      
  integer, parameter :: DCL_CYLINDRICAL=10, DCL_MERCATOR   =11, &
                      & DCL_MOLLWEIDE  =12, DCL_HAMMER     =13, &
                      & DCL_ECKERT6    =14, DCL_KITADA     =15, &
                      & DCL_CONICAL    =20, DCL_CON_AREA   =21, &
                      & DCL_CON_CONF   =22, DCL_BONNE      =23, &
                      & DCL_OTHOGAPHIC =30, DCL_POLARSTEREO=31, &
                      & DCL_AZIMUTHAL  =32, DCL_AZIM_AREA  =33
                      
  real,    parameter :: DCL_PI=3.1415927

!---------------- time & date -------------------

  character(len=9), dimension(12) :: DCL_MONTH =  &
         &   (/ 'JANUARY  ','FEBRUARY ','MARCH    ','APRIL    ', &
         &      'MAY      ','JUNE     ','JULY     ','AUGUST   ', &
         &      'SEPTEMBER','OCTOBER  ','NOVEMBER ','DECEMBER '  /)

  character(len=9), dimension(7) :: DCL_WEEK = &
         &   (/ 'SUNDAY   ','MONDAY   ','TUESDAY  ','WEDNESDAY', &
         &      'THURSDAY ','FRIDAY   ','SATURDAY '              /)
         

  type dcl_date
      integer :: year, month, day
  end type dcl_date

  type dcl_time
     integer :: hour, minute, second
  end type dcl_time
  
!------------------- coordinate -----------------
  type map
    real:: lon, lat
  end type map

  type cartesian
    real::x,y
  end type cartesian

  type polar
    real:: r, theta
  end type polar

  type elliptic
    real::u,v
  end type elliptic

  type hyperbolic
    real::u,v
  end type hyperbolic

  type bipolar
    real::u,v
  end type bipolar

  type cartesian3D
    real::x,y,z
  end type cartesian3D

  type spherical
    real::r,theta,phi
  end type spherical
!---------------------------------------------
  contains
    function DclSwapIndex(x)
      real, dimension(:,:), intent(in) :: x
      real, dimension(size(x,1), size(x,2)) :: DclSwapIndex
      integer, dimension(2)          :: shp, ord

      shp = (/size(x,2), size(x,1) /)
      ord = (/ 2, 1 /)

      DclSwapIndex = reshape(x, shape=shp, order=ord)
    end function
end module

*-----------------------------------------------------------------------
      SUBROUTINE UETONZ (Z,MX,NX,NY,IMAGE,NI)

      REAL      Z(MX,*)

      INTEGER   IMAGE(NI)
      LOGICAL   LMISS,LIMC

      EXTERNAL  IUETON


*     / CHECK IMAGE CAPABILITY /

      CALL SWQIMC(LIMC)
      IF (.NOT.LIMC) THEN
        CALL MSGDMP('E','UETONZ','NO IMAGE CAPABILITY.')
      END IF

*     / GET INTERNAL PARAMETERS /

      CALL GLRGET('RUNDEF  ',RUNDEF)
      CALL GLIGET('IUNDEF  ',IUNDEF)
      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX, NY)

*     / CHECK Z VALUES AND TONE LEVEL /

      CALL UEZCHK(Z,MX,NX,NY,'UETONF',ISTAT)
      IF (ISTAT.NE.0) RETURN

*     / INITIALIZE /

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      CALL STFPR2(VXMIN, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX1, WY1)
      CALL SWFINT(WX1, WY1, IX1, IY1)

      CALL STFPR2(VXMAX, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX2, WY2)
      CALL SWFINT(WX2, WY2, IX2, IY2)

      CALL STFPR2(VXMAX, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX3, WY3)
      CALL SWFINT(WX3, WY3, IX3, IY3)

      CALL STFPR2(VXMIN, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX4, WY4)
      CALL SWFINT(WX4, WY4, IX4, IY4)

      IXMIN  = MIN(IX1, IX2, IX3, IX4)
      IYMIN  = MIN(IY1, IY2, IY3, IY4)
      IXMAX  = MAX(IX1, IX2, IX3, IX4)
      IYMAX  = MAX(IY1, IY2, IY3, IY4)
      IWIDTH = IXMAX-IXMIN+1
      IHIGHT = IYMAX-IYMIN+1

      IF(IWIDTH .GT. NI) 
     &      CALL MSGDMP('E','UETONZ','WORKING AREA IS NOT ENOUGH.')

      CALL SWIOPN(IXMIN, IYMIN, IWIDTH, IHIGHT, 
     +            WX1, WY1, WX2, WY2, WX3, WY3, WX4, WY4)

*     / LOOP FOR EACH PIXEL /

      DO 30 J=1, IHIGHT

        DO 20 I=1, IWIDTH

          CALL SWIINT(I+IXMIN-1, J+IYMIN-1, WX, WY)
          CALL STIWTR(WX, WY, RX, RY)
          CALL STIPR2(RX, RY, VX, VY)
          CALL STITRF(VX, VY, UX, UY)

          IF (UX.EQ.RUNDEF) THEN
            IMAGE(I) = 0
          ELSE
            CALL UWQGXI(UX,IX,FX)
            CALL UWQGYI(UY,IY,FY)
            IF (IX.EQ.IUNDEF .OR. IY.EQ.IUNDEF) THEN
              IMAGE(I) = 0
            ELSE
              IF (LMISS .AND.
     +             (Z(IX  , IY  ).EQ.RMISS .OR.
     +              Z(IX+1, IY  ).EQ.RMISS .OR.
     +              Z(IX  , IY+1).EQ.RMISS .OR.
     +              Z(IX+1, IY+1).EQ.RMISS)     ) THEN
                IMAGE(I) = 0
              ELSE
                ZZ = (Z(IX, IY  )*(1-FX) + Z(IX+1,IY  )*FX)*(1-FY)
     +             + (Z(IX, IY+1)*(1-FX) + Z(IX+1,IY+1)*FX)*FY
                IMAGE(I) = IUETON(ZZ)/1000
              END IF
            END IF
          END IF

   20   CONTINUE

        CALL SWIDAT(IMAGE, IWIDTH)

   30 CONTINUE

      CALL SWICLS

      END

program axis04

  use dcl
  integer,parameter :: days=90
  type(dcl_date) :: date

    date%year = 1991
    date%month = 4
    date%day = 1

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( 0.0, real(days), -1.0, +1.0 )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransFunction

    call DclDrawAxisCalendar( 'bt', date, nd=days )

    call DclDrawAxis( 'l', 0.25, 0.05 )
!    call DclSetParm( 'AXIS:labelyr', .true. )
!    call uysfmt( '(f6.2)' )
!!    call DclSetYLabelFormat( '(f6.2)' )
    call DclDrawAxis( 'r', 0.25, 0.05 )
    call DclDrawTitle( 'l', 'Correlation', 0.0 )

    call DclDrawTitle( 't', 'Calendar', 0.0, 2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM ULPK01

      PARAMETER (NBL=2)

      REAL      BL(NBL)
      CHARACTER CTL*64

      DATA      BL/1.0,3.0/


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(-ABS(IWS))

      CALL SGLSET('LFULL',.TRUE.)
      CALL UZFACT(0.6)
      CALL SLRAT(0.75,1.0)
      CALL SLDIV('T',1,7)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(-0.15,-200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',1)
      CALL ULXLOG('B',1,9)
      CTL='ULXLOG (IXTYPE=1,NLBL=1,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGLSET('LCNTL',.TRUE.)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(-0.15,-200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',1)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=1,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(-0.15,-200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',2)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=2,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(-0.15,-200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',3)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=3,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(-0.15,-200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',4)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=4,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(-0.15,-200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULXSFM('(F5.1)')
      CALL ULISET('IXTYPE',3)
      CALL ULXLOG('B',3,9)
      CTL='ULXLOG (IXTYPE=3,NLBL=3,NTCK=9)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGFRM
      CALL UZINIT
      CALL SGSWND(-0.15,-200.,0.1,1E5)
      CALL SGSVPT(0.1,0.9,0.1,0.11)
      CALL SGSTRN(4)
      CALL SGSTRF
      CALL ULISET('IXTYPE',1)
      CALL ULISET('IXCHR',194)
      CALL ULSXBL(BL,NBL)
      CALL ULXLOG('B',4,5)
      CTL='ULXLOG (IXTYPE=1,NLBL=4,NTCK=5)'
      CALL UXSTTL('B',CTL,0.0)

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UGUNIT
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGUNIT


*     / GET INTERNAL PARAMETERES /

      CALL UGRGET('RUNDEF',RUNDEF)
      CALL UGIGET('INDEX',INDEX )

*     / INQUIRE NORMALIZATION TRANSFORMATION /

      CALL SGQVPT(VX1,VX2,VY1,VY2)

*     / DETERMINE LOCATION OF UNIT VECTORS IN NDC /

      CALL UGRGET('VXULOC',VXULOC)
      IF (VXULOC.EQ.RUNDEF) THEN
        CALL UGRGET('VXUOFF',VXOFF)
        VXULOC=VX2+VXOFF
        CALL UGRSET('VXULOC',VXULOC)
      END IF

      CALL UGRGET('VYULOC',VYULOC)
      IF (VYULOC.EQ.RUNDEF) THEN
        CALL UGRGET('VYUOFF',VYOFF)
        VYULOC=VY1+VYOFF
        CALL UGRSET('VYULOC',VYULOC)
      END IF

*     / DETERMINE LENGTH OF UNIT VECTORS IN NDC /

      CALL UGRGET('UXUNIT',UXUNIT)
      CALL UGRGET('XFACT2',XFACT2)
      IF (UXUNIT.EQ.RUNDEF) THEN
        CALL UGRGET('VXUNIT',VXUNIT)
        UXUNIT=VXUNIT/XFACT2
        CALL UGRSET('UXUNIT',UXUNIT)
      ELSE
        VXUNIT=UXUNIT*XFACT2
        CALL UGRSET('VXUNIT',VXUNIT)
      END IF

      CALL UGRGET('UYUNIT',UYUNIT)
      CALL UGRGET('YFACT2',YFACT2)
      IF (UYUNIT.EQ.RUNDEF) THEN
        CALL UGRGET('VYUNIT',VYUNIT)
        UYUNIT=VYUNIT/YFACT2
        CALL UGRSET('UYUNIT',UYUNIT)
      ELSE
        VYUNIT=UYUNIT*YFACT2
        CALL UGRSET('VYUNIT',VYUNIT)
      END IF

*     / DRAW UNIT VECTORS /

      UVX1=VXULOC
      UVX2=VXULOC+VXUNIT
      UVY1=VYULOC
      UVY2=VYULOC+VYUNIT

      CALL SZLAOP(1,INDEX)
      CALL SZLAZV(UVX1,UVY1,UVX2,UVY1)
      CALL SZLAZV(UVX1,UVY1,UVX1,UVY2)
      CALL SZLACL

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVBXAZ(N,UPX,UPY1,UPY2,ITPAT1,ITPAT2)

      REAL      UPX(*),UPY1(*),UPY2(*)

      LOGICAL   LMISS, LXUNI, LYC1, LYC2
      CHARACTER COBJ*80

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UVBXAZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','UVBXAZ','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LT.0) THEN
        CALL MSGDMP('E','UVBXAZ','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      CALL STFPR2(0., 0., RX0, RY0)
      CALL STFPR2(0., 1., RX1, RY1)
      CALL STFPR2(1., 0., RX2, RY2)

      ROT = (RX2-RX0)*(RY1-RY0) - (RY2-RY0)*(RX1-RX0)

      IRMODE = 0
      IF (ROT.GT.0) THEN
        IRMODR = IRMODE
      ELSE
        IRMODR = MOD(IRMODE+1, 2)
      END IF

      WRITE(COBJ,'(2I8)') ITPAT1, ITPAT2
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVBXAZ',COBJ)

      LXUNI = UPX(1).EQ.RUNDEF
      LYC1  = UPY1(1).EQ.RUNDEF
      LYC2  = UPY2(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/N
      END IF

      IF (LYC1 .OR. LYC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LXUNI) THEN
          UX1 = UXMIN + DX*(I-1)
          UX2 = UXMIN + DX*I
        ELSE
          UX1 = UPX(I)
          UX2 = UPX(I+1)
        END IF

        IF (LYC1) THEN
          UY1 = UREF
        ELSE
          UY1 = UPY1(I)
        END IF

        IF (LYC2) THEN
          UY2 = UREF
        ELSE
          UY2 = UPY2(I)
        END IF

        IF (.NOT.
     #    ((UX1.EQ.RMISS .OR. UX1.EQ.RMISS .OR.
     #      UY1.EQ.RMISS .OR. UY2.EQ.RMISS) .AND. LMISS)) THEN

          CALL STFTRF(UX1, UY1, VX1, VY1)
          CALL STFTRF(UX2, UY2, VX2, VY2)

          IF (UY2 .GT. UY1) THEN
            CALL SZSTNI(ITPAT1)
          ELSE
            CALL SZSTNI(ITPAT2)
          END IF

          IF ((VY2-VY1)*(VX2-VX1).LT.0) THEN
            VYY = VY1
            VY1 = VY2
            VY2 = VYY
          END IF

          CALL SZOPTV
          CALL SZSTTV(VX1, VY1)
          CALL SZSTTV(VX2, VY1)
          CALL SZSTTV(VX2, VY2)
          CALL SZSTTV(VX1, VY2)
          CALL SZSTTV(VX1, VY1)
          CALL SZCLTV

        END IF
   20 CONTINUE

      CALL SWOCLS('UVBXAZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGTCLR

      PARAMETER (NP=5,NT=10)
      PARAMETER (DD=0.07,DS=0.003)
      PARAMETER (DX=DD+DS*2,DY=1.0/NT)

      REAL      XBOX(NP),YBOX(NP)
      CHARACTER CHR*5

      DATA      XBOX/ 0.0, 1.0, 1.0, 0.0, 0.0/
      DATA      YBOX/ 0.0, 0.0, 1.0, 1.0, 0.0/


      WRITE(*,*) ' WORKSTATION ID (I) ? ; '
      CALL SGPWSN
      READ(*,*) IW

      CALL GLISET('MAXMSG',300)

      CALL SGOPN(IW)

      CALL SGLSET('LFULL',.TRUE.)
      CALL SGLSET('LSOFTF',.FALSE.)
      CALL SGISET('INDEX',1)
      CALL SLRAT(0.85,1.0)
      CALL SLMGN(0.0,0.0,0.05,0.1)
      CALL SLSTTL('TEST OF SGTONE','T',0.0,-0.5,0.025,1)

      CALL SGFRM
      CALL SGSWND(0.0,1.0,0.0,1.0)
      CALL SGSTRN(1)
      DO 20 J=0,9
        DO 10 I=0,9
          X1=DX*I+DS+(1-DX*NT)/2
          X2=X1+DD
          Y1=DY*(9-J)+DS
          Y2=Y1+DD
          LEVEL=(I+J*10)*1000+999
          CALL SGSVPT(X1,X2,Y1,Y2)
          CALL SGSTRF
          WRITE(CHR,'(I5)') LEVEL
          CALL SGTNZU(NP,XBOX,YBOX,LEVEL)
          CALL SGPLZU(NP,XBOX,YBOX,1,1)
          CALL SGTXZV(X2,Y2+(DY-DD)/2,CHR,0.01,0,1,1)
   10   CONTINUE
   20 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
      SUBROUTINE RADBG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)
      EXTERNAL RFPI
      TPI = 2.0*RFPI()
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IPP2 = IP+2
      IPPH = (IP+1)/2
      IF (IDO .LT. L1) GO TO 103
      DO 102 K=1,L1
         DO 101 I=1,IDO
            CH(I,K,1) = CC(I,1,K)
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I=1,IDO
         DO 104 K=1,L1
            CH(I,K,1) = CC(I,1,K)
  104    CONTINUE
  105 CONTINUE
  106 DO 108 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 107 K=1,L1
            CH(1,K,J) = CC(IDO,J2-2,K)+CC(IDO,J2-2,K)
            CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)
  107    CONTINUE
  108 CONTINUE
      IF (IDO .EQ. 1) GO TO 116
      IF (NBD .LT. L1) GO TO 112
      DO 111 J=2,IPPH
         JC = IPP2-J
         DO 110 K=1,L1
            DO 109 I=3,IDO,2
               IC = IDP2-I
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  109       CONTINUE
  110    CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J=2,IPPH
         JC = IPP2-J
         DO 114 I=3,IDO,2
            IC = IDP2-I
            DO 113 K=1,L1
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  113       CONTINUE
  114    CONTINUE
  115 CONTINUE
  116 AR1 = 1.
      AI1 = 0.
      DO 120 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 117 IK=1,IDL1
            C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)
            C2(IK,LC) = AI1*CH2(IK,IP)
  117    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 119 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 118 IK=1,IDL1
               C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)
               C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)
  118       CONTINUE
  119    CONTINUE
  120 CONTINUE
      DO 122 J=2,IPPH
         DO 121 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)
  121    CONTINUE
  122 CONTINUE
      DO 124 J=2,IPPH
         JC = IPP2-J
         DO 123 K=1,L1
            CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)
            CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)
  123    CONTINUE
  124 CONTINUE
      IF (IDO .EQ. 1) GO TO 132
      IF (NBD .LT. L1) GO TO 128
      DO 127 J=2,IPPH
         JC = IPP2-J
         DO 126 K=1,L1
            DO 125 I=3,IDO,2
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J=2,IPPH
         JC = IPP2-J
         DO 130 I=3,IDO,2
            DO 129 K=1,L1
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  129       CONTINUE
  130    CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO .EQ. 1) RETURN
      DO 133 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  133 CONTINUE
      DO 135 J=2,IP
         DO 134 K=1,L1
            C1(1,K,J) = CH(1,K,J)
  134    CONTINUE
  135 CONTINUE
      IF (NBD .GT. L1) GO TO 139
      IS = -IDO
      DO 138 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 137 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 136 K=1,L1
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  136       CONTINUE
  137    CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
      DO 142 J=2,IP
         IS = IS+IDO
         DO 141 K=1,L1
            IDIJ = IS
            DO 140 I=3,IDO,2
               IDIJ = IDIJ+2
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  140       CONTINUE
  141    CONTINUE
  142 CONTINUE
  143 RETURN
      END

      PROGRAM USPAC1

      PARAMETER( NMAX=50 )
      REAL X(0:NMAX), Y(0:NMAX)

      R    = 3.7
      X(0) = 1950.
      Y(0) = 0.5
      DO 10 N=0,NMAX-1
        X(N+1) = X(N) + 1.
        Y(N+1) = R*Y(N)*(1.-Y(N))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL USSTTL( 'TIME', 'YEAR', 'HEAT FLUX', 'W/m|2"' )
      CALL USGRPH( NMAX+1, X, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     TMPQNP / TMPQID / TMPQCP / TMPQVL / TMPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE TMPQNP(NCP)
      IMPLICIT NONE

      CHARACTER CP*(*)

      INTEGER   NPARA
      PARAMETER (NPARA = 11)

      INTEGER   ITYPE(NPARA)
      LOGICAL   LCHREQ
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      INTEGER   LENC
      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'GRDTHRES' /, ITYPE( 1) / 1 /
      DATA      CPARAS( 2) / 'ARRWINTV' /, ITYPE( 2) / 3 /
      DATA      CPARAS( 3) / 'SKIPINTV' /, ITYPE( 3) / 1 /
      DATA      CPARAS( 4) / 'STLNDT  ' /, ITYPE( 4) / 3 /
      DATA      CPARAS( 5) / 'STLNNUM ' /, ITYPE( 5) / 1 /
      DATA      CPARAS( 6) / 'PERIODX ' /, ITYPE( 6) / 2 /
      DATA      CPARAS( 7) / 'PERIODY ' /, ITYPE( 7) / 2 /
      DATA      CPARAS( 8) / 'NODRSHRT' /, ITYPE( 8) / 2 /
      DATA      CPARAS( 9) / 'ENDARROW' /, ITYPE( 9) / 2 /
      DATA      CPARAS(10) / 'FIXEDDT ' /, ITYPE(10) / 2 /
      DATA      CPARAS(11) / 'STLNGLIM' /, ITYPE(11) / 1 /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'GRID_PASSING_THRESHOLD' /
      DATA      CPARAL( 2) / 'ARROW_DRAWING_INTERVAL' /
      DATA      CPARAL( 3) / 'SKIPPING_POINT_INTERVAL' /
      DATA      CPARAL( 4) / 'STLN_CALCULATING_INTERVAL' /
      DATA      CPARAL( 5) / 'STREAM_LINE_NUMBERS' /
      DATA      CPARAL( 6) / 'PERIOD_BOUNDARY_XDIRECTION' /
      DATA      CPARAL( 7) / 'PERIOD_BOUNDARY_YDIRECTION' /
      DATA      CPARAL( 8) / 'NO_DRAW_SHORTLINE' /
      DATA      CPARAL( 9) / 'END_ARROW_FLAG' /
      DATA      CPARAL(10) / 'FIXED_TIME_STEP' /
      DATA      CPARAL(11) / 'STREAM_LIMIT_INTERVAL' /

*     / WORKING VALUES /

      INTEGER   N, IDX, ITP, IN, IPARA, ID, NCP



      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','TMPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','TMPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','TMPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','TMPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL TMIQID(CPARAS(IDX), ID)
          CALL TMIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL TMLQID(CPARAS(IDX), ID)
          CALL TMLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL TMRQID(CPARAS(IDX), ID)
          CALL TMRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','TMPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL TMIQID(CPARAS(IDX), ID)
          CALL TMISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL TMLQID(CPARAS(IDX), ID)
          CALL TMLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL TMRQID(CPARAS(IDX), ID)
          CALL TMRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','TMPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!interface module of uupack
!-------------------------------------------------
module uu_interface
  interface
!--------------------------------------------------------
    subroutine uulin (n,x,y)                      !折れ線を描く．
      integer,   intent(in) :: n                  !配列x, y の長さ
      real,      intent(in), dimension(*) :: x    !折れ線の座標値
      real,      intent(in), dimension(*) :: y
    end subroutine
      
    subroutine uulinz(n,x,y,itype,index)          !折れ線を描く．
      integer,   intent(in) :: n                  !配列x, y の長さ
      real,      intent(in), dimension(*) :: x    !折れ線の座標値
      real,      intent(in), dimension(*) :: y
      integer,   intent(in) :: itype              !折れ線のラインタイプ
      integer,   intent(in) :: index              !折れ線のラインインデクス
    end subroutine
!--------------------------------------------------------      
    subroutine uumrk (n,x,y)                      !マーカー列を描く．
      integer,   intent(in) :: n                  !配列x, y の長さ
      real,      intent(in), dimension(*) :: x    !マーカーの座標値
      real,      intent(in), dimension(*) :: y
    end subroutine
      
    subroutine uumrkz(n,x,y,itype,index,rsize)    !マーカー列を描く．
      integer,   intent(in) :: n                  !配列x, y の長さ
      real,      intent(in), dimension(*) :: x    !マーカーの 座標値
      real,      intent(in), dimension(*) :: y
      integer,   intent(in) :: itype              !マーカーのラインタイプ
      integer,   intent(in) :: index              !マーカーのラインインデクス
      real,      intent(in) :: rsize              !マーカーの大きさ
    end subroutine
!--------------------------------------------------------
    subroutine uuslnt(itype)                      !折れ線の属性を指定する．
      integer,   intent(in) :: itype              !折れ線のラインタイプ
    end subroutine
      
    subroutine uuslni(index)                      !折れ線の属性を指定する．
      integer,   intent(in) :: index              !折れ線のラインインデクス
    end subroutine
      
    subroutine uusmkt(itype)                      !マーカーの属性を指定する．
      integer,   intent(in) :: itype              !マーカーのラインタイプ
    end subroutine
      
    subroutine uusmki(index)                      !マーカーの属性を指定する．
      integer,   intent(in) :: index              !マーカーのラインインデクス
    end subroutine
      
    subroutine uusmks(rsize)                      !マーカーの属性を指定する．
      real,      intent(in) :: rsize              !マーカーの大きさ
    end subroutine
      
    subroutine uusebt(itype)                      !エラーバーの属性を指定する．
      integer,   intent(in) :: itype              !エラーバーのラインタイプ
    end subroutine
      
    subroutine uusebi(index)                      !エラーバーの属性を指定する．
      integer,   intent(in) :: index              !エラーバーのラインインデクス
    end subroutine
      
    subroutine uusebs(rsize)                      !エラーバーの属性を指定する．
      real,      intent(in) :: rsize              !エラーバーの横幅
    end subroutine
      
    subroutine uusbrs(rsize)                      !棒グラフの横巾を指定する．
      real,      intent(in) :: rsize              !棒グラフの横幅
    end subroutine
      
    subroutine uusarp(itp1,itp2)                  !内部領域を塗るトーンパターンを指定する．
      integer,   intent(in) :: itp1               !トーンパターン番号
      integer,   intent(in) :: itp2
    end subroutine
      
    subroutine uusfrt(itype)                      !枠の属性を指定する．
      integer,   intent(in) :: itype              !枠のラインタイプ
    end subroutine
      
    subroutine uusfri(index)                      !枠の属性を指定する．
      integer,   intent(in) :: index              !枠のラインインデクス
    end subroutine
      
    subroutine uusidv(umin, umax)                 !独立変数の定義域を指定する．
      real,      intent(in) :: umin               !定義域の最大最小値
      real,      intent(in) :: umax
    end subroutine

  end interface
end module
!uupack library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SYSL01

      LOGICAL LMISS,LEPSL


      CALL GLIGET('NBITSPW ',NBITS )
      WRITE(*,*) '*** NBITSPW  = ',NBITS
      CALL GLIGET('NCHRSPW ',NCHRS )
      WRITE(*,*) '*** NCHRSPW  = ',NCHRS
      CALL GLIGET('INTMAX  ',INTMAX)
      WRITE(*,*) '*** INTMAX   = ',INTMAX
      CALL GLRGET('REALMAX ',RLMAX )
      WRITE(*,*) '*** REALMAX  = ',RLMAX
      CALL GLRGET('REALMIN ',RLMIN )
      WRITE(*,*) '*** REALMIN  = ',RLMIN
      CALL GLIGET('IIUNIT  ',IIUNIT)
      WRITE(*,*) '*** IIUNIT   = ',IIUNIT
      CALL GLIGET('IOUNIT  ',IOUNIT)
      WRITE(*,*) '*** IOUNIT   = ',IOUNIT
      CALL GLIGET('MSGUNIT ',MSGU  )
      WRITE(*,*) '*** MSGUNIT  = ',MSGU
      CALL GLIGET('MAXMSG  ',MAXMSG)
      WRITE(*,*) '*** MAXMSG   = ',MAXMSG
      CALL GLIGET('MSGLEV  ',MSGLEV)
      WRITE(*,*) '*** MSGLEV   = ',MSGLEV
      CALL GLIGET('NLNSIZE ',NLINES)
      WRITE(*,*) '*** NLNSIZE  = ',NLINES
      CALL GLLGET('LMISS   ',LMISS )
      WRITE(*,*) '*** LMISS    = ',LMISS
      CALL GLIGET('IMISS   ',IMISS )
      WRITE(*,*) '*** IMISS    = ',IMISS
      CALL GLRGET('RMISS   ',RMISS )
      WRITE(*,*) '*** RMISS    = ',RMISS
      CALL GLIGET('IUNDEF  ',IUNDEF)
      WRITE(*,*) '*** IUNDEF   = ',IUNDEF
      CALL GLRGET('RUNDEF  ',RUNDEF)
      WRITE(*,*) '*** RUNDEF   = ',RUNDEF
      CALL GLLGET('LEPSL   ',LEPSL )
      WRITE(*,*) '*** LEPSL    = ',LEPSL
      CALL GLRGET('REPSL   ',REPSL )
      WRITE(*,*) '*** REPSL    = ',REPSL
      CALL GLRGET('RFACT   ',RFACT )
      WRITE(*,*) '*** RFACT    = ',RFACT

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHON7

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
C      CALL SGLSET( 'LCLIP', .TRUE. )
*-- frame 1 ----
      CALL SGFRM
*                  XMIN,  XMAX,  YMIN, YMAX
      CALL SGSWND( -100., 100., -100., 100. )
      CALL SGSVPT(  0.0,   1.0,   0.0,  1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

*-- frame 2 ----
      CALL SGFRM
*-- 左上 ----      XMIN,  XMAX,  YMIN, YMAX
      CALL SGSWND( -100., 100., -100., 100. )
      CALL SGSVPT(   0.1,  0.4,   0.6,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

*-- 右上 ----       XMIN, XMAX, YMIN, YMAX
      CALL SGSWND( -100., 100., -40.,  40. )
      CALL SGSVPT(   0.6,  0.9,  0.6,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

*-- 左下 ----       XMIN, XMAX,  YMIN, YMAX
      CALL SGSWND( -100., 100., -200.,   0. )
      CALL SGSVPT(   0.1,  0.4,   0.1,  0.4 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

      
*-- 右下 ----       XMIN, XMAX, YMIN,  YMAX
      CALL SGSWND( -100., 100.,   0., -200. )
      CALL SGSVPT(   0.6,  0.9,  0.1,   0.4 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL APLOT

      CALL SGCLS

      END
*-----------------------------------------------------------------------
      SUBROUTINE APLOT

      PARAMETER( NMAX=40 )
      REAL X(0:NMAX), Y(0:NMAX)

      CALL SLPVPR( 1 )

*-- 円形 ----
      DT = 2.*3.14159 / NMAX
      DO 10 N=0,NMAX
        X(N) = 40.*SIN(N*DT)
        Y(N) = 40.*COS(N*DT)
   10 CONTINUE

      CALL SGPLU( NMAX+1, X, Y )

*-- 三角形 ----
      DT = 2.*3.14159 / 3
      DO 20 N=0,3
        X(N) = 40.*SIN(N*DT)
        Y(N) = 40.*COS(N*DT)
   20 CONTINUE

      CALL SGPLU( 4, X, Y )

*-- 文字列 ----
      CALL SGTXU( 0., 0., 'SGTXU' )

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTNZR(N,RPX,RPY,ITPAT)

      REAL      RPX(*),RPY(*)


      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNZR','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPAT.EQ.0) THEN
        CALL MSGDMP('M','SGTNZR','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT.LT.0) THEN
        CALL MSGDMP('E','SGTNZR','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZTNOP(ITPAT)
      CALL SZTNZR(N,RPX,RPY)
      CALL SZTNCL

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2D6

      PARAMETER( NX=11, NY=11 )
      PARAMETER( XMIN=-1, XMAX=1, YMIN=-1, YMAX=1 )
      REAL U(NX,NY), V(NX,NY)

      DO 10 J=1,NY
      DO 10 I=1,NX
        X = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
        Y = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
        U(I,J) =  X * 0.1
        V(I,J) = -Y
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS

      CALL UGLSET( 'LNRMAL', .FALSE. )
      CALL UGRSET( 'XFACT1', 0.5 )
      CALL UGRSET( 'YFACT1', 0.05 )
      CALL UGLSET( 'LUNIT' , .TRUE. )
      CALL UGRSET( 'VXUNIT', 0.1 )
      CALL UGRSET( 'VYUNIT', 0.1 )
      CALL UGRSET( 'VXUOFF', 0.06 )
      CALL UGSUT( 'X', 'U' )
      CALL UGSUT( 'Y', 'V' )
      CALL UGVECT( U, NX, V, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UCXAYR : PLOT YEAR AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCXAYR(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      PARAMETER (N=50)

      REAL      UX(N)
      CHARACTER CH(N)*4
      LOGICAL   LABEL,LUXCHK,LBTWN


      IF (.NOT.LUXCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCXAYR','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCXAYR','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCXAYR','DATE LENGTH IS LESS THAN 0.')
      END IF

      CALL UXPAXS(CSIDE,2)

      NN=1
      UX(NN)=0
      CALL DATE13(JD0,IY0,MO0,ID0)

      DO 10 I=1,ND
        CALL DATEF3(I,IY0,MO0,ID0,IYI,MOI,IDI)
        CALL DATE32(IYI,MOI,IDI,ITDI)
        IYL=NDYEAR(IYI)
        IF (ITDI.EQ.IYL .OR. I.EQ.ND) THEN
          NN=NN+1
          IF (NN.GT.N) THEN
            CALL MSGDMP('E','UCXAYR','WORKING AREA IS NOT ENOUGH.')
          END IF
          UX(NN)=I
          WRITE(CH(NN-1),'(I4)') IYI
          CALL CLADJ(CH(NN-1)(1:4))
        END IF
   10 CONTINUE

      CALL SGQVPT(VX1,VX2,VY1,VY2)
      CALL UZRGET('RSIZEL2',RSIZE)
      NCHX=(VX2-VX1)/RSIZE

      CALL UZIGET('ICENTX'//CSIDE,ICENT)
      CALL UZIGET('IROTLX'//CSIDE,IROTA)
      CALL UZIGET('IROTCX'//CSIDE,IROTC)
      CALL UZLGET('LBTWN',LBTWN)

      CALL UZISET('ICENTX'//CSIDE,0)
      IF (NN*4.LE.NCHX) THEN
        CALL UZISET('IROTLX'//CSIDE,IROTC)
      ELSE
        CALL UZISET('IROTLX'//CSIDE,+1)
      END IF
      CALL UZLSET('LBTWN',.TRUE.)

      CALL UZRGET('RSIZET2',RTICK2)
      CALL UZRSET('RSIZET2',RTICK2*1.5)
      CALL UXPTMK(CSIDE,2,UX,NN)
      CALL UZRSET('RSIZET2',RTICK2)

      CALL UZLGET('LABELX'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UXPLBL(CSIDE,2,UX,CH,4,NN)
      END IF

      CALL UZISET('ICENTX'//CSIDE,ICENT)
      CALL UZISET('IROTLX'//CSIDE,IROTA)
      CALL UZLSET('LBTWN',LBTWN)

      END

*-----------------------------------------------------------------------
*     UIIQNP / UIIQID / UIIQCP / UIIQVL / UIISVL
*-----------------------------------------------------------------------
      SUBROUTINE UIIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 3)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'ICOLOR1 ' /, IX(1) / Z'FFFFFF' /
      DATA      CPARAS(2) / 'ICOLOR2 ' /, IX(2) / Z'FFFFFF' /
      DATA      CPARAS(3) / 'ICOLOR3 ' /, IX(3) / Z'FFFFFF' /

*     / LONG NAME /

      DATA      CPARAL(1) / 'COLOR_FOR_OUT_OF_DOMAIN' /
      DATA      CPARAL(2) / 'COLOR_FOR_OUT_OF_GRID' /
      DATA      CPARAL(3) / 'COLOR_FOR_MISSING_VALUE' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UIIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UIIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UIIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UI', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','UIIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UI', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','UIISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UIIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     UCYADY : PLOT DATE AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCYADY(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      PARAMETER (N=100)

      REAL      UY(N)
      CHARACTER CH(N)*2
      LOGICAL   LABEL,LUYCHK,LBTWN


      IF (.NOT.LUYCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCYADY','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCYADY','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCYADY','DATE LENGTH IS LESS THAN 0.')
      END IF

      CALL UYPAXS(CSIDE,2)

      ID=NUCDAY('Y',ND)
      IF (ID.LE.0) THEN
        CALL MSGDMP('W','UCYADY','NO DAY-AXIS.')
        RETURN
      END IF

      CALL DATE12(JD0,IY0,IT0)
      NN=0
      DO 10 I=0,ND
        CALL DATEF2(I,IY0,IT0,IYI,ITI)
        CALL DATE23(IYI,MOI,IDI,ITI)
        IML=NDMON(IYI,MOI)
        IF ((IDI.LT.IML-ID/2 .AND. MOD(IDI,ID).EQ.0)
     +     .OR. IDI.EQ.IML) THEN
          NN=NN+1
          IF (NN.GT.N) THEN
            CALL MSGDMP('E','UCYADY','WORKING AREA IS NOT ENOUGH.')
          END IF
          UY(NN)=I
          WRITE(CH(NN)(1:2),'(I2)') IDI
          CALL CLADJ(CH(NN)(1:2))
        END IF
   10 CONTINUE

      IF (NN.EQ.0) THEN
        CALL MSGDMP('W','UCYADY','THERE IS NO TICKMARK / LABEL.')
        RETURN
      END IF

      CALL UZIGET('ICENTY'//CSIDE,ICENT)
      CALL UZIGET('IROTLY'//CSIDE,IROTA)
      CALL UZIGET('IROTCY'//CSIDE,IROTC)
      CALL UZLGET('LBTWN',LBTWN)

      CALL UZISET('ICENTY'//CSIDE,0)
      CALL UZISET('IROTLY'//CSIDE,IROTC)
      CALL UZLSET('LBTWN',.FALSE.)

      CALL UYPTMK(CSIDE,1,UY,NN)
      CALL UZLGET('LABELY'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UYPLBL(CSIDE,1,UY,CH,2,NN)
      END IF

      CALL UZISET('ICENTY'//CSIDE,ICENT)
      CALL UZISET('IROTLY'//CSIDE,IROTA)
      CALL UZLSET('LBTWN',LBTWN)

      END

      PROGRAM UXYZ4

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( -50., 50., 1.E3, 0.4 )
      CALL GRSVPT(  0.2, 0.8,  0.2, 0.8 )
      CALL GRSTRN( 2 )
      CALL GRSTRF

      CALL UXAXDV( 'B', 5., 20. )
      CALL UXAXDV( 'T', 5., 20. )
      CALL UXSTTL( 'B', 'LATITUDE (deg)', 0. )

      CALL ULISET( 'IYTYPE', 3 )
      CALL ULYLOG( 'L', 3, 9 )
      CALL ULYLOG( 'R', 3, 9 )
      CALL UYSTTL( 'L', 'PRESSURE (hPa)', 0. )

      CALL UXMTTL( 'T', 'UXAXDV/ULYLOG', 0. )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     POLYLINE PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPLU(N,UPX,UPY)

      REAL      UPX(*),UPY(*),VPX(*),VPY(*),RPX(*),RPY(*)

      SAVE

      DATA      ITYPEZ/1/,INDEXZ/1/


      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLU','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPLU','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGPLU','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGPLU','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZPLOP(ITYPEZ,INDEXZ)
      CALL SZPLZU(N,UPX,UPY)
      CALL SZPLCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPLV(N,VPX,VPY)

      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLV','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPLV','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGPLV','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGPLV','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZPLOP(ITYPEZ,INDEXZ)
      CALL SZPLZV(N,VPX,VPY)
      CALL SZPLCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPLR(N,RPX,RPY)

      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLR','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPLR','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGPLR','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGPLR','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZPLOP(ITYPEZ,INDEXZ)
      CALL SZPLZR(N,RPX,RPY)
      CALL SZPLCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSPLT(ITYPE)

      ITYPEZ=ITYPE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQPLT(ITYPE)

      ITYPE=ITYPEZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSPLI(INDEX)

      INDEXZ=INDEX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQPLI(INDEX)

      INDEX=INDEXZ

      RETURN
      END

!-------------------------------------------------
!interface module of rfalib
!-------------------------------------------------
module rfa_interface
  interface

    function rmax(rx,n,jx)                        !最大値を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real rmax                                   !最大値を与える関数値
    end function
      
    function rmin(rx,n,jx)                        !最小値を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real rmin                                   !最小値を与える関数値
    end function
      
    function rsum(rx,n,jx)                        !総和を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real rsum                                   !総和を与える関数値
    end function
      
    function rave(rx,n,jx)                        !平均を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real rave                                   !平均を与える関数値
    end function
      
    function rvar(rx,n,jx)                        !分散を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real rvar                                   !分散を与える関数値
    end function
      
    function rstd(rx,n,jx)                        !標準偏差を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real rstd                                   !標準偏差を与える関数値
    end function
      
    function rrms(rx,n,jx)                        !root mean squareを求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real rrms                                   !root mean squareを与える関数値．
    end function
      
    function ramp(rx,n,jx)                        !大きさ (（Σ rx^2)^1/2 ) を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      real ramp                                   !大きさを与える関数値
    end function
      
    function rvmax(rx,ns,np,nq,nd)                !多次元配列の（一部分の）最大値を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in), dimension(*) :: ns   !配列の各次元の長さを与える 整数型配列
      integer,   intent(in), dimension(*) :: np   !各次元の処理をおこなう最初の位置を与える整数型配列
      integer,   intent(in), dimension(*) :: nq   !各次元の処理をおこなう最後の位置を与える整数型配列
      integer,   intent(in) :: nd                 !配列の次元数
      real                  :: rvmax              !最大値を与える関数値
    end function
      
    function rvmin(rx,ns,np,nq,nd)                !多次元配列の（一部分の）最小値を求める
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      integer,   intent(in), dimension(*) :: ns   !配列の各次元の長さを与える 整数型配列
      integer,   intent(in), dimension(*) :: np   !各次元の処理をおこなう最初の位置を与える整数型配列
      integer,   intent(in), dimension(*) :: nq   !各次元の処理をおこなう最後の位置を与える整数型配列
      integer,   intent(in) :: nd                 !配列の次元数
      real                  :: rvmin              !最小値を与える関数値
    end function

  end interface
end module
!rfalib library end ----

*-----------------------------------------------------------------------
*     UXPLBB : PLOT LABELS ( BETWEEN THE POINTS )
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPLBB(UX,CH,NC,N,UPY,ROFFX,RSIZE,IROTA,ICENT,INDEX,
     +                  RBTWN,LBOUND,LBMSG)

      REAL      UX(*)
      LOGICAL   LBOUND,LBMSG
      CHARACTER CH(*)*(*)

      LOGICAL   LCLIPZ


      IF (NC.LE.0) THEN
        CALL MSGDMP('E','UXPLBB',
     +       'CHARACTER LENGTH IS LESS THAN OR EQUAL TO ZERO.')
      END IF
      IF (N.LE.1) THEN
        CALL MSGDMP('E','UXPLBB','NUMBER OF POINTS IS INVALID.')
      END IF
      IF (RSIZE.LE.0) THEN
        CALL MSGDMP('E','UXPLBB','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','UXPLBB','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.LE.0) THEN
        CALL MSGDMP('E','UXPLBB','TEXT INDEX IS INVALID.')
      END IF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)

      CALL SZTXOP(RSIZE,IROTA*90,ICENT,INDEX)
      DO 10 I=1,N-1
        LC = LENC(CH(I))
        CALL SZQTXW(CH(I),LCZ,WXCH,WYCH)
        CALL STFTRF(UX(I),UPY,VPX1,VPY)
        CALL STFTRF(UX(I+1),UPY,VPX2,VPY)
        VWX=ABS(VPX2-VPX1)
        JROTA=MOD(IROTA,2)
        IF (JROTA.EQ.0) THEN
          CWX=RSIZE*WXCH
        ELSE
          CWX=RSIZE*WYCH
        END IF
        IF (CWX.GT.VWX .AND. LBOUND) THEN
          IF (LBMSG) THEN
            CALL MSGDMP('W','UXPLBB','SPACE FOR LABEL IS NOT ENOUGH.')
          END IF
          GO TO 10
        END IF
        VPX=(VPX1+VPX2)/2+(VWX-CWX)/2*RBTWN
        VPY=VPY+ROFFX
        CALL SZTXZV(VPX,VPY,CH(I)(1:LC))
   10 CONTINUE
      CALL SZTXCL

   15 CONTINUE

      CALL SGLSET('LCLIP',LCLIPZ)

      END

*-----------------------------------------------------------------------
      PROGRAM UMPK01

      PARAMETER (NP=14)

      INTEGER   NTR(NP)
      REAL      FCT(NP)
      CHARACTER CTTL*32

      DATA NTR /   10,   11,   12,   13,   14,   15,
     +             20,   21,   22,   23,   30,   31,   32,   33/
      DATA FCT / 0.12, 0.12, 0.14, 0.14, 0.14, 0.14,
     +           0.11, 0.16, 0.12, 0.12, 0.40, 0.12, 0.12, 0.17/

      CALL SWCSTX('FNAME','UMPK01')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN( -ABS(IWS) )

      CALL SLRAT( 2.0, 3.0 )
      CALL SLDIV( 'Y', 2, 3 )

      CALL SGRSET( 'STLAT1', 45.0 )
      CALL SGRSET( 'STLAT2', 30.0 )

      CALL UMLSET( 'LGRIDMN', .FALSE. )
      CALL UMISET( 'INDEXMJ', 1 )

      DO 10 I=1,NP

        CALL SGFRM

        CALL SGSSIM( FCT(I), 0.0, 0.0 )
        CALL SGSMPL( 0.0, 90.0, 0.0 )
        CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
        IF ( NTR(I).EQ.30 ) THEN
          CALL SGSTXY( -180.0, 180.0,   0.0, 90.0 )
        ELSE
          CALL SGSTXY( -180.0, 180.0, -90.0, 90.0 )
        END IF
        CALL SGSTRN( NTR(I) )
        CALL SGSTRF

        CALL SGLSET( 'LCLIP', .TRUE. )
        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( NTR(I), CTTL )
        CALL SGTXZR( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB

        IF ( NTR(I).EQ.23 ) THEN
          CALL SGFRM
          CALL SGFRM
        END IF

   10 CONTINUE

      CALL SGCLS

      END

!-------------------------------------------------
!interface module of vialib
!-------------------------------------------------
module via_interface
  interface

    subroutine vifna(ix,iy,n,jx,jy,ifna)          !IXにIFNAを作用させてIYに代入する
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(out), dimension(*) :: iy
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iyにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      external ifna                               !引数が1個である整数型関数名
    end subroutine
      
    subroutine viinc(ix,iy,n,jx,jy,ii)            !IXにIIを加えてIYに代入する． 
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(out), dimension(*) :: iy
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iyにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: ii                 !加える整数値
    end subroutine
      
    subroutine vifct(ix,iy,n,jx,jy,ii)            !IXにIIを掛けてIYに代入する．
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(out), dimension(*) :: iy
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iyにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: ii                 !掛ける整数値
    end subroutine
      
    subroutine vicon(ix,iy,n,jx,jy,ii)            !IIをIYに代入する． 
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(out), dimension(*) :: iy
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iyにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: ii                 !代入する整数値
    end subroutine
      
    subroutine viset(ix,iy,n,jx,jy)               !IXをIYに代入する．
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(out), dimension(*) :: iy
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iyにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
    end subroutine
      
    subroutine iadd(ix,n,jx,ii)                   !IXにIIを加える．  
      integer,   intent(inout), dimension(*) :: ix !処理する整数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ixにおいて，処理する配列要素の間隔
      integer,   intent(in) :: ii                 !加える整数値
    end subroutine
      
    subroutine imlt(ix,n,jx,ii)                   !IXにIIを掛ける．  
      integer,   intent(inout), dimension(*) :: ix !処理する整数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ixにおいて，処理する配列要素の間隔
      integer,   intent(in) :: ii                 !掛ける整数値
    end subroutine
      
    subroutine iset(ix,n,jx,ii)                   !IXにIIを代入する． 
      integer,   intent(inout), dimension(*) :: ix !処理する整数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ixにおいて，処理する配列要素の間隔
      integer,   intent(in) :: ii                 !代入する整数値
    end subroutine

  end interface
end module
!vialib library end ----

!-------------------------------------------------
!  INDXlib Module
!-------------------------------------------------
module indxlib
  use dcl_common
  interface DclLocFirst
    module procedure DclLocFirstChar, DclLocFirstInt, DclLocFirstReal
  end interface

  interface DclLocLast
    module procedure DclLocLastChar, DclLocLastInt, DclLocLastReal
  end interface

  private :: DclLocFirstChar, DclLocFirstInt, DclLocFirstReal
  private :: DclLocLastChar,  DclLocLastInt,  DclLocLastReal
  
  contains
    
    function DclLocFirstChar(array,value)
      character(len=*), intent(in), dimension(:) :: array 
      character(len=*), intent(in)               :: value
      integer                                    :: DclLocFirstChar

      call prcopn('DclLocFirst')
      DclLocFirstChar = indxnf(array,size(array),1,value)
      call prccls('DclLocFirst')
    end function
      
    function DclLocLastChar(array,value)
      character(len=*), intent(in), dimension(:) :: array
      character(len=*), intent(in)               :: value
      integer                                    :: DclLocLastChar

      call prcopn('DclLocLast')
      DclLocLastChar = indxnl(array,size(array),1,value) 
      call prccls('DclLocLast')
    end function
      
    function DclLocFirstCharEx(array,value)
      character(len=*), intent(in), dimension(:) :: array
      character(len=*), intent(in)               :: value 
      integer                                    :: DclLocFirstCharEx

      call prcopn('DclLocFirst')
      DclLocFirstCharEx = indxmf(array,size(array),1,value)
      call prccls('DclLocFirst')
    end function
      
    function DclLocLastCharEx(array,value)
      character(len=*), intent(in), dimension(:) :: array
      character(len=*), intent(in)               :: value
      integer                                    :: DclLocLastCharEx

      call prcopn('DclLocLast')
      DclLocLastCharEx = indxml(array,size(array),1,value)
      call prccls('DclLocLast')
    end function
      
    function DclLocFirstInt(array,value)
      integer, intent(in), dimension(:) :: array
      integer, intent(in)               :: value
      integer                           :: DclLocFirstInt

      call prcopn('DclLocFirst')
      DclLocFirstInt = indxif(array,size(array),1,value)
      call prccls('DclLocFirst')
    end function
      
    function DclLocLastInt(array,value)
      integer, intent(in), dimension(:) :: array
      integer, intent(in)               :: value
      integer                           :: DclLocLastInt

      call prcopn('DclLocLast')
      DclLocLastInt = indxil(array,size(array),1,value)
      call prccls('DclLocLast')
    end function
      
    function DclLocFirstReal(array,value) 
      real, intent(in), dimension(:) :: array
      real, intent(in)               :: value
      integer                        :: DclLocFirstReal

      call prcopn('DclLocFirst')
      DclLocFirstReal = indxrf(array,size(array),1,value)
      call prccls('DclLocFirst')
    end function
      
    function DclLocLastReal(array,value)
      real, intent(in), dimension(:) :: array
      real, intent(in)               :: value
      integer                        :: DclLocLastReal

      call prcopn('DclLocLast')
      DclLocLastReal = indxrl(array,size(array),1,value)
      call prccls('DclLocLast')
    end function

end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE VRFNB1(RX,RY,RZ,N,JX,JY,JZ,RFNB)

      REAL      RX(*),RY(*),RZ(*)

      REAL      RFNB
      EXTERNAL  RFNB


      CALL GLRGET('RMISS',RMISS)
      KX=1-JX
      KY=1-JY
      KZ=1-JZ
      DO 10 J=1,N
        KX=KX+JX
        KY=KY+JY
        KZ=KZ+JZ
        IF (RX(KX).NE.RMISS .AND. RY(KY).NE.RMISS) THEN
          RZ(KZ)=RFNB(RX(KX),RY(KY))
        ELSE
          RZ(KZ)=RMISS
        END IF
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     UYPNUM : PLOT NUMBERS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPNUM(CSIDE,ISLCT,UY,N)

      PARAMETER (NCH=40,LCH=12)

      REAL      UY(*)
      CHARACTER CSIDE*1

      LOGICAL   LUYCHK
      CHARACTER CFMTZ*16,CH(NCH)*(LCH)


*     / CHECK ARGUMENTS /

      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYPNUM','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UYPNUM','''ISLCT'' IS INVALID.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UYPNUM','NUMBER OF POINTS IS INVALID.')
      ELSE IF (N.GT.NCH) THEN
        CALL MSGDMP('E','UYPNUM','WORKING AREA IS NOT ENOUGH.')
      END IF

*     / GENERATE CHARACTERS /

      CALL UZCGET('CYFMT', CFMTZ)
      DO 10 I=1,N
        CALL CHVAL(CFMTZ,UY(I),CH(I))
   10 CONTINUE

*     / UYPLBL CALL /

      CALL UYPLBL(CSIDE,ISLCT,UY,CH,LCH,N)

      END

!-----------------------------------------------------------------------
program ucpk02
  use dcl

    integer,parameter :: jd0=19920401
    character(len=32) :: ctl

    call DclOpenGraphics( +abs(DclSelectDevice()) )

    call DclSetParm( 'GRAPH:lfull',.true.)
    call DclSetAxisFactor(0.7)
    call DclSetAspectRatio(1.0,0.75)
    call DclDivideFrame('y',7,1)

    call DclNewFrame
    nd=30
    call DclSetWindow(0.0,1.0,0.0,real(nd))
    call DclSetViewPort(0.13,0.14,0.1,0.9)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawYAxisCalendar('l',jd0,nd)
    ctl='DclDrawYAxisCalendar (30days)'
    call DclDrawYSubTitle('l',ctl,0.0)

    call DclNewFrame
    nd=90
    call DclSetWindow(0.0,1.0,0.0,real(nd))
    call DclSetViewPort(0.13,0.14,0.1,0.9)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawYAxisCalendar('l',jd0,nd)
    ctl='DclDrawYAxisCalendar (90days)'
    call DclDrawYSubTitle('l',ctl,0.0)

    call DclNewFrame
    nd=180
    call DclSetWindow(0.0,1.0,0.0,real(nd))
    call DclSetViewPort(0.13,0.14,0.1,0.9)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawYAxisCalendar('l',jd0,nd)
    ctl='DclDrawYAxisCalendar (180days)'
    call DclDrawYSubTitle('l',ctl,0.0)

    call DclNewFrame
    nd=400
    call DclSetWindow(0.0,1.0,0.0,real(nd))
    call DclSetViewPort(0.13,0.14,0.1,0.9)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawYAxisCalendar('l',jd0,nd)
    ctl='DclDrawYAxisCalendar (400days)'
    call DclDrawYSubTitle('l',ctl,0.0)

    call DclNewFrame
    nd=60
    call DclSetWindow(0.0,1.0,0.0,real(nd))
    call DclSetViewPort(0.13,0.14,0.1,0.9)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawYAxisDay('l',jd0,nd)
    ctl='DclDrawYAxisDay (60days)'
    call DclDrawYSubTitle('l',ctl,0.0)

    call DclNewFrame
    nd=120
    call DclSetWindow(0.0,1.0,0.0,real(nd))
    call DclSetViewPort(0.13,0.14,0.1,0.9)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawYAxisMonth('l',jd0,nd)
    ctl='DclDrawYAxisMonth (120days)'
    call DclDrawYSubTitle('l',ctl,0.0)

    call DclNewFrame
    nd=2000
    call DclSetWindow(0.0,1.0,0.0,real(nd))
    call DclSetViewPort(0.13,0.14,0.1,0.9)
    call DclSetTransNumber(1)
    call DclSetTransFunction
    call DclDrawYAxisYear('l',jd0,nd)
    ctl='DclDrawYAxisYear (2000days)'
    call DclDrawYSubTitle('l',ctl,0.0)

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SYSFONT

      PARAMETER (N=10)
      DIMENSION Y(N)
      CHARACTER FONTNAME*50, CH*3, OPT*20, FULLNAME*70
      INTEGER PM, J, NFNT

      CALL SWLSET('LSYSFNT', .TRUE.)

      CALL SWFTNM(NFNT)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      I = 0
      CALL ZGFONTNAME(I, FONTNAME, NFNT)

      PM = NFNT/N + 1

      OPT = ' Regular '

      WRITE(*,*) OPT



      CALL SGOPN(IWS)

      CALL SLDIV('T',2,2)

      X1 = 0.01
      X2 = 0.99
      XC = 0.35

      DO 30 J=0, PM
      CALL SGFRM

      CALL SGSLNI(1)
      DO 10 I=1, N
        Y(I) = 0.09 * (11-I)
        CALL SGLNV(X1, Y(I)+0.05, X2, Y(I)+0.05)
  10  CONTINUE
      CALL SGLNV(X1, 0.05, X2, 0.05)

      CALL SGSTXC(-1)

      DO 20 I=1, N
      IF (I+J*N .GT. NFNT-1) THEN
        GO TO 40
      END IF

      CALL ZGFONTNAME(I+J*N, FONTNAME, NFNT)

      DO 5 K=1, 50
         IF (FONTNAME(K:K) == FONTNAME(50:50)) THEN
           FULLNAME = FONTNAME(1:K-1)//OPT
         GO TO 6
         END IF
   5  CONTINUE
   6  CONTINUE


      CALL SWCSET('FONTNAME', FULLNAME)

      CALL SGSTXS(0.015)
      CALL SGTXV(X1, Y(I)+0.015, FULLNAME)
      WRITE(CH,'(I3)') I+J*N
      CALL SGTXZV(X1, Y(I)+0.035, CH, 0.015, 0, -1, 1)
      CALL SGSTXS(0.05)
      CALL SGTXV(XC, Y(I), 'ABCabs012留硫粒')
      WRITE(*,*) FULLNAME


  20  CONTINUE



  30  CONTINUE

  40  CONTINUE



      CALL SGCLS

      END

module fft_work
  use dcl_common

  type work
    integer                     :: n
    real, dimension(:), pointer :: array
  end type work

end module
!-------------------------------------------------
!  FFT  周期実数値データのフーリエ変換 (1)
!-------------------------------------------------
module fftreal
  use fft_work
  type(work), dimension(10), private :: wk

  contains
!---------------------------------------------------------
  subroutine DclInitRealFFT(n, index)       !初期化をおこなう
    integer, intent(in)           :: n      !処理するデータの長さ
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclInitRealFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    if(associated(wk(idx)%array)) call msgdmp('E', 'DclInitRealFFT', &
                   & 'Working area has been allocated already.')
    wk(idx)%n = n
    len = 2*n+15
    allocate(wk(idx)%array(len))

    call rffti(n, wk(idx)%array) 
    call prccls('DclInitRealFFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocRealFFT(index)
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclDeallocRealFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if
    deallocate(wk(idx)%array)
    call prccls('DclDeallocRealFFT')
  end subroutine
!---------------------------------------------------------
  function DclRealFFT_F(x, index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclRealFFT_F

    call prcopn('DclRealFFT_F')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclRealFFT_F', &
                   & 'Wrong working area.')
    DclRealFFT_F = x
    call rfftf(n, DclRealFFT_F, wk(idx)%array) 
    call prccls('DclRealFFT_F')
  end function
!---------------------------------------------------------
  function DclRealFFT_B(x, index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclRealFFT_B

    call prcopn('DclRealFFT_B')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclrealFFT_B', &
                   & 'Wrong working area.')
    DclRealFFT_B = x
    call rfftb(n, DclRealFFT_B, wk(idx)%array) 
    call prccls('DclRealFFT_B')
  end function
end module
!-------------------------------------------------
! FFT: rffti, rfftf, rfftbの簡易型サブルーチン (2)
!-------------------------------------------------
module ffteasy
  use fft_work
  type(work), dimension(10), private :: wk

  contains
!---------------------------------------------------------
  subroutine DclInitEasyFFT(n, index)       !初期化をおこなう
    integer, intent(in)           :: n      !処理するデータの長さ
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclInitEasyFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    if(associated(wk(idx)%array)) call msgdmp('E', 'DclInitEasyFFT', &
                   & 'Working area has been allocated already.')
    wk(idx)%n = n
    len = 3*n+15
    allocate(wk(idx)%array(len))

    call ezffti(n, wk(idx)%array) 
    call prccls('DclInitEasyFFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocEasyFFT(index)
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclDeallocEasyFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if
    deallocate(wk(idx)%array)
    call prccls('DclDeallocEasyFFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclEasyFFT_F(x,a0,a,b,index)
    real,    intent(in),  dimension(:) :: x
    real,    intent(out)               :: a0 
    real,    intent(out), dimension(:) :: a
    real,    intent(out), dimension(:) :: b
    integer, intent(in),  optional     :: index

    call prcopn('DclEasyFFT_F')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclEasyFFT_F', &
                   & 'Wrong working area.')
    call ezfftf(n,x,a0,a,b,wk(idx)%array) 
    call prccls('DclEasyFFT_F')
  end subroutine
!---------------------------------------------------------
  subroutine DclEasyFFT_B(x,a0,a,b,index)
    real,    intent(out), dimension(:) :: x
    real,    intent(in)                :: a0
    real,    intent(in),  dimension(:) :: a
    real,    intent(in),  dimension(:) :: b 
    integer, intent(in),  optional     :: index

    call prcopn('DclEasyFFT_B')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclEasyFFT_B', &
                   & 'Wrong working area.')
    call ezfftb(n,x,a0,a,b,wk(idx)%array) 
    call prccls('DclEasyFFT_B')
  end subroutine
end module
!-------------------------------------------------
! 奇の周期データのsine変換をおこなう． (3)
!-------------------------------------------------
module fftsin
  use fft_work
  type(work), dimension(10), private :: wk

  contains
!---------------------------------------------------------
  subroutine DclInitSinFFT(n,index)
    integer, intent(in)           :: n      !処理するデータの長さ
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclInitSinFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    if(associated(wk(idx)%array)) call msgdmp('E', 'DclInitSinFFT', &
                   & 'Working area has been allocated already.')
    wk(idx)%n = n
    len = 2.5*n+15
    allocate(wk(idx)%array(len))

    call sinti(n, wk(idx)%array)
    call prccls('DclInitSinFFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocSinFFT(index)
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclDeallocSinFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if
    deallocate(wk(idx)%array)
    call prccls('DclDeallocSinFFT')
  end subroutine
!---------------------------------------------------------
  function DclSinFFT(x,index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclSinFFT

    call prcopn('DclSinFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclSinFFT', &
                   & 'Wrong working area.')
    DclSinFFT = x
    call sint(n, DclSinFFT, wk(idx)%array)
    call prccls('DclSinFFT')
  end function
end module
!-------------------------------------------------
! FFT: 偶の周期データのcosine変換をおこなう (4)
!-------------------------------------------------
module fftcos
  use fft_work
  type(work), dimension(10), private :: wk

  contains
!---------------------------------------------------------
  subroutine DclInitCosFFT(n,index) 
    integer, intent(in)           :: n      !処理するデータの長さ
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclInitCosFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    if(associated(wk(idx)%array)) call msgdmp('E', 'DclInitCosFFT', &
                   & 'Working area has been allocated already.')
    wk(idx)%n = n
    len = 3*n+15
    allocate(wk(idx)%array(len))

    call costi(n, wk(idx)%array)
    call prccls('DclInitCosFFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocCosFFT(index)
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclDeallocCosFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if
    deallocate(wk(idx)%array)
    call prccls('DclDeallocCosFFT')
  end subroutine
!---------------------------------------------------------
  function DclCosFFT(x, index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclCosFFT

    call prcopn('DclCosFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclCosFFT', &
                   & 'Wrong working area.')
    DclCosFFT = x
    call cost(n,DclCosFFT,wk(idx)%array)
    call prccls('DclCosFFT')
  end function
end module
!-------------------------------------------------
! FFT: 奇数波数成分のみのsin変換をおこなう．(5)
!-------------------------------------------------
module fftqsin
  use fft_work
  type(work), dimension(10), private :: wk

  contains
!---------------------------------------------------------
  subroutine DclInitSinQFT(n,index)
    integer, intent(in)           :: n      !処理するデータの長さ
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclInitSinQFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    if(associated(wk(idx)%array)) call msgdmp('E', 'DclInitSinQFT', &
                   & 'Working area has been allocated already.')
    wk(idx)%n = n
    len = 3*n+15
    allocate(wk(idx)%array(len))

    call sinqi(n, wk(idx)%array)
    call prccls('DclInitSinQFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocSinQFT(index)
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclDeallocSinQFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if
    deallocate(wk(idx)%array)
    call prccls('DclDeallocSinQFT')
  end subroutine
!---------------------------------------------------------
  function DclSinQFT_F(x, index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclSinQFT_F

    call prcopn('DclSinQFT_F')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclSinQFT_F', &
                   & 'Wrong working area.')
    DclSinQFT_F = x
    call sinqf(n, DclSinQFT_F, wk(idx)%array)
    call prccls('DclSinQFT_F')
  end function
!---------------------------------------------------------
  function DclSinQFT_B(x, index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclSinQFT_B

    call prcopn('DclSinQFT_B')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclSinQFT_B', &
                   & 'Wrong working area.')
    DclSinQFT_B = x
    call sinqb(n, DclSinQFT_B, wk(idx)%array)
    call prccls('DclSinQFT_B')
  end function
end module
!-------------------------------------------------
! FFT:偶数波数成分のみのcossine変換をおこなう．(6)
!-------------------------------------------------
module fftqcos
  use fft_work
  type(work), dimension(10), private :: wk

  contains
!---------------------------------------------------------
  subroutine DclInitCosQFT(n,index)
    integer, intent(in)           :: n      !処理するデータの長さ
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclInitCosQFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    if(associated(wk(idx)%array)) call msgdmp('E', 'DclInitCosQFT', &
                   & 'Working area has been allocated already.')
    wk(idx)%n = n
    len = 3*n+15
    allocate(wk(idx)%array(len))

    call cosqi(n, wk(idx)%array)
    call prccls('DclInitCosQFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocCosQFT(index)
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclDeallocCosQFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if
    deallocate(wk(idx)%array)
    call prccls('DclDeallocCosQFT')
  end subroutine
!---------------------------------------------------------
  function DclCosQFT_F(x, index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclCosQFT_F

    call prcopn('DclCosQFT_F')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclCosQFT_F', &
                   & 'Wrong working area.')
    DclCosQFT_F = x
    call cosqf(n, DclCosQFT_F, wk(idx)%array)
    call prccls('DclCosQFT_F')
  end function
!---------------------------------------------------------
  function DclCosQFT_B(x, index)
    real,    intent(in), dimension(:) :: x
    integer, intent(in), optional     :: index
    real,    dimension(size(x))       :: DclCosQFT_B

    call prcopn('DclCosQFT_B')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(x)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclCosQFT_B', &
                   & 'Wrong working area.')
    DclCosQFT_B = x
    call cosqb(size(x), DclCosQFT_B, wk(idx)%array)
    call prccls('DclCosQFT_B')
  end function
end module
!-------------------------------------------------
! 周期複素数データのフーリエ変換をおこなう  (7)
!-------------------------------------------------
module fftcmplx
  use fft_work
  type(work), dimension(10), private :: wk

  contains
!---------------------------------------------------------
  subroutine DclInitComplexFFT(n,index)
    integer, intent(in)           :: n      !処理するデータの長さ
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclInitComplexFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    if(associated(wk(idx)%array)) call msgdmp('E', 'DclInitComplexFFT', &
                   & 'Working area has been allocated already.')
    wk(idx)%n = n
    len = 4*n+15
    allocate(wk(idx)%array(len))

    call cffti(n, wk(idx)%array)
    call prccls('DclInitComplexFFT')
  end subroutine
!---------------------------------------------------------
  subroutine DclDeallocComplexFFT(index)
    integer, intent(in), optional :: index  !作業領域番号

    call prcopn('DclDeallocComplexFFT')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if
    deallocate(wk(idx)%array)
    call prccls('DclDeallocComplexFFT')
  end subroutine
!---------------------------------------------------------
  function DclComplexFFT_F(c,index)
    complex, intent(in), dimension(:) :: c
    integer, intent(in), optional     :: index
    complex, dimension(size(c))       :: DclComplexFFT_F

    call prcopn('DclComplexFFT_F')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(c)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclComplexFFT_F', &
                   & 'Wrong working area.')
    DclComplexFFT_F = c
    call cfftf(n, DclComplexFFT_F, wk(idx)%array)
    call prccls('DclComplexFFT_F')
  end function
!---------------------------------------------------------
  function DclComplexFFT_B(c,index)
    complex, intent(in), dimension(:) :: c
    integer, intent(in), optional     :: index
    complex, dimension(size(c))       :: DclComplexFFT_B

    call prcopn('DclComplexFFT_B')
    if(present(index)) then; idx = index
                       else; idx = 1     ; end if

    n = size(c)
    if(n.ne.wk(idx)%n) call msgdmp('E', 'DclComplexFFT_B', &
                   & 'Wrong working area.')
    DclComplexFFT_B = c
    call cfftb(n, DclComplexFFT_B, wk(idx)%array)
    call prccls('DclComplexFFT_B')
  end function
end module
!-------------------------------------------------
!  fftlib Module
!-------------------------------------------------
module fftlib
  use fftreal
  use ffteasy
  use fftsin
  use fftcos
  use fftqsin
  use fftqcos
  use fftcmplx
  private :: work
end module

*-----------------------------------------------------------------------
*     SWLQNP / SWLQID / SWLQCP / SWLQVL / SWLSVL
*-----------------------------------------------------------------------
      SUBROUTINE SWLQNP(NCP)
      INTEGER   NCP
      CHARACTER CP*(*)

      PARAMETER (NPARA = 14)

      LOGICAL   LX(NPARA), LPARA
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

* ---- SHORT NAME ----
      DATA      CPARAS(1)  / 'LWAIT   ' / , LX(1)  / .TRUE. /
      DATA      CPARAS(2)  / 'LWAIT0  ' / , LX(2)  / .FALSE. /
      DATA      CPARAS(3)  / 'LWAIT1  ' / , LX(3)  / .TRUE. /
      DATA      CPARAS(4)  / 'LKEY    ' / , LX(4)  / .TRUE. /
      DATA      CPARAS(5)  / 'LDUMP   ' / , LX(5)  / .FALSE. /
      DATA      CPARAS(6)  / 'LALT    ' / , LX(6)  / .FALSE. /
      DATA      CPARAS(7)  / 'LCOLOR  ' / , LX(7)  / .TRUE. /
      DATA      CPARAS(8)  / 'LSEP    ' / , LX(8)  / .FALSE. /
      DATA      CPARAS(9)  / 'LPRINT  ' / , LX(9)  / .FALSE. /
      DATA      CPARAS(10) / 'LWND    ' / , LX(10) / .TRUE. /
      DATA      CPARAS(11) / 'LFGBG   ' / , LX(11) / .FALSE. /
      DATA      CPARAS(12) / 'LCMCH   ' / , LX(12) / .TRUE. /
      DATA      CPARAS(13) / 'LSTDOT  ' / , LX(13) / .FALSE. /
      DATA      CPARAS(14) / 'LSYSFNT ' / , LX(14) / .FALSE. /

* ---- LONG NAME ----
      DATA      CPARAL(1)  / 'WAIT' /
      DATA      CPARAL(2)  / 'WAIT_OPENING' /
      DATA      CPARAL(3)  / 'WAIT_CLOSING' /
      DATA      CPARAL(4)  / 'KEYCLICK' /
      DATA      CPARAL(5)  / 'DUMP' /
      DATA      CPARAL(6)  / 'ALTERNATE' /
      DATA      CPARAL(7)  / 'ENABLE_COLOR_PS' /
      DATA      CPARAL(8)  / 'SEPARATE' /
      DATA      CPARAL(9)  / 'PRINT' /
      DATA      CPARAL(10) / 'SHOW_WINDOW' /
      DATA      CPARAL(11) / '****LFGBG   ' /
      DATA      CPARAL(12) / 'CMAP_CHANGABLE' /
      DATA      CPARAL(13) / 'PNG_STDOUT' /
      DATA      CPARAL(14) / 'USE_SYSTEM_FONT' /

      DATA      LFIRST / .TRUE. /

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N))
     &        .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','SWLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','SWLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','SWLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('SW', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST=.FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','SWLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('SW', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','SWLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWLQIN(CP, IN)

      DO 20 N = 1, NPARA
         IF (LCHREQ(CP, CPARAS(N)) .OR.
     &        LCHREQ(CP, CPARAL(N))) THEN
            IN = N
            RETURN
         ENDIF
 20   CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     UZCQNP
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UZCQNP(NCP)

      CHARACTER CP*(*), CVAL*(*)

      PARAMETER (NPARA = 2)

      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CX(NPARA)*80, CMSG*80

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1)/'CXFMT  '/, CX( 1) /'B'/
      DATA      CPARAS( 2)/'CYFMT  '/, CX( 2) /'B'/

*     / LONG NAME /

      DATA      CPARAL( 1) / '****CXFMT  ' /
      DATA      CPARAL( 2) / '****CYFMT  ' /

      DATA      LFIRST /.TRUE./


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCQID(CP, IDX)

      DO 10 N=1,NPARA
        IF (LCHREQ(CP,CPARAS(N)) .OR. LCHREQ(CP,CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE

      CMSG = 'PARAMETER "'//CP(1:LENC(CP))//'" IS NOT DEFINED.'
      CALL MSGDMP('E','UZCQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCQCP(IDX,CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UZCQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCQCL(IDX,CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UZCQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCQVL(IDX,CVAL)

      IF(LFIRST) THEN
        CALL RTCGET('UZ', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      ENDIF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CVAL = CX(IDX)
      ELSE
        CALL MSGDMP('E','UZCQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCSVL(IDX,CVAL)

      IF(LFIRST) THEN
        CALL RTCGET('UZ', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      ENDIF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CX(IDX) = CVAL
      ELSE
        CALL MSGDMP('E','UZCSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCSAV(IU)

      WRITE(UNIT=IU,IOSTAT=IOS) CX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZCSAV','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZCRST(IU)

      READ(UNIT=IU,IOSTAT=IOS) CX
      IF (IOS.NE.0) THEN
        CALL MSGDMP('E','UZCRST','IOSTAT IS NOT ZERO.')
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM LAY1

      PARAMETER( NMAX=401, JMAX=51 )
      REAL Y(NMAX), YY(JMAX)

*-- データ ----
      Y0 = 0.5
      DO 10 N=1,NMAX
        Y(N) = 5.*Y0 + 10.
        Y0   = 3.7*Y0*(1.-Y0)
   10 CONTINUE

      CALL GLRGET( 'RUNDEF', RUNDEF )

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SLDIV( 'Y', 3, 2 )

      DO 20 I=1,8
        CALL GRFRM

        IJMIN = (I-1)*(JMAX-1) + 1
        IJ = IJMIN
        DO 30 J=1,JMAX
          YY(J) = Y(IJ)
          IJ = IJ + 1
   30   CONTINUE
        XMIN = IJMIN + 1599
        XMAX =  XMIN + JMAX - 1

        CALL GRSWND( XMIN, XMAX, RUNDEF, RUNDEF )
        CALL USSTTL( 'TIME', 'YEAR', 'TEMPERATURE', 'DEG' )
        CALL USGRPH( JMAX, RUNDEF, YY )
   20 CONTINUE

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZLAZV(VX1,VY1,VX2,VY2)

      COMMON    /SZBLA1/ LARRWZ,LPROPZ,AFACTZ,CONSTZ,ANGLEZ,
     +                   LATONZ,LUARWZ,CONSMZ,RDUNIT
      LOGICAL   LARRWZ,LPROPZ,LATONZ,LUARWZ

      EXTERNAL  RFPI

      SAVE


      R=SQRT((VX2-VX1)**2+(VY2-VY1)**2)
      IF (R.EQ.0) RETURN

      CALL SZOPLV
      CALL SZMVLV(VX1,VY1)
      CALL SZPLLV(VX2,VY2)
      CALL SZCLLV

      IF (.NOT.LARRWZ) RETURN

      PI=RFPI()

      IF (LPROPZ) THEN
        AR=R*AFACTZ
      ELSE
        AR=CONSTZ
      END IF

      XE=(VX2-VX1)/R*AR
      YE=(VY2-VY1)/R*AR
      CALL CR2C(-(PI-ANGLEZ*RDUNIT),XE,YE,XA1,YA1)
      CALL CR2C(-(PI+ANGLEZ*RDUNIT),XE,YE,XA2,YA2)

      IF (LATONZ) THEN
        CALL SZOPTV
        CALL SZSTTV(VX2+XA1,VY2+YA1)
        CALL SZSTTV(VX2,VY2)
        CALL SZSTTV(VX2+XA2,VY2+YA2)
        CALL SZCLTV
      ELSE
        CALL SZOPLV
        CALL SZMVLV(VX2+XA1,VY2+YA1)
        CALL SZPLLV(VX2,VY2)
        CALL SZPLLV(VX2+XA2,VY2+YA2)
        CALL SZCLLV
      END IF

  100 CONTINUE

      END

*-----------------------------------------------------------------------
*     UCYACL : PLOT CALENDAR AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCYACL(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      LOGICAL   LUYCHK


      IF (.NOT.LUYCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCYACL','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCYACL','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCYACL','DATE LENGTH IS LESS THAN 0.')
      END IF

      CALL UYPAXS(CSIDE,2)

      CALL UCYADY(CSIDE,JD0,ND)
      CALL UCYAMN(CSIDE,JD0,ND)
      CALL UCYAYR(CSIDE,JD0,ND)

      END

program layout05

  use dcl

    call DclOpenGraphics()

    call DclSetFrameMargin( 0.1, 0.1, 0.1, 0.1 )
    call DclSetFrameTitle( 'figure title', 't',  0.,  0., 0.03, 1 )
    call DclSetFrameTitle( 'program.name', 'b', -1.,  1., 0.02, 2 )
    call DclSetFrameTitle( '#date #time',  'b',  0.,  0., 0.02, 3 )
    call DclSetFrameTitle( 'page:#page',   'b',  1., -1., 0.02, 4 )

    call DclNewFrame
    call DclSetViewPort( 0.1,0.9,0.1,0.9 )
    call DclDrawViewPortFrame( 1 )
    call DclDrawTextNormalized( 0.5, 0.5, 'figure' )

    call DclCloseGraphics

end program

program sample01

  use dcl
  integer,parameter :: nmax = 400
  real,dimension(0:nmax) :: x,y,t

!-- リサジューの図 ----

    t = (/( n,n=0,nmax )/) / real(nmax)     ! 媒介変数(0≦t≦1)
    x = 1.e2  * sin( 2.*DCL_PI * 4.*t )     ! x = Asin(2πω t)
    y = 1.e-3 * cos( 2.*DCL_PI * 5.*t ) + 6.! y = Bcos(2πω't)+C

!-- グラフ ----

    call DclOpenGraphics()          ! 出力装置のオープン
    call DclNewFrame                ! 新しい描画領域を作成する

    call DclDrawScaledGraph( x, y ) ! おまかせでグラフを描く

    call DclCloseGraphics           ! 出力装置のクローズ

end program

program sample_1d04

  use dcl
  integer, parameter :: n=200
  real(kind=selected_real_kind(12)) :: x=0.d0, y=1.d0, z=1.d0
  real(kind=selected_real_kind(12)) :: dx, dy, dz, dt=0.01d0
  real(kind=selected_real_kind(12)) :: s=10.d0, r=26.d0, b=2.6d0
  real, dimension(n)                :: t, a

!-----------------------------------------------------------------------

    do i=1, n
      do  j=1, 8
        dx = -s*x + s*y
        dy = -x*z + r*x - y
        dz =  x*y - b*z
        x = x + dx*dt
        y = y + dy*dt
        z = z + dz*dt
      end do
      t(i) = (i-1)*1000
      a(i) = y + 20.
    end do

!-----------------------------------------------------------------------

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetTitle ('Time', 'Heat Flux', 'Sec', 'W/m\^{2}')
    call DclDrawScaledGraph(t, a)

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2D2

      PARAMETER( NT=51, NZ=21 )
      PARAMETER( TMIN=0, TMAX=5, ZMIN=20, ZMAX=50 )
      PARAMETER( DT=(TMAX-TMIN)/(NT-1), DZ=(ZMAX-ZMIN)/(NZ-1) )
      REAL U(NT,NZ)

*-- データ ----
      DO 10 J=1,NZ
        Z  = (J-1)*DZ
        UZ = EXP(-0.2*Z)*(Z**0.5)
        DO 20 I=1,NT
          T = (I-1)*DT - 2.*EXP(-0.1*Z)
          U(I,J) = UZ*SIN(3.*T)
   20   CONTINUE
   10 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL GRFRM

      CALL GRSWND( TMIN, TMAX, ZMIN, ZMAX )
      CALL GRSVPT(  0.2,  0.9,  0.4,  0.8 )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'TIME', 'YEAR', 'HEIGHT', 'km' )
      CALL USDAXS

      CALL UDCNTR( U, NT, NT, NZ )
      CALL UETONE( U, NT, NT, NZ )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TIME02

      CHARACTER CFORM*24


      WRITE(*,*) '*** TEST FOR CHARACTER TIME & TIME INQUIRY'
      WRITE(*,*) '*** TYPE-1'
      CFORM='HH,MM,SS'
      WRITE(*,*) 'CFORM = ',CFORM
      CALL TIMEQ1(ITIME)
      CALL TIMEC1(CFORM,ITIME)
      WRITE(*,*) 'AFTER CALLING TIMEQ1(ITIME)'
      WRITE(*,*) '    AND       TIMEC1(CFORM,ITIME)'
      WRITE(*,*) 'CFORM = ',CFORM
      WRITE(*,*) '*** TYPE-2'
      CFORM='HHhMMmSSs'
      WRITE(*,*) 'CFORM = ',CFORM
      CALL TIMEQ2(ITT)
      CALL TIMEC2(CFORM,ITT)
      WRITE(*,*) 'AFTER CALLING TIMEQ2(ITT)'
      WRITE(*,*) '    AND       TIMEC2(CFORM,ITT)'
      WRITE(*,*) 'CFORM = ',CFORM
      WRITE(*,*) '*** TYPE-3'
      CFORM='HH:MM:SS'
      WRITE(*,*) 'CFORM = ',CFORM
      CALL TIMEQ3(IH,IM,IS)
      CALL TIMEC3(CFORM,IH,IM,IS)
      WRITE(*,*) 'AFTER CALLING TIMEQ3(IH,IM,IS)'
      WRITE(*,*) '    AND       TIMEC3(CFORM,IH,IM,IS)'
      WRITE(*,*) 'CFORM = ',CFORM

      END

*-----------------------------------------------------------------------
      PROGRAM SGPK10

      PARAMETER ( ND=12, DDEG=360.0/ND, DD=0.25 )
      PARAMETER ( PI=3.141592 )

      REAL      RX(ND), RY(ND)


      DO 10 N = 1, ND
        RX(N) = DD*N*COS(PI/180*DDEG*(N-1))
        RY(N) = DD*N*SIN(PI/180*DDEG*(N-1))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN( IWS )

      CALL SGFRM

      CALL SGSWND( 0.0, 10.0, 0.0, 10.0 )
      CALL SGSVPT( 0.0, 1.0, 0.0, 1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      X1 = 3.0
      Y1 = 7.0
      DO 15 N = 1, ND
        CALL SGLAZU( X1, Y1, X1+RX(N), Y1+RY(N), 1, 2 )
   15 CONTINUE

      CALL SGLSET( 'LPROP', .FALSE. )
      CALL SGRSET( 'CONST', 0.05 )
      X1 = 7.0
      Y1 = 7.0
      DO 20 N = 1, ND
        CALL SGLAZU( X1, Y1, X1+RX(N), Y1+RY(N), 1, 2 )
   20 CONTINUE

      DO 25 I = 1, 8
        CALL SGRSET( 'ANGLE', 10.0*I )
        CALL SGLAZU( REAL(I), 2.0, REAL(I)+1, 3.0, 1, 2 )
   25 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UETONE(Z,MX,NX,NY)

      REAL      Z(MX,*)

      INTEGER   NP(2),NI(2)
      REAL      XC(4),YC(4),ZC(4),AX(10),AY(10),TLM(2)
      LOGICAL   LMISS

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)

      EXTERNAL  RUWGX,RUWGY

      CALL SGIGET('IBGCLI',IBGCLI)

*     / GET INTERNAL PARAMETERS /

      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )
      CALL SGIGET('ITR     ',ITR)

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX,NY)

*     / CHECK Z VALUES AND TONE LEVEL /

      CALL UEZCHK(Z,MX,NX,NY,'UETONE',ISTAT)
      IF (ISTAT.NE.0) RETURN

*     / SET TONE MODE (IRMODE) /

      CALL UWQGXB(UXMIN,UXMAX,NXZ)
      CALL UWQGYB(UYMIN,UYMAX,NYZ)

      IF (ITR.LT.4) THEN
        CALL STFTRF(UXMIN,UYMIN,VXMIN,VYMIN)
        CALL STFTRF(UXMAX,UYMAX,VXMAX,VYMAX)
        DX=VXMAX-VXMIN
        DY=VYMAX-VYMIN
      ELSE
        DX=UXMAX-UXMIN
        DY=UYMAX-UYMIN
      END IF

      IRMODE=0
      IF (DX.LT.0) IRMODE=MOD(IRMODE+1,2)
      IF (DY.LT.0) IRMODE=MOD(IRMODE+1,2)

      CALL SGISET('IRMODE', IRMODE)

*     / INITIALIZE /

      CALL UEAINT

*     / LOOP FOR EACH TONE PATTERN /

      DO 30 IT=1,NT

        CALL SZTNOP(IPT(IT))

*       / LOOP FOR EACH SECTION /

        DO 20 I=1,NX-1

          I1=I+1
          ZMAX1=MAX(Z(I,1),Z(I1,1))
          ZMIN1=MIN(Z(I,1),Z(I1,1))

          XC(1)=RUWGX(I)
          XC(2)=RUWGX(I1)
          XC(3)=XC(2)
          XC(4)=XC(1)

          DO 10 J=1,NY-1

            J1=J+1
            ZMAX0=ZMAX1
            ZMIN0=ZMIN1
            ZMAX1=MAX(Z(I, J1), Z(I1, J1))
            ZMIN1=MIN(Z(I, J1), Z(I1, J1))

            ZMAX=MAX(ZMAX0,ZMAX1)
            ZMIN=MIN(ZMIN0,ZMIN1)

            IF (ZMAX.LT.TL1(IT)) GO TO 10
            IF (ZMIN.GT.TL2(IT)) GO TO 10

            ZC(1)=Z(I ,J )
            ZC(2)=Z(I1,J )
            ZC(3)=Z(I1,J1)
            ZC(4)=Z(I ,J1)

            IF (LMISS .AND. NINDXR(ZC,4,1,RMISS).NE.0) GO TO 10

            YC(1)=RUWGY(J)
            YC(2)=YC(1)
            YC(3)=RUWGY(J1)
            YC(4)=YC(3)

            TLM(1)=TL1(IT)
            TLM(2)=TL2(IT)
            CALL UEAREA(XC,YC,ZC,TLM,AX,AY,NP,NI,NG)

            DO 40 N=1,NG
              CALL SZTNZU(NP(N),AX(NI(N)),AY(NI(N)))
   40       CONTINUE

   10     CONTINUE
   20   CONTINUE

        CALL SZTNCL

   30 CONTINUE

      END

*-----------------------------------------------------------------------
*     LINE INDEX ATTRIBUTE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZSIDX(INDEX)

      LOGICAL   LFRST,LWDATR,LCLATR,LFCATR

      SAVE

      DATA      LFRST/.TRUE./


      INDEXZ=INDEX

      IF (LFRST) THEN
        CALL SWQWDC(LWDATR)
        CALL SWQCLC(LCLATR)
        LFRST=.FALSE.
      END IF

      CALL SGIGET('IBGCLI',IBGCLI)
      CALL SGIGET('IFCIDX',IFCIDX)

      IWDIDX=MOD(INDEXZ,10)
      ICLIDX=INDEXZ/10

      IF (ICLIDX.EQ.IBGCLI) THEN
        ICLIDX=0
      ELSE
        ICLIDX=MOD(ICLIDX,1000)
        IF (ICLIDX.EQ.0) ICLIDX=1
      END IF

      IF (.NOT.LCLATR .AND. IWDIDX.EQ.0) THEN
        IWDIDX=ICLIDX
      ELSE IF (.NOT.LWDATR .AND. ICLIDX.EQ.0) THEN
        ICLIDX=IWDIDX
      END IF

      CALL SWSWDI(IWDIDX)
      CALL SWQFCC(LFCATR)
      CALL SWSCLI(ICLIDX,.NOT.LFCATR)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQIDX(INDEX)

      INDEX=INDEXZ

      RETURN
      END

*-----------------------------------------------------------------------
*     GET EXTERNAL PARAMETERS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE RPNGET

      INTEGER   IPARA(*)
      LOGICAL   LPARA(*)
      REAL      RPARA(*)
      CHARACTER CPARA(*)*80
      CHARACTER CPFIX*(*), CPS(*)*8, CPL(*)*40

      LOGICAL   LCHREQ, LFIRST, LGLC

      EXTERNAL  LCHREQ

      DATA      LFIRST / .TRUE. /

      RETURN
*-----------------------------------------------------------------------
*     GET INTEGER PARAMETERS WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTIGET(CPFIX, CPS, IPARA, MAX)

      IF (LFIRST) THEN
        CALL RPNXFL
        CALL RPNENV
        CALL RPNOPT
        LFIRST = .FALSE.
      END IF

      DO 10 N = 1, MAX
        CALL RTIXFL(CPFIX, CPS(N), IPARA(N))
        CALL RTIENV(CPFIX, CPS(N), IPARA(N))
        CALL RTIOPT(CPFIX, CPS(N), IPARA(N))
   10 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET LOGICAL PARAMETERS WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTLGET(CPFIX, CPS, LPARA, MAX)

      IF (LFIRST) THEN
        CALL RPNXFL
        CALL RPNENV
        CALL RPNOPT
        LFIRST = .FALSE.
      END IF

      DO 20 N = 1, MAX
        CALL RTLXFL(CPFIX, CPS(N), LPARA(N))
        CALL RTLENV(CPFIX, CPS(N), LPARA(N))
        CALL RTLOPT(CPFIX, CPS(N), LPARA(N))
   20 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET REAL PARAMETERS WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTRGET(CPFIX, CPS, RPARA, MAX)

      IF (LFIRST) THEN
        CALL RPNXFL
        CALL RPNENV
        CALL RPNOPT
        LFIRST = .FALSE.
      END IF

      DO 30 N = 1, MAX
        CALL RTRXFL(CPFIX, CPS(N), RPARA(N))
        CALL RTRENV(CPFIX, CPS(N), RPARA(N))
        CALL RTROPT(CPFIX, CPS(N), RPARA(N))
   30 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET CHARACTER PARAMETERS WITH SHORT NAME
*-----------------------------------------------------------------------
      ENTRY RTCGET(CPFIX, CPS, CPARA, MAX)

      LGLC = CPFIX.EQ.'GL'

      IF (LFIRST) THEN
        IF (.NOT.LGLC) THEN
          CALL RPNXFL
          LFIRST = .FALSE.
        END IF
        CALL RPNENV
        CALL RPNOPT
      END IF

      DO 40 N = 1, MAX
        IF (.NOT.LGLC) CALL RTCXFL(CPFIX, CPS(N), CPARA(N))
        CALL RTCENV(CPFIX, CPS(N), CPARA(N))
        CALL RTCOPT(CPFIX, CPS(N), CPARA(N))
   40 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET INTEGER PARAMETERS WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLIGET(CPL, IPARA, MAX)

      IF (LFIRST) THEN
        CALL RPNXFL
        CALL RPNENV
        CALL RPNOPT
        LFIRST = .FALSE.
      END IF

      DO 50 N = 1, MAX
        CALL RLIXFL(CPL(N), IPARA(N))
        CALL RLIENV(CPL(N), IPARA(N))
        CALL RLIOPT(CPL(N), IPARA(N))
   50 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET LOGICAL PARAMETERS WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLLGET(CPL, LPARA, MAX)

      IF (LFIRST) THEN
        CALL RPNXFL
        CALL RPNENV
        CALL RPNOPT
        LFIRST = .FALSE.
      END IF

      DO 60 N = 1, MAX
        CALL RLLXFL(CPL(N), LPARA(N))
        CALL RLLENV(CPL(N), LPARA(N))
        CALL RLLOPT(CPL(N), LPARA(N))
   60 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET REAL PARAMETERS WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLRGET(CPL, RPARA, MAX)

      IF (LFIRST) THEN
        CALL RPNXFL
        CALL RPNENV
        CALL RPNOPT
        LFIRST = .FALSE.
      END IF

      DO 70 N = 1, MAX
        CALL RLRXFL(CPL(N), RPARA(N))
        CALL RLRENV(CPL(N), RPARA(N))
        CALL RLROPT(CPL(N), RPARA(N))
   70 CONTINUE

      RETURN
*-----------------------------------------------------------------------
*     GET CHARACTER PARAMETERS WITH LONG NAME
*-----------------------------------------------------------------------
      ENTRY RLCGET(CPL, CPARA, MAX)

      LGLC = LCHREQ(CPL(1)(1:LENC(CPL(1))),'CONFIG_FILE')

      IF (LFIRST) THEN
        IF (.NOT.LGLC) THEN
          CALL RPNXFL
          LFIRST = .FALSE.
        END IF
        CALL RPNENV
        CALL RPNOPT
      END IF

      DO 80 N = 1, MAX
        IF (.NOT.LGLC) CALL RLCXFL(CPL(N), CPARA(N))
        CALL RLCENV(CPL(N), CPARA(N))
        CALL RLCOPT(CPL(N), CPARA(N))
   80 CONTINUE

      RETURN
      END

*-----------------------------------------------------------------------
*     DRAW MAP (GEOGRAPHIC LINES)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMPMAP(CDSN)

      CHARACTER CDSN*(*)

      PARAMETER (NPMAX=8192)

      REAL      XLAT(NPMAX),XLON(NPMAX)
      REAL      XLATSG(NPMAX),XLONSG(NPMAX)
      CHARACTER CDSNX*1024,CMSG*80
      LOGICAL   LITRONE, LLAST

      EXTERNAL  IUFOPN

      LITRONE = .FALSE.

*     / GET INTERNAL PARAMETERS /

      CALL UMIGET('INDEXOUT',INDEX)
      CALL UMIGET('ITYPEOUT',ITYPE)
      CALL SGQWND(UX0,UX1,UY0,UY1)
      CALL SGQTRN(ITR)

      IF (ITR .EQ. 1) THEN
        LITRONE = .TRUE.
      ELSE IF (1 .LT. ITR .AND. ITR .LT. 10) THEN
        CALL MSGDMP('E','UMPMAP','INVALID TRANSFORMATION NUMBER.')
      END IF

*     / INQUIRE OUTLINE FILE /
      CALL UMQFNM(CDSN,CDSNX)
      IF (CDSNX.EQ.' ') THEN
        CMSG='OUTLINE FILE = '//CDSN(1:LENC(CDSN))
        CALL MSGDMP('M','UMPMAP',CMSG)
        CALL MSGDMP('E','UMPMAP','OUTLINE FILE DOES NOT EXIST.')
      END IF

*     / OPEN OUTLINE FILE /

      IU=IUFOPN()
      OPEN(IU,FILE=CDSNX,FORM='UNFORMATTED',STATUS='OLD')
      REWIND(IU)

*     / READ OUTLINE DATA AND PLOT /

      CALL SZPLOP(ITYPE,INDEX)
   10 CONTINUE
        READ(IU,IOSTAT=IOS) NPTS,IGID,XLATMX,XLATMN,XLONMX,XLONMN,
     +     (XLAT(I),XLON(I),I=1,NPTS/2)
        IF (IOS.EQ.0) THEN
          IF (NPTS.GE.2) THEN
            IF (LITRONE) THEN
              DO 15 N=1, NPTS/2
                IF (UX0 .GT. XLON(N)) XLON(N) = XLON(N) + 360.0
                IF (UX1 .LT. XLON(N)) XLON(N) = XLON(N) - 360.0
   15         CONTINUE
              N0 = 1
              LLAST = .FALSE.
   20         CONTINUE
              DO 25 N = N0+1, NPTS/2
                IF (ABS(XLON(N)-XLON(N-1)) .GT. 300.0) GO TO 30
   25         CONTINUE
   30         CONTINUE
              NM = N
              IF (NM .GT. NPTS/2) THEN
                LLAST = .TRUE.
                NM = NPTS/2
              END IF
              DO 35 N = 1, NM-N0+1
                XLATSG(N) = XLAT(N+N0-1)
   35         CONTINUE
              DO 40 N = 1, NM-N0
                XLONSG(N) = XLON(N+N0-1)
   40         CONTINUE
              IF (LLAST) THEN
                XLONSG(NM-N0+1) = XLON(NM)
              ELSE
                IF (XLON(NM) .GT. XLON(NM-1)) THEN
                  XLONSG(NM-N0+1) = XLON(NM)-360.0
                  XLON(NM-1) = XLON(NM-1)+360.0
                ELSE
                  XLONSG(NM-N0+1) = XLON(NM)+360.0
                  XLON(NM-1) = XLON(NM-1)-360.0
                END IF
              END IF
              CALL SZPLZU(NM-N0+1,XLONSG,XLATSG)
              N0 = NM-1
              IF (NM .EQ. NPTS/2) GO TO 45
              GO TO 20
            ELSE
              CALL SZPLZU(NPTS/2,XLON,XLAT)
            END IF
   45       CONTINUE
          END IF
        END IF
      IF (IOS.EQ.0) GO TO 10
   50 CONTINUE
      CALL SZPLCL

      CLOSE(IU)

      END

      PROGRAM KIHON1

      PARAMETER( NMAX=50 )
      REAL X(0:NMAX), Y1(0:NMAX), Y2(0:NMAX), Y3(0:NMAX)

      DO 10 N=0,NMAX
        X (N) = REAL(N)/REAL(NMAX)
        Y1(N) = X(N)**3
        Y2(N) = X(N)**2
        Y3(N) = SQRT(X(N))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPLV( NMAX+1, X, Y1 )
      CALL SGPMV( NMAX+1, X, Y2 )
      CALL SGTXV( 0.5, 0.5, 'SGTXV' )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL SGTNV( NMAX+1, X, Y3 )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     USCQNP
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USCQNP(NCP)

      CHARACTER CP*(*), CVAL*(*)

      PARAMETER (NPARA = 11)

      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CX(NPARA)*80, CMSG*80
      LOGICAL   LCHREQ, LFIRST
      SAVE

* ---- short name ----
      DATA      CPARAS( 1) / 'CXSIDE  ' /, CX( 1) / 'BT' /
      DATA      CPARAS( 2) / 'CYSIDE  ' /, CX( 2) / 'LR' /
      DATA      CPARAS( 3) / 'CXSPOS  ' /, CX( 3) / 'R ' /
      DATA      CPARAS( 4) / 'CYSPOS  ' /, CX( 4) / 'T ' /
      DATA      CPARAS( 5) / 'CBLKT   ' /, CX( 5) / '()' /
      DATA      CPARAS( 6) / 'CXTTL   ' /, CX( 6) / ' ' /
      DATA      CPARAS( 7) / 'CYTTL   ' /, CX( 7) / ' ' /
      DATA      CPARAS( 8) / 'CXUNIT  ' /, CX( 8) / ' ' /
      DATA      CPARAS( 9) / 'CYUNIT  ' /, CX( 9) / ' ' /
      DATA      CPARAS(10) / 'CXFMT   ' /, CX(10) / ' ' /
      DATA      CPARAS(11) / 'CYFMT   ' /, CX(11) / ' ' /

* ---- long name ----
      DATA      CPARAL( 1) / 'X_AXIS_POS    ' /
      DATA      CPARAL( 2) / 'Y_AXIS_POS    ' /
      DATA      CPARAL( 3) / 'X_SUBLABEL_POS' /
      DATA      CPARAL( 4) / 'Y_SUBLABEL_POS' /
      DATA      CPARAL( 5) / 'SUBLABEL_BRACKET' /
      DATA      CPARAL( 6) / '****CXTTL   ' /
      DATA      CPARAL( 7) / '****CYTTL   ' /
      DATA      CPARAL( 8) / '****CXUNIT  ' /
      DATA      CPARAL( 9) / '****CYUNIT  ' /
      DATA      CPARAL(10) / '****CXFMT   ' /
      DATA      CPARAL(11) / '****CYFMT   ' /

      DATA      LFIRST /.TRUE./

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY USCQID(CP, IDX)

      DO 10 N=1,NPARA
        IF (LCHREQ(CP,CPARAS(N)) .OR. LCHREQ(CP,CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE

      CMSG='PARAMETER "'//CP(1:LENC(CP))//'" IS NOT DEFINED.'
      CALL MSGDMP('E','USCQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY USCQCP(IDX,CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
         CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','USCQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USCQCL(IDX,CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
         CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','USCQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USCQVL(IDX,CVAL)

      IF(LFIRST) THEN
        CALL RTCGET('US', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      ENDIF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CVAL=CX(IDX)
      ELSE
        CALL MSGDMP('E','USCQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USCSVL(IDX,CVAL)

      IF(LFIRST) THEN
        CALL RTCGET('US', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      ENDIF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CX(IDX)=CVAL
      ELSE
        CALL MSGDMP('E','USCSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USCQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
 20   CONTINUE

      IN = 0

      RETURN
      END

program size

  use dcl

    call DclOpenGraphics()

    call DclSetParm( 'USE_FULL_WINDOW', .true. )
    call DclSetFrameMargin( 0., 0., 0.08, 0.08 )
    call DclSetAspectRatio( 1., 0.6 )

    call DclNewFrame
    call DclSetViewPort( 0.1, 0.9, 0.1, 0.5 )
    call DclDrawDeviceWindowFrame( 1 )
    call DclDrawViewportFrame( 2 )
    call DclDrawTextNormalized( 0.5, 0.3, 'Figure' )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTNZV(N,VPX,VPY,ITPAT)

      REAL      VPX(*),VPY(*)


      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNZV','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPAT.EQ.0) THEN
        CALL MSGDMP('M','SGTNZV','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT.LT.0) THEN
        CALL MSGDMP('E','SGTNZV','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZTNOP(ITPAT)
      CALL SZTNZV(N,VPX,VPY)
      CALL SZTNCL

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGTXXU(UX,UY,CHARS,RSIZE,IROTA,ICENT,INDEX,ICOLOR)

      CHARACTER CHARS*(*)
      LOGICAL   LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGTXXU','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGTXXU','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGTXXU','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','SGTXXU','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGTXXU','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGTXXU','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZTXOP(RSIZE,IROTA,ICENT,INDEX)
      CALL SZTXZU(UX,UY,CHARS)
      CALL SZTXCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     MAP PROJECTION (VAN DER GRINTEN)              2007-11-04 E. TOYODA
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE MPXVDG(XLON, YLAT, X, Y)

      PARAMETER (EPSL = 1.0E-5, EPSX = 1.0E-3)
      PARAMETER (PLDYDB = 25.0, PLDXDB = 1000.0)
      EXTERNAL  RFPI, XMPLON
      REAL LAMBDA, HALFPI

      PI = RFPI()
      HALFPI = PI * 0.5
      LAMBDA = XMPLON(XLON)
      PHI = YLAT
      IF (PHI .GT. HALFPI - EPSL) THEN
        Y = PI + PLDYDB * (PHI - HALFPI)
        X = PLDXDB * LAMBDA * DIM(PHI, HALFPI)
        GOTO 8000
      ELSEIF (PHI .LT. -HALFPI + EPSL) THEN
        Y = -PI + PLDYDB * (PHI + HALFPI)
        X = PLDXDB * LAMBDA * DIM(-PHI, HALFPI)
        GOTO 8000
      ELSEIF (ABS(PHI) .LT. EPSL) THEN
        Y = PHI
        IF (ABS(LAMBDA) .LT. EPSL) THEN
          X = LAMBDA
          GOTO 8000
        ENDIF
        A = 0.5 * ABS(PI / LAMBDA - LAMBDA / PI)
        IF (LAMBDA .GT. 0.0) THEN
          X = PI * (SQRT(A**2 + 1) - A)
        ELSE
          X = -PI * (SQRT(A**2 + 1) - A)
        ENDIF
        GOTO 8000
      ENDIF
      TH = ASIN(ABS(2.0 * PHI / PI))
      G = COS(TH) / (SIN(TH) + COS(TH) - 1.0)
      P = G * (2.0 / SIN(TH) - 1.0)
      IF (ABS(LAMBDA) .LT. EPSX) THEN
        X = LAMBDA
        Y = +9.770711E-01 * PHI
     &      +5.484717E-01 * PHI**3
     &      -2.441382E+00 * PHI**5
     &      +5.923668E+00 * PHI**7
     &      -7.208943E+00 * PHI**9
     &      +4.639224E+00 * PHI**11
     &      -1.500824E+00 * PHI**13
     &      +1.924256E-01 * PHI**15
        GOTO 8000
      ENDIF
      A = 0.5 * ABS(PI / LAMBDA - LAMBDA / PI)
      Q = A * A + G
      IF (LAMBDA .GT. 0.0) THEN
        SGNLAM = 1.0
      ELSE
        SGNLAM = -1.0
      ENDIF
      X = SGNLAM * (
     &    PI * (A * (G - P**2)                                          &
     &  + SQRT(A**2 * (G - P**2)**2 - (P**2 + A**2) * (G**2 - P**2)))   &
     &  ) / (P * P + A * A)
      IF (PHI .GE. 0.0) THEN
        SGNPHI = 1.0
      ELSE
        SGNPHI = -1.0
      ENDIF
      Y = SGNPHI * PI * ABS(P * Q - A * SQRT((A**2 + 1) * (P**2 + A**2) &
     &  - Q**2)) / (P**2 + A**2)
 8000 CONTINUE
      END
*-----------------------------------------------------------------------
      SUBROUTINE MPFVDG(XLON, YLAT, X, Y)
        EXTERNAL MPXVDG
        CALL MPXVDG(XLON, YLAT, X, Y)
        RETURN
      ENTRY MPIVDG(X, Y, XLON, YLAT)
        XLON = X * 0.5
        YLAT = Y * 0.5
        CALL MPNWTN(X, Y, XLON, YLAT, MPXVDG, .FALSE.)
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTXZU(UX,UY,CHARS,RSIZE,IROTA,ICENT,INDEX)

      REAL WXR,WYR,Q2SIZE
      PARAMETER (WIDE=24)

      CHARACTER CHARS*(*)

      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGTXZU','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGTXZU','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','SGTXZU','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGTXZU','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGTXZU','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL STFTRF(UX,UY,VX,VY)
      CALL STFWTR(VX,VY,WX,WY)
      CALL STFWTR(VX+RSIZE,VY+RSIZE,WXR,WYR)
      QSIZE=WXR-WX
      Q2SIZE=WYR-WY

      IF(Q2SIZE>QSIZE)THEN
        QSIZE=Q2SIZE
      END IF

      THETA=RD2R(REAL(IROTA))
      CT=QSIZE*COS(THETA)
      ST=QSIZE*SIN(THETA)

      CALL SZTXOP(RSIZE,IROTA,ICENT,INDEX)
      CALL SZTXZU(UX,UY,CHARS)
      CALL SZTXCL

      END

!-------------------------------------------------
!  UVpack Module
!-------------------------------------------------
module uvpack
  use dcl_common
  contains
!--------------------------------------------------------
!   エラーバーを描く．
    subroutine   DclDrawYErrorBar(x,y1,y2,type,index,width)
      real,      intent(in), dimension(:) :: x, y1, y2
      integer,   intent(in), optional :: type, index
      real,      intent(in), optional :: width

      call sgoopn('DclDrawYErrorBar', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqebt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqebi(index0)
      end if

      if(present(width)) then ; width0 = width
                         else ; call uuqebs(width0)
      end if

      nx  = size(x)
      ny1 = size(y1)
      ny2 = size(y2)
      if(nx.ne.ny1 .or. nx.ne.ny2)  call msgdmp('M', 'DclDrawYErrorBar', &
                                    & 'Length of x and y don''t match.')
      n = min(nx, ny1, ny2)

      call uverbz(n,x,y1,y2,itype0,index0,width0)
      call sgocls('DclDrawYErrorBar')
    end subroutine
!--------------------------------------------------------
!   2本の折れ線の間をトーンパターンで塗る．
    subroutine  DclShadeYGap(x,y1,y2,pattern1,pattern2)
      real,      intent(in), dimension(:) :: x, y1, y2
      integer,   intent(in), optional :: pattern1, pattern2

      call sgoopn('DclShadeYGap', ' ')
      if(present(pattern1)) then ; itp1 = pattern1
                            else ; call uuqarp(itp1, idummy)
      end if

      if(present(pattern2)) then ; itp2 = pattern1
                            else ; call uuqarp(idummy, itp2)
      end if
 
      nx  = size(x)
      ny1 = size(y1)
      ny2 = size(y2)
      if(nx.ne.ny1 .or. nx.ne.ny2)  call msgdmp('M', 'DclShadeYGap', &
                                    & 'Length of x and y don''t match.')
      n = min(nx, ny1, ny2)

      call uvdifz(n,x,y1,y2,itp1,itp2)
      call sgocls('DclShadeYGap')
    end subroutine
!--------------------------------------------------------
!   棒グラフの枠を描く．
    subroutine DclDrawYBarFrame(x,y1,y2,type,index,width)
      real,      intent(in), dimension(:) :: x, y1, y2
      integer,   intent(in), optional :: type, index
      real,      intent(in), optional :: width

      call sgoopn('DclDrawYBarFrame', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      if(present(width)) then ; width0 = width
                         else ; call uuqbrs(width0)
      end if

      nx  = size(x)
      ny1 = size(y1)
      ny2 = size(y2)
      if(nx.ne.ny1 .or. nx.ne.ny2)  call msgdmp('M', 'DclDrawYBarFrame', &
                                    & 'Length of x and y don''t match.')
      n = min(nx, ny1, ny2)

      call uvbrfz(n,x,y1,y2,itype0,index0,width0)
      call sgocls('DclDrawYBarFrame')
    end subroutine
!--------------------------------------------------------
!   棒グラフの内部領域を塗る．
    subroutine DclShadeYBarArea(x,y1,y2,pattern1,pattern2,width)
      real,      intent(in), dimension(:) :: x, y1, y2
      integer,   intent(in), optional :: pattern1, pattern2
      real,      intent(in), optional :: width

      call sgoopn('DclShadeYBarArea', ' ')
      if(present(pattern1)) then ; itp1 = pattern1
                            else ; call uuqarp(itp1, idummy)
      end if

      if(present(pattern2)) then ; itp2 = pattern1
                            else ; call uuqarp(idummy, itp2)
      end if
 
      if(present(width))    then ; width0 = width
                            else ; call uuqbrs(width0)
      end if

      nx  = size(x)
      ny1 = size(y1)
      ny2 = size(y2)
      if(nx.ne.ny1 .or. nx.ne.ny2)  call msgdmp('M', 'DclShadeYBarArea', &
                                    & 'Length of x and y don''t match.')
      n = min(nx, ny1, ny2)
      
      call uvbraz(n,x,y1,y2,itp1,itp2,width0) 
      call sgocls('DclShadeYBarArea')
    end subroutine
!--------------------------------------------------------
!   棒グラフを線で結ぶ．
    subroutine DclDrawYBarLine(x,y,type,index,width)
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional :: type, index
      real,      intent(in), optional :: width

      call sgoopn('DclDrawYBarLine', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      if(present(width)) then ; width0 = width
                         else ; call uuqbrs(width0)
      end if

      nx = size(x)
      ny = size(y)
      if(nx.ne.ny)  call msgdmp('M', 'DclDrawYBarLine', &
                                    & 'Length of x and y don''t match.')
      n = min(nx, ny)
      
      call uvbrlz(n,x,y,itype0,index0,width0) 
      call sgocls('DclDrawYBarLine')
   end subroutine
!--------------------------------------------------------
!   箱グラフの枠を描く．
    subroutine DclDrawYBoxFrame(x,y1,y2,type,index)
      real,      intent(in), dimension(:) :: x, y1, y2
      integer,   intent(in), optional :: type, index

      call sgoopn('DclDrawYBoxFrame', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      nx  = size(x)
      ny1 = size(y1)
      ny2 = size(y2)
      if(nx-1.ne.ny1 .or. nx-1.ne.ny2)  call msgdmp('M', 'DclDrawYBoxFrame', &
                                    & 'Length of x and y don''t match.')
      n = min(nx-1, ny1, ny2)

      call uvbxfz(n,x,y1,y2,itype0,index0)    
      call sgocls('DclDrawYBoxFrame')
    end subroutine
!--------------------------------------------------------
!   箱グラフの内部領域を塗る．
    subroutine DclShadeYBoxArea(x,y1,y2,pattern1,pattern2)
      real,      intent(in), dimension(:) :: x, y1, y2
      integer,   intent(in), optional :: pattern1, pattern2

      call sgoopn('DclShadeYBoxArea', ' ')
      if(present(pattern1)) then ; itp1 = pattern1
                            else ; call uuqarp(itp1, idummy)
      end if

      if(present(pattern2)) then ; itp2 = pattern1
                            else ; call uuqarp(idummy, itp2)
      end if
  
      nx  = size(x)
      ny1 = size(y1)
      ny2 = size(y2)
      if(nx-1.ne.ny1 .or. nx-1.ne.ny2)  call msgdmp('M', 'DclShadeYBoxArea', &
                                    & 'Length of x and y don''t match.')
      n = min(nx-1, ny1, ny2)
      
      call uvbxaz(n,x,y1,y2,itp1,itp2)
      call sgocls('DclShadeYBoxArea')
    end subroutine
!--------------------------------------------------------
!   階段状のグラフを描く．
    subroutine DclDrawYBoxLine(x,y,type,index)
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional :: type, index

      call sgoopn('DclDrawYBoxLine', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      nx = size(x)
      ny = size(y)
      if(nx-1.ne.ny)  call msgdmp('M', 'DclDrawYBoxLine', &
                                    & 'Length of x and y don''t match.')
      n = min(nx-1, ny)

      call uvbxlz(n,x,y,itype0,index0)  
      call sgocls('DclDrawYBoxLine')
    end subroutine

end module

!-------------------------------------------------
!interface module of odelib
!-------------------------------------------------
module ode_interface
  interface
!----------------------------------------------------------------------
!アルゴリズムルーチン
    subroutine odrkg(n,fcn,t,dt,x,dx,xout,work)   !ルンゲ-クッタ-ギル
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(in) :: dt                 !積分ステップ幅.
      real,      intent(in), dimension(n) :: x    !被積分変数のt=t における値
      real,      intent(inout), dimension(n) :: dx !被積分変数のt=t における微分値
      real,      intent(inout), dimension(n) :: xout !被積分変数のt=t+dtにおける値
      real,      intent(out), dimension(n) :: work !作業変数
    end subroutine
      
    subroutine odrk4(n,fcn,t,dt,x,dx,xout,work)   !4次精度のルンゲ-クッタ
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(in) :: dt                 !積分ステップ幅
      real,      intent(in), dimension(n) :: x    !被積分変数のt=t における値
      real,      intent(inout), dimension(n) :: dx !被積分変数のt=t における微分値
      real,      intent(inout), dimension(n) :: xout !被積分変数のt=t+dtにおける値
      real,      intent(out), dimension(n,3) :: work !作業変数
    end subroutine
      
    subroutine odrk2(n,fcn,t,dt,x,dx,xout,work)   !2次精度のルンゲ-クッタ
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(in) :: dt                 !積分ステップ幅
      real,      intent(in), dimension(n) :: x    !被積分変数のt=t における値
      real,      intent(inout), dimension(n) :: dx !被積分変数のt=t における微分値
      real,      intent(inout), dimension(n) :: xout !被積分変数のt=t+dtにおける値
      real,      intent(out), dimension(n) :: work !作業変数
    end subroutine
      
    subroutine odrk1(n,fcn,t,dt,x,dx,xout,work)   !が1次精度のルンゲ-クッタである．
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(in) :: dt                 !積分ステップ幅
      real,      intent(in), dimension(n) :: x    !被積分変数のt=t における値
      real,      intent(inout), dimension(n) :: dx !被積分変数のt=t における微分値
      real,      intent(inout), dimension(n) :: xout !被積分変数のt=t+dtにおける値
      real,      intent(out), dimension(n) :: work !作業変数
    end subroutine
!--------------------------------------------------------------------
!ステッパルーチン
    subroutine odrkgr(n,fcn,t,dt,epsl,x,work)     !可変幅のきざみを求める
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(inout) :: dt              !積分ステップ幅
      real,      intent(in) :: epsl               !要求精度
      real,      intent(inout), dimension(n) :: x !被積分変数のt=t における値を入力し,t=t+ 2 における値 を出力する．
      real,      intent(out), dimension(n,5) :: work !作業変数
    end subroutine
      
    subroutine odrkgs(n,fcn,t,dt,epsl,x,work)     !固定幅のきざみを求める．
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(inout) :: dt              !積分ステップ幅
      real,      intent(in) :: epsl               !要求精度
      real,      intent(inout), dimension(n) :: x !被積分変数のt=t における値を入力し,t=t+ 2 における値 を出力する
      real,      intent(out), dimension(n,3) :: work !作業変数
    end subroutine
      
    subroutine odrk4r(n,fcn,t,dt,epsl,x,work)     !可変幅のきざみを求める．
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(inout) :: dt              !積分ステップ幅
      real,      intent(in) :: epsl               !要求精度
      real,      intent(inout), dimension(n) :: x !被積分変数のt=t における値を入力し,t=t+ 2 における値 を出力する
      real,      intent(out), dimension(n,7) :: work !作業変数
    end subroutine
      
    subroutine odrk4s(n,fcn,t,dt,epsl,x,work)     !固定幅のきざみを求める．  
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(in) :: t                  !独立変数tの値
      real,      intent(inout) :: dt              !積分ステップ幅
      real,      intent(in) :: epsl               !要求精度
      real,      intent(inout), dimension(n) :: x !被積分変数のt=t における値を入力し,t=t+ 2 における値 を出力する
      real,      intent(out), dimension(n,5) :: work !作業変数
    end subroutine
!-----------------------------------------------------------------
!ドライバルーチン 
    subroutine odrkdu(n,algor,fcn,t,tend,istep,x,work) !固定刻幅で積分を行う．   
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  algor                              !使用するアルゴリズムルーチン名
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(inout) :: t               !積分を始める独立変数tの値．
      real,      intent(in) :: tend               !積分を終了する独立変数tの値
      integer,   intent(in) :: istep              !ステップ数．
      real,      intent(inout), dimension(n) :: x !被積分変数のt=tにおける値を入力し， t=tendにおける値を出力する．
      real,      intent(out), dimension(n,*) :: work !作業変数
    end subroutine
      
    subroutine odrkdv(n,steper,fcn,t,tint,dt,x,work) !要求精度を満たすように積分を行う．
      integer,   intent(in) :: n                  !被積分変数（方程式）の数
      external  steper                             !使用するアルゴリズムルーチン名
      external  fcn                                !dxを計算するサブルーチン名
      real,      intent(inout) :: t               !積分を始める独立変数tの値
      real,      intent(in) :: tint               !積分を終了する独立変数tの値
      real,      intent(inout) :: dt              !ステップ幅の初期値
      real,      intent(inout), dimension(n) :: x !被積分変数のt=tにおける値を入力し， t=tendにおける値を出力する．
      real,      intent(out), dimension(n,*) :: work !作業変数
    end subroutine
!--------------------------------------------------------------------
!内部変数管理ルーチン
    subroutine odpget(cpara,ipara)                !odrkdv で使用する内部変数を参照する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine odiget(cpara,ipara)                !odrkdv で使用する内部変数を参照する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine odrget(cpara,ipara)                !odrkdv で使用する内部変数を参照する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      real,      intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine odlget(cpara,ipara)                !odrkdv で使用する内部変数を参照する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine odpset(cpara,ipara)                !odrkdv で使用する内部変数を設定する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine odiset(cpara,ipara)                !odrkdv で使用する内部変数を設定する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine odrset(cpara,ipara)                !odrkdv で使用する内部変数を設定する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine odlset(cpara,ipara)                !odrkdv で使用する内部変数を設定する．
      character(len=*), intent(in) :: cpara       !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine

  end interface
end module
!odelib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZSGCL(TX0, TY0, TX1, TY1)

      PARAMETER (EPSIL = 1.E-5)

      LOGICAL   LMER, LREQA

      EXTERNAL  RFPI, LREQA

      SAVE


      PI = RFPI()

      TXX = TX0
      TYY = TY0

      IF(LREQA(ABS(TY0), PI/2, EPSIL) .OR.
     +   LREQA(ABS(TY1), PI/2, EPSIL)) THEN
        LMER = .TRUE.
      ELSE
        TAN0 = TAN(TY0)
        TAN1 = TAN(TY1)

        IF (TAN0.EQ.0 .AND. TAN1.EQ.0) THEN
          XLA = 0
        ELSE
          XLA = ATAN2(TAN1*COS(TX0)-TAN0*COS(TX1),
     +                TAN0*SIN(TX1)-TAN1*SIN(TX0))
        END IF

        DX1 = SZXMOD(TX1-TX0)
        XLM = SZXMOD(TX0+DX1/2 - XLA)

        CS0 = COS(TX0-XLA)
        CS1 = COS(TX1-XLA)

        IF (ABS(CS0).GE.ABS(CS1)) THEN
          ALPHA = TAN0/CS0
          LMER = .FALSE.
        ELSE IF (ABS(CS1).NE.0) THEN
          ALPHA = TAN1/CS1
          LMER = .FALSE.
        ELSE
          LMER = .TRUE.
        END IF
      END IF

      IF(LMER) THEN
        TYY = SIGN(PI/2, (TY0+TY1))
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQGCY(TX, TY)

      IF (LMER) THEN
        TY = TYY
      ELSE
        TY = ATAN(ALPHA*COS(TX-XLA))
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZQGCX(TY, TX)

      IF (LMER) THEN
        TX = TXX
      ELSE
        IF(ALPHA.EQ.0) THEN
          TX = TXX
        ELSE
          TT = TAN(TY)/ALPHA
          IF (ABS(TT).GE.1) THEN
            TX = SIGN(PI, XLM) + XLA
          ELSE
            TX = SIGN(ACOS(TT), XLM) + XLA
          END IF
        END IF
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     CONTROL CHARACTER CONVERT TO OLD TYPE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZTXNO(CHARS,CHARZ,LCNTLZ)

      CHARACTER CHARS*(*)
      CHARACTER CHARZ*(*)

      PARAMETER (NCHARS=2048,LEN=6000)
      PARAMETER (WUNIT=24,ZUNIT=24)

      CHARACTER CHARX*(NCHARS)

      COMMON    /SZBTX1/ QSIZE,CT,ST,ICENTZ
      COMMON    /SZBTX2/ LCNTL,JSUP,JSUB,JRST,SMALL,SHIFT
      LOGICAL   LCNTL, LMARK
      INTEGER   ISUPZ,ISUBZ,IRSTZ
      INTEGER   ISUP,ISUB,IRST
      CHARACTER CSGI*1,CSUP*1,CSUB*1,CRST*1
      INTEGER   IMODE, IDEST, IOCMDE
      LOGICAL   LCNTLZ

      EXTERNAL  LENC,ISGC

      SAVE

      DATA      NCNTZ/0/

      LCNTLZ=LCNTL
      CALL SGIGET('ISUP',ISUP)
      CALL SGIGET('ISUB',ISUB)
      CALL SGIGET('IRST',IRST)
      ISUPZ=29
      ISUBZ=30
      IRSTZ=31
      CSUP=CSGI(ISUPZ)
      CSUB=CSGI(ISUBZ)
      CRST=CSGI(IRSTZ)

*     / Remove '\x' /
      DO 20 I=1,NCHARS
        CHARX(I:I)=' '
   20 CONTINUE
      NCS=LENC(CHARS)
      IDEST=1
      IMODE=0
      DO 10 I=1,NCS
        IF (CHARS(I:I+1).EQ.'\x')THEN
          IMODE=1
        ELSE IF(IMODE.EQ.1)THEN
          IMODE=0
        ELSE
          CHARX(IDEST:IDEST)=CHARS(I:I)
          IDEST=IDEST+1
        ENDIF
   10 CONTINUE

*     / CONVERT NEW TYPE MARKUPS TO OLD ONE /
      NCS=LENC(CHARX)
      NCHAR=LENC(CHARZ)
      DO 1 N=1,NCHAR
        CHARZ=' '
    1 CONTINUE
      NSKIP=0
      IDEST=1
      IMODE=0
      IOCMDE=0
      LMARK=.TRUE.
      DO 3 N=1,NCS
        IDX0=ISGC(CHARX(N:N))
        IF(IDX0.EQ.ISUPZ .OR. IDX0.EQ.ISUBZ .OR. IDX0.EQ.IRSTZ)THEN
          CHARX(N:N)=CSGI(32)
          IDX0=ISGC(CHARX(N:N))
        END IF
        IF(IMODE.EQ.1)THEN
          IF (IDX0.EQ.94)THEN
            LCNTLZ=.TRUE.
            CHARZ(IDEST:IDEST)=CSUP
            IDEST=IDEST+1
            IMODE=2
          ELSE IF (IDX0.EQ.95)THEN
            LCNTLZ=.TRUE.
            CHARZ(IDEST:IDEST)=CSUB
            IDEST=IDEST+1
            IMODE=2
          ELSE IF (IDX0.EQ.111)THEN
C           180: UP ARROW
            CHARZ(IDEST:IDEST)=CSGI(180)
            IDEST=IDEST+1
            CALL MSGDMP('W','SZTXWV',
     *        'TOPBAR IS NOT SUPPORT IN STROKEFONT')
            IMODE=2
            LMARK=.FALSE.
          ELSE IF (IDX0.EQ.117)THEN
C           182: DOWN ARROW
            CHARZ(IDEST:IDEST)=CSGI(182)
            IDEST=IDEST+1
            CALL MSGDMP('W','SZTXWV',
     *        'UNDERBAR IS NOT SUPPORT IN STROKEFONT')
            IMODE=2
            LMARK=.FALSE.
          ELSE IF(IDX0.EQ.92)THEN
            CHARZ(IDEST:IDEST)=CSGI(92)
            IDEST=IDEST+1
            IMODE=0
            LCNTLZ=.TRUE.
          ELSE IF(IDX0.EQ.120) THEN
            IMODE=0
          ELSE
            IMODE=0
            CHARZ(IDEST:IDEST)=CHARX(N:N)
            IDEST=IDEST+1
            IF(LMARK) THEN
              CHARZ(IDEST:IDEST)=CRST
              IDEST=IDEST+1
            ELSE
              LMARK=.TRUE.
            END IF
          END IF
        ELSE IF (IMODE.EQ.2) THEN
          IF(IDX0.EQ.123) THEN
            IMODE=3
          ELSE
            IMODE=0
            CHARZ(IDEST:IDEST)=CHARX(N:N)
            IDEST=IDEST+1
            CHARZ(IDEST:IDEST)=CRST
            IDEST=IDEST+1
          ENDIF
        ELSE IF(IMODE.EQ.3)THEN
          IF(ISGC(CHARX(N:N)).EQ.125)THEN
            IMODE=0
            IF(LMARK)THEN
              CHARZ(IDEST:IDEST)=CRST
              IDEST=IDEST+1
            ELSE
              LMARK=.TRUE.
            END IF
          ELSE
            CHARZ(IDEST:IDEST)=CHARX(N:N)
            IDEST=IDEST+1
          END IF
*       92:\ 94:^ 95:_ 111:o 117:u 123:{ 125:} 120:x
        ELSE IF (IDX0.EQ.92) THEN
            IMODE=1
*OLD TYPE CONTROL
        ELSE IF (IDX0.EQ.ISUP .AND. LCNTL) THEN
          CHARZ(IDEST:IDEST)=CSGI(ISUP)
          IOCMDE=IDEST
          IDEST=IDEST+1
        ELSE IF (IDX0.EQ.ISUB .AND. LCNTL) THEN
          CHARZ(IDEST:IDEST)=CSGI(ISUB)
          IOCMDE=-IDEST
          IDEST=IDEST+1
        ELSE IF (IDX0.EQ.IRST .AND. LCNTL) THEN
          IF(IOCMDE.GT.0)THEN
            CHARZ(IOCMDE:IOCMDE)=CSUP
            CHARZ(IDEST:IDEST)=CRST
            IDEST=IDEST+1
            IOCMOD=0
          ELSE IF(IOCMDE.LT.0)THEN
            CHARZ(-IOCMDE:-IOCMDE)=CSUB
            CHARZ(IDEST:IDEST)=CRST
            IDEST=IDEST+1
            IOCMOD=0
          ELSE
            CHARZ(IDEST:IDEST)=CSGI(IRST)
            IOCMDE=0
            IDEST=IDEST+1
          END IF
        ELSE
          CHARZ(IDEST:IDEST)=CHARX(N:N)
          IDEST=IDEST+1
        END IF
    3 CONTINUE

      IF (IDEST.LE.NCS)THEN
        NCS=IDEST-1
      END IF
*  / END CONVERT MARKUPS /
      LCNTLZ=.TRUE.
      END

*-----------------------------------------------------------------------
*     LCHR
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      LOGICAL FUNCTION LCHR(CHAR,CREF)

      CHARACTER CHAR*(*),CREF*(*)

      LOGICAL   LCHRF,LCHRA,LCHRS,LCHRL,LCHRD,LCHRB,LCHRC

      EXTERNAL  LCHRF,LCHRA,LCHRS,LCHRL,LCHRD,LCHRB,LCHRC


      NCH=LEN(CHAR)
      NCR=LEN(CREF)
      IF (NCH.NE.NCR) THEN
        CALL MSGDMP('E','LCHR  ',
     +      'LENGTH OF CHAR IS NOT EQUAL TO THAT OF CREF.')
      END IF

      LCHR=.TRUE.
      DO 10 I=1,NCH
        IF (CREF(I:I).EQ.'F') THEN
          LCHR=LCHR.AND.LCHRF(CHAR(I:I))
        ELSE IF (CREF(I:I).EQ.'A') THEN
          LCHR=LCHR.AND.LCHRA(CHAR(I:I))
        ELSE IF (CREF(I:I).EQ.'S') THEN
          LCHR=LCHR.AND.LCHRS(CHAR(I:I))
        ELSE IF (CREF(I:I).EQ.'L') THEN
          LCHR=LCHR.AND.LCHRL(CHAR(I:I))
        ELSE IF (CREF(I:I).EQ.'D') THEN
          LCHR=LCHR.AND.LCHRD(CHAR(I:I))
        ELSE IF (CREF(I:I).EQ.'B') THEN
          LCHR=LCHR.AND.LCHRB(CHAR(I:I))
        ELSE IF (CREF(I:I).EQ.'C') THEN
          LCHR=LCHR.AND.LCHRC(CHAR(I:I))
        ELSE
          CALL MSGDMP('E','LCHR  ','INVALID REFERENCE NAME.')
        END IF
        IF (.NOT.LCHR) RETURN
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     USRQNP / USRQID / USRQCP / USRQVL / USRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 30)
      PARAMETER (RUNDEF = -999.)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

* ---- SHORT NAME ----
*     / PARAMETERS FOR USDAXS /
      DATA      CPARAS( 1) / 'RMRGN   ' /, RX( 1) /  9.524 /
*     / PARAMETERS FOR USUSCU /
      DATA      CPARAS( 2) / 'XOFF    ' /, RX( 2) / RUNDEF /
      DATA      CPARAS( 3) / 'YOFF    ' /, RX( 3) / RUNDEF /
      DATA      CPARAS( 4) / 'XFAC    ' /, RX( 4) / RUNDEF /
      DATA      CPARAS( 5) / 'YFAC    ' /, RX( 5) / RUNDEF /
      DATA      CPARAS( 6) / 'DXT     ' /, RX( 6) / RUNDEF /
      DATA      CPARAS( 7) / 'DYT     ' /, RX( 7) / RUNDEF /
      DATA      CPARAS( 8) / 'DXL     ' /, RX( 8) / RUNDEF /
      DATA      CPARAS( 9) / 'DYL     ' /, RX( 9) / RUNDEF /
      DATA      CPARAS(10) / 'TFACT   ' /, RX(10) / 2. /
*     / FOLLOWING 20 PARAMETERS ARE RESET BY USINIZ /
      DATA      CPARAS(11) / 'SOFFXTR ' /, RX(11) /  0.018 /
      DATA      CPARAS(12) / 'SOFFXBR ' /, RX(12) /  0.018 /
      DATA      CPARAS(13) / 'SOFFXUR ' /, RX(13) /  0.018 /
      DATA      CPARAS(14) / 'SOFFXTL ' /, RX(14) / -0.018 /
      DATA      CPARAS(15) / 'SOFFXBL ' /, RX(15) / -0.018 /
      DATA      CPARAS(16) / 'SOFFXUL ' /, RX(16) / -0.018 /
      DATA      CPARAS(17) / 'SOFFYRT ' /, RX(17) /  0.018 /
      DATA      CPARAS(18) / 'SOFFYLT ' /, RX(18) /  0.018 /
      DATA      CPARAS(19) / 'SOFFYUT ' /, RX(19) /  0.018 /
      DATA      CPARAS(20) / 'SOFFYRB ' /, RX(20) / -0.018 /
      DATA      CPARAS(21) / 'SOFFYLB ' /, RX(21) / -0.018 /
      DATA      CPARAS(22) / 'SOFFYUB ' /, RX(22) / -0.018 /
      DATA      CPARAS(23) / 'ROFFXT  ' /, RX(23) /  0. /
      DATA      CPARAS(24) / 'ROFFXB  ' /, RX(24) /  0. /
      DATA      CPARAS(25) / 'ROFFYR  ' /, RX(25) /  0. /
      DATA      CPARAS(26) / 'ROFFYL  ' /, RX(26) /  0. /

      DATA      CPARAS(27) / 'XDTMIN  ' /, RX(27) /  RUNDEF /
      DATA      CPARAS(28) / 'XDTMAX  ' /, RX(28) /  RUNDEF /
      DATA      CPARAS(29) / 'YDTMIN  ' /, RX(29) /  RUNDEF /
      DATA      CPARAS(30) / 'YDTMAX  ' /, RX(30) /  RUNDEF /

* ---- LONG NAME ----
*     / PARAMETERS FOR USDAXS /
      DATA      CPARAL( 1) / 'MARGIN_WIDTH' /
*     / PARAMETERS FOR USUSCU /
      DATA      CPARAL( 2) / 'X_LABEL_OFFSET' /
      DATA      CPARAL( 3) / 'Y_LABEL_OFFSET' /
      DATA      CPARAL( 4) / 'X_LABEL_FACTOR' /
      DATA      CPARAL( 5) / 'Y_LABEL_FACTOR' /
      DATA      CPARAL( 6) / 'X_TICK_INTERVAL' /
      DATA      CPARAL( 7) / 'Y_TICK_INTERVAL' /
      DATA      CPARAL( 8) / 'X_LABEL_INTERVAL' /
      DATA      CPARAL( 9) / 'Y_LABEL_INTERVAL' /
      DATA      CPARAL(10) / 'MAX_TICK_INTERVAL' /
*     / FOLLOWING 20 PARAMETERS ARE RESET BY USINIZ /
      DATA      CPARAL(11) / '****SOFFXTR ' /
      DATA      CPARAL(12) / '****SOFFXBR ' /
      DATA      CPARAL(13) / '****SOFFXUR ' /
      DATA      CPARAL(14) / '****SOFFXTL ' /
      DATA      CPARAL(15) / '****SOFFXBL ' /
      DATA      CPARAL(16) / '****SOFFXUL ' /
      DATA      CPARAL(17) / '****SOFFYRT ' /
      DATA      CPARAL(18) / '****SOFFYLT ' /
      DATA      CPARAL(19) / '****SOFFYUT ' /
      DATA      CPARAL(20) / '****SOFFYRB ' /
      DATA      CPARAL(21) / '****SOFFYLB ' /
      DATA      CPARAL(22) / '****SOFFYUB ' /
      DATA      CPARAL(23) / '****ROFFXT  ' /
      DATA      CPARAL(24) / '****ROFFXB  ' /
      DATA      CPARAL(25) / '****ROFFYR  ' /
      DATA      CPARAL(26) / '****ROFFYL  ' /

      DATA      CPARAL(27) / '****XDTMIN  ' /
      DATA      CPARAL(28) / '****XDTMAX  ' /
      DATA      CPARAL(29) / '****YDTMIN  ' /
      DATA      CPARAL(30) / '****YDTMAX  ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY USRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','USRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY USRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','USRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','USRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('US', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','USRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('US', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','USRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DCLTRF

      PARAMETER (MAXNTR=99)

      LOGICAL   LTR
      CHARACTER CTR1*3,CTR2*20,CPARA*4,CFMT*4,CMSG*80

      EXTERNAL  LENC


      CALL OSQARN(NP)
      IF (NP.EQ.0) THEN
        N1=1
        N2=MAXNTR
      ELSE
        CALL OSGARG(1,CPARA)
        CFMT='(I#)'
        CALL CHNGI(CFMT,'#',LENC(CPARA),'(I1)')
        READ(CPARA,CFMT) N1
        N2=N1
      END IF

      CALL GLIGET('IOUNIT',IU)
      DO 10 N=N1,N2
        CALL SGTRQF(N,LTR)
        IF (LTR) THEN
          CALL SGTRNS(N,CTR1)
          CALL SGTRNL(N,CTR2)
          WRITE(IU,'(A,I2,5A)') ' NTR = ',N,' ; ',CTR1,' ; ',CTR2,' ;'
        ELSE
          IF (N1.EQ.N2) THEN
            CMSG='TRANSFORMATION NUMBER ## IS NOT DEFINED.'
            CALL CHNGI(CMSG,'##',N,'(I2)')
            CALL MSGDMP('M','DCLTRF',CMSG)
          END IF
        END IF
   10 CONTINUE

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGPMXV(N,VPX,VPY,ITYPE,INDEX,ICOLOR,RSIZE)

      REAL      VPX(*),VPY(*)
      LOGICAL   LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGPMXV','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMXV','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPMXV','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPMXV','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPMXV','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGPMXV','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGPMXV','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZPMOP(ITYPE,INDEX,RSIZE)
      CALL SZPMZV(N,VPX,VPY)
      CALL SZPMCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     UUPQNP / UUPQID / UUPQCP / UUPQVL / UUPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UUPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 3)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*12
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

* ---- SHORT NAME ----
      DATA      CPARAS(1) / 'UMIN    ' /, ITYPE(1) / 3 /
      DATA      CPARAS(2) / 'UMAX    ' /, ITYPE(2) / 3 /
      DATA      CPARAS(3) / 'UREF    ' /, ITYPE(3) / 3 /

* ---- LONG NAME ----
      DATA      CPARAL(1) / '****UMIN    ' /
      DATA      CPARAL(2) / '****UMAX    ' /
      DATA      CPARAL(3) / '****UREF    ' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UUPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UUPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UUPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','UUPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UUIQID(CPARAS(IDX), ID)
          CALL UUIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UULQID(CPARAS(IDX), ID)
          CALL UULQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UURQID(CPARAS(IDX), ID)
          CALL UURQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UUPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UUIQID(CPARAS(IDX), ID)
          CALL UUISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UULQID(CPARAS(IDX), ID)
          CALL UULSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UURQID(CPARAS(IDX), ID)
          CALL UURSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UUPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     TMSTLS : THE ROUTINE FOR DRAWING STREAM LINES (COORD. OF SPHERIC.)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD DENNOU CLUB. ALL RIGHTS RESERVED.
*-----------------------------------------------------------------------
      SUBROUTINE TMSTLS( L, T, U, V, NX, NY )

      IMPLICIT NONE

*-- AGREENMENT
      INTEGER  NX        !* GRID NUMBERS FOR X-DIRECTION
      INTEGER  NY        !* GRID NUMBERS FOR Y-DIRECTION
      REAL     U(NX,NY)  !* VECTOR COMPONENT OF X-DIRECTION
      REAL     V(NX,NY)  !* VECTOR COMPONENT OF Y-DIRECTION
      REAL     L(NX)     !* GRID POINTS OF ZONAL DIR. [UNIT:DEGREE]
      REAL     T(NY)     !* GRID POINTS OF MERIDIONAL DIR. [UNIT:DEGREE]

*-- INTERNAL VARIABLES
      REAL     TRX(NX*NY,2)     !* STREAM LINE OF X-COORDINATE
      REAL     TRY(NX*NY,2)     !* STREAM LINE OF Y-COORDINATE
      INTEGER  I, J, K          !* TMP VALUES
      INTEGER  COUNTER          !* NUMBER OF STREAM LINE
      INTEGER  TOTNM(NX*NY,2)   !* ARRAY NUMBER IN TOTAL STREAM LINES AT END
      INTEGER  TOTSNM(NX*NY,2)  !* ARRAY NUMBER IN TOTAL STREAM LINES AT START
      REAL     X(NX), Y(NY)
      REAL     TMPU(NX,NY), TMPV(NX,NY)
      REAL     ARROW_THRES
      REAL     DXA, DYA
      REAL     ARROW_LENG
      REAL     VXMIN, VXMAX, VYMIN, VYMAX
      REAL     UXMIN, UXMAX, UYMIN, UYMAX
      REAL     VXRATIO, VYRATIO
      REAL     RCOE
      REAL     CIRC_FLAG
      REAL     UNDEF
      REAL     RAD
      PARAMETER(RAD=6.387)
      INTEGER  N, M, IBLKGE, ARRCNT
      LOGICAL  NO_SHORT, END_ARR

*-- EXTERNAL FUNCTION
      REAL     RFPI
      EXTERNAL RFPI

      RCOE=RFPI()/180.0

*-- GETTING TMPACK'S PARAMETERS
      CALL TMRGET( 'ARRWINTV', ARROW_THRES )
      CALL TMLGET( 'NODRSHRT', NO_SHORT )
      CALL TMLGET( 'ENDARROW', END_ARR )

      CALL GLRGET( 'RMISS', UNDEF )
      CALL GLLSET( 'LMISS', .TRUE. )

*-- GETTING VIEWPORT PARAMETERS
      CALL SGQVPT( VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGQWND( UXMIN, UXMAX, UYMIN, UYMAX)
      VXRATIO=(VXMAX-VXMIN)/(UXMAX-UXMIN)
      VYRATIO=(VYMAX-VYMIN)/(UYMAX-UYMIN)

*-- CONVERTING DEGREE TO RADIAN
      DO 11 I=1,NX
         X(I)=L(I)*RCOE
 11   CONTINUE
      DO 12 J=1,NY
         Y(J)=T(J)*RCOE
 12   CONTINUE

*-- CONVERTING VECTORS TO THEMSELVES INCLUDING SCALE PARAMETER
      DO 20 J=1,NY
         DO 21 I=1,NX
            IF(U(I,J).NE.UNDEF.AND.V(I,J).NE.UNDEF
     &         .AND.COS(Y(J)).NE.0.0)THEN
               TMPU(I,J)=U(I,J)/COS(Y(J))
               TMPV(I,J)=V(I,J)
            ELSE
               TMPU(I,J)=UNDEF
               TMPV(I,J)=UNDEF
            END IF
 21      CONTINUE
 20   CONTINUE

*-- DOING TMSTLN ROUTINE
      CALL TMSTLN( X, Y, TMPU, TMPV, NX, NY, TRX, TRY, TOTNM )

*-- GETTING STREAM LINE NUMBERS
      CALL TMIGET( 'STLNNUM', COUNTER )

*-- SETTING START NUMBERS IN TOTAL STREAM LINES
      TOTSNM(1,1:2)=1
      DO 10 I=2,COUNTER
         TOTSNM(I,1)=TOTNM(I-1,1)+1
         TOTSNM(I,2)=TOTNM(I-1,2)+1
 10   CONTINUE

*-- CONVERTING TRY(RADIAN) TO TRY(DEGREE)
      DO 32 K=1,2
         DO 30 I=1,COUNTER
            DO 31 J=TOTSNM(I,K),TOTNM(I,K)
               IF(TRX(J,K).NE.UNDEF.AND.TRY(J,K).NE.UNDEF)THEN
                  TRX(J,K)=TRX(J,K)/RCOE
                  TRY(J,K)=TRY(J,K)/RCOE
               ELSE
                  TRX(J,K)=UNDEF
                  TRY(J,K)=UNDEF
               END IF
 31         CONTINUE
 30      CONTINUE
 32   CONTINUE

*-- SETTING PARAMETER FOR ARROW. (NOW, CONSTANT VALUES)
      CALL SGLSET('LPROP',.FALSE.)
      CALL SGRSET('CONST',0.01)

*-- DRAWING STREAM LINES
      DO 82 K=1,2
         DO 81 I=1,COUNTER

*-- CALCULATING THE INTERVAL LENGTH OF DRAWING ARROWS.
            ARROW_LENG=0.0
            ARRCNT=0
            IF(((TOTNM(I,K)-TOTSNM(I,K)+1).GT.1).AND.
     &         ((TOTNM(I,K)-TOTSNM(I,K)+1).LE.NX*NY))THEN
               DO 80 J=TOTSNM(I,K)+1,TOTNM(I,K)
                  IF(TRX(J,K).NE.UNDEF.AND.TRY(J,K).NE.UNDEF.AND.
     &               TRX(J-1,K).NE.UNDEF.AND.TRY(J-1,K).NE.UNDEF
     &               )THEN
                     DXA=(TRX(J,K)-TRX(J-1,K))*VXRATIO
                     DYA=(TRY(J,K)-TRY(J-1,K))*VYRATIO
                     ARROW_LENG=ARROW_LENG+SQRT(DXA*DXA+DYA*DYA)
                     IF(ARROW_LENG.GE.ARROW_THRES)THEN
                        CALL SGLAU( TRX(J-1,K), TRY(J-1,K),
     &                              TRX(J,K), TRY(J,K) )
                        ARROW_LENG=0.0
                        ARRCNT=ARRCNT+1
                     END IF
                  END IF
 80            CONTINUE

*-- IF NO_SHORT IS TRUE, NO DRAWING STREAM LINE WHOSE ARROW NUMBER IS ZERO
*-- 流線の始点と終点が近似点にいれば, 閉じた流線とみなして描く.
*-- 矢羽は終点に描く.
               IF(ARRCNT.EQ.0)THEN
                  IF(NO_SHORT.EQV..TRUE.)THEN
                     IF((TOTNM(I,K)-TOTSNM(I,K)+1).LE.2)THEN
                        GO TO 81
                     ELSE
                        N=IBLKGE( L, NX, TRX(TOTSNM(I,K),K) )
                        M=IBLKGE( L, NX, TRX(TOTNM(I,K),K) )
                        IF(ABS(N-M).GT.1)THEN
                           GO TO 81
                        ELSE
*-- 一周しているのか, 短いだけなのかのチェック
*--  始点, 終点, 終点１つ前の順に増減していれば一周.
                           CIRC_FLAG=
     &                        (TRX(TOTNM(I,K),K)-TRX(TOTNM(I,K)-1,K))
     &                        *(TRX(TOTSNM(I,K),K)-TRX(TOTNM(I,K),K))
                           IF(CIRC_FLAG.LT.0.0)THEN  ! 単に短いだけ
                              GO TO 81
                           ELSE
                              N=IBLKGE( Y, NY, TRY(TOTSNM(I,K),K) )
                              M=IBLKGE( Y, NY, TRY(TOTNM(I,K),K) )
                              IF(ABS(N-M).GT.1)THEN
                                 GO TO 81
                              ELSE
                                 CIRC_FLAG=
     &                         (TRY(TOTNM(I,K),K)-TRY(TOTNM(I,K)-1,K))
     &                         *(TRY(TOTSNM(I,K),K)-TRY(TOTNM(I,K),K))
                                 IF(CIRC_FLAG.LT.0.0)THEN
                                    GO TO 81
!                              ELSE
!                                 CALL SGLAU( TRX(TOTNM(I,K)-1,K), TRY(TOTNM(I,K)-1,K),
!     &                                       TRX(TOTNM(I,K),K), TRY(TOTNM(I,K),K) )
                                 END IF
                              END IF
                           END IF
                        END IF
                     END IF
                  ELSE
                     IF(END_ARR.EQV..TRUE.)THEN
                        CALL SGLAU( TRX(TOTNM(I,K)-1,K),
     &                              TRY(TOTNM(I,K)-1,K),
     &                              TRX(TOTNM(I,K),K),
     &                              TRY(TOTNM(I,K),K) )
                     END IF
                  END IF
               END IF

               CALL UULIN( (TOTNM(I,K)-TOTSNM(I,K)+1),
     &                     TRX(TOTSNM(I,K):TOTNM(I,K),K),
     &                     TRY(TOTSNM(I,K):TOTNM(I,K),K) )

            END IF

 81      CONTINUE

 82   CONTINUE

      CALL MSGDMP( 'M', 'TMSTLS', 'DRAWING FINISHED.' )

      END SUBROUTINE TMSTLS

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TIME01


      WRITE(*,*) '*** TEST FOR TIME CONVERSION'
      ITIME=100930
      WRITE(*,*) 'ITIME = ',ITIME
      CALL TIME12(ITIME,ITT)
      WRITE(*,*) 'AFTER CALLING TIME12(ITIME,ITT)'
      WRITE(*,*) 'ITT = ',ITT
      CALL TIME21(JTIME,ITT)
      WRITE(*,*) 'AFTER CALLING TIME21(JTIME,ITT)'
      WRITE(*,*) 'JTIME = ',JTIME
      CALL TIME13(JTIME,IH,IM,IS)
      WRITE(*,*) 'AFTER CALLING TIME13(JTIME,IH,IM,IS)'
      WRITE(*,*) 'IH = ',IH,' : IM = ',IM,' : IS = ',IS
      CALL TIME31(KTIME,IH,IM,IS)
      WRITE(*,*) 'AFTER CALLING TIME31(KTIME,IH,IM,IS)'
      WRITE(*,*) 'KTIME = ',KTIME

      END

*-----------------------------------------------------------------------
*     USPACK AUTO SCALING ROUTINE (UNIFORM)           DCL 5.0  95/09/04
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USUSCU(CAXIS, UMIN,  UMAX,  VMIN,  VMAX,  MODE)

      PARAMETER(NS1=4, NS2=4)
      REAL        SC1(NS1), SC2(NS2)
      CHARACTER   CAXIS*1,  CFMT*8
      CHARACTER*8 CDUT, CDUL, COFF, CFAC, CMXD, CCFMT
      LOGICAL     LEPSL

      DATA SC1 / 1., 2., 5., 10./
     &     SC2 / 1., 2., 4., 10./

*------------------------- ARGUMENT CHECK ------------------------------

      IF(CAXIS.NE.'X' .AND. CAXIS.NE.'Y')
     &   CALL MSGDMP('E', 'USUSCU', 'INVALID CAXIS')

      IF(VMIN.GE.VMAX)
     &   CALL MSGDMP('E', 'USUSCU', 'VMIN>VMAX')

*-------------------------- PARAMETERS ---------------------------------

      CALL GLRGET('RUNDEF' , RUNDEF)
      CALL UZRGET('RSIZEL1', CW)

      IF(MODE.EQ.0) THEN
        CALL USIGET('NBLANK1'  , NB)
      ELSE
        CALL USIGET('NBLANK2'  , NB)
      ENDIF

*------------------------------- DUT -----------------------------------
      CDUT = 'D'//CAXIS//'T'
      CALL USRGET(CDUT, DUT)

      IF(DUT.EQ.RUNDEF) THEN
        RMIN = MIN(UMIN, UMAX)
        RMAX = MAX(UMIN, UMAX)
        CALL USURDT(RMIN, RMAX, VMIN, VMAX, DUT)
        CALL USRSET(CDUT, DUT)
      ENDIF

*------------------------------- DUL -----------------------------------

      CALL GLLGET('LEPSL', LEPSL)
      CALL GLLSET('LEPSL', .TRUE.)
      CALL GNSAVE
      CALL GNSBLK(SC1, NS1)
      CALL GNLE(DUT, BX, IEXP)

      RMIN = MIN(UMIN, UMAX)
      RMAX = MAX(UMIN, UMAX)
      U2V  = (VMAX-VMIN) / (RMAX-RMIN)

      CDUL = 'D'//CAXIS//'L'
      COFF = CAXIS//'OFF'
      CFAC = CAXIS//'FAC'
      CMXD = 'MXDGT'//CAXIS

      CALL USRGET(CDUL, DUL)
      CALL USRGET(COFF, UOFF)
      CALL USRGET(CFAC, UFAC)
      CALL USIGET(CMXD, MAXDGT)

      IF(DUL.EQ.RUNDEF) THEN
        DUL0 = DUT*SC1(2)
        DO 100 NTRY=1, 2
          IF(MODE.EQ.0) THEN
            UOFF0 = UOFF
            UFAC0 = UFAC
            CALL USZDGT(RMIN,  RMAX,  DUL0, MAXDGT,
     &                  UOFF0, UFAC0, NDGT, LDGT)
          ELSE
            NDGT=1
          ENDIF

          FAC = CW*(NDGT+NB)/(U2V*DUT)

          IF(BX.EQ.5.) THEN
            CALL GNSBLK(SC2, NS2)
            FAC = RGNGE(FAC)
          ELSE
            CALL GNSBLK(SC1, NS1)
            FAC = RGNGE(FAC)
          ENDIF
          IF(FAC.LT.2.) FAC = 2.
          IFAC = INT(FAC+0.1)
          DUL  = DUT * IFAC
          DUL  = MAX(DUL, DUL0)
          IF(IFAC.LT.10) GOTO 200
          DUL0 = DUL/2.
  100   CONTINUE
  200   CONTINUE

        CALL USRSET(CDUL, DUL)
      ENDIF

*------------------------------ CFMT ----------------------------------

      CCFMT = 'C'//CAXIS//'FMT'
      CALL USCGET(CCFMT, CFMT)

      IF (CFMT.EQ.' ') THEN
        DVL = DUL*U2V
        IF(MODE.EQ.0) THEN
          MAXD = MIN(MAXDGT, INT(DVL/CW) - NB)
        ELSE
          MAXD = MAXDGT
        ENDIF

        CALL USZDGT(RMIN, RMAX, DUL,  MAXD,
     &              UOFF, UFAC, NDGT, LDGT)

        IF(LDGT.EQ.0) THEN
          WRITE(CFMT, 500) NDGT
        ELSE
          WRITE(CFMT, 510) NDGT, LDGT
        ENDIF
  500   FORMAT('(I', I1, ')')
  510   FORMAT('(F', I1, '.', I1, ')')

        CALL USRSET(COFF, UOFF)
        CALL USRSET(CFAC, UFAC)
        CALL USCSET(CCFMT, CFMT)
      ENDIF

      CALL GNRSET
      CALL GLLSET('LEPSL', LEPSL)

      RETURN
      END

program sample_1d05

  use dcl
  integer, parameter :: n=200, m=10
  real, dimension(n) :: x, y
  real, dimension(m) :: a

    a = (/( (-1)**j *2./((j*2-1)*DCL_PI), j=1, m) /)

    dt = 1./(n-1)
    x  = (/( dt*(i-1), i=1, n )/)

    do  i=1, n
      y(i) = 2*sum(a*cos((/(  2*DCL_PI*dt*(i-1)*(j*2-1), j=1, m )/)) )
    end do

!-----------------------------------------------------------------------

    call DclOpenGraphics
    call DclNewFrame

!         --- x axis ---
    call DclSetParm('AXIS:uyuser'  , 0.)
    call DclSetParm('SCALE:cxside'  , 'u')

!         --- y axis ---
    call DclSetParm('AXIS:irotlyl' , 1)
    call DclSetParm('AXIS:icentyl' , 0)
    call DclSetParm('SCALE:cyside'  , 'l')

!         --- etc. ---
    call DclSetParm('AXIS:inner' , -1)
    call DclSetParm('SCALE:cblkt' , '[]')

    call DclSetTitle('Time', 'Voltage', 'Sec', 'mV')
    call DclDrawScaledGraph(x, y)

    call DclCloseGraphics

end program

!-------------------------------------------------
!  TIMElib Module
!-------------------------------------------------
module timelib
  use dcl_common

  contains
    function DclGetTime()
      type(dcl_time) :: DclGetTime

      call prcopn('DclGetTime')
      call timeq3(DclGetTime%hour,DclGetTime%minute,DclGetTime%second)  
      call prccls('DclGetTime')
    end function
      
    subroutine DclFormatTime(cform,time)
      type(dcl_time), intent(in) :: time
      character(len=*), intent(inout) :: cform   !時刻のフォーマット

      call prcopn('DclFormatTime')
      call timec3(cform,time%hour,time%minute,time%second) 
      call prccls('DclFormatTime')
    end subroutine

end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHON8

      PARAMETER( XMIN=1., XMAX=100., YMIN=1., YMAX=100. )

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGLSET( 'LCLIP', .TRUE. )

      CALL SGFRM
*-- 直角一様座標(左上) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.1,  0.4,  0.6,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL BPLOT

*-- 片対数(y)座標(右上) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.6,  0.9,  0.6,  0.9 )
      CALL SGSTRN( 2 )
      CALL SGSTRF

      CALL BPLOT

*-- 片対数(x)座標(左下) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.1,  0.4,  0.1,  0.4 )
      CALL SGSTRN( 3 )
      CALL SGSTRF

      CALL BPLOT
      
*-- 対数座標(右下) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(  0.6,  0.9,  0.1,  0.4 )
      CALL SGSTRN( 4 )
      CALL SGSTRF

      CALL BPLOT

      CALL SGCLS

      END
*-----------------------------------------------------------------------
      SUBROUTINE BPLOT

      PARAMETER( NMAX=50 )
      REAL X(NMAX), Y(NMAX)

      CALL SLPVPR( 1 )

*-- 一次関数 ----
      DO 10 N=1,NMAX
        X(N) = 2.*N
        Y(N) = X(N)
   10 CONTINUE

      CALL SGSPLT( 1 )
      CALL SGPLU( NMAX, X, Y )

*-- 指数関数 ----
      DO 20 N=1,NMAX
        Y(N) = EXP(0.05*X(N))
   20 CONTINUE

      CALL SGSPLT( 2 )
      CALL SGPLU( NMAX, X, Y )

*-- 対数関数 ----
      DO 30 N=1,NMAX
        Y(N) = 20.*LOG(X(N))
   30 CONTINUE

      CALL SGSPLT( 3 )
      CALL SGPLU( NMAX, X, Y )

*-- 文字列 ----
      CALL SGSTXS( 0.02 )
      CALL SGTXU( 30., 40., '(30,40)' )

      RETURN
      END

module dcl
  use dcl_parm

!--- math1 ---
  use syslib
  use oslib
  use lrllib
  use blklib
  use gnmlib
  use intlib
  use indxlib
  use rfalib
  use rfblib
  use ctrlib
  use maplib

!--- math2 ---
  use fftlib
  use shtrlib
  use intrlib
  use rnmlib

!--- misc1 ---
  use chklib
  use chglib
  use datelib
  use timelib

!--- grph1 ---
  use sgpack
  use scpack
  use slpack

!--- grph2 ---
  use grpack
!  use uxpack
!  use uypack
  use uzpack
!  use ulpack
  use uupack
  use uhpack
  use uvpack
  use uspack
  use udpack
  use uepack
  use ugpack
  use uwpack
  use umpack
!  use ucpack

end module dcl

!-------------------------------------------------
!  INTRlib Module
!-------------------------------------------------
module intrlib
  use dcl_common
  interface DclInterpolate
    module procedure DclInterpolateR, DclInterpolateC
  end interface
  private :: DclInterpolateR, DclInterpolateC

  contains

    function DclInterpolateR(x)                !実数型配列の補間をする
      real, intent(in), dimension(:)        :: x !処理する実数型の配列
      real,             dimension(size(x)) :: DclInterpolateReal

      call prcopn('DclInterpolateR')
      DclInterpolateReal = x
      call vrintr(DclInterpolateR,size(x),1)
      call prccls('DclInterpolateR')
    end function
      
    function DclInterpolateC(x)            !複素数型配列の補間をする
      complex, intent(in), dimension(:)        :: x !処理する複素数型の配列
      complex,             dimension(size(x)) :: DclInterpolateComplex

      call prcopn('DclInterpolateC')
      DclInterpolateComplex = x
      call vcintr(DclInterpolateC,size(x),1)
      call prccls('DclInterpolateC')
    end function

end module

*-----------------------------------------------------------------------
      PROGRAM SGTONE

      PARAMETER (NP=5,NT=6)
      PARAMETER (DD=0.13,DS=0.005)
      PARAMETER (DX=DD+DS*2,DY=1.0/NT)

      REAL      XBOX(NP),YBOX(NP)
      CHARACTER CHR*5,CTTL*32

      DATA      XBOX/ 0.0, 1.0, 1.0, 0.0, 0.0/
      DATA      YBOX/ 0.0, 0.0, 1.0, 1.0, 0.0/


      WRITE(*,*) ' WORKSTATION ID (I) ? ; '
      CALL SGPWSN
      READ(*,*) IW
*     WRITE(*,*) ' SOFT FILL=1/HARD FILL=2 (I) ? ;'
*     READ(*,*) IFN
      IFN=1
      WRITE(*,*) ' TONE PATTERN (0-6) (I) ? ;'
      READ(*,*) N

      CALL GLISET('MAXMSG',300)

      CALL SGOPN(IW)

      IF (IFN.EQ.1) THEN
        CALL SGLSET('LSOFTF',.TRUE.)
      ELSE
        CALL SGLSET('LSOFTF',.FALSE.)
      END IF
      CALL SGLSET('LFULL',.TRUE.)
      CALL SGISET('INDEX',3)
      CALL SLRAT(0.85,1.0)
      CALL SLMGN(0.0,0.0,0.05,0.1)
      CTTL='TONE PATTERN = #XX'
      WRITE(CTTL(16:16),'(I1)') N
      CALL SLSTTL(CTTL,'T',0.0,-0.5,0.03,1)

      CALL SGFRM
      CALL SGSWND(0.0,1.0,0.0,1.0)
      CALL SGSTRN(1)
      DO 20 J=0,5
        DO 10 I=0,5
          X1=DX*I+DS+(1-DX*NT)/2
          X2=X1+DD
          Y1=DY*(5-J)+DS
          Y2=Y1+DD
          LEVEL=I+J*10+N*100
          CALL SGSVPT(X1,X2,Y1,Y2)
          CALL SGSTRF
          WRITE(CHR,'(I5)') LEVEL
          CALL SGTNZU(NP,XBOX,YBOX,LEVEL)
          CALL SGPLZU(NP,XBOX,YBOX,1,1)
          CALL SGTXZV(X2,Y2+(DY-DD)/2,CHR,0.015,0,1,3)
   10   CONTINUE
   20 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZLAZU(UX1,UY1,UX2,UY2)

      LOGICAL   LMAP

      COMMON    /SZBLA1/ LARRWZ,LPROPZ,AFACTZ,CONSTZ,ANGLEZ,
     +                   LATONZ,LUARWZ,CONSMZ,RDUNIT
      LOGICAL   LARRWZ,LPROPZ,LATONZ,LUARWZ

      EXTERNAL  RFPI

      SAVE


      IF (UX1.EQ.UX2 .AND. UY1.EQ.UY2) RETURN

      CALL SZOPLU
      CALL SZMVLU(UX1,UY1)
      CALL SZPLLU(UX2,UY2)
      CALL SZCLLU

      IF (.NOT.LARRWZ) RETURN

      PI=RFPI()

      CALL STQTRF(LMAP)

      CALL SZPIPZ(UX1,UY1,UX2,UY2,NN)
      IF (LMAP) THEN
        CALL STFRAD(UX1,PI/RDUNIT/2-UY1,PH1,TH1)
        CALL STFRAD(UX2,PI/RDUNIT/2-UY2,PH2,TH2)
        CALL CR3S(TH2,PH2,0.0,TH1,PH1,THX,PHX)
        RV=ABS(THX)
        CALL SZGIPZ(RX1,RY1,RX2,RY2,NN)
        CALL STFTRF(RX1,RY1,VX1,VY1)
        CALL STFTRF(RX2,RY2,VX2,VY2)
      ELSE
        RV=0
        DO 10 N=1,NN
          CALL SZGIPZ(RX1,RY1,RX2,RY2,N)
          CALL STFTRF(RX1,RY1,VX1,VY1)
          CALL STFTRF(RX2,RY2,VX2,VY2)
          RV=RV+SQRT((VX2-VX1)**2+(VY2-VY1)**2)
   10   CONTINUE
      END IF

      IF (LPROPZ.AND.LUARWZ) THEN
        AR=RV*AFACTZ
      ELSE
        IF (LMAP.AND.LUARWZ) THEN
          AR=CONSMZ*RDUNIT
        ELSE
          AR=CONSTZ
        END IF
      END IF

      IF (LMAP.AND.LUARWZ) THEN

        CALL STFRAD(RX1,PI/RDUNIT/2-RY1,PH1,TH1)
        CALL STFRAD(RX2,PI/RDUNIT/2-RY2,PH2,TH2)
        CALL CR3S(TH2,PH2,0.0,TH1,PH1,THX,PHX)

        CALL CR3S(-TH2,0.0,-PH2,AR,PHX+ANGLEZ*RDUNIT,THF1,PHF1)
        CALL CR3S(-TH2,0.0,-PH2,AR,PHX-ANGLEZ*RDUNIT,THF2,PHF2)

        CALL STIRAD(PHF1,THF1,UXA,UYA)
        CALL STIRAD(PHF2,THF2,UXB,UYB)
        UYA=PI/RDUNIT/2-UYA
        UYB=PI/RDUNIT/2-UYB

        IF (LATONZ) THEN
          CALL SZOPTU
          CALL SZSTTU(UXA,UYA)
          CALL SZSTTU(UX2,UY2)
          CALL SZSTTU(UXB,UYB)
          CALL SZCLTU
        ELSE
          CALL SZOPLU
          CALL SZMVLU(UXA,UYA)
          CALL SZPLLU(UX2,UY2)
          CALL SZPLLU(UXB,UYB)
          CALL SZCLLU
        END IF

      ELSE

        RVX=SQRT((VX2-VX1)**2+(VY2-VY1)**2)
        XE=(VX2-VX1)/RVX*AR
        YE=(VY2-VY1)/RVX*AR
        CALL CR2C(-(PI-ANGLEZ*RDUNIT),XE,YE,XT1,YT1)
        CALL CR2C(-(PI+ANGLEZ*RDUNIT),XE,YE,XT2,YT2)
        VXA=VX2+XT1
        VYA=VY2+YT1
        VXB=VX2+XT2
        VYB=VY2+YT2

        IF (LATONZ) THEN
          CALL SZOPTV
          CALL SZSTTV(VXA,VYA)
          CALL SZSTTV(VX2,VY2)
          CALL SZSTTV(VXB,VYB)
          CALL SZCLTV
        ELSE
          CALL SZOPLV
          CALL SZMVLV(VXA,VYA)
          CALL SZPLLV(VX2,VY2)
          CALL SZPLLV(VXB,VYB)
          CALL SZCLLV
        END IF

      END IF

      END

*-----------------------------------------------------------------------
*     REAL PARAMETER CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 2)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'RIMGCMP ' / , RX( 1) / -1.0 /
      DATA      CPARAS( 2) / 'RLWFACT ' / , RX( 2) / 1.0 /

*    / LONG NAME /

      DATA      CPARAL( 1) / 'IMAGE_COMPRESSION'/
      DATA      CPARAL( 2) / 'LINE_WIDTH_FACTOR'/

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWRQID(CP, IDX)

      DO 10 N = 1, NPARA
         IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
            IDX = N
            RETURN
         END IF
 10   CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','SWRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
         CP = CPARAS(IDX)
      ELSE
         CALL MSGDMP('E','SWRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
         CP = CPARAL(IDX)
      ELSE
         CALL MSGDMP('E','SWRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWRQVL(IDX, RPARA)

      IF (LFIRST) THEN
         CALL RTRGET('SW', CPARAS, RX, NPARA)
         CALL RLRGET(CPARAL, RX, NPARA)
         LFIRST = .FALSE.
      END IF

      if (1.LE.IDX .AND. IDX.LE.NPARA) THEN
         RPARA = RX(IDX)
      ELSE
         CALL MSGDMP('E','SWRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWRSVL(IDX, RPARA)

      IF (LFIRST) THEN
         CALL RTRGET('SW', CPARAS, RX, NPARA)
         CALL RLRGET(CPARAL, RX, NPARA)
         LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
         RX(IDX) = RPARA
      ELSE
         CALL MSGDMP('E','SWRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWRQIN(CP, IN)

      DO 20 N = 1, NPARA
         IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
            IN = N
            RETURN
         END IF
 20   CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     PARAMETER CONTROL (GENERIC)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE GLPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 20)

      INTEGER   ITYPE(NPARA)
      LOGICAL   LCHREQ
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA CPARAS( 1) / 'LMISS   ' /, ITYPE( 1) / 2 /
      DATA CPARAS( 2) / 'IMISS   ' /, ITYPE( 2) / 1 /
      DATA CPARAS( 3) / 'RMISS   ' /, ITYPE( 3) / 3 /
      DATA CPARAS( 4) / 'IUNDEF  ' /, ITYPE( 4) / 1 /
      DATA CPARAS( 5) / 'RUNDEF  ' /, ITYPE( 5) / 3 /
      DATA CPARAS( 6) / 'LEPSL   ' /, ITYPE( 6) / 2 /
      DATA CPARAS( 7) / 'REPSL   ' /, ITYPE( 7) / 3 /
      DATA CPARAS( 8) / 'RFACT   ' /, ITYPE( 8) / 3 /

      DATA CPARAS( 9) / 'INTMAX  ' /, ITYPE( 9) / 1 /
      DATA CPARAS(10) / 'REALMAX ' /, ITYPE(10) / 3 /
      DATA CPARAS(11) / 'REALMIN ' /, ITYPE(11) / 3 /
      DATA CPARAS(12) / 'NBITSPW ' /, ITYPE(12) / 1 /
      DATA CPARAS(13) / 'NCHRSPW ' /, ITYPE(13) / 1 /

      DATA CPARAS(14) / 'IIUNIT  ' /, ITYPE(14) / 1 /
      DATA CPARAS(15) / 'IOUNIT  ' /, ITYPE(15) / 1 /
      DATA CPARAS(16) / 'MSGUNIT ' /, ITYPE(16) / 1 /
      DATA CPARAS(17) / 'MAXMSG  ' /, ITYPE(17) / 1 /
      DATA CPARAS(18) / 'MSGLEV  ' /, ITYPE(18) / 1 /
      DATA CPARAS(19) / 'NLNSIZE ' /, ITYPE(19) / 1 /
      DATA CPARAS(20) / 'LLMSG   ' /, ITYPE(20) / 2 /

*     / LONG NAME /

      DATA CPARAL( 1) / 'INTERPRET_MISSING_VALUE' /
      DATA CPARAL( 2) / 'MISSING_INT         ' /
      DATA CPARAL( 3) / 'MISSING_REAL        ' /
      DATA CPARAL( 4) / 'UNDEFINED_INT       ' /
      DATA CPARAL( 5) / 'UNDEFINED_REAL      ' /
      DATA CPARAL( 6) / 'INTERPRET_TRUNCATION' /
      DATA CPARAL( 7) / 'TRUNCATION_ERROR    ' /
      DATA CPARAL( 8) / 'TRUNCATION_FACTOR   ' /

      DATA CPARAL( 9) / 'MAX_INT             ' /
      DATA CPARAL(10) / 'MAX_REAL            ' /
      DATA CPARAL(11) / 'MIN_REAL            ' /
      DATA CPARAL(12) / 'WORD_LENGTH_IN_BIT  ' /
      DATA CPARAL(13) / 'WORD_LENGTH_IN_CHAR ' /

      DATA CPARAL(14) / 'INPUT_UNIT          ' /
      DATA CPARAL(15) / 'OUTPUT_UNIT         ' /
      DATA CPARAL(16) / 'MESSAGE_UNIT        ' /
      DATA CPARAL(17) / 'MAX_MESSAGE_NUMBER  ' /
      DATA CPARAL(18) / 'MESSAGE_LEVEL       ' /
      DATA CPARAL(19) / 'LINE_SIZE           ' /
      DATA CPARAL(20) / 'ENABLE_LONG_MESSAGE ' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP,CPARAS(N)) .OR. LCHREQ(CP,CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E', 'GLPQID', CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E', 'GLPQCP', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E', 'GLPQCL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','GLPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL GLIQID(CPARAS(IDX), ID)
          CALL GLIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL GLLQID(CPARAS(IDX), ID)
          CALL GLLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL GLRQID(CPARAS(IDX), ID)
          CALL GLRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','GLPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL GLIQID(CPARAS(IDX), ID)
          CALL GLISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL GLLQID(CPARAS(IDX), ID)
          CALL GLLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL GLRQID(CPARAS(IDX), ID)
          CALL GLRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','GLPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program map02

  use dcl
  integer,parameter :: np=14
  integer,dimension(np) :: ntr = (/ &
    10,   11,   12,   13,   14,   15,   20, &
    21,   22,   23,   30,   31,   32,   33 /)

  character(len=32) :: cttl

    call DclOpenGraphics( -abs(DclSelectDevice()) )

    call DclSetAspectRatio( 2.0, 3.0 )
    call DclDivideFrame( 'y', 2, 3 )

    call DclSetParm( 'MAP_MAJOR_LINE_INDEX', 1 )
    call DclSetParm( 'MAP_MINOR_LINE_TYPE', 1 )

    do i=1,np
      call DclNewFrame
!       call DclSetMapProjectionAngle( 0.0, 90.0, 0.0 )
      call DclSetViewPort( 0.1, 0.9, 0.1, 0.9 )
      call DclSetTransNumber( ntr(i) )
      call DclFitMapParm
      call DclSetTransFunction

      call DclSetParm( 'ENABLE_CLIPPING', .true. )
      call DclDrawDeviceWindowFrame( 1 )
      call DclDrawViewPortFrame( 1 )
      call DclTransNumToLong( ntr(i), cttl )
      call DclDrawTextProjected( 0.5, 0.95, cttl, height=0.03, index=3 )

      call DclDrawMap( 'coast_world' )
      call DclDrawGlobe

      if ( ntr(i).eq.23 ) then
        call DclNewFrame
        call DclNewFrame
      end if

    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
C     SUBROUTINE SINT(N,X,WSAVE)
C
C     SUBROUTINE SINT COMPUTES THE DISCRETE FOURIER SINE TRANSFORM
C     OF AN ODD SEQUENCE X(I). THE TRANSFORM IS DEFINED BELOW AT
C     OUTPUT PARAMETER X.
C
C     SINT IS THE UNNORMALIZED INVERSE OF ITSELF SINCE A CALL OF SINT
C     FOLLOWED BY ANOTHER CALL OF SINT WILL MULTIPLY THE INPUT SEQUENCE
C     X BY 2*(N+1).
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE SINT MUST BE
C     INITIALIZED BY CALLING SUBROUTINE SINTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N+1 IS THE PRODUCT OF SMALL PRIMES.
C
C     X       AN ARRAY WHICH CONTAINS THE SEQUENCE TO BE TRANSFORMED
C
C
C     WSAVE   A WORK ARRAY WITH DIMENSION AT LEAST INT(2.5*N+15)
C             IN THE PROGRAM THAT CALLS SINT. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE SINTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C
C     OUTPUT PARAMETERS
C
C     X       FOR I=1,...,N
C
C                  X(I)= THE SUM FROM K=1 TO K=N
C
C                       2*X(K)*SIN(K*I*PI/(N+1))
C
C                  A CALL OF SINT FOLLOWED BY ANOTHER CALL OF
C                  SINT WILL MULTIPLY THE SEQUENCE X BY 2*(N+1).
C                  HENCE SINT IS THE UNNORMALIZED INVERSE
C                  OF ITSELF.
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SINT.
C
      SUBROUTINE SINT (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
C
      NP1 = N+1
      IW1 = N/2+1
      IW2 = IW1+NP1
      IW3 = IW2+NP1
      CALL SINT1(N,X,WSAVE,WSAVE(IW1),WSAVE(IW2),WSAVE(IW3))
      RETURN
      END

*-----------------------------------------------------------------------
*     UUPGET / UUPSET / UUPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UUPGET(CP,IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL UUPQID(CP, IDX)
      CALL UUPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPSET(CP, IPARA)

      CALL UUPQID(CP, IDX)
      CALL UUPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UUPSTX(CP, IPARA)

      IP = IPARA
      CALL UUPQID(CP, IDX)
      CALL UUPQIT(IDX, IT)
      CALL UUPQCP(IDX, CX)
      CALL UUPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UU', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL UUIQID(CP, IDX)
        CALL UUISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UU', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL UULQID(CP, IDX)
        CALL UULSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UU', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL UURQID(CP, IDX)
        CALL UURSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TEST06

      PARAMETER (NP=14)

      CHARACTER CTTL*32, CTR(NP)*3

      EXTERNAL  ISGTRC

      DATA CTR /'CYL','MER','MWD','HMR','EK6','KTD',
     +          'CON','COA','COC','BON',
     +          'OTG','PST','AZM','AZA'/


      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)

      CALL UMLSET('LGLOBE', .TRUE.)

      DO 10 I=1,NP

        CALL GRFRM

        CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
        CALL GRSTRN( ISGTRC(CTR(I)) )
        CALL UMPFIT
        CALL GRSTRF

        CALL SGLSET( 'LCLIP', .TRUE. )
        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( ISGTRC(CTR(I)), CTTL )
        CALL SGTXZR( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB

   10 CONTINUE

      CALL GRCLS

      END

*-----------------------------------------------------------------------
      SUBROUTINE UIPDA2(U, V, MX, NX, NY)

      PARAMETER (MAXPXL=4000)
      REAL      U(MX, *), V(MX, *)
      INTEGER   IMAGE(MAXPXL)

      CALL UIPD2Z(U, V, MX, NX, NY, IMAGE, MAXPXL)

      END
*-----------------------------------------------------------------------
      SUBROUTINE UIPD2Z(U, V, MX, NX, NY, IMAGE, MAXPXL)

      REAL      U(MX, *), V(MX, *)
      INTEGER   IMAGE(MAXPXL)
      INTEGER   NS(2), NP(2), NQ(2)
      LOGICAL   LMISS,LIMC,LFCC,LCX,LCY,LCNR
      DATA      NP /1,1/


*     / CHECK IMAGE CAPABILITY /

      CALL SWQIMC(LIMC)
      IF (.NOT.LIMC) THEN
        CALL MSGDMP('E','UIPGR2','NO IMAGE CAPABILITY.')
      END IF

      CALL SWQFCC(LFCC)
      IF (.NOT.LFCC) THEN
        CALL MSGDMP('E','UIPGR2','NO FULL COLOR CAPABILITY.')
      END IF

*     / GET INTERNAL PARAMETERS /

      CALL GLRGET('RUNDEF  ', RUNDEF)
      CALL GLIGET('IUNDEF  ', IUNDEF)
      CALL GLLGET('LMISS   ', LMISS )
      CALL GLRGET('RMISS   ', RMISS )

      CALL UIIGET('ICOLOR1 ', ICOLOR1)
      CALL UIIGET('ICOLOR2 ', ICOLOR2)
      CALL UIIGET('ICOLOR3 ', ICOLOR3)
      CALL UILGET('LCELLX  ', LCX)
      CALL UILGET('LCELLY  ', LCY)
      CALL UILGET('LCORNER ', LCNR)

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      NGX = NX
      NGY = NY
      IF(LCX) NGX = NGX + 1
      IF(LCY) NGY = NGY + 1
      CALL UWDFLT(NGX, NGY)

*     / INITIALIZE /

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      CALL STFPR2(VXMIN, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX1, WY1)
      CALL SWFINT(WX1, WY1, IX1, IY1)

      CALL STFPR2(VXMAX, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX2, WY2)
      CALL SWFINT(WX2, WY2, IX2, IY2)

      CALL STFPR2(VXMAX, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX3, WY3)
      CALL SWFINT(WX3, WY3, IX3, IY3)

      CALL STFPR2(VXMIN, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX4, WY4)
      CALL SWFINT(WX4, WY4, IX4, IY4)

      IXMIN  = MIN(IX1, IX2, IX3, IX4)
      IYMIN  = MIN(IY1, IY2, IY3, IY4)
      IXMAX  = MAX(IX1, IX2, IX3, IX4)
      IYMAX  = MAX(IY1, IY2, IY3, IY4)
      IWIDTH = IXMAX-IXMIN+1
      IHIGHT = IYMAX-IYMIN+1

      CALL SWIOPN(IXMIN, IYMIN, IWIDTH, IHIGHT, 
     +            WX1, WY1, WX2, WY2, WX3, WY3, WX4, WY4)

      NS(1) = MX
      NS(2) = NY
      NQ(1) = NX
      NQ(2) = NY

      UMIN = RVMIN(U, NS, NP, NQ, 2)
      UMAX = RVMAX(U, NS, NP, NQ, 2)
      VMIN = RVMIN(V, NS, NP, NQ, 2)
      VMAX = RVMAX(V, NS, NP, NQ, 2)

      CALL UI2INI(UMIN, UMAX, VMIN, VMAX)

*     / LOOP FOR EACH PIXEL /

      DO 30 J=1, IHIGHT
        DO 20 I=1, IWIDTH

          CALL SWIINT(I+IXMIN-1, J+IYMIN-1, WX, WY)
          CALL STIWTR(WX, WY, RX, RY)
          CALL STIPR2(RX, RY, VX, VY)
          CALL STITRF(VX, VY, UX, UY)

          IF (UX.EQ.RUNDEF) THEN
            IMAGE(I) = ICOLOR1
          ELSE
            CALL UWQGXI(UX,IX,FX)
            CALL UWQGYI(UY,IY,FY)

            IF (IX.EQ.IUNDEF .OR. IY.EQ.IUNDEF) THEN
              IMAGE(I) = ICOLOR2
            ELSE
              IF(LCX .AND. LCY) THEN
                IF (LMISS .AND. 
     +             (U(IX,IY).EQ.RMISS.OR.V(IX,IY).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  CALL UIC2D(U(IX,IY), V(IX,IY),IMAGE(I))
                END IF

              ELSE IF(LCX .AND. .NOT.LCY) THEN
                IF (LMISS .AND. 
     +             (U(IX,IY).EQ.RMISS .OR. U(IX,IY+1).EQ.RMISS .OR.
     +              V(IX,IY).EQ.RMISS .OR. V(IX,IY+1).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  UU = U(IX, IY  )*(1-FY) + U(IX  ,IY+1)*FY
                  VV = V(IX, IY  )*(1-FY) + V(IX  ,IY+1)*FY
                  CALL UIC2D(UU, VV,IMAGE(I))
                END IF

              ELSE IF(.NOT.LCX .AND. LCY) THEN
                IF (LMISS .AND. 
     +             (U(IX,IY).EQ.RMISS .OR. U(IX+1,IY).EQ.RMISS .OR.
     +              V(IX,IY).EQ.RMISS .OR. V(IX+1,IY).EQ.RMISS)) THEN
                  IMAGE(I) = ICOLOR3
                ELSE
                  UU = U(IX, IY  )*(1-FX) + U(IX+1,IY  )*FX
                  VV = V(IX, IY  )*(1-FX) + V(IX+1,IY  )*FX
                  CALL UIC2D(UU, VV,IMAGE(I))
                END IF

              ELSE IF(.NOT.LCX .AND. .NOT.LCY) THEN
                IF (.NOT. LMISS .OR. 
     +           (U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND. U(IX+1,IY+1).NE.RMISS .AND.
     +            V(IX,IY  ).NE.RMISS .AND. V(IX+1,IY  ).NE.RMISS .AND.
     +            V(IX,IY+1).NE.RMISS .AND. V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = (U(IX, IY  )*(1-FX) + U(IX+1,IY  )*FX)*(1-FY)
     +               + (U(IX, IY+1)*(1-FX) + U(IX+1,IY+1)*FX)*FY
                  
                  VV = (V(IX, IY  )*(1-FX) + V(IX+1,IY  )*FX)*(1-FY)
     +               + (V(IX, IY+1)*(1-FX) + V(IX+1,IY+1)*FX)*FY
                  
                  CALL UIC2D(UU, VV,IMAGE(I))

                ELSE IF(LCNR .AND. (FX+FY).LE.1 .AND.
     +           (U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND.
     +            U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS                            )) THEN

                  UU = U(IX,  IY  )*(1-FX-FY) 
     +               + U(IX+1,IY )*FX + U(IX, IY+1)*FY

                  VV = V(IX,  IY  )*(1-FX-FY) 
     +               + V(IX+1,IY )*FX + V(IX, IY+1)*FY

                  CALL UIC2D(UU, VV,IMAGE(I))

                ELSE IF(LCNR .AND. (1-FX+FY).LE.1 .AND.
     +           (U(IX,IY  ).NE.RMISS .AND. U(IX+1,IY  ).NE.RMISS .AND.
     +                                      U(IX+1,IY+1).NE.RMISS .AND.
     +            V(IX,IY  ).NE.RMISS .AND. V(IX+1,IY  ).NE.RMISS .AND.
     +                                      V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = U(IX+1,IY  )*(FX-FY) 
     +               + U(IX  ,IY )*(1-FX) + U(IX+1, IY+1)*FY

                  VV = V(IX+1,IY  )*(FX-FY) 
     +               + V(IX  ,IY )*(1-FX) + V(IX+1, IY+1)*FY

                  CALL UIC2D(UU, VV,IMAGE(I))

                ELSE IF(LCNR .AND. (1+FX-FY).LE.1 .AND.
     +           (U(IX,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND. U(IX+1,IY+1).NE.RMISS .AND.
     +            V(IX,IY  ).NE.RMISS .AND.
     +            V(IX,IY+1).NE.RMISS .AND. V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = U(IX  ,IY+1)*(FY-FX) 
     +               + U(IX+1,IY+1)*FX + U(IX, IY)*(1-FY)

                  VV = V(IX  ,IY+1)*(FY-FX) 
     +               + V(IX+1,IY+1)*FX + V(IX, IY)*(1-FY)

                  CALL UIC2D(UU, VV,IMAGE(I))

                ELSE IF(LCNR .AND. (2-FX-FY).LE.1 .AND.
     +           (                          U(IX+1,IY  ).NE.RMISS .AND.
     +            U(IX,IY+1).NE.RMISS .AND. U(IX+1,IY+1).NE.RMISS .AND.
     +                                      V(IX+1,IY  ).NE.RMISS .AND.
     +            V(IX,IY+1).NE.RMISS .AND. V(IX+1,IY+1).NE.RMISS)) THEN

                  UU = U(IX+1,IY+1)*(FX+FY-1) 
     +               + U(IX  ,IY+1)*(1-FX) + U(IX+1, IY)*(1-FY)

                  VV = V(IX+1,IY+1)*(FX+FY-1) 
     +               + V(IX  ,IY+1)*(1-FX) + V(IX+1, IY)*(1-FY)

                  CALL UIC2D(UU, VV,IMAGE(I))

                ELSE
                  IMAGE(I) = ICOLOR3
                END IF
              END IF

            END IF
          END IF
   20   CONTINUE

        CALL SWICLR(IMAGE, IWIDTH)

   30 CONTINUE

      CALL SWICLS

      END

*-----------------------------------------------------------------------
*     ARROW SUBPRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLAU(UX1,UY1,UX2,UY2)

      SAVE

      DATA      ITYPEZ/1/,INDEXZ/1/


      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGLAU','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGLAU','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGLAU','LINE INDEX IS INVALID.')
      END IF

      CALL SZLAOP(ITYPEZ,INDEXZ)
      CALL SZLAZU(UX1,UY1,UX2,UY2)
      CALL SZLACL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLAV(VX1,VY1,VX2,VY2)

      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGLAV','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGLAV','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGLAV','LINE INDEX IS INVALID.')
      END IF

      CALL SZLAOP(ITYPEZ,INDEXZ)
      CALL SZLAZV(VX1,VY1,VX2,VY2)
      CALL SZLACL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLAR(RX1,RY1,RX2,RY2)

      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGLAR','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGLAR','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGLAR','LINE INDEX IS INVALID.')
      END IF

      CALL SZLAOP(ITYPEZ,INDEXZ)
      CALL SZLAZR(RX1,RY1,RX2,RY2)
      CALL SZLACL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSLAT(ITYPE)

      ITYPEZ=ITYPE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQLAT(ITYPE)

      ITYPE=ITYPEZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSLAI(INDEX)

      INDEXZ=INDEX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQLAI(INDEX)

      INDEX=INDEXZ

      RETURN
      END

*-----------------------------------------------------------------------
*     PROGRAM FOR FONT FILE CONVERSION                       (95/05/31)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM CVFONT

      PARAMETER (NCHAR=256,LEN=6000,NP=8)
      PARAMETER (IU1=11,IU2=21)

      INTEGER   IPOSX(NCHAR),KX(NP),KY(NP)
      CHARACTER CKX(LEN)*1,CKY(LEN)*1,CDSNI*64,CDSNO*64
      LOGICAL   LEND

      EXTERNAL  INDXIF


*     / READ FONT FILE NAMES /

      READ(*,*) CDSNI,CDSNO

*     / OPEN FONT FILES /

      OPEN(IU1,FILE=CDSNI,FORM='FORMATTED',STATUS='OLD')
      REWIND(IU1)
      OPEN(IU2,FILE=CDSNO,FORM='UNFORMATTED',STATUS='NEW')
      REWIND(IU2)

*     / INITIALIZE ARRAYS FOR REPRODUCIBILITY /
      DO 5 I=1,LEN
        CKX(I) = CHAR(0)
        CKY(I) = CHAR(0)
    5 CONTINUE
      DO 6 I=1,NCHAR
        IPOSX(I) = 0
    6 CONTINUE

*     / LOAD TEXT FONT /

      NC=0
      IPLST=0

   30 CONTINUE

        NC=NC+1
        NL=0

   20   CONTINUE

*         / READ FONT DATA /

          NL=NL+1
          READ(IU1,100) ID,(KX(I),KY(I),I=1,NP)
  100     FORMAT(I5,3X,8(I3,1X,I3,1X))

*         / CHECK END OF LINE /

          JD=INDXIF(KY,NP,1,-64)
          IF (JD.EQ.0) THEN
            JDL=NP
          ELSE
            JDL=JD
          END IF

*         / PACK IN CHARACTER /

          DO 10 J=1,JDL
            IPC=NP*(NL-1)+J+IPLST
            CKX(IPC)=CHAR(KX(J)+64)
            CKY(IPC)=CHAR(KY(J)+64)
   10     CONTINUE

*         / CHECK END OF SEGMENT /

          IF (JD.NE.0) THEN
            IF (KX(JD).EQ.-64) THEN
              LEND=.TRUE.
              IPOSX(NC)=IPLST+1
              IPLST=NP*(NL-1)+JD+IPLST
            ELSE
              LEND=.FALSE.
            END IF
          ELSE
            LEND=.FALSE.
          END IF
        IF (.NOT.LEND) GO TO 20

      IF (.NOT.(NC.EQ.NCHAR)) GO TO 30

*     / WRITE UNFORMATTED FILE /

      WRITE(IU2) IPOSX
      WRITE(IU2) CKX
      WRITE(IU2) CKY

*     / CLOSE FONT FILE /

      CLOSE(IU1)
      CLOSE(IU2)

      END
*-----------------------------------------------------------------------
*     INDXIF
*-----------------------------------------------------------------------
      INTEGER FUNCTION INDXIF(IX,N,JD,II)

      INTEGER   IX(*)


      INDXIF=0
      DO 10 I=1,N
        J=JD*(I-1)+1
        IF (IX(J).EQ.II) THEN
          INDXIF=I
          RETURN
        END IF
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSSIM(SIMFAC, VXOFF, VYOFF)


      CALL SGRSET('SIMFAC',SIMFAC)
      CALL SGRSET('VXOFF' ,VXOFF)
      CALL SGRSET('VYOFF' ,VYOFF)

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CX  = SIMFAC
      CY  = SIMFAC
      VX0 = (VXMAX + VXMIN)/2 + VXOFF
      VY0 = (VYMAX + VYMIN)/2 + VYOFF
      CXMIN = ( VXMIN - VX0 ) / CX
      CXMAX = CXMIN + (VXMAX-VXMIN) / CX
      CYMIN = ( VYMIN - VY0 ) / CY
      CYMAX = CYMIN + (VYMAX-VYMIN) / CY
      CALL SGRSET('CXMIN',CXMIN)
      CALL SGRSET('CXMAX',CXMAX)
      CALL SGRSET('CYMIN',CYMIN)
      CALL SGRSET('CYMAX',CYMAX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQSIM(SIMFAC, VXOFF, VYOFF)

      CALL SGRGET('SIMFAC',SIMFAC)
      CALL SGRGET('VXOFF' ,VXOFF)
      CALL SGRGET('VYOFF' ,VYOFF)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHERBZ(N,UPX1,UPX2,UPY,ITYPE,INDEX,RSIZE)

      REAL      UPX1(*),UPX2(*),UPY(*)

      LOGICAL   LMISS, LYUNI
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      COMMON    /SZBTX3/ LCLIPT
      LOGICAL   LCLIP, LCLIPT


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UHERBZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UHERBZ','LINE TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UHERBZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UHERBZ','LINE INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UHERBZ','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UHERBZ','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      LCLIPT = LCLIP
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      IF (UPX1(1).EQ.RUNDEF .OR. UPX2(1).EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'UHERBZ',
     #    'RUNDEF CAN NOT BE UESED FOR UPY1 OR UPY2')
      END IF

      WRITE(COBJ,'(2I8,F8.5)') ITYPE, INDEX, RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHERBZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)

      LYUNI = UPY(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/(N-1)
      END IF

      DO 20 I=1,N
        IF (LYUNI) THEN
          UYY = UYMIN + DY*(I-1)
        ELSE
          UYY = UPY(I)
        END IF

        IF (.NOT.
     #    ((UYY.EQ.RMISS .OR. UPX1(I).EQ.RMISS .OR. UPX2(I).EQ.RMISS)
     #     .AND. LMISS)) THEN

          CALL STFTRF(UPX1(I), UYY, VX1, VYY)
          CALL STFTRF(UPX2(I), UYY, VX2, VYY)

          CALL SZOPLV
          CALL SZMVLV(VX1, VYY)
          CALL SZPLLV(VX2, VYY)
          CALL SZCLLV

          CALL SZOPSV
          CALL SZMVSV(VX1, VYY-RSIZE/2.)
          CALL SZPLSV(VX1, VYY+RSIZE/2.)
          CALL SZMVSV(VX2, VYY-RSIZE/2.)
          CALL SZPLSV(VX2, VYY+RSIZE/2.)
          CALL SZCLSV
        END IF
   20 CONTINUE

      CALL SWOCLS('UHERBZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTRQF(NTX,LTR)

      LOGICAL   LTR
      CHARACTER CTS*(*),CTL*(*)

      PARAMETER (NMAX=29)

      INTEGER   NTR(NMAX)
      LOGICAL   LCHREQ
      CHARACTER CTR1(NMAX)*3,CTR2(NMAX)*20,CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA CTR1( 1)/'U-U'/, CTR2( 1)/'UNI-UNI           '/, NTR( 1)/ 1/
      DATA CTR1( 2)/'U-L'/, CTR2( 2)/'UNI-LOG           '/, NTR( 2)/ 2/
      DATA CTR1( 3)/'L-U'/, CTR2( 3)/'LOG-UNI           '/, NTR( 3)/ 3/
      DATA CTR1( 4)/'L-L'/, CTR2( 4)/'LOG-LOG           '/, NTR( 4)/ 4/
      DATA CTR1( 5)/'POL'/, CTR2( 5)/'POLAR             '/, NTR( 5)/ 5/
      DATA CTR1( 6)/'BPL'/, CTR2( 6)/'BIPOLAR           '/, NTR( 6)/ 6/
      DATA CTR1( 7)/'ELP'/, CTR2( 7)/'ELLIPTIC          '/, NTR( 7)/ 7/
      DATA CTR1( 8)/'CYL'/, CTR2( 8)/'EQDST. CYLINDRICAL'/, NTR( 8)/10/
      DATA CTR1( 9)/'MER'/, CTR2( 9)/'MERCATOR          '/, NTR( 9)/11/
      DATA CTR1(10)/'MWD'/, CTR2(10)/'MOLLWEIDE         '/, NTR(10)/12/
      DATA CTR1(11)/'HMR'/, CTR2(11)/'HAMMER            '/, NTR(11)/13/
      DATA CTR1(12)/'EK6'/, CTR2(12)/'ECKERT 6          '/, NTR(12)/14/
      DATA CTR1(13)/'KTD'/, CTR2(13)/'KITADA            '/, NTR(13)/15/
      DATA CTR1(14)/'CON'/, CTR2(14)/'PTOLEMAIC CONICAL '/, NTR(14)/20/
      DATA CTR1(15)/'COA'/, CTR2(15)/'EQ.-AREA CONICAL  '/, NTR(15)/21/
      DATA CTR1(16)/'COC'/, CTR2(16)/'CONFORMAL CONICAL '/, NTR(16)/22/
      DATA CTR1(17)/'BON'/, CTR2(17)/'BONNE             '/, NTR(17)/23/
      DATA CTR1(18)/'OTG'/, CTR2(18)/'ORTHOGRAPHIC      '/, NTR(18)/30/
      DATA CTR1(19)/'PST'/, CTR2(19)/'STEREOGRAPHIC     '/, NTR(19)/31/
      DATA CTR1(20)/'AZM'/, CTR2(20)/'EQUIDST. AZIMUTHAL'/, NTR(20)/32/
      DATA CTR1(21)/'AZA'/, CTR2(21)/'AZIMUTHAL EQ. AREA'/, NTR(21)/33/
      DATA CTR1(22)/'GTR'/, CTR2(22)/'GRIDBASE TRANSFORM'/, NTR(22)/51/
      DATA CTR1(23)/'USR'/, CTR2(23)/'USER              '/, NTR(23)/99/
      DATA CTR1(24)/'MIL'/, CTR2(24)/'MILLER            '/, NTR(24)/16/
      DATA CTR1(25)/'RBS'/, CTR2(25)/'ROBINSON          '/, NTR(25)/17/
      DATA CTR1(26)/'SIN'/, CTR2(26)/'SANSON/SINUSOIDAL '/, NTR(26)/18/
      DATA CTR1(27)/'VDG'/, CTR2(27)/'VAN DER GRINTEN   '/, NTR(27)/19/
      DATA CTR1(28)/'PLC'/, CTR2(28)/'POLYCONIC         '/, NTR(28)/24/
      DATA CTR1(29)/'GNO'/, CTR2(29)/'GNOMONIC          '/, NTR(29)/34/

      LTR=INDXIF(NTR,NMAX,1,NTX).NE.0
      
      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTRSL(CTS,CTL)

      DO 10 N=1,NMAX
        IF (LCHREQ(CTS,CTR1(N))) THEN
          CTL=CTR2(N)
          RETURN
        END IF
   10 CONTINUE

      NCP=LENC(CTS)
      CMSG='TRANSFORMATION NAME <'//CTS(1:NCP)//'> IS NOT DEFINED.'
      CALL MSGDMP('E','SGTRSL',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTRSN(CTS,NTX)

      DO 20 N=1,NMAX
        IF (LCHREQ(CTS,CTR1(N))) THEN
          NTX=NTR(N)
          RETURN
        END IF
   20 CONTINUE

      NCP=LENC(CTS)
      CMSG='TRANSFORMATION NAME <'//CTS(1:NCP)//'> IS NOT DEFINED.'
      CALL MSGDMP('E','SGTRSN',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTRLS(CTL,CTS)

      DO 30 N=1,NMAX
        IF (LCHREQ(CTL,CTR2(N))) THEN
          CTS=CTR1(N)
          RETURN
        END IF
   30 CONTINUE

      NCP=LENC(CTL)
      CMSG='TRANSFORMATION NAME <'//CTL(1:NCP)//'> IS NOT DEFINED.'
      CALL MSGDMP('E','SGTRLS',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTRLN(CTL,NTX)

      DO 40 N=1,NMAX
        IF (LCHREQ(CTL,CTR2(N))) THEN
          NTX=NTR(N)
          RETURN
        END IF
   40 CONTINUE

      NCP=LENC(CTL)
      CMSG='TRANSFORMATION NAME <'//CTL(1:NCP)//'> IS NOT DEFINED.'
      CALL MSGDMP('E','SGTRLN',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTRNS(NTX,CTS)

      DO 50 N=1,NMAX
        IF (NTX.EQ.NTR(N)) THEN
          CTS=CTR1(N)
          RETURN
        END IF
   50 CONTINUE

      CMSG='TRANSFORMATION NUMBER <##> IS NOT DEFINED.'
      CALL CHNGI(CMSG,'##',NTX,'(I2)')
      CALL MSGDMP('E','SGTRNS',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTRNL(NTX,CTL)

      DO 60 N=1,NMAX
        IF (NTX.EQ.NTR(N)) THEN
          CTL=CTR2(N)
          RETURN
        END IF
   60 CONTINUE

      CMSG='TRANSFORMATION NUMBER <##> IS NOT DEFINED.'
      CALL CHNGI(CMSG,'##',NTX,'(I2)')
      CALL MSGDMP('E','SGTRNL',CMSG)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSCMN(NC)

      LOGICAL LFCATR,LCMCH

      CALL SWCMLL
      CALL SWISTX('ICLRMAP',NC)

      CALL SWQFCC(LFCATR)
      CALL SWLGET('LCMCH',LCMCH)
      CALL SWIGET('IWS', IWS)
      IF ((IWS.GE.1).AND.(IWS.LE.4)) THEN
      IF (LCMCH) THEN
        IF ((.NOT.LFCATR).OR.(IWS.EQ.1)) THEN
          CALL MSGDMP('W','SGSCMN',
     *         'COLORMAP MIGHT NOT CHANGE IMMEDIATELY.')
        ENDIF
        CALL SWCLCH()
      ENDIF
      ENDIF
      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQCMN(NMAX)

      CALL SWCMLL
      CALL SWQCMN(NMAX)

      RETURN
      END

*-----------------------------------------------------------------------
*     USPGET / USPSET / USPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USPGET(CP,IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL USPQID(CP, IDX)
      CALL USPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPSET(CP, IPARA)

      CALL USPQID(CP, IDX)
      CALL USPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY USPSTX(CP, IPARA)

      IP = IPARA
      CALL USPQID(CP, IDX)
      CALL USPQIT(IDX, IT)
      CALL USPQCP(IDX, CX)
      CALL USPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('US', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL USIQID(CP, IDX)
        CALL USISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('US', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL USLQID(CP, IDX)
        CALL USLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('US', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL USRQID(CP, IDX)
        CALL USRSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     UGPGET / UGPSET / UGPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL UGPQID(CP, IDX)
      CALL UGPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPSET(CP, IPARA)

      CALL UGPQID(CP, IDX)
      CALL UGPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGPSTX(CP, IPARA)

      IP = IPARA
      CALL UGPQID(CP, IDX)
      CALL UGPQIT(IDX, IT)
      CALL UGPQCP(IDX, CX)
      CALL UGPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UG', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL UGIQID(CP, IDX)
        CALL UGISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UG', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL UGLQID(CP, IDX)
        CALL UGLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UG', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL UGRQID(CP, IDX)
        CALL UGRSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
C     SUBROUTINE COST(N,X,WSAVE)
C
C     SUBROUTINE COST COMPUTES THE DISCRETE FOURIER COSINE TRANSFORM
C     OF AN EVEN SEQUENCE X(I). THE TRANSFORM IS DEFINED BELOW AT OUTPUT
C     PARAMETER X.
C
C     COST IS THE UNNORMALIZED INVERSE OF ITSELF SINCE A CALL OF COST
C     FOLLOWED BY ANOTHER CALL OF COST WILL MULTIPLY THE INPUT SEQUENCE
C     X BY 2*(N-1). THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER X
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE COST MUST BE
C     INITIALIZED BY CALLING SUBROUTINE COSTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE SEQUENCE X. N MUST BE GREATER THAN 1.
C             THE METHOD IS MOST EFFICIENT WHEN N-1 IS A PRODUCT OF
C             SMALL PRIMES.
C
C     X       AN ARRAY WHICH CONTAINS THE SEQUENCE TO BE TRANSFORMED
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15
C             IN THE PROGRAM THAT CALLS COST. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE COSTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C
C     OUTPUT PARAMETERS
C
C     X       FOR I=1,...,N
C
C                 X(I) = X(1)+(-1)**(I-1)*X(N)
C
C                  + THE SUM FROM K=2 TO K=N-1
C
C                      2*X(K)*COS((K-1)*(I-1)*PI/(N-1))
C
C                  A CALL OF COST FOLLOWED BY ANOTHER CALL OF
C                  COST WILL MULTIPLY THE SEQUENCE X BY 2*(N-1)
C                  HENCE COST IS THE UNNORMALIZED INVERSE
C                  OF ITSELF.
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF COST.
C
      SUBROUTINE COST (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
C
      NM1 = N-1
      NP1 = N+1
      NS2 = N/2
      IF (N-2) 106,101,102
  101 X1H = X(1)+X(2)
      X(2) = X(1)-X(2)
      X(1) = X1H
      RETURN
  102 IF (N .GT. 3) GO TO 103
      X1P3 = X(1)+X(3)
      TX2 = X(2)+X(2)
      X(2) = X(1)-X(3)
      X(1) = X1P3+TX2
      X(3) = X1P3-TX2
      RETURN
  103 C1 = X(1)-X(N)
      X(1) = X(1)+X(N)
      DO 104 K=2,NS2
         KC = NP1-K
         T1 = X(K)+X(KC)
         T2 = X(K)-X(KC)
         C1 = C1+WSAVE(KC)*T2
         T2 = WSAVE(K)*T2
         X(K) = T1-T2
         X(KC) = T1+T2
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN .NE. 0) X(NS2+1) = X(NS2+1)+X(NS2+1)
      CALL RFFTF (NM1,X,WSAVE(N+1))
      XIM2 = X(2)
      X(2) = C1
      DO 105 I=4,N,2
         XI = X(I)
         X(I) = X(I-2)-X(I-1)
         X(I-1) = XIM2
         XIM2 = XI
  105 CONTINUE
      IF (MODN .NE. 0) X(N) = XIM2
  106 RETURN
      END

*-----------------------------------------------------------------------
*     POLYMARKER PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPMU(N,UPX,UPY)

      REAL      UPX(*),UPY(*),VPX(*),VPY(*),RPX(*),RPY(*)

      SAVE

      DATA      ITYPEZ/1/,INDEXZ/1/,RSIZEZ/0.01/


      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMU','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMU','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMU','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGPMU','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMU','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SGPMU','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZPMOP(ITYPEZ,INDEXZ,RSIZEZ)
      CALL SZPMZU(N,UPX,UPY)
      CALL SZPMCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPMV(N,VPX,VPY)

      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMV','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMV','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMV','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGPMV','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMV','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SGPMV','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZPMOP(ITYPEZ,INDEXZ,RSIZEZ)
      CALL SZPMZV(N,VPX,VPY)
      CALL SZPMCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPMR(N,RPX,RPY)

      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMR','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMR','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMR','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGPMR','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SGPMR','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SGPMR','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZPMOP(ITYPEZ,INDEXZ,RSIZEZ)
      CALL SZPMZR(N,RPX,RPY)
      CALL SZPMCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSPMT(ITYPE)

      ITYPEZ=ITYPE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQPMT(ITYPE)

      ITYPE=ITYPEZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSPMI(INDEX)

      INDEXZ=INDEX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQPMI(INDEX)

      INDEX=INDEXZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSPMS(RSIZE)

      RSIZEZ=RSIZE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQPMS(RSIZE)

      RSIZE=RSIZEZ

      RETURN
      END

*-----------------------------------------------------------------------
*     SGPGET / SGPSET / SGPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL SGPQID(CP, IDX)
      CALL SGPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPSET(CP, IPARA)

      CALL SGPQID(CP, IDX)
      CALL SGPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGPSTX(CP, IPARA)

      IP = IPARA
      CALL SGPQID(CP, IDX)
      CALL SGPQIT(IDX, IT)
      CALL SGPQCP(IDX, CX)
      CALL SGPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('SG', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL SGIQID(CP, IDX)
        CALL SGISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('SG', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL SGLQID(CP, IDX)
        CALL SGLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('SG', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL SGRQID(CP, IDX)
        CALL SGRSVL(IDX, IP)
      ENDIF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPMZR(N,RPX,RPY)

      REAL      RPX(*),RPY(*)

      LOGICAL   LFLAG,LCLIPZ

      COMMON    /SZBPM1/ LMISS,RMISS,NPM
      LOGICAL   LMISS
      COMMON    /SZBPM2/ CMARK
      CHARACTER CMARK*1
      COMMON    /SZBTX3/ LCLIP
      LOGICAL   LCLIP

      SAVE


      LCLIPZ=LCLIP
      LCLIP=.FALSE.
      CALL STEPR2

      DO 10 I=1,N,NPM
        LFLAG=LMISS .AND. (RPX(I).EQ.RMISS .OR. RPY(I).EQ.RMISS)
        IF (.NOT.LFLAG) THEN
          CALL SZTXZV(RPX(I),RPY(I),CMARK)
        END IF
   10 CONTINUE

      LCLIP=LCLIPZ
      CALL STRPR2

      END

*-----------------------------------------------------------------------
*     T-WINDOW
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMQTXY(TXMINZ, TXMAXZ, TYMINZ, TYMAXZ)

      COMMON    /UMWK1/ITR, RUNDEF, IUNDEF, PI, CPR, CPD, CP

      SAVE


      CALL SGQTXY(TXMIN,  TXMAX,  TYMIN,  TYMAX)
      CALL STFRAD(TXMIN, TXMAX, TXMINZ, TXMAXZ)
      IF (ITR.EQ.11) THEN
        TYMINZ = -CP*75.
        TYMAXZ =  CP*75.
      ELSE IF (ITR.EQ.31) THEN
        TYMINZ =  CP*0.
        TYMAXZ =  CP*90.
      ELSE IF (ITR.EQ.22) THEN
        CALL SGRGET('STLAT1', STLAT1)
        CALL SGRGET('STLAT2', STLAT2)
        IF (STLAT1+STLAT2.GE.0.) THEN
          TYMINZ =  CP*0.
          TYMAXZ =  CP*90.
        ELSE
          TYMINZ = -CP*90.
          TYMAXZ =  CP*0.
        END IF
      ELSE
        CALL STFRAD(TYMIN, TYMAX, TYMINZ, TYMAXZ)
      END IF
      END

!-------------------------------------------------
!interface module of indxlib
!-------------------------------------------------
module ind_interface
  interface

    function indxcf(cx,n,jd,ch)                   !指定した文字が最初に現れる位置を求める（文字長 は1)．
      character(len=1), intent(in),dimension(*) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=1), intent(in) :: ch          !指定した文字
      integer indxcf                              !最初に現れる位置を与える関数値
    end function                                  
      
    function indxcl(cx,n,jd,ch)                   !指定した文字が最後に現れる位置を求める（文字長 は1).
      character(len=1), intent(in),dimension(*) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=1), intent(in) :: ch          !指定した文字
      integer indxcl                              !最後に現れる位置を与える関数値
    end function                                  
      
    function indxnf(cx,n,jd,ch)                   !指定した文字が最初に現れる位置を求める（文字長 は1以上).
      character(len=*), intent(in) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=*), intent(in) :: ch          !指定した文字
      integer indxnf                              !最初に現れる位置を与える関数値
    end function
      
    function indxnl(cx,n,jd,ch)                   !指定した文字が最後に現れる位置を求める（文字長 は1以上).
      character(len=*), intent(in) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=*), intent(in) :: ch          !指定した文字
      integer indxnl                              !最後に現れる位置を与える関数値
    end function
      
    function indxmf(cx,n,jd,ch)                   !指定した文字が最初に現れる位置を求める．大文字・小文字を区別しない
      character(len=*), intent(in) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=*), intent(in) :: ch          !指定した文字
      integer indxmf                              !最初に現れる位置を与える関数値
    end function
      
    function indxml(cx,n,jd,ch)                   !指定した文字が最後に現れる位置を求める．大文字・小文字を区別しない
      character(len=*), intent(in) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=*), intent(in) :: ch          !指定した文字
      integer indxml                              !最後に現れる位置を与える関数値
    end function
      
    function indxif(ix,n,jd,ii)                   !指定した整数値が最初に現れる位置を求める．
      integer,   intent(in), dimension(*) :: ix   !調べる整数型配列
      integer,   intent(in) :: n                  !調べる配列要素の個数
      integer,   intent(in) :: jd                 !調べる配列要素の間隔
      integer,   intent(in) :: ii                 !指定した整数値
      integer indxif                              !最初に現れる位置を与える関数値
    end function
      
    function indxil(ix,n,jd,ii)                   !指定した整数値が最後に現れる位置を求める．
      integer,   intent(in), dimension(*) :: ix   !調べる整数型配列
      integer,   intent(in) :: n                  !調べる配列要素の個数
      integer,   intent(in) :: jd                 !調べる配列要素の間隔
      integer,   intent(in) :: ii                 !指定した整数値
      integer indxil                              !最後に現れる位置を与える関数値
    end function
      
    function indxrf(rx,n,jd,rr)                   !指定した実数値が最初に現れる位置を求める．
      real,      intent(in), dimension(*) :: rx   !調べる実数型配列
      integer,   intent(in) :: n                  !調べる配列要素の個数
      integer,   intent(in) :: jd                 !調べる配列要素の間隔
      real,      intent(in) :: rr                 !指定した実数値
      integer indxrf                              !最初に現れる位置を与える関数値
    end function
      
    function indxrl(rx,n,jd,rr)                   !指定した実数値が最後に現れる位置を求める．
      real,      intent(in), dimension(*) :: rx   !調べる実数型配列
      integer,   intent(in) :: n                  !調べる配列要素の個数
      integer,   intent(in) :: jd                 !調べる配列要素の間隔
      real,      intent(in) :: rr                 !指定した実数値
      integer indxrl                              !最後に現れる位置を与える関数値
    end function
      
    function nindxc(cx,n,jd,ch)                   !指定した文字（文字長は1)が何個あるかを求める．
      character(len=1), intent(in), dimension(*) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=1), intent(in) :: ch          !指定した文字
      integer nindxc                              !文字の個数を与える関数値
    end function
      
    function nindxn(cx,n,jd,ch)                   !指定した文字（文字長は1以上）が何個あるかを求める．
      character(len=*), intent(in) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=*), intent(in) :: ch          !指定した文字
      integer nindxn                              !文字の個数を与える関数値
    end function
      
    function nindxm(cx,n,jd,ch)                   !指定した文字（文字長は1以上）が何個あるかを求める． 大文字・小文字を区別しないで調べる．
      character(len=*), intent(in) :: cx          !調べる文字列
      integer,   intent(in) :: n                  !調べる文字の個数
      integer,   intent(in) :: jd                 !調べる文字の間隔
      character(len=*), intent(in) :: ch          !指定した文字
      integer nindxm                              !文字の個数を与える関数値
    end function
      
    function nindxi(ix,n,jd,ii)                   !指定した整数値が何個あるかを求める．
      integer,   intent(in), dimension(*) :: ix   !調べる整数型配列
      integer,   intent(in) :: n                  !調べる配列要素の個数
      integer,   intent(in) :: jd                 !調べる配列要素の間隔
      integer,   intent(in) :: ii                 !指定した整数値
      integer nindxi                              !整数値の個数を与える関数値
    end function
      
    function nindxr(rx,n,jd,rr)                   !指定した実数値が何個あるかを求める．
      real,      intent(in), dimension(*) :: rx   !調べる実数型配列
      integer,   intent(in) :: n                  !調べる配列要素の個数
      integer,   intent(in) :: jd                 !調べる配列要素の間隔
      real,      intent(in) :: rr                 !指定した実数値
      integer nindxr                              !実数の個数を与える関数値
    end function

  end interface
end module
!indxlib library end ----

!-------------------------------------------------
!interface module of timelib
!-------------------------------------------------
module tim_interface
  interface

    subroutine time12(itime,itt)                  !1型の時刻を2型の時刻に変換する．
      integer,   intent(in) :: itime              !1型の時刻
      integer,   intent(out) :: itt               !通しの秒数
    end subroutine
      
    subroutine time13(itime,ih,im,is)             !1型の時刻を3型の時刻に変換する．
      integer,   intent(in) :: itime              !1型の時刻
      integer,   intent(out) :: ih                !時
      integer,   intent(out) :: im                !分
      integer,   intent(out) :: is                !秒
    end subroutine
      
    subroutine time21(itime,itt)                  !2型の時刻を1型の時刻に変換する．
      integer,   intent(out) :: itime              !1型の時刻
      integer,   intent(in) :: itt               !通しの秒数
    end subroutine
      
    subroutine time23(ih,im,is,itt)               !2型の時刻を3型の時刻に変換する．
      integer,   intent(out) :: ih                 !時
      integer,   intent(out) :: im                 !分
      integer,   intent(out) :: is                 !秒
      integer,   intent(in) :: itt               !通しの秒数
    end subroutine
      
    subroutine time31(itime,ih,im,is)             !3型の時刻を1型の時刻に変換する．
      integer,   intent(out) :: itime              !1型の時刻
      integer,   intent(in) :: ih                !時
      integer,   intent(in) :: im                !分
      integer,   intent(in) :: is                !秒
    end subroutine
      
    subroutine time32(ih,im,is,itt)               !3型の時刻を2型の時刻に変換する．
      integer,   intent(in) :: ih                 !時
      integer,   intent(in) :: im                 !分
      integer,   intent(in) :: is                 !秒
      integer,   intent(out) :: itt               !通しの秒数
    end subroutine
      
    subroutine timeq1(itime)                      !現在の1型の時刻を求める．
      integer,   intent(out) :: itime             !1型の時刻
    end subroutine
      
    subroutine timeq2(itt)                        !現在の2型の時刻を求める．
      integer,   intent(out) :: itt               !通しの秒数
    end subroutine
      
    subroutine timeq3(ih,im,is)                   !現在の3型の時刻を求める．
      integer,   intent(out) :: ih                !時
      integer,   intent(out) :: im                !分
      integer,   intent(out) :: is                !秒
    end subroutine
      
    subroutine timec1(cform,itime)                !itimeをcformに従って表現してcformで返す．
      integer,   intent(in) :: itime              !1型の時刻
      character(len=*), intent(inout) :: cform    !時刻のフォーマット
    end subroutine
      
    subroutine timec2(cform,itt)                  !ittをcformに従って表現してcformで返す．
      integer,   intent(in) :: itt                !通しの秒数
      character(len=*), intent(inout) :: cform    !時刻のフォーマット
    end subroutine
      
    subroutine timec3(cform,ih,im,is)             !ih,im,isをcformに従って表現してcformで返す．
      integer,   intent(in) :: ih                 !時
      integer,   intent(in) :: im                 !分
      integer,   intent(in) :: is                 !秒
      character(len=*), intent(inout) :: cform    !時刻のフォーマット
    end subroutine

  end interface
end module
!timelib library end ----

*-----------------------------------------------------------------------
*     USPACK REAL TO CHARACTER                       S. Sakai  90/03/16
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USCHVL(X, CHX)

      CHARACTER CHX*(*), CFMT*16, CVAL*16, CEXP*16, CEXP2*16, USGI*3
      REAL X
      LOGICAL LEXP, LCNTL, LSFNT, LCNTLZ

      CHARACTER CVAL2*16
      INTEGER NSPACE

      CALL SGLGET('LCNTL', LCNTL)
      LCNTLZ = LCNTL
      LCNTL = .TRUE.

      CALL SWLGET('LSYSFNT',LSFNT)
      CALL GLRGET('REPSL', PREC)
      NPREC = -LOG10(PREC)
      IF(NPREC.GT.8) NPREC = 8

      CFMT = '(E16.xE3)'
      WRITE(CFMT(6:6), '(I1)') NPREC
      WRITE(CVAL, CFMT) X

      CFMT = '(F11.x, TR1, I4)'
      WRITE(CFMT(6:6), '(I1)') NPREC
      READ (CVAL, CFMT) XX, NEXP

*------------------------ effective digits -----------------------------

      DO 10 N=11, 4, -1
        NDIG=N
        IF(CVAL(N:N).NE.'0') GOTO 20
   10 CONTINUE
   20 CONTINUE
      NDIG = NDIG - INDEX(CVAL, '.')

*----------------------------- mantissa --------------------------------

      NLOW = NEXP - NDIG + 1
      LEXP = NEXP.LE.-3 .OR. NLOW.GE.5

      IF(LEXP) THEN
        XX = XX*10
        NPREC = NDIG - 1
      ELSE
        XX = XX*1.D1**NEXP
        NPREC = -NLOW + 1
      ENDIF

      IF(NPREC.GE.1) THEN
        CFMT = '(SP, F16.x)'
        WRITE(CFMT(10:10), '(I1)')  NPREC
        WRITE(CVAL, CFMT) XX
      ELSE
        CFMT = '(SP, I16)'
        IX = NINT(XX)
        WRITE(CVAL, CFMT) IX
      ENDIF

      CALL CLADJ(CVAL)

*------------------------ For F2C --------------------------------------

      NSPACE=0
      DO 3 N=1,13
        IF (CVAL(N:N).NE.' ' .AND. CVAL(N:N).NE.'+'
     + .AND. CVAL(N:N).NE.'-' .AND. NSPACE.EQ.0) THEN
          NSPACE=N
        END IF
    3 CONTINUE
      IF (CVAL(NSPACE:NSPACE).EQ.'.')THEN
          CVAL2=CVAL(1:NSPACE-1)//'0'//CVAL(NSPACE:15)
          CVAL=CVAL2
      END IF

*-------------------------- characteristic -----------------------------

      IF(LEXP) THEN
        NEXP = NEXP - 1
        WRITE(CEXP2, '(I3)') NEXP
        CALL CLADJ(CEXP2)
        IF(LCNTL) THEN
              CEXP = USGI(194)//'10\^{'//CEXP2(1:LENC(CEXP2))
     +        //'}'
        ELSE
          CEXP = 'E'//CEXP2(1:LENC(CEXP2))
        END IF
      ELSE
        CEXP = ' '
      ENDIF

*-----------------------------------------------------------------------

      IF(LCNTL .AND. CVAL(2:3).EQ.'1 ' .AND. CEXP.NE.'  ') THEN
        IF(CEXP(1:3).EQ.USGI(194))THEN
          CHX = CVAL(1:1) // CEXP(4:16)
        ELSE
          CHX = CVAL(1:1) // CEXP(2:16)
        ENDIF
      ELSE
        CHX = CVAL(1:LENC(CVAL)) // CEXP
      ENDIF

      LCNTL = LCNTLZ

      RETURN
      END

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program fuzzy

  use dcl

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( -50.0, +50.0, 1.0e3, 0.4 )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransNumber( 2 )
    call DclSetTransFunction

    call DclDrawAxis( 'bt', 5.0, 20.0 )
    call DclDrawTitle( 'b', 'Latitude', 0.0 )

    call DclSetParm( 'iytype', 3 )
    call DclDrawAxisLog( 'lr', 3, 9 )
    call DclDrawTitle( 'l', 'Pressure (mb)', 0.0 )
!    call DclDrawTitle( 't', 'uxaxdv/ulylog', 0.0, sw=2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCPLZU(N,UPX,UPY,UPZ,INDEX)

      REAL      UPX(*),UPY(*),UPZ(*)


      IF (N.LT.2) THEN
        CALL MSGDMP('E','SCPLZU','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SCPLZU','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SCPLZU','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZL3OP(INDEX)
      CALL SZL3ZU(N,UPX,UPY,UPZ)
      CALL SZL3CL

      END

*-----------------------------------------------------------------------
      PROGRAM U2DF08

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=  0, XMAX=360, DX1=20, DX2=60 )
      PARAMETER ( YMIN=-90, YMAX=+90, DY1=10, DY2=30 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05 )

      REAL      P(NX,NY), U(NX,NY), V(NX,NY)

      EXTERNAL  IMOD


      CALL GLRGET( 'RMISS', RMISS )
      CALL GLLSET( 'LMISS', .TRUE. )

      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
   10   CONTINUE
   20 CONTINUE

      DO 40 J = 1, NY
        DO 30 I = 1, NX
          IF (J.EQ.1 .OR. J.EQ.NY) THEN
            U(I,J)=RMISS
            V(I,J)=RMISS
          ELSE
            U(I,J) = P(I,J-1) - P(I,J+1)
            V(I,J) = P(IMOD(I,NX-1)+1,J) - P(IMOD(I-2,NX-1)+1,J)
          END IF
   30   CONTINUE
   40 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UXAXDV( 'B', DX1, DX2 )
      CALL UXAXDV( 'T', DX1, DX2 )
      CALL UXSTTL( 'B', 'LONGITUDE', 0.0 )

      CALL UYAXDV( 'L', DY1, DY2 )
      CALL UYAXDV( 'R', DY1, DY2 )
      CALL UYSTTL( 'L', 'LATITUDE', 0.0 )

      CALL UDRSET( 'RSIZEL', 0.015 )
      CALL UDRSET( 'RSIZET', 0.015 )
      CALL UDCNTR( P, NX, NX, NY )

      CALL UGRSET( 'RSIZET', 0.015 )
      CALL UGLSET( 'LNRMAL', .FALSE. )
      CALL UGRSET( 'XFACT1', 0.025 )
      CALL UGRSET( 'YFACT1', 0.050 )
      CALL UGLSET( 'LUNIT', .TRUE. )
      CALL UGSUT( 'X', 'U' )
      CALL UGSUT( 'Y', 'V' )
      CALL UGRSET( 'VXUNIT', 0.05 )
      CALL UGRSET( 'VYUNIT', 0.10 )
      CALL UGVECT( U, NX, V, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UGRQNP / UGRQID / UGRQCP / UGRQVL / UGRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 20)
      PARAMETER (RUNDEF = -999.)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'XFACT1  ' /, RX( 1) / 1.0 /
      DATA      CPARAS( 2) / 'YFACT1  ' /, RX( 2) / 1.0 /
      DATA      CPARAS( 3) / 'XFACT2  ' /, RX( 3) / RUNDEF /
      DATA      CPARAS( 4) / 'YFACT2  ' /, RX( 4) / RUNDEF /
      DATA      CPARAS( 5) / 'RSMALL  ' /, RX( 5) / 0.001 /
      DATA      CPARAS( 6) / 'RSIZEM  ' /, RX( 6) / 0.01 /
      DATA      CPARAS( 7) / 'RSIZET  ' /, RX( 7) / RUNDEF /
      DATA      CPARAS( 8) / 'XTTL    ' /, RX( 8) / 0.0 /
      DATA      CPARAS( 9) / 'VXUOFF  ' /, RX( 9) / 0.02 /
      DATA      CPARAS(10) / 'VYUOFF  ' /, RX(10) / 0. /
      DATA      CPARAS(11) / 'VXULOC  ' /, RX(11) / RUNDEF /
      DATA      CPARAS(12) / 'VYULOC  ' /, RX(12) / RUNDEF /
      DATA      CPARAS(13) / 'UXUNIT  ' /, RX(13) / RUNDEF /
      DATA      CPARAS(14) / 'UYUNIT  ' /, RX(14) / RUNDEF /
      DATA      CPARAS(15) / 'VXUNIT  ' /, RX(15) / 0.05 /
      DATA      CPARAS(16) / 'VYUNIT  ' /, RX(16) / 0.05 /
      DATA      CPARAS(17) / 'RSIZEUT ' /, RX(17) / RUNDEF /
      DATA      CPARAS(18) / 'VUTOFF  ' /, RX(18) / 0.005 /
      DATA      CPARAS(19) / 'RHFACT  ' /, RX(19) / 1.5 /
      DATA      CPARAS(20) / 'RUNDEF  ' /, RX(20) / RUNDEF /

*     / LONG NAME /

      DATA      CPARAL(1) / 'VECTOR_SCALING_FACTOR_X' /
      DATA      CPARAL(2) / 'VECTOR_SCALING_FACTOR_Y' /
      DATA      CPARAL(3) / '****XFACT2  ' /
      DATA      CPARAL(4) / '****YFACT2  ' /
      DATA      CPARAL(5) / 'SMALL_VECTOR_THRESHOLD' /
      DATA      CPARAL(6) / 'MISS_VECTOR_MARKER_SIZE' /
      DATA      CPARAL(7) / 'VECTOR_MESSAGE_HEIGHT' /
      DATA      CPARAL(8) / 'VECTOR_MESSAGE_POSITION' /
      DATA      CPARAL( 9) / 'UNIT_VECTOR_X_OFFSET' /
      DATA      CPARAL(10) / 'UNIT_VECTOR_Y_OFFSET' /
      DATA      CPARAL(11) / 'UNIT_VECTOR_X_LOCATION' /
      DATA      CPARAL(12) / 'UNIT_VECTOR_Y_LOCATION' /
      DATA      CPARAL(13) / 'UNIT_VECTOR_X_LENGTH' /
      DATA      CPARAL(14) / 'UNIT_VECTOR_Y_LENGTH' /
      DATA      CPARAL(15) / 'UNIT_VECTOR_X_NORMALIZED_LENGTH' /
      DATA      CPARAL(16) / 'UNIT_VECTOR_Y_NORMALIZED_LENGTH' /
      DATA      CPARAL(17) / 'UNIT_VECTOR_TITLE_HEIGHT' /
      DATA      CPARAL(18) / '****VUTOFF  ' /
      DATA      CPARAL(19) / '****RHFACT  ' /
      DATA      CPARAL(20) / '----RUNDEF  ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UGRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UGRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UGRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UG', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
        IF ((IDX.EQ.7 .OR. IDX.EQ.17) .AND. RX(IDX).EQ.RUNDEF) THEN
          CALL UZRGET('RSIZEL1',RPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UGRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UG', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UGRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UGRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     GLPGET / GLPSET / GLPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE GLPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*40, CL*40


      CALL GLPQID(CP, IDX)
      CALL GLPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPSET(CP, IPARA)

      CALL GLPQID(CP, IDX)
      CALL GLPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLPSTX(CP, IPARA)

      IP = IPARA
      CALL GLPQID(CP, IDX)
      CALL GLPQIT(IDX, IT)
      CALL GLPQCP(IDX, CX)
      CALL GLPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('GL', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL GLIQID(CP, IDX)
        CALL GLISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('GL', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL GLLQID(CP, IDX)
        CALL GLLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('GL', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL GLRQID(CP, IDX)
        CALL GLRSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     USPACK SUB-LABEL (Y)                            S.Sakai  90/08/18
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USYSUB(CYA, CXA, CLABEL, RLBL)

      CHARACTER CLABEL*(*), CXS*1, CYS*1, CXA*1, CYA*1, CP*8
      LOGICAL   LPRTCT,LCLIPZ


      CXS = CXA
      CYS = CYA
      CALL CUPPER(CXS)
      CALL CUPPER(CYS)

      IF(CXS.NE.'T' .AND. CXS.NE.'B')
     #   CALL MSGDMP('E', 'USYSUB', 'INVALID CXS')
      IF(CYS.NE.'L' .AND. CYS.NE.'R'.AND. CYS.NE.'U')
     #   CALL MSGDMP('E', 'USYSUB', 'INVALID CYS')

      CP = 'ROFFY' //CYS
      CALL UZRGET(CP, ROFFY )
      CP = 'ICENTY'//CYS
      CALL UZIGET(CP, ICENTY)
      CP = 'IROTLY'//CYS
      CALL UZIGET(CP, IROTLY)
      CALL UZRGET('RSIZEL1', RSIZEL)
      CALL UZRGET('RSIZET2', RSIZET)
      CALL UZIGET('INDEXL1', INDEX )
      CALL UZIGET('INNER'  , INNER )
      CALL UZRGET('PAD1'   , PAD1  )

      CALL SZQTXW(CLABEL, NCH, WSUB, HSUB)
      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      IROTLY = MOD(IROTLY, 4)
      WSUB = WSUB*RSIZEL
      WLBL = RLBL*RSIZEL
      WPAD = PAD1*RSIZEL

      IC = 1
      IF(IROTLY.GE.2) IC = -1
      ICY = IC*ICENTY

*======================== < VERTICAL LABEL > ===========================

      IF(IROTLY.EQ.1 .OR. IROTLY.EQ.3) THEN
        IF(CXS.EQ.'T') THEN
          ICENTY = IC
          POSY = VYMAX - WLBL/2*(ICY-1)
        ELSE
          ICENTY = -IC
          POSY = VYMIN - WLBL/2*(ICY+1)
        ENDIF

        IF(CYS.EQ.'L') THEN
          POSX  = VXMIN
          IFLAG = -1
        ELSEIF(CYS.EQ.'R') THEN
          POSX  = VXMAX
          IFLAG = +1
        ELSE
          CALL UZRGET('UXUSER', UXUSR)
          CALL UZIGET('IFLAG', IFLAG)
          IFLAG = SIGN(1, IFLAG)
          CALL STFTRF(UXUSR, 1., POSX, VY)
        ENDIF
        ROFFY = ROFFY + RSIZEL*IFLAG*(1.+PAD1)
        POSX  = POSX  + ROFFY - RSIZEL*IFLAG/2.
        CP = 'ROFFY' //CYS
        CALL UZRSET(CP, ROFFY )

*====================== < HORIZONTAL LABEL > ===========================

      ELSE
        CALL USIGET('MXDGTSY', MXDGT )
        CALL USLGET('LPRTCT' , LPRTCT)
        CP = 'SOFFY'//CYS//CXS
        CALL USRGET(CP, RSOFF )
        IF(LPRTCT .AND. CYS.EQ.'U')
     #    CALL MSGDMP('M', 'USYSUB', 'X-LABEL REGION IS NOT PROTECTED.')

        IF(CXS .EQ. 'T') THEN
          POSY  = VYMAX + RSOFF + RSIZEL*(0.5+PAD1)
          RSOFF = RSOFF + RSIZEL*(1.+PAD1)
        ELSE
          POSY  = VYMIN + RSOFF - RSIZEL*(0.5+PAD1)
          RSOFF = RSOFF - RSIZEL*(1.+PAD1)
        ENDIF

        CP = 'SOFFY'//CYS//CXS
        CALL USRSET(CP, RSOFF)

        CP = 'ROFFX'//CXS
        CALL USRGET(CP, ROFFX)

        ROFFX = MAX(RSOFF, ROFFX)

*-----------------------------------------------------------------------
*       IFLAG =  1 : LABEL IS RIGHT SIDE OF THE AXIS.
*       IFLAG = -1 : LABEL IS LEFT  SIDE OF THE AXIS.

        CP = 'ROFGY'//CYS
        CALL UZRGET(CP , ROFG)
        IF(INNER.LT.0) WPAD = WPAD - INNER*RSIZET
        IF(CYS.EQ.'L') THEN
          IFLAG = -1
          VXP  = -(VXMIN+ROFG)
        ELSEIF(CYS.EQ.'R') THEN
          IFLAG = 1
          VXP  = VXMAX+ROFG
        ELSEIF(CYS.EQ.'U') THEN
          CALL UZRGET('UXUSER', UXUSR)
          CALL UZIGET('IFLAG', IFLAG)
          CALL STFTRF(UXUSR, 1., VXP, VY)
          VXP = VXP + ROFG
          CP = 'ROFFX'//CXS
          CALL USRSET(CP, ROFFX)
        ENDIF

        POSX = VXP + WPAD + WLBL*(ICY*IFLAG+1)/2.
        XMIN = VXP + WPAD
        XMAX = VXP + WPAD + MXDGT*RSIZEL

*------------------------ boundary check -------------------------------

        XLMIN = POSX - WSUB*(ICY*IFLAG+1)/2.
        IF(XLMIN.LT.XMIN) THEN
          ICY    = -IFLAG
          POSX   = XMIN
        ENDIF

        XLMAX = POSX - WSUB*(ICY*IFLAG-1)/2.
        IF(.NOT.LPRTCT .AND. XLMAX.GT.XMAX) THEN
          ICY    = IFLAG
          POSX   = XMAX
        ENDIF

        XLMIN = POSX - WSUB*(ICY*IFLAG+1)/2.
        IF(XLMIN.LT.VXP) THEN
          IF(CYS.EQ.'U') THEN
            ICY = 0
            POSX = (VXP+XMAX)/2.
          ELSE
            CP = 'ROFFX'//CXS
            CALL USRSET(CP, ROFFX)
          ENDIF
        ENDIF

        ICENTY = ICY/IC
        POSX = ABS(POSX)
      ENDIF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)
      CALL SGTXZV(POSX, POSY, CLABEL, RSIZEL, IROTLY*90, ICENTY, INDEX)
      CALL SGLSET('LCLIP',LCLIPZ)

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      LOGICAL FUNCTION LFROMC(CX)

      CHARACTER CX*(*)

      LOGICAL   LCHREQ
      CHARACTER CMSG*80

      EXTERNAL  LENY,LENZ,LCHREQ


      LC1=LENY(CX)+1
      LC2=LENZ(CX)

      IF (LC2.EQ.0) THEN
        CMSG='THERE IS NO VALID CHARACTER.'
        CALL MSGDMP('E','IFROMC',CMSG)
      END IF

      IF (CX(LC1:LC1).EQ.'.') THEN
        LC1=LC1+1
      END IF

      IF (LCHREQ(CX(LC1:LC1),'T')) THEN
        LFROMC=.TRUE.
      ELSE IF (LCHREQ(CX(LC1:LC1),'F')) THEN
        LFROMC=.FALSE.
      ELSE
        CMSG='THIS IS INVALID LOGICAL EXPRESSION.'
        CALL MSGDMP('E','LFROMC',CMSG)
      END IF

      END

!-------------------------------------------------
!interface module of ifalib
!-------------------------------------------------
module ifa_interface
  interface

    function imax(ix,n,jx)                        !最大値を求める
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      integer imax                                !最大値を与える関数値
    end function
      
    function imin(ix,n,jx)                        !最小値を求める
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      integer imin                                !最小値を与える関数値
    end function
      
    function isum(ix,n,jx)                        !総和をもとめる
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
      integer isum                                !総和を与える関数値
    end function

  end interface
end module
!ifalib library end ----

*-----------------------------------------------------------------------
*     BASIC ROUTINES
*-----------------------------------------------------------------------
*     UYPTMZ : PLOT TICKMARKS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPTMZ(UY,N,UPX,ROFFY,RTICK,INDEX)

      REAL      UY(*)

      LOGICAL   LCLIPZ


      IF (N.LE.0) THEN
        CALL MSGDMP('E','UYPTMZ','NUMBER OF POINTS IS INVALID.')
      END IF
      IF (INDEX.LE.0) THEN
        CALL MSGDMP('E','UYPTMZ','LINE INDEX IS INVALID.')
      END IF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)

      CALL SZLNOP(INDEX)
      DO 10 I=1,N
        CALL STFTRF(UPX,UY(I),VPX,VPY)
        VPX=VPX+ROFFY
        CALL SZLNZV(VPX,VPY,VPX+RTICK,VPY)
   10 CONTINUE
      CALL SZLNCL

      CALL SGLSET('LCLIP',LCLIPZ)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLTLCV(CTLIN,CTLOUT,LOUT)

      CHARACTER CTLIN*(*),CTLOUT*(*)

      LOGICAL   LCHREQ,LPARA
      CHARACTER CST*4,CTMP*16

      EXTERNAL  LCHREQ,LENC


      ITL=LENC(CTLIN)
      IN=0
      IC=0
   10 CONTINUE
        IN=IN+1
        IC=IC+1
        IF (CTLIN(IN:IN).EQ.'#') THEN
          CST=CTLIN(IN+1:IN+4)
          IF (LCHREQ(CST,'PAGE')) THEN
            CTMP='##'
            CALL SGIGET('NPAGE',IPAGE)
            CALL CHNGI(CTMP,'##',IPAGE,'(I2)')
            LPARA=.TRUE.
          ELSE IF (LCHREQ(CST,'DATE')) THEN
            CTMP='YY/MM/DD'
            CALL DATEQ3(IY,IM,ID)
            CALL DATEC3(CTMP,IY,IM,ID)
            LPARA=.TRUE.
          ELSE IF (LCHREQ(CST,'TIME')) THEN
            CTMP='HH:MM:SS'
            CALL TIMEQ3(JH,JM,JS)
            CALL TIMEC3(CTMP,JH,JM,JS)
            LPARA=.TRUE.
          ELSE IF (LCHREQ(CST,'PROG')) THEN
            CALL OSGARG(0,CTMP)
            LPARA=.TRUE.
          ELSE IF (LCHREQ(CST,'USER')) THEN
            CALL OSGENV('USER',CTMP)
            LPARA=.TRUE.
          ELSE
            LPARA=.FALSE.
          END IF
          IF (LPARA) THEN
            NP=LENC(CTMP)-1
            CTLOUT(IC:IC+NP)=CTMP
            IN=IN+4
            IC=IC+NP
          ELSE
            CTLOUT(IC:IC)='#'
          END IF
        ELSE
          CTLOUT(IC:IC)=CTLIN(IN:IN)
        END IF
      IF (.NOT.(IN.GE.ITL)) GO TO 10
      LOUT=IC

      END

*-----------------------------------------------------------------------
      PROGRAM U2DF05

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=  0, XMAX=360, DX1=20, DX2=60 )
      PARAMETER ( YMIN=-90, YMAX=+90, DY1=10, DY2=30 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05, DP=0.2 )

      REAL      P(NX,NY)


      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
   10   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )

      CALL GLRGET( 'RMISS', RMISS )
      CALL SGLSET( 'LSOFTF', .FALSE. )

      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UESTLV( RMISS,  -DP, 201 )
      CALL UESTLV(    DP, DP*2, 401 )
      CALL UESTLV( DP*2, RMISS, 402 )
      CALL UETONE( P, NX, NX, NY )

      CALL UXAXDV( 'B', DX1, DX2 )
      CALL UXAXDV( 'T', DX1, DX2 )
      CALL UXSTTL( 'B', 'LONGITUDE', 0.0 )

      CALL UYAXDV( 'L', DY1, DY2 )
      CALL UYAXDV( 'R', DY1, DY2 )
      CALL UYSTTL( 'L', 'LATITUDE', 0.0 )

      CALL UDGCLB( P, NX, NX, NY, DP )
      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UEPQNP / UEPQID / UEPQCP / UEPQVL / UEPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 8)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'LTONE   ' /, ITYPE(1) / 2 /
      DATA      CPARAS(2) / 'IPAT    ' /, ITYPE(2) / 1 /
      DATA      CPARAS(3) / 'RLEV    ' /, ITYPE(3) / 3 /
      DATA      CPARAS(4) / 'LBOUND  ' /, ITYPE(4) / 2 /
      DATA      CPARAS(5) / 'NLEV    ' /, ITYPE(5) / 1 /
      DATA      CPARAS(6) / 'ITPAT   ' /, ITYPE(6) / 1 /
      DATA      CPARAS(7) / 'ICOLOR1 ' /, ITYPE(7) / 1 /
      DATA      CPARAS(8) / 'ICOLOR2 ' /, ITYPE(8) / 1 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'ENABLE_AUTO_SHADE_LEVEL' /
      DATA      CPARAL(2) / 'DEFAULT_SHADE_PATTERN' /
      DATA      CPARAL(3) / 'DEFAULT_SHADE_THRESHOLD' /
      DATA      CPARAL(4) / '????LBOUND  ' /
      DATA      CPARAL(5) / '****NLEV    ' /
      DATA      CPARAL(6) / 'AUTO_SHADE_PATTERN' /
      DATA      CPARAL(7) / 'SHADE_COLOR_MIN' /
      DATA      CPARAL(8) / 'SHADE_COLOR_MAX' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG='PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UEPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UEPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UEPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','UEPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UEIQID(CPARAS(IDX), ID)
          CALL UEIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UELQID(CPARAS(IDX), ID)
          CALL UELQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UERQID(CPARAS(IDX), ID)
          CALL UERQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UEPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UEIQID(CPARAS(IDX), ID)
          CALL UEISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UELQID(CPARAS(IDX), ID)
          CALL UELSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UERQID(CPARAS(IDX), ID)
          CALL UERSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UEPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     DATEC3
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE DATEC3(CFORM,IY,IM,ID)

      CHARACTER CFORM*(*)

      PARAMETER (NN=3)

      INTEGER   JD(NN)
      CHARACTER CD(NN)*1,CFMT*4,CMON*9,CWEEK*9

      SAVE

      EXTERNAL  LENC,INDXCF,INDXCL,CMON,CWEEK

      DATA      CD/'Y','M','D'/


      MC=LENC(CFORM)
      JD(1)=IY
      JD(2)=IM
      JD(3)=ID
      DO 10 I=1,3
        IDX1=INDXCF(CFORM,MC,1,CD(I))
        IDX2=INDXCL(CFORM,MC,1,CD(I))
        IF (IDX1.GT.0) THEN
          NCM=IDX2-IDX1+1
          WRITE(CFMT,'(A2,I1,A1)') '(I',NCM,')'
          WRITE(CFORM(IDX1:IDX2),CFMT) MOD(JD(I),10**NCM)
        END IF
   10 CONTINUE

      IDX1=INDXCF(CFORM,MC,1,'C')
      IDX2=INDXCL(CFORM,MC,1,'C')
      IF (IDX1.GT.0) THEN
        NCM=IDX2-IDX1+1
        WRITE(CFMT,'(A2,I1,A1)') '(A',NCM,')'
        WRITE(CFORM(IDX1:IDX2),CFMT) CMON(JD(2))
        CALL CRADJ(CFORM(IDX1:IDX2))
      END IF

      IDX1=INDXCF(CFORM,MC,1,'W')
      IDX2=INDXCL(CFORM,MC,1,'W')
      IF (IDX1.GT.0) THEN
        NCW=IDX2-IDX1+1
        WRITE(CFMT,'(A2,I1,A1)') '(A',NCW,')'
        WRITE(CFORM(IDX1:IDX2),CFMT) CWEEK(IWEEK3(IY,IM,ID))
        CALL CRADJ(CFORM(IDX1:IDX2))
      END IF

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGLAXU(UX1,UY1,UX2,UY2,ITYPE,INDEX,ICOLOR)

      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGLAXU','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGLAXU','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLAXU','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLAXU','LINE INDEX IS INVALID.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZLAOP(ITYPE,INDEX)
      CALL SZLAZU(UX1,UY1,UX2,UY2)
      CALL SZLACL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHBXLZ(N,UPX,UPY,ITYPE,INDEX)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG, LMISS, LYUNI
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.2) THEN
        CALL MSGDMP('E','UHBOXL','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UHBOXL','LINE TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UHBOXL','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UHBOXL','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      IF (UPX(1).EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'UHBXLZ', 'RUNDEF CAN NOT BE UESED FOR UPX.')
      END IF

      WRITE(COBJ,'(2I8)') ITYPE,INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHBXLZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)
      CALL SZOPLU

      LYUNI = UPY(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/N
      END IF

      CALL SZOPLU

      LFLAG=.FALSE.
      DO 20 I=1,N
        IF (LYUNI) THEN
          UY1 = UYMIN + DY*(I-1)
          UY2 = UYMIN + DY*I
        ELSE
          UY1 = UPY(I)
          UY2 = UPY(I+1)
        END IF

        IF ((UPX(I).EQ.RMISS .OR. UY1.EQ.RMISS .OR. UY2.EQ.RMISS)
     #    .AND. LMISS) THEN
          LFLAG=.FALSE.
        ELSE
          IF (LFLAG) THEN
            CALL SZPLLU(UPX(I),UY1)
            CALL SZPLLU(UPX(I),UY2)
          ELSE
            CALL SZMVLU(UPX(I),UY1)
            CALL SZPLLU(UPX(I),UY2)
            LFLAG=.TRUE.
          END IF
        END IF
   20 CONTINUE

      CALL SZCLLU
      CALL SWOCLS('UHBXLZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TEST05

      PARAMETER ( NP=14 )
      PARAMETER ( NX=73, NY=37 )
      PARAMETER ( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )

      REAL      FCT(NP), P(NX,NY)
      CHARACTER CTTL*32, CTR(NP)*3

      EXTERNAL  ISGTRC

      DATA CTR /'CYL','MER','MWD','HMR','EK6','KTD',
     +          'CON','COA','COC','BON',
     +          'OTG','PST','AZM','AZA'/
      DATA FCT / 0.12, 0.12, 0.14, 0.14, 0.14, 0.14,
     +           0.11, 0.16, 0.12, 0.12,
     +           0.40, 0.12, 0.12, 0.17/


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      OPEN(11,FILE='t811231.dat',FORM='FORMATTED')
      DO 10 J=1,NY
        READ(11,'(10F8.3)') (P(I,J),I=1,NX)
   10 CONTINUE
      CLOSE(11)

      DO 20 IR=190,245,5
        R=IR
        AMIN=R
        AMAX=R+5
*       IDX=(R-180)*1.4*1000+999
        IDX=INT((R-170)*1.25)*1000+999
        CALL UESTLV(AMIN,AMAX,IDX)
   20 CONTINUE 

      CALL SGOPN( IWS )

      CALL SGLSET( 'LSOFTF', .FALSE. )
      CALL SGRSET( 'STLAT1', 75.0 )
      CALL SGRSET( 'STLAT2', 60.0 )
      CALL UMLSET( 'LGRIDMJ', .FALSE. )
      CALL UMRSET( 'DGRIDMN', 30.0 )

      DO 30 I=1,NP

        CALL SGFRM

        CALL SGSSIM( FCT(I), 0.0, 0.0 )
        CALL SGSMPL( 165.0, 60.0, 0.0 )
        CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
        CALL SGSWND(XMIN, XMAX, YMIN, YMAX)
        IF (CTR(I).EQ.'OTG') THEN
          CALL SGSTXY( -180.0, 180.0,   0.0, 90.0 )
        ELSE
          CALL SGSTXY( -180.0, 180.0, -90.0, 90.0 )
        END IF
        CALL SGSTRN( ISGTRC(CTR(I)) )
        CALL SGSTRF

        CALL SGLSET( 'LCLIP', .TRUE. )
        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( ISGTRC(CTR(I)), CTTL )
        CALL SGTXZR( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

        CALL UETONE( P, NX, NX, NY )
        CALL UDCNTR( P, NX, NX, NY )
        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB
        CALL SLPVPR( 1 )

   30 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     LINE SUBPRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLNU(UX1,UY1,UX2,UY2)

      SAVE

      DATA      INDEXZ/1/


      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGLNU','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGLNU','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZLNOP(INDEXZ)
      CALL SZLNZU(UX1,UY1,UX2,UY2)
      CALL SZLNCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLNV(VX1,VY1,VX2,VY2)

      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGLNV','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGLNV','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZLNOP(INDEXZ)
      CALL SZLNZV(VX1,VY1,VX2,VY2)
      CALL SZLNCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLNR(RX1,RY1,RX2,RY2)

      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGLNR','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGLNR','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZLNOP(INDEXZ)
      CALL SZLNZR(RX1,RY1,RX2,RY2)
      CALL SZLNCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSLNI(INDEX)

      INDEXZ=INDEX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQLNI(INDEX)

      INDEX=INDEXZ

      RETURN
      END

*-----------------------------------------------------------------------
*     CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGOPN(IWS)

      LOGICAL   LFIRST,LFULL,LPAGE

      SAVE


*     / SET WORKSTATION NUMBER /

      CALL SGISET('IWS',IWS)

      CONTINUE
*-----------------------------------------------------------------------
      ENTRY SGINIT

*     / SET INITIALIZATION FLAG /

      LFIRST=.TRUE.

*     / CHECK WORKSTATION NUMBER /

      CALL SGIGET('IWS',IWSX)
      CALL SWIGET('MAXWNU',NW)
      JWS=ABS(IWSX)
      IF (.NOT.(1.LE.JWS .AND. JWS.LE.NW)) THEN
        CALL MSGDMP('E','SGINIT','WORKSTATION NUMBER IS INVALID.')
      END IF

*     / OPEN WORKSTATION /

      CALL SWISET('IWS',JWS)
      CALL SWDOPN

*     / GET RANGE OF WORKSTATION RECTANGLE AND SCALING FACTOR /

      CALL SWQRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)

*     / SET WORKSTATION RECTANGLE /

      IF (IWSX.GE.0) THEN
        WX0=WSXMX-WSXMN
        WY0=WSYMX-WSYMN
        ITR=1
      ELSE
        WX0=WSYMX-WSYMN
        WY0=WSXMX-WSXMN
        ITR=2
      END IF

      CALL STSWRC(WSXMN,WSXMX,WSYMN,WSYMX)
      CALL SWSROT(ITR)

*     / INITIALIZATION FOR LAYOUT /

      CALL SLINIT(WX0,WY0,FACT)

*     / SET DUMMY TRANSFORMATION /

      RXM=MIN(1.0,WX0/WY0)
      RYM=MIN(WY0/WX0,1.0)
      CALL STSWTR(0.0,RXM,0.0,RYM,0.0,WX0,0.0,WY0,ITR)
      CALL SGSVPT(0.0,RXM,0.0,RYM)
      CALL SGSWND(0.0,1.0,0.0,1.0)
      CALL SGSTRN(1)
      CALL SGSTRF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGFRM

*     / INQUIRE LAYOUT STATUS  /

      CALL SGIGET('NLEVEL',LEV)
      CALL SGIGET('NFRAME',IFR)
      CALL SGIGET('NPAGE' ,IPG)

*     / SET NEW FRAME /

      IFR=IFR+1
      JFR=IFR
      CALL SGISET('NFRAME',IFR)

*     / INQUIRE PAGE NO. /

      CALL SLPAGE(LEV,JFR,IPAGE)
      LPAGE=IPAGE.NE.IPG

      IF (LPAGE) THEN

*       / CLOSE PAGE /

        IF (LFIRST) THEN
          LFIRST=.FALSE.
        ELSE
          CALL SWPCLS
        END IF

*       / NEXT PAGE /

        CALL SGISET('NPAGE',IPAGE)

        CALL SWPOPN

*       / PLOT CORNER MARKS & TITLES /

        CALL SLQRCT(1,1,XAMIN,XAMAX,YAMIN,YAMAX)
        WXL=XAMAX-XAMIN
        WYL=YAMAX-YAMIN
        RXM=MIN(1.0,WXL/WYL)
        RYM=MIN(WYL/WXL,1.0)
        CALL STSWTR(0.0,RXM,0.0,RYM,XAMIN,XAMAX,YAMIN,YAMAX,ITR)

        CALL SLPCNR
        CALL SLPTTL

      END IF

*     / GET WORKSTATION RECTANGLE /

      CALL SLQRCT(LEV,IFR,XAMIN,XAMAX,YAMIN,YAMAX)
      WXL=XAMAX-XAMIN
      WYL=YAMAX-YAMIN

*     / SET WORKSTATION TRANSFORMATION /

      CALL SGLGET('LFULL', LFULL)
      IF (LFULL) THEN
        RXM=MIN(1.0,WXL/WYL)
        RYM=MIN(WYL/WXL,1.0)
        CALL STSWTR(0.0,RXM,0.0,RYM,XAMIN,XAMAX,YAMIN,YAMAX,ITR)
      ELSE
        CALL STSWTR(0.0,1.0,0.0,1.0,XAMIN,XAMAX,YAMIN,YAMAX,ITR)
      END IF

*     / SET NORMALIZATION TRANSFORMATION /

      CALL STQWTR(RXMIN,RXMAX,RYMIN,RYMAX,WXMIN,WXMAX,WYMIN,WYMAX,JTR)
      CALL SGSVPT(RXMIN,RXMAX,RYMIN,RYMAX)
      CALL SGSWND(RXMIN,RXMAX,RYMIN,RYMAX)
      CALL SGSTRN(1)
      CALL SGSTRF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGCLS

*     / CLOSE SGKS /

      CALL SWPCLS
      CALL SWDCLS

      RETURN
      END

!-----------------------------------------------------------------------
program ulpk02
  use dcl

  integer,parameter :: nbl=2
  real,dimension(nbl) :: bl
  character*64 :: ctl

    bl = (/ 1.0,3.0 /)

    call DclOpenGraphics( DclSelectDevice() )

    call DclSetParm( 'GRAPH:lfull',.true. )
    call DclSetAxisFactor(0.7)
    call DclSetAspectRatio(1.0,0.75)
    call DclDivideFrame('y',7,1)

    do i=1,7

      call DclNewFrame
      call DclSetWindow(0.2,200.,0.15,200.)
      call DclSetViewPort(0.13,0.14,0.1,0.9)
      call DclSetTransNumber( DCL_LOG_LOG )
      call DclSetTransFunction

      select case(i)
      case(1)
        call DclSetParm( 'LOG:IYTYPE',1)
        call DclDrawYLogAxis('l',1,9)
        ctl='iytype=1,nlbl=1,ntck=9'
      case(2)
        call DclSetParm( 'LOG:IYTYPE',1)
        call DclDrawYLogAxis('l',3,9)
        ctl='iytype=1,nlbl=3,ntck=9'
      case(3)
        call DclSetParm( 'LOG:IYTYPE',2)
        call DclDrawYLogAxis('l',3,9)
        ctl='iytype=2,nlbl=3,ntck=9'
      case(4)
        call DclSetParm( 'LOG:IYTYPE',3)
        call DclDrawYLogAxis('l',3,9)
        ctl='iytype=3,nlbl=3,ntck=9'
      case(5)
        call DclSetParm( 'LOG:IYTYPE',4)
        call DclDrawYLogAxis('l',3,9)
        ctl='iytype=4,nlbl=3,ntck=9'
      case(6)
        call DclSetYLogFormat('(f5.1)')
        call DclSetParm( 'LOG:iytype',3)
        call DclDrawYLogAxis('l',3,9)
        ctl='iytype=3,nlbl=3,ntck=9'
      case(7)
        call DclSetParm( 'LOG:IYTYPE',1)
        call DclSetParm( 'LOG:IYCHR',194)
        call DclSetYLogLabel( bl )
        call DclDrawYLogAxis('l',4,5)
        ctl='iytype=1,nlbl=4,ntck=5'
      end select
      call DclDrawYSubTitle('l',ctl,0.0)
    end do

    call DclCloseGraphics

end program

      PROGRAM U2D5

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL P(NX,NY)

      DO 10 J=1,NY
      DO 10 I=1,NX
        ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
        ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
        SLAT = SIN(ALAT)
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      DO 20 K=-5,3
        TLEV1 = 0.4*K
        TLEV2 = TLEV1 + 0.4
        IF(K.LE.-1) THEN
          IPAT = 600 + ABS(K+1)
        ELSE
          IPAT =  30 + K
        END IF
        CALL UESTLV( TLEV1, TLEV2, IPAT )
   20 CONTINUE

      CALL USDAXS
      CALL UDGCLB( P, NX, NX, NY, 0.4 )
      CALL UDCNTR( P, NX, NX, NY )
      CALL UETONE( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     TMLQNP / TMLQID / TMLQCP / TMLQVL / TMLSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE TMLQNP(NCP)
      IMPLICIT NONE

      INTEGER   NCP
      LOGICAL   LPARA
      CHARACTER CP*(*)

      INTEGER   NPARA
      PARAMETER (NPARA = 5)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      INTEGER   LENC
      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'PERIODX ' /, LX(1) / .FALSE. /
      DATA      CPARAS(2) / 'PERIODY ' /, LX(2) / .FALSE. /
      DATA      CPARAS(3) / 'NODRSHRT' /, LX(3) / .FALSE. /
      DATA      CPARAS(4) / 'ENDARROW' /, LX(4) / .FALSE. /
      DATA      CPARAS(5) / 'FIXEDDT ' /, LX(5) / .FALSE. /

*     / LONG NAME /

      DATA      CPARAL(1) / 'PERIOD_BOUNDARY_XDIRECTION' /
      DATA      CPARAL(2) / 'PERIOD_BOUNDARY_YDIRECTION' /
      DATA      CPARAL(3) / 'NO_DRAW_SHORTLINE' /
      DATA      CPARAL(4) / 'END_ARROW_FLAG' /
      DATA      CPARAL(5) / 'FIXED_TIME_STEP' /

      DATA      LFIRST / .TRUE. /

      INTEGER   N, IDX, IN

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','TMLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','TMLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','TMLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('TM', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','TMLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('TM', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','TMLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     UGVECT
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UGVECT(U,MU,V,MV,NX,NY)

      REAL      U(MU,*),V(MV,*)

      CHARACTER CMSG*80
      LOGICAL   LMISS,LNRMAL,LMADA,LOK,LMSG,LEQRAT,
     +          LMISSP,LSMALL,LUNIT,LUMSG

      EXTERNAL  RUWGX,RUWGY

      SAVE


*     / GET INTERNAL PARAMETERS /

      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )
      CALL UGIGET('INDEX   ',INDEX )
      CALL UGLGET('LNRMAL  ',LNRMAL)
      CALL UGLGET('LEQRAT  ',LEQRAT)
      CALL UGLGET('LMSG    ',LMSG  )
      CALL UGLGET('LUNIT   ',LUNIT )
      CALL UGLGET('LUMSG   ',LUMSG )
      CALL UGIGET('ICENT   ',ICENT )
      CALL UGLGET('LMISSP  ',LMISSP)
      CALL UGIGET('ITYPE1  ',ITYPE1)
      CALL UGLGET('LSMALL  ',LSMALL)
      CALL UGRGET('RSMALL  ',RSMALL)
      CALL UGIGET('ITYPE2  ',ITYPE2)
      CALL UGRGET('RSIZEM  ',RSIZEM)
      CALL UGRGET('RSIZET  ',RSIZET)
      CALL UGRGET('XTTL    ',XTTL  )
      CALL UGIGET('IXINT   ',IXINT )
      CALL UGIGET('IYINT   ',IYINT )

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX,NY)

*     / CHECK INPUT DATA /

      LMADA=.TRUE.

      DO 10 J=1,NY,IYINT
        DO 15 I=1,NX,IXINT

          LOK=.NOT.(LMISS .AND. (U(I,J).EQ.RMISS .OR. V(I,J).EQ.RMISS))

*         / CHECK MIN & MAX /

          IF (LMADA) THEN
            IF (LOK) THEN
              RMAXU=U(I,J)
              RMINU=U(I,J)
              RMAXV=V(I,J)
              RMINV=V(I,J)
              LMADA=.FALSE.
            END IF
          ELSE
            IF (LOK) THEN
              IF (U(I,J).GT.RMAXU) THEN
                RMAXU=U(I,J)
              ELSE IF (U(I,J).LT.RMINU) THEN
                RMINU=U(I,J)
              END IF
              IF (V(I,J).GT.RMAXV) THEN
                RMAXV=V(I,J)
              ELSE IF (V(I,J).LT.RMINV) THEN
                RMINV=V(I,J)
              END IF
            END IF
          END IF

   15   CONTINUE
   10 CONTINUE

*     / WRITE MESSAGE IF MISSING OR ZERO FIELD /

      IF (LMADA .OR. (RMINU.EQ.0 .AND. RMAXU.EQ.0
     +          .AND. RMINV.EQ.0 .AND. RMAXV.EQ.0)) THEN

        IF (LMADA) THEN
          CMSG='MISSING FIELD.'
        ELSE
          CMSG='ZERO FIELD.'
        END IF
        CALL MSGDMP('W','UGVECT',CMSG)
        IF (LMSG) THEN
          CALL UZRGET('RSIZEC2',RSIZEZ)
          CALL UZRSET('RSIZEC2',RSIZET)
          CALL UXPTTL('B',2,'  ',XTTL)
          CALL UXPTTL('B',2,CMSG,XTTL)
          CALL UZRSET('RSIZEC2',RSIZEZ)
        END IF
        GO TO 100

      END IF

*     / CALCULATE NORMALIZATION FACTOR /

      IF (LNRMAL) THEN

        CALL SGQVPT(VXMN,VXMX,VYMN,VYMX)
        UE=(VXMX-VXMN)/(NX/IXINT)
        VE=(VYMX-VYMN)/(NY/IYINT)
        AU=RGNLE(UE/MAX(ABS(RMINU),ABS(RMAXU)))
        AV=RGNLE(VE/MAX(ABS(RMINV),ABS(RMAXV)))
        IF (LEQRAT) THEN
          AU=MIN(AU,AV)
          AV=MIN(AU,AV)
        END IF

      ELSE

        CALL UGRGET('XFACT1  ',XFACT1)
        CALL UGRGET('YFACT1  ',YFACT1)
        AU=XFACT1
        AV=YFACT1

      END IF

      CALL UGRSET('XFACT2  ',AU)
      CALL UGRSET('YFACT2  ',AV)

*     / DRAW UNIT VECTOR IF LUNIT /

      IF (LUNIT) THEN

        CALL UGUNIT

*       / WRITE UNIT VALUE IF LMUSG /

        IF (LUMSG) THEN

          CALL UGRGET('UXUNIT  ',UXUNIT)
          CALL UGRGET('UYUNIT  ',UYUNIT)
          CMSG='XUNIT =##########, YUNIT =##########'
          WRITE(CMSG( 8:17),'(1P,E10.3)') UXUNIT
          WRITE(CMSG(27:36),'(1P,E10.3)') UYUNIT
          CALL UZRGET('RSIZEC2',RSIZEZ)
          CALL UZRSET('RSIZEC2',RSIZET)
          CALL UXPTTL('B',2,'  ',XTTL)
          CALL UXPTTL('B',2,CMSG,XTTL)
          CALL UZRSET('RSIZEC2',RSIZEZ)

        END IF

*       / DRAW TITLE FOR UNIT VECTOR /

        CALL UGDUT

*     / WRITE SCALING FACTOR IF LMSG /

      ELSE IF (LMSG) THEN

        CMSG='XFACT =##########, YFACT =##########'
        WRITE(CMSG( 8:17),'(1P,E10.3)') AU
        WRITE(CMSG(27:36),'(1P,E10.3)') AV
        CALL UZRGET('RSIZEC2',RSIZEZ)
        CALL UZRSET('RSIZEC2',RSIZET)
        CALL UXPTTL('B',2,'  ',XTTL)
        CALL UXPTTL('B',2,CMSG,XTTL)
        CALL UZRSET('RSIZEC2',RSIZEZ)

      END IF

*     / DRAW VECTORS /

      CALL SZLAOP(1,INDEX)

      DO 25 J=1,NY,IYINT
        DO 20 I=1,NX,IXINT

          LOK=.NOT.(LMISS .AND. (U(I,J).EQ.RMISS .OR. V(I,J).EQ.RMISS))
          CALL STFTRF(RUWGX(I),RUWGY(J),VX0,VY0)

          IF (LOK) THEN

            VX1=VX0-U(I,J)*(ICENT+1)/2.0*AU
            VX2=VX0-U(I,J)*(ICENT-1)/2.0*AU
            VY1=VY0-V(I,J)*(ICENT+1)/2.0*AV
            VY2=VY0-V(I,J)*(ICENT-1)/2.0*AV
            R=SQRT((VX2-VX1)**2+(VY2-VY1)**2)
            IF (LSMALL .AND. R.LE.RSMALL) THEN
              CALL SGPMZV(1,VX0,VY0,ITYPE2,INDEX,RSIZEM)
            ELSE
              CALL SZLAZV(VX1,VY1,VX2,VY2)
            END IF

          ELSE

            IF (LMISSP) THEN
              CALL SGPMZV(1,VX0,VY0,ITYPE1,INDEX,RSIZEM)
            END IF

          END IF

   20   CONTINUE
   25 CONTINUE

      CALL SZLACL

  100 CONTINUE

      END

      PROGRAM UXYZ3

      PARAMETER( ID0=19960101, ND=90, RND=ND )

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( 0.0, RND, -90., 90. )
      CALL GRSVPT( 0.2, 0.8,  0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UCXACL( 'B', ID0, ND )
      CALL UCXACL( 'T', ID0, ND )

      CALL UYAXDV( 'L', 10., 30. )
      CALL UYAXDV( 'R', 10., 30. )
      CALL UYSTTL( 'L', 'LATITUDE', 0. )

      CALL UXMTTL( 'T', 'UCXACL/UYAXDV', 0. )

      CALL GRCLS

      END

      PROGRAM UXYZ1

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( -180., 180., -90., 90. )
      CALL GRSVPT(   0.2,  0.8,  0.3, 0.7 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UXAXDV( 'B', 10., 60. )
      CALL UXAXDV( 'T', 10., 60. )
      CALL UXSTTL( 'B', 'LONGITUDE', 0. )
      CALL UXSTTL( 'B', '<- WEST      EAST ->', 0. )

      CALL UYAXDV( 'L', 10., 30. )
      CALL UYAXDV( 'R', 10., 30. )
      CALL UYSTTL( 'L', 'LATITUDE', 0. )
      CALL UYSTTL( 'L', '<- SH    NH ->', 0. )

      CALL UXMTTL( 'T', 'UXAXDV/UYAXDV', 0. )

      CALL GRCLS

      END

!-------------------------------------------------
!     interface module of stpack
!-------------------------------------------------
      module st_interface
        interface
!--------------------------------------------------
!座標変換
        subroutine stftrf(ux,uy,vx,vy)  !正規化変換 
            real,      intent(in) :: ux  !UC の 座標
            real,      intent(in) :: uy
            real,      intent(out) :: vx !VC の 座標 
            real,      intent(out) :: vy
        end subroutine

        subroutine stitrf(vx,vy,ux,uy)   !逆変換            
            real,      intent(in) :: vx   !VC の 座標 
            real,      intent(in) :: vy
            real,      intent(out) :: ux  !UC の 座標
            real,      intent(out) :: uy
        end subroutine

        subroutine ststrf(lmap)
            logical,   intent(in) :: lmap     !地図投影関数を示すフラグ
        end subroutine

        subroutine stqtrf(lmap) !パラメタ問い合わせルーチン             
            logical,   intent(out) :: lmap     !地図投影関数を示すフラグ
        end subroutine
        !----------------------------
        subroutine stfpr2(vx,vy,rx,ry) !二次元透視変換  
            real,      intent(in) :: vx  !VC の座標
            real,      intent(in) :: vy
            real,      intent(out) :: rx !RC の座標
            real,      intent(out) :: ry
        end subroutine

        subroutine stipr2(rx,ry,vx,vy) !逆変換    
            real,      intent(in) :: rx        !RC の座標
            real,      intent(in) :: ry
            real,      intent(out) :: vx    !VC の座標
            real,      intent(out) :: vy
        end subroutine

        subroutine stspr2(ix,iy,sect) 
            integer,   intent(in) :: ix    !2次元のX軸とY軸を，3次元のどの軸に                      
            integer,   intent(in) :: iy    !対応させるか，番号で指定する
            real,      intent(in) :: sect     !2次元平面と交わる座標軸の交点座標
        end subroutine
        !----------------------------               
        subroutine stftr3(ux,uy,uz,vx,vy,vz) !3次元正規化変換 
            real,      intent(in) :: ux   !UC の座標
            real,      intent(in) :: uy
            real,      intent(in) :: uz
            real,      intent(out) :: vx  !VC の座標
            real,      intent(out) :: vy
            real,      intent(out) :: vz
        end subroutine
                !----------------------------
        subroutine stfpr3(vx,vy,vz,rx,ry) !三次元透視変換
            real,      intent(in) :: vx  !VC の座標
            real,      intent(in) :: vy
            real,      intent(in) :: vz
            real,      intent(out) :: rx !RC の座標
            real,      intent(out) :: ry
        end subroutine

        subroutine stspr3(xfc,yfc,zfc,theta,phi,psi,fac,zview,rxoff,ryoff)
            real,      intent(in) :: xfc   !焦点中心の座標                                                    
            real,      intent(in) :: yfc
            real,      intent(in) :: zfc
            real,      intent(in) :: theta !回転角                
            real,      intent(in) :: phi
            real,      intent(in) :: psi
            real,      intent(in) :: fac   !拡大縮小ファクター
            real,      intent(in) :: zview !視点のZ座標
            real,      intent(in) :: rxoff !オフセット
            real,      intent(in) :: ryoff
        end subroutine
        !----------------------------
        subroutine stfwtr(rx,ry,wx,wy) !ワークステーション変換 
            real,      intent(in) :: rx   !RC の座標                         
            real,      intent(in) :: ry
            real,      intent(out) :: wx  !WC の座標
            real,      intent(out) :: wy
        end subroutine

        subroutine stiwtr(wx,wy,rx,ry) 
            real,      intent(in) :: wx   !WC の座標
            real,      intent(in) :: wy
            real,      intent(out) :: rx  !RC の座標
            real,      intent(out) :: ry
        end subroutine
                              
        subroutine stswtr(rxmin,rxmax,rymin,rymax,wxmin,wxmax,wymin,wymax,iwtrf)  
            real,      intent(in) :: rxmin  !ワークステーションウインドウ
            real,      intent(in) :: rxmax
            real,      intent(in) :: rymin
            real,      intent(in) :: rymax
            real,      intent(in) :: wxmin !ワークステーションビューポート
            real,      intent(in) :: wxmax
            real,      intent(in) :: wymin
            real,      intent(in) :: wymax
            integer,   intent(in) :: iwtrf  !変換番号
        end subroutine
    
        subroutine stqwtr(rxmin,rxmax,rymin,rymax,wxmin,wxmax,wymin,wymax,iwtrf)
            real,      intent(out) :: rxmin  !ワークステーションウインドウ
            real,      intent(out) :: rxmax
            real,      intent(out) :: rymin
            real,      intent(out) :: rymax
            real,      intent(out) :: wxmin     !ワークステーションビューポート
            real,      intent(out) :: wxmax
            real,      intent(out) :: wymin
            real,      intent(out) :: wymax
            integer,   intent(out) :: iwtrf  !変換番号
        end subroutine
!-----------------------------------------------------------------------
!下請けルーチン
        subroutine stftrn(ux,uy,vx,vy)  !正規化変換
            real,      intent(in) :: ux  !UC の座標
            real,      intent(in) :: uy
            real,      intent(out) :: vx !VC の座標
            real,      intent(out) :: vy
        end subroutine

        subroutine stitrn(vx,vy,ux,uy)
            real,      intent(in) :: vx  !VC の座標
            real,      intent(in) :: vy
            real,      intent(out) :: ux !UC の座標
            real,      intent(out) :: uy
        end subroutine

        subroutine ststrn(itr,cxa,cya,vx0,vy0)
            integer,   intent(in) :: itr     !変換関数番号
            real,      intent(in) :: cxa     !座標値にかけるファクター
            real,      intent(in) :: cya
            real,      intent(in) :: vx0     !VC における原点の位置       
            real,      intent(in) :: vy0
        end subroutine
        !----------------------------------------
        subroutine stfrot(ux,uy,tx,ty)!        地図座標の回転
            real,      intent(in) :: ux  !VC の座標
            real,      intent(in) :: uy
            real,      intent(out) :: tx !TC の座標
            real,      intent(out) :: ty
        end subroutine

        subroutine stirot(tx,ty,ux,uy)
            real,      intent(in) :: tx  !TC の座標
            real,      intent(in) :: ty
            real,      intent(out) :: ux !VC の座標
            real,      intent(out) :: uy
        end subroutine

        subroutine stsrot(theta,phi,psi) !地図座標の回転パラメタ設定
            real,      intent(in) :: theta     !回転角       
            real,      intent(in) :: phi
            real,      intent(in) :: psi
        end subroutine
        !-------------------------------------------
        subroutine stfrad(ux1,uy1,ux2,uy2)  !角度の単位変換
            real,      intent(in) :: ux1    !UC の座標                                         
            real,      intent(in) :: uy1
            real,      intent(out) :: ux2    !UC の座標（常にラジアン）                         
            real,      intent(out) :: uy2
        end subroutine

        subroutine stirad(ux2,uy2,ux1,uy1)                    
            real,      intent(in) :: ux2    !UC の座標（常にラジアン）
            real,      intent(in) :: uy2
            real,      intent(out) :: ux1    !UC の座標
            real,      intent(out) :: uy1
        end subroutine

        subroutine stsrad(lxdeg,lydeg)  !角度の単位変換パラメタ設定 
            logical,   intent(in) :: lxdeg  !単位が「度」であることを示すフラグ
            logical,   intent(in) :: lydeg    
        end subroutine
        end interface
      end module
!  stpack library end ----

      PROGRAM U1D1

      PARAMETER( NMAX=51, XMIN=1945, XMAX=1995 )
      REAL Y(NMAX)

*-- データ ----
      Y0 = 0.5
      DO 10 N=1,NMAX
        Y(N) = 5.*Y0 + 10.
        Y0   = 3.7*Y0*(1.-Y0)
   10 CONTINUE

      CALL GLRGET( 'RUNDEF', RUNDEF )

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, RUNDEF, RUNDEF )
      CALL USSTTL( 'TIME', 'YEAR', 'TEMPERATURE', 'DEG' )
      CALL USGRPH( NMAX, RUNDEF, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
      PROGRAM UXYZ01


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL GRFRM

      CALL SGSWND( -180.0, +180.0, -90.0, +90.0 )
      CALL SGSVPT( 0.2, 0.8, 0.3, 0.7 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL UXAXDV( 'B', 10.0, 60.0 )
      CALL UXAXDV( 'T', 10.0, 60.0 )
      CALL UXSTTL( 'B', 'LONGITUDE', 0.0 )
      CALL UXSTTL( 'B', '<- WEST      EAST ->', 0.0 )

      CALL UYAXDV( 'L', 10.0, 30.0 )
      CALL UYAXDV( 'R', 10.0, 30.0 )
      CALL UYSTTL( 'L', 'LATITUDE', 0.0 )
      CALL UYSTTL( 'L', '<- SH    NH ->', 0.0 )

      CALL UXMTTL( 'T', 'UXAXDV/UYAXDV', 0.0 )

      CALL GRCLS

      END

      PROGRAM JUMP2

      PARAMETER ( NMAX=100 )
      REAL X(NMAX), Y(NMAX)

*-- データ ----
      R  = 0.2
      R0 = 0.0
      DO 10 I=1,NMAX
        R  = 3.6*R*(1.-R)
        R0 = R0 + R*4 - 2.58
        X2 = (I-50)**2
        REXP = 4.*I/NMAX
        X(I) = 10**REXP
        Y(I) = 1.E5*EXP(-X2) + 10.**R0
   10 CONTINUE
      Y(20) = 1.E4
      Y(40) = 2.E3
      Y(65) = 3.E4
      Y(70) = 5.E2

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( 1.E0, 1.E4, 1.E-1, 1.E6 )
      CALL GRSVPT(  0.2,  0.8,   0.2,  0.8 )
      CALL GRSTRN( 4 )
      CALL GRSTRF

      CALL USSTTL( 'FREQUENCY', '/s', 'POWER', 'm|2"/s|2"' )
      CALL USDAXS

      CALL UULIN( NMAX, X, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UETONB(Z,MX,NX,NY)

      REAL      Z(MX,*)

      INTEGER   NP(2),NI(2)
      REAL      XC(4),YC(4),ZC(4),AX(10),AY(10),TLM(2)
      LOGICAL   LMISS

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)

      EXTERNAL  RUWGX,RUWGY


*     / GET INTERNAL PARAMETERS /

      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )
      CALL SGIGET('ITR     ',ITR)

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX,NY)

*     / CHECK Z VALUES AND TONE LEVEL /

      CALL UEZCHK(Z,MX,NX,NY,'UETONB',ISTAT)
      IF (ISTAT.NE.0) RETURN

*     / SET TONE MODE (IRMODE) /

      CALL UWQGXB(UXMIN,UXMAX,NXZ)
      CALL UWQGYB(UYMIN,UYMAX,NYZ)

      IF (ITR.LT.4) THEN
        CALL STFTRF(UXMIN,UYMIN,VXMIN,VYMIN)
        CALL STFTRF(UXMAX,UYMAX,VXMAX,VYMAX)
        DX=VXMAX-VXMIN
        DY=VYMAX-VYMIN
      ELSE
        DX=UXMAX-UXMIN
        DY=UYMAX-UYMIN
      END IF

      IRMODE=0
      IF (DX.LT.0) IRMODE=MOD(IRMODE+1,2)
      IF (DY.LT.0) IRMODE=MOD(IRMODE+1,2)

      CALL SGISET('IRMODE', IRMODE)

*     / INITIALIZE /

      CALL UEAINT

*     / LOOP FOR EACH TONE PATTERN /

      DO 30 IT=1,NT

        CALL SZTNOP(IPT(IT))

*       / LOOP FOR EACH SECTION /

        DO 20 I=1,NX

          I0=I-1
          I1=I+1

          IF (I.EQ.1) THEN
            XC(1)=RUWGX(I)
          ELSE
            XC(1)=(RUWGX(I0)+RUWGX(I))/2.0
          END IF
          IF (I.EQ.NX) THEN
            XC(2)=RUWGX(I)
          ELSE
            XC(2)=(RUWGX(I)+RUWGX(I1))/2.0
          END IF
          XC(3)=XC(2)
          XC(4)=XC(1)

          DO 10 J=1,NY

            J0=J-1
            J1=J+1

            IF (Z(I,J).LT.TL1(IT)) GO TO 10
            IF (Z(I,J).GT.TL2(IT)) GO TO 10

            ZC(1)=Z(I,J)
            ZC(2)=Z(I,J)
            ZC(3)=Z(I,J)
            ZC(4)=Z(I,J)

            IF (LMISS .AND. NINDXR(ZC,4,1,RMISS).NE.0) GO TO 10

            IF (J.EQ.1) THEN
              YC(1)=RUWGY(J)
            ELSE
              YC(1)=(RUWGY(J0)+RUWGY(J))/2.0
            END IF
            IF (J.EQ.NY) THEN
              YC(3)=RUWGY(J)
            ELSE
              YC(3)=(RUWGY(J)+RUWGY(J1))/2.0
            END IF
            YC(2)=YC(1)
            YC(4)=YC(3)

            TLM(1)=TL1(IT)
            TLM(2)=TL2(IT)
            CALL UEAREA(XC,YC,ZC,TLM,AX,AY,NP,NI,NG)

            DO 40 N=1,NG
              CALL SZTNZU(NP(N),AX(NI(N)),AY(NI(N)))
   40       CONTINUE

   10     CONTINUE
   20   CONTINUE

        CALL SZTNCL

   30 CONTINUE

      END

*-----------------------------------------------------------------------
      PROGRAM UXYZ09

      PARAMETER ( ID0=19811201, ND=180, RND=ND )
      PARAMETER ( RLAT1=20, RLAT2=80, DLAT1=5, DLAT2=10 )


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL UZFACT( 0.7 )

      CALL GRFRM

      CALL SGSWND( 0.0, RND, RLAT1, RLAT2 )
      CALL SGSVPT( 0.2, 0.8, 0.4, 0.8 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SLPVPR( 1 )

      CALL UXSAXS( 'B' )
      CALL UCXACL( 'B', ID0, ND )
      CALL UXSAXS( 'B' )
      CALL UXAXDV( 'B', 10.0, 20.0 )
      CALL UXSTTL( 'B', 'DAY NUMBER', 0.0 )
      CALL UXSAXS( 'T' )
      CALL UCXACL( 'T', ID0, ND )

      CALL UYSAXS( 'L' )
      CALL UYAXDV( 'L', DLAT1, DLAT2 )
      CALL UYSAXS( 'R' )
      CALL UYAXDV( 'R', DLAT1, DLAT2 )
      CALL UYSTTL( 'L', 'LATITUDE', 0.0 )

      CALL UXMTTL( 'T', 'UXSAXS/UYSAXS', 0.0 )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     LOGICAL PARAMETER CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 26)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1)/'LCLIP   '/, LX( 1) / .FALSE. /
      DATA      CPARAS( 2)/'LCHAR   '/, LX( 2) / .FALSE. /
      DATA      CPARAS( 3)/'LLNINT  '/, LX( 3) / .FALSE. /
      DATA      CPARAS( 4)/'LGCINT  '/, LX( 4) / .TRUE. /
      DATA      CPARAS( 5)/'LSOFTF  '/, LX( 5) / .TRUE. /
      DATA      CPARAS( 6)/'LCL2TN  '/, LX( 6) / .FALSE. /
      DATA      CPARAS( 7)/'LCNTL   '/, LX( 7) / .FALSE. /
      DATA      CPARAS( 8)/'LFULL   '/, LX( 8) / .FALSE. /
      DATA      CPARAS( 9)/'LFPROP  '/, LX( 9) / .TRUE. /
      DATA      CPARAS(10)/'LROT    '/, LX(10) / .FALSE. /
      DATA      CPARAS(11)/'LBUFF   '/, LX(11) / .TRUE. /
      DATA      CPARAS(12)/'LCURV   '/, LX(12) / .TRUE. /
      DATA      CPARAS(13)/'LPROP   '/, LX(13) / .TRUE. /
      DATA      CPARAS(14)/'LUARW   '/, LX(14) / .TRUE. /
      DATA      CPARAS(15)/'LARROW  '/, LX(15) / .FALSE. /
      DATA      CPARAS(16)/'LATONE  '/, LX(16) / .FALSE. /
      DATA      CPARAS(17)/'LDEG    '/, LX(17) / .TRUE. /
      DATA      CPARAS(18)/'LCORNER '/, LX(18) / .FALSE. /
      DATA      CPARAS(19)/'LTITLE  '/, LX(19) / .TRUE. /
      DATA      CPARAS(20)/'LWIDE   '/, LX(20) / .FALSE. /
      DATA      CPARAS(21)/'LFGBG   '/, LX(21) / .FALSE. /
      DATA      CPARAS(22)/'L2TO3   '/, LX(22) / .FALSE. /
      DATA      CPARAS(23)/'LXLOG3  '/, LX(23) / .FALSE. /
      DATA      CPARAS(24)/'LYLOG3  '/, LX(24) / .FALSE. /
      DATA      CPARAS(25)/'LZLOG3  '/, LX(25) / .FALSE. /
      DATA      CPARAS(26)/'LMRKFNT '/, LX(26) / .TRUE. /

*     / LONG  NAME /

      DATA      CPARAL( 1) / 'ENABLE_CLIPPING' /
      DATA      CPARAL( 2) / 'ENABLE_LINE_LABELING' /
      DATA      CPARAL( 3) / 'ENABLE_LINEAR_INTERPOLATION' /
      DATA      CPARAL( 4) / 'ENABLE_GREATCIRCLE_INTERPOLATION' /
      DATA      CPARAL( 5) / 'ENABLE_SOFTFILL' /
      DATA      CPARAL( 6) / 'ENABLE_COLOR_SUBSTITUTION' /
      DATA      CPARAL( 7) / 'ENABLE_CONTROL_CHAR' /
      DATA      CPARAL( 8) / 'USE_FULL_WINDOW' /
      DATA      CPARAL( 9) / 'ENABLE_PROPORTIONAL_FONT' /
      DATA      CPARAL(10) / 'ENABLE_LINE_LABEL_ROTATION' /
      DATA      CPARAL(11) / 'ENABLE_LINE_BUFFERING' /
      DATA      CPARAL(12) / 'DISABLE_LINE_LABEL_AT_CURVE' /
      DATA      CPARAL(13) / 'FIX_ARROWHEAD_PROPORTION' /
      DATA      CPARAL(14) / 'ENABLE_ARROWHEAD_MAPPING' /
      DATA      CPARAL(15) / '----LARROW  ' /
      DATA      CPARAL(16) / 'ENABLE_ARROWHEAD_SHADE' /
      DATA      CPARAL(17) / 'USE_DEGREE' /
      DATA      CPARAL(18) / 'DRAW_CORNERMARK' /
      DATA      CPARAL(19) / 'DRAW_PAGE_TITLE' /
      DATA      CPARAL(20) / '****LWIDE   ' /
      DATA      CPARAL(21) / '****LFGBG   ' /
      DATA      CPARAL(22) / '****L2TO3   ' /
      DATA      CPARAL(23) / '++++LXLOG3  ' /
      DATA      CPARAL(24) / '++++LYLOG3  ' /
      DATA      CPARAL(25) / '++++LZLOG3  ' /
      DATA      CPARAL(26) / 'USE_DCLMARKER_FONT' /

      DATA      LFIRST/.TRUE./

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','SGLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','SGLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','SGLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('SG', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','SGLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('SG', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','SGLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

program line

  use dcl
  integer,parameter :: nmax = 40
  real,dimension(0:nmax) :: x,y1,y2,y3,y4,y5,y6

    x  = (/( n,n=0,nmax )/) / real(nmax) ! 0≦x≦1
    y1 = sin( 2.*DCL_PI * x ) + 1.5      ! y = sin(2πx)+C
    y2 = sin( 2.*DCL_PI * x ) + 1.0
    y3 = sin( 2.*DCL_PI * x ) + 0.5
    y4 = sin( 2.*DCL_PI * x ) - 0.5
    y5 = sin( 2.*DCL_PI * x ) - 1.0
    y6 = sin( 2.*DCL_PI * x ) - 1.5

!-- グラフ ----

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( 0., 1., -3., 3. )        ! ウィンドウの設定
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )   ! ビューポートの設定
    call DclSetTransFunction                    ! 正規変換の確定

    call DclDrawScaledAxis                      ! 座標軸を描く

    call DclDrawLine( x, y1 )                   ! 通常(type=1,index=1)
    call DclDrawLine( x, y2, index=5 )          ! 太さを変える
    call DclDrawLine( x, y3, index=21 )         ! 色を変える
    call DclDrawLine( x, y4, type=2 )           ! 線種を変える
    call DclDrawLine( x, y5, type=4, index=43 ) ! 全部変える

    call DclSetLineType( 3 )                    ! 前もって線種を指定
    call DclSetLineIndex( 30 )                  ! 前もって色を指定
    call DclDrawLine( x, y6 )

    call DclCloseGraphics

end program

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program marker

  use dcl
  integer,parameter :: n=41
  real :: x(n), y(n)

    dt = 4.* 3.14159 / (n-1)
    do i=1,n
      y(i) = sin(dt*(i-1))*0.15
      x(i) = real(i-1)/real(n-1)
    end do

    call DclOpenGraphics
    call DclNewFrame
    call DclSetWindow( 0.0, 1.0, -0.8, 0.2)
    call DclSetViewPort( 0.1, 0.9,  0.1, 0.9)
    call DclSetTransNumber( 1)
    call DclSetTransFunction

    call DclSetParm( 'ENABLE_CLIPPING', .true.)
    call DclDrawViewPortFrame(1)

    call DclDrawMarker(x, y)                    ! <-- マーカー描画 (1列目)
    call DclDrawMarker(x, y-0.1, type=2)        ! <-- マーカー描画 (2列目)
    call DclDrawMarker(x, y-0.2, type=3)        ! <-- マーカー描画 (3列目)
    call DclDrawMarker(x, y-0.3, type=2,height=0.06)! <-- マーカー描画 (4列目)
    call DclDrawMarker(x, y-0.4, index=2)       ! <-- マーカー描画 (5列目)
    call DclDrawMarker(x, y-0.5, index=3,type=2)! <-- マーカー描画 (6列目)
    call DclDrawLine(x, y-0.5)                  ! <-- 折れ線描画

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     USPACK DRAW X-AXIS (UNIFORM)                    DCL 5.0  95/09/04
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USXAXU(CXS)
      CHARACTER CXS*(*), CXFMT*8, CXUNIT*32
      CHARACTER CFMT0*8, CPOS*1, CXSUB*32, CSBLBL*32, CP*8
      LOGICAL   LAB1
      EXTERNAL  CSBLBL, LENZ

*---------------------------- PARAMETERS -------------------------------

      CALL USRGET('DXT',  DXT )
      CALL USRGET('DXL',  DXL )
      CALL USRGET('XFAC', XFAC)
      CALL USRGET('XOFF', XOFF)
      CALL USCGET('CXFMT',  CXFMT)
      CALL USCGET('CXUNIT', CXUNIT)

      IF(DXT.LE.0 .OR. DXL.LE.0)
     #   CALL MSGDMP('E', 'USXAXU', 'DXT OR DXL IS NEGATIVE.')

*-----------------------------------------------------------------------

      CALL SGQTRN(ITR)
      IF(.NOT.(ITR.EQ.1 .OR. ITR.EQ.2))
     #   CALL MSGDMP('E', 'USXAXU', 'INVALID TRANSFORMATION NUMBER.')
      CALL SGQWND(XMIN, XMAX, YMIN, YMAX)

      DXTA = DXT/XFAC
      DXLA = DXL/XFAC
      XMINA = (XMIN - XOFF) * XFAC
      XMAXA = (XMAX - XOFF) * XFAC
      CALL SGSWND(XMINA, XMAXA, YMIN, YMAX)
      CALL SGSTRF

*---------------------------- X-AXIS -----------------------------------

      CALL UXQFMT(CFMT0)
      CALL UXSFMT(CXFMT)
      NXS = MIN(LENZ(CXS), 2)

      DO 100 I=1, NXS
        CALL UXAXDV(CXS(I:I), DXTA, DXLA)
        CP = 'LABELX'//CXS(I:I)
        CALL UZLGET(CP, LAB1)
        IF(LAB1) THEN
          CXSUB = CSBLBL(XFAC, XOFF, CXUNIT)
          IF(LENZ(CXSUB).NE.0) THEN
            CALL USCGET('CXSPOS', CPOS)
            READ(CXFMT, '(T3,I1)') NDGT
            CALL USXSUB(CXS(I:I), CPOS, CXSUB, REAL(NDGT))
          ENDIF
        ENDIF
  100 CONTINUE

      CALL SGSWND(XMIN,  XMAX,  YMIN,  YMAX)
      CALL SGSTRF
      CALL UXSFMT(CFMT0)

      RETURN
      END

*-----------------------------------------------------------------------
*     UXPNUM : PLOT NUMBERS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPNUM(CSIDE,ISLCT,UX,N)

      PARAMETER (NCH=40,LCH=12)

      REAL      UX(*)
      CHARACTER CSIDE*1

      LOGICAL   LUXCHK
      CHARACTER CFMTZ*16,CH(NCH)*(LCH)


*     / CHECK ARGUMENTS /

      IF (.NOT.(LUXCHK(CSIDE))) THEN
        CALL MSGDMP('E','UXPNUM','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UXPNUM','''ISLCT'' IS INVALID.')
      END IF
      IF (N.LE.0) THEN
        CALL MSGDMP('E','UXPNUM','NUMBER OF POINTS IS INVALID.')
      ELSE IF (N.GT.NCH) THEN
        CALL MSGDMP('E','UXPNUM','WORKING AREA IS NOT ENOUGH.')
      END IF

*     / GENERATE CHARACTERS /

      CALL UZCGET('CXFMT', CFMTZ)
      DO 10 I=1,N
        CALL CHVAL(CFMTZ,UX(I),CH(I))
   10 CONTINUE

*     / UXPLBL CALL /

      CALL UXPLBL(CSIDE,ISLCT,UX,CH,LCH,N)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DCLFNT

      CHARACTER CH*3,USGI*3,CTTL*16


      CALL SWISTX('IWIDTH ',600)
      CALL SWISTX('IHEIGHT',600)

      CTTL='DCLFONT (#)'
      CALL SGIGET('IFONT',IFONT)
      CALL CHNGI(CTTL,'#',IFONT,'(I1)')
      CALL CLOWER(CTTL)
      CALL SWCSTX('TITLE',CTTL)

      CALL GLISTX('MAXMSG',0)
      CALL SGLSTX('LCORNER',.FALSE.)

      CALL GROPN(1)

      CALL SGLSET('LCNTL',.FALSE.)

      CALL SGFRM

      CALL SGSVPT(0.05,0.95,0.05,0.95)
      CALL SGSWND(0.0,16.0,0.0,16.0)
      CALL SGSTRN(1)
      CALL SGSTRF

      DO 10 I=0,16
        CALL SGLNZU(REAL(I),0.0,REAL(I),16.0,2)
        CALL SGLNZU(0.0,REAL(I),16.0,REAL(I),2)
   10 CONTINUE

      DO 15 I=0,255
        UX=I/16+0.5
        UY=16-MOD(I,16)-0.5
        CALL SGTXZU(UX,UY,USGI(I),0.035,0,0,3)
        UX=UX+0.48
        UY=UY+0.38
        WRITE(CH,'(I3)') I
        CALL SGTXZU(UX,UY,CH,0.01,0,+1,1)
   15 CONTINUE

      CALL SGCLS

      END

program multi

  use dcl

  character(len=7) :: ctxt = 'frame??'

    call DclOpenGraphics()

    call DclSetFrameMargin( 0.1, 0.1, 0.05, 0.05 )
    call DclDivideFrame( 'y', 3, 2 )
    call DclSetFrameMargin( 0.05, 0.05, 0.05, 0.05 )

    do i=1,12
      call DclNewFrame
      call DclSetViewPort( 0.1,0.9,0.1,0.9 )
      call DclDrawViewPortFrame( 1 )
      write(ctxt(6:7),'(i2.2)') i
      call DclDrawTextNormalized( 0.5, 0.5, ctxt )
    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
      PROGRAM UXYZ07


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL GRFRM

      CALL SGSWND( 1985.0, 1990.0, -2.0, +2.0 )
      CALL SGSVPT( 0.2, 0.8, 0.3, 0.7 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL UZRSET( 'UYUSER', 0.0 )
      CALL UZLSET( 'LBTWN', .TRUE. )
      CALL UXSFMT( '(I4)' )
      CALL UXAXDV( 'U', 0.25, 1.0 )
      CALL UZLSET( 'LBTWN', .FALSE. )
      CALL UXSTTL( 'U', 'YEAR', +1.0 )

      CALL UYAXDV( 'L', 0.25, 1.0 )
      CALL UYSTTL( 'L', 'S.O.I.', 0.0 )

      CALL UXMTTL( 'T', 'UXAXDV/UYAXDV', 0.0 )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     BASIC ROUTINES
*-----------------------------------------------------------------------
*     UMSPCT : CONTACT POINT MODE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMSPCT

      COMMON    /UMWK1/ITR, RUNDEF, IUNDEF, PI, CPR, CPD, CP

      SAVE


      CALL SGQMPL(PLX, PLY, PLROT)
      IF (PLX.NE.RUNDEF .AND. PLY.NE. RUNDEF .AND.
     +    PLROT.NE.RUNDEF ) RETURN

      CALL UMQCNT(XCTCT, YCTCT, ROT)
      IF (XCTCT .EQ. RUNDEF .OR. YCTCT.EQ.RUNDEF .OR.
     +      ROT .EQ. RUNDEF ) RETURN

      XCTCTZ = XCTCT/CPR
      YCTCTZ = YCTCT/CPR
      ROTZ   = ROT/CPR

*--------------------- CYLINDRICAL PROJECTION --------------------------

      IF (10.LE.ITR .AND. ITR.LE.19) THEN
        IF (ROTZ .NE. 0.) THEN
          A = PI/2. - YCTCTZ
          C = ACOS(SIN(A)*COS(ROTZ))
          ALPH = SIGN(ACOS(COS(A)/SIN(C)), ROTZ)
          BETA = SIGN(ACOS(-COS(ALPH)*COS(ROTZ)), ROTZ)

          PLX = (XCTCTZ-BETA)*CPR
          PLY = (PI/2.- C)*CPR
          PLROT = (PI-ALPH)*CPR

        ELSE
          PLY = PI/2.*CPR - ABS(YCTCT)
          IF (YCTCT.LE.0) THEN
            PLX = XCTCT
            PLROT =  0
          ELSE
            PLX = XCTCT + PI*CPR
            PLROT = - PI*CPR
          END IF
        END IF

*----------------------- CONICAL PROJECTION ----------------------------

      ELSE IF (20.LE.ITR .AND. ITR.LE.24) THEN
        CALL SGRGET('STLAT1', ST1)
        IF (ITR.EQ.22) THEN
          CALL SGRGET('STLAT2', ST2)
          IF (ST1 .EQ. RUNDEF) THEN
            ST1 = MAX(YCTCT-5.*CPD, -PI/2.)
            CALL SGRSET('STLAT1', ST1)
          END IF
          IF (ST2 .EQ. RUNDEF) THEN
            ST2 = MIN(YCTCT+5.*CPD, PI/2.)
            CALL SGRSET('STLAT2', ST2)
          END IF
          YC = (ST1+ST2)/2./CPR
        ELSE
          IF (ST1 .EQ. RUNDEF) THEN
            ST1 = YCTCT
            CALL SGRSET('STLAT1', ST1)
          END IF
          YC = ST1/CPR
        END IF
        IF (YC .EQ. 0)
     +    CALL MSGDMP('E', 'UMSCNT', 'INVALID STANDARD LATITUDE')

        IF (ROT .NE. 0.) THEN
          A = PI/2. - YCTCTZ
          B = PI/2. - YC
          C = ACOS(COS(A)*COS(B) + SIN(A)*SIN(B)*COS(ROTZ))
          ALPH = SIGN(ACOS((COS(A)-COS(C)*COS(B))/(SIN(C)*SIN(B))),ROTZ)
          BETA = SIGN(ACOS((COS(B)-COS(C)*COS(A))/(SIN(C)*SIN(A))),ROTZ)

          PLX = (XCTCTZ-BETA)*CPR
          PLY = (PI/2.- C)*CPR
          PLROT = (PI-ALPH)*CPR

        ELSE
          PLX = XCTCT
          PLY =   90.*CPD
          PLROT =  0.*CPD
        END IF

*---------------------- AZIMUTHAL PROJECTION ---------------------------

      ELSE IF (30.LE.ITR .AND. ITR.LE.34) THEN
        PLX = XCTCT
        PLY = YCTCT
        PLROT = ROT
      ELSE
        CALL MSGDMP('E', 'UMSCNT', 'INVALID ITR')
      END IF

      CALL SGSMPL(PLX, PLY, PLROT)

      END

!-------------------------------------------------
!interface module of randlib
!-------------------------------------------------
module ran_interface
  interface

    function rngu0(iseed)                         !一様乱数．システムルーチンを使用する
      integer,   intent(inout) :: iseed              !乱数の種
      real rngu0                                  !一様乱数
    end function
      
    function rngu1(iseed)                         !一様乱数．混合合同法
      integer,   intent(inout) :: iseed              !乱数の種
      real rngu1                                  !一様乱数．
    end function
      
    function rngu2(iseed)                         !一様乱数．混合合同法+シャッフル
      integer,   intent(inout) :: iseed              !乱数の種
      real rngu2                                  !一様乱数．
    end function
      
    function rngu3(iseed)                         !一様乱数．numerical recipes の ran3
      integer,   intent(inout) :: iseed              !乱数の種
      real rngu3                                  !一様乱数．
    end function

  end interface
end module
!randlib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SCPKT8

      PARAMETER( NX=37 )
      PARAMETER(  XMIN=   0,  XMAX=360,  YMIN=0,  YMAX= 180 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )

      REAL ALON(NX), ALAT(NX), R(NX), A(NX)


      DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
        ALAT(I) = YMIN + (YMAX-YMIN)*(I-1)/(NX-1)
        R   (I) = 1.
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM
      CALL SGLSET('LDEG', .TRUE.)

*---------------- 3-D ------------------

      CALL SCSORG(1., 0., 0., 0.)
      CALL SCSTRN(3)
      CALL SCSTRF

      CALL SCSEYE(  5., 1.,  2. )
      CALL SCSOBJ(  0.0,  0.0,  0.0 )
      CALL SCSPRJ

      CALL SCSPMT(10)
      CALL SCSPMI(1)
      CALL SCSPMS(.01)
      DO 100 I=1, NX
        DO 110 J=1, NX
          A(J) = ALAT(I)
  110   CONTINUE
        CALL SCPLU(NX, R, A, ALON)
        CALL SCPMU(NX, R, A, ALON)
  100 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     TEXT PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTXU(UX,UY,CHARS)

      CHARACTER CHARS*(*)

      SAVE

      DATA      RSIZEZ/0.05/,IROTAZ/0/,ICENTZ/0/,INDEXZ/1/


      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SGTXU','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SGTXU','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENTZ .AND. ICENTZ.LE.1)) THEN
        CALL MSGDMP('E','SGTXU','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGTXU','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGTXU','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL SZTXOP(RSIZEZ,IROTAZ,ICENTZ,INDEXZ)
      CALL SZTXZU(UX,UY,CHARS)
      CALL SZTXCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTXV(VX,VY,CHARS)

      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SGTXV','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SGTXV','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENTZ .AND. ICENTZ.LE.1)) THEN
        CALL MSGDMP('E','SGTXV','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGTXV','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGTXV','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL SZTXOP(RSIZEZ,IROTAZ,ICENTZ,INDEXZ)
      CALL SZTXZV(VX,VY,CHARS)
      CALL SZTXCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGTXR(RX,RY,CHARS)

      IF (RSIZEZ.EQ.0) THEN
        CALL MSGDMP('M','SGTXR','TEXT HEIGHT IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZEZ.LT.0) THEN
        CALL MSGDMP('E','SGTXR','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENTZ .AND. ICENTZ.LE.1)) THEN
        CALL MSGDMP('E','SGTXR','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SGTXR','TEXT INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SGTXR','TEXT INDEX IS LESS THAN 0.')
      END IF

      CALL SZTXOP(RSIZEZ,IROTAZ,ICENTZ,INDEXZ)
      CALL SZTXZR(RX,RY,CHARS)
      CALL SZTXCL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSTXS(RSIZE)

      RSIZEZ=RSIZE

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQTXS(RSIZE)

      RSIZE=RSIZEZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSTXR(IROTA)

      IROTAZ=IROTA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQTXR(IROTA)

      IROTA=IROTAZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSTXC(ICENT)

      ICENTZ=ICENT

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQTXC(ICENT)

      ICENT=ICENTZ

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGSTXI(INDEX)

      INDEXZ=INDEX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQTXI(INDEX)

      INDEX=INDEXZ

      RETURN
      END

*-----------------------------------------------------------------------
*     UWDFLT
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UWDFLT(NX,NY)

      LOGICAL   LSET


*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)

      CALL UWQGXZ(LSET)
      IF (.NOT.LSET) THEN
        CALL UWSGXB(UXMN,UXMX,NX)
        CALL UWSGXZ(.FALSE.)
      END IF

      CALL UWQGYZ(LSET)
      IF (.NOT.LSET) THEN
        CALL UWSGYB(UYMN,UYMX,NY)
        CALL UWSGYZ(.FALSE.)
      END IF

      END

*-----------------------------------------------------------------------
*     BITPCI
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE BITPCI(CP,IP)

      CHARACTER CP*(*)

      PARAMETER (NB=32)

      INTEGER   MASK(NB)
      LOGICAL   LFST

      SAVE

      EXTERNAL  ISHIFT

      DATA      LFST/.TRUE./


      IF (LFST) THEN
        CALL GLIGET('NBITSPW',NBITPW)
        IF (NBITPW.NE.NB) THEN
          CALL MSGDMP('E','BITPCI',
     +      'NUMBER OF BITS PER ONE WORD IS INVALID / '//
     +      'CHECK NB IN THE PARAMETER STATEMENT OF BITPCI '//
     +      'AND CHANGE IT CORRECTLY.')
        END IF
        MASK(1)=1
        DO 10 I=2,NB
          MASK(I)=ISHIFT(MASK(I-1),1)
   10   CONTINUE
        LFST=.FALSE.
      END IF

      NBC=LEN(CP)
      IP=0
      DO 15 I=1,MIN(NBC,NB)
        II=NBC-I+1
        IF (CP(II:II).NE.'0') THEN
          IP=IP+MASK(I)
        END IF
   15 CONTINUE

      END

*-----------------------------------------------------------------------
*     UCPQNP / UCPQID / UCPQCP / UCPQVL / UCPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 5)

      INTEGER   ITYPE(NPARA)
      LOGICAL   LCHREQ
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'NDAY    ' /, ITYPE( 1) / 1 /
      DATA      CPARAS( 2) / 'NCHAR   ' /, ITYPE( 2) / 1 /
      DATA      CPARAS( 3) / 'LOWER   ' /, ITYPE( 3) / 2 /
      DATA      CPARAS( 4) / 'DFACT   ' /, ITYPE( 4) / 3 /
      DATA      CPARAS( 5) / 'IUNDEF  ' /, ITYPE( 5) / 1 /

*     / LONG  NAME /

      DATA      CPARAL( 1) / 'DAY_INTERVAL' /
      DATA      CPARAL( 2) / 'MONTH_NAME_LENGTH' /
      DATA      CPARAL( 3) / 'MONTH_NAME_LOWER'  /
      DATA      CPARAL( 4) / '****DFACT' /
      DATA      CPARAL( 5) / '----IUNDEF' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG='PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UCPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UCPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UCPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','UCPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UCIQID(CPARAS(IDX), ID)
          CALL UCIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UCLQID(CPARAS(IDX), ID)
          CALL UCLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UCRQID(CPARAS(IDX), ID)
          CALL UCRQVL(ID, IPARA)
        END IF
      ELSE
         CALL MSGDMP('E','UCPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UCIQID(CPARAS(IDX), ID)
          CALL UCISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UCLQID(CPARAS(IDX), ID)
          CALL UCLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UCRQID(CPARAS(IDX), ID)
          CALL UCRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UCPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*---------------------------------------------------------------
      SUBROUTINE UIPCMP(XMIN,XMAX,YMIN,YMAX,CPOS)
      CHARACTER*(*) CPOS

      REAL  U(2,2),V(2,2)
      LOGICAL LCX, LCY,LEM

      CALL UIQCR2(U1, U2, V1, V2)

      U(1,1) = U1
      U(1,2) = U1
      U(2,1) = U2
      U(2,2) = U2

      V(1,1) = V1
      V(1,2) = V2
      V(2,1) = V1
      V(2,2) = V2

      CALL GRFIG
      CALL SGSTRN( 1 )
      CALL SGSVPT( XMIN,  XMAX, YMIN,  YMAX )
      CALL SGSWND( U1,  U2,  V1,  V2 )
      CALL SGSTRF

      CALL UILGET('CELL_MODE_X', LCX)
      CALL UILGET('CELL_MODE_Y', LCY)
      CALL UILGET('EMBOSS     ', LEM)

      CALL UILSET('CELL_MODE_X', .FALSE.)
      CALL UILSET('CELL_MODE_Y', .FALSE.)
      CALL UILSET('EMBOSS     ', .FALSE.)

      CALL UWSGXB(U1, U2, 2)
      CALL UWSGYB(V1, V2, 2)
      CALL UIPDA2(U,V,2,2,2)
      CALL SLPVPR(3)
      CALL USDAXS

      CALL UILSET('CELL_MODE_X', LCX)
      CALL UILSET('CELL_MODE_Y', LCY)
      CALL UILSET('EMBOSS     ', LEM)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGPK09

      PARAMETER ( KMAX=4, NN=73 )
      PARAMETER ( DD=2.0, PI=3.141592 )

      REAL      XORG(KMAX), YORG(KMAX), UX(NN), UY(NN)

      DATA      XORG / 2.5, 7.5, 2.5, 7.5 /
      DATA      YORG / 7.5, 7.5, 2.5, 2.5 /


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN( IWS )

      CALL SGFRM

      CALL SGSWND( 0.0, 10.0, 0.0, 10.0 )
      CALL SGSVPT( 0.0, 1.0, 0.0, 1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGSTXS( 0.03 )
      CALL SGSTXI( 3 )
      CALL SGSTXC( 0 )

      CALL SGSPLC( 'K=1' )

      DO 20 K = 1, KMAX

        CALL SGSLNI( 1 )
        CALL SGLNU( XORG(K)-DD, YORG(K), XORG(K)+DD, YORG(K) )
        CALL SGLNU( XORG(K), YORG(K)-DD, XORG(K), YORG(K)+DD )

        DO 10 I = 1, NN
          TH = 2*PI*(I-1)/(NN-1)
          UX(I) = XORG(K) + DD*COS(TH+(K-1)*PI/7)
          UY(I) = YORG(K) + DD*SIN(K*TH)
   10   CONTINUE

        CALL SGSPLI( 2 )
        CALL SGSPLT( K )
        CALL SGLSET( 'LCHAR', .TRUE. )
        CALL SGPLU( NN, UX, UY )
        CALL SGLSET( 'LCHAR', .FALSE. )
        CALL SGNPLC

   20 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UDGCLA
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UDGCLA(XMIN,XMAX,DX)

      CHARACTER CLABZ*8
      LOGICAL   LDASH,LABEL

      EXTERNAL  RGNGE,IRLE,IRGE,IMOD


      IF (.NOT.(XMIN.LT.XMAX)) THEN
        CALL MSGDMP('E','UDGCLA','XMIN SHOULD BE LEAST THAN XMAX.')
      END IF

      CALL UDIGET('INDXMJ  ',IDXMJ )
      CALL UDIGET('INDXMN  ',IDXMN )
      CALL UDLGET('LDASH   ',LDASH )
      CALL UDLGET('LABEL   ',LABEL )
      CALL UDIGET('ICYCLE  ',ICYCL )
      CALL UDIGET('ISOLID  ',ISOLID)
      CALL UDIGET('IDASH   ',IDASH )
      CALL UDIGET('NLEV    ',NLEV  )
      CALL UDRGET('RSIZEL  ',RSIZE )

      IF (DX.GT.0) THEN
        DZ=DX
      ELSE IF (DX.EQ.0) THEN
        DZ=RGNGE((XMAX-XMIN)/NLEV)
      ELSE
        NL=MAX(1,NINT(ABS(DX)))
        DZ=RGNGE((XMAX-XMIN)/NL)
      END IF

      ZMIN=IRGE(XMIN/DZ)*DZ
      ZMAX=IRLE(XMAX/DZ)*DZ
      N=NINT((ZMAX-ZMIN)/DZ)+1
      IOFST=IMOD(NINT(ZMIN/DZ),ICYCL)

      CALL UDICLV

      DO 10 I=1,N

*       / CONTOUR LEVEL /

        ZLEV=DZ*NINT((ZMIN+(I-1)*DZ)/DZ)

        CALL UDLABL(ZLEV,CLABZ)

        IF (MOD(I+IOFST-1,ICYCL).EQ.0) THEN

*         / MAJOR LINE /

          INDX=IDXMJ
          IF (LABEL) THEN
            HL=RSIZE
          ELSE
            HL=0
          END IF

        ELSE

*         / MINOR LINE /

          INDX=IDXMN
          HL=0

        END IF

*       / DASH OPTION FOR NEGATIVE CONTOUR LEVEL /

        IF (LDASH .AND. ZLEV.LT.0) THEN
          ITYP=IDASH
        ELSE
          ITYP=ISOLID
        END IF

*       / SET CONTOUR LEVEL /

        CALL UDSCLV(ZLEV,INDX,ITYP,CLABZ,HL)

   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USXINZ(CSA, FACA, OFFA)
      CHARACTER CSA, CS, CPOS
      CHARACTER*32  CSBLBL, CTTL, CTITLE, CUNIT, CSUB
      CHARACTER*16  CMIN, CMAX, CFMT0, CFMT1
      LOGICAL LOFF, LSUB, LABEL

      SAVE OFF0, FAC0, OFF1, FAC1, CFMT0, CFMT1, CS, FACTOR, OFFSET

      CALL GLRGET('RUNDEF',  RUNDEF)

      CS = CSA
      CALL UZRGET('ROFFX'//CS,ROFF)
      CALL UZRGET('ROFGX'//CS,ROFG)
      IF (ROFF.NE.ROFG)  CALL UXSAXS(CS)

      CALl UZRGET('RSIZEL1', SIZEL)
      CALL USRSET('SOFFX'//CS//'R',  SIZEL*0.86)
      CALL USRSET('SOFFX'//CS//'L', -SIZEL*0.86)

      CALL UZLGET('LOFFSET', LOFF)
      IF(LOFF) THEN
        CALL UZRGET('XOFFSET', OFF0)
        CALL UZRGET('XFACT',   FAC0)
      ELSE
        OFF0 = 0.
        FAC0 = 1.
      END IF

      CALL USRGET('XOFF',  OFF1)
      CALL USRGET('XFAC',  FAC1)
      IF(OFF1.EQ.RUNDEF) OFF1 = 0.
      IF(FAC1.EQ.RUNDEF) FAC1 = 1.
      OFFA = OFF1
      FACA = FAC1

      FACTOR = FAC0/FAC1
      OFFSET = (OFF0-OFF1)/FAC1
      CALL UZLSET('LOFFSET', .TRUE.)
      CALL UZRSET('XOFFSET', OFFSET)
      CALL UZRSET('XFACT',   FACTOR)

      CALL UZCGET('CXFMT', CFMT0)
      CALL USCGET('CXFMT', CFMT1)
      IF(CFMT1 .EQ. ' ') CFMT1 = CFMT0
      CALL UZCSET('CXFMT', CFMT1)

      RETURN
*-------------------------------------------------------------
      ENTRY USXTLZ

      CALL SGQWND(XMIN,XMAX,YMIN,YMAX)

      CALL UZLGET('LABELX'//CS, LABEL)
      CALL USCGET('CXUNIT', CUNIT)
      CALL USCGET('CXTTL ', CTTL)

      IF(LABEL) THEN
        CSUB = CSBLBL(FAC1, OFF1, CUNIT)
        CALL USLGET('LXSUB', LSUB)
        IF(LENZ(CSUB).NE.0) THEN
          IF(LSUB) THEN
            CALL CHVAL(CFMT1,XMIN*FACTOR+OFFSET,CMIN)
            CALL CHVAL(CFMT1,XMAX*FACTOR+OFFSET,CMAX)
            RLEN = MAX(LENZ(CMIN), LENZ(CMAX))

            CALL USCGET('CXSPOS', CPOS)
            CALL USXSUB(CS, CPOS, CSUB, RLEN)
            CTITLE = CTTL
          ELSE
            NLT = LENZ(CTTL)
            CTITLE = CTTL(1:NLT+1) // CSUB
          ENDIF
        ELSE
          CTITLE = CTTL
        ENDIF

        CALL CLADJ(CTITLE)
        IF(LENZ(CTITLE).NE.0) CALL UXSTTL(CS, CTITLE, 0.)
      ENDIF

      CALL UZRSET('XOFFSET', OFF0)
      CALL UZRSET('XFACT',   FAC0)
      CALL UZCSET('CXFMT',   CFMT0)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM MAP3D2

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL P(NX,NY)

      DO 10 J=1,NY
      DO 10 I=1,NX
        ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
        ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
        SLAT = SIN(ALAT)
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SGLSET( 'LSOFTF', .FALSE. )
      CALL GRFRM

      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL SGSSIM( 0.4, 0., 0. )
      CALL SGSMPL( 135., 35., 0. )
      CALL SGSTXY( -180., 180., 0., 90. )
      CALL SGSTRN( 30 )
      CALL SGSTRF

      DO 20 K=-5,3
        TLEV1 = 0.4*K
        TLEV2 = TLEV1 + 0.4
        IF(K.LE.-1) THEN
          IPAT = 600 + ABS(K+1)
        ELSE
          IPAT =  30 + K
        END IF
        CALL UESTLV( TLEV1, TLEV2, IPAT )
   20 CONTINUE

      CALL UETONE( P, NX, NX, NY )

      CALL UDGCLB( P, NX, NX, NY, 0.4 )
      CALL UDCNTR( P, NX, NX, NY )

      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     USPACK SET POINTS                             S.Sakai    95/03/02
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USSPNT(N, X, Y)
      REAL  X(*), Y(*)
      REAL  XMIND(2), XMAXD(2), YMIND(2), YMAXD(2)

      CALL GLRGET('RUNDEF', RUNDEF)

*---------------------------- XMAX/XMIN --------------------------------

      IF( X(1) .NE. RUNDEF ) THEN
        CALL USRGET('XDTMIN', XMIND(1))
        CALL USRGET('XDTMAX', XMAXD(1))
        XMIND(2) = RMIN(X,N,1)
        XMAXD(2) = RMAX(X,N,1)

        IF(XMIND(1).NE.RUNDEF) THEN
          XDTMIN = RMIN(XMIND,2,1)
          XDTMAX = RMAX(XMAXD,2,1)
        ELSE
          XDTMIN = XMIND(2)
          XDTMAX = XMAXD(2)
        ENDIF
        CALL USRSET('XDTMIN', XDTMIN)
        CALL USRSET('XDTMAX', XDTMAX)
      ENDIF

*---------------------------- YMAX/YMIN --------------------------------

      IF( Y(1) .NE. RUNDEF ) THEN
        CALL USRGET('YDTMIN', YMIND(1))
        CALL USRGET('YDTMAX', YMAXD(1))
        YMIND(2) = RMIN(Y,N,1)
        YMAXD(2) = RMAX(Y,N,1)

        IF(YMIND(1).NE.RUNDEF) THEN
          YDTMIN = RMIN(YMIND,2,1)
          YDTMAX = RMAX(YMAXD,2,1)
        ELSE
          YDTMIN = YMIND(2)
          YDTMAX = YMAXD(2)
        ENDIF
        CALL USRSET('YDTMIN', YDTMIN)
        CALL USRSET('YDTMAX', YDTMAX)
      ENDIF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM GRPK01


*     WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
*     CALL SGPWSN
*     READ (*,*) IWS
      IWS=1

      CALL GROPN(IWS)
      CALL GRFRM

      CALL GRSWND(0.0, 1.0, -0.7, 0.7)
      CALL GRSVPT(0.2, 0.8,  0.2, 0.6)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL USSTTL('X-AXIS', ' ', 'Y1-AXIS', ' ')
      CALL USDAXS
      CALL SGTXZU(0.5, 0.0, 'PAGE:1, FRAME:1', 0.02, 0, 0, 3)

      CALL GRFIG

      CALL GRSWND(0.0, 1.0, -0.5, 0.5)
      CALL GRSVPT(0.2, 0.8, 0.62, 0.82)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL UZLSET('LABELXB', .FALSE.)
      CALL USSTTL('X-AXIS', ' ', 'Y2-AXIS', ' ')
      CALL USDAXS
      CALL SGTXZU(0.5, 0.0, 'PAGE:1, FRAME:2', 0.02, 0, 0, 3)
      CALL UZLSET('LABELXB', .TRUE.)

      CALL GRFRM

      CALL UZFACT(0.5)

      CALL GRSWND(0.0, 1.0, -0.7, 0.7)
      CALL GRSVPT(0.2, 0.8,  0.2, 0.6)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL USSTTL('X-AXIS', ' ', 'Y1-AXIS', ' ')
      CALL USDAXS
      CALL SGTXZU(0.5, 0.0, 'PAGE:2, FRAME:1', 0.02, 0, 0, 3)

      CALL GRFIG

      CALL GRSWND(0.0, 1.0, -0.5, 0.5)
      CALL GRSVPT(0.2, 0.8, 0.62, 0.82)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL UZLSET('LABELXB', .FALSE.)
      CALL USSTTL('X-AXIS', ' ', 'Y2-AXIS', ' ')
      CALL USDAXS
      CALL SGTXZU(0.5, 0.0, 'PAGE:2, FRAME:2', 0.02, 0, 0, 3)
      CALL UZLSET('LABELXB', .TRUE.)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TEST08

      EXTERNAL  ISGTRC


      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGLSET('LFULL', .TRUE.)
      CALL GROPN(IWS)
      CALL SLRAT(1., 0.6)
      CALL GRFRM

      CALL GRSMPL(140., 90., 0.)
      CALL GRSTRN(ISGTRC('HMR'))
      CALL UMPFIT
      CALL GRSTRF
      CALL UMPGLB
 
      CALL UMISET('INDEXOUT',3)
      CALL UMPMAP('coast_world')
      CALL UMISET('INDEXOUT',30)
      CALL UMPMAP('border_world')
      CALL UMISET('INDEXOUT',20)
      CALL UMPMAP('plate_world')

      CALL GRCLS

      END

!-------------------------------------------------
!  RFAlib Module
!-------------------------------------------------
module rfalib
  use dcl_common
  contains

    function DclGetAVE(x)                        !平均を求める
      real, intent(in), dimension(:) :: x
      real                           :: DclGetAVE

      call prcopn('DclGetAVE')
      DclGetAVE = rave(x,size(x),1)
      call prccls('DclGetAVE')
    end function
      
    function DclGetVAR(x)                        !分散を求める
      real, intent(in), dimension(:) :: x
      real                           :: DclGetVAR

      call prcopn('DclGetVAR')
      DclGetVAR = rvar(x,size(x),1)
      call prccls('DclGetVAR')
    end function
      
    function DclGetSTD(x)                        !標準偏差を求める
      real, intent(in), dimension(:) :: x
      real                           :: DclGetSTD

      call prcopn('DclGetSTD')
      DclGetSTD = rstd(x,size(x),1)
      call prccls('DclGetSTD')
    end function
      
    function DclGetRMS(x)                        !root mean squareを求める
      real, intent(in), dimension(:) :: x
      real                           :: DclGetRMS

      call prcopn('DclGetRMS')
      DclGetRMS = rrms(x,size(x),1)
      call prccls('DclGetRMS')
    end function
      
    function DclGetAMP(x)                        !大きさ (（Σ x^2)^1/2 ) を求める
      real, intent(in), dimension(:) :: x
      real                           :: DclGetAMP

      call prcopn('DclGetAMP')
      DclGetAMP = ramp(x,size(x),1)
      call prccls('DclGetAMP')
    end function
end module

*-----------------------------------------------------------------------
*     USPACK DRAW Y-AXIS (UNIFORM)                     DCL 5.0 95/09/04
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USYAXU(CYS)
      CHARACTER CYS*(*), CYFMT*8, CYUNIT*32
      CHARACTER CFMT0*8, CPOS*1, CYSUB*32, CSBLBL*32, CP*8
      LOGICAL   LAB1
      EXTERNAL  CSBLBL, LENZ

*---------------------------- PARAMETERS -------------------------------

      CALL USRGET('DYT',  DYT )
      CALL USRGET('DYL',  DYL )
      CALL USRGET('YFAC', YFAC)
      CALL USRGET('YOFF', YOFF)
      CALL USCGET('CYFMT',  CYFMT)
      CALL USCGET('CYUNIT', CYUNIT)

      IF(DYT.LE.0 .OR. DYL.LE.0)
     #   CALL MSGDMP('E', 'USYAXU', 'DYT OR DYL IS NEGATIVE.')

*-----------------------------------------------------------------------

      CALL SGQTRN(ITR)
      IF(.NOT.(ITR.EQ.1 .OR. ITR.EQ.3))
     #   CALL MSGDMP('E', 'USYAXU', 'INVALID TRANSFORMATION NUMBER.')
      CALL SGQWND(XMIN, XMAX, YMIN, YMAX)

      DYTA = DYT/YFAC
      DYLA = DYL/YFAC
      YMINA = (YMIN - YOFF) * YFAC
      YMAXA = (YMAX - YOFF) * YFAC
      CALL SGSWND(XMIN, XMAX, YMINA, YMAXA)
      CALL SGSTRF

*---------------------------- Y-AXIS -----------------------------------

      CALL UYQFMT(CFMT0)
      CALL UYSFMT(CYFMT)
      NYS = MIN(LENZ(CYS), 2)

      DO 100 I=1, NYS
        CALL UYAXDV(CYS(I:I), DYTA, DYLA)
        CP = 'LABELY'//CYS(I:I)
        CALL UZLGET(CP, LAB1)
        IF(LAB1) THEN
          CYSUB = CSBLBL(YFAC, YOFF, CYUNIT)
          IF(LENZ(CYSUB).NE.0) THEN
            CALL USCGET('CYSPOS', CPOS)
            READ(CYFMT, '(T3,I1)') NDGT
            CALL USYSUB(CYS(I:I), CPOS, CYSUB, REAL(NDGT))
          ENDIF
        ENDIF
  100 CONTINUE

      CALL SGSWND(XMIN,  XMAX,  YMIN,  YMAX)
      CALL SGSTRF
      CALL UYSFMT(CFMT0)

      RETURN
      END

program multi

  use dcl
  integer, parameter :: n=200, m=5
  real, dimension(0:n) :: x, y0, y1, y2, t
  real, dimension(m) :: a

!-- データ ----

    do j=1,m
      a(j) = (-1)**j *2./((j*2-1)*DCL_PI)
    end do

    x = (/( real(i)/n, i=0,n )/)
    t  = 2*DCL_PI*x

    y0 = -0.5
    where (x >= 1./4. .and. x <= 3./4.) y0 = 0.5
    y1 = a(1)*cos(t)
    y2 = 0.
    do j=1,m
      y2 = y2 + a(j)*cos((j*2-1)*t)
    end do

!-- グラフ ----

    call DclOpenGraphics()
    call DclNewFrame

    call DclScalingPoint( x, y0 )
    call DclScalingPoint( x, y1 )
    call DclScalingPoint( x, y2 )

    call DclFitScalingParm
    call DclSetTransFunction

    call DclDrawScaledAxis

    call DclDrawLine ( x, y0, index=5 )
    call DclDrawLine ( x, y1, type=3 )
    call DclDrawLine ( x, y2, type=2, index=2 )

    call DclCloseGraphics
end program

*-----------------------------------------------------------------------
*     UYPLBB : PLOT LABELS ( BETWEEN THE POINTS )
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPLBB(UY,CH,NC,N,UPX,ROFFY,RSIZE,IROTA,ICENT,INDEX,
     +                  RBTWN,LBOUND,LBMSG)

      REAL      UY(*)
      LOGICAL   LBOUND,LBMSG
      CHARACTER CH(*)*(*)

      LOGICAL   LCLIPZ


      IF (NC.LE.0) THEN
        CALL MSGDMP('E','UYPLBB',
     +       'CHARACTER LENGTH IS LESS THAN OR EQUAL TO ZERO.')
      END IF
      IF (N.LE.1) THEN
        CALL MSGDMP('E','UYPLBB','NUMBER OF POINTS IS INVALID.')
      END IF
      IF (RSIZE.LE.0) THEN
        CALL MSGDMP('E','UYPLBB','TEXT HEIGHT IS LESS THAN ZERO.')
      END IF
      IF (.NOT.(-1.LE.ICENT .AND. ICENT.LE.1)) THEN
        CALL MSGDMP('E','UYPLBB','CENTERING OPTION IS INVALID.')
      END IF
      IF (INDEX.LE.0) THEN
        CALL MSGDMP('E','UYPLBB','TEXT INDEX IS INVALID.')
      END IF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)

      CALL SZTXOP(RSIZE,IROTA*90,ICENT,INDEX)
      DO 10 I=1,N-1
        LC = LENC(CH(I))
        CALL SZQTXW(CH(I),LCZ,WXCH,WYCH)
        CALL STFTRF(UPX,UY(I),VPX,VPY1)
        CALL STFTRF(UPX,UY(I+1),VPX,VPY2)
        VWY=ABS(VPY2-VPY1)
        JROTA=MOD(IROTA,2)
        IF (JROTA.NE.0) THEN
          CWY=RSIZE*WXCH
        ELSE
          CWY=RSIZE*WYCH
        END IF
        IF (CWY.GT.VWY .AND. LBOUND) THEN
          IF (LBMSG) THEN
            CALL MSGDMP('W','UYPLBB','SPACE FOR LABEL IS NOT ENOUGH.')
          END IF
          GO TO 10
        END IF
        VPY=(VPY1+VPY2)/2+(VWY-CWY)/2*RBTWN
        VPX=VPX+ROFFY
        CALL SZTXZV(VPX,VPY,CH(I)(1:LC))
   10 CONTINUE
      CALL SZTXCL

   15 CONTINUE

      CALL SGLSET('LCLIP',LCLIPZ)

      END

*-----------------------------------------------------------------------
*     USPACK SET PARAMETER
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USPFIT
      LOGICAL LXINV, LYINV, LOFF
      CHARACTER  CXSIDE*2, CYSIDE*2

      CALL GLRGET('RUNDEF', RUNDEF)

      CALL USCGET('CXSIDE' ,  CXSIDE)
      CALL USCGET('CYSIDE' ,  CYSIDE)

      CALL CUPPER(CXSIDE)
      CALL CUPPER(CYSIDE)

      IF(INDEX(CYSIDE,'U') .NE. 0) THEN
        CALL UZRGET('UXUSER', UXUSER)
        CALL USSPNT(1, UXUSER, RUNDEF)
      ENDIF

      IF(INDEX(CXSIDE,'U') .NE. 0) THEN
        CALL UZRGET('UYUSER', UYUSER)
        CALL USSPNT(1, RUNDEF, UYUSER)
      ENDIF

      CALL SGIGET('ITR'    , ITR)
      CALL USLGET('LXINV'  , LXINV)
      CALL USLGET('LYINV'  , LYINV)
      CALL UZLGET('LOFFSET', LOFF)

*--------------------------- VIEW PORT ---------------------------------

      CALL SGRGET('VXMIN'  , VXMIN)
      CALL SGRGET('VXMAX'  , VXMAX)
      CALL SGRGET('VYMIN'  , VYMIN)
      CALL SGRGET('VYMAX'  , VYMAX)

      CALL USRGET('RMRGN'  , RMRGN)
      CALL UZRGET('RSIZEL1', CW)
      RMC = RMRGN*CW

      CALL STQWTR(VXMIN0, VXMAX0, VYMIN0, VYMAX0,
     #            WXMIN , WXMAX,  WYMIN,  WYMAX, ITRW)

      IF(VXMIN.EQ.RUNDEF)  VXMIN = VXMIN0 + RMC
      IF(VXMAX.EQ.RUNDEF)  VXMAX = VXMAX0 - RMC
      IF(VYMIN.EQ.RUNDEF)  VYMIN = VYMIN0 + RMC
      IF(VYMAX.EQ.RUNDEF)  VYMAX = VYMAX0 - RMC

*----------------------------- X-AXIS ----------------------------------

      CALL SGRGET('UXMAX' , XMAX)
      CALL SGRGET('UXMIN' , XMIN)

      IF(XMIN.NE.RUNDEF .AND. XMAX.NE.RUNDEF .AND. XMIN.GT.XMAX) THEN
        LXINV = .TRUE.
        CALL USWAPZ(XMIN, XMAX, 1)
      ENDIF

      CALL USRGET('XDTMAX', UXMAX)
      CALL USRGET('XDTMIN', UXMIN)
      IF(XMIN.NE.RUNDEF) UXMIN = XMIN
      IF(XMAX.NE.RUNDEF) UXMAX = XMAX

      IF(UXMIN.EQ.RUNDEF .OR. UXMAX.EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'USPFIT', 'XMIN OR XMAX IS NOT DEFINED.')
      END IF

      IF(LOFF) THEN
        CALL UZRGET('XOFFSET', XOFF)
        CALL UZRGET('XFACT'  , XFAC)
        UXMIN = XFAC*UXMIN + XOFF
        UXMAX = XFAC*UXMAX + XOFF
      END IF

      IF(ITR.EQ.1 .OR. ITR.EQ.2) THEN
        CALL USURDT(UXMIN, UXMAX, VXMIN, VXMAX, DT)
      ELSEIF(ITR.EQ.3. .OR. ITR.EQ.4) THEN
        CALL USURDL(UXMIN, UXMAX, VXMIN, VXMAX)
      ELSE
        CALL MSGDMP('E', 'USPFIT', 'INVALID ITR')
      ENDIF

      IF(XMIN.NE.RUNDEF) UXMIN = XMIN
      IF(XMAX.NE.RUNDEF) UXMAX = XMAX

*----------------------------- Y-AXIS ----------------------------------

      CALL SGRGET('UYMAX', YMAX)
      CALL SGRGET('UYMIN', YMIN)

      IF(YMIN.NE.RUNDEF .AND. YMAX.NE.RUNDEF .AND. YMIN.GT.YMAX) THEN
        LYINV = .TRUE.
        CALL USWAPZ(YMIN, YMAX, 1)
      ENDIF

      CALL USRGET('YDTMAX', UYMAX)
      CALL USRGET('YDTMIN', UYMIN)
      IF(YMIN.NE.RUNDEF) UYMIN = YMIN
      IF(YMAX.NE.RUNDEF) UYMAX = YMAX

      IF(UYMIN.EQ.RUNDEF .OR. UYMAX.EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'USPFIT', 'YMIN OR YMAX IS NOT DEFINED.')
      END IF

      IF(LOFF) THEN
        CALL UZRGET('YOFFSET', YOFF)
        CALL UZRGET('YFACT'  , YFAC)
        UYMIN = YFAC*UYMIN + YOFF
        UYMAX = YFAC*UYMAX + YOFF
      END IF

      IF(ITR.EQ.1 .OR. ITR.EQ.3) THEN
        CALL USURDT(UYMIN, UYMAX, VYMIN, VYMAX, DT)
      ELSE
        CALL USURDL(UYMIN, UYMAX, VYMIN, VYMAX)
      ENDIF

      IF(YMIN.NE.RUNDEF) UYMIN = YMIN
      IF(YMAX.NE.RUNDEF) UYMAX = YMAX

*-----------------------------------------------------------------------

      IF(LXINV) CALL USWAPZ(UXMIN, UXMAX, 1)
      IF(LYINV) CALL USWAPZ(UYMIN, UYMAX, 1)

      CALL SGSWND(UXMIN, UXMAX, UYMIN, UYMAX)
      CALL SGSVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGSTRN(ITR)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2D3

      PARAMETER( NX=21, NY=21 )
      PARAMETER( XMIN=-1, XMAX=1, YMIN=-1, YMAX=1 )
      PARAMETER( DX=(XMAX-XMIN)/(NX-1), DY=(YMAX-YMIN)/(NY-1) )
      REAL U(NX,NY), V(NX,NY)

*-- データ ----
      DO 10 J=1,NY
      DO 10 I=1,NX
        X = XMIN + (I-1)*DX
        Y = YMIN + (J-1)*DY
        U(I,J) =   X
        V(I,J) = - Y
   10 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'X', 'km', 'Y', 'km' )
      CALL USDAXS

      CALL UGVECT( U, NX, V, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     REAL PARAMETER CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ODRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA=1)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ,LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      CPARAS( 1)/'EPSILON '/, RX( 1) / 1.E-5 /

      DATA      CPARAL( 1)/'EPSILON '/

      DATA      LFIRST /.TRUE./

      NCP=NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODRQID(CP,IDX)

      DO 10 N=1,NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','ODRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODRQCP(IDX,CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','ODRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','ODRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTLGET('OD', CPARAS, IX, NPARA)
        CALL RLLGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','ODRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODRSVL(IDX,RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('OD', CPARAS, IX, NPARA)
        CALL RLRGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','ODRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      INTEGER FUNCTION IUETON(ZLEV)

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)

      SAVE

      IF (LASCND) THEN
        ITBEG = 1
        ITEND = NT
        ITSTEP = 1
      ELSE
        ITBEG = NT
        ITEND = 1
        ITSTEP = -1
      END IF
      IF (ZLEV .LT. TL1(1)) THEN
        IT = 1
      ELSE IF (ZLEV .GT. TL2(NT)) THEN
        IT = NT
      ELSE
        DO 10 IT = ITBEG, ITEND, ITSTEP
          IF (TL1(IT) .LE. ZLEV .AND. ZLEV .LE. TL2(IT)) GO TO 20
 10   CONTINUE
 20   CONTINUE

      END IF
      IUETON = IPT(IT)

      END

      PROGRAM KIHON2

      PARAMETER( NMAX=40, IMAX=4 )
      REAL X(0:NMAX), Y(0:NMAX,IMAX)

      DT = 4.* 3.14159 / NMAX
      DO 20 N=0,NMAX
        X(N) = REAL(N)/REAL(NMAX)
        DO 10 I=1,IMAX
          Y(N,I) = 0.2*SIN(N*DT) + 1. - 0.2*I
   10   CONTINUE
   20 CONTINUE

      CALL SWCSTX('FNAME','KIHON2')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )

*-- ラインインデクス: frame 1 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPLV( NMAX+1, X, Y(0,1) )

      DO 30 I=2,IMAX
        CALL SGSPLI( 2*I )
        CALL SGPLV( NMAX+1, X, Y(0,I) )
   30 CONTINUE

      CALL SGSPLI( 1 )

*-- ラインタイプ: frame 2 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPLV( NMAX+1, X, Y(0,1) )

      DO 40 I=2,IMAX
        CALL SGSPLT( I )
        CALL SGPLV( NMAX+1, X, Y(0,I) )
   40 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     BITPIC
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE BITPIC(IP,CP)

      CHARACTER CP*(*)

      PARAMETER (NB=32)

      INTEGER   MASK(NB)
      LOGICAL   LFST

      SAVE

      EXTERNAL  ISHIFT

      DATA      LFST/.TRUE./


      IF (LFST) THEN
        CALL GLIGET('NBITSPW',NBITPW)
        IF (NBITPW.NE.NB) THEN
          CALL MSGDMP('E','BITPIC',
     +      'NUMBER OF BITS PER ONE WORD IS INVALID / '//
     +      'CHECK NB IN THE PARAMETER STATEMENT OF BITPIC '//
     +      'AND CHANGE IT CORRECTLY.')
        END IF
        MASK(1)=1
        DO 10 I=2,NB
          MASK(I)=ISHIFT(MASK(I-1),1)
   10   CONTINUE
        LFST=.FALSE.
      END IF

      NBC=LEN(CP)
      DO 15 I=1,MIN(NBC,NB)
        II=NBC-I+1
        IF (IAND(MASK(I),IP).EQ.0) THEN
          CP(II:II)='0'
        ELSE
          CP(II:II)='1'
        END IF
   15 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UMPK05

      PARAMETER ( NX=37, NY=37 )
      PARAMETER ( XMIN=  0, XMAX=360, YMIN=-90, YMAX=+90 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05 )
      PARAMETER ( FACT=10 )

      REAL      P(NX,NY), U(NX,NY), V(NX,NY), ALON(NX), ALAT(NY)

      EXTERNAL  IMOD


      CALL GLRGET( 'RMISS', RMISS )
      CALL GLLSET( 'LMISS', .TRUE. )
     
      DO 10 I = 1, NX
        ALON(I) = XMIN + (XMAX-XMIN) * (I-1) / (NX-1)
   10 CONTINUE

      DO 20 J = 1, NY
        ALAT(J) = YMIN + (YMAX-YMIN) * (J-1) / (NY-1)
   20 CONTINUE

      DO 40 J = 1, NY
        DO 30 I = 1, NX
          SLAT = SIN(ALAT(J)*DRAD)
          P(I,J) = COS(ALON(I)*DRAD) * (1-SLAT**2) * SIN(2*PI*SLAT) 
     +             + DZ
   30   CONTINUE
   40 CONTINUE

      DO 60 J = 1, NY
        DO 50 I = 1, NX
          IF (J.EQ.1 .OR. J.EQ.NY) THEN
            U(I,J) = RMISS
            V(I,J) = RMISS
          ELSE
            U(I,J) = ( P(I,J-1) - P(I,J+1) ) * FACT
            V(I,J) = ( P(IMOD(I,NX-1)+1,J) - P(IMOD(I-2,NX-1)+1,J) )
     +             * FACT
          END IF
   50   CONTINUE
   60 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL GRSSIM( 0.4, 0.0, 0.0 )
      CALL GRSMPL( 165.0, 60.0, 0.0 )
      CALL GRSTXY( -180.0, 180.0, 0.0, 90.0 )
      CALL GRSTRN( 30 )
      CALL GRSTRF
      CALL SGLSET( 'LCLIP', .TRUE. )

      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB

      CALL UDCNTR( P, NX, NX, NY )

      DO 80 J=1,NY
        DO 70 I=1,NX
          IF (.NOT.(U(I,J).EQ.RMISS .OR. V(I,J).EQ.RMISS)) THEN
            CALL SGLAZU(ALON(I),ALAT(J),ALON(I)+U(I,J),ALAT(J)+V(I,J),
     +           1, 3 )
          END IF
   70   CONTINUE
   80 CONTINUE

      CALL GRCLS

      END

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program shade

  use dcl
  real :: upx3(3), upy3(3), upx6(6), upy6(6), upxs(61), upys(61)

    a = 0.8
    th = 3.14159 * 2 / 3
    do i=1, 3
      upx3(i) = a*sin(th*i)
      upy3(i) = a*cos(th*i)
    end do

    th = 3.14159 * 2 / 6
    do i=1, 6
      upx6(i) = a*sin(th*i)
      upy6(i) = a*cos(th*i)
    end do

    th = 3.14159 * 4 / 60
    do i=1, 61
      upxs(i) = a*(i-31) / 30.
      upys(i) = a*sin(th*(i-1))
    end do

    call DclOpenGraphics

    call DclSetParm( 'ENABLE_SOFTFILL',.true.) ! <-- ソフトフィルの指定
    call DclNewFrame

    call DclSetWindow(-1., 1., -1., 1.)
    call DclSetViewPort(0., 0.5, 0., 0.5)
    call DclSetTransNumber( 1)
    call DclSetTransFunction
    call DclDrawLine(upx3, upy3)
    call DclShadeRegion(upx3, upy3)              ! <-- 網かけ (左下)

    call DclNewFig

    call DclSetWindow(-1., 1., -1., 1.)
    call DclSetViewPort(0., 0.5, 0.5, 1.)
    call DclSetTransFunction
    call DclSetShadePattern(101)
    call DclShadeRegion(upx6, upy6)              ! <-- 横線 (左上)

    call DclNewFig

    call DclSetWindow(-1., 1., -1., 1.)
    call DclSetViewPort(0.5, 1., 0., 0.5)
    call DclSetTransFunction
    call DclShadeRegion(upx6, upy6, 201)        ! <-- 斜線 (右下)

    call DclNewFig

    call DclSetWindow(-1., 1., -1., 1.)
    call DclSetViewPort(0.5, 1., 0.5, 1.)
    call DclSetTransFunction
    call DclShadeRegion(upxs, upys, 601)       ! <-- 横線 (右上)

    call DclCloseGraphics

end program

      PROGRAM SAMPLE02

      PARAMETER (NX = 50, NY = 50)

      REAL Z(NX,NY)

      DO I = 1, NX
         DO J = 1, NY

            Z(I,J) = - (I - NX / 2.)**2 - (J - NY / 2.)**2

         END DO
      END DO

      CALL SWISET('WINDOW_HEIGHT', 300)
      CALL SWISET('WINDOW_WIDTH', 300)

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSWND(-1., 1., -1., 1.)
      CALL GRSVPT(.1, .9, .1, .9)
      CALL GRSTRN(1)
      CALL GRSTRF

      CALL UIPDAT(Z, NX, NX, NY)

      CALL UXAXDV('T', .1, .5)
      CALL UXAXDV('B', .1, .5)
      CALL UYAXDV('L', .1, .5)
      CALL UYAXDV('R', .1, .5)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      INTEGER FUNCTION JFROMC(CX)

      CHARACTER CX*(*)

      CHARACTER CNUM*10,CMSG*80

      INTRINSIC INDEX

      EXTERNAL  LENZ

      SAVE

      DATA      CNUM/'0123456789'/


      LCX=LENZ(CX)

      IF (LCX.EQ.0) THEN
        CMSG='THERE IS NO VALID CHARACTER.'
        CALL MSGDMP('E','JFROMC',CMSG)
      END IF

      JFROMC=0
      IDIG=1
      DO 10 N=LCX,1,-1
        IDX=INDEX(CNUM,CX(N:N))
        IF (IDX.EQ.0) THEN
          CMSG='THERE IS A NON-NUMERAL CHARACTER.'
          CALL MSGDMP('E','JFROMC',CMSG)
        END IF
        JFROMC=JFROMC+(IDX-1)*IDIG
        IDIG=IDIG*10
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DCLDBS

      PARAMETER (NDX=2,NGL=1,NSW=6)

      CHARACTER CDXLST(NDX)*8,CGLLST(NGL)*8,CSWLST(NSW)*8,CFNAME*1024

      DATA      CDXLST/'DSPATH','DUPATH'/
      DATA      CGLLST/'DCLRC'/
      DATA      CSWLST/'BITMAP','CL2TN','CMAPLIST','CLRMAP',
     +                 'FONT1','FONT2' /


      CALL GLIGET('IOUNIT',IU)
      WRITE(IU,'(A)') '*** PATH NAME FOR DATABASE'
      DO 10 N=1,NDX
        CALL GLCGET(CDXLST(N),CFNAME)
        WRITE(IU,'(A)') CDXLST(N)//' : '//CFNAME(1:LENC(CFNAME))
   10 CONTINUE

      WRITE(IU,'(A)') '*** FILE NAME FOR SYSLIB'
      DO 20 N=1,NGL
        CALL GLQFNM(CGLLST(N),CFNAME)
        WRITE(IU,'(A)') CGLLST(N)//' : '//CFNAME(1:LENC(CFNAME))
   20 CONTINUE

      WRITE(IU,'(A)') '*** FILE NAME FOR SWPACK/SZPACK'
      DO 30 N=1,NSW
        CALL SWQFNM(CSWLST(N),CFNAME)
        WRITE(IU,'(A)') CSWLST(N)//' : '//CFNAME(1:LENC(CFNAME))
   30 CONTINUE

      END

!----------------------------------------------
!  USpack Module
!----------------------------------------------
module uspack
  use dcl_common
  real, private :: xsec0, ysec0, xfac0, yfac0, xoff0, yoff0
  character(len=32) :: xttl0, yttl0, xuni0, yuni0
  private ::   SetFactor,  SetOffset,  SetSection,  SetTitle,  SetUnit, &
           & ResetFactor,ResetOffset,ResetSection,ResetTitle,ResetUnit
  contains

!----------------------------------------------------
    subroutine SetFactor(factor)
      call usrget('XFAC', xfac0)
      call usrget('YFAC', yfac0)
      call usrset('XFAC', factor)
      call usrset('YFAC', factor)
    end subroutine

    subroutine ResetFactor
      call uspset('XFAC', xfac0)
      call uspset('YFAC', yfac0)
    end subroutine

    subroutine SetOffset(offset)
      call usrget('XOFF', xoff0)
      call usrget('YOFF', yoff0)
      call usrset('XOFF', offset)
      call usrset('YOFF', offset)
    end subroutine

    subroutine SetTitle(title)
      character(len=*) :: title
      call uscget('CXTTL', xttl0)
      call uscget('CYTTL', yttl0)
      call uscset('CXTTL', title)
      call uscset('CYTTL', title)
    end subroutine

    subroutine SetUnit(unit)
      character(len=*) :: unit
      call uscget('CXUNIT', xuni0)
      call uscget('CYUNIT', yuni0)
      call uscset('CXUNIT', unit)
      call uscset('CYUNIT', unit)
    end subroutine

    subroutine ResetOffset
      call uspset('XOFF', xoff0)
      call uspset('YOFF', yoff0)
    end subroutine

    subroutine SetSection(section)
      call uzrget('UXUSER', xsec0)
      call uzrget('UYUSER', ysec0)
      call uzrset('UXUSER', section)
      call uzrset('UYUSER', section)
    end subroutine

    subroutine ResetSection
      call uzpset('UXUSER', xsec0)
      call uzpset('UYUSER', ysec0)
    end subroutine

    subroutine ResetTitle
      call uscset('CXTTL', xttl0)
      call uscset('CYTTL', yttl0)
    end subroutine

    subroutine ResetUnit
      call uscset('CXUNIT', xuni0)
      call uscset('CYUNIT', yuni0)
    end subroutine
!-------------------------------------------------------------------

    subroutine DclScalingPoint(x, y)
      real, dimension(:), intent(in), optional :: x, y

      call prcopn('DclScalingPoint')
      call glrget('rundef', rundef)

      if(present(x) .and. present(y)) then
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclScalingPoint', 'Length of x and y don''t match.')
        n = min(nx, ny)
        call usspnt(n, x, y)
      else if(present(x)) then
        n = size(x)
        call usspnt(n, x, (/rundef/))
      else if(present(y)) then
        n = size(y)
        call usspnt(n, (/rundef/), y)
      end if
      
      call prccls('DclScalingPoint')
    end subroutine
!----------------------------------------------------
    subroutine DclSetTitle(xtitle, ytitle, xunit, yunit)
      character(len=*), intent(in) :: xtitle, ytitle, xunit,  yunit
      optional                     :: xtitle, ytitle, xunit,  yunit
 
      call prcopn('DclSetTitle')

      if(present(xtitle)) call uscset('cxttl' , xtitle)
      if(present(ytitle)) call uscset('cyttl' , ytitle)
      if(present(xunit )) call uscset('cxunit', xunit)
      if(present(yunit )) call uscset('cyunit', yunit)

      call prccls('DclSetTitle')
    end subroutine
!----------------------------------------------------
    subroutine DclFitScalingParm
      call prcopn('DclFitScalingParm')
      call uspfit
      call prccls('DclFitScalingParm')
    end subroutine
!----------------------------------------------------
    subroutine DclDrawScaledAxis(side,section)
      character(len=*), intent(in), optional :: side
      real, optional :: section

      call sgoopn('DclDrawScaledAxis', ' ')
      if(present(section)) call SetSection(section)

      if(present(side)) then; call usaxsc(side)
                        else; call usdaxs
      end if

      if(present(section)) call ResetSection
      call sgocls('DclDrawScaledAxis')
    end subroutine
!----------------------------------------------------
    subroutine DclDrawScaledGraph(x, y, type, index)
      real,    intent(in), dimension(:) :: x, y
      integer, intent(in), optional     :: type,  index
      integer                           :: type0, index0

      call sgoopn('DclDrawScaledGraph', ' ')
      call glrget('rundef', rundef)

      if(present(type)) then;   type0 = type
                        else;   call sgqplt(type0)
      end if
        
      if(present(index)) then;  index0 = index
                         else;  call sgqpli(index0)
      end if

      nx = size(x)
      ny = size(y)
      if(nx.ne.ny) call msgdmp('M', 'DclScalingPoint', 'Length of x and y don''t match.')
      n = min(nx, ny)

      call usspnt(n, x, y)
      call uspfit
      call grstrf
      call usdaxs
      call sgplzu(n, x, y, type0, index0)
      call sgocls('DclDrawScaledGraph')

    end subroutine
!----------------------------------
!   UXYZPACK 座標軸
!---------------------------------- 目盛とラベルの間隔を指定して座標軸を描く
    subroutine DclDrawAxis(side,dlabel,dtick, &
                         & title,unit,factor,offset,section) 
      character(len=*), intent(in) :: side !座標軸を描く場所
      real, intent(in) :: dlabel, dtick    !目盛およびラベルの間隔
      character(len=*), intent(in), optional :: title, unit
      real, intent(in), optional :: factor,offset,section

      call sgoopn('DclDrawAxis', ' ')

      if(present(factor))  call SetFactor(factor)
      if(present(offset))  call SetOffset(offset)
      if(present(section)) call SetSection(section)
      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      call usaxdv(side,dtick,dlabel)

      if(present(factor))  call ResetFactor
      if(present(offset))  call ResetOffset
      if(present(section)) call ResetSection
      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      call sgocls('DclDrawAxis')

    end subroutine
!---------------------------------- 目盛とラベルの場所を指定して座標軸を描く．
    subroutine DclDrawAxisSpecify(side,label_pos,tick_pos,label, &
                                & title, unit, factor, offset, section)
      character(len=*), intent(in) :: side       !座標軸を描く場所
      real, intent(in), dimension(:) :: label_pos       !大きめの目盛およびラベルの場所
      real, intent(in), dimension(:), optional :: tick_pos      !小さめの目盛の場所
      character(len=*), intent(in), dimension(:), optional :: label !ラベル
      character(len=*), intent(in), optional :: title, unit
      real, intent(in), optional :: factor, offset, section
      real, dimension(1) :: dummy      !小さめの目盛の場所


      call sgoopn('DclDrawAxisSpecify', ' ')

      if(present(factor))  call SetFactor(factor)
      if(present(offset))  call SetOffset(offset)
      if(present(section)) call SetSection(section)
      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      if (present(label)) then
        if(present(tick_pos)) then
          call usaxlb(side,tick_pos,size(tick_pos),label_pos,label,len(label(1)),size(label_pos))
        else
          call usaxlb(side, dummy, 0,label_pos,label,len(label(1)),size(label_pos))
        end if
      else
        if(present(tick_pos)) then
          call usaxnm(side,tick_pos,size(tick_pos),label_pos,size(label_pos))
        else
          call usaxnm(side, dummy,0,label_pos,size(label_pos))
        end if
      end if

      if(present(factor))  call ResetFactor
      if(present(offset))  call ResetOffset
      if(present(section)) call ResetSection
      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      call sgocls('DclDrawAxisSpecify')

    end subroutine
!---------------------------------- LOG 座標軸を描く．
    subroutine DclDrawAxisLog(side, nlabel, nticks, &
                            & title, unit, format, cformat, factor, section, label_pos)
      character(len=*), intent(in)  :: side       !座標軸を描く場所
      integer, intent(in)           :: nlabel, nticks
      integer, intent(in), optional :: format
      character(len=*), intent(in), optional :: cformat
      character(len=*), intent(in), optional :: title, unit
      real,    intent(in), optional :: factor, section
      real,    intent(in), dimension(:), optional :: label_pos
      real, dimension(9) :: xlb, ylb

      call sgoopn('DclDrawAxisLog', ' ')

      if(present(factor))  call SetFactor(factor)
      if(present(section)) call SetSection(section)
      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      if(present(format))  then
        call uliget('IXTYPE', ix0)
        call uliget('IYTYPE', iy0)
        call uliset('IXTYPE', format)
        call uliset('IYTYPE', format)
      end if

      if(present(cformat))  then
        call ulxsfm(cformat)
        call ulxsfm(cformat)
      endif

      if(present(label_pos)) then
        call ulqxbl (xlb, 9 )
        call ulqybl (ylb, 9 )
        call ulsxbl (label_pos, size(label_pos) )
        call ulsybl (label_pos, size(label_pos) )
      end if

      call usaxlg(side,nlabel,nticks)

      if(present(factor))  call ResetFactor
      if(present(section)) call ResetSection
      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      if(present(format))  then
        call uliset('IXTYPE', ix0)
        call uliset('IYTYPE', iy0)
      end if

      if(present(label_pos)) then
        call ulsxbl (xlb, 9 )
        call ulsybl (ylb, 9 )
      end if

      call sgocls('DclDrawAxisLog')

    end subroutine
!----------------------------------------
!   日付座標軸
!----------------------------------------
    subroutine DclDrawAxisCalendar (side,first_day, title, unit, type,nd) !日・月・年に関する座標軸を描く．
      character(len=*),  intent(in) :: side       !座標軸を書く場所を指定する
      type(dcl_date),    intent(in) :: first_day   !ucで0に相当する場所の日付を指定する
      character(len=*), intent(in), optional :: title, unit
      character(len=*),  intent(in), optional :: type        !年、月、日を YMD で指定する
      integer, optional, intent(in) :: nd          !作画する日数を指定する
      character(len=8)              :: type0

      call sgoopn('DclDrawAxisCalendar', ' ')

      jd = first_day%year*10000 + first_day%month*100 + first_day%day

      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      if(present(nd)) then; nd0 = nd
                      else; nd0 = 0
      end if

      if(present(type)) then; type0 = type
                        else; type0 = 'DMY'
      end if

      call usaxcl(side,jd,type0, nd0) 

      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      call sgocls('DclDrawAxisCalendar')
    end subroutine
      
!----------------------------------
!   UXYZPACK 座標軸要素
!---------------------------------- タイトルを描く．
    subroutine DclDrawTitle(side,title,position,sw)
      character(len=*), intent(in) :: side     !座標軸を描く場所を指定する
      character(len=*), intent(in) :: title    !描くタイトル
      real,   optional, intent(in) :: position !位置:-1から+1の間の実数値
      integer,optional, intent(in) :: sw

      call sgoopn('DclDrawTitle', ' ')

      if(present(sw))       then;  isw=sw 
                            else;  isw=1
      end if

      if(present(position)) then;  pos=position 
                            else;  pos=0.
      end if

      call uspttl(side, isw, title, pos) 
      call sgocls('DclDrawTitle')
    end subroutine
!---------------------------------- 軸を示す線分を描く．
    subroutine DclDrawAxisLine(side,sw)
      character(len=*),  intent(in) :: side   !座標軸を描く場所を指定する
      integer, optional, intent(in) :: sw     !描く軸の属性を指定する

      call sgoopn('DclDrawAxisLine', ' ')

      if(present(sw)) then;  isw=sw 
                      else;  isw=1
      end if

      call uspaxs(side,isw)
      call sgocls('DclDrawAxisLine')
    end subroutine
!---------------------------------- 目盛を描く．
    subroutine DclDrawTickmark(side, position, sw)
      character(len=*), intent(in)        :: side      !目盛を描く座標軸の場所
      integer,   intent(in), optional     :: sw        !描く目盛の属性
      real,      intent(in), dimension(:) :: position  !目盛を描く場所
      integer                             :: isw

      call sgoopn('DclDrawTickmark', ' ')

      if(present(sw)) then;  isw=sw 
                      else;  isw=1
      end if
      call uxptmk(side, isw, position, size(position)) 
      call sgocls('DclDrawTickmark')
    end subroutine
!---------------------------------- 文字列で指定したラベルを描く
    subroutine DclDrawAxisLabel(side, position, label, sw)
      character(len=*), intent(in)               :: side     !ラベルを描く座標軸の場所
      real,             intent(in), dimension(:) :: position !ラベルを描く場所
      character(len=*), intent(in), dimension(:) :: label    !ラベル
      integer,          intent(in)               :: sw       !ラベルの属性
      optional :: label, sw

      call sgoopn('DclDrawAxisLabel', ' ')

      if(present(sw)) then;  isw=sw 
                      else;  isw=1
      end if

      if(present(label)) then
        call usplbl(side, isw, position, label, len(label(1)),size(position)) 
      else
        call uspnum(side, isw, position,size(position))
      end if 
      call sgocls('DclDrawAxisLabel')
    end subroutine
!---------------------------------- 軸をずらす。
    subroutine DclShiftAxis(side)
      character(len=*), intent(in) :: side

      call prcopn('DclShifAxis')
      call ussaxs(side)
      call prccls('DclShifAxis')
    end subroutine

end module

!-------------------------------------------------
!interface module of bitlib
!-------------------------------------------------
module bit_interface
  interface

    subroutine bitpic(ip,cp)                      !ビットパターンを'0', '1'の文字列として返す．
      integer,   intent(in) :: ip                 !ビットパターン を調べる1語長の引数
      character(len=*), intent(out) :: cp         !ビットパターン を返す文字型の引数
    end subroutine
      
    subroutine bitpci(cp,ip)                      !'0', '1'の文字列をビットパターンとして返す．
      character(len=*), intent(in) :: cp          !ビットパターンを与える文字型の引数
      integer,   intent(out) :: ip                !ビットパターンを返す1語長の引数
    end subroutine
      
    subroutine gbyte(np,io,ib,nb)                 !連続した記憶領域からビットパターンを切り出す．
      integer,   intent(in), dimension(*) :: np   !連続した記憶領域（たとえば配列）の先頭となる語
      integer,   intent(out) :: io                !切り出したビットパターンを返す変数
      integer,   intent(in) :: ib                 !先頭の語においてスキップするビット数
      integer,   intent(in) :: nb                 !切り出すビット数
    end subroutine
      
    subroutine gbytes(np,no,ib,nb,ns,it)          !連続した記憶領域からビットパターンを切り出す．
      integer,   intent(in), dimension(*) :: np   !連続した記憶領域（たとえば配列）の先頭となる語
      integer,   intent(out), dimension(*) :: no  !切り出したビットパターンを返す配列
      integer,   intent(in) :: ib                 !先頭の語においてスキップするビット数
      integer,   intent(in) :: nb                 !切り出すビット数
      integer,   intent(in) :: ns                 !切り出すビットパターン間のビット数
      integer,   intent(in) :: it                 !配列noの長さ
    end subroutine
      
    subroutine sbyte(np,io,ib,nb)                 !連続した記憶領域にビットパターンを埋め込む．
      integer,   intent(out), dimension(*) :: np  !連続した記憶領域（たとえば配列）の先頭となる語
      integer,   intent(in) :: io                 !埋め込むビットパターンを与える変数
      integer,   intent(in) :: ib                 !先頭の語においてスキップするビット数
      integer,   intent(in) :: nb                 !埋め込むビット数
    end subroutine
      
    subroutine sbytes(np,no,ib,nb,ns,it)          !連続した記憶領域にビットパターンを埋め込む．
      integer,   intent(out), dimension(*) :: np  !連続した記憶領域（たとえば配列）の先頭となる語
      integer,   intent(in), dimension(*) :: no   !埋め込むビットパターンを与える配列
      integer,   intent(in) :: ib                 !先頭の語においてスキップするビット数
      integer,   intent(in) :: nb                 !埋め込むビット数
      integer,   intent(in) :: ns                 !埋め込むビットパターン間のビット数
      integer,   intent(in) :: it                 !配列noの長さ
    end subroutine
      
    function ishift(iw,n)                         !ビットパターンをシフトする．
      integer,   intent(in) :: iw                 !ットパターンをシフトする1語長の引数
      integer,   intent(in) :: n                  !シフトするビット数
      integer ishift                              !シフトした結果を返す関数値
    end function
      
    function iand(i1,i2)                          !ビットごとのブール積を求める．
      integer,   intent(in) :: i1                 !ビット列を与える1語長の引数
      integer,   intent(in) :: i2
      integer iand                                !ビット列のブール積を返す関数値
    end function
      
    function ior(i1,i2)                           !ビットごとのブール積を求める．
      integer,   intent(in) :: i1                 !ビット列を与える1語長の引数
      integer,   intent(in) :: i2
      integer ior                                 !ビット列のブール和を返す関数値
    end function

  end interface
end module
!bitlib library end ----

*-----------------------------------------------------------------------
*     DRAW LIMB OF MAP
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMPLIM

      PARAMETER (EPSIL=1.0E-4)

      REAL      XBND(2),YBND(2)

      LOGICAL   LREQA,LDIFF

      EXTERNAL  RFPI,LREQA


      PI=RFPI()

*     / GET INTERNAL PARAMETERS /

      CALL SZQCLX(XBND(1),XBND(2))
      CALL SZQCLY(YBND(1),YBND(2))
      CALL UMIGET('INDEXBND',INDEX)
      CALL UMIGET('MAXBND',NMAX)

*     / SET INTERNAL PARAMETER /

      CALL SZSLTI(1,INDEX)

*     / DRAW SIDE BOUNDARIES /

      CALL STFTRN(XBND(1), 0., X1, Y1)
      CALL STFTRN(XBND(2), 0., X2, Y2)
      LDIFF = .NOT.(LREQA(X1, X2, EPSIL) .AND. LREQA(Y1, Y2, EPSIL))

      IF (LDIFF) THEN
        DO 20 I=1,2
          CALL SZOPLV
          CALL STFTRN(XBND(I),YBND(1),XX,YY)
          CALL SZMVLV(XX,YY)
          DO 10 J=1,NMAX
            Y=J*(YBND(2) - YBND(1))/NMAX + YBND(1)
            CALL STFTRN(XBND(I),Y,XX,YY)
            CALL SZPLLV(XX,YY)
   10     CONTINUE
          CALL SZCLLV
   20   CONTINUE
      END IF

*     / DRAW POLES /

      IF (XBND(1).EQ.XBND(2)) THEN
        XBND(1)=-PI
        XBND(2)= PI
      END IF

      DO 40 I=1,2

        CALL STFTRN(XBND(1), YBND(I), X1, Y1)
        CALL STFTRN(XBND(2), YBND(I), X2, Y2)
        CALL STFTRN(     0., YBND(I), X3, Y3)

        LDIFF = .NOT.(LREQA(X1, X3, EPSIL) .AND. LREQA(Y1, Y3, EPSIL))
     +     .OR. .NOT.(LREQA(X2, X3, EPSIL) .AND. LREQA(Y2, Y3, EPSIL))

        IF (LDIFF) THEN
          CALL SZOPLV
          CALL STFTRN(XBND(1),YBND(I),XX,YY)
          CALL SZMVLV(XX,YY)
          DO 30 J=1,NMAX
            X=J*(XBND(2)-XBND(1))/NMAX+XBND(1)
            CALL STFTRN(X,YBND(I),XX,YY)
            CALL SZPLLV(XX,YY)
   30     CONTINUE
          CALL SZCLLV
        END IF

   40 CONTINUE

      END

*-----------------------------------------------------------------------
*     UMSPCW : CIRCLE WINDOW
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMSPCW

      COMMON    /UMWK1/ITR, RUNDEF, IUNDEF, PI, CPR, CPD, CP

      SAVE


      CALL SGQMPL(PLX, PLY, PLROT)
      IF (PLX.NE.RUNDEF .AND. PLY.NE. RUNDEF .AND.
     +    PLROT.NE.RUNDEF ) RETURN

      CALL UMQCWD (XCNTR, YCNTR, R)
      IF (XCNTR .EQ. RUNDEF .OR. YCNTR.EQ.RUNDEF .OR.
     +        R .EQ. RUNDEF ) RETURN

      IF (10.LE.ITR .AND. ITR.LE.19) THEN
        PLX = XCNTR
        PLY = 90.*CPD
      ELSE IF (20.LE.ITR .AND. ITR.LE.24) THEN
        PLX = XCNTR
        PLY = 90.*CPD

        IF (YCNTR .EQ. 0) CALL MSGDMP ('E', 'UMSPCW',
     +    'INVALID WINDOW FOR CONICAL PROJECTION.')
        CALL SGRGET('STLAT1',STLAT1)
        CALL SGRGET('STLAT2',STLAT2)

        IF (ITR .EQ. 22) THEN
          IF (STLAT1 .EQ. RUNDEF) STLAT1 = MAX(YCNTR-R, -89.*CPD)
          IF (STLAT2 .EQ. RUNDEF) STLAT2 = MIN(YCNTR+R,  89.*CPD)
          CALL SGRSET('STLAT1', STLAT1)
          CALL SGRSET('STLAT2', STLAT2)
        ELSE
          IF (STLAT1 .EQ. RUNDEF) STLAT1 =  YCNTR
          CALL SGRSET('STLAT1',STLAT1)
        END IF
      ELSE IF (30.LE.ITR .AND. ITR.LE.34) THEN
        PLX = XCNTR
        PLY = YCNTR
      END IF

      CALL SGSMPL(PLX, PLY, 0.)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGFONZ

      PARAMETER (NP=5,NT=6)
      PARAMETER (DD=0.13,DS=0.005)
      PARAMETER (DX=DD+DS*2,DY=1.0/NT)

      REAL      XBOX(NP),YBOX(NP)
      CHARACTER CHR*5

      DATA      XBOX/ 0.0, 1.0, 1.0, 0.0, 0.0/
      DATA      YBOX/ 0.0, 0.0, 1.0, 1.0, 0.0/

      WRITE(*,*) ' WORKSTATION ID (I) ? ; '
      CALL SGPWSN
      READ(*,*) IW
      WRITE(*,*) ' SOFT FILL=1/HARD FILL=2 (I) ? ;'
      READ(*,*) IFN

      CALL GLISET('MAXMSG',300)

      CALL SGOPN(IW)

      IF (IFN.EQ.1) THEN
        CALL SGLSET('LSOFTF',.TRUE.)
      ELSE
        CALL SGLSET('LSOFTF',.FALSE.)
      END IF
      CALL SGLSET('LFULL',.TRUE.)
      CALL SWLSET('LALT',.TRUE.)
      CALL SGISET('INDEX',3)
      CALL SLRAT(0.85,1.0)
      CALL SLMGN(0.0,0.0,0.05,0.1)
      CALL SLSTTL('TEST OF SGTONE','T',0.0,-0.5,0.03,1)

      DO 30 N=0,6
        CALL SGFRM
        CALL SGSWND(0.0,1.0,0.0,1.0)
        CALL SGSTRN(1)
        DO 20 J=0,5
          DO 10 I=0,5
            X1=DX*I+DS+(1-DX*NT)/2
            X2=X1+DD
            Y1=DY*(5-J)+DS
            Y2=Y1+DD
            LEVEL=I+J*10+N*100+N*1000
            CALL SGSVPT(X1,X2,Y1,Y2)
            CALL SGSTRF
            WRITE(CHR,'(I5)') LEVEL
            CALL SGTNZU(NP,XBOX,YBOX,LEVEL)
            CALL SGPLZU(NP,XBOX,YBOX,1,1)
            CALL SGTXZV(X2,Y2+(DY-DD)/2,CHR,0.015,0,1,3)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     SLPWWC : PLOT MAXIMUM-DRAWING-REGION CORNER MARKS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLPWVC(INDEX,RC)


      IF (INDEX.LE.0) THEN
        IF (INDEX.EQ.0) THEN
          CALL MSGDMP('M','SLPWVC','LINE INDEX IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPWVC','LINE INDEX IS LESS THAN ZERO.')
        END IF
      END IF

      IF (RC.LE.0) THEN
        IF (RC.EQ.0) THEN
          CALL MSGDMP('E','SLPWVC',
     +         'LENGTH OF CORNER MARKS IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPWVC',
     +         'LENGTH OF CORNER MARKS IS LESS THAN ZERO.')
        END IF
      END IF

      CALL STQWTR(RXMN,RXMX,RYMN,RYMX,WXMN,WXMX,WYMN,WYMX,ITR)
      IF (ITR.EQ.1) THEN
        CALL STQWRC(WXMIN,WXMAX,WYMIN,WYMAX)
      ELSE
        CALL STQWRC(WXMIN,WXMAX,WYMAX,WYMIN)
      END IF

      CALL SZQCLL(CXMIN,CXMAX,CYMIN,CYMAX,0)

      CALL STIWTR(WXMIN,WYMIN,RXMIN,RYMIN)
      CALL STIWTR(WXMAX,WYMAX,RXMAX,RYMAX)

      CALL SZSCLL(RXMIN,RXMAX,RYMIN,RYMAX,0)
      CALL SZSLTI(1,INDEX)

      CALL SZOPLR
      CALL SZMVLR(RXMIN   ,RYMIN+RC)
      CALL SZPLLR(RXMIN   ,RYMIN   )
      CALL SZPLLR(RXMIN+RC,RYMIN   )
      CALL SZCLLR
      CALL SZOPLR
      CALL SZMVLR(RXMAX-RC,RYMIN   )
      CALL SZPLLR(RXMAX   ,RYMIN   )
      CALL SZPLLR(RXMAX   ,RYMIN+RC)
      CALL SZCLLR
      CALL SZOPLR
      CALL SZMVLR(RXMAX   ,RYMAX-RC)
      CALL SZPLLR(RXMAX   ,RYMAX   )
      CALL SZPLLR(RXMAX-RC,RYMAX   )
      CALL SZCLLR
      CALL SZOPLR
      CALL SZMVLR(RXMIN+RC,RYMAX   )
      CALL SZPLLR(RXMIN   ,RYMAX   )
      CALL SZPLLR(RXMIN   ,RYMAX-RC)
      CALL SZCLLR

      CALL SZSCLL(CXMIN,CXMAX,CYMIN,CYMAX,0)

      END

*-----------------------------------------------------------------------
C     SUBROUTINE COSQB(N,X,WSAVE)
C
C     SUBROUTINE COSQB COMPUTES THE FAST FOURIER TRANSFORM OF QUARTER
C     WAVE DATA. THAT IS , COSQB COMPUTES A SEQUENCE FROM ITS
C     REPRESENTATION IN TERMS OF A COSINE SERIES WITH ODD WAVE NUMBERS.
C     THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER X.
C
C     COSQB IS THE UNNORMALIZED INVERSE OF COSQF SINCE A CALL OF COSQB
C     FOLLOWED BY A CALL OF COSQF WILL MULTIPLY THE INPUT SEQUENCE X
C     BY 4*N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE COSQB MUST BE
C     INITIALIZED BY CALLING SUBROUTINE COSQI(N,WSAVE).
C
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE ARRAY X TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C
C     X       AN ARRAY WHICH CONTAINS THE SEQUENCE TO BE TRANSFORMED
C
C     WSAVE   A WORK ARRAY THAT MUST BE DIMENSIONED AT LEAST 3*N+15
C             IN THE PROGRAM THAT CALLS COSQB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE COSQI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C
C     OUTPUT PARAMETERS
C
C     X       FOR I=1,...,N
C
C                  X(I)= THE SUM FROM K=1 TO K=N OF
C
C                    4*X(K)*COS((2*K-1)*(I-1)*PI/(2*N))
C
C                  A CALL OF COSQB FOLLOWED BY A CALL OF
C                  COSQF WILL MULTIPLY THE SEQUENCE X BY 4*N.
C                  THEREFORE COSQF IS THE UNNORMALIZED INVERSE
C                  OF COSQB.
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT
C             BE DESTROYED BETWEEN CALLS OF COSQB OR COSQF.
C
      SUBROUTINE COSQB (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
      DATA TSQRT2 /2.82842712474619/
C
      IF (N-2) 101,102,103
  101 X(1) = 4.*X(1)
      RETURN
  102 X1 = 4.*(X(1)+X(2))
      X(2) = TSQRT2*(X(1)-X(2))
      X(1) = X1
      RETURN
  103 CALL COSQB1 (N,X,WSAVE,WSAVE(N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVBRAZ(N,UPX,UPY1,UPY2,ITPAT1,ITPAT2,RSIZE)

      REAL      UPX(*),UPY1(*),UPY2(*)

      LOGICAL   LMISS, LXUNI, LYC1, LYC2
      CHARACTER COBJ*80

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UVBRAZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','UVBRAZ','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LT.0) THEN
        CALL MSGDMP('E','UVBRAZ','TONE PAT. INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UVBRAZ','BAR SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UVBRAZ','BAR SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP)
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      CALL STFPR2(0., 0., RX0, RY0)
      CALL STFPR2(0., 1., RX1, RY1)
      CALL STFPR2(1., 0., RX2, RY2)

      ROT = (RX2-RX0)*(RY1-RY0) - (RY2-RY0)*(RX1-RX0)

      IRMODE = 0
      IF (ROT.GT.0) THEN
        IRMODR = IRMODE
      ELSE
        IRMODR = MOD(IRMODE+1, 2)
      END IF

      WRITE(COBJ,'(2I8,F8.5)') ITPAT1, ITPAT2, RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVBRAZ',COBJ)

      LXUNI = UPX(1).EQ.RUNDEF
      LYC1  = UPY1(1).EQ.RUNDEF
      LYC2  = UPY2(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/(N-1)
      END IF

      IF (LYC1 .OR. LYC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LXUNI) THEN
          UXX = UXMIN + DX*(I-1)
        ELSE
          UXX = UPX(I)
        END IF

        IF (LYC1) THEN
          UYY1 = UREF
        ELSE
          UYY1 = UPY1(I)
        END IF

        IF (LYC2) THEN
          UYY2 = UREF
        ELSE
          UYY2 = UPY2(I)
        END IF

        IF (.NOT.
     #    ((UXX.EQ.RMISS .OR. UYY1.EQ.RMISS .OR. UYY2.EQ.RMISS)
     #     .AND. LMISS)) THEN

          CALL STFTRF(UXX, UYY1, VXX, VY1)
          CALL STFTRF(UXX, UYY2, VXX, VY2)

          IF (UYY2 .GT. UYY1) THEN
            CALL SZSTNI(ITPAT1)
          ELSE
            CALL SZSTNI(ITPAT2)
          END IF

          IF (VY1 .GT. VY2) THEN
            VYY = VY1
            VY1 = VY2
            VY2 = VYY
          END IF

          CALL SZOPTV
          CALL SZSTTV(VXX-RSIZE/2., VY1)
          CALL SZSTTV(VXX+RSIZE/2., VY1)
          CALL SZSTTV(VXX+RSIZE/2., VY2)
          CALL SZSTTV(VXX-RSIZE/2., VY2)
          CALL SZSTTV(VXX-RSIZE/2., VY1)
          CALL SZCLTV
        END IF
   20 CONTINUE

      CALL SWOCLS('UVBRAZ')

      END

!-----------------------------------------------------------------------
!     Copyright (c) 2002 GFD Dennou Club. All Rights Reserved.
!-----------------------------------------------------------------------
program many

  use dcl
  integer,parameter :: days=180
  type(dcl_date) :: date

    date%year = 1981
    date%month = 12
    date%day = 1

    call DclOpenGraphics

    call DclSetAxisFactor( 0.7 )
    call DclSetParm( 'ENABLE_LINEAR_OFFSET',.true.)

    call DclNewFrame

    call DclSetWindow( 0.0, real(days), 0.0, 100.0 )
    call DclSetViewPort( 0.4, 0.9, 0.3, 0.8 )
    call DclSetTransFunction

    call DclDrawViewPortFrame( 1 )

    call DclDrawAxisCalendar( 'b', date, nd=days )
    call DclShiftAxis( 'b' )
    call DclDrawAxis( 'b', 20.0, 10.0 )
    call DclDrawTitle( 'b', 'Day Number', 0.0 )
    call DclDrawAxisCalendar( 't', date, nd=days )

    call DclDrawAxis( 'lr', 10.0, 5.0 )
    call DclDrawTitle( 'l', 'Celsius Scale', 0.0 )
    call DclShiftAxis( 'l' )
    call DclSetParm( 'Y_AXIS_OFFSET', 273.15 )
    call DclSetParm( 'Y_AXIS_FACTOR', 1.0 )
    call DclDrawAxis( 'l', 10.0, 5.0 )
    call DclDrawTitle( 'l', 'Kelvin Scale', 0.0 )
    call DclShiftAxis( 'l' )
    call DclSetParm( 'Y_AXIS_OFFSET', 32.0 )
    call DclSetParm( 'Y_AXIS_FACTOR', 1.8 )
    call DclDrawAxis( 'l', 20.0, 10.0 )
    call DclDrawTitle( 'l', 'Fahrenheit Scale', 0.0 )

!    call DclDrawTitle( 't', '( AXIS:lofset=.true. )', 0.0 )
    call DclDrawTitle( 't', 'DclShiftXAxis', sw=2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2D3

      PARAMETER( NX=37, NY=37, MY=7 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL      P(NX,NY), UY1(NY), UY2(MY)
      CHARACTER CH(MY)*3

      DATA      CH/ 'SP ', '60S', '30S', 'EQ ', '30N', '60N', 'NP ' /

      DO 10 J=1,NY
      DO 10 I=1,NX
        ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
        ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
        SLAT = SIN(ALAT)
        UY1(J) = SLAT
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
   10 CONTINUE

      DO 20 J=1,MY
        UY2(J) = SIN( ( YMIN + (YMAX-YMIN)*(J-1)/(MY-1) ) * DRAD )
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, -1.,  1. )
      CALL GRSVPT(  0.2,  0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UXAXDV( 'B', 10., 60. )
      CALL UXAXDV( 'T', 10., 60. )
      CALL UXSTTL( 'B', 'LONGITUDE', 0. )

      CALL UYAXDV( 'L', 0.1, 0.5 )
      CALL UYSTTL( 'L', 'SINE LATITUDE', 0. )

      CALL UZLSET( 'LABELYR', .TRUE. )
      CALL UYAXLB( 'R', UY1, NY, UY2, CH, 3, MY )
      CALL UYSTTL( 'R', 'LATITUDE', 0. )

      CALL UWSGXB( XMIN, XMAX, NX )
      CALL UWSGYA( UY1, NY )

      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2D1

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL P(NX,NY)

      DO 10 J=1,NY
      DO 10 I=1,NX
        ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
        ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
        SLAT = SIN(ALAT)
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS
      CALL UDSFMT( '(F4.1)' )
      CALL UDGCLA( 0., 1.4, 0.2 )
      CALL UDSCLV( -1., 3, 4, 'abc', 0.028 )
      CALL UDDCLV( 0.6 )
      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     POLYMARKER PRIMITIVE (3-D)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZM3OP(ITYPE,INDEX,RSIZE)

      CHARACTER CSGI*1,COBJ*80

      COMMON    /SZBPM1/ LMISS,RMISS,NPM
      COMMON    /SZBPM2/ CMARK
      CHARACTER CMARK*1

      EXTERNAL  CSGI

      SAVE


      CALL GLLGET('LMISS',LMISS)
      CALL GLRGET('RMISS',RMISS)
      CALL SGRGET('PMFACT',PMF)
      CALL SGIGET('NPMSKIP',NPM)

      CMARK=CSGI(ITYPE)

      WRITE(COBJ,'(2I8,F8.5)') ITYPE,INDEX,RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('SZM3',COBJ)

      CALL SZTXOP(RSIZE*PMF,0,0,INDEX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZM3CL

      CALL SZTXCL

      CALL SWOCLS('SZM3')

      RETURN
      END

      PROGRAM LAY1

      PARAMETER( NMAX=401, JMAX=51 )
      REAL Y(NMAX), YY(JMAX)

*-- データ ----
      Y0 = 0.5
      DO 10 N=1,NMAX
        Y(N) = 5.*Y0 + 10.
        Y0   = 3.7*Y0*(1.-Y0)
   10 CONTINUE

      CALL GLRGET( 'RUNDEF', RUNDEF )

      CALL SWCSTX('FNAME','LAY1')
      CALL SWLSTX('LSEP',.TRUE.)

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SLDIV( 'Y', 3, 2 )

      DO 20 I=1,8
        CALL GRFRM

        IJMIN = (I-1)*(JMAX-1) + 1
        IJ = IJMIN
        DO 30 J=1,JMAX
          IJ = IJ + 1
          YY(J) = Y(IJ)
   30   CONTINUE
        XMIN = IJMIN + 1599
        XMAX =  XMIN + JMAX - 1

        CALL GRSWND( XMIN, XMAX, RUNDEF, RUNDEF )
        CALL USSTTL( 'TIME', 'YEAR', 'TEMPERATURE', 'DEG' )
        CALL USGRPH( JMAX, RUNDEF, YY )
   20 CONTINUE

      CALL GRCLS

      END

!----------------------------------------------
!  USpack Module
!----------------------------------------------
module uspack
  use dcl_common
  real, private :: xsec0, ysec0, xfac0, yfac0, xoff0, yoff0
  character(len=32) :: xttl0, yttl0, xuni0, yuni0
  private ::   SetFactor,  SetOffset,  SetSection,  SetTitle,  SetUnit, &
           & ResetFactor,ResetOffset,ResetSection,ResetTitle,ResetUnit
  contains

!----------------------------------------------------
    subroutine SetFactor(factor)
      call usrget('XFAC', xfac0)
      call usrget('YFAC', yfac0)
      call usrset('XFAC', factor)
      call usrset('YFAC', factor)
    end subroutine

    subroutine ResetFactor
      call uspset('XFAC', xfac0)
      call uspset('YFAC', yfac0)
    end subroutine

    subroutine SetOffset(offset)
      call usrget('XOFF', xoff0)
      call usrget('YOFF', yoff0)
      call usrset('XOFF', offset)
      call usrset('YOFF', offset)
    end subroutine

    subroutine SetTitle(title)
      character(len=*) :: title
      call uscget('CXTTL', xttl0)
      call uscget('CYTTL', yttl0)
      call uscset('CXTTL', title)
      call uscset('CYTTL', title)
    end subroutine

    subroutine SetUnit(unit)
      character(len=*) :: unit
      call uscget('CXUNIT', xuni0)
      call uscget('CYUNIT', yuni0)
      call uscset('CXUNIT', unit)
      call uscset('CYUNIT', unit)
    end subroutine

    subroutine ResetOffset
      call uspset('XOFF', xoff0)
      call uspset('YOFF', yoff0)
    end subroutine

    subroutine SetSection(section)
      call uzrget('UXUSER', xsec0)
      call uzrget('UYUSER', ysec0)
      call uzrset('UXUSER', section)
      call uzrset('UYUSER', section)
    end subroutine

    subroutine ResetSection
      call uzpset('UXUSER', xsec0)
      call uzpset('UYUSER', ysec0)
    end subroutine

    subroutine ResetTitle
      call uscset('CXTTL', xttl0)
      call uscset('CYTTL', yttl0)
    end subroutine

    subroutine ResetUnit
      call uscset('CXUNIT', xuni0)
      call uscset('CYUNIT', yuni0)
    end subroutine
!-------------------------------------------------------------------

    subroutine DclScalingPoint(x, y)
      real, dimension(:), intent(in), optional :: x, y

      call prcopn('DclScalingPoint')
      call glrget('rundef', rundef)

      if(present(x) .and. present(y)) then
        nx = size(x)
        ny = size(y)
        if(nx.ne.ny) call msgdmp('M', 'DclScalingPoint', 'Length of x and y don''t match.')
        n = min(nx, ny)
        call usspnt(n, x, y)
      else if(present(x)) then
        n = size(x)
        call usspnt(n, x, (/rundef/))
      else if(present(y)) then
        n = size(y)
        call usspnt(n, (/rundef/), y)
      end if
      
      call prccls('DclScalingPoint')
    end subroutine
!----------------------------------------------------
    subroutine DclSetTitle(xtitle, ytitle, xunit, yunit)
      character(len=*), intent(in) :: xtitle, ytitle, xunit,  yunit
      optional                     :: xtitle, ytitle, xunit,  yunit
 
      call prcopn('DclSetTitle')

      if(present(xtitle)) call uscset('cxttl' , xtitle)
      if(present(ytitle)) call uscset('cyttl' , ytitle)
      if(present(xunit )) call uscset('cxunit', xunit)
      if(present(yunit )) call uscset('cyunit', yunit)

      call prccls('DclSetTitle')
    end subroutine
!----------------------------------------------------
    subroutine DclFitScalingParm
      call prcopn('DclFitScalingParm')
      call uspfit
      call prccls('DclFitScalingParm')
    end subroutine
!----------------------------------------------------
    subroutine DclDrawScaledAxis(side,section)
      character(len=*), intent(in), optional :: side
      real, optional :: section

      call sgoopn('DclDrawScaledAxis', ' ')
      if(present(section)) call SetSection(section)

      if(present(side)) then; call usaxsc(side)
                        else; call usdaxs
      end if

      if(present(section)) call ResetSection
      call sgocls('DclDrawScaledAxis')
    end subroutine
!----------------------------------------------------
    subroutine DclDrawScaledGraph(x, y, type, index)
      real,    intent(in), dimension(:) :: x, y
      integer, intent(in), optional     :: type,  index
      integer                           :: type0, index0

      call sgoopn('DclDrawScaledGraph', ' ')
      call glrget('rundef', rundef)

      if(present(type)) then;   type0 = type
                        else;   call sgqplt(type0)
      end if
        
      if(present(index)) then;  index0 = index
                         else;  call sgqpli(index0)
      end if

      nx = size(x)
      ny = size(y)
      if(nx.ne.ny) call msgdmp('M', 'DclScalingPoint', 'Length of x and y don''t match.')
      n = min(nx, ny)

      call usspnt(n, x, y)
      call uspfit
      call grstrf
      call usdaxs
      call sgplzu(n, x, y, type0, index0)
      call sgocls('DclDrawScaledGraph')

    end subroutine
!----------------------------------
!   UXYZPACK 座標軸
!---------------------------------- 目盛とラベルの間隔を指定して座標軸を描く
    subroutine DclDrawAxis(side,dlabel,dtick, &
                         & title,unit,factor,offset,section) 
      character(len=*), intent(in) :: side !座標軸を描く場所
      real, intent(in) :: dlabel, dtick    !目盛およびラベルの間隔
      character(len=*), intent(in), optional :: title, unit
      real, intent(in), optional :: factor,offset,section

      call sgoopn('DclDrawAxis', ' ')

      if(present(factor))  call SetFactor(factor)
      if(present(offset))  call SetOffset(offset)
      write(6,*) 1
      if(present(section)) call SetSection(section)
      write(6,*) 2
      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      call usaxdv(side,dtick,dlabel)

      if(present(factor))  call ResetFactor
      if(present(offset))  call ResetOffset
      if(present(section)) call ResetSection
      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      call sgocls('DclDrawAxis')

    end subroutine
!---------------------------------- 目盛とラベルの場所を指定して座標軸を描く．
    subroutine DclDrawAxisSpecify(side,label_pos,tick_pos,label, &
                                & title, unit, factor, offset, section)
      character(len=*), intent(in) :: side       !座標軸を描く場所
      real, intent(in), dimension(:) :: label_pos       !大きめの目盛およびラベルの場所
      real, intent(in), dimension(:), optional :: tick_pos      !小さめの目盛の場所
      character(len=*), intent(in), dimension(:), optional :: label !ラベル
      character(len=*), intent(in), optional :: title, unit
      real, intent(in), optional :: factor, offset, section
      real,dimension(1) :: dummy

      call sgoopn('DclDrawAxisSpecify', ' ')

      if(present(factor))  call SetFactor(factor)
      if(present(offset))  call SetOffset(offset)
      if(present(section)) call SetSection(section)
      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      if (present(label)) then
        if(present(tick_pos)) then
          call usaxlb(side,tick_pos,size(tick_pos),label_pos,label,len(label(1)),size(label_pos))
        else
          call usaxlb(side, dummy, 0,label_pos,label,len(label(1)),size(label_pos))
        end if
      else
        if(present(tick_pos)) then
          call usaxnm(side,tick_pos,size(tick_pos),label_pos,size(label_pos))
        else
          call usaxnm(side, dummy,0,label_pos,size(label_pos))
        end if
      end if

      if(present(factor))  call ResetFactor
      if(present(offset))  call ResetOffset
      if(present(section)) call ResetSection
      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      call sgocls('DclDrawAxisSpecify')

    end subroutine
!---------------------------------- LOG 座標軸を描く．
    subroutine DclDrawAxisLog(side, nlabel, nticks, &
                            & title, unit, format, factor, section, label_pos)
      character(len=*), intent(in)  :: side       !座標軸を描く場所
      integer, intent(in)           :: nlabel, nticks
      integer, intent(in), optional :: format
      character(len=*), intent(in), optional :: title, unit
      real,    intent(in), optional :: factor, section
      real,    intent(in), dimension(:), optional :: label_pos
      real, dimension(9) :: xlb, ylb

      call sgoopn('DclDrawAxisLog', ' ')

      if(present(factor))  call SetFactor(factor)
      if(present(section)) call SetSection(section)
      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      if(present(format))  then
        call uliget('IXTYPE', ix0)
        call uliget('IYTYPE', iy0)
        call uliset('IXTYPE', format)
        call uliset('IYTYPE', format)
      end if

      if(present(label_pos)) then
        call ulqxbl (xlb, 9 )
        call ulqybl (ylb, 9 )
        call ulsxbl (label_pos, size(label_pos) )
        call ulsybl (label_pos, size(label_pos) )
      end if

      call usaxlg(side,nlabel,nticks)

      if(present(factor))  call ResetFactor
      if(present(section)) call ResetSection
      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      if(present(format))  then
        call uliset('IXTYPE', ix0)
        call uliset('IYTYPE', iy0)
      end if

      if(present(label_pos)) then
        call ulsxbl (xlb, 9 )
        call ulsybl (ylb, 9 )
      end if

      call sgocls('DclDrawAxisLog')

    end subroutine
!----------------------------------------
!   日付座標軸
!----------------------------------------
    subroutine DclDrawAxisCalendar (side,first_day, title, unit, type,nd) !日・月・年に関する座標軸を描く．
      character(len=*),  intent(in) :: side       !座標軸を書く場所を指定する
      type(dcl_date),    intent(in) :: first_day   !ucで0に相当する場所の日付を指定する
      character(len=*), intent(in), optional :: title, unit
      character(len=*),  intent(in), optional :: type        !年、月、日を YMD で指定する
      integer, optional, intent(in) :: nd          !作画する日数を指定する
      character(len=8)              :: type0

      call sgoopn('DclDrawAxisCalendar', ' ')

      jd = first_day%year*10000 + first_day%month*100 + first_day%day

      if(present(title))   call SetTitle(title)
      if(present(unit))    call SetUnit(unit)

      if(present(nd)) then; nd0 = nd
                      else; nd0 = 0
      end if

      if(present(type)) then; type0 = type
                        else; type0 = 'DMY'
      end if

      call usaxcl(side,jd,type0, nd0) 

      if(present(title))   call ResetTitle
      if(present(unit))    call ResetUnit

      call sgocls('DclDrawAxisCalendar')
    end subroutine
      
!----------------------------------
!   UXYZPACK 座標軸要素
!---------------------------------- タイトルを描く．
    subroutine DclDrawTitle(side,title,position,sw)
      character(len=*), intent(in) :: side     !座標軸を描く場所を指定する
      character(len=*), intent(in) :: title    !描くタイトル
      real,   optional, intent(in) :: position !位置:-1から+1の間の実数値
      integer,optional, intent(in) :: sw

      call sgoopn('DclDrawTitle', ' ')

      if(present(sw))       then;  isw=sw 
                            else;  isw=1
      end if

      if(present(position)) then;  pos=position 
                            else;  pos=0.
      end if

      call uspttl(side, isw, title, pos) 
      call sgocls('DclDrawTitle')
    end subroutine
!---------------------------------- 軸を示す線分を描く．
    subroutine DclDrawAxisLine(side,sw)
      character(len=*),  intent(in) :: side   !座標軸を描く場所を指定する
      integer, optional, intent(in) :: sw     !描く軸の属性を指定する

      call sgoopn('DclDrawAxisLine', ' ')

      if(present(sw)) then;  isw=sw 
                      else;  isw=1
      end if

      call uspaxs(side,isw)
      call sgocls('DclDrawAxisLine')
    end subroutine
!---------------------------------- 目盛を描く．
    subroutine DclDrawTickmark(side, position, sw)
      character(len=*), intent(in)        :: side      !目盛を描く座標軸の場所
      integer,   intent(in), optional     :: sw        !描く目盛の属性
      real,      intent(in), dimension(:) :: position  !目盛を描く場所
      integer                             :: isw

      call sgoopn('DclDrawTickmark', ' ')

      if(present(sw)) then;  isw=sw 
                      else;  isw=1
      end if
      call uxptmk(side, isw, position, size(position)) 
      call sgocls('DclDrawTickmark')
    end subroutine
!---------------------------------- 文字列で指定したラベルを描く
    subroutine DclDrawAxisLabel(side, position, label, sw)
      character(len=*), intent(in)               :: side     !ラベルを描く座標軸の場所
      real,             intent(in), dimension(:) :: position !ラベルを描く場所
      character(len=*), intent(in), dimension(:) :: label    !ラベル
      integer,          intent(in)               :: sw       !ラベルの属性
      optional :: label, sw

      call sgoopn('DclDrawAxisLabel', ' ')

      if(present(sw)) then;  isw=sw 
                      else;  isw=1
      end if

      if(present(label)) then
        call usplbl(side, isw, position, label, len(label(1)),size(position)) 
      else
        call uspnum(side, isw, position,size(position))
      end if 
      call sgocls('DclDrawAxisLabel')
    end subroutine
!---------------------------------- 軸をずらす。
    subroutine DclShiftAxis(side)
      character(len=*), intent(in) :: side

      call prcopn('DclShifAxis')
      call ussaxs(side)
      call prccls('DclShifAxis')
    end subroutine

end module
!-----------------------------------------------------------------------
program axis09

  use dcl

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( 1985.0, 1990.0, -2.0, +2.0 )
    call DclSetViewPort( 0.2, 0.8, 0.3, 0.7 )
    call DclSetTransNumber( DCL_UNI_UNI )
    call DclSetTransFunction

    call DclSetParm( 'AXIS:uyuser', 0.0 )
    call DclSetParm( 'AXIS:lbtwn', .true. )
    call uxsfmt( '(i4)' )
!    call DclSetXLabelFormat( '(i4)' )
    call DclDrawAxis( 'h', 1.0, 0.25, section=0.0 )
    call DclSetParm( 'AXIS:lbtwn', .false. )
    call DclDrawTitle( 'h', 'Year', +1.0 )

    call DclDrawAxis( 'l', 1.0, 0.25 )
    call DclDrawTitle( 'l', 'S.O.I.', 0.0 )

    call DclDrawTitle( 't', 'DclDrawXAxis', 0.0, 2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSWND(UXMIN, UXMAX, UYMIN, UYMAX)


      CALL SGRSET('UXMIN',UXMIN)
      CALL SGRSET('UXMAX',UXMAX)
      CALL SGRSET('UYMIN',UYMIN)
      CALL SGRSET('UYMAX',UYMAX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQWND(UXMIN, UXMAX, UYMIN, UYMAX)

      CALL SGRGET('UXMIN',UXMIN)
      CALL SGRGET('UXMAX',UXMAX)
      CALL SGRGET('UYMIN',UYMIN)
      CALL SGRGET('UYMAX',UYMAX)

      RETURN
      END

*-----------------------------------------------------------------------
*     UMPQNP / UMPQID / UMPQCP / UMPQVL / UMPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 20)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'INDEXMJ ' /, ITYPE( 1) / 1 /
      DATA      CPARAS( 2) / 'INDEXMN ' /, ITYPE( 2) / 1 /
      DATA      CPARAS( 3) / 'ITYPEMJ ' /, ITYPE( 3) / 1 /
      DATA      CPARAS( 4) / 'ITYPEMN ' /, ITYPE( 4) / 1 /
      DATA      CPARAS( 5) / 'DGRIDMJ ' /, ITYPE( 5) / 3 /
      DATA      CPARAS( 6) / 'DGRIDMN ' /, ITYPE( 6) / 3 /
      DATA      CPARAS( 7) / 'DGRPLMJ ' /, ITYPE( 7) / 3 /
      DATA      CPARAS( 8) / 'DGRPLMN ' /, ITYPE( 8) / 3 /
      DATA      CPARAS( 9) / 'LGRIDMJ ' /, ITYPE( 9) / 2 /
      DATA      CPARAS(10) / 'LGRIDMN ' /, ITYPE(10) / 2 /
      DATA      CPARAS(11) / 'INDEXBND' /, ITYPE(11) / 1 /
      DATA      CPARAS(12) / 'MAXBND  ' /, ITYPE(12) / 1 /
      DATA      CPARAS(13) / 'IGROUP  ' /, ITYPE(13) / 1 /
      DATA      CPARAS(14) / 'INDEXOUT' /, ITYPE(14) / 1 /
      DATA      CPARAS(15) / 'ITYPEOUT' /, ITYPE(15) / 1 /
      DATA      CPARAS(16) / 'LGLOBE  ' /, ITYPE(16) / 2 /
      DATA      CPARAS(17) / 'LWHINT  ' /, ITYPE(17) / 2 /
      DATA      CPARAS(18) / 'IPATLAND' /, ITYPE(18) / 1 /
      DATA      CPARAS(19) / 'IPATLAKE' /, ITYPE(19) / 1 /
      DATA      CPARAS(20) / 'LFILLAKE' /, ITYPE(20) / 2 /

*     / LONG NAME /

      DATA      CPARAL( 1) / 'MAP_MAJOR_LINE_INDEX' /
      DATA      CPARAL( 2) / 'MAP_MINOR_LINE_INDEX' /
      DATA      CPARAL( 3) / 'MAP_MAJOR_LINE_TYPE' /
      DATA      CPARAL( 4) / 'MAP_MINOR_LINE_TYPE' /
      DATA      CPARAL( 5) / 'MAP_MAJOR_LINE_INTERVAL' /
      DATA      CPARAL( 6) / 'MAP_MINOR_LINE_INTERVAL' /
      DATA      CPARAL( 7) / 'MAP_MAJOR_LINE_POLAR_LIMIT' /
      DATA      CPARAL( 8) / 'MAP_MINOR_LINE_POLAR_LIMIT' /
      DATA      CPARAL( 9) / 'ENABLE_MAP_MAJOR_LINE' /
      DATA      CPARAL(10) / 'ENABLE_MAP_MINOR_LINE' /
      DATA      CPARAL(11) / 'MAP_BOUNDARY_INDEX' /
      DATA      CPARAL(12) / 'MAP_BOUNDARY_LINE_MAX' /
      DATA      CPARAL(13) / '****IGROUP  ' /
      DATA      CPARAL(14) / 'MAP_OUTLINE_INDEX' /
      DATA      CPARAL(15) / 'MAP_OUTLINE_TYPE' /
      DATA      CPARAL(16) / 'ENABLE_GLOBAL_MAPPING' /
      DATA      CPARAL(17) / '----LWHINT  ' /
      DATA      CPARAL(18) / 'SHADE PATTERN ON LAND' /
      DATA      CPARAL(19) / 'SHADE PATTERN ON LAKE' /
      DATA      CPARAL(20) / 'ENABLE_PAINT_LAKE' /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UMPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UMPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UMPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','UMPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UMIQID(CPARAS(IDX), ID)
          CALL UMIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UMLQID(CPARAS(IDX), ID)
          CALL UMLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UMRQID(CPARAS(IDX), ID)
          CALL UMRQVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UMPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL UMIQID(CPARAS(IDX), ID)
          CALL UMISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL UMLQID(CPARAS(IDX), ID)
          CALL UMLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL UMRQID(CPARAS(IDX), ID)
          CALL UMRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','UMPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

program box

  use dcl
  integer,parameter :: n=30
    double precision a, r
  real,dimension(n+1) :: x
  real,dimension(n)   :: y

!---------------------------- data definition --------------------------

    r = 0.2d0
    a = 3.7d0
    x = (/ (1./n*(i-1), i=1,n+1) /)
    do i=1, n
      r = a*r*(1.d0-r)
      y(i) = r
    end do
    y(n/2) = 999.
    call DclSetParm( 'GLOBAL:LMISS', .true.)

!----------------------------- graph -----------------------------------

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( xmin=0., xmax=1. )
    call DclScalingPoint( y=y )
    call DclFitScalingParm
    call DclSetTransFunction

    call DclDrawScaledAxis

    call DclDrawYBoxLine( x, y )

    call DclNewFrame

    call DclSetWindow( ymin=0., ymax=1. )
    call DclScalingPoint( x=y )
    call DclFitScalingParm
    call DclSetTransFunction

    call DclDrawScaledAxis

    call DclDrawXBoxLine( y, x )

    call DclCloseGraphics

end program

!-------------------------------------------------
!interface module of gnmlib
!-------------------------------------------------
module gnm_interface
  interface
!-----------------------------------------------------------------
    subroutine gnlt(rx,bx,ip)                     !与えた実数値より小さいきりのよい数のうちで最大/最小のものを求める． 結果はbx 10^ipの形で返される．
      real,      intent(in) :: rx                 !調べる実数値
      real,      intent(out) :: bx                !きりのよい数の仮数部
      integer,   intent(out) :: ip                !きりのよい数の指数部
    end subroutine
      
    subroutine gngt(rx,bx,ip)                     !与えた実数値より大きいきりのよい数のうちで最大/最小のものを求める． 結果はbx 10^ipの形で返される．
      real,      intent(in) :: rx                 !調べる実数値
      real,      intent(out) :: bx                !きりのよい数の仮数部
      integer,   intent(out) :: ip                !きりのよい数の指数部
    end subroutine
      
    subroutine gnle(rx,bx,ip)                     !与えた実数値以下のきりのよい数のうちで最大/最小のものを求める． 結果はbx 10^ipの形で返される．
      real,      intent(in) :: rx                 !調べる実数値
      real,      intent(out) :: bx                !きりのよい数の仮数部
      integer,   intent(out) :: ip                !きりのよい数の指数部
    end subroutine
      
    subroutine gnge(rx,bx,ip)                     !与えた実数値以上のきりのよい数のうちで最大/最小のものを求める． 結果はbx 10^ipの形で返される．
      real,      intent(in) :: rx                 !調べる実数値
      real,      intent(out) :: bx                !きりのよい数の仮数部
      integer,   intent(out) :: ip                !きりのよい数の指数部
    end subroutine
      
    subroutine gnsblk(xb,nb)                      !きりのよい数のリストを設定/参照する．
      real,      intent(in),dimension(*) :: xb    !きりのよい数を昇順に納めた実数型配列．
      integer,   intent(in) :: nb                 !配列の寸法
    end subroutine
      
    subroutine gnqblk(xb,nb)                      !きりのよい数のリストを参照する．
      real,      intent(out),dimension(*) :: xb   !きりのよい数を昇順に納めた実数型配列
      integer,   intent(in) :: nb                 !配列の寸法
    end subroutine
      
    subroutine gnsave()                           !現在設定されているきりのよい数のリストを保存する
    end subroutine
      
    subroutine gnrset()                           !現在設定されているきりのよい数のリストを 保存してあったリストで再設定する．
    end subroutine
!-----------------------------------------------------------------      
    function rgnlt(rx)                            !きりのよい数を求める．
      real,      intent(in) :: rx                 !調べる実数値
      real rgnlt                                  !rxより小さいきりのよい数のうちで 最大のものを与える関数値．
    end function
      
    function rgnle(rx)                            !きりのよい数を求める．
      real,      intent(in) :: rx                 !調べる実数値
      real rgnle                                  !rx以下のきりのよい数のうちで 最大のものを与える関数値．
    end function
      
    function rgngt(rx)                            !きりのよい数を求める．
      real,      intent(in) :: rx                 !調べる実数値
      real rgngt                                  !rxより大きいきりのよい数のうちで 最小のものを与える関数値
    end function
      
    function rgnge(rx)                            !きりのよい数を求める．
      real,      intent(in) :: rx                 !調べる実数値
      real rgnge                                  !rx以上のきりのよい数のうちで 最小のものを与える関数値．
    end function

  end interface
end module
!gnmlib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHDIFZ(N,UPX1,UPX2,UPY,ITPAT1,ITPAT2)

      REAL      UPX1(*),UPX2(*),UPY(*)

      LOGICAL   LMISS, LYUNI, LXC1, LXC2
      CHARACTER COBJ*80

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UHDIFZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','UHDIFZ','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LT.0) THEN
        CALL MSGDMP('E','UHDIFZ','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP)
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      CALL STFPR2(0., 0., RX0, RY0)
      CALL STFPR2(0., 1., RX1, RY1)
      CALL STFPR2(1., 0., RX2, RY2)

      ROT = (RX2-RX0)*(RY1-RY0) - (RY2-RY0)*(RX1-RX0)

      IF (ROT.GT.0) THEN
        IR = 0
      ELSE
        IR = 1
      END IF

      WRITE(COBJ,'(2I8)') ITPAT1, ITPAT2
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHDIFZ',COBJ)

      LYUNI = UPY(1).EQ.RUNDEF
      LXC1  = UPX1(1).EQ.RUNDEF
      LXC2  = UPX2(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/(N-1)
      END IF

      IF (LXC1 .OR. LXC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N-1
        IF (LYUNI) THEN
          UYP = UYMIN + DY*(I-1)
          UYN = UYMIN + DY*I
        ELSE
          UYP = UPY(I)
          UYN = UPY(I+1)
        END IF

        IF (LXC1) THEN
          UX1P = UREF
          UX1N = UREF
        ELSE
          UX1P = UPX1(I)
          UX1N = UPX1(I+1)
        END IF

        IF (LXC2) THEN
          UX2P = UREF
          UX2N = UREF
        ELSE
          UX2P = UPX2(I)
          UX2N = UPX2(I+1)
        END IF

        IF (.NOT.
     #    ((UYP .EQ.RMISS .OR. UYN .EQ.RMISS .OR.
     #      UX1P.EQ.RMISS .OR. UX1N.EQ.RMISS .OR.
     #      UX2P.EQ.RMISS .OR. UX2N.EQ.RMISS) .AND. LMISS)) THEN

          CALL STFTRF(UX1P, UYP, VX1P, VYP)
          CALL STFTRF(UX2P, UYP, VX2P, VYP)
          CALL STFTRF(UX1N, UYN, VX1N, VYN)
          CALL STFTRF(UX2N, UYN, VX2N, VYN)

          IF ((VX2P-VX1P)*(VX2N-VX1N) .GE. 0) THEN
            IF (VX2P.GE.VX1P) THEN
              IRMODE = 0
            ELSE
              IRMODE = 1
            END IF
            IRMODR = MOD(IRMODE+IR, 2)

            IF (UX2P .GT. UX1P) THEN
              CALL SZSTNI(ITPAT1)
            ELSE
              CALL SZSTNI(ITPAT2)
            END IF

            CALL SZOPTV
            CALL SZSTTV(VX1P, VYP)
            CALL SZSTTV(VX2P, VYP)
            CALL SZSTTV(VX2N, VYN)
            CALL SZSTTV(VX1N, VYN)
            CALL SZSTTV(VX1P, VYP)
            CALL SZCLTV
          ELSE
            DXP = ABS(VX2P-VX1P)
            DXN = ABS(VX2N-VX1N)
            VYC = (VYP*DXN  + VYN*DXP ) / (DXP + DXN)
            VXC = (VX1P*DXN + VX1N*DXP) / (DXP + DXN)

            IF (VX2P.GE.VX1P) THEN
              IRMODE = 0
            ELSE
              IRMODE = 1
            END IF
            IRMODR = MOD(IRMODE+IR, 2)

            IF (UX2P .GT. UX1P) THEN
              CALL SZSTNI(ITPAT1)
            ELSE
              CALL SZSTNI(ITPAT2)
            END IF

            CALL SZOPTV
            CALL SZSTTV(VX1P, VYP)
            CALL SZSTTV(VX2P, VYP)
            CALL SZSTTV(VXC , VYC )
            CALL SZSTTV(VX1P, VYP)
            CALL SZCLTV

            IRMODE = MOD(IRMODE+1,  2)
            IRMODR = MOD(IRMODE+IR, 2)

            IF (UX2N .GT. UX1N) THEN
              CALL SZSTNI(ITPAT1)
            ELSE
              CALL SZSTNI(ITPAT2)
            END IF

            CALL SZOPTV
            CALL SZSTTV(VX2N, VYN)
            CALL SZSTTV(VX1N, VYN)
            CALL SZSTTV(VXC , VYC )
            CALL SZSTTV(VX2N, VYN)
            CALL SZCLTV
          END IF
        END IF
   20 CONTINUE

      CALL SWOCLS('UHDIFZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM SGKSX3

      PARAMETER (NP=100)

      REAL      UX(NP), UY(NP)


      DO 10 I=1,NP
        UX(I)=I
        UY(I)=EXP(-I*0.03)*SIN(I*3.14/180*20)
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS
      IWS=+ABS(IWS)

      CALL SGOPN( IWS )

      CALL SLRAT( 2.0, 1.0 )
      CALL SLDIV( 'Y', 2, 1 )
      CALL SLMGN( 0.1, 0.1 ,0.1, 0.1 )

*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN WC.
*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN NDC.
*     TRANSFORMATION FUNCTION : LINEAR*LINEAR

      CALL SGFRM

      CALL SGSWND( 1.0, REAL(NP), -1.0, +1.0 )
      CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SLPWWR( 1 )

      CALL SGLNZU( 1.0, 0.0, REAL(NP), 0.0, 1 )
      CALL SGLNZU( 1.0, -1.0, 1.0, +1.0, 1 )

      CALL SGPLZU( NP, UX, UY, 2, 3 )
      CALL SGPMZU( NP, UX, UY, 5, 3, 0.02 )
      CALL SGTXZV( 0.5, 0.9, 'TEST1', 0.05, 0, 0, 3 )

*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN WC.
*     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN NDC.
*     TRANSFORMATION FUNCTION : LOG*LINEAR

      CALL SGFRM

      CALL SGSWND( 1.0, REAL(NP), -1.0, +1.0 )
      CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL SGSTRN( 3 )
      CALL SGSTRF

      CALL SLPWWR( 1 )

      CALL GLLSET( 'LMISS', .TRUE. )
      CALL SGISET( 'NPMSKIP' , 2 )
      UX( 5)=999.0
      UY(20)=999.0

      CALL SGLNZU( 1.0, 0.0, REAL(NP), 0.0, 1 )
      CALL SGLNZU( 1.0, -1.0, 1.0, +1.0, 1 )

      CALL SGPLZU( NP, UX, UY, 3, 3 )
      CALL SGPMZU( NP, UX, UY, 2, 3, 0.02 )
      CALL SGTXZV( 0.5, 0.9, 'TEST2', 0.05, 0, 0, 3 )

      CALL SGCLS

      END

program sample07

  use dcl
  integer,parameter :: nx=20, ny=20
  real,parameter :: xmin=-1., xmax=1., ymin=-1., ymax=1.
  real,dimension(0:nx,0:ny) :: u,v

!-- 変形場 ----

    do j=0,ny
      do i=0,nx
        x = xmin + (xmax-xmin)*i/nx
        y = ymin + (ymax-ymin)*j/ny
        u(i,j) =  0.8 * x           ! u =  a*x
        v(i,j) = -1.  * y           ! y = -b*y
      end do
    end do

!-- グラフ ----

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort( 0.2, 0.8, 0.2, 0.8 )
    call DclSetTransFunction

    call DclDrawScaledAxis

    call DclDrawVectors( u, v )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     SWPGET / SWPSET / SWPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40

      CALL SWPQID(CP, IDX)
      CALL SWPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPSET(CP, IPARA)

      CALL SWPQID(CP, IDX)
      CALL SWPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPSTX(CP, IPARA)

      IP = IPARA
      CALL SWPQID(CP, IDX)
      CALL SWPQIT(IDX, IT)
      CALL SWPQCP(IDX, CX)
      CALL SWPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('SW', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL SWIQID(CP, IDX)
        CALL SWISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('SW', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL SWLQID(CP, IDX)
        CALL SWLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('SW', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL SWRQID(CP, IDX)
        CALL SWRSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCPLZV(N,VPX,VPY,VPZ,INDEX)

      REAL      VPX(*),VPY(*),VPZ(*)


      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLZV','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPLZV','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPLZV','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZL3OP(INDEX)
      CALL SZL3ZV(N,VPX,VPY,VPZ)
      CALL SZL3CL

      END

*-----------------------------------------------------------------------
C     SUBROUTINE SINQI(N,WSAVE)
C
C     SUBROUTINE SINQI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH SINQF AND SINQB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED. THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH SINQF AND SINQB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF SINQF OR SINQB.
C
      SUBROUTINE SINQI (N,WSAVE)
      DIMENSION       WSAVE(*)
C
      CALL COSQI (N,WSAVE)
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHBRAZ(N,UPX1,UPX2,UPY,ITPAT1,ITPAT2,RSIZE)

      REAL      UPX1(*),UPX2(*),UPY(*)

      LOGICAL   LMISS, LYUNI, LXC1, LXC2
      CHARACTER COBJ*80

      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UHBRAZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','UHBRAZ','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LT.0) THEN
        CALL MSGDMP('E','UHBRAZ','TONE PAT. INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UHBRAZ','BAR SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UHBRAZ','BAR SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP)
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      CALL STFPR2(0., 0., RX0, RY0)
      CALL STFPR2(0., 1., RX1, RY1)
      CALL STFPR2(1., 0., RX2, RY2)

      ROT = (RX2-RX0)*(RY1-RY0) - (RY2-RY0)*(RX1-RX0)

      IRMODE = 0
      IF (ROT.GT.0) THEN
        IRMODR = IRMODE
      ELSE
        IRMODR = MOD(IRMODE+1, 2)
      END IF

      WRITE(COBJ,'(2I8,F8.5)') ITPAT1, ITPAT2, RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHBRAZ',COBJ)

      LYUNI = UPY(1).EQ.RUNDEF
      LXC1  = UPX1(1).EQ.RUNDEF
      LXC2  = UPX2(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/(N-1)
      END IF

      IF (LXC1 .OR. LXC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LYUNI) THEN
          UYY = UYMIN + DY*(I-1)
        ELSE
          UYY = UPY(I)
        END IF

        IF (LXC1) THEN
          UXX1 = UREF
        ELSE
          UXX1 = UPX1(I)
        END IF

        IF (LXC2) THEN
          UXX2 = UREF
        ELSE
          UXX2 = UPX2(I)
        END IF

        IF (.NOT.
     #    ((UYY.EQ.RMISS .OR. UXX1.EQ.RMISS .OR. UXX2.EQ.RMISS)
     #     .AND. LMISS)) THEN

          CALL STFTRF(UXX1, UYY, VX1, VYY)
          CALL STFTRF(UXX2, UYY, VX2, VYY)

          IF (UXX2 .GT. UXX1) THEN
            CALL SZSTNI(ITPAT1)
          ELSE
            CALL SZSTNI(ITPAT2)
          END IF

          IF (VX1 .GT. VX2) THEN
            VXX = VX1
            VX1 = VX2
            VX2 = VXX
          END IF

          CALL SZOPTV
          CALL SZSTTV(VX1, VYY+RSIZE/2.)
          CALL SZSTTV(VX1, VYY-RSIZE/2.)
          CALL SZSTTV(VX2, VYY-RSIZE/2.)
          CALL SZSTTV(VX2, VYY+RSIZE/2.)
          CALL SZSTTV(VX1, VYY+RSIZE/2.)
          CALL SZCLTV
        END IF
   20 CONTINUE

      CALL SWOCLS('UHBRAZ')

      END

*-----------------------------------------------------------------------
      SUBROUTINE CFFTI1 (N,WA,IFAC)
      DIMENSION       WA(*)      ,IFAC(*)    ,NTRYH(4)
      EXTERNAL RFPI
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/3,4,2,5/
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 2.*RFPI()
      ARGH = TPI/FLOAT(N)
      I = 2
      L1 = 1
      DO 110 K1=1,NF
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IDOT = IDO+IDO+2
         IPM = IP-1
         DO 109 J=1,IPM
            I1 = I
            WA(I-1) = 1.
            WA(I) = 0.
            LD = LD+L1
            FI = 0.
            ARGLD = FLOAT(LD)*ARGH
            DO 108 II=4,IDOT,2
               I = I+2
               FI = FI+1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IF (IP .LE. 5) GO TO 109
            WA(I1-1) = WA(I-1)
            WA(I1) = WA(I)
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END

!-------------------------------------------------
!  BLKlib Module
!-------------------------------------------------
module blklib
  use dcl_common
  contains

    function DclIntervalLT(bounds,value)
      real, intent(in), dimension(:) :: bounds 
      real, intent(in)               :: value 
      integer                        :: DclIntervalLT

      call prcopn('DclIntervalLT')
      DclIntervalLT = iblklt(bounds,n,value)
      call prccls('DclIntervalLT')
    end function
      
    function DclIntervalLE(bounds,value)
      real, intent(in), dimension(:) :: bounds
      real, intent(in)               :: value
      integer                        :: DclIntervalLE

      call prcopn('DclIntervalLE')
      DclIntervalLE = iblkle(bounds,n,value) 
      call prccls('DclIntervalLE')
    end function
      
    function DclIntervalGT(bounds,value)
      real, intent(in), dimension(:) :: bounds
      real, intent(in)               :: value 
      integer                        :: DclIntervalGT

      call prcopn('DclIntervalGT')
      DclIntervalGT = iblkgt(bounds,n,value)
      call prccls('DclIntervalGT')
    end function
      
    function DclIntervalGE(bounds,value)
      real, intent(in), dimension(:) :: bounds
      real, intent(in)               :: value
      integer                        :: DclIntervalGE

      call prcopn('DclIntervalGE')
      DclIntervalGE = iblkge(bounds,n,value)
      call prccls('DclIntervalGE')
    end function

end module

!-------------------------------------------------
!  UMpack Module
!-------------------------------------------------
module umpack
  use dcl_common
  contains
!以下の２つは見当たらない
!UMQCNT(XCNT, YCNT, ROT)				DclGetMapContactPoint
!UMQCWD(XCNTR, YCNTR, R)				DclGetCircleWindow

!-------------------------------------------------
    subroutine DclSetMapContactPoint(lon, lat, rot)  !投影面の「接点」を指定する．
      real, intent(in), optional :: lon, lat, rot 

      call prcopn('DclSetMapContactPoint')
      call glrget('rundef', rundef)

      x0   = rundef
      y0   = rundef
      rot0 = rundef

      if(present(lon))  x0   = lon
      if(present(lat))  y0   = lat
      if(present(rot))  rot0 = rot
      
      call umscnt(x0, y0, rot0) 
      call prccls('DclSetMapContactPoint')
    end subroutine
!-------------------------------------------------
    subroutine DclSetCircleWindow(lon, lat, r)  !円形のウィンドウを設定する．
      real,intent(in), optional :: lon, lat, r  

      call prcopn('DclSetCircleWindow')
      call glrget('rundef', rundef)

      x0 = rundef
      y0 = rundef
      r0 = rundef

      if(present(lon)) x0 = lon
      if(present(lat)) y0 = lat
      if(present(r))   r0 = r
      
      call umscwd(x0, y0, r0) 
      call prccls('DclSetCircleWindow')
    end subroutine
!-------------------------------------------------
    subroutine DclSetMapPoint(lon, lat)        !地図に含める点を指定する．
      real, intent(in), dimension(:) :: lon, lat  !点の経度，緯度

      call prcopn('DclSetMapPoint')
      nx = size(lon)
      ny = size(lat)

      if(nx.ne.ny) call msgdmp('M', 'DclSetMapPoint', 'Length of x and y don''t match.')

      n = min(nx, ny)
      call umspnt(n, lon, lat)
      call prccls('DclSetMapPoint')
    end subroutine
!-------------------------------------------------
    subroutine DclFitMapParm()         !地図投影の変換関数のパラメタを適切に決める．
      call prcopn('DclFitMapParm')
      call umpfit() 
      call prccls('DclFitMapParm')
    end subroutine
!-------------------------------------------------
    subroutine DclDrawGlobe()          !地図の境界線（縁）と緯度線,経度線を描く．
      call sgoopn('DclDrawGlobe', ' ')
      call umpglb() 
      call sgocls('DclDrawGlobe')
    end subroutine
!-------------------------------------------------
    subroutine DclDrawGrid()           !緯度線・経度線を描く．
      call sgoopn('DclDrawGrid', ' ')
      call umpgrd()  
      call sgocls('DclDrawGrid')
    end subroutine
!-------------------------------------------------
    subroutine DclDrawLimb()           !地図の境界線（縁）を描く．
      call sgoopn('DclDrawLimb', ' ')
      call umplim()
      call sgocls('DclDrawLimb')
    end subroutine
!-------------------------------------------------
    subroutine DclDrawMap(file_name)        !各種地図情報を描く．
      character(len=*), intent(in) :: file_name        !地図情報ファイル名
      call sgoopn('DclDrawMap', ' ')
      call umpmap(file_name)
      call sgocls('DclDrawMap')
    end subroutine
!-------------------------------------------------
    subroutine DclFillMap(file_name)        !陸地塗り潰し
      character(len=*), intent(in) :: file_name        !地図情報ファイル名
      call sgoopn('DclFillMap', ' ')
      call umfmap(file_name)
      call sgocls('DclFillMap')
    end subroutine
!-------------------------------------------------
end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DCLTON

      PARAMETER (NP=5)
      PARAMETER (XMIN=0.08,XMAX=0.98,YMIN=0.04,YMAX=0.94)
      PARAMETER (DX=(XMAX-XMIN)/6,DY=(YMAX-YMIN)/6)

      REAL      XBOX(NP),YBOX(NP)
      CHARACTER CHR*2,CTTL*16,CPARA*4,CFMT*4

      DATA      XBOX/ 0.0, 1.0, 1.0, 0.0, 0.0/
      DATA      YBOX/ 0.0, 0.0, 1.0, 1.0, 0.0/


      CALL OSQARN(NPR)
      IF (NPR.EQ.0) THEN
        CALL GLIGET('IIUNIT',II)
        CALL GLIGET('IOUNIT',IO)
        WRITE(IO,*) ' TONE PATTERN (0-6) (I) ? ;'
        READ(II,*) N
      ELSE
        CALL OSGARG(1,CPARA)
        CFMT='(I#)'
        CALL CHNGI(CFMT,'#',LENC(CPARA),'(I1)')
        READ(CPARA,CFMT) N
      END IF

      CALL SWISTX('IWIDTH ',600)
      CALL SWISTX('IHEIGHT',600)

      CTTL='DCLTONE (#)'
      CALL CHNGI(CTTL,'#',N,'(I1)')
      CALL CLOWER(CTTL)
      CALL SWCSTX('TITLE',CTTL)

      CALL GLISTX('MAXMSG',0)
      CALL SGISTX('IFONT',2)
      CALL SGLSTX('LCORNER',.FALSE.)

      CALL GROPN(1)
      CALL SGFRM
      CALL SGSWND(0.0,1.0,0.0,1.0)
      CALL SGSTRN(1)

      DO 20 J=0,5
        DO 10 I=0,5
          X1=XMIN+DX*I
          X2=X1+DX*0.9
          Y1=YMIN+DY*(5-J)
          Y2=Y1+DY*0.9
          LEVEL=I+J*10+N*100
          CALL SGSVPT(X1,X2,Y1,Y2)
          CALL SGSTRF
          CALL SGTNZU(NP,XBOX,YBOX,LEVEL)
          CALL SGPLZU(NP,XBOX,YBOX,1,1)
   10   CONTINUE
   20 CONTINUE

      CALL SGSVPT(0.0,1.0,0.0,1.0)
      CALL SGSTRF

      DO 30 I=0,5
        XX=XMIN+DX*(I+0.45)
        YY=(1+YMAX)/2
        WRITE(CHR,'(I1)') I
        CALL SGTXZV(XX,YY,CHR,0.025,0,0,1)
   30 CONTINUE

      DO 40 J=0,5
        XX=XMIN/2
        YY=YMIN+DY*(5-J+0.45)
        WRITE(CHR,'(I2)') J*10
        CALL SGTXZV(XX,YY,CHR,0.025,0,0,1)
   40 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGCLST(ccfile)

      parameter (maxcli = 256)

      character ccfile*(*)
      character cmsg*64

      INTEGER ir(maxcli),ig(maxcli),ib(maxcli)

      iu = iufopn()
      open(iu, file=ccfile)
      read(iu, '(i3)') max_pal
      if (max_pal.gt. maxcli) then
        max_pal = maxcli
        cmsg='color numbers greater than xx are ignored.'
        write(cmsg(28:29),'(i2)') nplmax
        call msgdmp('w', 'zmdopn', cmsg)
      endif

      ns = 2**8
      do i=1, max_pal
        read(iu, '(3i6)') ir0, ig0, ib0
        ir(i) = ir0 / ns
        ig(i) = ig0 / ns
        ib(i) = ib0 / ns
      end do

      close(iu)

      RETURN

*------------------------------------------------------------------------
      ENTRY SGQCL(NUM,NR,NG,NB)

      NR=IR(NUM+1)
      NG=IG(NUM+1)
      NB=IB(NUM+1)

      RETURN

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2D4

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      PARAMETER( KXMN=9, KXMX=33, KYMN=7, KYMX=31 )
      REAL P(NX,NY), ALON(NX), ALAT(NY)

       DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
   10 CONTINUE
      DO 20 J=1,NY
        ALAT(J) = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
   20 CONTINUE

      DO 30 J=1,NY
        SLAT = SIN(ALAT(J)*DRAD)
      DO 30 I=1,NX
        P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON(I)*DRAD)
     +         - 0.5*(3*SLAT**2-1)
   30 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( ALON(KXMN), ALON(KXMX), ALAT(KYMN), ALAT(KYMX) )
      CALL GRSVPT(        0.2,        0.8,        0.2,        0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS
      CALL UDCNTR( P(KXMN,KYMN), NX, KXMX-KXMN+1, KYMX-KYMN+1 )

      CALL GRCLS

      END

      PROGRAM TMPK3
      IMPLICIT NONE
      INTEGER NX, NY, THRES
      PARAMETER (NX=101, NY=101, THRES=1)
      REAL DX, DY, DXT, DYT
C      PARAMETER (DX=6.2832/REAL(NX-1), DY=3.14159/REAL(NY-1))
      PARAMETER (DX=6.2832/REAL(NX-1), DY=1.57079/REAL(NY-1))
      PARAMETER (DXT=360.0/REAL(NX-1), DYT=90.0/REAL(NY-1))
      REAL ARROW_THRES
      PARAMETER (ARROW_THRES=1.0)
      REAL U(NX,NY), V(NX,NY)
      REAL X(NX), Y(NY)
      REAL XT(NX), YT(NY)
      INTEGER I, J, SKIP, IWS
    
      WRITE(*,*) "SKIP NUM INPUT"
      READ(*,*) SKIP

      X=(/(DX*REAL(I-1),I=1,NX)/)
      Y=(/(DY*REAL(I-1-NY/2),I=1,NY)/)
      XT=(/(DXT*REAL(I-1),I=1,NX)/)
      YT=(/(DYT*REAL(I-1-NY/2),I=1,NY)/)

      WRITE(*,*) "Y, YT", Y(1), Y(NY), YT(1), YT(ny)
      DO 21 J=1,NY
         DO 20 I=1,NX
            U(I,J)=-COS(Y(J))
            V(I,J)=COS(X(I))
 20      CONTINUE
 21   CONTINUE
    
      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM
      CALL GRSWND( XT(1), XT(NX), YT(1), YT(NY) )
      CALL GRSVPT( 0.05, 0.95, 0.1, 0.9 )
      CALL SGSTRN( 10 )
C      CALL USPFIT
      CALL UMPFIT
      CALL GRSTRF

      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB

C      CALL UETONF( U, NX, NX, NY )
C      CALL UDCNTR( V, NX, NX, NY )
C-- 流線描画
      CALL TMLSET( 'PERIODX', .TRUE. )
      CALL TMISET( 'SKIPINTV', SKIP )
      CALL TMSTLS( XT, YT, U, V, NX, NY )

      CALL GRCLS

      END PROGRAM

**-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWQFNM(CPARA,CFNAME)

      CHARACTER CPARA*(*),CFNAME*(*)

      PARAMETER (MAXP=3,MAXF=3)

      LOGICAL   LCHREQ
      CHARACTER CPLIST(MAXP)*1024,CFLIST(MAXF)*1024,CPX*1024,
     +          CX11*4,CPSX*4,CMSG*1024

      EXTERNAL  LENC,LCHREQ

      CPLIST(1)=' '
      CALL GLCGET('DUPATH',CPLIST(2))
      CALL GLCGET('DSPATH',CPLIST(3))
      NP=3

      CALL SWCGET(CPARA,CPX)
      LCP=LENC(CPX)
      CALL SWIGET('IWS',IWS)
      CX11='.X11'
      CALL CLOWER(CX11)
      CPSX='.PSX'
      CALL CLOWER(CPSX)

      IF (      LCHREQ(CPARA,'FONT1')
     +     .OR. LCHREQ(CPARA,'FONT2')
     +     .OR. LCHREQ(CPARA,'CL2TN')
     +     .OR. LCHREQ(CPARA,'CMAPLIST')) THEN
        CFLIST(1)=CPX(1:LCP)
        NF=1
      ELSE IF ( LCHREQ(CPARA,'CLRMAP')
     +     .OR. LCHREQ(CPARA,'BITMAP')) THEN
        IF (IWS.EQ.2 .OR. IWS.EQ.3) THEN
          CFLIST(1)=CPX(1:LCP)//CPSX
          CFLIST(2)=CPX(1:LCP)
          CFLIST(3)=CPX(1:LCP)//CX11
        ELSE
          CFLIST(1)=CPX(1:LCP)//CX11
          CFLIST(2)=CPX(1:LCP)
          CFLIST(3)=CPX(1:LCP)//CPSX
        END IF
        NF=3
      ELSE
        CMSG='PARAMETER NAME <'//CPARA(1:LENC(CPARA))//'> IS INVALID.'
        CALL MSGDMP('E','SWQFNM',CMSG)
      END IF
      CALL CFSRCH(CPLIST,NP,CFLIST,NF,CFNAME)

      END

*-----------------------------------------------------------------------
*     RUDLEV
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      REAL FUNCTION RUDLEV(NLEV)

      CHARACTER CLV1*8,CLV2*8


      CALL UDQCLN(NLEVZ)
      IF (.NOT.(2.LE.NLEVZ)) THEN
        CALL MSGDMP('W','IUDLEV',
     +       'NO. OF CONTOUR LEVELS IS LESS THAN 2.')
        RUDLEV=0
        RETURN
      END IF
      IF (.NOT.(1.LE.NLEV .AND. NLEV.LE.NLEVZ-1)) THEN
        CALL MSGDMP('W','IUDLEV','NLEV IS OUT OF RANGE.')
        RUDLEV=0
        RETURN
      END IF

      CALL UDQCLV(ZLEV1,INDX1,ITYP1,CLV1,HL1,NLEV  )
      CALL UDQCLV(ZLEV2,INDX2,ITYP2,CLV2,HL2,NLEV+1)
      RUDLEV=ZLEV2-ZLEV1

      END

*-----------------------------------------------------------------------
*     TMPGET / TMPSET / TMPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE TMPGET(CP, IPARA)
      IMPLICIT NONE

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40

      INTEGER   IT, IP, IPARA, IDX

      CALL TMPQID(CP, IDX)
      CALL TMPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPSET(CP, IPARA)

      CALL TMPQID(CP, IDX)
      CALL TMPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY TMPSTX(CP,IPARA)

      IP = IPARA
      CALL TMPQID(CP, IDX)
      CALL TMPQIT(IDX, IT)
      CALL TMPQCP(IDX, CX)
      CALL TMPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('TM', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL TMIQID(CP, IDX)
        CALL TMISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('TM', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL TMLQID(CP, IDX)
        CALL TMLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('TM', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL TMRQID(CP, IDX)
        CALL TMRSVL(IDX, IP)
      END IF

      RETURN
      END

module dcl_parm
  use dcl_common

  interface DclGetParm
    module procedure DclGetIntegerS, DclGetRealS, DclGetLogicalS, DclGetCharS
  end interface

  interface DclSetParm
    module procedure DclSetInteger, DclSetReal, DclSetLogical, DclSetChar
  end interface

  interface DclSetParmEx
    module procedure DclSetIntegerEX, DclSetRealEX, DclSetLogicalEX, DclSetCharEX
  end interface

!======================================================
  contains
    function DclGetInteger(name)
      integer                       :: DclGetInteger
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetInteger')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udiqin(name,idx)
          if(idx.ne.0) then
            call udiqvl(idx, DclGetInteger) ;  exit
          end if

          call ueiqin(name,idx)
          if(idx.ne.0) then
            call ueiqvl(idx, DclGetInteger) ;  exit
          end if

          call ugiqin(name,idx)
          if(idx.ne.0) then
            call ugiqvl(idx, DclGetInteger) ;  exit
          end if

          call usiqin(name,idx)
          if(idx.ne.0) then
            call usiqvl(idx, DclGetInteger) ;  exit
          end if

          call uziqin(name,idx)
          if(idx.ne.0) then
            call uziqvl(idx, DclGetInteger) ;  exit
          end if

          call uliqin(name,idx)
          if(idx.ne.0) then
            call uliqvl(idx, DclGetInteger) ;  exit
          end if

          call uciqin(name,idx)
          if(idx.ne.0) then
            call uciqvl(idx, DclGetInteger) ;  exit
          end if

          call umiqin(name,idx)
          if(idx.ne.0) then
            call umiqvl(idx, DclGetInteger) ;  exit
          end if

          call sgiqin(name,idx)
          if(idx.ne.0) then
            call sgiqvl(idx, DclGetInteger) ;  exit
          end if

          call swiqin(name,idx)
          if(idx.ne.0) then
            call swiqvl(idx, DclGetInteger) ;  exit
          end if

          call gliqin(name,idx)
          if(idx.ne.0) then
            call gliqvl(idx, DclGetInteger) ;  exit
          end if
          call msgdmp('E', 'DclGetInteger', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udiget(pname,DclGetInteger)
          case('HATCH'   ) ; call ueiget(pname,DclGetInteger)
          case('VECTOR'  ) ; call ugiget(pname,DclGetInteger)
          case('SCALE'   ) ; call usiget(pname,DclGetInteger)
          case('AXIS'    ) ; call uziget(pname,DclGetInteger)
          case('LOG'     ) ; call uliget(pname,DclGetInteger)
          case('CALENDAR') ; call uciget(pname,DclGetInteger)
          case('MAP'     ) ; call umiget(pname,DclGetInteger)
          case('GRAPH'   ) ; call sgiget(pname,DclGetInteger)
          case('DEVICE'  ) ; call swiget(pname,DclGetInteger)
          case('GLOBAL'  ) ; call gliget(pname,DclGetInteger)
          case default
            call msgdmp('E', 'DclGetInteger', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetInteger')

    end function
!------------------------------------------------------
    function DclGetReal(name)
      real                          :: DclGetReal
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetReal')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udrqin(name,idx)
          if(idx.ne.0) then
            call udrqvl(idx, DclGetReal) ;  exit
          end if

          call uerqin(name,idx)
          if(idx.ne.0) then
            call uerqvl(idx, DclGetReal) ;  exit
          end if

          call ugrqin(name,idx)
          if(idx.ne.0) then
            call ugrqvl(idx, DclGetReal) ;  exit
          end if

          call usrqin(name,idx)
          if(idx.ne.0) then
            call usrqvl(idx, DclGetReal) ;  exit
          end if

          call uzrqin(name,idx)
          if(idx.ne.0) then
            call uzrqvl(idx, DclGetReal) ;  exit
          end if

          call ulrqin(name,idx)
          if(idx.ne.0) then
            call ulrqvl(idx, DclGetReal) ;  exit
          end if

          call ucrqin(name,idx)
          if(idx.ne.0) then
            call ucrqvl(idx, DclGetReal) ;  exit
          end if

          call umrqin(name,idx)
          if(idx.ne.0) then
            call umrqvl(idx, DclGetReal) ;  exit
          end if

          call sgrqin(name,idx)
          if(idx.ne.0) then
            call sgrqvl(idx, DclGetReal) ;  exit
          end if

          call swrqin(name,idx)
          if(idx.ne.0) then
            call swrqvl(idx, DclGetReal) ;  exit
          end if

          call glrqin(name,idx)
          if(idx.ne.0) then
            call glrqvl(idx, DclGetReal) ;  exit
          end if
          call msgdmp('E', 'DclGetReal', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udrget(pname,DclGetReal)
          case('HATCH'   ) ; call uerget(pname,DclGetReal)
          case('VECTOR'  ) ; call ugrget(pname,DclGetReal)
          case('SCALE'   ) ; call usrget(pname,DclGetReal)
          case('AXIS'    ) ; call uzrget(pname,DclGetReal)
          case('LOG'     ) ; call ulrget(pname,DclGetReal)
          case('CALENDAR') ; call ucrget(pname,DclGetReal)
          case('MAP'     ) ; call umrget(pname,DclGetReal)
          case('GRAPH'   ) ; call sgrget(pname,DclGetReal)
          case('DEVICE'  ) ; call swrget(pname,DclGetReal)
          case('GLOBAL'  ) ; call glrget(pname,DclGetReal)
          case default
            call msgdmp('E', 'DclGetReal', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetReal')
    end function
!------------------------------------------------------
    function DclGetLogical(name)
      logical                       :: DclGetLogical
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetLogical')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udlqin(name,idx)
          if(idx.ne.0) then
            call udlqvl(idx, DclGetLogical) ;  exit
          end if

          call uelqin(name,idx)
          if(idx.ne.0) then
            call uelqvl(idx, DclGetLogical) ;  exit
          end if

          call uglqin(name,idx)
          if(idx.ne.0) then
            call uglqvl(idx, DclGetLogical) ;  exit
          end if

          call uslqin(name,idx)
          if(idx.ne.0) then
            call uslqvl(idx, DclGetLogical) ;  exit
          end if

          call uzlqin(name,idx)
          if(idx.ne.0) then
            call uzlqvl(idx, DclGetLogical) ;  exit
          end if

          call ullqin(name,idx)
          if(idx.ne.0) then
            call ullqvl(idx, DclGetLogical) ;  exit
          end if

          call uclqin(name,idx)
          if(idx.ne.0) then
            call uclqvl(idx, DclGetLogical) ;  exit
          end if

          call umlqin(name,idx)
          if(idx.ne.0) then
            call umlqvl(idx, DclGetLogical) ;  exit
          end if

          call sglqin(name,idx)
          if(idx.ne.0) then
            call sglqvl(idx, DclGetLogical) ;  exit
          end if

          call swlqin(name,idx)
          if(idx.ne.0) then
            call swlqvl(idx, DclGetLogical) ;  exit
          end if

          call gllqin(name,idx)
          if(idx.ne.0) then
            call gllqvl(idx, DclGetLogical) ;  exit
          end if
          call msgdmp('E', 'DclGetParm', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udlget(pname,DclGetLogical)
          case('HATCH'   ) ; call uelget(pname,DclGetLogical)
          case('VECTOR'  ) ; call uglget(pname,DclGetLogical)
          case('SCALE'   ) ; call uslget(pname,DclGetLogical)
          case('AXIS'    ) ; call uzlget(pname,DclGetLogical)
          case('LOG'     ) ; call ullget(pname,DclGetLogical)
          case('CALENDAR') ; call uclget(pname,DclGetLogical)
          case('MAP'     ) ; call umlget(pname,DclGetLogical)
          case('GRAPH'   ) ; call sglget(pname,DclGetLogical)
          case('DEVICE'  ) ; call swlget(pname,DclGetLogical)
          case('GLOBAL'  ) ; call gllget(pname,DclGetLogical)
          case default
            call msgdmp('E', 'DclGetLogical', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetLogical')
    end function
!------------------------------------------------------
    function DclGetChar(name)
      character(len=8)              :: DclGetChar
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetChar')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call uscqin(name,idx)
          if(idx.ne.0) then
            call uscqvl(idx, DclGetChar) ;  exit
          end if

          call uzcqin(name,idx)
          if(idx.ne.0) then
            call uzcqvl(idx, DclGetChar) ;  exit
          end if

          call swcqin(name,idx)
          if(idx.ne.0) then
            call swcqvl(idx, DclGetChar) ;  exit
          end if

          call glcqin(name,idx)
          if(idx.ne.0) then
            call glcqvl(idx, DclGetChar) ;  exit
          end if
          call msgdmp('E', 'DclGetChar', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('SCALE'  ) ; call uscget(pname,DclGetChar)
          case('AXIS'   ) ; call uzcget(pname,DclGetChar)
          case('DEVICE' ) ; call swcget(pname,DclGetChar)
          case('GLOBAL' ) ; call glcget(pname,DclGetChar)
          case default
            call msgdmp('E', 'DclGetChar', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetChar')
    end function
!======================================================
    subroutine DclGetIntegerS(name, value)
      integer                       :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetIntegerS')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udiqin(name,idx)
          if(idx.ne.0) then
            call udiqvl(idx, value) ;  exit
          end if

          call ueiqin(name,idx)
          if(idx.ne.0) then
            call ueiqvl(idx, value) ;  exit
          end if

          call ugiqin(name,idx)
          if(idx.ne.0) then
            call ugiqvl(idx, value) ;  exit
          end if

          call usiqin(name,idx)
          if(idx.ne.0) then
            call usiqvl(idx, value) ;  exit
          end if

          call uziqin(name,idx)
          if(idx.ne.0) then
            call uziqvl(idx, value) ;  exit
          end if

          call uliqin(name,idx)
          if(idx.ne.0) then
            call uliqvl(idx, value) ;  exit
          end if

          call uciqin(name,idx)
          if(idx.ne.0) then
            call uciqvl(idx, value) ;  exit
          end if

          call umiqin(name,idx)
          if(idx.ne.0) then
            call umiqvl(idx, value) ;  exit
          end if

          call sgiqin(name,idx)
          if(idx.ne.0) then
            call sgiqvl(idx, value) ;  exit
          end if

          call swiqin(name,idx)
          if(idx.ne.0) then
            call swiqvl(idx, value) ;  exit
          end if

          call gliqin(name,idx)
          if(idx.ne.0) then
            call gliqvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclGetIntegerS', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udiget(pname,value)
          case('HATCH'   ) ; call ueiget(pname,value)
          case('VECTOR'  ) ; call ugiget(pname,value)
          case('SCALE'   ) ; call usiget(pname,value)
          case('AXIS'    ) ; call uziget(pname,value)
          case('LOG'     ) ; call uliget(pname,value)
          case('CALENDAR') ; call uciget(pname,value)
          case('MAP'     ) ; call umiget(pname,value)
          case('GRAPH'   ) ; call sgiget(pname,value)
          case('DEVICE'  ) ; call swiget(pname,value)
          case('GLOBAL'  ) ; call gliget(pname,value)
          case default
            call msgdmp('E', 'DclGetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetIntegerS')

    end subroutine
!------------------------------------------------------
    subroutine DclGetRealS(name, value)
      real                          :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetRealS')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udrqin(name,idx)
          if(idx.ne.0) then
            call udrqvl(idx, value) ;  exit
          end if

          call uerqin(name,idx)
          if(idx.ne.0) then
            call uerqvl(idx, value) ;  exit
          end if

          call ugrqin(name,idx)
          if(idx.ne.0) then
            call ugrqvl(idx, value) ;  exit
          end if

          call usrqin(name,idx)
          if(idx.ne.0) then
            call usrqvl(idx, value) ;  exit
          end if

          call uzrqin(name,idx)
          if(idx.ne.0) then
            call uzrqvl(idx, value) ;  exit
          end if

          call ulrqin(name,idx)
          if(idx.ne.0) then
            call ulrqvl(idx, value) ;  exit
          end if

          call ucrqin(name,idx)
          if(idx.ne.0) then
            call ucrqvl(idx, value) ;  exit
          end if

          call umrqin(name,idx)
          if(idx.ne.0) then
            call umrqvl(idx, value) ;  exit
          end if

          call sgrqin(name,idx)
          if(idx.ne.0) then
            call sgrqvl(idx, value) ;  exit
          end if

          call swrqin(name,idx)
          if(idx.ne.0) then
            call swrqvl(idx, value) ;  exit
          end if

          call glrqin(name,idx)
          if(idx.ne.0) then
            call glrqvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclGetRealS', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udrget(pname,value)
          case('HATCH'   ) ; call uerget(pname,value)
          case('VECTOR'  ) ; call ugrget(pname,value)
          case('SCALE'   ) ; call usrget(pname,value)
          case('AXIS'    ) ; call uzrget(pname,value)
          case('LOG'     ) ; call ulrget(pname,value)
          case('CALENDAR') ; call ucrget(pname,value)
          case('MAP'     ) ; call umrget(pname,value)
          case('GRAPH'   ) ; call sgrget(pname,value)
          case('DEVICE'  ) ; call swrget(pname,value)
          case('GLOBAL'  ) ; call glrget(pname,value)
          case default
            call msgdmp('E', 'DclGetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetRealS')

    end subroutine
!------------------------------------------------------
    subroutine DclGetLogicalS(name, value)
      logical                       :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetLogicalS')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udlqin(name,idx)
          if(idx.ne.0) then
            call udlqvl(idx, value) ;  exit
          end if

          call uelqin(name,idx)
          if(idx.ne.0) then
            call uelqvl(idx, value) ;  exit
          end if

          call uglqin(name,idx)
          if(idx.ne.0) then
            call uglqvl(idx, value) ;  exit
          end if

          call uslqin(name,idx)
          if(idx.ne.0) then
            call uslqvl(idx, value) ;  exit
          end if

          call uzlqin(name,idx)
          if(idx.ne.0) then
            call uzlqvl(idx, value) ;  exit
          end if

          call ullqin(name,idx)
          if(idx.ne.0) then
            call ullqvl(idx, value) ;  exit
          end if

          call uclqin(name,idx)
          if(idx.ne.0) then
            call uclqvl(idx, value) ;  exit
          end if

          call umlqin(name,idx)
          if(idx.ne.0) then
            call umlqvl(idx, value) ;  exit
          end if

          call sglqin(name,idx)
          if(idx.ne.0) then
            call sglqvl(idx, value) ;  exit
          end if

          call swlqin(name,idx)
          if(idx.ne.0) then
            call swlqvl(idx, value) ;  exit
          end if

          call gllqin(name,idx)
          if(idx.ne.0) then
            call gllqvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclGetRealS', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udlget(pname,value)
          case('HATCH'   ) ; call uelget(pname,value)
          case('VECTOR'  ) ; call uglget(pname,value)
          case('SCALE'   ) ; call uslget(pname,value)
          case('AXIS'    ) ; call uzlget(pname,value)
          case('LOG'     ) ; call ullget(pname,value)
          case('CALENDAR') ; call uclget(pname,value)
          case('MAP'     ) ; call umlget(pname,value)
          case('GRAPH'   ) ; call sglget(pname,value)
          case('DEVICE'  ) ; call swlget(pname,value)
          case('GLOBAL'  ) ; call gllget(pname,value)
          case default
            call msgdmp('E', 'DclGetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetLogicalS')

    end subroutine
!------------------------------------------------------
    subroutine DclGetCharS(name, value)
      character(len=8)              :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclGetCharS')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call uscqin(name,idx)
          if(idx.ne.0) then
            call uscqvl(idx, value) ;  exit
          end if

          call uzcqin(name,idx)
          if(idx.ne.0) then
            call uzcqvl(idx, value) ;  exit
          end if

          call swcqin(name,idx)
          if(idx.ne.0) then
            call swcqvl(idx, value) ;  exit
          end if

          call glcqin(name,idx)
          if(idx.ne.0) then
            call glcqvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclGetChar', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('SCALE'  ) ; call uscget(pname,value)
          case('AXIS'   ) ; call uzcget(pname,value)
          case('DEVICE' ) ; call swcget(pname,value)
          case('GLOBAL' ) ; call glcget(pname,value)
          case default
            call msgdmp('E', 'DclGetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclGetCharS')
    end subroutine
!======================================================
    subroutine DclSetInteger(name, value)
      integer                       :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclSetInteger')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udiqin(name,idx)
          if(idx.ne.0) then
            call udisvl(idx, value) ;  exit
          end if

          call ueiqin(name,idx)
          if(idx.ne.0) then
            call ueisvl(idx, value) ;  exit
          end if

          call ugiqin(name,idx)
          if(idx.ne.0) then
            call ugisvl(idx, value) ;  exit
          end if

          call usiqin(name,idx)
          if(idx.ne.0) then
            call usisvl(idx, value) ;  exit
          end if

          call uziqin(name,idx)
          if(idx.ne.0) then
            call uzisvl(idx, value) ;  exit
          end if

          call uliqin(name,idx)
          if(idx.ne.0) then
            call ulisvl(idx, value) ;  exit
          end if

          call uciqin(name,idx)
          if(idx.ne.0) then
            call ucisvl(idx, value) ;  exit
          end if

          call umiqin(name,idx)
          if(idx.ne.0) then
            call umisvl(idx, value) ;  exit
          end if

          call sgiqin(name,idx)
          if(idx.ne.0) then
            call sgisvl(idx, value) ;  exit
          end if

          call swiqin(name,idx)
          if(idx.ne.0) then
            call swisvl(idx, value) ;  exit
          end if

          call gliqin(name,idx)
          if(idx.ne.0) then
            call glisvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclSetInteger', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udiset(pname,value)
          case('HATCH'   ) ; call ueiset(pname,value)
          case('VECTOR'  ) ; call ugiset(pname,value)
          case('SCALE'   ) ; call usiset(pname,value)
          case('AXIS'    ) ; call uziset(pname,value)
          case('LOG'     ) ; call uliset(pname,value)
          case('CALENDAR') ; call uciset(pname,value)
          case('MAP'     ) ; call umiset(pname,value)
          case('GRAPH'   ) ; call sgiset(pname,value)
          case('DEVICE'  ) ; call swiset(pname,value)
          case('GLOBAL'  ) ; call gliset(pname,value)
          case default
            call msgdmp('E', 'DclSetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetInteger')

    end subroutine
!------------------------------------------------------
    subroutine DclSetReal(name, value)
      real                          :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclSetReal')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udrqin(name,idx)
          if(idx.ne.0) then
            call udrsvl(idx, value) ;  exit
          end if

          call uerqin(name,idx)
          if(idx.ne.0) then
            call uersvl(idx, value) ;  exit
          end if

          call ugrqin(name,idx)
          if(idx.ne.0) then
            call ugrsvl(idx, value) ;  exit
          end if

          call usrqin(name,idx)
          if(idx.ne.0) then
            call usrsvl(idx, value) ;  exit
          end if

          call uzrqin(name,idx)
          if(idx.ne.0) then
            call uzrsvl(idx, value) ;  exit
          end if

          call ulrqin(name,idx)
          if(idx.ne.0) then
            call ulrsvl(idx, value) ;  exit
          end if

          call ucrqin(name,idx)
          if(idx.ne.0) then
            call ucrsvl(idx, value) ;  exit
          end if

          call umrqin(name,idx)
          if(idx.ne.0) then
            call umrsvl(idx, value) ;  exit
          end if

          call sgrqin(name,idx)
          if(idx.ne.0) then
            call sgrsvl(idx, value) ;  exit
          end if

          call swrqin(name,idx)
          if(idx.ne.0) then
            call swrsvl(idx, value) ;  exit
          end if

          call glrqin(name,idx)
          if(idx.ne.0) then
            call glrsvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclSetParm', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udrset(pname,value)
          case('HATCH'   ) ; call uerset(pname,value)
          case('VECTOR'  ) ; call ugrset(pname,value)
          case('SCALE'   ) ; call usrset(pname,value)
          case('AXIS'    ) ; call uzrset(pname,value)
          case('LOG'     ) ; call ulrset(pname,value)
          case('CALENDAR') ; call ucrset(pname,value)
          case('MAP'     ) ; call umrset(pname,value)
          case('GRAPH'   ) ; call sgrset(pname,value)
          case('DEVICE'  ) ; call swrset(pname,value)
          case('GLOBAL'  ) ; call glrset(pname,value)
          case default
            call msgdmp('E', 'DclSetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetReal')

    end subroutine
!------------------------------------------------------
    subroutine DclSetLogical(name, value)
      logical                       :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclSetLogical')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call udlqin(name,idx)
          if(idx.ne.0) then
            call udlsvl(idx, value) ;  exit
          end if

          call uelqin(name,idx)
          if(idx.ne.0) then
            call uelsvl(idx, value) ;  exit
          end if

          call uglqin(name,idx)
          if(idx.ne.0) then
            call uglsvl(idx, value) ;  exit
          end if

          call uslqin(name,idx)
          if(idx.ne.0) then
            call uslsvl(idx, value) ;  exit
          end if

          call uzlqin(name,idx)
          if(idx.ne.0) then
            call uzlsvl(idx, value) ;  exit
          end if

          call ullqin(name,idx)
          if(idx.ne.0) then
            call ullsvl(idx, value) ;  exit
          end if

          call uclqin(name,idx)
          if(idx.ne.0) then
            call uclsvl(idx, value) ;  exit
          end if

          call umlqin(name,idx)
          if(idx.ne.0) then
            call umlsvl(idx, value) ;  exit
          end if

          call sglqin(name,idx)
          if(idx.ne.0) then
            call sglsvl(idx, value) ;  exit
          end if

          call swlqin(name,idx)
          if(idx.ne.0) then
            call swlsvl(idx, value) ;  exit
          end if

          call gllqin(name,idx)
          if(idx.ne.0) then
            call gllsvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclSetParm', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udlset(pname,value)
          case('HATCH'   ) ; call uelset(pname,value)
          case('VECTOR'  ) ; call uglset(pname,value)
          case('SCALE'   ) ; call uslset(pname,value)
          case('AXIS'    ) ; call uzlset(pname,value)
          case('LOG'     ) ; call ullset(pname,value)
          case('CALENDAR') ; call uclset(pname,value)
          case('MAP'     ) ; call umlset(pname,value)
          case('GRAPH'   ) ; call sglset(pname,value)
          case('DEVICE'  ) ; call swlset(pname,value)
          case('GLOBAL'  ) ; call gllset(pname,value)
          case default
            call msgdmp('E', 'DclSetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetLogical')

    end subroutine
!------------------------------------------------------
    subroutine DclSetChar(name, value)
      character(len=*)              :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclSetChar')
      n = index(name, ':')
      if(n.eq.0) then
        do
          call uscqin(name,idx)
          if(idx.ne.0) then
            call uscsvl(idx, value) ;  exit
          end if

          call uzcqin(name,idx)
          if(idx.ne.0) then
            call uzcsvl(idx, value) ;  exit
          end if

          call swcqin(name,idx)
          if(idx.ne.0) then
            call swcsvl(idx, value) ;  exit
          end if

          call glcqin(name,idx)
          if(idx.ne.0) then
            call glcsvl(idx, value) ;  exit
          end if
          call msgdmp('E', 'DclGetChar', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('SCALE'  ) ; call uscset(pname,value)
          case('AXIS'   ) ; call uzcset(pname,value)
          case('DEVICE' ) ; call swcset(pname,value)
          case('GLOBAL' ) ; call glcset(pname,value)
          case default
            call msgdmp('E', 'DclSetParm', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetChar')

    end subroutine
!======================================================
    subroutine DclSetIntegerEX(name, value)
      integer                       :: value, v0
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclSetIntegerEX')
      n = index(name, ':')
      if(n.eq.0) then
        do
          v0 = value
          call udiqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call udisvl(idx, v0) ;  exit
          end if

          call ueiqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call ueisvl(idx, v0) ;  exit
          end if

          call ugiqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call ugisvl(idx, v0) ;  exit
          end if

          call usiqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call usisvl(idx, v0) ;  exit
          end if

          call uziqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call uzisvl(idx, v0) ;  exit
          end if

          call uliqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call ulisvl(idx, v0) ;  exit
          end if

          call uciqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call ucisvl(idx, v0) ;  exit
          end if

          call umiqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call umisvl(idx, v0) ;  exit
          end if

          call sgiqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call sgisvl(idx, v0) ;  exit
          end if

          call swiqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call swisvl(idx, v0) ;  exit
          end if

          call gliqin(name,idx)
          if(idx.ne.0) then
            call rliget(name, v0, 1)
            call glisvl(idx, v0) ;  exit
          end if
          call msgdmp('E', 'DclSetParmEX', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udistx(pname,value)
          case('HATCH'   ) ; call ueistx(pname,value)
          case('VECTOR'  ) ; call ugistx(pname,value)
          case('SCALE'   ) ; call usistx(pname,value)
          case('AXIS'    ) ; call uzistx(pname,value)
          case('LOG'     ) ; call ulistx(pname,value)
          case('CALENDAR') ; call ucistx(pname,value)
          case('MAP'     ) ; call umistx(pname,value)
          case('GRAPH'   ) ; call sgistx(pname,value)
          case('DEVICE'  ) ; call swistx(pname,value)
          case('GLOBAL'  ) ; call glistx(pname,value)
          case default
            call msgdmp('E', 'DclSetParmEX', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetIntegerEX')

    end subroutine
!------------------------------------------------------
    subroutine DclSetRealEX(name, value)
      real                          :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclSetRealEX')
      n = index(name, ':')
      if(n.eq.0) then
        do
          v0 = value
          call udrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call udrsvl(idx, v0) ;  exit
          end if

          call uerqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call uersvl(idx, v0) ;  exit
          end if

          call ugrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call ugrsvl(idx, v0) ;  exit
          end if

          call usrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call usrsvl(idx, v0) ;  exit
          end if

          call uzrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call uzrsvl(idx, v0) ;  exit
          end if

          call ulrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call ulrsvl(idx, v0) ;  exit
          end if

          call ucrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call ucrsvl(idx, v0) ;  exit
          end if

          call umrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call umrsvl(idx, v0) ;  exit
          end if

          call sgrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call sgrsvl(idx, v0) ;  exit
          end if

          call swrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call swrsvl(idx, v0) ;  exit
          end if

          call glrqin(name,idx)
          if(idx.ne.0) then
            call rlrget(name, v0, 1)
            call glrsvl(idx, v0) ;  exit
          end if
          call msgdmp('E', 'DclSetParmEX', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udrstx(pname,value)
          case('HATCH'   ) ; call uerstx(pname,value)
          case('VECTOR'  ) ; call ugrstx(pname,value)
          case('SCALE'   ) ; call usrstx(pname,value)
          case('AXIS'    ) ; call uzrstx(pname,value)
          case('LOG'     ) ; call ulrstx(pname,value)
          case('CALENDAR') ; call ucrstx(pname,value)
          case('MAP'     ) ; call umrstx(pname,value)
          case('GRAPH'   ) ; call sgrstx(pname,value)
          case('DEVICE'  ) ; call swrstx(pname,value)
          case('GLOBAL'  ) ; call glrstx(pname,value)
          case default
            call msgdmp('E', 'DclSetParmEX', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetRealEX')

    end subroutine
!------------------------------------------------------
    subroutine DclSetLogicalEX(name, value)
      logical                       :: value, v0
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname

      call prcopn('DclSetLogicalEX')
      n = index(name, ':')
      if(n.eq.0) then
        do
          v0 = value
          call udlqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call udlsvl(idx, v0) ;  exit
          end if

          call uelqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call uelsvl(idx, v0) ;  exit
          end if

          call uglqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call uglsvl(idx, v0) ;  exit
          end if

          call uslqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call uslsvl(idx, v0) ;  exit
          end if

          call uzlqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call uzlsvl(idx, v0) ;  exit
          end if

          call ullqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call ullsvl(idx, v0) ;  exit
          end if

          call uclqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call uclsvl(idx, v0) ;  exit
          end if

          call umlqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call umlsvl(idx, v0) ;  exit
          end if

          call sglqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call sglsvl(idx, v0) ;  exit
          end if

          call swlqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call swlsvl(idx, v0) ;  exit
          end if

          call gllqin(name,idx)
          if(idx.ne.0) then
            call rllget(name, v0, 1)
            call gllsvl(idx, v0) ;  exit
          end if
          call msgdmp('E', 'DclSetParmEX', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('CONTOUR' ) ; call udlstx(pname,value)
          case('HATCH'   ) ; call uelstx(pname,value)
          case('VECTOR'  ) ; call uglstx(pname,value)
          case('SCALE'   ) ; call uslstx(pname,value)
          case('AXIS'    ) ; call uzlstx(pname,value)
          case('LOG'     ) ; call ullstx(pname,value)
          case('CALENDAR') ; call uclstx(pname,value)
          case('MAP'     ) ; call umlstx(pname,value)
          case('GRAPH'   ) ; call sglstx(pname,value)
          case('DEVICE'  ) ; call swlstx(pname,value)
          case('GLOBAL'  ) ; call gllstx(pname,value)
          case default
            call msgdmp('E', 'DclSetParmEX', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetLogicalEX')

    end subroutine
!------------------------------------------------------
    subroutine DclSetCharEX(name, value)
      character(len=*)              :: value
      character(len=*), intent(in)  :: name
      character(len=8)              :: prefix, pname
      character(len=32)             :: v0

      call prcopn('DclSetCharEX')
      n = index(name, ':')
      if(n.eq.0) then
        do
          v0 = value
          call uscqin(name,idx)
          if(idx.ne.0) then
            call rlcget(name, v0, 1)
            call uscsvl(idx, v0) ;  exit
          end if

          call uzcqin(name,idx)
          if(idx.ne.0) then
            call rlcget(name, v0, 1)
            call uzcsvl(idx, v0) ;  exit
          end if

          call swcqin(name,idx)
          if(idx.ne.0) then
            call rlcget(name, v0, 1)
            call swcsvl(idx, v0) ;  exit
          end if

          call glcqin(name,idx)
          if(idx.ne.0) then
            call rlcget(name, v0, 1)
            call glcsvl(idx, v0) ;  exit
          end if
          call msgdmp('E', 'DclSetParmEX', 'Invalid parameter ['//name//']')
        end do
      else
        prefix = name(1:n-1)
        pname  = name(n+1:)
        call cupper(prefix)

        select case(prefix)
          case('SCALE' ) ; call uscstx(pname,value)
          case('AXIS'  ) ; call uzcstx(pname,value)
          case('DEVICE') ; call swcstx(pname,value)
          case('GLOBAL') ; call glcstx(pname,value)
         case default
            call msgdmp('E', 'DclSetParmEX', 'Invalid prefix ['//prefix//']')
        end select
      end if
      call prccls('DclSetCharEX')

    end subroutine
end module dcl_parm

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UESTLN(TLEVN,IPATN,NTON)

      PARAMETER (MAXNT=100)

      INTEGER   IPATN(*)
      REAL      TLEVN(*)

      CHARACTER CMSG*80


*     / CHECK NUMBER OF TONE /

      CALL UEQNTL(NT)
      IF (NT+NTON.GT.MAXNT) THEN
        CMSG='NUMBER OF TONE IS IN EXCESS OF MAXIMUM (###).'
        WRITE(CMSG(41:43),'(I3)') MAXNT
        CALL MSGDMP('E','UESTLN',CMSG)
      END IF

      DO 10 IT=1,NTON

*       / CHECK IPAT /

        IF (IPATN(IT).LT.0) THEN
          CMSG='TONE PATTERN NUMBER IS LESS THAN ZERO.'
          CALL MSGDMP('E','UESTLN',CMSG)
        END IF

        CALL UESTLV(TLEVN(IT),TLEVN(IT+1),IPATN(IT))

   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM MISS1

      PARAMETER( NMAX=40 )
      PARAMETER( PI=3.14159 )
      PARAMETER( XMIN=0., XMAX=4*PI, YMIN=-1., YMAX=1. )
      REAL X(0:NMAX), Y(0:NMAX)

      DT = XMAX/NMAX
      DO 10 N=0,NMAX
        X(N) = N*DT
        Y(N) = SIN(X(N))
   10 CONTINUE

      N1 = NMAX/4
      Y(N1-1) = 999.
      Y(N1  ) = 999.
      Y(N1+1) = 999.

      N2 = N1*3
      Y(N2-1) = 999.
      Y(N2+1) = 999.

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

*-- 欠損値処理なし ----
      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.1,  0.9,  0.7,  0.9 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL SGPLU( NMAX+1, X, Y )

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.1,  0.9,  0.5,  0.7 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL SGSPMT( 3 )
      CALL SGPMU( NMAX+1, X, Y )

*-- 欠損値処理 ----
      CALL GLLSET( 'LMISS', .TRUE. )

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.1,  0.9,  0.3,  0.5 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL SGPLU( NMAX+1, X, Y )

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.1,  0.9,  0.1,  0.3 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL SGPMU( NMAX+1, X, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCPMZV(N,VPX,VPY,VPZ,ITYPE,INDEX,RSIZE)

      REAL      VPX(*),VPY(*),VPZ(*)


      IF (N.LT.1) THEN
        CALL MSGDMP('E','SCPMZV','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SCPMZV','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SCPMZV','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SCPMZV','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SCPMZV','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SCPMZV','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZM3OP(ITYPE,INDEX,RSIZE)
      CALL SZM3ZV(N,VPX,VPY,VPZ)
      CALL SZM3CL

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM MAP3D3
      PARAMETER( NX=16, NY=16 )
      PARAMETER( XMIN=120, XMAX=150, YMIN=20, YMAX=50 )
      PARAMETER( FACT=0.2 )
      REAL U(NX,NY), V(NX,NY), ALON(NX), ALAT(NY)

      DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
   10 CONTINUE
      DO 20 J=1,NY
        ALAT(J) = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
   20 CONTINUE

      DO 30 J=1,NY
      DO 30 I=1,NX
        U(I,J) =   (J-1-(NY-1)/2.) * FACT
        V(I,J) = - (I-1-(NX-1)/2.) * FACT
   30 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM
      CALL SGLSET( 'LCLIP', .TRUE. )

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL GRSTRN( 10 )
      CALL UMPFIT
      CALL GRSTRF

      CALL SLPVPR( 3 )
      CALL UMRSET( 'DGRIDMJ', 10. )
      CALL UMRSET( 'DGRIDMN',  2. )
      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB

      CALL SGSLAI( 3 )
      DO 40 J=1,NY
      DO 40 I=1,NX
        CALL SGLAU( ALON(I), ALAT(J), ALON(I)+U(I,J), ALAT(J)+V(I,J) )
   40   CONTINUE

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     SWPQNP / SWPQID / SWPQCP / SWPQVL / SWPSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWPQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 21)

      INTEGER   ITYPE(NPARA)
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      LOGICAL   LCHREQ

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'MAXWNU  ' / , ITYPE( 1) / 1 /
      DATA      CPARAS( 2) / 'IWS     ' / , ITYPE( 2) / 0 /
      DATA      CPARAS( 3) / 'IPOSX   ' / , ITYPE( 3) / 1 /
      DATA      CPARAS( 4) / 'IPOSY   ' / , ITYPE( 4) / 1 /
      DATA      CPARAS( 5) / 'IWIDTH  ' / , ITYPE( 5) / 1 /
      DATA      CPARAS( 6) / 'IHEIGHT ' / , ITYPE( 6) / 1 /
      DATA      CPARAS( 7) / 'LWAIT   ' / , ITYPE( 7) / 2 /
      DATA      CPARAS( 8) / 'LWAIT0  ' / , ITYPE( 8) / 2 /
      DATA      CPARAS( 9) / 'LWAIT1  ' / , ITYPE( 9) / 2 /
      DATA      CPARAS(10) / 'LKEY    ' / , ITYPE(10) / 2 /
      DATA      CPARAS(11) / 'LDUMP   ' / , ITYPE(11) / 2 /
      DATA      CPARAS(12) / 'LALT    ' / , ITYPE(12) / 2 /
      DATA      CPARAS(13) / 'LCOLOR  ' / , ITYPE(13) / 2 /
      DATA      CPARAS(14) / 'LSEP    ' / , ITYPE(14) / 2 /
      DATA      CPARAS(15) / 'LPRINT  ' / , ITYPE(15) / 2 /
      DATA      CPARAS(16) / 'LWND    ' / , ITYPE(16) / 2 /
      DATA      CPARAS(17) / 'MODE    ' / , ITYPE(17) / 1 /
      DATA      CPARAS(18) / 'NLNSIZE ' / , ITYPE(18) / 1 /
      DATA      CPARAS(19) / 'ICLRMAP ' / , ITYPE(19) / 1 /
      DATA      CPARAS(20) / 'LFGBG   ' / , ITYPE(20) / 2 /
      DATA      CPARAS(21) / 'LSYSFNT ' / , ITYPE(21) / 2 /

*     / LONG NAME /

      DATA      CPARAL( 1) / '****MAXWNU  ' /
      DATA      CPARAL( 2) / '****IWS     ' /
      DATA      CPARAL( 3) / 'WINDOW_X_POS' /
      DATA      CPARAL( 4) / 'WINDOW_Y_POS' /
      DATA      CPARAL( 5) / 'WINDOW_WIDTH' /
      DATA      CPARAL( 6) / 'WINDOW_HEIGHT' /
      DATA      CPARAL( 7) / 'WAIT' /
      DATA      CPARAL( 8) / 'WAIT_OPENING' /
      DATA      CPARAL( 9) / 'WAIT_CLOSING' /
      DATA      CPARAL(10) / 'KEYCLICK' /
      DATA      CPARAL(11) / 'DUMP' /
      DATA      CPARAL(12) / 'ALTERNATE' /
      DATA      CPARAL(13) / 'ENABLE_COLOR_PS' /
      DATA      CPARAL(14) / 'SEPARATE' /
      DATA      CPARAL(15) / 'PRINT' /
      DATA      CPARAL(16) / 'SHOW_WINDOW' /
      DATA      CPARAL(17) / '****MODE    ' /
      DATA      CPARAL(18) / '****NLNSIZE ' /
      DATA      CPARAL(19) / 'COLORMAP_NUMBER' /
      DATA      CPARAL(20) / '****LFGBG   ' /
      DATA      CPARAL(21) / 'USE_SYSTEM_FONT' /

      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','SWPQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','SWPQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','SWPQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPQIT(IDX, ITP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        ITP = ITYPE(IDX)
      ELSE
        CALL MSGDMP('E','SWPQIT','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPQVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL SWIQID(CPARAS(IDX), ID)
          CALL SWIQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL SWLQID(CPARAS(IDX), ID)
          CALL SWLQVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL SWRQID(CPARAS(IDX), ID)
          CALL SWRQVL(ID, IPARA)
        END IF
      ELSE
         CALL MSGDMP('E','SWPQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPSVL(IDX, IPARA)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (ITYPE(IDX) .EQ. 1) THEN
          CALL SWIQID(CPARAS(IDX), ID)
          CALL SWISVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 2) THEN
          CALL SWLQID(CPARAS(IDX), ID)
          CALL SWLSVL(ID, IPARA)
        ELSE IF (ITYPE(IDX) .EQ. 3) THEN
          CALL SWRQID(CPARAS(IDX), ID)
          CALL SWRSVL(ID, IPARA)
        END IF
      ELSE
        CALL MSGDMP('E','SWPSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!interface module of uzpack
!-------------------------------------------------
module uz_interface
  interface
    subroutine uzpget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uziget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uzrget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uzlget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uzpset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uziset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uzrset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uzlset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uzpstx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uzistx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uzrstx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uzlstx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uzpqnp(ncp)                        !内部変数の総数を求める．
      integer,   intent(out) :: ncp               !内部変数の値
    end subroutine
      
    subroutine uzpqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine uzpqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する．
      integer,   intent(in) :: idx
      character(len=*), intent(out) :: cp
    end subroutine
      
    subroutine uzpqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する．
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine uzpsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine
      
    subroutine uzinit()                           !内部変数 'roffzs', 'rofgzs'をすべて0にセットする．
    end subroutine
      
    subroutine uzfact(rfact)                      !内部変数 'rsizeti' 'rsizeli' 'rsizeci'　(i=1,2) をすべて何倍かする．
      real,      intent(in) :: rfact              !何倍するかを指定する実数値
    end subroutine
      
    subroutine uzpsav()                           !現在設定されている内部変数の値すべてをスクラッチファイルに書き出す．
    end subroutine
      
    subroutine uzprst()                           !スクラッチファイルに書き出した値ですべての内部変数を再設定する．
    end subroutine

  end interface
end module
!uzpack library end ----

      PROGRAM UXYZ8

      PARAMETER( ID0=19911201, ND=180, RND=ND )

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL UZFACT( 0.7 )
      CALL UZLSET( 'LOFFSET', .TRUE. )
      CALL GRFRM

      CALL GRSWND( 0.0, RND, 0.0, 100. )
      CALL GRSVPT( 0.4, 0.9, 0.3,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UCXACL( 'B', ID0, ND )
      CALL UCXACL( 'T', ID0, ND )
      CALL UXSAXS( 'B' )
      CALL UXAXDV( 'B', 10., 20. )
      CALL UXSTTL( 'B', 'DAY NUMBER', 0. )

      CALL UYAXDV( 'L', 5., 10. )
      CALL UYAXDV( 'R', 5., 10. )
      CALL UYSTTL( 'L', 'CELSIUS SCALE', 0. )

      CALL UYSAXS( 'L' )
      CALL UZRSET( 'YOFFSET', 273.15 )
      CALL UZRSET( 'YFACT  ', 1. )
      CALL UYAXDV( 'L', 5., 10. )
      CALL UYSTTL( 'L', 'KELVIN SCALE', 0. )

      CALL UYSAXS( 'L' )
      CALL UZRSET( 'YOFFSET', 32. )
      CALL UZRSET( 'YFACT  ', 1.8 )
      CALL UYAXDV( 'L', 10., 20. )
      CALL UYSTTL( 'L', 'FAHRENHEIT SCALE', 0. )

      CALL UXSTTL( 'T', '(LOFFSET=.TRUE.)', 0. )
      CALL UXMTTL( 'T', 'UXSAXS/UYSAXS', 0. )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     USPACK AXIS (CALENDAR)                          S.Sakai  99/10/05
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USAXCL(CSIDE, JD0, CTYPE, ND)

      CHARACTER  CSIDE*(*), CTYPE*(*), CS, CT
      EXTERNAL   LENZ
      LOGICAL    LOFF

      NCS = LENZ(CSIDE)

      CALL UZLGET('LOFFSET', LOFF)
      CALL UZLSET('LOFFSET', .FALSE.)

      DO 100 I=1, NCS
        CS = CSIDE(I:I)
        CALL CUPPER(CS)

        IF(CS.EQ.'T' .OR. CS.EQ.'B' .OR. CS.EQ.'H') THEN
          IF(CS.EQ.'H') CS='U'

          IF(ND.EQ.0) THEN
            CALl SGQWND(XMIN,XMAX,YMIN,YMAX)
            ND0 = ABS(NINT(XMAX-XMIN))
          ELSE
            ND0 = ND
          END IF

          CALL USXINZ(CS,FACTOT,OFFSET)
          NTYP = LENZ(CTYPE)
          DO 200 J=1, NTYP
            CT = CTYPE(J:J)
            CALL CUPPER(CT)
            IF(CT.EQ.'Y')  CALL UCXAYR(CS, JD0, ND0)
            IF(CT.EQ.'M')  CALL UCXAMN(CS, JD0, ND0)
            IF(CT.EQ.'D')  CALL UCXADY(CS, JD0, ND0)
 200      CONTINUE
          CALL USXTLZ

        ELSEIF(CS.EQ.'L' .OR. CS.EQ.'R' .OR. CS.EQ.'V') THEN
          IF(CS.EQ.'V') CS='U'

          IF(ND.EQ.0) THEN
            CALl SGQWND(XMIN,XMAX,YMIN,YMAX)
            ND0 = ABS(NINT(YMAX-YMIN))
          ELSE
            ND0 = ND
          END IF

          CALL USYINZ(CS, FACTOR, OFFSET)
          NTYP = LENZ(CTYPE)
          DO 250 J=1, NTYP
            CT = CTYPE(J:J)
            CALL CUPPER(CT)
            IF(CT.EQ.'Y')  CALL UCYAYR(CS, JD0, ND0)
            IF(CT.EQ.'M')  CALL UCYAMN(CS, JD0, ND0)
            IF(CT.EQ.'D')  CALL UCYADY(CS, JD0, ND0)
 250      CONTINUE
          CALL USYTLZ
        ENDIF

  100 CONTINUE
      CALL UZLSET('LOFFSET', LOFF)

      END

!-------------------------------------------------
!interface module of xfclib
!-------------------------------------------------
module xfc_interface
  interface

    function ifromc(cx)                           !整数文字列のあらわす整数値を返す．
      character(len=*), intent(in) :: cx          !調べる文字列
      integer ifromc                              !求める整数値
    end function
      
    function lfromc(cx)                           !論理定数を表現する文字列のあらわす論理値を返す．
      character(len=*), intent(in) :: cx          !調べる文字列
      logical lfromc                              !求める論理値
    end function
      
    function rfromc(cx)                           !指数表現を含む実数文字列のあらわす実数値を返す．
      character(len=*), intent(in) :: cx          !調べる文字列
      real rfromc                                 !求める実数値
    end function

  end interface
end module
!xfclib library end ----

!-------------------------------------------------
!interface module of ucpack
!-------------------------------------------------
module uc_interface
  interface
    subroutine ucxacl(cside,jd0,nd)               !日・月・年に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucyacl(cside,jd0,nd)               !日・月・年に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucxady(cside,jd0,nd)               !日に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucyady(cside,jd0,nd)               !日に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucxamn(cside,jd0,nd)               !月に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucyamn(cside,jd0,nd)               !月に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucxayr(cside,jd0,nd)               !年に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucyayr(cside,jd0,nd)               !年に関する座標軸を描く．
      character(len=1), intent(in) :: cside       !座標軸を書く場所を指定する
      integer,   intent(in) :: jd0                !ucで0に相当する場所の日付を指定する
      integer,   intent(in) :: nd                 !作画する日数を指定する
    end subroutine
      
    subroutine ucpget(cp,ipara)                   !内部変数を参照する
      character(len=8), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uciget(cp,ipara)                   !内部変数を参照する
      character(len=8), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ucrget(cp,ipara)                   !内部変数を参照する
      character(len=8), intent(in) :: cp          !内部変数の名前
      real,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uclget(cp,ipara)                   !内部変数を参照する
      character(len=8), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ucpset(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uciset(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ucrset(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      real,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uclset(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ucpstx(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ucistx(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ucrstx(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      real,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uclstx(cp,ipara)                   !内部変数を変更する
      character(len=8), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ucpqnp(ncp)                        !内部変数の総数ncpを求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine ucpqid(cp,idx)                     !内部変数cpの位置idxを求める．
      character(len=8), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine ucpqcp(idx,cp)                     !idxの位置にある内部変数の名前cpを参照する
      character(len=8), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine ucpqvl(idx,ipara)                  !idxの位置にある内部変数の値iparaを参照する
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine ucpsvl(idx,ipara)                  !idxの位置にある内部変数の値iparaを変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine
      
  end interface
end module
!ucpack library end ----

*-----------------------------------------------------------------------
*     MSGDMP
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE MSGDMP(CLEV,CSUB,CMSG)

      CHARACTER CLEV*(*),CSUB*(*),CMSG*(*)

      LOGICAL   LCHREQ,LLMSG
      CHARACTER CLEVX*1,CSUBX*32,CPRC*32,CMSGX*200

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      IMSG/0/


      CALL GLIGET('MSGUNIT',IUNIT)
      CALL GLIGET('MAXMSG',MAXMSG)
      CALL GLIGET('MSGLEV',MSGLEV)
      CALL GLIGET('NLNSIZE',LNSIZE)
      CALL GLLGET('LLMSG',LLMSG)
      CALL PRCLVL(NLEV)
      CALL PRCNAM(MIN(NLEV,1), CPRC)

      CLEVX=CLEV
      CSUBX=CSUB
      LMSG=LENC(CMSG)
      LPRC=LENC(CPRC)
      LSUB=LENC(CSUBX)

      IF (LCHREQ(CLEVX,'E')) THEN
        IF (LLMSG) THEN
          CMSGX='*** Error ('//CSUBX(1:LSUB)// '@ '
     #         //CPRC(1:LPRC) // ') ' //CMSG(1:LMSG)
        ELSE
          CMSGX='***** ERROR ('//CSUBX(1:6)//') ***  '//CMSG(1:LMSG)
        END IF
        CALL MSZDMP(CMSGX,IUNIT,LNSIZE)
        CALL OSABRT
        STOP
      END IF
      IF (IMSG.LT.MAXMSG) THEN
        IF (LCHREQ(CLEVX,'W') .AND. MSGLEV.LE.1) THEN
          IMSG=IMSG+1
          IF (LLMSG) THEN
            CMSGX='- Warning ('//CSUBX(1:LSUB)// '@ '
     #           //CPRC(1:LPRC) // ') ' //CMSG(1:LMSG)
          ELSE
            CMSGX='*** WARNING ('//CSUBX(1:6)//') ***  '//CMSG(1:LMSG)
          END IF
          CALL MSZDMP(CMSGX,IUNIT,LNSIZE)
        ELSE IF (LCHREQ(CLEVX,'M') .AND. MSGLEV.LE.0) THEN
          IMSG=IMSG+1
          IF (LLMSG) THEN
            CMSGX='- Message ('//CSUBX(1:LSUB)// '@ '
     #           //CPRC(1:LPRC) // ') '//CMSG(1:LMSG)
          ELSE
            CMSGX='*** MESSAGE ('//CSUBX(1:6)//') ***  '//CMSG(1:LMSG)
          END IF
          CALL MSZDMP(CMSGX,IUNIT,LNSIZE)
        END IF
        IF (IMSG.EQ.MAXMSG) THEN
          CMSGX='+++ THE FOLLOWING MESSAGES ARE SUPPRESSED.'
          CALL MSZDMP(CMSGX,IUNIT,LNSIZE)
        END IF
      END IF

      END

*-----------------------------------------------------------------------
*     SGRQNP / SGRQID / SGRQCP / SGRQVL / SGRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 73)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1) / 'RDX     ' / , RX( 1) / 5.0 /
      DATA      CPARAS( 2) / 'RDY     ' / , RX( 2) / 5.0 /
      DATA      CPARAS( 3) / 'BITLEN  ' / , RX( 3) / 0.003 /
      DATA      CPARAS( 4) / 'SMALL   ' / , RX( 4) / 0.7 /
      DATA      CPARAS( 5) / 'SHIFT   ' / , RX( 5) / 0.3 /
      DATA      CPARAS( 6) / 'PMFACT  ' / , RX( 6) / 2.0 /
      DATA      CPARAS( 7) / 'RFAROT  ' / , RX( 7) / 0.01 /
      DATA      CPARAS( 8) / 'TNBLEN  ' / , RX( 8) / 0.001 /
      DATA      CPARAS( 9) / 'FWC     ' / , RX( 9) / 1.25 /
      DATA      CPARAS(10) / 'CWL     ' / , RX(10) / 30.0 /
      DATA      CPARAS(11) / 'FFCT    ' / , RX(11) / 0.5 /
      DATA      CPARAS(12) / 'RBUFF   ' / , RX(12) / 0.99 /
      DATA      CPARAS(13) / 'RCURV   ' / , RX(13) / 1.0 /
      DATA      CPARAS(14) / 'AFACT   ' / , RX(14) / 0.33 /
      DATA      CPARAS(15) / 'CONST   ' / , RX(15) / 0.01 /
      DATA      CPARAS(16) / 'CONSTM  ' / , RX(16) / 5.0 /
      DATA      CPARAS(17) / 'ANGLE   ' / , RX(17) / 20.0 /
      DATA      CPARAS(18) / 'VXMIN   ' / , RX(18) / 0.0 /
      DATA      CPARAS(19) / 'VXMAX   ' / , RX(19) / 1.0 /
      DATA      CPARAS(20) / 'VYMIN   ' / , RX(20) / 0.0 /
      DATA      CPARAS(21) / 'VYMAX   ' / , RX(21) / 1.0 /
      DATA      CPARAS(22) / 'UXMIN   ' / , RX(22) / 0.0 /
      DATA      CPARAS(23) / 'UXMAX   ' / , RX(23) / 1.0 /
      DATA      CPARAS(24) / 'UYMIN   ' / , RX(24) / 0.0 /
      DATA      CPARAS(25) / 'UYMAX   ' / , RX(25) / 1.0 /
      DATA      CPARAS(26) / 'VXOFF   ' / , RX(26) / 0.0 /
      DATA      CPARAS(27) / 'VYOFF   ' / , RX(27) / 0.0 /
      DATA      CPARAS(28) / 'PLX     ' / , RX(28) / 0.0 /
      DATA      CPARAS(29) / 'PLY     ' / , RX(29) / 90.0 /
      DATA      CPARAS(30) / 'PLROT   ' / , RX(30) / 0.0 /
      DATA      CPARAS(31) / 'SIMFAC  ' / , RX(31) / 0.0 /
      DATA      CPARAS(32) / 'STLAT1  ' / , RX(32) / 0.0 /
      DATA      CPARAS(33) / 'STLAT2  ' / , RX(33) / 0.0 /
      DATA      CPARAS(34) / 'TXMIN   ' / , RX(34) / -180.0 /
      DATA      CPARAS(35) / 'TXMAX   ' / , RX(35) / +180.0 /
      DATA      CPARAS(36) / 'TYMIN   ' / , RX(36) / -90.0 /
      DATA      CPARAS(37) / 'TYMAX   ' / , RX(37) / +90.0 /
      DATA      CPARAS(38) / 'CXMIN   ' / , RX(38) / 0.0 /
      DATA      CPARAS(39) / 'CXMAX   ' / , RX(39) / 1.0 /
      DATA      CPARAS(40) / 'CYMIN   ' / , RX(40) / 0.0 /
      DATA      CPARAS(41) / 'CYMAX   ' / , RX(41) / 1.0 /
      DATA      CPARAS(42) / 'RSAT    ' / , RX(42) / 0. /
      DATA      CPARAS(43) / 'FACTOR  ' / , RX(43) / 1.0 /
      DATA      CPARAS(44) / 'CORNER  ' / , RX(44) / 0.01 /
      DATA      CPARAS(45) / 'XPAD    ' / , RX(45) / 1.0 /
      DATA      CPARAS(46) / 'YPAD    ' / , RX(46) / 1.0 /
      DATA      CPARAS(47) / 'TILT3   ' / , RX(47) / 0. /
      DATA      CPARAS(48) / 'ANGLE3  ' / , RX(48) / 30. /
      DATA      CPARAS(49) / 'XOFF3   ' / , RX(49) / 0. /
      DATA      CPARAS(50) / 'YOFF3   ' / , RX(50) / 0. /
      DATA      CPARAS(51) / 'XOBJ3   ' / , RX(51) / 0.5 /
      DATA      CPARAS(52) / 'YOBJ3   ' / , RX(52) / 0.5 /
      DATA      CPARAS(53) / 'ZOBJ3   ' / , RX(53) / 0. /
      DATA      CPARAS(54) / 'XEYE3   ' / , RX(54) / -0.8 /
      DATA      CPARAS(55) / 'YEYE3   ' / , RX(55) / -1.5 /
      DATA      CPARAS(56) / 'ZEYE3   ' / , RX(56) / +1.5 /
      DATA      CPARAS(57) / 'SEC3    ' / , RX(57) / 0. /
      DATA      CPARAS(58) / 'VXMIN3  ' / , RX(58) / 0. /
      DATA      CPARAS(59) / 'VXMAX3  ' / , RX(59) / 1. /
      DATA      CPARAS(60) / 'VYMIN3  ' / , RX(60) / 0. /
      DATA      CPARAS(61) / 'VYMAX3  ' / , RX(61) / 1. /
      DATA      CPARAS(62) / 'VZMIN3  ' / , RX(62) / 0. /
      DATA      CPARAS(63) / 'VZMAX3  ' / , RX(63) / 1. /
      DATA      CPARAS(64) / 'UXMIN3  ' / , RX(64) / 0. /
      DATA      CPARAS(65) / 'UXMAX3  ' / , RX(65) / 1. /
      DATA      CPARAS(66) / 'UYMIN3  ' / , RX(66) / 0. /
      DATA      CPARAS(67) / 'UYMAX3  ' / , RX(67) / 1. /
      DATA      CPARAS(68) / 'UZMIN3  ' / , RX(68) / 0. /
      DATA      CPARAS(69) / 'UZMAX3  ' / , RX(69) / 1. /
      DATA      CPARAS(70) / 'VXORG3  ' / , RX(70) / 0. /
      DATA      CPARAS(71) / 'VYORG3  ' / , RX(71) / 0. /
      DATA      CPARAS(72) / 'VZORG3  ' / , RX(72) / 0. /
      DATA      CPARAS(73) / 'SIMFAC3 ' / , RX(73) / 0.0 /

*     / LONG  NAME /

      DATA      CPARAL( 1) / 'INTERPOLATION_ANGLE_X' /
      DATA      CPARAL( 2) / 'INTERPOLATION_ANGLE_Y' /
      DATA      CPARAL( 3) / 'LINE_BIT_LENGTH' /
      DATA      CPARAL( 4) / 'SCRIPT_HEIGHT' /
      DATA      CPARAL( 5) / 'SCRIPT_SHIFT' /
      DATA      CPARAL( 6) / 'POLIMARKER_HEIGHT' /
      DATA      CPARAL( 7) / '****RFAROT  ' /
      DATA      CPARAL( 8) / 'TONE_CYCLE_LENGTH' /
      DATA      CPARAL( 9) / 'LINE_LABEL_SPACE' /
      DATA      CPARAL(10) / 'LINE_CYCLE_LENGTH' /
      DATA      CPARAL(11) / 'LINE_START_POSITION' /
      DATA      CPARAL(12) / 'RESUME_POSITION_AFTER_BUFFERING' /
      DATA      CPARAL(13) / 'LINE_LABEL_THRESHOLD_CURVATURE' /
      DATA      CPARAL(14) / 'ARROWHEAD_PROPOTION' /
      DATA      CPARAL(15) / 'ARROWHEAD_SIZE' /
      DATA      CPARAL(16) / 'ARROWHEAD_SIZE_MAP' /
      DATA      CPARAL(17) / 'ARROWHEAD_ANGLE' /
      DATA      CPARAL(18) / '++++VXMIN   ' /
      DATA      CPARAL(19) / '++++VXMAX   ' /
      DATA      CPARAL(20) / '++++VYMIN   ' /
      DATA      CPARAL(21) / '++++VYMAX   ' /
      DATA      CPARAL(22) / '++++UXMIN   ' /
      DATA      CPARAL(23) / '++++UXMAX   ' /
      DATA      CPARAL(24) / '++++UYMIN   ' /
      DATA      CPARAL(25) / '++++UYMAX   ' /
      DATA      CPARAL(26) / '++++VXOFF   ' /
      DATA      CPARAL(27) / '++++VYOFF   ' /
      DATA      CPARAL(28) / '++++PLX     ' /
      DATA      CPARAL(29) / '++++PLY     ' /
      DATA      CPARAL(30) / '++++PLROT   ' /
      DATA      CPARAL(31) / '++++SIMFAC  ' /
      DATA      CPARAL(32) / '++++STLAT1  ' /
      DATA      CPARAL(33) / '++++STLAT2  ' /
      DATA      CPARAL(34) / '++++TXMIN   ' /
      DATA      CPARAL(35) / '++++TXMAX   ' /
      DATA      CPARAL(36) / '++++TYMIN   ' /
      DATA      CPARAL(37) / '++++TYMAX   ' /
      DATA      CPARAL(38) / '++++CXMIN   ' /
      DATA      CPARAL(39) / '++++CXMAX   ' /
      DATA      CPARAL(40) / '++++CYMIN   ' /
      DATA      CPARAL(41) / '++++CYMAX   ' /
      DATA      CPARAL(42) / 'SATELLITE_ALTITUDE' /
      DATA      CPARAL(43) / '****FACTOR  ' /
      DATA      CPARAL(44) / 'CORNERMARK_LENGTH' /
      DATA      CPARAL(45) / '****XPAD    ' /
      DATA      CPARAL(46) / '****YPAD    ' /
      DATA      CPARAL(47) / '++++TILT3   ' /
      DATA      CPARAL(48) / '++++ANGLE3  ' /
      DATA      CPARAL(49) / '++++XOFF3   ' /
      DATA      CPARAL(50) / '++++YOFF3   ' /
      DATA      CPARAL(51) / '++++XOBJ3   ' /
      DATA      CPARAL(52) / '++++YOBJ3   ' /
      DATA      CPARAL(53) / '++++ZOBJ3   ' /
      DATA      CPARAL(54) / '++++XEYE3   ' /
      DATA      CPARAL(55) / '++++YEYE3   ' /
      DATA      CPARAL(56) / '++++ZEYE3   ' /
      DATA      CPARAL(57) / '++++SEC3    ' /
      DATA      CPARAL(58) / '++++VXMIN3  ' /
      DATA      CPARAL(59) / '++++VXMAX3  ' /
      DATA      CPARAL(60) / '++++VYMIN3  ' /
      DATA      CPARAL(61) / '++++VYMAX3  ' /
      DATA      CPARAL(62) / '++++VZMIN3  ' /
      DATA      CPARAL(63) / '++++VZMAX3  ' /
      DATA      CPARAL(64) / '++++UXMIN3  ' /
      DATA      CPARAL(65) / '++++UXMAX3  ' /
      DATA      CPARAL(66) / '++++UYMIN3  ' /
      DATA      CPARAL(67) / '++++UYMAX3  ' /
      DATA      CPARAL(68) / '++++UZMIN3  ' /
      DATA      CPARAL(69) / '++++UZMAX3  ' /
      DATA      CPARAL(70) / '++++VXORG3  ' /
      DATA      CPARAL(71) / '++++VYORG3  ' /
      DATA      CPARAL(72) / '++++VZORG3  ' /
      DATA      CPARAL(73) / '++++SIMFAC3 ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','SGRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','SGRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','SGRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('SG', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','SGRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('SG', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','SGRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U1D2

      PARAMETER( NMAX=50, YMIN=0., YMAX=50. )
      REAL X1(0:NMAX), X2(0:NMAX)

*-- データ ----
      ISEED = 1
      DO 10 N=0,NMAX
        Y = YMIN + (YMAX-YMIN)*N/NMAX
        X1(N) = 10.*(EXP(-Y/20))**2 * EXP((RNGU0(ISEED)-0.5)*2)**2
        X2(N) = 10.*(EXP(-Y/20))**2
   10 CONTINUE

      CALL GLRGET( 'RUNDEF', RUNDEF )

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( RUNDEF, RUNDEF, YMIN, YMAX )
      CALL USSPNT( NMAX+1, X1, RUNDEF )
      CALL USSPNT( NMAX+1, X2, RUNDEF )
      CALL GRSTRN( 3 )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'MIXING RATIO', 'ppmv', 'HEIGHT', 'km' )
      CALL USDAXS

      CALL UUSMKT( 2 )
      CALL UUMRK( NMAX+1, X1, RUNDEF )

      CALL UULIN( NMAX+1, X2, RUNDEF )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     ULIQNP / ULIQID / ULIQCP / ULIQVL / ULISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ULIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 4)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'IXCHR   ' /, IX(1) / 195 /
      DATA      CPARAS(2) / 'IYCHR   ' /, IX(2) / 195 /
      DATA      CPARAS(3) / 'IXTYPE  ' /, IX(3) / 1 /
      DATA      CPARAS(4) / 'IYTYPE  ' /, IX(4) / 1 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'LOG_X_LABEL_CHAR' /
      DATA      CPARAL(2) / 'LOG_Y_LABEL_CHAR' /
      DATA      CPARAL(3) / '****IXTYPE  ' /
      DATA      CPARAL(4) / '****IYTYPE  ' /

*     IXCHR /IYCHR  : CHARACTER NUMBER OF * FOR 5*10E1 IN X/Y-AXIS
*     IXTYPE/IXTYPE : 1-4  1 ... 10|2" 2*10|2" 5*10|2" 10|3"  ETC
*                          2 ... 10|2" 2       5       10|3"  ETC
*                          3 ... 100   200     500     1000   ETC
*                          4 ... 100   2       5       1000   ETC
*               FORMAT FOR 3 OR 4 DEPENDS ON THAT SET BY ULSFMT

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','ULIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','ULIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','ULIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UL', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','ULIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UL', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','ULISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY ULIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!  UHpack Module
!-------------------------------------------------
module uhpack
  use dcl_common
  contains

!--------------------------------------------------------
!   エラーバーを描く．
    subroutine DclDrawXErrorBar(x1,x2,y,type,index,width)
      real,      intent(in), dimension(:) :: x1, x2, y 
      integer,   intent(in), optional     :: type, index
      real,      intent(in), optional     :: width

      call sgoopn('DclDrawXErrorBar', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqebt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqebi(index0)
      end if

      if(present(width)) then ; width0 = width
                         else ; call uuqebs(width0)
      end if

      nx1 = size(x1)
      nx2 = size(x2)
      ny = size(y)
      if(nx1.ne.ny .or. nx2.ne.ny)  call msgdmp('M', 'DclDrawXErrorBar', &
                                    & 'Length of x and y don''t match.')
      n = min(nx1, nx2, ny)

      call uherbz(n,x1,x2,y,itype0,index0,width0)
      call sgocls('DclDrawXErrorBar')
    end subroutine
!--------------------------------------------------------
!   2本の折れ線の間をトーンパターンで塗る．
    subroutine DclShadeXGap(x1,x2,y,pattern1,pattern2)
      real,      intent(in), dimension(:) :: x1, x2, y
      integer,   intent(in), optional :: pattern1, pattern2     !トーンパターン番号．

      call sgoopn('DclShadeXGap', ' ')
      if(present(pattern1)) then ; itp1 = pattern1
                            else ; call uuqarp(itp1, idummy)
      end if

      if(present(pattern2)) then ; itp2 = pattern1
                            else ; call uuqarp(idummy, itp2)
      end if
 
      nx1 = size(x1)
      nx2 = size(x2)
      ny = size(y)
      if(nx1.ne.ny .or. nx2.ne.ny)  call msgdmp('M', 'DclShadeXGap', &
                                    & 'Length of x and y don''t match.')
      n = min(nx1, nx2, ny)

      call uhdifz(n,x1,x2,y,itp1,itp2) 
      call sgocls('DclShadeXGap')
    end subroutine
!--------------------------------------------------------
!   棒グラフの枠を描く．
    subroutine DclDrawXBarFrame(x1,x2,y,type,index,width)
      real,      intent(in), dimension(:) :: x1, x2, y
      integer,   intent(in), optional :: type, index
      real,      intent(in), optional :: width
 
     call sgoopn('DclDrawXBarFrame', ' ')
     if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      if(present(width)) then ; width0 = width
                         else ; call uuqbrs(width0)
      end if

      nx1 = size(x1)
      nx2 = size(x2)
      ny = size(y)
      if(nx1.ne.ny .or. nx2.ne.ny)  call msgdmp('M', 'DclDrawXBarFrame', &
                                    & 'Length of x and y don''t match.')
      n = min(nx1, nx2, ny)
      
      call uhbrfz(n,x1,x2,y,itype0,index0,width0)
      call sgocls('DclDrawXBarFrame')
    end subroutine
!--------------------------------------------------------
!   棒グラフの内部領域を塗る
    subroutine DclShadeXBarArea(x1,x2,y,pattern1,pattern2,width)
      real,      intent(in), dimension(:) :: x1, x2, y
      integer,   intent(in), optional :: pattern1, pattern2
      real,      intent(in), optional :: width

      call sgoopn('DclShadeXBarArea', ' ')
      if(present(pattern1)) then ; itp1 = pattern1
                            else ; call uuqarp(itp1, idummy)
      end if

      if(present(pattern2)) then ; itp2 = pattern1
                            else ; call uuqarp(idummy, itp2)
      end if
 
      if(present(width))    then ; width0 = width
                            else ; call uuqbrs(width0)
      end if
 
      nx1 = size(x1)
      nx2 = size(x2)
      ny = size(y)
      if(nx1.ne.ny .or. nx2.ne.ny)  call msgdmp('M', 'DclShadeXBarArea', &
                                    & 'Length of x and y don''t match.')
      n = min(nx1, nx2, ny)
      
      call uhbraz(n,x1,x2,y,itp1,itp2,width0)
      call sgocls('DclShadeXBarArea')
    end subroutine
!--------------------------------------------------------
!   棒グラフを線で結ぶ．
    subroutine DclDrawXBarLine(x,y,type,index,width)
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional :: type, index
      real,      intent(in), optional :: width

      call sgoopn('DclDrawXBarLine', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      if(present(width)) then ; width0 = width
                         else ; call uuqbrs(width0)
      end if

      nx = size(x)
      ny = size(y)
      if(nx.ne.ny)  call msgdmp('M', 'DclDrawXBarLine', &
                                    & 'Length of x and y don''t match.')
      n = min(nx, ny)
      
      call uhbrlz(n,x,y,itype0,index0,width0) 
      call sgocls('DclDrawXBarLine')
    end subroutine
!--------------------------------------------------------
!   箱グラフの枠を描く．
    subroutine DclDrawXBoxFrame(x1,x2,y,type,index)
      real,      intent(in), dimension(:) ::x1, x2, y
      integer,   intent(in), optional :: type, index

      call sgoopn('DclDrawXBoxFrame', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      nx1 = size(x1)
      nx2 = size(x2)
      ny = size(y)
      if(nx1.ne.ny-1 .or. nx2.ne.ny-1)  call msgdmp('M', 'DclDrawXBoxFrame', &
                                    & 'Length of x and y don''t match.')
      n = min(nx1, nx2, ny-1)

      call uhbxfz(n,x1,x2,y,itype0,index0) 
      call sgocls('DclDrawXBoxFrame')
    end subroutine
!--------------------------------------------------------
!   箱グラフの内部領域を塗る．
    subroutine DclShadeXBoxArea(x1,x2,y,pattern1,pattern2)
      real,      intent(in), dimension(:) :: x1, x2, y
      integer,   intent(in), optional :: pattern1, pattern2

      call sgoopn('DclShadeXBoxArea', ' ')
      if(present(pattern1)) then ; itp1 = pattern1
                            else ; call uuqarp(itp1, idummy)
      end if

      if(present(pattern2)) then ; itp2 = pattern1
                            else ; call uuqarp(idummy, itp2)
      end if
  
      nx1 = size(x1)
      nx2 = size(x2)
      ny = size(y)
      if(nx1.ne.ny-1 .or. nx2.ne.ny-1)  call msgdmp('M', 'DclShadeXBoxArea', &
                                    & 'Length of x and y don''t match.')
      n = min(nx1, nx2, ny-1)
      
      call uhbxaz(n,x1,x2,y,itp1,itp2) 

      call sgocls('DclShadeXBoxArea')
    end subroutine
!--------------------------------------------------------
!   階段状のグラフを描く．
    subroutine DclDrawXBoxLine(x,y,type,index)
      real,      intent(in), dimension(:) :: x, y
      integer,   intent(in), optional :: type, index

      call sgoopn('DclDrawXBoxLine', ' ')
      if(present(type))  then ; itype0 = type
                         else ; call uuqfrt(itype0)
      end if
        
      if(present(index)) then ; index0 = index
                         else ; call uuqfri(index0)
      end if

      nx = size(x)
      ny = size(y)
      if(nx.ne.ny-1)  call msgdmp('M', 'DclDrawXBoxLine', &
                                    & 'Length of x and y don''t match.')
      n = min(nx, ny-1)

      call uhbxlz(n,x,y,itype0,index0)
      call sgocls('DclDrawXBoxLine')
    end subroutine

end module

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM G2PK01

      PARAMETER(NX=15,NY=15)

      REAL UX(NX), UY(NY)
      REAL UYW(NX), UXW(NY) 
      REAL CX(NX,NY), CY(NX,NY)
      REAL Z(NX,NY)


*     / SET PARAMETERS /

      DO 10 I=1,NX
        UX(I)=(I-1.0)/(NX-1.0)
   10 CONTINUE
      DO 15 J=1,NY
        UY(J)=(J-1.0)/(NY-1.0)
   15 CONTINUE

      DO 25 J=1,NY
        DO 20 I=1,NX
          CX(I,J) = UX(I) + 0.1*UY(J)
          CY(I,J) = 0.2*UX(I) + UY(J)
   20   CONTINUE
   25 CONTINUE

      CXMIN = 0.0
      CXMAX = 1.1
      CYMIN = 0.0
      CYMAX = 1.1

*     / GRAPHIC /

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSVPT(0.15,0.85,0.15,0.85)
      CALL GRSWND(UX(1),UX(NX),UY(1),UY(NY))
      CALL G2SCTR(NX,NY,UX,UY,CX,CY)
      CALL GRSTRN(51)
      CALL SGSCWD(CXMIN,CXMAX,CYMIN,CYMAX)
      CALL GRSTRF

      CALL SGLSET('LCLIP',.TRUE.)

*     / TONE /

      DO 35 J=1,NY
        DO 30 I=1,NX
          Z(I,J) = UX(I) + UY(J)
   30   CONTINUE
   35 CONTINUE

      CALL UELSET('LTONE',.TRUE.)
      CALL UWSGXA(UX,NX)
      CALL UWSGYA(UY,NY)
      CALL UETONE(Z, NX, NX, NY)

*     / GRID LINES /

      DO 45 J=1,NY
        DO 40 I=1,NX
          UYW(I) = UY(J)
   40   CONTINUE
        CALL SGPLU(NX,UX,UYW)
   45 CONTINUE

      DO 55 I=1,NX
        DO 50 J=1,NY
          UXW(J) = UX(I)
   50   CONTINUE
        CALL SGPLU(NY,UXW,UY)
   55 CONTINUE

*     / AXES (Switch to ITR==1) /

      CALL GRSWND(CXMIN,CXMAX,CYMIN,CYMAX)
      CALL GRSTRN(1)
      CALL GRSTRF
      CALL USDAXS
      CALL UXSTTL('T','BOTH X & Y TRANSFORMED',0.0)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM GT2D01

      PARAMETER(NX=15,NY=15)

      REAL UX(NX), UY(NY)
      REAL CX(NX,NY), CY(NX,NY)
      REAL TERRAIN(NX)


      CALL GLRGET('RUNDEF',RUNDEF)

      DO 10 I=1,NX
        UX(I)=(I-1.0)/(NX-1.0) - 0.5
        TERRAIN(I) = 0.1 * EXP(-24*UX(I)**2)
   10 CONTINUE
      DO 15 J=1,NY
        UY(J)=(J-1.0)/(NY-1.0)
   15 CONTINUE

      CX(1,1) = RUNDEF
      DO 25 J=1,NY
        DO 20 I=1,NX
          CY(I,J) = UY(J)*(1.0-TERRAIN(I)) + TERRAIN(I)
   20   CONTINUE
   25 CONTINUE

      CALL G2SCTR(NX, NY, UX,UY, CX,CY)

      PRINT *, "TERRAIN FOLLOWING COORDINATE"

      UXP = 0.2
      UYP = 0.3
      PRINT *, "ORIGINAL UX, UY:", UXP, UYP

      CALL G2FCTR(UXP, UYP, CXP, CYP)
      PRINT *, "TRANSFORMED CX, CY:", CXP, CYP
      CALL G2ICTR(CXP, CYP, UXP, UYP)
      PRINT *, "INVERTED UX, UY:", UXP, UYP

      END

*-----------------------------------------------------------------------
      SUBROUTINE CLRGLS(R,G,B,H,L,S,N,M)

      INTEGER R(N,M),G(N,M),B(N,M)
      REAL    H(N,M),L(N,M),S(N,M)
      REAL    CNT
      INTEGER MAX,MIN


      DO 10 I=1,N
      DO 20 J=1,M
      IF ((R(I,J).GE.G(I,J)) .AND.(R(I,J).GE.B(I,J))) THEN
        MAX=R(I,J)
      ELSE IF (G(I,J).GE.B(I,J)) THEN
        MAX=G(I,J)
      ELSE
        MAX=B(I,J)
      ENDIF
      IF (( R(I,J).LE.G(I,J) ) .AND. ( R(I,J).LE.B(I,J))) THEN
        MIN=R(I,J)
      ELSE IF (G(I,J).LE.B(I,J)) THEN
        MIN=G(I,J)
      ELSE
        MIN=B(I,J)
      ENDIF

      IF (MAX.EQ.R(I,J))THEN
        H(I,J) = 60.0 * (G(I,J)-B(I,J))/(MAX-MIN)
      ELSE IF (MAX.EQ.G(I,J))THEN
        H(I,J) = 60.0 * (B(I,J)-R(I,J))/(MAX-MIN) + 120.0
      ELSE
        H(I,J) = 60.0 * (R(I,J)-G(I,J))/(MAX-MIN) + 240.0
      ENDIF

      H(I,J) = MOD(H(I,J),360.0)
      L(I,J)=100.*((MAX+MIN)/2.)/255.
      IF (L(I,J).LE.50.) THEN
        S(I,J) = 100.*(MAX-MIN)/(MAX+MIN)
      ELSE
        S(I,J) = 100.*(MAX-MIN)/(510-MAX-MIN)
      ENDIF

 20   CONTINUE
 10   CONTINUE


      RETURN
      END

      PROGRAM KIHON4

      PARAMETER( NMAX=9, X1=0.1, XC=0.5, X2=0.9 )
      REAL Y(NMAX)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

*-- 罫線 ----
      DO 10 N=1,NMAX
        Y(N) = 0.1*(10-N)
        CALL SGLNV( X1, Y(N), X2, Y(N) )
  10  CONTINUE

      CALL SGLNV( XC, 0.05, XC, 0.95 )

*-- デフォルト ----
      CALL SGTXV( XC, Y(1), 'SGTXV' )

*-- 文字のラインインデクス ----
      CALL SGSTXI( 3 )
      CALL SGTXV( XC, Y(2), 'INDEX3' )

      CALL SGSTXI( 5 )
      CALL SGTXV( XC, Y(3), 'INDEX5' )

      CALL SGSTXI( 1 )

*-- 文字の大きさ ----
      CALL SGSTXS( 0.03 )
      CALL SGTXV( XC, Y(4), 'SMALL' )

      CALL SGSTXS( 0.07 )
      CALL SGTXV( XC, Y(5), 'LARGE' )

      CALL SGSTXS( 0.05 )

*-- 文字列のセンタリングオプション ----
      CALL SGSTXC( -1 )
      CALL SGTXV( XC, Y(6), 'LEFT' )

      CALL SGSTXC( 1 )
      CALL SGTXV( XC, Y(7), 'RIGHT' )

      CALL SGSTXC( 0 )

*-- 文字列の回転角 ----
      CALL SGSTXR( 10 )
      CALL SGTXV( XC, Y(8), 'ROTATION+' )

      CALL SGSTXR( -10 )
      CALL SGTXV( XC, Y(9), 'ROTATION-' )

      CALL SGCLS

      END

!-------------------------------------------------
!interface module of ugpack
!-------------------------------------------------
module ug_interface
  interface

    subroutine ugvect(u,mu,v,mv,nx,ny)            !2次元ベクトル場を描く．
      real,      intent(in), dimension(mu,*) :: u !ベクトルのx成分を与えるmu,nyの2次元配列．
      integer,   intent(in) :: mu                 !配列uの第1次元整合寸法
      real,      intent(in), dimension(mv,*) :: v !ベクトルのy成分を与えるmu,nyの2次元配列．
      integer,   intent(in) :: mv                 !配列vの第1次元整合寸法
      integer,   intent(in) :: nx                 !作画に使う配列u, vの第1次元寸法
      integer,   intent(in) :: ny                 !作画に使う配列u, vの第2次元寸法
    end subroutine
      
    subroutine ugsut(cside,cttl)                  !ユニットベクトルにつけるタイトルを設定する．
      character(len=1), intent(in) :: cside       !タイトル位置を指定する
      character(len=*), intent(in) :: cttl        !タイトル
    end subroutine
      
    subroutine ugpget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ugiget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ugrget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine uglget(cp,ipara)                   !内部変数を参照する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine ugpset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ugiset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ugrset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uglset(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ugpstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ugistx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ugrstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine uglstx(cp,ipara)                   !内部変数を変更する
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine ugpqnp(ncp)                        !内部変数の総数を求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine ugpqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine ugpqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する
      character(len=*), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine ugpqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine ugpsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine
      
  end interface
end module
!ugpack library end ----

      PROGRAM UXYZ7

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( 1990., 1995., -2.0, 2.0 )
      CALL GRSVPT(   0.2,   0.8,  0.3, 0.7 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UZRSET( 'UYUSER', 0. )
      CALL UZLSET( 'LBTWN', .TRUE. )
      CALL UXSFMT( '(I4)' )
      CALL UXAXDV( 'U', 0.25, 1. )
      CALL UZLSET( 'LBTWN', .FALSE. )
      CALL UXSTTL( 'U', 'YEAR', 1. )

      CALL UZISET( 'INNER', -1 )
      CALL UYSFMT( '(F4.1)' )
      CALL UYAXDV( 'L', 0.25, 1. )
      CALL UYSTTL( 'L', 'S.O.Index', 0. )

      CALL UXMTTL( 'T', 'UXAXDV/UYAXDV', 0. )

      CALL GRCLS

      END

!-------------------------------------------------
!interface module of fftlib
!-------------------------------------------------
module fft_interface
  interface
!---------------------------------------------------------
!周期実数値データのフーリエ変換
    subroutine rffti(n,wsave)                     !初期化をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(out), dimension(*) :: wsave !作業用配列．長さは少なくとも2n+15以上
    end subroutine
      
    subroutine rfftf(n,r,wsave)                   !フーリエ順変換をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列．長さは少なくとも2n+15以上
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
      
    subroutine rfftb(n,r,wsave)                   !フーリエ逆変換をおこなう．
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列．長さは少なくとも2n+15以上
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
!---------------------------------------------------------
!rffti, rfftf, rfftbの簡易型サブルーチン
    subroutine ezffti(n,wsave)                    !初期化をおこなう;
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(out), dimension(*) :: wsave !作業用配列
    end subroutine
      
    subroutine ezfftf(n,r,a0,a,b,wsave)           !フーリエ順変換をおこなう;
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(in), dimension(*) :: r    !処理する実数型配列
      real,      intent(out) :: a0                !上記定義における a_0 および a_0
      real,      intent(out), dimension(*) :: a   !nが偶数のとき n/2, nが奇数のとき(n-1)/2の長さの実数型配列
      real,      intent(out), dimension(*) :: b   !
    end subroutine
      
    subroutine ezfftb(n,r,a0,a,b,wsave)           !ezfftbはフーリエ逆変換をおこなう．
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(out), dimension(*) :: r   !処理する実数型配列
      real,      intent(in) :: a0                 !上記定義における a_0 および a_0
      real,      intent(in), dimension(*) :: a    !nが偶数のとき n/2, nが奇数のとき(n-1)/2の長さの実数型配列
      real,      intent(in), dimension(*) :: b 
    end subroutine
!---------------------------------------------------------
!奇の周期データのsine変換をおこなう． 
    subroutine sinti(n,wsave)                     !初期化をおこなう;
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(out), dimension(*) :: wsave !作業用配列
    end subroutine
      
    subroutine sint(n,r,wsave)                    !sine変換をおこなう．
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
!---------------------------------------------------------
!偶の周期データのcosine変換をおこなう 
    subroutine costi(n,wsave)                     !初期化をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(out), dimension(*) :: wsave !作業用配列
    end subroutine
      
    subroutine cost(n,r,wsave)                    !cosine変換をおこなう．
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
!---------------------------------------------------------
!奇数波数成分のみのsin変換をおこなう．
    subroutine sinqi(n,wsave)                     !初期化をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(out), dimension(*) :: wsave !作業用配列
    end subroutine
      
    subroutine sinqf(n,r,wsave)                   !sine順変換をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
      
    subroutine sinqb(n,r,wsave)                   !逆変換をおこなう．
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
!---------------------------------------------------------
!偶数波数成分のみのcossine変換をおこなう．
    subroutine cosqi(n,wsave)                     !初期化をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(out), dimension(*) :: wsave !作業用配列
    end subroutine
      
    subroutine cosqf(n,r,wsave)                   !cosine順変換をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
      
    subroutine cosqb(n,r,wsave)                   !cosine逆変換をおこなう．
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      real,      intent(inout), dimension(*) :: r !処理する実数型配列
    end subroutine
!---------------------------------------------------------
!周期複素数データのフーリエ変換をおこなう
    subroutine cffti(n,wsave)                     !初期化をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(out), dimension(*) :: wsave !作業用配列
    end subroutine
      
    subroutine cfftf(n,c,wsave)                   !フーリエ順変換をおこなう
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      complex,   intent(inout), dimension(*) :: c !処理する複素数型配列
    end subroutine
      
    subroutine cfftb(n,c,wsave)                   !フーリエ逆変換をおこなう．
      integer,   intent(in) :: n                  !処理するデータの長さ
      real,      intent(in), dimension(*) :: wsave !作業用配列
      complex,   intent(inout), dimension(*) :: c !処理する複素数型配列
    end subroutine

  end interface
end module
!fftlib library end ----

      PROGRAM COLOR3

      PARAMETER ( NX=21, NY=21 )
      PARAMETER ( XMIN=-10, XMAX=10, YMIN=-10, YMAX=10 )
      PARAMETER ( DX1=1, DX2=5, DY1=1, DY2=5 )
      PARAMETER ( KMAX=56, PMIN=0, PMAX=1 )
      REAL P(NX,NY), PI(2,KMAX+1)

      DO 10 J=1,NY
      DO 10 I=1,NX
        X = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
        Y = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
        P(I,J) = EXP( -X**2/64 -Y**2/25 )
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      DP = (PMAX-PMIN)/KMAX
      DO 20 K=1,KMAX
        TLEV1 = (K-1)*DP
        TLEV2 = TLEV1 + DP
        IPAT  = (29+K)*1000 + 999
        CALL UESTLV( TLEV1, TLEV2, IPAT )
   20 CONTINUE

      CALL UETONE( P, NX, NX, NY )
      CALL USDAXS

*-- トーンバー ----
      CALL GRSWND(  0.0, 1.0, PMIN, PMAX )
      CALL GRSVPT( 0.85, 0.9,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      DO 30 K=1,KMAX+1
        PI(1,K) = PMIN + (K-1)*DP
        PI(2,K) = PMIN + (K-1)*DP
   30 CONTINUE

      CALL UETONE( PI, 2, 2, KMAX+1 )

      CALL SLPVPR( 3 )
      CALL UZLSET( 'LABELYR', .TRUE. )
      CALL UZFACT( 0.8 )
      CALL UYSFMT( '(F4.1)' )
      CALL UYAXDV( 'R', 0.1, 0.2 )

      CALL GRCLS

      END

      PROGRAM MAP3D3
      PARAMETER( NX=16, NY=16 )
      PARAMETER( XMIN=120, XMAX=150, YMIN=20, YMAX=50 )
      PARAMETER( FACT=0.2 )
      REAL U(NX,NY), V(NX,NY), ALON(NX), ALAT(NY)

      DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
   10 CONTINUE
      DO 20 J=1,NY
        ALAT(J) = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
   20 CONTINUE

      DO 30 J=1,NY
      DO 30 I=1,NX
        U(I,J) =   (J-1-(NY-1)/2.) * FACT
        V(I,J) = - (I-1-(NX-1)/2.) * FACT
   30 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM
      CALL SGLSET( 'LCLIP', .TRUE. )

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
      CALL GRSTRN( 10 )
      CALL UMPFIT
      CALL GRSTRF

      CALL SLPVPR( 3 )
      CALL UMRSET( 'DGRIDMJ', 10. )
      CALL UMRSET( 'DGRIDMN',  2. )
      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB

      CALL SGSLAI( 3 )
      DO 40 J=1,NY
      DO 40 I=1,NX
        CALL SGLAU( ALON(I), ALAT(J), ALON(I)+U(I,J), ALAT(J)+V(I,J) )
   40   CONTINUE

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     SLPWWR : PLOT WORKSTATION-WINDOW RECTANGLE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLPWWR(INDEX)


      IF (INDEX.LE.0) THEN
        IF (INDEX.EQ.0) THEN
          CALL MSGDMP('M','SLPWWR','LINE INDEX IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPWWR','LINE INDEX IS LESS THAN ZERO.')
        END IF
      END IF

      CALL STQWTR(RXMIN,RXMAX,RYMIN,RYMAX,WXMIN,WXMAX,WYMIN,WYMAX,ITR)

      CALL SZSLTI(1,INDEX)

      CALL SZOPLR
      CALL SZMVLR(RXMIN,RYMIN)
      CALL SZPLLR(RXMAX,RYMIN)
      CALL SZPLLR(RXMAX,RYMAX)
      CALL SZPLLR(RXMIN,RYMAX)
      CALL SZPLLR(RXMIN,RYMIN)
      CALL SZCLLR

      END

*-----------------------------------------------------------------------
*     USPACK AXIS (AUTO SCALING)                      S.Sakai  99/10/07
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USAXSC(CSIDE)

      CHARACTER  CSIDE*(*), CS, CP*8
      EXTERNAL   LENZ
      LOGICAL    LMATCH, LOFF

      IF(CSIDE.EQ.' ') RETURN

      CALL SGQTRN(ITR)
      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGQWND(UXMIN0, UXMAX0, UYMIN0, UYMAX0)

      CALL UZRGET('XFACT' , XFACT  )
      CALL UZRGET('XOFFSET', XOFFSET)
      CALL UZRGET('YFACT' , YFACT  )
      CALL UZRGET('YOFFSET', YOFFSET)
      UXMIN = XFACT*UXMIN0 + XOFFSET
      UXMAX = XFACT*UXMAX0 + XOFFSET
      UYMIN = YFACT*UYMIN0 + YOFFSET
      UYMAX = YFACT*UYMAX0 + YOFFSET

      NCS = LENZ(CSIDE)
      CALL UZLGET('LOFFSET', LOFF)
      CALL UZLSET('LOFFSET', .TRUE.)

      DO 100 I=1, NCS
        CS = CSIDE(I:I)
        CALL CUPPER(CS)

        IF(CS.EQ.'T' .OR. CS.EQ.'B' .OR. CS.EQ.'H') THEN
          IF(CS.EQ.'H') CS='U'

          IF(ITR.EQ.1 .OR. ITR.EQ.2) THEN
            CP = 'IROTLX'//CS
            CALL UZIGET(CP, IROTA)
            CALL USLGET('LMATCH' , LMATCH)
            MODE = MOD(IROTA,2)
            IF(LMATCH) MODE = 0

            CALL USUSCU('X', UXMIN, UXMAX, VXMIN, VXMAX, MODE)
            CALL USRGET('DXT', DXT)
            CALL USRGET('DXL', DXL)
            IF(CS.EQ.'U') CS='H'
            CALL USAXDV(CS, DXT, DXL)

          ELSEIF(ITR.EQ.3 .OR. ITR.EQ.4) THEN
            CALL USUSCL('X', UXMIN, UXMAX, VXMIN, VXMAX)
            CALL USIGET('NLBLX'  , NLBL  )
            CALL USIGET('NTICKSX', NTICKS)
            CALL USIGET('ITYPEX' , ITYPEX)

            CALL ULIGET('IXTYPE', IT    )
            CALL ULISET('IXTYPE', ITYPEX)
            CALL USAXLG(CS, NLBL, NTICKS)
            CALL ULISET('IXTYPE', IT    )
          ELSE
            CALL MSGDMP('E', 'USXAXS', 'INVALID TRANSFORMATION NUMBER.')
          ENDIF


        ELSEIF(CS.EQ.'L' .OR. CS.EQ.'R' .OR. CS.EQ.'V') THEN
          IF(CS.EQ.'V') CS='U'

          IF(ITR.EQ.1 .OR. ITR.EQ.3) THEN
            CP = 'IROTLY'//CS
            CALL UZIGET(CP, IROTA)
            CALL USLGET('LMATCH' , LMATCH)
            MODE = MOD(IROTA+1,2)
            IF(LMATCH) MODE = 0

            CALL USUSCU('Y', UYMIN, UYMAX, VYMIN, VYMAX, MODE)
            CALL USRGET('DYT', DYT)
            CALL USRGET('DYL', DYL)
            IF(CS.EQ.'U') CS='V'
            CALL USAXDV(CS, DYT, DYL)

          ELSEIF(ITR.EQ.2 .OR. ITR.EQ.4) THEN
            CALL USUSCL('Y', UYMIN, UYMAX, VYMIN, VYMAX)
            CALL USIGET('NLBLY'  , NLBL  )
            CALL USIGET('NTICKSY', NTICKS)
            CALL USIGET('ITYPEY' , ITYPEY)

            CALL ULIGET('IYTYPE', IT    )
            CALL ULISET('IYTYPE', ITYPEY)
            CALL USAXLG(CS, NLBL, NTICKS)
            CALL ULISET('IYTYPE', IT    )

          ELSE
            CALL MSGDMP('E', 'USYAXS', 'INVALID TRANSFORMATION NUMBER.')
          ENDIF

        ENDIF

  100 CONTINUE

      CALL UZLSET('LOFFSET', LOFF)
      END

      PROGRAM QUICK1

      PARAMETER( NMAX=50 )
      REAL X(0:NMAX), Y(0:NMAX)

*-- ロジスティク模型 ----
      R    = 3.7
      X(0) = 0.0
      Y(0) = 0.5
      DO 10 N=0,NMAX-1
        X(N+1) = X(N) + 1.0
        Y(N+1) = R*Y(N)*(1.-Y(N))
   10 CONTINUE

*-- グラフ ----
      CALL GROPN( 1 )
      CALL GRFRM
      CALL USGRPH( NMAX+1, X, Y )
      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCTNZV(VPX,VPY,VPZ,ITPAT1,ITPAT2)

      REAL      VPX(*),VPY(*),VPZ(*)


      IF (ITPAT1.EQ.0 .OR. ITPAT2.EQ.0) THEN
        CALL MSGDMP('M','SCTNZV','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT1.LT.0 .OR. ITPAT2.LE.0) THEN
        CALL MSGDMP('E','SCTNZV','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZT3OP(ITPAT1, ITPAT2)
      CALL SZT3ZV(VPX,VPY,VPZ)
      CALL SZT3CL

      END

      program UIPK03

	  PARAMETER (NX=100, NY=100, LEVEL=256)
      REAL R(NX,NY),B(NX,NY),G(NX,NY)
      REAL RC(NX,NY),BC(NX,NY),GC(NX,NY)
      REAL CL(LEVEL)
      INTEGER IR(LEVEL),IG(LEVEL),IB(LEVEL)
      INTEGER I
      INTEGER IMAGE(300)

	  do i=1,level
		CL(i) = 1.0*(i-1)/(level-1)
		call UIFPAC(level-i,0,0,ir(i))
		call UIFPAC(0,level-i,0,ig(i))
		call UIFPAC(0,0,level-i,ib(i))
	  end do
	  do i=1,nx
		do j=1,ny
			r(i,j) = exp(-((i-nx/2. )**2.  + (j-ny/2.)**2. ) / 5000.)
			g(i,j) = exp(-((i-nx/1.1)**2.  + (j-ny/1.2)**2.) / 1000.)
			b(i,j) = exp(-((i-ny/3. )**2.  + (j-ny/5.)**2. ) / 3000.)
		end do
      end do
      CALL RNORML(R,RC,NX,NY,0.0,1.0)
      CALL RNORML(G,GC,NX,NY,0.2,1.0)
      CALL RNORML(B,BC,NX,NY,0.0,1.0)

      CALL SWISET('WINDOW_HEIGHT', 300)
      CALL SWISET('WINDOW_WIDTH', 300)

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSWND( -1., 1., -1., 1.)
      CALL GRSVPT(.1, .9, .1, .9)
      CALL GRSTRN(1)
      CALL GRSTRF

      call UISCMP(ig(1),ig(level),ib(1),ib(level))

      call prcopn('DclPaintGrid3')

      if(nu1 /= nv1 .or. nu2 /= nv2) then
        call msgdmp('E', 'DclPaintGrid2', 
     *       'Size of arrays are not consistent.')
      end if

      call sgqvpt(vxmin, vxmax, vymin, vymax)

      call stfpr2(vxmin, vymin, rx, ry)
      call stfwtr(rx, ry, wx, wy)
      call swfint(wx, wy, ix1, iy1)

      call stfpr2(vxmax, vymax, rx, ry)
      call stfwtr(rx, ry, wx, wy)
      call swfint(wx, wy, ix2, iy2)

      call uipd3z(rc, gc, bc, nx, nx, ny, image, iwidth)

      call prccls('DclPaintGrid3')

      CALL UXAXDV('T', .1, .5)
      CALL UXAXDV('B', .1, .5)
      CALL UYAXDV('L', .1, .5)
      CALL UYAXDV('R', .1, .5)

      CALL GRCLS


      end program

*-----------------------------------------------------------------------
*     TONE PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZTNOP(ITPAT)

      CHARACTER COBJ*80

      COMMON    /SZBLS1/ LLNINT,LGCINT,RDXR,RDYR
      LOGICAL   LLNINT,LGCINT
      COMMON    /SZBTN2/ IRMODE, IRMODR
      COMMON    /SZBTN3/ LCLIP
      LOGICAL   LCLIP

      SAVE


      CALL SGLGET('LLNINT',LLNINT)
      CALL SGLGET('LGCINT',LGCINT)
      CALL SGRGET('RDX',RDX)
      CALL SGRGET('RDY',RDY)
      CALL SGIGET('IRMODE',IRMODE)
      CALL SGLGET('LCLIP',LCLIP)

      CALL STFPR2(0., 0., RX0, RY0)
      CALL STFPR2(0., 1., RX1, RY1)
      CALL STFPR2(1., 0., RX2, RY2)

      ROT = (RX2-RX0)*(RY1-RY0) - (RY2-RY0)*(RX1-RX0)

      IRMODE = MOD(IRMODE, 2)
      IF (ROT.GT.0) THEN
        IRMODR = IRMODE
      ELSE
        IRMODR = MOD(IRMODE+1, 2)
      END IF

      CALL STFRAD(RDX, RDY, RDXR, RDYR)

      WRITE(COBJ,'(I8)') ITPAT
      CALL CDBLK(COBJ)
      CALL SWOOPN('SZTN',COBJ)

      CALL SZSTNI(ITPAT)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZTNCL

      CALL SWOCLS('SZTN')

      RETURN
      END

*-----------------------------------------------------------------------
C     SUBROUTINE RFFTI(N,WSAVE)
C
C     SUBROUTINE RFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH RFFTF AND RFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED.
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH RFFTF AND RFFTB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF RFFTF OR RFFTB.
C
      SUBROUTINE RFFTI (N,WSAVE)
      DIMENSION       WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      CALL RFFTI1 (N,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLNZV(VX1,VY1,VX2,VY2,INDEX)


      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLNZV','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLNZV','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZLNOP(INDEX)
      CALL SZLNZV(VX1,VY1,VX2,VY2)
      CALL SZLNCL

      END

!-------------------------------------------------
!interface module of udpack
!-------------------------------------------------
module ud_interface
  interface
    subroutine udcntr(z,mx,nx,ny)                 !2次元等高線図を描く
      real,      intent(in), dimension(mx,*) :: z !mx  nyの2次元配列．作画にはnx nyの部分を使う
      integer,   intent(in) :: mx                 !配列zの第1次元整合寸法
      integer,   intent(in) :: nx                 !作画に使う配列zの第1次元寸法
      integer,   intent(in) :: ny                 !作画に使う配列zの第2次元寸法
    end subroutine
      
    subroutine udcntz(z,mx,nx,ny,ibr,nbr3)        !2次元等高線図を描く.
      real,      intent(in), dimension(mx,*) :: z !mx  nyの2次元配列． 作画にはnx nyの部分を使う
      integer,   intent(in) :: mx                 !配列zの第1次元整合寸法
      integer,   intent(in) :: nx                 !作画に使う配列zの第1次元寸法
      integer,   intent(in) :: ny                 !作画に使う配列zの第2次元寸法
      integer,   intent(out), dimension(*) :: ibr !作業領域として用いられる配列
      integer,   intent(in) :: nbr3               !配列ibrの長さ
    end subroutine
      
    subroutine udgcla(xmin,xmax,dx)               !コンターレベル値を最小値・最大値,きざみ値,レベル数で設定する．
      real,      intent(in) :: xmin               !コンターレベルの最小値
      real,      intent(in) :: xmax               !コンターレベルの最大値.
      real,      intent(in) :: dx                 !きざみ幅
    end subroutine
      
    subroutine udgclb(z,mx,nx,ny,dx)              !コンターレベル値を格子点値を与える配列,きざみ値,レベル数で設定する．
      real,      intent(in), dimension(mx,*) :: z !mx  nyの2次元配列．作画にはnx nyの部分を使う
      integer,   intent(in) :: mx                 !配列zの第1次元整合寸法
      integer,   intent(in) :: nx                 !作画に使う配列zの第1次元寸法
      integer,   intent(in) :: ny                 !作画に使う配列zの第2次元寸法
      real,      intent(in) :: dx                 !きざみ幅
    end subroutine
      
    subroutine udsclv(zlev,indx,ityp,clv,hl)      !コンターラインの属性をすべて指定して1本のコンターレベルを設定する．
      real,      intent(in) :: zlev               !コンターレベルの値
      integer,   intent(in) :: indx               !コンターラインのラインインデクス
      integer,   intent(in) :: ityp               !コンターラインのラインタイプ
      character(len=*), intent(in) :: clv         !コンターラインにつけるラベル
      real,      intent(in) :: hl                 !ラベルの高さ(単位はv座標系）
    end subroutine
      
    subroutine udqclv(zlev,indx,ityp,clv,hl,nlev) !第nl番目のコンターレベルの属性
      real,      intent(out) :: zlev
      integer,   intent(out) :: indx
      integer,   intent(out) :: ityp
      character(len=*), intent(out) :: clv
      real,      intent(out) :: hl
      integer,   intent(in) :: nlev
    end subroutine
      
    subroutine udqcln(nlev)                       !現在設定されているコンターレベルの総本数
      integer,   intent(out) :: nlev
    end subroutine
      
    subroutine uddclv(zlev)                       !あるコンターレベルを削除する．
      real,      intent(in) :: zlev               !削除するコンターレベルの値
    end subroutine
      
    subroutine udiclv()                           !コンターレベルを無効にする．
    end subroutine
      
    function rudlev(nlev)                         !コンターレベルの間隔を求める．
      integer,   intent(in) :: nlev               !何番目のコンター間隔を調べるか指定する
      real rudlev                                 !コンター間隔を与える実数型関数値
    end function
      
    subroutine udsfmt(cfmt)                       !コンターラベルのフォーマットを指定する．
      character(len=*), intent(in) :: cfmt        !指定するフォーマット（長さは16文字以下）
    end subroutine
      
    subroutine udqfmt(cfmt)                       !現在設定されているフォーマット
      character(len=*), intent(out) :: cfmt
    end subroutine
      
    subroutine udpget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine udiget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine udrget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine udlget(cp,ipara)                   !内部変数を参照
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(out) :: ipara             !内部変数の値
    end subroutine
      
    subroutine udpset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udiset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udrset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udlset(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udpstx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udistx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      integer,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udrstx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      real,      intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udlstx(cp,ipara)                   !内部変数を変更
      character(len=*), intent(in) :: cp          !内部変数の名前
      logical,   intent(in) :: ipara              !内部変数の値
    end subroutine
      
    subroutine udpqnp(ncp)                        !内部変数の総数を求める
      integer,   intent(out) :: ncp
    end subroutine
      
    subroutine udpqid(cp,idx)                     !内部変数cpの位置を求める．
      character(len=*), intent(in) :: cp
      integer,   intent(out) :: idx
    end subroutine
      
    subroutine udpqcp(idx,cp)                     !idxの位置にある内部変数の名前を参照する
      character(len=*), intent(out) :: cp
      integer,   intent(in) :: idx
    end subroutine
      
    subroutine udpqvl(idx,ipara)                  !idxの位置にある内部変数の値を参照する
      integer,   intent(in) :: idx
      integer,   intent(out) :: ipara
    end subroutine
      
    subroutine udpsvl(idx,ipara)                  !idxの位置にある内部変数の値を変更する
      integer,   intent(in) :: idx
      integer,   intent(in) :: ipara
    end subroutine
      
  end interface
end module
!udpack library end ----

*-----------------------------------------------------------------------
*     USPACK AXIS (LOG)                               S.Sakai  99/10/05
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USAXLG(CSIDE, NLBL, NTICKS)

      CHARACTER  CSIDE*(*), CS
      EXTERNAL   LENZ
      LOGICAL    LOFF

      CALL UZLGET('LOFFSET', LOFF)
      CALL UZLSET('LOFFSET', .TRUE.)

      NCS = LENZ(CSIDE)
      DO 100 I=1, NCS
        CS = CSIDE(I:I)
        CALL CUPPER(CS)

        IF(CS.EQ.'T' .OR. CS.EQ.'B' .OR. CS.EQ.'H') THEN
          IF(CS.EQ.'H') CS='U'
          CALL USXINZ(CS,FACTOR,OFFSET)
          CALL ULXLOG(CS, NLBL, NTICKS)
          CALL USXTLZ

        ELSEIF(CS.EQ.'L' .OR. CS.EQ.'R' .OR. CS.EQ.'V') THEN
          IF(CS.EQ.'V') CS='U'
          CALL USYINZ(CS,FACTOR,OFFSET)
          CALL ULYLOG(CS, NLBL, NTICKS)
          CALL USYTLZ
        ENDIF
  100 CONTINUE
      CALL UZLSET('LOFFSET', LOFF)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      REAL FUNCTION FFROMC(CX)

      CHARACTER CX*(*)

      CHARACTER CMSG*80,CXX*16

      INTRINSIC INDEX

      EXTERNAL  LENY,LENZ,JFROMC


      LC1=LENY(CX)+1
      LC2=LENZ(CX)

      IF (LC2.EQ.0) THEN
        CMSG='THERE IS NO VALID CHARACTER.'
        CALL MSGDMP('E','FFROMC',CMSG)
      END IF

      IF (CX(LC1:LC1).EQ.'-') THEN
        ISGN=-1
        LC1=LC1+1
      ELSE IF (CX(LC1:LC1).EQ.'+') THEN
        ISGN=+1
        LC1=LC1+1
      ELSE
        ISGN=+1
      END IF

      IDOT=INDEX(CX(1:LC2),'.')

      IF (IDOT.EQ.0) THEN
        CXX=CX(LC1:LC2)
        INX=0
      ELSE
        IF (IDOT.EQ.LC1 .AND. IDOT.EQ.LC2) THEN
          CMSG='THERE EXISTS A PERIOD ONLY.'
          CALL MSGDMP('E','FFROMC',CMSG)
        ELSE IF (IDOT.EQ.LC1) THEN
          CXX=CX(IDOT+1:LC2)
        ELSE IF (IDOT.EQ.LC2) THEN
          CXX=CX(LC1:IDOT-1)
        ELSE
          CXX=CX(LC1:IDOT-1)//CX(IDOT+1:LC2)
        END IF
        INX=IDOT-LC2
      END IF

      LCXX=LENZ(CXX)

   10 IF (CXX(1:1).NE.'0' .OR. LCXX.EQ.1) GO TO 20
        CXX(1:1)=' '
        CALL CLADJ(CXX)
        LCXX=LCXX-1
      GO TO 10
   20 CONTINUE

      IF (LCXX.GT.8) THEN
        CMSG='GIVEN NUMBER IS TRUNCATED WITHIN 8 DIGITS.'
        CALL MSGDMP('W','FFROMC',CMSG)
        INX=INX+(LCXX-8)
        LCXX=8
      END IF

      FFROMC=ISGN*REAL(JFROMC(CXX(1:LCXX)))*10.0**INX
          
      END

*-----------------------------------------------------------------------
*     PROGRAM FOR BITMAP FILE CONVERSION FOR X               (94/05/07)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM BMCX11

      PARAMETER (NBASE=8,NBMAX=32)
      PARAMETER (NCMAX=NBMAX/NBASE,NHMAX=NCMAX*2)
      PARAMETER (NLMAX=NBMAX*NHMAX)
      PARAMETER (IU1=11,IU2=21)

      CHARACTER CPAT(NCMAX)*(NBASE),CPATX*(NBMAX),CLINE*(NLMAX),
     +          CDSNI*64,CDSNO*64,CFMT1*8,CMSG*80

      EQUIVALENCE (CPAT,CPATX)


*     / READ BITMAP FILE NAMES /

*     WRITE(*,*) ' INPUT  BITMAP FILE NAME (C) ? ;'
*     READ(*,*) CDSNI
*     WRITE(*,*) ' OUTPUT BITMAP FILE NAME (C) ? ;'
*     READ(*,*) CDSNO

      READ(*,*) CDSNI,CDSNO

*     / OPEN BITMAP FILES /

      OPEN(IU1,FILE=CDSNI,FORM='FORMATTED',STATUS='OLD')
      REWIND(IU1)
      OPEN(IU2,FILE=CDSNO,FORM='FORMATTED',STATUS='NEW')
      REWIND(IU2)

*     / READ ASCII BITMAP IMAGE & WRITE HEXADECIMAL BITMAP IMAGE /

      READ(IU1,'(I4)') NPAT
      WRITE(IU2,'(I4)') NPAT

      DO 10 I=1,NPAT

        READ(IU1,'(4I4)') IPAT1,IPAT2,IBITS,ILINE

        IF (.NOT.(NBASE.LE.IBITS .AND. IBITS.LE.NBMAX)) THEN
          CMSG='BIT LENGTH IS NOT WITHIN ## - ##.'
          WRITE(CMSG(26:27),'(I2)') NBASE
          WRITE(CMSG(31:32),'(I2)') NBMAX
          WRITE(*,'(A)') ' ERROR -- '//CMSG
        END IF
        IF (MOD(IBITS,NBASE).NE.0) THEN
          CMSG='BIT LENGTH IS NOT MULTIPLE OF ##.'
          WRITE(CMSG(31:32),'(I2)') NBASE
          WRITE(*,'(A)') ' ERROR -- '//CMSG
        END IF

        NBIT=IBITS
        NBYT=NBIT/NBASE
        NHEX=NBYT*2

        WRITE(CFMT1,'(A,I2,A)') '(A',NBIT,')'

        DO 20 J=1,ILINE
          READ(IU1,CFMT1) CPATX(1:NBIT)
          DO 30 K=1,NBYT
            CALL CRVRS(CPAT(K)(1:NBASE))
   30     CONTINUE
          DO 40 N=1,NHEX
            IH1=4*(N-1)+1
            IH2=IH1+(4-1)
            IDX=NHEX*(J-1)+N
            CALL HEXDCC(CPATX(IH1:IH2),CLINE(IDX:IDX))
   40     CONTINUE
   20   CONTINUE

        WRITE(IU2,100) IPAT1,IPAT2,IBITS,ILINE,CLINE(1:NHEX*ILINE)
  100   FORMAT(I4,I4,I3,I3,TR1,A)

   10 CONTINUE

*     / CLOSE BITMAP FILE /

      CLOSE(IU1)
      CLOSE(IU2)

      END
*-----------------------------------------------------------------------
      SUBROUTINE CRVRS(CHR)

      CHARACTER CHR*(*)

      CHARACTER CH1*1


      LC=LEN(CHR)
      DO 10 I=1,LC/2
        CH1=CHR(LC-I+1:LC-I+1)
        CHR(LC-I+1:LC-I+1)=CHR(I:I)
        CHR(I:I)=CH1
   10 CONTINUE

      END
*-----------------------------------------------------------------------
      SUBROUTINE HEXDCC(CP,CH)

      CHARACTER CP*(*),CH*(*)

      CHARACTER CHEX(0:15)*1

      SAVE

      DATA      CHEX/ '0', '1', '2', '3', '4', '5', '6', '7',
     +                '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'/


      NN=0
      DO 10 I=4,1,-1
        IF (CP(I:I).NE.'0') THEN
          NN=NN+2**(4-I)
        END IF
   10 CONTINUE
      CH=CHEX(NN)

      END

program map04

  use dcl
  integer,parameter :: nx=36, ny=36
  real,parameter :: xmin=  0, xmax=360, ymin=-90, ymax=+90
  real,parameter :: pi=3.141592, drad=pi/180, dz=0.05
  integer,parameter :: fact=10
  real,dimension(0:nx,0:ny) :: p,u,v
  real :: alon(0:nx), alat(0:ny)

    rmiss = DclGetReal( 'GLOBAL:RMISS' )
    call DclSetParm( 'GLOBAL:lmiss', .true. )
     
    alon = xmin + (xmax-xmin) * (/(i, i=0,nx)/) /nx
    alat = ymin + (ymax-ymin) * (/(j, j=0,ny)/) /ny

    do j = 0, ny
      do i = 0, nx
        slat = sin(alat(j)*drad)
        p(i,j) = cos(alon(i)*drad) * (1-slat**2) * sin(2*pi*slat) + dz
      end do
    end do

    do j = 1, ny-1
      do i = 0, nx
        u(i,j) = ( p(i,j-1) - p(i,j+1) ) * fact
        v(i,j) = ( p(modulo(i,nx)+1,j) - p(modulo(i-1,nx),j) )* fact
      end do
    end do
    u(:,1) = rmiss; u(:,ny) = rmiss
    v(:,1) = rmiss; v(:,ny) = rmiss

    call DclOpenGraphics()
    call DclNewFrame

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort( 0.1, 0.9, 0.1, 0.9 )
    call DclSetSimilarity( 0.4, 0.0, 0.0 )
    call DclSetMapProjectionAngle( 165.0, 60.0, 0.0 )
    call DclSetMapProjectionWindow( -180.0, 180.0, 0.0, 90.0 )
    call DclSetTransNumber( 30 )
    call DclSetTransFunction
    call DclSetParm( 'GRAPH:lclip', .true. )

    call DclDrawMap( 'coast_world' )
    call DclDrawGlobe()

    call DclDrawContour( p )

    do j=0,ny
      do i=0,nx
        if (.not.(u(i,j).eq.rmiss .or. v(i,j).eq.rmiss)) then
          call DclDrawArrow( &
            alon(i),alat(j),alon(i)+u(i,j),alat(j)+v(i,j), 1, 3 )
        end if
      end do
    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
      PROGRAM UMPK02

      PARAMETER (NP=14)

      INTEGER   NTR(NP)
      CHARACTER CTTL*32

      DATA NTR /   10,   11,   12,   13,   14,   15,
     +             20,   21,   22,   23,   30,   31,   32,   33/


      WRITE(*,*) ' WORKSTATION IS (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( -ABS(IWS) )

      CALL SLRAT( 2.0, 3.0 )
      CALL SLDIV( 'Y', 2, 3 )

      CALL UMISET( 'INDEXMJ', 1 )
      CALL UMISET( 'ITYPEMN', 1 )

      DO 10 I=1,NP

        CALL GRFRM

*       CALL GRSMPL( 0.0, 90.0, 0.0 )
        CALL GRSVPT( 0.1, 0.9, 0.1, 0.9 )
        CALL GRSTRN( NTR(I) )
        CALL UMPFIT
        CALL GRSTRF

        CALL SGLSET( 'LCLIP', .TRUE. )
        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( NTR(I), CTTL )
        CALL SGTXZR( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB

        IF ( NTR(I).EQ.23 ) THEN
          CALL GRFRM
          CALL GRFRM
        END IF

   10 CONTINUE

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     LOGICAL PARAMETER CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE GLLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 3)

      LOGICAL   LX(NPARA), LW(NPARA), LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA CPARAS(1) / 'LMISS   ' /, LX( 1) / .FALSE. /
      DATA CPARAS(2) / 'LEPSL   ' /, LX( 2) / .FALSE. /
      DATA CPARAS(3) / 'LLMSG   ' /, LX( 3) / .FALSE. /

*     / LONG NAME /

      DATA CPARAL(1) / 'INTERPRET_MISSING_VALUE' /, LW( 1) / .TRUE. /
      DATA CPARAL(2) / 'INTERPRET_TRUNCATION   ' /, LW( 2) / .TRUE. /
      DATA CPARAL(3) / 'ENABLE_LONG_MESSAGE    ' /, LW( 3) / .TRUE. /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP,CPARAS(N)) .OR. LCHREQ(CP,CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E', 'GLLQID', CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E', 'GLLQCP', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E', 'GLLQCL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('GL', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E', 'GLLQVL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('GL', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IF (LW(IDX)) THEN
          LX(IDX) = LPARA
          RETURN
        ELSE
          CMSG = 'PARAMETER'''//CPARAS(IDX)//''' CANNOT BE SET.'
          CALL MSGDMP('E', 'GLLQVL', CMSG)
        END IF
      ELSE
        CALL MSGDMP('E', 'GLLQVL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY GLLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TEST03

      PARAMETER ( NX=37, NY=37 )
      PARAMETER ( XMIN=  0, XMAX=360, YMIN=-90, YMAX=+90 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05 )
      PARAMETER ( FACT=10 )

      REAL      P(NX,NY), U(NX,NY), V(NX,NY), ALON(NX), ALAT(NY)

      EXTERNAL  IMOD


      CALL GLRGET( 'RMISS', RMISS )
      CALL GLLSET( 'LMISS', .TRUE. )
     
      DO 10 I = 1, NX
        ALON(I) = XMIN + (XMAX-XMIN) * (I-1) / (NX-1)
   10 CONTINUE

      DO 20 J = 1, NY
        ALAT(J) = YMIN + (YMAX-YMIN) * (J-1) / (NY-1)
   20 CONTINUE

      DO 40 J = 1, NY
        DO 30 I = 1, NX
          SLAT = SIN(ALAT(J)*DRAD)
          P(I,J) = COS(ALON(I)*DRAD) * (1-SLAT**2) * SIN(2*PI*SLAT) 
     +             + DZ
   30   CONTINUE
   40 CONTINUE

      DO 60 J = 1, NY
        DO 50 I = 1, NX
          IF (J.EQ.1 .OR. J.EQ.NY) THEN
            U(I,J) = RMISS
            V(I,J) = RMISS
          ELSE
            U(I,J) = ( P(I,J-1) - P(I,J+1) ) * FACT
            V(I,J) = ( P(IMOD(I,NX-1)+1,J) - P(IMOD(I-2,NX-1)+1,J) )
     +             * FACT
          END IF
   50   CONTINUE
   60 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.1,  0.9,  0.1,  0.9 )
      CALL GRSSIM( 0.4, 0.0, 0.0 )
      CALL GRSMPL( 165.0, 60.0, 0.0 )
      CALL GRSTXY( -180.0, 180.0, 0.0, 90.0 )
      CALL GRSTRN( 30 )
      CALL GRSTRF
      CALL SGLSET( 'LCLIP', .TRUE. )

      CALL UMLSET( 'LGRIDMJ', .FALSE. )
      CALL UMRSET( 'DGRIDMN', 30.0 )
      CALL UMPMAP( 'coast_world' )
      CALL UMPGLB

      CALL UDCNTR( P, NX, NX, NY )

      DO 80 J=1,NY
        DO 70 I=1,NX
          IF (.NOT.(U(I,J).EQ.RMISS .OR. V(I,J).EQ.RMISS)) THEN
            CALL SGLAZU(ALON(I),ALAT(J),ALON(I)+U(I,J),ALAT(J)+V(I,J),
     +           1, 3 )
          END IF
   70   CONTINUE
   80 CONTINUE

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGTNZU(N,UPX,UPY,ITPAT)

      REAL      UPX(*),UPY(*)

      IF (N.LT.3) THEN
        CALL MSGDMP('E','SGTNZU','NUMBER OF POINTS IS LESS THAN 3.')
      END IF
      IF (ITPAT.EQ.0) THEN
        CALL MSGDMP('M','SGTNZU','TONE PAT. INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (ITPAT.LT.0) THEN
        CALL MSGDMP('E','SGTNZU','TONE PAT. INDEX IS LESS THAN 0.')
      END IF

      CALL SZTNOP(ITPAT)
      CALL SZTNZU(N,UPX,UPY)
      CALL SZTNCL

      END

!-------------------------------------------------
!interface module of viblib
!-------------------------------------------------
module vib_interface
  interface

    subroutine vifnb(ix,iy,iz,n,jx,jy,jz,ifnb)    !IXとIYにIFNBを作用させてIZに代入する．
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in), dimension(*) :: iy
      integer,   intent(out), dimension(*) :: iz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iy, izにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
      external ifnb                               !引数が2個である整数型関数名
    end subroutine
      
    subroutine viadd(ix,iy,iz,n,jx,jy,jz)         !IXとIYを加えてIZに代入する．
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in), dimension(*) :: iy
      integer,   intent(out), dimension(*) :: iz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iy, izにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine
      
    subroutine visub(ix,iy,iz,n,jx,jy,jz)         !IXからIYを引いてIZに代入する
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in), dimension(*) :: iy
      integer,   intent(out), dimension(*) :: iz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iy, izにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine
      
    subroutine vimlt(ix,iy,iz,n,jx,jy,jz)         !IXとIYを掛けてIZに代入する．
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in), dimension(*) :: iy
      integer,   intent(out), dimension(*) :: iz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iy, izにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine
      
    subroutine vidiv(ix,iy,iz,n,jx,jy,jz)         !IXをIYで割ってIZに代入する
      integer,   intent(in), dimension(*) :: ix   !処理する整数型配列
      integer,   intent(in), dimension(*) :: iy
      integer,   intent(out), dimension(*) :: iz
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列ix, iy, izにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      integer,   intent(in) :: jz
    end subroutine

  end interface
end module
!viblib library end ----

*-----------------------------------------------------------------------
*     SET MAPPING PARAMETERS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMPFIT

      LOGICAL   LGLOBE

      EXTERNAL  STFTRF, STFTRN, SGQWND, UMQTXY


      CALL GLRGET('RUNDEF', RUNDEF)

      CALL UMSCOM
      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGQSIM(RADIUS, VXOFF, VYOFF)

*----------------------- SET EARTH'S POSITION---------------------------

      CALL UMSPCT
      CALL UMSPCW
      CALL UMSPWD
      CALL UMSPPT
      CALL UMSPDF

      CALL SGRGET('RSAT',RSAT)
      IF (RSAT .EQ. RUNDEF) RSAT = 0.
      CALL SGRSET('RSAT',RSAT)

*--------------------- SET TENTATIVE VIEW PORT--------------------------

      CALL UMSTVZ
      CALL SGSSIM(1., 0., 0.)
      CALL SGSTRF

*--------------------------- RESCALING ---------------------------------

      CALL UMLGET('LGLOBE', LGLOBE)
      CALL SGQVPT(VXMINZ, VXMAXZ, VYMINZ, VYMAXZ)
      CALL UMQTXY(TXMINZ, TXMAXZ, TYMINZ, TYMAXZ)

      XMIN = RUNDEF

      IF (.NOT.LGLOBE) THEN
        CALL UMBNDC(XMIN,  XMAX,  YMIN,  YMAX  )
        CALL UMBNDR(STFTRF, SGQWND,
     +              XMIN,  XMAX,  YMIN,  YMAX  )
        CALL UMBNDP(XMIN,  XMAX,  YMIN,  YMAX  )
      END IF
      IF (XMIN .EQ. RUNDEF) THEN
        CALL UMBNDR(STFTRN, UMQTXY,
     +               XMIN,   XMAX,   YMIN,   YMAX  )
      END IF

*-----------------------------------------------------------------------

      IF (RADIUS.EQ.RUNDEF) 
     +     RADIUS = MIN((VXMAXZ-VXMINZ)/(XMAX-XMIN),
     +                  (VYMAXZ-VYMINZ)/(YMAX-YMIN))

      IF (VXOFF.EQ.RUNDEF)
     +     VXOFF = ((VXMAXZ + VXMINZ) - (XMAX  + XMIN )) /2. * RADIUS
      IF (VYOFF.EQ.RUNDEF)
     +     VYOFF = ((VYMAXZ + VYMINZ) - (YMAX  + YMIN )) /2. * RADIUS
      CALL SGSSIM(RADIUS, VXOFF, VYOFF)

*------------------------- RESET VIEW PORT -----------------------------

      WX = (XMAX-XMIN)*RADIUS
      WY = (YMAX-YMIN)*RADIUS

      IF (VXMIN .EQ. RUNDEF .AND. VXMAX .EQ. RUNDEF) THEN
        VXMIN = (VXMINZ+VXMAXZ-WX)/2.
        VXMAX = (VXMINZ+VXMAXZ+WX)/2.
      ELSE IF (VXMIN .EQ. RUNDEF) THEN
        VXMIN = VXMAX - WX
      ELSE IF (VXMAX .EQ. RUNDEF) THEN
        VXMAX = VXMIN + WX
      END IF

      IF (VYMIN .EQ. RUNDEF .AND. VYMAX .EQ. RUNDEF) THEN
        VYMIN = (VYMINZ+VYMAXZ-WY)/2.
        VYMAX = (VYMINZ+VYMAXZ+WY)/2.
      ELSE IF (VYMIN .EQ. RUNDEF) THEN
        VYMIN = VYMAX - WY
      ELSE IF (VYMAX .EQ. RUNDEF) THEN
        VYMAX = VYMIN + WY
      END IF

      CALL SGSVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPMZU(N,UPX,UPY)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG

      COMMON    /SZBPM1/ LMISS,RMISS,NPM
      LOGICAL   LMISS
      COMMON    /SZBPM2/ CMARK
      CHARACTER CMARK*1

      SAVE


      DO 10 I=1,N,NPM
        LFLAG=LMISS .AND. (UPX(I).EQ.RMISS .OR. UPY(I).EQ.RMISS)
        IF (.NOT.LFLAG) THEN
          CALL SZTXZU(UPX(I),UPY(I),CMARK)
        END IF
   10 CONTINUE

      END

!-----------------------------------------------------------------------
program uxyz10
  use dcl

  integer,parameter :: id0=19811201, nd=180

    call DclOpenGraphics()

    call DclSetAxisFactor( 0.7 )
    call DclSetParm( 'AXIS:loffset',.true.)

    call DclNewFrame

    call DclSetWindow( 0.0, real(nd), 0.0, 100.0 )
    call DclSetViewPort( 0.4, 0.9, 0.3, 0.8 )
    call DclSetTransNumber( DCL_UNI_UNI )
    call DclSetTransFunction

    call DclDrawViewPortFrame( 1 )

    call DclDrawXAxisCalendar( 'b', id0, nd )
    call DclShiftXAxis( 'b' )
    call DclDrawXAxis( 'b', 20.0, 10.0 )
    call DclDrawXSubTitle( 'b', 'Day Number', 0.0 )
    call DclDrawXAxisCalendar( 't', id0, nd )

    call DclDrawYAxis( 'l', 10.0, 5.0 )
    call DclDrawYAxis( 'r', 10.0, 5.0 )
    call DclDrawYSubTitle( 'l', 'Celsius Scale', 0.0 )
    call DclShiftYAxis( 'l' )
    call DclSetParm( 'AXIS:yoffset', 273.15 )
    call DclSetParm( 'AXIS:yfact  ', 1.0 )
    call DclDrawYAxis( 'l', 10.0, 5.0 )
    call DclDrawYSubTitle( 'l', 'Kelvin Scale', 0.0 )
    call DclShiftYAxis( 'l' )
    call DclSetParm( 'AXIS:yoffset', 32.0 )
    call DclSetParm( 'AXIS:yfact  ', 1.8 )
    call DclDrawYAxis( 'l', 20.0, 10.0 )
    call DclDrawYSubTitle( 'l', 'Fahrenheit Scale', 0.0 )

    call DclDrawXSubTitle( 't', '( AXIS:lofset=.true. )', 0.0 )
    call DclDrawXSubTitle( 't', 'DclShiftXAxis', 0.0 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     TONE ROUTINE ON TC
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZOPTT

      PARAMETER (NMAX=8192, NLMAX=100, EPSIL=1.E-5, EP2=1.E-3)

      INTEGER   NBGN(NLMAX), NLEN(NLMAX), NSTAT(NLMAX)
      REAL      TXX(NMAX),   TYY (NMAX),  POS  (NLMAX)
      REAL      XB(2), YB(2), BDX(4), BDY(4)
      LOGICAL   LFIRST, LCONT1, LCONT2, LCONT3, LMOVE, LVLDX, LVLDY,
     +          LREQA

      COMMON    /SZBTN2/ IRMODE, IRMODR

      EXTERNAL  IMOD, XMPLON, LREQA

      SAVE

      POSBD(X,Y) =
     +     (-1)**(NINT(((XB(2)-X)/XWIDTH+(YB(2)-Y)/YWIDTH)/2) + IRMODE)
     +     *((XB(2)-X)/XWIDTH + (Y-YB(1))/YWIDTH) + 2

*     POSBD RAGES FROM 0 TO 4. (AT UPPER LEFT CORNER)
*     ANTI-CLOCK WISE (IMODE=0), CLOCK WISE (IMODE=1)


      PI = RFPI()

      CALL SZQCLX(XB(1), XB(2))
      CALL SZQCLY(YB(1), YB(2))

      XWIDTH = XB(2) - XB(1)
      YWIDTH = YB(2) - YB(1)

      DO 5 I=1, 4
        BDX(I) = XB(MOD((I+3+IRMODE)/2, 2) + 1)
        BDY(I) = YB(MOD((I+2-IRMODE)/2, 2) + 1)
    5 CONTINUE

      NN = 0
      NLINE = 0
      LFIRST = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSTTT(TX, TY)

      TX1 = XMPLON(TX)
      TY1 = TY

      IF (LFIRST) THEN
        LFIRST = .FALSE.
        TX0 = TX1
        TY0 = TY1
        BX0 = TX1
        BY0 = TY1
        CX0 = TX1
        CY0 = TY1
      ELSE
        IF (LREQA(TX1,TX0,EPSIL) .AND. LREQA(TY1,TY0,EPSIL)) RETURN
      END IF

      CALL SZPIPT(TX0, TY0, TX1, TY1, 1)
   10 CONTINUE
        CALL SZGIPT(BX1, BY1, LCONT1)
        CALL SZPCLY(BX0, BY0, BX1, BY1, LVLDY, .FALSE.)
        IF(LVLDY) THEN
   20     CONTINUE
            CALL SZGCLY(CX1, CY1, LCONT2)
            CX1 = XMPLON(CX1)
            CALL SZPCLX(CX0, CY0, CX1, CY1, LVLDX, .FALSE.)
            IF (LVLDX) THEN
   30         CONTINUE
                NN = NN+1
                IF (NN.GT.NMAX) CALL MSGDMP('E', 'SZSTTT',
     +               'WORKING AREA OVER FLOW. (TOO MANY POINTS)')
                CALL SZGCLX(TXX(NN), TYY(NN), LCONT3, LMOVE)
                IF (.NOT. LREQA(ABS(TYY(NN)), PI/2, EPSIL) ) THEN
                  IF (LREQA( TXX(NN), XB(1), EPSIL)) THEN
                    TXX(NN) = XB(1) - EPSIL
                  ELSE IF (LREQA( TXX(NN), XB(2), EPSIL)) THEN
                    TXX(NN) = XB(2) + EPSIL
                  ENDIF
                ENDIF

                IF (LMOVE .OR. LCONT2) THEN
                  NLINE = NLINE +1
                  IF (NLINE.GT.NLMAX) CALL MSGDMP('E', 'SZSTTT',
     +                 'WORKING AREA OVER FLOW. (TOO MANY CROSSINGS)')
                  NBGN(NLINE) = NN
                END IF
              IF (LCONT3) GO TO 30
            END IF
            CX0 = CX1
            CY0 = CY1
          IF(LCONT2) GOTO 20
        ENDIF
        BX0 = BX1
        BY0 = BY1
      IF (LCONT1) GO TO 10
      TX0 = TX1
      TY0 = TY1

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCLTT

      IF (LFIRST) RETURN

      IF (NLINE.EQ.0) THEN

        IF (NN.GE.3) THEN
          CALL SZOPTV
          DO 200 I=1, NN
            CALL STFTRN(TXX(I), TYY(I), VX, VY)
            CALL SZSTTV(VX, VY)
  200     CONTINUE
          CALL SZCLTV
        END IF
        RETURN

      ELSE

*       / PREPEARIG /

        DO 300 I=1, NLINE-1
          NLEN(I) = NBGN(I+1) - NBGN(I)
  300   CONTINUE
        NLEN(NLINE) = NN - NBGN(NLINE) + NBGN(1)

        DO 310 I=1, NLINE
          NSTAT(I) = 0
          IF(NLEN(I).LE.2) NSTAT(I) = 2
          NBG = NBGN(I)
          POS(I) = POSBD(TXX(NBG), TYY(NBG))
  310   CONTINUE

*       / SCANNING STARTING POINT /

  400   CONTINUE

          NX = 0
          DO 410 ILINE=1, NLINE
            IF (NSTAT(ILINE).EQ.0) GO TO 420
  410     CONTINUE
          RETURN

  420     CONTINUE
          NSTAT(ILINE) = 1
          CALL SZOPTV
  430     CONTINUE
          NEND = NBGN(ILINE) + NLEN(ILINE) - 1
          DO 440 J = NBGN(ILINE), NEND
            NX = NX + 1
            JJ = MOD(J-1, NN) + 1
            CALL STFTRN(TXX(JJ), TYY(JJ), VX, VY)
            CALL SZSTTV(VX, VY)
  440     CONTINUE
          NEND = MOD(NEND-1, NN) + 1
          POS0 = POSBD(TXX(NEND), TYY(NEND))

*         / SEARCH NEXT LINE /

          DIF0 = 4.
          DO 450 I=1, NLINE
            IF (NSTAT(I).EQ.2) GO TO 450
            DIF = RMOD(POS(I) - POS0 + EP2, 4.)
            IF (DIF.GE.DIF0) GO TO 450
            IF (NLEN(I).LE.2) GO TO 450
            ILINE = I
            DIF0 = DIF
  450     CONTINUE

*         / BOUNDARY /

          POS1 = POS(ILINE)
          NS0 = POS0 + 1
          NS1 = POS1 + 1
          NLST = NS0 + IMOD(NS1 - NS0, 4)
          IF (NS0.EQ.NS1 .AND. POS0.GT.POS1 + EP2) NLST = NLST +4

          NEXT = NBGN(ILINE)
          DO 600 I=NS0, NLST

            I1 = IMOD(I-1, 4) + 1
            I2 = IMOD(I  , 4) + 1

            IF (I.EQ.NS0) THEN
              X1 = TXX(NEND)
              Y1 = TYY(NEND)
            ELSE
              X1 = BDX(I1)
              Y1 = BDY(I1)
            END IF

            IF (I.EQ.NLST) THEN
              X2 = TXX(NEXT)
              Y2 = TYY(NEXT)
            ELSE
              X2 = BDX(I2)
              Y2 = BDY(I2)
            END IF

            CALL SZPIPL(X1, Y1, X2, Y2, 3)
  520       CONTINUE
              CALL SZGIPL(XX, YY, LCONT1)
              CALL STFTRN(XX, YY, VX, VY)
              CALL SZSTTV(VX, VY)
            IF (LCONT1) GOTO 520

  600     CONTINUE

          IF (NSTAT(ILINE).EQ.0) THEN
            NSTAT(ILINE) = 2
            GO TO 430
          END IF
          NSTAT(ILINE) = 2
          CALL SZCLTV

        GO TO 400

      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     UZPGET / UZPSET / UZPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UZPGET(CP,IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL UZPQID(CP, IDX)
      CALL UZPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPSET(CP, IPARA)

      CALL UZPQID(CP, IDX)
      CALL UZPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UZPSTX(CP, IPARA)

      IP = IPARA
      CALL UZPQID(CP, IDX)
      CALL UZPQIT(IDX, IT)
      CALL UZPQCP(IDX, CX)
      CALL UZPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UZ', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL UZIQID(CP, IDX)
        CALL UZISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UZ', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL UZLQID(CP, IDX)
        CALL UZLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UZ', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL UZRQID(CP, IDX)
        CALL UZRSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
*     TONE ROUTINE ON RC (HARD FILL - CLIPPING)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZOPTR

      PARAMETER (NMAX=16384, NLMAX=100, EPSIL = 1.E-5)

      INTEGER   NBGN(NLMAX), NLEN(NLMAX), NSTAT(NLMAX)
      REAL      RXX (NMAX),  RYY (NMAX),  POS  (NLMAX)
      REAL      XB(2), YB(2), BDX(4), BDY(4)
      LOGICAL   LFIRST, LVALID, LMOVE, LCONT, LREQA

      COMMON    /SZBTN2/ IRMODE, IRMODR

      EXTERNAL  IMOD, LREQA

      SAVE

      POSBD(X,Y) =
     +     (-1)**(NINT(((XB(2)-X)/XWIDTH+(YB(2)-Y)/YWIDTH)/2) + IRMODR)
     +     *((XB(2)-X)/XWIDTH + (Y-YB(1))/YWIDTH) + 2

*     POSBD RAGES FROM 0 TO 4. (AT UPPER LEFT CORNER)
*     ANTI-CLOCK WISE (IMODE=0), CLOCK WISE (IMODE=1)


      CALL SZQCLL(XB(1), XB(2), YB(1), YB(2), 0)
      XWIDTH = XB(2) - XB(1)
      YWIDTH = YB(2) - YB(1)

      DO 5 I=1, 4
        BDX(I) = XB(MOD((I+3+IRMODR)/2, 2) + 1)
        BDY(I) = YB(MOD((I+2-IRMODR)/2, 2) + 1)
    5 CONTINUE

      NN = 0
      NLINE = 0
      LFIRST = .TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZSTTR(RX, RY)

      IF (LFIRST) THEN
        RX0 = RX
        RY0 = RY
        LFIRST = .FALSE.
      ELSE
        IF (LREQA(RX0, RX1, EPSIL) .AND. LREQA(RY0, RY1, EPSIL)) RETURN
      END IF

      CALL SZPCLL(RX0, RY0, RX, RY, LVALID, 0)
      IF (LVALID) THEN
   10   CONTINUE
          NN = NN+1
          IF (NN.GT.NMAX) CALL MSGDMP('E', 'SZSTTR',
     +         'WORKING AREA OVER FLOW (TOO MANY POINTS)')
          CALL SZGCLL(RXX(NN), RYY(NN), LCONT, LMOVE, 0)
          IF (LMOVE) THEN
            NLINE = NLINE +1
            IF (NLINE.GT.NLMAX) CALL MSGDMP('E', 'SZSTTR',
     +           'WORKING AREA OVER FLOW (TOO MANY LINES)')
            NBGN(NLINE) = NN
          END IF
        IF (LCONT) GO TO 10
      END IF

      RX0 = RX
      RY0 = RY

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZCLTR

      IF (LFIRST) RETURN

      IF (NLINE.EQ.0) THEN

        IF (NN.GE.3) THEN
          CALL SZOPTZ
          DO 200 I=1, NN
            CALL SZSTTZ(RXX(I), RYY(I))
  200     CONTINUE
          CALL SZCLTZ
        END IF
        RETURN

      ELSE

*       / PREPEARIG /

        DO 300 I=1, NLINE-1
          NLEN(I) = NBGN(I+1) - NBGN(I)
  300   CONTINUE
        NLEN(NLINE) = NN - NBGN(NLINE) + NBGN(1)

        DO 310 I=1, NLINE
          NSTAT(I) = 0
          IF(NLEN(I).LE.2) NSTAT(I) = 2
          NBG = NBGN(I)
          POS(I) = POSBD(RXX(NBG), RYY(NBG))
  310   CONTINUE

*       / SCANNING STARTING POINT /

  400   CONTINUE

          NX = 0
          DO 410 ILINE=1, NLINE
            IF (NSTAT(ILINE).EQ.0) GO TO 420
  410     CONTINUE
          RETURN

  420     CONTINUE
          NSTAT(ILINE) = 1
          CALL SZOPTZ
  430     CONTINUE
          NEND = NBGN(ILINE) + NLEN(ILINE) - 1

          DO 440 J = NBGN(ILINE), NEND
            NX = NX + 1
            JJ = MOD(J-1, NN) + 1
            CALL SZSTTZ(RXX(JJ), RYY(JJ))
  440     CONTINUE
          NEND = MOD(NEND-1, NN) + 1
          POS0 = POSBD(RXX(NEND), RYY(NEND))

*         / SEARCH NEXT LINE /

          DIF0 = 4
          DO 450 I=1, NLINE
            IF (NSTAT(I).EQ.2) GO TO 450
            DIF = RMOD(POS(I) - POS0+EPSIL, 4.)
            IF (DIF.GE.DIF0) GO TO 450
            IF (NLEN(I).LE.2) GO TO 450
            ILINE = I
            DIF0 = DIF
  450     CONTINUE

*         / BOUNDARY /

          POS1 = POS(ILINE)
          NS0 = POS0 + 1
          NS1 = POS1 + 1
          NST  = NS0 + 1
          NEND = NS0 + IMOD(NS1 - NS0, 4)
          IF (NS0.EQ.NS1 .AND. POS0.GT.POS1+EPSIL) NEND = NEND +4

          DO 600 I=NST, NEND
            II = IMOD(I-1, 4) + 1
            CALL SZSTTZ(BDX(II), BDY(II))
  600     CONTINUE

          IF (NSTAT(ILINE).EQ.0) THEN
            NSTAT(ILINE) = 2
            GO TO 430
          END IF
          NSTAT(ILINE) = 2
          CALL SZCLTZ

        GO TO 400

      END IF

      RETURN
      END

*-----------------------------------------------------------------------
C     SUBROUTINE COSQF(N,X,WSAVE)
C
C     SUBROUTINE COSQF COMPUTES THE FAST FOURIER TRANSFORM OF QUARTER
C     WAVE DATA. THAT IS , COSQF COMPUTES THE COEFFICIENTS IN A COSINE
C     SERIES REPRESENTATION WITH ONLY ODD WAVE NUMBERS. THE TRANSFORM
C     IS DEFINED BELOW AT OUTPUT PARAMETER X
C
C     COSQF IS THE UNNORMALIZED INVERSE OF COSQB SINCE A CALL OF COSQF
C     FOLLOWED BY A CALL OF COSQB WILL MULTIPLY THE INPUT SEQUENCE X
C     BY 4*N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE COSQF MUST BE
C     INITIALIZED BY CALLING SUBROUTINE COSQI(N,WSAVE).
C
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE ARRAY X TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C
C     X       AN ARRAY WHICH CONTAINS THE SEQUENCE TO BE TRANSFORMED
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15
C             IN THE PROGRAM THAT CALLS COSQF. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE COSQI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C
C     OUTPUT PARAMETERS
C
C     X       FOR I=1,...,N
C
C                  X(I) = X(1) PLUS THE SUM FROM K=2 TO K=N OF
C
C                     2*X(K)*COS((2*I-1)*(K-1)*PI/(2*N))
C
C                  A CALL OF COSQF FOLLOWED BY A CALL OF
C                  COSQB WILL MULTIPLY THE SEQUENCE X BY 4*N.
C                  THEREFORE COSQB IS THE UNNORMALIZED INVERSE
C                  OF COSQF.
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT
C             BE DESTROYED BETWEEN CALLS OF COSQF OR COSQB.
C
      SUBROUTINE COSQF (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
      DATA SQRT2 /1.4142135623731/
C
      IF (N-2) 102,101,103
  101 TSQX = SQRT2*X(2)
      X(2) = X(1)-TSQX
      X(1) = X(1)+TSQX
  102 RETURN
  103 CALL COSQF1 (N,X,WSAVE,WSAVE(N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     DRAW CONTINENTAL OUTLINES
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMPOUT


      CALL MSGDMP('M','UMPOUT','THIS IS OLD INTERFACE - USE UMPMAP !')

      CALL UMIGET('IGROUP',IG)

      IF (IG.EQ.1) THEN
        CALL UMPMAP('COAST_WORLD')
      ELSE IF (IG.EQ.2) THEN
        CALL UMPMAP('COAST_WORLD')
        CALL UMPMAP('BORDER_WORLD')
      ELSE
        CALL MSGDMP('M','UMPOUT','INVALID GROUP NUMBER / DO NOTHING.')
        RETURN
      END IF

      END

*-----------------------------------------------------------------------
*     INTEGER PARAMATER CONTROL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 24)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS( 1)/'IRMODE  '/, IX( 1) / 0 /
      DATA      CPARAS( 2)/'MOVE    '/, IX( 2) / 1 /
      DATA      CPARAS( 3)/'NBITS   '/, IX( 3) / 16 /
      DATA      CPARAS( 4)/'ISUP    '/, IX( 4) / 124 /
      DATA      CPARAS( 5)/'ISUB    '/, IX( 5) / 95 /
      DATA      CPARAS( 6)/'IRST    '/, IX( 6) / 34 /
      DATA      CPARAS( 7)/'NPMSKIP '/, IX( 7) / 1 /
      DATA      CPARAS( 8)/'IFONT   '/, IX( 8) / 1 /
      DATA      CPARAS( 9)/'ICLRMAP '/, IX( 9) / 1 /
      DATA      CPARAS(10)/'IROT    '/, IX(10) / 0 /
      DATA      CPARAS(11)/'INDEXC  '/, IX(11) / 0 /
      DATA      CPARAS(12)/'NBUFF   '/, IX(12) / 200 /
      DATA      CPARAS(13)/'IATONE  '/, IX(13) / 999 /
      DATA      CPARAS(14)/'IWS     '/, IX(14) / 0 /
      DATA      CPARAS(15)/'ITR     '/, IX(15) / 1 /
      DATA      CPARAS(16)/'IBGCLI  '/, IX(16) / 999 /
      DATA      CPARAS(17)/'NFRAME  '/, IX(17) / 0 /
      DATA      CPARAS(18)/'NPAGE   '/, IX(18) / 0 /
      DATA      CPARAS(19)/'NLEVEL  '/, IX(19) / 0 /
      DATA      CPARAS(20)/'INDEX   '/, IX(20) / 1 /
      DATA      CPARAS(21)/'ITR3    '/, IX(21) / 1 /
      DATA      CPARAS(22)/'IXC3    '/, IX(22) / 1 /
      DATA      CPARAS(23)/'IYC3    '/, IX(23) / 2 /
      DATA      CPARAS(24)/'IFCIDX  '/, IX(24) / 998 /

*     / LONG  NAME /

      DATA      CPARAL( 1) / 'BOUNDARY_DIRECTION' /
      DATA      CPARAL( 2) / 'LINE_RESUME_MODE' /
      DATA      CPARAL( 3) / 'PATTERN_BIT_LENGTH' /
      DATA      CPARAL( 4) / 'BEGIN_SUPERSCRIPT' /
      DATA      CPARAL( 5) / 'BEGIN_SUBSCRIPT' /
      DATA      CPARAL( 6) / 'END_SCRIPT' /
      DATA      CPARAL( 7) / 'POLIMARKER_INTERVAL' /
      DATA      CPARAL( 8) / 'FONT_NUMBER' /
      DATA      CPARAL( 9) / 'COLORMAP_NUMBER' /
      DATA      CPARAL(10) / 'LINE_LABEL_ROTATION_ANGLE' /
      DATA      CPARAL(11) / 'LABEL_CHAR_INDEX' /
      DATA      CPARAL(12) / 'LINE_BUFFERING_LENGTH' /
      DATA      CPARAL(13) / 'ARROWHEAD_SHADE_PATTERN' /
      DATA      CPARAL(14) / '++++IWS     ' /
      DATA      CPARAL(15) / '++++ITR     ' /
      DATA      CPARAL(16) / 'BACKGROUND_COLOR_INDEX' /
      DATA      CPARAL(17) / '****NFRAME  ' /
      DATA      CPARAL(18) / '****NPAGE   ' /
      DATA      CPARAL(19) / '****NLEVEL  ' /
      DATA      CPARAL(20) / 'CORNERMARK_INDEX' /
      DATA      CPARAL(21) / '++++ITR3    ' /
      DATA      CPARAL(22) / '++++IXC3    ' /
      DATA      CPARAL(23) / '++++IYC3    ' /
      DATA      CPARAL(24) / 'FULLCOLOR_INDEX' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','SGIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','SGIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','SGIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('SG', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','SGIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('SG', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','SGISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UUPK05

      PARAMETER(N=20, M=5)
      REAL  Y1(N), Y2(N), A(M)

      CALL GLRGET('RUNDEF', RUNDEF)

*-----------------------------------------------------------------------

      DT = 1./(N-1)
      PI = 3.14159
      DO 50 J=1, M
        JJ = J*2-1
        A(J) = (-1)**J *2./(JJ*PI)
  50  CONTINUE

      DO 100 I=1, N
        T     = DT*(I-1)*2*PI
        Y1(I) = A(1)*COS(T)
        Y2(I) = 0.
        DO 150 J=1, M
          JJ = J*2-1
          YY = A(J)*COS(JJ*T)
          Y2(I)  = Y2(I) + YY
  150   CONTINUE

  100 CONTINUE

*-----------------------------------------------------------------------

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS
      CALL SGLSET('LCLIP', .TRUE.)

      CALL GROPN(IWS)
      CALL GRFRM

      CALL USSPNT(N, RUNDEF, Y1)
      CALL USSPNT(N, RUNDEF, Y2)
      CALL GRSWND(0., 1., RUNDEF, RUNDEF)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UUSARP(2999, 4999)
      CALL UVBXA(N, RUNDEF, RUNDEF, Y1)
      CALL UVBXF(N, RUNDEF, RUNDEF, Y1)

      CALL GRFRM

      CALL USSPNT(N, Y1, RUNDEF)
      CALL USSPNT(N, Y2, RUNDEF)
      CALL GRSWND(RUNDEF, RUNDEF, 0., 1.)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UHBXA(N, Y1, Y2, RUNDEF)
      CALL UHBXF(N, Y1, Y2, RUNDEF)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE MSZDMP(CMSG,IUNIT,LNSIZE)

      CHARACTER CMSG*(*)

      PARAMETER (MMAX=200)

      CHARACTER CMSGX*(MMAX),CFM*12

      EXTERNAL  LENC


      CMSGX=CMSG
      NMSG=LENC(CMSGX)
      MMSG=(NMSG-1)/LNSIZE+1
      CFM='(TR1,A###)'
      WRITE(CFM(7:9),'(I3)') LNSIZE

      DO 10 M=1,MMSG
        WRITE(IUNIT,CFM) CMSGX(1+LNSIZE*(M-1):MIN(LNSIZE*M,MMAX))
   10 CONTINUE

      END

!-------------------------------------------------
!interface module of chnlib
!-------------------------------------------------
module chn_interface
  interface

    subroutine chngc(ch,ca,cb)                    !指定された文字列を見つけだし， その部分を別の文字列でおきかえる．
      character(len=*), intent(inout) :: ch          !調べる文字列
      character(len=*), intent(in) :: ca          !見つけ出す文字列
      character(len=*), intent(in) :: cb          !おきかえる文字列
    end subroutine
      
    subroutine chngi(ch,ca,ii,cfmt)               !指定された文字列を見つけだし， その部分を書式にしたがって整数でおきかえる．
      character(len=*), intent(inout) :: ch          !調べる文字列
      character(len=*), intent(in) :: ca          !見つけ出す文字列
      integer,   intent(in) :: ii                 !おきかえる整数値
      character(len=*), intent(in) :: cfmt        !文字書式仕様． たとえば，'(i4)', '(e12.4)'と指定する
    end subroutine
      
    subroutine chngr(ch,ca,rr,cfmt)               !指定された文字列を見つけだし， その部分を書式にしたがって実数でおきかえる．
      character(len=*), intent(inout) :: ch          !調べる文字列
      character(len=*), intent(in) :: ca          !見つけ出す文字列
      real,      intent(in) :: rr                 !おきかえる実数値
      character(len=*), intent(in) :: cfmt        !文字書式仕様． たとえば，'(i4)', '(e12.4)'と指定する
    end subroutine

  end interface
end module
!chnlib library end ----

*-----------------------------------------------------------------------
*     BASIC SUBROUTINES
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLDIVZ(XAMIN,XAMAX,YAMIN,YAMAX,CFORM,IX,IY,
     +                  XBMIN,XBMAX,YBMIN,YBMAX)

      REAL      XBMIN(IX*IY),XBMAX(IX*IY),YBMIN(IX*IY),YBMAX(IX*IY)
      CHARACTER CFORM*(*)

      LOGICAL   LCHREQ
      CHARACTER CF1*1

      EXTERNAL  LCHREQ


      CF1=CFORM(1:1)

      WXA=(XAMAX-XAMIN)/IX
      WYA=(YAMAX-YAMIN)/IY

      DO 10 I=1,IX*IY
        IF (LCHREQ(CF1,'T') .OR. LCHREQ(CF1,'L')) THEN
          JX=(I-1)/IY+1
          JY=MOD(I-1,IY)+1
        ELSE
          JX=MOD(I-1,IX)+1
          JY=(I-1)/IX+1
        END IF
        XBMIN(I)=XAMIN+WXA*(JX- 1)
        XBMAX(I)=XAMIN+WXA* JX
        YBMIN(I)=YAMIN+WYA*(IY-JY)
        YBMAX(I)=YAMIN+WYA*(IY-JY+1)
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UULINZ(N,UPX,UPY,ITYPE,INDEX)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG, LMISS, LXUNI, LYUNI
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.2) THEN
        CALL MSGDMP('E','UULINZ','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UULINZ','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UULINZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UULINZ','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      WRITE(COBJ,'(2I8)') ITYPE,INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('UULINZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)
      CALL SZOPLU

      LXUNI = UPX(1).EQ.RUNDEF
      LYUNI = UPY(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF(UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF(UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/(N-1)
      END IF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF(UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF(UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/(N-1)
      END IF


      LFLAG=.FALSE.
      DO 20 I=1,N
        IF (LXUNI) THEN
          UXX = UXMIN + DX*(I-1)
        ELSE
          UXX = UPX(I)
        END IF

        IF (LYUNI) THEN
          UYY = UYMIN + DY*(I-1)
        ELSE
          UYY = UPY(I)
        END IF

        IF ((UXX.EQ.RMISS .OR. UYY.EQ.RMISS) .AND. LMISS) THEN
          LFLAG=.FALSE.
        ELSE IF (LFLAG) THEN
          CALL SZPLLU(UXX,UYY)
        ELSE
          CALL SZMVLU(UXX,UYY)
          LFLAG=.TRUE.
        END IF
   20 CONTINUE

      CALL SZCLLU
      CALL SWOCLS('UULINZ')

      END

*-----------------------------------------------------------------------
*     UMRQNP / UMRQID / UMRQCP / UMRQVL / UMRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 4)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'DGRIDMJ ' /, RX(1) / 30. /
      DATA      CPARAS(2) / 'DGRIDMN ' /, RX(2) / 10. /
      DATA      CPARAS(3) / 'DGRPLMJ ' /, RX(3) / 0. /
      DATA      CPARAS(4) / 'DGRPLMN ' /, RX(4) / 0. /

*     / LONG NAME /

      DATA      CPARAL(1) / 'MAP_MAJOR_LINE_INTERVAL' /
      DATA      CPARAL(2) / 'MAP_MINOR_LINE_INTERVAL' /
      DATA      CPARAL(3) / 'MAP_MAJOR_LINE_POLAR_LIMIT' /
      DATA      CPARAL(4) / 'MAP_MINOR_LINE_POLAR_LIMIT' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UMRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UMRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UMRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UM', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','UMRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UM', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UMRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     BASIC TEXT PRIMITIVE ON VC
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZTXWV(VX,VY,CHARS)

      CHARACTER CHARS*(*)

      PARAMETER (NCHAR=2048,LEN=6000)
      PARAMETER (WUNIT=24,ZUNIT=24)

      INTEGER   IPOSX(NCHAR)
      REAL      WX1(NCHAR),WX2(NCHAR)
      CHARACTER CKX(LEN)*1,CKY(LEN)*1

      COMMON    /SZBTX1/ QSIZE,CT,ST,ICENTZ
      COMMON    /SZBTX2/ LCNTL,JSUP,JSUB,JRST,SMALL,SHIFT
      LOGICAL   LCNTL, LSYSFNT, LFPROP, LMRKFNT, LMARK
      REAL      IROTA, XRATE, YRATE
      INTEGER   INDEX, IFONT
      CHARACTER FONTNAME*70
      INTEGER   ISUPZ,ISUBZ,IRSTZ
      INTEGER   ISUP,ISUB,IRST
      CHARACTER CSGI*1,CSUP*1,CSUB*1,CRST*1
      INTEGER   IMODE, IDEST, IOCMDE
      CHARACTER CHARZ*(NCHAR),CHARX*(NCHAR)
      LOGICAL   LCNTLZ

      EXTERNAL  LENC,ISGC

      SAVE

      DATA      NCNTZ/0/

      LCNTLZ=LCNTL
      CALL SGIGET('ISUP',ISUP)
      CALL SGIGET('ISUB',ISUB)
      CALL SGIGET('IRST',IRST)
      ISUPZ=29
      ISUBZ=30
      IRSTZ=31
      CSUP=CSGI(ISUPZ)
      CSUB=CSGI(ISUBZ)
      CRST=CSGI(IRSTZ)


*      / START: CODE FOR USING SYSTEN FONTS /
*      / PROCCESS IF NOT MARKER /
      CALL SWLGET("LSYSFNT", LSYSFNT)
      IF(LSYSFNT) THEN
      CALL SZQIDX(INDEX)
      CALL SWCGET("FONTNAME",FONTNAME)
*     / WHEN FONTNAME IS NOT GIVEN /
      IF (LENZ(FONTNAME) == 0) THEN
        CALL SGLGET('LFPROP', LFPROP)
        IF (LFPROP) THEN
          CALL SGIGET('IFONT', IFONT)
          IF (IFONT.EQ.1)THEN
            FONTNAME = 'Sans'
          ELSE IF(IFONT.EQ.2)THEN
            FONTNAME = 'Serif'
          ENDIF
        ELSE
          FONTNAME = 'Monospace'
        END IF
        CALL SWFTFC(FONTNAME)
        CALL SWSFW(MAX(MOD(INDEX,10),1))
      ELSE
        CALL SWFTFC(FONTNAME)
      END IF

      IDX=ISGC(CHARS(1:1))
      CALL SGLGET('LMRKFNT',LMRKFNT)

      IF (IDX.GT.18 .OR. LMRKFNT) THEN
        NCZ = LENC(CHARS)
        CALL STFWTR(VX,VY,WX,WY)
        CALL STQWTR(RXMIN,RXMAX,RYMIN,RYMAX,
     +              WXMIN,WXMAX,WYMIN,WYMAX,IWTRF)
        XRATE = (WXMAX-WXMIN)/(RXMAX - RXMIN)
        YRATE = (WYMAX-WYMIN)/(RYMAX - RYMIN)

        IF (INDEX .GT. 9) THEN
          CALL SWSCLI(INDEX/10,.TRUE.)
        END IF
        IF (IDX.LT.18) THEN
          CALL SWSFW(MAX(MOD(INDEX,10),1))
        END IF

        IROTA = ASIN(ST/QSIZE)
        CALL SWTXT(WX,WY,QSIZE*XRATE,CHARS,NCZ,IROTA,ICENTZ)
        GO TO 30
      END IF

      END IF
*      / END: CODE FOR USING SYSTEN FONTS /



*     / GET FONT INFORMATION /


      CALL SZFINT(NCNT)
      IF (NCNTZ.NE.NCNT) THEN
        CALL SZQFNT(IPOSX,CKX,CKY)
        CALL SZQFNW(WX1,WX2)
        NCNTZ=NCNT
      END IF
*     /REMOVE DCL EXT CHARACTER MARKER */
      NCZ=LENC(CHARS)
      J=0
      DO 999 I=1,NCZ
        IDX0=ISGC(CHARS(I:I))
        IF(IDX0.EQ.92)THEN
           IMODE=1
        END IF
        IF(IMODE.EQ.0 .OR. IMODE.EQ.4)THEN
          J=J+1
          CHARX(J:J)=CHARS(I:I)
          IMODE=0
        END IF
        IF(IMODE.EQ.3)THEN
          IF(IDX0.EQ.120)THEN
            IMODE=2
          ELSE
            J=J+1
            CHARX(J:J)=CSGI(92)
            J=J+1
            CHARX(J:J)=CHARS(I:I)
            IMODE=0
          END IF
        END IF
        IF(IMODE.EQ.1 .OR. IMODE.EQ.2)THEN
          IMODE=IMODE+2
        END IF
  999 CONTINUE

      DO 998 I=J+1,2048
        CHARX(I:I)=CHAR(0)
  998 CONTINUE

      CALL SZTXNO(CHARS,CHARZ,LCNTLZ)
      CALL SZQTXW(CHARS,NC,WXCH,WYCH)

*     / CALCULATE OFFSET VALUES /

      OFFX=-0.5*WXCH*WUNIT*(ICENTZ+1)
      OFFY=0.0
      XC=VX+OFFX*CT-OFFY*ST
      YC=VY+OFFX*ST+OFFY*CT

*     / INITIALIZATION /

      MODE0=0
      MODE=0
      FACTZ=1.0
      VX1=0

*     / PROCESS EACH CHARACTER /
      DO 20 K=1,NCZ

*       / CHARACTER CONVERSION /
        IDX=ISGC(CHARZ(K:K))+1

*       / CHECK CONTROL CHARACTERS /
        IPS=IPOSX(IDX)+1
        IF (LCNTLZ .AND.
     +    (IDX.EQ.ISUBZ+1 .OR. IDX.EQ.ISUPZ+1 .OR. IDX.EQ.IRSTZ+1)) THEN
          IF (IDX.EQ.ISUBZ+1) THEN
            MODE=-1
            FACTZ=SMALL
          ELSE IF (IDX.EQ.ISUPZ+1) THEN
            MODE=+1
            FACTZ=SMALL
          ELSE IF (IDX.EQ.IRSTZ+1) THEN
            MODE=0
            FACTZ=1.0
          END IF
          GO TO 20
        END IF

        VX2=-WX1(IDX)
        IF (MODE0.EQ.MODE) THEN
          IF (MODE.EQ.0) THEN
            FNX=VX1+VX2
          ELSE
            FNX=(VX1+VX2)*SMALL
          END IF
          FNY=0
        ELSE
          IF (MODE0*MODE.EQ.0) THEN
            IF (MODE.EQ.0) THEN
              FNX=VX1*SMALL+VX2
            ELSE
              FNX=VX2+VX1*SMALL
            END IF
          ELSE
*           'IS THIS BLOCK REALLY NECESSARY?'
            FNX=(VX1+VX2)*SMALL
          END IF
          FNY=ZUNIT*SHIFT*(MODE-MODE0)
        END IF
        MODE0=MODE

        XC=XC+FNX*CT-FNY*ST
        YC=YC+FNX*ST+FNY*CT

        VX1=WX2(IDX)

        CALL SZOPSV

        IP=0

   10   CONTINUE

          NX=ICHAR(CKX(IPS))-64
          FNX=+NX*FACTZ
          NY=ICHAR(CKY(IPS))-64
          FNY=-NY*FACTZ

          IF (NX.NE.-64) THEN
            XP=XC+FNX*CT-FNY*ST
            YP=YC+FNX*ST+FNY*CT
            IF (IP.EQ.0) THEN
              CALL SZMVSV(XP,YP)
            ELSE IF (IP.EQ.1) THEN
              CALL SZPLSV(XP,YP)
            END IF
            IP=1
          ELSE
            IP=0
          END IF

          IPS=IPS+1

        IF (.NOT.(NX.EQ.-64 .AND. NY.EQ.-64)) GO TO 10

        CALL SZCLSV

   20 CONTINUE

      CALL SWOCLS('SZTXZ')

   30 CONTINUE

      END

*-----------------------------------------------------------------------
*     UEPGET / UEPSET / UEPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL UEPQID(CP, IDX)
      CALL UEPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPSET(CP, IPARA)

      CALL UEPQID(CP, IDX)
      CALL UEPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEPSTX(CP, IPARA)

      IP = IPARA
      CALL UEPQID(CP, IDX)
      CALL UEPQIT(IDX, IT)
      CALL UEPQCP(IDX, CX)
      CALL UEPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('UE', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL UEIQID(CP, IDX)
        CALL UEISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('UE', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL UELQID(CP, IDX)
        CALL UELSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('UE', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL UERQID(CP, IDX)
        CALL UERSVL(IDX, IP)
      END IF

      RETURN
      END

*-----------------------------------------------------------------------
      PROGRAM SGPK01

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN                  ! <-- 使用可能なデバイス名一覧を出力
      READ(*,*) IWS

      CALL SGOPN(IWS)              ! <-- デバイスをオープンする.

      CALL SGFRM                   ! <-- ページを用意する. 

      X1 = 0.1
      X2 = 0.9
      CALL SGLNV(X1, 0.9, X2, 0.9) ! <-- デフォルトのLINE INDEXで直線描画

      CALL SGSLNI(2)               ! <-- LINE INDEX を2に設定
      CALL SGLNV(X1, 0.8, X2, 0.8)

      CALL SGSLNI(3)
      CALL SGLNV(X1, 0.7, X2, 0.7)

      CALL SGSLNI(4)
      CALL SGLNV(X1, 0.6, X2, 0.6)

      CALL SGLNZV(X1, 0.4, X2, 0.4, 1 ) !  <-- LINE INDEX を指定して描画
      CALL SGLNZV(X1, 0.3, X2, 0.3, 2 )
      CALL SGLNZV(X1, 0.2, X2, 0.2, 3 )
      CALL SGLNZV(X1, 0.1, X2, 0.1, 4 )

      CALL SGCLS

      END

*---------------------------------------------------------------
      SUBROUTINE UIXBAR(XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,CPOS)
      CHARACTER CPOS*(*)
      REAL  Z(2,2)
      LOGICAL LCX, LCY,LEM

      CALL GRFIG
      CALL SGSTRN( 1 )
      CALL SGSVPT( XMIN,  XMAX, YMIN,  YMAX )
      CALL SGSWND( ZMIN,  ZMAX,  0.,  1. )
      CALL SGSTRF

      Z(1,1) = ZMIN
      Z(1,2) = ZMIN
      Z(2,1) = ZMAX
      Z(2,2) = ZMAX

      CALL UILGET('CELL_MODE_X', LCX)
      CALL UILGET('CELL_MODE_Y', LCY)
      CALL UILGET('EMBOSS     ', LEM)

      CALL UILSET('CELL_MODE_X', .FALSE.)
      CALL UILSET('CELL_MODE_Y', .FALSE.)
      CALL UILSET('EMBOSS     ', .FALSE.)

      CALL UWSGXB(ZMIN, ZMAX, 2)
      CALL UWSGYB(0.,     1., 2)
      CALL UIPDAT(Z,2,2,2)
      CALL SLPVPR(3)
      CALL USAXSC(CPOS)

      CALL UILSET('CELL_MODE_X', LCX)
      CALL UILSET('CELL_MODE_Y', LCY)
      CALL UILSET('EMBOSS     ', LEM)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM USPAC2

      PARAMETER( NMAX=201, IMAX=5 )
      REAL X(NMAX), Y0(NMAX), Y1(NMAX), Y2(NMAX), A(IMAX)

      PI = 3.14159
      DO 10 I=1,IMAX
        II = 2*I - 1
        A(I) = (-1)**I *2./(II*PI)
   10 CONTINUE

      DO 20 N=1,NMAX
        X(N)  = 1.*(N-1)/(NMAX-1)
        T     = 2.*PI*X(N)
        IF(T.LT.PI/2. .OR. T.GE.PI*3./2.) THEN
          Y0(N) = 0.
        ELSE
          Y0(N) = 1.
        END IF
        Y1(N) = 0.5 + A(1)*COS(T) 
        Y2(N) = 0.5
        DO 30 I=1,IMAX
          II = 2*I - 1
          Y2(N) = Y2(N) + A(I)*COS(II*T)
   30   CONTINUE
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL USSPNT( NMAX, X, Y0 )
      CALL USSPNT( NMAX, X, Y1 )
      CALL USSPNT( NMAX, X, Y2 )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'FREQUENCY', '/DAY', 'RESPONSE', ' ' )
      CALL USDAXS

      CALL UULIN( NMAX, X, Y0 )
      CALL UUSLNT( 2 )
      CALL UUSLNI( 3 )
      CALL UULIN( NMAX, X, Y1 )
      CALL UUSLNT( 3 )
      CALL UULIN( NMAX, X, Y2 )

      CALL GRCLS

      END

      PROGRAM KIHONB

      PARAMETER( NMAX=9 )
      REAL Y(NMAX)
      CHARACTER GREEK1*10, GREEK2*10, SYMBOL*10, USGI*3

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN(IWS)
      CALL SGFRM

      X1 = 0.1
      X2 = 0.9
      XC = 0.5

*-- 鐃緒申鐃緒申 ----
      DO 10 N=1,NMAX
        Y(N) = 0.1*(10-N)
        CALL SGLNV( X1, Y(N), X2, Y(N) )
  10  CONTINUE

      CALL SGLNV( XC, 0.05, XC, 0.95 )

*-- 鐃叔フワ申鐃緒申鐃緒申 ----
      CALL SGTXV( XC, Y(1), 'SGTXV|SUP"RST_SUB"' )

*-- 添鐃緒申 ----
      CALL SGLSET( 'LCNTL', .TRUE. )
      CALL SGTXV( XC, Y(2), 'SGTXV|SUP"RST_SUB"' )

      CALL SGRSET( 'SMALL', 0.5 )
      CALL SGRSET( 'SHIFT', 0.5 )
      CALL SGTXV( XC, Y(3), 'SGTXV|SUP"RST_SUB"' )

*-- 鐃春ワ申鐃緒申鐃緒申 ----
      CALL SGTXV( XC, Y(4), 'ABCDEFG abcdefg' )

      CALL SGISET( 'IFONT', 2 )
      CALL SGTXV( XC, Y(5), 'ABCDEFG abcdefg' )

      CALL SGSTXI( 3 )
      CALL SGTXV( XC, Y(6), 'ABCDEFG abcdefg' )

      CALL SGISET( 'IFONT', 1 )
      CALL SGSTXI( 1 )

*-- 鐃緒申鐃所シ鐃緒申文鐃緒申 ----
      GREEK1 = USGI(128)//USGI(129)//USGI(130)//USGI(131)//USGI(132)//
     +         USGI(133)//USGI(134)//USGI(135)//USGI(136)//USGI(137)
      GREEK2 = USGI(152)//USGI(153)//USGI(154)//USGI(155)//USGI(156)//
     +         USGI(157)//USGI(158)//USGI(159)//USGI(160)//USGI(161)

      CALL SGTXV( XC, Y(7), GREEK1 )
      CALL SGTXV( XC, Y(8), GREEK2 )

*-- 鐃獣殊記鐃緒申 ----
      SYMBOL = USGI(189)//USGI(190)//USGI(191)//USGI(192)//USGI(193)//
     +         USGI(210)//USGI(211)//USGI(212)//USGI(217)//USGI(218)

      CALL SGTXV( XC, Y(9), SYMBOL )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE CHNGI(CH,CA,II,CFMT)

      CHARACTER CH*(*),CA*(*),CFMT*(*)

      CHARACTER CPAT*1024

      EXTERNAL  INDXNF


      NH=LEN(CH)
      NN=LEN(CA)
      CPAT=CA(1:NN)

      IF (.NOT.(NH.GE.NN)) THEN
        CALL MSGDMP('E','CHNGI','TEXT LENGTH IS TOO SHORT.')
      END IF

      ID1=INDXNF(CH,NH-NN+1,1,CA)
      ID2=ID1+NN-1
      IF (ID1.EQ.0) THEN
        CALL MSGDMP('W','CHNGI',
     +       'PATTERN < '//CPAT(1:NN)//' > WAS NOT FOUND.')
      ELSE
        WRITE(CH(ID1:ID2),CFMT,IOSTAT=IOS) II
        IF (IOS.NE.0) THEN
          CALL MSGDMP('W','CHNGI','SUBSTITUTION ERROR.')
        END IF
      END IF

      END

*-----------------------------------------------------------------------
      PROGRAM UXYZ06

      PARAMETER ( ID0=19811201, ND=720 )


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL UZFACT( 0.8 )

      CALL GRFRM

      RND=ND
      CALL SGSWND( -180.0, 180.0, RND, 0.0 )
      CALL SGSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL UXAXDV( 'B', 10.0, 60.0 )
      CALL UXAXDV( 'T', 10.0, 60.0 )
      CALL UXSTTL( 'B', 'LONGITUDE', 0.0 )

      CALL UCYACL( 'L', ID0, ND )
      CALL UZLSET( 'LABELYR', .TRUE. )
      CALL UYAXDV( 'R', 20.0, 100.0 )
      CALL UYSTTL( 'R', 'DAY NUMBER', 0.0 )

      CALL UXMTTL( 'T', 'UXAXDV/UCYACL', 0.0 )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
      PROGRAM SGPK09

      PARAMETER ( KMAX=4, NN=73 )
      PARAMETER ( DD=2.0, PI=3.141592 )

      REAL      XORG(KMAX), YORG(KMAX), UX(NN), UY(NN)

      DATA      XORG / 2.5, 7.5, 2.5, 7.5 /
      DATA      YORG / 7.5, 7.5, 2.5, 2.5 /


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN( IWS )

      CALL SGFRM

      CALL SGSWND( 0.0, 10.0, 0.0, 10.0 )
      CALL SGSVPT( 0.0, 1.0, 0.0, 1.0 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGSTXS( 0.03 )
      CALL SGSTXI( 3 )
      CALL SGSTXC( 0 )

      CALL SGSPLC( 'K=1' )

      DO 20 K = 1, KMAX

        CALL SGSLNI( 1 )
        CALL SGLNU( XORG(K)-DD, YORG(K), XORG(K)+DD, YORG(K) )
        CALL SGLNU( XORG(K), YORG(K)-DD, XORG(K), YORG(K)+DD )

        DO 10 I = 1, NN
          TH = 2*PI*(I-1)/(NN-1)
          UX(I) = XORG(K) + DD*COS(TH+(K-1)*PI/7)
          UY(I) = YORG(K) + DD*SIN(K*TH)
   10   CONTINUE

        CALL SGSPLI( 2 )
        CALL SGSPLT( K )
        CALL SGLSET( 'LCHAR', .TRUE. )
        CALL SGPLU( NN, UX, UY )
        CALL SGLSET( 'LCHAR', .FALSE. )
        CALL SGNPLC

   20 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     UMSTVZ : SET VIEW PORT AND T-WINDOW
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMSTVZ

      LOGICAL   LPRJ

      COMMON    /UMWK1/ITR, RUNDEF, IUNDEF, PI, CPR, CPD, CP


      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CALL SGLGET('L2TO3',LPRJ)

      IF (LPRJ) THEN
        RXMIN = 0.
        RXMAX = 1.
        RYMIN = 0.
        RYMAX = 1.
      ELSE
        CALL STQWTR(RXMIN, RXMAX, RYMIN, RYMAX,
     +              WXMIN, WXMAX, WYMIN, WYMAX, IWTRF)
      END IF

      IF (VXMIN .EQ. RUNDEF) VXMIN = RXMIN
      IF (VXMAX .EQ. RUNDEF) VXMAX = RXMAX
      IF (VYMIN .EQ. RUNDEF) VYMIN = RYMIN
      IF (VYMAX .EQ. RUNDEF) VYMAX = RYMAX

      CALL SGSVPT(VXMIN, VXMAX, VYMIN, VYMAX)

*------------------------------- T-WINDOW ------------------------------

      CALL SGQTXY(TXMIN, TXMAX, TYMIN, TYMAX)

      IF (TXMIN .EQ. RUNDEF) TXMIN = -CPD*180
      IF (TXMAX .EQ. RUNDEF) TXMAX =  CPD*180
      IF (TYMAX .EQ. RUNDEF) TYMAX =  CPD*90
      IF (TYMIN .EQ. RUNDEF) THEN
        IF (ITR.EQ.30) THEN
          CALL SGRGET('RSAT',RSAT)
          IF (RSAT.EQ.0.) THEN
            TYMIN = CPD*0.
          ELSE
            TYMIN = CPR*ASIN(1./RSAT)
          END IF
        ELSE
          TYMIN =  -CPD*90.
        END IF
      END IF

      CALL SGSTXY(TXMIN, TXMAX, TYMIN, TYMAX)

      END

!-------------------------------------------------
!interface module of rfblib
!-------------------------------------------------
module rfb_interface
  interface

    function rprd(rx,ry,n,jx,jy)                  !内積をもとめる．
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      integer,   intent(in) :: jy
      real rprd                                   !内積を与える関数値
    end function
      
    function rcov(rx,ry,n,jx,jy)                  !共分散をもとめる．
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      real rcov                                   !共分散を与える関数値
    end function
      
    function rcor(rx,ry,n,jx,jy)                  !相関係数をもとめる．
      real,      intent(in), dimension(*) :: rx   !処理する実数型配列
      real,      intent(in), dimension(*) :: ry
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !配列rx, ryにおいて，処理する配列要素の間隔
      real rcor                                   !相関係数を与える関数値
    end function

  end interface
end module
!rfblib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGSCWD(CXMIN,CXMAX,CYMIN,CYMAX)


      CALL SGRSET('CXMIN',CXMIN)
      CALL SGRSET('CXMAX',CXMAX)
      CALL SGRSET('CYMIN',CYMIN)
      CALL SGRSET('CYMAX',CYMAX)

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)
      CX  = (VXMAX-VXMIN) / (CXMAX-CXMIN)
      CY  = (VYMAX-VYMIN) / (CYMAX-CYMIN)
      VX0 = VXMIN - CX * CXMIN
      VY0 = VYMIN - CY * CYMIN
      SIMFAC = CX
      VXOFF = VX0 - (VXMAX + VXMIN)/2
      VYOFF = VY0 - (VYMAX + VYMIN)/2
      CALL SGRSET('SIMFAC',SIMFAC)
      CALL SGRSET('VXOFF' ,VXOFF)
      CALL SGRSET('VYOFF' ,VYOFF)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SGQCWD(CXMIN,CXMAX,CYMIN,CYMAX)

      CALL SGRGET('CXMIN',CXMIN)
      CALL SGRGET('CXMAX',CXMAX)
      CALL SGRGET('CYMIN',CYMIN)
      CALL SGRGET('CYMAX',CYMAX)

      RETURN
      END

*-----------------------------------------------------------------------
*     ODPGET / ODPSET / ODPSTX
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ODPGET(CP, IPARA)

      CHARACTER CP*(*)

      CHARACTER CX*8, CL*40


      CALL ODPQID(CP, IDX)
      CALL ODPQVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPSET(CP, IPARA)

      CALL ODPQID(CP, IDX)
      CALL ODPSVL(IDX, IPARA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY ODPSTX(CP, IPARA)

      IP = IPARA
      CALL ODPQID(CP, IDX)
      CALL ODPQIT(IDX, IT)
      CALL ODPQCP(IDX, CX)
      CALL ODPQCL(IDX, CL)
      IF (IT .EQ. 1) THEN
        CALL RTIGET('OD', CX, IP, 1)
        CALL RLIGET(CL, IP, 1)
        CALL ODIQID(CP, IDX)
        CALL ODISVL(IDX, IP)
      ELSE IF (IT .EQ. 2) THEN
        CALL RTLGET('OD', CX, IP, 1)
        CALL RLLGET(CL, IP, 1)
        CALL ODLQID(CP, IDX)
        CALL ODLSVL(IDX, IP)
      ELSE IF (IT .EQ. 3) THEN
        CALL RTRGET('OD', CX, IP, 1)
        CALL RLRGET(CL, IP, 1)
        CALL ODRQID(CP, IDX)
        CALL ODRSVL(IDX, IP)
      ENDIF

      RETURN
      END

!-------------------------------------------------
!interface module of chglib
!-------------------------------------------------
module chg_interface
  interface

    subroutine cupper(ch)                         !文字列を大文字化化する．
      character(len=*), intent(inout) :: ch       !処理する文字列
    end subroutine
      
    subroutine clower(ch)                         !文字列を小文字化する．
      character(len=*), intent(inout) :: ch       !処理する文字列
    end subroutine

  end interface
end module
!chglib library end ----

      PROGRAM LAY2

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )

      CALL SLMGN( 0.1, 0.1, 0.1, 0.1 )
      CALL SLSTTL( 'FIGURE TITLE', 'T',  0.,  0., 0.03, 1 )
      CALL SLSTTL( 'PROGRAM.NAME', 'B', -1.,  1., 0.02, 2 )
      CALL SLSTTL( '#DATE #TIME',  'B',  0.,  0., 0.02, 3 )
      CALL SLSTTL( 'page:#PAGE',   'B',  1., -1., 0.02, 4 )

      CALL SGFRM
      CALL SLPVPR( 1 )
      CALL SGTXV( 0.5, 0.5, 'FIGURE' )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
C     SUBROUTINE RFFTB(N,R,WSAVE)
C
C     SUBROUTINE RFFTB COMPUTES THE REAL PERODIC SEQUENCE FROM ITS
C     FOURIER COEFFICIENTS (FOURIER SYNTHESIS). THE TRANSFORM IS DEFINED
C     BELOW AT OUTPUT PARAMETER R.
C
C     INPUT PARAMETERS
C
C     N       THE LENGTH OF THE ARRAY R TO BE TRANSFORMED.  THE METHOD
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.
C             N MAY CHANGE SO LONG AS DIFFERENT WORK ARRAYS ARE PROVIDED
C
C     R       A REAL ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C             TO BE TRANSFORMED
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.
C             IN THE PROGRAM THAT CALLS RFFTB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE RFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY RFFTF AND RFFTB.
C
C
C     OUTPUT PARAMETERS
C
C     R       FOR N EVEN AND FOR I = 1,...,N
C
C                  R(I) = R(1)+(-1)**(I-1)*R(N)
C
C                       PLUS THE SUM FROM K=2 TO K=N/2 OF
C
C                        2.*R(2*K-2)*COS((K-1)*(I-1)*2*PI/N)
C
C                       -2.*R(2*K-1)*SIN((K-1)*(I-1)*2*PI/N)
C
C             FOR N ODD AND FOR I = 1,...,N
C
C                  R(I) = R(1) PLUS THE SUM FROM K=2 TO K=(N+1)/2 OF
C
C                       2.*R(2*K-2)*COS((K-1)*(I-1)*2*PI/N)
C
C                      -2.*R(2*K-1)*SIN((K-1)*(I-1)*2*PI/N)
C
C      *****  NOTE
C                  THIS TRANSFORM IS UNNORMALIZED SINCE A CALL OF RFFTF
C                  FOLLOWED BY A CALL OF RFFTB WILL MULTIPLY THE INPUT
C                  SEQUENCE BY N.
C
C     WSAVE   CONTAINS RESULTS WHICH MUST NOT BE DESTROYED BETWEEN
C             CALLS OF RFFTB OR RFFTF.
C
C
      SUBROUTINE RFFTB (N,R,WSAVE)
      DIMENSION       R(*)       ,WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      CALL RFFTB1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     BASIC PLOT SUBROUTINES
*-----------------------------------------------------------------------
*     SLPVPR : PLOT VIEWPORT RECTANGLE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLPVPR(INDEX)


      IF (INDEX.LE.0) THEN
        IF (INDEX.EQ.0) THEN
          CALL MSGDMP('M','SLPVPR','LINE INDEX IS ZERO / DO NOTHING.')
          RETURN
        ELSE
          CALL MSGDMP('E','SLPVPR','LINE INDEX IS LESS THAN ZERO.')
        END IF
      END IF

      CALL SGQVPT(VXMIN,VXMAX,VYMIN,VYMAX)

      CALL SZSLTI(1,INDEX)

      CALL SZOPLV
      CALL SZMVLV(VXMIN,VYMIN)
      CALL SZPLLV(VXMAX,VYMIN)
      CALL SZPLLV(VXMAX,VYMAX)
      CALL SZPLLV(VXMIN,VYMAX)
      CALL SZPLLV(VXMIN,VYMIN)
      CALL SZCLLV

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM TEST09

      PARAMETER ( NP=14 )
      PARAMETER ( NX=73, NY=37 )
      PARAMETER ( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )

      REAL      FCT(NP), P(NX,NY)
      CHARACTER CTTL*32, CTR(NP)*3

      EXTERNAL  ISGTRC

      DATA CTR /'CYL','MER','MWD','HMR','EK6','KTD',
     +          'CON','COA','COC','BON',
     +          'OTG','PST','AZM','AZA'/
      DATA FCT / 0.12, 0.12, 0.14, 0.14, 0.14, 0.14,
     +           0.11, 0.16, 0.12, 0.12,
     +           0.40, 0.12, 0.12, 0.17/


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      OPEN(11,FILE='t811231.dat',FORM='FORMATTED')
      DO 10 J=1,NY
        READ(11,'(10F8.3)') (P(I,J),I=1,NX)
   10 CONTINUE
      CLOSE(11)

      DO 20 IR=190,245,5
        R=IR
        AMIN=R
        AMAX=R+5
*       IDX=(R-180)*1.4*1000+999
        IDX=INT((R-170)*1.25)*1000+999
        CALL UESTLV(AMIN,AMAX,IDX)
   20 CONTINUE 

      CALL SGLSET( 'LSOFTF', .FALSE. )
      CALL SWLSET( 'LCMCH', .TRUE. )
      CALL SGRSET( 'STLAT1', 75.0 )
      CALL SGRSET( 'STLAT2', 60.0 )
      CALL UMLSET( 'LGRIDMJ', .FALSE. )
      CALL UMRSET( 'DGRIDMN', 30.0 )

      CALL SGQCMN(NN)

      CALL SGSCMN(1)

      CALL SGOPN( IWS )

      DO 30 I=1,NP

        ICN=MOD(I-1,NN)+1
        CALL SGSCMN(I)

        CALL SGFRM

        CALL SGSSIM( FCT(I), 0.0, 0.0 )
        CALL SGSMPL( 165.0, 60.0, 0.0 )
        CALL SGSVPT( 0.1, 0.9, 0.1, 0.9 )
        CALL SGSWND(XMIN, XMAX, YMIN, YMAX)
        IF (CTR(I).EQ.'OTG') THEN
          CALL SGSTXY( -180.0, 180.0,   0.0, 90.0 )
        ELSE
          CALL SGSTXY( -180.0, 180.0, -90.0, 90.0 )
        END IF
        CALL SGSTRN( ISGTRC(CTR(I)) )
        CALL SGSTRF

        CALL SGLSET( 'LCLIP', .TRUE. )
        CALL SLPWWR( 1 )
        CALL SLPVPR( 1 )
        CALL SGTRNL( ISGTRC(CTR(I)), CTTL )
        CALL SGTXZR( 0.5, 0.95, CTTL, 0.03, 0, 0, 3 )

        CALL UETONE( P, NX, NX, NY )
        CALL UDCNTR( P, NX, NX, NY )
        CALL UMFMAP( 'coast_world' )
        CALL UMPMAP( 'coast_world' )
        CALL UMPGLB
        CALL SLPVPR( 1 )


   30 CONTINUE
      CALL SWPCLS

      CALL SGCLS	

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGLAXR(RX1,RY1,RX2,RY2,ITYPE,INDEX,ICOLOR)
      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGLAXR','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGLAXR','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLAXR','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLAXR','LINE INDEX IS INVALID.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZLAOP(ITYPE,INDEX)
      CALL SZLAZR(RX1,RY1,RX2,RY2)
      CALL SZLACL

      CALL SWSFCM(.FALSE.)

      END

!-----------------------------------------------------------------------
program ulpk01
  use dcl

  integer,parameter :: nbl=2
  real,dimension(nbl) :: bl
  character(len=64) :: ctl

    bl = (/ 1.0,3.0 /)

    call DclOpenGraphics( -DclSelectDevice() )

    call DclSetParm( 'GRAPH:lfull',.true.)
    call DclSetAxisFactor(0.7)
    call DclSetAspectRatio(0.75,1.0)
    call DclDivideFrame('t',1,7)

    do i=1,7

      call DclNewFrame
      call DclSetWindow(0.15,200.,0.1,1e5)
      call DclSetViewPort(0.1,0.9,0.1,0.11)
      call DclSetTransNumber( DCL_LOG_LOG )
      call DclSetTransFunction

      select case(i)
      case(1)
        call DclSetParm( 'LOG:ixtype',1)
        call DclDrawAxisLog('b',1,9)
        ctl='ixtype=1,nlbl=1,ntck=9'
      case(2)
        call DclSetParm( 'LOG:ixtype',1)
        call DclDrawAxisLog('b',3,9)
        ctl='ixtype=1,nlbl=3,ntck=9'
      case(3)
        call DclSetParm( 'LOG:ixtype',2)
        call DclDrawAxisLog('b',3,9)
        ctl='ixtype=2,nlbl=3,ntck=9'
      case(4)
        call DclSetParm( 'LOG:ixtype',3)
        call DclDrawAxisLog('b',3,9)
        ctl='ixtype=3,nlbl=3,ntck=9'
      case(5)
        call DclSetParm( 'LOG:ixtype',4)
        call DclDrawAxisLog('b',3,9)
        ctl='ixtype=4,nlbl=3,ntck=9'
      case(6)
        call DclSetParm( 'LOG:ixtype',3)
        call DclDrawAxisLog('b',3,9,cformat='(f5.1)')
        ctl='ixtype=3,nlbl=3,ntck=9'
      case(7)
        call DclSetParm( 'LOG:ixtype',1)
        call DclSetParm( 'LOG:ixchr',194)
        CALL ULSXBL(BL,NBL)
!        call DclSetXLogLabel( bl )
        call DclDrawAxisLog('b',4,5)
        ctl='ixtype=1,nlbl=4,ntck=5'
      end select

      call DclDrawTitle('b',ctl,0.0,1)
    end do

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     UMLQNP / UMLQID / UMLQCP / UMLQVL / UMLSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMLQNP(NCP)

      LOGICAL   LPARA
      CHARACTER CP*(*)

      PARAMETER (NPARA = 5)

      LOGICAL   LX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'LGRIDMJ ' /, LX(1) / .TRUE. /
      DATA      CPARAS(2) / 'LGRIDMN ' /, LX(2) / .TRUE. /
      DATA      CPARAS(3) / 'LGLOBE  ' /, LX(3) / .FALSE. /
      DATA      CPARAS(4) / 'LWHINT  ' /, LX(4) / .TRUE. /
      DATA      CPARAS(5) / 'LFILLAKE' /, LX(5) / .FALSE. /

*     / LONG NAME /

      DATA      CPARAL(1) / 'ENABLE_MAP_MAJOR_LINE' /
      DATA      CPARAL(2) / 'ENABLE_MAP_MINOR_LINE' /
      DATA      CPARAL(3) / 'ENABLE_GLOBAL_MAPPING' /
      DATA      CPARAL(4) / '----LWHINT  ' /
      DATA      CPARAL(5) / 'ENABLE_PAINT_LAKE' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMLQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UMLQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMLQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UMLQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMLQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UMLQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMLQVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UM', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LPARA = LX(IDX)
      ELSE
        CALL MSGDMP('E','UMLQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMLSVL(IDX, LPARA)

      IF (LFIRST) THEN
        CALL RTLGET('UM', CPARAS, LX, NPARA)
        CALL RLLGET(CPARAL, LX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        LX(IDX) = LPARA
      ELSE
        CALL MSGDMP('E','UMLSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UMLQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     UCYAMN : PLOT MONTH AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCYAMN(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      PARAMETER (N=50)

      REAL      UY(N)
      CHARACTER CH(N)*9,CMON*9
      LOGICAL   LABEL,LUYCHK,LBTWN


      IF (.NOT.LUYCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCYAMN','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCYAMN','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCYAMN','DATE LENGTH IS LESS THAN 0.')
      END IF

      NC=NUCCHR('Y',ND)
      MC=ABS(NC)
      IF (MC.EQ.0) THEN
        CALL MSGDMP('W','UCYAMN','NO MONTH-AXIS.')
        RETURN
      END IF

      CALL UYPAXS(CSIDE,2)

      NN=1
      UY(NN)=0
      CALL DATE13(JD0,IY0,MO0,ID0)

      DO 10 I=1,ND
        CALL DATEF3(I,IY0,MO0,ID0,IYI,MOI,IDI)
        CALL DATE32(IYI,MOI,IDI,ITDI)
        IML=NDMON(IYI,MOI)
        IF (IDI.EQ.IML .OR. I.EQ.ND) THEN
          NN=NN+1
          IF (NN.GT.N) THEN
            CALL MSGDMP('E','UCYAMN','WORKING AREA IS NOT ENOUGH.')
          END IF
          UY(NN)=I
          CH(NN-1)=' '
          CH(NN-1)(1:MC)=CMON(MOI)
          IF (NC.LT.0 .AND. MC.GE.2) THEN
            CALL CLOWER(CH(NN-1)(2:MC))
          END IF
        END IF
   10 CONTINUE

      CALL UZIGET('ICENTY'//CSIDE,ICENT)
      CALL UZIGET('IROTLY'//CSIDE,IROTA)
      CALL UZIGET('IROTCY'//CSIDE,IROTC)
      CALL UZLGET('LBTWN',LBTWN)

      CALL UZISET('ICENTY'//CSIDE,0)
      CALL UZISET('IROTLY'//CSIDE,IROTC)
      CALL UZLSET('LBTWN',.TRUE.)

      CALL UYPTMK(CSIDE,2,UY,NN)
      CALL UZLGET('LABELY'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UYPLBL(CSIDE,2,UY,CH,9,NN)
      END IF

      CALL UZISET('ICENTY'//CSIDE,ICENT)
      CALL UZISET('IROTLY'//CSIDE,IROTA)
      CALL UZLSET('LBTWN',LBTWN)

      END

*-----------------------------------------------------------------------
      PROGRAM USPK08

      PARAMETER(N=200)
      CHARACTER USGI*3
      REAL T(N), Z(N)
      DOUBLE PRECISION R, A

      R = 0.2D0
      A = 4.0D0
      DO 10 I=1, N
        R = A*R*(1.D0-R)
        Z2  = (FLOAT(I-5)/40.)**2
        T(I) = 20.*EXP(-Z2) + R*2.
        Z(I) = I*2
   10 CONTINUE

*-----------------------------------------------------------------------

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM

*          --- OMAJINAI ---
      CALL USLSET('LYINV'   , .TRUE.)
      CALL UZLSET('LABELXT' , .TRUE.)
      CALL USCSET('CYSPOS'  , 'B')

      CALL USCSET('CXSIDE'  , 'T')
      CALL USCSET('CYSIDE'  , 'L')

      CALL USSTTL('TEMPERATURE', 'C|'//USGI(4)//'"', 'DEPTH', 'm')
      CALL USGRPH(N, T, Z)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     NORMALIZATION TRANSFORMATION (INCLUDING MAP PROJECTION)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE STFTRN(UX, UY, VX, VY)

      SAVE

      IF (ITRZ.EQ.1) THEN
        XX = UX
        YY = UY
      ELSE IF (ITRZ.EQ.2) THEN
        CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)
        XX = UX
        UYS = SIGN(1.0,UYMIN)*UY
        IF (UYS.LE.0.0) CALL MSGDMP('E','STFTRN',
     +            'UY HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
        YY = LOG10(UYS)
      ELSE IF (ITRZ.EQ.3) THEN
        CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)
        UXS = SIGN(1.0,UXMIN)*UX
        IF (UXS.LE.0.0) CALL MSGDMP('E','STFTRN',
     +            'UX HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
        XX = LOG10(UXS)
        YY = UY
      ELSE IF (ITRZ.EQ.4) THEN
        CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)
        UXS = SIGN(1.0,UXMIN)*UX
        UYS = SIGN(1.0,UYMIN)*UY
        IF (UXS.LE.0.0) CALL MSGDMP('E','STFTRN',
     +            'UX HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
        IF (UYS.LE.0.0) CALL MSGDMP('E','STFTRN',
     +            'UY HAS INVALID SIGN FOR LOG TRANSFORMATION OR IS 0')
        XX = LOG10(UXS)
        YY = LOG10(UYS)
      ELSE IF (ITRZ.EQ.5) THEN
        CALL CT2PC(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.6) THEN
        CALL CT2BC(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.10) THEN
        CALL MPFCYL(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.11) THEN
        CALL MPFMER(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.12) THEN
        CALL MPFMWD(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.13) THEN
        CALL MPFHMR(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.14) THEN
        CALL MPFEK6(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.15) THEN
        CALL MPFKTD(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.16) THEN
        CALL MPFMIL(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.17) THEN
        CALL MPFRBS(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.18) THEN
        CALL MPFSIN(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.19) THEN
        CALL MPFVDG(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.20) THEN
        CALL MPFCON(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.21) THEN
        CALL MPFCOA(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.22) THEN
        CALL MPFCOC(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.23) THEN
        CALL MPFBON(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.24) THEN
        CALL MPFPLC(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.30) THEN
        CALL MPFOTG(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.31) THEN
        CALL MPFPST(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.32) THEN
        CALL MPFAZM(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.33) THEN
        CALL MPFAZA(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.34) THEN
        CALL MPFGNO(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.40) THEN
        CALL MPFVDG(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.51) THEN
        CALL G2FCTR(UX, UY, XX, YY)
      ELSE IF (ITRZ.EQ.99) THEN
        CALL STFUSR(UX, UY, XX, YY)
      END IF

      IF (XX.EQ.RNA .OR. YY.EQ.RNA) THEN
        VX = RNA
        VY = RNA
      ELSE
        VX = CX*XX + VX0
        VY = CY*YY + VY0
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY STITRN(VX, VY, UX, UY)

      XX = (VX - VX0) / CX
      YY = (VY - VY0) / CY

      IF (ITRZ.EQ.1) THEN
        UX = XX
        UY = YY
      ELSE IF (ITRZ.EQ.2) THEN
        CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)
        UX = XX
        UY = SIGN(1.0,UYMIN)*10**YY
      ELSE IF (ITRZ.EQ.3) THEN
        CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)
        UX = SIGN(1.0,UXMIN)*10**XX
        UY = VY
      ELSE IF (ITRZ.EQ.4) THEN
        CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)
        UX = SIGN(1.0,UXMIN)*10**XX
        UY = SIGN(1.0,UYMIN)*10**YY
      ELSE IF (ITRZ.EQ.5) THEN
        CALL CT2CP(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.6) THEN
        CALL MSGDMP('E', 'STITRN',
     +       'INVERSE TRANSFORMATION IS NOT DEFINED FOR ITR=6.')
      ELSE IF (ITRZ.EQ.10) THEN
        CALL MPICYL(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.11) THEN
        CALL MPIMER(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.12) THEN
        CALL MPIMWD(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.13) THEN
        CALL MPIHMR(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.14) THEN
        CALL MPIEK6(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.15) THEN
        CALL MPIKTD(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.16) THEN
        CALL MPIMIL(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.17) THEN
        CALL MPIRBS(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.18) THEN
        CALL MPISIN(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.19) THEN
        CALL MPIVDG(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.20) THEN
        CALL MPICON(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.21) THEN
        CALL MPICOA(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.22) THEN
        CALL MPICOC(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.23) THEN
        CALL MPIBON(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.24) THEN
        CALL MPIPLC(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.30) THEN
        CALL MPIOTG(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.31) THEN
        CALL MPIPST(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.32) THEN
        CALL MPIAZM(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.33) THEN
        CALL MPIAZA(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.34) THEN
        CALL MPIGNO(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.51) THEN
        CALL G2ICTR(XX, YY, UX, UY)
      ELSE IF (ITRZ.EQ.99) THEN
        CALL STIUSR(XX, YY, UX, UY)
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSTRI(ITR)

      ITRZ = ITR

      CALL GLRGET('RUNDEF',RNA)

      RETURN
*-----------------------------------------------------------------------
      ENTRY STSTRP(CXA, CYA, VXOFF, VYOFF)

      CX  = CXA
      CY  = CYA
      VX0 = VXOFF
      VY0 = VYOFF

      RETURN
      END

!-------------------------------------------------
!interface module of datelib
!-------------------------------------------------
module dat_interface
  interface

    subroutine date12(idate,iy,itd)               !1型の日付を2型の日付に変換する．
      integer,   intent(in) :: idate              !1型の日付
      integer,   intent(out) :: iy                !年
      integer,   intent(out) :: itd               !通しの日付
    end subroutine
      
    subroutine date13(idate,iy,im,id)             !1型の日付を3型の日付に変換する．
      integer,   intent(in) :: idate              !1型の日付
      integer,   intent(out) :: iy                !年
      integer,   intent(out) :: im                !月
      integer,   intent(out) :: id                !日
    end subroutine
      
    subroutine date21(idate,iy,itd)               !2型の日付を1型の日付に変換する．
      integer,   intent(out) :: idate              !1型の日付
      integer,   intent(in) :: iy                !年
      integer,   intent(in) :: itd               !通しの日付
    end subroutine
      
    subroutine date23(iy,im,id,itd)               !2型の日付を3型の日付に変換する．
      integer,   intent(inout) :: iy                 !年
      integer,   intent(out) :: im                !月
      integer,   intent(out) :: id                !日
      integer,   intent(in) :: itd               !通しの日付
    end subroutine
      
    subroutine date31(idate,iy,im,id)             !3型の日付を1型の日付に変換する．
      integer,   intent(out) :: idate              !1型の日付
      integer,   intent(in) :: iy                !年
      integer,   intent(in) :: im                !月
      integer,   intent(in) :: id                !日
    end subroutine
      
    subroutine date32(iy,im,id,itd)               !3型の日付を2型の日付に変換する．
      integer,   intent(inout) :: iy                 !年
      integer,   intent(in) :: im                 !月
      integer,   intent(in) :: id                 !日
      integer,   intent(out) :: itd               !通しの日付
    end subroutine
      
    subroutine datef1(n,idate,ndate)              !idateのn日後(ndate)を求める．
      integer,   intent(in) :: idate              !1型の日付
      integer,   intent(out) :: ndate             !1型の日付
      integer,   intent(in) :: n                  !日付の差（日数）.
    end subroutine
      
    subroutine datef2(n,iy,itd,ny,ntd)            !iy,itdのn日後(ny,ntd)を求める．
      integer,   intent(in) :: n                  !日付の差（日数）.
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: itd                !通しの日付
      integer,   intent(out) :: ny                !年
      integer,   intent(out) :: ntd               !通しの日付
    end subroutine
      
    subroutine datef3(n,iy,im,id,ny,nm,nd)        !iy,im,idのn日後(ny,nm,nd)を求める．
      integer,   intent(in) :: n                  !日付の差（日数）.
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: im                 !月
      integer,   intent(in) :: id                 !日
      integer,   intent(out) :: ny                !年
      integer,   intent(out) :: nm                !月
      integer,   intent(out) :: nd                !日
    end subroutine
      
    subroutine dateg1(n,idate,ndate)              !idateの何(n)日後がndateかを求める．
      integer,   intent(in) :: idate              !1型の日付
      integer,   intent(in) :: ndate              !1型の日付
      integer,   intent(out) :: n                 !日付の差（日数）
    end subroutine
      
    subroutine dateg2(n,iy,itd,ny,ntd)            !iy,itdの何(n)日後がny,ntdかを求める．
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: ny                 !年
      integer,   intent(in) :: itd                !通しの日付
      integer,   intent(in) :: ntd                !通しの日付
      integer,   intent(out) :: n                 !日付の差（日数）
    end subroutine
      
    subroutine dateg3(n,iy,im,id,ny,nm,nd)        !iy,im,idの何(n)日後がny,nm,ndかを求める
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: ny                 !年
      integer,   intent(in) :: im                 !月
      integer,   intent(in) :: nm                 !月
      integer,   intent(in) :: id                 !日
      integer,   intent(in) :: nd                 !日
      integer,   intent(out) :: n                 !日付の差（日数）
    end subroutine
      
    subroutine dateq1(idate)                      !今日の1型の日付を求める．
      integer,   intent(out) :: idate             !1型の日付
    end subroutine
      
    subroutine dateq2(iy,itd)                     !今日の2型の日付を求める．
      integer,   intent(out) :: iy                !年
      integer,   intent(out) :: itd               !通しの日付
    end subroutine
      
    subroutine dateq3(iy,im,id)                   !今日の3型の日付を求める．
      integer,   intent(out) :: iy                !年
      integer,   intent(out) :: im                !月
      integer,   intent(out) :: id                !日
    end subroutine
      
    subroutine datec1(cform,idate)                !idateをcformに従って表現してcformで返す
      integer,   intent(in) :: idate              !1型の日付
      character(len=*), intent(inout) :: cform    !日付のフォーマット
    end subroutine
      
    subroutine datec2(cform,iy,itd)               !iy,itdをcformに従って表現してcformで返す
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: itd                !通しの日付
      character(len=*), intent(inout) :: cform    !日付のフォーマット
    end subroutine
      
    subroutine datec3(cform,iy,im,id)             !iy,im,idをcformに従って表現してcformで返す
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: im                 !月
      integer,   intent(in) :: id                 !日
      character(len=*), intent(inout) :: cform    !日付のフォーマット
    end subroutine
!----------------------------------------------------------------
    function ndate1(idate,ndate)                  !idateの何(n)日後がndateかを求める
      integer,   intent(in) :: idate              !1型の日付
      integer,   intent(in) :: ndate              !1型の日付
      integer ndate1                              !1型の日付の差を与える関数値
    end function
      
    function ndate2(iy,itd,ny,ntd)                !iy,itdの何(n)日後がny,ntdかを求める．
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: ny                 !年
      integer,   intent(in) :: itd                !通しの日付
      integer,   intent(in) :: ntd                !通しの日付
      integer ndate2                              !2型の日付の差を与える関数値
    end function
      
    function ndate3(iy,im,id,ny,nm,nd)            !iy,im,idの何(n)日後がny,nm,ndかを求める
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: ny                 !年
      integer,   intent(in) :: im                 !月
      integer,   intent(in) :: nm                 !月
      integer,   intent(in) :: id                 !日
      integer,   intent(in) :: nd                 !日
      integer ndate3                              !3型の日付の差を与える関数値
    end function
      
    function iweek1(idate)                        !1型の日付idateに対応する曜日番号を返す
      integer,   intent(in) :: idate              !1型の日付
      integer iweek1                              !1型の日付に対応する曜日番号を与える関数値
    end function
      
    function iweek2(iy,itd)                       !2型の日付iy,itdに対応する曜日番号を返す．
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: itd                !通しの日付
      integer iweek2                              !2型の日付に対応する曜日番号を与える関数値
    end function
      
    function iweek3(iy,im,id)                     !3型の日付iy,im, idに対応する曜日番号を返す．
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: im                 !月
      integer,   intent(in) :: id                 !日
      integer iweek3                              !3型の日付に対応する曜日番号を与える関数値
    end function
      
    function ndmon(iy,im)                         !iy年im月は何日あるかを返す．
      integer,   intent(in) :: iy                 !年
      integer,   intent(in) :: im                 !月
      integer ndmon                               !指定した月の日数を与える関数値
    end function
      
    function ndyear(iy)                           !iy年は何日あるかを返す．
      integer,   intent(in) :: iy                 !年
      integer ndyear                              !指定した年の日数を与える関数値
    end function
      
    function cmon(im)                             !文字型の月名を返す文字型関数．
      integer,   intent(in) :: im                 !月
      character(len=9)      :: cmon               !文字型の月名を返す文字型関数値
    end function
      
    function cweek(iw)                            !文字型の曜日を返す文字型関数．
      integer,   intent(in) :: iw                 !曜日番号
      character(len=9)      :: cweek              !文字型の曜日を返す文字型関数値
    end function

  end interface
end module
!datelib library end ----

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      REAL FUNCTION RVMAX1(RX,NS,NP,NQ,ND)

      INTEGER   NS(*),NP(*),NQ(*)
      REAL      RX(*)

      PARAMETER (MD=10)

      INTEGER   NZX(MD),NAD(MD)
      LOGICAL   LMADA


      IF (.NOT.(1.LE.ND .AND. ND.LE.MD)) THEN
        CALL MSGDMP('E','RVMAX1',
     +       'NUMBER OF DIMENSION SHOULD BE 1<= ND <= 10.')
      END IF

      DO 10 N=1,ND
        IF (.NOT.(1.LE.NP(N) .AND. NP(N).LE.NQ(N)
     +       .AND. NQ(N).LE.NS(N))) THEN
          CALL MSGDMP('E','RVMAX1',
     +         'RELATION SHOULD BE 1 <= NP(N) <= NQ(N) <= NS(N).')
        END IF
   10 CONTINUE

      CALL GLRGET('RMISS',RMISS)

      CALL DXFLOC(ND,NS,NP,N1)
      CALL DXFLOC(ND,NS,NQ,N2)

      LMADA=.TRUE.

      NDX=1
      DO 20 NN=1,ND
        NZX(NN)=NP(NN)
        NAD(NN)=(NS(NN)-(NQ(NN)-NP(NN)+1))*NDX
        NDX=NDX*NS(NN)
   20 CONTINUE

      N=N1
   30 CONTINUE

        DO 40 NN=1,ND
          IF (NZX(NN).GT.NQ(NN)) THEN
            NZX(NN)=NP(NN)
            NZX(NN+1)=NZX(NN+1)+1
            N=N+NAD(NN)
          ELSE
            GO TO 50
          END IF
   40   CONTINUE
   50   CONTINUE

        IF (LMADA) THEN
          IF (RX(N).NE.RMISS) THEN
            RVMAX1=RX(N)
            LMADA=.FALSE.
          END IF
        ELSE
          IF (RX(N).NE.RMISS .AND. RX(N).GT.RVMAX1) THEN
            RVMAX1=RX(N)
          END IF
        END IF

        NZX(1)=NZX(1)+1
        N=N+1

      IF (N.LE.N2) GO TO 30

      IF (LMADA) THEN
        RVMAX1=RMISS
      END IF

      END

*-----------------------------------------------------------------------
*     UURQNP / UURQID / UURQCP / UURQVL / UURSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UURQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA  = 3)
      PARAMETER (RUNDEF = -999.)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

* ---- SHORT NAME ----
      DATA      CPARAS(1) / 'UMIN    ' /, RX(1) / RUNDEF /
      DATA      CPARAS(2) / 'UMAX    ' /, RX(2) / RUNDEF /
      DATA      CPARAS(3) / 'UREF    ' /, RX(3) / 0.0 /
* ---- LONG NAME ----
      DATA      CPARAL(1) / '****UMIN    ' /
      DATA      CPARAL(2) / '****UMAX    ' /
      DATA      CPARAL(3) / '****UREF    ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UURQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UURQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UURQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UURQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UURQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UURQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UURQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UU', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','UURQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UURSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UU', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UURSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UURQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

!-------------------------------------------------
!interface module of shtlib
!-------------------------------------------------
module sht_interface
  interface

    subroutine shtint(mm,jm,im,work)              !初期化ルーチン． 
      integer,   intent(in) :: mm                 !入力．切断波数
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2
      integer,   intent(in) :: im                 !入力．東西分割数の1/2
      real,      intent(out), dimension(*) :: work !出力．shtlibの他のルーチンで用いられる作業領域
    end subroutine
      
    subroutine shtnml(mm,n,m,lr,li)               !スペクトルデータの格納位置を求める．
      integer,   intent(in) :: mm                 !入力．切断波数
      integer,   intent(in) :: n                  !入力．全波数
      integer,   intent(in) :: m                  !入力．帯状波数(
      integer,   intent(out) :: lr                !出力．
      integer,   intent(out) :: li                !出力．
    end subroutine
      
    subroutine shtlap(mm,ind,a,b)                 !スペクトルデータに対してラプラシアンを演算する．
      integer,   intent(in) :: mm                 !入力．切断波数(m).
      integer,   intent(in) :: ind                !入力．ラプラシアンの演算形式を指定する
      real,      intent(in), dimension(*) :: a    !入力．
      real,      intent(out), dimension(*) :: b   !出力．
    end subroutine
      
    subroutine shts2w(mm,jm,isw,s,w,work)         !スペクトルデータからウエーブデータへの変換
      integer,   intent(in) :: mm                 !入力．切断 波数(m)
      integer,   intent(in) :: jm                 !入力． 南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力． 変換の種類の指定
      real,      intent(in), dimension(*) :: s    !入力． スペクトルデータ
      real,      intent(out), dimension(*) :: w   !出力．ウエーブデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtw2g(mm,jm,im,w,g,work)          !ウエーブデータからグリッドデータへの変換 
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      real,      intent(in), dimension(*) :: w    !入力．ウエーブデータ
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shts2g(mm,jm,im,isw,s,w,g,work)    !スペクトルデータからグリッドデータへの変換
      integer,   intent(in) :: mm                 !入力．切断波数(m).
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: w   !出力．ウエーブデータ
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtg2w(mm,jm,im,g,w,work)          !グリッドデータからウエーブデータへの変換
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      real,      intent(in), dimension(*) :: g    !入力．変換の種類の指定
      real,      intent(out), dimension(*) :: w   !出力．ウエーブデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtw2s(mm,jm,isw,w,s,work)         !ウエーブデータからスペクトルデータへの変換  
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      real,      intent(in), dimension(*) :: w    !入力．ウエーブデータ
      real,      intent(out), dimension(*) :: s   !出力．スペクトルデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtg2s(mm,jm,im,isw,g,w,s,work)    !グリッドデータからスペクトルデータへの変換
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      real,      intent(in), dimension(*) :: g    !入力．グリッドデータ
      real,      intent(out), dimension(*) :: w   !出力．ウエーブデータ
      real,      intent(out), dimension(*) :: s   !出力．スペクトルデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
!----------------------------------------------------------
!下位ルーチン     
    subroutine shtswa(mm,jm,isw,m1,m2,s,w,work)   !SHTS2Wの下位ルーチン
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      integer,   intent(in) :: m1                 !入力．変換する波数区間の最小値
      integer,   intent(in) :: m2                 !入力．変換する波数区間の最大値
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: w   !出力．ウエーブデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtwga(mm,jm,im,m1,m2,w,g,work)    !SHTW2Gの下位ルーチン   
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: m1                 !入力．変換する波数区間の最小値
      integer,   intent(in) :: m2                 !入力．変換する波数区間の最大値
      real,      intent(in), dimension(*) :: w    !入力．ウエーブデータ
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtsga(mm,jm,im,isw,m1,m2,s,w,g,work) !SHTS2Gの下位ルーチン．
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      integer,   intent(in) :: m1                 !入力．変換する波数区間の最小値
      integer,   intent(in) :: m2                 !入力．変換する波数区間の最大値
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: w   !出力．ウエーブデータ
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtswm(mm,jm,m,isw,s,wr,wi,work)   !SHTS2Wの下位ルーチン 
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: m                  !入力．変換する波数
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: wr  !出力． w^m（φ）の実数部分
      real,      intent(out), dimension(*) :: wi  !出力． w^m（φ）の虚数部分
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtwgm(mm,jm,im,m,wr,wi,g,work)    !SHTW2Gの下位ルーチン 
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: m                  !入力．変換する波数
      real,      intent(in), dimension(*) :: wr   !入力． w^m（φ）の実数部分
      real,      intent(in), dimension(*) :: wi   !入力． w^m（φ）の虚数部分
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtsgm(mm,jm,im,m,isw,s,wr,wi,g,work) !SHTS2Gの下位ルーチ
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: m                  !入力．変換する波数
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: wr  !出力． w^m（φ）の実数部分
      real,      intent(out), dimension(*) :: wi  !出力． w^m（φ）の虚数部分
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtswz(mm,jm,isw,s,wz,work)        !SHTS2Wの下位ルーチン
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: wz  !出力． w^0（φ）が格納される
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtwgz(jm,im,wz,g)                 !SHTW2Gの下位ルーチン
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      real,      intent(in), dimension(*) :: wz   !入力．ウエーブデータ(w^0（φ）)
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
    end subroutine
      
    subroutine shtsgz(mm,jm,im,isw,s,wz,g,work)   !SHTS2Gの下位ルーチン s
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: wz  !出力．ウエーブデータ(w^0（φ）)
      real,      intent(out), dimension(*) :: g   !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtswj(mm,jm,isw,j,m1,m2,s,wj,work) !SHTS2Wの下位ルーチン
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      integer,   intent(in) :: j                  !入力．変換を行う緯度円の指定
      integer,   intent(in) :: m1                 !入力．変換する波数区間の最小値
      integer,   intent(in) :: m2                 !入力．変換する波数区間の最大値
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: wj  !出力． w^m（φ_j) が格納される． 長さ2*mm+1の配列
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtwgj(mm,im,m1,m2,wj,gj,work)     !SHTW2Gの下位ルーチン．
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: m1                 !入力．変換する波数区間の最小値
      integer,   intent(in) :: m2                 !入力．変換する波数区間の最大値
      real,      intent(in), dimension(*) :: wj   !入力． w^m（φ_j)
      real,      intent(out), dimension(*) :: gj  !出力．グリッドデータ．長さ2*im+1の配列
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtsgj(mm,jm,im,isw,j,m1,m2,s,wj,gj,work) !SHTS2Gの下位  
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: im                 !入力．東西分割数の1/2(i)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      integer,   intent(in) :: j                  !入力．変換を行う緯度円の指定
      integer,   intent(in) :: m1                 !入力．変換する波数区間の最小値
      integer,   intent(in) :: m2                 !入力．変換する波数区間の最大値
      real,      intent(in), dimension(*) :: s    !入力．スペクトルデータ
      real,      intent(out), dimension(*) :: wj  !出力． w^m（φ_j)
      real,      intent(out), dimension(*) :: gj  !出力．グリッドデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtfun(mm,jm,m,fun,work)           !ルジャンドル陪関数を計算する．
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: m                  !入力．求めるルジャンドル陪関数の帯状波数(m).
      real,      intent(out), dimension(*) :: fun !p^m_n(φ）が格納される長さ (2*jm+1)*(mm-m+1)の配列
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtlfw(mm,jm,m,isw,wm,sm,work)     !ルジャンドル正変換を行う．
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      integer,   intent(in) :: m                  !入力．変換を行う帯状波数(m).
      real,      intent(in), dimension(*) :: wm   !入力．ウエーブデータ
      real,      intent(out), dimension(*) :: sm  !出力．スペクトルデータ
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine
      
    subroutine shtlbw(mm,jm,m,isw,sm,wm,work)     !ルジャンドル逆変換を行う．
      integer,   intent(in) :: mm                 !入力．切断波数(m)
      integer,   intent(in) :: jm                 !入力．南北分割数の1/2(j)
      integer,   intent(in) :: isw                !入力．変換の種類の指定
      integer,   intent(in) :: m                  !入力．変換を行う帯状波数(m).
      real,      intent(in), dimension(*) :: sm   !入力．スペクトルデータ．長さmm-m+1の配列
      real,      intent(out), dimension(*) :: wm  !出力．ウエーブデータ． 長さ(2*jm+1)の配列
      real,      intent(out), dimension(*) :: work !shtintで初期化された作業領域
    end subroutine

  end interface
end module
!shtlib library end ----

*-----------------------------------------------------------------------
      PROGRAM UXYZ08

      PARAMETER ( X1=-180, X2=+180, DX1=10, DX2=60 )
      PARAMETER ( Y1= -90, Y2= +90, DY1=10, DY2=30 )


      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN( IWS )

      CALL GRFRM

      CALL SGSWND( X1, X2, Y1, Y2 )
      CALL SGSVPT( 0.2, 0.8, 0.3, 0.7 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL UZISET( 'INNER', -1 )
      CALL UZRSET( 'UXUSER', 0.0 )
      CALL UZRSET( 'UYUSER', 0.0 )
      CALL UZLSET( 'LABELXU', .FALSE. )
      CALL UZLSET( 'LABELYU', .FALSE. )

      CALL UXAXDV( 'B', DX1, DX2 )
      CALL UXAXDV( 'T', DX1, DX2 )
      CALL UXSTTL( 'B', 'LONGITUDE', 0.0 )

      CALL UYAXDV( 'L', DY1, DY2 )
      CALL UYAXDV( 'R', DY1, DY2 )
      CALL UYSTTL( 'L', 'LATITUDE', 0.0 )

      CALL UXMTTL( 'T', 'UXAXDV/UYAXDV', 0.0 )

      CALL UZFACT( 0.5 )
      CALL UXAXDV( 'U', DX1, DX2 )
      CALL UXSTTL( 'U', 'EQ', +0.9 )
      CALL UYAXDV( 'U', DY1, DY2 )
      CALL UYSTTL( 'U', 'GM', -0.9 )
      CALL UZISET( 'INNER', +1 )
      CALL UXAXDV( 'U', DX1, DX2 )
      CALL UYAXDV( 'U', DY1, DY2 )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
      SUBROUTINE SGPLXU(N,UPX,UPY,ITYPE,INDEX,ICOLOR)

      REAL      UPX(*),UPY(*)
      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGPLXU','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLXU','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPLXU','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPLXU','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPLXU','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZPLOP(ITYPE,INDEX)
      CALL SZPLZU(N,UPX,UPY)
      CALL SZPLCL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U1D1

      PARAMETER( NMAX=51, XMIN=1945, XMAX=1995 )
      REAL Y(NMAX)

*-- データ ----
      Y0 = 0.5
      DO 10 N=1,NMAX
        Y(N) = 5.*Y0 + 10.
        Y0   = 3.7*Y0*(1.-Y0)
   10 CONTINUE

      CALL GLRGET( 'RUNDEF', RUNDEF )

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, RUNDEF, RUNDEF )
      CALL USSTTL( 'TIME', 'YEAR', 'TEMPERATURE', 'DEG' )
      CALL USGRPH( NMAX, RUNDEF, Y )

      CALL GRCLS

      END

program axis02

  use dcl

    call DclOpenGraphics()

    call DclNewFrame

    call DclSetWindow( -180.0, +180.0, -90.0, +90.0 )
    call DclSetViewPort( 0.2, 0.8, 0.3, 0.7 )
    call DclSetTransFunction

    call DclDrawAxis( 'bt', 60.0, 10.0 )
    call DclDrawTitle( 'b', 'Longitude', 0.0 )
    call DclDrawTitle( 'b', '<- west      east ->', 0.0 )

    call DclDrawAxis( 'lr', 30.0, 10.0 )
    call DclDrawTitle( 'l', 'Latitude', 0.0 )
    call DclDrawTitle( 'l', '<- SH    NH ->', 0.0 )

    call DclDrawTitle( 't', 'Main Title', 0.0, 2 )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
*     UYSAXS : OFFSET FOR NEW AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYSAXS(CSIDE)

      CHARACTER CSIDE*1

      LOGICAL   LUYCHK,LCHREQ


      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYSAXS','SIDE PARAMETER IS INVALID.')
      END IF

      CALL UZRGET('ROFFY'//CSIDE,ROFFY)
      CALL UZRGET('RSIZET2',RSIZET)
      CALL UZRGET('RSIZEC2',RSIZEC)
      CALL UZRGET('PAD2',PAD)
      CALL UZIGET('INNER',INNER)
      JSGN=SIGN(1,INNER)

      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        IF (LCHREQ(CSIDE,'L')) THEN
          IFLAG=-1
        ELSE
          IFLAG=+1
        END IF
      ELSE
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      RTICK=-RSIZET*JSGN*IFLAG

      IF (IFLAG.GE.0) THEN
        ROFFY=MAX(ROFFY-RTICK,ROFFY)+RSIZEC*PAD
      ELSE
        ROFFY=MIN(ROFFY-RTICK,ROFFY)-RSIZEC*PAD
      END IF

      CALL UYSAXZ(CSIDE,ROFFY)

      END

*-----------------------------------------------------------------------
*     COORDINATE ROTATION (3D SPHERICAL)
*                                              93/02/19   S.SAKAI
*                                              93/10/29   S.SAKAI
*                                            2000/04/28   S.SAKAI
*                                            2002/01/17   S.SAKAI
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE CR3S(THETA, PHI, PSI, THETA0, PHI0, THETA1, PHI1)

      LOGICAL   LREQA, LFIRST

      EXTERNAL  RFPI, LREQA

      SAVE

      DATA      LFIRST /.TRUE./


      IF (LFIRST) THEN
        CALL GLRGET('REPSL',REPSL)
        PI = RFPI()
        LFIRST = .FALSE.
      END IF

      IF (LREQA(THETA, 0., REPSL)) THEN
        THETA1 = THETA0
        PHI1   = PHI0 - PHI - PSI
      ELSE
        CTE = COS(THETA)
        STE = SIN(THETA)

        CT0 = COS(THETA0)
        ST0 = SIN(THETA0)

        CP  = COS(PHI0 - PHI)
        SP  = SIN(PHI0 - PHI)

        A = CT0*CTE + ST0*STE*CP

        IF (ABS(A).LE. 0.8) THEN
          THETA1 = ACOS(A)
        ELSE
          C = SQRT((STE*SP)**2 + (CT0*STE*CP-ST0*CTE)**2)
          THETA1 = ASIN(C)
          IF(A.LE.0) THETA1 = PI - THETA1
        END IF

        A =    SP*ST0
        B = - CT0*STE + ST0*CTE*CP

        IF (A.EQ.0. .AND. B.EQ.0.) THEN
          PHI1 = PHI0 - PHI - PSI
        ELSE
          PHI1 = ATAN2(A, B) - PSI
        END IF
      END IF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      REAL FUNCTION RMIN1(RX,N,JX)

      REAL      RX(*)

      LOGICAL   MADA


      CALL GLRGET('RMISS',RMISS)
      MADA=.TRUE.
      DO 10 I=1,JX*(N-1)+1,JX
        IF (MADA) THEN
          IF (RX(I).NE.RMISS) THEN
            RMIN1=RX(I)
            MADA=.FALSE.
          END IF
        ELSE
          IF (RX(I).NE.RMISS .AND. RX(I).LT.RMIN1) THEN
            RMIN1=RX(I)
          END IF
        END IF
   10 CONTINUE
      IF (MADA) THEN
        RMIN1=RMISS
      END IF

      END

*-----------------------------------------------------------------------
*     DRAW LAT-LON GRIDS OF MAP
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMPGRD

      PARAMETER (NP=4)

      REAL      X(NP),Y(NP)
      LOGICAL   LEPSL,LLNINT,LGCINT,LGRDMJ,LGRDMN,LRNE

      EXTERNAL  LRNE,IRGT,IRLT


*     / GET INTERNAL PARAMETERS /

      CALL GLLGET('LEPSL' ,LEPSL)
      CALL SGLGET('LLNINT',LLNINT)
      CALL SGLGET('LGCINT',LGCINT)

      CALL UMSGRD

      CALL UMRGET('DGRIDMJ',DGMJ)
      CALL UMRGET('DGRIDMN',DGMN)
      CALL UMRGET('DGRPLMJ',DPMJ)
      CALL UMRGET('DGRPLMN',DPMN)
      CALL UMLGET('LGRIDMJ',LGRDMJ)
      CALL UMLGET('LGRIDMN',LGRDMN)
      CALL UMIGET('INDEXMJ',IDMJ)
      CALL UMIGET('INDEXMN',IDMN)
      CALL UMIGET('ITYPEMJ',ITMJ)
      CALL UMIGET('ITYPEMN',ITMN)

      IF (.NOT.LGRDMJ .AND. .NOT.LGRDMN) RETURN

*     / SET INTERNAL PARAMETER /

      CALL GLLSET('LEPSL' ,.TRUE.)
      CALL SGLSET('LLNINT',.TRUE.)
      CALL SGLSET('LGCINT',.TRUE.)

*     / MAJOR LINES /

      IF (LGRDMJ) THEN

        RN=360/DGMJ
        NMJ=NINT(RN)
        IF (LRNE(RN,REAL(NMJ))) THEN
          CALL MSGDMP('E','UMPGRD',
     +         'MAJOR DIVISION IS NOT A COMMON MEASURE OF 360.')
        END IF

        CALL SZPLOP(ITMJ,IDMJ)

        DO 20 M=1,NMJ
          DO 10 N=1,NP
            X(N)=-180.0+(M-1)*DGMJ
            Y(N)=(N-1)*(180.0-DPMJ*2)/(NP-1)-(90.0-DPMJ)
   10     CONTINUE
          CALL SZPLZU(NP,X,Y)
   20   CONTINUE

        M1=IRGT(-90/DGMJ)
        M2=IRLT(+90/DGMJ)
        DO 40 M=M1,M2
          DO 30 N=1,NP
            X(N)=(N-1)*360.0/(NP-1)-180.0
            Y(N)=DGMJ*M
   30     CONTINUE
          CALL SZPLZU(NP,X,Y)
   40   CONTINUE

        CALL SZPLCL

      END IF

*     / MINOR LINES /

      IF (LGRDMN) THEN

        RN=360/DGMN
        NMN=NINT(RN)
        IF (LRNE(RN,REAL(NMN))) THEN
          CALL MSGDMP('E','UMPGRD',
     +         'MINOR DIVISION IS NOT A COMMON MEASURE OF 360.')
        END IF
        IF (LGRDMJ) THEN
          IF (MOD(NMN,NMJ).NE.0) THEN
            CALL MSGDMP('E','UMPGRD',
     +           'MAJOR DIVISION IS NOT MULTIPLE OF MINOR DIVISION.')
          END IF
          NDX=NMN/NMJ
        ELSE
          NDX=1
        END IF

        CALL SZPLOP(ITMN,IDMN)

        DO 60 M=1,NMN
          IF (LGRDMJ .AND. MOD(M-1,NDX).EQ.0) GO TO 60
          DO 50 N=1,NP
            X(N)=-180.0+(M-1)*DGMN
            Y(N)=(N-1)*(180.0-DPMN*2)/(NP-1)-(90.0-DPMN)
   50     CONTINUE
          CALL SZPLZU(NP,X,Y)
   60   CONTINUE

        M1=IRGT(-90/DGMN)
        M2=IRLT(+90/DGMN)
        DO 80 M=M1,M2
          IF (LGRDMJ .AND. MOD(M,NDX).EQ.0) GO TO 80
          DO 70 N=1,NP
            X(N)=(N-1)*360.0/(NP-1)-180.0
            Y(N)=DGMN*M
   70     CONTINUE
          CALL SZPLZU(NP,X,Y)
   80   CONTINUE

        CALL SZPLCL

      END IF

*     / RESET INTERNAL PARAMETER /

      CALL GLLSET('LEPSL', LEPSL)
      CALL SGLSET('LLNINT',LLNINT)
      CALL SGLSET('LGCINT',LGCINT)

      END

      PROGRAM KIHON3

      PARAMETER( NMAX=40, IMAX=7 )
      REAL X(0:NMAX), Y(0:NMAX,IMAX)

      DT = 4.* 3.14159 / NMAX
      DO 20 N=0,NMAX
        X(N) = REAL(N)/REAL(NMAX)
        DO 10 I=1,IMAX
          Y(N,I) = 0.2*SIN(N*DT) + 0.9 - 0.1*I
   10   CONTINUE
   20 CONTINUE

      CALL SWCSTX('FNAME','KIHON3')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )

*-- マーカータイプ: frame 1 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGPMV( NMAX+1, X, Y(0,1) )

      DO 30 I=2,IMAX
        ITYPE = I
        CALL SGSPMT( ITYPE )
        CALL SGPMV( NMAX+1, X, Y(0,I) )
   30 CONTINUE

*-- マーカーサイズ: frame 2 --
      CALL SGFRM
      CALL SLPVPR( 1 )

      CALL SGSPMT( 10 )
      CALL SGPMV( NMAX+1, X, Y(0,1) )

      DO 40 I=2,IMAX
        RSIZE = 0.005*(I-1)
        CALL SGSPMS( RSIZE )
        CALL SGPMV( NMAX+1, X, Y(0,I) )
   40 CONTINUE

      CALL SGCLS

      END

      PROGRAM U2D2

      PARAMETER( NT=51, NZ=21 )
      PARAMETER( TMIN=0, TMAX=5, ZMIN=20, ZMAX=50 )
      PARAMETER( DT=(TMAX-TMIN)/(NT-1), DZ=(ZMAX-ZMIN)/(NZ-1) )
      REAL U(NT,NZ)

*-- データ ----
      DO 10 J=1,NZ
        Z  = (J-1)*DZ
        UZ = EXP(-0.2*Z)*(Z**0.5)
        DO 20 I=1,NT
          T = (I-1)*DT - 2.*EXP(-0.1*Z)
          U(I,J) = UZ*SIN(3.*T)
   20   CONTINUE
   10 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL GRFRM

      CALL GRSWND( TMIN, TMAX, ZMIN, ZMAX )
      CALL GRSVPT(  0.2,  0.9,  0.4,  0.8 )
      CALL USPFIT
      CALL GRSTRF

      CALL USSTTL( 'TIME', 'YEAR', 'HEIGHT', 'km' )
      CALL USDAXS

      CALL UDCNTR( U, NT, NT, NZ )
      CALL UETONE( U, NT, NT, NZ )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
C     SUBROUTINE EZFFTI(N,WSAVE)
C
C     SUBROUTINE EZFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH EZFFTF AND EZFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED.
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 3*N+15.
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH EZFFTF AND EZFFTB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N.
C
      SUBROUTINE EZFFTI (N,WSAVE)
      DIMENSION       WSAVE(*)
C
      IF (N .EQ. 1) RETURN
      CALL EZFFT1 (N,WSAVE(2*N+1),WSAVE(3*N+1))
      RETURN
      END

*-----------------------------------------------------------------------
*     UCXACL : PLOT CALENDAR AXIS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCXACL(CSIDE,JD0,ND)

      CHARACTER CSIDE*1

      LOGICAL   LUXCHK


      IF (.NOT.LUXCHK(CSIDE)) THEN
        CALL MSGDMP('E','UCXACL','SIDE PARAMETER IS INVALID.')
      END IF
      IF (JD0.LT.0) THEN
        CALL MSGDMP('E','UCXACL','FIRST DATE IS LESS THAN 0.')
      END IF
      IF (ND.LE.0) THEN
        CALL MSGDMP('E','UCXACL','DATE LENGTH IS LESS THAN 0.')
      END IF

      CALL UXPAXS(CSIDE,2)

      CALL UCXADY(CSIDE,JD0,ND)
      CALL UCXAMN(CSIDE,JD0,ND)
      CALL UCXAYR(CSIDE,JD0,ND)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UUPK07

      PARAMETER (MAX=5)
      REAL  XNEC(MAX), XIBM(MAX), XAPL(MAX)

      DATA XNEC /1.2, 2.5, 3.3, 3.7, 3.1/
      DATA XAPL /1.3, 2.6, 3.8, 4.4, 4.5/
      DATA XIBM /1.7, 2.2, 3.5, 4.2, 5.7/


      CALL GLRGET('RUNDEF', RUNDEF)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM

      CALL GRSWND(0., 5., RUNDEF, RUNDEF)
      CALL USSPNT(MAX, RUNDEF, XIBM)
      CALL USSPNT(MAX, RUNDEF, XNEC)
      CALL USSPNT(MAX, RUNDEF, XAPL)
      CALL USSPNT(1,  RUNDEF, 0.)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UUSIDV(0.3, 4.3)
      CALL UUSARP(2999, 2999)
      CALL UVBRA(MAX, RUNDEF, XNEC, RUNDEF)
      CALL UVBRF(MAX, RUNDEF, XNEC, RUNDEF)

      CALL UUSIDV(0.5, 4.5)
      CALL UUSARP(3999, 3999)
      CALL UVBRA(MAX, RUNDEF, XAPL, RUNDEF)
      CALL UVBRF(MAX, RUNDEF, XAPL, RUNDEF)

      CALL UUSIDV(0.7, 4.7)
      CALL UUSARP(4999, 4999)
      CALL UVBRA(MAX, RUNDEF, XIBM, RUNDEF)
      CALL UVBRF(MAX, RUNDEF, XIBM, RUNDEF)

      CALL GRFRM

      DO 10 I=1, MAX
        XAPL(I) = XNEC(I) + XAPL(I)
        XIBM(I) = XAPL(I) + XIBM(I)
  10  CONTINUE

      CALL GRSWND(0., 5., RUNDEF, RUNDEF)
      CALL USSPNT(MAX, RUNDEF, XIBM)
      CALL USSPNT(1,  RUNDEF, 0.)
      CALL USPFIT
      CALL GRSTRF

      CALL USDAXS

      CALL UUSIDV(0.5, 4.5)

      CALL UUSARP(2999, 2999)
      CALL UUSBRS(0.05)
      CALL UVBRA(MAX, RUNDEF, XNEC, RUNDEF)
      CALL UUSARP(3999, 3999)
      CALL UVBRA(MAX, RUNDEF, XNEC, XAPL)
      CALL UUSARP(4999, 4999)
      CALL UVBRA(MAX, RUNDEF, XAPL, XIBM)

      CALL UVBRF(MAX, RUNDEF, XNEC, RUNDEF)
      CALL UVBRF(MAX, RUNDEF, XNEC, XAPL)
      CALL UVBRF(MAX, RUNDEF, XAPL, XIBM)

      CALL UVBRL(MAX, RUNDEF, XNEC)
      CALL UVBRL(MAX, RUNDEF, XAPL)
      CALL UVBRL(MAX, RUNDEF, XIBM)

      CALL GRCLS

      END

!-------------------------------------------------
!interface module of intrlib
!-------------------------------------------------
module intr_interface
  interface

    subroutine vrintr(rx,n,jx)                    !実数型配列の補間をする
      real,      intent(inout), dimension(*) :: rx !処理する実数型の配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
    end subroutine
      
    subroutine vcintr(cx,n,jx)                    !複素数型配列の補間をする
      complex,   intent(inout), dimension(*) :: cx !処理する複素数型の配列
      integer,   intent(in) :: n                  !処理する配列要素の個数
      integer,   intent(in) :: jx                 !処理する配列要素の間隔
    end subroutine

  end interface
end module
!intrlib library end ----

***********************************************************************
*     BACKWARD LEGENDRE TRANSFORMATION (AT A LATITUDE)
***********************************************************************
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SHLBWJ(MM,JM,M,J,ISW,SM,WMJ,SD,PMJ,YC,R)

      REAL SM(M:MM),WMJ
      REAL SD(0:MM+1),PMJ(0:MM+1)
      REAL YC(0:JM)
      REAL R((MM+1)*(MM+1))
      REAL WS,WA

*     ISW=-1: X-DIFFERENTIAL, ISW=0: NORMAL, ISW=1: Y-DIFFERENTIAL

      CALL SHLSSD(MM,M,ISW,SM,SD,R)

      CALL SHLBWL(MM,M,SD,WS,WA,PMJ)

      JD=ABS(J)

      IF((ISW.EQ.0).AND.(M.NE.0)) THEN
        WS=WS*YC(JD)
        WA=WA*YC(JD)
      ELSE IF((ISW.NE.0).AND.(M.EQ.0)) THEN
        IF(JD.EQ.JM) THEN
          WS=0
          WA=0
        ELSE
          WS=WS/YC(JD)
          WA=WA/YC(JD)
        END IF
      END IF

      IF(J.GE.0) THEN
        WMJ=WS+WA
      ELSE
        WMJ=WS-WA
      END IF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UMBNDR(FUNC, FTR,
     +                  XMIN,  XMAX,  YMIN,  YMAX )

      PARAMETER (NMAX = 360)

      EXTERNAL  FUNC, FTR


      CALL GLRGET('RUNDEF', RUNDEF)

      CALL FTR(UXMIN, UXMAX, UYMIN, UYMAX)

      IF (UXMIN.EQ.RUNDEF .OR. UXMAX.EQ.RUNDEF .OR.
     +    UYMIN.EQ.RUNDEF .OR. UYMAX.EQ.RUNDEF ) RETURN

      DX = (UXMAX - UXMIN) / NMAX
      DY = (UYMAX - UYMIN) / NMAX

      IF (XMIN.EQ.RUNDEF) THEN
        CALL FUNC(UXMIN, UYMIN, XMIN, YMIN)
        XMAX = XMIN
        YMAX = YMIN
      END IF

      DO 10 I=0, NMAX
        X = UXMIN + DX*I
        Y = UYMIN + DY*I

        CALL FUNC(X, UYMIN, X1, Y1)
        CALL FUNC(X, UYMAX, X2, Y2)
        CALL FUNC(UXMIN, Y, X3, Y3)
        CALL FUNC(UXMAX, Y, X4, Y4)

        XMAX = MAX (XMAX, X1, X2, X3, X4)
        XMIN = MIN (XMIN, X1, X2, X3, X4)
        YMAX = MAX (YMAX, Y1, Y2, Y3, Y4)
        YMIN = MIN (YMIN, Y1, Y2, Y3, Y4)

   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPMZV(N,VPX,VPY,ITYPE,INDEX,RSIZE)

      REAL      VPX(*),VPY(*)


      IF (N.LT.1) THEN
        CALL MSGDMP('E','SGPMZV','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPMZV','MARKER TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPMZV','POLYMARKER INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPMZV','POLYMARKER INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','SGPMZV','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','SGPMZV','MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SZPMOP(ITYPE,INDEX,RSIZE)
      CALL SZPMZV(N,VPX,VPY)
      CALL SZPMCL

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE GLQFNM(CPARA,CFNAME)

      CHARACTER CPARA*(*),CFNAME*(*)

      PARAMETER (MAXP=3,MAXF=1)

      CHARACTER CPLIST(MAXP)*1024,CFLIST(MAXF)*1024


      CPLIST(1)=' '
      CALL GLCGET('DUPATH',CPLIST(2))
      CALL GLCGET('DSPATH',CPLIST(3))
      CALL GLCGET(CPARA,CFLIST(1))

      CALL CFSRCH(CPLIST,MAXP,CFLIST,MAXF,CFNAME)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USGRPY(N, Y, XMIN, XMAX)

      REAL      Y(*)


      CALL MSGDMP('W','USGRPY','THIS IS OLD INTERFACE - USE USGRPH !')

      CALL GLRGET('RUNDEF', RUNDEF)
      CALL SGRSET('UXMIN', XMIN)
      CALL SGRSET('UXMAX', XMAX)

      CALL USSPNT(N, RUNDEF, Y)
      CALL USAXIS
      CALL UULIN(N, RUNDEF, Y)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DATE02


      WRITE(*,*) '*** TEST FOR DATE COUNT'
      WRITE(*,*) '*** TYPE-1'
      IDATE=19890215
      WRITE(*,*) 'IDATE = ',IDATE
      CALL DATEF1(500,IDATE,JDATE)
      WRITE(*,*) 'AFTER CALLING DATEF1(500,IDATE,JDATE)'
      WRITE(*,*) 'JDATE = ',JDATE
      CALL DATEG1(ND,IDATE,JDATE)
      WRITE(*,*) 'AFTER CALLING DATEG1(ND,IDATE,JDATE)'
      WRITE(*,*) 'ND = ',ND
      WRITE(*,*) '*** TYPE-2'
      IY=1989
      ITD=46
      WRITE(*,*) 'IY = ',IY,' : ITD = ',ITD
      CALL DATEF2(-80,IY,ITD,JY,JTD)
      WRITE(*,*) 'AFTER CALLING DATEF2(-80,IY,ITD,JY,JTD)'
      WRITE(*,*) 'JY = ',JY,' : JTD = ',JTD
      CALL DATEG2(ND,IY,ITD,JY,JTD)
      WRITE(*,*) 'AFTER CALLING DATEG1(ND,IY,ITD,JY,JTD)'
      WRITE(*,*) 'ND = ',ND
      WRITE(*,*) '*** TYPE-3'
      IY=1989
      IM=2
      ID=15
      WRITE(*,*) 'IY = ',IY,' : IM = ',IM,' : ID = ',ID
      CALL DATEF3(120,IY,IM,ID,JY,JM,JD)
      WRITE(*,*) 'AFTER CALLING DATEF3(120,IY,IM,ID,JY,JM,JD)'
      WRITE(*,*) 'JY = ',JY,' : JM = ',JM,' : JD = ',JD
      CALL DATEG3(ND,IY,IM,ID,JY,JM,JD)
      WRITE(*,*) 'AFTER CALLING DATEG3(ND,IY,IM,ID,JY,JM,JD)'
      WRITE(*,*) 'ND = ',ND

      END

*-----------------------------------------------------------------------
*     USINIT                                          DCL 5.0  95/09/04
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USINIT

      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLIGET('IUNDEF', IUNDEF)
      CALL USIGET('IRESET', IRESET)

      IF(IRESET.LT.0 .OR. IRESET.GT.2)
     +   CALL MSGDMP('E', 'USINIT', 'INVALID VALUE OF ''IRESET''.')

*-----------------------------------------------------------------------

      CALl UZRGET( 'RSIZEL1',  SIZEL)
      OFFSET = SIZEL*0.86

      CALL USRSET( 'SOFFXTR',  OFFSET)
      CALL USRSET( 'SOFFXBR',  OFFSET)
      CALL USRSET( 'SOFFXUR',  OFFSET)

      CALL USRSET( 'SOFFXTL', -OFFSET)
      CALL USRSET( 'SOFFXBL', -OFFSET)
      CALL USRSET( 'SOFFXUL', -OFFSET)

      CALL USRSET( 'SOFFYRT',  OFFSET)
      CALL USRSET( 'SOFFYLT',  OFFSET)
      CALL USRSET( 'SOFFYUT',  OFFSET)

      CALL USRSET( 'SOFFYRB', -OFFSET)
      CALL USRSET( 'SOFFYLB', -OFFSET)
      CALL USRSET( 'SOFFYUB', -OFFSET)

      CALL USRSET( 'ROFFXT', 0.)
      CALL USRSET( 'ROFFXB', 0.)
      CALL USRSET( 'ROFFYR', 0.)
      CALL USRSET( 'ROFFYL', 0.)

      CALL USRSTX( 'XOFF',     RUNDEF)
      CALL USRSTX( 'YOFF',     RUNDEF)
      CALL USRSTX( 'XFAC',     RUNDEF)
      CALL USRSTX( 'YFAC',     RUNDEF)
      CALL USRSTX( 'DXT',      RUNDEF)
      CALL USRSTX( 'DYT',      RUNDEF)
      CALL USRSTX( 'DXL',      RUNDEF)
      CALL USRSTX( 'DYL',      RUNDEF)

      CALL USISTX( 'NLBLX',    IUNDEF)
      CALL USISTX( 'NLBLY',    IUNDEF)
      CALL USISTX( 'NTICKSX',  IUNDEF)
      CALL USISTX( 'NTICKSY',  IUNDEF)
      CALL USISTX( 'ITYPEX',   IUNDEF)
      CALL USISTX( 'ITYPEY',   IUNDEF)

      CALL USRSET( 'XDTMIN',   RUNDEF)
      CALL USRSET( 'XDTMAX',   RUNDEF)
      CALL USRSET( 'YDTMIN',   RUNDEF)
      CALL USRSET( 'YDTMAX',   RUNDEF)

      CALL USCSTX('CXFMT', ' ')
      CALL USCSTX('CYFMT', ' ')

      IF(IRESET.GE.1) THEN
        CALL USCSTX('CXTTL', ' ')
        CALL USCSTX('CYTTL', ' ')
        CALL USCSTX('CXUNIT', ' ')
        CALL USCSTX('CYUNIT', ' ')
      ENDIF

      IF(IRESET.GE.2) THEN
        CALL USCSTX('CXSIDE', 'BT')
        CALL USCSTX('CYSIDE', 'LR')
        CALL USCSTX('CXSPOS', 'R ')
        CALL USCSTX('CYSPOS', 'T ')
        CALL USCSTX('CBLKT ', '()')

*-------------------- PARAMETERS FOR USDAXS ----------------------------

        CALL USLSTX( 'LXINV',   .FALSE.)
        CALL USLSTX( 'LYINV',   .FALSE.)
        CALL USLSTX( 'LMATCH',  .FALSE.)
        CALL USRSTX( 'RMRGN',    9.524)

*-------------------- PARAMETERS FOR USUSCU ----------------------------

        CALL USRSTX( 'TFACT',    2.)
        CALL USISTX( 'MXDGTX',   4)
        CALL USISTX( 'MXDGTY',   4)
        CALL USISTX( 'NBLANK1',  1)
        CALL USISTX( 'NBLANK2',  2)

*---------------- PARAMETERS FOR USXSUB & USYSUB -----------------------

        CALL USISTX( 'MXDGTSX',  6)
        CALL USISTX( 'MXDGTSY',  6)
        CALL USLSTX( 'LPRTCT',  .FALSE.)
      ENDIF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UETONC (Z,MX,NX,NY)

      REAL      Z(MX,*)

      PARAMETER (MAXPXL=4000)

      INTEGER   IMAGE(MAXPXL)
      LOGICAL   LMISS,LIMC

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)

      REAL      TXMIN,TXMAX,TYMIN,TYMAX,TUX,TUY,TUXZ,TUYZ
      LOGICAL   LEXTEN

      EXTERNAL  IUETON, IUWGX, IUWGY

      CALL SGIGET('IBGCLI',IBGCLI)

*     / CHECK IMAGE CAPABILITY /

      CALL SWQIMC(LIMC)
      IF (.NOT.LIMC) THEN
        CALL MSGDMP('E','UETONC','NO IMAGE CAPABILITY.')
      END IF

*     / GET INTERNAL PARAMETERS /

      CALL GLRGET('RUNDEF  ',RUNDEF)
      CALL GLIGET('IUNDEF  ',IUNDEF)
      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX, NY)

*     / CHECK Z VALUES AND TONE LEVEL /

      CALL UEZCHK(Z,MX,NX,NY,'UETONC',ISTAT)
      IF (ISTAT.NE.0) RETURN

*     / INITIALIZE /

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      CALL STFPR2(VXMIN, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX1, WY1)
      CALL SWFINT(WX1, WY1, IX1, IY1)

      CALL STFPR2(VXMAX, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX2, WY2)
      CALL SWFINT(WX2, WY2, IX2, IY2)

      CALL STFPR2(VXMAX, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX3, WY3)
      CALL SWFINT(WX3, WY3, IX3, IY3)

      CALL STFPR2(VXMIN, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX4, WY4)
      CALL SWFINT(WX4, WY4, IX4, IY4)

      IXMIN  = MIN(IX1, IX2, IX3, IX4)
      IYMIN  = MIN(IY1, IY2, IY3, IY4)
      IXMAX  = MAX(IX1, IX2, IX3, IX4)
      IYMAX  = MAX(IY1, IY2, IY3, IY4)
      IWIDTH = IXMAX-IXMIN+1
      IHIGHT = IYMAX-IYMIN+1

      CALL SWIOPN(IXMIN, IYMIN, IWIDTH, IHIGHT,
     +            WX1, WY1, WX2, WY2, WX3, WY3, WX4, WY4)

*     / LOOP FOR EACH PIXEL /
      CALL SGQTRN(ITR)
      CALL SGQTXY(TXMIN,TXMAX,TYMIN,TYMAX)

      DO 30 J=1, IHIGHT
        DO 20 I=1, IWIDTH

          CALL SWIINT(I+IXMIN-1, J+IYMIN-1, WX, WY)
          CALL STIWTR(WX, WY, RX, RY)
          CALL STIPR2(RX, RY, VX, VY)
          IF (VX .LT. VXMIN .OR. VX .GT. VXMAX .OR.
     +        VY .LT. VYMIN .OR. VY .GT. VYMAX) THEN
            UX = RUNDEF
          ELSE
            CALL STITRF(VX, VY, UX, UY)
          END IF

          IF (UX.EQ.RUNDEF) THEN
            IMAGE(I) = 0
          ELSE
            IX = IUWGX(UX)
            IY = IUWGY(UY)
            TUX=RMOD(UX,360.)-180.
            CALL STITRN(VX, VY, TUXZ, TUYZ)
            CALL STIRAD(TUXZ,TUYZ,TUX,TUY)
    !          TUX=RMOD(UX,360.)-180.
            IF(TXMIN.LE.TXMAX)THEN
              IF ((TUX.GE.TXMIN).AND.(TUX.LE.TXMAX))THEN
                LEXTEN=.FALSE.
              ELSE
                LEXTEN=.TRUE.
              END IF
            ELSE
              IF ((TUX.GE.TXMIN).OR.(TUX.LE.TXMAX))THEN
                LEXTEN=.FALSE.
              ELSE
                LEXTEN=.TRUE.
              END IF
            END IF
            IF ((TUY.GE.TYMAX).OR.(TUY.LE.TYMIN))THEN
              LEXTEN=.TRUE.
            END IF
            IF(LEXTEN.AND.((ITR.GE.5).AND.(ITR.NE.51)))THEN
              IMAGE(I) = 0
            ELSE IF (IX.EQ.IUNDEF .OR. IY.EQ.IUNDEF) THEN
              IMAGE(I) = 0
            ELSE
              ZZ = Z(IX, IY)
              IF (LMISS .AND. ZZ.EQ.RMISS) THEN
                IMAGE(I) = 0
              ELSE
                IF (TL1(1) .LE. ZZ .AND. ZZ .LE. TL2(NT)) THEN
                  IMAGE(I) = IUETON(ZZ)/1000
                  IF(IMAGE(I) .EQ. IBGCLI) THEN
                    IMAGE(I)=0
                  ENDIF
                ELSE
                  IMAGE(I) = 0
                END IF
              END IF
            END IF
          END IF

   20   CONTINUE

        CALL SWIDAT(IMAGE, IWIDTH)

   30 CONTINUE

      CALL SWICLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLMGN(XL,XR,YB,YT)

      COMMON    /SLBLK1/ XMIN,XMAX,YMIN,YMAX,NN
      PARAMETER (MAXFR=1000,MAXLEV=3)
      INTEGER   NN(0:MAXLEV)
      REAL      XMIN(MAXFR),XMAX(MAXFR),YMIN(MAXFR),YMAX(MAXFR)

      EXTERNAL  ISUM0


      IF (XL.LT.0 .OR. XR.LT.0 .OR. YB.LT.0 .OR. YT.LT.0) THEN
        CALL MSGDMP('E','SLMGN ',
     +    'MARGIN PARAMETER IS LESS THAN ZERO.')
      END IF
      IF (XL+XR.GE.1.0 .OR. YB+YT.GE.1.0) THEN
        CALL MSGDMP('E','SLMGN ',
     +    'SUM OF MARGIN PARAMETERS IS LARGER THAN 1.0.')
      END IF

      CALL SGIGET('NLEVEL',LEV)

      L1=ISUM0(NN,LEV,1)+1
      L2=ISUM0(NN,LEV+1,1)
      DO 10 LI=L1,L2
        CALL SLMGNZ(XMIN(LI),XMAX(LI),YMIN(LI),YMAX(LI),XL,XR,YB,YT)
   10 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM QUICK4

      PARAMETER( NX=37, NY=37 )
      PARAMETER( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )
      REAL P(NX,NY)

*-- 球面調和関数 ----
      DO 20 J=1,NY
        DO 10 I=1,NX
          ALON = ( XMIN + (XMAX-XMIN)*(I-1)/(NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN)*(J-1)/(NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON) - 0.5*(3*SLAT**2-1)
   10   CONTINUE
   20 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL UETONE( P, NX, NX, NY )
      CALL USDAXS
      CALL UDCNTR( P, NX, NX, NY )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLQRCT(LEV,IFRM,XAMIN,XAMAX,YAMIN,YAMAX)

      COMMON    /SLBLK1/ XMIN,XMAX,YMIN,YMAX,NN
      PARAMETER (MAXFR=1000,MAXLEV=3)
      INTEGER   NN(0:MAXLEV)
      REAL      XMIN(MAXFR),XMAX(MAXFR),YMIN(MAXFR),YMAX(MAXFR)

      EXTERNAL  ISUM0

      CALL SGIGET('NLEVEL',LEVC)

      IF (.NOT.(0.LE.LEV .AND. LEV.LE.LEVC)) THEN
        CALL MSGDMP('E','SLQRCT','LEVEL NUMBER IS INVALID.')
      END IF
      IF (IFRM.LE.0) THEN
        CALL MSGDMP('E','SLQRCT','FRAME NUMBER IS LESS THAN ZERO.')
      END IF

      JFRM=MOD(IFRM-1,NN(LEV))+1
      NM=JFRM+ISUM0(NN,LEV,1)
      XAMIN=XMIN(NM)
      XAMAX=XMAX(NM)
      YAMIN=YMIN(NM)
      YAMAX=YMAX(NM)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DCLCLR

      PARAMETER (NP=5)
      PARAMETER (XMIN=0.07,XMAX=0.97,YMIN=0.03,YMAX=0.93)
      PARAMETER (DX=(XMAX-XMIN)/10,DY=(YMAX-YMIN)/10)

      REAL      XBOX(NP),YBOX(NP)
      CHARACTER CHR*2,CTTL*8

      DATA      XBOX/ 0.0, 1.0, 1.0, 0.0, 0.0/
      DATA      YBOX/ 0.0, 0.0, 1.0, 1.0, 0.0/


      CALL SWISTX('IWIDTH ',600)
      CALL SWISTX('IHEIGHT',600)
      CTTL='DCLCLR'
      CALL CLOWER(CTTL)
      CALL SWCSTX('TITLE',CTTL)

      CALL GLISTX('MAXMSG',0)
      CALL SGISTX('IFONT',2)
      CALL SGLSTX('LCORNER',.FALSE.)

      CALL GROPN(1)
      CALL SGFRM
      CALL SGSWND(0.0,1.0,0.0,1.0)
      CALL SGSTRN(1)

      DO 20 J=0,9
        DO 10 I=0,9
          X1=XMIN+DX*I
          X2=X1+DX
          Y1=YMIN+DY*(9-J)
          Y2=Y1+DY
          LEVEL=(I+J*10)*1000+999
          CALL SGSVPT(X1,X2,Y1,Y2)
          CALL SGSTRF
          CALL SGTNZU(NP,XBOX,YBOX,LEVEL)
          CALL SGPLZU(NP,XBOX,YBOX,1,1)
   10   CONTINUE
   20 CONTINUE

      CALL SGSVPT(0.0,1.0,0.0,1.0)
      CALL SGSTRF

      DO 30 I=0,9
        XX=XMIN+DX*(I+0.5)
        YY=(1+YMAX)/2
        WRITE(CHR,'(I1)') I
        CALL SGTXZV(XX,YY,CHR,0.025,0,0,1)
   30 CONTINUE

      DO 40 J=0,9
        XX=XMIN/2
        YY=YMIN+DY*(9-J+0.5)
        WRITE(CHR,'(I2)') J*10
        CALL SGTXZV(XX,YY,CHR,0.025,0,0,1)
   40 CONTINUE

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM COLOR1

      PARAMETER( NP=4, NT=10 )
      PARAMETER( DD=0.07, DS=0.003 )
      PARAMETER( DX=DD+DS*2, DY=1.0/NT )

      REAL      XBOX(NP), YBOX(NP)
      CHARACTER CHR*5

      DATA      XBOX/ 0., 1., 1., 0. /
      DATA      YBOX/ 0., 0., 1., 1. /

      WRITE(*,*) ' WORKSTATION ID (I) ? ; '
      CALL SGPWSN
      READ (*,*) IWS

      CALL GLISET( 'MAXMSG', 300 )

      CALL SGOPN( -ABS(IWS) )

      CALL SGLSET( 'LFULL' , .TRUE. )
      CALL SLRAT( 0.85, 1. )
      CALL SLMGN( 0., 0., 0.05, 0.1 )
      CALL SLSTTL( 'TEST OF COLORMAP', 'T', 0., -0.5, 0.025, 1 )

      DO 20 K=1,80

      CALL SWISET('ICLRMAP',K)
*      IF (MOD(K,2).EQ.1) THEN
*        CALL SWLSET('LFGBG',.FALSE.)
*      ELSE
*        CALL SWLSET('LFGBG',.TRUE.)
*      END IF
      CALL SWCLCH
      CALL SGFRM
      CALL SGSWND( 0., 1., 0., 1. )
      CALL SGSTRN( 1 )

      CALL SGSTXS( 0.01 )
      CALL SGSTXC( 1 )
      DO 10 J=0,9
      DO 10 I=0,9
        X1 = DX*I     + DS + (1-DX*NT)/2
        Y1 = DY*(9-J) + DS
        X2 = X1 + DD
        Y2 = Y1 + DD
        ITPAT = (I+J*10)*1000 + 999

        CALL SGSVPT( X1, X2, Y1, Y2 )
        CALL SGSTRF

        WRITE(CHR,'(I5)') ITPAT
        CALL SGIGET('IBGCLI',IBC)
        IF(ITPAT.EQ.999)THEN
*          ITPAT=IBC*1000 + 999
        ENDIF

        CALL SLPVPR( 1 )
        CALL SGSTNP( ITPAT )
        CALL SGTNU( NP, XBOX, YBOX )
        CALL SGTXV( X2, Y2+(DY-DD)/2, CHR )
   10 CONTINUE
   20 CONTINUE
        CALL SGCLS

        END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UETONF (Z,MX,NX,NY)

      REAL      Z(MX,*)

      PARAMETER (MAXPXL=4000)

      INTEGER   IMAGE(MAXPXL)
      LOGICAL   LMISS,LIMC

      COMMON    /UEBLK1/ TL1,TL2,IPT,NT,LASCND
      PARAMETER (MAXNT=100)
      LOGICAL   LASCND
      INTEGER   IPT(MAXNT)
      REAL      TL1(MAXNT),TL2(MAXNT)

      REAL      TXMIN,TXMAX,TYMIN,TYMAX,TUX,TUY,TUXZ,TUYZ
      LOGICAL   LEXTEN

*     / CHECK IMAGE CAPABILITY /

      CALL SWQIMC(LIMC)
      IF (.NOT.LIMC) THEN
        CALL MSGDMP('E','UETONF','NO IMAGE CAPABILITY.')
      END IF

*     / GET INTERNAL PARAMETERS /

      CALL GLRGET('RUNDEF  ',RUNDEF)
      CALL GLIGET('IUNDEF  ',IUNDEF)
      CALL GLLGET('LMISS   ',LMISS )
      CALL GLRGET('RMISS   ',RMISS )

*     / SET GRID ATTRIBUTE IF IT HAS NOT BEEN SET YET /

      CALL UWDFLT(NX, NY)

*     / CHECK Z VALUES AND TONE LEVEL /

      CALL UEZCHK(Z,MX,NX,NY,'UETONF',ISTAT)
      IF (ISTAT.NE.0) RETURN

*     / INITIALIZE /

      CALL SGQVPT(VXMIN, VXMAX, VYMIN, VYMAX)

      CALL STFPR2(VXMIN, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX1, WY1)
      CALL SWFINT(WX1, WY1, IX1, IY1)

      CALL STFPR2(VXMAX, VYMIN, RX, RY)
      CALL STFWTR(RX, RY, WX2, WY2)
      CALL SWFINT(WX2, WY2, IX2, IY2)

      CALL STFPR2(VXMAX, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX3, WY3)
      CALL SWFINT(WX3, WY3, IX3, IY3)

      CALL STFPR2(VXMIN, VYMAX, RX, RY)
      CALL STFWTR(RX, RY, WX4, WY4)
      CALL SWFINT(WX4, WY4, IX4, IY4)

      IXMIN  = MIN(IX1, IX2, IX3, IX4)
      IYMIN  = MIN(IY1, IY2, IY3, IY4)
      IXMAX  = MAX(IX1, IX2, IX3, IX4)
      IYMAX  = MAX(IY1, IY2, IY3, IY4)
      IWIDTH = IXMAX-IXMIN+1
      IHIGHT = IYMAX-IYMIN+1
        CALL SGQTXY(TXMIN,TXMAX,TYMIN,TYMAX)

      CALL SWIOPN(IXMIN, IYMIN, IWIDTH, IHIGHT,
     +            WX1, WY1, WX2, WY2, WX3, WY3, WX4, WY4)

*     / LOOP FOR EACH PIXEL /

        CALL SGQTXY(TXMIN,TXMAX,TYMIN,TYMAX)

      DO 30 J=1, IHIGHT
        DO 20 I=1, IWIDTH

          CALL SWIINT(I+IXMIN-1, J+IYMIN-1, WX, WY)
          CALL STIWTR(WX, WY, RX, RY)
          CALL STIPR2(RX, RY, VX, VY)
          IF (VX .LT. VXMIN .OR. VX .GT. VXMAX .OR.
     +        VY .LT. VYMIN .OR. VY .GT. VYMAX) THEN
            UX = RUNDEF
          ELSE
            CALL STITRF(VX, VY, UX, UY)
          END IF

          IF (UX.EQ.RUNDEF) THEN
            IMAGE(I) = 0
          ELSE

          CALL SGQTRN(ITR)

          IF (ITR.EQ.5) THEN
            CALL SGRGET('UYMAX',UYX)
            CALL SGRGET('UYMIN',UYN)
            IF (UYX .LT. (UYN+360.)) THEN
              UYX=UYN+360.
            END IF
          END IF
        CALL UWQGXI(UX,IX,FX)
        CALL UWQGYI(UY,IY,FY)
        CALL STITRN(VX, VY, TUXZ, TUYZ)
        CALL STIRAD(TUXZ,TUYZ,TUX,TUY)
        IF(TXMIN.LE.TXMAX)THEN
          IF ((TUX.GE.TXMIN).AND.(TUX.LE.TXMAX))THEN
            LEXTEN=.FALSE.
          ELSE
            LEXTEN=.TRUE.
          END IF
        ELSE
          IF ((TUX.GE.TXMIN).OR.(TUX.LE.TXMAX))THEN
            LEXTEN=.FALSE.
          ELSE
            LEXTEN=.TRUE.
          END IF
        END IF
        IF ((TUY.GE.TYMAX).OR.(TUY.LE.TYMIN))THEN
          LEXTEN=.TRUE.
        END IF
        IF(LEXTEN.AND.((ITR.GT.5).AND.(ITR.NE.51)))THEN
              IMAGE(I) = 0
        ELSE IF (IX.EQ.IUNDEF .OR. IY.EQ.IUNDEF) THEN
              IMAGE(I) = 0
        ELSE
              IF (LMISS .AND.
     +             (Z(IX  , IY  ).EQ.RMISS .OR.
     +              Z(IX+1, IY  ).EQ.RMISS .OR.
     +              Z(IX  , IY+1).EQ.RMISS .OR.
     +              Z(IX+1, IY+1).EQ.RMISS)     ) THEN
                IMAGE(I) = 0
              ELSE
                ZZ = (Z(IX, IY  )*(1-FX) + Z(IX+1,IY  )*FX)*(1-FY)
     +             + (Z(IX, IY+1)*(1-FX) + Z(IX+1,IY+1)*FX)*FY
                IF (TL1(1) .LE. ZZ .AND. ZZ .LE. TL2(NT)) THEN
                  IMAGE(I) = IUETON(ZZ)/1000
                  IF(IMAGE(I) .EQ. IBGCLI) THEN
                    IMAGE(I)=0
                  ENDIF
                ELSE
                  IMAGE(I) = 0
                END IF
              END IF
            END IF
          END IF

   20   CONTINUE

        CALL SWIDAT(IMAGE, IWIDTH)

   30 CONTINUE

      CALL SWICLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM KIHON4

      PARAMETER( NMAX=9, X1=0.1, XC=0.5, X2=0.9 )
      REAL Y(NMAX)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

*-- 罫線 ----
      DO 10 N=1,NMAX
        Y(N) = 0.1*(10-N)
        CALL SGLNV( X1, Y(N), X2, Y(N) )
  10  CONTINUE

      CALL SGLNV( XC, 0.05, XC, 0.95 )

*-- デフォルト ----
      CALL SGTXV( XC, Y(1), 'SGTXV' )

*-- 文字のラインインデクス ----
      CALL SGSTXI( 3 )
      CALL SGTXV( XC, Y(2), 'INDEX3' )

      CALL SGSTXI( 5 )
      CALL SGTXV( XC, Y(3), 'INDEX5' )

      CALL SGSTXI( 1 )

*-- 文字の大きさ ----
      CALL SGSTXS( 0.03 )
      CALL SGTXV( XC, Y(4), 'SMALL' )

      CALL SGSTXS( 0.07 )
      CALL SGTXV( XC, Y(5), 'LARGE' )

      CALL SGSTXS( 0.05 )

*-- 文字列のセンタリングオプション ----
      CALL SGSTXC( -1 )
      CALL SGTXV( XC, Y(6), 'LEFT' )

      CALL SGSTXC( 1 )
      CALL SGTXV( XC, Y(7), 'RIGHT' )

      CALL SGSTXC( 0 )

*-- 文字列の回転角 ----
      CALL SGSTXR( 10 )
      CALL SGTXV( XC, Y(8), 'ROTATION+' )

      CALL SGSTXR( -10 )
      CALL SGTXV( XC, Y(9), 'ROTATION-' )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UVBXLZ(N,UPX,UPY,ITYPE,INDEX)

      REAL      UPX(*),UPY(*)

      LOGICAL   LFLAG, LMISS, LXUNI
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.2) THEN
        CALL MSGDMP('E','UVBXLZ','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UVBXLZ','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UVBXLZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UVBXLZ','LINE INDEX IS LESS THAN 0.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      IF (UPY(1).EQ.RUNDEF) THEN
        CALL MSGDMP('E', 'UVBXLZ', 'RUNDEF CAN NOT BE UESED FOR UPY.')
      END IF

      WRITE(COBJ,'(2I8)') ITYPE,INDEX
      CALL CDBLK(COBJ)
      CALL SWOOPN('UVBXLZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)
      CALL SZOPLU

      LXUNI = UPX(1).EQ.RUNDEF

      IF (LXUNI) THEN
        CALL UUQIDV(UXMIN, UXMAX)
        IF (UXMIN.EQ.RUNDEF) CALL SGRGET('UXMIN', UXMIN)
        IF (UXMAX.EQ.RUNDEF) CALL SGRGET('UXMAX', UXMAX)
        DX = (UXMAX-UXMIN)/N
      END IF

      CALL SZOPLU

      LFLAG=.FALSE.
      DO 20 I=1,N
        IF (LXUNI) THEN
          UX1 = UXMIN + DX*(I-1)
          UX2 = UXMIN + DX*I
        ELSE
          UX1 = UPX(I)
          UX2 = UPX(I+1)
        END IF

        IF ((UX1.EQ.RMISS .OR. UX2.EQ.RMISS .OR. UPY(I).EQ.RMISS)
     #    .AND. LMISS) THEN
          LFLAG=.FALSE.
        ELSE
          IF (LFLAG) THEN
            CALL SZPLLU(UX1,UPY(I))
            CALL SZPLLU(UX2,UPY(I))
          ELSE
            CALL SZMVLU(UX1,UPY(I))
            CALL SZPLLU(UX2,UPY(I))
            LFLAG=.TRUE.
          END IF
        END IF
   20 CONTINUE

      CALL SZCLLU
      CALL SWOCLS('UVBXLZ')

      END

      PROGRAM UIPK01

      REAL A(2), B(2)

      CALL SWISET('WINDOW_HEIGHT', 300)
      CALL SWISET('WINDOW_WIDTH', 300)

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL GROPN(IWS)
      CALL GRFRM
      CALL GRSWND(0., 256., 0., 256.)
      CALL GRSVPT(.1, .9, .1, .9)
      CALL GRSTRN(1)
      CALL GRSTRF

      DO I = 1, 255

         A(1) = 1. * I
         A(2) = 1. * I

         DO J = 1, 255

            B(1) = 1. * (J - 1)
            B(2) = 1. * J

            CALL SGPLXU(2, A, B, 1, 1, ISGRGB(I,J,0))

         END DO
      END DO

      CALL UXAXDV('T', 16., 64.)
      CALL UXAXDV('B', 16., 64.)
      CALL UYAXDV('L', 16., 64.)
      CALL UYAXDV('R', 16., 64.)

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     NUCDAY
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      INTEGER FUNCTION NUCDAY(CS,ND)

      CHARACTER CS*(*)

      PARAMETER (NX=5)

      INTEGER   NDX(NX)

      DATA      NDX/  1,  2,  5, 10, 15/


      CALL UCIGET('IUNDEF',IUNDEF)
      CALL UCIGET('NDAY  ',NDAY  )

      IF (NDAY.NE.IUNDEF) THEN
        NUCDAY=NDAY
      ELSE
        CALL UCRGET('DFACT  ',DFACT)
        CALL UZRGET('RSIZEL1',RSIZE)
        CALL SGQVPT(VX1,VX2,VY1,VY2)
        IF (CS(1:1).EQ.'X') THEN
          WD=VX2-VX1
        ELSE IF (CS(1:1).EQ.'Y') THEN
          WD=VY2-VY1
        END IF
        MAXL=WD/(RSIZE*2*DFACT)
        DO 10 N=1,NX
          IF (ND/NDX(N).LE.MAXL) THEN
            NUCDAY=NDX(N)
            RETURN
          END IF
   10   CONTINUE
        NUCDAY=0
      END IF

      END

*-----------------------------------------------------------------------
*     UEIQNP / UEIQID / UEIQCP / UEIQVL / UEISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 5)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

*     / SHORT NAME /

      DATA      CPARAS(1) / 'IPAT    ' /, IX(1) / 1201 /
      DATA      CPARAS(2) / 'NLEV    ' /, IX(2) / 12 /
      DATA      CPARAS(3) / 'ITPAT   ' /, IX(3) / 999 /
      DATA      CPARAS(4) / 'ICOLOR1 ' /, IX(4) / 15 /
      DATA      CPARAS(5) / 'ICOLOR2 ' /, IX(5) / 94 /

*     / LONG NAME /

      DATA      CPARAL(1) / 'DEFAULT_SHADE_PATTERN' /
      DATA      CPARAL(2) / '****NLEV    ' /
      DATA      CPARAL(3) / 'AUTO_SHADE_PATTERN' /
      DATA      CPARAL(4) / 'SHADE_COLOR_MIN' /
      DATA      CPARAL(5) / 'SHADE_COLOR_MAX' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UEIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UEIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UEIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UE', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','UEIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('UE', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','UEISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UEIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     UCRQNP / UCRQID / UCRQCP / UCRQVL / UCRSVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UCRQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 1)

      REAL      RX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ,LENC

      SAVE

      DATA      CPARAS( 1) / 'DFACT   ' /, RX( 1) / 1.2 /

      DATA      CPARAL( 1) / '****DFACT   ' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCRQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','UCRQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCRQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','UCRQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCRQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','UCRQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCRQVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UC', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RPARA = RX(IDX)
      ELSE
        CALL MSGDMP('E','UCRQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCRSVL(IDX, RPARA)

      IF (LFIRST) THEN
        CALL RTRGET('UC', CPARAS, RX, NPARA)
        CALL RLRGET(CPARAL, RX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        RX(IDX) = RPARA
      ELSE
        CALL MSGDMP('E','UCRSVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY UCRQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*    Runge-Kutta dirver (Variable step)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ODRKDV(N, STEPER, FCN, T, TEND, DT, X, WORK)

      DIMENSION X(N), WORK(N,*)
*                     WORK(N,7) FOR ODRK4R
*                     WORK(N,5) FOR RKGR
      EXTERNAL  FCN, STEPER
      SAVE

      IF(DT*(TEND-T).LE.0.)
     #             CALL MSGDMP('E', 'ODRKDV', 'INVALID TEND OR DT.')

      CALL ODIGET('MAXSTEP', MXSTEP)
      CALL ODRGET('EPSILON', EPSL)

      T0  = T
      DTT = DT

      DO 10 I=1,MXSTEP
        DT = DTT
        IF((T+DT*2-TEND)*(T+DT*2-T0).GT.0.) DTT=(TEND-T)/2.
        CALL STEPER(N, FCN, T, DTT, EPSL, X, WORK)
        NS = I
        IF((T-TEND)*(TEND-T0).GE.0.) THEN
          CALL ODISET('NSTEP', NS)
          RETURN
        ENDIF
   10 CONTINUE
      CALL MSGDMP('W', 'ODRKDV', 'TOO MANY STEPS.')

      RETURN
      END

      PROGRAM KIHON5

      PARAMETER( NMAX=40, IMAX=4 )
      REAL X(0:NMAX,IMAX), Y(0:NMAX,IMAX), XC(IMAX), YC(IMAX)

      DATA XC/0.25, 0.75, 0.25, 0.75/
      DATA YC/0.75, 0.75, 0.25, 0.25/

      DT = 2.* 3.14159 / 6
      DO 10 N=0,5
      DO 10 I=1,IMAX-1
        X(N,I) = 0.2*COS(N*DT) + XC(I)
        Y(N,I) = 0.2*SIN(N*DT) + YC(I)
   10 CONTINUE

      DT = 4.* 3.14159 / NMAX
      DO 20 N=0,NMAX
        X(N,IMAX) = 0.4*REAL(N)/REAL(NMAX) - 0.2 + XC(IMAX)
        Y(N,IMAX) = 0.2*SIN(N*DT)                + YC(IMAX)
   20 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL SGFRM

*-- デフォルト ----
      CALL SGTNV( 6, X(0,1), Y(0,1) )

*-- トーンパターン ----
      CALL SGSTNP( 3 )
      CALL SGTNV( 6, X(0,2), Y(0,2) )

      CALL SGSTNP( 601 )
      CALL SGTNV( 6, X(0,3), Y(0,3) )

*-- ねじれた多角形 ----
      CALL SGTNV( NMAX+1, X(0,4), Y(0,4) )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZLAZR(RX1,RY1,RX2,RY2)

      LOGICAL   LCLPLZ,LCLPTZ

      COMMON    /SZBLA1/ LARRWZ,LPROPZ,AFACTZ,CONSTZ,ANGLEZ,
     +                   LATONZ,LUARWZ,CONSMZ,RDUNIT
      LOGICAL   LARRWZ,LPROPZ,LATONZ,LUARWZ
      COMMON    /SZBLS2/ LCLIPL
      LOGICAL   LCLIPL
      COMMON    /SZBTX3/ LCLIPT
      LOGICAL   LCLIPT

      EXTERNAL  RFPI

      SAVE


      R=SQRT((RX2-RX1)**2+(RY2-RY1)**2)
      IF (R.EQ.0) RETURN

      PI=RFPI()

      LCLPLZ=LCLIPL
      LCLPTZ=LCLIPT
      LCLIPL=.FALSE.
      LCLIPT=.FALSE.
      CALL STEPR2

      CALL SZOPLV
      CALL SZMVLV(RX1,RY1)
      CALL SZPLLV(RX2,RY2)
      CALL SZCLLV

      IF (.NOT.LARRWZ) GO TO 100

      IF (LPROPZ) THEN
        AR=R*AFACTZ
      ELSE
        AR=CONSTZ
      END IF

      XE=(RX2-RX1)/R*AR
      YE=(RY2-RY1)/R*AR
      CALL CR2C(-(PI-ANGLEZ*RDUNIT),XE,YE,XA1,YA1)
      CALL CR2C(-(PI+ANGLEZ*RDUNIT),XE,YE,XA2,YA2)

      IF (LATONZ) THEN
        CALL SZOPTV
        CALL SZSTTV(RX2+XA1,RY2+YA1)
        CALL SZSTTV(RX2,RY2)
        CALL SZSTTV(RX2+XA2,RY2+YA2)
        CALL SZCLTV
      ELSE
        CALL SZOPLV
        CALL SZMVLV(RX2+XA1,RY2+YA1)
        CALL SZPLLV(RX2,RY2)
        CALL SZPLLV(RX2+XA2,RY2+YA2)
        CALL SZCLLV
      END IF

  100 CONTINUE

      LCLIPL=LCLPLZ
      LCLIPT=LCLPTZ
      CALL STRPR2

      END

*-----------------------------------------------------------------------
*     PROGRAM FOR MAPDATA SUBTRUCTION                        (94/05/07)
*-----------------------------------------------------------------------
*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM RMAPD1

      PARAMETER (IU1=11,IU2=21)

      REAL      FLIM(4),PTX1(20000),PTY1(20000),PTX2(20000),PTY2(20000)
      CHARACTER CDSNI*64,CDSNO*64


      READ(*,*) CDSNI,CDSNO

      OPEN(IU1,FILE=CDSNI,FORM='FORMATTED',STATUS='OLD')
      REWIND(IU1)
      OPEN(IU2,FILE=CDSNO,FORM='FORMATTED',STATUS='NEW')
      REWIND(IU2)

   10 CONTINUE
        READ(IU1,'(2I8,4F8.3)',IOSTAT=IOS) NPTS,IGID,(FLIM(I),I=1,4)
        NPT1=NPTS/2
        IF (IOS.EQ.0) THEN
          IF (NPT1.GE.1) THEN
            READ(IU1,'(10F8.3)') (PTX1(I),PTY1(I),I=1,NPT1)
          END IF
          CALL RMPSUB(PTX1,PTY1,NPT1,PTX2,PTY2,NPT2)
          CALL RMPSUB(PTX2,PTY2,NPT2,PTX1,PTY1,NPT1)
          WRITE(IU2,'(2I8,4F8.3)') NPT1*2,IGID,(FLIM(I),I=1,4)
          WRITE(IU2,'(10F8.3)') (PTX1(I),PTY1(I),I=1,NPT1)
        END IF
      IF (IOS.EQ.0) GO TO 10

      CLOSE(IU1)
      CLOSE(IU2)

      END
*-----------------------------------------------------------------------
      SUBROUTINE RMPSUB(PTX1,PTY1,NPT1,PTX2,PTY2,NPT2)

      PARAMETER (CXLIM=0.5)

      REAL      PTX1(*),PTY1(*),PTX2(*),PTY2(*)


      IF (NPT1.LT.2) THEN
        WRITE(*,*) 'PMAPD1/RMPSUB - ERROR IN POINTS.'
        STOP
      END IF

      PTX2(1)=PTX1(1)
      PTY2(1)=PTY1(1)

      IF (NPT1.LE.2) THEN
        NPT2=2
        PTX2(NPT2)=PTX1(NPT1)
        PTY2(NPT2)=PTY1(NPT1)
        RETURN
      END IF

      NX=1
      NPT2=1

   10 CONTINUE

        N0=NX
        N1=NX+1
        N2=NX+2
        DX1=PTX1(N1)-PTX1(N0)
        DX2=PTX1(N2)-PTX1(N1)
        DY1=PTY1(N1)-PTY1(N0)
        DY2=PTY1(N2)-PTY1(N1)
        CX=(DX1*DX2+DY1*DY2)/(SQRT(DX1**2+DY1**2)*SQRT(DX2**2+DY2**2))
        IF (CX.GT.CXLIM) THEN
          NX=N2
        ELSE
          NX=N1
        END IF
        NPT2=NPT2+1
        PTX2(NPT2)=PTX1(NX)
        PTY2(NPT2)=PTY1(NX)

      IF (NX+2.LE.NPT1) GO TO 10

      IF (NX.NE.NPT1) THEN
        NPT2=NPT2+1
        PTX2(NPT2)=PTX1(NPT1)
        PTY2(NPT2)=PTY1(NPT1)
      END IF

      END

program sample03

  use dcl
  integer,parameter :: nx=36, ny=36
  real,parameter :: xmin=0., xmax=360., ymin=-90., ymax=90.
  real,dimension(0:nx,0:ny) :: p

!-- 球面調和関数 ----

    do j=0,ny
      do i=0,nx
        alon = ( xmin + (xmax-xmin)*i/nx ) * DCL_PI/180.
        alat = ( ymin + (ymax-ymin)*j/ny ) * DCL_PI/180.
        p(i,j) = sqrt(1-sin(alat)**2) * sin(alat) * cos(alon)
      end do
    end do

!-- グラフ ----

    call DclOpenGraphics()
    call DclNewFrame

!    call DclSetParm('ENABLE_SOFTFILL',.true.)

    call DclSetWindow( xmin, xmax, ymin, ymax )
    call DclSetViewPort( 0.1, 0.9, 0.2, 0.8 )
    call DclSetTransFunction

    call DclShadeContour( p )

    call DclDrawScaledAxis

    call DclDrawContour( p )

    call DclCloseGraphics

end program

*-----------------------------------------------------------------------
      PROGRAM U2DF07

      PARAMETER ( NX=19, NY=19 )
      PARAMETER ( XMIN=0, XMAX=360, YMIN=-90, YMAX=90 )
      PARAMETER ( PI=3.141592, DRAD=PI/180, DZ=0.05 )

      REAL      P(NX,NY), U(NX,NY), V(NX,NY)

      EXTERNAL  IMOD


      CALL GLRGET( 'RMISS', RMISS )
      CALL GLLSET( 'LMISS', .TRUE. )

      DO 20 J = 1, NY
        DO 10 I = 1, NX
          ALON = ( XMIN + (XMAX-XMIN) * (I-1) / (NX-1) ) * DRAD
          ALAT = ( YMIN + (YMAX-YMIN) * (J-1) / (NY-1) ) * DRAD
          SLAT = SIN(ALAT)
          P(I,J) = COS(ALON) * (1-SLAT**2) * SIN(2*PI*SLAT) + DZ
   10   CONTINUE
   20 CONTINUE

      DO 40 J = 1, NY
        DO 30 I = 1, NX
          IF (J.EQ.1 .OR. J.EQ.NY) THEN
            U(I,J)=RMISS
            V(I,J)=RMISS
          ELSE
            U(I,J) = P(I,J-1) - P(I,J+1)
            V(I,J) = P(IMOD(I,NX-1)+1,J) - P(IMOD(I-2,NX-1)+1,J)
          END IF
   30   CONTINUE
   40 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT( 0.2, 0.8, 0.2, 0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS

      CALL UGVECT( U, NX, V, NX, NX, NY )

      CALL GRCLS

      END

program etc

  use dcl

  call DclSetParm('WINDOW_WIDTH',300)
  call DclSetParm('WINDOW_HEIGHT',200)
  call DclOpenGraphics(-1)

  call DclDrawDeviceViewPortFrame(1)
  call DclSetParm( 'IFONT', 2 )
  call DclSetParm( 'ENABLE_PROPORTIONAL_FONT', .true. )

  call DclDrawTextProjected(0.3,0.5,'Font2')

  call DclCloseGraphics
end program

*-----------------------------------------------------------------------
*     INTERPOLATION FOR ARROW PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SZPIPZ(UXP0,UYP0,UXP1,UYP1,NN)

      PARAMETER (NMAX=100)

      REAL      XZ(NMAX),YZ(NMAX)
      LOGICAL   LFRST,LMAP,LCONTU,LCONTT

      EXTERNAL  RFPI

      SAVE

      DATA      LFRST/.TRUE./


      PI=RFPI()

      CALL STQTRF(LMAP)

      CALL STFRAD(UXP0,UYP0,UX0,UY0)
      CALL STFRAD(UXP1,UYP1,UX1,UY1)

      DXX=UX1-UX0
      IF (LMAP) THEN
        IF (DXX.GT.PI) THEN
          UX1=UX1-2*PI
        ELSE IF (DXX.LT.-PI) THEN
          UX1=UX1+2*PI
        END IF
      END IF

      XX1=UX0
      YY1=UY0
      NC=1
      XZ(1)=UX0
      YZ(1)=UY0
      CALL SZPIPL(UX0,UY0,UX1,UY1,2)
   10 CONTINUE
        XX0=XX1
        YY0=YY1
        CALL SZGIPL(XX1,YY1,LCONTU)
        CALL SZPIPT(XX0,YY0,XX1,YY1,2)
   20   CONTINUE
          NC=NC+1
          IF (NC.GT.NMAX) THEN
            IF (LFRST) THEN
              CALL MSGDMP('M','SGSIPU','WORKING AREA OVERFLOW.')
              LFRST=.FALSE.
            END IF
            XZ(NMAX-1)=XZ(NMAX)
            YZ(NMAX-1)=YZ(NMAX)
            NC=NMAX
          END IF
          CALL SZGIPT(XZ(NC),YZ(NC),LCONTT)
        IF (LCONTT) GO TO 20
      IF (LCONTU) GO TO 10

      NN=NC-1

      RETURN
*-----------------------------------------------------------------------
      ENTRY SZGIPZ(UXG0,UYG0,UXG1,UYG1,N0)

      N1=N0+1
      CALL STIRAD(XZ(N0),YZ(N0),UXG0,UYG0)
      CALL STIRAD(XZ(N1),YZ(N1),UXG1,UYG1)

      RETURN
      END

*-----------------------------------------------------------------------
      SUBROUTINE SGLAXV(VX1,VY1,VX2,VY2,ITYPE,INDEX,ICOLOR)
      LOGICAL LFCATR

      CALL SWQFCC(LFCATR)
      IF(.NOT.LFCATR) THEN
        CALL MSGDMP('M','SGLAXV','FULL COLOR MODE IS NOT SUPPORTED.')
      END IF

      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGLAXV','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLAXV','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLAXV','LINE INDEX IS INVALID.')
      END IF

      CALL SWSFCM(.TRUE.)
      CALL SWSLCL(ICOLOR)

      CALL SZLAOP(ITYPE,INDEX)
      CALL SZLAZV(VX1,VY1,VX2,VY2)
      CALL SZLACL

      CALL SWSFCM(.FALSE.)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE VCINTR(CX,N,JX)

      COMPLEX CX(*),CMISS,CD,C1
      LOGICAL LFLAG


      CALL GLRGET('RMISS',RMISS)
      CMISS=CMPLX(RMISS,RMISS)

      LFLAG=.FALSE.

      KX=1-JX
      DO 15 J=1,N
        KX=KX+JX
        IF (LFLAG) THEN
          IF (CX(KX).EQ.CMISS) THEN
            IF (.NOT.(CX(KX-JX).EQ.CMISS)) THEN
              NMISS=1
            ELSE
              NMISS=NMISS+1
            END IF
          ELSE
            IF (CX(KX-JX).EQ.CMISS) THEN
              C1=CX(KX-(NMISS+1)*JX)
              CD=(CX(KX)/C1)**(1.0/(NMISS+1))
              DO 10 NN=1,NMISS
                CX(KX-(NMISS+1-NN)*JX)=C1*(CD**NN)
   10         CONTINUE
            END IF
          END IF
        ELSE
          IF (.NOT.(CX(KX).EQ.CMISS)) THEN
            LFLAG=.TRUE.
          END IF
        END IF
   15 CONTINUE

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ULYLOG ( CSIDE, NLBL, NTICKS )

*     CSIDE : 'L','R','U'
*     NLBL  : 1-4          ... Label buffer number used in the axis
*     NTICKS: 1-9          ... Number of small ticks in 10**N-10**(N+1)

      PARAMETER(MAXL=50,MAXS=200)
      DIMENSION BL(10),BS(10),UY1(MAXS),UY2(MAXL),UYT(MAXL)
      CHARACTER CH(MAXL)*18,CHR*8,CFMT*16,USGI*3,CSIDE,CHW*16
      LOGICAL LRLT,LRGT,LABEL,LEPSL,LCNTL,LUYCHK,LOFF,LSFNT

      SAVE

      IF(.NOT.LUYCHK(CSIDE))
     #   CALL MSGDMP('E', 'ULYLOG', 'INVALID CSIDE.')
      IF(NLBL.LT.1 .OR. NLBL.GT.4)
     #   CALL MSGDMP('E', 'ULYLOG', 'INVALID NLBL.')
      IF(NTICKS.LT.1 .OR. NTICKS.GT.9)
     #   CALL MSGDMP('E', 'ULYLOG', 'INVALID NTICKS.')

      CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)

      CALL UZLGET('LOFFSET', LOFF)
      IF(LOFF) THEN
        CALL UZRGET('YFACT',   FACTOR)
        YMIN = UYMIN/FACTOR
        YMAX = UYMAX/FACTOR
        CALL SGSWND(UXMIN, UXMAX , YMIN, YMAX)
        CALL SGSTRF
      ELSE
        YMIN = UYMIN
        YMAX = UYMAX
      ENDIF

      SGN = SIGN(1.0,YMIN)

      IF(SGN*YMIN.GT.SGN*YMAX)THEN
        YYY=YMIN
        YMIN=YMAX
        YMAX=YYY
      END IF

      CALL ULIGET('IYTYPE', ITYPE)
      CALL ULIGET('IYCHR' , IYCHR)
      CALL ULYLBL( BL, NB , NLBL)

      CALL SGIGET('ISUP', ISUP)
      CALL SGIGET('IRST', IRST)

      CALL GLLGET('LEPSL',LEPSL)
      CALL SGLGET('LCNTL',LCNTL)
      CALL SWLGET('LSYSFNT',LSFNT)
      CALL GLLSET('LEPSL',.TRUE.)
      CALL GNSAVE

*     SMALL TICKS

      CALL VRGNN(BS, 10, 1)
      BS(NTICKS+1)=10.
      CALL GNSBLK(BS,NTICKS+1)
      CALL GNLE(ABS(YMAX),BYMAX,IPMAX)
      CALL GNGE(ABS(YMIN),BYMIN,IPMIN)

      NBS=0
      DO 100 IP=IPMIN,IPMAX
      DO 100 IB=1,NTICKS
        IF(IP.EQ.IPMIN.AND.LRLT(BS(IB),BYMIN))GOTO 100
        IF(IP.EQ.IPMAX.AND.LRGT(BS(IB),BYMAX))GOTO 100
        NBS=NBS+1
        IF(NBS.GT.MAXS) CALL MSGDMP('E', 'ULYLOG', 'TOO MANY TICKS.')
        UY1(NBS)=SGN*BS(IB)*10.**IP
  100 CONTINUE

*     LARGE LABELS AND TICKS

      CALL GNSBLK(BL,NB+1)
      CALL GNLE(ABS(YMAX),BYMAX,IPMAX)
      CALL GNGE(ABS(YMIN),BYMIN,IPMIN)

      NBL=0
      NBT=0
      JTYPE = MOD(ITYPE, 2)

      DO 201 IP=IPMIN,IPMAX
      DO 201 IB=1,NB
        IF(IP.EQ.IPMIN.AND.LRLT(BL(IB),BYMIN))GOTO 201
        IF(IP.EQ.IPMAX.AND.LRGT(BL(IB),BYMAX))GOTO 201

        IF(IB.EQ.1)THEN
          NBT=NBT+1
          UYT(NBT)=SGN*10.**IP
        END IF

        NBL=NBL+1
        IF(NBL.GT.MAXL) CALL MSGDMP('E', 'ULYLOG', 'TOO MANY LABELS.')
        UY2(NBL)=SGN*BL(IB)*10.**IP

        IF(ITYPE.LE.2) THEN
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            IF(JTYPE.EQ.1 .AND. NB.NE.1) THEN
              WRITE(CH(NBL),'(I1,A3)') INT(BL(IB)),USGI(IYCHR)
            ELSE
              CH(NBL)=' '
            ENDIF

            WRITE(CHR,'(I8)') IP
            CALL CLADJ(CHR)
            CH(NBL)(5:18)='10\^{'//CHR(1:LENZ(CHR))//'}'
            CALL CLADJ(CH(NBL))
          ENDIF
        ELSE
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            CALL UZCGET('CYFMT', CFMT)
            CALL CHVAL(CFMT, ABS(UY2(NBL)), CH(NBL))
            CALL CLADJ(CH(NBL))
          ENDIF
        ENDIF
  201 CONTINUE

      IF(SGN.LT.0) THEN
         DO 301 IB=1,NBL
            CHW='-'//CH(IB)
            CH(IB)=CHW
  301    CONTINUE
      ENDIF

*     DRAW AXIS, TICKS, AND LABELS

      CALL UYPAXS(CSIDE,2)
      IF(NBS.NE.0) CALL UYPTMK(CSIDE,1,UY1,NBS)
      IF(NBT.NE.0) CALL UYPTMK(CSIDE,2,UYT,NBT)
      CALL UZLGET('LABELY'//CSIDE,LABEL)
      IF(LABEL) CALL UYPLBL(CSIDE,1,UY2,CH,16,NBL)

      CALL GLLSET('LEPSL',LEPSL)
      CALL GNRSET

      IF(LOFF) THEN
        CALL SGSWND(UXMIN,UXMAX,UYMIN,UYMAX)
        CALL SGSTRF
      ENDIF

      END

*-----------------------------------------------------------------------
      SUBROUTINE CLSVRG(H,S,V,R,G,B,N,M)

      INTEGER R(N,M),G(N,M),B(N,M),HI
      REAL    H(N,M),S(N,M),V(N,M),F,P,Q,T

      DO 10 I=1,N
      DO 20 J=1,M
      IF(S(I,J).EQ.0.)THEN
        R(I,J)=V(I,J)
        G(I,J)=V(I,J)
        B(I,J)=V(I,J)
      ELSE
        HI = H(I,J) / 60.0
        HI = MOD(HI,6)
        F=H(I,J)/60.0 - HI
        P=V(I,J)*(1.0-S(I,J))
        Q=V(I,J)*(1.0-F*S(I,J))
        T=V(I,J)*(1.0-(1.0-F)*S(I,J))
        IF(HI.EQ.0)THEN
          R(I,J)=V(I,J)
          G(I,J)=T
          B(I,J)=P
        ELSE IF(HI.EQ.1)THEN
          R(I,J)=Q
          G(I,J)=V(I,J)
          B(I,J)=P
        ELSE IF(HI.EQ.2)THEN
          R(I,J)=P
          G(I,J)=V(I,J)
          B(I,J)=T
        ELSE IF(HI.EQ.3)THEN
          R(I,J)=P
          G(I,J)=Q
          B(I,J)=V(I,J)
        ELSE IF(HI.EQ.4)THEN
          R(I,J)=T
          G(I,J)=P
          B(I,J)=V(I,J)
        ELSE IF(HI.EQ.5)THEN
          R(I,J)=V(I,J)
          G(I,J)=P
          B(I,J)=Q
        ELSE
          CALL MSGDMP('E','CLSVRG',
     +          'CAN NOT CONVERT HSV TO RGB.')
        ENDIF
      ENDIF
 20   CONTINUE
 10   CONTINUE

      RETURN
      END

*-----------------------------------------------------------------------
*    Runge-Kutta Stepper.
*    Re-try when error condition is not satisfied.
*                                                 Oct. 5, 1990  S.Sakai
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ODRK4R(N, FCN, T, DT, EPSL, X, WORK)

      PARAMETER (SAFETY=0.9,ERRCON=6.E-4)
      DIMENSION X(N), WORK(N,7)
      EXTERNAL  FCN

      PGROW  = -0.20
      PSHRNK = -0.25
      TINY   = 1.E-30
      T0     = T
      CALL FCN(N, T0, X, WORK(1,1))

*-------------------- Integration with DT & DT*2 -----------------------

  100 CONTINUE
      DT2 = DT*2
      CALL ODRK4(N, FCN, T0, DT2, X, WORK(1,1), WORK(1,2), WORK(1,5))

      CALL ODRK4(N, FCN, T0, DT,  X, WORK(1,1), WORK(1,4), WORK(1,5))
      T = T0 + DT
      CALL FCN(N, T, WORK(1,4), WORK(1,3))
      CALL ODRK4(N, FCN, T, DT,
     +	         WORK(1,4), WORK(1,3), WORK(1,4),WORK(1,5))
      T = T0 + DT2

*------------------------- ERROR EVALUATION ----------------------------

      ERRMAX=0.
      DO 200 I=1, N
        WORK(I,3) = WORK(I,4)-WORK(I,2)
        XSCAL   = ABS(X(I)) + ABS(DT2*WORK(I,1)) + TINY
        ERRMAX  = MAX(ERRMAX, ABS(WORK(I,3)/XSCAL))
  200 CONTINUE
      ERRMAX = ERRMAX/EPSL

      IF(ERRMAX.GT.1.) THEN
        DT = SAFETY*DT*(ERRMAX**PSHRNK)
        CALL MSGDMP('M', 'ODRK4R', 'RECALCULATING.')
        GOTO 100
      ELSE
        IF(ERRMAX.GT.ERRCON)THEN
          DT = SAFETY*DT*(ERRMAX**PGROW)
        ELSE
          DT = 4.*DT
        ENDIF
      ENDIF

      DO 300 I=1, N
        X(I) = WORK(I,4)
  300 CONTINUE

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGPLZV(N,VPX,VPY,ITYPE,INDEX)

      REAL      VPX(*),VPY(*)


      IF (N.LT.2) THEN
        CALL MSGDMP('E','SGPLZV','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGPLZV','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGPLZV','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGPLZV','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZPLOP(ITYPE,INDEX)
      CALL SZPLZV(N,VPX,VPY)
      CALL SZPLCL

      END

*-----------------------------------------------------------------------
*     POLYLINE PRIMITIVE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCPLU(N,UPX,UPY,UPZ)

      REAL      UPX(*),UPY(*),UPZ(*),VPX(*),VPY(*),VPZ(*)

      SAVE

      DATA      INDEXZ/1/


      IF (N.LT.2) THEN
        CALL MSGDMP('E','SCPLU','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SCPLU','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SCPLU','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZL3OP(INDEXZ)
      CALL SZL3ZU(N,UPX,UPY,UPZ)
      CALL SZL3CL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCPLV(N,VPX,VPY,VPZ)

      IF (N.LT.2) THEN
        CALL MSGDMP('E','SCPLV','NUMBER OF POINTS IS LESS THAN 2.')
      END IF
      IF (INDEXZ.EQ.0) THEN
        CALL MSGDMP('M','SCPLV','POLYLINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEXZ.LT.0) THEN
        CALL MSGDMP('E','SCPLV','POLYLINE INDEX IS LESS THAN 0.')
      END IF

      CALL SZL3OP(INDEXZ)
      CALL SZL3ZV(N,VPX,VPY,VPZ)
      CALL SZL3CL

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCSPLI(INDEX)

      INDEXZ=INDEX

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCQPLI(INDEX)

      INDEX=INDEXZ

      RETURN
      END

module dcl_f77

!----- math1 -----
  use blk_interface
  use chr_interface
  use ctr_interface
  use fnc_interface
  use gnm_interface
  use ifa_interface
  use ind_interface
  use int_interface
  use lrl_interface
  use map_interface
  use os_interface
  use rfa_interface
  use rfb_interface
  use sub_interface
  use sys_interface
  use via_interface
  use vib_interface
  use vra_interface
  use vrb_interface
  use xfc_interface

!----- math2 -----
  use fft_interface
  use ode_interface
  use sht_interface
  use vst_interface
  use intr_interface
  use rnm_interface

!----- misc1 -----
  use bit_interface
  use chg_interface
  use chk_interface
  use chn_interface
  use fmt_interface
  use dat_interface
  use tim_interface
  use mis_interface
  use clc_interface
  use fio_interface
  use ran_interface
  use hex_interface
  use rea_interface

!---- graph1 -----
  use sz_interface
  use sg_interface
  use sl_interface
  use st_interface
  use sw_interface
  use sc_interface

!---- graph2 -----
  use gr_interface
  use uc_interface
  use ud_interface
  use ue_interface
  use ug_interface
  use uh_interface
  use ul_interface
  use um_interface
  use us_interface
  use uu_interface
  use uv_interface
  use uw_interface
  use ux_interface
  use uy_interface
  use uz_interface


end module

      PROGRAM KIHON9

      PARAMETER( NMAX=40 )
      PARAMETER( PI=3.14159 )
      PARAMETER( XMIN=0., XMAX=4*PI, YMIN=-1., YMAX=1. )
      REAL X(0:NMAX), Y(0:NMAX)

      DT = XMAX/NMAX
      DO 10 N=0,NMAX
        X(N) = N*DT
        Y(N) = SIN(X(N))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

*--  ラインタイプ = 4 (デフォルト) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.7,  0.9 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGSPLT( 4 )
      CALL SGPLU( NMAX+1, X, Y )

*--  ラインタイプ = 4 (BITLEN*2) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.5,  0.7 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGRSET( 'BITLEN', 0.006 )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGRSET( 'BITLEN', 0.003 )

*--  ビットパターン ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.3,  0.5 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL BITPCI( '1111111100100100', ITYPE )
      CALL SGSPLT( ITYPE )
      CALL SGPLU( NMAX+1, X, Y )

*--  ビットパターン(倍長) ----
      CALL SGSWND( XMIN, XMAX, YMIN, YMAX )
      CALL SGSVPT(   0.,   1.,  0.1,  0.3 )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SGISET( 'NBITS', 32 )
      CALL BITPCI( '10010010011111000111110001111100', ITYPE )
      CALL SGSPLT( ITYPE )
      CALL SGPLU( NMAX+1, X, Y )

      CALL SGCLS

      END

*-----------------------------------------------------------------------
      PROGRAM SGPK08

      REAL UPX3(3), UPY3(3), UPX6(6), UPY6(6), UPXS(61), UPYS(61)


      A = 0.8
      TH = 3.14159 * 2 / 3
      DO 100 I=1, 3
        UPX3(I) = A*SIN(TH*I)
        UPY3(I) = A*COS(TH*I)
  100 CONTINUE

      TH = 3.14159 * 2 / 6
      DO 200 I=1, 6
        UPX6(I) = A*SIN(TH*I)
        UPY6(I) = A*COS(TH*I)
  200 CONTINUE

      TH = 3.14159 * 4 / 60
      DO 300 I=1, 61
        UPXS(I) = A*(I-31) / 30.
        UPYS(I) = A*SIN(TH*(I-1))
  300 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)

      CALL SGLSET('LSOFTF',.TRUE.)           ! <-- ソフトフィルの指定
      CALL SGFRM

      CALL SGSWND(-1., 1., -1., 1.)
      CALL SGSVPT(0., 0.5, 0., 0.5)
      CALL SGSTRN( 1)
      CALL SGSTRF

      CALL SGPLU(3, UPX3, UPY3)
      CALL SGTNU(3, UPX3, UPY3)              ! <-- 網かけ (左下)

      CALL SGSVPT(0., 0.5, 0.5, 1.)
      CALL SGSTRF
      CALL SGSTNP(101)
      CALL SGTNU(6, UPX6, UPY6)              ! <-- 横線 (左上)

      CALL SGSVPT(0.5, 1., 0., 0.5)
      CALL SGSTRF
      CALL SGTNZU(6, UPX6, UPY6, 201)        ! <-- 斜線 (右下)

      CALL SGSVPT(0.5, 1., 0.5, 1.)
      CALL SGSTRF
      CALL SGTNZU(61, UPXS, UPYS, 601)       ! <-- 横線 (右上)

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UHBRFZ(N,UPX1,UPX2,UPY,ITYPE,INDEX,RSIZE)

      REAL      UPX1(*),UPX2(*),UPY(*)

      LOGICAL   LMISS, LYUNI, LXC1, LXC2
      CHARACTER COBJ*80

      COMMON    /SZBLS2/ LCLIP
      LOGICAL   LCLIP


      IF (N.LT.1) THEN
        CALL MSGDMP('E','UHBRFZ','NUMBER OF POINTS IS LESS THAN 1.')
      END IF
      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','UHBRFZ','LINE TYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','UHBRFZ','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','UHBRFZ','LINE INDEX IS LESS THAN 0.')
      END IF
      IF (RSIZE.EQ.0) THEN
        CALL MSGDMP('M','UHBRFZ','MARKER SIZE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (RSIZE.LT.0) THEN
        CALL MSGDMP('E','UHBRFZ','ERROR MARKER SIZE IS LESS THAN ZERO.')
      END IF

      CALL SGLGET('LCLIP' , LCLIP )
      CALL GLRGET('RUNDEF', RUNDEF)
      CALL GLRGET('RMISS' , RMISS)
      CALL GLLGET('LMISS' , LMISS)

      WRITE(COBJ,'(2I8,F8.5)') ITYPE, INDEX, RSIZE
      CALL CDBLK(COBJ)
      CALL SWOOPN('UHBRFZ',COBJ)

      CALL SZSLTI(ITYPE,INDEX)

      LYUNI = UPY(1).EQ.RUNDEF
      LXC1  = UPX1(1).EQ.RUNDEF
      LXC2  = UPX2(1).EQ.RUNDEF

      IF (LYUNI) THEN
        CALL UUQIDV(UYMIN, UYMAX)
        IF (UYMIN.EQ.RUNDEF) CALL SGRGET('UYMIN', UYMIN)
        IF (UYMAX.EQ.RUNDEF) CALL SGRGET('UYMAX', UYMAX)
        DY = (UYMAX-UYMIN)/(N-1)
      END IF

      IF (LXC1 .OR. LXC2) THEN
        CALL UURGET('UREF', UREF)
      END IF

      DO 20 I=1,N
        IF (LYUNI) THEN
          UYY = UYMIN + DY*(I-1)
        ELSE
          UYY = UPY(I)
        END IF

        IF (LXC1) THEN
          UXX1 = UREF
        ELSE
          UXX1 = UPX1(I)
        END IF

        IF (LXC2) THEN
          UXX2 = UREF
        ELSE
          UXX2 = UPX2(I)
        END IF

        IF (.NOT.
     #    ((UYY.EQ.RMISS .OR. UXX1.EQ.RMISS .OR. UXX2.EQ.RMISS)
     #     .AND. LMISS)) THEN

          CALL STFTRF(UXX1, UYY, VX1, VYY)
          CALL STFTRF(UXX2, UYY, VX2, VYY)

          CALL SZOPLV
          CALL SZMVLV(VX2, VYY-RSIZE/2.)
          CALL SZPLLV(VX2, VYY+RSIZE/2.)
          CALL SZPLLV(VX1, VYY+RSIZE/2.)
          CALL SZPLLV(VX1, VYY-RSIZE/2.)
          CALL SZPLLV(VX2, VYY-RSIZE/2.)
          CALL SZCLLV
        END IF
   20 CONTINUE

      CALL SWOCLS('UHBRFZ')

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM MAP3D6

      PARAMETER( NX=37, NY=37 )
      PARAMETER(  XMIN=   0,  XMAX=360,  YMIN= -90,  YMAX= 90 )
      PARAMETER( VXMIN=-0.4, VXMAX=0.4, VYMIN=-0.3, VYMAX=0.3 )
      PARAMETER(  ZMIN=-1.9,  ZMAX=1.9 )
      PARAMETER( VZMIN=-0.2, VZMAX=0.2 )
      PARAMETER( PI=3.14159, DRAD=PI/180 )

      REAL ALON(NX), ALAT(NY), P(NX,NY)
      REAL XP(3), YP(3), ZP(3)

      DO 10 I=1,NX
        ALON(I) = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
   10 CONTINUE
      DO 20 J=1,NY
        ALAT(J) = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
   20 CONTINUE

      DO 30 J=1,NY
        SLAT = SIN(ALAT(J)*DRAD)
        DO 30 I=1,NX
          P(I,J) = 3*SQRT(1-SLAT**2)*SLAT*COS(ALON(I)*DRAD)
     +           - 0.5*(3*SLAT**2-1)
   30 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL SGOPN( IWS )
      CALL SGFRM

*-- X-Y PLANE ----

      CALL SGSWND(  XMIN,  XMAX,  YMIN,  YMAX )
      CALL SGSVPT( VXMIN, VXMAX, VYMIN, VYMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 2, VZMIN)
      CALL SCSEYE( -1.1, -1.1, 2.5 )
      CALL SCSOBJ(  0.0,  0.0, 0.0 )
      CALL SCSPRJ

      CALL UXAXDV( 'B', 10., 60. )
      CALL UXAXDV( 'T', 10., 60. )
      CALL UXSTTL( 'B', 'LONGITUDE', 0. )
      CALL UYAXDV( 'L', 10., 30. )
      CALL UYAXDV( 'R', 10., 30. )
      CALL UYSTTL( 'L', 'LATITUDE', 0. )

*-- X-Z PLANE ----

      CALL SGSWND(  XMIN,  XMAX,  ZMIN,  ZMAX )
      CALL SGSVPT( VXMIN, VXMAX, VZMIN, VZMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 1, 3, VYMAX)
      CALL SCSPRJ

      CALL UZINIT
      CALL UXAXDV( 'T', 10., 60. )
      CALL UZLSET( 'LABELXB', .FALSE. )
      CALL UXAXDV( 'B', 10., 60. )
      CALL UYAXDV( 'L', 0.2, 1.0 )
      CALL UYAXDV( 'R', 0.2, 1.0 )
      CALL UYSTTL( 'L', 'AMPLITUDE', 0. )

*-- Y-Z PLANE ----

      CALL SGSWND(  YMIN,  YMAX,  ZMIN,  ZMAX )
      CALL SGSVPT( VYMIN, VYMAX, VZMIN, VZMAX )
      CALL SGSTRN( 1 )
      CALL SGSTRF

      CALL SCSPLN( 2, 3, VXMAX)
      CALL SCSPRJ

      CALL UZINIT
      CALL UXAXDV( 'T', 10., 30. )
      CALL UXAXDV( 'B', 10., 30. )
      CALL UZLSET( 'LABELYL', .FALSE. )
      CALL UYAXDV( 'L', 0.2, 1.0 )
      CALL UYAXDV( 'R', 0.2, 1.0 )

*---------------- 3-D ------------------

      CALL SCSVPT(VXMIN, VXMAX, VYMIN, VYMAX, VZMIN, VZMAX)
      CALL SCSWND( XMIN,  XMAX,  YMIN,  YMAX,  ZMIN,  ZMAX)
      CALL SCSLOG(.FALSE., .FALSE., .FALSE.)
      CALL SCSTRN(1)
      CALL SCSTRF

      CALL SZL3OP(1)
C      CALL SZT3OP(2999,4999)

      DO 40 J=NY-1, 1, -1
      DO 40 I=NX-1, 1, -1
        XP(1) = ALON(I)
        YP(1) = ALAT(J)
        ZP(1) = P(I,J)
        XP(2) = ALON(I)
        YP(2) = ALAT(J+1)
        ZP(2) = P(I,J+1)
        XP(3) = ALON(I+1)
        YP(3) = ALAT(J+1)
        ZP(3) = P(I+1,J+1)

C        CALL SZT3ZU(XP, YP, ZP)
        CALL SZL3ZU(3, XP, YP, ZP)

        XP(1) = ALON(I+1)
        YP(1) = ALAT(J+1)
        ZP(1) = P(I+1,J+1)
        XP(2) = ALON(I+1)
        YP(2) = ALAT(J)
        ZP(2) = P(I+1,J)
        XP(3) = ALON(I)
        YP(3) = ALAT(J)
        ZP(3) = P(I,J)

C        CALL SZT3ZU(XP, YP, ZP)
        CALL SZL3ZU(3, XP, YP, ZP)

   40 CONTINUE

      CALL SZL3CL
C      CALL SZT3CL

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM DCLDAT

      CHARACTER CFORM*32,CTIMEZ*3

      DATA      CTIMEZ/'JST'/


      CFORM='WWW CCC DD ######## ### YYYY'
      CALL DATEQ1(IDATE)
      CALL TIMEQ1(ITIME)
      CALL DATEC1(CFORM,IDATE)
      CALL CLOWER(CFORM(2:3))
      CALL CLOWER(CFORM(6:7))
      CFORM(12:19)='HH:MM:SS'
      CALL TIMEC1(CFORM(12:19),ITIME)
      CFORM(21:23)=CTIMEZ
      CALL GLIGET('IOUNIT',IU)
      WRITE(IU,'(A)') CFORM

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM QUICK5

      PARAMETER ( NX=21, NY=21 )
      PARAMETER ( XMIN=-1, XMAX=1, YMIN=-1, YMAX=1 )
      REAL U(NX,NY), V(NX,NY)

*-- 2次元ベクトルデータ: 変形場 ----
      DO 20 J=1,NY
        DO 10 I=1,NX
          X = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
          Y = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
          U(I,J) =  X
          V(I,J) = -Y
   10   CONTINUE
   20 CONTINUE

*-- グラフ ----
      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      CALL USDAXS
      CALL UGVECT( U, NX, V, NX, NX, NY )

      CALL GRCLS

      END

      PROGRAM UXYZ2

      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GRSWND( 1.E0, 1.E5, 1.E3, 1.E0 )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 4 )
      CALL GRSTRF

      CALL ULXLOG( 'B', 1, 9 )
      CALL ULXLOG( 'T', 1, 9 )
      CALL UXSTTL( 'B', '[X]', 1. )

      CALL ULYLOG( 'L', 3, 9 )
      CALL ULYLOG( 'R', 3, 9 )
      CALL UYSTTL( 'L', '[Y]', 1. )

      CALL UXMTTL( 'T', 'ULXLOG/ULYLOG', 0. )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UXSOFF / UXROFF
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXSOFF

      LOGICAL   LCALL,LOFF

      SAVE

      DATA      LCALL/.FALSE./

      FX(X)=XFCT*X+XOFF


*     / SCALING FACTOR FOR OFFSET /

      CALL UZLGET('LOFFSET',LOFF)
      IF (LOFF) THEN
        CALL UZRGET('XOFFSET',XOFF)
        CALL UZRGET('XFACT  ',XFCT)
      ELSE
        XOFF=0.0
        XFCT=1.0
      END IF

*     / INQUIRE NORMALIZATION TRANSFORMATION /

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)

      FXMN=FX(UXMN)
      FXMX=FX(UXMX)

*     / SET NORMALIZATION TRANSFORMATION /

      CALL SGSWND(FXMN,FXMX,UYMN,UYMX)
      CALL SGSTRF

      LCALL=.TRUE.

      RETURN
*-----------------------------------------------------------------------
      ENTRY UXROFF

      IF (.NOT.LCALL) THEN
        CALL MSGDMP('E','UXROFF','UXSOFF HAS NOT BEEN CALLED.')
      END IF

*     / RESET NORMALIZATION TRANSFORMATION /

      CALL SGSWND(UXMN,UXMX,UYMN,UYMX)
      CALL SGSTRF

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM U2DF09B

      PARAMETER( NX=21, NY=21 )
      PARAMETER( XMIN=-10, XMAX=10, YMIN=-10, YMAX=10 )
      PARAMETER( DX1=1, DX2=5, DY1=1, DY2=5 )
      PARAMETER( KMAX=5, PMIN=0, PMAX=1 )

      REAL P(NX,NY), PI(2,KMAX+1)


      DO 10 J=1,NY
        DO 15 I=1,NX
          X = XMIN + (XMAX-XMIN)*(I-1)/(NX-1)
          Y = YMIN + (YMAX-YMIN)*(J-1)/(NY-1)
          P(I,J) = EXP( -X**2/64 -Y**2/25 )
   15   CONTINUE
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL SGLSET( 'LSOFTF', .TRUE. )
      CALL GRFRM

      CALL GRSWND( XMIN, XMAX, YMIN, YMAX )
      CALL GRSVPT(  0.2,  0.8,  0.2,  0.8 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      DP = (PMAX-PMIN)/KMAX
      DO 20 K=1,KMAX
        TLEV1 = (K-1)*DP
        TLEV2 = TLEV1 + DP
        IPAT  = 600 + K - 1
        CALL UESTLV( TLEV1, TLEV2, IPAT )
   20 CONTINUE

      CALL UETONB( P, NX, NX, NY )

      CALL UXAXDV( 'B', DX1, DX2 )
      CALL UXAXDV( 'T', DX1, DX2 )
      CALL UXSTTL( 'B', 'X-axis', 0. )
      CALL UXMTTL( 'T', 'FIGURE TITLE', 0. )

      CALL UYAXDV( 'L', DY1, DY2 )
      CALL UYAXDV( 'R', DY1, DY2 )
      CALL UYSTTL( 'L', 'Y-axis', 0. )

*-- トーンバー ----

      CALL GRSWND(  0.0, 1.0, PMIN, PMAX )
      CALL GRSVPT( 0.85, 0.9, 0.45, 0.75 )
      CALL GRSTRN( 1 )
      CALL GRSTRF

      DO 30 K=1,KMAX+1
        PI(1,K) = PMIN + (K-1)*DP
        PI(2,K) = PMIN + (K-1)*DP
   30 CONTINUE

      CALL UDLSET( 'LMSG' , .FALSE. )
      CALL UETONE( PI, 2, 2, KMAX+1 )
*     CALL UDCNTR( PI, 2, 2, KMAX+1 )

      CALL SLPVPR( 3 )
      CALL UZLSET( 'LABELYR', .TRUE. )
      CALL UZFACT( 0.8 )
      CALL UYSFMT( '(F4.1)' )
      CALL UYAXDV( 'R', DP, DP )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     USIQNP / USIQID / USIQCP / USIQVL / USISVL
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USIQNP(NCP)

      CHARACTER CP*(*)

      PARAMETER (NPARA = 13)
      PARAMETER (IUNDEF = -999)

      INTEGER   IX(NPARA)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

* ---- SHORT NAME ----
*     / CONTROL PARAMETERS /
      DATA      CPARAS( 1) / 'IRESET  ' /, IX( 1) / 1 /
*     / PARAMETERS FOR USUSCU /
      DATA      CPARAS( 2) / 'MXDGTX  ' /, IX( 2) / 4 /
      DATA      CPARAS( 3) / 'MXDGTY  ' /, IX( 3) / 4 /
      DATA      CPARAS( 4) / 'NBLANK1 ' /, IX( 4) / 1 /
      DATA      CPARAS( 5) / 'NBLANK2 ' /, IX( 5) / 2 /
*     / PARAMETERS FOR USUSCL /
      DATA      CPARAS( 6) / 'NLBLX   ' /, IX( 6) / IUNDEF /
      DATA      CPARAS( 7) / 'NLBLY   ' /, IX( 7) / IUNDEF /
      DATA      CPARAS( 8) / 'NTICKSX ' /, IX( 8) / IUNDEF /
      DATA      CPARAS( 9) / 'NTICKSY ' /, IX( 9) / IUNDEF /
      DATA      CPARAS(10) / 'ITYPEX  ' /, IX(10) / IUNDEF /
      DATA      CPARAS(11) / 'ITYPEY  ' /, IX(11) / IUNDEF /
*     / PARAMETERS FOR USXSUB & USYSUB /
      DATA      CPARAS(12) / 'MXDGTSX ' /, IX(12) / 6 /
      DATA      CPARAS(13) / 'MXDGTSY ' /, IX(13) / 6 /

* ---- LONG NAME ----
*     / CONTROL PARAMETERS /
      DATA      CPARAL( 1) / '****IRESET  ' /
*     / PARAMETERS FOR USUSCU /
      DATA      CPARAL( 2) / 'X_LABEL_MAX_CHAR' /
      DATA      CPARAL( 3) / 'X_LABEL_MAX_CHAR' /
      DATA      CPARAL( 4) / 'LABEL_GAP_PARALLEL' /
      DATA      CPARAL( 5) / 'LABEL_GAP_RIGHT_ANGLE' /
*     / PARAMETERS FOR USUSCL /
      DATA      CPARAL( 6) / 'LOG_X_LABEL_NUMBER' /
      DATA      CPARAL( 7) / 'LOG_Y_LABEL_NUMBER' /
      DATA      CPARAL( 8) / 'LOG_X_TICKS_NUMBER' /
      DATA      CPARAL( 9) / 'LOG_X_TICKS_NUMBER' /
      DATA      CPARAL(10) / 'LOG_X_LABEL_FORMAT' /
      DATA      CPARAL(11) / 'LOG_X_LABEL_FORMAT' /
*     / PARAMETERS FOR USXSUB & USYSUB /
      DATA      CPARAL(12) / 'X_SUBLABEL_MAX_CHAR' /
      DATA      CPARAL(13) / 'Y_SUBLABEL_MAX_CHAR' /

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY USIQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E','USIQID',CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY USIQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E','USIQCP','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USIQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E','USIQCL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USIQVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('US', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IPARA = IX(IDX)
      ELSE
        CALL MSGDMP('E','USIQVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USISVL(IDX, IPARA)

      IF (LFIRST) THEN
        CALL RTIGET('US', CPARAS, IX, NPARA)
        CALL RLIGET(CPARAL, IX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        IX(IDX) = IPARA
      ELSE
        CALL MSGDMP('E','USISVL','IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY USIQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM USPAC3

      PARAMETER( NMAX=50, XMIN=1950, XMAX=2000 )
      REAL Y(0:NMAX)

      R    = 3.7
      Y(0) = 0.5
      DO 10 N=0,NMAX-1
        Y(N+1) = R*Y(N)*(1.-Y(N))
   10 CONTINUE

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ (*,*) IWS

      CALL GROPN( IWS )
      CALL GRFRM

      CALL GLRGET( 'RUNDEF', RUNDEF )
      CALL GRSWND( XMIN, XMAX, RUNDEF, RUNDEF )
      CALL USSTTL( 'TIME', 'YEAR', 'HEAT FLUX', 'W/m\^2' )
      CALL USGRPH( NMAX+1, RUNDEF, Y )

      CALL GRCLS

      END

*-----------------------------------------------------------------------
*     UXAXDV : PLOT X-AXIS (SPECIFY DIVISION)
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXAXDV(CSIDE,DX1,DX2)

      PARAMETER (N=200)

      REAL      UX(N)
      CHARACTER CSIDE*1

      LOGICAL   LABEL,LEPSL,LREQ,LRLE,LUXCHK


*     / CHECK ARGUMENTS /

      IF (.NOT.(LUXCHK(CSIDE))) THEN
        CALL MSGDMP('E','UXAXDV','SIDE PARAMETER IS INVALID.')
      END IF
      IF (DX1.LE.0) THEN
        CALL MSGDMP('E','UXAXDV','MINOR DIVISION IS LESS THAN 0.')
      END IF
      IF (DX2.LE.0) THEN
        CALL MSGDMP('E','UXAXDV','MAJOR DIVISION IS LESS THAN 0.')
      END IF
      IF (DX1.LE.DX2) THEN
        DZ1=DX1
        DZ2=DX2
      ELSE
        CALL MSGDMP('W','UXAXDV',
     +    'MINOR DIVISION IS GREATER THAN MAJOR DIVISION.')
        DZ1=DX2
        DZ2=DX1
        CALL MSGDMP('M','-CNT.-','DX1 AND DX2 WERE SWITCHED.')
      END IF
      FRC=DZ2/DZ1-NINT(DZ2/DZ1)
      IF (ABS(FRC).GT.0.0001) THEN
        CALL MSGDMP('W','UXAXDV',
     +    'MAJOR DIVISION IS NOT MULTIPLE OF MINOR DIVISION.')
      END IF

*     / GET & SET INTERNAL PARAMETERS /

      CALL GLLGET('LEPSL',LEPSL)
      CALL GLRGET('REPSL',REPSL)
      CALL GLLSET('LEPSL',.TRUE.)

*     / SET SCALING FOR OFFSET /

      CALL UXSOFF

*     / INQUIRE NORMALIZATION TRANSFORMATION /

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)

      UXMNW=MIN(UXMN,UXMX)
      UXMXW=MAX(UXMN,UXMX)

*     / PLOT HOLIZONTAL AXIS /

      CALL UXPAXS(CSIDE,2)

*     / GENERATE NUMBERS FOR MINOR TICKMARKS /

      NN=0
      RX=IRLE(UXMNW/DZ1)*DZ1
      IF (LREQ(UXMNW,RX)) THEN
        X=RX
      ELSE
        X=RX+DZ1
      END IF
   11 IF (.NOT.LRLE(X,UXMXW)) GO TO 10
        NN=NN+1
        IF (ABS(X).LT.DZ1*REPSL*NN) THEN
          X=0
        END IF
        UX(NN)=X
        X=X+DZ1
        GO TO 11
   10 CONTINUE

      IF (NN.EQ.0) THEN
        CALL MSGDMP('W','UXAXDV','THERE IS NO TICKMARK / LABEL.')
        GO TO 100
      ELSE IF (NN.GT.N) THEN
        CALL MSGDMP('E','UXAXDV','WORKING AREA IS NOT ENOUGH.')
      END IF

*     / IF DZ1.NE.DZ2 THEN PLOT MINOR TICKMARKS
*       ELSE SKIP TO THE PROCESS FOR MAJOR TICKMARKS /

      IF (DZ2.EQ.DZ1) GO TO 20

      CALL UXPTMK(CSIDE,1,UX,NN)

*     / GENERATE NUMBERS FOR MAJOR TICKMARKS AND LABELS /

      NN=0
      RX=IRLE(UXMNW/DZ2)*DZ2
      IF (LREQ(UXMNW,RX)) THEN
        X=RX
      ELSE
        X=RX+DZ2
      END IF
   16 IF (.NOT.LRLE(X,UXMXW)) GO TO 15
        NN=NN+1
        IF (ABS(X).LT.DZ2*REPSL*NN) THEN
          X=0
        END IF
        UX(NN)=X
        X=X+DZ2
        GO TO 16
   15 CONTINUE

   20 CONTINUE
      CALL UXPTMK(CSIDE,2,UX,NN)
      CALL UZLGET('LABELX'//CSIDE,LABEL)
      IF (LABEL) THEN
        CALL UXPNUM(CSIDE,1,UX,NN)
      END IF

*     / RESET INTERNAL PARAMETER /

  100 CALL GLLSET('LEPSL',LEPSL)

*     / RESET SCALING FOR OFFSET /

      CALL UXROFF

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SLRATZ(XAMIN,XAMAX,YAMIN,YAMAX,RX,RY)


      WXA=XAMAX-XAMIN
      WYA=YAMAX-YAMIN

      IF (WXA.LT.0 .OR. WYA.LT.0) THEN
        CALL MSGDMP('E','SLRATZ','RECTANGLE DEFINITION IS INVALID.')
      END IF
      IF (RX.LT.0 .OR. RY.LT.0) THEN
        CALL MSGDMP('E','SLRATZ',
     +    'PROPORTION PARAMETER IS LESS THAN ZERO.')
      END IF

      ARAT=WYA/WXA
      BRAT=RY/RX
      IF (ARAT.GE.BRAT) THEN
        XX=0
        YY=(1-BRAT/ARAT)/2
      ELSE
        XX=(1-ARAT/BRAT)/2
        YY=0
      END IF
      CALL SLMGNZ(XAMIN,XAMAX,YAMIN,YAMAX,XX,XX,YY,YY)

      END

*-----------------------------------------------------------------------
*     3-D NORMALIZATION TRANSFORMATION
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SCSVPT(VXMIN, VXMAX, VYMIN, VYMAX, VZMIN, VZMAX)


      CALL SGRSET('VXMIN3',VXMIN)
      CALL SGRSET('VXMAX3',VXMAX)
      CALL SGRSET('VYMIN3',VYMIN)
      CALL SGRSET('VYMAX3',VYMAX)
      CALL SGRSET('VZMIN3',VZMIN)
      CALL SGRSET('VZMAX3',VZMAX)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SCQVPT(VXMIN, VXMAX, VYMIN, VYMAX, VZMIN, VZMAX)

      CALL SGRGET('VXMIN3',VXMIN)
      CALL SGRGET('VXMAX3',VXMAX)
      CALL SGRGET('VYMIN3',VYMIN)
      CALL SGRGET('VYMAX3',VYMAX)
      CALL SGRGET('VZMIN3',VZMIN)
      CALL SGRGET('VZMAX3',VZMAX)

      RETURN
      END

*-----------------------------------------------------------------------
      PROGRAM SGPK03

      PARAMETER(N=41)
      DIMENSION X(N), Y(N)


      DT = 4.* 3.14159 / (N-1)
      DO 10 I=1,N
        Y(I) = SIN(DT*(I-1))*0.15
        X(I) = REAL(I-1)/REAL(N-1)
   10 CONTINUE

      CALL SWCSTX('FNAME','SGPK03')
      CALL SWLSTX('LSEP',.TRUE.)

      WRITE(*,*) ' WORKSTATION ID (I)  ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)

*----------------------------- page 1 ---------------------------------
      CALL SGFRM

      CALL SGSWND( 0.0,  1.0, -0.8, 0.2)
      CALL SGSVPT( 0.15, 0.85, 0.1, 0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL SLPVPR(1)
      CALL SGPLU(N, X, Y)                   ! <-- 1本目

      CALL SGSWND( 0.0,  1.0, -0.7, 0.3)
      CALL SGSTRF
      CALL SGSPLI(2)                        ! <-- Line INDEX 設定
      CALL SGPLU(N, X, Y)                   ! <-- 2本目

      CALL SGSWND( 0.0,  1.0, -0.6, 0.4)
      CALL SGSTRF
      CALL SGSPLI(3)                        ! <-- Line INDEX 設定
      CALL SGPLU(N, X, Y)                   ! <-- 3本目

      CALL SGSWND( 0.0,  1.0, -0.4, 0.6)
      CALL SGSTRF
      CALL SGSPLT(2)                        ! <-- Line TYPE 設定 (破線)
      CALL SGPLU(N, X, Y)                   ! <-- 4本目

      CALL SGSWND( 0.0,  1.0, -0.3, 0.7)
      CALL SGSTRF
      CALL SGSPLT(3)                        ! <-- Line TYPE 設定 (点線)
      CALL SGPLU(N, X, Y)                   ! <-- 5本目

      CALL SGSWND( 0.0,  1.0, -0.2, 0.8)
      CALL SGSTRF
      CALL SGSPLT(4)                        ! <-- Line TYPE 設定 (一点鎖線)
      CALL SGPLU(N, X, Y)                   ! <-- 6本目

*----------------------------- page 2 ---------------------------------

      CALL SGFRM

      CALL SGSWND( 0.0,  1.0, -0.8, 0.2)
      CALL SGSVPT( 0.15, 0.85, 0.1, 0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL SLPVPR(1)

      CALL SGRSET('BITLEN', 0.006)          ! <-- サイクル長の変更
      CALL SGSPLT(4)
      CALL SGPLU(N, X, Y)                   ! <-- 1本目

      CALL SGSWND( 0.0,  1.0, -0.6, 0.4)
      CALL SGSTRF
      CALL SGSPLI(2)

      CALL BITPCI('1111111100100100', ITYPE)! <-- パターン生成
      CALL SGSPLT(ITYPE)                    ! <-- パターン設定
      CALL SGPLU(N, X, Y)                   ! <-- 2本目

      CALL SGSWND( 0.0,  1.0, -0.4, 0.6)
      CALL SGSTRF
      CALL SGISET('NBITS', 32)
      CALL BITPCI('10010010011111000111110001111100', ITYPE)
      CALL SGSPLT(ITYPE)
      CALL SGPLU(N, X, Y)

      CALL SGSWND( 0.0,  1.0, -0.2, 0.8)
      CALL SGSTRF
      CALL SGSPLI(1)
      CALL SGSPLT(1)

      N1=N/4
      Y(N1-1) = 999.                        ! <-- 欠損値
      Y(N1  ) = 999.
      Y(N1+1) = 999.

      N2=N1*3
      Y(N2-1) = 999.
      Y(N2+1) = 999.

      CALL GLLSET('LMISS',.TRUE.)
      CALL SGPLU(N, X, Y)                   ! <-- 4本目

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     BASIC ROUTINES
*-----------------------------------------------------------------------
*     UXPTMZ : PLOT TICKMARKS
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UXPTMZ(UX,N,UPY,ROFFX,RTICK,INDEX)

      REAL      UX(*)

      LOGICAL   LCLIPZ


      IF (N.LE.0) THEN
        CALL MSGDMP('E','UXPTMZ','NUMBER OF POINTS IS INVALID.')
      END IF
      IF (INDEX.LE.0) THEN
        CALL MSGDMP('E','UXPTMZ','LINE INDEX IS INVALID.')
      END IF

      CALL SGLGET('LCLIP',LCLIPZ)
      CALL SGLSET('LCLIP',.FALSE.)

      CALL SZLNOP(INDEX)
      DO 10 I=1,N
        CALL STFTRF(UX(I),UPY,VPX,VPY)
        VPY=VPY+ROFFX
        CALL SZLNZV(VPX,VPY,VPX,VPY+RTICK)
   10 CONTINUE
      CALL SZLNCL

      CALL SGLSET('LCLIP',LCLIPZ)

      END

*-----------------------------------------------------------------------
*     UYPTTL : PLOT TITLE
*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UYPTTL(CSIDE,ISLCT,CTTL,PX)

      CHARACTER CSIDE*1,CTTL*(*)

      REAL      UY(2)
      LOGICAL   LBOUND,LBMSG,LUYCHK,LCHREQ
      CHARACTER CSLCT*1


      IF (.NOT.(LUYCHK(CSIDE))) THEN
        CALL MSGDMP('E','UYPTTL','SIDE PARAMETER IS INVALID.')
      END IF
      IF (.NOT.(0.LE.ISLCT .AND. ISLCT.LE.2)) THEN
        CALL MSGDMP('E','UYPTTL','''ISLCT'' IS INVALID.')
      END IF
      NCTL=LEN(CTTL)
      IF (.NOT.(0.LT.NCTL)) THEN
        CALL MSGDMP('M','UYPTTL','CHARACTER LENGTH IS ZERO.')
        RETURN
      END IF

      WRITE(CSLCT,'(I1)') ISLCT

      CALL UZRGET('ROFFY'//CSIDE,ROFFY)
      CALL UZRGET('RSIZEC'//CSLCT,RSIZE)
      CALL UZIGET('IROTCY'//CSIDE,IROTA)
      CALL UZIGET('INDEXL'//CSLCT,INDEX)
      CALL UZRGET('PAD1',PAD)
      CALL UZLGET('LBOUND',LBOUND)
      CALL UZLGET('LBMSG',LBMSG)
      ICENT=0

      CALL SGQWND(UXMN,UXMX,UYMN,UYMX)
      IF (.NOT.LCHREQ(CSIDE,'U')) THEN
        IF (LCHREQ(CSIDE,'L')) THEN
          POSX=UXMN
          IFLAG=-1
        ELSE
          POSX=UXMX
          IFLAG=+1
        END IF
      ELSE
        CALL UZRGET('UXUSER',POSX)
        CALL UZIGET('IFLAG',IFLAG)
        IFLAG=SIGN(1,IFLAG)
      END IF

      UY(1)=UYMN
      UY(2)=UYMX

      JROTA=MOD(IROTA+3,4)-2
      IF (JROTA.EQ.-2) THEN
        JROTA=0
      END IF

      NC=LENC(CTTL)
      CALL SZQTXW(CTTL,LCW,WXCH,WYCH)
      IF (JROTA.EQ.0) THEN
        RLC=WYCH
      ELSE
        RLC=WXCH
      END IF

      IC=JROTA*ICENT*IFLAG
      ROFFZ=ROFFY+RSIZE*(PAD+RLC*(1+IC)*0.5)*IFLAG
      ROFFY=ROFFY+RSIZE*(PAD+RLC)*IFLAG

      CALL UYPLBB(UY,CTTL,NC,2,POSX,ROFFZ,RSIZE,IROTA,ICENT,INDEX,
     +            PX,LBOUND,LBMSG)

      CALL UZRSET('ROFFY'//CSIDE,ROFFY)

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      PROGRAM UCPK02

      PARAMETER (JD0=19920401)

      CHARACTER CTL*32


      WRITE(*,*) ' WORKSTATION ID (I) ? ;'
      CALL SGPWSN
      READ(*,*) IWS

      CALL SGOPN(IWS)

      CALL SGLSET('LFULL',.TRUE.)
      CALL UZFACT(0.7)
      CALL SLRAT(1.0,1.0)
      CALL SLDIV('Y',7,1)

      CALL SGFRM
      CALL UZINIT
      ND=30
      CALL SGSWND(0.0,1.0,0.0,REAL(ND))
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCYACL('L',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=90
      CALL SGSWND(0.0,1.0,0.0,REAL(ND))
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCYACL('L',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=180
      CALL SGSWND(0.0,1.0,0.0,REAL(ND))
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCYACL('L',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=400
      CALL SGSWND(0.0,1.0,0.0,REAL(ND))
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCYACL('L',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=1000
      CALL SGSWND(0.0,1.0,0.0,REAL(ND))
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCYACL('L',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=3000
      CALL SGSWND(0.0,1.0,0.0,REAL(ND))
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCYACL('L',JD0,ND)

      CALL SGFRM
      CALL UZINIT
      ND=9000
      CALL SGSWND(0.0,1.0,0.0,REAL(ND))
      CALL SGSVPT(0.13,0.14,0.1,0.9)
      CALL SGSTRN(1)
      CALL SGSTRF
      CALL UCYACL('L',JD0,ND)

      CALL SGCLS

      END

*-----------------------------------------------------------------------
*     Copyright (C) 2000-2022 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SGLAZR(RX1,RY1,RX2,RY2,ITYPE,INDEX)


      IF (ITYPE.EQ.0) THEN
        CALL MSGDMP('M','SGLAZR','LINETYPE IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.EQ.0) THEN
        CALL MSGDMP('M','SGLAZR','LINE INDEX IS 0 / DO NOTHING.')
        RETURN
      END IF
      IF (INDEX.LT.0) THEN
        CALL MSGDMP('E','SGLAZR','LINE INDEX IS INVALID.')
      END IF

      CALL SZLAOP(ITYPE,INDEX)
      CALL SZLAZR(RX1,RY1,RX2,RY2)
      CALL SZLACL

      END

@SET DCLFRTDIR=%~dp0

@SET VSVER=vs2013
@SET VCVER="Microsoft Visual Studio 12.0"

:CL(Visual C)
@IF EXIST "c:\Program Files (x86)\"%VCVER%"\VC\bin\vcvars32.bat" call   "c:\Program Files (x86)\"%VCVER%"\VC\bin\vcvars32.bat"

:IFRT(Intel Fortran)
call "C:\Program Files (x86)\Intel\Composer XE\bin\ifortvars.bat" ia32 %VSVER%

:DCLFRT
@SET DFLIB=%DCLFRTDIR%lib
@SET DFINCLUDE=%DCLFRTDIR%include
@SET DFWBIN=%DCLFRTDIR%bin
@SET DFSRC=%DCLFRTDIR%src
@PATH=%DFWBIN%;%PATH%
@SET LIB=%DFLIB%;%LIB%
@SET INCLUDE=%DFINCLUDE%;%INCLUDE%
@SET GL_DSPATH=%DCLFRTDIR%lib\dcldbase\

:GTK
@SET PKG_CONFIG_PATH=%DCLFRTDIR%GTK\lib\pkgconfig
@SET DllPath=%DCLFRTDIR%GTK\bin
@PATH=%DllPath%;%PATH%
@SET GTKDIR=C:\dcl-fortran\GTK\lib
@SET GTKLIBS=pango-1.0.lib pangoft2-1.0.lib pangowin32-1.0.lib atk-1.0.lib gdk_pixbuf-2.0.lib gdk-win32-2.0.lib gtk-win32-2.0.lib glib-2.0.lib gmodule-2.0.lib gobject-2.0.lib gthread-2.0.lib cairo.lib

@FOR /f "DELIMS=" %%A IN ('pkg-config --cflags gtk+-2.0') DO @SET CFLTMP=%%A
@FOR /f "DELIMS=" %%A IN ('pkg-config --libs gtk+-2.0') DO @SET GTKTMP=%%A
@SET CFLAGS=%CFLTMP:-mms-bitfields=%
@SET CFLAGS=%CFLAGS% -Dinline= /link /libpath:%GTKDIR% %GTKLIBS% /stack:10000000 /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmt.lib /NODEFAULTLIB:oldnames.lib  
@SET FFLAGS=/module:%DFLIB% %CFLAGS% %DFLIB%\dcl.lib %DFLIB%\dcl-f90.lib
SET INCLUDE=%INCLUDE%;%DCLFRTDIR%GTK\include

:HOME
@IF NOT "%HOME%" == "" GOTO :EOF
@SET HOME=%HOMEDRIVE%%HOMEPATH%
@%HOMEDRIVE%
@CD %HOME%

:EOF

echo %echo%
:
:  地球流体電脳ライブラリ depend ver.5.1 for DEC Fortran
: 
:  97/10/28  酒井 敏
:
if "%DWIN%"==""   dcl_error
if "%DLIB%"==""   dcl_error
if "%DMODE%"==""  dcl_error

:---------------------------- dcl-win ------------------------------------
:cd src

call df_%DMODE%

df -c dcl_common.f90 /include:%DLIB%\module

df -c *pack.f90 /include:%DLIB%\module
df -c *lib.f90 /include:%DLIB%\module

df -c dcl_parm.f90 /include:%DLIB%\module
df -c dcl.f90 /include:%DLIB%\module

lib /out:%DLIB%\%DMODE%\dcl_f90.lib *.obj
del *.obj
copy *.mod  %DLIB%\module
del *.mod
call mk_lib

#!/bin/bash
#
port=57010

usage_exit() {
        echo "Usage: $0 remotehost" 1>&2
        exit 1
}

while getopts h OPT
do
    case $OPT in
        h)  usage_exit
            ;;
    esac
done

shift $((OPTIND - 1))

if [ $# = 0 ]; then
    usage_exit
fi

echo ssh -A -t $1 -R $port:localhost:$port -N
echo dclsrv

ssh -A -t $1 -R $port:localhost:$port -N &
sshpid=$!

trap "kill $sshpid; exit" 2

while true
do
    dclsrv
done
